--
-- PostgreSQL database dump
--

-- Dumped from database version 13.1 (Ubuntu 13.1-1.pgdg20.04+1)
-- Dumped by pg_dump version 13.1 (Ubuntu 13.1-1.pgdg20.04+1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: common_date_reported; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.common_date_reported (
    type character varying(50) NOT NULL,
    id integer NOT NULL,
    date_reported character varying(255) NOT NULL,
    year_week character varying(255) NOT NULL,
    datum date NOT NULL,
    year integer NOT NULL,
    month integer NOT NULL,
    day_of_month integer NOT NULL,
    day_of_week integer NOT NULL,
    week_of_year integer NOT NULL
);


ALTER TABLE public.common_date_reported OWNER TO covid19data;

--
-- Name: common_date_reported_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.common_date_reported_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.common_date_reported_id_seq OWNER TO covid19data;

--
-- Name: common_date_reported_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.common_date_reported_id_seq OWNED BY public.common_date_reported.id;


--
-- Name: common_region; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.common_region (
    type character varying(50),
    id integer NOT NULL,
    region character varying(255) NOT NULL
);


ALTER TABLE public.common_region OWNER TO covid19data;

--
-- Name: common_region_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.common_region_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.common_region_id_seq OWNER TO covid19data;

--
-- Name: common_region_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.common_region_id_seq OWNED BY public.common_region.id;


--
-- Name: europe_country; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.europe_country (
    id integer NOT NULL,
    countries_and_territories character varying(255) NOT NULL,
    pop_data_2019 character varying(255) NOT NULL,
    geo_id character varying(255) NOT NULL,
    country_territory_code character varying(255) NOT NULL,
    continent_id integer NOT NULL
);


ALTER TABLE public.europe_country OWNER TO covid19data;

--
-- Name: europe_country_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.europe_country_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.europe_country_id_seq OWNER TO covid19data;

--
-- Name: europe_country_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.europe_country_id_seq OWNED BY public.europe_country.id;


--
-- Name: europe_data; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.europe_data (
    id integer NOT NULL,
    deaths_weekly integer NOT NULL,
    cases_weekly integer NOT NULL,
    notification_rate_per_100000_population_14days double precision NOT NULL,
    europe_country_id integer NOT NULL,
    europe_date_reported_id integer NOT NULL
);


ALTER TABLE public.europe_data OWNER TO covid19data;

--
-- Name: europe_data_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.europe_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.europe_data_id_seq OWNER TO covid19data;

--
-- Name: europe_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.europe_data_id_seq OWNED BY public.europe_data.id;


--
-- Name: europe_data_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.europe_data_import (
    id integer NOT NULL,
    date_rep character varying(255) NOT NULL,
    year_week character varying(255) NOT NULL,
    cases_weekly character varying(255) NOT NULL,
    deaths_weekly character varying(255) NOT NULL,
    pop_data_2019 character varying(255) NOT NULL,
    countries_and_territories character varying(255) NOT NULL,
    geo_id character varying(255) NOT NULL,
    country_territory_code character varying(255) NOT NULL,
    continent_exp character varying(255) NOT NULL,
    notification_rate_per_100000_population_14days character varying(255) NOT NULL
);


ALTER TABLE public.europe_data_import OWNER TO covid19data;

--
-- Name: europe_data_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.europe_data_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.europe_data_import_id_seq OWNER TO covid19data;

--
-- Name: europe_data_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.europe_data_import_id_seq OWNED BY public.europe_data_import.id;


--
-- Name: rki_bundeslsaender_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_bundeslsaender_import (
    id integer NOT NULL,
    "OBJECTID_1" character varying(255) NOT NULL,
    "LAN_ew_AGS" character varying(255) NOT NULL,
    "LAN_ew_GEN" character varying(255) NOT NULL,
    "LAN_ew_BEZ" character varying(255) NOT NULL,
    "LAN_ew_EWZ" character varying(255) NOT NULL,
    "OBJECTID" character varying(255) NOT NULL,
    "Fallzahl" character varying(255) NOT NULL,
    "Aktualisierung" character varying(255) NOT NULL,
    "AGS_TXT" character varying(255) NOT NULL,
    "GlobalID" character varying(255) NOT NULL,
    "faelle_100000_EW" character varying(255) NOT NULL,
    "Death" character varying(255) NOT NULL,
    cases7_bl_per_100k character varying(255) NOT NULL,
    cases7_bl character varying(255) NOT NULL,
    death7_bl character varying(255) NOT NULL,
    cases7_bl_per_100k_txt character varying(255) NOT NULL,
    "AdmUnitId" character varying(255) NOT NULL,
    "SHAPE_Length" character varying(255) NOT NULL,
    "SHAPE_Area" character varying(255) NOT NULL
);


ALTER TABLE public.rki_bundeslsaender_import OWNER TO covid19data;

--
-- Name: rki_bundeslsaender_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_bundeslsaender_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_bundeslsaender_import_id_seq OWNER TO covid19data;

--
-- Name: rki_bundeslsaender_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_bundeslsaender_import_id_seq OWNED BY public.rki_bundeslsaender_import.id;


--
-- Name: rki_country; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_country (
    id integer NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    region_id integer NOT NULL
);


ALTER TABLE public.rki_country OWNER TO covid19data;

--
-- Name: rki_country_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_country_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_country_id_seq OWNER TO covid19data;

--
-- Name: rki_country_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_country_id_seq OWNED BY public.rki_country.id;


--
-- Name: rki_global_data; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_global_data (
    id integer NOT NULL,
    cases_new integer NOT NULL,
    cases_cumulative integer NOT NULL,
    deaths_new integer NOT NULL,
    deaths_cumulative integer NOT NULL,
    date_reported_id integer NOT NULL,
    country_id integer NOT NULL
);


ALTER TABLE public.rki_global_data OWNER TO covid19data;

--
-- Name: rki_global_data_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_global_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_global_data_id_seq OWNER TO covid19data;

--
-- Name: rki_global_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_global_data_id_seq OWNED BY public.rki_global_data.id;


--
-- Name: rki_global_data_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_global_data_import (
    id integer NOT NULL,
    date_reported character varying(255) NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    who_region character varying(255) NOT NULL,
    new_cases character varying(255) NOT NULL,
    cumulative_cases character varying(255) NOT NULL,
    new_deaths character varying(255) NOT NULL,
    cumulative_deaths character varying(255) NOT NULL
);


ALTER TABLE public.rki_global_data_import OWNER TO covid19data;

--
-- Name: rki_global_data_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_global_data_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_global_data_import_id_seq OWNER TO covid19data;

--
-- Name: rki_global_data_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_global_data_import_id_seq OWNED BY public.rki_global_data_import.id;


--
-- Name: rki_landkreise_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_landkreise_import (
    id integer NOT NULL,
    date_reported character varying(255) NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    who_region character varying(255) NOT NULL,
    new_cases character varying(255) NOT NULL,
    cumulative_cases character varying(255) NOT NULL,
    new_deaths character varying(255) NOT NULL,
    cumulative_deaths character varying(255) NOT NULL
);


ALTER TABLE public.rki_landkreise_import OWNER TO covid19data;

--
-- Name: rki_landkreise_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_landkreise_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_landkreise_import_id_seq OWNER TO covid19data;

--
-- Name: rki_landkreise_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_landkreise_import_id_seq OWNED BY public.rki_landkreise_import.id;


--
-- Name: vaccination_germany_timeline; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.vaccination_germany_timeline (
    id integer NOT NULL,
    datum character varying(255) NOT NULL,
    dosen_kumulativ integer NOT NULL,
    dosen_differenz_zum_vortag integer NOT NULL,
    dosen_biontech_kumulativ integer NOT NULL,
    dosen_moderna_kumulativ integer NOT NULL,
    personen_erst_kumulativ integer NOT NULL,
    personen_voll_kumulativ integer NOT NULL,
    impf_quote_erst double precision NOT NULL,
    impf_quote_voll double precision NOT NULL,
    indikation_alter_dosen integer NOT NULL,
    indikation_beruf_dosen integer NOT NULL,
    indikation_medizinisch_dosen integer NOT NULL,
    indikation_pflegeheim_dosen integer NOT NULL,
    indikation_alter_erst integer NOT NULL,
    indikation_beruf_erst integer NOT NULL,
    indikation_medizinisch_erst integer NOT NULL,
    indikation_pflegeheim_erst integer NOT NULL,
    indikation_alter_voll integer NOT NULL,
    indikation_beruf_voll integer NOT NULL,
    indikation_medizinisch_voll integer NOT NULL,
    indikation_pflegeheim_voll integer NOT NULL
);


ALTER TABLE public.vaccination_germany_timeline OWNER TO covid19data;

--
-- Name: vaccination_germany_timeline_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.vaccination_germany_timeline_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.vaccination_germany_timeline_id_seq OWNER TO covid19data;

--
-- Name: vaccination_germany_timeline_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.vaccination_germany_timeline_id_seq OWNED BY public.vaccination_germany_timeline.id;


--
-- Name: who_country; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.who_country (
    id integer NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    region_id integer NOT NULL
);


ALTER TABLE public.who_country OWNER TO covid19data;

--
-- Name: who_country_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.who_country_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.who_country_id_seq OWNER TO covid19data;

--
-- Name: who_country_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.who_country_id_seq OWNED BY public.who_country.id;


--
-- Name: who_global_data; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.who_global_data (
    id integer NOT NULL,
    cases_new integer NOT NULL,
    cases_cumulative integer NOT NULL,
    deaths_new integer NOT NULL,
    deaths_cumulative integer NOT NULL,
    date_reported_id integer NOT NULL,
    country_id integer NOT NULL
);


ALTER TABLE public.who_global_data OWNER TO covid19data;

--
-- Name: who_global_data_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.who_global_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.who_global_data_id_seq OWNER TO covid19data;

--
-- Name: who_global_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.who_global_data_id_seq OWNED BY public.who_global_data.id;


--
-- Name: who_global_data_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.who_global_data_import (
    id integer NOT NULL,
    date_reported character varying(255) NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    who_region character varying(255) NOT NULL,
    new_cases character varying(255) NOT NULL,
    cumulative_cases character varying(255) NOT NULL,
    new_deaths character varying(255) NOT NULL,
    cumulative_deaths character varying(255) NOT NULL
);


ALTER TABLE public.who_global_data_import OWNER TO covid19data;

--
-- Name: who_global_data_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.who_global_data_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.who_global_data_import_id_seq OWNER TO covid19data;

--
-- Name: who_global_data_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.who_global_data_import_id_seq OWNED BY public.who_global_data_import.id;


--
-- Name: common_date_reported id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_date_reported ALTER COLUMN id SET DEFAULT nextval('public.common_date_reported_id_seq'::regclass);


--
-- Name: common_region id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_region ALTER COLUMN id SET DEFAULT nextval('public.common_region_id_seq'::regclass);


--
-- Name: europe_country id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_country ALTER COLUMN id SET DEFAULT nextval('public.europe_country_id_seq'::regclass);


--
-- Name: europe_data id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data ALTER COLUMN id SET DEFAULT nextval('public.europe_data_id_seq'::regclass);


--
-- Name: europe_data_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data_import ALTER COLUMN id SET DEFAULT nextval('public.europe_data_import_id_seq'::regclass);


--
-- Name: rki_bundeslsaender_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_bundeslsaender_import ALTER COLUMN id SET DEFAULT nextval('public.rki_bundeslsaender_import_id_seq'::regclass);


--
-- Name: rki_country id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country ALTER COLUMN id SET DEFAULT nextval('public.rki_country_id_seq'::regclass);


--
-- Name: rki_global_data id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data ALTER COLUMN id SET DEFAULT nextval('public.rki_global_data_id_seq'::regclass);


--
-- Name: rki_global_data_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data_import ALTER COLUMN id SET DEFAULT nextval('public.rki_global_data_import_id_seq'::regclass);


--
-- Name: rki_landkreise_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_landkreise_import ALTER COLUMN id SET DEFAULT nextval('public.rki_landkreise_import_id_seq'::regclass);


--
-- Name: vaccination_germany_timeline id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.vaccination_germany_timeline ALTER COLUMN id SET DEFAULT nextval('public.vaccination_germany_timeline_id_seq'::regclass);


--
-- Name: who_country id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country ALTER COLUMN id SET DEFAULT nextval('public.who_country_id_seq'::regclass);


--
-- Name: who_global_data id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data ALTER COLUMN id SET DEFAULT nextval('public.who_global_data_id_seq'::regclass);


--
-- Name: who_global_data_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data_import ALTER COLUMN id SET DEFAULT nextval('public.who_global_data_import_id_seq'::regclass);


--
-- Data for Name: common_date_reported; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 1, '01/02/2021', '2021-05', '2021-02-01', 2021, 2, 1, 1, 5);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 2, '25/01/2021', '2021-04', '2021-01-25', 2021, 1, 25, 1, 4);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 3, '18/01/2021', '2021-03', '2021-01-18', 2021, 1, 18, 1, 3);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 4, '11/01/2021', '2021-02', '2021-01-11', 2021, 1, 11, 1, 2);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 5, '04/01/2021', '2021-01', '2021-01-04', 2021, 1, 4, 1, 1);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 6, '28/12/2020', '2020-53', '2020-12-28', 2020, 12, 28, 1, 53);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 7, '21/12/2020', '2020-52', '2020-12-21', 2020, 12, 21, 1, 52);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 8, '14/12/2020', '2020-51', '2020-12-14', 2020, 12, 14, 1, 51);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 9, '07/12/2020', '2020-50', '2020-12-07', 2020, 12, 7, 1, 50);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 10, '30/11/2020', '2020-49', '2020-11-30', 2020, 11, 30, 1, 49);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 11, '23/11/2020', '2020-48', '2020-11-23', 2020, 11, 23, 1, 48);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 12, '16/11/2020', '2020-47', '2020-11-16', 2020, 11, 16, 1, 47);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 13, '09/11/2020', '2020-46', '2020-11-09', 2020, 11, 9, 1, 46);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 14, '02/11/2020', '2020-45', '2020-11-02', 2020, 11, 2, 1, 45);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 15, '26/10/2020', '2020-44', '2020-10-26', 2020, 10, 26, 1, 44);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 16, '19/10/2020', '2020-43', '2020-10-19', 2020, 10, 19, 1, 43);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 17, '12/10/2020', '2020-42', '2020-10-12', 2020, 10, 12, 1, 42);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 18, '05/10/2020', '2020-41', '2020-10-05', 2020, 10, 5, 1, 41);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 19, '28/09/2020', '2020-40', '2020-09-28', 2020, 9, 28, 1, 40);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 20, '21/09/2020', '2020-39', '2020-09-21', 2020, 9, 21, 1, 39);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 21, '14/09/2020', '2020-38', '2020-09-14', 2020, 9, 14, 1, 38);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 22, '07/09/2020', '2020-37', '2020-09-07', 2020, 9, 7, 1, 37);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 23, '31/08/2020', '2020-36', '2020-08-31', 2020, 8, 31, 1, 36);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 24, '24/08/2020', '2020-35', '2020-08-24', 2020, 8, 24, 1, 35);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 25, '17/08/2020', '2020-34', '2020-08-17', 2020, 8, 17, 1, 34);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 26, '10/08/2020', '2020-33', '2020-08-10', 2020, 8, 10, 1, 33);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 27, '03/08/2020', '2020-32', '2020-08-03', 2020, 8, 3, 1, 32);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 28, '27/07/2020', '2020-31', '2020-07-27', 2020, 7, 27, 1, 31);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 29, '20/07/2020', '2020-30', '2020-07-20', 2020, 7, 20, 1, 30);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 30, '13/07/2020', '2020-29', '2020-07-13', 2020, 7, 13, 1, 29);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 31, '06/07/2020', '2020-28', '2020-07-06', 2020, 7, 6, 1, 28);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 32, '29/06/2020', '2020-27', '2020-06-29', 2020, 6, 29, 1, 27);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 33, '22/06/2020', '2020-26', '2020-06-22', 2020, 6, 22, 1, 26);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 34, '15/06/2020', '2020-25', '2020-06-15', 2020, 6, 15, 1, 25);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 35, '08/06/2020', '2020-24', '2020-06-08', 2020, 6, 8, 1, 24);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 36, '01/06/2020', '2020-23', '2020-06-01', 2020, 6, 1, 1, 23);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 37, '25/05/2020', '2020-22', '2020-05-25', 2020, 5, 25, 1, 22);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 38, '18/05/2020', '2020-21', '2020-05-18', 2020, 5, 18, 1, 21);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 39, '11/05/2020', '2020-20', '2020-05-11', 2020, 5, 11, 1, 20);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 40, '04/05/2020', '2020-19', '2020-05-04', 2020, 5, 4, 1, 19);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 41, '27/04/2020', '2020-18', '2020-04-27', 2020, 4, 27, 1, 18);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 42, '20/04/2020', '2020-17', '2020-04-20', 2020, 4, 20, 1, 17);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 43, '13/04/2020', '2020-16', '2020-04-13', 2020, 4, 13, 1, 16);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 44, '06/04/2020', '2020-15', '2020-04-06', 2020, 4, 6, 1, 15);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 45, '30/03/2020', '2020-14', '2020-03-30', 2020, 3, 30, 1, 14);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 46, '23/03/2020', '2020-13', '2020-03-23', 2020, 3, 23, 1, 13);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 47, '16/03/2020', '2020-12', '2020-03-16', 2020, 3, 16, 1, 12);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 48, '09/03/2020', '2020-11', '2020-03-09', 2020, 3, 9, 1, 11);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 49, '02/03/2020', '2020-10', '2020-03-02', 2020, 3, 2, 1, 10);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 50, '24/02/2020', '2020-09', '2020-02-24', 2020, 2, 24, 1, 9);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 51, '17/02/2020', '2020-08', '2020-02-17', 2020, 2, 17, 1, 8);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 52, '10/02/2020', '2020-07', '2020-02-10', 2020, 2, 10, 1, 7);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 53, '03/02/2020', '2020-06', '2020-02-03', 2020, 2, 3, 1, 6);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 54, '27/01/2020', '2020-05', '2020-01-27', 2020, 1, 27, 1, 5);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 55, '20/01/2020', '2020-04', '2020-01-20', 2020, 1, 20, 1, 4);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 56, '13/01/2020', '2020-03', '2020-01-13', 2020, 1, 13, 1, 3);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 57, '06/01/2020', '2020-02', '2020-01-06', 2020, 1, 6, 1, 2);


--
-- Data for Name: common_region; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.common_region VALUES ('europe_continent', 1, 'Africa');
INSERT INTO public.common_region VALUES ('europe_continent', 2, 'America');
INSERT INTO public.common_region VALUES ('europe_continent', 3, 'Asia');
INSERT INTO public.common_region VALUES ('europe_continent', 4, 'Europe');
INSERT INTO public.common_region VALUES ('europe_continent', 5, 'Oceania');
INSERT INTO public.common_region VALUES ('europe_continent', 6, 'Other');


--
-- Data for Name: europe_country; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.europe_country VALUES (1, 'Algeria', '43053054', 'DZ', 'DZA', 1);
INSERT INTO public.europe_country VALUES (2, 'Angola', '31825299', 'AO', 'AGO', 1);
INSERT INTO public.europe_country VALUES (3, 'Benin', '11801151', 'BJ', 'BEN', 1);
INSERT INTO public.europe_country VALUES (4, 'Botswana', '2303703', 'BW', 'BWA', 1);
INSERT INTO public.europe_country VALUES (5, 'Burkina_Faso', '20321383', 'BF', 'BFA', 1);
INSERT INTO public.europe_country VALUES (6, 'Burundi', '11530577', 'BI', 'BDI', 1);
INSERT INTO public.europe_country VALUES (7, 'Cameroon', '25876387', 'CM', 'CMR', 1);
INSERT INTO public.europe_country VALUES (8, 'Cape_Verde', '549936', 'CV', 'CPV', 1);
INSERT INTO public.europe_country VALUES (9, 'Central_African_Republic', '4745179', 'CF', 'CAF', 1);
INSERT INTO public.europe_country VALUES (10, 'Chad', '15946882', 'TD', 'TCD', 1);
INSERT INTO public.europe_country VALUES (11, 'Comoros', '850891', 'KM', 'COM', 1);
INSERT INTO public.europe_country VALUES (12, 'Congo', '5380504', 'CG', 'COG', 1);
INSERT INTO public.europe_country VALUES (13, 'Cote_dIvoire', '25716554', 'CI', 'CIV', 1);
INSERT INTO public.europe_country VALUES (14, 'Democratic_Republic_of_the_Congo', '86790568', 'CD', 'COD', 1);
INSERT INTO public.europe_country VALUES (15, 'Djibouti', '973557', 'DJ', 'DJI', 1);
INSERT INTO public.europe_country VALUES (16, 'Egypt', '100388076', 'EG', 'EGY', 1);
INSERT INTO public.europe_country VALUES (17, 'Equatorial_Guinea', '1355982', 'GQ', 'GNQ', 1);
INSERT INTO public.europe_country VALUES (18, 'Eritrea', '3497117', 'ER', 'ERI', 1);
INSERT INTO public.europe_country VALUES (19, 'Eswatini', '1148133', 'SZ', 'SWZ', 1);
INSERT INTO public.europe_country VALUES (20, 'Ethiopia', '112078727', 'ET', 'ETH', 1);
INSERT INTO public.europe_country VALUES (21, 'Gabon', '2172578', 'GA', 'GAB', 1);
INSERT INTO public.europe_country VALUES (22, 'Gambia', '2347696', 'GM', 'GMB', 1);
INSERT INTO public.europe_country VALUES (23, 'Ghana', '30417858', 'GH', 'GHA', 1);
INSERT INTO public.europe_country VALUES (24, 'Guinea', '12771246', 'GN', 'GIN', 1);
INSERT INTO public.europe_country VALUES (25, 'Guinea_Bissau', '1920917', 'GW', 'GNB', 1);
INSERT INTO public.europe_country VALUES (26, 'Kenya', '52573967', 'KE', 'KEN', 1);
INSERT INTO public.europe_country VALUES (27, 'Lesotho', '2125267', 'LS', 'LSO', 1);
INSERT INTO public.europe_country VALUES (28, 'Liberia', '4937374', 'LR', 'LBR', 1);
INSERT INTO public.europe_country VALUES (29, 'Libya', '6777453', 'LY', 'LBY', 1);
INSERT INTO public.europe_country VALUES (30, 'Madagascar', '26969306', 'MG', 'MDG', 1);
INSERT INTO public.europe_country VALUES (31, 'Malawi', '18628749', 'MW', 'MWI', 1);
INSERT INTO public.europe_country VALUES (32, 'Mali', '19658023', 'ML', 'MLI', 1);
INSERT INTO public.europe_country VALUES (33, 'Mauritania', '4525698', 'MR', 'MRT', 1);
INSERT INTO public.europe_country VALUES (34, 'Mauritius', '1269670', 'MU', 'MUS', 1);
INSERT INTO public.europe_country VALUES (35, 'Morocco', '36471766', 'MA', 'MAR', 1);
INSERT INTO public.europe_country VALUES (36, 'Mozambique', '30366043', 'MZ', 'MOZ', 1);
INSERT INTO public.europe_country VALUES (37, 'Namibia', '2494524', 'NA', 'NAM', 1);
INSERT INTO public.europe_country VALUES (38, 'Niger', '23310719', 'NE', 'NER', 1);
INSERT INTO public.europe_country VALUES (39, 'Nigeria', '200963603', 'NG', 'NGA', 1);
INSERT INTO public.europe_country VALUES (40, 'Rwanda', '12626938', 'RW', 'RWA', 1);
INSERT INTO public.europe_country VALUES (41, 'Sao_Tome_and_Principe', '215048', 'ST', 'STP', 1);
INSERT INTO public.europe_country VALUES (42, 'Senegal', '16296362', 'SN', 'SEN', 1);
INSERT INTO public.europe_country VALUES (43, 'Seychelles', '97741', 'SC', 'SYC', 1);
INSERT INTO public.europe_country VALUES (44, 'Sierra_Leone', '7813207', 'SL', 'SLE', 1);
INSERT INTO public.europe_country VALUES (45, 'Somalia', '15442906', 'SO', 'SOM', 1);
INSERT INTO public.europe_country VALUES (46, 'South_Africa', '58558267', 'ZA', 'ZAF', 1);
INSERT INTO public.europe_country VALUES (47, 'South_Sudan', '11062114', 'SS', 'SSD', 1);
INSERT INTO public.europe_country VALUES (48, 'Sudan', '42813237', 'SD', 'SDN', 1);
INSERT INTO public.europe_country VALUES (49, 'Togo', '8082359', 'TG', 'TGO', 1);
INSERT INTO public.europe_country VALUES (50, 'Tunisia', '11694721', 'TN', 'TUN', 1);
INSERT INTO public.europe_country VALUES (51, 'Uganda', '44269587', 'UG', 'UGA', 1);
INSERT INTO public.europe_country VALUES (52, 'United_Republic_of_Tanzania', '58005461', 'TZ', 'TZA', 1);
INSERT INTO public.europe_country VALUES (53, 'Western_Sahara', '582458', 'EH', 'ESH', 1);
INSERT INTO public.europe_country VALUES (54, 'Zambia', '17861034', 'ZM', 'ZMB', 1);
INSERT INTO public.europe_country VALUES (55, 'Zimbabwe', '14645473', 'ZW', 'ZWE', 1);
INSERT INTO public.europe_country VALUES (56, 'Anguilla', '14872', 'AI', 'AIA', 2);
INSERT INTO public.europe_country VALUES (57, 'Antigua_and_Barbuda', '97115', 'AG', 'ATG', 2);
INSERT INTO public.europe_country VALUES (58, 'Argentina', '44780675', 'AR', 'ARG', 2);
INSERT INTO public.europe_country VALUES (59, 'Aruba', '106310', 'AW', 'ABW', 2);
INSERT INTO public.europe_country VALUES (60, 'Bahamas', '389486', 'BS', 'BHS', 2);
INSERT INTO public.europe_country VALUES (61, 'Barbados', '287021', 'BB', 'BRB', 2);
INSERT INTO public.europe_country VALUES (62, 'Belize', '390351', 'BZ', 'BLZ', 2);
INSERT INTO public.europe_country VALUES (63, 'Bermuda', '62508', 'BM', 'BMU', 2);
INSERT INTO public.europe_country VALUES (64, 'Bolivia', '11513102', 'BO', 'BOL', 2);
INSERT INTO public.europe_country VALUES (65, 'Bonaire, Saint Eustatius and Saba', '25983', 'BQ', 'BES', 2);
INSERT INTO public.europe_country VALUES (66, 'Brazil', '211049519', 'BR', 'BRA', 2);
INSERT INTO public.europe_country VALUES (67, 'British_Virgin_Islands', '30033', 'VG', 'VGB', 2);
INSERT INTO public.europe_country VALUES (68, 'Canada', '37411038', 'CA', 'CAN', 2);
INSERT INTO public.europe_country VALUES (69, 'Cayman_Islands', '64948', 'KY', 'CYM', 2);
INSERT INTO public.europe_country VALUES (70, 'Chile', '18952035', 'CL', 'CHL', 2);
INSERT INTO public.europe_country VALUES (71, 'Colombia', '50339443', 'CO', 'COL', 2);
INSERT INTO public.europe_country VALUES (72, 'Costa_Rica', '5047561', 'CR', 'CRI', 2);
INSERT INTO public.europe_country VALUES (73, 'Cuba', '11333484', 'CU', 'CUB', 2);
INSERT INTO public.europe_country VALUES (74, 'Curaçao', '163423', 'CW', 'CUW', 2);
INSERT INTO public.europe_country VALUES (75, 'Dominica', '71808', 'DM', 'DMA', 2);
INSERT INTO public.europe_country VALUES (76, 'Dominican_Republic', '10738957', 'DO', 'DOM', 2);
INSERT INTO public.europe_country VALUES (77, 'Ecuador', '17373657', 'EC', 'ECU', 2);
INSERT INTO public.europe_country VALUES (78, 'El_Salvador', '6453550', 'SV', 'SLV', 2);
INSERT INTO public.europe_country VALUES (79, 'Falkland_Islands_(Malvinas)', '3372', 'FK', 'FLK', 2);
INSERT INTO public.europe_country VALUES (80, 'Greenland', '56660', 'GL', 'GRL', 2);
INSERT INTO public.europe_country VALUES (81, 'Grenada', '112002', 'GD', 'GRD', 2);
INSERT INTO public.europe_country VALUES (82, 'Guatemala', '17581476', 'GT', 'GTM', 2);
INSERT INTO public.europe_country VALUES (83, 'Guyana', '782775', 'GY', 'GUY', 2);
INSERT INTO public.europe_country VALUES (84, 'Haiti', '11263079', 'HT', 'HTI', 2);
INSERT INTO public.europe_country VALUES (85, 'Honduras', '9746115', 'HN', 'HND', 2);
INSERT INTO public.europe_country VALUES (86, 'Jamaica', '2948277', 'JM', 'JAM', 2);
INSERT INTO public.europe_country VALUES (87, 'Mexico', '127575529', 'MX', 'MEX', 2);
INSERT INTO public.europe_country VALUES (88, 'Montserrat', '4991', 'MS', 'MSF', 2);
INSERT INTO public.europe_country VALUES (89, 'Nicaragua', '6545503', 'NI', 'NIC', 2);
INSERT INTO public.europe_country VALUES (90, 'Panama', '4246440', 'PA', 'PAN', 2);
INSERT INTO public.europe_country VALUES (91, 'Paraguay', '7044639', 'PY', 'PRY', 2);
INSERT INTO public.europe_country VALUES (92, 'Peru', '32510462', 'PE', 'PER', 2);
INSERT INTO public.europe_country VALUES (93, 'Puerto_Rico', '2933404', 'PR', 'PRI', 2);
INSERT INTO public.europe_country VALUES (94, 'Saint_Kitts_and_Nevis', '52834', 'KN', 'KNA', 2);
INSERT INTO public.europe_country VALUES (95, 'Saint_Lucia', '182795', 'LC', 'LCA', 2);
INSERT INTO public.europe_country VALUES (96, 'Saint_Vincent_and_the_Grenadines', '110593', 'VC', 'VCT', 2);
INSERT INTO public.europe_country VALUES (97, 'Sint_Maarten', '42389', 'SX', 'SXM', 2);
INSERT INTO public.europe_country VALUES (98, 'Suriname', '581363', 'SR', 'SUR', 2);
INSERT INTO public.europe_country VALUES (99, 'Trinidad_and_Tobago', '1394969', 'TT', 'TTO', 2);
INSERT INTO public.europe_country VALUES (100, 'Turks_and_Caicos_islands', '38194', 'TC', 'TCA', 2);
INSERT INTO public.europe_country VALUES (101, 'United_States_of_America', '329064917', 'US', 'USA', 2);
INSERT INTO public.europe_country VALUES (102, 'United_States_Virgin_Islands', '104579', 'VI', 'VIR', 2);
INSERT INTO public.europe_country VALUES (103, 'Uruguay', '3461731', 'UY', 'URY', 2);
INSERT INTO public.europe_country VALUES (104, 'Venezuela', '28515829', 'VE', 'VEN', 2);
INSERT INTO public.europe_country VALUES (105, 'Afghanistan', '38041757', 'AF', 'AFG', 3);
INSERT INTO public.europe_country VALUES (106, 'Bahrain', '1641164', 'BH', 'BHR', 3);
INSERT INTO public.europe_country VALUES (107, 'Bangladesh', '163046173', 'BD', 'BGD', 3);
INSERT INTO public.europe_country VALUES (108, 'Bhutan', '763094', 'BT', 'BTN', 3);
INSERT INTO public.europe_country VALUES (109, 'Brunei_Darussalam', '433296', 'BN', 'BRN', 3);
INSERT INTO public.europe_country VALUES (110, 'Cambodia', '16486542', 'KH', 'KHM', 3);
INSERT INTO public.europe_country VALUES (111, 'China', '1433783692', 'CN', 'CHN', 3);
INSERT INTO public.europe_country VALUES (112, 'India', '1366417756', 'IN', 'IND', 3);
INSERT INTO public.europe_country VALUES (113, 'Indonesia', '270625567', 'ID', 'IDN', 3);
INSERT INTO public.europe_country VALUES (114, 'Iran', '82913893', 'IR', 'IRN', 3);
INSERT INTO public.europe_country VALUES (115, 'Iraq', '39309789', 'IQ', 'IRQ', 3);
INSERT INTO public.europe_country VALUES (116, 'Israel', '8519373', 'IL', 'ISR', 3);
INSERT INTO public.europe_country VALUES (117, 'Japan', '126860299', 'JP', 'JPN', 3);
INSERT INTO public.europe_country VALUES (118, 'Jordan', '10101697', 'JO', 'JOR', 3);
INSERT INTO public.europe_country VALUES (119, 'Kazakhstan', '18551428', 'KZ', 'KAZ', 3);
INSERT INTO public.europe_country VALUES (120, 'Kuwait', '4207077', 'KW', 'KWT', 3);
INSERT INTO public.europe_country VALUES (121, 'Kyrgyzstan', '6415851', 'KG', 'KGZ', 3);
INSERT INTO public.europe_country VALUES (122, 'Laos', '7169456', 'LA', 'LAO', 3);
INSERT INTO public.europe_country VALUES (123, 'Lebanon', '6855709', 'LB', 'LBN', 3);
INSERT INTO public.europe_country VALUES (124, 'Malaysia', '31949789', 'MY', 'MYS', 3);
INSERT INTO public.europe_country VALUES (125, 'Maldives', '530957', 'MV', 'MDV', 3);
INSERT INTO public.europe_country VALUES (126, 'Mongolia', '3225166', 'MN', 'MNG', 3);
INSERT INTO public.europe_country VALUES (127, 'Myanmar', '54045422', 'MM', 'MMR', 3);
INSERT INTO public.europe_country VALUES (128, 'Nepal', '28608715', 'NP', 'NPL', 3);
INSERT INTO public.europe_country VALUES (129, 'Oman', '4974992', 'OM', 'OMN', 3);
INSERT INTO public.europe_country VALUES (130, 'Pakistan', '216565317', 'PK', 'PAK', 3);
INSERT INTO public.europe_country VALUES (131, 'Palestine', '4981422', 'PS', 'PSE', 3);
INSERT INTO public.europe_country VALUES (132, 'Philippines', '108116622', 'PH', 'PHL', 3);
INSERT INTO public.europe_country VALUES (133, 'Qatar', '2832071', 'QA', 'QAT', 3);
INSERT INTO public.europe_country VALUES (134, 'Saudi_Arabia', '34268529', 'SA', 'SAU', 3);
INSERT INTO public.europe_country VALUES (135, 'Singapore', '5804343', 'SG', 'SGP', 3);
INSERT INTO public.europe_country VALUES (136, 'South_Korea', '51225321', 'KR', 'KOR', 3);
INSERT INTO public.europe_country VALUES (137, 'Sri_Lanka', '21323734', 'LK', 'LKA', 3);
INSERT INTO public.europe_country VALUES (138, 'Syria', '17070132', 'SY', 'SYR', 3);
INSERT INTO public.europe_country VALUES (139, 'Taiwan', '23773881', 'TW', 'CNG1925', 3);
INSERT INTO public.europe_country VALUES (140, 'Tajikistan', '9321023', 'TJ', 'TJK', 3);
INSERT INTO public.europe_country VALUES (141, 'Thailand', '69625581', 'TH', 'THA', 3);
INSERT INTO public.europe_country VALUES (142, 'Timor_Leste', '1293120', 'TL', 'TLS', 3);
INSERT INTO public.europe_country VALUES (143, 'United_Arab_Emirates', '9770526', 'AE', 'ARE', 3);
INSERT INTO public.europe_country VALUES (144, 'Uzbekistan', '32981715', 'UZ', 'UZB', 3);
INSERT INTO public.europe_country VALUES (145, 'Vietnam', '96462108', 'VN', 'VNM', 3);
INSERT INTO public.europe_country VALUES (146, 'Yemen', '29161922', 'YE', 'YEM', 3);
INSERT INTO public.europe_country VALUES (147, 'Albania', '2862427', 'AL', 'ALB', 4);
INSERT INTO public.europe_country VALUES (148, 'Andorra', '76177', 'AD', 'AND', 4);
INSERT INTO public.europe_country VALUES (149, 'Armenia', '2957728', 'AM', 'ARM', 4);
INSERT INTO public.europe_country VALUES (150, 'Austria', '8858775', 'AT', 'AUT', 4);
INSERT INTO public.europe_country VALUES (151, 'Azerbaijan', '10047719', 'AZ', 'AZE', 4);
INSERT INTO public.europe_country VALUES (152, 'Belarus', '9452409', 'BY', 'BLR', 4);
INSERT INTO public.europe_country VALUES (153, 'Belgium', '11455519', 'BE', 'BEL', 4);
INSERT INTO public.europe_country VALUES (154, 'Bosnia_and_Herzegovina', '3300998', 'BA', 'BIH', 4);
INSERT INTO public.europe_country VALUES (155, 'Bulgaria', '7000039', 'BG', 'BGR', 4);
INSERT INTO public.europe_country VALUES (156, 'Croatia', '4076246', 'HR', 'HRV', 4);
INSERT INTO public.europe_country VALUES (157, 'Cyprus', '875899', 'CY', 'CYP', 4);
INSERT INTO public.europe_country VALUES (158, 'Czechia', '10649800', 'CZ', 'CZE', 4);
INSERT INTO public.europe_country VALUES (159, 'Denmark', '5806081', 'DK', 'DNK', 4);
INSERT INTO public.europe_country VALUES (160, 'Estonia', '1324820', 'EE', 'EST', 4);
INSERT INTO public.europe_country VALUES (161, 'Faroe_Islands', '48677', 'FO', 'FRO', 4);
INSERT INTO public.europe_country VALUES (162, 'Finland', '5517919', 'FI', 'FIN', 4);
INSERT INTO public.europe_country VALUES (163, 'France', '67012883', 'FR', 'FRA', 4);
INSERT INTO public.europe_country VALUES (164, 'Georgia', '3996762', 'GE', 'GEO', 4);
INSERT INTO public.europe_country VALUES (165, 'Germany', '83019213', 'DE', 'DEU', 4);
INSERT INTO public.europe_country VALUES (166, 'Gibraltar', '33706', 'GI', 'GIB', 4);
INSERT INTO public.europe_country VALUES (167, 'Greece', '10724599', 'EL', 'GRC', 4);
INSERT INTO public.europe_country VALUES (168, 'Guernsey', '64468', 'GG', 'GGY', 4);
INSERT INTO public.europe_country VALUES (169, 'Holy_See', '815', 'VA', 'VAT', 4);
INSERT INTO public.europe_country VALUES (170, 'Hungary', '9772756', 'HU', 'HUN', 4);
INSERT INTO public.europe_country VALUES (171, 'Iceland', '356991', 'IS', 'ISL', 4);
INSERT INTO public.europe_country VALUES (172, 'Ireland', '4904240', 'IE', 'IRL', 4);
INSERT INTO public.europe_country VALUES (173, 'Isle_of_Man', '84589', 'IM', 'IMN', 4);
INSERT INTO public.europe_country VALUES (174, 'Italy', '60359546', 'IT', 'ITA', 4);
INSERT INTO public.europe_country VALUES (175, 'Jersey', '107796', 'JE', 'JEY', 4);
INSERT INTO public.europe_country VALUES (176, 'Kosovo', '1798506', 'XK', 'XKX', 4);
INSERT INTO public.europe_country VALUES (177, 'Latvia', '1919968', 'LV', 'LVA', 4);
INSERT INTO public.europe_country VALUES (178, 'Liechtenstein', '38378', 'LI', 'LIE', 4);
INSERT INTO public.europe_country VALUES (179, 'Lithuania', '2794184', 'LT', 'LTU', 4);
INSERT INTO public.europe_country VALUES (180, 'Luxembourg', '613894', 'LU', 'LUX', 4);
INSERT INTO public.europe_country VALUES (181, 'Malta', '493559', 'MT', 'MLT', 4);
INSERT INTO public.europe_country VALUES (182, 'Moldova', '4043258', 'MD', 'MDA', 4);
INSERT INTO public.europe_country VALUES (183, 'Monaco', '33085', 'MC', 'MCO', 4);
INSERT INTO public.europe_country VALUES (184, 'Montenegro', '622182', 'ME', 'MNE', 4);
INSERT INTO public.europe_country VALUES (185, 'Netherlands', '17282163', 'NL', 'NLD', 4);
INSERT INTO public.europe_country VALUES (186, 'North_Macedonia', '2077132', 'MK', 'MKD', 4);
INSERT INTO public.europe_country VALUES (187, 'Norway', '5328212', 'NO', 'NOR', 4);
INSERT INTO public.europe_country VALUES (188, 'Poland', '37972812', 'PL', 'POL', 4);
INSERT INTO public.europe_country VALUES (189, 'Portugal', '10276617', 'PT', 'PRT', 4);
INSERT INTO public.europe_country VALUES (190, 'Romania', '19414458', 'RO', 'ROU', 4);
INSERT INTO public.europe_country VALUES (191, 'Russia', '145872260', 'RU', 'RUS', 4);
INSERT INTO public.europe_country VALUES (192, 'San_Marino', '34453', 'SM', 'SMR', 4);
INSERT INTO public.europe_country VALUES (193, 'Serbia', '6963764', 'RS', 'SRB', 4);
INSERT INTO public.europe_country VALUES (194, 'Slovakia', '5450421', 'SK', 'SVK', 4);
INSERT INTO public.europe_country VALUES (195, 'Slovenia', '2080908', 'SI', 'SVN', 4);
INSERT INTO public.europe_country VALUES (196, 'Spain', '46937060', 'ES', 'ESP', 4);
INSERT INTO public.europe_country VALUES (197, 'Sweden', '10230185', 'SE', 'SWE', 4);
INSERT INTO public.europe_country VALUES (198, 'Switzerland', '8544527', 'CH', 'CHE', 4);
INSERT INTO public.europe_country VALUES (199, 'Turkey', '82003882', 'TR', 'TUR', 4);
INSERT INTO public.europe_country VALUES (200, 'Ukraine', '43993643', 'UA', 'UKR', 4);
INSERT INTO public.europe_country VALUES (201, 'United_Kingdom', '66647112', 'UK', 'GBR', 4);
INSERT INTO public.europe_country VALUES (202, 'Australia', '25203200', 'AU', 'AUS', 5);
INSERT INTO public.europe_country VALUES (203, 'Fiji', '889955', 'FJ', 'FJI', 5);
INSERT INTO public.europe_country VALUES (204, 'French_Polynesia', '279285', 'PF', 'PYF', 5);
INSERT INTO public.europe_country VALUES (205, 'Guam', '167295', 'GU', 'GUM', 5);
INSERT INTO public.europe_country VALUES (206, 'Marshall_Islands', '58791', 'MH', 'MHL', 5);
INSERT INTO public.europe_country VALUES (207, 'Micronesia_(Federated_States_of)', '113811', 'FM', 'FSM', 5);
INSERT INTO public.europe_country VALUES (208, 'New_Caledonia', '282757', 'NC', 'NCL', 5);
INSERT INTO public.europe_country VALUES (209, 'New_Zealand', '4783062', 'NZ', 'NZL', 5);
INSERT INTO public.europe_country VALUES (210, 'Northern_Mariana_Islands', '57213', 'MP', 'MNP', 5);
INSERT INTO public.europe_country VALUES (211, 'Papua_New_Guinea', '8776119', 'PG', 'PNG', 5);
INSERT INTO public.europe_country VALUES (212, 'Solomon_Islands', '669821', 'SB', 'SLB', 5);
INSERT INTO public.europe_country VALUES (213, 'Vanuatu', '299882', 'VU', 'VUT', 5);
INSERT INTO public.europe_country VALUES (214, 'Wallis_and_Futuna', '', 'WF', '', 5);
INSERT INTO public.europe_country VALUES (215, 'Cases_on_an_international_conveyance_Japan', '', 'JPG11668', '', 6);


--
-- Data for Name: europe_data; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.europe_data VALUES (1, 16, 267, 2.58, 105, 2);
INSERT INTO public.europe_data VALUES (2, 65, 5853, 364.62, 147, 2);
INSERT INTO public.europe_data VALUES (3, 28, 1743, 8.14, 1, 2);
INSERT INTO public.europe_data VALUES (4, 5, 388, 1121.07, 148, 2);
INSERT INTO public.europe_data VALUES (5, 7, 397, 2.89, 2, 2);
INSERT INTO public.europe_data VALUES (6, 0, 1, 13.45, 56, 2);
INSERT INTO public.europe_data VALUES (7, 0, 33, 46.34, 57, 2);
INSERT INTO public.europe_data VALUES (8, 1215, 59056, 282.36, 58, 2);
INSERT INTO public.europe_data VALUES (9, 37, 994, 81.55, 149, 2);
INSERT INTO public.europe_data VALUES (10, 2, 244, 518.3, 59, 2);
INSERT INTO public.europe_data VALUES (11, 0, 52, 0.44, 202, 2);
INSERT INTO public.europe_data VALUES (12, 291, 9451, 224.32, 150, 2);
INSERT INTO public.europe_data VALUES (13, 39, 1187, 28.15, 151, 2);
INSERT INTO public.europe_data VALUES (14, 1, 41, 27.47, 60, 2);
INSERT INTO public.europe_data VALUES (15, 8, 3601, 332.08, 106, 2);
INSERT INTO public.europe_data VALUES (16, 104, 3340, 4.6, 107, 2);
INSERT INTO public.europe_data VALUES (17, 4, 157, 161.31, 61, 2);
INSERT INTO public.europe_data VALUES (18, 69, 10725, 221.91, 152, 2);
INSERT INTO public.europe_data VALUES (19, 291, 16454, 276.37, 153, 2);
INSERT INTO public.europe_data VALUES (20, 9, 175, 111.95, 62, 2);
INSERT INTO public.europe_data VALUES (21, 4, 250, 4.07, 3, 2);
INSERT INTO public.europe_data VALUES (22, 0, 6, 14.4, 63, 2);
INSERT INTO public.europe_data VALUES (23, 0, 4, 2.23, 108, 2);
INSERT INTO public.europe_data VALUES (24, 328, 14017, 257.55, 64, 2);
INSERT INTO public.europe_data VALUES (25, 0, 10, 103.91, 65, 2);
INSERT INTO public.europe_data VALUES (26, 131, 2056, 124.69, 154, 2);
INSERT INTO public.europe_data VALUES (27, 29, 1639, 170.51, 4, 2);
INSERT INTO public.europe_data VALUES (28, 7435, 357929, 339.99, 66, 2);
INSERT INTO public.europe_data VALUES (29, 0, 4, 66.59, 67, 2);
INSERT INTO public.europe_data VALUES (30, 0, 5, 1.38, 109, 2);
INSERT INTO public.europe_data VALUES (31, 225, 3931, 99.07, 155, 2);
INSERT INTO public.europe_data VALUES (32, 4, 665, 7.78, 5, 2);
INSERT INTO public.europe_data VALUES (33, 0, 156, 3.46, 6, 2);
INSERT INTO public.europe_data VALUES (34, 0, 8, 0.15, 110, 2);
INSERT INTO public.europe_data VALUES (35, 12, 696, 8.9, 7, 2);
INSERT INTO public.europe_data VALUES (36, 898, 30578, 183.15, 68, 2);
INSERT INTO public.europe_data VALUES (37, 4, 609, 200.93, 8, 2);
INSERT INTO public.europe_data VALUES (38, 0, 15, 27.71, 69, 2);
INSERT INTO public.europe_data VALUES (39, 0, 9, 0.32, 9, 2);
INSERT INTO public.europe_data VALUES (40, 5, 224, 3.07, 10, 2);
INSERT INTO public.europe_data VALUES (41, 538, 27710, 301.49, 70, 2);
INSERT INTO public.europe_data VALUES (42, 13, 816, 0.15, 111, 2);
INSERT INTO public.europe_data VALUES (43, 2525, 76760, 360.3, 71, 2);
INSERT INTO public.europe_data VALUES (44, 27, 543, 143.26, 11, 2);
INSERT INTO public.europe_data VALUES (45, 1, 93, 3.31, 12, 2);
INSERT INTO public.europe_data VALUES (46, 76, 3824, 169.45, 72, 2);
INSERT INTO public.europe_data VALUES (47, 5, 844, 9.54, 13, 2);
INSERT INTO public.europe_data VALUES (48, 195, 3466, 181.34, 156, 2);
INSERT INTO public.europe_data VALUES (49, 19, 5764, 80.73, 73, 2);
INSERT INTO public.europe_data VALUES (50, 1, 37, 39.77, 74, 2);
INSERT INTO public.europe_data VALUES (51, 13, 859, 217.83, 157, 2);
INSERT INTO public.europe_data VALUES (52, 939, 47325, 896.51, 158, 2);
INSERT INTO public.europe_data VALUES (53, 12, 888, 2.05, 14, 2);
INSERT INTO public.europe_data VALUES (54, 135, 3664, 156.13, 159, 2);
INSERT INTO public.europe_data VALUES (55, 2, 13, 2.77, 15, 2);
INSERT INTO public.europe_data VALUES (56, 0, 4, 5.57, 75, 2);
INSERT INTO public.europe_data VALUES (57, 143, 9924, 187.36, 76, 2);
INSERT INTO public.europe_data VALUES (58, 251, 9419, 111.33, 77, 2);
INSERT INTO public.europe_data VALUES (59, 357, 4134, 9.52, 16, 2);
INSERT INTO public.europe_data VALUES (60, 49, 1716, 58.23, 78, 2);
INSERT INTO public.europe_data VALUES (61, 0, 80, 12.46, 17, 2);
INSERT INTO public.europe_data VALUES (62, 0, 185, 7.38, 18, 2);
INSERT INTO public.europe_data VALUES (63, 43, 3492, 518.11, 160, 2);
INSERT INTO public.europe_data VALUES (64, 198, 2860, 249.1, 19, 2);
INSERT INTO public.europe_data VALUES (65, 37, 4617, 6.41, 20, 2);
INSERT INTO public.europe_data VALUES (66, 0, 3, 237.25, 79, 2);
INSERT INTO public.europe_data VALUES (67, 0, 2, 10.27, 161, 2);
INSERT INTO public.europe_data VALUES (68, 0, 0, 0, 203, 2);
INSERT INTO public.europe_data VALUES (69, 22, 2902, 93.24, 162, 2);
INSERT INTO public.europe_data VALUES (70, 3008, 143497, 426.97, 163, 2);
INSERT INTO public.europe_data VALUES (71, 5, 425, 152.17, 204, 2);
INSERT INTO public.europe_data VALUES (72, 1, 542, 48.51, 21, 2);
INSERT INTO public.europe_data VALUES (73, 3, 131, 9.75, 22, 2);
INSERT INTO public.europe_data VALUES (74, 123, 4535, 261.11, 164, 2);
INSERT INTO public.europe_data VALUES (75, 5033, 80306, 218.4, 165, 2);
INSERT INTO public.europe_data VALUES (76, 44, 4875, 30.56, 23, 2);
INSERT INTO public.europe_data VALUES (77, 14, 148, 1317.27, 166, 2);
INSERT INTO public.europe_data VALUES (78, 150, 4977, 77.86, 167, 2);
INSERT INTO public.europe_data VALUES (79, 0, 0, 0, 80, 2);
INSERT INTO public.europe_data VALUES (80, 0, 0, 8.04, 81, 2);
INSERT INTO public.europe_data VALUES (81, 0, 54, 73.52, 205, 2);
INSERT INTO public.europe_data VALUES (82, 204, 5202, 59.64, 82, 2);
INSERT INTO public.europe_data VALUES (83, 0, 218, 356.77, 168, 2);
INSERT INTO public.europe_data VALUES (84, 1, 176, 3, 24, 2);
INSERT INTO public.europe_data VALUES (85, 0, 103, 6.56, 25, 2);
INSERT INTO public.europe_data VALUES (86, 4, 324, 93.64, 83, 2);
INSERT INTO public.europe_data VALUES (87, 2, 304, 6.06, 84, 2);
INSERT INTO public.europe_data VALUES (88, 0, 0, 0, 169, 2);
INSERT INTO public.europe_data VALUES (89, 148, 5859, 140.9, 85, 2);
INSERT INTO public.europe_data VALUES (90, 554, 8292, 163.79, 170, 2);
INSERT INTO public.europe_data VALUES (91, 0, 19, 10.92, 171, 2);
INSERT INTO public.europe_data VALUES (92, 922, 89874, 13.6, 112, 2);
INSERT INTO public.europe_data VALUES (93, 2163, 89052, 62.96, 113, 2);
INSERT INTO public.europe_data VALUES (94, 576, 45022, 105.64, 114, 2);
INSERT INTO public.europe_data VALUES (95, 54, 5873, 29.01, 115, 2);
INSERT INTO public.europe_data VALUES (96, 337, 8993, 485.72, 172, 2);
INSERT INTO public.europe_data VALUES (97, 0, 2, 7.09, 173, 2);
INSERT INTO public.europe_data VALUES (98, 359, 45208, 1110.27, 116, 2);
INSERT INTO public.europe_data VALUES (99, 3055, 86219, 284.55, 174, 2);
INSERT INTO public.europe_data VALUES (100, 14, 766, 51.01, 86, 2);
INSERT INTO public.europe_data VALUES (101, 703, 28857, 48.26, 117, 2);
INSERT INTO public.europe_data VALUES (102, 3, 30, 90.91, 175, 2);
INSERT INTO public.europe_data VALUES (103, 102, 7609, 123.92, 118, 2);
INSERT INTO public.europe_data VALUES (104, 88, 9953, 101.77, 119, 2);
INSERT INTO public.europe_data VALUES (105, 22, 804, 3.22, 26, 2);
INSERT INTO public.europe_data VALUES (106, 42, 2130, 242.81, 176, 2);
INSERT INTO public.europe_data VALUES (107, 7, 3972, 177.8, 120, 2);
INSERT INTO public.europe_data VALUES (108, 11, 617, 21.98, 121, 2);
INSERT INTO public.europe_data VALUES (109, 0, 0, 0.04, 122, 2);
INSERT INTO public.europe_data VALUES (110, 84, 5233, 550.89, 177, 2);
INSERT INTO public.europe_data VALUES (111, 762, 21455, 703.65, 123, 2);
INSERT INTO public.europe_data VALUES (112, 37, 622, 89.73, 27, 2);
INSERT INTO public.europe_data VALUES (113, 0, 25, 1.05, 28, 2);
INSERT INTO public.europe_data VALUES (114, 94, 4103, 140.66, 29, 2);
INSERT INTO public.europe_data VALUES (115, 0, 43, 265.78, 178, 2);
INSERT INTO public.europe_data VALUES (116, 161, 5727, 533.29, 179, 2);
INSERT INTO public.europe_data VALUES (117, 16, 965, 295.98, 180, 2);
INSERT INTO public.europe_data VALUES (118, 2, 322, 2.83, 30, 2);
INSERT INTO public.europe_data VALUES (119, 194, 4378, 63.85, 31, 2);
INSERT INTO public.europe_data VALUES (120, 82, 31158, 176.92, 124, 2);
INSERT INTO public.europe_data VALUES (121, 1, 848, 250.11, 125, 2);
INSERT INTO public.europe_data VALUES (122, 8, 117, 1.33, 32, 2);
INSERT INTO public.europe_data VALUES (123, 22, 1177, 465.19, 181, 2);
INSERT INTO public.europe_data VALUES (124, 0, 0, 0, 206, 2);
INSERT INTO public.europe_data VALUES (125, 5, 146, 11.14, 33, 2);
INSERT INTO public.europe_data VALUES (126, 0, 1, 1.73, 34, 2);
INSERT INTO public.europe_data VALUES (127, 8827, 97968, 172.61, 87, 2);
INSERT INTO public.europe_data VALUES (128, 0, 0, 0, 207, 2);
INSERT INTO public.europe_data VALUES (129, 77, 3602, 171.89, 182, 2);
INSERT INTO public.europe_data VALUES (130, 5, 132, 858.4, 183, 2);
INSERT INTO public.europe_data VALUES (131, 2, 171, 8.93, 126, 2);
INSERT INTO public.europe_data VALUES (132, 37, 3343, 991.03, 184, 2);
INSERT INTO public.europe_data VALUES (133, 0, 0, 0, 88, 2);
INSERT INTO public.europe_data VALUES (134, 125, 4868, 31.49, 35, 2);
INSERT INTO public.europe_data VALUES (135, 23, 6679, 42.51, 36, 2);
INSERT INTO public.europe_data VALUES (136, 69, 2571, 10.78, 127, 2);
INSERT INTO public.europe_data VALUES (137, 34, 1743, 152.53, 37, 2);
INSERT INTO public.europe_data VALUES (138, 28, 1509, 12.71, 128, 2);
INSERT INTO public.europe_data VALUES (139, 445, 28671, 371.83, 185, 2);
INSERT INTO public.europe_data VALUES (140, 0, 3, 1.06, 208, 2);
INSERT INTO public.europe_data VALUES (141, 0, 15, 0.86, 209, 2);
INSERT INTO public.europe_data VALUES (142, 1, 49, 1.54, 89, 2);
INSERT INTO public.europe_data VALUES (143, 10, 184, 1.63, 38, 2);
INSERT INTO public.europe_data VALUES (144, 100, 8922, 10.71, 39, 2);
INSERT INTO public.europe_data VALUES (145, 70, 2039, 180.78, 186, 2);
INSERT INTO public.europe_data VALUES (146, 0, 3, 6.99, 210, 2);
INSERT INTO public.europe_data VALUES (147, 19, 1884, 80.98, 187, 2);
INSERT INTO public.europe_data VALUES (148, 11, 1480, 54.95, 129, 2);
INSERT INTO public.europe_data VALUES (149, 365, 12387, 11.64, 130, 2);
INSERT INTO public.europe_data VALUES (150, 50, 3973, 154.65, 131, 2);
INSERT INTO public.europe_data VALUES (151, 172, 8221, 526.56, 90, 2);
INSERT INTO public.europe_data VALUES (152, 0, 18, 0.38, 211, 2);
INSERT INTO public.europe_data VALUES (153, 86, 4861, 157.1, 91, 2);
INSERT INTO public.europe_data VALUES (154, 1404, 43703, 227.35, 92, 2);
INSERT INTO public.europe_data VALUES (155, 507, 11999, 23.16, 132, 2);
INSERT INTO public.europe_data VALUES (156, 1779, 35266, 196.12, 188, 2);
INSERT INTO public.europe_data VALUES (157, 2036, 83208, 1652.47, 189, 2);
INSERT INTO public.europe_data VALUES (158, 58, 5521, 448.32, 93, 2);
INSERT INTO public.europe_data VALUES (159, 0, 2316, 135.27, 133, 2);
INSERT INTO public.europe_data VALUES (160, 561, 17495, 179.78, 190, 2);
INSERT INTO public.europe_data VALUES (161, 3701, 129397, 189.91, 191, 2);
INSERT INTO public.europe_data VALUES (162, 24, 2484, 35.06, 40, 2);
INSERT INTO public.europe_data VALUES (163, 0, 3, 5.68, 94, 2);
INSERT INTO public.europe_data VALUES (164, 2, 490, 437.65, 95, 2);
INSERT INTO public.europe_data VALUES (165, 0, 205, 413.23, 96, 2);
INSERT INTO public.europe_data VALUES (166, 2, 151, 690.8, 192, 2);
INSERT INTO public.europe_data VALUES (167, 0, 58, 48.83, 41, 2);
INSERT INTO public.europe_data VALUES (168, 23, 1703, 9.18, 134, 2);
INSERT INTO public.europe_data VALUES (169, 56, 1934, 22.72, 42, 2);
INSERT INTO public.europe_data VALUES (170, 134, 11660, 326.4, 193, 2);
INSERT INTO public.europe_data VALUES (171, 2, 154, 529.97, 43, 2);
INSERT INTO public.europe_data VALUES (172, 2, 461, 8.04, 44, 2);
INSERT INTO public.europe_data VALUES (173, 0, 228, 7.29, 135, 2);
INSERT INTO public.europe_data VALUES (174, 0, 112, 504.85, 97, 2);
INSERT INTO public.europe_data VALUES (175, 574, 12886, 468.37, 194, 2);
INSERT INTO public.europe_data VALUES (176, 171, 8334, 818.83, 195, 2);
INSERT INTO public.europe_data VALUES (177, 0, 0, 0, 212, 2);
INSERT INTO public.europe_data VALUES (178, 0, 30, 0.26, 45, 2);
INSERT INTO public.europe_data VALUES (179, 3525, 43323, 202.16, 46, 2);
INSERT INTO public.europe_data VALUES (180, 65, 2987, 11.28, 136, 2);
INSERT INTO public.europe_data VALUES (181, 0, 249, 3.32, 47, 2);
INSERT INTO public.europe_data VALUES (182, 2873, 229423, 1036.18, 196, 2);
INSERT INTO public.europe_data VALUES (183, 33, 5727, 52.03, 137, 2);
INSERT INTO public.europe_data VALUES (184, 85, 927, 14.33, 48, 2);
INSERT INTO public.europe_data VALUES (185, 7, 337, 141.91, 98, 2);
INSERT INTO public.europe_data VALUES (186, 89, 20683, 429.49, 197, 2);
INSERT INTO public.europe_data VALUES (187, 295, 11451, 293.24, 198, 2);
INSERT INTO public.europe_data VALUES (188, 36, 420, 5.93, 138, 2);
INSERT INTO public.europe_data VALUES (189, 1, 23, 0.21, 139, 2);
INSERT INTO public.europe_data VALUES (190, 0, 0, 0, 140, 2);
INSERT INTO public.europe_data VALUES (191, 2, 5931, 10.33, 141, 2);
INSERT INTO public.europe_data VALUES (192, 0, 3, 1.39, 142, 2);
INSERT INTO public.europe_data VALUES (193, 3, 430, 9.77, 49, 2);
INSERT INTO public.europe_data VALUES (194, 0, 74, 12.26, 99, 2);
INSERT INTO public.europe_data VALUES (195, 515, 11409, 240.79, 50, 2);
INSERT INTO public.europe_data VALUES (196, 920, 47858, 110.19, 199, 2);
INSERT INTO public.europe_data VALUES (197, 2, 217, 1044.67, 100, 2);
INSERT INTO public.europe_data VALUES (198, 7, 418, 3.44, 51, 2);
INSERT INTO public.europe_data VALUES (199, 1010, 29551, 136.75, 200, 2);
INSERT INTO public.europe_data VALUES (200, 58, 25654, 515.3, 143, 2);
INSERT INTO public.europe_data VALUES (201, 8219, 169713, 632.01, 201, 2);
INSERT INTO public.europe_data VALUES (202, 0, 0, 0, 52, 2);
INSERT INTO public.europe_data VALUES (203, 22226, 1024054, 724.12, 101, 2);
INSERT INTO public.europe_data VALUES (204, 0, 71, 153.95, 102, 2);
INSERT INTO public.europe_data VALUES (205, 54, 4087, 267.64, 103, 2);
INSERT INTO public.europe_data VALUES (206, 0, 326, 2.18, 144, 2);
INSERT INTO public.europe_data VALUES (207, 0, 0, 0, 213, 2);
INSERT INTO public.europe_data VALUES (208, 41, 3218, 22.73, 104, 2);
INSERT INTO public.europe_data VALUES (209, 0, 271, 0.29, 145, 2);
INSERT INTO public.europe_data VALUES (210, 0, 1, 0, 214, 2);
INSERT INTO public.europe_data VALUES (211, 0, 0, 0, 53, 2);
INSERT INTO public.europe_data VALUES (212, 0, 3, 0.03, 146, 2);
INSERT INTO public.europe_data VALUES (213, 120, 8896, 94.26, 54, 2);
INSERT INTO public.europe_data VALUES (214, 229, 2228, 43.32, 55, 2);
INSERT INTO public.europe_data VALUES (215, 43, 713, 3.34, 105, 3);
INSERT INTO public.europe_data VALUES (216, 38, 4584, 303.2, 147, 3);
INSERT INTO public.europe_data VALUES (217, 27, 1763, 8.02, 1, 3);
INSERT INTO public.europe_data VALUES (218, 5, 466, 1138.14, 148, 3);
INSERT INTO public.europe_data VALUES (219, 23, 524, 3.79, 2, 3);
INSERT INTO public.europe_data VALUES (220, 0, 1, 6.72, 56, 3);
INSERT INTO public.europe_data VALUES (221, 0, 12, 25.74, 57, 3);
INSERT INTO public.europe_data VALUES (222, 1202, 67388, 321.29, 58, 3);
INSERT INTO public.europe_data VALUES (223, 49, 1418, 128.68, 149, 3);
INSERT INTO public.europe_data VALUES (224, 5, 307, 633.99, 59, 3);
INSERT INTO public.europe_data VALUES (225, 0, 58, 0.6, 202, 3);
INSERT INTO public.europe_data VALUES (226, 348, 10421, 246.39, 150, 3);
INSERT INTO public.europe_data VALUES (227, 71, 1641, 41.85, 151, 3);
INSERT INTO public.europe_data VALUES (228, 0, 66, 33.12, 60, 3);
INSERT INTO public.europe_data VALUES (229, 7, 1849, 237.51, 106, 3);
INSERT INTO public.europe_data VALUES (230, 117, 4167, 5.73, 107, 3);
INSERT INTO public.europe_data VALUES (231, 3, 306, 180.13, 61, 3);
INSERT INTO public.europe_data VALUES (232, 58, 10251, 249.86, 152, 3);
INSERT INTO public.europe_data VALUES (233, 373, 15206, 253.6, 153, 3);
INSERT INTO public.europe_data VALUES (234, 12, 262, 119.64, 62, 3);
INSERT INTO public.europe_data VALUES (235, 2, 230, 2.87, 3, 3);
INSERT INTO public.europe_data VALUES (236, 0, 3, 47.99, 63, 3);
INSERT INTO public.europe_data VALUES (237, 0, 13, 5.5, 108, 3);
INSERT INTO public.europe_data VALUES (238, 415, 15635, 251.21, 64, 3);
INSERT INTO public.europe_data VALUES (239, 0, 17, 184.74, 65, 3);
INSERT INTO public.europe_data VALUES (240, 107, 2060, 132.84, 154, 3);
INSERT INTO public.europe_data VALUES (241, 34, 2289, 156.44, 4, 3);
INSERT INTO public.europe_data VALUES (242, 7365, 359623, 350.52, 66, 3);
INSERT INTO public.europe_data VALUES (243, 0, 16, 133.19, 67, 3);
INSERT INTO public.europe_data VALUES (244, 0, 1, 0.46, 109, 3);
INSERT INTO public.europe_data VALUES (245, 337, 3004, 90.09, 155, 3);
INSERT INTO public.europe_data VALUES (246, 15, 915, 9, 5, 3);
INSERT INTO public.europe_data VALUES (247, 0, 243, 3.99, 6, 3);
INSERT INTO public.europe_data VALUES (248, 0, 17, 0.41, 110, 3);
INSERT INTO public.europe_data VALUES (249, 7, 1607, 10.7, 7, 3);
INSERT INTO public.europe_data VALUES (250, 1118, 37939, 226.75, 68, 3);
INSERT INTO public.europe_data VALUES (251, 11, 496, 192.02, 8, 3);
INSERT INTO public.europe_data VALUES (252, 0, 3, 32.33, 69, 3);
INSERT INTO public.europe_data VALUES (253, 0, 6, 0.15, 9, 3);
INSERT INTO public.europe_data VALUES (254, 5, 266, 3.91, 10, 3);
INSERT INTO public.europe_data VALUES (255, 452, 29428, 302.27, 70, 3);
INSERT INTO public.europe_data VALUES (256, 7, 1308, 0.17, 111, 3);
INSERT INTO public.europe_data VALUES (257, 2743, 104614, 448.64, 71, 3);
INSERT INTO public.europe_data VALUES (258, 26, 676, 130.22, 11, 3);
INSERT INTO public.europe_data VALUES (259, 3, 85, 10.72, 12, 3);
INSERT INTO public.europe_data VALUES (260, 100, 4729, 211.67, 72, 3);
INSERT INTO public.europe_data VALUES (261, 5, 1609, 12.05, 13, 3);
INSERT INTO public.europe_data VALUES (262, 204, 3926, 216.65, 156, 3);
INSERT INTO public.europe_data VALUES (263, 24, 3385, 60.18, 73, 3);
INSERT INTO public.europe_data VALUES (264, 1, 28, 51.4, 74, 3);
INSERT INTO public.europe_data VALUES (265, 16, 1049, 304.49, 157, 3);
INSERT INTO public.europe_data VALUES (266, 1004, 48152, 981.71, 158, 3);
INSERT INTO public.europe_data VALUES (267, 28, 895, 2.83, 14, 3);
INSERT INTO public.europe_data VALUES (268, 205, 5401, 216.51, 159, 3);
INSERT INTO public.europe_data VALUES (269, 0, 14, 4.93, 15, 3);
INSERT INTO public.europe_data VALUES (270, 0, 0, 5.57, 75, 3);
INSERT INTO public.europe_data VALUES (271, 97, 10196, 203.74, 76, 3);
INSERT INTO public.europe_data VALUES (272, 317, 9923, 115.47, 77, 3);
INSERT INTO public.europe_data VALUES (273, 376, 5420, 11.98, 16, 3);
INSERT INTO public.europe_data VALUES (274, 85, 2042, 70.88, 78, 3);
INSERT INTO public.europe_data VALUES (275, 0, 89, 11.65, 17, 3);
INSERT INTO public.europe_data VALUES (276, 1, 73, 11.27, 18, 3);
INSERT INTO public.europe_data VALUES (277, 43, 3372, 521.66, 160, 3);
INSERT INTO public.europe_data VALUES (278, 0, 0, 107.39, 19, 3);
INSERT INTO public.europe_data VALUES (279, 36, 2572, 4.6, 20, 3);
INSERT INTO public.europe_data VALUES (280, 0, 5, 237.25, 79, 3);
INSERT INTO public.europe_data VALUES (281, 0, 3, 12.33, 161, 3);
INSERT INTO public.europe_data VALUES (282, 0, 0, 0.22, 203, 3);
INSERT INTO public.europe_data VALUES (283, 34, 2243, 72.31, 162, 3);
INSERT INTO public.europe_data VALUES (284, 2766, 142628, 403.45, 163, 3);
INSERT INTO public.europe_data VALUES (285, 0, 0, 141.07, 204, 3);
INSERT INTO public.europe_data VALUES (286, 1, 512, 30.88, 21, 3);
INSERT INTO public.europe_data VALUES (287, 1, 98, 5.62, 22, 3);
INSERT INTO public.europe_data VALUES (288, 113, 5901, 351.18, 164, 3);
INSERT INTO public.europe_data VALUES (289, 5454, 101006, 265.77, 165, 3);
INSERT INTO public.europe_data VALUES (290, 26, 4421, 19.41, 23, 3);
INSERT INTO public.europe_data VALUES (291, 20, 296, 2361.6, 166, 3);
INSERT INTO public.europe_data VALUES (292, 177, 3373, 67.53, 167, 3);
INSERT INTO public.europe_data VALUES (293, 0, 0, 5.29, 80, 3);
INSERT INTO public.europe_data VALUES (294, 0, 9, 11.61, 81, 3);
INSERT INTO public.europe_data VALUES (295, 1, 69, 78.3, 205, 3);
INSERT INTO public.europe_data VALUES (296, 191, 5284, 64.03, 82, 3);
INSERT INTO public.europe_data VALUES (297, 0, 12, 24.82, 168, 3);
INSERT INTO public.europe_data VALUES (298, 1, 207, 3.05, 24, 3);
INSERT INTO public.europe_data VALUES (299, 0, 23, 2.81, 25, 3);
INSERT INTO public.europe_data VALUES (300, 2, 409, 71.92, 83, 3);
INSERT INTO public.europe_data VALUES (301, 3, 379, 9, 84, 3);
INSERT INTO public.europe_data VALUES (302, 0, 0, 0, 169, 3);
INSERT INTO public.europe_data VALUES (303, 108, 7873, 144.05, 85, 3);
INSERT INTO public.europe_data VALUES (304, 615, 7715, 171.52, 170, 3);
INSERT INTO public.europe_data VALUES (305, 0, 20, 25.77, 171, 3);
INSERT INTO public.europe_data VALUES (306, 1051, 95963, 14.72, 112, 3);
INSERT INTO public.europe_data VALUES (307, 1848, 81333, 59.58, 113, 3);
INSERT INTO public.europe_data VALUES (308, 580, 42566, 104.41, 114, 3);
INSERT INTO public.europe_data VALUES (309, 49, 5531, 39.16, 115, 3);
INSERT INTO public.europe_data VALUES (310, 362, 14828, 814.42, 172, 3);
INSERT INTO public.europe_data VALUES (311, 0, 4, 42.56, 173, 3);
INSERT INTO public.europe_data VALUES (312, 432, 49380, 1244.29, 116, 3);
INSERT INTO public.europe_data VALUES (313, 3284, 85536, 315.31, 174, 3);
INSERT INTO public.europe_data VALUES (314, 12, 738, 46.64, 86, 3);
INSERT INTO public.europe_data VALUES (315, 518, 32367, 58.26, 117, 3);
INSERT INTO public.europe_data VALUES (316, 1, 68, 139.15, 175, 3);
INSERT INTO public.europe_data VALUES (317, 71, 4909, 116.64, 118, 3);
INSERT INTO public.europe_data VALUES (318, 67, 8927, 85.2, 119, 3);
INSERT INTO public.europe_data VALUES (319, 13, 890, 3.39, 26, 3);
INSERT INTO public.europe_data VALUES (320, 46, 2237, 239.75, 176, 3);
INSERT INTO public.europe_data VALUES (321, 5, 3508, 165.7, 120, 3);
INSERT INTO public.europe_data VALUES (322, 14, 793, 24.8, 121, 3);
INSERT INTO public.europe_data VALUES (323, 0, 3, 0.04, 122, 3);
INSERT INTO public.europe_data VALUES (324, 133, 5344, 595.84, 177, 3);
INSERT INTO public.europe_data VALUES (325, 455, 26785, 879.57, 123, 3);
INSERT INTO public.europe_data VALUES (326, 30, 1285, 80.88, 27, 3);
INSERT INTO public.europe_data VALUES (327, 0, 27, 2.31, 28, 3);
INSERT INTO public.europe_data VALUES (328, 91, 5430, 146.38, 29, 3);
INSERT INTO public.europe_data VALUES (329, 2, 59, 281.41, 178, 3);
INSERT INTO public.europe_data VALUES (330, 195, 9174, 598.39, 179, 3);
INSERT INTO public.europe_data VALUES (331, 12, 852, 280.18, 180, 3);
INSERT INTO public.europe_data VALUES (332, 6, 442, 2.75, 30, 3);
INSERT INTO public.europe_data VALUES (333, 204, 7517, 61.26, 31, 3);
INSERT INTO public.europe_data VALUES (334, 77, 25367, 149.64, 124, 3);
INSERT INTO public.europe_data VALUES (335, 2, 480, 166.49, 125, 3);
INSERT INTO public.europe_data VALUES (336, 11, 144, 1.95, 32, 3);
INSERT INTO public.europe_data VALUES (337, 12, 1119, 472.49, 181, 3);
INSERT INTO public.europe_data VALUES (338, 0, 0, 0, 206, 3);
INSERT INTO public.europe_data VALUES (339, 11, 358, 19.55, 33, 3);
INSERT INTO public.europe_data VALUES (340, 0, 21, 1.81, 34, 3);
INSERT INTO public.europe_data VALUES (341, 9025, 122238, 180.37, 87, 3);
INSERT INTO public.europe_data VALUES (342, 0, 0, 0, 207, 3);
INSERT INTO public.europe_data VALUES (343, 111, 3348, 168.45, 182, 3);
INSERT INTO public.europe_data VALUES (344, 0, 152, 906.76, 183, 3);
INSERT INTO public.europe_data VALUES (345, 0, 117, 6.23, 126, 3);
INSERT INTO public.europe_data VALUES (346, 23, 2823, 945.86, 184, 3);
INSERT INTO public.europe_data VALUES (347, 0, 0, 0, 88, 3);
INSERT INTO public.europe_data VALUES (348, 208, 6618, 37.72, 35, 3);
INSERT INTO public.europe_data VALUES (349, 122, 6230, 34.4, 36, 3);
INSERT INTO public.europe_data VALUES (350, 107, 3256, 12.9, 127, 3);
INSERT INTO public.europe_data VALUES (351, 34, 2062, 153.26, 37, 3);
INSERT INTO public.europe_data VALUES (352, 42, 2128, 16.32, 128, 3);
INSERT INTO public.europe_data VALUES (353, 522, 35590, 431.41, 185, 3);
INSERT INTO public.europe_data VALUES (354, 0, 0, 1.41, 208, 3);
INSERT INTO public.europe_data VALUES (355, 0, 26, 1.38, 209, 3);
INSERT INTO public.europe_data VALUES (356, 1, 52, 1.63, 89, 3);
INSERT INTO public.europe_data VALUES (357, 11, 197, 2.04, 38, 3);
INSERT INTO public.europe_data VALUES (358, 72, 12609, 11.4, 39, 3);
INSERT INTO public.europe_data VALUES (359, 83, 1716, 200.28, 186, 3);
INSERT INTO public.europe_data VALUES (360, 0, 1, 6.99, 210, 3);
INSERT INTO public.europe_data VALUES (361, 27, 2431, 105.27, 187, 3);
INSERT INTO public.europe_data VALUES (362, 9, 1254, 45.51, 129, 3);
INSERT INTO public.europe_data VALUES (363, 321, 12830, 13.74, 130, 3);
INSERT INTO public.europe_data VALUES (364, 90, 3731, 180.61, 131, 3);
INSERT INTO public.europe_data VALUES (365, 311, 14139, 776.23, 90, 3);
INSERT INTO public.europe_data VALUES (366, 0, 15, 0.43, 211, 3);
INSERT INTO public.europe_data VALUES (367, 127, 6206, 179.33, 91, 3);
INSERT INTO public.europe_data VALUES (368, 846, 30211, 189.67, 92, 3);
INSERT INTO public.europe_data VALUES (369, 347, 13042, 23.98, 132, 3);
INSERT INTO public.europe_data VALUES (370, 1994, 39205, 231.04, 188, 3);
INSERT INTO public.europe_data VALUES (371, 1693, 86610, 1496.8, 189, 3);
INSERT INTO public.europe_data VALUES (372, 75, 7630, 532.08, 93, 3);
INSERT INTO public.europe_data VALUES (373, 0, 1515, 104.2, 133, 3);
INSERT INTO public.europe_data VALUES (374, 570, 17408, 202.37, 190, 3);
INSERT INTO public.europe_data VALUES (375, 3881, 147624, 214.86, 191, 3);
INSERT INTO public.europe_data VALUES (376, 32, 1943, 26.49, 40, 3);
INSERT INTO public.europe_data VALUES (377, 0, 0, 1.89, 94, 3);
INSERT INTO public.europe_data VALUES (378, 5, 310, 264.23, 95, 3);
INSERT INTO public.europe_data VALUES (379, 1, 252, 449.4, 96, 3);
INSERT INTO public.europe_data VALUES (380, 0, 87, 600.82, 192, 3);
INSERT INTO public.europe_data VALUES (381, 0, 47, 57.2, 41, 3);
INSERT INTO public.europe_data VALUES (382, 29, 1442, 7.48, 134, 3);
INSERT INTO public.europe_data VALUES (383, 56, 1769, 21.23, 42, 3);
INSERT INTO public.europe_data VALUES (384, 136, 11070, 343.41, 193, 3);
INSERT INTO public.europe_data VALUES (385, 1, 364, 550.43, 43, 3);
INSERT INTO public.europe_data VALUES (386, 0, 167, 4.19, 44, 3);
INSERT INTO public.europe_data VALUES (387, 0, 195, 6.91, 135, 3);
INSERT INTO public.europe_data VALUES (388, 0, 102, 431.72, 97, 3);
INSERT INTO public.europe_data VALUES (389, 542, 12642, 512.95, 194, 3);
INSERT INTO public.europe_data VALUES (390, 210, 8705, 885.48, 195, 3);
INSERT INTO public.europe_data VALUES (391, 0, 0, 0, 212, 3);
INSERT INTO public.europe_data VALUES (392, 0, 10, 0.18, 45, 3);
INSERT INTO public.europe_data VALUES (393, 3769, 75060, 309.76, 46, 3);
INSERT INTO public.europe_data VALUES (394, 96, 2792, 12.51, 136, 3);
INSERT INTO public.europe_data VALUES (395, 1, 118, 1.14, 47, 3);
INSERT INTO public.europe_data VALUES (396, 2439, 256931, 1026.05, 196, 3);
INSERT INTO public.europe_data VALUES (397, 19, 5368, 47.13, 137, 3);
INSERT INTO public.europe_data VALUES (398, 254, 5206, 12.16, 48, 3);
INSERT INTO public.europe_data VALUES (399, 4, 488, 180.27, 98, 3);
INSERT INTO public.europe_data VALUES (400, 400, 23255, 510.37, 197, 3);
INSERT INTO public.europe_data VALUES (401, 337, 13605, 339.2, 198, 3);
INSERT INTO public.europe_data VALUES (402, 53, 592, 7.4, 138, 3);
INSERT INTO public.europe_data VALUES (403, 0, 27, 0.23, 139, 3);
INSERT INTO public.europe_data VALUES (404, 0, 0, 0, 140, 3);
INSERT INTO public.europe_data VALUES (405, 5, 1264, 4.51, 141, 3);
INSERT INTO public.europe_data VALUES (406, 0, 15, 1.39, 142, 3);
INSERT INTO public.europe_data VALUES (407, 3, 360, 8.72, 49, 3);
INSERT INTO public.europe_data VALUES (408, 2, 97, 16.13, 99, 3);
INSERT INTO public.europe_data VALUES (409, 537, 16751, 310.28, 50, 3);
INSERT INTO public.europe_data VALUES (410, 1076, 42504, 126.03, 199, 3);
INSERT INTO public.europe_data VALUES (411, 0, 182, 767.14, 100, 3);
INSERT INTO public.europe_data VALUES (412, 14, 1103, 3.12, 51, 3);
INSERT INTO public.europe_data VALUES (413, 1055, 30612, 170.51, 200, 3);
INSERT INTO public.europe_data VALUES (414, 47, 24694, 460.29, 143, 3);
INSERT INTO public.europe_data VALUES (415, 8678, 251504, 862.92, 201, 3);
INSERT INTO public.europe_data VALUES (416, 0, 0, 0, 52, 3);
INSERT INTO public.europe_data VALUES (417, 23518, 1358783, 873.4, 101, 3);
INSERT INTO public.europe_data VALUES (418, 0, 90, 175.94, 102, 3);
INSERT INTO public.europe_data VALUES (419, 71, 5178, 321.8, 103, 3);
INSERT INTO public.europe_data VALUES (420, 2, 393, 2.48, 144, 3);
INSERT INTO public.europe_data VALUES (421, 0, 0, 0, 213, 3);
INSERT INTO public.europe_data VALUES (422, 36, 3265, 23.59, 104, 3);
INSERT INTO public.europe_data VALUES (423, 0, 9, 0.04, 145, 3);
INSERT INTO public.europe_data VALUES (424, 0, 0, 0, 214, 3);
INSERT INTO public.europe_data VALUES (425, 0, 0, 0, 53, 3);
INSERT INTO public.europe_data VALUES (426, 3, 6, 0.05, 146, 3);
INSERT INTO public.europe_data VALUES (427, 101, 7939, 98.26, 54, 3);
INSERT INTO public.europe_data VALUES (428, 292, 4117, 67.21, 55, 3);
INSERT INTO public.europe_data VALUES (429, 45, 557, 3.24, 105, 4);
INSERT INTO public.europe_data VALUES (430, 36, 4095, 288.29, 147, 4);
INSERT INTO public.europe_data VALUES (431, 29, 1689, 7.96, 1, 4);
INSERT INTO public.europe_data VALUES (432, 5, 401, 1169.64, 148, 4);
INSERT INTO public.europe_data VALUES (433, 20, 682, 3.87, 2, 4);
INSERT INTO public.europe_data VALUES (434, 0, 0, 0, 56, 4);
INSERT INTO public.europe_data VALUES (435, 0, 13, 29.86, 57, 4);
INSERT INTO public.europe_data VALUES (436, 1178, 76488, 372.24, 58, 4);
INSERT INTO public.europe_data VALUES (437, 67, 2388, 150.66, 149, 4);
INSERT INTO public.europe_data VALUES (438, 0, 367, 819.3, 59, 4);
INSERT INTO public.europe_data VALUES (439, 0, 94, 0.81, 202, 4);
INSERT INTO public.europe_data VALUES (440, 383, 11406, 299.58, 150, 4);
INSERT INTO public.europe_data VALUES (441, 96, 2564, 70.92, 151, 4);
INSERT INTO public.europe_data VALUES (442, 0, 63, 36.72, 60, 4);
INSERT INTO public.europe_data VALUES (443, 4, 2049, 251.59, 106, 4);
INSERT INTO public.europe_data VALUES (444, 125, 5179, 7.12, 107, 4);
INSERT INTO public.europe_data VALUES (445, 0, 211, 170.37, 61, 4);
INSERT INTO public.europe_data VALUES (446, 65, 13367, 289.85, 152, 4);
INSERT INTO public.europe_data VALUES (447, 344, 13845, 249.23, 153, 4);
INSERT INTO public.europe_data VALUES (448, 7, 205, 155.5, 62, 4);
INSERT INTO public.europe_data VALUES (449, 2, 109, 1.37, 3, 4);
INSERT INTO public.europe_data VALUES (450, 0, 27, 97.59, 63, 4);
INSERT INTO public.europe_data VALUES (451, 0, 29, 16.51, 108, 4);
INSERT INTO public.europe_data VALUES (452, 260, 13287, 212.99, 64, 4);
INSERT INTO public.europe_data VALUES (453, 0, 31, 477.24, 65, 4);
INSERT INTO public.europe_data VALUES (454, 128, 2325, 164.74, 154, 4);
INSERT INTO public.europe_data VALUES (455, 23, 1315, 112.86, 4, 4);
INSERT INTO public.europe_data VALUES (456, 6719, 380158, 368.65, 66, 4);
INSERT INTO public.europe_data VALUES (457, 0, 24, 79.91, 67, 4);
INSERT INTO public.europe_data VALUES (458, 0, 1, 0.46, 109, 4);
INSERT INTO public.europe_data VALUES (459, 357, 3302, 125.17, 155, 4);
INSERT INTO public.europe_data VALUES (460, 13, 913, 10.52, 5, 4);
INSERT INTO public.europe_data VALUES (461, 0, 217, 3.5, 6, 4);
INSERT INTO public.europe_data VALUES (462, 0, 50, 0.36, 110, 4);
INSERT INTO public.europe_data VALUES (463, 7, 1162, 4.49, 7, 4);
INSERT INTO public.europe_data VALUES (464, 1034, 46891, 303.14, 68, 4);
INSERT INTO public.europe_data VALUES (465, 4, 560, 195.11, 8, 4);
INSERT INTO public.europe_data VALUES (466, 0, 18, 50.81, 69, 4);
INSERT INTO public.europe_data VALUES (467, 0, 1, 0.23, 9, 4);
INSERT INTO public.europe_data VALUES (468, 4, 358, 4.28, 10, 4);
INSERT INTO public.europe_data VALUES (469, 385, 27858, 293.16, 70, 4);
INSERT INTO public.europe_data VALUES (470, 10, 1115, 0.12, 111, 4);
INSERT INTO public.europe_data VALUES (471, 2553, 121229, 491.29, 71, 4);
INSERT INTO public.europe_data VALUES (472, 27, 432, 85.56, 11, 4);
INSERT INTO public.europe_data VALUES (473, 6, 492, 11.19, 12, 4);
INSERT INTO public.europe_data VALUES (474, 105, 5955, 269.04, 72, 4);
INSERT INTO public.europe_data VALUES (475, 2, 1491, 10.08, 13, 4);
INSERT INTO public.europe_data VALUES (476, 252, 4905, 298.56, 156, 4);
INSERT INTO public.europe_data VALUES (477, 20, 3436, 50.32, 73, 4);
INSERT INTO public.europe_data VALUES (478, 0, 56, 124.22, 74, 4);
INSERT INTO public.europe_data VALUES (479, 22, 1618, 570.16, 157, 4);
INSERT INTO public.europe_data VALUES (480, 1177, 56398, 1362.82, 158, 4);
INSERT INTO public.europe_data VALUES (481, 15, 1564, 3.35, 14, 4);
INSERT INTO public.europe_data VALUES (482, 208, 7170, 364.86, 159, 4);
INSERT INTO public.europe_data VALUES (483, 0, 34, 6.47, 15, 4);
INSERT INTO public.europe_data VALUES (484, 0, 4, 23.67, 75, 4);
INSERT INTO public.europe_data VALUES (485, 21, 11684, 201.46, 76, 4);
INSERT INTO public.europe_data VALUES (486, 138, 10138, 98.02, 77, 4);
INSERT INTO public.europe_data VALUES (487, 386, 6605, 14.16, 16, 4);
INSERT INTO public.europe_data VALUES (488, 70, 2532, 67.4, 78, 4);
INSERT INTO public.europe_data VALUES (489, 0, 69, 6.34, 17, 4);
INSERT INTO public.europe_data VALUES (490, 0, 321, 14.7, 18, 4);
INSERT INTO public.europe_data VALUES (491, 46, 3539, 590.5, 160, 4);
INSERT INTO public.europe_data VALUES (492, 78, 1233, 261.38, 19, 4);
INSERT INTO public.europe_data VALUES (493, 27, 2579, 4.97, 20, 4);
INSERT INTO public.europe_data VALUES (494, 0, 3, 88.97, 79, 4);
INSERT INTO public.europe_data VALUES (495, 0, 3, 59.58, 161, 4);
INSERT INTO public.europe_data VALUES (496, 0, 2, 0.67, 203, 4);
INSERT INTO public.europe_data VALUES (497, 24, 1747, 61.94, 162, 4);
INSERT INTO public.europe_data VALUES (498, 2533, 127733, 380.91, 163, 4);
INSERT INTO public.europe_data VALUES (499, 4, 394, 253.86, 204, 4);
INSERT INTO public.europe_data VALUES (500, 0, 159, 13.53, 21, 4);
INSERT INTO public.europe_data VALUES (501, 2, 34, 4.43, 22, 4);
INSERT INTO public.europe_data VALUES (502, 162, 8135, 454.17, 164, 4);
INSERT INTO public.europe_data VALUES (503, 5947, 119635, 319.38, 165, 4);
INSERT INTO public.europe_data VALUES (504, 8, 1484, 8.37, 23, 4);
INSERT INTO public.europe_data VALUES (505, 27, 500, 3750.07, 166, 4);
INSERT INTO public.europe_data VALUES (506, 206, 3869, 79.33, 167, 4);
INSERT INTO public.europe_data VALUES (507, 0, 3, 5.29, 80, 4);
INSERT INTO public.europe_data VALUES (508, 0, 4, 4.46, 81, 4);
INSERT INTO public.europe_data VALUES (509, 4, 62, 94.44, 205, 4);
INSERT INTO public.europe_data VALUES (510, 228, 5973, 59.67, 82, 4);
INSERT INTO public.europe_data VALUES (511, 0, 4, 13.96, 168, 4);
INSERT INTO public.europe_data VALUES (512, 0, 183, 2.92, 24, 4);
INSERT INTO public.europe_data VALUES (513, 0, 31, 3.23, 25, 4);
INSERT INTO public.europe_data VALUES (514, 1, 154, 70.26, 83, 4);
INSERT INTO public.europe_data VALUES (515, 2, 635, 6.93, 84, 4);
INSERT INTO public.europe_data VALUES (516, 0, 0, 0, 169, 4);
INSERT INTO public.europe_data VALUES (517, 81, 6166, 110.22, 85, 4);
INSERT INTO public.europe_data VALUES (518, 684, 9047, 244.07, 170, 4);
INSERT INTO public.europe_data VALUES (519, 0, 72, 60.51, 171, 4);
INSERT INTO public.europe_data VALUES (520, 1259, 105178, 16.93, 112, 4);
INSERT INTO public.europe_data VALUES (521, 1858, 79903, 55.23, 113, 4);
INSERT INTO public.europe_data VALUES (522, 632, 44005, 104.9, 114, 4);
INSERT INTO public.europe_data VALUES (523, 100, 9863, 25.09, 115, 4);
INSERT INTO public.europe_data VALUES (524, 264, 25113, 1444.44, 172, 4);
INSERT INTO public.europe_data VALUES (525, 0, 32, 56.74, 173, 4);
INSERT INTO public.europe_data VALUES (526, 316, 56626, 1285.33, 116, 4);
INSERT INTO public.europe_data VALUES (527, 3422, 104786, 374.14, 174, 4);
INSERT INTO public.europe_data VALUES (528, 13, 637, 41.55, 86, 4);
INSERT INTO public.europe_data VALUES (529, 457, 41542, 66.57, 117, 4);
INSERT INTO public.europe_data VALUES (530, 5, 82, 216.15, 175, 4);
INSERT INTO public.europe_data VALUES (531, 110, 6874, 171.61, 118, 4);
INSERT INTO public.europe_data VALUES (532, 16, 6878, 53.34, 119, 4);
INSERT INTO public.europe_data VALUES (533, 18, 891, 4.49, 26, 4);
INSERT INTO public.europe_data VALUES (534, 33, 2075, 216.07, 176, 4);
INSERT INTO public.europe_data VALUES (535, 4, 3463, 152.93, 120, 4);
INSERT INTO public.europe_data VALUES (536, 16, 798, 27.9, 121, 4);
INSERT INTO public.europe_data VALUES (537, 0, 0, 0, 122, 4);
INSERT INTO public.europe_data VALUES (538, 129, 6096, 685.79, 177, 4);
INSERT INTO public.europe_data VALUES (539, 259, 33516, 926.73, 123, 4);
INSERT INTO public.europe_data VALUES (540, 8, 434, 148.92, 27, 4);
INSERT INTO public.europe_data VALUES (541, 1, 87, 1.76, 28, 4);
INSERT INTO public.europe_data VALUES (542, 109, 4491, 116.47, 29, 4);
INSERT INTO public.europe_data VALUES (543, 1, 49, 450.78, 178, 4);
INSERT INTO public.europe_data VALUES (544, 237, 7546, 715.95, 179, 4);
INSERT INTO public.europe_data VALUES (545, 19, 868, 314.88, 180, 4);
INSERT INTO public.europe_data VALUES (546, 6, 300, 1.98, 30, 4);
INSERT INTO public.europe_data VALUES (547, 89, 3895, 30.2, 31, 4);
INSERT INTO public.europe_data VALUES (548, 50, 22442, 117.73, 124, 4);
INSERT INTO public.europe_data VALUES (549, 0, 404, 121.67, 125, 4);
INSERT INTO public.europe_data VALUES (550, 13, 239, 2.98, 32, 4);
INSERT INTO public.europe_data VALUES (551, 7, 1213, 508.96, 181, 4);
INSERT INTO public.europe_data VALUES (552, 0, 0, 0, 206, 4);
INSERT INTO public.europe_data VALUES (553, 21, 527, 27.51, 33, 4);
INSERT INTO public.europe_data VALUES (554, 0, 2, 1.26, 34, 4);
INSERT INTO public.europe_data VALUES (555, 6880, 107869, 157.36, 87, 4);
INSERT INTO public.europe_data VALUES (556, 0, 0, 0, 207, 4);
INSERT INTO public.europe_data VALUES (557, 111, 3463, 172.66, 182, 4);
INSERT INTO public.europe_data VALUES (558, 5, 148, 900.71, 183, 4);
INSERT INTO public.europe_data VALUES (559, 0, 84, 7.44, 126, 4);
INSERT INTO public.europe_data VALUES (560, 20, 3062, 1012.24, 184, 4);
INSERT INTO public.europe_data VALUES (561, 0, 0, 0, 88, 4);
INSERT INTO public.europe_data VALUES (562, 199, 7139, 45.31, 35, 4);
INSERT INTO public.europe_data VALUES (563, 44, 4217, 23.85, 36, 4);
INSERT INTO public.europe_data VALUES (564, 109, 3714, 14.75, 127, 4);
INSERT INTO public.europe_data VALUES (565, 24, 1761, 199.52, 37, 4);
INSERT INTO public.europe_data VALUES (566, 42, 2542, 19.1, 128, 4);
INSERT INTO public.europe_data VALUES (567, 645, 38967, 555.45, 185, 4);
INSERT INTO public.europe_data VALUES (568, 0, 4, 1.41, 208, 4);
INSERT INTO public.europe_data VALUES (569, 0, 40, 1.69, 209, 4);
INSERT INTO public.europe_data VALUES (570, 1, 55, 1.62, 89, 4);
INSERT INTO public.europe_data VALUES (571, 14, 279, 2.96, 38, 4);
INSERT INTO public.europe_data VALUES (572, 77, 10300, 10.1, 39, 4);
INSERT INTO public.europe_data VALUES (573, 80, 2444, 236.58, 186, 4);
INSERT INTO public.europe_data VALUES (574, 0, 3, 10.49, 210, 4);
INSERT INTO public.europe_data VALUES (575, 43, 3178, 148.94, 187, 4);
INSERT INTO public.europe_data VALUES (576, 4, 1010, 44.34, 129, 4);
INSERT INTO public.europe_data VALUES (577, 321, 16918, 15.09, 130, 4);
INSERT INTO public.europe_data VALUES (578, 125, 5266, 224.27, 131, 4);
INSERT INTO public.europe_data VALUES (579, 332, 18823, 1042.83, 90, 4);
INSERT INTO public.europe_data VALUES (580, 0, 23, 0.4, 211, 4);
INSERT INTO public.europe_data VALUES (581, 100, 6427, 185.77, 91, 4);
INSERT INTO public.europe_data VALUES (582, 596, 31452, 146.86, 92, 4);
INSERT INTO public.europe_data VALUES (583, 490, 12887, 21.06, 132, 4);
INSERT INTO public.europe_data VALUES (584, 2143, 48529, 305.39, 188, 4);
INSERT INTO public.europe_data VALUES (585, 1103, 67210, 1215.19, 189, 4);
INSERT INTO public.europe_data VALUES (586, 61, 7978, 469.69, 93, 4);
INSERT INTO public.europe_data VALUES (587, 2, 1436, 100.99, 133, 4);
INSERT INTO public.europe_data VALUES (588, 546, 21882, 281.87, 190, 4);
INSERT INTO public.europe_data VALUES (589, 3764, 165797, 226.86, 191, 4);
INSERT INTO public.europe_data VALUES (590, 22, 1402, 18.66, 40, 4);
INSERT INTO public.europe_data VALUES (591, 0, 1, 3.79, 94, 4);
INSERT INTO public.europe_data VALUES (592, 3, 173, 141.14, 95, 4);
INSERT INTO public.europe_data VALUES (593, 1, 245, 334.56, 96, 4);
INSERT INTO public.europe_data VALUES (594, 1, 120, 853.34, 192, 4);
INSERT INTO public.europe_data VALUES (595, 0, 76, 54.87, 41, 4);
INSERT INTO public.europe_data VALUES (596, 32, 1120, 5.18, 134, 4);
INSERT INTO public.europe_data VALUES (597, 57, 1691, 20.99, 42, 4);
INSERT INTO public.europe_data VALUES (598, 168, 12844, 411.6, 193, 4);
INSERT INTO public.europe_data VALUES (599, 0, 174, 417.43, 43, 4);
INSERT INTO public.europe_data VALUES (600, 0, 160, 4.26, 44, 4);
INSERT INTO public.europe_data VALUES (601, 0, 206, 7.17, 135, 4);
INSERT INTO public.europe_data VALUES (602, 0, 81, 457.67, 97, 4);
INSERT INTO public.europe_data VALUES (603, 519, 15316, 665.75, 194, 4);
INSERT INTO public.europe_data VALUES (604, 224, 9721, 1132.97, 195, 4);
INSERT INTO public.europe_data VALUES (605, 0, 0, 0, 212, 4);
INSERT INTO public.europe_data VALUES (606, 0, 18, 0.19, 45, 4);
INSERT INTO public.europe_data VALUES (607, 3942, 106329, 405.03, 46, 4);
INSERT INTO public.europe_data VALUES (608, 124, 3615, 16.53, 136, 4);
INSERT INTO public.europe_data VALUES (609, 0, 8, 0.73, 47, 4);
INSERT INTO public.europe_data VALUES (610, 1494, 224669, 804.5, 196, 4);
INSERT INTO public.europe_data VALUES (611, 32, 4682, 38.87, 137, 4);
INSERT INTO public.europe_data VALUES (612, 0, 0, 0, 48, 4);
INSERT INTO public.europe_data VALUES (613, 7, 560, 211.74, 98, 4);
INSERT INTO public.europe_data VALUES (614, 569, 28957, 668.84, 197, 4);
INSERT INTO public.europe_data VALUES (615, 392, 15378, 442.53, 198, 4);
INSERT INTO public.europe_data VALUES (616, 58, 672, 7.77, 138, 4);
INSERT INTO public.europe_data VALUES (617, 0, 28, 0.2, 139, 4);
INSERT INTO public.europe_data VALUES (618, 0, 0, 0.09, 140, 4);
INSERT INTO public.europe_data VALUES (619, 3, 1876, 5.72, 141, 4);
INSERT INTO public.europe_data VALUES (620, 0, 3, 0.62, 142, 4);
INSERT INTO public.europe_data VALUES (621, 1, 345, 7.42, 49, 4);
INSERT INTO public.europe_data VALUES (622, 4, 128, 16.13, 99, 4);
INSERT INTO public.europe_data VALUES (623, 466, 19535, 327.85, 50, 4);
INSERT INTO public.europe_data VALUES (624, 1190, 60845, 177.05, 199, 4);
INSERT INTO public.europe_data VALUES (625, 1, 111, 510.55, 100, 4);
INSERT INTO public.europe_data VALUES (626, 2, 277, 4.6, 51, 4);
INSERT INTO public.europe_data VALUES (627, 1034, 44402, 203.72, 200, 4);
INSERT INTO public.europe_data VALUES (628, 34, 20279, 394.34, 143, 4);
INSERT INTO public.europe_data VALUES (629, 7830, 323610, 1112.1, 201, 4);
INSERT INTO public.europe_data VALUES (630, 0, 0, 0, 52, 4);
INSERT INTO public.europe_data VALUES (631, 23169, 1515282, 1002.26, 101, 4);
INSERT INTO public.europe_data VALUES (632, 0, 94, 196.02, 102, 4);
INSERT INTO public.europe_data VALUES (633, 57, 5962, 347.8, 103, 4);
INSERT INTO public.europe_data VALUES (634, 2, 425, 2.36, 144, 4);
INSERT INTO public.europe_data VALUES (635, 0, 0, 0, 213, 4);
INSERT INTO public.europe_data VALUES (636, 39, 3461, 21.17, 104, 4);
INSERT INTO public.europe_data VALUES (637, 0, 25, 0.04, 145, 4);
INSERT INTO public.europe_data VALUES (638, 0, 0, 0, 214, 4);
INSERT INTO public.europe_data VALUES (639, 0, 0, 0, 53, 4);
INSERT INTO public.europe_data VALUES (640, 1, 8, 0.04, 146, 4);
INSERT INTO public.europe_data VALUES (641, 88, 9611, 90.78, 54, 4);
INSERT INTO public.europe_data VALUES (642, 206, 5726, 81.51, 55, 4);
INSERT INTO public.europe_data VALUES (643, 71, 675, 4.15, 105, 5);
INSERT INTO public.europe_data VALUES (644, 48, 4157, 245.35, 147, 5);
INSERT INTO public.europe_data VALUES (645, 35, 1736, 8.16, 1, 5);
INSERT INTO public.europe_data VALUES (646, 2, 490, 1437.44, 148, 5);
INSERT INTO public.europe_data VALUES (647, 8, 551, 2.82, 2, 5);
INSERT INTO public.europe_data VALUES (648, 0, 0, 13.45, 56, 5);
INSERT INTO public.europe_data VALUES (649, 0, 16, 18.53, 57, 5);
INSERT INTO public.europe_data VALUES (650, 1172, 90203, 313.58, 58, 5);
INSERT INTO public.europe_data VALUES (651, 67, 2068, 146.73, 149, 5);
INSERT INTO public.europe_data VALUES (652, 3, 504, 700.78, 59, 5);
INSERT INTO public.europe_data VALUES (653, 0, 110, 1.2, 202, 5);
INSERT INTO public.europe_data VALUES (654, 378, 15133, 319.69, 150, 5);
INSERT INTO public.europe_data VALUES (655, 193, 4562, 93, 151, 5);
INSERT INTO public.europe_data VALUES (656, 0, 80, 43.65, 60, 5);
INSERT INTO public.europe_data VALUES (657, 4, 2080, 233.07, 106, 5);
INSERT INTO public.europe_data VALUES (658, 155, 6434, 8.16, 107, 5);
INSERT INTO public.europe_data VALUES (659, 0, 278, 181.87, 61, 5);
INSERT INTO public.europe_data VALUES (660, 75, 14031, 268.77, 152, 5);
INSERT INTO public.europe_data VALUES (661, 384, 14706, 227.74, 153, 5);
INSERT INTO public.europe_data VALUES (662, 24, 402, 190.09, 62, 5);
INSERT INTO public.europe_data VALUES (663, 0, 53, 0.84, 3, 5);
INSERT INTO public.europe_data VALUES (664, 2, 34, 119.98, 63, 5);
INSERT INTO public.europe_data VALUES (665, 1, 97, 24.9, 108, 5);
INSERT INTO public.europe_data VALUES (666, 175, 11235, 165.49, 64, 5);
INSERT INTO public.europe_data VALUES (667, 0, 93, 581.15, 65, 5);
INSERT INTO public.europe_data VALUES (668, 227, 3113, 183.79, 154, 5);
INSERT INTO public.europe_data VALUES (669, 3, 1285, 87.9, 4, 5);
INSERT INTO public.europe_data VALUES (670, 7562, 397866, 306.72, 66, 5);
INSERT INTO public.europe_data VALUES (671, 0, 0, 13.32, 67, 5);
INSERT INTO public.europe_data VALUES (672, 0, 1, 4.85, 109, 5);
INSERT INTO public.europe_data VALUES (673, 448, 5460, 154.21, 155, 5);
INSERT INTO public.europe_data VALUES (674, 3, 1224, 9.5, 5, 5);
INSERT INTO public.europe_data VALUES (675, 0, 186, 1.82, 6, 5);
INSERT INTO public.europe_data VALUES (676, 0, 9, 0.16, 110, 5);
INSERT INTO public.europe_data VALUES (677, 0, 0, 2.21, 7, 5);
INSERT INTO public.europe_data VALUES (678, 1221, 66518, 310.5, 68, 5);
INSERT INTO public.europe_data VALUES (679, 2, 513, 129.11, 8, 5);
INSERT INTO public.europe_data VALUES (680, 0, 15, 67.75, 69, 5);
INSERT INTO public.europe_data VALUES (681, 0, 10, 0.25, 9, 5);
INSERT INTO public.europe_data VALUES (682, 3, 324, 3.27, 10, 5);
INSERT INTO public.europe_data VALUES (683, 395, 27701, 231.45, 70, 5);
INSERT INTO public.europe_data VALUES (684, 2, 611, 0.11, 111, 5);
INSERT INTO public.europe_data VALUES (685, 2486, 126083, 393.52, 71, 5);
INSERT INTO public.europe_data VALUES (686, 5, 296, 50.42, 11, 5);
INSERT INTO public.europe_data VALUES (687, 0, 110, 12.01, 12, 5);
INSERT INTO public.europe_data VALUES (688, 124, 7625, 283.29, 72, 5);
INSERT INTO public.europe_data VALUES (689, 1, 1102, 6.12, 13, 5);
INSERT INTO public.europe_data VALUES (690, 331, 7265, 367.42, 156, 5);
INSERT INTO public.europe_data VALUES (691, 6, 2267, 31.53, 73, 5);
INSERT INTO public.europe_data VALUES (692, 3, 147, 191.53, 74, 5);
INSERT INTO public.europe_data VALUES (693, 17, 3376, 878.3, 157, 5);
INSERT INTO public.europe_data VALUES (694, 1202, 88740, 1512.84, 158, 5);
INSERT INTO public.europe_data VALUES (695, 20, 1343, 2.97, 14, 5);
INSERT INTO public.europe_data VALUES (696, 223, 14014, 505.95, 159, 5);
INSERT INTO public.europe_data VALUES (697, 0, 29, 5.96, 15, 5);
INSERT INTO public.europe_data VALUES (698, 0, 13, 23.67, 75, 5);
INSERT INTO public.europe_data VALUES (699, 9, 9951, 147.84, 76, 5);
INSERT INTO public.europe_data VALUES (700, 125, 6892, 67.62, 77, 5);
INSERT INTO public.europe_data VALUES (701, 392, 7605, 17.18, 16, 5);
INSERT INTO public.europe_data VALUES (702, 64, 1818, 66.41, 78, 5);
INSERT INTO public.europe_data VALUES (703, 0, 17, 3.54, 17, 5);
INSERT INTO public.europe_data VALUES (704, 3, 193, 14.78, 18, 5);
INSERT INTO public.europe_data VALUES (705, 36, 4284, 603.63, 160, 5);
INSERT INTO public.europe_data VALUES (706, 67, 1768, 263.38, 19, 5);
INSERT INTO public.europe_data VALUES (707, 55, 2994, 4.88, 20, 5);
INSERT INTO public.europe_data VALUES (708, 0, 0, 29.66, 79, 5);
INSERT INTO public.europe_data VALUES (709, 1, 26, 131.48, 161, 5);
INSERT INTO public.europe_data VALUES (710, 0, 4, 0.79, 203, 5);
INSERT INTO public.europe_data VALUES (711, 32, 1671, 62.58, 162, 5);
INSERT INTO public.europe_data VALUES (712, 2713, 127528, 329.21, 163, 5);
INSERT INTO public.europe_data VALUES (713, 8, 315, 247.42, 204, 5);
INSERT INTO public.europe_data VALUES (714, 0, 135, 10.59, 21, 5);
INSERT INTO public.europe_data VALUES (715, 0, 70, 3.37, 22, 5);
INSERT INTO public.europe_data VALUES (716, 168, 10017, 441.28, 164, 5);
INSERT INTO public.europe_data VALUES (717, 6112, 145511, 324.25, 165, 5);
INSERT INTO public.europe_data VALUES (718, 3, 1062, 5.68, 23, 5);
INSERT INTO public.europe_data VALUES (719, 8, 764, 4343.44, 166, 5);
INSERT INTO public.europe_data VALUES (720, 306, 4639, 82.12, 167, 5);
INSERT INTO public.europe_data VALUES (721, 0, 0, 1.76, 80, 5);
INSERT INTO public.europe_data VALUES (722, 1, 1, 16.96, 81, 5);
INSERT INTO public.europe_data VALUES (723, 1, 96, 91.46, 205, 5);
INSERT INTO public.europe_data VALUES (724, 215, 4517, 43.98, 82, 5);
INSERT INTO public.europe_data VALUES (725, 0, 5, 12.41, 168, 5);
INSERT INTO public.europe_data VALUES (726, 0, 190, 2.36, 24, 5);
INSERT INTO public.europe_data VALUES (727, 1, 31, 1.61, 25, 5);
INSERT INTO public.europe_data VALUES (728, 5, 396, 58.89, 83, 5);
INSERT INTO public.europe_data VALUES (729, 2, 145, 2.42, 84, 5);
INSERT INTO public.europe_data VALUES (730, 0, 0, 0, 169, 5);
INSERT INTO public.europe_data VALUES (731, 93, 4576, 80.46, 85, 5);
INSERT INTO public.europe_data VALUES (732, 748, 14805, 276.15, 170, 5);
INSERT INTO public.europe_data VALUES (733, 0, 144, 48.18, 171, 5);
INSERT INTO public.europe_data VALUES (734, 1511, 126126, 18.93, 112, 5);
INSERT INTO public.europe_data VALUES (735, 1574, 69553, 42.37, 113, 5);
INSERT INTO public.europe_data VALUES (736, 631, 42972, 103.65, 114, 5);
INSERT INTO public.europe_data VALUES (737, 0, 0, 17.23, 115, 5);
INSERT INTO public.europe_data VALUES (738, 85, 45726, 1253.69, 172, 5);
INSERT INTO public.europe_data VALUES (739, 0, 16, 26.01, 173, 5);
INSERT INTO public.europe_data VALUES (740, 256, 52876, 1069.06, 116, 5);
INSERT INTO public.europe_data VALUES (741, 3423, 121045, 379.05, 174, 5);
INSERT INTO public.europe_data VALUES (742, 9, 588, 30.7, 86, 5);
INSERT INTO public.europe_data VALUES (743, 445, 42905, 52.43, 117, 5);
INSERT INTO public.europe_data VALUES (744, 13, 151, 286.65, 175, 5);
INSERT INTO public.europe_data VALUES (745, 140, 10462, 205.15, 118, 5);
INSERT INTO public.europe_data VALUES (746, 100, 3018, 61.6, 119, 5);
INSERT INTO public.europe_data VALUES (747, 28, 1469, 4.33, 26, 5);
INSERT INTO public.europe_data VALUES (748, 33, 1811, 165.42, 176, 5);
INSERT INTO public.europe_data VALUES (749, 6, 2971, 110.79, 120, 5);
INSERT INTO public.europe_data VALUES (750, 11, 992, 28.76, 121, 5);
INSERT INTO public.europe_data VALUES (751, 0, 0, 0, 122, 5);
INSERT INTO public.europe_data VALUES (752, 169, 7071, 689.49, 177, 5);
INSERT INTO public.europe_data VALUES (753, 107, 30018, 701.17, 123, 5);
INSERT INTO public.europe_data VALUES (754, 20, 2731, 140.26, 27, 5);
INSERT INTO public.europe_data VALUES (755, 0, 0, 0, 28, 5);
INSERT INTO public.europe_data VALUES (756, 63, 3403, 103.24, 29, 5);
INSERT INTO public.europe_data VALUES (757, 14, 124, 661.84, 178, 5);
INSERT INTO public.europe_data VALUES (758, 282, 12459, 1004.84, 179, 5);
INSERT INTO public.europe_data VALUES (759, 27, 1065, 347.78, 180, 5);
INSERT INTO public.europe_data VALUES (760, 5, 234, 1.06, 30, 5);
INSERT INTO public.europe_data VALUES (761, 30, 1731, 11.8, 31, 5);
INSERT INTO public.europe_data VALUES (762, 50, 15174, 96.7, 124, 5);
INSERT INTO public.europe_data VALUES (763, 1, 242, 87.58, 125, 5);
INSERT INTO public.europe_data VALUES (764, 20, 347, 4.56, 32, 5);
INSERT INTO public.europe_data VALUES (765, 11, 1299, 426.09, 181, 5);
INSERT INTO public.europe_data VALUES (766, 0, 0, 0, 206, 5);
INSERT INTO public.europe_data VALUES (767, 26, 718, 38.31, 33, 5);
INSERT INTO public.europe_data VALUES (768, 0, 14, 1.42, 34, 5);
INSERT INTO public.europe_data VALUES (769, 7155, 92878, 119.3, 87, 5);
INSERT INTO public.europe_data VALUES (770, 0, 0, 0, 207, 5);
INSERT INTO public.europe_data VALUES (771, 102, 3518, 198.75, 182, 5);
INSERT INTO public.europe_data VALUES (772, 0, 150, 767.72, 183, 5);
INSERT INTO public.europe_data VALUES (773, 0, 156, 9.46, 126, 5);
INSERT INTO public.europe_data VALUES (774, 36, 3236, 922.08, 184, 5);
INSERT INTO public.europe_data VALUES (775, 0, 0, 0, 88, 5);
INSERT INTO public.europe_data VALUES (776, 258, 9386, 56.08, 35, 5);
INSERT INTO public.europe_data VALUES (777, 28, 3025, 13.25, 36, 5);
INSERT INTO public.europe_data VALUES (778, 118, 4259, 16.13, 127, 5);
INSERT INTO public.europe_data VALUES (779, 43, 3216, 253.15, 37, 5);
INSERT INTO public.europe_data VALUES (780, 39, 2921, 23.07, 128, 5);
INSERT INTO public.europe_data VALUES (781, 799, 57026, 623.33, 185, 5);
INSERT INTO public.europe_data VALUES (782, 0, 0, 0.71, 208, 5);
INSERT INTO public.europe_data VALUES (783, 0, 41, 1.63, 209, 5);
INSERT INTO public.europe_data VALUES (784, 1, 51, 1.62, 89, 5);
INSERT INTO public.europe_data VALUES (785, 16, 412, 3.08, 38, 5);
INSERT INTO public.europe_data VALUES (786, 47, 10007, 7.6, 39, 5);
INSERT INTO public.europe_data VALUES (787, 92, 2470, 225.79, 186, 5);
INSERT INTO public.europe_data VALUES (788, 0, 3, 5.24, 210, 5);
INSERT INTO public.europe_data VALUES (789, 29, 4758, 157.95, 187, 5);
INSERT INTO public.europe_data VALUES (790, 6, 1196, 46.39, 129, 5);
INSERT INTO public.europe_data VALUES (791, 326, 15764, 14.31, 130, 5);
INSERT INTO public.europe_data VALUES (792, 124, 5906, 312.88, 131, 5);
INSERT INTO public.europe_data VALUES (793, 315, 25460, 1071.27, 90, 5);
INSERT INTO public.europe_data VALUES (794, 0, 12, 0.35, 211, 5);
INSERT INTO public.europe_data VALUES (795, 113, 6660, 147.05, 91, 5);
INSERT INTO public.europe_data VALUES (796, 462, 16292, 87.49, 92, 5);
INSERT INTO public.europe_data VALUES (797, 148, 9883, 16.47, 132, 5);
INSERT INTO public.europe_data VALUES (798, 2103, 67438, 340.7, 188, 5);
INSERT INTO public.europe_data VALUES (799, 729, 57670, 901.34, 189, 5);
INSERT INTO public.europe_data VALUES (800, 80, 5800, 464.85, 93, 5);
INSERT INTO public.europe_data VALUES (801, 1, 1424, 106.14, 133, 5);
INSERT INTO public.europe_data VALUES (802, 746, 32842, 282.48, 190, 5);
INSERT INTO public.europe_data VALUES (803, 3285, 165131, 238.04, 191, 5);
INSERT INTO public.europe_data VALUES (804, 19, 954, 12.74, 40, 5);
INSERT INTO public.europe_data VALUES (805, 0, 1, 3.79, 94, 5);
INSERT INTO public.europe_data VALUES (806, 0, 85, 72.76, 95, 5);
INSERT INTO public.europe_data VALUES (807, 0, 125, 126.59, 96, 5);
INSERT INTO public.europe_data VALUES (808, 2, 174, 1137.78, 192, 5);
INSERT INTO public.europe_data VALUES (809, 0, 42, 24.18, 41, 5);
INSERT INTO public.europe_data VALUES (810, 35, 654, 4.64, 134, 5);
INSERT INTO public.europe_data VALUES (811, 45, 1730, 17.21, 42, 5);
INSERT INTO public.europe_data VALUES (812, 257, 15819, 446.17, 193, 5);
INSERT INTO public.europe_data VALUES (813, 2, 234, 321.26, 43, 5);
INSERT INTO public.europe_data VALUES (814, 1, 173, 3.66, 44, 5);
INSERT INTO public.europe_data VALUES (815, 0, 210, 6.6, 135, 5);
INSERT INTO public.europe_data VALUES (816, 0, 113, 386.89, 97, 5);
INSERT INTO public.europe_data VALUES (817, 486, 20970, 751.81, 194, 5);
INSERT INTO public.europe_data VALUES (818, 256, 13855, 1171.89, 195, 5);
INSERT INTO public.europe_data VALUES (819, 0, 0, 0, 212, 5);
INSERT INTO public.europe_data VALUES (820, 0, 12, 0.23, 45, 5);
INSERT INTO public.europe_data VALUES (821, 3586, 130849, 375.23, 46, 5);
INSERT INTO public.europe_data VALUES (822, 159, 4850, 22.32, 136, 5);
INSERT INTO public.europe_data VALUES (823, 0, 73, 1.55, 47, 5);
INSERT INTO public.europe_data VALUES (824, 1197, 152938, 495.07, 196, 5);
INSERT INTO public.europe_data VALUES (825, 19, 3606, 34.36, 137, 5);
INSERT INTO public.europe_data VALUES (826, 0, 0, 0, 48, 5);
INSERT INTO public.europe_data VALUES (827, 15, 671, 180.78, 98, 5);
INSERT INTO public.europe_data VALUES (828, 637, 39467, 789.85, 197, 5);
INSERT INTO public.europe_data VALUES (829, 417, 22434, 536.58, 198, 5);
INSERT INTO public.europe_data VALUES (830, 45, 654, 7.8, 138, 5);
INSERT INTO public.europe_data VALUES (831, 0, 19, 0.17, 139, 5);
INSERT INTO public.europe_data VALUES (832, 0, 8, 0.76, 140, 5);
INSERT INTO public.europe_data VALUES (833, 2, 2108, 6.12, 141, 5);
INSERT INTO public.europe_data VALUES (834, 0, 5, 0.62, 142, 5);
INSERT INTO public.europe_data VALUES (835, 4, 255, 4.71, 49, 5);
INSERT INTO public.europe_data VALUES (836, 1, 97, 10.75, 99, 5);
INSERT INTO public.europe_data VALUES (837, 484, 18806, 263.01, 50, 5);
INSERT INTO public.europe_data VALUES (838, 1319, 84344, 217.89, 199, 5);
INSERT INTO public.europe_data VALUES (839, 0, 84, 379.64, 100, 5);
INSERT INTO public.europe_data VALUES (840, 28, 1758, 8.66, 51, 5);
INSERT INTO public.europe_data VALUES (841, 981, 45221, 202.17, 200, 5);
INSERT INTO public.europe_data VALUES (842, 29, 18250, 318.78, 143, 5);
INSERT INTO public.europe_data VALUES (843, 6407, 417570, 1114.26, 201, 5);
INSERT INTO public.europe_data VALUES (844, 0, 0, 0, 52, 5);
INSERT INTO public.europe_data VALUES (845, 22852, 1782792, 994.14, 101, 5);
INSERT INTO public.europe_data VALUES (846, 0, 111, 154.91, 102, 5);
INSERT INTO public.europe_data VALUES (847, 58, 6078, 277.17, 103, 5);
INSERT INTO public.europe_data VALUES (848, 3, 353, 2.36, 144, 5);
INSERT INTO public.europe_data VALUES (849, 0, 0, 0, 213, 5);
INSERT INTO public.europe_data VALUES (850, 35, 2576, 16.37, 104, 5);
INSERT INTO public.europe_data VALUES (851, 0, 17, 0.08, 145, 5);
INSERT INTO public.europe_data VALUES (852, 0, 0, 0, 214, 5);
INSERT INTO public.europe_data VALUES (853, 0, 0, 0, 53, 5);
INSERT INTO public.europe_data VALUES (854, 1, 3, 0.03, 146, 5);
INSERT INTO public.europe_data VALUES (855, 73, 6603, 48.45, 54, 5);
INSERT INTO public.europe_data VALUES (856, 127, 6212, 56.87, 55, 5);
INSERT INTO public.europe_data VALUES (857, 60, 902, 7.61, 105, 6);
INSERT INTO public.europe_data VALUES (858, 29, 2866, 224.81, 147, 6);
INSERT INTO public.europe_data VALUES (859, 35, 1777, 12.09, 1, 6);
INSERT INTO public.europe_data VALUES (860, 2, 605, 807.33, 148, 6);
INSERT INTO public.europe_data VALUES (861, 5, 346, 3.14, 2, 6);
INSERT INTO public.europe_data VALUES (862, 0, 2, 33.62, 56, 6);
INSERT INTO public.europe_data VALUES (863, 0, 2, 7.21, 57, 6);
INSERT INTO public.europe_data VALUES (864, 614, 50220, 209, 58, 6);
INSERT INTO public.europe_data VALUES (865, 89, 2272, 208.1, 149, 6);
INSERT INTO public.europe_data VALUES (866, 0, 241, 364.97, 59, 6);
INSERT INTO public.europe_data VALUES (867, 1, 192, 1.21, 202, 6);
INSERT INTO public.europe_data VALUES (868, 381, 13188, 320.04, 150, 6);
INSERT INTO public.europe_data VALUES (869, 195, 4782, 180.91, 151, 6);
INSERT INTO public.europe_data VALUES (870, 5, 90, 40.82, 60, 6);
INSERT INTO public.europe_data VALUES (871, 1, 1745, 194.74, 106, 6);
INSERT INTO public.europe_data VALUES (872, 174, 6871, 9.39, 107, 6);
INSERT INTO public.europe_data VALUES (873, 0, 244, 98.95, 61, 6);
INSERT INTO public.europe_data VALUES (874, 57, 11374, 279.71, 152, 6);
INSERT INTO public.europe_data VALUES (875, 455, 11383, 209.22, 153, 6);
INSERT INTO public.europe_data VALUES (876, 17, 340, 193.67, 62, 6);
INSERT INTO public.europe_data VALUES (877, 0, 46, 0.71, 3, 6);
INSERT INTO public.europe_data VALUES (878, 0, 41, 151.98, 63, 6);
INSERT INTO public.europe_data VALUES (879, 0, 93, 32.63, 108, 6);
INSERT INTO public.europe_data VALUES (880, 103, 7818, 106.63, 64, 6);
INSERT INTO public.europe_data VALUES (881, 0, 58, 238.62, 65, 6);
INSERT INTO public.europe_data VALUES (882, 178, 2954, 215.72, 154, 6);
INSERT INTO public.europe_data VALUES (883, 5, 740, 76.01, 4, 6);
INSERT INTO public.europe_data VALUES (884, 4879, 249461, 222.76, 66, 6);
INSERT INTO public.europe_data VALUES (885, 0, 4, 36.63, 67, 6);
INSERT INTO public.europe_data VALUES (886, 0, 20, 4.62, 109, 6);
INSERT INTO public.europe_data VALUES (887, 514, 5335, 169.37, 155, 6);
INSERT INTO public.europe_data VALUES (888, 8, 707, 9.31, 5, 6);
INSERT INTO public.europe_data VALUES (889, 0, 24, 0.62, 6, 6);
INSERT INTO public.europe_data VALUES (890, 0, 18, 0.12, 110, 6);
INSERT INTO public.europe_data VALUES (891, 0, 571, 3.86, 7, 6);
INSERT INTO public.europe_data VALUES (892, 901, 49643, 230.81, 68, 6);
INSERT INTO public.europe_data VALUES (893, 1, 197, 62.01, 8, 6);
INSERT INTO public.europe_data VALUES (894, 0, 29, 47.73, 69, 6);
INSERT INTO public.europe_data VALUES (895, 0, 2, 0.53, 9, 6);
INSERT INTO public.europe_data VALUES (896, 0, 198, 2.03, 10, 6);
INSERT INTO public.europe_data VALUES (897, 324, 16163, 162, 70, 6);
INSERT INTO public.europe_data VALUES (898, 14, 918, 0.08, 111, 6);
INSERT INTO public.europe_data VALUES (899, 1591, 72013, 313.38, 71, 6);
INSERT INTO public.europe_data VALUES (900, 6, 133, 23.27, 11, 6);
INSERT INTO public.europe_data VALUES (901, 8, 536, 16.86, 12, 6);
INSERT INTO public.europe_data VALUES (902, 85, 6674, 248.5, 72, 6);
INSERT INTO public.europe_data VALUES (903, 1, 472, 2.84, 13, 6);
INSERT INTO public.europe_data VALUES (904, 333, 7712, 422.69, 156, 6);
INSERT INTO public.europe_data VALUES (905, 4, 1306, 22.04, 73, 6);
INSERT INTO public.europe_data VALUES (906, 2, 166, 209.88, 74, 6);
INSERT INTO public.europe_data VALUES (907, 19, 4317, 717.66, 157, 6);
INSERT INTO public.europe_data VALUES (908, 918, 72374, 1119.19, 158, 6);
INSERT INTO public.europe_data VALUES (909, 20, 1236, 2.7, 14, 6);
INSERT INTO public.europe_data VALUES (910, 170, 15362, 590.36, 159, 6);
INSERT INTO public.europe_data VALUES (911, 0, 29, 6.27, 15, 6);
INSERT INTO public.europe_data VALUES (912, 0, 4, 5.57, 75, 6);
INSERT INTO public.europe_data VALUES (913, 14, 5926, 114.34, 76, 6);
INSERT INTO public.europe_data VALUES (914, 65, 4856, 47.69, 77, 6);
INSERT INTO public.europe_data VALUES (915, 400, 9646, 16.57, 16, 6);
INSERT INTO public.europe_data VALUES (916, 51, 2468, 51.37, 78, 6);
INSERT INTO public.europe_data VALUES (917, 0, 31, 3.54, 17, 6);
INSERT INTO public.europe_data VALUES (918, 2, 324, 15.9, 18, 6);
INSERT INTO public.europe_data VALUES (919, 38, 3713, 583.25, 160, 6);
INSERT INTO public.europe_data VALUES (920, 64, 1256, 219.14, 19, 6);
INSERT INTO public.europe_data VALUES (921, 36, 2477, 5.06, 20, 6);
INSERT INTO public.europe_data VALUES (922, 0, 1, 177.94, 79, 6);
INSERT INTO public.europe_data VALUES (923, 0, 38, 152.02, 161, 6);
INSERT INTO public.europe_data VALUES (924, 0, 3, 0.34, 203, 6);
INSERT INTO public.europe_data VALUES (925, 19, 1782, 68.09, 162, 6);
INSERT INTO public.europe_data VALUES (926, 1928, 93082, 272.15, 163, 6);
INSERT INTO public.europe_data VALUES (927, 6, 376, 266.39, 204, 6);
INSERT INTO public.europe_data VALUES (928, 2, 95, 8.52, 21, 6);
INSERT INTO public.europe_data VALUES (929, 2, 9, 0.72, 22, 6);
INSERT INTO public.europe_data VALUES (930, 210, 7620, 507.94, 164, 6);
INSERT INTO public.europe_data VALUES (931, 4448, 123679, 319.04, 165, 6);
INSERT INTO public.europe_data VALUES (932, 2, 665, 4.98, 23, 6);
INSERT INTO public.europe_data VALUES (933, 2, 700, 3447.46, 166, 6);
INSERT INTO public.europe_data VALUES (934, 285, 4168, 84.17, 167, 6);
INSERT INTO public.europe_data VALUES (935, 0, 1, 14.12, 80, 6);
INSERT INTO public.europe_data VALUES (936, 0, 18, 24.11, 81, 6);
INSERT INTO public.europe_data VALUES (937, 2, 57, 69.34, 205, 6);
INSERT INTO public.europe_data VALUES (938, 62, 3215, 28.75, 82, 6);
INSERT INTO public.europe_data VALUES (939, 0, 3, 10.86, 168, 6);
INSERT INTO public.europe_data VALUES (940, 1, 111, 1.95, 24, 6);
INSERT INTO public.europe_data VALUES (941, 0, 0, 0, 25, 6);
INSERT INTO public.europe_data VALUES (942, 0, 65, 23.89, 83, 6);
INSERT INTO public.europe_data VALUES (943, 0, 128, 3.16, 84, 6);
INSERT INTO public.europe_data VALUES (944, 0, 0, 0, 169, 6);
INSERT INTO public.europe_data VALUES (945, 92, 3266, 65.12, 85, 6);
INSERT INTO public.europe_data VALUES (946, 816, 12182, 242.73, 170, 6);
INSERT INTO public.europe_data VALUES (947, 1, 28, 31.37, 171, 6);
INSERT INTO public.europe_data VALUES (948, 1748, 132598, 20.85, 112, 6);
INSERT INTO public.europe_data VALUES (949, 1318, 45108, 34.57, 113, 6);
INSERT INTO public.europe_data VALUES (950, 847, 42969, 110.19, 114, 6);
INSERT INTO public.europe_data VALUES (951, 64, 6772, 36.18, 115, 6);
INSERT INTO public.europe_data VALUES (952, 55, 15758, 455.63, 172, 6);
INSERT INTO public.europe_data VALUES (953, 0, 6, 8.28, 173, 6);
INSERT INTO public.europe_data VALUES (954, 193, 38201, 772.69, 116, 6);
INSERT INTO public.europe_data VALUES (955, 3407, 107750, 335.09, 174, 6);
INSERT INTO public.europe_data VALUES (956, 6, 317, 25.78, 86, 6);
INSERT INTO public.europe_data VALUES (957, 347, 23611, 35.73, 117, 6);
INSERT INTO public.europe_data VALUES (958, 3, 158, 449.92, 175, 6);
INSERT INTO public.europe_data VALUES (959, 145, 10262, 205.51, 118, 6);
INSERT INTO public.europe_data VALUES (960, 86, 8409, 83.11, 119, 6);
INSERT INTO public.europe_data VALUES (961, 21, 810, 4.38, 26, 6);
INSERT INTO public.europe_data VALUES (962, 27, 1164, 155.46, 176, 6);
INSERT INTO public.europe_data VALUES (963, 6, 1690, 79.96, 120, 6);
INSERT INTO public.europe_data VALUES (964, 11, 853, 33.26, 121, 6);
INSERT INTO public.europe_data VALUES (965, 0, 0, 0, 122, 6);
INSERT INTO public.europe_data VALUES (966, 121, 6167, 601.94, 177, 6);
INSERT INTO public.europe_data VALUES (967, 105, 18052, 454.72, 123, 6);
INSERT INTO public.europe_data VALUES (968, 14, 250, 31.05, 27, 6);
INSERT INTO public.europe_data VALUES (969, 0, 0, 0.24, 28, 6);
INSERT INTO public.europe_data VALUES (970, 90, 3594, 99.96, 29, 6);
INSERT INTO public.europe_data VALUES (971, 8, 130, 1024.02, 178, 6);
INSERT INTO public.europe_data VALUES (972, 681, 15618, 1198.92, 179, 6);
INSERT INTO public.europe_data VALUES (973, 19, 1070, 464.58, 180, 6);
INSERT INTO public.europe_data VALUES (974, 1, 53, 0.5, 30, 6);
INSERT INTO public.europe_data VALUES (975, 7, 467, 3.67, 31, 6);
INSERT INTO public.europe_data VALUES (976, 49, 15722, 86.1, 124, 6);
INSERT INTO public.europe_data VALUES (977, 0, 223, 70.44, 125, 6);
INSERT INTO public.europe_data VALUES (978, 22, 550, 5.4, 32, 6);
INSERT INTO public.europe_data VALUES (979, 6, 804, 289.33, 181, 6);
INSERT INTO public.europe_data VALUES (980, 0, 0, 0, 206, 6);
INSERT INTO public.europe_data VALUES (981, 28, 1016, 52.5, 33, 6);
INSERT INTO public.europe_data VALUES (982, 0, 4, 0.39, 34, 6);
INSERT INTO public.europe_data VALUES (983, 4358, 59325, 96.29, 87, 6);
INSERT INTO public.europe_data VALUES (984, 146, 4518, 263.8, 182, 6);
INSERT INTO public.europe_data VALUES (985, 1, 104, 541.03, 183, 6);
INSERT INTO public.europe_data VALUES (986, 0, 149, 9.08, 126, 6);
INSERT INTO public.europe_data VALUES (987, 23, 2501, 842.2, 184, 6);
INSERT INTO public.europe_data VALUES (988, 0, 0, 0, 88, 6);
INSERT INTO public.europe_data VALUES (989, 245, 11067, 71.35, 35, 6);
INSERT INTO public.europe_data VALUES (990, 7, 999, 5.73, 36, 6);
INSERT INTO public.europe_data VALUES (991, 127, 4459, 18.89, 127, 6);
INSERT INTO public.europe_data VALUES (992, 25, 3099, 267.47, 37, 6);
INSERT INTO public.europe_data VALUES (993, 53, 3678, 28.27, 128, 6);
INSERT INTO public.europe_data VALUES (994, 570, 50699, 759.7, 185, 6);
INSERT INTO public.europe_data VALUES (995, 0, 2, 1.06, 208, 6);
INSERT INTO public.europe_data VALUES (996, 0, 37, 1.25, 209, 6);
INSERT INTO public.europe_data VALUES (997, 1, 55, 1.65, 89, 6);
INSERT INTO public.europe_data VALUES (998, 11, 306, 3.46, 38, 6);
INSERT INTO public.europe_data VALUES (999, 47, 5269, 5.8, 39, 6);
INSERT INTO public.europe_data VALUES (1000, 74, 2220, 275.33, 186, 6);
INSERT INTO public.europe_data VALUES (1001, 0, 0, 10.49, 210, 6);
INSERT INTO public.europe_data VALUES (1002, 20, 3658, 149.02, 187, 6);
INSERT INTO public.europe_data VALUES (1003, 7, 1112, 38.53, 129, 6);
INSERT INTO public.europe_data VALUES (1004, 421, 15220, 13.65, 130, 6);
INSERT INTO public.europe_data VALUES (1005, 189, 9680, 401.41, 131, 6);
INSERT INTO public.europe_data VALUES (1006, 248, 20031, 934.85, 90, 6);
INSERT INTO public.europe_data VALUES (1007, 0, 19, 0.43, 211, 6);
INSERT INTO public.europe_data VALUES (1008, 90, 3699, 120.11, 91, 6);
INSERT INTO public.europe_data VALUES (1009, 348, 12150, 69.46, 92, 6);
INSERT INTO public.europe_data VALUES (1010, 148, 7921, 16.67, 132, 6);
INSERT INTO public.europe_data VALUES (1011, 2014, 61937, 316.67, 188, 6);
INSERT INTO public.europe_data VALUES (1012, 519, 34957, 559.54, 189, 6);
INSERT INTO public.europe_data VALUES (1013, 106, 7836, 721.11, 93, 6);
INSERT INTO public.europe_data VALUES (1014, 1, 1582, 93.32, 133, 6);
INSERT INTO public.europe_data VALUES (1015, 645, 22000, 253.08, 190, 6);
INSERT INTO public.europe_data VALUES (1016, 3723, 182103, 341.03, 191, 6);
INSERT INTO public.europe_data VALUES (1017, 26, 655, 10.95, 40, 6);
INSERT INTO public.europe_data VALUES (1018, 0, 1, 5.68, 94, 6);
INSERT INTO public.europe_data VALUES (1019, 0, 48, 36.11, 95, 6);
INSERT INTO public.europe_data VALUES (1020, 0, 15, 18.08, 96, 6);
INSERT INTO public.europe_data VALUES (1021, 5, 218, 1120.37, 192, 6);
INSERT INTO public.europe_data VALUES (1022, 0, 10, 5.58, 41, 6);
INSERT INTO public.europe_data VALUES (1023, 71, 935, 6.26, 134, 6);
INSERT INTO public.europe_data VALUES (1024, 34, 1075, 12.55, 42, 6);
INSERT INTO public.europe_data VALUES (1025, 252, 15251, 576.17, 193, 6);
INSERT INTO public.europe_data VALUES (1026, 0, 80, 94.13, 43, 6);
INSERT INTO public.europe_data VALUES (1027, 0, 113, 2.1, 44, 6);
INSERT INTO public.europe_data VALUES (1028, 0, 173, 4.74, 135, 6);
INSERT INTO public.europe_data VALUES (1029, 0, 51, 292.53, 97, 6);
INSERT INTO public.europe_data VALUES (1030, 642, 20007, 674.5, 194, 6);
INSERT INTO public.europe_data VALUES (1031, 307, 10531, 959.15, 195, 6);
INSERT INTO public.europe_data VALUES (1032, 0, 0, 0, 212, 6);
INSERT INTO public.europe_data VALUES (1033, 3, 24, 0.34, 45, 6);
INSERT INTO public.europe_data VALUES (1034, 2506, 88877, 305.38, 46, 6);
INSERT INTO public.europe_data VALUES (1035, 162, 6584, 26.69, 136, 6);
INSERT INTO public.europe_data VALUES (1036, 1, 98, 3.26, 47, 6);
INSERT INTO public.europe_data VALUES (1037, 956, 79431, 297.41, 196, 6);
INSERT INTO public.europe_data VALUES (1038, 22, 3720, 35.23, 137, 6);
INSERT INTO public.europe_data VALUES (1039, 0, 0, 1.15, 48, 6);
INSERT INTO public.europe_data VALUES (1040, 3, 380, 139.33, 98, 6);
INSERT INTO public.europe_data VALUES (1041, 657, 41336, 767.08, 197, 6);
INSERT INTO public.europe_data VALUES (1042, 495, 23414, 555.89, 198, 6);
INSERT INTO public.europe_data VALUES (1043, 51, 677, 8.88, 138, 6);
INSERT INTO public.europe_data VALUES (1044, 0, 22, 0.21, 139, 6);
INSERT INTO public.europe_data VALUES (1045, 0, 63, 3.65, 140, 6);
INSERT INTO public.europe_data VALUES (1046, 5, 2154, 5.07, 141, 6);
INSERT INTO public.europe_data VALUES (1047, 0, 3, 1.01, 142, 6);
INSERT INTO public.europe_data VALUES (1048, 0, 126, 3.54, 49, 6);
INSERT INTO public.europe_data VALUES (1049, 2, 53, 11.18, 99, 6);
INSERT INTO public.europe_data VALUES (1050, 334, 11952, 186.63, 50, 6);
INSERT INTO public.europe_data VALUES (1051, 1610, 94334, 265, 199, 6);
INSERT INTO public.europe_data VALUES (1052, 0, 61, 293.24, 100, 6);
INSERT INTO public.europe_data VALUES (1053, 26, 2077, 10.98, 51, 6);
INSERT INTO public.europe_data VALUES (1054, 1005, 43719, 234.35, 200, 6);
INSERT INTO public.europe_data VALUES (1055, 25, 12896, 216.54, 143, 6);
INSERT INTO public.europe_data VALUES (1056, 3915, 325049, 922.22, 201, 6);
INSERT INTO public.europe_data VALUES (1057, 0, 0, 0, 52, 6);
INSERT INTO public.europe_data VALUES (1058, 18264, 1488563, 849.49, 101, 6);
INSERT INTO public.europe_data VALUES (1059, 1, 51, 128.13, 102, 6);
INSERT INTO public.europe_data VALUES (1060, 44, 3517, 212.21, 103, 6);
INSERT INTO public.europe_data VALUES (1061, 1, 426, 3.67, 144, 6);
INSERT INTO public.europe_data VALUES (1062, 0, 0, 0, 213, 6);
INSERT INTO public.europe_data VALUES (1063, 24, 2091, 15.19, 104, 6);
INSERT INTO public.europe_data VALUES (1064, 0, 56, 0.09, 145, 6);
INSERT INTO public.europe_data VALUES (1065, 0, 0, 0, 214, 6);
INSERT INTO public.europe_data VALUES (1066, 0, 0, 0, 53, 6);
INSERT INTO public.europe_data VALUES (1067, 3, 7, 0.05, 146, 6);
INSERT INTO public.europe_data VALUES (1068, 14, 2050, 18.35, 54, 6);
INSERT INTO public.europe_data VALUES (1069, 26, 2117, 19.88, 55, 6);
INSERT INTO public.europe_data VALUES (1070, 88, 1994, 7.19, 105, 7);
INSERT INTO public.europe_data VALUES (1071, 76, 3569, 280.95, 147, 7);
INSERT INTO public.europe_data VALUES (1072, 71, 3428, 15.17, 1, 7);
INSERT INTO public.europe_data VALUES (1073, 1, 10, 326.87, 148, 7);
INSERT INTO public.europe_data VALUES (1074, 16, 652, 3.48, 2, 7);
INSERT INTO public.europe_data VALUES (1075, 0, 3, 20.17, 56, 7);
INSERT INTO public.europe_data VALUES (1076, 0, 5, 10.3, 57, 7);
INSERT INTO public.europe_data VALUES (1077, 871, 43370, 206.17, 58, 7);
INSERT INTO public.europe_data VALUES (1078, 119, 3883, 313.28, 149, 7);
INSERT INTO public.europe_data VALUES (1079, 2, 147, 257.74, 59, 7);
INSERT INTO public.europe_data VALUES (1080, 0, 114, 1.11, 202, 7);
INSERT INTO public.europe_data VALUES (1081, 656, 15164, 353.89, 150, 7);
INSERT INTO public.europe_data VALUES (1082, 328, 13395, 394.21, 151, 7);
INSERT INTO public.europe_data VALUES (1083, 6, 69, 41.08, 60, 7);
INSERT INTO public.europe_data VALUES (1084, 2, 1451, 157.81, 106, 7);
INSERT INTO public.europe_data VALUES (1085, 172, 8435, 11.42, 107, 7);
INSERT INTO public.europe_data VALUES (1086, 0, 40, 22.99, 61, 7);
INSERT INTO public.europe_data VALUES (1087, 70, 15065, 299.32, 152, 7);
INSERT INTO public.europe_data VALUES (1088, 534, 12584, 264.21, 153, 7);
INSERT INTO public.europe_data VALUES (1089, 9, 416, 324.32, 62, 7);
INSERT INTO public.europe_data VALUES (1090, 0, 38, 0.97, 3, 7);
INSERT INTO public.europe_data VALUES (1091, 1, 54, 239.97, 63, 7);
INSERT INTO public.europe_data VALUES (1092, 0, 156, 24.24, 108, 7);
INSERT INTO public.europe_data VALUES (1093, 55, 4458, 66.82, 64, 7);
INSERT INTO public.europe_data VALUES (1094, 0, 4, 38.49, 65, 7);
INSERT INTO public.europe_data VALUES (1095, 328, 4167, 259.74, 154, 7);
INSERT INTO public.europe_data VALUES (1096, 2, 1011, 50.01, 4, 7);
INSERT INTO public.europe_data VALUES (1097, 3848, 220666, 275.92, 66, 7);
INSERT INTO public.europe_data VALUES (1098, 0, 7, 43.29, 67, 7);
INSERT INTO public.europe_data VALUES (1099, 0, 0, 0, 109, 7);
INSERT INTO public.europe_data VALUES (1100, 555, 6521, 260.96, 155, 7);
INSERT INTO public.europe_data VALUES (1101, 2, 1184, 11.39, 5, 7);
INSERT INTO public.europe_data VALUES (1102, 0, 48, 0.69, 6, 7);
INSERT INTO public.europe_data VALUES (1103, 0, 1, 0.03, 110, 7);
INSERT INTO public.europe_data VALUES (1104, 0, 428, 3.55, 7, 7);
INSERT INTO public.europe_data VALUES (1105, 632, 36706, 243.98, 68, 7);
INSERT INTO public.europe_data VALUES (1106, 1, 144, 66.55, 8, 7);
INSERT INTO public.europe_data VALUES (1107, 0, 2, 30.79, 69, 7);
INSERT INTO public.europe_data VALUES (1108, 0, 23, 0.53, 9, 7);
INSERT INTO public.europe_data VALUES (1109, 2, 125, 1.54, 10, 7);
INSERT INTO public.europe_data VALUES (1110, 246, 14540, 158.87, 70, 7);
INSERT INTO public.europe_data VALUES (1111, 7, 245, 0.23, 111, 7);
INSERT INTO public.europe_data VALUES (1112, 1694, 85740, 353.67, 71, 7);
INSERT INTO public.europe_data VALUES (1113, 0, 65, 12.1, 11, 7);
INSERT INTO public.europe_data VALUES (1114, 0, 371, 6.9, 12, 7);
INSERT INTO public.europe_data VALUES (1115, 107, 5869, 249.49, 72, 7);
INSERT INTO public.europe_data VALUES (1116, 4, 258, 1.93, 13, 7);
INSERT INTO public.europe_data VALUES (1117, 482, 9518, 720.27, 156, 7);
INSERT INTO public.europe_data VALUES (1118, 6, 1192, 17.74, 73, 7);
INSERT INTO public.europe_data VALUES (1119, 3, 177, 322.48, 74, 7);
INSERT INTO public.europe_data VALUES (1120, 21, 1969, 520.15, 157, 7);
INSERT INTO public.europe_data VALUES (1121, 741, 46817, 875.71, 158, 7);
INSERT INTO public.europe_data VALUES (1122, 13, 1107, 2.77, 14, 7);
INSERT INTO public.europe_data VALUES (1123, 169, 18915, 750.78, 159, 7);
INSERT INTO public.europe_data VALUES (1124, 0, 32, 8.73, 15, 7);
INSERT INTO public.europe_data VALUES (1125, 0, 0, 5.57, 75, 7);
INSERT INTO public.europe_data VALUES (1126, 19, 6353, 118.38, 76, 7);
INSERT INTO public.europe_data VALUES (1127, 45, 3429, 44.02, 77, 7);
INSERT INTO public.europe_data VALUES (1128, 307, 6986, 10.92, 16, 7);
INSERT INTO public.europe_data VALUES (1129, 56, 847, 42.44, 78, 7);
INSERT INTO public.europe_data VALUES (1130, 1, 17, 3.91, 17, 7);
INSERT INTO public.europe_data VALUES (1131, 1, 232, 9.38, 18, 7);
INSERT INTO public.europe_data VALUES (1132, 39, 4014, 585.21, 160, 7);
INSERT INTO public.europe_data VALUES (1133, 27, 1260, 167.14, 19, 7);
INSERT INTO public.europe_data VALUES (1134, 59, 3194, 5.69, 20, 7);
INSERT INTO public.europe_data VALUES (1135, 0, 5, 266.9, 79, 7);
INSERT INTO public.europe_data VALUES (1136, 0, 36, 110.94, 161, 7);
INSERT INTO public.europe_data VALUES (1137, 0, 0, 0, 203, 7);
INSERT INTO public.europe_data VALUES (1138, 57, 1975, 78.42, 162, 7);
INSERT INTO public.europe_data VALUES (1139, 2560, 89292, 277.25, 163, 7);
INSERT INTO public.europe_data VALUES (1140, 5, 368, 287.52, 204, 7);
INSERT INTO public.europe_data VALUES (1141, 0, 90, 7.32, 21, 7);
INSERT INTO public.europe_data VALUES (1142, 0, 8, 0.64, 22, 7);
INSERT INTO public.europe_data VALUES (1143, 278, 12681, 777.63, 164, 7);
INSERT INTO public.europe_data VALUES (1144, 3851, 141182, 379.14, 165, 7);
INSERT INTO public.europe_data VALUES (1145, 2, 850, 4.9, 23, 7);
INSERT INTO public.europe_data VALUES (1146, 0, 462, 1872.07, 166, 7);
INSERT INTO public.europe_data VALUES (1147, 500, 4859, 106.27, 167, 7);
INSERT INTO public.europe_data VALUES (1148, 0, 7, 12.35, 80, 7);
INSERT INTO public.europe_data VALUES (1149, 0, 9, 41.96, 81, 7);
INSERT INTO public.europe_data VALUES (1150, 1, 59, 98.03, 205, 7);
INSERT INTO public.europe_data VALUES (1151, 55, 1840, 35.03, 82, 7);
INSERT INTO public.europe_data VALUES (1152, 0, 4, 12.41, 168, 7);
INSERT INTO public.europe_data VALUES (1153, 0, 138, 1.81, 24, 7);
INSERT INTO public.europe_data VALUES (1154, 0, 0, 0, 25, 7);
INSERT INTO public.europe_data VALUES (1155, 5, 122, 47.65, 83, 7);
INSERT INTO public.europe_data VALUES (1156, 1, 228, 3.85, 84, 7);
INSERT INTO public.europe_data VALUES (1157, 0, 0, 0, 169, 7);
INSERT INTO public.europe_data VALUES (1158, 61, 3081, 58.94, 85, 7);
INSERT INTO public.europe_data VALUES (1159, 879, 11539, 335.62, 170, 7);
INSERT INTO public.europe_data VALUES (1160, 0, 84, 47.34, 171, 7);
INSERT INTO public.europe_data VALUES (1161, 2091, 152311, 23.69, 112, 7);
INSERT INTO public.europe_data VALUES (1162, 1357, 48435, 35.31, 113, 7);
INSERT INTO public.europe_data VALUES (1163, 1245, 48393, 111.19, 114, 7);
INSERT INTO public.europe_data VALUES (1164, 83, 7452, 43.15, 115, 7);
INSERT INTO public.europe_data VALUES (1165, 46, 6587, 202.76, 172, 7);
INSERT INTO public.europe_data VALUES (1166, 0, 1, 1.18, 173, 7);
INSERT INTO public.europe_data VALUES (1167, 139, 27627, 541.44, 116, 7);
INSERT INTO public.europe_data VALUES (1168, 3126, 94511, 337.95, 174, 7);
INSERT INTO public.europe_data VALUES (1169, 12, 443, 34.66, 86, 7);
INSERT INTO public.europe_data VALUES (1170, 352, 21713, 31.99, 117, 7);
INSERT INTO public.europe_data VALUES (1171, 5, 327, 820.07, 175, 7);
INSERT INTO public.europe_data VALUES (1172, 154, 10498, 280.47, 118, 7);
INSERT INTO public.europe_data VALUES (1173, 67, 7009, 66.74, 119, 7);
INSERT INTO public.europe_data VALUES (1174, 25, 1492, 7.8, 26, 7);
INSERT INTO public.europe_data VALUES (1175, 55, 1632, 234.69, 176, 7);
INSERT INTO public.europe_data VALUES (1176, 10, 1674, 81.65, 120, 7);
INSERT INTO public.europe_data VALUES (1177, 18, 1281, 44.59, 121, 7);
INSERT INTO public.europe_data VALUES (1178, 0, 0, 0, 122, 7);
INSERT INTO public.europe_data VALUES (1179, 120, 5390, 554.96, 177, 7);
INSERT INTO public.europe_data VALUES (1180, 113, 13122, 360.37, 123, 7);
INSERT INTO public.europe_data VALUES (1181, 3, 410, 31.57, 27, 7);
INSERT INTO public.europe_data VALUES (1182, 0, 12, 0.59, 28, 7);
INSERT INTO public.europe_data VALUES (1183, 67, 3181, 112.17, 29, 7);
INSERT INTO public.europe_data VALUES (1184, 3, 263, 1506.07, 178, 7);
INSERT INTO public.europe_data VALUES (1185, 230, 17882, 1336.63, 179, 7);
INSERT INTO public.europe_data VALUES (1186, 47, 1782, 745.57, 180, 7);
INSERT INTO public.europe_data VALUES (1187, 1, 81, 0.3, 30, 7);
INSERT INTO public.europe_data VALUES (1188, 1, 216, 1.67, 31, 7);
INSERT INTO public.europe_data VALUES (1189, 15, 11787, 67.67, 124, 7);
INSERT INTO public.europe_data VALUES (1190, 0, 151, 51.98, 125, 7);
INSERT INTO public.europe_data VALUES (1191, 34, 512, 4.52, 32, 7);
INSERT INTO public.europe_data VALUES (1192, 20, 624, 237.46, 181, 7);
INSERT INTO public.europe_data VALUES (1193, 0, 0, 0, 206, 7);
INSERT INTO public.europe_data VALUES (1194, 49, 1360, 62.02, 33, 7);
INSERT INTO public.europe_data VALUES (1195, 0, 1, 0.32, 34, 7);
INSERT INTO public.europe_data VALUES (1196, 4257, 63515, 109.26, 87, 7);
INSERT INTO public.europe_data VALUES (1197, 139, 6148, 366.96, 182, 7);
INSERT INTO public.europe_data VALUES (1198, 0, 75, 408.04, 183, 7);
INSERT INTO public.europe_data VALUES (1199, 0, 144, 6.98, 126, 7);
INSERT INTO public.europe_data VALUES (1200, 40, 2739, 846.7, 184, 7);
INSERT INTO public.europe_data VALUES (1201, 0, 0, 0, 88, 7);
INSERT INTO public.europe_data VALUES (1202, 283, 14954, 89.03, 35, 7);
INSERT INTO public.europe_data VALUES (1203, 14, 742, 4.47, 36, 7);
INSERT INTO public.europe_data VALUES (1204, 158, 5752, 25.06, 127, 7);
INSERT INTO public.europe_data VALUES (1205, 16, 3573, 230.54, 37, 7);
INSERT INTO public.europe_data VALUES (1206, 37, 4409, 34.11, 128, 7);
INSERT INTO public.europe_data VALUES (1207, 551, 80594, 906.99, 185, 7);
INSERT INTO public.europe_data VALUES (1208, 0, 1, 0.71, 208, 7);
INSERT INTO public.europe_data VALUES (1209, 0, 23, 1, 209, 7);
INSERT INTO public.europe_data VALUES (1210, 1, 53, 1.59, 89, 7);
INSERT INTO public.europe_data VALUES (1211, 12, 500, 3.87, 38, 7);
INSERT INTO public.europe_data VALUES (1212, 43, 6377, 5.79, 39, 7);
INSERT INTO public.europe_data VALUES (1213, 164, 3499, 393.14, 186, 7);
INSERT INTO public.europe_data VALUES (1214, 0, 6, 15.73, 210, 7);
INSERT INTO public.europe_data VALUES (1215, 25, 4282, 113.62, 187, 7);
INSERT INTO public.europe_data VALUES (1216, 7, 805, 44.86, 129, 7);
INSERT INTO public.europe_data VALUES (1217, 537, 14341, 15.02, 130, 7);
INSERT INTO public.europe_data VALUES (1218, 147, 10316, 516.04, 131, 7);
INSERT INTO public.europe_data VALUES (1219, 295, 19667, 958.4, 90, 7);
INSERT INTO public.europe_data VALUES (1220, 0, 19, 0.63, 211, 7);
INSERT INTO public.europe_data VALUES (1221, 99, 4762, 167.39, 91, 7);
INSERT INTO public.europe_data VALUES (1222, 352, 10433, 73.62, 92, 7);
INSERT INTO public.europe_data VALUES (1223, 162, 10097, 18.95, 132, 7);
INSERT INTO public.europe_data VALUES (1224, 1750, 58310, 330.06, 188, 7);
INSERT INTO public.europe_data VALUES (1225, 543, 22545, 466.32, 189, 7);
INSERT INTO public.europe_data VALUES (1226, 74, 13317, 734.51, 93, 7);
INSERT INTO public.europe_data VALUES (1227, 1, 1061, 68.54, 133, 7);
INSERT INTO public.europe_data VALUES (1228, 940, 27135, 319.83, 190, 7);
INSERT INTO public.europe_data VALUES (1229, 6114, 315367, 290.74, 191, 7);
INSERT INTO public.europe_data VALUES (1230, 12, 728, 10.79, 40, 7);
INSERT INTO public.europe_data VALUES (1231, 0, 2, 7.57, 94, 7);
INSERT INTO public.europe_data VALUES (1232, 0, 18, 16.41, 95, 7);
INSERT INTO public.europe_data VALUES (1233, 0, 5, 9.95, 96, 7);
INSERT INTO public.europe_data VALUES (1234, 2, 168, 952.02, 192, 7);
INSERT INTO public.europe_data VALUES (1235, 0, 2, 2.33, 41, 7);
INSERT INTO public.europe_data VALUES (1236, 63, 1210, 6.81, 134, 7);
INSERT INTO public.europe_data VALUES (1237, 25, 970, 10.14, 42, 7);
INSERT INTO public.europe_data VALUES (1238, 340, 24872, 893.01, 193, 7);
INSERT INTO public.europe_data VALUES (1239, 0, 12, 15.35, 43, 7);
INSERT INTO public.europe_data VALUES (1240, 1, 51, 1.47, 44, 7);
INSERT INTO public.europe_data VALUES (1241, 0, 102, 3.51, 135, 7);
INSERT INTO public.europe_data VALUES (1242, 1, 73, 382.17, 97, 7);
INSERT INTO public.europe_data VALUES (1243, 324, 16756, 644.13, 194, 7);
INSERT INTO public.europe_data VALUES (1244, 216, 9428, 913.69, 195, 7);
INSERT INTO public.europe_data VALUES (1245, 0, 0, 0, 212, 7);
INSERT INTO public.europe_data VALUES (1246, 3, 28, 0.72, 45, 7);
INSERT INTO public.europe_data VALUES (1247, 2380, 89949, 257.7, 46, 7);
INSERT INTO public.europe_data VALUES (1248, 121, 7089, 27.71, 136, 7);
INSERT INTO public.europe_data VALUES (1249, 0, 263, 2.42, 47, 7);
INSERT INTO public.europe_data VALUES (1250, 862, 60164, 271.7, 196, 7);
INSERT INTO public.europe_data VALUES (1251, 15, 3793, 38.75, 137, 7);
INSERT INTO public.europe_data VALUES (1252, 34, 493, 4.51, 48, 7);
INSERT INTO public.europe_data VALUES (1253, 2, 430, 113.53, 98, 7);
INSERT INTO public.europe_data VALUES (1254, 638, 37138, 814.44, 197, 7);
INSERT INTO public.europe_data VALUES (1255, 563, 24084, 748.05, 198, 7);
INSERT INTO public.europe_data VALUES (1256, 68, 838, 10.94, 138, 7);
INSERT INTO public.europe_data VALUES (1257, 0, 27, 0.22, 139, 7);
INSERT INTO public.europe_data VALUES (1258, 1, 277, 5.72, 140, 7);
INSERT INTO public.europe_data VALUES (1259, 0, 1378, 2.94, 141, 7);
INSERT INTO public.europe_data VALUES (1260, 0, 10, 0.77, 142, 7);
INSERT INTO public.europe_data VALUES (1261, 2, 160, 4.02, 49, 7);
INSERT INTO public.europe_data VALUES (1262, 0, 103, 16.92, 99, 7);
INSERT INTO public.europe_data VALUES (1263, 267, 9874, 172.99, 50, 7);
INSERT INTO public.europe_data VALUES (1264, 1781, 122977, 379.07, 199, 7);
INSERT INTO public.europe_data VALUES (1265, 0, 51, 209.46, 100, 7);
INSERT INTO public.europe_data VALUES (1266, 17, 2786, 14.55, 51, 7);
INSERT INTO public.europe_data VALUES (1267, 1184, 59381, 294.83, 200, 7);
INSERT INTO public.europe_data VALUES (1268, 20, 8261, 172.84, 143, 7);
INSERT INTO public.europe_data VALUES (1269, 3708, 289583, 720.7, 201, 7);
INSERT INTO public.europe_data VALUES (1270, 0, 0, 0, 52, 7);
INSERT INTO public.europe_data VALUES (1271, 15656, 1306812, 879.73, 101, 7);
INSERT INTO public.europe_data VALUES (1272, 0, 83, 168.29, 102, 7);
INSERT INTO public.europe_data VALUES (1273, 41, 3829, 219.49, 103, 7);
INSERT INTO public.europe_data VALUES (1274, 1, 784, 5.27, 144, 7);
INSERT INTO public.europe_data VALUES (1275, 0, 0, 0, 213, 7);
INSERT INTO public.europe_data VALUES (1276, 26, 2241, 18.02, 104, 7);
INSERT INTO public.europe_data VALUES (1277, 0, 28, 0.05, 145, 7);
INSERT INTO public.europe_data VALUES (1278, 0, 0, 0, 214, 7);
INSERT INTO public.europe_data VALUES (1279, 0, 0, 0, 53, 7);
INSERT INTO public.europe_data VALUES (1280, 1, 9, 0.05, 146, 7);
INSERT INTO public.europe_data VALUES (1281, 11, 1227, 9.34, 54, 7);
INSERT INTO public.europe_data VALUES (1282, 34, 795, 12.99, 55, 7);
INSERT INTO public.europe_data VALUES (1283, 111, 740, 6.56, 105, 8);
INSERT INTO public.europe_data VALUES (1284, 85, 4473, 349.88, 147, 8);
INSERT INTO public.europe_data VALUES (1285, 70, 3101, 16.15, 1, 8);
INSERT INTO public.europe_data VALUES (1286, 2, 239, 691.81, 148, 8);
INSERT INTO public.europe_data VALUES (1287, 16, 456, 3.48, 2, 8);
INSERT INTO public.europe_data VALUES (1288, 0, 0, 6.72, 56, 8);
INSERT INTO public.europe_data VALUES (1289, 0, 5, 7.21, 57, 8);
INSERT INTO public.europe_data VALUES (1290, 1231, 48955, 187.63, 58, 8);
INSERT INTO public.europe_data VALUES (1291, 153, 5383, 396.28, 149, 8);
INSERT INTO public.europe_data VALUES (1292, 1, 127, 198.48, 59, 8);
INSERT INTO public.europe_data VALUES (1293, 0, 167, 0.92, 202, 8);
INSERT INTO public.europe_data VALUES (1294, 816, 16186, 397.87, 150, 8);
INSERT INTO public.europe_data VALUES (1295, 288, 26214, 551.46, 151, 8);
INSERT INTO public.europe_data VALUES (1296, 1, 91, 47.76, 60, 8);
INSERT INTO public.europe_data VALUES (1297, 1, 1139, 143.31, 106, 8);
INSERT INTO public.europe_data VALUES (1298, 228, 10180, 14.21, 107, 8);
INSERT INTO public.europe_data VALUES (1299, 0, 26, 12.19, 61, 8);
INSERT INTO public.europe_data VALUES (1300, 61, 13228, 278.93, 152, 8);
INSERT INTO public.europe_data VALUES (1301, 654, 17683, 300.96, 153, 8);
INSERT INTO public.europe_data VALUES (1302, 29, 850, 608.68, 62, 8);
INSERT INTO public.europe_data VALUES (1303, 0, 77, 0.95, 3, 8);
INSERT INTO public.europe_data VALUES (1304, 0, 96, 382.35, 63, 8);
INSERT INTO public.europe_data VALUES (1305, 0, 29, 4.85, 108, 8);
INSERT INTO public.europe_data VALUES (1306, 25, 3235, 41.91, 64, 8);
INSERT INTO public.europe_data VALUES (1307, 0, 6, 57.73, 65, 8);
INSERT INTO public.europe_data VALUES (1308, 289, 4407, 333.75, 154, 8);
INSERT INTO public.europe_data VALUES (1309, 0, 141, 64.37, 4, 8);
INSERT INTO public.europe_data VALUES (1310, 5889, 361667, 312.76, 66, 8);
INSERT INTO public.europe_data VALUES (1311, 0, 6, 43.29, 67, 8);
INSERT INTO public.europe_data VALUES (1312, 0, 0, 0.23, 109, 8);
INSERT INTO public.europe_data VALUES (1313, 921, 11746, 425.34, 155, 8);
INSERT INTO public.europe_data VALUES (1314, 5, 1130, 9.59, 5, 8);
INSERT INTO public.europe_data VALUES (1315, 1, 32, 0.58, 6, 8);
INSERT INTO public.europe_data VALUES (1316, 0, 4, 0.09, 110, 8);
INSERT INTO public.europe_data VALUES (1317, 3, 490, 4.24, 7, 8);
INSERT INTO public.europe_data VALUES (1318, 901, 54571, 267.65, 68, 8);
INSERT INTO public.europe_data VALUES (1319, 1, 222, 93.83, 8, 8);
INSERT INTO public.europe_data VALUES (1320, 0, 18, 43.11, 69, 8);
INSERT INTO public.europe_data VALUES (1321, 0, 2, 0.34, 9, 8);
INSERT INTO public.europe_data VALUES (1322, 0, 120, 1.03, 10, 8);
INSERT INTO public.europe_data VALUES (1323, 311, 15569, 143.02, 70, 8);
INSERT INTO public.europe_data VALUES (1324, 25, 3029, 0.22, 111, 8);
INSERT INTO public.europe_data VALUES (1325, 1627, 92293, 291.95, 71, 8);
INSERT INTO public.europe_data VALUES (1326, 0, 38, 5.88, 11, 8);
INSERT INTO public.europe_data VALUES (1327, 0, 0, 7.92, 12, 8);
INSERT INTO public.europe_data VALUES (1328, 101, 6724, 321.11, 72, 8);
INSERT INTO public.europe_data VALUES (1329, 0, 238, 1.68, 13, 8);
INSERT INTO public.europe_data VALUES (1330, 617, 19842, 1113.16, 156, 8);
INSERT INTO public.europe_data VALUES (1331, 0, 819, 12.88, 73, 8);
INSERT INTO public.europe_data VALUES (1332, 0, 350, 512.78, 74, 8);
INSERT INTO public.europe_data VALUES (1333, 13, 2587, 597.9, 157, 8);
INSERT INTO public.europe_data VALUES (1334, 802, 46444, 757.67, 158, 8);
INSERT INTO public.europe_data VALUES (1335, 210, 1297, 2.55, 14, 8);
INSERT INTO public.europe_data VALUES (1336, 94, 24676, 754.92, 159, 8);
INSERT INTO public.europe_data VALUES (1337, 0, 53, 8.22, 15, 8);
INSERT INTO public.europe_data VALUES (1338, 0, 4, 9.75, 75, 8);
INSERT INTO public.europe_data VALUES (1339, 24, 6360, 117.32, 76, 8);
INSERT INTO public.europe_data VALUES (1340, 74, 4219, 47.95, 77, 8);
INSERT INTO public.europe_data VALUES (1341, 178, 3980, 7.1, 16, 8);
INSERT INTO public.europe_data VALUES (1342, 52, 1892, 53.1, 78, 8);
INSERT INTO public.europe_data VALUES (1343, 0, 36, 4.79, 17, 8);
INSERT INTO public.europe_data VALUES (1344, 0, 96, 5, 18, 8);
INSERT INTO public.europe_data VALUES (1345, 25, 3739, 514.48, 160, 8);
INSERT INTO public.europe_data VALUES (1346, 13, 659, 80.65, 19, 8);
INSERT INTO public.europe_data VALUES (1347, 47, 3182, 5.94, 20, 8);
INSERT INTO public.europe_data VALUES (1348, 0, 4, 177.94, 79, 8);
INSERT INTO public.europe_data VALUES (1349, 0, 18, 73.96, 161, 8);
INSERT INTO public.europe_data VALUES (1350, 0, 0, 0.22, 203, 8);
INSERT INTO public.europe_data VALUES (1351, 28, 2352, 100.24, 162, 8);
INSERT INTO public.europe_data VALUES (1352, 2638, 96502, 269.88, 163, 8);
INSERT INTO public.europe_data VALUES (1353, 7, 435, 384.91, 204, 8);
INSERT INTO public.europe_data VALUES (1354, 1, 69, 7.64, 21, 8);
INSERT INTO public.europe_data VALUES (1355, 0, 7, 0.81, 22, 8);
INSERT INTO public.europe_data VALUES (1356, 301, 18399, 1113.05, 164, 8);
INSERT INTO public.europe_data VALUES (1357, 4300, 173574, 393.88, 165, 8);
INSERT INTO public.europe_data VALUES (1358, 4, 639, 4.53, 23, 8);
INSERT INTO public.europe_data VALUES (1359, 1, 169, 566.66, 166, 8);
INSERT INTO public.europe_data VALUES (1360, 547, 6538, 145.47, 167, 8);
INSERT INTO public.europe_data VALUES (1361, 0, 0, 1.76, 80, 8);
INSERT INTO public.europe_data VALUES (1362, 0, 38, 58.93, 81, 8);
INSERT INTO public.europe_data VALUES (1363, 2, 105, 123.73, 205, 8);
INSERT INTO public.europe_data VALUES (1364, 295, 4319, 45.79, 82, 8);
INSERT INTO public.europe_data VALUES (1365, 0, 4, 7.76, 168, 8);
INSERT INTO public.europe_data VALUES (1366, 0, 93, 2.48, 24, 8);
INSERT INTO public.europe_data VALUES (1367, 0, 0, 0.26, 25, 8);
INSERT INTO public.europe_data VALUES (1368, 4, 251, 64.64, 83, 8);
INSERT INTO public.europe_data VALUES (1369, 1, 206, 3.56, 84, 8);
INSERT INTO public.europe_data VALUES (1370, 0, 0, 0, 169, 8);
INSERT INTO public.europe_data VALUES (1371, 52, 2663, 61.55, 85, 8);
INSERT INTO public.europe_data VALUES (1372, 1152, 21260, 521.67, 170, 8);
INSERT INTO public.europe_data VALUES (1373, 0, 85, 44.82, 171, 8);
INSERT INTO public.europe_data VALUES (1374, 2455, 171460, 27.69, 112, 8);
INSERT INTO public.europe_data VALUES (1375, 1061, 47110, 32.94, 113, 8);
INSERT INTO public.europe_data VALUES (1376, 1252, 43803, 134.51, 114, 8);
INSERT INTO public.europe_data VALUES (1377, 118, 9511, 50.74, 115, 8);
INSERT INTO public.europe_data VALUES (1378, 34, 3357, 107.99, 172, 8);
INSERT INTO public.europe_data VALUES (1379, 0, 0, 3.55, 173, 8);
INSERT INTO public.europe_data VALUES (1380, 102, 18500, 365.73, 116, 8);
INSERT INTO public.europe_data VALUES (1381, 4279, 109473, 371.62, 174, 8);
INSERT INTO public.europe_data VALUES (1382, 13, 579, 39.65, 86, 8);
INSERT INTO public.europe_data VALUES (1383, 315, 18870, 28.74, 117, 8);
INSERT INTO public.europe_data VALUES (1384, 4, 557, 908.2, 175, 8);
INSERT INTO public.europe_data VALUES (1385, 239, 17834, 369.83, 118, 8);
INSERT INTO public.europe_data VALUES (1386, 70, 5373, 62.32, 119, 8);
INSERT INTO public.europe_data VALUES (1387, 52, 2608, 11.64, 26, 8);
INSERT INTO public.europe_data VALUES (1388, 64, 2589, 353.85, 176, 8);
INSERT INTO public.europe_data VALUES (1389, 10, 1761, 85.81, 120, 8);
INSERT INTO public.europe_data VALUES (1390, 19, 1580, 60.15, 121, 8);
INSERT INTO public.europe_data VALUES (1391, 0, 0, 0, 122, 8);
INSERT INTO public.europe_data VALUES (1392, 90, 5265, 501.41, 177, 8);
INSERT INTO public.europe_data VALUES (1393, 81, 11584, 305.6, 123, 8);
INSERT INTO public.europe_data VALUES (1394, 4, 261, 18.63, 27, 8);
INSERT INTO public.europe_data VALUES (1395, 0, 17, 2.27, 28, 8);
INSERT INTO public.europe_data VALUES (1396, 70, 4421, 127.19, 29, 8);
INSERT INTO public.europe_data VALUES (1397, 6, 315, 1128.25, 178, 8);
INSERT INTO public.europe_data VALUES (1398, 214, 19466, 1376.11, 179, 8);
INSERT INTO public.europe_data VALUES (1399, 44, 2795, 1039.76, 180, 8);
INSERT INTO public.europe_data VALUES (1400, 2, 0, 0.44, 30, 8);
INSERT INTO public.europe_data VALUES (1401, 0, 95, 0.59, 31, 8);
INSERT INTO public.europe_data VALUES (1402, 22, 9834, 64.52, 124, 8);
INSERT INTO public.europe_data VALUES (1403, 0, 125, 55.56, 125, 8);
INSERT INTO public.europe_data VALUES (1404, 28, 377, 5.37, 32, 8);
INSERT INTO public.europe_data VALUES (1405, 20, 548, 231.58, 181, 8);
INSERT INTO public.europe_data VALUES (1406, 0, 0, 0, 206, 8);
INSERT INTO public.europe_data VALUES (1407, 56, 1447, 81.93, 33, 8);
INSERT INTO public.europe_data VALUES (1408, 0, 3, 1.65, 34, 8);
INSERT INTO public.europe_data VALUES (1409, 4645, 75871, 117.63, 87, 8);
INSERT INTO public.europe_data VALUES (1410, 180, 8689, 459.33, 182, 8);
INSERT INTO public.europe_data VALUES (1411, 0, 60, 272.03, 183, 8);
INSERT INTO public.europe_data VALUES (1412, 0, 81, 3.29, 126, 8);
INSERT INTO public.europe_data VALUES (1413, 44, 2529, 917.58, 184, 8);
INSERT INTO public.europe_data VALUES (1414, 0, 0, 0, 88, 8);
INSERT INTO public.europe_data VALUES (1415, 333, 17516, 102.73, 35, 8);
INSERT INTO public.europe_data VALUES (1416, 6, 614, 4.36, 36, 8);
INSERT INTO public.europe_data VALUES (1417, 175, 7792, 31.42, 127, 8);
INSERT INTO public.europe_data VALUES (1418, 17, 2178, 145.76, 37, 8);
INSERT INTO public.europe_data VALUES (1419, 90, 5349, 44.71, 128, 8);
INSERT INTO public.europe_data VALUES (1420, 443, 76154, 765.8, 185, 8);
INSERT INTO public.europe_data VALUES (1421, 0, 1, 0.71, 208, 8);
INSERT INTO public.europe_data VALUES (1422, 0, 25, 0.88, 209, 8);
INSERT INTO public.europe_data VALUES (1423, 1, 51, 1.53, 89, 8);
INSERT INTO public.europe_data VALUES (1424, 7, 401, 3.44, 38, 8);
INSERT INTO public.europe_data VALUES (1425, 24, 5259, 4.57, 39, 8);
INSERT INTO public.europe_data VALUES (1426, 171, 4667, 497.66, 186, 8);
INSERT INTO public.europe_data VALUES (1427, 0, 3, 12.23, 210, 8);
INSERT INTO public.europe_data VALUES (1428, 11, 1772, 101.42, 187, 8);
INSERT INTO public.europe_data VALUES (1429, 17, 1427, 55.9, 129, 8);
INSERT INTO public.europe_data VALUES (1430, 560, 18181, 17.86, 130, 8);
INSERT INTO public.europe_data VALUES (1431, 208, 15390, 562.33, 131, 8);
INSERT INTO public.europe_data VALUES (1432, 241, 21031, 855.28, 90, 8);
INSERT INTO public.europe_data VALUES (1433, 1, 36, 1.03, 211, 8);
INSERT INTO public.europe_data VALUES (1434, 150, 7030, 180.17, 91, 8);
INSERT INTO public.europe_data VALUES (1435, 496, 13502, 75.55, 92, 8);
INSERT INTO public.europe_data VALUES (1436, 214, 10389, 18.46, 132, 8);
INSERT INTO public.europe_data VALUES (1437, 2533, 67024, 366.71, 188, 8);
INSERT INTO public.europe_data VALUES (1438, 575, 25377, 502.57, 189, 8);
INSERT INTO public.europe_data VALUES (1439, 110, 8229, 589.18, 93, 8);
INSERT INTO public.europe_data VALUES (1440, 2, 880, 73.9, 133, 8);
INSERT INTO public.europe_data VALUES (1441, 1009, 34959, 400.31, 190, 8);
INSERT INTO public.europe_data VALUES (1442, 2210, 108740, 206.96, 191, 8);
INSERT INTO public.europe_data VALUES (1443, 7, 634, 9.22, 40, 8);
INSERT INTO public.europe_data VALUES (1444, 0, 2, 9.46, 94, 8);
INSERT INTO public.europe_data VALUES (1445, 1, 12, 12.04, 95, 8);
INSERT INTO public.europe_data VALUES (1446, 0, 6, 15.37, 96, 8);
INSERT INTO public.europe_data VALUES (1447, 4, 160, 923, 192, 8);
INSERT INTO public.europe_data VALUES (1448, 0, 3, 6.05, 41, 8);
INSERT INTO public.europe_data VALUES (1449, 74, 1122, 6.7, 134, 8);
INSERT INTO public.europe_data VALUES (1450, 16, 683, 7.86, 42, 8);
INSERT INTO public.europe_data VALUES (1451, 402, 37315, 1207.61, 193, 8);
INSERT INTO public.europe_data VALUES (1452, 0, 3, 21.49, 43, 8);
INSERT INTO public.europe_data VALUES (1453, 0, 64, 1.06, 44, 8);
INSERT INTO public.europe_data VALUES (1454, 0, 102, 2.79, 135, 8);
INSERT INTO public.europe_data VALUES (1455, 0, 89, 464.74, 97, 8);
INSERT INTO public.europe_data VALUES (1456, 380, 18352, 634.91, 194, 8);
INSERT INTO public.europe_data VALUES (1457, 156, 9585, 965.64, 195, 8);
INSERT INTO public.europe_data VALUES (1458, 0, 0, 0, 212, 8);
INSERT INTO public.europe_data VALUES (1459, 3, 83, 0.89, 45, 8);
INSERT INTO public.europe_data VALUES (1460, 1415, 60958, 183.33, 46, 8);
INSERT INTO public.europe_data VALUES (1461, 111, 7107, 24.27, 136, 8);
INSERT INTO public.europe_data VALUES (1462, 0, 5, 0.42, 47, 8);
INSERT INTO public.europe_data VALUES (1463, 1247, 67365, 249.1, 196, 8);
INSERT INTO public.europe_data VALUES (1464, 24, 4471, 44.01, 137, 8);
INSERT INTO public.europe_data VALUES (1465, 87, 1437, 7.84, 48, 8);
INSERT INTO public.europe_data VALUES (1466, 1, 230, 44.55, 98, 8);
INSERT INTO public.europe_data VALUES (1467, 645, 46181, 877.91, 197, 8);
INSERT INTO public.europe_data VALUES (1468, 802, 39833, 808.25, 198, 8);
INSERT INTO public.europe_data VALUES (1469, 92, 1029, 10.5, 138, 8);
INSERT INTO public.europe_data VALUES (1470, 0, 26, 0.21, 139, 8);
INSERT INTO public.europe_data VALUES (1471, 1, 256, 5.71, 140, 8);
INSERT INTO public.europe_data VALUES (1472, 0, 670, 1.15, 141, 8);
INSERT INTO public.europe_data VALUES (1473, 0, 0, 0, 142, 8);
INSERT INTO public.europe_data VALUES (1474, 0, 165, 3.97, 49, 8);
INSERT INTO public.europe_data VALUES (1475, 3, 133, 17.56, 99, 8);
INSERT INTO public.europe_data VALUES (1476, 305, 10357, 151.49, 50, 8);
INSERT INTO public.europe_data VALUES (1477, 1680, 187873, 492.06, 199, 8);
INSERT INTO public.europe_data VALUES (1478, 0, 29, 109.96, 100, 8);
INSERT INTO public.europe_data VALUES (1479, 10, 3655, 19.63, 51, 8);
INSERT INTO public.europe_data VALUES (1480, 1418, 70327, 358.43, 200, 8);
INSERT INTO public.europe_data VALUES (1481, 20, 8626, 175.49, 143, 8);
INSERT INTO public.europe_data VALUES (1482, 3231, 190744, 475.5, 201, 8);
INSERT INTO public.europe_data VALUES (1483, 0, 0, 0, 52, 8);
INSERT INTO public.europe_data VALUES (1484, 18493, 1588085, 938.37, 101, 8);
INSERT INTO public.europe_data VALUES (1485, 0, 93, 260.09, 102, 8);
INSERT INTO public.europe_data VALUES (1486, 27, 3769, 178.35, 103, 8);
INSERT INTO public.europe_data VALUES (1487, 0, 954, 6.05, 144, 8);
INSERT INTO public.europe_data VALUES (1488, 0, 0, 0, 213, 8);
INSERT INTO public.europe_data VALUES (1489, 39, 2898, 19.75, 104, 8);
INSERT INTO public.europe_data VALUES (1490, 0, 16, 0.05, 145, 8);
INSERT INTO public.europe_data VALUES (1491, 0, 1, 0, 214, 8);
INSERT INTO public.europe_data VALUES (1492, 0, 0, 0, 53, 8);
INSERT INTO public.europe_data VALUES (1493, 1, 6, 0.04, 146, 8);
INSERT INTO public.europe_data VALUES (1494, 6, 442, 4.48, 54, 8);
INSERT INTO public.europe_data VALUES (1495, 13, 1107, 11.16, 55, 8);
INSERT INTO public.europe_data VALUES (1496, 71, 1757, 9.01, 105, 9);
INSERT INTO public.europe_data VALUES (1497, 98, 5542, 380.97, 147, 9);
INSERT INTO public.europe_data VALUES (1498, 80, 3850, 22.95, 1, 9);
INSERT INTO public.europe_data VALUES (1499, 1, 288, 821.77, 148, 9);
INSERT INTO public.europe_data VALUES (1500, 17, 652, 3.41, 2, 9);
INSERT INTO public.europe_data VALUES (1501, 0, 1, 40.34, 56, 9);
INSERT INTO public.europe_data VALUES (1502, 1, 2, 7.21, 57, 9);
INSERT INTO public.europe_data VALUES (1503, 996, 35067, 177.23, 58, 9);
INSERT INTO public.europe_data VALUES (1504, 159, 6338, 458.39, 149, 9);
INSERT INTO public.europe_data VALUES (1505, 1, 84, 198.48, 59, 9);
INSERT INTO public.europe_data VALUES (1506, 0, 66, 0.55, 202, 9);
INSERT INTO public.europe_data VALUES (1507, 668, 19060, 472.46, 150, 9);
INSERT INTO public.europe_data VALUES (1508, 290, 29195, 574.05, 151, 9);
INSERT INTO public.europe_data VALUES (1509, 0, 95, 45.7, 60, 9);
INSERT INTO public.europe_data VALUES (1510, 7, 1213, 143.56, 106, 9);
INSERT INTO public.europe_data VALUES (1511, 214, 12988, 17.25, 107, 9);
INSERT INTO public.europe_data VALUES (1512, 0, 9, 7.32, 61, 9);
INSERT INTO public.europe_data VALUES (1513, 56, 13138, 267.52, 152, 9);
INSERT INTO public.europe_data VALUES (1514, 666, 16793, 279.93, 153, 9);
INSERT INTO public.europe_data VALUES (1515, 22, 1526, 909.95, 62, 9);
INSERT INTO public.europe_data VALUES (1516, 0, 35, 0.98, 3, 9);
INSERT INTO public.europe_data VALUES (1517, 0, 143, 287.96, 63, 9);
INSERT INTO public.europe_data VALUES (1518, 0, 8, 5.5, 108, 9);
INSERT INTO public.europe_data VALUES (1519, 23, 1590, 21.96, 64, 9);
INSERT INTO public.europe_data VALUES (1520, 0, 9, 46.18, 65, 9);
INSERT INTO public.europe_data VALUES (1521, 384, 6610, 416.33, 154, 9);
INSERT INTO public.europe_data VALUES (1522, 4, 1342, 125.06, 4, 9);
INSERT INTO public.europe_data VALUES (1523, 4461, 298412, 278.23, 66, 9);
INSERT INTO public.europe_data VALUES (1524, 0, 7, 23.31, 67, 9);
INSERT INTO public.europe_data VALUES (1525, 0, 1, 0.46, 109, 9);
INSERT INTO public.europe_data VALUES (1526, 891, 18028, 528.04, 155, 9);
INSERT INTO public.europe_data VALUES (1527, 3, 818, 5.78, 5, 9);
INSERT INTO public.europe_data VALUES (1528, 0, 35, 0.42, 6, 9);
INSERT INTO public.europe_data VALUES (1529, 0, 11, 0.22, 110, 9);
INSERT INTO public.europe_data VALUES (1530, 2, 607, 4.8, 7, 9);
INSERT INTO public.europe_data VALUES (1531, 766, 45561, 241.81, 68, 9);
INSERT INTO public.europe_data VALUES (1532, 1, 294, 151.11, 8, 9);
INSERT INTO public.europe_data VALUES (1533, 0, 10, 36.95, 69, 9);
INSERT INTO public.europe_data VALUES (1534, 0, 14, 0.48, 9, 9);
INSERT INTO public.europe_data VALUES (1535, 0, 45, 0.55, 10, 9);
INSERT INTO public.europe_data VALUES (1536, 258, 11537, 113.39, 70, 9);
INSERT INTO public.europe_data VALUES (1537, 0, 103, 0.01, 111, 9);
INSERT INTO public.europe_data VALUES (1538, 1245, 54671, 233.21, 71, 9);
INSERT INTO public.europe_data VALUES (1539, 0, 12, 2, 11, 9);
INSERT INTO public.europe_data VALUES (1540, 6, 426, 7.92, 12, 9);
INSERT INTO public.europe_data VALUES (1541, 163, 9484, 318.49, 72, 9);
INSERT INTO public.europe_data VALUES (1542, 1, 195, 1.44, 13, 9);
INSERT INTO public.europe_data VALUES (1543, 466, 25533, 1208.81, 156, 9);
INSERT INTO public.europe_data VALUES (1544, 1, 641, 10.5, 73, 9);
INSERT INTO public.europe_data VALUES (1545, 4, 488, 771.01, 74, 9);
INSERT INTO public.europe_data VALUES (1546, 17, 2650, 538.65, 157, 9);
INSERT INTO public.europe_data VALUES (1547, 707, 34246, 576.12, 158, 9);
INSERT INTO public.europe_data VALUES (1548, 12, 918, 2.09, 14, 9);
INSERT INTO public.europe_data VALUES (1549, 56, 19155, 523.69, 159, 9);
INSERT INTO public.europe_data VALUES (1550, 0, 27, 5.24, 15, 9);
INSERT INTO public.europe_data VALUES (1551, 0, 3, 4.18, 75, 9);
INSERT INTO public.europe_data VALUES (1552, 16, 6239, 104.47, 76, 9);
INSERT INTO public.europe_data VALUES (1553, 97, 4112, 57.52, 77, 9);
INSERT INTO public.europe_data VALUES (1554, 149, 3143, 6.01, 16, 9);
INSERT INTO public.europe_data VALUES (1555, 41, 1535, 53.85, 78, 9);
INSERT INTO public.europe_data VALUES (1556, 0, 29, 3.1, 17, 9);
INSERT INTO public.europe_data VALUES (1557, 0, 79, 3.83, 18, 9);
INSERT INTO public.europe_data VALUES (1558, 18, 3077, 453.12, 160, 9);
INSERT INTO public.europe_data VALUES (1559, 5, 267, 31.18, 19, 9);
INSERT INTO public.europe_data VALUES (1560, 59, 3474, 6.46, 20, 9);
INSERT INTO public.europe_data VALUES (1561, 0, 2, 59.31, 79, 9);
INSERT INTO public.europe_data VALUES (1562, 0, 18, 53.41, 161, 9);
INSERT INTO public.europe_data VALUES (1563, 0, 2, 0.45, 203, 9);
INSERT INTO public.europe_data VALUES (1564, 46, 3179, 112.02, 162, 9);
INSERT INTO public.europe_data VALUES (1565, 2756, 84355, 236.33, 163, 9);
INSERT INTO public.europe_data VALUES (1566, 17, 640, 591.15, 204, 9);
INSERT INTO public.europe_data VALUES (1567, 3, 97, 7.36, 21, 9);
INSERT INTO public.europe_data VALUES (1568, 0, 12, 2.04, 22, 9);
INSERT INTO public.europe_data VALUES (1569, 299, 26087, 1388.1, 164, 9);
INSERT INTO public.europe_data VALUES (1570, 3056, 153424, 341.14, 165, 9);
INSERT INTO public.europe_data VALUES (1571, 2, 740, 4.75, 23, 9);
INSERT INTO public.europe_data VALUES (1572, 0, 22, 180.98, 166, 9);
INSERT INTO public.europe_data VALUES (1573, 622, 9063, 189.35, 167, 9);
INSERT INTO public.europe_data VALUES (1574, 0, 1, 1.76, 80, 9);
INSERT INTO public.europe_data VALUES (1575, 0, 28, 25, 81, 9);
INSERT INTO public.europe_data VALUES (1576, 5, 102, 172.15, 205, 9);
INSERT INTO public.europe_data VALUES (1577, 173, 3732, 41.58, 82, 9);
INSERT INTO public.europe_data VALUES (1578, 0, 1, 4.65, 168, 9);
INSERT INTO public.europe_data VALUES (1579, 4, 224, 3.27, 24, 9);
INSERT INTO public.europe_data VALUES (1580, 0, 5, 1.3, 25, 9);
INSERT INTO public.europe_data VALUES (1581, 2, 255, 69.5, 83, 9);
INSERT INTO public.europe_data VALUES (1582, 1, 195, 2.67, 84, 9);
INSERT INTO public.europe_data VALUES (1583, 0, 0, 0, 169, 9);
INSERT INTO public.europe_data VALUES (1584, 29, 3336, 66.4, 85, 9);
INSERT INTO public.europe_data VALUES (1585, 1146, 29722, 683, 170, 9);
INSERT INTO public.europe_data VALUES (1586, 1, 75, 49.3, 171, 9);
INSERT INTO public.europe_data VALUES (1587, 2782, 206897, 33.11, 112, 9);
INSERT INTO public.europe_data VALUES (1588, 1079, 42024, 30.87, 113, 9);
INSERT INTO public.europe_data VALUES (1589, 1886, 67722, 192.39, 114, 9);
INSERT INTO public.europe_data VALUES (1590, 147, 10434, 61.56, 115, 9);
INSERT INTO public.europe_data VALUES (1591, 27, 1939, 80.42, 172, 9);
INSERT INTO public.europe_data VALUES (1592, 0, 3, 4.73, 173, 9);
INSERT INTO public.europe_data VALUES (1593, 82, 12658, 256.81, 116, 9);
INSERT INTO public.europe_data VALUES (1594, 4442, 114834, 428.32, 174, 9);
INSERT INTO public.europe_data VALUES (1595, 8, 590, 33.95, 86, 9);
INSERT INTO public.europe_data VALUES (1596, 250, 17586, 25.93, 117, 9);
INSERT INTO public.europe_data VALUES (1597, 0, 422, 789.45, 175, 9);
INSERT INTO public.europe_data VALUES (1598, 309, 19525, 448.51, 118, 9);
INSERT INTO public.europe_data VALUES (1599, 64, 6188, 67.22, 119, 9);
INSERT INTO public.europe_data VALUES (1600, 61, 3512, 16.31, 26, 9);
INSERT INTO public.europe_data VALUES (1601, 92, 3775, 418.29, 176, 9);
INSERT INTO public.europe_data VALUES (1602, 20, 1849, 90.13, 120, 9);
INSERT INTO public.europe_data VALUES (1603, 15, 2279, 75.86, 121, 9);
INSERT INTO public.europe_data VALUES (1604, 0, 0, 0.03, 122, 9);
INSERT INTO public.europe_data VALUES (1605, 87, 4362, 453.13, 177, 9);
INSERT INTO public.europe_data VALUES (1606, 101, 9367, 285.54, 123, 9);
INSERT INTO public.europe_data VALUES (1607, 0, 135, 8.28, 27, 9);
INSERT INTO public.europe_data VALUES (1608, 0, 95, 3.56, 28, 9);
INSERT INTO public.europe_data VALUES (1609, 68, 4199, 123.19, 29, 9);
INSERT INTO public.europe_data VALUES (1610, 2, 118, 627.96, 178, 9);
INSERT INTO public.europe_data VALUES (1611, 188, 18985, 1205.93, 179, 9);
INSERT INTO public.europe_data VALUES (1612, 46, 3588, 1188.97, 180, 9);
INSERT INTO public.europe_data VALUES (1613, 3, 120, 1.08, 30, 9);
INSERT INTO public.europe_data VALUES (1614, 2, 15, 0.22, 31, 9);
INSERT INTO public.europe_data VALUES (1615, 33, 10781, 59.44, 124, 9);
INSERT INTO public.europe_data VALUES (1616, 1, 170, 70.44, 125, 9);
INSERT INTO public.europe_data VALUES (1617, 30, 679, 5.88, 32, 9);
INSERT INTO public.europe_data VALUES (1618, 21, 595, 279.8, 181, 9);
INSERT INTO public.europe_data VALUES (1619, 0, 0, 0, 206, 9);
INSERT INTO public.europe_data VALUES (1620, 48, 2261, 53.52, 33, 9);
INSERT INTO public.europe_data VALUES (1621, 0, 18, 1.73, 34, 9);
INSERT INTO public.europe_data VALUES (1622, 4236, 74194, 112.07, 87, 9);
INSERT INTO public.europe_data VALUES (1623, 153, 9883, 482.31, 182, 9);
INSERT INTO public.europe_data VALUES (1624, 0, 30, 181.35, 183, 9);
INSERT INTO public.europe_data VALUES (1625, 0, 25, 3.75, 126, 9);
INSERT INTO public.europe_data VALUES (1626, 49, 3180, 1051.94, 184, 9);
INSERT INTO public.europe_data VALUES (1627, 0, 0, 0, 88, 9);
INSERT INTO public.europe_data VALUES (1628, 379, 19952, 125.59, 35, 9);
INSERT INTO public.europe_data VALUES (1629, 9, 710, 4.42, 36, 9);
INSERT INTO public.europe_data VALUES (1630, 158, 9187, 34.89, 127, 9);
INSERT INTO public.europe_data VALUES (1631, 8, 1458, 87.83, 37, 9);
INSERT INTO public.europe_data VALUES (1632, 104, 7442, 57.48, 128, 9);
INSERT INTO public.europe_data VALUES (1633, 360, 56193, 546.65, 185, 9);
INSERT INTO public.europe_data VALUES (1634, 0, 1, 1.41, 208, 9);
INSERT INTO public.europe_data VALUES (1635, 0, 17, 0.84, 209, 9);
INSERT INTO public.europe_data VALUES (1636, 1, 49, 1.57, 89, 9);
INSERT INTO public.europe_data VALUES (1637, 3, 402, 3.18, 38, 9);
INSERT INTO public.europe_data VALUES (1638, 17, 3920, 2.87, 39, 9);
INSERT INTO public.europe_data VALUES (1639, 197, 5670, 582.29, 186, 9);
INSERT INTO public.europe_data VALUES (1640, 0, 4, 12.23, 210, 9);
INSERT INTO public.europe_data VALUES (1641, 39, 3632, 117.41, 187, 9);
INSERT INTO public.europe_data VALUES (1642, 27, 1354, 55.4, 129, 9);
INSERT INTO public.europe_data VALUES (1643, 434, 20493, 19.75, 130, 9);
INSERT INTO public.europe_data VALUES (1644, 157, 12622, 559.46, 131, 9);
INSERT INTO public.europe_data VALUES (1645, 163, 15288, 665.92, 90, 9);
INSERT INTO public.europe_data VALUES (1646, 1, 54, 0.8, 211, 9);
INSERT INTO public.europe_data VALUES (1647, 100, 5662, 165.74, 91, 9);
INSERT INTO public.europe_data VALUES (1648, 403, 11061, 69.03, 92, 9);
INSERT INTO public.europe_data VALUES (1649, 179, 9566, 18.07, 132, 9);
INSERT INTO public.europe_data VALUES (1650, 2775, 72227, 396.6, 188, 9);
INSERT INTO public.europe_data VALUES (1651, 596, 26270, 524.93, 189, 9);
INSERT INTO public.europe_data VALUES (1652, 80, 9054, 564.63, 93, 9);
INSERT INTO public.europe_data VALUES (1653, 2, 1213, 87.32, 133, 9);
INSERT INTO public.europe_data VALUES (1654, 1065, 42759, 436.78, 190, 9);
INSERT INTO public.europe_data VALUES (1655, 3800, 193158, 263.66, 191, 9);
INSERT INTO public.europe_data VALUES (1656, 5, 530, 5.86, 40, 9);
INSERT INTO public.europe_data VALUES (1657, 0, 3, 11.36, 94, 9);
INSERT INTO public.europe_data VALUES (1658, 2, 10, 9.85, 95, 9);
INSERT INTO public.europe_data VALUES (1659, 0, 11, 11.75, 96, 9);
INSERT INTO public.europe_data VALUES (1660, 3, 158, 1047.8, 192, 9);
INSERT INTO public.europe_data VALUES (1661, 0, 10, 9.3, 41, 9);
INSERT INTO public.europe_data VALUES (1662, 83, 1175, 8.05, 134, 9);
INSERT INTO public.europe_data VALUES (1663, 11, 598, 6.14, 42, 9);
INSERT INTO public.europe_data VALUES (1664, 382, 46780, 1396.06, 193, 9);
INSERT INTO public.europe_data VALUES (1665, 0, 18, 29.67, 43, 9);
INSERT INTO public.europe_data VALUES (1666, 1, 19, 0.44, 44, 9);
INSERT INTO public.europe_data VALUES (1667, 0, 60, 1.84, 135, 9);
INSERT INTO public.europe_data VALUES (1668, 0, 108, 431.72, 97, 9);
INSERT INTO public.europe_data VALUES (1669, 179, 16253, 499.98, 194, 9);
INSERT INTO public.europe_data VALUES (1670, 954, 10509, 1005.96, 195, 9);
INSERT INTO public.europe_data VALUES (1671, 0, 0, 0, 212, 9);
INSERT INTO public.europe_data VALUES (1672, 0, 54, 0.87, 45, 9);
INSERT INTO public.europe_data VALUES (1673, 1070, 46399, 125.11, 46, 9);
INSERT INTO public.europe_data VALUES (1674, 38, 5323, 18.12, 136, 9);
INSERT INTO public.europe_data VALUES (1675, 0, 42, 1.03, 47, 9);
INSERT INTO public.europe_data VALUES (1676, 1367, 49556, 220.93, 196, 9);
INSERT INTO public.europe_data VALUES (1677, 12, 4913, 43.64, 137, 9);
INSERT INTO public.europe_data VALUES (1678, 52, 1918, 8.78, 48, 9);
INSERT INTO public.europe_data VALUES (1679, 0, 29, 7.05, 98, 9);
INSERT INTO public.europe_data VALUES (1680, 499, 43631, 786.61, 197, 9);
INSERT INTO public.europe_data VALUES (1681, 546, 29228, 647.34, 198, 9);
INSERT INTO public.europe_data VALUES (1682, 71, 763, 8.02, 138, 9);
INSERT INTO public.europe_data VALUES (1683, 0, 24, 0.27, 139, 9);
INSERT INTO public.europe_data VALUES (1684, 1, 276, 5.89, 140, 9);
INSERT INTO public.europe_data VALUES (1685, 0, 130, 0.37, 141, 9);
INSERT INTO public.europe_data VALUES (1686, 0, 0, 0.08, 142, 9);
INSERT INTO public.europe_data VALUES (1687, 1, 156, 3.58, 49, 9);
INSERT INTO public.europe_data VALUES (1688, 0, 112, 15.7, 99, 9);
INSERT INTO public.europe_data VALUES (1689, 333, 7359, 129.2, 50, 9);
INSERT INTO public.europe_data VALUES (1690, 1517, 215632, 532.05, 199, 9);
INSERT INTO public.europe_data VALUES (1691, 0, 13, 54.98, 100, 9);
INSERT INTO public.europe_data VALUES (1692, 15, 5033, 16.69, 51, 9);
INSERT INTO public.europe_data VALUES (1693, 1659, 87360, 404.57, 200, 9);
INSERT INTO public.europe_data VALUES (1694, 25, 8520, 176, 143, 9);
INSERT INTO public.europe_data VALUES (1695, 2925, 126161, 348.22, 201, 9);
INSERT INTO public.europe_data VALUES (1696, 0, 0, 0, 52, 9);
INSERT INTO public.europe_data VALUES (1697, 16867, 1499756, 873.21, 101, 9);
INSERT INTO public.europe_data VALUES (1698, 0, 179, 271.57, 102, 9);
INSERT INTO public.europe_data VALUES (1699, 10, 2405, 115.32, 103, 9);
INSERT INTO public.europe_data VALUES (1700, 1, 1041, 6.74, 144, 9);
INSERT INTO public.europe_data VALUES (1701, 0, 0, 0, 213, 9);
INSERT INTO public.europe_data VALUES (1702, 30, 2735, 18.01, 104, 9);
INSERT INTO public.europe_data VALUES (1703, 0, 31, 0.06, 145, 9);
INSERT INTO public.europe_data VALUES (1704, 0, 0, 0, 214, 9);
INSERT INTO public.europe_data VALUES (1705, 0, 0, 0, 53, 9);
INSERT INTO public.europe_data VALUES (1706, 0, 6, 0.02, 146, 9);
INSERT INTO public.europe_data VALUES (1707, 3, 358, 3.73, 54, 9);
INSERT INTO public.europe_data VALUES (1708, 16, 528, 8.85, 55, 9);
INSERT INTO public.europe_data VALUES (1709, 137, 1672, 7.22, 105, 10);
INSERT INTO public.europe_data VALUES (1710, 107, 5363, 357.28, 147, 10);
INSERT INTO public.europe_data VALUES (1711, 106, 6031, 31.1, 1, 10);
INSERT INTO public.europe_data VALUES (1712, 2, 338, 1042.31, 148, 10);
INSERT INTO public.europe_data VALUES (1713, 8, 433, 3.28, 2, 10);
INSERT INTO public.europe_data VALUES (1714, 0, 5, 33.62, 56, 10);
INSERT INTO public.europe_data VALUES (1715, 0, 5, 7.21, 57, 10);
INSERT INTO public.europe_data VALUES (1716, 1297, 44299, 207.1, 58, 10);
INSERT INTO public.europe_data VALUES (1717, 180, 7220, 528.62, 149, 10);
INSERT INTO public.europe_data VALUES (1718, 0, 127, 220.11, 59, 10);
INSERT INTO public.europe_data VALUES (1719, 1, 72, 0.57, 202, 10);
INSERT INTO public.europe_data VALUES (1720, 828, 22794, 619.18, 150, 10);
INSERT INTO public.europe_data VALUES (1721, 271, 28484, 533.31, 151, 10);
INSERT INTO public.europe_data VALUES (1722, 0, 83, 42.62, 60, 10);
INSERT INTO public.europe_data VALUES (1723, 0, 1143, 135.57, 106, 10);
INSERT INTO public.europe_data VALUES (1724, 229, 15138, 18.52, 107, 10);
INSERT INTO public.europe_data VALUES (1725, 0, 12, 9.76, 61, 10);
INSERT INTO public.europe_data VALUES (1726, 56, 12149, 245, 152, 10);
INSERT INTO public.europe_data VALUES (1727, 699, 15275, 275.22, 153, 10);
INSERT INTO public.europe_data VALUES (1728, 26, 2026, 662.48, 62, 10);
INSERT INTO public.europe_data VALUES (1729, 1, 81, 1.18, 3, 10);
INSERT INTO public.europe_data VALUES (1730, 0, 37, 97.59, 63, 10);
INSERT INTO public.europe_data VALUES (1731, 0, 34, 6.29, 108, 10);
INSERT INTO public.europe_data VALUES (1732, 43, 938, 14.23, 64, 10);
INSERT INTO public.europe_data VALUES (1733, 0, 3, 11.55, 65, 10);
INSERT INTO public.europe_data VALUES (1734, 332, 7133, 439.26, 154, 10);
INSERT INTO public.europe_data VALUES (1735, 3, 1539, 84.08, 4, 10);
INSERT INTO public.europe_data VALUES (1736, 4108, 288800, 252.14, 66, 10);
INSERT INTO public.europe_data VALUES (1737, 0, 0, 3.33, 67, 10);
INSERT INTO public.europe_data VALUES (1738, 0, 1, 0.69, 109, 10);
INSERT INTO public.europe_data VALUES (1739, 983, 18935, 565.73, 155, 10);
INSERT INTO public.europe_data VALUES (1740, 0, 356, 2.35, 5, 10);
INSERT INTO public.europe_data VALUES (1741, 0, 13, 0.28, 6, 10);
INSERT INTO public.europe_data VALUES (1742, 0, 25, 0.25, 110, 10);
INSERT INTO public.europe_data VALUES (1743, 6, 635, 4.73, 7, 10);
INSERT INTO public.europe_data VALUES (1744, 633, 44904, 226.35, 68, 10);
INSERT INTO public.europe_data VALUES (1745, 5, 537, 143.11, 8, 10);
INSERT INTO public.europe_data VALUES (1746, 0, 14, 41.57, 69, 10);
INSERT INTO public.europe_data VALUES (1747, 0, 9, 0.23, 9, 10);
INSERT INTO public.europe_data VALUES (1748, 1, 43, 0.52, 10, 10);
INSERT INTO public.europe_data VALUES (1749, 272, 9952, 104.17, 70, 10);
INSERT INTO public.europe_data VALUES (1750, 0, 104, 0.01, 111, 10);
INSERT INTO public.europe_data VALUES (1751, 1224, 62727, 243.72, 71, 10);
INSERT INTO public.europe_data VALUES (1752, 0, 5, 2.35, 11, 10);
INSERT INTO public.europe_data VALUES (1753, 0, 0, 2.64, 12, 10);
INSERT INTO public.europe_data VALUES (1754, 83, 6592, 282.65, 72, 10);
INSERT INTO public.europe_data VALUES (1755, 1, 175, 1.35, 13, 10);
INSERT INTO public.europe_data VALUES (1756, 462, 23741, 1144.07, 156, 10);
INSERT INTO public.europe_data VALUES (1757, 2, 549, 8.26, 73, 10);
INSERT INTO public.europe_data VALUES (1758, 3, 772, 848.72, 74, 10);
INSERT INTO public.europe_data VALUES (1759, 13, 2068, 434.75, 157, 10);
INSERT INTO public.europe_data VALUES (1760, 764, 27110, 512.4, 158, 10);
INSERT INTO public.europe_data VALUES (1761, 11, 893, 1.56, 14, 10);
INSERT INTO public.europe_data VALUES (1762, 56, 11251, 346.5, 159, 10);
INSERT INTO public.europe_data VALUES (1763, 0, 24, 3.39, 15, 10);
INSERT INTO public.europe_data VALUES (1764, 0, 0, 11.14, 75, 10);
INSERT INTO public.europe_data VALUES (1765, 15, 4980, 93.52, 76, 10);
INSERT INTO public.europe_data VALUES (1766, 355, 5881, 71.11, 77, 10);
INSERT INTO public.europe_data VALUES (1767, 135, 2891, 5.38, 16, 10);
INSERT INTO public.europe_data VALUES (1768, 50, 1940, 43.12, 78, 10);
INSERT INTO public.europe_data VALUES (1769, 0, 13, 2.65, 17, 10);
INSERT INTO public.europe_data VALUES (1770, 0, 55, 2.32, 18, 10);
INSERT INTO public.europe_data VALUES (1771, 19, 2926, 396.58, 160, 10);
INSERT INTO public.europe_data VALUES (1772, 1, 91, 24.56, 19, 10);
INSERT INTO public.europe_data VALUES (1773, 47, 3761, 6.7, 20, 10);
INSERT INTO public.europe_data VALUES (1774, 0, 0, 29.66, 79, 10);
INSERT INTO public.europe_data VALUES (1775, 0, 8, 20.54, 161, 10);
INSERT INTO public.europe_data VALUES (1776, 0, 2, 1.01, 203, 10);
INSERT INTO public.europe_data VALUES (1777, 22, 3002, 108.59, 162, 10);
INSERT INTO public.europe_data VALUES (1778, 2830, 74014, 227.25, 163, 10);
INSERT INTO public.europe_data VALUES (1779, 6, 1011, 762.3, 204, 10);
INSERT INTO public.europe_data VALUES (1780, 1, 63, 5.66, 21, 10);
INSERT INTO public.europe_data VALUES (1781, 0, 36, 1.87, 22, 10);
INSERT INTO public.europe_data VALUES (1782, 273, 29392, 1408.29, 164, 10);
INSERT INTO public.europe_data VALUES (1783, 2671, 129785, 306.58, 165, 10);
INSERT INTO public.europe_data VALUES (1784, 2, 705, 4.6, 23, 10);
INSERT INTO public.europe_data VALUES (1785, 0, 39, 281.85, 166, 10);
INSERT INTO public.europe_data VALUES (1786, 682, 11244, 222.4, 167, 10);
INSERT INTO public.europe_data VALUES (1787, 0, 0, 0, 80, 10);
INSERT INTO public.europe_data VALUES (1788, 0, 0, 0, 81, 10);
INSERT INTO public.europe_data VALUES (1789, 1, 186, 271.97, 205, 10);
INSERT INTO public.europe_data VALUES (1790, 84, 3579, 39.37, 82, 10);
INSERT INTO public.europe_data VALUES (1791, 0, 2, 7.76, 168, 10);
INSERT INTO public.europe_data VALUES (1792, 0, 194, 3.19, 24, 10);
INSERT INTO public.europe_data VALUES (1793, 1, 20, 1.09, 25, 10);
INSERT INTO public.europe_data VALUES (1794, 3, 289, 67.96, 83, 10);
INSERT INTO public.europe_data VALUES (1795, 1, 106, 1.39, 84, 10);
INSERT INTO public.europe_data VALUES (1796, 0, 0, 0, 169, 10);
INSERT INTO public.europe_data VALUES (1797, 37, 3135, 67.6, 85, 10);
INSERT INTO public.europe_data VALUES (1798, 1161, 37026, 779.68, 170, 10);
INSERT INTO public.europe_data VALUES (1799, 1, 101, 57.42, 171, 10);
INSERT INTO public.europe_data VALUES (1800, 3434, 245512, 39.32, 112, 10);
INSERT INTO public.europe_data VALUES (1801, 925, 41530, 28.87, 113, 10);
INSERT INTO public.europe_data VALUES (1802, 2435, 91798, 224.55, 114, 10);
INSERT INTO public.europe_data VALUES (1803, 208, 13765, 73.47, 115, 10);
INSERT INTO public.europe_data VALUES (1804, 45, 2005, 77.18, 172, 10);
INSERT INTO public.europe_data VALUES (1805, 0, 1, 2.36, 173, 10);
INSERT INTO public.europe_data VALUES (1806, 53, 9221, 185.44, 116, 10);
INSERT INTO public.europe_data VALUES (1807, 5174, 143700, 530.17, 174, 10);
INSERT INTO public.europe_data VALUES (1808, 9, 411, 28.36, 86, 10);
INSERT INTO public.europe_data VALUES (1809, 216, 15307, 24.55, 117, 10);
INSERT INTO public.europe_data VALUES (1810, 0, 429, 506.51, 175, 10);
INSERT INTO public.europe_data VALUES (1811, 362, 25782, 560.9, 118, 10);
INSERT INTO public.europe_data VALUES (1812, 55, 6283, 68.48, 119, 10);
INSERT INTO public.europe_data VALUES (1813, 74, 5064, 20.94, 26, 10);
INSERT INTO public.europe_data VALUES (1814, 101, 3748, 473.17, 176, 10);
INSERT INTO public.europe_data VALUES (1815, 13, 1943, 102.52, 120, 10);
INSERT INTO public.europe_data VALUES (1816, 26, 2588, 85.88, 121, 10);
INSERT INTO public.europe_data VALUES (1817, 0, 2, 0.24, 122, 10);
INSERT INTO public.europe_data VALUES (1818, 65, 4338, 426.73, 177, 10);
INSERT INTO public.europe_data VALUES (1819, 95, 10209, 301.6, 123, 10);
INSERT INTO public.europe_data VALUES (1820, 0, 41, 3.06, 27, 10);
INSERT INTO public.europe_data VALUES (1821, 0, 81, 2.53, 28, 10);
INSERT INTO public.europe_data VALUES (1822, 65, 4150, 129.21, 29, 10);
INSERT INTO public.europe_data VALUES (1823, 1, 123, 740.01, 178, 10);
INSERT INTO public.europe_data VALUES (1824, 131, 14711, 1037.48, 179, 10);
INSERT INTO public.europe_data VALUES (1825, 44, 3711, 1197.44, 180, 10);
INSERT INTO public.europe_data VALUES (1826, 4, 172, 0.64, 30, 10);
INSERT INTO public.europe_data VALUES (1827, 0, 26, 0.26, 31, 10);
INSERT INTO public.europe_data VALUES (1828, 25, 8209, 56.08, 124, 10);
INSERT INTO public.europe_data VALUES (1829, 1, 204, 111.12, 125, 10);
INSERT INTO public.europe_data VALUES (1830, 15, 476, 4.73, 32, 10);
INSERT INTO public.europe_data VALUES (1831, 15, 786, 335.32, 181, 10);
INSERT INTO public.europe_data VALUES (1832, 0, 0, 0, 206, 10);
INSERT INTO public.europe_data VALUES (1833, 2, 161, 13.57, 33, 10);
INSERT INTO public.europe_data VALUES (1834, 0, 4, 0.87, 34, 10);
INSERT INTO public.europe_data VALUES (1835, 4062, 68779, 105.02, 87, 10);
INSERT INTO public.europe_data VALUES (1836, 129, 9618, 462.35, 182, 10);
INSERT INTO public.europe_data VALUES (1837, 0, 30, 169.26, 183, 10);
INSERT INTO public.europe_data VALUES (1838, 0, 96, 7.66, 126, 10);
INSERT INTO public.europe_data VALUES (1839, 46, 3365, 1154.65, 184, 10);
INSERT INTO public.europe_data VALUES (1840, 0, 0, 0, 88, 10);
INSERT INTO public.europe_data VALUES (1841, 456, 25854, 160.93, 35, 10);
INSERT INTO public.europe_data VALUES (1842, 3, 631, 3.97, 36, 10);
INSERT INTO public.europe_data VALUES (1843, 192, 9669, 36.84, 127, 10);
INSERT INTO public.europe_data VALUES (1844, 1, 733, 48.63, 37, 10);
INSERT INTO public.europe_data VALUES (1845, 115, 9003, 72.26, 128, 10);
INSERT INTO public.europe_data VALUES (1846, 338, 38280, 419.47, 185, 10);
INSERT INTO public.europe_data VALUES (1847, 0, 3, 1.06, 208, 10);
INSERT INTO public.europe_data VALUES (1848, 0, 23, 1.02, 209, 10);
INSERT INTO public.europe_data VALUES (1849, 1, 54, 1.73, 89, 10);
INSERT INTO public.europe_data VALUES (1850, 7, 340, 2.09, 38, 10);
INSERT INTO public.europe_data VALUES (1851, 7, 1843, 1.43, 39, 10);
INSERT INTO public.europe_data VALUES (1852, 193, 6425, 636.7, 186, 10);
INSERT INTO public.europe_data VALUES (1853, 0, 3, 8.74, 210, 10);
INSERT INTO public.europe_data VALUES (1854, 26, 2624, 111.35, 187, 10);
INSERT INTO public.europe_data VALUES (1855, 26, 1402, 56.38, 129, 10);
INSERT INTO public.europe_data VALUES (1856, 373, 22270, 20.02, 130, 10);
INSERT INTO public.europe_data VALUES (1857, 115, 15247, 555.97, 131, 10);
INSERT INTO public.europe_data VALUES (1858, 133, 12990, 540.12, 90, 10);
INSERT INTO public.europe_data VALUES (1859, 0, 16, 0.76, 211, 10);
INSERT INTO public.europe_data VALUES (1860, 110, 6014, 162.45, 91, 10);
INSERT INTO public.europe_data VALUES (1861, 351, 11382, 74.57, 92, 10);
INSERT INTO public.europe_data VALUES (1862, 181, 9970, 19.44, 132, 10);
INSERT INTO public.europe_data VALUES (1863, 3060, 78374, 532.27, 188, 10);
INSERT INTO public.europe_data VALUES (1864, 536, 27675, 600.55, 189, 10);
INSERT INTO public.europe_data VALUES (1865, 98, 7509, 449.31, 93, 10);
INSERT INTO public.europe_data VALUES (1866, 2, 1260, 94.6, 133, 10);
INSERT INTO public.europe_data VALUES (1867, 1127, 42040, 488.97, 190, 10);
INSERT INTO public.europe_data VALUES (1868, 3614, 191454, 254.63, 191, 10);
INSERT INTO public.europe_data VALUES (1869, 3, 210, 3.67, 40, 10);
INSERT INTO public.europe_data VALUES (1870, 0, 3, 9.46, 94, 10);
INSERT INTO public.europe_data VALUES (1871, 0, 8, 24.62, 95, 10);
INSERT INTO public.europe_data VALUES (1872, 0, 2, 2.71, 96, 10);
INSERT INTO public.europe_data VALUES (1873, 3, 203, 1143.59, 192, 10);
INSERT INTO public.europe_data VALUES (1874, 0, 10, 9.3, 41, 10);
INSERT INTO public.europe_data VALUES (1875, 81, 1585, 10.08, 134, 10);
INSERT INTO public.europe_data VALUES (1876, 5, 402, 3.65, 42, 10);
INSERT INTO public.europe_data VALUES (1877, 400, 50438, 1414.92, 193, 10);
INSERT INTO public.europe_data VALUES (1878, 0, 11, 18.42, 43, 10);
INSERT INTO public.europe_data VALUES (1879, 0, 15, 0.27, 44, 10);
INSERT INTO public.europe_data VALUES (1880, 0, 47, 1.72, 135, 10);
INSERT INTO public.europe_data VALUES (1881, 1, 75, 316.12, 97, 10);
INSERT INTO public.europe_data VALUES (1882, 180, 10998, 375.93, 194, 10);
INSERT INTO public.europe_data VALUES (1883, 331, 10424, 985, 195, 10);
INSERT INTO public.europe_data VALUES (1884, 0, 0, 0.15, 212, 10);
INSERT INTO public.europe_data VALUES (1885, 8, 80, 0.52, 45, 10);
INSERT INTO public.europe_data VALUES (1886, 729, 26863, 80.07, 46, 10);
INSERT INTO public.europe_data VALUES (1887, 23, 3960, 13.97, 136, 10);
INSERT INTO public.europe_data VALUES (1888, 1, 72, 1.21, 47, 10);
INSERT INTO public.europe_data VALUES (1889, 1577, 54141, 255.05, 196, 10);
INSERT INTO public.europe_data VALUES (1890, 24, 4393, 36.14, 137, 10);
INSERT INTO public.europe_data VALUES (1891, 54, 1841, 8.48, 48, 10);
INSERT INTO public.europe_data VALUES (1892, 0, 12, 4.82, 98, 10);
INSERT INTO public.europe_data VALUES (1893, 476, 36841, 707.71, 197, 10);
INSERT INTO public.europe_data VALUES (1894, 596, 26084, 627.51, 198, 10);
INSERT INTO public.europe_data VALUES (1895, 34, 606, 6.9, 138, 10);
INSERT INTO public.europe_data VALUES (1896, 0, 41, 0.41, 139, 10);
INSERT INTO public.europe_data VALUES (1897, 1, 273, 5.73, 140, 10);
INSERT INTO public.europe_data VALUES (1898, 0, 130, 0.28, 141, 10);
INSERT INTO public.europe_data VALUES (1899, 0, 1, 0.08, 142, 10);
INSERT INTO public.europe_data VALUES (1900, 1, 133, 3.12, 49, 10);
INSERT INTO public.europe_data VALUES (1901, 2, 107, 22.72, 99, 10);
INSERT INTO public.europe_data VALUES (1902, 342, 7751, 130.75, 50, 10);
INSERT INTO public.europe_data VALUES (1903, 1342, 220667, 463.55, 199, 10);
INSERT INTO public.europe_data VALUES (1904, 0, 8, 26.18, 100, 10);
INSERT INTO public.europe_data VALUES (1905, 5, 2354, 10.24, 51, 10);
INSERT INTO public.europe_data VALUES (1906, 1375, 90627, 456.07, 200, 10);
INSERT INTO public.europe_data VALUES (1907, 22, 8676, 178.49, 143, 10);
INSERT INTO public.europe_data VALUES (1908, 3000, 105915, 316.89, 201, 10);
INSERT INTO public.europe_data VALUES (1909, 0, 0, 0, 52, 10);
INSERT INTO public.europe_data VALUES (1910, 15437, 1373677, 762.79, 101, 10);
INSERT INTO public.europe_data VALUES (1911, 0, 105, 138.65, 102, 10);
INSERT INTO public.europe_data VALUES (1912, 6, 1587, 75.22, 103, 10);
INSERT INTO public.europe_data VALUES (1913, 3, 1183, 7.39, 144, 10);
INSERT INTO public.europe_data VALUES (1914, 0, 0, 0, 213, 10);
INSERT INTO public.europe_data VALUES (1915, 25, 2402, 16.16, 104, 10);
INSERT INTO public.europe_data VALUES (1916, 0, 23, 0.06, 145, 10);
INSERT INTO public.europe_data VALUES (1917, 0, 0, 0, 214, 10);
INSERT INTO public.europe_data VALUES (1918, 0, 0, 0, 53, 10);
INSERT INTO public.europe_data VALUES (1919, 1, 0, 0.03, 146, 10);
INSERT INTO public.europe_data VALUES (1920, 7, 308, 2.75, 54, 10);
INSERT INTO public.europe_data VALUES (1921, 15, 768, 10.23, 55, 10);
INSERT INTO public.europe_data VALUES (1922, 68, 1073, 6.42, 105, 11);
INSERT INTO public.europe_data VALUES (1923, 99, 4864, 342.19, 147, 11);
INSERT INTO public.europe_data VALUES (1924, 135, 7359, 33.78, 1, 11);
INSERT INTO public.europe_data VALUES (1925, 0, 456, 1102.7, 148, 11);
INSERT INTO public.europe_data VALUES (1926, 9, 610, 5.43, 2, 11);
INSERT INTO public.europe_data VALUES (1927, 0, 0, 6.72, 56, 11);
INSERT INTO public.europe_data VALUES (1928, 0, 2, 7.21, 57, 11);
INSERT INTO public.europe_data VALUES (1929, 1471, 48444, 241.89, 58, 11);
INSERT INTO public.europe_data VALUES (1930, 188, 8415, 582.81, 149, 11);
INSERT INTO public.europe_data VALUES (1931, 0, 107, 165.55, 59, 11);
INSERT INTO public.europe_data VALUES (1932, 0, 72, 0.67, 202, 11);
INSERT INTO public.europe_data VALUES (1933, 705, 32058, 843.1, 150, 11);
INSERT INTO public.europe_data VALUES (1934, 230, 25101, 423.05, 151, 11);
INSERT INTO public.europe_data VALUES (1935, 0, 83, 79.59, 60, 11);
INSERT INTO public.europe_data VALUES (1936, 3, 1082, 126.98, 106, 11);
INSERT INTO public.europe_data VALUES (1937, 221, 15066, 18.45, 107, 11);
INSERT INTO public.europe_data VALUES (1938, 0, 16, 8.71, 61, 11);
INSERT INTO public.europe_data VALUES (1939, 55, 11009, 220.29, 152, 11);
INSERT INTO public.europe_data VALUES (1940, 874, 16253, 336.6, 153, 11);
INSERT INTO public.europe_data VALUES (1941, 31, 560, 225.95, 62, 11);
INSERT INTO public.europe_data VALUES (1942, 0, 58, 1.1, 3, 11);
INSERT INTO public.europe_data VALUES (1943, 0, 24, 46.39, 63, 11);
INSERT INTO public.europe_data VALUES (1944, 0, 14, 2.75, 108, 11);
INSERT INTO public.europe_data VALUES (1945, 48, 700, 11.95, 64, 11);
INSERT INTO public.europe_data VALUES (1946, 0, 0, 23.09, 65, 11);
INSERT INTO public.europe_data VALUES (1947, 344, 7367, 499.06, 154, 11);
INSERT INTO public.europe_data VALUES (1948, 0, 398, 76.7, 4, 11);
INSERT INTO public.europe_data VALUES (1949, 3650, 243339, 214, 66, 11);
INSERT INTO public.europe_data VALUES (1950, 0, 1, 3.33, 67, 11);
INSERT INTO public.europe_data VALUES (1951, 0, 2, 0.46, 109, 11);
INSERT INTO public.europe_data VALUES (1952, 934, 20666, 631.93, 155, 11);
INSERT INTO public.europe_data VALUES (1953, 0, 121, 1.06, 5, 11);
INSERT INTO public.europe_data VALUES (1954, 0, 19, 0.46, 6, 11);
INSERT INTO public.europe_data VALUES (1955, 0, 17, 0.13, 110, 11);
INSERT INTO public.europe_data VALUES (1956, 2, 589, 5.51, 7, 11);
INSERT INTO public.europe_data VALUES (1957, 577, 39775, 198.34, 68, 11);
INSERT INTO public.europe_data VALUES (1958, 0, 250, 128.01, 8, 11);
INSERT INTO public.europe_data VALUES (1959, 0, 13, 30.79, 69, 11);
INSERT INTO public.europe_data VALUES (1960, 0, 2, 0.27, 9, 11);
INSERT INTO public.europe_data VALUES (1961, 0, 40, 0.53, 10, 11);
INSERT INTO public.europe_data VALUES (1962, 287, 9790, 101.08, 70, 11);
INSERT INTO public.europe_data VALUES (1963, 0, 83, 0.01, 111, 11);
INSERT INTO public.europe_data VALUES (1964, 1297, 59959, 217.78, 71, 11);
INSERT INTO public.europe_data VALUES (1965, 0, 15, 3.76, 11, 11);
INSERT INTO public.europe_data VALUES (1966, 2, 142, 7.34, 12, 11);
INSERT INTO public.europe_data VALUES (1967, 82, 7675, 274.79, 72, 11);
INSERT INTO public.europe_data VALUES (1968, 0, 172, 1.3, 13, 11);
INSERT INTO public.europe_data VALUES (1969, 359, 22894, 1040.32, 156, 11);
INSERT INTO public.europe_data VALUES (1970, 2, 387, 5.67, 73, 11);
INSERT INTO public.europe_data VALUES (1971, 1, 615, 626.59, 74, 11);
INSERT INTO public.europe_data VALUES (1972, 4, 1740, 365.91, 157, 11);
INSERT INTO public.europe_data VALUES (1973, 942, 27460, 559.7, 158, 11);
INSERT INTO public.europe_data VALUES (1974, 5, 462, 1.05, 14, 11);
INSERT INTO public.europe_data VALUES (1975, 45, 8867, 296.52, 159, 11);
INSERT INTO public.europe_data VALUES (1976, 0, 9, 2.88, 15, 11);
INSERT INTO public.europe_data VALUES (1977, 0, 8, 23.67, 75, 11);
INSERT INTO public.europe_data VALUES (1978, 20, 5063, 90.78, 76, 11);
INSERT INTO public.europe_data VALUES (1979, 222, 6474, 68.05, 77, 11);
INSERT INTO public.europe_data VALUES (1980, 88, 2514, 4.76, 16, 11);
INSERT INTO public.europe_data VALUES (1981, 33, 843, 31.72, 78, 11);
INSERT INTO public.europe_data VALUES (1982, 0, 23, 3.61, 17, 11);
INSERT INTO public.europe_data VALUES (1983, 0, 26, 2.4, 18, 11);
INSERT INTO public.europe_data VALUES (1984, 24, 2328, 333.25, 160, 11);
INSERT INTO public.europe_data VALUES (1985, 1, 191, 27.44, 19, 11);
INSERT INTO public.europe_data VALUES (1986, 53, 3749, 6.08, 20, 11);
INSERT INTO public.europe_data VALUES (1987, 0, 1, 59.31, 79, 11);
INSERT INTO public.europe_data VALUES (1988, 0, 2, 8.22, 161, 11);
INSERT INTO public.europe_data VALUES (1989, 0, 7, 0.79, 203, 11);
INSERT INTO public.europe_data VALUES (1990, 18, 2990, 96.3, 162, 11);
INSERT INTO public.europe_data VALUES (1991, 3593, 78275, 353.15, 163, 11);
INSERT INTO public.europe_data VALUES (1992, 10, 1118, 855.76, 204, 11);
INSERT INTO public.europe_data VALUES (1993, 0, 60, 5.94, 21, 11);
INSERT INTO public.europe_data VALUES (1994, 0, 8, 1.36, 22, 11);
INSERT INTO public.europe_data VALUES (1995, 255, 26894, 1319.79, 164, 11);
INSERT INTO public.europe_data VALUES (1996, 2136, 124736, 304.2, 165, 11);
INSERT INTO public.europe_data VALUES (1997, 0, 695, 4.75, 23, 11);
INSERT INTO public.europe_data VALUES (1998, 1, 56, 332.29, 166, 11);
INSERT INTO public.europe_data VALUES (1999, 691, 12608, 279.94, 167, 11);
INSERT INTO public.europe_data VALUES (2000, 0, 0, 1.76, 80, 11);
INSERT INTO public.europe_data VALUES (2001, 0, 0, 8.04, 81, 11);
INSERT INTO public.europe_data VALUES (2002, 6, 269, 416.63, 205, 11);
INSERT INTO public.europe_data VALUES (2003, 90, 3342, 40.3, 82, 11);
INSERT INTO public.europe_data VALUES (2004, 0, 3, 6.2, 168, 11);
INSERT INTO public.europe_data VALUES (2005, 1, 213, 3.35, 24, 11);
INSERT INTO public.europe_data VALUES (2006, 0, 1, 0.16, 25, 11);
INSERT INTO public.europe_data VALUES (2007, 7, 243, 70.65, 83, 11);
INSERT INTO public.europe_data VALUES (2008, 0, 50, 0.75, 84, 11);
INSERT INTO public.europe_data VALUES (2009, 0, 0, 0, 169, 11);
INSERT INTO public.europe_data VALUES (2010, 52, 3453, 49.11, 85, 11);
INSERT INTO public.europe_data VALUES (2011, 932, 39170, 712.86, 170, 11);
INSERT INTO public.europe_data VALUES (2012, 0, 104, 53.78, 171, 11);
INSERT INTO public.europe_data VALUES (2013, 3401, 291826, 42.93, 112, 11);
INSERT INTO public.europe_data VALUES (2014, 931, 36598, 24.81, 113, 11);
INSERT INTO public.europe_data VALUES (2015, 3073, 94388, 225.15, 114, 11);
INSERT INTO public.europe_data VALUES (2016, 266, 15114, 79.58, 115, 11);
INSERT INTO public.europe_data VALUES (2017, 30, 1780, 88.45, 172, 11);
INSERT INTO public.europe_data VALUES (2018, 0, 1, 7.09, 173, 11);
INSERT INTO public.europe_data VALUES (2019, 58, 6577, 139.04, 116, 11);
INSERT INTO public.europe_data VALUES (2020, 5081, 176310, 673.71, 174, 11);
INSERT INTO public.europe_data VALUES (2021, 18, 425, 27.98, 86, 11);
INSERT INTO public.europe_data VALUES (2022, 139, 15843, 23.71, 117, 11);
INSERT INTO public.europe_data VALUES (2023, 0, 117, 181.82, 175, 11);
INSERT INTO public.europe_data VALUES (2024, 458, 30878, 699.18, 118, 11);
INSERT INTO public.europe_data VALUES (2025, 61, 6421, 67.69, 119, 11);
INSERT INTO public.europe_data VALUES (2026, 72, 5944, 24.86, 26, 11);
INSERT INTO public.europe_data VALUES (2027, 91, 4762, 552.68, 176, 11);
INSERT INTO public.europe_data VALUES (2028, 12, 2370, 132.78, 120, 11);
INSERT INTO public.europe_data VALUES (2029, 34, 2922, 90.78, 121, 11);
INSERT INTO public.europe_data VALUES (2030, 0, 15, 0.21, 122, 11);
INSERT INTO public.europe_data VALUES (2031, 44, 3855, 334.8, 177, 11);
INSERT INTO public.europe_data VALUES (2032, 104, 10468, 313.81, 123, 11);
INSERT INTO public.europe_data VALUES (2033, 0, 24, 3.2, 27, 11);
INSERT INTO public.europe_data VALUES (2034, 1, 44, 1.78, 28, 11);
INSERT INTO public.europe_data VALUES (2035, 77, 4607, 130.26, 29, 11);
INSERT INTO public.europe_data VALUES (2036, 7, 161, 750.43, 178, 11);
INSERT INTO public.europe_data VALUES (2037, 120, 14278, 950.8, 179, 11);
INSERT INTO public.europe_data VALUES (2038, 44, 3640, 1210.14, 180, 11);
INSERT INTO public.europe_data VALUES (2039, 0, 0, 0.4, 30, 11);
INSERT INTO public.europe_data VALUES (2040, 0, 22, 0.32, 31, 11);
INSERT INTO public.europe_data VALUES (2041, 22, 9710, 53.42, 124, 11);
INSERT INTO public.europe_data VALUES (2042, 0, 386, 148.79, 125, 11);
INSERT INTO public.europe_data VALUES (2043, 6, 453, 4.02, 32, 11);
INSERT INTO public.europe_data VALUES (2044, 25, 869, 351.73, 181, 11);
INSERT INTO public.europe_data VALUES (2045, 0, 0, 5.1, 206, 11);
INSERT INTO public.europe_data VALUES (2046, 6, 453, 14.67, 33, 11);
INSERT INTO public.europe_data VALUES (2047, 0, 7, 1.81, 34, 11);
INSERT INTO public.europe_data VALUES (2048, 3979, 65196, 78.82, 87, 11);
INSERT INTO public.europe_data VALUES (2049, 141, 9076, 438.71, 182, 11);
INSERT INTO public.europe_data VALUES (2050, 0, 26, 181.35, 183, 11);
INSERT INTO public.europe_data VALUES (2051, 0, 151, 11.16, 126, 11);
INSERT INTO public.europe_data VALUES (2052, 48, 3819, 1238.22, 184, 11);
INSERT INTO public.europe_data VALUES (2053, 0, 0, 0, 88, 11);
INSERT INTO public.europe_data VALUES (2054, 533, 32841, 166.23, 35, 11);
INSERT INTO public.europe_data VALUES (2055, 6, 576, 3.84, 36, 11);
INSERT INTO public.europe_data VALUES (2056, 179, 10240, 37.92, 127, 11);
INSERT INTO public.europe_data VALUES (2057, 6, 480, 33.55, 37, 11);
INSERT INTO public.europe_data VALUES (2058, 158, 11670, 77.61, 128, 11);
INSERT INTO public.europe_data VALUES (2059, 457, 34213, 410.47, 185, 11);
INSERT INTO public.europe_data VALUES (2060, 0, 0, 0.71, 208, 11);
INSERT INTO public.europe_data VALUES (2061, 0, 26, 1.15, 209, 11);
INSERT INTO public.europe_data VALUES (2062, 1, 59, 1.88, 89, 11);
INSERT INTO public.europe_data VALUES (2063, 0, 148, 0.9, 38, 11);
INSERT INTO public.europe_data VALUES (2064, 6, 1029, 1.13, 39, 11);
INSERT INTO public.europe_data VALUES (2065, 220, 6800, 697.74, 186, 11);
INSERT INTO public.europe_data VALUES (2066, 0, 2, 6.99, 210, 11);
INSERT INTO public.europe_data VALUES (2067, 22, 3309, 141.15, 187, 11);
INSERT INTO public.europe_data VALUES (2068, 38, 1403, 62.21, 129, 11);
INSERT INTO public.europe_data VALUES (2069, 329, 21095, 18, 130, 11);
INSERT INTO public.europe_data VALUES (2070, 93, 12448, 430.84, 131, 11);
INSERT INTO public.europe_data VALUES (2071, 103, 9946, 425.67, 90, 11);
INSERT INTO public.europe_data VALUES (2072, 0, 51, 0.63, 211, 11);
INSERT INTO public.europe_data VALUES (2073, 86, 5430, 146.66, 91, 11);
INSERT INTO public.europe_data VALUES (2074, 328, 12860, 78.49, 92, 11);
INSERT INTO public.europe_data VALUES (2075, 250, 11046, 20.37, 132, 11);
INSERT INTO public.europe_data VALUES (2076, 3411, 123744, 716.57, 188, 11);
INSERT INTO public.europe_data VALUES (2077, 530, 34041, 754.12, 189, 11);
INSERT INTO public.europe_data VALUES (2078, 77, 5671, 428.55, 93, 11);
INSERT INTO public.europe_data VALUES (2079, 1, 1419, 101.09, 133, 11);
INSERT INTO public.europe_data VALUES (2080, 1146, 52891, 573.05, 190, 11);
INSERT INTO public.europe_data VALUES (2081, 3348, 179987, 235.47, 191, 11);
INSERT INTO public.europe_data VALUES (2082, 1, 254, 3.67, 40, 11);
INSERT INTO public.europe_data VALUES (2083, 0, 2, 5.68, 94, 11);
INSERT INTO public.europe_data VALUES (2084, 0, 37, 47.05, 95, 11);
INSERT INTO public.europe_data VALUES (2085, 0, 1, 6.33, 96, 11);
INSERT INTO public.europe_data VALUES (2086, 2, 191, 966.53, 192, 11);
INSERT INTO public.europe_data VALUES (2087, 0, 10, 11.16, 41, 11);
INSERT INTO public.europe_data VALUES (2088, 104, 1870, 11.3, 134, 11);
INSERT INTO public.europe_data VALUES (2089, 3, 193, 1.73, 42, 11);
INSERT INTO public.europe_data VALUES (2090, 350, 48094, 1215.52, 193, 11);
INSERT INTO public.europe_data VALUES (2091, 0, 7, 15.35, 43, 11);
INSERT INTO public.europe_data VALUES (2092, 0, 6, 0.26, 44, 11);
INSERT INTO public.europe_data VALUES (2093, 1, 53, 1.62, 135, 11);
INSERT INTO public.europe_data VALUES (2094, 0, 59, 313.76, 97, 11);
INSERT INTO public.europe_data VALUES (2095, 145, 9492, 347.97, 194, 11);
INSERT INTO public.europe_data VALUES (2096, 264, 10073, 977.41, 195, 11);
INSERT INTO public.europe_data VALUES (2097, 0, 1, 0.15, 212, 11);
INSERT INTO public.europe_data VALUES (2098, 0, 0, 0.93, 45, 11);
INSERT INTO public.europe_data VALUES (2099, 574, 20023, 62.64, 46, 11);
INSERT INTO public.europe_data VALUES (2100, 17, 3197, 10.6, 136, 11);
INSERT INTO public.europe_data VALUES (2101, 1, 62, 0.96, 47, 11);
INSERT INTO public.europe_data VALUES (2102, 1938, 65571, 322.4, 196, 11);
INSERT INTO public.europe_data VALUES (2103, 29, 3313, 29.06, 137, 11);
INSERT INTO public.europe_data VALUES (2104, 48, 1788, 7.01, 48, 11);
INSERT INTO public.europe_data VALUES (2105, 1, 16, 6.54, 98, 11);
INSERT INTO public.europe_data VALUES (2106, 418, 35559, 659.85, 197, 11);
INSERT INTO public.europe_data VALUES (2107, 669, 27534, 711.93, 198, 11);
INSERT INTO public.europe_data VALUES (2108, 37, 572, 6.52, 138, 11);
INSERT INTO public.europe_data VALUES (2109, 0, 57, 0.3, 139, 11);
INSERT INTO public.europe_data VALUES (2110, 0, 261, 5.85, 140, 11);
INSERT INTO public.europe_data VALUES (2111, 0, 64, 0.15, 141, 11);
INSERT INTO public.europe_data VALUES (2112, 0, 0, 0, 142, 11);
INSERT INTO public.europe_data VALUES (2113, 0, 119, 3.55, 49, 11);
INSERT INTO public.europe_data VALUES (2114, 5, 210, 41.58, 99, 11);
INSERT INTO public.europe_data VALUES (2115, 398, 7540, 135.51, 50, 11);
INSERT INTO public.europe_data VALUES (2116, 1200, 159462, 291.6, 199, 11);
INSERT INTO public.europe_data VALUES (2117, 0, 2, 73.31, 100, 11);
INSERT INTO public.europe_data VALUES (2118, 29, 2177, 9.32, 51, 11);
INSERT INTO public.europe_data VALUES (2119, 1400, 110014, 424.66, 200, 11);
INSERT INTO public.europe_data VALUES (2120, 18, 8763, 178.17, 143, 11);
INSERT INTO public.europe_data VALUES (2121, 3494, 105282, 372.12, 201, 11);
INSERT INTO public.europe_data VALUES (2122, 0, 0, 0, 52, 11);
INSERT INTO public.europe_data VALUES (2123, 10091, 1136412, 713.01, 101, 11);
INSERT INTO public.europe_data VALUES (2124, 0, 40, 105.18, 102, 11);
INSERT INTO public.europe_data VALUES (2125, 5, 1017, 48.7, 103, 11);
INSERT INTO public.europe_data VALUES (2126, 5, 1253, 7.97, 144, 11);
INSERT INTO public.europe_data VALUES (2127, 0, 0, 0, 213, 11);
INSERT INTO public.europe_data VALUES (2128, 23, 2205, 16.44, 104, 11);
INSERT INTO public.europe_data VALUES (2129, 0, 37, 0.06, 145, 11);
INSERT INTO public.europe_data VALUES (2130, 0, 1, 0, 214, 11);
INSERT INTO public.europe_data VALUES (2131, 0, 0, 0, 53, 11);
INSERT INTO public.europe_data VALUES (2132, 1, 8, 0.03, 146, 11);
INSERT INTO public.europe_data VALUES (2133, 0, 184, 2.72, 54, 11);
INSERT INTO public.europe_data VALUES (2134, 8, 730, 7.95, 55, 11);
INSERT INTO public.europe_data VALUES (2135, 69, 1368, 6.66, 105, 12);
INSERT INTO public.europe_data VALUES (2136, 76, 4931, 298.87, 147, 12);
INSERT INTO public.europe_data VALUES (2137, 121, 7183, 29.76, 1, 12);
INSERT INTO public.europe_data VALUES (2138, 0, 384, 1146.02, 148, 12);
INSERT INTO public.europe_data VALUES (2139, 15, 1119, 6.78, 2, 12);
INSERT INTO public.europe_data VALUES (2140, 0, 1, 6.72, 56, 12);
INSERT INTO public.europe_data VALUES (2141, 0, 5, 8.24, 57, 12);
INSERT INTO public.europe_data VALUES (2142, 1566, 59874, 286.24, 58, 12);
INSERT INTO public.europe_data VALUES (2143, 188, 8823, 650.6, 149, 12);
INSERT INTO public.europe_data VALUES (2144, 1, 69, 123.22, 59, 12);
INSERT INTO public.europe_data VALUES (2145, 0, 96, 0.65, 202, 12);
INSERT INTO public.europe_data VALUES (2146, 520, 42630, 1056.76, 150, 12);
INSERT INTO public.europe_data VALUES (2147, 164, 17406, 275.52, 151, 12);
INSERT INTO public.europe_data VALUES (2148, 7, 227, 119.64, 60, 12);
INSERT INTO public.europe_data VALUES (2149, 3, 1002, 137.04, 106, 12);
INSERT INTO public.europe_data VALUES (2150, 194, 15008, 16.62, 107, 12);
INSERT INTO public.europe_data VALUES (2151, 0, 9, 5.92, 61, 12);
INSERT INTO public.europe_data VALUES (2152, 50, 9814, 187.47, 152, 12);
INSERT INTO public.europe_data VALUES (2153, 1123, 22306, 491.19, 153, 12);
INSERT INTO public.europe_data VALUES (2154, 26, 322, 257.97, 62, 12);
INSERT INTO public.europe_data VALUES (2155, 0, 72, 1.45, 3, 12);
INSERT INTO public.europe_data VALUES (2156, 0, 5, 28.8, 63, 12);
INSERT INTO public.europe_data VALUES (2157, 0, 7, 3.01, 108, 12);
INSERT INTO public.europe_data VALUES (2158, 55, 676, 12.57, 64, 12);
INSERT INTO public.europe_data VALUES (2159, 0, 6, 26.94, 65, 12);
INSERT INTO public.europe_data VALUES (2160, 419, 9107, 532.69, 154, 12);
INSERT INTO public.europe_data VALUES (2161, 4, 1369, 76.36, 4, 12);
INSERT INTO public.europe_data VALUES (2162, 3385, 208308, 192.98, 66, 12);
INSERT INTO public.europe_data VALUES (2163, 0, 0, 0, 67, 12);
INSERT INTO public.europe_data VALUES (2164, 0, 0, 0, 109, 12);
INSERT INTO public.europe_data VALUES (2165, 750, 23569, 666.57, 155, 12);
INSERT INTO public.europe_data VALUES (2166, 0, 94, 0.82, 5, 12);
INSERT INTO public.europe_data VALUES (2167, 0, 34, 0.42, 6, 12);
INSERT INTO public.europe_data VALUES (2168, 0, 4, 0.05, 110, 12);
INSERT INTO public.europe_data VALUES (2169, 2, 836, 4.28, 7, 12);
INSERT INTO public.europe_data VALUES (2170, 502, 34426, 177.46, 68, 12);
INSERT INTO public.europe_data VALUES (2171, 1, 454, 164.93, 8, 12);
INSERT INTO public.europe_data VALUES (2172, 1, 7, 16.94, 69, 12);
INSERT INTO public.europe_data VALUES (2173, 0, 11, 0.67, 9, 12);
INSERT INTO public.europe_data VALUES (2174, 0, 45, 0.6, 10, 12);
INSERT INTO public.europe_data VALUES (2175, 250, 9367, 100.69, 70, 12);
INSERT INTO public.europe_data VALUES (2176, 0, 95, 0.01, 111, 12);
INSERT INTO public.europe_data VALUES (2177, 1256, 49671, 207.65, 71, 12);
INSERT INTO public.europe_data VALUES (2178, 0, 17, 3.88, 11, 12);
INSERT INTO public.europe_data VALUES (2179, 0, 253, 4.7, 12, 12);
INSERT INTO public.europe_data VALUES (2180, 62, 6195, 258.64, 72, 12);
INSERT INTO public.europe_data VALUES (2181, 3, 162, 1.19, 13, 12);
INSERT INTO public.europe_data VALUES (2182, 304, 19512, 894.72, 156, 12);
INSERT INTO public.europe_data VALUES (2183, 1, 256, 4.84, 73, 12);
INSERT INTO public.europe_data VALUES (2184, 1, 409, 398.96, 74, 12);
INSERT INTO public.europe_data VALUES (2185, 4, 1465, 303.23, 157, 12);
INSERT INTO public.europe_data VALUES (2186, 988, 32147, 727.1, 158, 12);
INSERT INTO public.europe_data VALUES (2187, 8, 450, 0.73, 14, 12);
INSERT INTO public.europe_data VALUES (2188, 24, 8349, 264.62, 159, 12);
INSERT INTO public.europe_data VALUES (2189, 0, 19, 6.16, 15, 12);
INSERT INTO public.europe_data VALUES (2190, 0, 9, 48.74, 75, 12);
INSERT INTO public.europe_data VALUES (2191, 25, 4686, 76.62, 76, 12);
INSERT INTO public.europe_data VALUES (2192, 193, 5348, 61.79, 77, 12);
INSERT INTO public.europe_data VALUES (2193, 95, 2260, 3.81, 16, 12);
INSERT INTO public.europe_data VALUES (2194, 34, 1204, 37.45, 78, 12);
INSERT INTO public.europe_data VALUES (2195, 0, 26, 2.8, 17, 12);
INSERT INTO public.europe_data VALUES (2196, 0, 58, 1.72, 18, 12);
INSERT INTO public.europe_data VALUES (2197, 7, 2087, 271.66, 160, 12);
INSERT INTO public.europe_data VALUES (2198, 1, 124, 18.81, 19, 12);
INSERT INTO public.europe_data VALUES (2199, 78, 3065, 5.45, 20, 12);
INSERT INTO public.europe_data VALUES (2200, 0, 1, 88.97, 79, 12);
INSERT INTO public.europe_data VALUES (2201, 0, 2, 6.16, 161, 12);
INSERT INTO public.europe_data VALUES (2202, 0, 0, 0.11, 203, 12);
INSERT INTO public.europe_data VALUES (2203, 6, 2324, 69.63, 162, 12);
INSERT INTO public.europe_data VALUES (2204, 4184, 158381, 526.59, 163, 12);
INSERT INTO public.europe_data VALUES (2205, 10, 1272, 1068.08, 204, 12);
INSERT INTO public.europe_data VALUES (2206, 1, 69, 5.02, 21, 12);
INSERT INTO public.europe_data VALUES (2207, 1, 24, 1.79, 22, 12);
INSERT INTO public.europe_data VALUES (2208, 279, 25855, 1201.22, 164, 12);
INSERT INTO public.europe_data VALUES (2209, 1565, 127806, 309.89, 165, 12);
INSERT INTO public.europe_data VALUES (2210, 1, 751, 5.5, 23, 12);
INSERT INTO public.europe_data VALUES (2211, 3, 56, 489.53, 166, 12);
INSERT INTO public.europe_data VALUES (2212, 524, 17414, 325.62, 167, 12);
INSERT INTO public.europe_data VALUES (2213, 0, 1, 1.76, 80, 12);
INSERT INTO public.europe_data VALUES (2214, 0, 9, 8.04, 81, 12);
INSERT INTO public.europe_data VALUES (2215, 8, 428, 786.63, 205, 12);
INSERT INTO public.europe_data VALUES (2216, 144, 3744, 41.9, 82, 12);
INSERT INTO public.europe_data VALUES (2217, 0, 1, 6.2, 168, 12);
INSERT INTO public.europe_data VALUES (2218, 0, 215, 3.13, 24, 12);
INSERT INTO public.europe_data VALUES (2219, 0, 2, 0.42, 25, 12);
INSERT INTO public.europe_data VALUES (2220, 4, 310, 79.08, 83, 12);
INSERT INTO public.europe_data VALUES (2221, 0, 35, 0.77, 84, 12);
INSERT INTO public.europe_data VALUES (2222, 0, 0, 0, 169, 12);
INSERT INTO public.europe_data VALUES (2223, 34, 1333, 40.29, 85, 12);
INSERT INTO public.europe_data VALUES (2224, 701, 30496, 646.43, 170, 12);
INSERT INTO public.europe_data VALUES (2225, 1, 88, 55.74, 171, 12);
INSERT INTO public.europe_data VALUES (2226, 3668, 294738, 42.9, 112, 12);
INSERT INTO public.europe_data VALUES (2227, 673, 30555, 22.15, 113, 12);
INSERT INTO public.europe_data VALUES (2228, 3309, 92293, 207.29, 114, 12);
INSERT INTO public.europe_data VALUES (2229, 288, 16169, 93.54, 115, 12);
INSERT INTO public.europe_data VALUES (2230, 43, 2558, 103.32, 172, 12);
INSERT INTO public.europe_data VALUES (2231, 0, 5, 13, 173, 12);
INSERT INTO public.europe_data VALUES (2232, 74, 5268, 115.51, 116, 12);
INSERT INTO public.europe_data VALUES (2233, 4594, 230339, 784.9, 174, 12);
INSERT INTO public.europe_data VALUES (2234, 7, 400, 26.39, 86, 12);
INSERT INTO public.europe_data VALUES (2235, 97, 14240, 18, 117, 12);
INSERT INTO public.europe_data VALUES (2236, 0, 79, 155.85, 175, 12);
INSERT INTO public.europe_data VALUES (2237, 464, 39751, 733.62, 118, 12);
INSERT INTO public.europe_data VALUES (2238, 53, 6137, 62.04, 119, 12);
INSERT INTO public.europe_data VALUES (2239, 111, 7127, 28.31, 26, 12);
INSERT INTO public.europe_data VALUES (2240, 92, 5178, 563.8, 176, 12);
INSERT INTO public.europe_data VALUES (2241, 28, 3216, 197.6, 120, 12);
INSERT INTO public.europe_data VALUES (2242, 34, 2902, 101.23, 121, 12);
INSERT INTO public.europe_data VALUES (2243, 0, 0, 0, 122, 12);
INSERT INTO public.europe_data VALUES (2244, 30, 2573, 261.72, 177, 12);
INSERT INTO public.europe_data VALUES (2245, 83, 11046, 324.4, 123, 12);
INSERT INTO public.europe_data VALUES (2246, 0, 44, 5.55, 27, 12);
INSERT INTO public.europe_data VALUES (2247, 0, 44, 2.21, 28, 12);
INSERT INTO public.europe_data VALUES (2248, 72, 4221, 143.21, 29, 12);
INSERT INTO public.europe_data VALUES (2249, 4, 127, 844.23, 178, 12);
INSERT INTO public.europe_data VALUES (2250, 109, 12289, 799.8, 179, 12);
INSERT INTO public.europe_data VALUES (2251, 40, 3789, 1279.05, 180, 12);
INSERT INTO public.europe_data VALUES (2252, 2, 108, 0.44, 30, 12);
INSERT INTO public.europe_data VALUES (2253, 0, 38, 0.28, 31, 12);
INSERT INTO public.europe_data VALUES (2254, 26, 7358, 45.59, 124, 12);
INSERT INTO public.europe_data VALUES (2255, 3, 404, 117.15, 125, 12);
INSERT INTO public.europe_data VALUES (2256, 4, 338, 2.7, 32, 12);
INSERT INTO public.europe_data VALUES (2257, 15, 867, 356.8, 181, 12);
INSERT INTO public.europe_data VALUES (2258, 0, 3, 5.1, 206, 12);
INSERT INTO public.europe_data VALUES (2259, 4, 211, 6.41, 33, 12);
INSERT INTO public.europe_data VALUES (2260, 0, 16, 3.31, 34, 12);
INSERT INTO public.europe_data VALUES (2261, 3134, 35353, 58.04, 87, 12);
INSERT INTO public.europe_data VALUES (2262, 130, 8662, 385.7, 182, 12);
INSERT INTO public.europe_data VALUES (2263, 1, 34, 290.16, 183, 12);
INSERT INTO public.europe_data VALUES (2264, 0, 209, 8.43, 126, 12);
INSERT INTO public.europe_data VALUES (2265, 48, 3885, 1327.1, 184, 12);
INSERT INTO public.europe_data VALUES (2266, 0, 0, 0, 88, 12);
INSERT INTO public.europe_data VALUES (2267, 477, 27785, 175.97, 35, 12);
INSERT INTO public.europe_data VALUES (2268, 11, 589, 4.18, 36, 12);
INSERT INTO public.europe_data VALUES (2269, 162, 10252, 33.06, 127, 12);
INSERT INTO public.europe_data VALUES (2270, 7, 357, 26.22, 37, 12);
INSERT INTO public.europe_data VALUES (2271, 100, 10532, 90.37, 128, 12);
INSERT INTO public.europe_data VALUES (2272, 404, 36725, 431.01, 185, 12);
INSERT INTO public.europe_data VALUES (2273, 0, 2, 1.06, 208, 12);
INSERT INTO public.europe_data VALUES (2274, 0, 29, 0.92, 209, 12);
INSERT INTO public.europe_data VALUES (2275, 1, 64, 2.05, 89, 12);
INSERT INTO public.europe_data VALUES (2276, 0, 61, 0.54, 38, 12);
INSERT INTO public.europe_data VALUES (2277, 4, 1235, 1.14, 39, 12);
INSERT INTO public.europe_data VALUES (2278, 206, 7693, 721.33, 186, 12);
INSERT INTO public.europe_data VALUES (2279, 0, 2, 6.99, 210, 12);
INSERT INTO public.europe_data VALUES (2280, 12, 4212, 154.14, 187, 12);
INSERT INTO public.europe_data VALUES (2281, 42, 1692, 79.22, 129, 12);
INSERT INTO public.europe_data VALUES (2282, 536, 17897, 14.82, 130, 12);
INSERT INTO public.europe_data VALUES (2283, 74, 9014, 284.64, 131, 12);
INSERT INTO public.europe_data VALUES (2284, 84, 8130, 359.27, 90, 12);
INSERT INTO public.europe_data VALUES (2285, 0, 4, 0.08, 211, 12);
INSERT INTO public.europe_data VALUES (2286, 70, 4902, 126.15, 91, 12);
INSERT INTO public.europe_data VALUES (2287, 364, 12659, 84.09, 92, 12);
INSERT INTO public.europe_data VALUES (2288, 291, 10980, 20.74, 132, 12);
INSERT INTO public.europe_data VALUES (2289, 3270, 148359, 829.29, 188, 12);
INSERT INTO public.europe_data VALUES (2290, 516, 43457, 792.42, 189, 12);
INSERT INTO public.europe_data VALUES (2291, 82, 6900, 438.36, 93, 12);
INSERT INTO public.europe_data VALUES (2292, 2, 1444, 106.85, 133, 12);
INSERT INTO public.europe_data VALUES (2293, 1121, 58364, 591.8, 190, 12);
INSERT INTO public.europe_data VALUES (2294, 2993, 163504, 215.94, 191, 12);
INSERT INTO public.europe_data VALUES (2295, 2, 210, 3.51, 40, 12);
INSERT INTO public.europe_data VALUES (2296, 0, 1, 1.89, 94, 12);
INSERT INTO public.europe_data VALUES (2297, 0, 49, 48.69, 95, 12);
INSERT INTO public.europe_data VALUES (2298, 0, 6, 7.23, 96, 12);
INSERT INTO public.europe_data VALUES (2299, 1, 142, 1021.68, 192, 12);
INSERT INTO public.europe_data VALUES (2300, 1, 14, 7.91, 41, 12);
INSERT INTO public.europe_data VALUES (2301, 123, 2003, 13.62, 134, 12);
INSERT INTO public.europe_data VALUES (2302, 2, 89, 1.07, 42, 12);
INSERT INTO public.europe_data VALUES (2303, 190, 36552, 838.24, 193, 12);
INSERT INTO public.europe_data VALUES (2304, 0, 8, 8.18, 43, 12);
INSERT INTO public.europe_data VALUES (2305, 0, 14, 0.31, 44, 12);
INSERT INTO public.europe_data VALUES (2306, 0, 41, 1.79, 135, 12);
INSERT INTO public.europe_data VALUES (2307, 1, 74, 261.86, 97, 12);
INSERT INTO public.europe_data VALUES (2308, 161, 9474, 380.63, 194, 12);
INSERT INTO public.europe_data VALUES (2309, 152, 10266, 968.18, 195, 12);
INSERT INTO public.europe_data VALUES (2310, 0, 0, 0.45, 212, 12);
INSERT INTO public.europe_data VALUES (2311, 6, 144, 1.4, 45, 12);
INSERT INTO public.europe_data VALUES (2312, 662, 16655, 51.92, 46, 12);
INSERT INTO public.europe_data VALUES (2313, 15, 2235, 6.74, 136, 12);
INSERT INTO public.europe_data VALUES (2314, 1, 44, 0.83, 47, 12);
INSERT INTO public.europe_data VALUES (2315, 1878, 85752, 429.08, 196, 12);
INSERT INTO public.europe_data VALUES (2316, 29, 2884, 29.27, 137, 12);
INSERT INTO public.europe_data VALUES (2317, 77, 1213, 4.09, 48, 12);
INSERT INTO public.europe_data VALUES (2318, 2, 22, 9.8, 98, 12);
INSERT INTO public.europe_data VALUES (2319, 332, 31945, 618.42, 197, 12);
INSERT INTO public.europe_data VALUES (2320, 611, 33297, 916.65, 198, 12);
INSERT INTO public.europe_data VALUES (2321, 31, 541, 5.92, 138, 12);
INSERT INTO public.europe_data VALUES (2322, 0, 15, 0.17, 139, 12);
INSERT INTO public.europe_data VALUES (2323, 1, 284, 5.99, 140, 12);
INSERT INTO public.europe_data VALUES (2324, 0, 38, 0.1, 141, 12);
INSERT INTO public.europe_data VALUES (2325, 0, 0, 0, 142, 12);
INSERT INTO public.europe_data VALUES (2326, 3, 168, 4.05, 49, 12);
INSERT INTO public.europe_data VALUES (2327, 3, 370, 43.08, 99, 12);
INSERT INTO public.europe_data VALUES (2328, 476, 8307, 150.43, 50, 12);
INSERT INTO public.europe_data VALUES (2329, 851, 79659, 179.01, 199, 12);
INSERT INTO public.europe_data VALUES (2330, 0, 26, 102.11, 100, 12);
INSERT INTO public.europe_data VALUES (2331, 27, 1948, 8.05, 51, 12);
INSERT INTO public.europe_data VALUES (2332, 1210, 76808, 346.26, 200, 12);
INSERT INTO public.europe_data VALUES (2333, 22, 8645, 172.43, 143, 12);
INSERT INTO public.europe_data VALUES (2334, 2817, 142727, 480.19, 201, 12);
INSERT INTO public.europe_data VALUES (2335, 0, 0, 0, 52, 12);
INSERT INTO public.europe_data VALUES (2336, 10568, 1209848, 691.43, 101, 12);
INSERT INTO public.europe_data VALUES (2337, 0, 70, 94.67, 102, 12);
INSERT INTO public.europe_data VALUES (2338, 6, 669, 34.23, 103, 12);
INSERT INTO public.europe_data VALUES (2339, 5, 1374, 8.58, 144, 12);
INSERT INTO public.europe_data VALUES (2340, 0, 0, 0.33, 213, 12);
INSERT INTO public.europe_data VALUES (2341, 20, 2483, 17.37, 104, 12);
INSERT INTO public.europe_data VALUES (2342, 0, 25, 0.1, 145, 12);
INSERT INTO public.europe_data VALUES (2343, 0, 1, 0, 214, 12);
INSERT INTO public.europe_data VALUES (2344, 0, 0, 0, 53, 12);
INSERT INTO public.europe_data VALUES (2345, 2, 1, 0.02, 146, 12);
INSERT INTO public.europe_data VALUES (2346, 4, 301, 2.63, 54, 12);
INSERT INTO public.europe_data VALUES (2347, 11, 434, 4.7, 55, 12);
INSERT INTO public.europe_data VALUES (2348, 61, 1164, 4.65, 105, 13);
INSERT INTO public.europe_data VALUES (2349, 64, 3624, 231.55, 147, 13);
INSERT INTO public.europe_data VALUES (2350, 106, 5628, 21.85, 1, 13);
INSERT INTO public.europe_data VALUES (2351, 1, 489, 1374.43, 148, 13);
INSERT INTO public.europe_data VALUES (2352, 19, 1039, 8.07, 2, 13);
INSERT INTO public.europe_data VALUES (2353, 0, 0, 0, 56, 13);
INSERT INTO public.europe_data VALUES (2354, 1, 3, 6.18, 57, 13);
INSERT INTO public.europe_data VALUES (2355, 1876, 68307, 305.84, 58, 13);
INSERT INTO public.europe_data VALUES (2356, 208, 10420, 826.24, 149, 13);
INSERT INTO public.europe_data VALUES (2357, 4, 62, 134.51, 59, 13);
INSERT INTO public.europe_data VALUES (2358, 0, 67, 0.52, 202, 13);
INSERT INTO public.europe_data VALUES (2359, 344, 50986, 1042.85, 150, 13);
INSERT INTO public.europe_data VALUES (2360, 127, 10277, 191.53, 151, 13);
INSERT INTO public.europe_data VALUES (2361, 4, 239, 121.19, 60, 13);
INSERT INTO public.europe_data VALUES (2362, 6, 1247, 169.39, 106, 13);
INSERT INTO public.europe_data VALUES (2363, 127, 12095, 14.16, 107, 13);
INSERT INTO public.europe_data VALUES (2364, 0, 8, 4.53, 61, 13);
INSERT INTO public.europe_data VALUES (2365, 39, 7906, 155.79, 152, 13);
INSERT INTO public.europe_data VALUES (2366, 1328, 33962, 767.8, 153, 13);
INSERT INTO public.europe_data VALUES (2367, 20, 685, 358.4, 62, 13);
INSERT INTO public.europe_data VALUES (2368, 0, 99, 1.7, 3, 13);
INSERT INTO public.europe_data VALUES (2369, 0, 13, 36.8, 63, 13);
INSERT INTO public.europe_data VALUES (2370, 0, 16, 2.75, 108, 13);
INSERT INTO public.europe_data VALUES (2371, 54, 771, 12.27, 64, 13);
INSERT INTO public.europe_data VALUES (2372, 0, 1, 7.7, 65, 13);
INSERT INTO public.europe_data VALUES (2373, 347, 8477, 587.55, 154, 13);
INSERT INTO public.europe_data VALUES (2374, 0, 390, 68.72, 4, 13);
INSERT INTO public.europe_data VALUES (2375, 3401, 198978, 150.39, 66, 13);
INSERT INTO public.europe_data VALUES (2376, 0, 0, 0, 67, 13);
INSERT INTO public.europe_data VALUES (2377, 0, 0, 0, 109, 13);
INSERT INTO public.europe_data VALUES (2378, 465, 23091, 631.17, 155, 13);
INSERT INTO public.europe_data VALUES (2379, 1, 72, 0.69, 5, 13);
INSERT INTO public.europe_data VALUES (2380, 0, 14, 0.34, 6, 13);
INSERT INTO public.europe_data VALUES (2381, 0, 5, 0.07, 110, 13);
INSERT INTO public.europe_data VALUES (2382, 0, 271, 3.47, 7, 13);
INSERT INTO public.europe_data VALUES (2383, 431, 31964, 158.34, 68, 13);
INSERT INTO public.europe_data VALUES (2384, 3, 453, 177.11, 8, 13);
INSERT INTO public.europe_data VALUES (2385, 0, 4, 21.56, 69, 13);
INSERT INTO public.europe_data VALUES (2386, 1, 21, 0.72, 9, 13);
INSERT INTO public.europe_data VALUES (2387, 2, 50, 0.62, 10, 13);
INSERT INTO public.europe_data VALUES (2388, 276, 9715, 102.41, 70, 13);
INSERT INTO public.europe_data VALUES (2389, 0, 76, 0.02, 111, 13);
INSERT INTO public.europe_data VALUES (2390, 1240, 54859, 229.29, 71, 13);
INSERT INTO public.europe_data VALUES (2391, 0, 16, 4, 11, 13);
INSERT INTO public.europe_data VALUES (2392, 0, 0, 1.65, 12, 13);
INSERT INTO public.europe_data VALUES (2393, 82, 6860, 262.54, 72, 13);
INSERT INTO public.europe_data VALUES (2394, 2, 144, 1.01, 13, 13);
INSERT INTO public.europe_data VALUES (2395, 255, 16959, 802.48, 156, 13);
INSERT INTO public.europe_data VALUES (2396, 1, 293, 5.78, 73, 13);
INSERT INTO public.europe_data VALUES (2397, 0, 243, 216, 74, 13);
INSERT INTO public.europe_data VALUES (2398, 13, 1191, 298.55, 157, 13);
INSERT INTO public.europe_data VALUES (2399, 1350, 45288, 1112.43, 158, 13);
INSERT INTO public.europe_data VALUES (2400, 4, 182, 0.48, 14, 13);
INSERT INTO public.europe_data VALUES (2401, 17, 7015, 255.54, 159, 13);
INSERT INTO public.europe_data VALUES (2402, 0, 41, 8.83, 15, 13);
INSERT INTO public.europe_data VALUES (2403, 0, 26, 36.21, 75, 13);
INSERT INTO public.europe_data VALUES (2404, 20, 3542, 59.52, 76, 13);
INSERT INTO public.europe_data VALUES (2405, 178, 5388, 63.9, 77, 13);
INSERT INTO public.europe_data VALUES (2406, 85, 1566, 3.02, 16, 13);
INSERT INTO public.europe_data VALUES (2407, 33, 1213, 36.31, 78, 13);
INSERT INTO public.europe_data VALUES (2408, 0, 12, 1.11, 17, 13);
INSERT INTO public.europe_data VALUES (2409, 0, 2, 0.86, 18, 13);
INSERT INTO public.europe_data VALUES (2410, 6, 1512, 200.18, 160, 13);
INSERT INTO public.europe_data VALUES (2411, 2, 92, 14.81, 19, 13);
INSERT INTO public.europe_data VALUES (2412, 46, 3045, 5.48, 20, 13);
INSERT INTO public.europe_data VALUES (2413, 0, 2, 59.31, 79, 13);
INSERT INTO public.europe_data VALUES (2414, 0, 1, 6.16, 161, 13);
INSERT INTO public.europe_data VALUES (2415, 0, 1, 0.11, 203, 13);
INSERT INTO public.europe_data VALUES (2416, 7, 1518, 54.8, 162, 13);
INSERT INTO public.europe_data VALUES (2417, 4109, 194503, 847.47, 163, 13);
INSERT INTO public.europe_data VALUES (2418, 14, 1711, 1591.21, 204, 13);
INSERT INTO public.europe_data VALUES (2419, 3, 40, 4.33, 21, 13);
INSERT INTO public.europe_data VALUES (2420, 1, 18, 1.28, 22, 13);
INSERT INTO public.europe_data VALUES (2421, 234, 22155, 1007.22, 164, 13);
INSERT INTO public.europe_data VALUES (2422, 1195, 129459, 308.72, 165, 13);
INSERT INTO public.europe_data VALUES (2423, 2, 921, 6.57, 23, 13);
INSERT INTO public.europe_data VALUES (2424, 1, 109, 590.4, 166, 13);
INSERT INTO public.europe_data VALUES (2425, 322, 17507, 310.28, 167, 13);
INSERT INTO public.europe_data VALUES (2426, 0, 0, 0, 80, 13);
INSERT INTO public.europe_data VALUES (2427, 0, 0, 3.57, 81, 13);
INSERT INTO public.europe_data VALUES (2428, 9, 888, 853.58, 205, 13);
INSERT INTO public.europe_data VALUES (2429, 111, 3623, 38.57, 82, 13);
INSERT INTO public.europe_data VALUES (2430, 0, 3, 18.61, 168, 13);
INSERT INTO public.europe_data VALUES (2431, 1, 185, 3.26, 24, 13);
INSERT INTO public.europe_data VALUES (2432, 2, 6, 0.31, 25, 13);
INSERT INTO public.europe_data VALUES (2433, 5, 309, 78.57, 83, 13);
INSERT INTO public.europe_data VALUES (2434, 0, 52, 1.11, 84, 13);
INSERT INTO public.europe_data VALUES (2435, 0, 0, 0, 169, 13);
INSERT INTO public.europe_data VALUES (2436, 72, 2594, 50.17, 85, 13);
INSERT INTO public.europe_data VALUES (2437, 697, 32678, 661.8, 170, 13);
INSERT INTO public.europe_data VALUES (2438, 5, 111, 83.76, 171, 13);
INSERT INTO public.europe_data VALUES (2439, 3459, 291470, 45.07, 112, 13);
INSERT INTO public.europe_data VALUES (2440, 597, 29397, 20.08, 113, 13);
INSERT INTO public.europe_data VALUES (2441, 3202, 79582, 170.75, 114, 13);
INSERT INTO public.europe_data VALUES (2442, 343, 20603, 111.59, 115, 13);
INSERT INTO public.europe_data VALUES (2443, 32, 2509, 120.32, 172, 13);
INSERT INTO public.europe_data VALUES (2444, 0, 6, 11.82, 173, 13);
INSERT INTO public.europe_data VALUES (2445, 58, 4573, 105.69, 116, 13);
INSERT INTO public.europe_data VALUES (2446, 3835, 243425, 777.33, 174, 13);
INSERT INTO public.europe_data VALUES (2447, 10, 378, 25.54, 86, 13);
INSERT INTO public.europe_data VALUES (2448, 65, 8593, 11.72, 117, 13);
INSERT INTO public.europe_data VALUES (2449, 0, 89, 146.57, 175, 13);
INSERT INTO public.europe_data VALUES (2450, 539, 34357, 671.29, 118, 13);
INSERT INTO public.europe_data VALUES (2451, 53, 5372, 55.98, 119, 13);
INSERT INTO public.europe_data VALUES (2452, 158, 7757, 27.33, 26, 13);
INSERT INTO public.europe_data VALUES (2453, 67, 4962, 496.97, 176, 13);
INSERT INTO public.europe_data VALUES (2454, 27, 5097, 244.97, 120, 13);
INSERT INTO public.europe_data VALUES (2455, 21, 3593, 110.73, 121, 13);
INSERT INTO public.europe_data VALUES (2456, 0, 0, 0, 122, 13);
INSERT INTO public.europe_data VALUES (2457, 24, 2452, 229.74, 177, 13);
INSERT INTO public.europe_data VALUES (2458, 94, 11194, 332.76, 123, 13);
INSERT INTO public.europe_data VALUES (2459, 0, 74, 4.42, 27, 13);
INSERT INTO public.europe_data VALUES (2460, 0, 65, 1.64, 28, 13);
INSERT INTO public.europe_data VALUES (2461, 88, 5485, 170.52, 29, 13);
INSERT INTO public.europe_data VALUES (2462, 1, 197, 1130.86, 178, 13);
INSERT INTO public.europe_data VALUES (2463, 70, 10059, 681.38, 179, 13);
INSERT INTO public.europe_data VALUES (2464, 37, 4063, 1264.39, 180, 13);
INSERT INTO public.europe_data VALUES (2465, 0, 10, 0.45, 30, 13);
INSERT INTO public.europe_data VALUES (2466, 1, 14, 0.18, 31, 13);
INSERT INTO public.europe_data VALUES (2467, 23, 7208, 46.67, 124, 13);
INSERT INTO public.europe_data VALUES (2468, 3, 218, 94.73, 125, 13);
INSERT INTO public.europe_data VALUES (2469, 2, 192, 1.64, 32, 13);
INSERT INTO public.europe_data VALUES (2470, 20, 894, 351.73, 181, 13);
INSERT INTO public.europe_data VALUES (2471, 0, 0, 0, 206, 13);
INSERT INTO public.europe_data VALUES (2472, 0, 79, 3.71, 33, 13);
INSERT INTO public.europe_data VALUES (2473, 0, 26, 2.52, 34, 13);
INSERT INTO public.europe_data VALUES (2474, 3515, 38697, 60.46, 87, 13);
INSERT INTO public.europe_data VALUES (2475, 126, 6933, 314.03, 182, 13);
INSERT INTO public.europe_data VALUES (2476, 0, 62, 550.1, 183, 13);
INSERT INTO public.europe_data VALUES (2477, 0, 63, 2.54, 126, 13);
INSERT INTO public.europe_data VALUES (2478, 54, 4372, 1360.21, 184, 13);
INSERT INTO public.europe_data VALUES (2479, 0, 0, 0, 88, 13);
INSERT INTO public.europe_data VALUES (2480, 507, 36396, 193.66, 35, 13);
INSERT INTO public.europe_data VALUES (2481, 14, 680, 4.81, 36, 13);
INSERT INTO public.europe_data VALUES (2482, 157, 7617, 28.84, 127, 13);
INSERT INTO public.europe_data VALUES (2483, 4, 297, 20.85, 37, 13);
INSERT INTO public.europe_data VALUES (2484, 113, 15323, 126.57, 128, 13);
INSERT INTO public.europe_data VALUES (2485, 481, 37762, 508.61, 185, 13);
INSERT INTO public.europe_data VALUES (2486, 0, 1, 0.71, 208, 13);
INSERT INTO public.europe_data VALUES (2487, 0, 15, 0.79, 209, 13);
INSERT INTO public.europe_data VALUES (2488, 1, 70, 2.25, 89, 13);
INSERT INTO public.europe_data VALUES (2489, 1, 64, 0.37, 38, 13);
INSERT INTO public.europe_data VALUES (2490, 9, 1058, 1.09, 39, 13);
INSERT INTO public.europe_data VALUES (2491, 169, 7290, 703.57, 186, 13);
INSERT INTO public.europe_data VALUES (2492, 0, 2, 10.49, 210, 13);
INSERT INTO public.europe_data VALUES (2493, 9, 4001, 143.82, 187, 13);
INSERT INTO public.europe_data VALUES (2494, 37, 2249, 93.57, 129, 13);
INSERT INTO public.europe_data VALUES (2495, 183, 14193, 11.05, 130, 13);
INSERT INTO public.europe_data VALUES (2496, 53, 5165, 191.19, 131, 13);
INSERT INTO public.europe_data VALUES (2497, 75, 7126, 290.05, 90, 13);
INSERT INTO public.europe_data VALUES (2498, 0, 3, 0.11, 211, 13);
INSERT INTO public.europe_data VALUES (2499, 97, 3985, 111.33, 91, 13);
INSERT INTO public.europe_data VALUES (2500, 352, 14678, 98.74, 92, 13);
INSERT INTO public.europe_data VALUES (2501, 293, 11443, 22.87, 132, 13);
INSERT INTO public.europe_data VALUES (2502, 2476, 166547, 877.13, 188, 13);
INSERT INTO public.europe_data VALUES (2503, 485, 37977, 709.96, 189, 13);
INSERT INTO public.europe_data VALUES (2504, 63, 5959, 387.37, 93, 13);
INSERT INTO public.europe_data VALUES (2505, 2, 1582, 108.22, 133, 13);
INSERT INTO public.europe_data VALUES (2506, 1047, 56530, 585.22, 190, 13);
INSERT INTO public.europe_data VALUES (2507, 2649, 151491, 198.15, 191, 13);
INSERT INTO public.europe_data VALUES (2508, 9, 233, 2.45, 40, 13);
INSERT INTO public.europe_data VALUES (2509, 0, 0, 0, 94, 13);
INSERT INTO public.europe_data VALUES (2510, 2, 40, 47.59, 95, 13);
INSERT INTO public.europe_data VALUES (2511, 0, 2, 2.71, 96, 13);
INSERT INTO public.europe_data VALUES (2512, 0, 210, 943.31, 192, 13);
INSERT INTO public.europe_data VALUES (2513, 0, 3, 7.44, 41, 13);
INSERT INTO public.europe_data VALUES (2514, 117, 2663, 16.34, 134, 13);
INSERT INTO public.europe_data VALUES (2515, 2, 85, 1, 42, 13);
INSERT INTO public.europe_data VALUES (2516, 119, 21821, 519.33, 193, 13);
INSERT INTO public.europe_data VALUES (2517, 0, 0, 5.12, 43, 13);
INSERT INTO public.europe_data VALUES (2518, 0, 10, 0.32, 44, 13);
INSERT INTO public.europe_data VALUES (2519, 0, 63, 1.72, 135, 13);
INSERT INTO public.europe_data VALUES (2520, 1, 37, 240.63, 97, 13);
INSERT INTO public.europe_data VALUES (2521, 159, 11272, 492.09, 194, 13);
INSERT INTO public.europe_data VALUES (2522, 129, 9881, 931.95, 195, 13);
INSERT INTO public.europe_data VALUES (2523, 0, 3, 1.19, 212, 13);
INSERT INTO public.europe_data VALUES (2524, 0, 72, 2.33, 45, 13);
INSERT INTO public.europe_data VALUES (2525, 432, 13746, 41.33, 46, 13);
INSERT INTO public.europe_data VALUES (2526, 14, 1216, 3.98, 136, 13);
INSERT INTO public.europe_data VALUES (2527, 0, 48, 0.7, 47, 13);
INSERT INTO public.europe_data VALUES (2528, 1908, 115646, 545.77, 196, 13);
INSERT INTO public.europe_data VALUES (2529, 23, 3358, 29.2, 137, 13);
INSERT INTO public.europe_data VALUES (2530, 1, 536, 1.88, 48, 13);
INSERT INTO public.europe_data VALUES (2531, 1, 35, 11.01, 98, 13);
INSERT INTO public.europe_data VALUES (2532, 235, 31320, 554.49, 197, 13);
INSERT INTO public.europe_data VALUES (2533, 552, 45026, 1199.11, 198, 13);
INSERT INTO public.europe_data VALUES (2534, 28, 469, 5.24, 138, 13);
INSERT INTO public.europe_data VALUES (2535, 0, 25, 0.17, 139, 13);
INSERT INTO public.europe_data VALUES (2536, 2, 274, 5.97, 140, 13);
INSERT INTO public.europe_data VALUES (2537, 0, 35, 0.13, 141, 13);
INSERT INTO public.europe_data VALUES (2538, 0, 0, 0, 142, 13);
INSERT INTO public.europe_data VALUES (2539, 4, 159, 3.93, 49, 13);
INSERT INTO public.europe_data VALUES (2540, 1, 231, 29.53, 99, 13);
INSERT INTO public.europe_data VALUES (2541, 472, 9285, 158.17, 50, 13);
INSERT INTO public.europe_data VALUES (2542, 620, 67133, 159.78, 199, 13);
INSERT INTO public.europe_data VALUES (2543, 0, 13, 41.89, 100, 13);
INSERT INTO public.europe_data VALUES (2544, 13, 1617, 7.4, 51, 13);
INSERT INTO public.europe_data VALUES (2545, 1153, 75526, 319.18, 200, 13);
INSERT INTO public.europe_data VALUES (2546, 16, 8202, 168.24, 143, 13);
INSERT INTO public.europe_data VALUES (2547, 2890, 177305, 501.75, 201, 13);
INSERT INTO public.europe_data VALUES (2548, 0, 0, 0, 52, 13);
INSERT INTO public.europe_data VALUES (2549, 8642, 1065410, 556.03, 101, 13);
INSERT INTO public.europe_data VALUES (2550, 0, 29, 55.46, 102, 13);
INSERT INTO public.europe_data VALUES (2551, 3, 516, 25.45, 103, 13);
INSERT INTO public.europe_data VALUES (2552, 13, 1455, 9.36, 144, 13);
INSERT INTO public.europe_data VALUES (2553, 0, 1, 0, 213, 13);
INSERT INTO public.europe_data VALUES (2554, 25, 2469, 17.63, 104, 13);
INSERT INTO public.europe_data VALUES (2555, 0, 68, 0.1, 145, 13);
INSERT INTO public.europe_data VALUES (2556, 0, 0, 0, 214, 13);
INSERT INTO public.europe_data VALUES (2557, 0, 0, 0, 53, 13);
INSERT INTO public.europe_data VALUES (2558, 0, 5, 0.02, 146, 13);
INSERT INTO public.europe_data VALUES (2559, 4, 169, 3.6, 54, 13);
INSERT INTO public.europe_data VALUES (2560, 4, 255, 2.81, 55, 13);
INSERT INTO public.europe_data VALUES (2561, 24, 606, 3.7, 105, 14);
INSERT INTO public.europe_data VALUES (2562, 41, 3004, 176.39, 147, 14);
INSERT INTO public.europe_data VALUES (2563, 75, 3779, 13.72, 1, 14);
INSERT INTO public.europe_data VALUES (2564, 0, 558, 1765.62, 148, 14);
INSERT INTO public.europe_data VALUES (2565, 19, 1530, 10.4, 2, 14);
INSERT INTO public.europe_data VALUES (2566, 0, 0, 0, 56, 14);
INSERT INTO public.europe_data VALUES (2567, 0, 3, 7.21, 57, 14);
INSERT INTO public.europe_data VALUES (2568, 2420, 68649, 338.52, 58, 14);
INSERT INTO public.europe_data VALUES (2569, 189, 14018, 968.85, 149, 14);
INSERT INTO public.europe_data VALUES (2570, 2, 81, 169.32, 59, 14);
INSERT INTO public.europe_data VALUES (2571, 0, 63, 0.55, 202, 14);
INSERT INTO public.europe_data VALUES (2572, 221, 41398, 789.86, 150, 14);
INSERT INTO public.europe_data VALUES (2573, 100, 8967, 153.79, 151, 14);
INSERT INTO public.europe_data VALUES (2574, 8, 233, 137.87, 60, 14);
INSERT INTO public.europe_data VALUES (2575, 8, 1533, 195.04, 106, 14);
INSERT INTO public.europe_data VALUES (2576, 126, 10986, 13.14, 107, 14);
INSERT INTO public.europe_data VALUES (2577, 0, 5, 5.23, 61, 14);
INSERT INTO public.europe_data VALUES (2578, 22, 6820, 142.36, 152, 14);
INSERT INTO public.europe_data VALUES (2579, 1411, 53994, 1340.3, 153, 14);
INSERT INTO public.europe_data VALUES (2580, 12, 714, 264.12, 62, 14);
INSERT INTO public.europe_data VALUES (2581, 2, 102, 1.59, 3, 14);
INSERT INTO public.europe_data VALUES (2582, 0, 10, 28.8, 63, 14);
INSERT INTO public.europe_data VALUES (2583, 0, 5, 2.23, 108, 14);
INSERT INTO public.europe_data VALUES (2584, 64, 642, 14.09, 64, 14);
INSERT INTO public.europe_data VALUES (2585, 0, 1, 15.39, 65, 14);
INSERT INTO public.europe_data VALUES (2586, 262, 10918, 652.2, 154, 14);
INSERT INTO public.europe_data VALUES (2587, 3, 1193, 83, 4, 14);
INSERT INTO public.europe_data VALUES (2588, 2323, 118410, 127.93, 66, 14);
INSERT INTO public.europe_data VALUES (2589, 0, 0, 0, 67, 14);
INSERT INTO public.europe_data VALUES (2590, 0, 0, 0, 109, 14);
INSERT INTO public.europe_data VALUES (2591, 367, 21091, 532.44, 155, 14);
INSERT INTO public.europe_data VALUES (2592, 0, 69, 0.58, 5, 14);
INSERT INTO public.europe_data VALUES (2593, 0, 25, 0.5, 6, 14);
INSERT INTO public.europe_data VALUES (2594, 0, 6, 0.06, 110, 14);
INSERT INTO public.europe_data VALUES (2595, 7, 628, 3.29, 7, 14);
INSERT INTO public.europe_data VALUES (2596, 343, 27272, 128.33, 68, 14);
INSERT INTO public.europe_data VALUES (2597, 5, 521, 176.93, 8, 14);
INSERT INTO public.europe_data VALUES (2598, 0, 10, 16.94, 69, 14);
INSERT INTO public.europe_data VALUES (2599, 0, 13, 0.36, 9, 14);
INSERT INTO public.europe_data VALUES (2600, 1, 49, 0.69, 10, 14);
INSERT INTO public.europe_data VALUES (2601, 296, 9694, 102.86, 70, 14);
INSERT INTO public.europe_data VALUES (2602, 0, 213, 0.03, 111, 14);
INSERT INTO public.europe_data VALUES (2603, 1276, 60566, 254.28, 71, 14);
INSERT INTO public.europe_data VALUES (2604, 0, 18, 5.41, 11, 14);
INSERT INTO public.europe_data VALUES (2605, 0, 89, 2.34, 12, 14);
INSERT INTO public.europe_data VALUES (2606, 79, 6392, 263, 72, 14);
INSERT INTO public.europe_data VALUES (2607, 0, 116, 1.41, 13, 14);
INSERT INTO public.europe_data VALUES (2608, 232, 15752, 757.24, 156, 14);
INSERT INTO public.europe_data VALUES (2609, 2, 362, 6.45, 73, 14);
INSERT INTO public.europe_data VALUES (2610, 1, 110, 146.25, 74, 14);
INSERT INTO public.europe_data VALUES (2611, 1, 1424, 278.8, 157, 14);
INSERT INTO public.europe_data VALUES (2612, 1429, 73184, 1471.68, 158, 14);
INSERT INTO public.europe_data VALUES (2613, 8, 236, 0.54, 14, 14);
INSERT INTO public.europe_data VALUES (2614, 20, 7822, 254.3, 159, 14);
INSERT INTO public.europe_data VALUES (2615, 0, 45, 7.4, 15, 14);
INSERT INTO public.europe_data VALUES (2616, 0, 0, 5.57, 75, 14);
INSERT INTO public.europe_data VALUES (2617, 16, 2850, 52.66, 76, 14);
INSERT INTO public.europe_data VALUES (2618, 146, 5713, 76.39, 77, 14);
INSERT INTO public.europe_data VALUES (2619, 90, 1465, 2.65, 16, 14);
INSERT INTO public.europe_data VALUES (2620, 31, 1130, 39.67, 78, 14);
INSERT INTO public.europe_data VALUES (2621, 2, 3, 0.96, 17, 14);
INSERT INTO public.europe_data VALUES (2622, 0, 28, 0.86, 18, 14);
INSERT INTO public.europe_data VALUES (2623, 2, 1140, 129.38, 160, 14);
INSERT INTO public.europe_data VALUES (2624, 0, 78, 12.98, 19, 14);
INSERT INTO public.europe_data VALUES (2625, 45, 3092, 5.65, 20, 14);
INSERT INTO public.europe_data VALUES (2626, 0, 0, 0, 79, 14);
INSERT INTO public.europe_data VALUES (2627, 0, 2, 14.38, 161, 14);
INSERT INTO public.europe_data VALUES (2628, 0, 0, 0.11, 203, 14);
INSERT INTO public.europe_data VALUES (2629, 4, 1506, 53.44, 162, 14);
INSERT INTO public.europe_data VALUES (2630, 3420, 373409, 968.2, 163, 14);
INSERT INTO public.europe_data VALUES (2631, 10, 2733, 1503.12, 204, 14);
INSERT INTO public.europe_data VALUES (2632, 0, 54, 4.74, 21, 14);
INSERT INTO public.europe_data VALUES (2633, 2, 12, 1.02, 22, 14);
INSERT INTO public.europe_data VALUES (2634, 157, 18101, 760.04, 164, 14);
INSERT INTO public.europe_data VALUES (2635, 822, 126841, 281.86, 165, 14);
INSERT INTO public.europe_data VALUES (2636, 0, 1078, 4.97, 23, 14);
INSERT INTO public.europe_data VALUES (2637, 0, 90, 373.82, 166, 14);
INSERT INTO public.europe_data VALUES (2638, 149, 15769, 241.65, 167, 14);
INSERT INTO public.europe_data VALUES (2639, 0, 0, 0, 80, 14);
INSERT INTO public.europe_data VALUES (2640, 0, 4, 3.57, 81, 14);
INSERT INTO public.europe_data VALUES (2641, 10, 540, 607.91, 205, 14);
INSERT INTO public.europe_data VALUES (2642, 83, 3158, 36.83, 82, 14);
INSERT INTO public.europe_data VALUES (2643, 0, 9, 21.72, 168, 14);
INSERT INTO public.europe_data VALUES (2644, 1, 231, 5.93, 24, 14);
INSERT INTO public.europe_data VALUES (2645, 0, 0, 0.52, 25, 14);
INSERT INTO public.europe_data VALUES (2646, 8, 306, 62.73, 83, 14);
INSERT INTO public.europe_data VALUES (2647, 0, 73, 0.9, 84, 14);
INSERT INTO public.europe_data VALUES (2648, 0, 0, 0, 169, 14);
INSERT INTO public.europe_data VALUES (2649, 76, 2296, 74.84, 85, 14);
INSERT INTO public.europe_data VALUES (2650, 604, 31998, 544.52, 170, 14);
INSERT INTO public.europe_data VALUES (2651, 8, 188, 176.48, 171, 14);
INSERT INTO public.europe_data VALUES (2652, 4004, 324344, 47.11, 112, 14);
INSERT INTO public.europe_data VALUES (2653, 671, 24932, 17.74, 113, 14);
INSERT INTO public.europe_data VALUES (2654, 2993, 61995, 137, 114, 14);
INSERT INTO public.europe_data VALUES (2655, 361, 23261, 119.16, 115, 14);
INSERT INTO public.europe_data VALUES (2656, 32, 3392, 168.55, 172, 14);
INSERT INTO public.europe_data VALUES (2657, 1, 4, 10.64, 173, 14);
INSERT INTO public.europe_data VALUES (2658, 120, 4431, 110.5, 116, 14);
INSERT INTO public.europe_data VALUES (2659, 2568, 225769, 678.14, 174, 14);
INSERT INTO public.europe_data VALUES (2660, 12, 375, 26.86, 86, 14);
INSERT INTO public.europe_data VALUES (2661, 44, 6271, 8.68, 117, 14);
INSERT INTO public.europe_data VALUES (2662, 0, 69, 104.83, 175, 14);
INSERT INTO public.europe_data VALUES (2663, 367, 33455, 556.68, 118, 14);
INSERT INTO public.europe_data VALUES (2664, 39, 5013, 45.35, 119, 14);
INSERT INTO public.europe_data VALUES (2665, 98, 6611, 24.28, 26, 14);
INSERT INTO public.europe_data VALUES (2666, 67, 3976, 345.4, 176, 14);
INSERT INTO public.europe_data VALUES (2667, 29, 5209, 240.26, 120, 14);
INSERT INTO public.europe_data VALUES (2668, 27, 3511, 112.53, 121, 14);
INSERT INTO public.europe_data VALUES (2669, 0, 0, 0, 122, 14);
INSERT INTO public.europe_data VALUES (2670, 25, 1959, 177.97, 177, 14);
INSERT INTO public.europe_data VALUES (2671, 80, 11619, 333.24, 123, 14);
INSERT INTO public.europe_data VALUES (2672, 1, 20, 1.27, 27, 14);
INSERT INTO public.europe_data VALUES (2673, 0, 16, 0.99, 28, 14);
INSERT INTO public.europe_data VALUES (2674, 58, 6072, 178.59, 29, 14);
INSERT INTO public.europe_data VALUES (2675, 0, 237, 1102.19, 178, 14);
INSERT INTO public.europe_data VALUES (2676, 41, 8980, 519.47, 179, 14);
INSERT INTO public.europe_data VALUES (2677, 25, 3699, 1348.28, 180, 14);
INSERT INTO public.europe_data VALUES (2678, 5, 112, 0.95, 30, 14);
INSERT INTO public.europe_data VALUES (2679, 0, 19, 0.33, 31, 14);
INSERT INTO public.europe_data VALUES (2680, 37, 7704, 42.7, 124, 14);
INSERT INTO public.europe_data VALUES (2681, 2, 285, 90.59, 125, 14);
INSERT INTO public.europe_data VALUES (2682, 1, 131, 0.95, 32, 14);
INSERT INTO public.europe_data VALUES (2683, 14, 842, 337.35, 181, 14);
INSERT INTO public.europe_data VALUES (2684, 0, 0, 1.7, 206, 14);
INSERT INTO public.europe_data VALUES (2685, 2, 89, 3.18, 33, 14);
INSERT INTO public.europe_data VALUES (2686, 0, 6, 1.34, 34, 14);
INSERT INTO public.europe_data VALUES (2687, 3132, 38433, 60.09, 87, 14);
INSERT INTO public.europe_data VALUES (2688, 93, 5764, 268.17, 182, 14);
INSERT INTO public.europe_data VALUES (2689, 0, 120, 544.05, 183, 14);
INSERT INTO public.europe_data VALUES (2690, 0, 19, 0.9, 126, 14);
INSERT INTO public.europe_data VALUES (2691, 24, 4091, 965.63, 184, 14);
INSERT INTO public.europe_data VALUES (2692, 0, 0, 0, 88, 14);
INSERT INTO public.europe_data VALUES (2693, 510, 34237, 162.59, 35, 14);
INSERT INTO public.europe_data VALUES (2694, 6, 780, 5.87, 36, 14);
INSERT INTO public.europe_data VALUES (2695, 162, 7972, 30.72, 127, 14);
INSERT INTO public.europe_data VALUES (2696, 1, 223, 22.09, 37, 14);
INSERT INTO public.europe_data VALUES (2697, 148, 20886, 127.11, 128, 14);
INSERT INTO public.europe_data VALUES (2698, 570, 50136, 686.53, 185, 14);
INSERT INTO public.europe_data VALUES (2699, 0, 1, 0.71, 208, 14);
INSERT INTO public.europe_data VALUES (2700, 0, 23, 0.96, 209, 14);
INSERT INTO public.europe_data VALUES (2701, 1, 77, 2.4, 89, 14);
INSERT INTO public.europe_data VALUES (2702, 0, 22, 0.12, 38, 14);
INSERT INTO public.europe_data VALUES (2703, 8, 1126, 1.04, 39, 14);
INSERT INTO public.europe_data VALUES (2704, 132, 7324, 616.52, 186, 14);
INSERT INTO public.europe_data VALUES (2705, 0, 4, 13.98, 210, 14);
INSERT INTO public.europe_data VALUES (2706, 3, 3662, 112.48, 187, 14);
INSERT INTO public.europe_data VALUES (2707, 55, 2406, 104.68, 129, 14);
INSERT INTO public.europe_data VALUES (2708, 142, 9746, 7.5, 130, 14);
INSERT INTO public.europe_data VALUES (2709, 26, 4359, 162.91, 131, 14);
INSERT INTO public.europe_data VALUES (2710, 92, 5191, 243.19, 90, 14);
INSERT INTO public.europe_data VALUES (2711, 0, 7, 0.1, 211, 14);
INSERT INTO public.europe_data VALUES (2712, 72, 3858, 113.49, 91, 14);
INSERT INTO public.europe_data VALUES (2713, 350, 17422, 103.41, 92, 14);
INSERT INTO public.europe_data VALUES (2714, 301, 13282, 24.39, 132, 14);
INSERT INTO public.europe_data VALUES (2715, 2089, 166523, 770.91, 188, 14);
INSERT INTO public.europe_data VALUES (2716, 352, 34983, 590.06, 189, 14);
INSERT INTO public.europe_data VALUES (2717, 40, 5404, 325.97, 93, 14);
INSERT INTO public.europe_data VALUES (2718, 0, 1483, 107.09, 133, 14);
INSERT INTO public.europe_data VALUES (2719, 812, 57088, 484.71, 190, 14);
INSERT INTO public.europe_data VALUES (2720, 2302, 137553, 178.55, 191, 14);
INSERT INTO public.europe_data VALUES (2721, 1, 76, 1.24, 40, 14);
INSERT INTO public.europe_data VALUES (2722, 0, 0, 0, 94, 14);
INSERT INTO public.europe_data VALUES (2723, 0, 47, 42.12, 95, 14);
INSERT INTO public.europe_data VALUES (2724, 0, 1, 2.71, 96, 14);
INSERT INTO public.europe_data VALUES (2725, 0, 115, 650.16, 192, 14);
INSERT INTO public.europe_data VALUES (2726, 0, 13, 10.23, 41, 14);
INSERT INTO public.europe_data VALUES (2727, 138, 2936, 16.68, 134, 14);
INSERT INTO public.europe_data VALUES (2728, 1, 78, 0.96, 42, 14);
INSERT INTO public.europe_data VALUES (2729, 64, 14344, 334.03, 193, 14);
INSERT INTO public.europe_data VALUES (2730, 0, 5, 5.12, 43, 14);
INSERT INTO public.europe_data VALUES (2731, 0, 15, 0.45, 44, 14);
INSERT INTO public.europe_data VALUES (2732, 0, 37, 1.48, 135, 14);
INSERT INTO public.europe_data VALUES (2733, 1, 65, 264.22, 97, 14);
INSERT INTO public.europe_data VALUES (2734, 132, 15549, 580.73, 194, 14);
INSERT INTO public.europe_data VALUES (2735, 146, 9512, 1067.37, 195, 14);
INSERT INTO public.europe_data VALUES (2736, 0, 5, 1.34, 212, 14);
INSERT INTO public.europe_data VALUES (2737, 3, 288, 1.86, 45, 14);
INSERT INTO public.europe_data VALUES (2738, 398, 10455, 36.56, 46, 14);
INSERT INTO public.europe_data VALUES (2739, 12, 821, 3.12, 136, 14);
INSERT INTO public.europe_data VALUES (2740, 0, 29, 0.65, 47, 14);
INSERT INTO public.europe_data VALUES (2741, 3088, 140521, 602.72, 196, 14);
INSERT INTO public.europe_data VALUES (2742, 14, 2869, 28.4, 137, 14);
INSERT INTO public.europe_data VALUES (2743, 278, 271, 0.81, 48, 14);
INSERT INTO public.europe_data VALUES (2744, 2, 29, 11.87, 98, 14);
INSERT INTO public.europe_data VALUES (2745, 157, 25405, 428.93, 197, 14);
INSERT INTO public.europe_data VALUES (2746, 369, 57432, 1262.06, 198, 14);
INSERT INTO public.europe_data VALUES (2747, 25, 426, 4.73, 138, 14);
INSERT INTO public.europe_data VALUES (2748, 0, 15, 0.12, 139, 14);
INSERT INTO public.europe_data VALUES (2749, 1, 282, 6.01, 140, 14);
INSERT INTO public.europe_data VALUES (2750, 1, 53, 0.14, 141, 14);
INSERT INTO public.europe_data VALUES (2751, 0, 0, 0.08, 142, 14);
INSERT INTO public.europe_data VALUES (2752, 0, 159, 3.91, 49, 14);
INSERT INTO public.europe_data VALUES (2753, 4, 181, 24.23, 99, 14);
INSERT INTO public.europe_data VALUES (2754, 492, 9213, 190.86, 50, 14);
INSERT INTO public.europe_data VALUES (2755, 561, 63892, 154.47, 199, 14);
INSERT INTO public.europe_data VALUES (2756, 0, 3, 15.71, 100, 14);
INSERT INTO public.europe_data VALUES (2757, 20, 1660, 6.69, 51, 14);
INSERT INTO public.europe_data VALUES (2758, 1144, 64891, 265.59, 200, 14);
INSERT INTO public.europe_data VALUES (2759, 18, 8236, 174.2, 143, 14);
INSERT INTO public.europe_data VALUES (2760, 2327, 157099, 477.46, 201, 14);
INSERT INTO public.europe_data VALUES (2761, 0, 0, 0, 52, 14);
INSERT INTO public.europe_data VALUES (2762, 6576, 764289, 405.84, 101, 14);
INSERT INTO public.europe_data VALUES (2763, 2, 29, 54.5, 102, 14);
INSERT INTO public.europe_data VALUES (2764, 3, 365, 19.15, 103, 14);
INSERT INTO public.europe_data VALUES (2765, 15, 1632, 10.03, 144, 14);
INSERT INTO public.europe_data VALUES (2766, 25, 2558, 18.65, 104, 14);
INSERT INTO public.europe_data VALUES (2767, 0, 33, 0.05, 145, 14);
INSERT INTO public.europe_data VALUES (2768, 0, 0, 0, 214, 14);
INSERT INTO public.europe_data VALUES (2769, 0, 0, 0, 53, 14);
INSERT INTO public.europe_data VALUES (2770, 2, 0, 0, 146, 14);
INSERT INTO public.europe_data VALUES (2771, 0, 474, 4.69, 54, 14);
INSERT INTO public.europe_data VALUES (2772, 10, 157, 1.74, 55, 14);
INSERT INTO public.europe_data VALUES (2773, 27, 800, 3.77, 105, 15);
INSERT INTO public.europe_data VALUES (2774, 41, 2045, 144.88, 147, 15);
INSERT INTO public.europe_data VALUES (2775, 59, 2129, 8.99, 1, 15);
INSERT INTO public.europe_data VALUES (2776, 6, 787, 1900.84, 148, 15);
INSERT INTO public.europe_data VALUES (2777, 17, 1779, 10.5, 2, 15);
INSERT INTO public.europe_data VALUES (2778, 0, 0, 0, 56, 15);
INSERT INTO public.europe_data VALUES (2779, 0, 4, 9.27, 57, 15);
INSERT INTO public.europe_data VALUES (2780, 2244, 82944, 410.56, 58, 15);
INSERT INTO public.europe_data VALUES (2781, 195, 14638, 972.17, 149, 15);
INSERT INTO public.europe_data VALUES (2782, 2, 99, 185.31, 59, 15);
INSERT INTO public.europe_data VALUES (2783, 2, 75, 0.81, 202, 15);
INSERT INTO public.europe_data VALUES (2784, 130, 28574, 514.21, 150, 15);
INSERT INTO public.europe_data VALUES (2785, 69, 6485, 114.25, 151, 15);
INSERT INTO public.europe_data VALUES (2786, 12, 304, 259.57, 60, 15);
INSERT INTO public.europe_data VALUES (2787, 9, 1668, 245.01, 106, 15);
INSERT INTO public.europe_data VALUES (2788, 138, 10437, 12.69, 107, 15);
INSERT INTO public.europe_data VALUES (2789, 0, 10, 5.23, 61, 15);
INSERT INTO public.europe_data VALUES (2790, 28, 6636, 124.42, 152, 15);
INSERT INTO public.europe_data VALUES (2791, 1056, 99544, 1788.42, 153, 15);
INSERT INTO public.europe_data VALUES (2792, 8, 317, 166.26, 62, 15);
INSERT INTO public.europe_data VALUES (2793, 0, 86, 1.25, 3, 15);
INSERT INTO public.europe_data VALUES (2794, 0, 8, 22.4, 63, 15);
INSERT INTO public.europe_data VALUES (2795, 0, 12, 3.54, 108, 15);
INSERT INTO public.europe_data VALUES (2796, 86, 980, 17.91, 64, 15);
INSERT INTO public.europe_data VALUES (2797, 0, 3, 11.55, 65, 15);
INSERT INTO public.europe_data VALUES (2798, 162, 10611, 526.66, 154, 15);
INSERT INTO public.europe_data VALUES (2799, 3, 719, 60.77, 4, 15);
INSERT INTO public.europe_data VALUES (2800, 2940, 151577, 147.06, 66, 15);
INSERT INTO public.europe_data VALUES (2801, 0, 0, 3.33, 67, 15);
INSERT INTO public.europe_data VALUES (2802, 0, 0, 0.23, 109, 15);
INSERT INTO public.europe_data VALUES (2803, 204, 16180, 350.94, 155, 15);
INSERT INTO public.europe_data VALUES (2804, 2, 49, 0.59, 5, 15);
INSERT INTO public.europe_data VALUES (2805, 0, 33, 0.41, 6, 15);
INSERT INTO public.europe_data VALUES (2806, 0, 4, 0.05, 110, 15);
INSERT INTO public.europe_data VALUES (2807, 1, 223, 1.36, 7, 15);
INSERT INTO public.europe_data VALUES (2808, 233, 20737, 103.43, 68, 15);
INSERT INTO public.europe_data VALUES (2809, 1, 452, 199.3, 8, 15);
INSERT INTO public.europe_data VALUES (2810, 0, 1, 10.78, 69, 15);
INSERT INTO public.europe_data VALUES (2811, 0, 4, 0.23, 9, 15);
INSERT INTO public.europe_data VALUES (2812, 2, 61, 0.75, 10, 15);
INSERT INTO public.europe_data VALUES (2813, 303, 9801, 106.08, 70, 15);
INSERT INTO public.europe_data VALUES (2814, 0, 196, 0.03, 111, 15);
INSERT INTO public.europe_data VALUES (2815, 1361, 67436, 245.83, 71, 15);
INSERT INTO public.europe_data VALUES (2816, 0, 28, 5.05, 11, 15);
INSERT INTO public.europe_data VALUES (2817, 0, 37, 2.49, 12, 15);
INSERT INTO public.europe_data VALUES (2818, 103, 6883, 286.42, 72, 15);
INSERT INTO public.europe_data VALUES (2819, 4, 246, 1.53, 13, 15);
INSERT INTO public.europe_data VALUES (2820, 125, 15115, 635.76, 156, 15);
INSERT INTO public.europe_data VALUES (2821, 0, 369, 6.31, 73, 15);
INSERT INTO public.europe_data VALUES (2822, 0, 129, 148.69, 74, 15);
INSERT INTO public.europe_data VALUES (2823, 1, 1018, 219.09, 157, 15);
INSERT INTO public.europe_data VALUES (2824, 1228, 83547, 1575.23, 158, 15);
INSERT INTO public.europe_data VALUES (2825, 3, 229, 0.37, 14, 15);
INSERT INTO public.europe_data VALUES (2826, 21, 6943, 205.08, 159, 15);
INSERT INTO public.europe_data VALUES (2827, 0, 27, 10.68, 15, 15);
INSERT INTO public.europe_data VALUES (2828, 0, 4, 12.53, 75, 15);
INSERT INTO public.europe_data VALUES (2829, 26, 2805, 55.73, 76, 15);
INSERT INTO public.europe_data VALUES (2830, 131, 7559, 91.55, 77, 15);
INSERT INTO public.europe_data VALUES (2831, 79, 1196, 2.3, 16, 15);
INSERT INTO public.europe_data VALUES (2832, 30, 1430, 36.4, 78, 15);
INSERT INTO public.europe_data VALUES (2833, 0, 10, 1.4, 17, 15);
INSERT INTO public.europe_data VALUES (2834, 0, 2, 1.09, 18, 15);
INSERT INTO public.europe_data VALUES (2835, 0, 574, 68.46, 160, 15);
INSERT INTO public.europe_data VALUES (2836, 1, 71, 12.63, 19, 15);
INSERT INTO public.europe_data VALUES (2837, 52, 3240, 6.64, 20, 15);
INSERT INTO public.europe_data VALUES (2838, 0, 0, 0, 79, 15);
INSERT INTO public.europe_data VALUES (2839, 0, 5, 20.54, 161, 15);
INSERT INTO public.europe_data VALUES (2840, 0, 1, 0.22, 203, 15);
INSERT INTO public.europe_data VALUES (2841, 5, 1443, 51.96, 162, 15);
INSERT INTO public.europe_data VALUES (2842, 2258, 275408, 771.32, 163, 15);
INSERT INTO public.europe_data VALUES (2843, 9, 1465, 1240.67, 204, 15);
INSERT INTO public.europe_data VALUES (2844, 1, 49, 4, 21, 15);
INSERT INTO public.europe_data VALUES (2845, 0, 12, 0.98, 22, 15);
INSERT INTO public.europe_data VALUES (2846, 127, 12276, 628.06, 164, 15);
INSERT INTO public.europe_data VALUES (2847, 474, 107161, 215.29, 165, 15);
INSERT INTO public.europe_data VALUES (2848, 4, 434, 2.68, 23, 15);
INSERT INTO public.europe_data VALUES (2849, 0, 36, 391.62, 166, 15);
INSERT INTO public.europe_data VALUES (2850, 61, 10147, 145.08, 167, 15);
INSERT INTO public.europe_data VALUES (2851, 0, 0, 1.76, 80, 15);
INSERT INTO public.europe_data VALUES (2852, 0, 0, 0.89, 81, 15);
INSERT INTO public.europe_data VALUES (2853, 7, 477, 608.51, 205, 15);
INSERT INTO public.europe_data VALUES (2854, 94, 3317, 38.36, 82, 15);
INSERT INTO public.europe_data VALUES (2855, 0, 5, 18.61, 168, 15);
INSERT INTO public.europe_data VALUES (2856, 2, 526, 5.3, 24, 15);
INSERT INTO public.europe_data VALUES (2857, 0, 10, 1.25, 25, 15);
INSERT INTO public.europe_data VALUES (2858, 7, 185, 60.55, 83, 15);
INSERT INTO public.europe_data VALUES (2859, 0, 28, 1.15, 84, 15);
INSERT INTO public.europe_data VALUES (2860, 0, 0, 0, 169, 15);
INSERT INTO public.europe_data VALUES (2861, 52, 4998, 100.42, 85, 15);
INSERT INTO public.europe_data VALUES (2862, 417, 21217, 358.26, 170, 15);
INSERT INTO public.europe_data VALUES (2863, 1, 442, 233.9, 171, 15);
INSERT INTO public.europe_data VALUES (2864, 3593, 319354, 49.69, 112, 15);
INSERT INTO public.europe_data VALUES (2865, 644, 23072, 18.81, 113, 15);
INSERT INTO public.europe_data VALUES (2866, 2682, 51595, 108.68, 114, 15);
INSERT INTO public.europe_data VALUES (2867, 343, 23581, 123.77, 115, 15);
INSERT INTO public.europe_data VALUES (2868, 33, 4874, 245.5, 172, 15);
INSERT INTO public.europe_data VALUES (2869, 0, 5, 5.91, 173, 15);
INSERT INTO public.europe_data VALUES (2870, 157, 4983, 132.46, 116, 15);
INSERT INTO public.europe_data VALUES (2871, 1488, 183553, 488.89, 174, 15);
INSERT INTO public.europe_data VALUES (2872, 21, 417, 29.07, 86, 15);
INSERT INTO public.europe_data VALUES (2873, 56, 4739, 6.85, 117, 15);
INSERT INTO public.europe_data VALUES (2874, 0, 44, 77.92, 175, 15);
INSERT INTO public.europe_data VALUES (2875, 287, 22779, 379.07, 118, 15);
INSERT INTO public.europe_data VALUES (2876, 37, 3400, 29.05, 119, 15);
INSERT INTO public.europe_data VALUES (2877, 111, 6156, 20.92, 26, 15);
INSERT INTO public.europe_data VALUES (2878, 25, 2236, 182.82, 176, 15);
INSERT INTO public.europe_data VALUES (2879, 36, 4899, 246.92, 120, 15);
INSERT INTO public.europe_data VALUES (2880, 21, 3709, 114.61, 121, 15);
INSERT INTO public.europe_data VALUES (2881, 0, 0, 0.01, 122, 15);
INSERT INTO public.europe_data VALUES (2882, 18, 1458, 139.9, 177, 15);
INSERT INTO public.europe_data VALUES (2883, 78, 11227, 296.56, 123, 15);
INSERT INTO public.europe_data VALUES (2884, 0, 7, 5.36, 27, 15);
INSERT INTO public.europe_data VALUES (2885, 0, 33, 0.99, 28, 15);
INSERT INTO public.europe_data VALUES (2886, 76, 6032, 195.57, 29, 15);
INSERT INTO public.europe_data VALUES (2887, 2, 186, 852.05, 178, 15);
INSERT INTO public.europe_data VALUES (2888, 32, 5535, 293.4, 179, 15);
INSERT INTO public.europe_data VALUES (2889, 15, 4578, 1325.31, 180, 15);
INSERT INTO public.europe_data VALUES (2890, 0, 143, 1.12, 30, 15);
INSERT INTO public.europe_data VALUES (2891, 1, 42, 0.4, 31, 15);
INSERT INTO public.europe_data VALUES (2892, 20, 5940, 37.58, 124, 15);
INSERT INTO public.europe_data VALUES (2893, 1, 196, 92.47, 125, 15);
INSERT INTO public.europe_data VALUES (2894, 3, 55, 0.84, 32, 15);
INSERT INTO public.europe_data VALUES (2895, 8, 823, 336.54, 181, 15);
INSERT INTO public.europe_data VALUES (2896, 0, 1, 0, 206, 15);
INSERT INTO public.europe_data VALUES (2897, 0, 55, 2.52, 33, 15);
INSERT INTO public.europe_data VALUES (2898, 0, 11, 3.07, 34, 15);
INSERT INTO public.europe_data VALUES (2899, 2971, 38232, 61.27, 87, 15);
INSERT INTO public.europe_data VALUES (2900, 115, 5079, 235.75, 182, 15);
INSERT INTO public.europe_data VALUES (2901, 0, 60, 305.27, 183, 15);
INSERT INTO public.europe_data VALUES (2902, 0, 10, 0.78, 126, 15);
INSERT INTO public.europe_data VALUES (2903, 47, 1917, 498.09, 184, 15);
INSERT INTO public.europe_data VALUES (2904, 0, 0, 0, 88, 15);
INSERT INTO public.europe_data VALUES (2905, 461, 25063, 134.11, 35, 15);
INSERT INTO public.europe_data VALUES (2906, 7, 1002, 6.99, 36, 15);
INSERT INTO public.europe_data VALUES (2907, 163, 8631, 32.16, 127, 15);
INSERT INTO public.europe_data VALUES (2908, 0, 328, 27.86, 37, 15);
INSERT INTO public.europe_data VALUES (2909, 113, 15478, 144.44, 128, 15);
INSERT INTO public.europe_data VALUES (2910, 388, 68512, 759.18, 185, 15);
INSERT INTO public.europe_data VALUES (2911, 0, 1, 0.35, 208, 15);
INSERT INTO public.europe_data VALUES (2912, 0, 23, 1.61, 209, 15);
INSERT INTO public.europe_data VALUES (2913, 1, 80, 2.46, 89, 15);
INSERT INTO public.europe_data VALUES (2914, 0, 6, 0.05, 38, 15);
INSERT INTO public.europe_data VALUES (2915, 16, 972, 0.76, 39, 15);
INSERT INTO public.europe_data VALUES (2916, 85, 5482, 424.05, 186, 15);
INSERT INTO public.europe_data VALUES (2917, 0, 4, 17.48, 210, 15);
INSERT INTO public.europe_data VALUES (2918, 3, 2331, 64.32, 187, 15);
INSERT INTO public.europe_data VALUES (2919, 72, 2802, 116.2, 129, 15);
INSERT INTO public.europe_data VALUES (2920, 96, 6491, 5.38, 130, 15);
INSERT INTO public.europe_data VALUES (2921, 43, 3756, 145.8, 131, 15);
INSERT INTO public.europe_data VALUES (2922, 73, 5136, 225.86, 90, 15);
INSERT INTO public.europe_data VALUES (2923, 0, 2, 0.1, 211, 15);
INSERT INTO public.europe_data VALUES (2924, 109, 4137, 127.86, 91, 15);
INSERT INTO public.europe_data VALUES (2925, 380, 16196, 111.46, 92, 15);
INSERT INTO public.europe_data VALUES (2926, 261, 13085, 24.51, 132, 15);
INSERT INTO public.europe_data VALUES (2927, 1345, 126214, 537.58, 188, 15);
INSERT INTO public.europe_data VALUES (2928, 228, 25655, 432.34, 189, 15);
INSERT INTO public.europe_data VALUES (2929, 31, 4158, 319.36, 93, 15);
INSERT INTO public.europe_data VALUES (2930, 2, 1550, 116.13, 133, 15);
INSERT INTO public.europe_data VALUES (2931, 676, 37015, 341.37, 190, 15);
INSERT INTO public.europe_data VALUES (2932, 2185, 122904, 162.78, 191, 15);
INSERT INTO public.europe_data VALUES (2933, 1, 80, 1.36, 40, 15);
INSERT INTO public.europe_data VALUES (2934, 0, 0, 0, 94, 15);
INSERT INTO public.europe_data VALUES (2935, 0, 30, 27.9, 95, 15);
INSERT INTO public.europe_data VALUES (2936, 0, 2, 7.23, 96, 15);
INSERT INTO public.europe_data VALUES (2937, 0, 109, 490.52, 192, 15);
INSERT INTO public.europe_data VALUES (2938, 1, 9, 7.44, 41, 15);
INSERT INTO public.europe_data VALUES (2939, 106, 2781, 15.92, 134, 15);
INSERT INTO public.europe_data VALUES (2940, 4, 79, 1.3, 42, 15);
INSERT INTO public.europe_data VALUES (2941, 34, 8917, 175.81, 193, 15);
INSERT INTO public.europe_data VALUES (2942, 0, 0, 4.09, 43, 15);
INSERT INTO public.europe_data VALUES (2943, 0, 20, 0.46, 44, 15);
INSERT INTO public.europe_data VALUES (2944, 0, 49, 1.86, 135, 15);
INSERT INTO public.europe_data VALUES (2945, 0, 47, 184.01, 97, 15);
INSERT INTO public.europe_data VALUES (2946, 60, 16103, 552.45, 194, 15);
INSERT INTO public.europe_data VALUES (2947, 53, 12699, 1081.5, 195, 15);
INSERT INTO public.europe_data VALUES (2948, 0, 4, 0.75, 212, 15);
INSERT INTO public.europe_data VALUES (2949, 0, 0, 0.5, 45, 15);
INSERT INTO public.europe_data VALUES (2950, 443, 10955, 39.33, 46, 15);
INSERT INTO public.europe_data VALUES (2951, 11, 777, 2.84, 136, 15);
INSERT INTO public.europe_data VALUES (2952, 3, 43, 0.76, 47, 15);
INSERT INTO public.europe_data VALUES (2953, 1226, 142377, 567.24, 196, 15);
INSERT INTO public.europe_data VALUES (2954, 6, 3188, 25.9, 137, 15);
INSERT INTO public.europe_data VALUES (2955, 0, 77, 0.3, 48, 15);
INSERT INTO public.europe_data VALUES (2956, 2, 40, 13.76, 98, 15);
INSERT INTO public.europe_data VALUES (2957, 82, 18475, 270.09, 197, 15);
INSERT INTO public.europe_data VALUES (2958, 159, 50405, 928.15, 198, 15);
INSERT INTO public.europe_data VALUES (2959, 23, 381, 4.17, 138, 15);
INSERT INTO public.europe_data VALUES (2960, 0, 13, 0.1, 139, 15);
INSERT INTO public.europe_data VALUES (2961, 1, 278, 6.02, 140, 15);
INSERT INTO public.europe_data VALUES (2962, 0, 44, 0.14, 141, 15);
INSERT INTO public.europe_data VALUES (2963, 0, 1, 0.08, 142, 15);
INSERT INTO public.europe_data VALUES (2964, 5, 157, 3.71, 49, 15);
INSERT INTO public.europe_data VALUES (2965, 2, 157, 26.6, 99, 15);
INSERT INTO public.europe_data VALUES (2966, 562, 13107, 182.68, 50, 15);
INSERT INTO public.europe_data VALUES (2967, 527, 62782, 151.46, 199, 15);
INSERT INTO public.europe_data VALUES (2968, 0, 3, 15.71, 100, 15);
INSERT INTO public.europe_data VALUES (2969, 11, 1300, 4.86, 51, 15);
INSERT INTO public.europe_data VALUES (2970, 915, 51951, 208.67, 200, 15);
INSERT INTO public.europe_data VALUES (2971, 19, 8784, 187.35, 143, 15);
INSERT INTO public.europe_data VALUES (2972, 1821, 161114, 468.9, 201, 15);
INSERT INTO public.europe_data VALUES (2973, 0, 0, 0, 52, 15);
INSERT INTO public.europe_data VALUES (2974, 5766, 571197, 319.93, 101, 15);
INSERT INTO public.europe_data VALUES (2975, 0, 28, 39.2, 102, 15);
INSERT INTO public.europe_data VALUES (2976, 6, 298, 17.85, 103, 15);
INSERT INTO public.europe_data VALUES (2977, 20, 1676, 11.3, 144, 15);
INSERT INTO public.europe_data VALUES (2978, 28, 2760, 19.95, 104, 15);
INSERT INTO public.europe_data VALUES (2979, 0, 12, 0.05, 145, 15);
INSERT INTO public.europe_data VALUES (2980, 0, 0, 0, 214, 15);
INSERT INTO public.europe_data VALUES (2981, 0, 0, 0, 53, 15);
INSERT INTO public.europe_data VALUES (2982, 1, 0, 0.01, 146, 15);
INSERT INTO public.europe_data VALUES (2983, 1, 363, 3.51, 54, 15);
INSERT INTO public.europe_data VALUES (2984, 6, 98, 1.55, 55, 15);
INSERT INTO public.europe_data VALUES (2985, 22, 633, 2.72, 105, 16);
INSERT INTO public.europe_data VALUES (2986, 26, 2102, 131.29, 147, 16);
INSERT INTO public.europe_data VALUES (2987, 58, 1741, 7.13, 1, 16);
INSERT INTO public.europe_data VALUES (2988, 10, 661, 1761.69, 148, 16);
INSERT INTO public.europe_data VALUES (2989, 26, 1564, 8.74, 2, 16);
INSERT INTO public.europe_data VALUES (2990, 0, 0, 0, 56, 16);
INSERT INTO public.europe_data VALUES (2991, 0, 5, 13.39, 57, 16);
INSERT INTO public.europe_data VALUES (2992, 2629, 100909, 438.54, 58, 16);
INSERT INTO public.europe_data VALUES (2993, 115, 14116, 755.95, 149, 16);
INSERT INTO public.europe_data VALUES (2994, 2, 98, 212.59, 59, 16);
INSERT INTO public.europe_data VALUES (2995, 1, 130, 1.02, 202, 16);
INSERT INTO public.europe_data VALUES (2996, 74, 16979, 299.74, 150, 16);
INSERT INTO public.europe_data VALUES (2997, 45, 4995, 79.39, 151, 16);
INSERT INTO public.europe_data VALUES (2998, 10, 707, 341.99, 60, 16);
INSERT INTO public.europe_data VALUES (2999, 12, 2353, 302.71, 106, 16);
INSERT INTO public.europe_data VALUES (3000, 143, 10246, 12.6, 107, 16);
INSERT INTO public.europe_data VALUES (3001, 0, 5, 6.62, 61, 16);
INSERT INTO public.europe_data VALUES (3002, 28, 5125, 98.27, 152, 16);
INSERT INTO public.europe_data VALUES (3003, 502, 105329, 1549.69, 153, 16);
INSERT INTO public.europe_data VALUES (3004, 6, 332, 183.94, 62, 16);
INSERT INTO public.europe_data VALUES (3005, 0, 61, 1.24, 3, 16);
INSERT INTO public.europe_data VALUES (3006, 0, 6, 11.2, 63, 16);
INSERT INTO public.europe_data VALUES (3007, 0, 15, 4.32, 108, 16);
INSERT INTO public.europe_data VALUES (3008, 164, 1082, 19.79, 64, 16);
INSERT INTO public.europe_data VALUES (3009, 1, 0, 7.7, 65, 16);
INSERT INTO public.europe_data VALUES (3010, 102, 6774, 310.48, 154, 16);
INSERT INTO public.europe_data VALUES (3011, 1, 681, 60.9, 4, 16);
INSERT INTO public.europe_data VALUES (3012, 3229, 158784, 141.74, 66, 16);
INSERT INTO public.europe_data VALUES (3013, 0, 1, 3.33, 67, 16);
INSERT INTO public.europe_data VALUES (3014, 0, 1, 0.46, 109, 16);
INSERT INTO public.europe_data VALUES (3015, 108, 8386, 192.67, 155, 16);
INSERT INTO public.europe_data VALUES (3016, 0, 70, 0.84, 5, 16);
INSERT INTO public.europe_data VALUES (3017, 0, 14, 0.28, 6, 16);
INSERT INTO public.europe_data VALUES (3018, 0, 4, 0.02, 110, 16);
INSERT INTO public.europe_data VALUES (3019, 2, 129, 1.42, 7, 16);
INSERT INTO public.europe_data VALUES (3020, 186, 17956, 101.54, 68, 16);
INSERT INTO public.europe_data VALUES (3021, 8, 644, 240.76, 8, 16);
INSERT INTO public.europe_data VALUES (3022, 0, 6, 27.71, 69, 16);
INSERT INTO public.europe_data VALUES (3023, 0, 7, 0.17, 9, 16);
INSERT INTO public.europe_data VALUES (3024, 3, 58, 0.83, 10, 16);
INSERT INTO public.europe_data VALUES (3025, 309, 10303, 109.18, 70, 16);
INSERT INTO public.europe_data VALUES (3026, 0, 179, 0.02, 111, 16);
INSERT INTO public.europe_data VALUES (3027, 1184, 56313, 207.73, 71, 16);
INSERT INTO public.europe_data VALUES (3028, 0, 15, 2.59, 11, 16);
INSERT INTO public.europe_data VALUES (3029, 0, 97, 2.51, 12, 16);
INSERT INTO public.europe_data VALUES (3030, 99, 7574, 310.03, 72, 16);
INSERT INTO public.europe_data VALUES (3031, 1, 147, 1.23, 13, 16);
INSERT INTO public.europe_data VALUES (3032, 74, 10800, 391.05, 156, 16);
INSERT INTO public.europe_data VALUES (3033, 3, 346, 5.19, 73, 16);
INSERT INTO public.europe_data VALUES (3034, 0, 114, 168.27, 74, 16);
INSERT INTO public.europe_data VALUES (3035, 0, 901, 177.99, 157, 16);
INSERT INTO public.europe_data VALUES (3036, 779, 84212, 1323.85, 158, 16);
INSERT INTO public.europe_data VALUES (3037, 2, 91, 0.34, 14, 16);
INSERT INTO public.europe_data VALUES (3038, 22, 4964, 136.65, 159, 16);
INSERT INTO public.europe_data VALUES (3039, 0, 77, 11.61, 15, 16);
INSERT INTO public.europe_data VALUES (3040, 0, 5, 8.36, 75, 16);
INSERT INTO public.europe_data VALUES (3041, 24, 3180, 56.34, 76, 16);
INSERT INTO public.europe_data VALUES (3042, 166, 8346, 84.05, 77, 16);
INSERT INTO public.europe_data VALUES (3043, 79, 1116, 2.14, 16, 16);
INSERT INTO public.europe_data VALUES (3044, 31, 919, 37.02, 78, 16);
INSERT INTO public.europe_data VALUES (3045, 0, 9, 1.18, 17, 16);
INSERT INTO public.europe_data VALUES (3046, 0, 36, 1.34, 18, 16);
INSERT INTO public.europe_data VALUES (3047, 5, 333, 41.21, 160, 16);
INSERT INTO public.europe_data VALUES (3048, 0, 74, 16.11, 19, 16);
INSERT INTO public.europe_data VALUES (3049, 74, 4206, 8.07, 20, 16);
INSERT INTO public.europe_data VALUES (3050, 0, 0, 0, 79, 16);
INSERT INTO public.europe_data VALUES (3051, 0, 5, 26.71, 161, 16);
INSERT INTO public.europe_data VALUES (3052, 0, 1, 0.11, 203, 16);
INSERT INTO public.europe_data VALUES (3053, 2, 1424, 51.65, 162, 16);
INSERT INTO public.europe_data VALUES (3054, 1284, 241473, 602.17, 163, 16);
INSERT INTO public.europe_data VALUES (3055, 6, 2000, 1111.77, 204, 16);
INSERT INTO public.europe_data VALUES (3056, 0, 38, 3.87, 21, 16);
INSERT INTO public.europe_data VALUES (3057, 1, 11, 1.19, 22, 16);
INSERT INTO public.europe_data VALUES (3058, 79, 12826, 463.1, 164, 16);
INSERT INTO public.europe_data VALUES (3059, 267, 71567, 135.55, 165, 16);
INSERT INTO public.europe_data VALUES (3060, 6, 380, 2.25, 23, 16);
INSERT INTO public.europe_data VALUES (3061, 0, 96, 539.96, 166, 16);
INSERT INTO public.europe_data VALUES (3062, 65, 5412, 78.55, 167, 16);
INSERT INTO public.europe_data VALUES (3063, 0, 1, 1.76, 80, 16);
INSERT INTO public.europe_data VALUES (3064, 0, 1, 3.57, 81, 16);
INSERT INTO public.europe_data VALUES (3065, 6, 541, 680.24, 205, 16);
INSERT INTO public.europe_data VALUES (3066, 114, 3427, 40.22, 82, 16);
INSERT INTO public.europe_data VALUES (3067, 0, 7, 10.86, 168, 16);
INSERT INTO public.europe_data VALUES (3068, 1, 151, 5.07, 24, 16);
INSERT INTO public.europe_data VALUES (3069, 0, 14, 0.94, 25, 16);
INSERT INTO public.europe_data VALUES (3070, 10, 289, 70.77, 83, 16);
INSERT INTO public.europe_data VALUES (3071, 1, 101, 1.28, 84, 16);
INSERT INTO public.europe_data VALUES (3072, 0, 0, 1717.79, 169, 16);
INSERT INTO public.europe_data VALUES (3073, 55, 4789, 93.71, 85, 16);
INSERT INTO public.europe_data VALUES (3074, 299, 13795, 235.2, 170, 16);
INSERT INTO public.europe_data VALUES (3075, 0, 393, 258.27, 171, 16);
INSERT INTO public.europe_data VALUES (3076, 4404, 359686, 57.77, 112, 16);
INSERT INTO public.europe_data VALUES (3077, 788, 27845, 20.79, 113, 16);
INSERT INTO public.europe_data VALUES (3078, 2241, 38516, 83, 114, 16);
INSERT INTO public.europe_data VALUES (3079, 369, 25073, 125.61, 115, 16);
INSERT INTO public.europe_data VALUES (3080, 30, 7166, 297.7, 172, 16);
INSERT INTO public.europe_data VALUES (3081, 0, 0, 2.36, 173, 16);
INSERT INTO public.europe_data VALUES (3082, 188, 6302, 215.04, 116, 16);
INSERT INTO public.europe_data VALUES (3083, 795, 111541, 283.02, 174, 16);
INSERT INTO public.europe_data VALUES (3084, 17, 440, 33.78, 86, 16);
INSERT INTO public.europe_data VALUES (3085, 44, 3947, 6.09, 117, 16);
INSERT INTO public.europe_data VALUES (3086, 0, 40, 75.14, 175, 16);
INSERT INTO public.europe_data VALUES (3087, 234, 15514, 278.77, 118, 16);
INSERT INTO public.europe_data VALUES (3088, 40, 1990, 20.07, 119, 16);
INSERT INTO public.europe_data VALUES (3089, 70, 4840, 15.55, 26, 16);
INSERT INTO public.europe_data VALUES (3090, 10, 1052, 98.08, 176, 16);
INSERT INTO public.europe_data VALUES (3091, 45, 5489, 250.03, 120, 16);
INSERT INTO public.europe_data VALUES (3092, 23, 3644, 108.17, 121, 16);
INSERT INTO public.europe_data VALUES (3093, 0, 1, 0.01, 122, 16);
INSERT INTO public.europe_data VALUES (3094, 14, 1228, 104.59, 177, 16);
INSERT INTO public.europe_data VALUES (3095, 45, 9104, 274.69, 123, 16);
INSERT INTO public.europe_data VALUES (3096, 1, 107, 6.35, 27, 16);
INSERT INTO public.europe_data VALUES (3097, 0, 16, 0.61, 28, 16);
INSERT INTO public.europe_data VALUES (3098, 70, 7223, 196.25, 29, 16);
INSERT INTO public.europe_data VALUES (3099, 0, 141, 591.48, 178, 16);
INSERT INTO public.europe_data VALUES (3100, 21, 2663, 145.37, 179, 16);
INSERT INTO public.europe_data VALUES (3101, 12, 3558, 789.06, 180, 16);
INSERT INTO public.europe_data VALUES (3102, 6, 158, 0.93, 30, 16);
INSERT INTO public.europe_data VALUES (3103, 2, 33, 0.37, 31, 16);
INSERT INTO public.europe_data VALUES (3104, 42, 6067, 34.14, 124, 16);
INSERT INTO public.europe_data VALUES (3105, 0, 295, 115.08, 125, 16);
INSERT INTO public.europe_data VALUES (3106, 1, 111, 1.04, 32, 16);
INSERT INTO public.europe_data VALUES (3107, 8, 838, 350.92, 181, 16);
INSERT INTO public.europe_data VALUES (3108, 0, 59, 2.47, 33, 16);
INSERT INTO public.europe_data VALUES (3109, 0, 28, 3.15, 34, 16);
INSERT INTO public.europe_data VALUES (3110, 2757, 39933, 45.79, 87, 16);
INSERT INTO public.europe_data VALUES (3111, 101, 4453, 231.3, 182, 16);
INSERT INTO public.europe_data VALUES (3112, 0, 41, 217.62, 183, 16);
INSERT INTO public.europe_data VALUES (3113, 0, 15, 0.65, 126, 16);
INSERT INTO public.europe_data VALUES (3114, 30, 1182, 470.6, 184, 16);
INSERT INTO public.europe_data VALUES (3115, 0, 0, 0, 88, 16);
INSERT INTO public.europe_data VALUES (3116, 373, 23849, 123.59, 35, 16);
INSERT INTO public.europe_data VALUES (3117, 11, 1120, 6.54, 36, 16);
INSERT INTO public.europe_data VALUES (3118, 215, 8749, 31.08, 127, 16);
INSERT INTO public.europe_data VALUES (3119, 2, 367, 29.02, 37, 16);
INSERT INTO public.europe_data VALUES (3120, 108, 25843, 175.94, 128, 16);
INSERT INTO public.europe_data VALUES (3121, 285, 62691, 673.96, 185, 16);
INSERT INTO public.europe_data VALUES (3122, 0, 0, 0, 208, 16);
INSERT INTO public.europe_data VALUES (3123, 0, 54, 1.44, 209, 16);
INSERT INTO public.europe_data VALUES (3124, 1, 81, 2.6, 89, 16);
INSERT INTO public.europe_data VALUES (3125, 0, 5, 0.06, 38, 16);
INSERT INTO public.europe_data VALUES (3126, 5, 552, 0.86, 39, 16);
INSERT INTO public.europe_data VALUES (3127, 85, 3326, 289.68, 186, 16);
INSERT INTO public.europe_data VALUES (3128, 0, 6, 26.22, 210, 16);
INSERT INTO public.europe_data VALUES (3129, 1, 1096, 37.74, 187, 16);
INSERT INTO public.europe_data VALUES (3130, 73, 2979, 141.55, 129, 16);
INSERT INTO public.europe_data VALUES (3131, 80, 5150, 4.47, 130, 16);
INSERT INTO public.europe_data VALUES (3132, 39, 3507, 130.28, 131, 16);
INSERT INTO public.europe_data VALUES (3133, 69, 4455, 209.28, 90, 16);
INSERT INTO public.europe_data VALUES (3134, 0, 7, 0.39, 211, 16);
INSERT INTO public.europe_data VALUES (3135, 121, 4870, 140.8, 91, 16);
INSERT INTO public.europe_data VALUES (3136, 390, 20040, 121.02, 92, 16);
INSERT INTO public.europe_data VALUES (3137, 325, 13410, 28.38, 132, 16);
INSERT INTO public.europe_data VALUES (3138, 865, 77922, 336.75, 188, 16);
INSERT INTO public.europe_data VALUES (3139, 135, 18775, 311.6, 189, 16);
INSERT INTO public.europe_data VALUES (3140, 35, 5210, 301.08, 93, 16);
INSERT INTO public.europe_data VALUES (3141, 6, 1739, 112.46, 133, 16);
INSERT INTO public.europe_data VALUES (3142, 519, 29260, 280.02, 190, 16);
INSERT INTO public.europe_data VALUES (3143, 1863, 114543, 147.5, 191, 16);
INSERT INTO public.europe_data VALUES (3144, 0, 92, 1.35, 40, 16);
INSERT INTO public.europe_data VALUES (3145, 0, 0, 0, 94, 16);
INSERT INTO public.europe_data VALUES (3146, 0, 21, 13.68, 95, 16);
INSERT INTO public.europe_data VALUES (3147, 0, 6, 8.14, 96, 16);
INSERT INTO public.europe_data VALUES (3148, 0, 60, 194.47, 192, 16);
INSERT INTO public.europe_data VALUES (3149, 0, 7, 5.12, 41, 16);
INSERT INTO public.europe_data VALUES (3150, 111, 2673, 16.36, 134, 16);
INSERT INTO public.europe_data VALUES (3151, 4, 133, 1.74, 42, 16);
INSERT INTO public.europe_data VALUES (3152, 16, 3326, 67.48, 193, 16);
INSERT INTO public.europe_data VALUES (3153, 0, 4, 5.12, 43, 16);
INSERT INTO public.europe_data VALUES (3154, 1, 16, 0.51, 44, 16);
INSERT INTO public.europe_data VALUES (3155, 0, 59, 1.62, 135, 16);
INSERT INTO public.europe_data VALUES (3156, 0, 31, 174.57, 97, 16);
INSERT INTO public.europe_data VALUES (3157, 71, 14008, 440.19, 194, 16);
INSERT INTO public.europe_data VALUES (3158, 22, 9806, 686.48, 195, 16);
INSERT INTO public.europe_data VALUES (3159, 0, 1, 0.6, 212, 16);
INSERT INTO public.europe_data VALUES (3160, 5, 77, 0.5, 45, 16);
INSERT INTO public.europe_data VALUES (3161, 497, 12075, 39.96, 46, 16);
INSERT INTO public.europe_data VALUES (3162, 13, 680, 2.44, 136, 16);
INSERT INTO public.europe_data VALUES (3163, 1, 41, 0.96, 47, 16);
INSERT INTO public.europe_data VALUES (3164, 1039, 123871, 446.03, 196, 16);
INSERT INTO public.europe_data VALUES (3165, 2, 2334, 14.63, 137, 16);
INSERT INTO public.europe_data VALUES (3166, 1, 51, 0.17, 48, 16);
INSERT INTO public.europe_data VALUES (3167, 0, 40, 20.47, 98, 16);
INSERT INTO public.europe_data VALUES (3168, 43, 9156, 144.44, 197, 16);
INSERT INTO public.europe_data VALUES (3169, 53, 28901, 504.33, 198, 16);
INSERT INTO public.europe_data VALUES (3170, 21, 331, 4.31, 138, 16);
INSERT INTO public.europe_data VALUES (3171, 0, 10, 0.1, 139, 16);
INSERT INTO public.europe_data VALUES (3172, 1, 283, 5.94, 140, 16);
INSERT INTO public.europe_data VALUES (3173, 0, 52, 0.15, 141, 16);
INSERT INTO public.europe_data VALUES (3174, 0, 0, 0.08, 142, 16);
INSERT INTO public.europe_data VALUES (3175, 1, 143, 3.22, 49, 16);
INSERT INTO public.europe_data VALUES (3176, 9, 214, 29.39, 99, 16);
INSERT INTO public.europe_data VALUES (3177, 193, 8257, 149.98, 50, 16);
INSERT INTO public.europe_data VALUES (3178, 503, 61418, 146.93, 199, 16);
INSERT INTO public.europe_data VALUES (3179, 0, 3, 15.71, 100, 16);
INSERT INTO public.europe_data VALUES (3180, 4, 853, 3.71, 51, 16);
INSERT INTO public.europe_data VALUES (3181, 718, 39851, 187.42, 200, 16);
INSERT INTO public.europe_data VALUES (3182, 14, 9521, 193.38, 143, 16);
INSERT INTO public.europe_data VALUES (3183, 1250, 151391, 405.24, 201, 16);
INSERT INTO public.europe_data VALUES (3184, 0, 0, 0, 52, 16);
INSERT INTO public.europe_data VALUES (3185, 5556, 481570, 265.49, 101, 16);
INSERT INTO public.europe_data VALUES (3186, 0, 13, 21.99, 102, 16);
INSERT INTO public.europe_data VALUES (3187, 2, 320, 16.09, 103, 16);
INSERT INTO public.europe_data VALUES (3188, 21, 2050, 13.29, 144, 16);
INSERT INTO public.europe_data VALUES (3189, 37, 2929, 22.54, 104, 16);
INSERT INTO public.europe_data VALUES (3190, 0, 34, 0.06, 145, 16);
INSERT INTO public.europe_data VALUES (3191, 0, 0, 0, 214, 16);
INSERT INTO public.europe_data VALUES (3192, 0, 0, 0, 53, 16);
INSERT INTO public.europe_data VALUES (3193, 2, 4, 0.03, 146, 16);
INSERT INTO public.europe_data VALUES (3194, 2, 264, 3.69, 54, 16);
INSERT INTO public.europe_data VALUES (3195, 6, 129, 1.81, 55, 16);
INSERT INTO public.europe_data VALUES (3196, 15, 401, 2.26, 105, 17);
INSERT INTO public.europe_data VALUES (3197, 31, 1656, 97.43, 147, 17);
INSERT INTO public.europe_data VALUES (3198, 55, 1330, 5.26, 1, 17);
INSERT INTO public.europe_data VALUES (3199, 4, 681, 1663.23, 148, 17);
INSERT INTO public.europe_data VALUES (3200, 23, 1216, 6.57, 2, 17);
INSERT INTO public.europe_data VALUES (3201, 0, 0, 0, 56, 17);
INSERT INTO public.europe_data VALUES (3202, 0, 8, 12.36, 57, 17);
INSERT INTO public.europe_data VALUES (3203, 2399, 95474, 426.96, 58, 17);
INSERT INTO public.europe_data VALUES (3204, 61, 8243, 412.41, 149, 17);
INSERT INTO public.europe_data VALUES (3205, 2, 128, 228.58, 59, 17);
INSERT INTO public.europe_data VALUES (3206, 6, 126, 1.01, 202, 17);
INSERT INTO public.europe_data VALUES (3207, 46, 9574, 191.21, 150, 17);
INSERT INTO public.europe_data VALUES (3208, 17, 2982, 42.53, 151, 17);
INSERT INTO public.europe_data VALUES (3209, 15, 625, 332.23, 60, 17);
INSERT INTO public.europe_data VALUES (3210, 27, 2615, 319.29, 106, 17);
INSERT INTO public.europe_data VALUES (3211, 136, 10303, 12.19, 107, 17);
INSERT INTO public.europe_data VALUES (3212, 0, 14, 8.01, 61, 17);
INSERT INTO public.europe_data VALUES (3213, 33, 4164, 78.32, 152, 17);
INSERT INTO public.europe_data VALUES (3214, 236, 72196, 969.19, 153, 17);
INSERT INTO public.europe_data VALUES (3215, 9, 386, 158.06, 62, 17);
INSERT INTO public.europe_data VALUES (3216, 0, 85, 1.18, 3, 17);
INSERT INTO public.europe_data VALUES (3217, 0, 1, 6.4, 63, 17);
INSERT INTO public.europe_data VALUES (3218, 0, 18, 3.8, 108, 17);
INSERT INTO public.europe_data VALUES (3219, 173, 1197, 25.21, 64, 17);
INSERT INTO public.europe_data VALUES (3220, 0, 2, 100.07, 65, 17);
INSERT INTO public.europe_data VALUES (3221, 63, 3475, 186.16, 154, 17);
INSERT INTO public.europe_data VALUES (3222, 2, 722, 89.86, 4, 17);
INSERT INTO public.europe_data VALUES (3223, 3417, 140362, 151.65, 66, 17);
INSERT INTO public.europe_data VALUES (3224, 0, 0, 0, 67, 17);
INSERT INTO public.europe_data VALUES (3225, 0, 1, 0.23, 109, 17);
INSERT INTO public.europe_data VALUES (3226, 94, 5101, 113.09, 155, 17);
INSERT INTO public.europe_data VALUES (3227, 2, 101, 1.05, 5, 17);
INSERT INTO public.europe_data VALUES (3228, 0, 18, 0.25, 6, 17);
INSERT INTO public.europe_data VALUES (3229, 0, 0, 0.02, 110, 17);
INSERT INTO public.europe_data VALUES (3230, 0, 238, 2, 7, 17);
INSERT INTO public.europe_data VALUES (3231, 175, 20031, 85.51, 68, 17);
INSERT INTO public.europe_data VALUES (3232, 11, 680, 253.12, 8, 17);
INSERT INTO public.europe_data VALUES (3233, 0, 12, 30.79, 69, 17);
INSERT INTO public.europe_data VALUES (3234, 0, 1, 0.21, 9, 17);
INSERT INTO public.europe_data VALUES (3235, 1, 75, 1.02, 10, 17);
INSERT INTO public.europe_data VALUES (3236, 317, 10389, 113.87, 70, 17);
INSERT INTO public.europe_data VALUES (3237, 0, 160, 0.02, 111, 17);
INSERT INTO public.europe_data VALUES (3238, 1136, 48256, 207.63, 71, 17);
INSERT INTO public.europe_data VALUES (3239, 0, 7, 1.76, 11, 17);
INSERT INTO public.europe_data VALUES (3240, 2, 38, 1.25, 12, 17);
INSERT INTO public.europe_data VALUES (3241, 107, 8075, 323.56, 72, 17);
INSERT INTO public.europe_data VALUES (3242, 1, 169, 1.71, 13, 17);
INSERT INTO public.europe_data VALUES (3243, 39, 5140, 194.32, 156, 17);
INSERT INTO public.europe_data VALUES (3244, 2, 242, 3.63, 73, 17);
INSERT INTO public.europe_data VALUES (3245, 0, 161, 178.68, 74, 17);
INSERT INTO public.europe_data VALUES (3246, 0, 658, 93.62, 157, 17);
INSERT INTO public.europe_data VALUES (3247, 388, 56775, 858.6, 158, 17);
INSERT INTO public.europe_data VALUES (3248, 27, 201, 0.34, 14, 17);
INSERT INTO public.europe_data VALUES (3249, 11, 2970, 98.38, 159, 17);
INSERT INTO public.europe_data VALUES (3250, 0, 36, 4.11, 15, 17);
INSERT INTO public.europe_data VALUES (3251, 0, 1, 2.79, 75, 17);
INSERT INTO public.europe_data VALUES (3252, 26, 2870, 63.94, 76, 17);
INSERT INTO public.europe_data VALUES (3253, 196, 6256, 70.54, 77, 17);
INSERT INTO public.europe_data VALUES (3254, 80, 1037, 1.73, 16, 17);
INSERT INTO public.europe_data VALUES (3255, 28, 1470, 34.34, 78, 17);
INSERT INTO public.europe_data VALUES (3256, 0, 7, 1.84, 17, 17);
INSERT INTO public.europe_data VALUES (3257, 0, 11, 0.77, 18, 17);
INSERT INTO public.europe_data VALUES (3258, 0, 213, 35.55, 160, 17);
INSERT INTO public.europe_data VALUES (3259, 3, 111, 18.38, 19, 17);
INSERT INTO public.europe_data VALUES (3260, 65, 4842, 9.21, 20, 17);
INSERT INTO public.europe_data VALUES (3261, 0, 0, 0, 79, 17);
INSERT INTO public.europe_data VALUES (3262, 0, 8, 22.6, 161, 17);
INSERT INTO public.europe_data VALUES (3263, 0, 0, 0, 203, 17);
INSERT INTO public.europe_data VALUES (3264, 5, 1426, 52.3, 162, 17);
INSERT INTO public.europe_data VALUES (3265, 747, 162060, 414.64, 163, 17);
INSERT INTO public.europe_data VALUES (3266, 4, 1105, 656.32, 204, 17);
INSERT INTO public.europe_data VALUES (3267, 0, 46, 3.87, 21, 17);
INSERT INTO public.europe_data VALUES (3268, 1, 17, 2.34, 22, 17);
INSERT INTO public.europe_data VALUES (3269, 51, 5683, 234.16, 164, 17);
INSERT INTO public.europe_data VALUES (3270, 168, 40968, 79.11, 165, 17);
INSERT INTO public.europe_data VALUES (3271, 4, 305, 1.58, 23, 17);
INSERT INTO public.europe_data VALUES (3272, 0, 86, 412.39, 166, 17);
INSERT INTO public.europe_data VALUES (3273, 60, 3012, 51.55, 167, 17);
INSERT INTO public.europe_data VALUES (3274, 0, 0, 3.53, 80, 17);
INSERT INTO public.europe_data VALUES (3275, 0, 3, 2.68, 81, 17);
INSERT INTO public.europe_data VALUES (3276, 6, 597, 583.4, 205, 17);
INSERT INTO public.europe_data VALUES (3277, 146, 3645, 42.07, 82, 17);
INSERT INTO public.europe_data VALUES (3278, 0, 0, 1.55, 168, 17);
INSERT INTO public.europe_data VALUES (3279, 1, 496, 5.98, 24, 17);
INSERT INTO public.europe_data VALUES (3280, 1, 4, 1.41, 25, 17);
INSERT INTO public.europe_data VALUES (3281, 6, 265, 81.89, 83, 17);
INSERT INTO public.europe_data VALUES (3282, 1, 43, 0.94, 84, 17);
INSERT INTO public.europe_data VALUES (3283, 0, 14, 1717.79, 169, 17);
INSERT INTO public.europe_data VALUES (3284, 56, 4344, 90.25, 85, 17);
INSERT INTO public.europe_data VALUES (3285, 205, 9191, 166.67, 170, 17);
INSERT INTO public.europe_data VALUES (3286, 1, 529, 317.66, 171, 17);
INSERT INTO public.europe_data VALUES (3287, 5460, 429735, 67.8, 112, 17);
INSERT INTO public.europe_data VALUES (3288, 667, 28418, 21.57, 113, 17);
INSERT INTO public.europe_data VALUES (3289, 1831, 30305, 70.69, 114, 17);
INSERT INTO public.europe_data VALUES (3290, 402, 24304, 120.82, 115, 17);
INSERT INTO public.europe_data VALUES (3291, 26, 7434, 243.26, 172, 17);
INSERT INTO public.europe_data VALUES (3292, 0, 2, 7.09, 173, 17);
INSERT INTO public.europe_data VALUES (3293, 226, 12018, 418.7, 116, 17);
INSERT INTO public.europe_data VALUES (3294, 377, 59291, 147.3, 174, 17);
INSERT INTO public.europe_data VALUES (3295, 32, 556, 46.77, 86, 17);
INSERT INTO public.europe_data VALUES (3296, 45, 3780, 5.82, 117, 17);
INSERT INTO public.europe_data VALUES (3297, 0, 41, 64.01, 175, 17);
INSERT INTO public.europe_data VALUES (3298, 154, 12647, 217.12, 118, 17);
INSERT INTO public.europe_data VALUES (3299, 36, 1733, 19.56, 119, 17);
INSERT INTO public.europe_data VALUES (3300, 66, 3335, 10.37, 26, 17);
INSERT INTO public.europe_data VALUES (3301, 6, 712, 59.88, 176, 17);
INSERT INTO public.europe_data VALUES (3302, 43, 5030, 216.8, 120, 17);
INSERT INTO public.europe_data VALUES (3303, 26, 3296, 76.23, 121, 17);
INSERT INTO public.europe_data VALUES (3304, 0, 0, 0, 122, 17);
INSERT INTO public.europe_data VALUES (3305, 2, 780, 71.04, 177, 17);
INSERT INTO public.europe_data VALUES (3306, 65, 9728, 259.7, 123, 17);
INSERT INTO public.europe_data VALUES (3307, 0, 28, 7.2, 27, 17);
INSERT INTO public.europe_data VALUES (3308, 0, 14, 0.59, 28, 17);
INSERT INTO public.europe_data VALUES (3309, 94, 6078, 176.78, 29, 17);
INSERT INTO public.europe_data VALUES (3310, 0, 86, 255.35, 178, 17);
INSERT INTO public.europe_data VALUES (3311, 10, 1399, 83.6, 179, 17);
INSERT INTO public.europe_data VALUES (3312, 3, 1286, 315.53, 180, 17);
INSERT INTO public.europe_data VALUES (3313, 1, 92, 0.93, 30, 17);
INSERT INTO public.europe_data VALUES (3314, 1, 36, 0.38, 31, 17);
INSERT INTO public.europe_data VALUES (3315, 30, 4841, 25.41, 124, 17);
INSERT INTO public.europe_data VALUES (3316, 2, 316, 128.07, 125, 17);
INSERT INTO public.europe_data VALUES (3317, 0, 93, 0.99, 32, 17);
INSERT INTO public.europe_data VALUES (3318, 2, 894, 285.88, 181, 17);
INSERT INTO public.europe_data VALUES (3319, 0, 53, 1.83, 33, 17);
INSERT INTO public.europe_data VALUES (3320, 0, 12, 2.05, 34, 17);
INSERT INTO public.europe_data VALUES (3321, 2525, 18484, 37.97, 87, 17);
INSERT INTO public.europe_data VALUES (3322, 123, 4899, 258.97, 182, 17);
INSERT INTO public.europe_data VALUES (3323, 0, 31, 129.97, 183, 17);
INSERT INTO public.europe_data VALUES (3324, 0, 6, 0.31, 126, 17);
INSERT INTO public.europe_data VALUES (3325, 34, 1746, 560.61, 184, 17);
INSERT INTO public.europe_data VALUES (3326, 0, 0, 0, 88, 17);
INSERT INTO public.europe_data VALUES (3327, 323, 21228, 110.66, 35, 17);
INSERT INTO public.europe_data VALUES (3328, 4, 865, 5.5, 36, 17);
INSERT INTO public.europe_data VALUES (3329, 234, 8051, 33.73, 127, 17);
INSERT INTO public.europe_data VALUES (3330, 3, 357, 26.74, 37, 17);
INSERT INTO public.europe_data VALUES (3331, 103, 24491, 158.77, 128, 17);
INSERT INTO public.europe_data VALUES (3332, 176, 53784, 535.15, 185, 17);
INSERT INTO public.europe_data VALUES (3333, 0, 0, 0, 208, 17);
INSERT INTO public.europe_data VALUES (3334, 0, 15, 0.65, 209, 17);
INSERT INTO public.europe_data VALUES (3335, 1, 89, 2.8, 89, 17);
INSERT INTO public.europe_data VALUES (3336, 0, 9, 0.04, 38, 17);
INSERT INTO public.europe_data VALUES (3337, 10, 1174, 1.04, 39, 17);
INSERT INTO public.europe_data VALUES (3338, 42, 2691, 241.97, 186, 17);
INSERT INTO public.europe_data VALUES (3339, 0, 9, 22.72, 210, 17);
INSERT INTO public.europe_data VALUES (3340, 3, 915, 37.29, 187, 17);
INSERT INTO public.europe_data VALUES (3341, 63, 4063, 174.53, 129, 17);
INSERT INTO public.europe_data VALUES (3342, 89, 4520, 4.08, 130, 17);
INSERT INTO public.europe_data VALUES (3343, 34, 2983, 122.58, 131, 17);
INSERT INTO public.europe_data VALUES (3344, 73, 4432, 222.75, 90, 17);
INSERT INTO public.europe_data VALUES (3345, 0, 27, 0.47, 211, 17);
INSERT INTO public.europe_data VALUES (3346, 111, 5049, 149.65, 91, 17);
INSERT INTO public.europe_data VALUES (3347, 454, 19304, 124.59, 92, 17);
INSERT INTO public.europe_data VALUES (3348, 331, 17277, 31.56, 132, 17);
INSERT INTO public.europe_data VALUES (3349, 569, 49950, 204.43, 188, 17);
INSERT INTO public.europe_data VALUES (3350, 101, 13247, 210.81, 189, 17);
INSERT INTO public.europe_data VALUES (3351, 36, 3622, 225.61, 93, 17);
INSERT INTO public.europe_data VALUES (3352, 4, 1446, 103.56, 133, 17);
INSERT INTO public.europe_data VALUES (3353, 461, 25105, 238.6, 190, 17);
INSERT INTO public.europe_data VALUES (3354, 1590, 100616, 126.37, 191, 17);
INSERT INTO public.europe_data VALUES (3355, 3, 78, 0.86, 40, 17);
INSERT INTO public.europe_data VALUES (3356, 0, 0, 0, 94, 17);
INSERT INTO public.europe_data VALUES (3357, 0, 4, 3.28, 95, 17);
INSERT INTO public.europe_data VALUES (3358, 0, 3, 2.71, 96, 17);
INSERT INTO public.europe_data VALUES (3359, 0, 7, 78.37, 192, 17);
INSERT INTO public.europe_data VALUES (3360, 0, 4, 9.3, 41, 17);
INSERT INTO public.europe_data VALUES (3361, 142, 2935, 16.97, 134, 17);
INSERT INTO public.europe_data VALUES (3362, 3, 150, 1.99, 42, 17);
INSERT INTO public.europe_data VALUES (3363, 13, 1373, 32.44, 193, 17);
INSERT INTO public.europe_data VALUES (3364, 0, 1, 4.09, 43, 17);
INSERT INTO public.europe_data VALUES (3365, 1, 24, 0.78, 44, 17);
INSERT INTO public.europe_data VALUES (3366, 1, 35, 1.71, 135, 17);
INSERT INTO public.europe_data VALUES (3367, 0, 43, 174.57, 97, 17);
INSERT INTO public.europe_data VALUES (3368, 27, 9984, 306.32, 194, 17);
INSERT INTO public.europe_data VALUES (3369, 19, 4479, 319.38, 195, 17);
INSERT INTO public.europe_data VALUES (3370, 0, 3, 0, 212, 17);
INSERT INTO public.europe_data VALUES (3371, 0, 0, 0.77, 45, 17);
INSERT INTO public.europe_data VALUES (3372, 691, 11322, 38.43, 46, 17);
INSERT INTO public.europe_data VALUES (3373, 11, 572, 2.17, 136, 17);
INSERT INTO public.europe_data VALUES (3374, 0, 65, 1.05, 47, 17);
INSERT INTO public.europe_data VALUES (3375, 868, 85481, 343.09, 196, 17);
INSERT INTO public.europe_data VALUES (3376, 0, 786, 10.02, 137, 17);
INSERT INTO public.europe_data VALUES (3377, 0, 21, 0.09, 48, 17);
INSERT INTO public.europe_data VALUES (3378, 2, 79, 32.51, 98, 17);
INSERT INTO public.europe_data VALUES (3379, 16, 5620, 96.75, 197, 17);
INSERT INTO public.europe_data VALUES (3380, 30, 14192, 235.93, 198, 17);
INSERT INTO public.europe_data VALUES (3381, 27, 404, 4.17, 138, 17);
INSERT INTO public.europe_data VALUES (3382, 0, 13, 0.1, 139, 17);
INSERT INTO public.europe_data VALUES (3383, 1, 271, 5.99, 140, 17);
INSERT INTO public.europe_data VALUES (3384, 0, 50, 0.15, 141, 17);
INSERT INTO public.europe_data VALUES (3385, 0, 1, 0.08, 142, 17);
INSERT INTO public.europe_data VALUES (3386, 2, 117, 2.51, 49, 17);
INSERT INTO public.europe_data VALUES (3387, 6, 196, 38.28, 99, 17);
INSERT INTO public.europe_data VALUES (3388, 170, 9283, 146.13, 50, 17);
INSERT INTO public.europe_data VALUES (3389, 459, 59070, 143.01, 199, 17);
INSERT INTO public.europe_data VALUES (3390, 0, 3, 7.85, 100, 17);
INSERT INTO public.europe_data VALUES (3391, 4, 789, 4.03, 51, 17);
INSERT INTO public.europe_data VALUES (3392, 701, 42604, 175.43, 200, 17);
INSERT INTO public.europe_data VALUES (3393, 18, 9373, 171.96, 143, 17);
INSERT INTO public.europe_data VALUES (3394, 821, 118693, 329.24, 201, 17);
INSERT INTO public.europe_data VALUES (3395, 0, 0, 0, 52, 17);
INSERT INTO public.europe_data VALUES (3396, 4903, 392051, 223.89, 101, 17);
INSERT INTO public.europe_data VALUES (3397, 1, 10, 13.39, 102, 17);
INSERT INTO public.europe_data VALUES (3398, 1, 237, 11.15, 103, 17);
INSERT INTO public.europe_data VALUES (3399, 24, 2332, 13.86, 144, 17);
INSERT INTO public.europe_data VALUES (3400, 39, 3499, 28.76, 104, 17);
INSERT INTO public.europe_data VALUES (3401, 0, 25, 0.04, 145, 17);
INSERT INTO public.europe_data VALUES (3402, 0, 1, 0, 214, 17);
INSERT INTO public.europe_data VALUES (3403, 0, 0, 0, 53, 17);
INSERT INTO public.europe_data VALUES (3404, 1, 4, 0.05, 146, 17);
INSERT INTO public.europe_data VALUES (3405, 10, 395, 4.48, 54, 17);
INSERT INTO public.europe_data VALUES (3406, 1, 136, 1.79, 55, 17);
INSERT INTO public.europe_data VALUES (3407, 15, 458, 1.5, 105, 18);
INSERT INTO public.europe_data VALUES (3408, 24, 1133, 74.76, 147, 18);
INSERT INTO public.europe_data VALUES (3409, 41, 936, 4.66, 1, 18);
INSERT INTO public.europe_data VALUES (3410, 2, 586, 1128.95, 148, 18);
INSERT INTO public.europe_data VALUES (3411, 25, 876, 4.95, 2, 18);
INSERT INTO public.europe_data VALUES (3412, 0, 0, 0, 56, 18);
INSERT INTO public.europe_data VALUES (3413, 0, 4, 10.3, 57, 18);
INSERT INTO public.europe_data VALUES (3414, 2850, 95720, 408.39, 58, 18);
INSERT INTO public.europe_data VALUES (3415, 43, 3955, 238.39, 149, 18);
INSERT INTO public.europe_data VALUES (3416, 2, 115, 329.23, 59, 18);
INSERT INTO public.europe_data VALUES (3417, 4, 128, 0.89, 202, 18);
INSERT INTO public.europe_data VALUES (3418, 51, 7365, 141.29, 150, 18);
INSERT INTO public.europe_data VALUES (3419, 13, 1291, 19.5, 151, 18);
INSERT INTO public.europe_data VALUES (3420, 11, 669, 330.69, 60, 18);
INSERT INTO public.europe_data VALUES (3421, 13, 2625, 396.79, 106, 18);
INSERT INTO public.europe_data VALUES (3422, 176, 9576, 11.73, 107, 18);
INSERT INTO public.europe_data VALUES (3423, 0, 9, 6.27, 61, 18);
INSERT INTO public.europe_data VALUES (3424, 39, 3239, 62.68, 152, 18);
INSERT INTO public.europe_data VALUES (3425, 139, 38830, 503.81, 153, 18);
INSERT INTO public.europe_data VALUES (3426, 5, 231, 146.79, 62, 18);
INSERT INTO public.europe_data VALUES (3427, 0, 54, 0.6, 3, 18);
INSERT INTO public.europe_data VALUES (3428, 0, 3, 4.8, 63, 18);
INSERT INTO public.europe_data VALUES (3429, 0, 11, 4.72, 108, 18);
INSERT INTO public.europe_data VALUES (3430, 207, 1706, 40.59, 64, 18);
INSERT INTO public.europe_data VALUES (3431, 1, 24, 242.47, 65, 18);
INSERT INTO public.europe_data VALUES (3432, 50, 2670, 112.94, 154, 18);
INSERT INTO public.europe_data VALUES (3433, 2, 1348, 69.41, 4, 18);
INSERT INTO public.europe_data VALUES (3434, 4136, 179693, 171.84, 66, 18);
INSERT INTO public.europe_data VALUES (3435, 0, 0, 0, 67, 18);
INSERT INTO public.europe_data VALUES (3436, 0, 0, 0, 109, 18);
INSERT INTO public.europe_data VALUES (3437, 48, 2815, 62.1, 155, 18);
INSERT INTO public.europe_data VALUES (3438, 4, 113, 1.34, 5, 18);
INSERT INTO public.europe_data VALUES (3439, 0, 11, 0.34, 6, 18);
INSERT INTO public.europe_data VALUES (3440, 0, 3, 0.04, 110, 18);
INSERT INTO public.europe_data VALUES (3441, 3, 279, 1.81, 7, 18);
INSERT INTO public.europe_data VALUES (3442, 104, 11961, 66.8, 68, 18);
INSERT INTO public.europe_data VALUES (3443, 10, 712, 236.57, 8, 18);
INSERT INTO public.europe_data VALUES (3444, 0, 8, 16.94, 69, 18);
INSERT INTO public.europe_data VALUES (3445, 0, 9, 1.01, 9, 18);
INSERT INTO public.europe_data VALUES (3446, 6, 87, 0.79, 10, 18);
INSERT INTO public.europe_data VALUES (3447, 339, 11192, 123.84, 70, 18);
INSERT INTO public.europe_data VALUES (3448, 0, 183, 0.02, 111, 18);
INSERT INTO public.europe_data VALUES (3449, 1122, 56264, 195.19, 71, 18);
INSERT INTO public.europe_data VALUES (3450, 0, 8, 2, 11, 18);
INSERT INTO public.europe_data VALUES (3451, 1, 29, 2.04, 12, 18);
INSERT INTO public.europe_data VALUES (3452, 126, 8257, 304.9, 72, 18);
INSERT INTO public.europe_data VALUES (3453, 0, 272, 2.04, 13, 18);
INSERT INTO public.europe_data VALUES (3454, 26, 2781, 104.09, 156, 18);
INSERT INTO public.europe_data VALUES (3455, 1, 169, 4.6, 73, 18);
INSERT INTO public.europe_data VALUES (3456, 0, 131, 136.46, 74, 18);
INSERT INTO public.europe_data VALUES (3457, 3, 162, 33.11, 157, 18);
INSERT INTO public.europe_data VALUES (3458, 307, 34664, 493.09, 158, 18);
INSERT INTO public.europe_data VALUES (3459, 2, 91, 0.28, 14, 18);
INSERT INTO public.europe_data VALUES (3460, 11, 2742, 99.64, 159, 18);
INSERT INTO public.europe_data VALUES (3461, 0, 4, 1.44, 15, 18);
INSERT INTO public.europe_data VALUES (3462, 0, 1, 11.14, 75, 18);
INSERT INTO public.europe_data VALUES (3463, 39, 3997, 66.03, 76, 18);
INSERT INTO public.europe_data VALUES (3464, 544, 5999, 70.72, 77, 18);
INSERT INTO public.europe_data VALUES (3465, 59, 704, 1.54, 16, 18);
INSERT INTO public.europe_data VALUES (3466, 31, 746, 24.27, 78, 18);
INSERT INTO public.europe_data VALUES (3467, 0, 18, 2.58, 17, 18);
INSERT INTO public.europe_data VALUES (3468, 0, 16, 1.12, 18, 18);
INSERT INTO public.europe_data VALUES (3469, 1, 258, 50.2, 160, 18);
INSERT INTO public.europe_data VALUES (3470, 2, 100, 20.73, 19, 18);
INSERT INTO public.europe_data VALUES (3471, 65, 5476, 9.78, 20, 18);
INSERT INTO public.europe_data VALUES (3472, 0, 0, 0, 79, 18);
INSERT INTO public.europe_data VALUES (3473, 0, 3, 34.92, 161, 18);
INSERT INTO public.europe_data VALUES (3474, 0, 0, 0, 203, 18);
INSERT INTO public.europe_data VALUES (3475, 1, 1460, 41.97, 162, 18);
INSERT INTO public.europe_data VALUES (3476, 500, 115804, 293.09, 163, 18);
INSERT INTO public.europe_data VALUES (3477, 2, 728, 486.96, 204, 18);
INSERT INTO public.europe_data VALUES (3478, 0, 38, 4.93, 21, 18);
INSERT INTO public.europe_data VALUES (3479, 2, 38, 2.68, 22, 18);
INSERT INTO public.europe_data VALUES (3480, 35, 3676, 156.18, 164, 18);
INSERT INTO public.europe_data VALUES (3481, 87, 24712, 48.18, 165, 18);
INSERT INTO public.europe_data VALUES (3482, 3, 176, 2.03, 23, 18);
INSERT INTO public.europe_data VALUES (3483, 0, 53, 314.48, 166, 18);
INSERT INTO public.europe_data VALUES (3484, 40, 2516, 45.82, 167, 18);
INSERT INTO public.europe_data VALUES (3485, 0, 2, 3.53, 80, 18);
INSERT INTO public.europe_data VALUES (3486, 0, 0, 0, 81, 18);
INSERT INTO public.europe_data VALUES (3487, 8, 379, 432.77, 205, 18);
INSERT INTO public.europe_data VALUES (3488, 91, 3752, 43.36, 82, 18);
INSERT INTO public.europe_data VALUES (3489, 0, 1, 3.1, 168, 18);
INSERT INTO public.europe_data VALUES (3490, 3, 268, 3.46, 24, 18);
INSERT INTO public.europe_data VALUES (3491, 1, 23, 3.18, 25, 18);
INSERT INTO public.europe_data VALUES (3492, 16, 376, 89.04, 83, 18);
INSERT INTO public.europe_data VALUES (3493, 1, 63, 1.41, 84, 18);
INSERT INTO public.europe_data VALUES (3494, 0, 0, 0, 169, 18);
INSERT INTO public.europe_data VALUES (3495, 90, 4452, 92.06, 85, 18);
INSERT INTO public.europe_data VALUES (3496, 135, 7097, 141.83, 170, 18);
INSERT INTO public.europe_data VALUES (3497, 0, 605, 252.95, 171, 18);
INSERT INTO public.europe_data VALUES (3498, 6465, 496723, 76.54, 112, 18);
INSERT INTO public.europe_data VALUES (3499, 693, 29951, 21.52, 113, 18);
INSERT INTO public.europe_data VALUES (3500, 1587, 28303, 64.68, 114, 18);
INSERT INTO public.europe_data VALUES (3501, 453, 23189, 134.52, 115, 18);
INSERT INTO public.europe_data VALUES (3502, 16, 4496, 153.7, 172, 18);
INSERT INTO public.europe_data VALUES (3503, 0, 4, 7.09, 173, 18);
INSERT INTO public.europe_data VALUES (3504, 264, 23653, 713.69, 116, 18);
INSERT INTO public.europe_data VALUES (3505, 180, 29621, 74.69, 174, 18);
INSERT INTO public.europe_data VALUES (3506, 19, 823, 58.51, 86, 18);
INSERT INTO public.europe_data VALUES (3507, 30, 3608, 5.69, 117, 18);
INSERT INTO public.europe_data VALUES (3508, 0, 28, 45.46, 175, 18);
INSERT INTO public.europe_data VALUES (3509, 90, 9286, 162.69, 118, 18);
INSERT INTO public.europe_data VALUES (3510, 29, 1896, 18.73, 119, 18);
INSERT INTO public.europe_data VALUES (3511, 35, 2119, 6.53, 26, 18);
INSERT INTO public.europe_data VALUES (3512, 17, 365, 39.31, 176, 18);
INSERT INTO public.europe_data VALUES (3513, 34, 4091, 179.98, 120, 18);
INSERT INTO public.europe_data VALUES (3514, 19, 1595, 44.81, 121, 18);
INSERT INTO public.europe_data VALUES (3515, 0, 0, 0, 122, 18);
INSERT INTO public.europe_data VALUES (3516, 2, 584, 51.77, 177, 18);
INSERT INTO public.europe_data VALUES (3517, 49, 8076, 237.82, 123, 18);
INSERT INTO public.europe_data VALUES (3518, 3, 125, 11.62, 27, 18);
INSERT INTO public.europe_data VALUES (3519, 0, 15, 0.49, 28, 18);
INSERT INTO public.europe_data VALUES (3520, 39, 5903, 152.68, 29, 18);
INSERT INTO public.europe_data VALUES (3521, 0, 12, 54.72, 178, 18);
INSERT INTO public.europe_data VALUES (3522, 9, 937, 62.16, 179, 18);
INSERT INTO public.europe_data VALUES (3523, 5, 651, 163.38, 180, 18);
INSERT INTO public.europe_data VALUES (3524, 5, 160, 1.61, 30, 18);
INSERT INTO public.europe_data VALUES (3525, 1, 35, 0.28, 31, 18);
INSERT INTO public.europe_data VALUES (3526, 20, 3276, 14.83, 124, 18);
INSERT INTO public.europe_data VALUES (3527, 1, 364, 149.92, 125, 18);
INSERT INTO public.europe_data VALUES (3528, 1, 102, 1.02, 32, 18);
INSERT INTO public.europe_data VALUES (3529, 4, 517, 167.76, 181, 18);
INSERT INTO public.europe_data VALUES (3530, 2, 30, 1.94, 33, 18);
INSERT INTO public.europe_data VALUES (3531, 0, 14, 2.21, 34, 18);
INSERT INTO public.europe_data VALUES (3532, 4554, 29957, 47.31, 87, 18);
INSERT INTO public.europe_data VALUES (3533, 95, 5572, 278.88, 182, 18);
INSERT INTO public.europe_data VALUES (3534, 0, 12, 72.54, 183, 18);
INSERT INTO public.europe_data VALUES (3535, 0, 4, 0.16, 126, 18);
INSERT INTO public.europe_data VALUES (3536, 23, 1742, 571.54, 184, 18);
INSERT INTO public.europe_data VALUES (3537, 0, 0, 0, 88, 18);
INSERT INTO public.europe_data VALUES (3538, 275, 19132, 95.19, 35, 18);
INSERT INTO public.europe_data VALUES (3539, 5, 805, 6.65, 36, 18);
INSERT INTO public.europe_data VALUES (3540, 234, 10180, 31.9, 127, 18);
INSERT INTO public.europe_data VALUES (3541, 5, 310, 36.2, 37, 18);
INSERT INTO public.europe_data VALUES (3542, 101, 20932, 120.11, 128, 18);
INSERT INTO public.europe_data VALUES (3543, 130, 38701, 364.19, 185, 18);
INSERT INTO public.europe_data VALUES (3544, 0, 0, 0, 208, 18);
INSERT INTO public.europe_data VALUES (3545, 0, 16, 0.79, 209, 18);
INSERT INTO public.europe_data VALUES (3546, 2, 94, 2.92, 89, 18);
INSERT INTO public.europe_data VALUES (3547, 0, 1, 0.02, 38, 18);
INSERT INTO public.europe_data VALUES (3548, 2, 921, 0.97, 39, 18);
INSERT INTO public.europe_data VALUES (3549, 39, 2335, 159.26, 186, 18);
INSERT INTO public.europe_data VALUES (3550, 0, 4, 12.23, 210, 18);
INSERT INTO public.europe_data VALUES (3551, 0, 1072, 34.06, 187, 18);
INSERT INTO public.europe_data VALUES (3552, 61, 4620, 169.65, 129, 18);
INSERT INTO public.europe_data VALUES (3553, 57, 4316, 3.74, 130, 18);
INSERT INTO public.europe_data VALUES (3554, 54, 3123, 127.73, 131, 18);
INSERT INTO public.europe_data VALUES (3555, 68, 5027, 229.79, 90, 18);
INSERT INTO public.europe_data VALUES (3556, 0, 14, 0.25, 211, 18);
INSERT INTO public.europe_data VALUES (3557, 148, 5493, 156.02, 91, 18);
INSERT INTO public.europe_data VALUES (3558, 563, 21202, 135.55, 92, 18);
INSERT INTO public.europe_data VALUES (3559, 545, 16844, 32.48, 132, 18);
INSERT INTO public.europe_data VALUES (3560, 400, 27676, 101.35, 188, 18);
INSERT INTO public.europe_data VALUES (3561, 85, 8417, 127.08, 189, 18);
INSERT INTO public.europe_data VALUES (3562, 44, 2996, 251.14, 93, 18);
INSERT INTO public.europe_data VALUES (3563, 4, 1487, 102.43, 133, 18);
INSERT INTO public.europe_data VALUES (3564, 464, 21218, 167.97, 190, 18);
INSERT INTO public.europe_data VALUES (3565, 1239, 83717, 100.97, 191, 18);
INSERT INTO public.europe_data VALUES (3566, 2, 30, 0.6, 40, 18);
INSERT INTO public.europe_data VALUES (3567, 0, 0, 0, 94, 18);
INSERT INTO public.europe_data VALUES (3568, 0, 2, 1.09, 95, 18);
INSERT INTO public.europe_data VALUES (3569, 0, 0, 0, 96, 18);
INSERT INTO public.europe_data VALUES (3570, 0, 20, 72.56, 192, 18);
INSERT INTO public.europe_data VALUES (3571, 0, 16, 8.37, 41, 18);
INSERT INTO public.europe_data VALUES (3572, 168, 2880, 17.72, 134, 18);
INSERT INTO public.europe_data VALUES (3573, 2, 174, 2.2, 42, 18);
INSERT INTO public.europe_data VALUES (3574, 9, 886, 20.15, 193, 18);
INSERT INTO public.europe_data VALUES (3575, 0, 3, 5.12, 43, 18);
INSERT INTO public.europe_data VALUES (3576, 0, 37, 1.16, 44, 18);
INSERT INTO public.europe_data VALUES (3577, 0, 64, 3.03, 135, 18);
INSERT INTO public.europe_data VALUES (3578, 0, 31, 155.7, 97, 18);
INSERT INTO public.europe_data VALUES (3579, 6, 6712, 197.65, 194, 18);
INSERT INTO public.europe_data VALUES (3580, 2, 2167, 159.31, 195, 18);
INSERT INTO public.europe_data VALUES (3581, 0, 119, 1.79, 45, 18);
INSERT INTO public.europe_data VALUES (3582, 804, 11182, 37.07, 46, 18);
INSERT INTO public.europe_data VALUES (3583, 11, 539, 2.03, 136, 18);
INSERT INTO public.europe_data VALUES (3584, 5, 51, 0.82, 47, 18);
INSERT INTO public.europe_data VALUES (3585, 899, 75556, 299.77, 196, 18);
INSERT INTO public.europe_data VALUES (3586, 0, 1350, 6.53, 137, 18);
INSERT INTO public.europe_data VALUES (3587, 0, 17, 0.15, 48, 18);
INSERT INTO public.europe_data VALUES (3588, 1, 110, 37.15, 98, 18);
INSERT INTO public.europe_data VALUES (3589, 22, 4278, 77.42, 197, 18);
INSERT INTO public.europe_data VALUES (3590, 10, 5967, 97.91, 198, 18);
INSERT INTO public.europe_data VALUES (3591, 16, 307, 3.52, 138, 18);
INSERT INTO public.europe_data VALUES (3592, 0, 10, 0.07, 139, 18);
INSERT INTO public.europe_data VALUES (3593, 1, 287, 6.18, 140, 18);
INSERT INTO public.europe_data VALUES (3594, 0, 51, 0.14, 141, 18);
INSERT INTO public.europe_data VALUES (3595, 0, 0, 0.08, 142, 18);
INSERT INTO public.europe_data VALUES (3596, 1, 86, 2.44, 49, 18);
INSERT INTO public.europe_data VALUES (3597, 9, 338, 52.98, 99, 18);
INSERT INTO public.europe_data VALUES (3598, 135, 7806, 129.5, 50, 18);
INSERT INTO public.europe_data VALUES (3599, 396, 58200, 140.63, 199, 18);
INSERT INTO public.europe_data VALUES (3600, 0, 0, 34.04, 100, 18);
INSERT INTO public.europe_data VALUES (3601, 12, 993, 5.13, 51, 18);
INSERT INTO public.europe_data VALUES (3602, 575, 34572, 141.84, 200, 18);
INSERT INTO public.europe_data VALUES (3603, 19, 7428, 151.07, 143, 18);
INSERT INTO public.europe_data VALUES (3604, 475, 100738, 253.19, 201, 18);
INSERT INTO public.europe_data VALUES (3605, 0, 0, 0, 52, 18);
INSERT INTO public.europe_data VALUES (3606, 4977, 344699, 196.77, 101, 18);
INSERT INTO public.europe_data VALUES (3607, 0, 4, 7.65, 102, 18);
INSERT INTO public.europe_data VALUES (3608, 2, 149, 8.26, 103, 18);
INSERT INTO public.europe_data VALUES (3609, 22, 2239, 16.69, 144, 18);
INSERT INTO public.europe_data VALUES (3610, 44, 4703, 36.63, 104, 18);
INSERT INTO public.europe_data VALUES (3611, 0, 13, 0.04, 145, 18);
INSERT INTO public.europe_data VALUES (3612, 0, 0, 0, 53, 18);
INSERT INTO public.europe_data VALUES (3613, 5, 10, 0.07, 146, 18);
INSERT INTO public.europe_data VALUES (3614, 3, 406, 4.57, 54, 18);
INSERT INTO public.europe_data VALUES (3615, 2, 126, 1.36, 55, 18);
INSERT INTO public.europe_data VALUES (3616, 9, 114, 0.78, 105, 19);
INSERT INTO public.europe_data VALUES (3617, 19, 1007, 65.71, 147, 19);
INSERT INTO public.europe_data VALUES (3618, 46, 1069, 5.37, 1, 19);
INSERT INTO public.europe_data VALUES (3619, 0, 274, 716.75, 148, 19);
INSERT INTO public.europe_data VALUES (3620, 22, 698, 4.33, 2, 19);
INSERT INTO public.europe_data VALUES (3621, 0, 0, 0, 56, 19);
INSERT INTO public.europe_data VALUES (3622, 0, 6, 11.33, 57, 19);
INSERT INTO public.europe_data VALUES (3623, 26, 3096, 171.25, 149, 19);
INSERT INTO public.europe_data VALUES (3624, 5269, 87161, 392.03, 58, 19);
INSERT INTO public.europe_data VALUES (3625, 5, 235, 496.66, 59, 19);
INSERT INTO public.europe_data VALUES (3626, 22, 96, 0.94, 202, 19);
INSERT INTO public.europe_data VALUES (3627, 26, 5152, 113.57, 150, 19);
INSERT INTO public.europe_data VALUES (3628, 10, 668, 14.96, 151, 19);
INSERT INTO public.europe_data VALUES (3629, 9, 619, 266.76, 60, 19);
INSERT INTO public.europe_data VALUES (3630, 18, 3887, 497.39, 106, 19);
INSERT INTO public.europe_data VALUES (3631, 187, 9542, 12.13, 107, 19);
INSERT INTO public.europe_data VALUES (3632, 0, 9, 3.48, 61, 19);
INSERT INTO public.europe_data VALUES (3633, 39, 2686, 48.89, 152, 19);
INSERT INTO public.europe_data VALUES (3634, 84, 18884, 263.26, 153, 19);
INSERT INTO public.europe_data VALUES (3635, 6, 342, 145.77, 62, 19);
INSERT INTO public.europe_data VALUES (3636, 1, 17, 0.65, 3, 19);
INSERT INTO public.europe_data VALUES (3637, 0, 0, 1.6, 63, 19);
INSERT INTO public.europe_data VALUES (3638, 0, 25, 4.85, 108, 19);
INSERT INTO public.europe_data VALUES (3639, 243, 2967, 53.78, 64, 19);
INSERT INTO public.europe_data VALUES (3640, 0, 39, 338.68, 65, 19);
INSERT INTO public.europe_data VALUES (3641, 61, 1058, 77.28, 154, 19);
INSERT INTO public.europe_data VALUES (3642, 0, 251, 26.26, 4, 19);
INSERT INTO public.europe_data VALUES (3643, 4611, 182980, 175.63, 66, 19);
INSERT INTO public.europe_data VALUES (3644, 0, 0, 0, 67, 19);
INSERT INTO public.europe_data VALUES (3645, 0, 0, 0.23, 109, 19);
INSERT INTO public.europe_data VALUES (3646, 48, 1532, 38.91, 155, 19);
INSERT INTO public.europe_data VALUES (3647, 3, 159, 1.58, 5, 19);
INSERT INTO public.europe_data VALUES (3648, 0, 28, 0.35, 6, 19);
INSERT INTO public.europe_data VALUES (3649, 0, 4, 0.03, 110, 19);
INSERT INTO public.europe_data VALUES (3650, 2, 189, 1.91, 7, 19);
INSERT INTO public.europe_data VALUES (3651, 213, 13031, 60.16, 68, 19);
INSERT INTO public.europe_data VALUES (3652, 8, 589, 200.57, 8, 19);
INSERT INTO public.europe_data VALUES (3653, 0, 3, 6.16, 69, 19);
INSERT INTO public.europe_data VALUES (3654, 0, 39, 1.1, 9, 19);
INSERT INTO public.europe_data VALUES (3655, 2, 39, 0.41, 10, 19);
INSERT INTO public.europe_data VALUES (3656, 338, 12278, 126.13, 70, 19);
INSERT INTO public.europe_data VALUES (3657, 0, 146, 0.02, 111, 19);
INSERT INTO public.europe_data VALUES (3658, 1224, 41996, 178.74, 71, 19);
INSERT INTO public.europe_data VALUES (3659, 0, 9, 2, 11, 19);
INSERT INTO public.europe_data VALUES (3660, 0, 81, 1.91, 12, 19);
INSERT INTO public.europe_data VALUES (3661, 122, 7133, 306.48, 72, 19);
INSERT INTO public.europe_data VALUES (3662, 0, 253, 2.19, 13, 19);
INSERT INTO public.europe_data VALUES (3663, 26, 1462, 67.15, 156, 19);
INSERT INTO public.europe_data VALUES (3664, 0, 352, 6.34, 73, 19);
INSERT INTO public.europe_data VALUES (3665, 0, 92, 112.59, 74, 19);
INSERT INTO public.europe_data VALUES (3666, 0, 128, 25.57, 157, 19);
INSERT INTO public.europe_data VALUES (3667, 121, 17849, 311.8, 158, 19);
INSERT INTO public.europe_data VALUES (3668, 3, 148, 0.28, 14, 19);
INSERT INTO public.europe_data VALUES (3669, 9, 3043, 134.91, 159, 19);
INSERT INTO public.europe_data VALUES (3670, 0, 10, 1.64, 15, 19);
INSERT INTO public.europe_data VALUES (3671, 0, 7, 9.75, 75, 19);
INSERT INTO public.europe_data VALUES (3672, 39, 3094, 57.65, 76, 19);
INSERT INTO public.europe_data VALUES (3673, 368, 6287, 84.12, 77, 19);
INSERT INTO public.europe_data VALUES (3674, 98, 843, 1.66, 16, 19);
INSERT INTO public.europe_data VALUES (3675, 37, 820, 29.39, 78, 19);
INSERT INTO public.europe_data VALUES (3676, 0, 17, 3.17, 17, 19);
INSERT INTO public.europe_data VALUES (3677, 0, 23, 0.97, 18, 19);
INSERT INTO public.europe_data VALUES (3678, 3, 407, 51.55, 160, 19);
INSERT INTO public.europe_data VALUES (3679, 3, 138, 26.13, 19, 19);
INSERT INTO public.europe_data VALUES (3680, 52, 5487, 8.92, 20, 19);
INSERT INTO public.europe_data VALUES (3681, 0, 0, 0, 79, 19);
INSERT INTO public.europe_data VALUES (3682, 0, 14, 82.17, 161, 19);
INSERT INTO public.europe_data VALUES (3683, 0, 0, 0, 203, 19);
INSERT INTO public.europe_data VALUES (3684, 2, 856, 28.24, 162, 19);
INSERT INTO public.europe_data VALUES (3685, 503, 80601, 246.83, 163, 19);
INSERT INTO public.europe_data VALUES (3686, 3, 632, 231.3, 204, 19);
INSERT INTO public.europe_data VALUES (3687, 0, 69, 4.65, 21, 19);
INSERT INTO public.europe_data VALUES (3688, 4, 25, 2.9, 22, 19);
INSERT INTO public.europe_data VALUES (3689, 22, 2566, 110.66, 164, 19);
INSERT INTO public.europe_data VALUES (3690, 74, 15287, 34.07, 165, 19);
INSERT INTO public.europe_data VALUES (3691, 4, 442, 2.71, 23, 19);
INSERT INTO public.europe_data VALUES (3692, 0, 53, 243.28, 166, 19);
INSERT INTO public.europe_data VALUES (3693, 30, 2398, 43.82, 167, 19);
INSERT INTO public.europe_data VALUES (3694, 0, 0, 0, 80, 19);
INSERT INTO public.europe_data VALUES (3695, 0, 0, 0, 81, 19);
INSERT INTO public.europe_data VALUES (3696, 10, 345, 347.89, 205, 19);
INSERT INTO public.europe_data VALUES (3697, 64, 3871, 48.45, 82, 19);
INSERT INTO public.europe_data VALUES (3698, 0, 1, 3.1, 168, 19);
INSERT INTO public.europe_data VALUES (3699, 0, 174, 3.36, 24, 19);
INSERT INTO public.europe_data VALUES (3700, 0, 38, 3.07, 25, 19);
INSERT INTO public.europe_data VALUES (3701, 11, 321, 105.27, 83, 19);
INSERT INTO public.europe_data VALUES (3702, 2, 96, 1.78, 84, 19);
INSERT INTO public.europe_data VALUES (3703, 0, 0, 0, 169, 19);
INSERT INTO public.europe_data VALUES (3704, 133, 4520, 82.22, 85, 19);
INSERT INTO public.europe_data VALUES (3705, 84, 6764, 129.07, 170, 19);
INSERT INTO public.europe_data VALUES (3706, 0, 298, 161.07, 171, 19);
INSERT INTO public.europe_data VALUES (3707, 7143, 549113, 83.15, 112, 19);
INSERT INTO public.europe_data VALUES (3708, 765, 28285, 21.74, 113, 19);
INSERT INTO public.europe_data VALUES (3709, 1368, 25324, 59.86, 114, 19);
INSERT INTO public.europe_data VALUES (3710, 409, 29691, 152.9, 115, 19);
INSERT INTO public.europe_data VALUES (3711, 8, 3042, 103.97, 172, 19);
INSERT INTO public.europe_data VALUES (3712, 0, 2, 3.55, 173, 19);
INSERT INTO public.europe_data VALUES (3713, 253, 37149, 936.08, 116, 19);
INSERT INTO public.europe_data VALUES (3714, 151, 15459, 45.02, 174, 19);
INSERT INTO public.europe_data VALUES (3715, 31, 902, 64.68, 86, 19);
INSERT INTO public.europe_data VALUES (3716, 51, 3608, 5.58, 117, 19);
INSERT INTO public.europe_data VALUES (3717, 0, 21, 25.97, 175, 19);
INSERT INTO public.europe_data VALUES (3718, 56, 7148, 107.52, 118, 19);
INSERT INTO public.europe_data VALUES (3719, 36, 1579, 18.27, 119, 19);
INSERT INTO public.europe_data VALUES (3720, 40, 1312, 4.65, 26, 19);
INSERT INTO public.europe_data VALUES (3721, 8, 342, 41.76, 176, 19);
INSERT INTO public.europe_data VALUES (3722, 23, 3481, 180.43, 120, 19);
INSERT INTO public.europe_data VALUES (3723, 2, 1280, 33.73, 121, 19);
INSERT INTO public.europe_data VALUES (3724, 0, 0, 0, 122, 19);
INSERT INTO public.europe_data VALUES (3725, 2, 410, 29.22, 177, 19);
INSERT INTO public.europe_data VALUES (3726, 59, 8228, 221.41, 123, 19);
INSERT INTO public.europe_data VALUES (3727, 4, 122, 12.05, 27, 19);
INSERT INTO public.europe_data VALUES (3728, 0, 9, 0.26, 28, 19);
INSERT INTO public.europe_data VALUES (3729, 72, 4445, 130.73, 29, 19);
INSERT INTO public.europe_data VALUES (3730, 0, 9, 36.48, 178, 19);
INSERT INTO public.europe_data VALUES (3731, 3, 800, 51.57, 179, 19);
INSERT INTO public.europe_data VALUES (3732, 1, 352, 147.42, 180, 19);
INSERT INTO public.europe_data VALUES (3733, 3, 273, 1.87, 30, 19);
INSERT INTO public.europe_data VALUES (3734, 0, 18, 0.3, 31, 19);
INSERT INTO public.europe_data VALUES (3735, 3, 1462, 6.77, 124, 19);
INSERT INTO public.europe_data VALUES (3736, 0, 432, 151.8, 125, 19);
INSERT INTO public.europe_data VALUES (3737, 1, 98, 0.87, 32, 19);
INSERT INTO public.europe_data VALUES (3738, 7, 311, 109.61, 181, 19);
INSERT INTO public.europe_data VALUES (3739, 0, 58, 3.36, 33, 19);
INSERT INTO public.europe_data VALUES (3740, 0, 14, 1.1, 34, 19);
INSERT INTO public.europe_data VALUES (3741, 2658, 30405, 48.87, 87, 19);
INSERT INTO public.europe_data VALUES (3742, 79, 5704, 246.9, 182, 19);
INSERT INTO public.europe_data VALUES (3743, 0, 12, 87.65, 183, 19);
INSERT INTO public.europe_data VALUES (3744, 0, 1, 0.06, 126, 19);
INSERT INTO public.europe_data VALUES (3745, 21, 1814, 564.95, 184, 19);
INSERT INTO public.europe_data VALUES (3746, 0, 0, 0, 88, 19);
INSERT INTO public.europe_data VALUES (3747, 261, 15587, 86.45, 35, 19);
INSERT INTO public.europe_data VALUES (3748, 8, 1213, 7.99, 36, 19);
INSERT INTO public.europe_data VALUES (3749, 186, 7060, 22.18, 127, 19);
INSERT INTO public.europe_data VALUES (3750, 4, 593, 50.07, 37, 19);
INSERT INTO public.europe_data VALUES (3751, 58, 13429, 79.35, 128, 19);
INSERT INTO public.europe_data VALUES (3752, 80, 24239, 243.4, 185, 19);
INSERT INTO public.europe_data VALUES (3753, 0, 0, 0.35, 208, 19);
INSERT INTO public.europe_data VALUES (3754, 0, 22, 0.73, 209, 19);
INSERT INTO public.europe_data VALUES (3755, 2, 97, 3.19, 89, 19);
INSERT INTO public.europe_data VALUES (3756, 0, 4, 0.05, 38, 19);
INSERT INTO public.europe_data VALUES (3757, 5, 1021, 1.05, 39, 19);
INSERT INTO public.europe_data VALUES (3758, 28, 973, 89.88, 186, 19);
INSERT INTO public.europe_data VALUES (3759, 0, 3, 6.99, 210, 19);
INSERT INTO public.europe_data VALUES (3760, 5, 743, 28.23, 187, 19);
INSERT INTO public.europe_data VALUES (3761, 68, 3820, 156.68, 129, 19);
INSERT INTO public.europe_data VALUES (3762, 47, 3775, 3.84, 130, 19);
INSERT INTO public.europe_data VALUES (3763, 48, 3240, 140.26, 131, 19);
INSERT INTO public.europe_data VALUES (3764, 83, 4731, 213.9, 90, 19);
INSERT INTO public.europe_data VALUES (3765, 0, 8, 0.26, 211, 19);
INSERT INTO public.europe_data VALUES (3766, 126, 5498, 151.35, 91, 19);
INSERT INTO public.europe_data VALUES (3767, 480, 22867, 182.32, 92, 19);
INSERT INTO public.europe_data VALUES (3768, 432, 18271, 33.07, 132, 19);
INSERT INTO public.europe_data VALUES (3769, 172, 10810, 49.77, 188, 19);
INSERT INTO public.europe_data VALUES (3770, 42, 4643, 94.1, 189, 19);
INSERT INTO public.europe_data VALUES (3771, 42, 4371, 301.25, 93, 19);
INSERT INTO public.europe_data VALUES (3772, 2, 1414, 110.24, 133, 19);
INSERT INTO public.europe_data VALUES (3773, 229, 11392, 109.63, 190, 19);
INSERT INTO public.europe_data VALUES (3774, 1034, 63563, 76.51, 191, 19);
INSERT INTO public.europe_data VALUES (3775, 0, 46, 1.23, 40, 19);
INSERT INTO public.europe_data VALUES (3776, 0, 0, 3.79, 94, 19);
INSERT INTO public.europe_data VALUES (3777, 0, 0, 0, 95, 19);
INSERT INTO public.europe_data VALUES (3778, 0, 0, 0, 96, 19);
INSERT INTO public.europe_data VALUES (3779, 0, 5, 26.12, 192, 19);
INSERT INTO public.europe_data VALUES (3780, 0, 2, 2.33, 41, 19);
INSERT INTO public.europe_data VALUES (3781, 192, 3194, 19.36, 134, 19);
INSERT INTO public.europe_data VALUES (3782, 4, 185, 2.33, 42, 19);
INSERT INTO public.europe_data VALUES (3783, 7, 517, 14.26, 193, 19);
INSERT INTO public.europe_data VALUES (3784, 0, 2, 4.09, 43, 19);
INSERT INTO public.europe_data VALUES (3785, 0, 54, 1.29, 44, 19);
INSERT INTO public.europe_data VALUES (3786, 0, 112, 4.07, 135, 19);
INSERT INTO public.europe_data VALUES (3787, 0, 35, 224.11, 97, 19);
INSERT INTO public.europe_data VALUES (3788, 11, 4061, 118.56, 194, 19);
INSERT INTO public.europe_data VALUES (3789, 4, 1148, 99.86, 195, 19);
INSERT INTO public.europe_data VALUES (3790, 0, 157, 1.96, 45, 19);
INSERT INTO public.europe_data VALUES (3791, 578, 10523, 34.29, 46, 19);
INSERT INTO public.europe_data VALUES (3792, 16, 503, 2.18, 136, 19);
INSERT INTO public.europe_data VALUES (3793, 1, 40, 0.76, 47, 19);
INSERT INTO public.europe_data VALUES (3794, 814, 65146, 302.41, 196, 19);
INSERT INTO public.europe_data VALUES (3795, 0, 42, 0.54, 137, 19);
INSERT INTO public.europe_data VALUES (3796, 0, 47, 0.23, 48, 19);
INSERT INTO public.europe_data VALUES (3797, 4, 106, 37.5, 98, 19);
INSERT INTO public.europe_data VALUES (3798, 17, 3642, 64.13, 197, 19);
INSERT INTO public.europe_data VALUES (3799, 5, 2399, 59.59, 198, 19);
INSERT INTO public.europe_data VALUES (3800, 13, 294, 3.32, 138, 19);
INSERT INTO public.europe_data VALUES (3801, 0, 7, 0.03, 139, 19);
INSERT INTO public.europe_data VALUES (3802, 3, 289, 6.32, 140, 19);
INSERT INTO public.europe_data VALUES (3803, 0, 45, 0.12, 141, 19);
INSERT INTO public.europe_data VALUES (3804, 0, 1, 0.08, 142, 19);
INSERT INTO public.europe_data VALUES (3805, 2, 111, 2.33, 49, 19);
INSERT INTO public.europe_data VALUES (3806, 10, 401, 61.79, 99, 19);
INSERT INTO public.europe_data VALUES (3807, 107, 7339, 108.78, 50, 19);
INSERT INTO public.europe_data VALUES (3808, 444, 57120, 141.21, 199, 19);
INSERT INTO public.europe_data VALUES (3809, 1, 13, 70.69, 100, 19);
INSERT INTO public.europe_data VALUES (3810, 8, 1278, 5.69, 51, 19);
INSERT INTO public.europe_data VALUES (3811, 438, 27828, 115.43, 200, 19);
INSERT INTO public.europe_data VALUES (3812, 14, 7332, 142.11, 143, 19);
INSERT INTO public.europe_data VALUES (3813, 362, 68009, 163.13, 201, 19);
INSERT INTO public.europe_data VALUES (3814, 0, 0, 0, 52, 19);
INSERT INTO public.europe_data VALUES (3815, 5038, 302799, 186.29, 101, 19);
INSERT INTO public.europe_data VALUES (3816, 1, 4, 49.72, 102, 19);
INSERT INTO public.europe_data VALUES (3817, 1, 137, 6.59, 103, 19);
INSERT INTO public.europe_data VALUES (3818, 23, 3266, 21.44, 144, 19);
INSERT INTO public.europe_data VALUES (3819, 47, 5743, 41.3, 104, 19);
INSERT INTO public.europe_data VALUES (3820, 0, 22, 0.03, 145, 19);
INSERT INTO public.europe_data VALUES (3821, 0, 0, 0, 53, 19);
INSERT INTO public.europe_data VALUES (3822, 3, 11, 0.05, 146, 19);
INSERT INTO public.europe_data VALUES (3823, 1, 411, 5.16, 54, 19);
INSERT INTO public.europe_data VALUES (3824, 1, 73, 1.38, 55, 19);
INSERT INTO public.europe_data VALUES (3825, 12, 183, 1.34, 105, 20);
INSERT INTO public.europe_data VALUES (3826, 15, 874, 66.59, 147, 20);
INSERT INTO public.europe_data VALUES (3827, 42, 1241, 6.53, 1, 20);
INSERT INTO public.europe_data VALUES (3828, 0, 272, 645.86, 148, 20);
INSERT INTO public.europe_data VALUES (3829, 19, 681, 4.2, 2, 20);
INSERT INTO public.europe_data VALUES (3830, 0, 0, 0, 56, 20);
INSERT INTO public.europe_data VALUES (3831, 0, 5, 6.18, 57, 20);
INSERT INTO public.europe_data VALUES (3832, 2840, 88391, 368.11, 58, 20);
INSERT INTO public.europe_data VALUES (3833, 21, 1969, 119.62, 149, 20);
INSERT INTO public.europe_data VALUES (3834, 2, 293, 750.63, 59, 20);
INSERT INTO public.europe_data VALUES (3835, 23, 142, 1.54, 202, 20);
INSERT INTO public.europe_data VALUES (3836, 21, 4909, 114.36, 150, 20);
INSERT INTO public.europe_data VALUES (3837, 11, 835, 16.88, 151, 20);
INSERT INTO public.europe_data VALUES (3838, 13, 420, 221.32, 60, 20);
INSERT INTO public.europe_data VALUES (3839, 21, 4276, 559.91, 106, 20);
INSERT INTO public.europe_data VALUES (3840, 222, 10232, 13.26, 107, 20);
INSERT INTO public.europe_data VALUES (3841, 0, 1, 3.14, 61, 20);
INSERT INTO public.europe_data VALUES (3842, 38, 1935, 36.35, 152, 20);
INSERT INTO public.europe_data VALUES (3843, 39, 11274, 186.65, 153, 20);
INSERT INTO public.europe_data VALUES (3844, 3, 227, 95.81, 62, 20);
INSERT INTO public.europe_data VALUES (3845, 0, 60, 0.62, 3, 20);
INSERT INTO public.europe_data VALUES (3846, 0, 1, 6.4, 63, 20);
INSERT INTO public.europe_data VALUES (3847, 0, 12, 3.67, 108, 20);
INSERT INTO public.europe_data VALUES (3848, 241, 3225, 61.76, 64, 20);
INSERT INTO public.europe_data VALUES (3849, 0, 49, 227.07, 65, 20);
INSERT INTO public.europe_data VALUES (3850, 53, 1493, 104.67, 154, 20);
INSERT INTO public.europe_data VALUES (3851, 3, 354, 29.04, 4, 20);
INSERT INTO public.europe_data VALUES (3852, 4846, 187680, 190.41, 66, 20);
INSERT INTO public.europe_data VALUES (3853, 0, 0, 16.65, 67, 20);
INSERT INTO public.europe_data VALUES (3854, 0, 1, 0.23, 109, 20);
INSERT INTO public.europe_data VALUES (3855, 35, 1192, 30.53, 155, 20);
INSERT INTO public.europe_data VALUES (3856, 0, 162, 1.48, 5, 20);
INSERT INTO public.europe_data VALUES (3857, 0, 12, 0.11, 6, 20);
INSERT INTO public.europe_data VALUES (3858, 0, 1, 0.01, 110, 20);
INSERT INTO public.europe_data VALUES (3859, 2, 304, 2.2, 7, 20);
INSERT INTO public.europe_data VALUES (3860, 51, 9476, 44.01, 68, 20);
INSERT INTO public.europe_data VALUES (3861, 6, 514, 174.2, 8, 20);
INSERT INTO public.europe_data VALUES (3862, 0, 1, 3.08, 69, 20);
INSERT INTO public.europe_data VALUES (3863, 0, 13, 1.2, 9, 20);
INSERT INTO public.europe_data VALUES (3864, 3, 27, 0.59, 10, 20);
INSERT INTO public.europe_data VALUES (3865, 355, 11627, 122.17, 70, 20);
INSERT INTO public.europe_data VALUES (3866, 2, 114, 0.02, 111, 20);
INSERT INTO public.europe_data VALUES (3867, 1280, 47980, 192.17, 71, 20);
INSERT INTO public.europe_data VALUES (3868, 0, 8, 2.59, 11, 20);
INSERT INTO public.europe_data VALUES (3869, 0, 22, 1.38, 12, 20);
INSERT INTO public.europe_data VALUES (3870, 122, 8337, 328.77, 72, 20);
INSERT INTO public.europe_data VALUES (3871, 0, 309, 2.4, 13, 20);
INSERT INTO public.europe_data VALUES (3872, 24, 1275, 65.35, 156, 20);
INSERT INTO public.europe_data VALUES (3873, 7, 366, 6.82, 73, 20);
INSERT INTO public.europe_data VALUES (3874, 0, 92, 124.22, 74, 20);
INSERT INTO public.europe_data VALUES (3875, 0, 96, 19.41, 157, 20);
INSERT INTO public.europe_data VALUES (3876, 103, 15357, 266.76, 158, 20);
INSERT INTO public.europe_data VALUES (3877, 0, 97, 0.26, 14, 20);
INSERT INTO public.europe_data VALUES (3878, 14, 4790, 127.81, 159, 20);
INSERT INTO public.europe_data VALUES (3879, 0, 6, 1.44, 15, 20);
INSERT INTO public.europe_data VALUES (3880, 0, 0, 0, 75, 20);
INSERT INTO public.europe_data VALUES (3881, 48, 3097, 71.94, 76, 20);
INSERT INTO public.europe_data VALUES (3882, 189, 8328, 92.97, 77, 20);
INSERT INTO public.europe_data VALUES (3883, 113, 825, 1.82, 16, 20);
INSERT INTO public.europe_data VALUES (3884, 14, 1077, 25.12, 78, 20);
INSERT INTO public.europe_data VALUES (3885, 0, 26, 2.36, 17, 20);
INSERT INTO public.europe_data VALUES (3886, 0, 11, 0.4, 18, 20);
INSERT INTO public.europe_data VALUES (3887, 0, 276, 39.55, 160, 20);
INSERT INTO public.europe_data VALUES (3888, 4, 162, 31.01, 19, 20);
INSERT INTO public.europe_data VALUES (3889, 74, 4512, 8.06, 20, 20);
INSERT INTO public.europe_data VALUES (3890, 0, 0, 0, 79, 20);
INSERT INTO public.europe_data VALUES (3891, 0, 26, 76.01, 161, 20);
INSERT INTO public.europe_data VALUES (3892, 0, 0, 0, 203, 20);
INSERT INTO public.europe_data VALUES (3893, 4, 702, 19.97, 162, 20);
INSERT INTO public.europe_data VALUES (3894, 442, 84806, 234.99, 163, 20);
INSERT INTO public.europe_data VALUES (3895, 3, 14, 157.9, 204, 20);
INSERT INTO public.europe_data VALUES (3896, 1, 32, 3.91, 21, 20);
INSERT INTO public.europe_data VALUES (3897, 3, 43, 6.99, 22, 20);
INSERT INTO public.europe_data VALUES (3898, 8, 1857, 79.06, 164, 20);
INSERT INTO public.europe_data VALUES (3899, 74, 12995, 30.09, 165, 20);
INSERT INTO public.europe_data VALUES (3900, 2, 383, 3.13, 23, 20);
INSERT INTO public.europe_data VALUES (3901, 0, 29, 145.37, 166, 20);
INSERT INTO public.europe_data VALUES (3902, 41, 2302, 39.2, 167, 20);
INSERT INTO public.europe_data VALUES (3903, 0, 0, 0, 80, 20);
INSERT INTO public.europe_data VALUES (3904, 0, 0, 0, 81, 20);
INSERT INTO public.europe_data VALUES (3905, 8, 237, 276.76, 205, 20);
INSERT INTO public.europe_data VALUES (3906, 110, 4648, 46.54, 82, 20);
INSERT INTO public.europe_data VALUES (3907, 0, 1, 4.65, 168, 20);
INSERT INTO public.europe_data VALUES (3908, 2, 255, 4.38, 24, 20);
INSERT INTO public.europe_data VALUES (3909, 0, 21, 2.55, 25, 20);
INSERT INTO public.europe_data VALUES (3910, 12, 503, 117.4, 83, 20);
INSERT INTO public.europe_data VALUES (3911, 6, 104, 2.04, 84, 20);
INSERT INTO public.europe_data VALUES (3912, 0, 0, 0, 169, 20);
INSERT INTO public.europe_data VALUES (3913, 105, 3493, 75.11, 85, 20);
INSERT INTO public.europe_data VALUES (3914, 63, 5850, 126.95, 170, 20);
INSERT INTO public.europe_data VALUES (3915, 0, 277, 128.29, 171, 20);
INSERT INTO public.europe_data VALUES (3916, 7660, 587122, 89.89, 112, 20);
INSERT INTO public.europe_data VALUES (3917, 833, 30537, 21, 113, 20);
INSERT INTO public.europe_data VALUES (3918, 1288, 24308, 53.57, 114, 20);
INSERT INTO public.europe_data VALUES (3919, 435, 30415, 150.45, 115, 20);
INSERT INTO public.europe_data VALUES (3920, 10, 2057, 81.66, 172, 20);
INSERT INTO public.europe_data VALUES (3921, 0, 1, 3.55, 173, 20);
INSERT INTO public.europe_data VALUES (3922, 210, 42599, 873.66, 116, 20);
INSERT INTO public.europe_data VALUES (3923, 128, 11714, 36.64, 174, 20);
INSERT INTO public.europe_data VALUES (3924, 22, 1005, 75.37, 86, 20);
INSERT INTO public.europe_data VALUES (3925, 48, 3474, 5.1, 117, 20);
INSERT INTO public.europe_data VALUES (3926, 0, 7, 18.55, 175, 20);
INSERT INTO public.europe_data VALUES (3927, 15, 3713, 51.26, 118, 20);
INSERT INTO public.europe_data VALUES (3928, 34, 1810, 20.22, 119, 20);
INSERT INTO public.europe_data VALUES (3929, 43, 1134, 3.72, 26, 20);
INSERT INTO public.europe_data VALUES (3930, 9, 409, 46.43, 176, 20);
INSERT INTO public.europe_data VALUES (3931, 17, 4110, 208.7, 120, 20);
INSERT INTO public.europe_data VALUES (3932, 1, 884, 22.24, 121, 20);
INSERT INTO public.europe_data VALUES (3933, 0, 0, 0, 122, 20);
INSERT INTO public.europe_data VALUES (3934, 0, 151, 10.52, 177, 20);
INSERT INTO public.europe_data VALUES (3935, 50, 6951, 174.22, 123, 20);
INSERT INTO public.europe_data VALUES (3936, 2, 134, 14.73, 27, 20);
INSERT INTO public.europe_data VALUES (3937, 0, 4, 0.41, 28, 20);
INSERT INTO public.europe_data VALUES (3938, 82, 4415, 141.4, 29, 20);
INSERT INTO public.europe_data VALUES (3939, 0, 5, 15.63, 178, 20);
INSERT INTO public.europe_data VALUES (3940, 4, 641, 37.58, 179, 20);
INSERT INTO public.europe_data VALUES (3941, 0, 553, 189.45, 180, 20);
INSERT INTO public.europe_data VALUES (3942, 6, 232, 1.96, 30, 20);
INSERT INTO public.europe_data VALUES (3943, 0, 37, 0.42, 31, 20);
INSERT INTO public.europe_data VALUES (3944, 4, 700, 3.14, 124, 20);
INSERT INTO public.europe_data VALUES (3945, 1, 374, 174.21, 125, 20);
INSERT INTO public.europe_data VALUES (3946, 2, 73, 0.82, 32, 20);
INSERT INTO public.europe_data VALUES (3947, 11, 230, 121.77, 181, 20);
INSERT INTO public.europe_data VALUES (3948, 0, 94, 4.11, 33, 20);
INSERT INTO public.europe_data VALUES (3949, 0, 0, 0.47, 34, 20);
INSERT INTO public.europe_data VALUES (3950, 2937, 31936, 47.04, 87, 20);
INSERT INTO public.europe_data VALUES (3951, 84, 4279, 195.31, 182, 20);
INSERT INTO public.europe_data VALUES (3952, 0, 17, 117.88, 183, 20);
INSERT INTO public.europe_data VALUES (3953, 0, 1, 0.06, 126, 20);
INSERT INTO public.europe_data VALUES (3954, 22, 1701, 578.77, 184, 20);
INSERT INTO public.europe_data VALUES (3955, 0, 0, 0, 88, 20);
INSERT INTO public.europe_data VALUES (3956, 239, 15942, 84.99, 35, 20);
INSERT INTO public.europe_data VALUES (3957, 15, 1212, 8.94, 36, 20);
INSERT INTO public.europe_data VALUES (3958, 132, 4929, 14.28, 127, 20);
INSERT INTO public.europe_data VALUES (3959, 7, 656, 52.68, 37, 20);
INSERT INTO public.europe_data VALUES (3960, 66, 9272, 67.23, 128, 20);
INSERT INTO public.europe_data VALUES (3961, 95, 17826, 170.62, 185, 20);
INSERT INTO public.europe_data VALUES (3962, 0, 1, 0.35, 208, 20);
INSERT INTO public.europe_data VALUES (3963, 0, 13, 0.63, 209, 20);
INSERT INTO public.europe_data VALUES (3964, 2, 112, 3.9, 89, 20);
INSERT INTO public.europe_data VALUES (3965, 0, 8, 0.07, 38, 20);
INSERT INTO public.europe_data VALUES (3966, 10, 1082, 1.03, 39, 20);
INSERT INTO public.europe_data VALUES (3967, 32, 894, 93.16, 186, 20);
INSERT INTO public.europe_data VALUES (3968, 0, 1, 17.48, 210, 20);
INSERT INTO public.europe_data VALUES (3969, 3, 761, 28.9, 187, 20);
INSERT INTO public.europe_data VALUES (3970, 63, 3975, 154.85, 129, 20);
INSERT INTO public.europe_data VALUES (3971, 46, 4537, 4.07, 130, 20);
INSERT INTO public.europe_data VALUES (3972, 43, 3747, 194.38, 131, 20);
INSERT INTO public.europe_data VALUES (3973, 83, 4352, 207.47, 90, 20);
INSERT INTO public.europe_data VALUES (3974, 0, 15, 0.24, 211, 20);
INSERT INTO public.europe_data VALUES (3975, 144, 5164, 154.26, 91, 20);
INSERT INTO public.europe_data VALUES (3976, 893, 36407, 232.8, 92, 20);
INSERT INTO public.europe_data VALUES (3977, 360, 17483, 39.78, 132, 20);
INSERT INTO public.europe_data VALUES (3978, 139, 8090, 34.7, 188, 20);
INSERT INTO public.europe_data VALUES (3979, 41, 5027, 93.62, 189, 20);
INSERT INTO public.europe_data VALUES (3980, 36, 4466, 304.22, 93, 20);
INSERT INTO public.europe_data VALUES (3981, 4, 1708, 118.08, 133, 20);
INSERT INTO public.europe_data VALUES (3982, 283, 9892, 98.78, 190, 20);
INSERT INTO public.europe_data VALUES (3983, 906, 48039, 60.76, 191, 20);
INSERT INTO public.europe_data VALUES (3984, 3, 109, 1.81, 40, 20);
INSERT INTO public.europe_data VALUES (3985, 0, 2, 3.79, 94, 20);
INSERT INTO public.europe_data VALUES (3986, 0, 0, 0, 95, 20);
INSERT INTO public.europe_data VALUES (3987, 0, 0, 0, 96, 20);
INSERT INTO public.europe_data VALUES (3988, 0, 4, 14.51, 192, 20);
INSERT INTO public.europe_data VALUES (3989, 0, 3, 2.33, 41, 20);
INSERT INTO public.europe_data VALUES (3990, 198, 3439, 22.01, 134, 20);
INSERT INTO public.europe_data VALUES (3991, 6, 195, 3.86, 42, 20);
INSERT INTO public.europe_data VALUES (3992, 6, 476, 14.02, 193, 20);
INSERT INTO public.europe_data VALUES (3993, 0, 2, 4.09, 43, 20);
INSERT INTO public.europe_data VALUES (3994, 0, 47, 1.36, 44, 20);
INSERT INTO public.europe_data VALUES (3995, 0, 124, 5.07, 135, 20);
INSERT INTO public.europe_data VALUES (3996, 2, 60, 224.11, 97, 20);
INSERT INTO public.europe_data VALUES (3997, 5, 2401, 65.06, 194, 20);
INSERT INTO public.europe_data VALUES (3998, 3, 930, 79.2, 195, 20);
INSERT INTO public.europe_data VALUES (3999, 1, 146, 1.29, 45, 20);
INSERT INTO public.europe_data VALUES (4000, 445, 9555, 35.82, 46, 20);
INSERT INTO public.europe_data VALUES (4001, 21, 616, 2.69, 136, 20);
INSERT INTO public.europe_data VALUES (4002, 0, 44, 0.98, 47, 20);
INSERT INTO public.europe_data VALUES (4003, 748, 76798, 329.24, 196, 20);
INSERT INTO public.europe_data VALUES (4004, 0, 73, 0.59, 137, 20);
INSERT INTO public.europe_data VALUES (4005, 0, 51, 0.32, 48, 20);
INSERT INTO public.europe_data VALUES (4006, 5, 112, 43.52, 98, 20);
INSERT INTO public.europe_data VALUES (4007, 11, 2919, 48.87, 197, 20);
INSERT INTO public.europe_data VALUES (4008, 14, 2693, 56.13, 198, 20);
INSERT INTO public.europe_data VALUES (4009, 20, 272, 3.12, 138, 20);
INSERT INTO public.europe_data VALUES (4010, 0, 1, 0.05, 139, 20);
INSERT INTO public.europe_data VALUES (4011, 2, 300, 6.4, 140, 20);
INSERT INTO public.europe_data VALUES (4012, 0, 39, 0.1, 141, 20);
INSERT INTO public.europe_data VALUES (4013, 0, 0, 0, 142, 20);
INSERT INTO public.europe_data VALUES (4014, 5, 77, 2.12, 49, 20);
INSERT INTO public.europe_data VALUES (4015, 6, 461, 94.63, 99, 20);
INSERT INTO public.europe_data VALUES (4016, 55, 5382, 81.05, 50, 20);
INSERT INTO public.europe_data VALUES (4017, 491, 58676, 143.27, 199, 20);
INSERT INTO public.europe_data VALUES (4018, 0, 14, 94.26, 100, 20);
INSERT INTO public.europe_data VALUES (4019, 10, 1243, 6.17, 51, 20);
INSERT INTO public.europe_data VALUES (4020, 402, 22956, 100.69, 200, 20);
INSERT INTO public.europe_data VALUES (4021, 8, 6553, 122.61, 143, 20);
INSERT INTO public.europe_data VALUES (4022, 211, 40712, 99.73, 201, 20);
INSERT INTO public.europe_data VALUES (4023, 0, 0, 0, 52, 20);
INSERT INTO public.europe_data VALUES (4024, 5247, 310232, 180.84, 101, 20);
INSERT INTO public.europe_data VALUES (4025, 0, 48, 92.75, 102, 20);
INSERT INTO public.europe_data VALUES (4026, 1, 91, 5.78, 103, 20);
INSERT INTO public.europe_data VALUES (4027, 25, 3804, 24.17, 144, 20);
INSERT INTO public.europe_data VALUES (4028, 59, 6035, 42.61, 104, 20);
INSERT INTO public.europe_data VALUES (4029, 0, 6, 0.01, 145, 20);
INSERT INTO public.europe_data VALUES (4030, 0, 0, 0, 53, 20);
INSERT INTO public.europe_data VALUES (4031, 2, 4, 0.07, 146, 20);
INSERT INTO public.europe_data VALUES (4032, 2, 510, 6.17, 54, 20);
INSERT INTO public.europe_data VALUES (4033, 2, 129, 1.95, 55, 20);
INSERT INTO public.europe_data VALUES (4034, 21, 328, 1.7, 105, 21);
INSERT INTO public.europe_data VALUES (4035, 28, 1032, 74.41, 147, 21);
INSERT INTO public.europe_data VALUES (4036, 60, 1572, 8.04, 1, 21);
INSERT INTO public.europe_data VALUES (4037, 0, 220, 458.14, 148, 21);
INSERT INTO public.europe_data VALUES (4038, 20, 656, 3.32, 2, 21);
INSERT INTO public.europe_data VALUES (4039, 0, 0, 0, 56, 21);
INSERT INTO public.europe_data VALUES (4040, 0, 1, 1.03, 57, 21);
INSERT INTO public.europe_data VALUES (4041, 1602, 76453, 337.48, 58, 21);
INSERT INTO public.europe_data VALUES (4042, 14, 1569, 89.53, 149, 21);
INSERT INTO public.europe_data VALUES (4043, 5, 505, 1036.59, 59, 21);
INSERT INTO public.europe_data VALUES (4044, 39, 247, 2.46, 202, 21);
INSERT INTO public.europe_data VALUES (4045, 10, 5222, 105.69, 150, 21);
INSERT INTO public.europe_data VALUES (4046, 13, 861, 18.5, 151, 21);
INSERT INTO public.europe_data VALUES (4047, 7, 442, 211.56, 60, 21);
INSERT INTO public.europe_data VALUES (4048, 9, 4913, 592.75, 106, 21);
INSERT INTO public.europe_data VALUES (4049, 206, 11396, 14.57, 107, 21);
INSERT INTO public.europe_data VALUES (4050, 0, 8, 3.48, 61, 21);
INSERT INTO public.europe_data VALUES (4051, 30, 1501, 29.78, 152, 21);
INSERT INTO public.europe_data VALUES (4052, 27, 10108, 141.99, 153, 21);
INSERT INTO public.europe_data VALUES (4053, 2, 147, 93.76, 62, 21);
INSERT INTO public.europe_data VALUES (4054, 0, 13, 0.57, 3, 21);
INSERT INTO public.europe_data VALUES (4055, 0, 3, 8, 63, 21);
INSERT INTO public.europe_data VALUES (4056, 0, 16, 4.06, 108, 21);
INSERT INTO public.europe_data VALUES (4057, 273, 3885, 86.05, 64, 21);
INSERT INTO public.europe_data VALUES (4058, 1, 10, 69.28, 65, 21);
INSERT INTO public.europe_data VALUES (4059, 68, 1962, 129.72, 154, 21);
INSERT INTO public.europe_data VALUES (4060, 3, 315, 24.53, 4, 21);
INSERT INTO public.europe_data VALUES (4061, 5270, 214174, 192.9, 66, 21);
INSERT INTO public.europe_data VALUES (4062, 0, 5, 26.64, 67, 21);
INSERT INTO public.europe_data VALUES (4063, 0, 0, 0, 109, 21);
INSERT INTO public.europe_data VALUES (4064, 41, 945, 25.9, 155, 21);
INSERT INTO public.europe_data VALUES (4065, 0, 139, 1.94, 5, 21);
INSERT INTO public.europe_data VALUES (4066, 0, 1, 0.1, 6, 21);
INSERT INTO public.europe_data VALUES (4067, 0, 0, 0.01, 110, 21);
INSERT INTO public.europe_data VALUES (4068, 1, 264, 3.2, 7, 21);
INSERT INTO public.europe_data VALUES (4069, 46, 6990, 31.42, 68, 21);
INSERT INTO public.europe_data VALUES (4070, 7, 444, 168.57, 8, 21);
INSERT INTO public.europe_data VALUES (4071, 0, 1, 6.16, 69, 21);
INSERT INTO public.europe_data VALUES (4072, 0, 44, 1.35, 9, 21);
INSERT INTO public.europe_data VALUES (4073, 1, 67, 0.7, 10, 21);
INSERT INTO public.europe_data VALUES (4074, 337, 11526, 125.39, 70, 21);
INSERT INTO public.europe_data VALUES (4075, 3, 172, 0.02, 111, 21);
INSERT INTO public.europe_data VALUES (4076, 1284, 48757, 195.78, 71, 21);
INSERT INTO public.europe_data VALUES (4077, 0, 14, 2.12, 11, 21);
INSERT INTO public.europe_data VALUES (4078, 1, 52, 6.65, 12, 21);
INSERT INTO public.europe_data VALUES (4079, 116, 8258, 332.68, 72, 21);
INSERT INTO public.europe_data VALUES (4080, 0, 307, 2.85, 13, 21);
INSERT INTO public.europe_data VALUES (4081, 24, 1389, 72.57, 156, 21);
INSERT INTO public.europe_data VALUES (4082, 7, 407, 6.9, 73, 21);
INSERT INTO public.europe_data VALUES (4083, 0, 111, 107.7, 74, 21);
INSERT INTO public.europe_data VALUES (4084, 1, 74, 10.39, 157, 21);
INSERT INTO public.europe_data VALUES (4085, 47, 13052, 197.98, 158, 21);
INSERT INTO public.europe_data VALUES (4086, 6, 125, 0.35, 14, 21);
INSERT INTO public.europe_data VALUES (4087, 6, 2631, 74.06, 159, 21);
INSERT INTO public.europe_data VALUES (4088, 0, 8, 1.54, 15, 21);
INSERT INTO public.europe_data VALUES (4089, 0, 0, 5.57, 75, 21);
INSERT INTO public.europe_data VALUES (4090, 79, 4629, 83.4, 76, 21);
INSERT INTO public.europe_data VALUES (4091, 187, 7825, 95.75, 77, 21);
INSERT INTO public.europe_data VALUES (4092, 122, 1006, 2.14, 16, 21);
INSERT INTO public.europe_data VALUES (4093, 24, 544, 19.29, 78, 21);
INSERT INTO public.europe_data VALUES (4094, 0, 6, 2.21, 17, 21);
INSERT INTO public.europe_data VALUES (4095, 0, 3, 0.97, 18, 21);
INSERT INTO public.europe_data VALUES (4096, 0, 248, 30.87, 160, 21);
INSERT INTO public.europe_data VALUES (4097, 6, 194, 36.23, 19, 21);
INSERT INTO public.europe_data VALUES (4098, 83, 4519, 9.05, 20, 21);
INSERT INTO public.europe_data VALUES (4099, 0, 0, 0, 79, 21);
INSERT INTO public.europe_data VALUES (4100, 0, 11, 43.14, 161, 21);
INSERT INTO public.europe_data VALUES (4101, 0, 0, 0.11, 203, 21);
INSERT INTO public.europe_data VALUES (4102, 2, 400, 12.49, 162, 21);
INSERT INTO public.europe_data VALUES (4103, 369, 72669, 192.48, 163, 21);
INSERT INTO public.europe_data VALUES (4104, 0, 427, 223.43, 204, 21);
INSERT INTO public.europe_data VALUES (4105, 0, 53, 4.37, 21, 21);
INSERT INTO public.europe_data VALUES (4106, 5, 121, 14.01, 22, 21);
INSERT INTO public.europe_data VALUES (4107, 1, 1303, 51.42, 164, 21);
INSERT INTO public.europe_data VALUES (4108, 36, 11982, 25.94, 165, 21);
INSERT INTO public.europe_data VALUES (4109, 11, 570, 4.03, 23, 21);
INSERT INTO public.europe_data VALUES (4110, 0, 20, 103.84, 166, 21);
INSERT INTO public.europe_data VALUES (4111, 33, 1902, 33.74, 167, 21);
INSERT INTO public.europe_data VALUES (4112, 0, 0, 0, 80, 21);
INSERT INTO public.europe_data VALUES (4113, 0, 0, 0, 81, 21);
INSERT INTO public.europe_data VALUES (4114, 9, 226, 297.68, 205, 21);
INSERT INTO public.europe_data VALUES (4115, 162, 3535, 44.14, 82, 21);
INSERT INTO public.europe_data VALUES (4116, 0, 2, 4.65, 168, 21);
INSERT INTO public.europe_data VALUES (4117, 1, 305, 4.72, 24, 21);
INSERT INTO public.europe_data VALUES (4118, 0, 28, 3.02, 25, 21);
INSERT INTO public.europe_data VALUES (4119, 8, 416, 102.33, 83, 21);
INSERT INTO public.europe_data VALUES (4120, 2, 126, 2.3, 84, 21);
INSERT INTO public.europe_data VALUES (4121, 0, 0, 0, 169, 21);
INSERT INTO public.europe_data VALUES (4122, 105, 3827, 70.3, 85, 21);
INSERT INTO public.europe_data VALUES (4123, 49, 6557, 107.23, 170, 21);
INSERT INTO public.europe_data VALUES (4124, 0, 181, 57.42, 171, 21);
INSERT INTO public.europe_data VALUES (4125, 8160, 641153, 93.89, 112, 21);
INSERT INTO public.europe_data VALUES (4126, 830, 26294, 18.69, 113, 21);
INSERT INTO public.europe_data VALUES (4127, 1144, 20111, 42.79, 114, 21);
INSERT INTO public.europe_data VALUES (4128, 541, 28726, 149.24, 115, 21);
INSERT INTO public.europe_data VALUES (4129, 8, 1948, 66.49, 172, 21);
INSERT INTO public.europe_data VALUES (4130, 0, 2, 2.36, 173, 21);
INSERT INTO public.europe_data VALUES (4131, 137, 31831, 678.25, 116, 21);
INSERT INTO public.europe_data VALUES (4132, 97, 10403, 34, 174, 21);
INSERT INTO public.europe_data VALUES (4133, 25, 1217, 63.94, 86, 21);
INSERT INTO public.europe_data VALUES (4134, 58, 3000, 5.36, 117, 21);
INSERT INTO public.europe_data VALUES (4135, 0, 13, 8.35, 175, 21);
INSERT INTO public.europe_data VALUES (4136, 6, 1465, 23.44, 118, 21);
INSERT INTO public.europe_data VALUES (4137, 53, 1942, 23.35, 119, 21);
INSERT INTO public.europe_data VALUES (4138, 26, 824, 3.57, 26, 21);
INSERT INTO public.europe_data VALUES (4139, 17, 426, 52.49, 176, 21);
INSERT INTO public.europe_data VALUES (4140, 24, 4670, 234.18, 120, 21);
INSERT INTO public.europe_data VALUES (4141, 0, 543, 15.9, 121, 21);
INSERT INTO public.europe_data VALUES (4142, 0, 0, 0.01, 122, 21);
INSERT INTO public.europe_data VALUES (4143, 1, 51, 5.05, 177, 21);
INSERT INTO public.europe_data VALUES (4144, 56, 4993, 129.48, 123, 21);
INSERT INTO public.europe_data VALUES (4145, 0, 179, 12.99, 27, 21);
INSERT INTO public.europe_data VALUES (4146, 0, 16, 0.57, 28, 21);
INSERT INTO public.europe_data VALUES (4147, 76, 5168, 150.5, 29, 21);
INSERT INTO public.europe_data VALUES (4148, 0, 1, 10.42, 178, 21);
INSERT INTO public.europe_data VALUES (4149, 0, 409, 23.66, 179, 21);
INSERT INTO public.europe_data VALUES (4150, 0, 610, 147.91, 180, 21);
INSERT INTO public.europe_data VALUES (4151, 12, 296, 2.72, 30, 21);
INSERT INTO public.europe_data VALUES (4152, 2, 41, 0.63, 31, 21);
INSERT INTO public.europe_data VALUES (4153, 2, 304, 2.57, 124, 21);
INSERT INTO public.europe_data VALUES (4154, 1, 551, 214.71, 125, 21);
INSERT INTO public.europe_data VALUES (4155, 0, 89, 0.87, 32, 21);
INSERT INTO public.europe_data VALUES (4156, 6, 371, 141.83, 181, 21);
INSERT INTO public.europe_data VALUES (4157, 0, 92, 5.17, 33, 21);
INSERT INTO public.europe_data VALUES (4158, 0, 6, 0.87, 34, 21);
INSERT INTO public.europe_data VALUES (4159, 2672, 28075, 48.45, 87, 21);
INSERT INTO public.europe_data VALUES (4160, 80, 3618, 168.16, 182, 21);
INSERT INTO public.europe_data VALUES (4161, 0, 22, 136.01, 183, 21);
INSERT INTO public.europe_data VALUES (4162, 0, 1, 0.06, 126, 21);
INSERT INTO public.europe_data VALUES (4163, 16, 1900, 491.66, 184, 21);
INSERT INTO public.europe_data VALUES (4164, 0, 0, 0, 88, 21);
INSERT INTO public.europe_data VALUES (4165, 252, 15057, 80.47, 35, 21);
INSERT INTO public.europe_data VALUES (4166, 8, 1502, 7.66, 36, 21);
INSERT INTO public.europe_data VALUES (4167, 70, 2790, 8.03, 127, 21);
INSERT INTO public.europe_data VALUES (4168, 11, 658, 67.83, 37, 21);
INSERT INTO public.europe_data VALUES (4169, 66, 9963, 62.45, 128, 21);
INSERT INTO public.europe_data VALUES (4170, 25, 11661, 109.76, 185, 21);
INSERT INTO public.europe_data VALUES (4171, 0, 0, 0, 208, 21);
INSERT INTO public.europe_data VALUES (4172, 1, 17, 0.82, 209, 21);
INSERT INTO public.europe_data VALUES (4173, 3, 143, 4.48, 89, 21);
INSERT INTO public.europe_data VALUES (4174, 0, 8, 0.05, 38, 21);
INSERT INTO public.europe_data VALUES (4175, 16, 986, 1.11, 39, 21);
INSERT INTO public.europe_data VALUES (4176, 47, 1041, 94.99, 186, 21);
INSERT INTO public.europe_data VALUES (4177, 0, 9, 19.23, 210, 21);
INSERT INTO public.europe_data VALUES (4178, 2, 779, 28.62, 187, 21);
INSERT INTO public.europe_data VALUES (4179, 66, 3729, 128.7, 129, 21);
INSERT INTO public.europe_data VALUES (4180, 37, 4284, 3.42, 130, 21);
INSERT INTO public.europe_data VALUES (4181, 50, 5936, 229.53, 131, 21);
INSERT INTO public.europe_data VALUES (4182, 91, 4458, 215.71, 90, 21);
INSERT INTO public.europe_data VALUES (4183, 1, 6, 0.23, 211, 21);
INSERT INTO public.europe_data VALUES (4184, 134, 5703, 156.63, 91, 21);
INSERT INTO public.europe_data VALUES (4185, 659, 39276, 242.75, 92, 21);
INSERT INTO public.europe_data VALUES (4186, 613, 25527, 45.67, 132, 21);
INSERT INTO public.europe_data VALUES (4187, 105, 5088, 22.16, 188, 21);
INSERT INTO public.europe_data VALUES (4188, 45, 4594, 80.95, 189, 21);
INSERT INTO public.europe_data VALUES (4189, 69, 4458, 249.03, 93, 21);
INSERT INTO public.europe_data VALUES (4190, 5, 1636, 115.85, 133, 21);
INSERT INTO public.europe_data VALUES (4191, 272, 9286, 91.51, 190, 21);
INSERT INTO public.europe_data VALUES (4192, 840, 40588, 53.4, 191, 21);
INSERT INTO public.europe_data VALUES (4193, 4, 120, 2.67, 40, 21);
INSERT INTO public.europe_data VALUES (4194, 0, 0, 0, 94, 21);
INSERT INTO public.europe_data VALUES (4195, 0, 0, 0.55, 95, 21);
INSERT INTO public.europe_data VALUES (4196, 0, 0, 2.71, 96, 21);
INSERT INTO public.europe_data VALUES (4197, 0, 1, 20.32, 192, 21);
INSERT INTO public.europe_data VALUES (4198, 0, 2, 4.65, 41, 21);
INSERT INTO public.europe_data VALUES (4199, 217, 4103, 26.05, 134, 21);
INSERT INTO public.europe_data VALUES (4200, 5, 434, 4.46, 42, 21);
INSERT INTO public.europe_data VALUES (4201, 8, 500, 14.4, 193, 21);
INSERT INTO public.europe_data VALUES (4202, 0, 2, 4.09, 43, 21);
INSERT INTO public.europe_data VALUES (4203, 0, 59, 1.46, 44, 21);
INSERT INTO public.europe_data VALUES (4204, 0, 170, 9.54, 135, 21);
INSERT INTO public.europe_data VALUES (4205, 1, 35, 172.21, 97, 21);
INSERT INTO public.europe_data VALUES (4206, 1, 1145, 37.85, 194, 21);
INSERT INTO public.europe_data VALUES (4207, 2, 718, 59.88, 195, 21);
INSERT INTO public.europe_data VALUES (4208, 0, 53, 0.52, 45, 21);
INSERT INTO public.europe_data VALUES (4209, 506, 11418, 38.75, 46, 21);
INSERT INTO public.europe_data VALUES (4210, 22, 760, 3.41, 136, 21);
INSERT INTO public.europe_data VALUES (4211, 0, 64, 0.89, 47, 21);
INSERT INTO public.europe_data VALUES (4212, 815, 77738, 310.88, 196, 21);
INSERT INTO public.europe_data VALUES (4213, 1, 53, 0.77, 137, 21);
INSERT INTO public.europe_data VALUES (4214, 2, 85, 0.35, 48, 21);
INSERT INTO public.europe_data VALUES (4215, 4, 141, 64.85, 98, 21);
INSERT INTO public.europe_data VALUES (4216, 12, 2080, 35.89, 197, 21);
INSERT INTO public.europe_data VALUES (4217, 18, 2103, 57.09, 198, 21);
INSERT INTO public.europe_data VALUES (4218, 17, 260, 3.68, 138, 21);
INSERT INTO public.europe_data VALUES (4219, 0, 11, 0.07, 139, 21);
INSERT INTO public.europe_data VALUES (4220, 1, 297, 5.94, 140, 21);
INSERT INTO public.europe_data VALUES (4221, 1, 31, 0.09, 141, 21);
INSERT INTO public.europe_data VALUES (4222, 0, 0, 0, 142, 21);
INSERT INTO public.europe_data VALUES (4223, 4, 94, 2.2, 49, 21);
INSERT INTO public.europe_data VALUES (4224, 12, 859, 118.35, 99, 21);
INSERT INTO public.europe_data VALUES (4225, 52, 4097, 50.93, 50, 21);
INSERT INTO public.europe_data VALUES (4226, 450, 58815, 143.02, 199, 21);
INSERT INTO public.europe_data VALUES (4227, 0, 22, 183.27, 100, 21);
INSERT INTO public.europe_data VALUES (4228, 8, 1488, 5.92, 51, 21);
INSERT INTO public.europe_data VALUES (4229, 379, 21343, 90.43, 200, 21);
INSERT INTO public.europe_data VALUES (4230, 5, 5427, 111.89, 143, 21);
INSERT INTO public.europe_data VALUES (4231, 149, 25753, 70.68, 201, 21);
INSERT INTO public.europe_data VALUES (4232, 0, 0, 0, 52, 21);
INSERT INTO public.europe_data VALUES (4233, 5430, 284835, 160.57, 101, 21);
INSERT INTO public.europe_data VALUES (4234, 0, 49, 84.15, 102, 21);
INSERT INTO public.europe_data VALUES (4235, 1, 109, 6.88, 103, 21);
INSERT INTO public.europe_data VALUES (4236, 41, 4169, 24.3, 144, 21);
INSERT INTO public.europe_data VALUES (4237, 62, 6116, 46.88, 104, 21);
INSERT INTO public.europe_data VALUES (4238, 0, 5, 0.02, 145, 21);
INSERT INTO public.europe_data VALUES (4239, 0, 0, 0, 53, 21);
INSERT INTO public.europe_data VALUES (4240, 3, 17, 0.15, 146, 21);
INSERT INTO public.europe_data VALUES (4241, 18, 592, 7.59, 54, 21);
INSERT INTO public.europe_data VALUES (4242, 1, 157, 4.82, 55, 21);
INSERT INTO public.europe_data VALUES (4243, 8, 318, 1.46, 105, 22);
INSERT INTO public.europe_data VALUES (4244, 18, 1098, 68.93, 147, 22);
INSERT INTO public.europe_data VALUES (4245, 56, 1890, 9.54, 1, 22);
INSERT INTO public.europe_data VALUES (4246, 0, 129, 288.8, 148, 22);
INSERT INTO public.europe_data VALUES (4247, 15, 400, 2.23, 2, 22);
INSERT INTO public.europe_data VALUES (4248, 0, 0, 0, 56, 22);
INSERT INTO public.europe_data VALUES (4249, 0, 0, 1.03, 57, 22);
INSERT INTO public.europe_data VALUES (4250, 1500, 74675, 324.34, 58, 22);
INSERT INTO public.europe_data VALUES (4251, 19, 1079, 71.41, 149, 22);
INSERT INTO public.europe_data VALUES (4252, 4, 597, 986.74, 59, 22);
INSERT INTO public.europe_data VALUES (4253, 57, 372, 3.89, 202, 22);
INSERT INTO public.europe_data VALUES (4254, 20, 4141, 69.05, 150, 22);
INSERT INTO public.europe_data VALUES (4255, 14, 998, 20.08, 151, 22);
INSERT INTO public.europe_data VALUES (4256, 9, 382, 195.39, 60, 22);
INSERT INTO public.europe_data VALUES (4257, 14, 4815, 488.19, 106, 22);
INSERT INTO public.europe_data VALUES (4258, 284, 12363, 16.37, 107, 22);
INSERT INTO public.europe_data VALUES (4259, 0, 2, 2.79, 61, 22);
INSERT INTO public.europe_data VALUES (4260, 39, 1314, 26.3, 152, 22);
INSERT INTO public.europe_data VALUES (4261, 19, 6158, 85.66, 153, 22);
INSERT INTO public.europe_data VALUES (4262, 4, 219, 124.5, 62, 22);
INSERT INTO public.europe_data VALUES (4263, 0, 54, 1.03, 3, 22);
INSERT INTO public.europe_data VALUES (4264, 0, 2, 12.8, 63, 22);
INSERT INTO public.europe_data VALUES (4265, 0, 15, 2.75, 108, 22);
INSERT INTO public.europe_data VALUES (4266, 336, 6022, 94.01, 64, 22);
INSERT INTO public.europe_data VALUES (4267, 0, 8, 42.34, 65, 22);
INSERT INTO public.europe_data VALUES (4268, 50, 2320, 111.27, 154, 22);
INSERT INTO public.europe_data VALUES (4269, 2, 250, 26.87, 4, 22);
INSERT INTO public.europe_data VALUES (4270, 4975, 192934, 221.82, 66, 22);
INSERT INTO public.europe_data VALUES (4271, 0, 3, 96.56, 67, 22);
INSERT INTO public.europe_data VALUES (4272, 0, 0, 0.23, 109, 22);
INSERT INTO public.europe_data VALUES (4273, 49, 868, 24.69, 155, 22);
INSERT INTO public.europe_data VALUES (4274, 1, 255, 1.67, 5, 22);
INSERT INTO public.europe_data VALUES (4275, 0, 10, 0.23, 6, 22);
INSERT INTO public.europe_data VALUES (4276, 0, 1, 0.01, 110, 22);
INSERT INTO public.europe_data VALUES (4277, 1, 563, 3.96, 7, 22);
INSERT INTO public.europe_data VALUES (4278, 26, 4764, 23.31, 68, 22);
INSERT INTO public.europe_data VALUES (4279, 2, 483, 174.75, 8, 22);
INSERT INTO public.europe_data VALUES (4280, 0, 3, 4.62, 69, 22);
INSERT INTO public.europe_data VALUES (4281, 0, 20, 1.03, 9, 22);
INSERT INTO public.europe_data VALUES (4282, 1, 45, 0.45, 10, 22);
INSERT INTO public.europe_data VALUES (4283, 357, 12238, 130.72, 70, 22);
INSERT INTO public.europe_data VALUES (4284, 4, 139, 0.02, 111, 22);
INSERT INTO public.europe_data VALUES (4285, 1512, 49798, 215.3, 71, 22);
INSERT INTO public.europe_data VALUES (4286, 0, 4, 3.88, 11, 22);
INSERT INTO public.europe_data VALUES (4287, 6, 306, 17.75, 12, 22);
INSERT INTO public.europe_data VALUES (4288, 112, 8534, 312.13, 72, 22);
INSERT INTO public.europe_data VALUES (4289, 1, 425, 4.14, 13, 22);
INSERT INTO public.europe_data VALUES (4290, 26, 1569, 83.66, 156, 22);
INSERT INTO public.europe_data VALUES (4291, 7, 375, 6.27, 73, 22);
INSERT INTO public.europe_data VALUES (4292, 0, 65, 61.19, 74, 22);
INSERT INTO public.europe_data VALUES (4293, 0, 17, 4.45, 157, 22);
INSERT INTO public.europe_data VALUES (4294, 20, 8032, 111, 158, 22);
INSERT INTO public.europe_data VALUES (4295, 5, 180, 0.4, 14, 22);
INSERT INTO public.europe_data VALUES (4296, 2, 1669, 43.33, 159, 22);
INSERT INTO public.europe_data VALUES (4297, 0, 7, 1.03, 15, 22);
INSERT INTO public.europe_data VALUES (4298, 0, 4, 5.57, 75, 22);
INSERT INTO public.europe_data VALUES (4299, 123, 4327, 87.71, 76, 22);
INSERT INTO public.europe_data VALUES (4300, 379, 8810, 28.47, 77, 22);
INSERT INTO public.europe_data VALUES (4301, 118, 1146, 2.27, 16, 22);
INSERT INTO public.europe_data VALUES (4302, 24, 701, 19.83, 78, 22);
INSERT INTO public.europe_data VALUES (4303, 0, 24, 4.06, 17, 22);
INSERT INTO public.europe_data VALUES (4304, 0, 31, 1.23, 18, 22);
INSERT INTO public.europe_data VALUES (4305, 0, 161, 22.87, 160, 22);
INSERT INTO public.europe_data VALUES (4306, 4, 222, 44.77, 19, 22);
INSERT INTO public.europe_data VALUES (4307, 95, 5629, 11.76, 20, 22);
INSERT INTO public.europe_data VALUES (4308, 0, 0, 0, 79, 22);
INSERT INTO public.europe_data VALUES (4309, 0, 10, 24.65, 161, 22);
INSERT INTO public.europe_data VALUES (4310, 0, 1, 0.45, 203, 22);
INSERT INTO public.europe_data VALUES (4311, 1, 289, 9.12, 162, 22);
INSERT INTO public.europe_data VALUES (4312, 215, 56317, 153.93, 163, 22);
INSERT INTO public.europe_data VALUES (4313, 2, 197, 168.64, 204, 22);
INSERT INTO public.europe_data VALUES (4314, 0, 42, 6.35, 21, 22);
INSERT INTO public.europe_data VALUES (4315, 4, 208, 18.83, 22, 22);
INSERT INTO public.europe_data VALUES (4316, 0, 752, 22.64, 164, 22);
INSERT INTO public.europe_data VALUES (4317, 25, 9556, 21.65, 165, 22);
INSERT INTO public.europe_data VALUES (4318, 3, 657, 4.04, 23, 22);
INSERT INTO public.europe_data VALUES (4319, 0, 15, 133.51, 166, 22);
INSERT INTO public.europe_data VALUES (4320, 21, 1716, 28.96, 167, 22);
INSERT INTO public.europe_data VALUES (4321, 0, 0, 0, 80, 22);
INSERT INTO public.europe_data VALUES (4322, 0, 0, 0, 81, 22);
INSERT INTO public.europe_data VALUES (4323, 11, 272, 325.17, 205, 22);
INSERT INTO public.europe_data VALUES (4324, 105, 4226, 45.49, 82, 22);
INSERT INTO public.europe_data VALUES (4325, 0, 1, 1.55, 168, 22);
INSERT INTO public.europe_data VALUES (4326, 2, 298, 5.08, 24, 22);
INSERT INTO public.europe_data VALUES (4327, 1, 30, 3.64, 25, 22);
INSERT INTO public.europe_data VALUES (4328, 10, 385, 79.08, 83, 22);
INSERT INTO public.europe_data VALUES (4329, 5, 133, 2.52, 84, 22);
INSERT INTO public.europe_data VALUES (4330, 0, 0, 0, 169, 22);
INSERT INTO public.europe_data VALUES (4331, 72, 3025, 78.13, 85, 22);
INSERT INTO public.europe_data VALUES (4332, 13, 3922, 64.96, 170, 22);
INSERT INTO public.europe_data VALUES (4333, 0, 24, 16.81, 171, 22);
INSERT INTO public.europe_data VALUES (4334, 8080, 641814, 89.66, 112, 22);
INSERT INTO public.europe_data VALUES (4335, 698, 24273, 17.12, 113, 22);
INSERT INTO public.europe_data VALUES (4336, 864, 15371, 34.32, 114, 22);
INSERT INTO public.europe_data VALUES (4337, 502, 29939, 150.43, 115, 22);
INSERT INTO public.europe_data VALUES (4338, 7, 1313, 45.37, 172, 22);
INSERT INTO public.europe_data VALUES (4339, 0, 0, 1.18, 173, 22);
INSERT INTO public.europe_data VALUES (4340, 100, 25952, 499.76, 116, 22);
INSERT INTO public.europe_data VALUES (4341, 69, 10119, 32.36, 174, 22);
INSERT INTO public.europe_data VALUES (4342, 9, 668, 47.96, 86, 22);
INSERT INTO public.europe_data VALUES (4343, 79, 3801, 6.14, 117, 22);
INSERT INTO public.europe_data VALUES (4344, 0, -4, 5.57, 175, 22);
INSERT INTO public.europe_data VALUES (4345, 8, 903, 13.34, 118, 22);
INSERT INTO public.europe_data VALUES (4346, 60, 2390, 31.48, 119, 22);
INSERT INTO public.europe_data VALUES (4347, 25, 1054, 3.99, 26, 22);
INSERT INTO public.europe_data VALUES (4348, 33, 518, 72.45, 176, 22);
INSERT INTO public.europe_data VALUES (4349, 16, 5182, 240.74, 120, 22);
INSERT INTO public.europe_data VALUES (4350, 3, 477, 16.05, 121, 22);
INSERT INTO public.europe_data VALUES (4351, 0, 1, 0.01, 122, 22);
INSERT INTO public.europe_data VALUES (4352, 0, 46, 4.22, 177, 22);
INSERT INTO public.europe_data VALUES (4353, 50, 3884, 108.52, 123, 22);
INSERT INTO public.europe_data VALUES (4354, 2, 97, 8.42, 27, 22);
INSERT INTO public.europe_data VALUES (4355, 0, 12, 0.3, 28, 22);
INSERT INTO public.europe_data VALUES (4356, 77, 5032, 138.08, 29, 22);
INSERT INTO public.europe_data VALUES (4357, 0, 3, 7.82, 178, 22);
INSERT INTO public.europe_data VALUES (4358, 1, 252, 16.5, 179, 22);
INSERT INTO public.europe_data VALUES (4359, 0, 298, 92.69, 180, 22);
INSERT INTO public.europe_data VALUES (4360, 11, 438, 3.39, 30, 22);
INSERT INTO public.europe_data VALUES (4361, 2, 76, 0.83, 31, 22);
INSERT INTO public.europe_data VALUES (4362, 0, 518, 1.82, 124, 22);
INSERT INTO public.europe_data VALUES (4363, 3, 589, 283.64, 125, 22);
INSERT INTO public.europe_data VALUES (4364, 1, 82, 0.77, 32, 22);
INSERT INTO public.europe_data VALUES (4365, 1, 329, 105.56, 181, 22);
INSERT INTO public.europe_data VALUES (4366, 1, 142, 5.61, 33, 22);
INSERT INTO public.europe_data VALUES (4367, 0, 5, 1.18, 34, 22);
INSERT INTO public.europe_data VALUES (4368, 3263, 33735, 55.6, 87, 22);
INSERT INTO public.europe_data VALUES (4369, 60, 3181, 155.27, 182, 22);
INSERT INTO public.europe_data VALUES (4370, 0, 23, 120.9, 183, 22);
INSERT INTO public.europe_data VALUES (4371, 0, 1, 0.31, 126, 22);
INSERT INTO public.europe_data VALUES (4372, 12, 1159, 308.91, 184, 22);
INSERT INTO public.europe_data VALUES (4373, 0, 0, 0, 88, 22);
INSERT INTO public.europe_data VALUES (4374, 217, 14292, 69.33, 35, 22);
INSERT INTO public.europe_data VALUES (4375, 8, 825, 4.77, 36, 22);
INSERT INTO public.europe_data VALUES (4376, 16, 1551, 4.12, 127, 22);
INSERT INTO public.europe_data VALUES (4377, 12, 1034, 94.37, 37, 22);
INSERT INTO public.europe_data VALUES (4378, 56, 7902, 54.52, 128, 22);
INSERT INTO public.europe_data VALUES (4379, 11, 7308, 69.16, 185, 22);
INSERT INTO public.europe_data VALUES (4380, 0, 0, 1.06, 208, 22);
INSERT INTO public.europe_data VALUES (4381, 0, 22, 1.25, 209, 22);
INSERT INTO public.europe_data VALUES (4382, 3, 150, 4.95, 89, 22);
INSERT INTO public.europe_data VALUES (4383, 0, 3, 0.02, 38, 22);
INSERT INTO public.europe_data VALUES (4384, 25, 1251, 1.19, 39, 22);
INSERT INTO public.europe_data VALUES (4385, 40, 932, 85.07, 186, 22);
INSERT INTO public.europe_data VALUES (4386, 0, 2, 6.99, 210, 22);
INSERT INTO public.europe_data VALUES (4387, 1, 746, 24.83, 187, 22);
INSERT INTO public.europe_data VALUES (4388, 52, 2674, 84.46, 129, 22);
INSERT INTO public.europe_data VALUES (4389, 38, 3117, 2.85, 130, 22);
INSERT INTO public.europe_data VALUES (4390, 47, 5498, 209.72, 131, 22);
INSERT INTO public.europe_data VALUES (4391, 80, 4702, 227.96, 90, 22);
INSERT INTO public.europe_data VALUES (4392, 1, 14, 0.59, 211, 22);
INSERT INTO public.europe_data VALUES (4393, 90, 5331, 150.78, 91, 22);
INSERT INTO public.europe_data VALUES (4394, 872, 39642, 253.62, 92, 22);
INSERT INTO public.europe_data VALUES (4395, 496, 23851, 40.53, 132, 22);
INSERT INTO public.europe_data VALUES (4396, 68, 3328, 19.18, 188, 22);
INSERT INTO public.europe_data VALUES (4397, 27, 3725, 60.48, 189, 22);
INSERT INTO public.europe_data VALUES (4398, 62, 2847, 154.5, 93, 22);
INSERT INTO public.europe_data VALUES (4399, 2, 1645, 111.76, 133, 22);
INSERT INTO public.europe_data VALUES (4400, 270, 8481, 86.07, 190, 22);
INSERT INTO public.europe_data VALUES (4401, 758, 37306, 49.69, 191, 22);
INSERT INTO public.europe_data VALUES (4402, 3, 217, 4.52, 40, 22);
INSERT INTO public.europe_data VALUES (4403, 0, 0, 0, 94, 22);
INSERT INTO public.europe_data VALUES (4404, 0, 1, 0.55, 95, 22);
INSERT INTO public.europe_data VALUES (4405, 0, 3, 3.62, 96, 22);
INSERT INTO public.europe_data VALUES (4406, 0, 6, 34.83, 192, 22);
INSERT INTO public.europe_data VALUES (4407, 0, 8, 4.65, 41, 22);
INSERT INTO public.europe_data VALUES (4408, 187, 4824, 31.6, 134, 22);
INSERT INTO public.europe_data VALUES (4409, 7, 293, 4.44, 42, 22);
INSERT INTO public.europe_data VALUES (4410, 9, 503, 14.98, 193, 22);
INSERT INTO public.europe_data VALUES (4411, 0, 2, 3.07, 43, 22);
INSERT INTO public.europe_data VALUES (4412, 1, 55, 1.11, 44, 22);
INSERT INTO public.europe_data VALUES (4413, 0, 384, 10.94, 135, 22);
INSERT INTO public.europe_data VALUES (4414, 0, 38, 202.88, 97, 22);
INSERT INTO public.europe_data VALUES (4415, 1, 918, 30.38, 194, 22);
INSERT INTO public.europe_data VALUES (4416, 1, 528, 40.22, 195, 22);
INSERT INTO public.europe_data VALUES (4417, 1, 27, 0.51, 45, 22);
INSERT INTO public.europe_data VALUES (4418, 558, 11276, 42.24, 46, 22);
INSERT INTO public.europe_data VALUES (4419, 27, 989, 4.56, 136, 22);
INSERT INTO public.europe_data VALUES (4420, 1, 34, 0.53, 47, 22);
INSERT INTO public.europe_data VALUES (4421, 332, 68181, 278.82, 196, 22);
INSERT INTO public.europe_data VALUES (4422, 0, 111, 1.04, 137, 22);
INSERT INTO public.europe_data VALUES (4423, 2, 63, 0.66, 48, 22);
INSERT INTO public.europe_data VALUES (4424, 8, 236, 98.56, 98, 22);
INSERT INTO public.europe_data VALUES (4425, 13, 1592, 28.58, 197, 22);
INSERT INTO public.europe_data VALUES (4426, 14, 2775, 60.41, 198, 22);
INSERT INTO public.europe_data VALUES (4427, 21, 369, 4.9, 138, 22);
INSERT INTO public.europe_data VALUES (4428, 0, 5, 0.04, 139, 22);
INSERT INTO public.europe_data VALUES (4429, 2, 257, 5.35, 140, 22);
INSERT INTO public.europe_data VALUES (4430, 0, 30, 0.09, 141, 22);
INSERT INTO public.europe_data VALUES (4431, 0, 0, 0, 142, 22);
INSERT INTO public.europe_data VALUES (4432, 5, 84, 2.18, 49, 22);
INSERT INTO public.europe_data VALUES (4433, 19, 792, 97.42, 99, 22);
INSERT INTO public.europe_data VALUES (4434, 14, 1859, 25.23, 50, 22);
INSERT INTO public.europe_data VALUES (4435, 383, 58466, 142.48, 199, 22);
INSERT INTO public.europe_data VALUES (4436, 0, 48, 363.93, 100, 22);
INSERT INTO public.europe_data VALUES (4437, 14, 1132, 4.23, 51, 22);
INSERT INTO public.europe_data VALUES (4438, 367, 18441, 80.15, 200, 22);
INSERT INTO public.europe_data VALUES (4439, 11, 5505, 100.29, 143, 22);
INSERT INTO public.europe_data VALUES (4440, 77, 21352, 51.07, 201, 22);
INSERT INTO public.europe_data VALUES (4441, 0, 0, 0, 52, 22);
INSERT INTO public.europe_data VALUES (4442, 5138, 243558, 158.88, 101, 22);
INSERT INTO public.europe_data VALUES (4443, 2, 39, 82.23, 102, 22);
INSERT INTO public.europe_data VALUES (4444, 0, 129, 6.44, 103, 22);
INSERT INTO public.europe_data VALUES (4445, 44, 3845, 18.1, 144, 22);
INSERT INTO public.europe_data VALUES (4446, 57, 7251, 51.45, 104, 22);
INSERT INTO public.europe_data VALUES (4447, 0, 14, 0.02, 145, 22);
INSERT INTO public.europe_data VALUES (4448, 0, 0, 0, 53, 22);
INSERT INTO public.europe_data VALUES (4449, 11, 26, 0.21, 146, 22);
INSERT INTO public.europe_data VALUES (4450, 17, 763, 8.48, 54, 22);
INSERT INTO public.europe_data VALUES (4451, 17, 549, 7.61, 55, 22);
INSERT INTO public.europe_data VALUES (4452, 10, 236, 1.05, 105, 23);
INSERT INTO public.europe_data VALUES (4453, 36, 875, 63.86, 147, 23);
INSERT INTO public.europe_data VALUES (4454, 55, 2218, 11.39, 1, 23);
INSERT INTO public.europe_data VALUES (4455, 0, 91, 223.16, 148, 23);
INSERT INTO public.europe_data VALUES (4456, 10, 311, 2.4, 2, 23);
INSERT INTO public.europe_data VALUES (4457, 0, 0, 0, 56, 23);
INSERT INTO public.europe_data VALUES (4458, 0, 1, 1.03, 57, 23);
INSERT INTO public.europe_data VALUES (4459, 1406, 70567, 301.48, 58, 23);
INSERT INTO public.europe_data VALUES (4460, 20, 1033, 67.32, 149, 23);
INSERT INTO public.europe_data VALUES (4461, 4, 452, 828.71, 59, 23);
INSERT INTO public.europe_data VALUES (4462, 142, 609, 5.82, 202, 23);
INSERT INTO public.europe_data VALUES (4463, 3, 1976, 44.64, 150, 23);
INSERT INTO public.europe_data VALUES (4464, 17, 1020, 20.45, 151, 23);
INSERT INTO public.europe_data VALUES (4465, 15, 379, 200.52, 60, 23);
INSERT INTO public.europe_data VALUES (4466, 9, 3197, 349.33, 106, 23);
INSERT INTO public.europe_data VALUES (4467, 201, 14335, 18.74, 107, 23);
INSERT INTO public.europe_data VALUES (4468, 0, 6, 6.27, 61, 23);
INSERT INTO public.europe_data VALUES (4469, 35, 1172, 25.3, 152, 23);
INSERT INTO public.europe_data VALUES (4470, 17, 3655, 59.15, 153, 23);
INSERT INTO public.europe_data VALUES (4471, 2, 267, 147.3, 62, 23);
INSERT INTO public.europe_data VALUES (4472, 0, 68, 0.83, 3, 23);
INSERT INTO public.europe_data VALUES (4473, 0, 6, 12.8, 63, 23);
INSERT INTO public.europe_data VALUES (4474, 0, 6, 9.83, 108, 23);
INSERT INTO public.europe_data VALUES (4475, 2042, 4801, 100.93, 64, 23);
INSERT INTO public.europe_data VALUES (4476, 0, 3, 19.24, 65, 23);
INSERT INTO public.europe_data VALUES (4477, 47, 1353, 98.21, 154, 23);
INSERT INTO public.europe_data VALUES (4478, 2, 369, 30.13, 4, 23);
INSERT INTO public.europe_data VALUES (4479, 5822, 275210, 251.95, 66, 23);
INSERT INTO public.europe_data VALUES (4480, 0, 26, 139.85, 67, 23);
INSERT INTO public.europe_data VALUES (4481, 0, 1, 0.46, 109, 23);
INSERT INTO public.europe_data VALUES (4482, 58, 860, 25.19, 155, 23);
INSERT INTO public.europe_data VALUES (4483, 0, 84, 0.61, 5, 23);
INSERT INTO public.europe_data VALUES (4484, 0, 17, 0.29, 6, 23);
INSERT INTO public.europe_data VALUES (4485, 0, 0, 0.01, 110, 23);
INSERT INTO public.europe_data VALUES (4486, 3, 462, 3.25, 7, 23);
INSERT INTO public.europe_data VALUES (4487, 28, 3955, 18.71, 68, 23);
INSERT INTO public.europe_data VALUES (4488, 2, 478, 149.29, 8, 23);
INSERT INTO public.europe_data VALUES (4489, 0, 0, 0, 69, 23);
INSERT INTO public.europe_data VALUES (4490, 1, 29, 1.05, 9, 23);
INSERT INTO public.europe_data VALUES (4491, 2, 27, 0.33, 10, 23);
INSERT INTO public.europe_data VALUES (4492, 348, 12536, 131.09, 70, 23);
INSERT INTO public.europe_data VALUES (4493, 8, 163, 0.03, 111, 23);
INSERT INTO public.europe_data VALUES (4494, 2048, 58583, 249.06, 71, 23);
INSERT INTO public.europe_data VALUES (4495, 0, 29, 4.11, 11, 23);
INSERT INTO public.europe_data VALUES (4496, 4, 649, 14.46, 12, 23);
INSERT INTO public.europe_data VALUES (4497, 60, 7221, 259.53, 72, 23);
INSERT INTO public.europe_data VALUES (4498, 4, 640, 4.34, 13, 23);
INSERT INTO public.europe_data VALUES (4499, 14, 1841, 92.95, 156, 23);
INSERT INTO public.europe_data VALUES (4500, 7, 336, 5.53, 73, 23);
INSERT INTO public.europe_data VALUES (4501, 0, 35, 29.98, 74, 23);
INSERT INTO public.europe_data VALUES (4502, 0, 22, 10.05, 157, 23);
INSERT INTO public.europe_data VALUES (4503, 13, 3789, 58.53, 158, 23);
INSERT INTO public.europe_data VALUES (4504, 2, 165, 0.44, 14, 23);
INSERT INTO public.europe_data VALUES (4505, 3, 847, 24.46, 159, 23);
INSERT INTO public.europe_data VALUES (4506, 1, 3, 0.62, 15, 23);
INSERT INTO public.europe_data VALUES (4507, 0, 0, 1.39, 75, 23);
INSERT INTO public.europe_data VALUES (4508, 164, 5092, 76.1, 76, 23);
INSERT INTO public.europe_data VALUES (4509, 3969, -3864, 11.6, 77, 23);
INSERT INTO public.europe_data VALUES (4510, 131, 1136, 2.62, 16, 23);
INSERT INTO public.europe_data VALUES (4511, 47, 579, 26.13, 78, 23);
INSERT INTO public.europe_data VALUES (4512, 0, 31, 3.39, 17, 23);
INSERT INTO public.europe_data VALUES (4513, 0, 12, 0.69, 18, 23);
INSERT INTO public.europe_data VALUES (4514, 0, 142, 18.34, 160, 23);
INSERT INTO public.europe_data VALUES (4515, 3, 292, 54.7, 19, 23);
INSERT INTO public.europe_data VALUES (4516, 125, 7550, 16.06, 20, 23);
INSERT INTO public.europe_data VALUES (4517, 0, 0, 0, 79, 23);
INSERT INTO public.europe_data VALUES (4518, 0, 2, 59.58, 161, 23);
INSERT INTO public.europe_data VALUES (4519, 0, 3, 0.34, 203, 23);
INSERT INTO public.europe_data VALUES (4520, 1, 214, 6.72, 162, 23);
INSERT INTO public.europe_data VALUES (4521, 95, 46834, 122.18, 163, 23);
INSERT INTO public.europe_data VALUES (4522, 0, 274, 163.99, 204, 23);
INSERT INTO public.europe_data VALUES (4523, 0, 96, 9.8, 21, 23);
INSERT INTO public.europe_data VALUES (4524, 3, 234, 32.37, 22, 23);
INSERT INTO public.europe_data VALUES (4525, 0, 153, 5.73, 164, 23);
INSERT INTO public.europe_data VALUES (4526, 27, 8418, 20.75, 165, 23);
INSERT INTO public.europe_data VALUES (4527, 7, 572, 4.18, 23, 23);
INSERT INTO public.europe_data VALUES (4528, 0, 30, 255.15, 166, 23);
INSERT INTO public.europe_data VALUES (4529, 22, 1390, 26.67, 167, 23);
INSERT INTO public.europe_data VALUES (4530, 0, 0, 0, 80, 23);
INSERT INTO public.europe_data VALUES (4531, 0, 0, 0, 81, 23);
INSERT INTO public.europe_data VALUES (4532, 4, 272, 477.6, 205, 23);
INSERT INTO public.europe_data VALUES (4533, 112, 3771, 54.01, 82, 23);
INSERT INTO public.europe_data VALUES (4534, 0, 0, 0, 168, 23);
INSERT INTO public.europe_data VALUES (4535, 2, 351, 5.91, 24, 23);
INSERT INTO public.europe_data VALUES (4536, 4, 40, 5, 25, 23);
INSERT INTO public.europe_data VALUES (4537, 9, 234, 65.54, 83, 23);
INSERT INTO public.europe_data VALUES (4538, 13, 151, 2.47, 84, 23);
INSERT INTO public.europe_data VALUES (4539, 0, 0, 0, 169, 23);
INSERT INTO public.europe_data VALUES (4540, 149, 4590, 105.2, 85, 23);
INSERT INTO public.europe_data VALUES (4541, 10, 2426, 33.07, 170, 23);
INSERT INTO public.europe_data VALUES (4542, 0, 36, 21.57, 171, 23);
INSERT INTO public.europe_data VALUES (4543, 7173, 583368, 80.38, 112, 23);
INSERT INTO public.europe_data VALUES (4544, 682, 22056, 14.99, 113, 23);
INSERT INTO public.europe_data VALUES (4545, 831, 13088, 33.47, 114, 23);
INSERT INTO public.europe_data VALUES (4546, 553, 29193, 142.53, 115, 23);
INSERT INTO public.europe_data VALUES (4547, 0, 912, 34.73, 172, 23);
INSERT INTO public.europe_data VALUES (4548, 0, 1, 1.18, 173, 23);
INSERT INTO public.europe_data VALUES (4549, 100, 16624, 322.71, 116, 23);
INSERT INTO public.europe_data VALUES (4550, 64, 9416, 30.3, 174, 23);
INSERT INTO public.europe_data VALUES (4551, 12, 746, 53.39, 86, 23);
INSERT INTO public.europe_data VALUES (4552, 84, 3991, 7.96, 117, 23);
INSERT INTO public.europe_data VALUES (4553, 0, 10, 19.48, 175, 23);
INSERT INTO public.europe_data VALUES (4554, 1, 445, 7.94, 118, 23);
INSERT INTO public.europe_data VALUES (4555, 121, 3450, 35.91, 119, 23);
INSERT INTO public.europe_data VALUES (4556, 23, 1046, 5.21, 26, 23);
INSERT INTO public.europe_data VALUES (4557, 47, 785, 92.91, 176, 23);
INSERT INTO public.europe_data VALUES (4558, 14, 4946, 215.21, 120, 23);
INSERT INTO public.europe_data VALUES (4559, 2, 553, 20.65, 121, 23);
INSERT INTO public.europe_data VALUES (4560, 0, 0, 0, 122, 23);
INSERT INTO public.europe_data VALUES (4561, 1, 35, 4.74, 177, 23);
INSERT INTO public.europe_data VALUES (4562, 31, 3556, 120.12, 123, 23);
INSERT INTO public.europe_data VALUES (4563, 0, 82, 6.26, 27, 23);
INSERT INTO public.europe_data VALUES (4564, 0, 3, 0.43, 28, 23);
INSERT INTO public.europe_data VALUES (4565, 53, 4326, 107.89, 29, 23);
INSERT INTO public.europe_data VALUES (4566, 0, 0, 18.24, 178, 23);
INSERT INTO public.europe_data VALUES (4567, 0, 209, 16.03, 179, 23);
INSERT INTO public.europe_data VALUES (4568, 0, 271, -131.62, 180, 23);
INSERT INTO public.europe_data VALUES (4569, 9, 476, 3.68, 30, 23);
INSERT INTO public.europe_data VALUES (4570, 1, 78, 1.57, 31, 23);
INSERT INTO public.europe_data VALUES (4571, 2, 63, 0.41, 124, 23);
INSERT INTO public.europe_data VALUES (4572, 1, 917, 339.95, 125, 23);
INSERT INTO public.europe_data VALUES (4573, 1, 69, 0.7, 32, 23);
INSERT INTO public.europe_data VALUES (4574, 2, 192, 82.87, 181, 23);
INSERT INTO public.europe_data VALUES (4575, 1, 112, 5.5, 33, 23);
INSERT INTO public.europe_data VALUES (4576, 0, 10, 0.79, 34, 23);
INSERT INTO public.europe_data VALUES (4577, 3400, 37193, 58.71, 87, 23);
INSERT INTO public.europe_data VALUES (4578, 71, 3097, 156.28, 182, 23);
INSERT INTO public.europe_data VALUES (4579, 0, 17, 111.83, 183, 23);
INSERT INTO public.europe_data VALUES (4580, 0, 9, 0.37, 126, 23);
INSERT INTO public.europe_data VALUES (4581, 10, 763, 194.48, 184, 23);
INSERT INTO public.europe_data VALUES (4582, 0, 0, 0, 88, 23);
INSERT INTO public.europe_data VALUES (4583, 250, 10995, 54.96, 35, 23);
INSERT INTO public.europe_data VALUES (4584, 4, 623, 3.45, 36, 23);
INSERT INTO public.europe_data VALUES (4585, 2, 677, 1.85, 127, 23);
INSERT INTO public.europe_data VALUES (4586, 17, 1320, 113.49, 37, 23);
INSERT INTO public.europe_data VALUES (4587, 68, 7696, 50.06, 128, 23);
INSERT INTO public.europe_data VALUES (4588, 19, 4644, 47.59, 185, 23);
INSERT INTO public.europe_data VALUES (4589, 0, 3, 1.06, 208, 23);
INSERT INTO public.europe_data VALUES (4590, 2, 38, 1.94, 209, 23);
INSERT INTO public.europe_data VALUES (4591, 4, 174, 5.45, 89, 23);
INSERT INTO public.europe_data VALUES (4592, 0, 1, 0.02, 38, 23);
INSERT INTO public.europe_data VALUES (4593, 44, 1140, 1.38, 39, 23);
INSERT INTO public.europe_data VALUES (4594, 22, 835, 60.08, 186, 23);
INSERT INTO public.europe_data VALUES (4595, 0, 2, 6.99, 210, 23);
INSERT INTO public.europe_data VALUES (4596, 0, 577, 17.32, 187, 23);
INSERT INTO public.europe_data VALUES (4597, 51, 1528, 66.39, 129, 23);
INSERT INTO public.europe_data VALUES (4598, 51, 3054, 2.83, 130, 23);
INSERT INTO public.europe_data VALUES (4599, 37, 4949, 180.43, 131, 23);
INSERT INTO public.europe_data VALUES (4600, 91, 4978, 238.86, 90, 23);
INSERT INTO public.europe_data VALUES (4601, 0, 38, 1.09, 211, 23);
INSERT INTO public.europe_data VALUES (4602, 127, 5291, 131.35, 91, 23);
INSERT INTO public.europe_data VALUES (4603, 1050, 42811, 294.22, 92, 23);
INSERT INTO public.europe_data VALUES (4604, 355, 19969, 44.18, 132, 23);
INSERT INTO public.europe_data VALUES (4605, 87, 3954, 23.86, 188, 23);
INSERT INTO public.europe_data VALUES (4606, 21, 2490, 45.36, 189, 23);
INSERT INTO public.europe_data VALUES (4607, 43, 1685, 158.08, 93, 23);
INSERT INTO public.europe_data VALUES (4608, 6, 1520, 109, 133, 23);
INSERT INTO public.europe_data VALUES (4609, 315, 8229, 84.93, 190, 23);
INSERT INTO public.europe_data VALUES (4610, 727, 35179, 47.13, 191, 23);
INSERT INTO public.europe_data VALUES (4611, 3, 354, 10.18, 40, 23);
INSERT INTO public.europe_data VALUES (4612, 0, 0, 0, 94, 23);
INSERT INTO public.europe_data VALUES (4613, 0, 0, 0, 95, 23);
INSERT INTO public.europe_data VALUES (4614, 0, 1, 2.71, 96, 23);
INSERT INTO public.europe_data VALUES (4615, 0, 6, 17.42, 192, 23);
INSERT INTO public.europe_data VALUES (4616, 0, 2, 2.79, 41, 23);
INSERT INTO public.europe_data VALUES (4617, 211, 6006, 38.95, 134, 23);
INSERT INTO public.europe_data VALUES (4618, 6, 431, 6.37, 42, 23);
INSERT INTO public.europe_data VALUES (4619, 13, 540, 17.92, 193, 23);
INSERT INTO public.europe_data VALUES (4620, 0, 1, 5.12, 43, 23);
INSERT INTO public.europe_data VALUES (4621, 1, 32, 0.79, 44, 23);
INSERT INTO public.europe_data VALUES (4622, 0, 251, 11.53, 135, 23);
INSERT INTO public.europe_data VALUES (4623, 2, 48, 271.3, 97, 23);
INSERT INTO public.europe_data VALUES (4624, 4, 738, 23.08, 194, 23);
INSERT INTO public.europe_data VALUES (4625, 2, 309, 25.13, 195, 23);
INSERT INTO public.europe_data VALUES (4626, 0, 52, 0.6, 45, 23);
INSERT INTO public.europe_data VALUES (4627, 861, 13461, 49.09, 46, 23);
INSERT INTO public.europe_data VALUES (4628, 12, 1349, 7.09, 136, 23);
INSERT INTO public.europe_data VALUES (4629, 1, 25, 0.41, 47, 23);
INSERT INTO public.europe_data VALUES (4630, 422, 62691, 255.9, 196, 23);
INSERT INTO public.europe_data VALUES (4631, 0, 111, 0.8, 137, 23);
INSERT INTO public.europe_data VALUES (4632, 9, 218, 1.33, 48, 23);
INSERT INTO public.europe_data VALUES (4633, 18, 337, 127.12, 98, 23);
INSERT INTO public.europe_data VALUES (4634, 12, 1332, 24.75, 197, 23);
INSERT INTO public.europe_data VALUES (4635, 8, 2387, 52.56, 198, 23);
INSERT INTO public.europe_data VALUES (4636, 25, 468, 6.02, 138, 23);
INSERT INTO public.europe_data VALUES (4637, 0, 5, 0.03, 139, 23);
INSERT INTO public.europe_data VALUES (4638, 2, 242, 5.16, 140, 23);
INSERT INTO public.europe_data VALUES (4639, 0, 33, 0.07, 141, 23);
INSERT INTO public.europe_data VALUES (4640, 0, 0, 0.08, 142, 23);
INSERT INTO public.europe_data VALUES (4641, 5, 92, 2.61, 49, 23);
INSERT INTO public.europe_data VALUES (4642, 13, 567, 89.11, 99, 23);
INSERT INTO public.europe_data VALUES (4643, 17, 1091, 17.43, 50, 23);
INSERT INTO public.europe_data VALUES (4644, 347, 58370, 141.18, 199, 23);
INSERT INTO public.europe_data VALUES (4645, 2, 91, 562.92, 100, 23);
INSERT INTO public.europe_data VALUES (4646, 11, 739, 3.17, 51, 23);
INSERT INTO public.europe_data VALUES (4647, 284, 16820, 70.32, 200, 23);
INSERT INTO public.europe_data VALUES (4648, 6, 4294, 71.41, 143, 23);
INSERT INTO public.europe_data VALUES (4649, 52, 12685, 32.27, 201, 23);
INSERT INTO public.europe_data VALUES (4650, 0, 0, 0, 52, 23);
INSERT INTO public.europe_data VALUES (4651, 5872, 279258, 174.38, 101, 23);
INSERT INTO public.europe_data VALUES (4652, 3, 47, 188.37, 102, 23);
INSERT INTO public.europe_data VALUES (4653, 1, 94, 4.39, 103, 23);
INSERT INTO public.europe_data VALUES (4654, 33, 2124, 14.64, 144, 23);
INSERT INTO public.europe_data VALUES (4655, 47, 7421, 48.13, 104, 23);
INSERT INTO public.europe_data VALUES (4656, 3, 9, 0.03, 145, 23);
INSERT INTO public.europe_data VALUES (4657, 0, 0, 0, 53, 23);
INSERT INTO public.europe_data VALUES (4658, 8, 34, 0.26, 146, 23);
INSERT INTO public.europe_data VALUES (4659, 8, 751, 9.48, 54, 23);
INSERT INTO public.europe_data VALUES (4660, 11, 565, 7.15, 55, 23);
INSERT INTO public.europe_data VALUES (4661, 15, 163, 1.49, 105, 24);
INSERT INTO public.europe_data VALUES (4662, 30, 953, 69.87, 147, 24);
INSERT INTO public.europe_data VALUES (4663, 66, 2686, 12.92, 1, 24);
INSERT INTO public.europe_data VALUES (4664, 0, 79, 177.22, 148, 24);
INSERT INTO public.europe_data VALUES (4665, 11, 453, 2.34, 2, 24);
INSERT INTO public.europe_data VALUES (4666, 0, 0, 0, 56, 24);
INSERT INTO public.europe_data VALUES (4667, 0, 0, 1.03, 57, 24);
INSERT INTO public.europe_data VALUES (4668, 1553, 64437, 250.42, 58, 24);
INSERT INTO public.europe_data VALUES (4669, 25, 958, 70.56, 149, 24);
INSERT INTO public.europe_data VALUES (4670, 3, 429, 841.88, 59, 24);
INSERT INTO public.europe_data VALUES (4671, 109, 858, 9.45, 202, 24);
INSERT INTO public.europe_data VALUES (4672, 1, 1979, 43.4, 150, 24);
INSERT INTO public.europe_data VALUES (4673, 13, 1035, 20.8, 151, 24);
INSERT INTO public.europe_data VALUES (4674, 14, 402, 218.75, 60, 24);
INSERT INTO public.europe_data VALUES (4675, 5, 2536, 313.44, 106, 24);
INSERT INTO public.europe_data VALUES (4676, 307, 16224, 21.02, 107, 24);
INSERT INTO public.europe_data VALUES (4677, 0, 12, 7.66, 61, 24);
INSERT INTO public.europe_data VALUES (4678, 34, 1219, 22.97, 152, 24);
INSERT INTO public.europe_data VALUES (4679, 28, 3121, 57.39, 153, 24);
INSERT INTO public.europe_data VALUES (4680, 7, 308, 138.85, 62, 24);
INSERT INTO public.europe_data VALUES (4681, 1, 30, 0.69, 3, 24);
INSERT INTO public.europe_data VALUES (4682, 0, 2, 11.2, 63, 24);
INSERT INTO public.europe_data VALUES (4683, 0, 69, 10.88, 108, 24);
INSERT INTO public.europe_data VALUES (4684, 457, 6819, 135.71, 64, 24);
INSERT INTO public.europe_data VALUES (4685, 0, 2, 7.7, 65, 24);
INSERT INTO public.europe_data VALUES (4686, 63, 1889, 128.87, 154, 24);
INSERT INTO public.europe_data VALUES (4687, 3, 325, 18.19, 4, 24);
INSERT INTO public.europe_data VALUES (4688, 6084, 256528, 247.39, 66, 24);
INSERT INTO public.europe_data VALUES (4689, 0, 16, 93.23, 67, 24);
INSERT INTO public.europe_data VALUES (4690, 0, 1, 0.46, 109, 24);
INSERT INTO public.europe_data VALUES (4691, 68, 903, 26.07, 155, 24);
INSERT INTO public.europe_data VALUES (4692, 0, 40, 0.5, 5, 24);
INSERT INTO public.europe_data VALUES (4693, 0, 16, 0.28, 6, 24);
INSERT INTO public.europe_data VALUES (4694, 0, 1, 0.01, 110, 24);
INSERT INTO public.europe_data VALUES (4695, 3, 380, 2.6, 7, 24);
INSERT INTO public.europe_data VALUES (4696, 44, 3044, 15.65, 68, 24);
INSERT INTO public.europe_data VALUES (4697, 3, 343, 122.38, 8, 24);
INSERT INTO public.europe_data VALUES (4698, 0, 0, 3.08, 69, 24);
INSERT INTO public.europe_data VALUES (4699, 0, 21, 1.01, 9, 24);
INSERT INTO public.europe_data VALUES (4700, 1, 26, 0.35, 10, 24);
INSERT INTO public.europe_data VALUES (4701, 392, 12309, 126.78, 70, 24);
INSERT INTO public.europe_data VALUES (4702, 11, 200, 0.04, 111, 24);
INSERT INTO public.europe_data VALUES (4703, 2048, 66791, 277.33, 71, 24);
INSERT INTO public.europe_data VALUES (4704, 0, 6, 2.12, 11, 24);
INSERT INTO public.europe_data VALUES (4705, 1, 129, 2.68, 12, 24);
INSERT INTO public.europe_data VALUES (4706, 63, 5879, 222.56, 72, 24);
INSERT INTO public.europe_data VALUES (4707, 2, 477, 3.59, 13, 24);
INSERT INTO public.europe_data VALUES (4708, 13, 1948, 87.14, 156, 24);
INSERT INTO public.europe_data VALUES (4709, 3, 291, 5.8, 73, 24);
INSERT INTO public.europe_data VALUES (4710, 0, 14, 14.07, 74, 24);
INSERT INTO public.europe_data VALUES (4711, 0, 66, 17.7, 157, 24);
INSERT INTO public.europe_data VALUES (4712, 11, 2444, 40.89, 158, 24);
INSERT INTO public.europe_data VALUES (4713, 7, 215, 0.43, 14, 24);
INSERT INTO public.europe_data VALUES (4714, 3, 573, 18.65, 159, 24);
INSERT INTO public.europe_data VALUES (4715, 0, 3, 1.64, 15, 24);
INSERT INTO public.europe_data VALUES (4716, 0, 1, 2.79, 75, 24);
INSERT INTO public.europe_data VALUES (4717, 114, 3080, 73.86, 76, 24);
INSERT INTO public.europe_data VALUES (4718, 245, 5879, 69.68, 77, 24);
INSERT INTO public.europe_data VALUES (4719, 156, 1490, 2.24, 16, 24);
INSERT INTO public.europe_data VALUES (4720, 48, 1107, 43.65, 78, 24);
INSERT INTO public.europe_data VALUES (4721, 0, 15, 8.85, 17, 24);
INSERT INTO public.europe_data VALUES (4722, 0, 12, 0.94, 18, 24);
INSERT INTO public.europe_data VALUES (4723, 1, 101, 13.81, 160, 24);
INSERT INTO public.europe_data VALUES (4724, 6, 336, 62.88, 19, 24);
INSERT INTO public.europe_data VALUES (4725, 115, 10451, 18.96, 20, 24);
INSERT INTO public.europe_data VALUES (4726, 0, 0, 0, 79, 24);
INSERT INTO public.europe_data VALUES (4727, 0, 27, 80.12, 161, 24);
INSERT INTO public.europe_data VALUES (4728, 1, 0, 0, 203, 24);
INSERT INTO public.europe_data VALUES (4729, 1, 157, 6.27, 162, 24);
INSERT INTO public.europe_data VALUES (4730, 93, 35044, 88.65, 163, 24);
INSERT INTO public.europe_data VALUES (4731, 0, 184, 81.64, 204, 24);
INSERT INTO public.europe_data VALUES (4732, 0, 117, 12.89, 21, 24);
INSERT INTO public.europe_data VALUES (4733, 12, 526, 46.47, 22, 24);
INSERT INTO public.europe_data VALUES (4734, 2, 76, 3.65, 164, 24);
INSERT INTO public.europe_data VALUES (4735, 26, 8806, 22.12, 165, 24);
INSERT INTO public.europe_data VALUES (4736, 15, 700, 5.5, 23, 24);
INSERT INTO public.europe_data VALUES (4737, 0, 56, 207.68, 166, 24);
INSERT INTO public.europe_data VALUES (4738, 20, 1470, 28.52, 167, 24);
INSERT INTO public.europe_data VALUES (4739, 0, 0, 0, 80, 24);
INSERT INTO public.europe_data VALUES (4740, 0, 0, 0, 81, 24);
INSERT INTO public.europe_data VALUES (4741, 3, 527, 471.62, 205, 24);
INSERT INTO public.europe_data VALUES (4742, 146, 5724, 64.56, 82, 24);
INSERT INTO public.europe_data VALUES (4743, 0, 0, 0, 168, 24);
INSERT INTO public.europe_data VALUES (4744, 6, 404, 6.96, 24, 24);
INSERT INTO public.europe_data VALUES (4745, 1, 56, 4.58, 25, 24);
INSERT INTO public.europe_data VALUES (4746, 6, 279, 67.07, 83, 24);
INSERT INTO public.europe_data VALUES (4747, 5, 127, 2.93, 84, 24);
INSERT INTO public.europe_data VALUES (4748, 0, 0, 0, 169, 24);
INSERT INTO public.europe_data VALUES (4749, 204, 5663, 99.24, 85, 24);
INSERT INTO public.europe_data VALUES (4750, 1, 806, 10.69, 170, 24);
INSERT INTO public.europe_data VALUES (4751, 0, 41, 26.33, 171, 24);
INSERT INTO public.europe_data VALUES (4752, 6927, 514897, 71.25, 112, 24);
INSERT INTO public.europe_data VALUES (4753, 663, 18518, 12.01, 113, 24);
INSERT INTO public.europe_data VALUES (4754, 819, 14665, 36.62, 114, 24);
INSERT INTO public.europe_data VALUES (4755, 531, 26836, 138, 115, 24);
INSERT INTO public.europe_data VALUES (4756, 0, 791, 30.65, 172, 24);
INSERT INTO public.europe_data VALUES (4757, 0, 0, 0, 173, 24);
INSERT INTO public.europe_data VALUES (4758, 85, 10869, 250.49, 116, 24);
INSERT INTO public.europe_data VALUES (4759, 40, 8873, 23.7, 174, 24);
INSERT INTO public.europe_data VALUES (4760, 5, 828, 42.19, 86, 24);
INSERT INTO public.europe_data VALUES (4761, 99, 6111, 10.18, 117, 24);
INSERT INTO public.europe_data VALUES (4762, 0, 11, 17.63, 175, 24);
INSERT INTO public.europe_data VALUES (4763, 3, 357, 5.82, 118, 24);
INSERT INTO public.europe_data VALUES (4764, 108, 3211, 48.7, 119, 24);
INSERT INTO public.europe_data VALUES (4765, 26, 1693, 7.49, 26, 24);
INSERT INTO public.europe_data VALUES (4766, 49, 886, 106.64, 176, 24);
INSERT INTO public.europe_data VALUES (4767, 15, 4108, 200.4, 120, 24);
INSERT INTO public.europe_data VALUES (4768, 1, 772, 29.72, 121, 24);
INSERT INTO public.europe_data VALUES (4769, 0, 0, 0.03, 122, 24);
INSERT INTO public.europe_data VALUES (4770, 1, 56, 3.7, 177, 24);
INSERT INTO public.europe_data VALUES (4771, 39, 4679, 116.53, 123, 24);
INSERT INTO public.europe_data VALUES (4772, 1, 51, 5.65, 27, 24);
INSERT INTO public.europe_data VALUES (4773, 0, 18, 0.95, 28, 24);
INSERT INTO public.europe_data VALUES (4774, 44, 2986, 83.88, 29, 24);
INSERT INTO public.europe_data VALUES (4775, 0, 7, 39.08, 178, 24);
INSERT INTO public.europe_data VALUES (4776, 2, 239, 16.39, 179, 24);
INSERT INTO public.europe_data VALUES (4777, 0, -1079, -132.6, 180, 24);
INSERT INTO public.europe_data VALUES (4778, 13, 516, 3.77, 30, 24);
INSERT INTO public.europe_data VALUES (4779, 8, 214, 2.49, 31, 24);
INSERT INTO public.europe_data VALUES (4780, 1, 67, 0.42, 124, 24);
INSERT INTO public.europe_data VALUES (4781, 2, 888, 354.45, 125, 24);
INSERT INTO public.europe_data VALUES (4782, 1, 68, 0.81, 32, 24);
INSERT INTO public.europe_data VALUES (4783, 2, 217, 103.74, 181, 24);
INSERT INTO public.europe_data VALUES (4784, 1, 137, 7.09, 33, 24);
INSERT INTO public.europe_data VALUES (4785, 0, 0, 0, 34, 24);
INSERT INTO public.europe_data VALUES (4786, 3678, 37703, 58.3, 87, 24);
INSERT INTO public.europe_data VALUES (4787, 52, 3222, 161.18, 182, 24);
INSERT INTO public.europe_data VALUES (4788, 0, 20, 96.72, 183, 24);
INSERT INTO public.europe_data VALUES (4789, 0, 3, 0.09, 126, 24);
INSERT INTO public.europe_data VALUES (4790, 14, 447, 121.35, 184, 24);
INSERT INTO public.europe_data VALUES (4791, 0, 0, 0, 88, 24);
INSERT INTO public.europe_data VALUES (4792, 223, 9050, 51.85, 35, 24);
INSERT INTO public.europe_data VALUES (4793, 3, 426, 3.18, 36, 24);
INSERT INTO public.europe_data VALUES (4794, 0, 324, 0.76, 127, 24);
INSERT INTO public.europe_data VALUES (4795, 20, 1511, 128.72, 37, 24);
INSERT INTO public.europe_data VALUES (4796, 72, 6626, 41.6, 128, 24);
INSERT INTO public.europe_data VALUES (4797, 24, 3581, 41.24, 185, 24);
INSERT INTO public.europe_data VALUES (4798, 0, 0, 0, 208, 24);
INSERT INTO public.europe_data VALUES (4799, 0, 55, 2.24, 209, 24);
INSERT INTO public.europe_data VALUES (4800, 4, 183, 5.79, 89, 24);
INSERT INTO public.europe_data VALUES (4801, 0, 4, 0.04, 38, 24);
INSERT INTO public.europe_data VALUES (4802, 11, 1638, 2.39, 39, 24);
INSERT INTO public.europe_data VALUES (4803, 21, 413, 57.19, 186, 24);
INSERT INTO public.europe_data VALUES (4804, 0, 2, 10.49, 210, 24);
INSERT INTO public.europe_data VALUES (4805, 0, 346, 13.01, 187, 24);
INSERT INTO public.europe_data VALUES (4806, 68, 1775, 49.41, 129, 24);
INSERT INTO public.europe_data VALUES (4807, 59, 3084, 3.06, 130, 24);
INSERT INTO public.europe_data VALUES (4808, 23, 4039, 143.09, 131, 24);
INSERT INTO public.europe_data VALUES (4809, 103, 5165, 238.44, 90, 24);
INSERT INTO public.europe_data VALUES (4810, 1, 58, 1.55, 211, 24);
INSERT INTO public.europe_data VALUES (4811, 103, 3962, 105.1, 91, 24);
INSERT INTO public.europe_data VALUES (4812, 1125, 52840, 342.11, 92, 24);
INSERT INTO public.europe_data VALUES (4813, 522, 27795, 51.93, 132, 24);
INSERT INTO public.europe_data VALUES (4814, 78, 5108, 26.82, 188, 24);
INSERT INTO public.europe_data VALUES (4815, 23, 2171, 35.67, 189, 24);
INSERT INTO public.europe_data VALUES (4816, 44, 2952, 233.24, 93, 24);
INSERT INTO public.europe_data VALUES (4817, 4, 1567, 123.41, 133, 24);
INSERT INTO public.europe_data VALUES (4818, 306, 8260, 84.08, 190, 24);
INSERT INTO public.europe_data VALUES (4819, 710, 33577, 46.25, 191, 24);
INSERT INTO public.europe_data VALUES (4820, 4, 931, 12.41, 40, 24);
INSERT INTO public.europe_data VALUES (4821, 0, 0, 0, 94, 24);
INSERT INTO public.europe_data VALUES (4822, 0, 0, 0.55, 95, 24);
INSERT INTO public.europe_data VALUES (4823, 0, 2, 2.71, 96, 24);
INSERT INTO public.europe_data VALUES (4824, 0, 0, 0, 192, 24);
INSERT INTO public.europe_data VALUES (4825, 0, 4, 5.12, 41, 24);
INSERT INTO public.europe_data VALUES (4826, 221, 7342, 47.5, 134, 24);
INSERT INTO public.europe_data VALUES (4827, 15, 607, 8.55, 42, 24);
INSERT INTO public.europe_data VALUES (4828, 13, 708, 24.17, 193, 24);
INSERT INTO public.europe_data VALUES (4829, 0, 4, 9.21, 43, 24);
INSERT INTO public.europe_data VALUES (4830, 1, 30, 0.84, 44, 24);
INSERT INTO public.europe_data VALUES (4831, 0, 418, 17.64, 135, 24);
INSERT INTO public.europe_data VALUES (4832, 0, 67, 344.43, 97, 24);
INSERT INTO public.europe_data VALUES (4833, 0, 520, 17.87, 194, 24);
INSERT INTO public.europe_data VALUES (4834, 1, 214, 21.58, 195, 24);
INSERT INTO public.europe_data VALUES (4835, 4, 41, 0.35, 45, 24);
INSERT INTO public.europe_data VALUES (4836, 969, 15283, 64.4, 46, 24);
INSERT INTO public.europe_data VALUES (4837, 15, 2282, 8.65, 136, 24);
INSERT INTO public.europe_data VALUES (4838, 0, 20, 0.27, 47, 24);
INSERT INTO public.europe_data VALUES (4839, 222, 57422, 221.1, 196, 24);
INSERT INTO public.europe_data VALUES (4840, 0, 59, 0.56, 137, 24);
INSERT INTO public.europe_data VALUES (4841, 8, 353, 1.82, 48, 24);
INSERT INTO public.europe_data VALUES (4842, 9, 402, 170.81, 98, 24);
INSERT INTO public.europe_data VALUES (4843, 10, 1200, 28.22, 197, 24);
INSERT INTO public.europe_data VALUES (4844, 5, 2104, 45.35, 198, 24);
INSERT INTO public.europe_data VALUES (4845, 24, 560, 6.01, 138, 24);
INSERT INTO public.europe_data VALUES (4846, 0, 1, 0.01, 139, 24);
INSERT INTO public.europe_data VALUES (4847, 2, 239, 5.2, 140, 24);
INSERT INTO public.europe_data VALUES (4848, 0, 15, 0.05, 141, 24);
INSERT INTO public.europe_data VALUES (4849, 0, 1, 0.15, 142, 24);
INSERT INTO public.europe_data VALUES (4850, 0, 119, 3.08, 49, 24);
INSERT INTO public.europe_data VALUES (4851, 7, 676, 81.08, 99, 24);
INSERT INTO public.europe_data VALUES (4852, 8, 947, 13.49, 50, 24);
INSERT INTO public.europe_data VALUES (4853, 205, 57407, 138.36, 199, 24);
INSERT INTO public.europe_data VALUES (4854, 1, 124, 547.21, 100, 24);
INSERT INTO public.europe_data VALUES (4855, 11, 665, 3.23, 51, 24);
INSERT INTO public.europe_data VALUES (4856, 256, 14116, 59.68, 200, 24);
INSERT INTO public.europe_data VALUES (4857, 7, 2683, 55.04, 143, 24);
INSERT INTO public.europe_data VALUES (4858, 70, 8825, 23.98, 201, 24);
INSERT INTO public.europe_data VALUES (4859, 0, 0, 0, 52, 24);
INSERT INTO public.europe_data VALUES (4860, 6263, 294552, 180.48, 101, 24);
INSERT INTO public.europe_data VALUES (4861, 3, 150, 375.79, 102, 24);
INSERT INTO public.europe_data VALUES (4862, 2, 58, 4.19, 103, 24);
INSERT INTO public.europe_data VALUES (4863, 44, 2705, 20.34, 144, 24);
INSERT INTO public.europe_data VALUES (4864, 52, 6304, 42.48, 104, 24);
INSERT INTO public.europe_data VALUES (4865, 5, 24, 0.08, 145, 24);
INSERT INTO public.europe_data VALUES (4866, 0, 0, 0, 53, 24);
INSERT INTO public.europe_data VALUES (4867, 17, 42, 0.29, 146, 24);
INSERT INTO public.europe_data VALUES (4868, 7, 943, 15.02, 54, 24);
INSERT INTO public.europe_data VALUES (4869, 41, 482, 7.86, 55, 24);
INSERT INTO public.europe_data VALUES (4870, 12, 403, 2.48, 105, 25);
INSERT INTO public.europe_data VALUES (4871, 22, 1047, 70.43, 147, 25);
INSERT INTO public.europe_data VALUES (4872, 65, 2877, 14.51, 1, 25);
INSERT INTO public.europe_data VALUES (4873, 0, 56, 116.83, 148, 25);
INSERT INTO public.europe_data VALUES (4874, 10, 292, 1.88, 2, 25);
INSERT INTO public.europe_data VALUES (4875, 0, 0, 0, 56, 25);
INSERT INTO public.europe_data VALUES (4876, 0, 1, 2.06, 57, 25);
INSERT INTO public.europe_data VALUES (4877, 1191, 47702, 212.12, 58, 25);
INSERT INTO public.europe_data VALUES (4878, 34, 1129, 80.53, 149, 25);
INSERT INTO public.europe_data VALUES (4879, 3, 466, 945.35, 59, 25);
INSERT INTO public.europe_data VALUES (4880, 106, 1524, 14.79, 202, 25);
INSERT INTO public.europe_data VALUES (4881, 4, 1866, 36.44, 150, 25);
INSERT INTO public.europe_data VALUES (4882, 12, 1055, 16.98, 151, 25);
INSERT INTO public.europe_data VALUES (4883, 11, 450, 222.6, 60, 25);
INSERT INTO public.europe_data VALUES (4884, 14, 2608, 306.31, 106, 25);
INSERT INTO public.europe_data VALUES (4885, 284, 18049, 22.69, 107, 25);
INSERT INTO public.europe_data VALUES (4886, 0, 10, 6.62, 61, 25);
INSERT INTO public.europe_data VALUES (4887, 32, 952, 17.12, 152, 25);
INSERT INTO public.europe_data VALUES (4888, 42, 3453, 62.89, 153, 25);
INSERT INTO public.europe_data VALUES (4889, 3, 234, 136.29, 62, 25);
INSERT INTO public.europe_data VALUES (4890, 0, 52, 1.52, 3, 25);
INSERT INTO public.europe_data VALUES (4891, 0, 5, 14.4, 63, 25);
INSERT INTO public.europe_data VALUES (4892, 0, 14, 5.9, 108, 25);
INSERT INTO public.europe_data VALUES (4893, 461, 8805, 166.33, 64, 25);
INSERT INTO public.europe_data VALUES (4894, 0, 0, 0, 65, 25);
INSERT INTO public.europe_data VALUES (4895, 60, 2365, 108.3, 154, 25);
INSERT INTO public.europe_data VALUES (4896, 0, 94, 17.32, 4, 25);
INSERT INTO public.europe_data VALUES (4897, 6892, 265586, 270.25, 66, 25);
INSERT INTO public.europe_data VALUES (4898, 0, 12, 39.96, 67, 25);
INSERT INTO public.europe_data VALUES (4899, 0, 1, 0.23, 109, 25);
INSERT INTO public.europe_data VALUES (4900, 47, 922, 27.01, 155, 25);
INSERT INTO public.europe_data VALUES (4901, 0, 61, 0.61, 5, 25);
INSERT INTO public.europe_data VALUES (4902, 0, 16, 0.18, 6, 25);
INSERT INTO public.europe_data VALUES (4903, 0, 0, 0.13, 110, 25);
INSERT INTO public.europe_data VALUES (4904, 7, 293, 2.78, 7, 25);
INSERT INTO public.europe_data VALUES (4905, 47, 2809, 14.55, 68, 25);
INSERT INTO public.europe_data VALUES (4906, 2, 330, 118.38, 8, 25);
INSERT INTO public.europe_data VALUES (4907, 0, 2, 3.08, 69, 25);
INSERT INTO public.europe_data VALUES (4908, 0, 27, 0.8, 9, 25);
INSERT INTO public.europe_data VALUES (4909, 0, 30, 0.26, 10, 25);
INSERT INTO public.europe_data VALUES (4910, 400, 11719, 129.85, 70, 25);
INSERT INTO public.europe_data VALUES (4911, 8, 320, 0.06, 111, 25);
INSERT INTO public.europe_data VALUES (4912, 2219, 72815, 305.26, 71, 25);
INSERT INTO public.europe_data VALUES (4913, 0, 12, 2.12, 11, 25);
INSERT INTO public.europe_data VALUES (4914, 1, 15, 3.46, 12, 25);
INSERT INTO public.europe_data VALUES (4915, 61, 5355, 208.69, 72, 25);
INSERT INTO public.europe_data VALUES (4916, 3, 445, 2.94, 13, 25);
INSERT INTO public.europe_data VALUES (4917, 5, 1604, 63.07, 156, 25);
INSERT INTO public.europe_data VALUES (4918, 3, 366, 6.43, 73, 25);
INSERT INTO public.europe_data VALUES (4919, 0, 9, 7.34, 74, 25);
INSERT INTO public.europe_data VALUES (4920, 1, 89, 20.44, 157, 25);
INSERT INTO public.europe_data VALUES (4921, 15, 1911, 33.5, 158, 25);
INSERT INTO public.europe_data VALUES (4922, 11, 154, 0.43, 14, 25);
INSERT INTO public.europe_data VALUES (4923, 0, 510, 29.02, 159, 25);
INSERT INTO public.europe_data VALUES (4924, 1, 13, 3.9, 15, 25);
INSERT INTO public.europe_data VALUES (4925, 0, 1, 1.39, 75, 25);
INSERT INTO public.europe_data VALUES (4926, 114, 4852, 106.43, 76, 25);
INSERT INTO public.europe_data VALUES (4927, 240, 6227, 76.61, 77, 25);
INSERT INTO public.europe_data VALUES (4928, 83, 762, 1.74, 16, 25);
INSERT INTO public.europe_data VALUES (4929, 51, 1710, 65.06, 78, 25);
INSERT INTO public.europe_data VALUES (4930, 0, 105, 7.74, 17, 25);
INSERT INTO public.europe_data VALUES (4931, 0, 21, 0.6, 18, 25);
INSERT INTO public.europe_data VALUES (4932, 0, 82, 9.06, 160, 25);
INSERT INTO public.europe_data VALUES (4933, 15, 386, 86.14, 19, 25);
INSERT INTO public.europe_data VALUES (4934, 150, 10795, 15.93, 20, 25);
INSERT INTO public.europe_data VALUES (4935, 0, 0, 0, 79, 25);
INSERT INTO public.europe_data VALUES (4936, 0, 12, 191.06, 161, 25);
INSERT INTO public.europe_data VALUES (4937, 0, 0, 0.11, 203, 25);
INSERT INTO public.europe_data VALUES (4938, 1, 189, 6.09, 162, 25);
INSERT INTO public.europe_data VALUES (4939, 103, 24363, 67.12, 163, 25);
INSERT INTO public.europe_data VALUES (4940, 0, 44, 62.3, 204, 25);
INSERT INTO public.europe_data VALUES (4941, 2, 163, 21.4, 21, 25);
INSERT INTO public.europe_data VALUES (4942, 21, 565, 51.2, 22, 25);
INSERT INTO public.europe_data VALUES (4943, 0, 70, 4.03, 164, 25);
INSERT INTO public.europe_data VALUES (4944, 40, 9561, 20.78, 165, 25);
INSERT INTO public.europe_data VALUES (4945, 30, 973, 8.23, 23, 25);
INSERT INTO public.europe_data VALUES (4946, 0, 14, 94.94, 166, 25);
INSERT INTO public.europe_data VALUES (4947, 14, 1589, 28.36, 167, 25);
INSERT INTO public.europe_data VALUES (4948, 0, 0, 0, 80, 25);
INSERT INTO public.europe_data VALUES (4949, 0, 0, 0, 81, 25);
INSERT INTO public.europe_data VALUES (4950, 2, 262, 240.29, 205, 25);
INSERT INTO public.europe_data VALUES (4951, 215, 5626, 65.88, 82, 25);
INSERT INTO public.europe_data VALUES (4952, 0, 0, 0, 168, 25);
INSERT INTO public.europe_data VALUES (4953, 2, 485, 8.12, 24, 25);
INSERT INTO public.europe_data VALUES (4954, 0, 32, 5.05, 25, 25);
INSERT INTO public.europe_data VALUES (4955, 8, 246, 49.44, 83, 25);
INSERT INTO public.europe_data VALUES (4956, 0, 203, 3.98, 84, 25);
INSERT INTO public.europe_data VALUES (4957, 0, 0, 0, 169, 25);
INSERT INTO public.europe_data VALUES (4958, 79, 4009, 72.41, 85, 25);
INSERT INTO public.europe_data VALUES (4959, 5, 239, 4.7, 170, 25);
INSERT INTO public.europe_data VALUES (4960, 0, 53, 29.69, 171, 25);
INSERT INTO public.europe_data VALUES (4961, 6621, 458685, 65.23, 112, 25);
INSERT INTO public.europe_data VALUES (4962, 530, 13986, 10.4, 113, 25);
INSERT INTO public.europe_data VALUES (4963, 1004, 15702, 38.83, 114, 25);
INSERT INTO public.europe_data VALUES (4964, 568, 27410, 137.95, 115, 25);
INSERT INTO public.europe_data VALUES (4965, 3, 712, 25.63, 172, 25);
INSERT INTO public.europe_data VALUES (4966, 0, 0, 0, 173, 25);
INSERT INTO public.europe_data VALUES (4967, 149, 10471, 236.51, 116, 25);
INSERT INTO public.europe_data VALUES (4968, 41, 5430, 14.54, 174, 25);
INSERT INTO public.europe_data VALUES (4969, 2, 416, 17.16, 86, 25);
INSERT INTO public.europe_data VALUES (4970, 82, 6802, 10.85, 117, 25);
INSERT INTO public.europe_data VALUES (4971, 1, 8, 16.7, 175, 25);
INSERT INTO public.europe_data VALUES (4972, 1, 231, 3.53, 118, 25);
INSERT INTO public.europe_data VALUES (4973, 186, 5823, 79.45, 119, 25);
INSERT INTO public.europe_data VALUES (4974, 74, 2244, 11.28, 26, 25);
INSERT INTO public.europe_data VALUES (4975, 66, 1032, 122.38, 176, 25);
INSERT INTO public.europe_data VALUES (4976, 14, 4323, 209.53, 120, 25);
INSERT INTO public.europe_data VALUES (4977, -439, 1135, 45.96, 121, 25);
INSERT INTO public.europe_data VALUES (4978, 0, 2, 0.03, 122, 25);
INSERT INTO public.europe_data VALUES (4979, 1, 15, 2.45, 177, 25);
INSERT INTO public.europe_data VALUES (4980, 18, 3310, 82.76, 123, 25);
INSERT INTO public.europe_data VALUES (4981, 0, 69, 12.85, 27, 25);
INSERT INTO public.europe_data VALUES (4982, 0, 29, 0.99, 28, 25);
INSERT INTO public.europe_data VALUES (4983, 43, 2699, 76.8, 29, 25);
INSERT INTO public.europe_data VALUES (4984, 0, 8, 31.27, 178, 25);
INSERT INTO public.europe_data VALUES (4985, 3, 219, 13.71, 179, 25);
INSERT INTO public.europe_data VALUES (4986, 1, 265, 96.27, 180, 25);
INSERT INTO public.europe_data VALUES (4987, 8, 500, 4.6, 30, 25);
INSERT INTO public.europe_data VALUES (4988, 5, 250, 3.56, 31, 25);
INSERT INTO public.europe_data VALUES (4989, 0, 67, 0.58, 124, 25);
INSERT INTO public.europe_data VALUES (4990, 4, 994, 327.33, 125, 25);
INSERT INTO public.europe_data VALUES (4991, 0, 91, 0.7, 32, 25);
INSERT INTO public.europe_data VALUES (4992, 1, 295, 134.13, 181, 25);
INSERT INTO public.europe_data VALUES (4993, 1, 184, 8.55, 33, 25);
INSERT INTO public.europe_data VALUES (4994, 0, 0, 0.16, 34, 25);
INSERT INTO public.europe_data VALUES (4995, 3723, 36673, 58.44, 87, 25);
INSERT INTO public.europe_data VALUES (4996, 44, 3295, 143.89, 182, 25);
INSERT INTO public.europe_data VALUES (4997, 0, 12, 51.38, 183, 25);
INSERT INTO public.europe_data VALUES (4998, 0, 0, 0.16, 126, 25);
INSERT INTO public.europe_data VALUES (4999, 7, 308, 116.53, 184, 25);
INSERT INTO public.europe_data VALUES (5000, 0, 0, 0, 88, 25);
INSERT INTO public.europe_data VALUES (5001, 230, 9860, 52.4, 35, 25);
INSERT INTO public.europe_data VALUES (5002, 1, 540, 3.71, 36, 25);
INSERT INTO public.europe_data VALUES (5003, 0, 88, 0.19, 127, 25);
INSERT INTO public.europe_data VALUES (5004, 17, 1700, 116.46, 37, 25);
INSERT INTO public.europe_data VALUES (5005, 45, 5275, 31.33, 128, 25);
INSERT INTO public.europe_data VALUES (5006, 28, 3547, 45.86, 185, 25);
INSERT INTO public.europe_data VALUES (5007, 0, 0, 0, 208, 25);
INSERT INTO public.europe_data VALUES (5008, 0, 52, 2.36, 209, 25);
INSERT INTO public.europe_data VALUES (5009, 5, 196, 6.25, 89, 25);
INSERT INTO public.europe_data VALUES (5010, 0, 5, 0.06, 38, 25);
INSERT INTO public.europe_data VALUES (5011, 27, 3159, 2.81, 39, 25);
INSERT INTO public.europe_data VALUES (5012, 19, 775, 79.82, 186, 25);
INSERT INTO public.europe_data VALUES (5013, 0, 4, 10.49, 210, 25);
INSERT INTO public.europe_data VALUES (5014, 3, 347, 13.68, 187, 25);
INSERT INTO public.europe_data VALUES (5015, 37, 683, 44, 129, 25);
INSERT INTO public.europe_data VALUES (5016, 60, 3550, 3.74, 130, 25);
INSERT INTO public.europe_data VALUES (5017, 22, 3089, 127.94, 131, 25);
INSERT INTO public.europe_data VALUES (5018, 125, 4960, 292.2, 90, 25);
INSERT INTO public.europe_data VALUES (5019, 1, 78, 2.13, 211, 25);
INSERT INTO public.europe_data VALUES (5020, 67, 3442, 89.8, 91, 25);
INSERT INTO public.europe_data VALUES (5021, 1382, 58380, 357.74, 92, 25);
INSERT INTO public.europe_data VALUES (5022, 333, 28348, 55.21, 132, 25);
INSERT INTO public.europe_data VALUES (5023, 78, 5078, 26.26, 188, 25);
INSERT INTO public.europe_data VALUES (5024, 18, 1495, 28.5, 189, 25);
INSERT INTO public.europe_data VALUES (5025, 55, 3890, 265.05, 93, 25);
INSERT INTO public.europe_data VALUES (5026, 0, 1928, 143.39, 133, 25);
INSERT INTO public.europe_data VALUES (5027, 281, 8064, 86.31, 190, 25);
INSERT INTO public.europe_data VALUES (5028, 698, 33896, 47.45, 191, 25);
INSERT INTO public.europe_data VALUES (5029, 4, 636, 7.52, 40, 25);
INSERT INTO public.europe_data VALUES (5030, 0, 0, 0, 94, 25);
INSERT INTO public.europe_data VALUES (5031, 0, 1, 0.55, 95, 25);
INSERT INTO public.europe_data VALUES (5032, 0, 1, 0.9, 96, 25);
INSERT INTO public.europe_data VALUES (5033, 0, 0, 0, 192, 25);
INSERT INTO public.europe_data VALUES (5034, 0, 7, 6.51, 41, 25);
INSERT INTO public.europe_data VALUES (5035, 241, 8937, 54.83, 134, 25);
INSERT INTO public.europe_data VALUES (5036, 16, 787, 10.89, 42, 25);
INSERT INTO public.europe_data VALUES (5037, 24, 975, 36.73, 193, 25);
INSERT INTO public.europe_data VALUES (5038, 0, 5, 6.14, 43, 25);
INSERT INTO public.europe_data VALUES (5039, 0, 36, 0.97, 44, 25);
INSERT INTO public.europe_data VALUES (5040, 0, 606, 21.52, 135, 25);
INSERT INTO public.europe_data VALUES (5041, 0, 79, 488.33, 97, 25);
INSERT INTO public.europe_data VALUES (5042, 2, 454, 13.94, 194, 25);
INSERT INTO public.europe_data VALUES (5043, 3, 235, 19.32, 195, 25);
INSERT INTO public.europe_data VALUES (5044, 0, 13, 0.27, 45, 25);
INSERT INTO public.europe_data VALUES (5045, 1220, 22428, 85.24, 46, 25);
INSERT INTO public.europe_data VALUES (5046, 4, 2150, 5.93, 136, 25);
INSERT INTO public.europe_data VALUES (5047, 0, 10, 0.26, 47, 25);
INSERT INTO public.europe_data VALUES (5048, 226, 46354, 175.67, 196, 25);
INSERT INTO public.europe_data VALUES (5049, 1, 60, 0.51, 137, 25);
INSERT INTO public.europe_data VALUES (5050, 12, 426, 2.2, 48, 25);
INSERT INTO public.europe_data VALUES (5051, 11, 591, 209.16, 98, 25);
INSERT INTO public.europe_data VALUES (5052, 19, 1687, 36.55, 197, 25);
INSERT INTO public.europe_data VALUES (5053, 4, 1771, 38.48, 198, 25);
INSERT INTO public.europe_data VALUES (5054, 21, 466, 5.59, 138, 25);
INSERT INTO public.europe_data VALUES (5055, 0, 2, 0.03, 139, 25);
INSERT INTO public.europe_data VALUES (5056, 2, 246, 6.07, 140, 25);
INSERT INTO public.europe_data VALUES (5057, 0, 19, 0.07, 141, 25);
INSERT INTO public.europe_data VALUES (5058, 0, 1, 0.08, 142, 25);
INSERT INTO public.europe_data VALUES (5059, 0, 130, 2.68, 49, 25);
INSERT INTO public.europe_data VALUES (5060, 3, 455, 52.19, 99, 25);
INSERT INTO public.europe_data VALUES (5061, 14, 631, 8.9, 50, 25);
INSERT INTO public.europe_data VALUES (5062, 147, 56050, 136.17, 199, 25);
INSERT INTO public.europe_data VALUES (5063, 0, 85, 437.24, 100, 25);
INSERT INTO public.europe_data VALUES (5064, 6, 763, 2.21, 51, 25);
INSERT INTO public.europe_data VALUES (5065, 182, 12138, 52.28, 200, 25);
INSERT INTO public.europe_data VALUES (5066, 11, 2695, 45.87, 143, 25);
INSERT INTO public.europe_data VALUES (5067, 63, 7158, 22.23, 201, 25);
INSERT INTO public.europe_data VALUES (5068, 0, 0, 0, 52, 25);
INSERT INTO public.europe_data VALUES (5069, 6754, 299342, 199.88, 101, 25);
INSERT INTO public.europe_data VALUES (5070, 2, 243, 417.87, 102, 25);
INSERT INTO public.europe_data VALUES (5071, 4, 87, 5.03, 103, 25);
INSERT INTO public.europe_data VALUES (5072, 45, 4002, 24.64, 144, 25);
INSERT INTO public.europe_data VALUES (5073, 48, 5809, 48.25, 104, 25);
INSERT INTO public.europe_data VALUES (5074, 3, 52, 0.18, 145, 25);
INSERT INTO public.europe_data VALUES (5075, 0, 0, 0, 53, 25);
INSERT INTO public.europe_data VALUES (5076, 17, 42, 0.37, 146, 25);
INSERT INTO public.europe_data VALUES (5077, 20, 1739, 16.78, 54, 25);
INSERT INTO public.europe_data VALUES (5078, 23, 669, 8.75, 55, 25);
INSERT INTO public.europe_data VALUES (5079, 63, 542, 2.33, 105, 26);
INSERT INTO public.europe_data VALUES (5080, 29, 969, 65.01, 147, 26);
INSERT INTO public.europe_data VALUES (5081, 68, 3369, 16.53, 1, 26);
INSERT INTO public.europe_data VALUES (5082, 1, 33, 84.01, 148, 26);
INSERT INTO public.europe_data VALUES (5083, 16, 307, 2.3, 2, 26);
INSERT INTO public.europe_data VALUES (5084, 0, 0, 0, 56, 26);
INSERT INTO public.europe_data VALUES (5085, 0, 1, 2.06, 57, 26);
INSERT INTO public.europe_data VALUES (5086, 1101, 47289, 206.69, 58, 26);
INSERT INTO public.europe_data VALUES (5087, 27, 1253, 86.59, 149, 26);
INSERT INTO public.europe_data VALUES (5088, 1, 539, 921.83, 59, 26);
INSERT INTO public.europe_data VALUES (5089, 101, 2204, 21.29, 202, 26);
INSERT INTO public.europe_data VALUES (5090, 7, 1362, 23.3, 150, 26);
INSERT INTO public.europe_data VALUES (5091, 16, 651, 17.68, 151, 26);
INSERT INTO public.europe_data VALUES (5092, 3, 417, 171.25, 60, 26);
INSERT INTO public.europe_data VALUES (5093, 8, 2419, 298.2, 106, 26);
INSERT INTO public.europe_data VALUES (5094, 258, 18949, 21.96, 107, 26);
INSERT INTO public.europe_data VALUES (5095, 0, 9, 6.62, 61, 26);
INSERT INTO public.europe_data VALUES (5096, 23, 666, 15.33, 152, 26);
INSERT INTO public.europe_data VALUES (5097, 75, 3751, 70.63, 153, 26);
INSERT INTO public.europe_data VALUES (5098, 1, 298, 101.19, 62, 26);
INSERT INTO public.europe_data VALUES (5099, 1, 127, 2.19, 3, 26);
INSERT INTO public.europe_data VALUES (5100, 0, 4, 9.6, 63, 26);
INSERT INTO public.europe_data VALUES (5101, 0, 31, 4.98, 108, 26);
INSERT INTO public.europe_data VALUES (5102, 408, 10345, 175.37, 64, 26);
INSERT INTO public.europe_data VALUES (5103, 0, 0, 7.7, 65, 26);
INSERT INTO public.europe_data VALUES (5104, 67, 1210, 103.82, 154, 26);
INSERT INTO public.europe_data VALUES (5105, 1, 305, 17.8, 4, 26);
INSERT INTO public.europe_data VALUES (5106, 6803, 304775, 287.38, 66, 26);
INSERT INTO public.europe_data VALUES (5107, 0, 0, 0, 67, 26);
INSERT INTO public.europe_data VALUES (5108, 0, 0, 0.23, 109, 26);
INSERT INTO public.europe_data VALUES (5109, 51, 969, 34.43, 155, 26);
INSERT INTO public.europe_data VALUES (5110, 1, 63, 0.58, 5, 26);
INSERT INTO public.europe_data VALUES (5111, 0, 5, 0.16, 6, 26);
INSERT INTO public.europe_data VALUES (5112, 0, 22, 0.2, 110, 26);
INSERT INTO public.europe_data VALUES (5113, 6, 427, 4.69, 7, 26);
INSERT INTO public.europe_data VALUES (5114, 45, 2636, 13.95, 68, 26);
INSERT INTO public.europe_data VALUES (5115, 3, 321, 114.92, 8, 26);
INSERT INTO public.europe_data VALUES (5116, 0, 0, 0, 69, 26);
INSERT INTO public.europe_data VALUES (5117, 1, 11, 0.8, 9, 26);
INSERT INTO public.europe_data VALUES (5118, 0, 12, 0.13, 10, 26);
INSERT INTO public.europe_data VALUES (5119, 375, 12890, 138.32, 70, 26);
INSERT INTO public.europe_data VALUES (5120, 17, 582, 0.1, 111, 26);
INSERT INTO public.europe_data VALUES (5121, 2255, 80851, 299.33, 71, 26);
INSERT INTO public.europe_data VALUES (5122, 0, 6, 2.23, 11, 26);
INSERT INTO public.europe_data VALUES (5123, 18, 171, 8.33, 12, 26);
INSERT INTO public.europe_data VALUES (5124, 59, 5179, 188.01, 72, 26);
INSERT INTO public.europe_data VALUES (5125, 5, 311, 3.28, 13, 26);
INSERT INTO public.europe_data VALUES (5126, 9, 967, 32.16, 156, 26);
INSERT INTO public.europe_data VALUES (5127, 0, 363, 5.91, 73, 26);
INSERT INTO public.europe_data VALUES (5128, 0, 3, 3.06, 74, 26);
INSERT INTO public.europe_data VALUES (5129, 1, 90, 20.78, 157, 26);
INSERT INTO public.europe_data VALUES (5130, 8, 1657, 30.16, 158, 26);
INSERT INTO public.europe_data VALUES (5131, 16, 222, 0.65, 14, 26);
INSERT INTO public.europe_data VALUES (5132, 4, 1175, 31.48, 159, 26);
INSERT INTO public.europe_data VALUES (5133, 0, 25, 21.36, 15, 26);
INSERT INTO public.europe_data VALUES (5134, 0, 0, 0, 75, 26);
INSERT INTO public.europe_data VALUES (5135, 144, 6577, 130.98, 76, 26);
INSERT INTO public.europe_data VALUES (5136, 148, 7083, 86.44, 77, 26);
INSERT INTO public.europe_data VALUES (5137, 151, 983, 1.98, 16, 26);
INSERT INTO public.europe_data VALUES (5138, 55, 2489, 84.67, 78, 26);
INSERT INTO public.europe_data VALUES (5139, 0, 0, 0, 17, 26);
INSERT INTO public.europe_data VALUES (5140, 0, 0, 0.17, 18, 26);
INSERT INTO public.europe_data VALUES (5141, 0, 38, 8.38, 160, 26);
INSERT INTO public.europe_data VALUES (5142, 12, 603, 92.67, 19, 26);
INSERT INTO public.europe_data VALUES (5143, 121, 7058, 10.6, 20, 26);
INSERT INTO public.europe_data VALUES (5144, 0, 0, 0, 79, 26);
INSERT INTO public.europe_data VALUES (5145, 0, 81, 301.99, 161, 26);
INSERT INTO public.europe_data VALUES (5146, 0, 1, 0.11, 203, 26);
INSERT INTO public.europe_data VALUES (5147, 2, 147, 5.04, 162, 26);
INSERT INTO public.europe_data VALUES (5148, 86, 20615, 45.69, 163, 26);
INSERT INTO public.europe_data VALUES (5149, 0, 130, 46.55, 204, 26);
INSERT INTO public.europe_data VALUES (5150, 0, 302, 31.94, 21, 26);
INSERT INTO public.europe_data VALUES (5151, 40, 637, 58.53, 22, 26);
INSERT INTO public.europe_data VALUES (5152, 0, 91, 4.1, 164, 26);
INSERT INTO public.europe_data VALUES (5153, 35, 7687, 16.4, 165, 26);
INSERT INTO public.europe_data VALUES (5154, 16, 1529, 18.14, 23, 26);
INSERT INTO public.europe_data VALUES (5155, 0, 18, 80.1, 166, 26);
INSERT INTO public.europe_data VALUES (5156, 16, 1452, 22.5, 167, 26);
INSERT INTO public.europe_data VALUES (5157, 0, 0, 0, 80, 26);
INSERT INTO public.europe_data VALUES (5158, 0, 0, 0, 81, 26);
INSERT INTO public.europe_data VALUES (5159, 0, 140, 113.57, 205, 26);
INSERT INTO public.europe_data VALUES (5160, 168, 5957, 64.02, 82, 26);
INSERT INTO public.europe_data VALUES (5161, 0, 0, 0, 168, 26);
INSERT INTO public.europe_data VALUES (5162, 1, 552, 8.75, 24, 26);
INSERT INTO public.europe_data VALUES (5163, 4, 65, 7.08, 25, 26);
INSERT INTO public.europe_data VALUES (5164, 1, 141, 30.02, 83, 26);
INSERT INTO public.europe_data VALUES (5165, 13, 245, 3.58, 84, 26);
INSERT INTO public.europe_data VALUES (5166, 0, 0, 0, 169, 26);
INSERT INTO public.europe_data VALUES (5167, 80, 3048, 74.95, 85, 26);
INSERT INTO public.europe_data VALUES (5168, 6, 220, 3.9, 170, 26);
INSERT INTO public.europe_data VALUES (5169, 0, 53, 29.13, 171, 26);
INSERT INTO public.europe_data VALUES (5170, 6535, 432589, 61.77, 112, 26);
INSERT INTO public.europe_data VALUES (5171, 427, 14153, 10.38, 113, 26);
INSERT INTO public.europe_data VALUES (5172, 1212, 16491, 40.72, 114, 26);
INSERT INTO public.europe_data VALUES (5173, 468, 26816, 121.55, 115, 26);
INSERT INTO public.europe_data VALUES (5174, 2, 545, 22.33, 172, 26);
INSERT INTO public.europe_data VALUES (5175, 0, 0, 0, 173, 26);
INSERT INTO public.europe_data VALUES (5176, 85, 9678, 230.71, 116, 26);
INSERT INTO public.europe_data VALUES (5177, 191, 3349, 9.68, 174, 26);
INSERT INTO public.europe_data VALUES (5178, 0, 90, 7.43, 86, 26);
INSERT INTO public.europe_data VALUES (5179, 51, 6962, 13.31, 117, 26);
INSERT INTO public.europe_data VALUES (5180, 0, 10, 18.55, 175, 26);
INSERT INTO public.europe_data VALUES (5181, 0, 126, 1.63, 118, 26);
INSERT INTO public.europe_data VALUES (5182, 54, 8917, 123.97, 119, 26);
INSERT INTO public.europe_data VALUES (5183, 54, 3684, 15.34, 26, 26);
INSERT INTO public.europe_data VALUES (5184, 74, 1169, 145.51, 176, 26);
INSERT INTO public.europe_data VALUES (5185, 23, 4492, 197.14, 120, 26);
INSERT INTO public.europe_data VALUES (5186, 22, 1814, 75.78, 121, 26);
INSERT INTO public.europe_data VALUES (5187, 0, 0, 0, 122, 26);
INSERT INTO public.europe_data VALUES (5188, 0, 32, 4.11, 177, 26);
INSERT INTO public.europe_data VALUES (5189, 27, 2364, 58.29, 123, 26);
INSERT INTO public.europe_data VALUES (5190, 7, 204, 10.73, 27, 26);
INSERT INTO public.europe_data VALUES (5191, 3, 20, 1.01, 28, 26);
INSERT INTO public.europe_data VALUES (5192, 32, 2506, 59.71, 29, 26);
INSERT INTO public.europe_data VALUES (5193, 0, 4, 10.42, 178, 26);
INSERT INTO public.europe_data VALUES (5194, 0, 164, 10.95, 179, 26);
INSERT INTO public.europe_data VALUES (5195, 4, 326, 121.19, 180, 26);
INSERT INTO public.europe_data VALUES (5196, 22, 741, 8.52, 30, 26);
INSERT INTO public.europe_data VALUES (5197, 15, 414, 4.51, 31, 26);
INSERT INTO public.europe_data VALUES (5198, 0, 117, 0.63, 124, 26);
INSERT INTO public.europe_data VALUES (5199, 3, 744, 305.3, 125, 26);
INSERT INTO public.europe_data VALUES (5200, 0, 47, 0.37, 32, 26);
INSERT INTO public.europe_data VALUES (5201, 0, 367, 119.54, 181, 26);
INSERT INTO public.europe_data VALUES (5202, 0, 203, 8.64, 33, 26);
INSERT INTO public.europe_data VALUES (5203, 0, 2, 0.16, 34, 26);
INSERT INTO public.europe_data VALUES (5204, 4459, 37880, 61.78, 87, 26);
INSERT INTO public.europe_data VALUES (5205, 51, 2523, 119.24, 182, 26);
INSERT INTO public.europe_data VALUES (5206, 0, 5, 45.34, 183, 26);
INSERT INTO public.europe_data VALUES (5207, 0, 5, 0.16, 126, 26);
INSERT INTO public.europe_data VALUES (5208, 13, 417, 124.88, 184, 26);
INSERT INTO public.europe_data VALUES (5209, 0, 0, 0, 88, 26);
INSERT INTO public.europe_data VALUES (5210, 160, 9252, 46.48, 35, 26);
INSERT INTO public.europe_data VALUES (5211, 3, 586, 2.99, 36, 26);
INSERT INTO public.europe_data VALUES (5212, 0, 15, 0.04, 127, 26);
INSERT INTO public.europe_data VALUES (5213, 16, 1205, 74.56, 37, 26);
INSERT INTO public.europe_data VALUES (5214, 29, 3688, 22.12, 128, 26);
INSERT INTO public.europe_data VALUES (5215, 15, 4379, 45.71, 185, 26);
INSERT INTO public.europe_data VALUES (5216, 0, 0, 0.35, 208, 26);
INSERT INTO public.europe_data VALUES (5217, 0, 61, 1.32, 209, 26);
INSERT INTO public.europe_data VALUES (5218, 5, 213, 6.77, 89, 26);
INSERT INTO public.europe_data VALUES (5219, 0, 9, 0.09, 38, 26);
INSERT INTO public.europe_data VALUES (5220, 30, 2491, 2.6, 39, 26);
INSERT INTO public.europe_data VALUES (5221, 17, 883, 81.12, 186, 26);
INSERT INTO public.europe_data VALUES (5222, 0, 2, 6.99, 210, 26);
INSERT INTO public.europe_data VALUES (5223, 5, 382, 12.05, 187, 26);
INSERT INTO public.europe_data VALUES (5224, 59, 1506, 78.93, 129, 26);
INSERT INTO public.europe_data VALUES (5225, 78, 4555, 4.24, 130, 26);
INSERT INTO public.europe_data VALUES (5226, 18, 3284, 123.56, 131, 26);
INSERT INTO public.europe_data VALUES (5227, 128, 7448, 341.16, 90, 26);
INSERT INTO public.europe_data VALUES (5228, 0, 109, 2.43, 211, 26);
INSERT INTO public.europe_data VALUES (5229, 63, 2884, 58.87, 91, 26);
INSERT INTO public.europe_data VALUES (5230, 5209, 57922, 329.42, 92, 26);
INSERT INTO public.europe_data VALUES (5231, 395, 31340, 53.71, 132, 26);
INSERT INTO public.europe_data VALUES (5232, 70, 4893, 25.78, 188, 26);
INSERT INTO public.europe_data VALUES (5233, 22, 1434, 25.68, 189, 26);
INSERT INTO public.europe_data VALUES (5234, 56, 3885, 258.91, 93, 26);
INSERT INTO public.europe_data VALUES (5235, 9, 2133, 140.29, 133, 26);
INSERT INTO public.europe_data VALUES (5236, 291, 8693, 88.98, 190, 26);
INSERT INTO public.europe_data VALUES (5237, 754, 35317, 49.35, 191, 26);
INSERT INTO public.europe_data VALUES (5238, 1, 313, 3.1, 40, 26);
INSERT INTO public.europe_data VALUES (5239, 0, 0, 0, 94, 26);
INSERT INTO public.europe_data VALUES (5240, 0, 0, 0, 95, 26);
INSERT INTO public.europe_data VALUES (5241, 0, 0, 1.81, 96, 26);
INSERT INTO public.europe_data VALUES (5242, 0, 0, 31.93, 192, 26);
INSERT INTO public.europe_data VALUES (5243, 0, 7, 5.12, 41, 26);
INSERT INTO public.europe_data VALUES (5244, 241, 9852, 57.51, 134, 26);
INSERT INTO public.europe_data VALUES (5245, 21, 987, 11.16, 42, 26);
INSERT INTO public.europe_data VALUES (5246, 33, 1583, 50.1, 193, 26);
INSERT INTO public.europe_data VALUES (5247, 0, 1, 13.3, 43, 26);
INSERT INTO public.europe_data VALUES (5248, 1, 40, 1.45, 44, 26);
INSERT INTO public.europe_data VALUES (5249, 0, 643, 50.34, 135, 26);
INSERT INTO public.europe_data VALUES (5250, 0, 128, 403.41, 97, 26);
INSERT INTO public.europe_data VALUES (5251, 0, 306, 10.24, 194, 26);
INSERT INTO public.europe_data VALUES (5252, 4, 167, 11.34, 195, 26);
INSERT INTO public.europe_data VALUES (5253, 0, 29, 0.28, 45, 26);
INSERT INTO public.europe_data VALUES (5254, 1431, 27487, 129.55, 46, 26);
INSERT INTO public.europe_data VALUES (5255, 0, 889, 2.2, 136, 26);
INSERT INTO public.europe_data VALUES (5256, 0, 19, 0.54, 47, 26);
INSERT INTO public.europe_data VALUES (5257, 70, 36102, 132.15, 196, 26);
INSERT INTO public.europe_data VALUES (5258, 0, 49, 0.33, 137, 26);
INSERT INTO public.europe_data VALUES (5259, 30, 516, 1.57, 48, 26);
INSERT INTO public.europe_data VALUES (5260, 18, 625, 200.74, 98, 26);
INSERT INTO public.europe_data VALUES (5261, 16, 2052, 39.75, 197, 26);
INSERT INTO public.europe_data VALUES (5262, 4, 1517, 30.08, 198, 26);
INSERT INTO public.europe_data VALUES (5263, 12, 489, 5.08, 138, 26);
INSERT INTO public.europe_data VALUES (5264, 0, 5, 0.04, 139, 26);
INSERT INTO public.europe_data VALUES (5265, 2, 320, 6.12, 140, 26);
INSERT INTO public.europe_data VALUES (5266, 0, 27, 0.08, 141, 26);
INSERT INTO public.europe_data VALUES (5267, 0, 0, 0.08, 142, 26);
INSERT INTO public.europe_data VALUES (5268, 4, 87, 2.3, 49, 26);
INSERT INTO public.europe_data VALUES (5269, 3, 273, 26.52, 99, 26);
INSERT INTO public.europe_data VALUES (5270, 3, 410, 4.67, 50, 26);
INSERT INTO public.europe_data VALUES (5271, 130, 55615, 134.96, 199, 26);
INSERT INTO public.europe_data VALUES (5272, 0, 82, 476.51, 100, 26);
INSERT INTO public.europe_data VALUES (5273, 6, 217, 0.72, 51, 26);
INSERT INTO public.europe_data VALUES (5274, 167, 10863, 46.94, 200, 26);
INSERT INTO public.europe_data VALUES (5275, 7, 1787, 33.91, 143, 26);
INSERT INTO public.europe_data VALUES (5276, 88, 7659, 20.69, 201, 26);
INSERT INTO public.europe_data VALUES (5277, 0, 0, 0, 52, 26);
INSERT INTO public.europe_data VALUES (5278, 7114, 358405, 223.46, 101, 26);
INSERT INTO public.europe_data VALUES (5279, 0, 194, 305.99, 102, 26);
INSERT INTO public.europe_data VALUES (5280, 1, 87, 4.45, 103, 26);
INSERT INTO public.europe_data VALUES (5281, 32, 4124, 27.64, 144, 26);
INSERT INTO public.europe_data VALUES (5282, 58, 7950, 47.51, 104, 26);
INSERT INTO public.europe_data VALUES (5283, 11, 123, 0.36, 145, 26);
INSERT INTO public.europe_data VALUES (5284, 0, 0, 0, 53, 26);
INSERT INTO public.europe_data VALUES (5285, 15, 65, 0.46, 146, 26);
INSERT INTO public.europe_data VALUES (5286, 25, 1258, 16.77, 54, 26);
INSERT INTO public.europe_data VALUES (5287, 28, 612, 9.15, 55, 26);
INSERT INTO public.europe_data VALUES (5288, 28, 344, 2.08, 105, 27);
INSERT INTO public.europe_data VALUES (5289, 33, 892, 57.57, 147, 27);
INSERT INTO public.europe_data VALUES (5290, 71, 3749, 18.25, 1, 27);
INSERT INTO public.europe_data VALUES (5291, 0, 31, 77.45, 148, 27);
INSERT INTO public.europe_data VALUES (5292, 18, 424, 2.02, 2, 27);
INSERT INTO public.europe_data VALUES (5293, 0, 0, 0, 56, 27);
INSERT INTO public.europe_data VALUES (5294, 0, 1, 10.3, 57, 27);
INSERT INTO public.europe_data VALUES (5295, 944, 45268, 177.05, 58, 27);
INSERT INTO public.europe_data VALUES (5296, 29, 1308, 102.11, 149, 27);
INSERT INTO public.europe_data VALUES (5297, 0, 441, 417.65, 59, 27);
INSERT INTO public.europe_data VALUES (5298, 87, 3161, 26.51, 202, 27);
INSERT INTO public.europe_data VALUES (5299, 3, 702, 17.21, 150, 27);
INSERT INTO public.europe_data VALUES (5300, 28, 1125, 35.01, 151, 27);
INSERT INTO public.europe_data VALUES (5301, 1, 250, 142.75, 60, 27);
INSERT INTO public.europe_data VALUES (5302, 15, 2475, 297.35, 106, 27);
INSERT INTO public.europe_data VALUES (5303, 245, 16854, 20.94, 107, 27);
INSERT INTO public.europe_data VALUES (5304, 0, 10, 11.15, 61, 27);
INSERT INTO public.europe_data VALUES (5305, 20, 783, 18.18, 152, 27);
INSERT INTO public.europe_data VALUES (5306, 30, 4340, 70.7, 153, 27);
INSERT INTO public.europe_data VALUES (5307, 0, 97, 27.16, 62, 27);
INSERT INTO public.europe_data VALUES (5308, 2, 131, 1.41, 3, 27);
INSERT INTO public.europe_data VALUES (5309, 0, 2, 6.4, 63, 27);
INSERT INTO public.europe_data VALUES (5310, 0, 7, 1.97, 108, 27);
INSERT INTO public.europe_data VALUES (5311, 487, 9846, 178.67, 64, 27);
INSERT INTO public.europe_data VALUES (5312, 0, 2, 7.7, 65, 27);
INSERT INTO public.europe_data VALUES (5313, 59, 2217, 128.93, 154, 27);
INSERT INTO public.europe_data VALUES (5314, 0, 105, 9.68, 4, 27);
INSERT INTO public.europe_data VALUES (5315, 6945, 301745, 292.03, 66, 27);
INSERT INTO public.europe_data VALUES (5316, 0, 0, 3.33, 67, 27);
INSERT INTO public.europe_data VALUES (5317, 0, 1, 0.23, 109, 27);
INSERT INTO public.europe_data VALUES (5318, 59, 1441, 42.41, 155, 27);
INSERT INTO public.europe_data VALUES (5319, 1, 54, 0.51, 5, 27);
INSERT INTO public.europe_data VALUES (5320, 0, 13, 0.41, 6, 27);
INSERT INTO public.europe_data VALUES (5321, 0, 11, 0.16, 110, 27);
INSERT INTO public.europe_data VALUES (5322, 8, 787, 5.16, 7, 27);
INSERT INTO public.europe_data VALUES (5323, 36, 2581, 14.84, 68, 27);
INSERT INTO public.europe_data VALUES (5324, 8, 311, 100.19, 8, 27);
INSERT INTO public.europe_data VALUES (5325, 0, 0, 0, 69, 27);
INSERT INTO public.europe_data VALUES (5326, 1, 27, 0.89, 9, 27);
INSERT INTO public.europe_data VALUES (5327, 1, 8, 0.18, 10, 27);
INSERT INTO public.europe_data VALUES (5328, 469, 13325, 143.87, 70, 27);
INSERT INTO public.europe_data VALUES (5329, 17, 808, 0.16, 111, 27);
INSERT INTO public.europe_data VALUES (5330, 2192, 69830, 275.14, 71, 27);
INSERT INTO public.europe_data VALUES (5331, 0, 13, 6.93, 11, 27);
INSERT INTO public.europe_data VALUES (5332, 2, 277, 11.63, 12, 27);
INSERT INTO public.europe_data VALUES (5333, 73, 4311, 159.62, 72, 27);
INSERT INTO public.europe_data VALUES (5334, 3, 533, 4.35, 13, 27);
INSERT INTO public.europe_data VALUES (5335, 8, 344, 18.33, 156, 27);
INSERT INTO public.europe_data VALUES (5336, 1, 307, 4.04, 73, 27);
INSERT INTO public.europe_data VALUES (5337, 0, 2, 1.22, 74, 27);
INSERT INTO public.europe_data VALUES (5338, 0, 92, 21.12, 157, 27);
INSERT INTO public.europe_data VALUES (5339, 6, 1555, 28.46, 158, 27);
INSERT INTO public.europe_data VALUES (5340, 9, 339, 0.72, 14, 27);
INSERT INTO public.europe_data VALUES (5341, 2, 653, 17.29, 159, 27);
INSERT INTO public.europe_data VALUES (5342, 0, 183, 30.2, 15, 27);
INSERT INTO public.europe_data VALUES (5343, 0, 0, 0, 75, 27);
INSERT INTO public.europe_data VALUES (5344, 131, 7489, 156.66, 76, 27);
INSERT INTO public.europe_data VALUES (5345, 172, 7935, 79.23, 77, 27);
INSERT INTO public.europe_data VALUES (5346, 144, 1009, 3.42, 16, 27);
INSERT INTO public.europe_data VALUES (5347, 96, 2975, 89.76, 78, 27);
INSERT INTO public.europe_data VALUES (5348, 0, 0, 129.06, 17, 27);
INSERT INTO public.europe_data VALUES (5349, 0, 6, 0.63, 18, 27);
INSERT INTO public.europe_data VALUES (5350, 0, 73, 8.91, 160, 27);
INSERT INTO public.europe_data VALUES (5351, 15, 461, 89.62, 19, 27);
INSERT INTO public.europe_data VALUES (5352, 123, 4819, 7.9, 20, 27);
INSERT INTO public.europe_data VALUES (5353, 0, 0, 0, 79, 27);
INSERT INTO public.europe_data VALUES (5354, 0, 66, 205.44, 161, 27);
INSERT INTO public.europe_data VALUES (5355, 0, 0, 0, 203, 27);
INSERT INTO public.europe_data VALUES (5356, 2, 131, 3.46, 162, 27);
INSERT INTO public.europe_data VALUES (5357, 59, 10002, 25.95, 163, 27);
INSERT INTO public.europe_data VALUES (5358, 0, 0, 0, 204, 27);
INSERT INTO public.europe_data VALUES (5359, 1, 392, 43.22, 21, 27);
INSERT INTO public.europe_data VALUES (5360, 14, 737, 40.81, 22, 27);
INSERT INTO public.europe_data VALUES (5361, 0, 73, 2.83, 164, 27);
INSERT INTO public.europe_data VALUES (5362, 49, 5925, 12.91, 165, 27);
INSERT INTO public.europe_data VALUES (5363, 33, 3989, 26.41, 23, 27);
INSERT INTO public.europe_data VALUES (5364, 0, 9, 35.6, 166, 27);
INSERT INTO public.europe_data VALUES (5365, 4, 961, 13.33, 167, 27);
INSERT INTO public.europe_data VALUES (5366, 0, 0, 1.76, 80, 27);
INSERT INTO public.europe_data VALUES (5367, 0, 0, 0.89, 81, 27);
INSERT INTO public.europe_data VALUES (5368, 0, 50, 43.04, 205, 27);
INSERT INTO public.europe_data VALUES (5369, 216, 5299, 65.71, 82, 27);
INSERT INTO public.europe_data VALUES (5370, 0, 0, 0, 168, 27);
INSERT INTO public.europe_data VALUES (5371, 4, 566, 7.22, 24, 27);
INSERT INTO public.europe_data VALUES (5372, 3, 71, 5.1, 25, 27);
INSERT INTO public.europe_data VALUES (5373, 1, 94, 25.29, 83, 27);
INSERT INTO public.europe_data VALUES (5374, 18, 158, 2.83, 84, 27);
INSERT INTO public.europe_data VALUES (5375, 0, 0, 0, 169, 27);
INSERT INTO public.europe_data VALUES (5376, 118, 4257, 83.91, 85, 27);
INSERT INTO public.europe_data VALUES (5377, 5, 161, 2.54, 170, 27);
INSERT INTO public.europe_data VALUES (5378, 0, 51, 31.09, 171, 27);
INSERT INTO public.europe_data VALUES (5379, 6251, 411379, 57.06, 112, 27);
INSERT INTO public.europe_data VALUES (5380, 487, 13941, 9.84, 113, 27);
INSERT INTO public.europe_data VALUES (5381, 1237, 17275, 42.86, 114, 27);
INSERT INTO public.europe_data VALUES (5382, 524, 20964, 101.97, 115, 27);
INSERT INTO public.europe_data VALUES (5383, 9, 550, 16.94, 172, 27);
INSERT INTO public.europe_data VALUES (5384, 0, 0, 0, 173, 27);
INSERT INTO public.europe_data VALUES (5385, 64, 9977, 247.04, 116, 27);
INSERT INTO public.europe_data VALUES (5386, 51, 2496, 7.37, 174, 27);
INSERT INTO public.europe_data VALUES (5387, 2, 129, 6.14, 86, 27);
INSERT INTO public.europe_data VALUES (5388, 36, 9918, 14.19, 117, 27);
INSERT INTO public.europe_data VALUES (5389, 0, 10, 12.06, 175, 27);
INSERT INTO public.europe_data VALUES (5390, 0, 39, 0.83, 118, 27);
INSERT INTO public.europe_data VALUES (5391, 324, 14081, 159.56, 119, 27);
INSERT INTO public.europe_data VALUES (5392, 51, 4383, 16.8, 26, 27);
INSERT INTO public.europe_data VALUES (5393, 78, 1448, 185.15, 176, 27);
INSERT INTO public.europe_data VALUES (5394, 21, 3802, 188.73, 120, 27);
INSERT INTO public.europe_data VALUES (5395, 54, 3048, 107.25, 121, 27);
INSERT INTO public.europe_data VALUES (5396, 0, 0, 0, 122, 27);
INSERT INTO public.europe_data VALUES (5397, 0, 47, 3.7, 177, 27);
INSERT INTO public.europe_data VALUES (5398, 14, 1632, 40.36, 123, 27);
INSERT INTO public.europe_data VALUES (5399, 4, 24, 13.93, 27, 27);
INSERT INTO public.europe_data VALUES (5400, 2, 30, 1.52, 28, 27);
INSERT INTO public.europe_data VALUES (5401, 33, 1541, 39.62, 29, 27);
INSERT INTO public.europe_data VALUES (5402, 0, 0, 5.21, 178, 27);
INSERT INTO public.europe_data VALUES (5403, 1, 142, 8.73, 179, 27);
INSERT INTO public.europe_data VALUES (5404, 2, 418, 136.99, 180, 27);
INSERT INTO public.europe_data VALUES (5405, 34, 1558, 14.06, 30, 27);
INSERT INTO public.europe_data VALUES (5406, 23, 427, 5.46, 31, 27);
INSERT INTO public.europe_data VALUES (5407, 0, 84, 0.58, 124, 27);
INSERT INTO public.europe_data VALUES (5408, 2, 877, 327.52, 125, 27);
INSERT INTO public.europe_data VALUES (5409, 1, 26, 0.29, 32, 27);
INSERT INTO public.europe_data VALUES (5410, 0, 223, 62.2, 181, 27);
INSERT INTO public.europe_data VALUES (5411, 0, 188, 7.23, 33, 27);
INSERT INTO public.europe_data VALUES (5412, 0, 0, 0, 34, 27);
INSERT INTO public.europe_data VALUES (5413, 4552, 40936, 66.98, 87, 27);
INSERT INTO public.europe_data VALUES (5414, 54, 2298, 114.41, 182, 27);
INSERT INTO public.europe_data VALUES (5415, 0, 10, 39.29, 183, 27);
INSERT INTO public.europe_data VALUES (5416, 0, 0, 0.16, 126, 27);
INSERT INTO public.europe_data VALUES (5417, 13, 360, 168.6, 184, 27);
INSERT INTO public.europe_data VALUES (5418, 0, 0, 0, 88, 27);
INSERT INTO public.europe_data VALUES (5419, 116, 7700, 35.53, 35, 27);
INSERT INTO public.europe_data VALUES (5420, 3, 323, 1.98, 36, 27);
INSERT INTO public.europe_data VALUES (5421, 0, 7, 0.02, 127, 27);
INSERT INTO public.europe_data VALUES (5422, 8, 655, 47.06, 37, 27);
INSERT INTO public.europe_data VALUES (5423, 18, 2640, 15.24, 128, 27);
INSERT INTO public.europe_data VALUES (5424, 8, 3521, 32.51, 185, 27);
INSERT INTO public.europe_data VALUES (5425, 0, 1, 0.35, 208, 27);
INSERT INTO public.europe_data VALUES (5426, 0, 2, 0.27, 209, 27);
INSERT INTO public.europe_data VALUES (5427, 7, 230, 7.07, 89, 27);
INSERT INTO public.europe_data VALUES (5428, 0, 11, 0.11, 38, 27);
INSERT INTO public.europe_data VALUES (5429, 57, 2736, 3.01, 39, 27);
INSERT INTO public.europe_data VALUES (5430, 30, 802, 85.21, 186, 27);
INSERT INTO public.europe_data VALUES (5431, 0, 2, 13.98, 210, 27);
INSERT INTO public.europe_data VALUES (5432, 1, 260, 7.19, 187, 27);
INSERT INTO public.europe_data VALUES (5433, 92, 2421, 112.06, 129, 27);
INSERT INTO public.europe_data VALUES (5434, 113, 4631, 4.79, 130, 27);
INSERT INTO public.europe_data VALUES (5435, 16, 2871, 110.85, 131, 27);
INSERT INTO public.europe_data VALUES (5436, 168, 7039, 334.3, 90, 27);
INSERT INTO public.europe_data VALUES (5437, 1, 104, 1.73, 211, 27);
INSERT INTO public.europe_data VALUES (5438, 23, 1263, 34.96, 91, 27);
INSERT INTO public.europe_data VALUES (5439, 1458, 49174, 286.76, 92, 27);
INSERT INTO public.europe_data VALUES (5440, 211, 26728, 45.75, 132, 27);
INSERT INTO public.europe_data VALUES (5441, 76, 4897, 22.98, 188, 27);
INSERT INTO public.europe_data VALUES (5442, 18, 1205, 24.37, 189, 27);
INSERT INTO public.europe_data VALUES (5443, 49, 3710, 237.88, 93, 27);
INSERT INTO public.europe_data VALUES (5444, 7, 1840, 128.6, 133, 27);
INSERT INTO public.europe_data VALUES (5445, 287, 8582, 87.41, 190, 27);
INSERT INTO public.europe_data VALUES (5446, 803, 36666, 51.45, 191, 27);
INSERT INTO public.europe_data VALUES (5447, 2, 78, 2.53, 40, 27);
INSERT INTO public.europe_data VALUES (5448, 0, 0, 0, 94, 27);
INSERT INTO public.europe_data VALUES (5449, 0, 0, 0.55, 95, 27);
INSERT INTO public.europe_data VALUES (5450, 0, 2, 4.52, 96, 27);
INSERT INTO public.europe_data VALUES (5451, 0, 11, 31.93, 192, 27);
INSERT INTO public.europe_data VALUES (5452, 0, 4, 6.98, 41, 27);
INSERT INTO public.europe_data VALUES (5453, 250, 9855, 63.47, 134, 27);
INSERT INTO public.europe_data VALUES (5454, 23, 831, 9.17, 42, 27);
INSERT INTO public.europe_data VALUES (5455, 51, 1906, 62.74, 193, 27);
INSERT INTO public.europe_data VALUES (5456, 0, 12, 12.28, 43, 27);
INSERT INTO public.europe_data VALUES (5457, 1, 73, 1.7, 44, 27);
INSERT INTO public.europe_data VALUES (5458, 0, 2279, 81.58, 135, 27);
INSERT INTO public.europe_data VALUES (5459, 1, 43, 224.11, 97, 27);
INSERT INTO public.europe_data VALUES (5460, 2, 252, 7.65, 194, 27);
INSERT INTO public.europe_data VALUES (5461, 3, 69, 8.03, 195, 27);
INSERT INTO public.europe_data VALUES (5462, 0, 15, 0.32, 45, 27);
INSERT INTO public.europe_data VALUES (5463, 2042, 48373, 195.4, 46, 27);
INSERT INTO public.europe_data VALUES (5464, 4, 237, 0.88, 136, 27);
INSERT INTO public.europe_data VALUES (5465, 1, 41, 1.88, 47, 27);
INSERT INTO public.europe_data VALUES (5466, 104, 25926, 94.16, 196, 27);
INSERT INTO public.europe_data VALUES (5467, 0, 21, 0.29, 137, 27);
INSERT INTO public.europe_data VALUES (5468, 21, 156, 1.19, 48, 27);
INSERT INTO public.europe_data VALUES (5469, 2, 542, 163.75, 98, 27);
INSERT INTO public.europe_data VALUES (5470, 18, 2014, 34.9, 197, 27);
INSERT INTO public.europe_data VALUES (5471, 6, 1053, 25.62, 198, 27);
INSERT INTO public.europe_data VALUES (5472, 8, 379, 3.15, 138, 27);
INSERT INTO public.europe_data VALUES (5473, 0, 5, 0.08, 139, 27);
INSERT INTO public.europe_data VALUES (5474, 1, 250, 5.93, 140, 27);
INSERT INTO public.europe_data VALUES (5475, 0, 31, 0.08, 141, 27);
INSERT INTO public.europe_data VALUES (5476, 0, 1, 0.08, 142, 27);
INSERT INTO public.europe_data VALUES (5477, 4, 99, 2.38, 49, 27);
INSERT INTO public.europe_data VALUES (5478, 0, 97, 9.46, 99, 27);
INSERT INTO public.europe_data VALUES (5479, 0, 136, 2.09, 50, 27);
INSERT INTO public.europe_data VALUES (5480, 116, 55058, 124.62, 199, 27);
INSERT INTO public.europe_data VALUES (5481, 0, 100, 306.33, 100, 27);
INSERT INTO public.europe_data VALUES (5482, 3, 101, 0.38, 51, 27);
INSERT INTO public.europe_data VALUES (5483, 197, 9789, 38.89, 200, 27);
INSERT INTO public.europe_data VALUES (5484, 6, 1526, 36.97, 143, 27);
INSERT INTO public.europe_data VALUES (5485, 71, 6130, 15.87, 201, 27);
INSERT INTO public.europe_data VALUES (5486, 0, 0, 0, 52, 27);
INSERT INTO public.europe_data VALUES (5487, 8078, 376909, 246.41, 101, 27);
INSERT INTO public.europe_data VALUES (5488, 1, 126, 177.86, 102, 27);
INSERT INTO public.europe_data VALUES (5489, 1, 67, 4.65, 103, 27);
INSERT INTO public.europe_data VALUES (5490, 41, 4992, 30.32, 144, 27);
INSERT INTO public.europe_data VALUES (5491, 49, 5599, 36.27, 104, 27);
INSERT INTO public.europe_data VALUES (5492, 7, 220, 0.44, 145, 27);
INSERT INTO public.europe_data VALUES (5493, 0, 0, 0, 53, 27);
INSERT INTO public.europe_data VALUES (5494, 18, 70, 0.42, 146, 27);
INSERT INTO public.europe_data VALUES (5495, 65, 1738, 20.18, 54, 27);
INSERT INTO public.europe_data VALUES (5496, 34, 728, 14.59, 55, 27);
INSERT INTO public.europe_data VALUES (5497, 15, 447, 3.25, 105, 28);
INSERT INTO public.europe_data VALUES (5498, 28, 756, 49.92, 147, 28);
INSERT INTO public.europe_data VALUES (5499, 76, 4108, 19.47, 1, 28);
INSERT INTO public.europe_data VALUES (5500, 0, 28, 59.07, 148, 28);
INSERT INTO public.europe_data VALUES (5501, 12, 218, 1.39, 2, 28);
INSERT INTO public.europe_data VALUES (5502, 0, 0, 0, 56, 28);
INSERT INTO public.europe_data VALUES (5503, 0, 9, 15.45, 57, 28);
INSERT INTO public.europe_data VALUES (5504, 673, 34017, 165.29, 58, 28);
INSERT INTO public.europe_data VALUES (5505, 51, 1712, 139.33, 149, 28);
INSERT INTO public.europe_data VALUES (5506, 0, 3, 8.47, 59, 28);
INSERT INTO public.europe_data VALUES (5507, 53, 3520, 24.29, 202, 28);
INSERT INTO public.europe_data VALUES (5508, 6, 823, 19.62, 150, 28);
INSERT INTO public.europe_data VALUES (5509, 45, 2393, 48.99, 151, 28);
INSERT INTO public.europe_data VALUES (5510, 3, 306, 127.09, 60, 28);
INSERT INTO public.europe_data VALUES (5511, 7, 2405, 311.61, 106, 28);
INSERT INTO public.europe_data VALUES (5512, 226, 17293, 22.22, 107, 28);
INSERT INTO public.europe_data VALUES (5513, 0, 22, 9.41, 61, 28);
INSERT INTO public.europe_data VALUES (5514, 33, 935, 20.86, 152, 28);
INSERT INTO public.europe_data VALUES (5515, 20, 3759, 54.54, 153, 28);
INSERT INTO public.europe_data VALUES (5516, 0, 9, 4.36, 62, 28);
INSERT INTO public.europe_data VALUES (5517, 1, 35, 1.72, 3, 28);
INSERT INTO public.europe_data VALUES (5518, 0, 2, 4.8, 63, 28);
INSERT INTO public.europe_data VALUES (5519, 0, 8, 1.83, 108, 28);
INSERT INTO public.europe_data VALUES (5520, 570, 10724, 178.67, 64, 28);
INSERT INTO public.europe_data VALUES (5521, 0, 0, 3.85, 65, 28);
INSERT INTO public.europe_data VALUES (5522, 60, 2039, 110.75, 154, 28);
INSERT INTO public.europe_data VALUES (5523, 1, 118, 12.24, 4, 28);
INSERT INTO public.europe_data VALUES (5524, 7100, 314586, 301.01, 66, 28);
INSERT INTO public.europe_data VALUES (5525, 0, 1, 3.33, 67, 28);
INSERT INTO public.europe_data VALUES (5526, 0, 0, 0, 109, 28);
INSERT INTO public.europe_data VALUES (5527, 48, 1528, 46.03, 155, 28);
INSERT INTO public.europe_data VALUES (5528, 0, 50, 0.42, 5, 28);
INSERT INTO public.europe_data VALUES (5529, 0, 34, 0.74, 6, 28);
INSERT INTO public.europe_data VALUES (5530, 0, 15, 0.42, 110, 28);
INSERT INTO public.europe_data VALUES (5531, 2, 547, 4.24, 7, 28);
INSERT INTO public.europe_data VALUES (5532, 55, 2972, 17.46, 68, 28);
INSERT INTO public.europe_data VALUES (5533, 2, 240, 91.65, 8, 28);
INSERT INTO public.europe_data VALUES (5534, 0, 0, 0, 69, 28);
INSERT INTO public.europe_data VALUES (5535, 0, 15, 2.72, 9, 28);
INSERT INTO public.europe_data VALUES (5536, 0, 21, 0.29, 10, 28);
INSERT INTO public.europe_data VALUES (5537, 496, 13941, 151.97, 70, 28);
INSERT INTO public.europe_data VALUES (5538, 17, 1415, 0.17, 111, 28);
INSERT INTO public.europe_data VALUES (5539, 2125, 68675, 239.12, 71, 28);
INSERT INTO public.europe_data VALUES (5540, 0, 46, 6.11, 11, 28);
INSERT INTO public.europe_data VALUES (5541, 5, 349, 14.01, 12, 28);
INSERT INTO public.europe_data VALUES (5542, 58, 3746, 155.74, 72, 28);
INSERT INTO public.europe_data VALUES (5543, 6, 586, 8.02, 13, 28);
INSERT INTO public.europe_data VALUES (5544, 13, 403, 22.23, 156, 28);
INSERT INTO public.europe_data VALUES (5545, 0, 151, 1.76, 73, 28);
INSERT INTO public.europe_data VALUES (5546, 0, 0, 0.61, 74, 28);
INSERT INTO public.europe_data VALUES (5547, 0, 93, 12.79, 157, 28);
INSERT INTO public.europe_data VALUES (5548, 12, 1476, 26.81, 158, 28);
INSERT INTO public.europe_data VALUES (5549, 10, 283, 0.82, 14, 28);
INSERT INTO public.europe_data VALUES (5550, 2, 351, 10.61, 159, 28);
INSERT INTO public.europe_data VALUES (5551, 1, 111, 15.41, 15, 28);
INSERT INTO public.europe_data VALUES (5552, 0, 0, 0, 75, 28);
INSERT INTO public.europe_data VALUES (5553, 115, 9335, 180.54, 76, 28);
INSERT INTO public.europe_data VALUES (5554, 235, 5830, 72.01, 77, 28);
INSERT INTO public.europe_data VALUES (5555, 259, 2421, 6.68, 16, 28);
INSERT INTO public.europe_data VALUES (5556, 59, 2818, 86.8, 78, 28);
INSERT INTO public.europe_data VALUES (5557, 32, 1750, 129.06, 17, 28);
INSERT INTO public.europe_data VALUES (5558, 0, 16, 0.8, 18, 28);
INSERT INTO public.europe_data VALUES (5559, 0, 45, 4.38, 160, 28);
INSERT INTO public.europe_data VALUES (5560, 11, 568, 85.53, 19, 28);
INSERT INTO public.europe_data VALUES (5561, 61, 4031, 7.58, 20, 28);
INSERT INTO public.europe_data VALUES (5562, 0, 0, 0, 79, 28);
INSERT INTO public.europe_data VALUES (5563, 0, 34, 69.85, 161, 28);
INSERT INTO public.europe_data VALUES (5564, 1, 0, 0.11, 203, 28);
INSERT INTO public.europe_data VALUES (5565, 0, 60, 2.08, 162, 28);
INSERT INTO public.europe_data VALUES (5566, 73, 7391, 19.76, 163, 28);
INSERT INTO public.europe_data VALUES (5567, 0, 0, 0, 204, 28);
INSERT INTO public.europe_data VALUES (5568, 1, 547, 55.97, 21, 28);
INSERT INTO public.europe_data VALUES (5569, 3, 221, 17.25, 22, 28);
INSERT INTO public.europe_data VALUES (5570, 1, 40, 3.73, 164, 28);
INSERT INTO public.europe_data VALUES (5571, 30, 4793, 10.33, 165, 28);
INSERT INTO public.europe_data VALUES (5572, 14, 4045, 30.73, 23, 28);
INSERT INTO public.europe_data VALUES (5573, 0, 3, 23.73, 166, 28);
INSERT INTO public.europe_data VALUES (5574, 6, 469, 6.11, 167, 28);
INSERT INTO public.europe_data VALUES (5575, 0, 1, 1.76, 80, 28);
INSERT INTO public.europe_data VALUES (5576, 0, 1, 0.89, 81, 28);
INSERT INTO public.europe_data VALUES (5577, 0, 22, 29.29, 205, 28);
INSERT INTO public.europe_data VALUES (5578, 261, 6253, 71.83, 82, 28);
INSERT INTO public.europe_data VALUES (5579, 0, 0, 0, 168, 28);
INSERT INTO public.europe_data VALUES (5580, 3, 356, 6.42, 24, 28);
INSERT INTO public.europe_data VALUES (5581, 0, 27, 2.81, 25, 28);
INSERT INTO public.europe_data VALUES (5582, 1, 104, 17.63, 83, 28);
INSERT INTO public.europe_data VALUES (5583, 8, 161, 3.76, 84, 28);
INSERT INTO public.europe_data VALUES (5584, 0, 0, 0, 169, 28);
INSERT INTO public.europe_data VALUES (5585, 261, 3921, 96.06, 85, 28);
INSERT INTO public.europe_data VALUES (5586, 1, 87, 2.07, 170, 28);
INSERT INTO public.europe_data VALUES (5587, 0, 60, 19.05, 171, 28);
INSERT INTO public.europe_data VALUES (5588, 5364, 368242, 50.18, 112, 28);
INSERT INTO public.europe_data VALUES (5589, 455, 12677, 9.21, 113, 28);
INSERT INTO public.europe_data VALUES (5590, 1490, 18265, 43, 114, 28);
INSERT INTO public.europe_data VALUES (5591, 506, 19119, 93.16, 115, 28);
INSERT INTO public.europe_data VALUES (5592, 0, 281, 8.2, 172, 28);
INSERT INTO public.europe_data VALUES (5593, 0, 0, 0, 173, 28);
INSERT INTO public.europe_data VALUES (5594, 66, 11069, 266.87, 116, 28);
INSERT INTO public.europe_data VALUES (5595, 47, 1952, 6.02, 174, 28);
INSERT INTO public.europe_data VALUES (5596, 2, 52, 3.53, 86, 28);
INSERT INTO public.europe_data VALUES (5597, 15, 8083, 10.23, 117, 28);
INSERT INTO public.europe_data VALUES (5598, 0, 3, 3.71, 175, 28);
INSERT INTO public.europe_data VALUES (5599, 0, 45, -0.05, 118, 28);
INSERT INTO public.europe_data VALUES (5600, 524, 15519, 144.48, 119, 28);
INSERT INTO public.europe_data VALUES (5601, 89, 4450, 16.55, 26, 28);
INSERT INTO public.europe_data VALUES (5602, 80, 1882, 170.36, 176, 28);
INSERT INTO public.europe_data VALUES (5603, 24, 4138, 206.96, 120, 28);
INSERT INTO public.europe_data VALUES (5604, 119, 3833, 155.65, 121, 28);
INSERT INTO public.europe_data VALUES (5605, 0, 0, 0.01, 122, 28);
INSERT INTO public.europe_data VALUES (5606, 1, 24, 2.66, 177, 28);
INSERT INTO public.europe_data VALUES (5607, 11, 1135, 29.55, 123, 28);
INSERT INTO public.europe_data VALUES (5608, 8, 272, 16.89, 27, 28);
INSERT INTO public.europe_data VALUES (5609, 5, 45, 2.35, 28, 28);
INSERT INTO public.europe_data VALUES (5610, 22, 1144, 26.93, 29, 28);
INSERT INTO public.europe_data VALUES (5611, 0, 2, 5.21, 178, 28);
INSERT INTO public.europe_data VALUES (5612, 0, 102, 6.37, 179, 28);
INSERT INTO public.europe_data VALUES (5613, 5, 423, 197.43, 180, 28);
INSERT INTO public.europe_data VALUES (5614, 29, 2233, 16.61, 30, 28);
INSERT INTO public.europe_data VALUES (5615, 24, 591, 6.65, 31, 28);
INSERT INTO public.europe_data VALUES (5616, 1, 102, 0.69, 124, 28);
INSERT INTO public.europe_data VALUES (5617, 2, 862, 225.63, 125, 28);
INSERT INTO public.europe_data VALUES (5618, 1, 31, 0.34, 32, 28);
INSERT INTO public.europe_data VALUES (5619, 0, 84, 21.88, 181, 28);
INSERT INTO public.europe_data VALUES (5620, 1, 139, 9.66, 33, 28);
INSERT INTO public.europe_data VALUES (5621, 0, 0, 0.08, 34, 28);
INSERT INTO public.europe_data VALUES (5622, 4066, 44519, 73.26, 87, 28);
INSERT INTO public.europe_data VALUES (5623, 56, 2328, 108.38, 182, 28);
INSERT INTO public.europe_data VALUES (5624, 0, 3, 24.18, 183, 28);
INSERT INTO public.europe_data VALUES (5625, 0, 5, 0.19, 126, 28);
INSERT INTO public.europe_data VALUES (5626, 11, 689, 239, 184, 28);
INSERT INTO public.europe_data VALUES (5627, 0, 0, 20.04, 88, 28);
INSERT INTO public.europe_data VALUES (5628, 69, 5259, 22.76, 35, 28);
INSERT INTO public.europe_data VALUES (5629, 2, 277, 1.5, 36, 28);
INSERT INTO public.europe_data VALUES (5630, 0, 3, 0.02, 127, 28);
INSERT INTO public.europe_data VALUES (5631, 3, 519, 41.97, 37, 28);
INSERT INTO public.europe_data VALUES (5632, 12, 1719, 9.35, 128, 28);
INSERT INTO public.europe_data VALUES (5633, 0, 2097, 19.2, 185, 28);
INSERT INTO public.europe_data VALUES (5634, 0, 0, 0, 208, 28);
INSERT INTO public.europe_data VALUES (5635, 0, 11, 0.27, 209, 28);
INSERT INTO public.europe_data VALUES (5636, 8, 233, 8.02, 89, 28);
INSERT INTO public.europe_data VALUES (5637, 0, 15, 0.18, 38, 28);
INSERT INTO public.europe_data VALUES (5638, 30, 3309, 3.57, 39, 28);
INSERT INTO public.europe_data VALUES (5639, 37, 968, 92.53, 186, 28);
INSERT INTO public.europe_data VALUES (5640, 0, 6, 15.73, 210, 28);
INSERT INTO public.europe_data VALUES (5641, 0, 123, 3.62, 187, 28);
INSERT INTO public.europe_data VALUES (5642, 37, 3154, 251.22, 129, 28);
INSERT INTO public.europe_data VALUES (5643, 142, 5740, 6.9, 130, 28);
INSERT INTO public.europe_data VALUES (5644, 9, 2651, 114.99, 131, 28);
INSERT INTO public.europe_data VALUES (5645, 177, 7157, 329.33, 90, 28);
INSERT INTO public.europe_data VALUES (5646, 2, 48, 1.06, 211, 28);
INSERT INTO public.europe_data VALUES (5647, 11, 1200, 27.3, 91, 28);
INSERT INTO public.europe_data VALUES (5648, 1385, 44053, 231.49, 92, 28);
INSERT INTO public.europe_data VALUES (5649, 127, 22737, 33.05, 132, 28);
INSERT INTO public.europe_data VALUES (5650, 60, 3829, 17.88, 188, 28);
INSERT INTO public.europe_data VALUES (5651, 21, 1299, 27.51, 189, 28);
INSERT INTO public.europe_data VALUES (5652, 29, 3268, 216.4, 93, 28);
INSERT INTO public.europe_data VALUES (5653, 12, 1802, 157.45, 133, 28);
INSERT INTO public.europe_data VALUES (5654, 226, 8388, 81.01, 190, 28);
INSERT INTO public.europe_data VALUES (5655, 859, 38385, 54.38, 191, 28);
INSERT INTO public.europe_data VALUES (5656, 0, 241, 3.8, 40, 28);
INSERT INTO public.europe_data VALUES (5657, 0, 0, 0, 94, 28);
INSERT INTO public.europe_data VALUES (5658, 0, 1, 1.09, 95, 28);
INSERT INTO public.europe_data VALUES (5659, 0, 3, 4.52, 96, 28);
INSERT INTO public.europe_data VALUES (5660, 0, 0, 0, 192, 28);
INSERT INTO public.europe_data VALUES (5661, 1, 11, 59.52, 41, 28);
INSERT INTO public.europe_data VALUES (5662, 184, 11894, 81.46, 134, 28);
INSERT INTO public.europe_data VALUES (5663, 18, 663, 9.41, 42, 28);
INSERT INTO public.europe_data VALUES (5664, 56, 2463, 76.09, 193, 28);
INSERT INTO public.europe_data VALUES (5665, 0, 0, 14.32, 43, 28);
INSERT INTO public.europe_data VALUES (5666, 1, 60, 1.69, 44, 28);
INSERT INTO public.europe_data VALUES (5667, 0, 2456, 84.64, 135, 28);
INSERT INTO public.europe_data VALUES (5668, 1, 52, 158.06, 97, 28);
INSERT INTO public.europe_data VALUES (5669, 1, 165, 6.7, 194, 28);
INSERT INTO public.europe_data VALUES (5670, 2, 98, 11.25, 195, 28);
INSERT INTO public.europe_data VALUES (5671, 0, 34, 0.6, 45, 28);
INSERT INTO public.europe_data VALUES (5672, 1597, 66052, 251.3, 46, 28);
INSERT INTO public.europe_data VALUES (5673, 2, 214, 1.21, 136, 28);
INSERT INTO public.europe_data VALUES (5674, 1, 167, 2.07, 47, 28);
INSERT INTO public.europe_data VALUES (5675, 38, 18272, 68.64, 196, 28);
INSERT INTO public.europe_data VALUES (5676, 0, 41, 0.46, 137, 28);
INSERT INTO public.europe_data VALUES (5677, 35, 353, 2.28, 48, 28);
INSERT INTO public.europe_data VALUES (5678, 4, 410, 141.05, 98, 28);
INSERT INTO public.europe_data VALUES (5679, 18, 1556, 28.07, 197, 28);
INSERT INTO public.europe_data VALUES (5680, 5, 1136, 22.9, 198, 28);
INSERT INTO public.europe_data VALUES (5681, 6, 159, 1.83, 138, 28);
INSERT INTO public.europe_data VALUES (5682, 0, 13, 0.08, 139, 28);
INSERT INTO public.europe_data VALUES (5683, 2, 303, 6.62, 140, 28);
INSERT INTO public.europe_data VALUES (5684, 0, 25, 0.1, 141, 28);
INSERT INTO public.europe_data VALUES (5685, 0, 0, 0, 142, 28);
INSERT INTO public.europe_data VALUES (5686, 1, 93, 2.31, 49, 28);
INSERT INTO public.europe_data VALUES (5687, 0, 35, 3.23, 99, 28);
INSERT INTO public.europe_data VALUES (5688, 1, 109, 1.6, 50, 28);
INSERT INTO public.europe_data VALUES (5689, 115, 47136, 65.36, 199, 28);
INSERT INTO public.europe_data VALUES (5690, 0, 17, 91.64, 100, 28);
INSERT INTO public.europe_data VALUES (5691, 2, 67, 0.26, 51, 28);
INSERT INTO public.europe_data VALUES (5692, 120, 7319, 30.29, 200, 28);
INSERT INTO public.europe_data VALUES (5693, 7, 2086, 41.73, 143, 28);
INSERT INTO public.europe_data VALUES (5694, 96, 4444, 13.49, 201, 28);
INSERT INTO public.europe_data VALUES (5695, 0, 0, 0, 52, 28);
INSERT INTO public.europe_data VALUES (5696, 7925, 433935, 271.89, 101, 28);
INSERT INTO public.europe_data VALUES (5697, 1, 60, 118.57, 102, 28);
INSERT INTO public.europe_data VALUES (5698, 2, 94, 6.7, 103, 28);
INSERT INTO public.europe_data VALUES (5699, 38, 5008, 26.87, 144, 28);
INSERT INTO public.europe_data VALUES (5700, 32, 4743, 29.16, 104, 28);
INSERT INTO public.europe_data VALUES (5701, 6, 201, 0.26, 145, 28);
INSERT INTO public.europe_data VALUES (5702, 0, 0, 0, 53, 28);
INSERT INTO public.europe_data VALUES (5703, 18, 53, 0.44, 146, 28);
INSERT INTO public.europe_data VALUES (5704, 31, 1866, 18.85, 54, 28);
INSERT INTO public.europe_data VALUES (5705, 36, 1409, 15.77, 55, 28);
INSERT INTO public.europe_data VALUES (5706, 88, 788, 4.76, 105, 29);
INSERT INTO public.europe_data VALUES (5707, 26, 673, 45.73, 147, 29);
INSERT INTO public.europe_data VALUES (5708, 77, 4273, 18.96, 1, 29);
INSERT INTO public.europe_data VALUES (5709, 0, 17, 55.13, 148, 29);
INSERT INTO public.europe_data VALUES (5710, 11, 225, 1.33, 2, 29);
INSERT INTO public.europe_data VALUES (5711, 0, 0, 0, 56, 29);
INSERT INTO public.europe_data VALUES (5712, 0, 6, 8.24, 57, 29);
INSERT INTO public.europe_data VALUES (5713, 693, 40002, 145.19, 58, 29);
INSERT INTO public.europe_data VALUES (5714, 61, 2409, 177.13, 149, 29);
INSERT INTO public.europe_data VALUES (5715, 0, 6, 13.17, 59, 29);
INSERT INTO public.europe_data VALUES (5716, 33, 2601, 18.28, 202, 29);
INSERT INTO public.europe_data VALUES (5717, 2, 915, 18.5, 150, 29);
INSERT INTO public.europe_data VALUES (5718, 63, 2529, 59.8, 151, 29);
INSERT INTO public.europe_data VALUES (5719, 0, 189, 59.31, 60, 29);
INSERT INTO public.europe_data VALUES (5720, 14, 2709, 377.17, 106, 29);
INSERT INTO public.europe_data VALUES (5721, 310, 18928, 24.32, 107, 29);
INSERT INTO public.europe_data VALUES (5722, 0, 5, 2.44, 61, 29);
INSERT INTO public.europe_data VALUES (5723, 35, 1037, 23.27, 152, 29);
INSERT INTO public.europe_data VALUES (5724, 15, 2489, 33.82, 153, 29);
INSERT INTO public.europe_data VALUES (5725, 0, 8, 2.82, 62, 29);
INSERT INTO public.europe_data VALUES (5726, 4, 168, 3.32, 3, 29);
INSERT INTO public.europe_data VALUES (5727, 0, 1, 6.4, 63, 29);
INSERT INTO public.europe_data VALUES (5728, 0, 6, 1.44, 108, 29);
INSERT INTO public.europe_data VALUES (5729, 432, 9847, 184.5, 64, 29);
INSERT INTO public.europe_data VALUES (5730, 0, 1, 15.39, 65, 29);
INSERT INTO public.europe_data VALUES (5731, 33, 1617, 96.49, 154, 29);
INSERT INTO public.europe_data VALUES (5732, 0, 164, 12.46, 4, 29);
INSERT INTO public.europe_data VALUES (5733, 7516, 320702, 262.69, 66, 29);
INSERT INTO public.europe_data VALUES (5734, 0, 0, 0, 67, 29);
INSERT INTO public.europe_data VALUES (5735, 0, 0, 0, 109, 29);
INSERT INTO public.europe_data VALUES (5736, 40, 1694, 45.36, 155, 29);
INSERT INTO public.europe_data VALUES (5737, 0, 35, 0.31, 5, 29);
INSERT INTO public.europe_data VALUES (5738, 0, 51, 0.96, 6, 29);
INSERT INTO public.europe_data VALUES (5739, 0, 54, 0.42, 110, 29);
INSERT INTO public.europe_data VALUES (5740, 12, 551, 5.93, 7, 29);
INSERT INTO public.europe_data VALUES (5741, 38, 3560, 16.89, 68, 29);
INSERT INTO public.europe_data VALUES (5742, 1, 264, 110.74, 8, 29);
INSERT INTO public.europe_data VALUES (5743, 0, 0, 3.08, 69, 29);
INSERT INTO public.europe_data VALUES (5744, 4, 114, 6.55, 9, 29);
INSERT INTO public.europe_data VALUES (5745, 0, 26, 0.22, 10, 29);
INSERT INTO public.europe_data VALUES (5746, 609, 14860, 162.25, 70, 29);
INSERT INTO public.europe_data VALUES (5747, 6, 957, 0.1, 111, 29);
INSERT INTO public.europe_data VALUES (5748, 1789, 51698, 195.73, 71, 29);
INSERT INTO public.europe_data VALUES (5749, 0, 6, 2.7, 11, 29);
INSERT INTO public.europe_data VALUES (5750, 2, 405, 17.38, 12, 29);
INSERT INTO public.europe_data VALUES (5751, 42, 4115, 151.22, 72, 29);
INSERT INTO public.europe_data VALUES (5752, 4, 1477, 11, 13, 29);
INSERT INTO public.europe_data VALUES (5753, 16, 503, 27.84, 156, 29);
INSERT INTO public.europe_data VALUES (5754, 0, 49, 0.61, 73, 29);
INSERT INTO public.europe_data VALUES (5755, 0, 1, 2.45, 74, 29);
INSERT INTO public.europe_data VALUES (5756, 0, 19, 4.11, 157, 29);
INSERT INTO public.europe_data VALUES (5757, 12, 1379, 20.19, 158, 29);
INSERT INTO public.europe_data VALUES (5758, 11, 429, 0.92, 14, 29);
INSERT INTO public.europe_data VALUES (5759, 2, 265, 8.47, 159, 29);
INSERT INTO public.europe_data VALUES (5760, 2, 39, 8.01, 15, 29);
INSERT INTO public.europe_data VALUES (5761, 0, 0, 0, 75, 29);
INSERT INTO public.europe_data VALUES (5762, 82, 10053, 171.12, 76, 29);
INSERT INTO public.europe_data VALUES (5763, 202, 6681, 73.81, 77, 29);
INSERT INTO public.europe_data VALUES (5764, 304, 4287, 9.95, 16, 29);
INSERT INTO public.europe_data VALUES (5765, 64, 2784, 76.79, 78, 29);
INSERT INTO public.europe_data VALUES (5766, 0, 0, 0, 17, 29);
INSERT INTO public.europe_data VALUES (5767, 0, 12, 0.89, 18, 29);
INSERT INTO public.europe_data VALUES (5768, 0, 13, 1.51, 160, 29);
INSERT INTO public.europe_data VALUES (5769, 11, 414, 74.56, 19, 29);
INSERT INTO public.europe_data VALUES (5770, 56, 4465, 5.72, 20, 29);
INSERT INTO public.europe_data VALUES (5771, 0, 0, 0, 79, 29);
INSERT INTO public.europe_data VALUES (5772, 0, 0, 6.16, 161, 29);
INSERT INTO public.europe_data VALUES (5773, 0, 1, 0.11, 203, 29);
INSERT INTO public.europe_data VALUES (5774, 1, 55, 1.83, 162, 29);
INSERT INTO public.europe_data VALUES (5775, 40, 5854, 14.59, 163, 29);
INSERT INTO public.europe_data VALUES (5776, 0, 0, 0, 204, 29);
INSERT INTO public.europe_data VALUES (5777, 3, 669, 47.96, 21, 29);
INSERT INTO public.europe_data VALUES (5778, 2, 184, 9.07, 22, 29);
INSERT INTO public.europe_data VALUES (5779, 1, 109, 3.55, 164, 29);
INSERT INTO public.europe_data VALUES (5780, 32, 3786, 8.01, 165, 29);
INSERT INTO public.europe_data VALUES (5781, 20, 5302, 27.78, 23, 29);
INSERT INTO public.europe_data VALUES (5782, 0, 5, 14.83, 166, 29);
INSERT INTO public.europe_data VALUES (5783, 8, 186, 3.64, 167, 29);
INSERT INTO public.europe_data VALUES (5784, 0, 0, 0, 80, 29);
INSERT INTO public.europe_data VALUES (5785, 0, 0, 0, 81, 29);
INSERT INTO public.europe_data VALUES (5786, 0, 27, 20.32, 205, 29);
INSERT INTO public.europe_data VALUES (5787, 249, 6376, 89.29, 82, 29);
INSERT INTO public.europe_data VALUES (5788, 0, 0, 0, 168, 29);
INSERT INTO public.europe_data VALUES (5789, 4, 464, 6.79, 24, 29);
INSERT INTO public.europe_data VALUES (5790, 0, 27, 5.83, 25, 29);
INSERT INTO public.europe_data VALUES (5791, 1, 34, 9.33, 83, 29);
INSERT INTO public.europe_data VALUES (5792, 11, 262, 5.22, 84, 29);
INSERT INTO public.europe_data VALUES (5793, 0, 0, 0, 169, 29);
INSERT INTO public.europe_data VALUES (5794, 216, 5441, 114.77, 85, 29);
INSERT INTO public.europe_data VALUES (5795, 0, 115, 2.19, 170, 29);
INSERT INTO public.europe_data VALUES (5796, 0, 8, 3.92, 171, 29);
INSERT INTO public.europe_data VALUES (5797, 5274, 317410, 40.78, 112, 29);
INSERT INTO public.europe_data VALUES (5798, 638, 12257, 8.53, 113, 29);
INSERT INTO public.europe_data VALUES (5799, 1512, 17384, 40.85, 114, 29);
INSERT INTO public.europe_data VALUES (5800, 581, 17502, 82.74, 115, 29);
INSERT INTO public.europe_data VALUES (5801, 10, 121, 5.16, 172, 29);
INSERT INTO public.europe_data VALUES (5802, 0, 0, 0, 173, 29);
INSERT INTO public.europe_data VALUES (5803, 61, 11667, 273.33, 116, 29);
INSERT INTO public.europe_data VALUES (5804, 62, 1684, 5.06, 174, 29);
INSERT INTO public.europe_data VALUES (5805, 0, 52, 2.85, 86, 29);
INSERT INTO public.europe_data VALUES (5806, 11, 4893, 6.4, 117, 29);
INSERT INTO public.europe_data VALUES (5807, 0, 1, 6.49, 175, 29);
INSERT INTO public.europe_data VALUES (5808, 0, -50, -0.11, 118, 29);
INSERT INTO public.europe_data VALUES (5809, 210, 11284, 125.24, 119, 29);
INSERT INTO public.europe_data VALUES (5810, 46, 4250, 14.26, 26, 29);
INSERT INTO public.europe_data VALUES (5811, 34, 1182, 110.42, 176, 29);
INSERT INTO public.europe_data VALUES (5812, 25, 4569, 211.05, 120, 29);
INSERT INTO public.europe_data VALUES (5813, 264, 6153, 345.69, 121, 29);
INSERT INTO public.europe_data VALUES (5814, 0, 1, 0.01, 122, 29);
INSERT INTO public.europe_data VALUES (5815, 0, 27, 2.4, 177, 29);
INSERT INTO public.europe_data VALUES (5816, 11, 891, 20.65, 123, 29);
INSERT INTO public.europe_data VALUES (5817, 5, 87, 10.02, 27, 29);
INSERT INTO public.europe_data VALUES (5818, 2, 71, 3.08, 28, 29);
INSERT INTO public.europe_data VALUES (5819, 10, 681, 16.44, 29, 29);
INSERT INTO public.europe_data VALUES (5820, 0, 0, 5.21, 178, 29);
INSERT INTO public.europe_data VALUES (5821, 0, 76, 4.97, 179, 29);
INSERT INTO public.europe_data VALUES (5822, 1, 789, 219.42, 180, 29);
INSERT INTO public.europe_data VALUES (5823, 26, 2246, 16.42, 30, 29);
INSERT INTO public.europe_data VALUES (5824, 37, 648, 6.85, 31, 29);
INSERT INTO public.europe_data VALUES (5825, 1, 118, 0.56, 124, 29);
INSERT INTO public.europe_data VALUES (5826, 0, 336, 107.54, 125, 29);
INSERT INTO public.europe_data VALUES (5827, 2, 35, 0.5, 32, 29);
INSERT INTO public.europe_data VALUES (5828, 0, 24, 5.27, 181, 29);
INSERT INTO public.europe_data VALUES (5829, 1, 298, 23.09, 33, 29);
INSERT INTO public.europe_data VALUES (5830, 0, 1, 0.16, 34, 29);
INSERT INTO public.europe_data VALUES (5831, 4496, 48945, 77.36, 87, 29);
INSERT INTO public.europe_data VALUES (5832, 51, 2054, 90.32, 182, 29);
INSERT INTO public.europe_data VALUES (5833, 0, 5, 15.11, 183, 29);
INSERT INTO public.europe_data VALUES (5834, 0, 1, 1.8, 126, 29);
INSERT INTO public.europe_data VALUES (5835, 10, 798, 216.66, 184, 29);
INSERT INTO public.europe_data VALUES (5836, 0, 1, 20.04, 88, 29);
INSERT INTO public.europe_data VALUES (5837, 40, 3042, 12.43, 35, 29);
INSERT INTO public.europe_data VALUES (5838, 1, 178, 1.69, 36, 29);
INSERT INTO public.europe_data VALUES (5839, 0, 9, 0.04, 127, 29);
INSERT INTO public.europe_data VALUES (5840, 5, 528, 39.69, 37, 29);
INSERT INTO public.europe_data VALUES (5841, 5, 955, 6.33, 128, 29);
INSERT INTO public.europe_data VALUES (5842, 4, 1221, 11.13, 185, 29);
INSERT INTO public.europe_data VALUES (5843, 0, 0, 0.35, 208, 29);
INSERT INTO public.europe_data VALUES (5844, 0, 2, 0.25, 209, 29);
INSERT INTO public.europe_data VALUES (5845, 9, 292, 9.06, 89, 29);
INSERT INTO public.europe_data VALUES (5846, 0, 28, 0.14, 38, 29);
INSERT INTO public.europe_data VALUES (5847, 69, 3869, 3.97, 39, 29);
INSERT INTO public.europe_data VALUES (5848, 38, 954, 95.08, 186, 29);
INSERT INTO public.europe_data VALUES (5849, 0, 3, 12.23, 210, 29);
INSERT INTO public.europe_data VALUES (5850, 0, 70, 2.25, 187, 29);
INSERT INTO public.europe_data VALUES (5851, 66, 9344, 401.81, 129, 29);
INSERT INTO public.europe_data VALUES (5852, 243, 9206, 10.47, 130, 29);
INSERT INTO public.europe_data VALUES (5853, 16, 3077, 122.27, 131, 29);
INSERT INTO public.europe_data VALUES (5854, 198, 6828, 345.3, 90, 29);
INSERT INTO public.europe_data VALUES (5855, 0, 45, 0.58, 211, 29);
INSERT INTO public.europe_data VALUES (5856, 10, 723, 21.24, 91, 29);
INSERT INTO public.europe_data VALUES (5857, 5042, 31207, 179.85, 92, 29);
INSERT INTO public.europe_data VALUES (5858, 101, 12992, 22.37, 132, 29);
INSERT INTO public.europe_data VALUES (5859, 47, 2961, 13.63, 188, 29);
INSERT INTO public.europe_data VALUES (5860, 28, 1528, 35.54, 189, 29);
INSERT INTO public.europe_data VALUES (5861, 23, 3080, 181.43, 93, 29);
INSERT INTO public.europe_data VALUES (5862, 8, 2657, 201.51, 133, 29);
INSERT INTO public.europe_data VALUES (5863, 161, 7340, 63.16, 190, 29);
INSERT INTO public.europe_data VALUES (5864, 927, 40939, 58.49, 191, 29);
INSERT INTO public.europe_data VALUES (5865, 0, 239, 3.83, 40, 29);
INSERT INTO public.europe_data VALUES (5866, 0, 0, 0, 94, 29);
INSERT INTO public.europe_data VALUES (5867, 0, 1, 1.09, 95, 29);
INSERT INTO public.europe_data VALUES (5868, 0, 2, 15.37, 96, 29);
INSERT INTO public.europe_data VALUES (5869, 0, 0, 0, 192, 29);
INSERT INTO public.europe_data VALUES (5870, 0, 117, 62.31, 41, 29);
INSERT INTO public.europe_data VALUES (5871, 247, 16021, 101.21, 134, 29);
INSERT INTO public.europe_data VALUES (5872, 24, 871, 9.49, 42, 29);
INSERT INTO public.europe_data VALUES (5873, 62, 2836, 77.11, 193, 29);
INSERT INTO public.europe_data VALUES (5874, 0, 14, 14.32, 43, 29);
INSERT INTO public.europe_data VALUES (5875, 1, 72, 1.89, 44, 29);
INSERT INTO public.europe_data VALUES (5876, 0, 2457, 75.94, 135, 29);
INSERT INTO public.europe_data VALUES (5877, 0, 15, 37.75, 97, 29);
INSERT INTO public.europe_data VALUES (5878, 0, 200, 5.1, 194, 29);
INSERT INTO public.europe_data VALUES (5879, 4, 136, 11.58, 195, 29);
INSERT INTO public.europe_data VALUES (5880, 0, 59, 0.77, 45, 29);
INSERT INTO public.europe_data VALUES (5881, 1736, 81105, 288.93, 46, 29);
INSERT INTO public.europe_data VALUES (5882, 3, 404, 1.36, 136, 29);
INSERT INTO public.europe_data VALUES (5883, 2, 62, 1.11, 47, 29);
INSERT INTO public.europe_data VALUES (5884, 12, 13946, 48.64, 196, 29);
INSERT INTO public.europe_data VALUES (5885, 0, 58, 0.77, 137, 29);
INSERT INTO public.europe_data VALUES (5886, 37, 623, 2.65, 48, 29);
INSERT INTO public.europe_data VALUES (5887, 2, 410, 120.06, 98, 29);
INSERT INTO public.europe_data VALUES (5888, 30, 1316, 28.72, 197, 29);
INSERT INTO public.europe_data VALUES (5889, 13, 821, 17.87, 198, 29);
INSERT INTO public.europe_data VALUES (5890, 13, 154, 1.5, 138, 29);
INSERT INTO public.europe_data VALUES (5891, 0, 7, 0.05, 139, 29);
INSERT INTO public.europe_data VALUES (5892, 2, 314, 6.87, 140, 29);
INSERT INTO public.europe_data VALUES (5893, 0, 45, 0.11, 141, 29);
INSERT INTO public.europe_data VALUES (5894, 0, 0, 0, 142, 29);
INSERT INTO public.europe_data VALUES (5895, 3, 94, 1.83, 49, 29);
INSERT INTO public.europe_data VALUES (5896, 0, 10, 1, 99, 29);
INSERT INTO public.europe_data VALUES (5897, 0, 78, 1.62, 50, 29);
INSERT INTO public.europe_data VALUES (5898, 122, 6459, 15.98, 199, 29);
INSERT INTO public.europe_data VALUES (5899, 0, 18, 70.69, 100, 29);
INSERT INTO public.europe_data VALUES (5900, 2, 50, 0.2, 51, 29);
INSERT INTO public.europe_data VALUES (5901, 120, 6007, 25.75, 200, 29);
INSERT INTO public.europe_data VALUES (5902, 5, 1991, 41.54, 143, 29);
INSERT INTO public.europe_data VALUES (5903, 116, 4549, 13.29, 201, 29);
INSERT INTO public.europe_data VALUES (5904, 0, 0, 0, 52, 29);
INSERT INTO public.europe_data VALUES (5905, 6401, 460760, 282.34, 101, 29);
INSERT INTO public.europe_data VALUES (5906, 1, 64, 172.12, 102, 29);
INSERT INTO public.europe_data VALUES (5907, 1, 138, 5.92, 103, 29);
INSERT INTO public.europe_data VALUES (5908, 29, 3854, 23.12, 144, 29);
INSERT INTO public.europe_data VALUES (5909, 30, 3572, 21.03, 104, 29);
INSERT INTO public.europe_data VALUES (5910, 0, 47, 0.05, 145, 29);
INSERT INTO public.europe_data VALUES (5911, 0, 0, 42.41, 53, 29);
INSERT INTO public.europe_data VALUES (5912, 34, 75, 0.74, 146, 29);
INSERT INTO public.europe_data VALUES (5913, 30, 1501, 14.48, 54, 29);
INSERT INTO public.europe_data VALUES (5914, 9, 901, 10.43, 55, 29);
INSERT INTO public.europe_data VALUES (5915, 171, 1024, 6.63, 105, 30);
INSERT INTO public.europe_data VALUES (5916, 19, 636, 41.82, 147, 30);
INSERT INTO public.europe_data VALUES (5917, 67, 3889, 16.59, 1, 30);
INSERT INTO public.europe_data VALUES (5918, 0, 25, 32.82, 148, 30);
INSERT INTO public.europe_data VALUES (5919, 3, 199, 1.13, 2, 30);
INSERT INTO public.europe_data VALUES (5920, 0, 0, 0, 56, 30);
INSERT INTO public.europe_data VALUES (5921, 0, 2, 8.24, 57, 30);
INSERT INTO public.europe_data VALUES (5922, 428, 25015, 105.29, 58, 30);
INSERT INTO public.europe_data VALUES (5923, 77, 2830, 204.38, 149, 30);
INSERT INTO public.europe_data VALUES (5924, 0, 8, 7.53, 59, 30);
INSERT INTO public.europe_data VALUES (5925, 14, 2005, 13.3, 202, 30);
INSERT INTO public.europe_data VALUES (5926, 2, 724, 14.7, 150, 30);
INSERT INTO public.europe_data VALUES (5927, 48, 3480, 71.63, 151, 30);
INSERT INTO public.europe_data VALUES (5928, 0, 42, 12.58, 60, 30);
INSERT INTO public.europe_data VALUES (5929, 17, 3481, 429.88, 106, 30);
INSERT INTO public.europe_data VALUES (5930, 266, 20730, 25.83, 107, 30);
INSERT INTO public.europe_data VALUES (5931, 0, 2, 2.44, 61, 30);
INSERT INTO public.europe_data VALUES (5932, 35, 1163, 26.88, 152, 30);
INSERT INTO public.europe_data VALUES (5933, 19, 1385, 18.24, 153, 30);
INSERT INTO public.europe_data VALUES (5934, 0, 3, 2.56, 62, 30);
INSERT INTO public.europe_data VALUES (5935, 5, 224, 3.41, 3, 30);
INSERT INTO public.europe_data VALUES (5936, 0, 3, 11.2, 63, 30);
INSERT INTO public.europe_data VALUES (5937, 0, 5, 1.18, 108, 30);
INSERT INTO public.europe_data VALUES (5938, 344, 11395, 176.19, 64, 30);
INSERT INTO public.europe_data VALUES (5939, 0, 3, 11.55, 65, 30);
INSERT INTO public.europe_data VALUES (5940, 30, 1568, 92.67, 154, 30);
INSERT INTO public.europe_data VALUES (5941, 0, 123, 10.72, 4, 30);
INSERT INTO public.europe_data VALUES (5942, 7388, 233708, 234.7, 66, 30);
INSERT INTO public.europe_data VALUES (5943, 0, 0, 0, 67, 30);
INSERT INTO public.europe_data VALUES (5944, 0, 0, 0, 109, 30);
INSERT INTO public.europe_data VALUES (5945, 32, 1481, 42.76, 155, 30);
INSERT INTO public.europe_data VALUES (5946, 0, 29, 0.38, 5, 30);
INSERT INTO public.europe_data VALUES (5947, 0, 60, 1.03, 6, 30);
INSERT INTO public.europe_data VALUES (5948, 0, 15, 0.18, 110, 30);
INSERT INTO public.europe_data VALUES (5949, 14, 984, 9.45, 7, 30);
INSERT INTO public.europe_data VALUES (5950, 69, 2759, 12.87, 68, 30);
INSERT INTO public.europe_data VALUES (5951, 2, 345, 107.65, 8, 30);
INSERT INTO public.europe_data VALUES (5952, 0, 2, 3.08, 69, 30);
INSERT INTO public.europe_data VALUES (5953, 2, 197, 10.87, 9, 30);
INSERT INTO public.europe_data VALUES (5954, 0, 9, 0.11, 10, 30);
INSERT INTO public.europe_data VALUES (5955, 1524, 15889, 186.78, 70, 30);
INSERT INTO public.europe_data VALUES (5956, 5, 496, 0.05, 111, 30);
INSERT INTO public.europe_data VALUES (5957, 1429, 46833, 159.25, 71, 30);
INSERT INTO public.europe_data VALUES (5958, 0, 17, 2.7, 11, 30);
INSERT INTO public.europe_data VALUES (5959, 2, 530, 20, 12, 30);
INSERT INTO public.europe_data VALUES (5960, 32, 3518, 121.21, 72, 30);
INSERT INTO public.europe_data VALUES (5961, 8, 1353, 13.01, 13, 30);
INSERT INTO public.europe_data VALUES (5962, 1, 632, 29.51, 156, 30);
INSERT INTO public.europe_data VALUES (5963, 0, 20, 0.65, 73, 30);
INSERT INTO public.europe_data VALUES (5964, 0, 3, 1.84, 74, 30);
INSERT INTO public.europe_data VALUES (5965, 0, 17, 4, 157, 30);
INSERT INTO public.europe_data VALUES (5966, 7, 771, 13.43, 158, 30);
INSERT INTO public.europe_data VALUES (5967, 5, 370, 1.14, 14, 30);
INSERT INTO public.europe_data VALUES (5968, 2, 227, 5.87, 159, 30);
INSERT INTO public.europe_data VALUES (5969, 0, 39, 22.49, 15, 30);
INSERT INTO public.europe_data VALUES (5970, 0, 0, 0, 75, 30);
INSERT INTO public.europe_data VALUES (5971, 84, 8323, 143.68, 76, 30);
INSERT INTO public.europe_data VALUES (5972, 266, 6143, 69.39, 77, 30);
INSERT INTO public.europe_data VALUES (5973, 444, 5705, 12.47, 16, 30);
INSERT INTO public.europe_data VALUES (5974, 77, 2172, 63.05, 78, 30);
INSERT INTO public.europe_data VALUES (5975, 0, 0, 0, 17, 30);
INSERT INTO public.europe_data VALUES (5976, 0, 19, 1.03, 18, 30);
INSERT INTO public.europe_data VALUES (5977, 0, 7, 2.11, 160, 30);
INSERT INTO public.europe_data VALUES (5978, 1, 442, 70.11, 19, 30);
INSERT INTO public.europe_data VALUES (5979, 40, 1943, 3.26, 20, 30);
INSERT INTO public.europe_data VALUES (5980, 0, 0, 0, 79, 30);
INSERT INTO public.europe_data VALUES (5981, 0, 3, 8.22, 161, 30);
INSERT INTO public.europe_data VALUES (5982, 0, 0, 0.9, 203, 30);
INSERT INTO public.europe_data VALUES (5983, 0, 46, 1.2, 162, 30);
INSERT INTO public.europe_data VALUES (5984, 148, 3922, 11.51, 163, 30);
INSERT INTO public.europe_data VALUES (5985, 0, 0, 0, 204, 30);
INSERT INTO public.europe_data VALUES (5986, 0, 373, 31.99, 21, 30);
INSERT INTO public.europe_data VALUES (5987, 1, 29, 1.53, 22, 30);
INSERT INTO public.europe_data VALUES (5988, 0, 33, 1.88, 164, 30);
INSERT INTO public.europe_data VALUES (5989, 22, 2860, 6.35, 165, 30);
INSERT INTO public.europe_data VALUES (5990, 9, 3149, 24.93, 23, 30);
INSERT INTO public.europe_data VALUES (5991, 0, 0, 5.93, 166, 30);
INSERT INTO public.europe_data VALUES (5992, 1, 204, 4.55, 167, 30);
INSERT INTO public.europe_data VALUES (5993, 0, 0, 0, 80, 30);
INSERT INTO public.europe_data VALUES (5994, 0, 0, 0, 81, 30);
INSERT INTO public.europe_data VALUES (5995, 0, 7, 10.76, 205, 30);
INSERT INTO public.europe_data VALUES (5996, 266, 9322, 87.76, 82, 30);
INSERT INTO public.europe_data VALUES (5997, 0, 0, 0, 168, 30);
INSERT INTO public.europe_data VALUES (5998, 2, 403, 7.31, 24, 30);
INSERT INTO public.europe_data VALUES (5999, 1, 85, 8.43, 25, 30);
INSERT INTO public.europe_data VALUES (6000, 2, 39, 8.05, 83, 30);
INSERT INTO public.europe_data VALUES (6001, 7, 326, 6.39, 84, 30);
INSERT INTO public.europe_data VALUES (6002, 0, 0, 0, 169, 30);
INSERT INTO public.europe_data VALUES (6003, 126, 5745, 101.5, 85, 30);
INSERT INTO public.europe_data VALUES (6004, 1, 99, 1.53, 170, 30);
INSERT INTO public.europe_data VALUES (6005, 0, 6, 2.52, 171, 30);
INSERT INTO public.europe_data VALUES (6006, 4323, 239789, 30.78, 112, 30);
INSERT INTO public.europe_data VALUES (6007, 537, 10822, 8.41, 113, 30);
INSERT INTO public.europe_data VALUES (6008, 1359, 16485, 40.22, 114, 30);
INSERT INTO public.europe_data VALUES (6009, 631, 15024, 81.53, 115, 30);
INSERT INTO public.europe_data VALUES (6010, 7, 132, 4.75, 172, 30);
INSERT INTO public.europe_data VALUES (6011, 0, 0, 0, 173, 30);
INSERT INTO public.europe_data VALUES (6012, 47, 11619, 238.64, 116, 30);
INSERT INTO public.europe_data VALUES (6013, 91, 1373, 4.68, 174, 30);
INSERT INTO public.europe_data VALUES (6014, 0, 32, 1.97, 86, 30);
INSERT INTO public.europe_data VALUES (6015, 3, 3228, 4.19, 117, 30);
INSERT INTO public.europe_data VALUES (6016, 0, 6, 10.2, 175, 30);
INSERT INTO public.europe_data VALUES (6017, 1, 39, 0.53, 118, 30);
INSERT INTO public.europe_data VALUES (6018, 0, 11949, 125.4, 119, 30);
INSERT INTO public.europe_data VALUES (6019, 49, 3248, 10.4, 26, 30);
INSERT INTO public.europe_data VALUES (6020, 33, 804, 132.28, 176, 30);
INSERT INTO public.europe_data VALUES (6021, 18, 4310, 220.18, 120, 30);
INSERT INTO public.europe_data VALUES (6022, 890, 16026, 303.19, 121, 30);
INSERT INTO public.europe_data VALUES (6023, 0, 0, 0, 122, 30);
INSERT INTO public.europe_data VALUES (6024, 1, 19, 3.54, 177, 30);
INSERT INTO public.europe_data VALUES (6025, 4, 525, 14.38, 123, 30);
INSERT INTO public.europe_data VALUES (6026, 4, 126, 13.17, 27, 30);
INSERT INTO public.europe_data VALUES (6027, 19, 81, 4.4, 28, 30);
INSERT INTO public.europe_data VALUES (6028, 9, 433, 12.94, 29, 30);
INSERT INTO public.europe_data VALUES (6029, 0, 2, 7.82, 178, 30);
INSERT INTO public.europe_data VALUES (6030, 1, 63, 3.44, 179, 30);
INSERT INTO public.europe_data VALUES (6031, 0, 558, 156.54, 180, 30);
INSERT INTO public.europe_data VALUES (6032, 24, 2182, 16.02, 30, 30);
INSERT INTO public.europe_data VALUES (6033, 24, 628, 6.71, 31, 30);
INSERT INTO public.europe_data VALUES (6034, 1, 61, 0.38, 124, 30);
INSERT INTO public.europe_data VALUES (6035, 2, 235, 93.79, 125, 30);
INSERT INTO public.europe_data VALUES (6036, 0, 64, 0.74, 32, 30);
INSERT INTO public.europe_data VALUES (6037, 0, 2, 0.81, 181, 30);
INSERT INTO public.europe_data VALUES (6038, 11, 747, 21.96, 33, 30);
INSERT INTO public.europe_data VALUES (6039, 0, 1, 0.16, 34, 30);
INSERT INTO public.europe_data VALUES (6040, 4178, 49745, 73.68, 87, 30);
INSERT INTO public.europe_data VALUES (6041, 42, 1598, 78.3, 182, 30);
INSERT INTO public.europe_data VALUES (6042, 0, 0, 3.02, 183, 30);
INSERT INTO public.europe_data VALUES (6043, 0, 57, 2.08, 126, 30);
INSERT INTO public.europe_data VALUES (6044, 7, 550, 159.12, 184, 30);
INSERT INTO public.europe_data VALUES (6045, 0, 0, 20.04, 88, 30);
INSERT INTO public.europe_data VALUES (6046, 23, 1491, 8.28, 35, 30);
INSERT INTO public.europe_data VALUES (6047, 1, 334, 1.66, 36, 30);
INSERT INTO public.europe_data VALUES (6048, 0, 10, 0.05, 127, 30);
INSERT INTO public.europe_data VALUES (6049, 2, 462, 33.47, 37, 30);
INSERT INTO public.europe_data VALUES (6050, 2, 857, 6.55, 128, 30);
INSERT INTO public.europe_data VALUES (6051, 1, 703, 6.39, 185, 30);
INSERT INTO public.europe_data VALUES (6052, 0, 1, 0.35, 208, 30);
INSERT INTO public.europe_data VALUES (6053, 0, 10, 0.44, 209, 30);
INSERT INTO public.europe_data VALUES (6054, 8, 301, 9.59, 89, 30);
INSERT INTO public.europe_data VALUES (6055, 1, 5, 0.05, 38, 30);
INSERT INTO public.europe_data VALUES (6056, 49, 4105, 3.96, 39, 30);
INSERT INTO public.europe_data VALUES (6057, 40, 1021, 100.43, 186, 30);
INSERT INTO public.europe_data VALUES (6058, 0, 4, 10.49, 210, 30);
INSERT INTO public.europe_data VALUES (6059, 3, 50, 2.25, 187, 30);
INSERT INTO public.europe_data VALUES (6060, 61, 10646, 411.72, 129, 30);
INSERT INTO public.europe_data VALUES (6061, 333, 13458, 15.36, 130, 30);
INSERT INTO public.europe_data VALUES (6062, 25, 3014, 112.3, 131, 30);
INSERT INTO public.europe_data VALUES (6063, 187, 7835, 360.75, 90, 30);
INSERT INTO public.europe_data VALUES (6064, 0, 6, 0.07, 211, 30);
INSERT INTO public.europe_data VALUES (6065, 9, 773, 18.37, 91, 30);
INSERT INTO public.europe_data VALUES (6066, 1317, 27264, 156.48, 92, 30);
INSERT INTO public.europe_data VALUES (6067, 297, 11197, 23.7, 132, 30);
INSERT INTO public.europe_data VALUES (6068, 53, 2213, 10.94, 188, 30);
INSERT INTO public.europe_data VALUES (6069, 29, 2124, 46.11, 189, 30);
INSERT INTO public.europe_data VALUES (6070, 11, 2242, 141.37, 93, 30);
INSERT INTO public.europe_data VALUES (6071, 10, 3050, 241.84, 133, 30);
INSERT INTO public.europe_data VALUES (6072, 142, 4923, 43.7, 190, 30);
INSERT INTO public.europe_data VALUES (6073, 1007, 44384, 61.9, 191, 30);
INSERT INTO public.europe_data VALUES (6074, 1, 245, 3.78, 40, 30);
INSERT INTO public.europe_data VALUES (6075, 0, 0, 1.89, 94, 30);
INSERT INTO public.europe_data VALUES (6076, 0, 1, 0.55, 95, 30);
INSERT INTO public.europe_data VALUES (6077, 0, 15, 18.99, 96, 30);
INSERT INTO public.europe_data VALUES (6078, 0, 0, 2.9, 192, 30);
INSERT INTO public.europe_data VALUES (6079, 0, 17, 12.09, 41, 30);
INSERT INTO public.europe_data VALUES (6080, 263, 18661, 120.84, 134, 30);
INSERT INTO public.europe_data VALUES (6081, 19, 675, 8.65, 42, 30);
INSERT INTO public.europe_data VALUES (6082, 79, 2534, 68.4, 193, 30);
INSERT INTO public.europe_data VALUES (6083, 0, 0, 91.06, 43, 30);
INSERT INTO public.europe_data VALUES (6084, 2, 76, 2.16, 44, 30);
INSERT INTO public.europe_data VALUES (6085, 1, 1951, 55.96, 135, 30);
INSERT INTO public.europe_data VALUES (6086, 0, 1, 2.36, 97, 30);
INSERT INTO public.europe_data VALUES (6087, 0, 78, 3.94, 194, 30);
INSERT INTO public.europe_data VALUES (6088, 0, 105, 11.82, 195, 30);
INSERT INTO public.europe_data VALUES (6089, 0, 60, 0.79, 45, 30);
INSERT INTO public.europe_data VALUES (6090, 954, 88086, 286.17, 46, 30);
INSERT INTO public.europe_data VALUES (6091, 7, 292, 1.33, 136, 30);
INSERT INTO public.europe_data VALUES (6092, 2, 61, 1.48, 47, 30);
INSERT INTO public.europe_data VALUES (6093, 16, 8883, 27.8, 196, 30);
INSERT INTO public.europe_data VALUES (6094, 0, 107, 3.04, 137, 30);
INSERT INTO public.europe_data VALUES (6095, 30, 512, 2.32, 48, 30);
INSERT INTO public.europe_data VALUES (6096, 3, 288, 74.82, 98, 30);
INSERT INTO public.europe_data VALUES (6097, 57, 1622, 37.15, 197, 30);
INSERT INTO public.europe_data VALUES (6098, 2, 706, 15.45, 198, 30);
INSERT INTO public.europe_data VALUES (6099, 9, 102, 0.81, 138, 30);
INSERT INTO public.europe_data VALUES (6100, 0, 4, 0.03, 139, 30);
INSERT INTO public.europe_data VALUES (6101, 2, 326, 7.13, 140, 30);
INSERT INTO public.europe_data VALUES (6102, 0, 30, 0.08, 141, 30);
INSERT INTO public.europe_data VALUES (6103, 0, 0, 0, 142, 30);
INSERT INTO public.europe_data VALUES (6104, 0, 54, 1.16, 49, 30);
INSERT INTO public.europe_data VALUES (6105, 0, 4, 0.29, 99, 30);
INSERT INTO public.europe_data VALUES (6106, 0, 111, 1.59, 50, 30);
INSERT INTO public.europe_data VALUES (6107, 128, 6648, 16.93, 199, 30);
INSERT INTO public.europe_data VALUES (6108, 0, 9, 89.02, 100, 30);
INSERT INTO public.europe_data VALUES (6109, 0, 40, 0.28, 51, 30);
INSERT INTO public.europe_data VALUES (6110, 102, 5321, 23.51, 200, 30);
INSERT INTO public.europe_data VALUES (6111, 6, 2068, 55.08, 143, 30);
INSERT INTO public.europe_data VALUES (6112, 150, 4310, 12.88, 201, 30);
INSERT INTO public.europe_data VALUES (6113, 0, 0, 0, 52, 30);
INSERT INTO public.europe_data VALUES (6114, 5329, 468318, 268.83, 101, 30);
INSERT INTO public.europe_data VALUES (6115, 0, 116, 176.9, 102, 30);
INSERT INTO public.europe_data VALUES (6116, 2, 67, 2.83, 103, 30);
INSERT INTO public.europe_data VALUES (6117, 27, 3773, 20.69, 144, 30);
INSERT INTO public.europe_data VALUES (6118, 23, 2426, 16.56, 104, 30);
INSERT INTO public.europe_data VALUES (6119, 0, 1, 0.02, 145, 30);
INSERT INTO public.europe_data VALUES (6120, 0, 247, 42.41, 53, 30);
INSERT INTO public.europe_data VALUES (6121, 28, 141, 1.17, 146, 30);
INSERT INTO public.europe_data VALUES (6122, 67, 1085, 7.55, 54, 30);
INSERT INTO public.europe_data VALUES (6123, 7, 626, 6.11, 55, 30);
INSERT INTO public.europe_data VALUES (6124, 146, 1500, 9.16, 105, 31);
INSERT INTO public.europe_data VALUES (6125, 17, 561, 36.75, 147, 31);
INSERT INTO public.europe_data VALUES (6126, 59, 3254, 13.76, 1, 31);
INSERT INTO public.europe_data VALUES (6127, 0, 0, 0, 148, 31);
INSERT INTO public.europe_data VALUES (6128, 7, 160, 0.75, 2, 31);
INSERT INTO public.europe_data VALUES (6129, 0, 0, 0, 56, 31);
INSERT INTO public.europe_data VALUES (6130, 0, 6, 9.27, 57, 31);
INSERT INTO public.europe_data VALUES (6131, 328, 22133, 88.8, 58, 31);
INSERT INTO public.europe_data VALUES (6132, 82, 3215, 237.48, 149, 31);
INSERT INTO public.europe_data VALUES (6133, 0, 0, 3.76, 59, 31);
INSERT INTO public.europe_data VALUES (6134, 4, 1348, 8.38, 202, 31);
INSERT INTO public.europe_data VALUES (6135, 2, 578, 13.79, 150, 31);
INSERT INTO public.europe_data VALUES (6136, 56, 3717, 75.81, 151, 31);
INSERT INTO public.europe_data VALUES (6137, 0, 7, 1.8, 60, 31);
INSERT INTO public.europe_data VALUES (6138, 12, 3574, 440.91, 106, 31);
INSERT INTO public.europe_data VALUES (6139, 300, 21378, 28.22, 107, 31);
INSERT INTO public.europe_data VALUES (6140, 0, 5, 2.09, 61, 31);
INSERT INTO public.europe_data VALUES (6141, 41, 1378, 36.57, 152, 31);
INSERT INTO public.europe_data VALUES (6142, 13, 704, 11.71, 153, 31);
INSERT INTO public.europe_data VALUES (6143, 0, 7, 3.33, 62, 31);
INSERT INTO public.europe_data VALUES (6144, 5, 179, 1.94, 3, 31);
INSERT INTO public.europe_data VALUES (6145, 0, 4, 6.4, 63, 31);
INSERT INTO public.europe_data VALUES (6146, 0, 4, 1.05, 108, 31);
INSERT INTO public.europe_data VALUES (6147, 373, 8890, 144.73, 64, 31);
INSERT INTO public.europe_data VALUES (6148, 0, 0, 0, 65, 31);
INSERT INTO public.europe_data VALUES (6149, 27, 1491, 80.85, 154, 31);
INSERT INTO public.europe_data VALUES (6150, 0, 124, 11.89, 4, 31);
INSERT INTO public.europe_data VALUES (6151, 7233, 261626, 246.64, 66, 31);
INSERT INTO public.europe_data VALUES (6152, 0, 0, 0, 67, 31);
INSERT INTO public.europe_data VALUES (6153, 0, 0, 0, 109, 31);
INSERT INTO public.europe_data VALUES (6154, 22, 1512, 36.59, 155, 31);
INSERT INTO public.europe_data VALUES (6155, 0, 49, 0.38, 5, 31);
INSERT INTO public.europe_data VALUES (6156, 0, 59, 0.69, 6, 31);
INSERT INTO public.europe_data VALUES (6157, 0, 15, 0.09, 110, 31);
INSERT INTO public.europe_data VALUES (6158, 31, 1462, 9.97, 7, 31);
INSERT INTO public.europe_data VALUES (6159, 99, 2055, 11.6, 68, 31);
INSERT INTO public.europe_data VALUES (6160, 2, 247, 98.74, 8, 31);
INSERT INTO public.europe_data VALUES (6161, 0, 0, 7.7, 69, 31);
INSERT INTO public.europe_data VALUES (6162, 5, 319, 18.1, 9, 31);
INSERT INTO public.europe_data VALUES (6163, 1, 8, 0.09, 10, 31);
INSERT INTO public.europe_data VALUES (6164, 671, 19509, 227.2, 70, 31);
INSERT INTO public.europe_data VALUES (6165, 0, 246, 0.03, 111, 31);
INSERT INTO public.europe_data VALUES (6166, 1243, 33335, 116.56, 71, 31);
INSERT INTO public.europe_data VALUES (6167, 0, 6, 5.29, 11, 31);
INSERT INTO public.europe_data VALUES (6168, 3, 546, 15.95, 12, 31);
INSERT INTO public.europe_data VALUES (6169, 11, 2600, 88.48, 72, 31);
INSERT INTO public.europe_data VALUES (6170, 10, 1994, 14.86, 13, 31);
INSERT INTO public.europe_data VALUES (6171, 6, 571, 25.29, 156, 31);
INSERT INTO public.europe_data VALUES (6172, 1, 54, 0.83, 73, 31);
INSERT INTO public.europe_data VALUES (6173, 0, 0, 0.61, 74, 31);
INSERT INTO public.europe_data VALUES (6174, 0, 18, 3.08, 157, 31);
INSERT INTO public.europe_data VALUES (6175, 4, 659, 14.75, 158, 31);
INSERT INTO public.europe_data VALUES (6176, 7, 622, 1.39, 14, 31);
INSERT INTO public.europe_data VALUES (6177, 3, 114, 4.67, 159, 31);
INSERT INTO public.europe_data VALUES (6178, 1, 180, 33.79, 15, 31);
INSERT INTO public.europe_data VALUES (6179, 0, 0, 0, 75, 31);
INSERT INTO public.europe_data VALUES (6180, 103, 7107, 122.54, 76, 31);
INSERT INTO public.europe_data VALUES (6181, 266, 5912, 72.61, 77, 31);
INSERT INTO public.europe_data VALUES (6182, 515, 6817, 16.82, 16, 31);
INSERT INTO public.europe_data VALUES (6183, 50, 1897, 57.95, 78, 31);
INSERT INTO public.europe_data VALUES (6184, 0, 0, 78.91, 17, 31);
INSERT INTO public.europe_data VALUES (6185, 0, 17, 1.17, 18, 31);
INSERT INTO public.europe_data VALUES (6186, 0, 21, 2.04, 160, 31);
INSERT INTO public.europe_data VALUES (6187, 7, 363, 49.65, 19, 31);
INSERT INTO public.europe_data VALUES (6188, 24, 1714, 1.67, 20, 31);
INSERT INTO public.europe_data VALUES (6189, 0, 0, 0, 79, 31);
INSERT INTO public.europe_data VALUES (6190, 0, 1, 2.05, 161, 31);
INSERT INTO public.europe_data VALUES (6191, 0, 8, 0.9, 203, 31);
INSERT INTO public.europe_data VALUES (6192, 0, 20, 1.83, 162, 31);
INSERT INTO public.europe_data VALUES (6193, 111, 3792, 11.66, 163, 31);
INSERT INTO public.europe_data VALUES (6194, 0, 0, 0, 204, 31);
INSERT INTO public.europe_data VALUES (6195, 2, 322, 33.74, 21, 31);
INSERT INTO public.europe_data VALUES (6196, 1, 7, 0.81, 22, 31);
INSERT INTO public.europe_data VALUES (6197, 0, 42, 1.73, 164, 31);
INSERT INTO public.europe_data VALUES (6198, 48, 2409, 6.27, 165, 31);
INSERT INTO public.europe_data VALUES (6199, 17, 4433, 23.56, 23, 31);
INSERT INTO public.europe_data VALUES (6200, 0, 2, 8.9, 166, 31);
INSERT INTO public.europe_data VALUES (6201, 1, 284, 3.98, 167, 31);
INSERT INTO public.europe_data VALUES (6202, 0, 0, 0, 80, 31);
INSERT INTO public.europe_data VALUES (6203, 0, 0, 0, 81, 31);
INSERT INTO public.europe_data VALUES (6204, 0, 11, 35.27, 205, 31);
INSERT INTO public.europe_data VALUES (6205, 272, 6107, 70.67, 82, 31);
INSERT INTO public.europe_data VALUES (6206, 0, 0, 0, 168, 31);
INSERT INTO public.europe_data VALUES (6207, 3, 531, 6.26, 24, 31);
INSERT INTO public.europe_data VALUES (6208, 0, 77, 11.87, 25, 31);
INSERT INTO public.europe_data VALUES (6209, 2, 24, 8.56, 83, 31);
INSERT INTO public.europe_data VALUES (6210, 26, 394, 7.81, 84, 31);
INSERT INTO public.europe_data VALUES (6211, 0, 0, 0, 169, 31);
INSERT INTO public.europe_data VALUES (6212, 135, 4147, 102.69, 85, 31);
INSERT INTO public.europe_data VALUES (6213, 6, 51, 0.94, 170, 31);
INSERT INTO public.europe_data VALUES (6214, 0, 3, 3.36, 171, 31);
INSERT INTO public.europe_data VALUES (6215, 3481, 180841, 24.15, 112, 31);
INSERT INTO public.europe_data VALUES (6216, 435, 11950, 8.01, 113, 31);
INSERT INTO public.europe_data VALUES (6217, 1258, 16865, 41.77, 114, 31);
INSERT INTO public.europe_data VALUES (6218, 677, 17027, 81.67, 115, 31);
INSERT INTO public.europe_data VALUES (6219, 5, 101, 3.85, 172, 31);
INSERT INTO public.europe_data VALUES (6220, 0, 0, 0, 173, 31);
INSERT INTO public.europe_data VALUES (6221, 31, 8712, 175.07, 116, 31);
INSERT INTO public.europe_data VALUES (6222, 93, 1450, 4.56, 174, 31);
INSERT INTO public.europe_data VALUES (6223, 0, 26, 2.1, 86, 31);
INSERT INTO public.europe_data VALUES (6224, 5, 2093, 2.67, 117, 31);
INSERT INTO public.europe_data VALUES (6225, 0, 5, 5.57, 175, 31);
INSERT INTO public.europe_data VALUES (6226, 0, 15, 0.57, 118, 31);
INSERT INTO public.europe_data VALUES (6227, 187, 11315, 207.87, 119, 31);
INSERT INTO public.europe_data VALUES (6228, 25, 2219, 7.67, 26, 31);
INSERT INTO public.europe_data VALUES (6229, 36, 1575, 125.33, 176, 31);
INSERT INTO public.europe_data VALUES (6230, 22, 4953, 236.55, 120, 31);
INSERT INTO public.europe_data VALUES (6231, 55, 3426, 95.08, 121, 31);
INSERT INTO public.europe_data VALUES (6232, 0, 0, 0, 122, 31);
INSERT INTO public.europe_data VALUES (6233, 0, 49, 2.97, 177, 31);
INSERT INTO public.europe_data VALUES (6234, 0, 461, 8.66, 123, 31);
INSERT INTO public.europe_data VALUES (6235, 2, 154, 9.69, 27, 31);
INSERT INTO public.europe_data VALUES (6236, 14, 136, 4.9, 28, 31);
INSERT INTO public.europe_data VALUES (6237, 12, 444, 9.9, 29, 31);
INSERT INTO public.europe_data VALUES (6238, 0, 1, 5.21, 178, 31);
INSERT INTO public.europe_data VALUES (6239, 0, 33, 1.9, 179, 31);
INSERT INTO public.europe_data VALUES (6240, 1, 403, 111.26, 180, 31);
INSERT INTO public.europe_data VALUES (6241, 6, 2139, 10.34, 30, 31);
INSERT INTO public.europe_data VALUES (6242, 19, 622, 6.54, 31, 31);
INSERT INTO public.europe_data VALUES (6243, 1, 60, 0.26, 124, 31);
INSERT INTO public.europe_data VALUES (6244, 2, 263, 76.84, 125, 31);
INSERT INTO public.europe_data VALUES (6245, 2, 81, 1.34, 32, 31);
INSERT INTO public.europe_data VALUES (6246, 0, 2, 0.81, 181, 31);
INSERT INTO public.europe_data VALUES (6247, 14, 247, 26.94, 33, 31);
INSERT INTO public.europe_data VALUES (6248, 0, 1, 0.08, 34, 31);
INSERT INTO public.europe_data VALUES (6249, 4367, 44253, 68.19, 87, 31);
INSERT INTO public.europe_data VALUES (6250, 57, 1568, 77.46, 182, 31);
INSERT INTO public.europe_data VALUES (6251, 0, 1, 18.14, 183, 31);
INSERT INTO public.europe_data VALUES (6252, 0, 10, 0.31, 126, 31);
INSERT INTO public.europe_data VALUES (6253, 9, 440, 118.94, 184, 31);
INSERT INTO public.europe_data VALUES (6254, 0, 1, 20.04, 88, 31);
INSERT INTO public.europe_data VALUES (6255, 15, 1530, 10.13, 35, 31);
INSERT INTO public.europe_data VALUES (6256, 1, 170, 0.98, 36, 31);
INSERT INTO public.europe_data VALUES (6257, 0, 18, 0.06, 127, 31);
INSERT INTO public.europe_data VALUES (6258, 1, 373, 24.13, 37, 31);
INSERT INTO public.europe_data VALUES (6259, 4, 1017, 14.08, 128, 31);
INSERT INTO public.europe_data VALUES (6260, 8, 401, 5.06, 185, 31);
INSERT INTO public.europe_data VALUES (6261, 0, 0, 0, 208, 31);
INSERT INTO public.europe_data VALUES (6262, 0, 11, 0.33, 209, 31);
INSERT INTO public.europe_data VALUES (6263, 8, 327, 10.33, 89, 31);
INSERT INTO public.europe_data VALUES (6264, 0, 6, 0.11, 38, 31);
INSERT INTO public.europe_data VALUES (6265, 95, 3847, 3.98, 39, 31);
INSERT INTO public.europe_data VALUES (6266, 41, 1065, 97.2, 186, 31);
INSERT INTO public.europe_data VALUES (6267, 0, 2, 5.24, 210, 31);
INSERT INTO public.europe_data VALUES (6268, 1, 70, 2.82, 187, 31);
INSERT INTO public.europe_data VALUES (6269, 44, 9837, 359.1, 129, 31);
INSERT INTO public.europe_data VALUES (6270, 504, 19807, 20.83, 130, 31);
INSERT INTO public.europe_data VALUES (6271, 17, 2580, 96.16, 131, 31);
INSERT INTO public.europe_data VALUES (6272, 162, 7484, 328.44, 90, 31);
INSERT INTO public.europe_data VALUES (6273, 0, 0, 0, 211, 31);
INSERT INTO public.europe_data VALUES (6274, 2, 521, 11.65, 91, 31);
INSERT INTO public.europe_data VALUES (6275, 1281, 23608, 144.28, 92, 31);
INSERT INTO public.europe_data VALUES (6276, 244, 14429, 19.24, 132, 31);
INSERT INTO public.europe_data VALUES (6277, 54, 1941, 10.49, 188, 31);
INSERT INTO public.europe_data VALUES (6278, 46, 2615, 47.35, 189, 31);
INSERT INTO public.europe_data VALUES (6279, 12, 1905, 89.73, 93, 31);
INSERT INTO public.europe_data VALUES (6280, 19, 3799, 324.32, 133, 31);
INSERT INTO public.europe_data VALUES (6281, 134, 3562, 32.05, 190, 31);
INSERT INTO public.europe_data VALUES (6282, 1174, 45911, 63.57, 191, 31);
INSERT INTO public.europe_data VALUES (6283, 1, 232, 3.46, 40, 31);
INSERT INTO public.europe_data VALUES (6284, 0, 1, 3.79, 94, 31);
INSERT INTO public.europe_data VALUES (6285, 0, 0, 1.64, 95, 31);
INSERT INTO public.europe_data VALUES (6286, 0, 6, 5.43, 96, 31);
INSERT INTO public.europe_data VALUES (6287, 0, 1, 2.9, 192, 31);
INSERT INTO public.europe_data VALUES (6288, 1, 9, 7.44, 41, 31);
INSERT INTO public.europe_data VALUES (6289, 307, 22750, 145.22, 134, 31);
INSERT INTO public.europe_data VALUES (6290, 15, 735, 9.51, 42, 31);
INSERT INTO public.europe_data VALUES (6291, 82, 2229, 61.95, 193, 31);
INSERT INTO public.europe_data VALUES (6292, 0, 89, 91.06, 43, 31);
INSERT INTO public.europe_data VALUES (6293, 1, 93, 2.66, 44, 31);
INSERT INTO public.europe_data VALUES (6294, 0, 1297, 43.11, 135, 31);
INSERT INTO public.europe_data VALUES (6295, 0, 0, 2.36, 97, 31);
INSERT INTO public.europe_data VALUES (6296, 0, 137, 4.35, 194, 31);
INSERT INTO public.europe_data VALUES (6297, 0, 141, 12.49, 195, 31);
INSERT INTO public.europe_data VALUES (6298, 1, 62, 1.07, 45, 31);
INSERT INTO public.europe_data VALUES (6299, 880, 79492, 235.85, 46, 31);
INSERT INTO public.europe_data VALUES (6300, 6, 388, 1.41, 136, 31);
INSERT INTO public.europe_data VALUES (6301, 3, 103, 1.36, 47, 31);
INSERT INTO public.europe_data VALUES (6302, 18, 4164, 14.88, 196, 31);
INSERT INTO public.europe_data VALUES (6303, 0, 541, 2.72, 137, 31);
INSERT INTO public.europe_data VALUES (6304, 42, 483, 2.32, 48, 31);
INSERT INTO public.europe_data VALUES (6305, 4, 147, 43.17, 98, 31);
INSERT INTO public.europe_data VALUES (6306, 84, 2179, 63.1, 197, 31);
INSERT INTO public.europe_data VALUES (6307, 0, 614, 14.79, 198, 31);
INSERT INTO public.europe_data VALUES (6308, 3, 36, 0.81, 138, 31);
INSERT INTO public.europe_data VALUES (6309, 0, 2, 0.02, 139, 31);
INSERT INTO public.europe_data VALUES (6310, 2, 339, 7.54, 140, 31);
INSERT INTO public.europe_data VALUES (6311, 0, 25, 0.08, 141, 31);
INSERT INTO public.europe_data VALUES (6312, 0, 0, 0, 142, 31);
INSERT INTO public.europe_data VALUES (6313, 0, 40, 0.97, 49, 31);
INSERT INTO public.europe_data VALUES (6314, 0, 0, 0.5, 99, 31);
INSERT INTO public.europe_data VALUES (6315, 0, 75, 0.8, 50, 31);
INSERT INTO public.europe_data VALUES (6316, 138, 7235, 19.21, 199, 31);
INSERT INTO public.europe_data VALUES (6317, 0, 25, 115.2, 100, 31);
INSERT INTO public.europe_data VALUES (6318, 0, 86, 0.37, 51, 31);
INSERT INTO public.europe_data VALUES (6319, 134, 5021, 23.96, 200, 31);
INSERT INTO public.europe_data VALUES (6320, 10, 3314, 72.23, 143, 31);
INSERT INTO public.europe_data VALUES (6321, 213, 4271, 12.45, 201, 31);
INSERT INTO public.europe_data VALUES (6322, 0, 0, 0, 52, 31);
INSERT INTO public.europe_data VALUES (6323, 5258, 416307, 229.73, 101, 31);
INSERT INTO public.europe_data VALUES (6324, 0, 69, 95.62, 102, 31);
INSERT INTO public.europe_data VALUES (6325, 3, 31, 1.68, 103, 31);
INSERT INTO public.europe_data VALUES (6326, 26, 3050, 15.65, 144, 31);
INSERT INTO public.europe_data VALUES (6327, 25, 2296, 14.62, 104, 31);
INSERT INTO public.europe_data VALUES (6328, 0, 17, 0.02, 145, 31);
INSERT INTO public.europe_data VALUES (6329, 0, 0, 53.39, 53, 31);
INSERT INTO public.europe_data VALUES (6330, 79, 200, 1.19, 146, 31);
INSERT INTO public.europe_data VALUES (6331, 12, 263, 1.89, 54, 31);
INSERT INTO public.europe_data VALUES (6332, 10, 269, 2.85, 55, 31);
INSERT INTO public.europe_data VALUES (6333, 143, 1984, 10.82, 105, 32);
INSERT INTO public.europe_data VALUES (6334, 21, 491, 33.75, 147, 32);
INSERT INTO public.europe_data VALUES (6335, 55, 2668, 9.69, 1, 32);
INSERT INTO public.europe_data VALUES (6336, 0, 0, 0, 148, 32);
INSERT INTO public.europe_data VALUES (6337, 8, 79, 0.53, 2, 32);
INSERT INTO public.europe_data VALUES (6338, 0, 0, 0, 56, 32);
INSERT INTO public.europe_data VALUES (6339, 0, 3, 43.25, 57, 32);
INSERT INTO public.europe_data VALUES (6340, 273, 17632, 72.78, 58, 32);
INSERT INTO public.europe_data VALUES (6341, 58, 3809, 282.24, 149, 32);
INSERT INTO public.europe_data VALUES (6342, 0, 4, 3.76, 59, 32);
INSERT INTO public.europe_data VALUES (6343, 0, 763, 3.92, 202, 32);
INSERT INTO public.europe_data VALUES (6344, 4, 644, 11.11, 150, 32);
INSERT INTO public.europe_data VALUES (6345, 52, 3900, 75.59, 151, 32);
INSERT INTO public.europe_data VALUES (6346, 0, 0, 0, 60, 32);
INSERT INTO public.europe_data VALUES (6347, 14, 3662, 463.27, 106, 32);
INSERT INTO public.europe_data VALUES (6348, 314, 24630, 30.73, 107, 32);
INSERT INTO public.europe_data VALUES (6349, 0, 1, 0.35, 61, 32);
INSERT INTO public.europe_data VALUES (6350, 40, 2079, 53.41, 152, 32);
INSERT INTO public.europe_data VALUES (6351, 25, 637, 10.86, 153, 32);
INSERT INTO public.europe_data VALUES (6352, 0, 6, 2.05, 62, 32);
INSERT INTO public.europe_data VALUES (6353, 5, 50, 3.68, 3, 32);
INSERT INTO public.europe_data VALUES (6354, 0, 0, 0, 63, 32);
INSERT INTO public.europe_data VALUES (6355, 0, 4, 1.57, 108, 32);
INSERT INTO public.europe_data VALUES (6356, 420, 7773, 129.5, 64, 32);
INSERT INTO public.europe_data VALUES (6357, 0, 0, 0, 65, 32);
INSERT INTO public.europe_data VALUES (6358, 11, 1178, 59.44, 154, 32);
INSERT INTO public.europe_data VALUES (6359, 0, 150, 8.07, 4, 32);
INSERT INTO public.europe_data VALUES (6360, 7245, 258912, 245.45, 66, 32);
INSERT INTO public.europe_data VALUES (6361, 0, 0, 0, 67, 32);
INSERT INTO public.europe_data VALUES (6362, 0, 0, 0, 109, 32);
INSERT INTO public.europe_data VALUES (6363, 27, 1049, 26.21, 155, 32);
INSERT INTO public.europe_data VALUES (6364, 0, 28, 0.41, 5, 32);
INSERT INTO public.europe_data VALUES (6365, 0, 21, 0.41, 6, 32);
INSERT INTO public.europe_data VALUES (6366, 0, 0, 0.07, 110, 32);
INSERT INTO public.europe_data VALUES (6367, 15, 1119, 8.12, 7, 32);
INSERT INTO public.europe_data VALUES (6368, 162, 2285, 11.22, 68, 32);
INSERT INTO public.europe_data VALUES (6369, 5, 296, 102.01, 8, 32);
INSERT INTO public.europe_data VALUES (6370, 0, 5, 9.24, 69, 32);
INSERT INTO public.europe_data VALUES (6371, 3, 540, 24.47, 9, 32);
INSERT INTO public.europe_data VALUES (6372, 0, 6, 0.09, 10, 32);
INSERT INTO public.europe_data VALUES (6373, 799, 23550, 280.59, 70, 32);
INSERT INTO public.europe_data VALUES (6374, 0, 114, 0.02, 111, 32);
INSERT INTO public.europe_data VALUES (6375, 958, 25341, 96.26, 71, 32);
INSERT INTO public.europe_data VALUES (6376, 0, 39, 7.52, 11, 32);
INSERT INTO public.europe_data VALUES (6377, 4, 312, 10.11, 12, 32);
INSERT INTO public.europe_data VALUES (6378, 4, 1866, 55.14, 72, 32);
INSERT INTO public.europe_data VALUES (6379, 8, 1828, 12.75, 13, 32);
INSERT INTO public.europe_data VALUES (6380, 6, 460, 20.46, 156, 32);
INSERT INTO public.europe_data VALUES (6381, 0, 40, 0.53, 73, 32);
INSERT INTO public.europe_data VALUES (6382, 0, 1, 1.22, 74, 32);
INSERT INTO public.europe_data VALUES (6383, 0, 9, 1.94, 157, 32);
INSERT INTO public.europe_data VALUES (6384, 0, 912, 18.94, 158, 32);
INSERT INTO public.europe_data VALUES (6385, 24, 584, 1.83, 14, 32);
INSERT INTO public.europe_data VALUES (6386, 2, 157, 7.6, 159, 32);
INSERT INTO public.europe_data VALUES (6387, 3, 149, 21.57, 15, 32);
INSERT INTO public.europe_data VALUES (6388, 0, 0, 0, 75, 32);
INSERT INTO public.europe_data VALUES (6389, 68, 6052, 100.08, 76, 32);
INSERT INTO public.europe_data VALUES (6390, 352, 6703, 65.14, 77, 32);
INSERT INTO public.europe_data VALUES (6391, 554, 10065, 19.94, 16, 32);
INSERT INTO public.europe_data VALUES (6392, 53, 1843, 48.83, 78, 32);
INSERT INTO public.europe_data VALUES (6393, 19, 1070, 103.76, 17, 32);
INSERT INTO public.europe_data VALUES (6394, 0, 24, 2.06, 18, 32);
INSERT INTO public.europe_data VALUES (6395, 0, 6, 0.91, 160, 32);
INSERT INTO public.europe_data VALUES (6396, 2, 207, 30.75, 19, 32);
INSERT INTO public.europe_data VALUES (6397, 5, 157, 1.17, 20, 32);
INSERT INTO public.europe_data VALUES (6398, 0, 0, 0, 79, 32);
INSERT INTO public.europe_data VALUES (6399, 0, 0, 0, 161, 32);
INSERT INTO public.europe_data VALUES (6400, 0, 0, 0, 203, 32);
INSERT INTO public.europe_data VALUES (6401, 0, 81, 2.34, 162, 32);
INSERT INTO public.europe_data VALUES (6402, 115, 4024, 9.82, 163, 32);
INSERT INTO public.europe_data VALUES (6403, 0, 0, 0.72, 204, 32);
INSERT INTO public.europe_data VALUES (6404, 4, 411, 54.87, 21, 32);
INSERT INTO public.europe_data VALUES (6405, 0, 12, 0.85, 22, 32);
INSERT INTO public.europe_data VALUES (6406, 0, 27, 1.13, 164, 32);
INSERT INTO public.europe_data VALUES (6407, 55, 2793, 7.46, 165, 32);
INSERT INTO public.europe_data VALUES (6408, 10, 2734, 19.5, 23, 32);
INSERT INTO public.europe_data VALUES (6409, 0, 1, 5.93, 166, 32);
INSERT INTO public.europe_data VALUES (6410, 1, 143, 2.36, 167, 32);
INSERT INTO public.europe_data VALUES (6411, 0, 0, 0, 80, 32);
INSERT INTO public.europe_data VALUES (6412, 0, 0, 0, 81, 32);
INSERT INTO public.europe_data VALUES (6413, 0, 48, 47.22, 205, 32);
INSERT INTO public.europe_data VALUES (6414, 220, 6318, 57.46, 82, 32);
INSERT INTO public.europe_data VALUES (6415, 0, 0, 0, 168, 32);
INSERT INTO public.europe_data VALUES (6416, 3, 268, 4.87, 24, 32);
INSERT INTO public.europe_data VALUES (6417, 4, 151, 11.66, 25, 32);
INSERT INTO public.europe_data VALUES (6418, 3, 43, 11.37, 83, 32);
INSERT INTO public.europe_data VALUES (6419, 9, 486, 9.96, 84, 32);
INSERT INTO public.europe_data VALUES (6420, 0, 0, 0, 169, 32);
INSERT INTO public.europe_data VALUES (6421, 160, 5861, 114.65, 85, 32);
INSERT INTO public.europe_data VALUES (6422, 8, 41, 0.83, 170, 32);
INSERT INTO public.europe_data VALUES (6423, 0, 9, 4.2, 171, 32);
INSERT INTO public.europe_data VALUES (6424, 3218, 149095, 19.92, 112, 32);
INSERT INTO public.europe_data VALUES (6425, 417, 9739, 6.6, 113, 32);
INSERT INTO public.europe_data VALUES (6426, 1063, 17769, 42.8, 114, 32);
INSERT INTO public.europe_data VALUES (6427, 717, 15077, 75.33, 115, 32);
INSERT INTO public.europe_data VALUES (6428, 6, 88, 3.02, 172, 32);
INSERT INTO public.europe_data VALUES (6429, 0, 0, 0, 173, 32);
INSERT INTO public.europe_data VALUES (6430, 13, 6203, 107.75, 116, 32);
INSERT INTO public.europe_data VALUES (6431, 123, 1301, 5.16, 174, 32);
INSERT INTO public.europe_data VALUES (6432, 0, 36, 2.48, 86, 32);
INSERT INTO public.europe_data VALUES (6433, 5, 1299, 1.47, 117, 32);
INSERT INTO public.europe_data VALUES (6434, 0, 1, 1.86, 175, 32);
INSERT INTO public.europe_data VALUES (6435, 1, 43, 1.3, 118, 32);
INSERT INTO public.europe_data VALUES (6436, 5, 27247, 166.25, 119, 32);
INSERT INTO public.europe_data VALUES (6437, 17, 1816, 5.99, 26, 32);
INSERT INTO public.europe_data VALUES (6438, 17, 679, 66, 176, 32);
INSERT INTO public.europe_data VALUES (6439, 20, 4999, 244.61, 120, 32);
INSERT INTO public.europe_data VALUES (6440, 42, 2674, 67.57, 121, 32);
INSERT INTO public.europe_data VALUES (6441, 0, 0, 0, 122, 32);
INSERT INTO public.europe_data VALUES (6442, 0, 8, 0.68, 177, 32);
INSERT INTO public.europe_data VALUES (6443, 2, 133, 4.17, 123, 32);
INSERT INTO public.europe_data VALUES (6444, 0, 52, 3.53, 27, 32);
INSERT INTO public.europe_data VALUES (6445, 3, 106, 5.02, 28, 32);
INSERT INTO public.europe_data VALUES (6446, 6, 227, 6.57, 29, 32);
INSERT INTO public.europe_data VALUES (6447, 0, 1, 2.61, 178, 32);
INSERT INTO public.europe_data VALUES (6448, 1, 20, 1.36, 179, 32);
INSERT INTO public.europe_data VALUES (6449, 0, 280, 65.48, 180, 32);
INSERT INTO public.europe_data VALUES (6450, 11, 650, 4.2, 30, 32);
INSERT INTO public.europe_data VALUES (6451, 6, 596, 5.43, 31, 32);
INSERT INTO public.europe_data VALUES (6452, 0, 24, 0.27, 124, 32);
INSERT INTO public.europe_data VALUES (6453, 3, 145, 49.91, 125, 32);
INSERT INTO public.europe_data VALUES (6454, 5, 183, 1.88, 32, 32);
INSERT INTO public.europe_data VALUES (6455, 0, 2, 1.42, 181, 32);
INSERT INTO public.europe_data VALUES (6456, 10, 972, 45.65, 33, 32);
INSERT INTO public.europe_data VALUES (6457, 0, 0, 0.32, 34, 32);
INSERT INTO public.europe_data VALUES (6458, 3991, 42740, 64.01, 87, 32);
INSERT INTO public.europe_data VALUES (6459, 55, 1564, 89.38, 182, 32);
INSERT INTO public.europe_data VALUES (6460, 0, 5, 21.16, 183, 32);
INSERT INTO public.europe_data VALUES (6461, 0, 0, 0.22, 126, 32);
INSERT INTO public.europe_data VALUES (6462, 3, 300, 67.34, 184, 32);
INSERT INTO public.europe_data VALUES (6463, 0, 0, 0, 88, 32);
INSERT INTO public.europe_data VALUES (6464, 14, 2163, 11.62, 35, 32);
INSERT INTO public.europe_data VALUES (6465, 3, 128, 0.84, 36, 32);
INSERT INTO public.europe_data VALUES (6466, 0, 14, 0.04, 127, 32);
INSERT INTO public.europe_data VALUES (6467, 0, 229, 14.31, 37, 32);
INSERT INTO public.europe_data VALUES (6468, 6, 3012, 23.62, 128, 32);
INSERT INTO public.europe_data VALUES (6469, 22, 474, 5.95, 185, 32);
INSERT INTO public.europe_data VALUES (6470, 0, 0, 0, 208, 32);
INSERT INTO public.europe_data VALUES (6471, 0, 5, 0.42, 209, 32);
INSERT INTO public.europe_data VALUES (6472, 9, 349, 7.72, 89, 32);
INSERT INTO public.europe_data VALUES (6473, 1, 19, 0.24, 38, 32);
INSERT INTO public.europe_data VALUES (6474, 80, 4144, 4.21, 39, 32);
INSERT INTO public.europe_data VALUES (6475, 55, 954, 93.4, 186, 32);
INSERT INTO public.europe_data VALUES (6476, 0, 1, 1.75, 210, 32);
INSERT INTO public.europe_data VALUES (6477, 2, 80, 3.51, 187, 32);
INSERT INTO public.europe_data VALUES (6478, 50, 8028, 335.82, 129, 32);
INSERT INTO public.europe_data VALUES (6479, 595, 25306, 23.42, 130, 32);
INSERT INTO public.europe_data VALUES (6480, 13, 2210, 68.98, 131, 32);
INSERT INTO public.europe_data VALUES (6481, 143, 6463, 285.39, 90, 32);
INSERT INTO public.europe_data VALUES (6482, 0, 0, 0.02, 211, 32);
INSERT INTO public.europe_data VALUES (6483, 5, 300, 14.88, 91, 32);
INSERT INTO public.europe_data VALUES (6484, 1272, 23299, 146.97, 92, 32);
INSERT INTO public.europe_data VALUES (6485, 46, 6375, 10.89, 132, 32);
INSERT INTO public.europe_data VALUES (6486, 79, 2043, 10.58, 188, 32);
INSERT INTO public.europe_data VALUES (6487, 50, 2251, 46.36, 189, 32);
INSERT INTO public.europe_data VALUES (6488, 2, 727, 47.42, 93, 32);
INSERT INTO public.europe_data VALUES (6489, 18, 5386, 438.9, 133, 32);
INSERT INTO public.europe_data VALUES (6490, 138, 2660, 25.38, 190, 32);
INSERT INTO public.europe_data VALUES (6491, 1088, 46814, 66.2, 191, 32);
INSERT INTO public.europe_data VALUES (6492, 1, 205, 2.99, 40, 32);
INSERT INTO public.europe_data VALUES (6493, 0, 1, 1.89, 94, 32);
INSERT INTO public.europe_data VALUES (6494, 0, 3, 1.64, 95, 32);
INSERT INTO public.europe_data VALUES (6495, 0, 0, 0, 96, 32);
INSERT INTO public.europe_data VALUES (6496, 0, 0, 5.81, 192, 32);
INSERT INTO public.europe_data VALUES (6497, 0, 7, 10.23, 41, 32);
INSERT INTO public.europe_data VALUES (6498, 365, 27016, 151.44, 134, 32);
INSERT INTO public.europe_data VALUES (6499, 28, 814, 9.28, 42, 32);
INSERT INTO public.europe_data VALUES (6500, 41, 2085, 46.48, 193, 32);
INSERT INTO public.europe_data VALUES (6501, 0, 0, 0, 43, 32);
INSERT INTO public.europe_data VALUES (6502, 2, 115, 2.75, 44, 32);
INSERT INTO public.europe_data VALUES (6503, 0, 1205, 44.26, 135, 32);
INSERT INTO public.europe_data VALUES (6504, 0, 1, 2.36, 97, 32);
INSERT INTO public.europe_data VALUES (6505, 0, 100, 3.25, 194, 32);
INSERT INTO public.europe_data VALUES (6506, 0, 119, 8.65, 195, 32);
INSERT INTO public.europe_data VALUES (6507, 2, 103, 1.41, 45, 32);
INSERT INTO public.europe_data VALUES (6508, 743, 58616, 169.83, 46, 32);
INSERT INTO public.europe_data VALUES (6509, 1, 334, 1.27, 136, 32);
INSERT INTO public.europe_data VALUES (6510, 2, 47, 1.39, 47, 32);
INSERT INTO public.europe_data VALUES (6511, 42, 2819, 11.26, 196, 32);
INSERT INTO public.europe_data VALUES (6512, 0, 39, 0.59, 137, 32);
INSERT INTO public.europe_data VALUES (6513, 36, 509, 2.77, 48, 32);
INSERT INTO public.europe_data VALUES (6514, 3, 104, 48.16, 98, 32);
INSERT INTO public.europe_data VALUES (6515, 98, 4276, 114.71, 197, 32);
INSERT INTO public.europe_data VALUES (6516, 4, 650, 11.41, 198, 32);
INSERT INTO public.europe_data VALUES (6517, 4, 102, 0.9, 138, 32);
INSERT INTO public.europe_data VALUES (6518, 0, 2, 0.01, 139, 32);
INSERT INTO public.europe_data VALUES (6519, 1, 364, 8.11, 140, 32);
INSERT INTO public.europe_data VALUES (6520, 0, 33, 0.07, 141, 32);
INSERT INTO public.europe_data VALUES (6521, 0, 0, 0, 142, 32);
INSERT INTO public.europe_data VALUES (6522, 1, 38, 1.37, 49, 32);
INSERT INTO public.europe_data VALUES (6523, 0, 7, 0.72, 99, 32);
INSERT INTO public.europe_data VALUES (6524, 0, 19, 0.27, 50, 32);
INSERT INTO public.europe_data VALUES (6525, 128, 8519, 22.04, 199, 32);
INSERT INTO public.europe_data VALUES (6526, 1, 19, 86.4, 100, 32);
INSERT INTO public.europe_data VALUES (6527, 0, 80, 0.38, 51, 32);
INSERT INTO public.europe_data VALUES (6528, 120, 5518, 27.14, 200, 32);
INSERT INTO public.europe_data VALUES (6529, 10, 3743, 67.7, 143, 32);
INSERT INTO public.europe_data VALUES (6530, 312, 4026, 13.9, 201, 32);
INSERT INTO public.europe_data VALUES (6531, 0, 0, 0, 52, 32);
INSERT INTO public.europe_data VALUES (6532, 4143, 339639, 184.68, 101, 32);
INSERT INTO public.europe_data VALUES (6533, 0, 31, 34.42, 102, 32);
INSERT INTO public.europe_data VALUES (6534, 1, 27, 2.31, 103, 32);
INSERT INTO public.europe_data VALUES (6535, 13, 2112, 11.48, 144, 32);
INSERT INTO public.europe_data VALUES (6536, 20, 1872, 11.4, 104, 32);
INSERT INTO public.europe_data VALUES (6537, 0, 0, 0.01, 145, 32);
INSERT INTO public.europe_data VALUES (6538, 0, 311, 84.81, 53, 32);
INSERT INTO public.europe_data VALUES (6539, 36, 147, 1.11, 146, 32);
INSERT INTO public.europe_data VALUES (6540, 8, 75, 1.13, 54, 32);
INSERT INTO public.europe_data VALUES (6541, 2, 149, 1.55, 55, 32);
INSERT INTO public.europe_data VALUES (6542, 140, 2134, 16.3, 105, 33);
INSERT INTO public.europe_data VALUES (6543, 11, 475, 30.78, 147, 33);
INSERT INTO public.europe_data VALUES (6544, 52, 1502, 5.47, 1, 33);
INSERT INTO public.europe_data VALUES (6545, 0, 0, 2.63, 148, 33);
INSERT INTO public.europe_data VALUES (6546, 2, 91, 0.4, 2, 33);
INSERT INTO public.europe_data VALUES (6547, 0, 0, 0, 56, 33);
INSERT INTO public.europe_data VALUES (6548, 0, 39, 40.16, 57, 33);
INSERT INTO public.europe_data VALUES (6549, 206, 14959, 58.43, 58, 33);
INSERT INTO public.europe_data VALUES (6550, 73, 4539, 272.61, 149, 33);
INSERT INTO public.europe_data VALUES (6551, 0, 0, 0, 59, 33);
INSERT INTO public.europe_data VALUES (6552, 2, 225, 1.45, 202, 33);
INSERT INTO public.europe_data VALUES (6553, 12, 340, 6.63, 150, 33);
INSERT INTO public.europe_data VALUES (6554, 44, 3695, 64.36, 151, 33);
INSERT INTO public.europe_data VALUES (6555, 0, 0, 0.26, 60, 33);
INSERT INTO public.europe_data VALUES (6556, 20, 3941, 436.34, 106, 33);
INSERT INTO public.europe_data VALUES (6557, 274, 25481, 30.83, 107, 33);
INSERT INTO public.europe_data VALUES (6558, 0, 0, 0.35, 61, 33);
INSERT INTO public.europe_data VALUES (6559, 37, 2970, 79.37, 152, 33);
INSERT INTO public.europe_data VALUES (6560, 39, 607, 11.13, 153, 33);
INSERT INTO public.europe_data VALUES (6561, 0, 2, 0.77, 62, 33);
INSERT INTO public.europe_data VALUES (6562, 3, 384, 5.75, 3, 33);
INSERT INTO public.europe_data VALUES (6563, 0, 0, 3.2, 63, 33);
INSERT INTO public.europe_data VALUES (6564, 0, 8, 1.31, 108, 33);
INSERT INTO public.europe_data VALUES (6565, 241, 7136, 113.48, 64, 33);
INSERT INTO public.europe_data VALUES (6566, 0, 0, 0, 65, 33);
INSERT INTO public.europe_data VALUES (6567, 13, 784, 36.78, 154, 33);
INSERT INTO public.europe_data VALUES (6568, 0, 36, 2.82, 4, 33);
INSERT INTO public.europe_data VALUES (6569, 7005, 259105, 225.79, 66, 33);
INSERT INTO public.europe_data VALUES (6570, 0, 0, 0, 67, 33);
INSERT INTO public.europe_data VALUES (6571, 0, 0, 0, 109, 33);
INSERT INTO public.europe_data VALUES (6572, 20, 786, 20.01, 155, 33);
INSERT INTO public.europe_data VALUES (6573, 0, 56, 0.32, 5, 33);
INSERT INTO public.europe_data VALUES (6574, 0, 26, 0.66, 6, 33);
INSERT INTO public.europe_data VALUES (6575, 0, 12, 0.08, 110, 33);
INSERT INTO public.europe_data VALUES (6576, 12, 982, 10.54, 7, 33);
INSERT INTO public.europe_data VALUES (6577, 92, 1913, 11.93, 68, 33);
INSERT INTO public.europe_data VALUES (6578, 4, 265, 73.64, 8, 33);
INSERT INTO public.europe_data VALUES (6579, 0, 1, 13.86, 69, 33);
INSERT INTO public.europe_data VALUES (6580, 22, 621, 25.44, 9, 33);
INSERT INTO public.europe_data VALUES (6581, 0, 8, 0.1, 10, 33);
INSERT INTO public.europe_data VALUES (6582, 1030, 29627, 515.45, 70, 33);
INSERT INTO public.europe_data VALUES (6583, 2, 185, 0.03, 111, 33);
INSERT INTO public.europe_data VALUES (6584, 869, 23117, 81.11, 71, 33);
INSERT INTO public.europe_data VALUES (6585, 2, 25, 11.28, 11, 33);
INSERT INTO public.europe_data VALUES (6586, 12, 232, 8.66, 12, 33);
INSERT INTO public.europe_data VALUES (6587, 3, 917, 28.03, 72, 33);
INSERT INTO public.europe_data VALUES (6588, 15, 1452, 15.01, 13, 33);
INSERT INTO public.europe_data VALUES (6589, 0, 374, 10.77, 156, 33);
INSERT INTO public.europe_data VALUES (6590, 1, 20, 0.74, 73, 33);
INSERT INTO public.europe_data VALUES (6591, 0, 1, 1.22, 74, 33);
INSERT INTO public.europe_data VALUES (6592, 0, 8, 1.26, 157, 33);
INSERT INTO public.europe_data VALUES (6593, 12, 1105, 14.83, 158, 33);
INSERT INTO public.europe_data VALUES (6594, 27, 1000, 2.36, 14, 33);
INSERT INTO public.europe_data VALUES (6595, 4, 284, 8.3, 159, 33);
INSERT INTO public.europe_data VALUES (6596, 7, 61, 18.28, 15, 33);
INSERT INTO public.europe_data VALUES (6597, 0, 0, 0, 75, 33);
INSERT INTO public.europe_data VALUES (6598, 64, 4696, 78.32, 76, 33);
INSERT INTO public.europe_data VALUES (6599, 206, 4615, 48.95, 77, 33);
INSERT INTO public.europe_data VALUES (6600, 596, 9955, 20.51, 16, 33);
INSERT INTO public.europe_data VALUES (6601, 57, 1308, 34.31, 78, 33);
INSERT INTO public.europe_data VALUES (6602, 0, 337, 51.25, 17, 33);
INSERT INTO public.europe_data VALUES (6603, 0, 48, 2.72, 18, 33);
INSERT INTO public.europe_data VALUES (6604, 0, 6, 1.06, 160, 33);
INSERT INTO public.europe_data VALUES (6605, 6, 146, 25.35, 19, 33);
INSERT INTO public.europe_data VALUES (6606, 24, 1157, 2.09, 20, 33);
INSERT INTO public.europe_data VALUES (6607, 0, 0, 0, 79, 33);
INSERT INTO public.europe_data VALUES (6608, 0, 0, 0, 161, 33);
INSERT INTO public.europe_data VALUES (6609, 0, 0, 0, 203, 33);
INSERT INTO public.europe_data VALUES (6610, 2, 48, 1.58, 162, 33);
INSERT INTO public.europe_data VALUES (6611, 138, 2559, 8.53, 163, 33);
INSERT INTO public.europe_data VALUES (6612, 0, 2, 0.72, 204, 33);
INSERT INTO public.europe_data VALUES (6613, 6, 781, 80.37, 21, 33);
INSERT INTO public.europe_data VALUES (6614, 0, 8, 0.72, 22, 33);
INSERT INTO public.europe_data VALUES (6615, 1, 18, 1.18, 164, 33);
INSERT INTO public.europe_data VALUES (6616, 76, 3402, 8.79, 165, 33);
INSERT INTO public.europe_data VALUES (6617, 27, 3197, 17.71, 23, 33);
INSERT INTO public.europe_data VALUES (6618, 0, 1, 2.97, 166, 33);
INSERT INTO public.europe_data VALUES (6619, 1, 110, 2.38, 167, 33);
INSERT INTO public.europe_data VALUES (6620, 0, 0, 0, 80, 33);
INSERT INTO public.europe_data VALUES (6621, 0, 0, 0, 81, 33);
INSERT INTO public.europe_data VALUES (6622, 0, 31, 40.65, 205, 33);
INSERT INTO public.europe_data VALUES (6623, 196, 3785, 40.3, 82, 33);
INSERT INTO public.europe_data VALUES (6624, 0, 0, 0, 168, 33);
INSERT INTO public.europe_data VALUES (6625, 4, 354, 6.34, 24, 33);
INSERT INTO public.europe_data VALUES (6626, 4, 73, 8.02, 25, 33);
INSERT INTO public.europe_data VALUES (6627, 0, 46, 9.07, 83, 33);
INSERT INTO public.europe_data VALUES (6628, 16, 636, 13.66, 84, 33);
INSERT INTO public.europe_data VALUES (6629, 0, 0, 0, 169, 33);
INSERT INTO public.europe_data VALUES (6630, 116, 5313, 94.64, 85, 33);
INSERT INTO public.europe_data VALUES (6631, 9, 40, 0.68, 170, 33);
INSERT INTO public.europe_data VALUES (6632, 0, 6, 3.08, 171, 33);
INSERT INTO public.europe_data VALUES (6633, 2776, 123036, 15.8, 112, 33);
INSERT INTO public.europe_data VALUES (6634, 289, 8119, 5.81, 113, 33);
INSERT INTO public.europe_data VALUES (6635, 885, 17717, 42.5, 114, 33);
INSERT INTO public.europe_data VALUES (6636, 656, 14534, 64.09, 115, 33);
INSERT INTO public.europe_data VALUES (6637, 20, 60, 2.77, 172, 33);
INSERT INTO public.europe_data VALUES (6638, 0, 0, 0, 173, 33);
INSERT INTO public.europe_data VALUES (6639, 12, 2977, 54.39, 116, 33);
INSERT INTO public.europe_data VALUES (6640, 104, 1811, 5.5, 174, 33);
INSERT INTO public.europe_data VALUES (6641, 0, 37, 2.68, 86, 33);
INSERT INTO public.europe_data VALUES (6642, 19, 560, 0.77, 117, 33);
INSERT INTO public.europe_data VALUES (6643, 0, 1, 5.57, 175, 33);
INSERT INTO public.europe_data VALUES (6644, 0, 88, 1.58, 118, 33);
INSERT INTO public.europe_data VALUES (6645, 63, 3595, 35.13, 119, 33);
INSERT INTO public.europe_data VALUES (6646, 20, 1332, 4.71, 26, 33);
INSERT INTO public.europe_data VALUES (6647, 13, 508, 66.22, 176, 33);
INSERT INTO public.europe_data VALUES (6648, 22, 5292, 214.45, 120, 33);
INSERT INTO public.europe_data VALUES (6649, 10, 1661, 41.23, 121, 33);
INSERT INTO public.europe_data VALUES (6650, 0, 0, 0, 122, 33);
INSERT INTO public.europe_data VALUES (6651, 0, 5, 0.99, 177, 33);
INSERT INTO public.europe_data VALUES (6652, 2, 153, 4.29, 123, 33);
INSERT INTO public.europe_data VALUES (6653, 0, 23, 1.08, 27, 33);
INSERT INTO public.europe_data VALUES (6654, 0, 142, 6.28, 28, 33);
INSERT INTO public.europe_data VALUES (6655, 11, 218, 5.08, 29, 33);
INSERT INTO public.europe_data VALUES (6656, 0, 0, 0, 178, 33);
INSERT INTO public.europe_data VALUES (6657, 2, 18, 1.72, 179, 33);
INSERT INTO public.europe_data VALUES (6658, 0, 122, 28.02, 180, 33);
INSERT INTO public.europe_data VALUES (6659, 4, 482, 2.99, 30, 33);
INSERT INTO public.europe_data VALUES (6660, 2, 416, 3.22, 31, 33);
INSERT INTO public.europe_data VALUES (6661, 0, 62, 0.57, 124, 33);
INSERT INTO public.europe_data VALUES (6662, 0, 120, 54.24, 125, 33);
INSERT INTO public.europe_data VALUES (6663, 3, 186, 1.72, 32, 33);
INSERT INTO public.europe_data VALUES (6664, 0, 5, 4.05, 181, 33);
INSERT INTO public.europe_data VALUES (6665, 12, 1094, 46.93, 33, 33);
INSERT INTO public.europe_data VALUES (6666, 0, 4, 0.32, 34, 33);
INSERT INTO public.europe_data VALUES (6667, 4823, 38916, 59.55, 87, 33);
INSERT INTO public.europe_data VALUES (6668, 57, 2050, 111.54, 182, 33);
INSERT INTO public.europe_data VALUES (6669, 0, 2, 9.07, 183, 33);
INSERT INTO public.europe_data VALUES (6670, 0, 7, 0.71, 126, 33);
INSERT INTO public.europe_data VALUES (6671, 2, 119, 25.07, 184, 33);
INSERT INTO public.europe_data VALUES (6672, 0, 0, 0, 88, 33);
INSERT INTO public.europe_data VALUES (6673, 7, 2075, 9.1, 35, 33);
INSERT INTO public.europe_data VALUES (6674, 0, 126, 0.91, 36, 33);
INSERT INTO public.europe_data VALUES (6675, 0, 9, 0.07, 127, 33);
INSERT INTO public.europe_data VALUES (6676, 0, 128, 6.05, 37, 33);
INSERT INTO public.europe_data VALUES (6677, 5, 3746, 24.51, 128, 33);
INSERT INTO public.europe_data VALUES (6678, 15, 554, 7.89, 185, 33);
INSERT INTO public.europe_data VALUES (6679, 0, 0, 0, 208, 33);
INSERT INTO public.europe_data VALUES (6680, 0, 15, 0.5, 209, 33);
INSERT INTO public.europe_data VALUES (6681, 10, 156, 7.87, 89, 33);
INSERT INTO public.europe_data VALUES (6682, 0, 38, 0.4, 38, 33);
INSERT INTO public.europe_data VALUES (6683, 47, 4323, 4.22, 39, 33);
INSERT INTO public.europe_data VALUES (6684, 48, 986, 97.97, 186, 33);
INSERT INTO public.europe_data VALUES (6685, 0, 0, 0, 210, 33);
INSERT INTO public.europe_data VALUES (6686, 5, 107, 3.92, 187, 33);
INSERT INTO public.europe_data VALUES (6687, 32, 8679, 294.85, 129, 33);
INSERT INTO public.europe_data VALUES (6688, 577, 25424, 28.64, 130, 33);
INSERT INTO public.europe_data VALUES (6689, 2, 1226, 31.62, 131, 33);
INSERT INTO public.europe_data VALUES (6690, 103, 5656, 259.04, 90, 33);
INSERT INTO public.europe_data VALUES (6691, 0, 2, 0.03, 211, 33);
INSERT INTO public.europe_data VALUES (6692, 2, 748, 11.9, 91, 33);
INSERT INTO public.europe_data VALUES (6693, 1272, 24483, 152.82, 92, 33);
INSERT INTO public.europe_data VALUES (6694, 75, 5403, 8.81, 132, 33);
INSERT INTO public.europe_data VALUES (6695, 82, 1976, 11.89, 188, 33);
INSERT INTO public.europe_data VALUES (6696, 34, 2513, 48.23, 189, 33);
INSERT INTO public.europe_data VALUES (6697, 4, 664, 46.98, 93, 33);
INSERT INTO public.europe_data VALUES (6698, 12, 7044, 522.97, 133, 33);
INSERT INTO public.europe_data VALUES (6699, 100, 2268, 22.22, 190, 33);
INSERT INTO public.europe_data VALUES (6700, 962, 49757, 72.31, 191, 33);
INSERT INTO public.europe_data VALUES (6701, 0, 172, 2.52, 40, 33);
INSERT INTO public.europe_data VALUES (6702, 0, 0, 0, 94, 33);
INSERT INTO public.europe_data VALUES (6703, 0, 0, 0, 95, 33);
INSERT INTO public.europe_data VALUES (6704, 0, 0, 1.81, 96, 33);
INSERT INTO public.europe_data VALUES (6705, 0, 2, 11.61, 192, 33);
INSERT INTO public.europe_data VALUES (6706, 1, 15, 24.18, 41, 33);
INSERT INTO public.europe_data VALUES (6707, 284, 24881, 160.36, 134, 33);
INSERT INTO public.europe_data VALUES (6708, 21, 698, 9.18, 42, 33);
INSERT INTO public.europe_data VALUES (6709, 9, 1152, 24.93, 193, 33);
INSERT INTO public.europe_data VALUES (6710, 0, 0, 0, 43, 33);
INSERT INTO public.europe_data VALUES (6711, 5, 100, 3.3, 44, 33);
INSERT INTO public.europe_data VALUES (6712, 0, 1364, 49.19, 135, 33);
INSERT INTO public.europe_data VALUES (6713, 0, 0, 0, 97, 33);
INSERT INTO public.europe_data VALUES (6714, 0, 77, 2.13, 194, 33);
INSERT INTO public.europe_data VALUES (6715, 2, 61, 4.13, 195, 33);
INSERT INTO public.europe_data VALUES (6716, 0, 115, 1.88, 45, 33);
INSERT INTO public.europe_data VALUES (6717, 526, 40832, 116.29, 46, 33);
INSERT INTO public.europe_data VALUES (6718, 2, 319, 1.24, 136, 33);
INSERT INTO public.europe_data VALUES (6719, 2, 107, 2.68, 47, 33);
INSERT INTO public.europe_data VALUES (6720, 22, 2466, 10.36, 196, 33);
INSERT INTO public.europe_data VALUES (6721, 0, 87, 0.69, 137, 33);
INSERT INTO public.europe_data VALUES (6722, 51, 678, 4.76, 48, 33);
INSERT INTO public.europe_data VALUES (6723, 3, 176, 48.51, 98, 33);
INSERT INTO public.europe_data VALUES (6724, 138, 7459, 142.05, 197, 33);
INSERT INTO public.europe_data VALUES (6725, 2, 325, 5.85, 198, 33);
INSERT INTO public.europe_data VALUES (6726, 2, 52, 0.46, 138, 33);
INSERT INTO public.europe_data VALUES (6727, 0, 1, 0.02, 139, 33);
INSERT INTO public.europe_data VALUES (6728, 0, 392, 8.73, 140, 33);
INSERT INTO public.europe_data VALUES (6729, 0, 14, 0.04, 141, 33);
INSERT INTO public.europe_data VALUES (6730, 0, 0, 0, 142, 33);
INSERT INTO public.europe_data VALUES (6731, 1, 73, 1.37, 49, 33);
INSERT INTO public.europe_data VALUES (6732, 0, 3, 0.22, 99, 33);
INSERT INTO public.europe_data VALUES (6733, 0, 12, 0.62, 50, 33);
INSERT INTO public.europe_data VALUES (6734, 147, 9554, 23.17, 199, 33);
INSERT INTO public.europe_data VALUES (6735, 0, 14, 41.89, 100, 33);
INSERT INTO public.europe_data VALUES (6736, 0, 89, 0.37, 51, 33);
INSERT INTO public.europe_data VALUES (6737, 127, 6422, 26.89, 200, 33);
INSERT INTO public.europe_data VALUES (6738, 11, 2872, 56.32, 143, 33);
INSERT INTO public.europe_data VALUES (6739, 442, 5240, 17.89, 201, 33);
INSERT INTO public.europe_data VALUES (6740, 0, 0, 0, 52, 33);
INSERT INTO public.europe_data VALUES (6741, 5829, 268084, 138.25, 101, 33);
INSERT INTO public.europe_data VALUES (6742, 0, 5, 7.65, 102, 33);
INSERT INTO public.europe_data VALUES (6743, 2, 53, 2.34, 103, 33);
INSERT INTO public.europe_data VALUES (6744, 3, 1673, 8.88, 144, 33);
INSERT INTO public.europe_data VALUES (6745, 11, 1379, 8.13, 104, 33);
INSERT INTO public.europe_data VALUES (6746, 0, 6, 0.02, 145, 33);
INSERT INTO public.europe_data VALUES (6747, 0, 183, 31.76, 53, 33);
INSERT INTO public.europe_data VALUES (6748, 46, 177, 1.34, 146, 33);
INSERT INTO public.europe_data VALUES (6749, 11, 127, 1.11, 54, 33);
INSERT INTO public.europe_data VALUES (6750, 0, 78, 1.26, 55, 33);
INSERT INTO public.europe_data VALUES (6751, 110, 4067, 22.32, 105, 34);
INSERT INTO public.europe_data VALUES (6752, 8, 406, 23.79, 147, 34);
INSERT INTO public.europe_data VALUES (6753, 78, 852, 3.76, 1, 34);
INSERT INTO public.europe_data VALUES (6754, 1, 2, 3.94, 148, 34);
INSERT INTO public.europe_data VALUES (6755, 3, 36, 0.27, 2, 34);
INSERT INTO public.europe_data VALUES (6756, 0, 0, 0, 56, 34);
INSERT INTO public.europe_data VALUES (6757, 0, 0, 0, 57, 34);
INSERT INTO public.europe_data VALUES (6758, 178, 11208, 44.64, 58, 34);
INSERT INTO public.europe_data VALUES (6759, 75, 3524, 245.56, 149, 34);
INSERT INTO public.europe_data VALUES (6760, 0, 0, 0, 59, 34);
INSERT INTO public.europe_data VALUES (6761, 0, 141, 0.8, 202, 34);
INSERT INTO public.europe_data VALUES (6762, 13, 247, 4.71, 150, 34);
INSERT INTO public.europe_data VALUES (6763, 35, 2772, 51.51, 151, 34);
INSERT INTO public.europe_data VALUES (6764, 0, 1, 0.26, 60, 34);
INSERT INTO public.europe_data VALUES (6765, 20, 3220, 426.59, 106, 34);
INSERT INTO public.europe_data VALUES (6766, 293, 24786, 28.54, 107, 34);
INSERT INTO public.europe_data VALUES (6767, 0, 1, 1.74, 61, 34);
INSERT INTO public.europe_data VALUES (6768, 38, 4532, 104.47, 152, 34);
INSERT INTO public.europe_data VALUES (6769, 43, 668, 11.69, 153, 34);
INSERT INTO public.europe_data VALUES (6770, 0, 1, 1.02, 62, 34);
INSERT INTO public.europe_data VALUES (6771, 6, 295, 4.21, 3, 34);
INSERT INTO public.europe_data VALUES (6772, 0, 2, 8, 63, 34);
INSERT INTO public.europe_data VALUES (6773, 0, 2, 1.18, 108, 34);
INSERT INTO public.europe_data VALUES (6774, 162, 5929, 93.33, 64, 34);
INSERT INTO public.europe_data VALUES (6775, 0, 0, 0, 65, 34);
INSERT INTO public.europe_data VALUES (6776, 6, 430, 22.96, 154, 34);
INSERT INTO public.europe_data VALUES (6777, 0, 29, 2.13, 4, 34);
INSERT INTO public.europe_data VALUES (6778, 7285, 217414, 186.34, 66, 34);
INSERT INTO public.europe_data VALUES (6779, 0, 0, 0, 67, 34);
INSERT INTO public.europe_data VALUES (6780, 1, 0, 0, 109, 34);
INSERT INTO public.europe_data VALUES (6781, 25, 615, 16.83, 155, 34);
INSERT INTO public.europe_data VALUES (6782, 0, 9, 0.07, 5, 34);
INSERT INTO public.europe_data VALUES (6783, 0, 50, 0.53, 6, 34);
INSERT INTO public.europe_data VALUES (6784, 0, 1, 0.02, 110, 34);
INSERT INTO public.europe_data VALUES (6785, 25, 1746, 14.31, 7, 34);
INSERT INTO public.europe_data VALUES (6786, 284, 2550, 15.07, 68, 34);
INSERT INTO public.europe_data VALUES (6787, 2, 140, 61.1, 8, 34);
INSERT INTO public.europe_data VALUES (6788, 0, 8, 47.73, 69, 34);
INSERT INTO public.europe_data VALUES (6789, 16, 586, 24.74, 9, 34);
INSERT INTO public.europe_data VALUES (6790, 1, 8, 0.13, 10, 34);
INSERT INTO public.europe_data VALUES (6791, 1156, 68062, 570.94, 70, 34);
INSERT INTO public.europe_data VALUES (6792, 1, 237, 0.03, 111, 34);
INSERT INTO public.europe_data VALUES (6793, 570, 17713, 58.44, 71, 34);
INSERT INTO public.europe_data VALUES (6794, 3, 71, 12.46, 11, 34);
INSERT INTO public.europe_data VALUES (6795, 3, 234, 6.13, 12, 34);
INSERT INTO public.europe_data VALUES (6796, 0, 498, 17.73, 72, 34);
INSERT INTO public.europe_data VALUES (6797, 6, 2408, 14.59, 13, 34);
INSERT INTO public.europe_data VALUES (6798, 0, 65, 1.72, 156, 34);
INSERT INTO public.europe_data VALUES (6799, 1, 64, 1.07, 73, 34);
INSERT INTO public.europe_data VALUES (6800, 0, 1, 1.22, 74, 34);
INSERT INTO public.europe_data VALUES (6801, 1, 3, 2.51, 157, 34);
INSERT INTO public.europe_data VALUES (6802, 7, 474, 8.17, 158, 34);
INSERT INTO public.europe_data VALUES (6803, 24, 1049, 2.09, 14, 34);
INSERT INTO public.europe_data VALUES (6804, 3, 198, 7.63, 159, 34);
INSERT INTO public.europe_data VALUES (6805, 2, 117, 38.52, 15, 34);
INSERT INTO public.europe_data VALUES (6806, 0, 0, 0, 75, 34);
INSERT INTO public.europe_data VALUES (6807, 70, 3715, 65.9, 76, 34);
INSERT INTO public.europe_data VALUES (6808, 327, 3889, 43.28, 77, 34);
INSERT INTO public.europe_data VALUES (6809, 618, 10635, 21.07, 16, 34);
INSERT INTO public.europe_data VALUES (6810, 33, 906, 24.96, 78, 34);
INSERT INTO public.europe_data VALUES (6811, 20, 358, 26.4, 17, 34);
INSERT INTO public.europe_data VALUES (6812, 0, 47, 2.92, 18, 34);
INSERT INTO public.europe_data VALUES (6813, 0, 8, 3.17, 160, 34);
INSERT INTO public.europe_data VALUES (6814, 1, 145, 26.3, 19, 34);
INSERT INTO public.europe_data VALUES (6815, 17, 1187, 2.24, 20, 34);
INSERT INTO public.europe_data VALUES (6816, 0, 0, 0, 79, 34);
INSERT INTO public.europe_data VALUES (6817, 0, 0, 0, 161, 34);
INSERT INTO public.europe_data VALUES (6818, 0, 0, 0, 203, 34);
INSERT INTO public.europe_data VALUES (6819, 0, 39, 2.94, 162, 34);
INSERT INTO public.europe_data VALUES (6820, 233, 3157, 9.55, 163, 34);
INSERT INTO public.europe_data VALUES (6821, 0, 0, 0, 204, 34);
INSERT INTO public.europe_data VALUES (6822, 11, 965, 61.08, 21, 34);
INSERT INTO public.europe_data VALUES (6823, 1, 9, 0.47, 22, 34);
INSERT INTO public.europe_data VALUES (6824, 0, 29, 2.5, 164, 34);
INSERT INTO public.europe_data VALUES (6825, 94, 3898, 7.43, 165, 34);
INSERT INTO public.europe_data VALUES (6826, 31, 2190, 14.85, 23, 34);
INSERT INTO public.europe_data VALUES (6827, 0, 0, 2.97, 166, 34);
INSERT INTO public.europe_data VALUES (6828, 7, 145, 2.51, 167, 34);
INSERT INTO public.europe_data VALUES (6829, 0, 0, 0, 80, 34);
INSERT INTO public.europe_data VALUES (6830, 0, 0, 0, 81, 34);
INSERT INTO public.europe_data VALUES (6831, 0, 37, 25.7, 205, 34);
INSERT INTO public.europe_data VALUES (6832, 147, 3300, 34.64, 82, 34);
INSERT INTO public.europe_data VALUES (6833, 0, 0, 0, 168, 34);
INSERT INTO public.europe_data VALUES (6834, 2, 456, 6.44, 24, 34);
INSERT INTO public.europe_data VALUES (6835, 2, 81, 9.01, 25, 34);
INSERT INTO public.europe_data VALUES (6836, 0, 25, 3.83, 83, 34);
INSERT INTO public.europe_data VALUES (6837, 15, 902, 16.67, 84, 34);
INSERT INTO public.europe_data VALUES (6838, 0, 0, 0, 169, 34);
INSERT INTO public.europe_data VALUES (6839, 51, 3911, 66.1, 85, 34);
INSERT INTO public.europe_data VALUES (6840, 9, 26, 1.35, 170, 34);
INSERT INTO public.europe_data VALUES (6841, 0, 5, 2.24, 171, 34);
INSERT INTO public.europe_data VALUES (6842, 4179, 92858, 12.34, 112, 34);
INSERT INTO public.europe_data VALUES (6843, 331, 7614, 5.43, 113, 34);
INSERT INTO public.europe_data VALUES (6844, 786, 17525, 40, 114, 34);
INSERT INTO public.europe_data VALUES (6845, 493, 10659, 47.07, 115, 34);
INSERT INTO public.europe_data VALUES (6846, 9, 76, 3.63, 172, 34);
INSERT INTO public.europe_data VALUES (6847, 0, 0, 0, 173, 34);
INSERT INTO public.europe_data VALUES (6848, 4, 1657, 33.61, 116, 34);
INSERT INTO public.europe_data VALUES (6849, 289, 1510, 5.8, 174, 34);
INSERT INTO public.europe_data VALUES (6850, 0, 42, 2.07, 86, 34);
INSERT INTO public.europe_data VALUES (6851, 28, 414, 0.58, 117, 34);
INSERT INTO public.europe_data VALUES (6852, 1, 5, 6.49, 175, 34);
INSERT INTO public.europe_data VALUES (6853, 0, 72, 2.23, 118, 34);
INSERT INTO public.europe_data VALUES (6854, 43, 2923, 26.27, 119, 34);
INSERT INTO public.europe_data VALUES (6855, 20, 1144, 3.75, 26, 34);
INSERT INTO public.europe_data VALUES (6856, 3, 683, 51.99, 176, 34);
INSERT INTO public.europe_data VALUES (6857, 30, 3730, 185.45, 120, 34);
INSERT INTO public.europe_data VALUES (6858, 13, 984, 20.64, 121, 34);
INSERT INTO public.europe_data VALUES (6859, 0, 0, 0, 122, 34);
INSERT INTO public.europe_data VALUES (6860, 2, 14, 1.2, 177, 34);
INSERT INTO public.europe_data VALUES (6861, 0, 141, 3.73, 123, 34);
INSERT INTO public.europe_data VALUES (6862, 0, 0, 0, 27, 34);
INSERT INTO public.europe_data VALUES (6863, 2, 168, 5.41, 28, 34);
INSERT INTO public.europe_data VALUES (6864, 2, 126, 4.25, 29, 34);
INSERT INTO public.europe_data VALUES (6865, 0, 0, 0, 178, 34);
INSERT INTO public.europe_data VALUES (6866, 1, 30, 3.01, 179, 34);
INSERT INTO public.europe_data VALUES (6867, 0, 50, 13.19, 180, 34);
INSERT INTO public.europe_data VALUES (6868, 4, 324, 2.02, 30, 34);
INSERT INTO public.europe_data VALUES (6869, 5, 183, 1.57, 31, 34);
INSERT INTO public.europe_data VALUES (6870, 0, 119, 0.78, 124, 34);
INSERT INTO public.europe_data VALUES (6871, 0, 168, 56.5, 125, 34);
INSERT INTO public.europe_data VALUES (6872, 7, 152, 2.18, 32, 34);
INSERT INTO public.europe_data VALUES (6873, 0, 15, 7.09, 181, 34);
INSERT INTO public.europe_data VALUES (6874, 21, 1030, 41.23, 33, 34);
INSERT INTO public.europe_data VALUES (6875, 0, 0, 0, 34, 34);
INSERT INTO public.europe_data VALUES (6876, 4684, 37054, 55.79, 87, 34);
INSERT INTO public.europe_data VALUES (6877, 67, 2460, 111.3, 182, 34);
INSERT INTO public.europe_data VALUES (6878, 0, 1, 3.02, 183, 34);
INSERT INTO public.europe_data VALUES (6879, 0, 16, 0.59, 126, 34);
INSERT INTO public.europe_data VALUES (6880, 0, 37, 6.11, 184, 34);
INSERT INTO public.europe_data VALUES (6881, 0, 0, 0, 88, 34);
INSERT INTO public.europe_data VALUES (6882, 2, 1243, 4.81, 35, 34);
INSERT INTO public.europe_data VALUES (6883, 2, 150, 1.01, 36, 34);
INSERT INTO public.europe_data VALUES (6884, 0, 28, 0.09, 127, 34);
INSERT INTO public.europe_data VALUES (6885, 0, 23, 1.04, 37, 34);
INSERT INTO public.europe_data VALUES (6886, 4, 3266, 19.5, 128, 34);
INSERT INTO public.europe_data VALUES (6887, 31, 810, 11.68, 185, 34);
INSERT INTO public.europe_data VALUES (6888, 0, 0, 0.35, 208, 34);
INSERT INTO public.europe_data VALUES (6889, 0, 9, 0.19, 209, 34);
INSERT INTO public.europe_data VALUES (6890, 9, 359, 10.77, 89, 34);
INSERT INTO public.europe_data VALUES (6891, 1, 56, 0.27, 38, 34);
INSERT INTO public.europe_data VALUES (6892, 98, 4159, 3.86, 39, 34);
INSERT INTO public.europe_data VALUES (6893, 50, 1049, 100.04, 186, 34);
INSERT INTO public.europe_data VALUES (6894, 0, 0, 5.24, 210, 34);
INSERT INTO public.europe_data VALUES (6895, 2, 102, 3.83, 187, 34);
INSERT INTO public.europe_data VALUES (6896, 27, 5990, 253.05, 129, 34);
INSERT INTO public.europe_data VALUES (6897, 861, 36610, 35.75, 130, 34);
INSERT INTO public.europe_data VALUES (6898, 0, 349, 7.45, 131, 34);
INSERT INTO public.europe_data VALUES (6899, 64, 5344, 226.19, 90, 34);
INSERT INTO public.europe_data VALUES (6900, 0, 1, 0.01, 211, 34);
INSERT INTO public.europe_data VALUES (6901, 2, 90, 3.46, 91, 34);
INSERT INTO public.europe_data VALUES (6902, 1357, 25200, 179.7, 92, 34);
INSERT INTO public.europe_data VALUES (6903, 81, 4122, 7.54, 132, 34);
INSERT INTO public.europe_data VALUES (6904, 109, 2539, 14.14, 188, 34);
INSERT INTO public.europe_data VALUES (6905, 13, 2443, 45.15, 189, 34);
INSERT INTO public.europe_data VALUES (6906, 2, 714, 52.5, 93, 34);
INSERT INTO public.europe_data VALUES (6907, 25, 7767, 656.02, 133, 34);
INSERT INTO public.europe_data VALUES (6908, 102, 2046, 18.37, 190, 34);
INSERT INTO public.europe_data VALUES (6909, 1163, 55716, 80.21, 191, 34);
INSERT INTO public.europe_data VALUES (6910, 0, 146, 2.29, 40, 34);
INSERT INTO public.europe_data VALUES (6911, 0, 0, 0, 94, 34);
INSERT INTO public.europe_data VALUES (6912, 0, 0, 0, 95, 34);
INSERT INTO public.europe_data VALUES (6913, 0, 2, 2.71, 96, 34);
INSERT INTO public.europe_data VALUES (6914, 0, 2, 26.12, 192, 34);
INSERT INTO public.europe_data VALUES (6915, 0, 37, 85.56, 41, 34);
INSERT INTO public.europe_data VALUES (6916, 295, 30071, 162.53, 134, 34);
INSERT INTO public.europe_data VALUES (6917, 24, 798, 9.57, 42, 34);
INSERT INTO public.europe_data VALUES (6918, 7, 584, 15.38, 193, 34);
INSERT INTO public.europe_data VALUES (6919, 0, 0, 0, 43, 34);
INSERT INTO public.europe_data VALUES (6920, 4, 158, 4.58, 44, 34);
INSERT INTO public.europe_data VALUES (6921, 0, 1491, 72.1, 135, 34);
INSERT INTO public.europe_data VALUES (6922, 0, 0, 0, 97, 34);
INSERT INTO public.europe_data VALUES (6923, 0, 39, 1.08, 194, 34);
INSERT INTO public.europe_data VALUES (6924, 0, 25, 1.68, 195, 34);
INSERT INTO public.europe_data VALUES (6925, 2, 176, 2.88, 45, 34);
INSERT INTO public.europe_data VALUES (6926, 450, 27264, 83.71, 46, 34);
INSERT INTO public.europe_data VALUES (6927, 3, 317, 1.22, 136, 34);
INSERT INTO public.europe_data VALUES (6928, 7, 189, 5.11, 47, 34);
INSERT INTO public.europe_data VALUES (6929, 1188, 2395, 10.2, 196, 34);
INSERT INTO public.europe_data VALUES (6930, 0, 61, 0.54, 137, 34);
INSERT INTO public.europe_data VALUES (6931, 62, 1360, 5.83, 48, 34);
INSERT INTO public.europe_data VALUES (6932, 5, 106, 33.03, 98, 34);
INSERT INTO public.europe_data VALUES (6933, 200, 7073, 138.77, 197, 34);
INSERT INTO public.europe_data VALUES (6934, 3, 175, 3.83, 198, 34);
INSERT INTO public.europe_data VALUES (6935, 1, 27, 0.37, 138, 34);
INSERT INTO public.europe_data VALUES (6936, 0, 3, 0.01, 139, 34);
INSERT INTO public.europe_data VALUES (6937, 2, 422, 9.96, 140, 34);
INSERT INTO public.europe_data VALUES (6938, 0, 13, 0.04, 141, 34);
INSERT INTO public.europe_data VALUES (6939, 0, 0, 0, 142, 34);
INSERT INTO public.europe_data VALUES (6940, 0, 38, 0.92, 49, 34);
INSERT INTO public.europe_data VALUES (6941, 0, 0, 0.43, 99, 34);
INSERT INTO public.europe_data VALUES (6942, 1, 61, 0.6, 50, 34);
INSERT INTO public.europe_data VALUES (6943, 143, 9446, 21.41, 199, 34);
INSERT INTO public.europe_data VALUES (6944, 0, 2, 5.24, 100, 34);
INSERT INTO public.europe_data VALUES (6945, 0, 74, 0.35, 51, 34);
INSERT INTO public.europe_data VALUES (6946, 113, 5406, 21.73, 200, 34);
INSERT INTO public.europe_data VALUES (6947, 13, 2631, 62.61, 143, 34);
INSERT INTO public.europe_data VALUES (6948, 512, 6680, 20.73, 201, 34);
INSERT INTO public.europe_data VALUES (6949, 0, 0, 0, 52, 34);
INSERT INTO public.europe_data VALUES (6950, 4243, 186843, 102.88, 101, 34);
INSERT INTO public.europe_data VALUES (6951, 0, 3, 4.78, 102, 34);
INSERT INTO public.europe_data VALUES (6952, 2, 28, 0.9, 103, 34);
INSERT INTO public.europe_data VALUES (6953, 0, 1255, 6.08, 144, 34);
INSERT INTO public.europe_data VALUES (6954, 8, 940, 5.4, 104, 34);
INSERT INTO public.europe_data VALUES (6955, 0, 15, 0.02, 145, 34);
INSERT INTO public.europe_data VALUES (6956, 0, 2, 0.34, 53, 34);
INSERT INTO public.europe_data VALUES (6957, 92, 213, 1.56, 146, 34);
INSERT INTO public.europe_data VALUES (6958, 0, 72, 1.55, 54, 34);
INSERT INTO public.europe_data VALUES (6959, 2, 106, 1.41, 55, 34);
INSERT INTO public.europe_data VALUES (6960, 114, 4424, 25.13, 105, 35);
INSERT INTO public.europe_data VALUES (6961, 2, 275, 13.42, 147, 35);
INSERT INTO public.europe_data VALUES (6962, 60, 765, 3.54, 1, 35);
INSERT INTO public.europe_data VALUES (6963, 0, 1, 116.83, 148, 35);
INSERT INTO public.europe_data VALUES (6964, 2, 49, 0.17, 2, 35);
INSERT INTO public.europe_data VALUES (6965, 0, 0, 0, 56, 35);
INSERT INTO public.europe_data VALUES (6966, 0, 0, 1.03, 57, 35);
INSERT INTO public.europe_data VALUES (6967, 169, 8783, 32.88, 58, 35);
INSERT INTO public.europe_data VALUES (6968, 74, 3739, 256.01, 149, 35);
INSERT INTO public.europe_data VALUES (6969, 0, 0, 0, 59, 35);
INSERT INTO public.europe_data VALUES (6970, 0, 60, 0.5, 202, 35);
INSERT INTO public.europe_data VALUES (6971, 5, 170, 4.47, 150, 35);
INSERT INTO public.europe_data VALUES (6972, 31, 2404, 44.42, 151, 35);
INSERT INTO public.europe_data VALUES (6973, 0, 0, 0.26, 60, 35);
INSERT INTO public.europe_data VALUES (6974, 17, 3781, 435.42, 106, 35);
INSERT INTO public.europe_data VALUES (6975, 283, 21751, 24.76, 107, 35);
INSERT INTO public.europe_data VALUES (6976, 0, 4, 1.39, 61, 35);
INSERT INTO public.europe_data VALUES (6977, 39, 5343, 120.78, 152, 35);
INSERT INTO public.europe_data VALUES (6978, 58, 671, 13.25, 153, 35);
INSERT INTO public.europe_data VALUES (6979, 0, 3, 0.77, 62, 35);
INSERT INTO public.europe_data VALUES (6980, 3, 202, 2.02, 3, 35);
INSERT INTO public.europe_data VALUES (6981, 0, 3, 6.4, 63, 35);
INSERT INTO public.europe_data VALUES (6982, 0, 7, 3.01, 108, 35);
INSERT INTO public.europe_data VALUES (6983, 146, 4816, 73.63, 64, 35);
INSERT INTO public.europe_data VALUES (6984, 0, 0, 0, 65, 35);
INSERT INTO public.europe_data VALUES (6985, 4, 328, 14.9, 154, 35);
INSERT INTO public.europe_data VALUES (6986, 0, 20, 0.95, 4, 35);
INSERT INTO public.europe_data VALUES (6987, 6877, 175866, 167.15, 66, 35);
INSERT INTO public.europe_data VALUES (6988, 0, 0, 0, 67, 35);
INSERT INTO public.europe_data VALUES (6989, 0, 0, 0, 109, 35);
INSERT INTO public.europe_data VALUES (6990, 14, 563, 11.1, 155, 35);
INSERT INTO public.europe_data VALUES (6991, 0, 5, 0.06, 5, 35);
INSERT INTO public.europe_data VALUES (6992, 0, 11, 0.27, 6, 35);
INSERT INTO public.europe_data VALUES (6993, 0, 2, 0.02, 110, 35);
INSERT INTO public.europe_data VALUES (6994, 73, 1956, 15.3, 7, 35);
INSERT INTO public.europe_data VALUES (6995, 346, 3088, 20.96, 68, 35);
INSERT INTO public.europe_data VALUES (6996, 1, 196, 57.28, 8, 35);
INSERT INTO public.europe_data VALUES (6997, 0, 23, 70.83, 69, 35);
INSERT INTO public.europe_data VALUES (6998, 2, 588, 25.52, 9, 35);
INSERT INTO public.europe_data VALUES (6999, 4, 13, 0.45, 10, 35);
INSERT INTO public.europe_data VALUES (7000, 1133, 40143, 393.65, 70, 35);
INSERT INTO public.europe_data VALUES (7001, 0, 144, 0.01, 111, 35);
INSERT INTO public.europe_data VALUES (7002, 408, 11703, 42.82, 71, 35);
INSERT INTO public.europe_data VALUES (7003, 0, 35, 8.23, 11, 35);
INSERT INTO public.europe_data VALUES (7004, 3, 96, 3.12, 12, 35);
INSERT INTO public.europe_data VALUES (7005, 2, 397, 13.06, 72, 35);
INSERT INTO public.europe_data VALUES (7006, 9, 1345, 8.75, 13, 35);
INSERT INTO public.europe_data VALUES (7007, 3, 5, 0.15, 156, 35);
INSERT INTO public.europe_data VALUES (7008, 1, 57, 1.79, 73, 35);
INSERT INTO public.europe_data VALUES (7009, 0, 1, 1.84, 74, 35);
INSERT INTO public.europe_data VALUES (7010, 0, 19, 4.45, 157, 35);
INSERT INTO public.europe_data VALUES (7011, 2, 396, 7.05, 158, 35);
INSERT INTO public.europe_data VALUES (7012, 21, 761, 1.99, 14, 35);
INSERT INTO public.europe_data VALUES (7013, 8, 245, 9.03, 159, 35);
INSERT INTO public.europe_data VALUES (7014, 15, 258, 114.12, 15, 35);
INSERT INTO public.europe_data VALUES (7015, 0, 0, 2.79, 75, 35);
INSERT INTO public.europe_data VALUES (7016, 54, 3362, 52.86, 76, 35);
INSERT INTO public.europe_data VALUES (7017, 275, 3631, 44.05, 77, 35);
INSERT INTO public.europe_data VALUES (7018, 338, 10519, 19.54, 16, 35);
INSERT INTO public.europe_data VALUES (7019, 19, 705, 18.64, 78, 35);
INSERT INTO public.europe_data VALUES (7020, 0, 0, 0, 17, 35);
INSERT INTO public.europe_data VALUES (7021, 0, 55, 1.63, 18, 35);
INSERT INTO public.europe_data VALUES (7022, 0, 34, 7.85, 160, 35);
INSERT INTO public.europe_data VALUES (7023, 1, 157, 17.86, 19, 35);
INSERT INTO public.europe_data VALUES (7024, 30, 1325, 1.94, 20, 35);
INSERT INTO public.europe_data VALUES (7025, 0, 0, 0, 79, 35);
INSERT INTO public.europe_data VALUES (7026, 0, 0, 0, 161, 35);
INSERT INTO public.europe_data VALUES (7027, 0, 0, 0, 203, 35);
INSERT INTO public.europe_data VALUES (7028, 3, 123, 4.44, 162, 35);
INSERT INTO public.europe_data VALUES (7029, 252, 3243, 8.16, 163, 35);
INSERT INTO public.europe_data VALUES (7030, 0, 0, 0, 204, 35);
INSERT INTO public.europe_data VALUES (7031, 2, 362, 37.19, 21, 35);
INSERT INTO public.europe_data VALUES (7032, 0, 2, 0.13, 22, 35);
INSERT INTO public.europe_data VALUES (7033, 1, 71, 2.4, 164, 35);
INSERT INTO public.europe_data VALUES (7034, 117, 2268, 5.6, 165, 35);
INSERT INTO public.europe_data VALUES (7035, 10, 2326, 12.8, 23, 35);
INSERT INTO public.europe_data VALUES (7036, 0, 1, 20.77, 166, 35);
INSERT INTO public.europe_data VALUES (7037, 3, 124, 1.9, 167, 35);
INSERT INTO public.europe_data VALUES (7038, 0, 0, 0, 80, 35);
INSERT INTO public.europe_data VALUES (7039, 0, 0, 0, 81, 35);
INSERT INTO public.europe_data VALUES (7040, 0, 6, 5.98, 205, 35);
INSERT INTO public.europe_data VALUES (7041, 132, 2790, 27.06, 82, 35);
INSERT INTO public.europe_data VALUES (7042, 0, 0, 0, 168, 35);
INSERT INTO public.europe_data VALUES (7043, 2, 367, 5.96, 24, 35);
INSERT INTO public.europe_data VALUES (7044, 3, 92, 7.18, 25, 35);
INSERT INTO public.europe_data VALUES (7045, 0, 5, 0.77, 83, 35);
INSERT INTO public.europe_data VALUES (7046, 22, 975, 19.4, 84, 35);
INSERT INTO public.europe_data VALUES (7047, 0, 0, 0, 169, 35);
INSERT INTO public.europe_data VALUES (7048, 54, 2531, 37.51, 85, 35);
INSERT INTO public.europe_data VALUES (7049, 21, 106, 2.05, 170, 35);
INSERT INTO public.europe_data VALUES (7050, 0, 3, 1.12, 171, 35);
INSERT INTO public.europe_data VALUES (7051, 2385, 75813, 10.38, 112, 35);
INSERT INTO public.europe_data VALUES (7052, 283, 7091, 4.36, 113, 35);
INSERT INTO public.europe_data VALUES (7053, 556, 15638, 43.37, 114, 35);
INSERT INTO public.europe_data VALUES (7054, 261, 7843, 35.03, 115, 35);
INSERT INTO public.europe_data VALUES (7055, 27, 102, 6.38, 172, 35);
INSERT INTO public.europe_data VALUES (7056, 0, 0, 0, 173, 35);
INSERT INTO public.europe_data VALUES (7057, 4, 1206, 24.06, 116, 35);
INSERT INTO public.europe_data VALUES (7058, 446, 1991, 6.58, 174, 35);
INSERT INTO public.europe_data VALUES (7059, 0, 19, 1.05, 86, 35);
INSERT INTO public.europe_data VALUES (7060, 9, 328, 0.49, 117, 35);
INSERT INTO public.europe_data VALUES (7061, 0, 2, 4.64, 175, 35);
INSERT INTO public.europe_data VALUES (7062, 0, 153, 2.2, 118, 35);
INSERT INTO public.europe_data VALUES (7063, 21, 1950, 18.87, 119, 35);
INSERT INTO public.europe_data VALUES (7064, 19, 827, 3.1, 26, 35);
INSERT INTO public.europe_data VALUES (7065, 2, 252, 22.41, 176, 35);
INSERT INTO public.europe_data VALUES (7066, 32, 4072, 211, 120, 35);
INSERT INTO public.europe_data VALUES (7067, 4, 340, 8.65, 121, 35);
INSERT INTO public.europe_data VALUES (7068, 0, 0, 0, 122, 35);
INSERT INTO public.europe_data VALUES (7069, 3, 9, 1.61, 177, 35);
INSERT INTO public.europe_data VALUES (7070, 2, 115, 3.3, 123, 35);
INSERT INTO public.europe_data VALUES (7071, 0, 0, 0.09, 27, 35);
INSERT INTO public.europe_data VALUES (7072, 2, 99, 3.44, 28, 35);
INSERT INTO public.europe_data VALUES (7073, 3, 162, 3.87, 29, 35);
INSERT INTO public.europe_data VALUES (7074, 0, 0, 0, 178, 35);
INSERT INTO public.europe_data VALUES (7075, 4, 54, 3.33, 179, 35);
INSERT INTO public.europe_data VALUES (7076, 0, 31, 8.47, 180, 35);
INSERT INTO public.europe_data VALUES (7077, 1, 220, 1.86, 30, 35);
INSERT INTO public.europe_data VALUES (7078, 2, 109, 1.41, 31, 35);
INSERT INTO public.europe_data VALUES (7079, 4, 131, 1.98, 124, 35);
INSERT INTO public.europe_data VALUES (7080, 0, 132, 49.34, 125, 35);
INSERT INTO public.europe_data VALUES (7081, 12, 276, 2.77, 32, 35);
INSERT INTO public.europe_data VALUES (7082, 0, 20, 6.28, 181, 35);
INSERT INTO public.europe_data VALUES (7083, 44, 836, 27.69, 33, 35);
INSERT INTO public.europe_data VALUES (7084, 0, 0, 0.16, 34, 35);
INSERT INTO public.europe_data VALUES (7085, 3442, 34118, 50.31, 87, 35);
INSERT INTO public.europe_data VALUES (7086, 65, 2040, 86.29, 182, 35);
INSERT INTO public.europe_data VALUES (7087, 0, 0, 0, 183, 35);
INSERT INTO public.europe_data VALUES (7088, 0, 3, 0.37, 126, 35);
INSERT INTO public.europe_data VALUES (7089, 0, 1, 0.16, 184, 35);
INSERT INTO public.europe_data VALUES (7090, 0, 0, 0, 88, 35);
INSERT INTO public.europe_data VALUES (7091, 4, 510, 2.54, 35, 35);
INSERT INTO public.europe_data VALUES (7092, 1, 157, 1.08, 36, 35);
INSERT INTO public.europe_data VALUES (7093, 0, 19, 0.06, 127, 35);
INSERT INTO public.europe_data VALUES (7094, 0, 3, 0.32, 37, 35);
INSERT INTO public.europe_data VALUES (7095, 6, 2312, 14.64, 128, 35);
INSERT INTO public.europe_data VALUES (7096, 46, 1209, 13.55, 185, 35);
INSERT INTO public.europe_data VALUES (7097, 0, 1, 0.71, 208, 35);
INSERT INTO public.europe_data VALUES (7098, 0, 0, 0, 209, 35);
INSERT INTO public.europe_data VALUES (7099, 9, 346, 13.69, 89, 35);
INSERT INTO public.europe_data VALUES (7100, 1, 7, 0.09, 38, 35);
INSERT INTO public.europe_data VALUES (7101, 66, 3599, 2.95, 39, 35);
INSERT INTO public.europe_data VALUES (7102, 35, 1029, 88.15, 186, 35);
INSERT INTO public.europe_data VALUES (7103, 0, 3, 13.98, 210, 35);
INSERT INTO public.europe_data VALUES (7104, 4, 102, 3.66, 187, 35);
INSERT INTO public.europe_data VALUES (7105, 29, 6599, 242.09, 129, 35);
INSERT INTO public.europe_data VALUES (7106, 662, 40807, 33.25, 130, 35);
INSERT INTO public.europe_data VALUES (7107, 0, 22, 0.92, 131, 35);
INSERT INTO public.europe_data VALUES (7108, 44, 4261, 170.1, 90, 35);
INSERT INTO public.europe_data VALUES (7109, 0, 0, 0, 211, 35);
INSERT INTO public.europe_data VALUES (7110, 0, 154, 4.3, 91, 35);
INSERT INTO public.europe_data VALUES (7111, 1223, 33221, 200.74, 92, 35);
INSERT INTO public.europe_data VALUES (7112, 85, 4035, 7.26, 132, 35);
INSERT INTO public.europe_data VALUES (7113, 90, 2831, 14.76, 188, 35);
INSERT INTO public.europe_data VALUES (7114, 38, 2197, 40.77, 189, 35);
INSERT INTO public.europe_data VALUES (7115, 5, 826, 69.37, 93, 35);
INSERT INTO public.europe_data VALUES (7116, 19, 10812, 801.25, 133, 35);
INSERT INTO public.europe_data VALUES (7117, 84, 1520, 14.12, 190, 35);
INSERT INTO public.europe_data VALUES (7118, 1089, 61291, 84.4, 191, 35);
INSERT INTO public.europe_data VALUES (7119, 0, 143, 1.68, 40, 35);
INSERT INTO public.europe_data VALUES (7120, 0, 0, 0, 94, 35);
INSERT INTO public.europe_data VALUES (7121, 0, 0, 0.55, 95, 35);
INSERT INTO public.europe_data VALUES (7122, 0, 1, 0.9, 96, 35);
INSERT INTO public.europe_data VALUES (7123, 0, 7, 66.76, 192, 35);
INSERT INTO public.europe_data VALUES (7124, 0, 147, 82.77, 41, 35);
INSERT INTO public.europe_data VALUES (7125, 260, 25627, 123.38, 134, 35);
INSERT INTO public.europe_data VALUES (7126, 11, 762, 8.87, 42, 35);
INSERT INTO public.europe_data VALUES (7127, 5, 487, 12.9, 193, 35);
INSERT INTO public.europe_data VALUES (7128, 0, 0, 0, 43, 35);
INSERT INTO public.europe_data VALUES (7129, 3, 200, 3.94, 44, 35);
INSERT INTO public.europe_data VALUES (7130, 1, 2694, 98.55, 135, 35);
INSERT INTO public.europe_data VALUES (7131, 0, 0, 0, 97, 35);
INSERT INTO public.europe_data VALUES (7132, 0, 20, 0.48, 194, 35);
INSERT INTO public.europe_data VALUES (7133, 1, 10, 1.06, 195, 35);
INSERT INTO public.europe_data VALUES (7134, 5, 269, 4.06, 45, 35);
INSERT INTO public.europe_data VALUES (7135, 482, 21753, 63.79, 46, 35);
INSERT INTO public.europe_data VALUES (7136, 4, 307, 1.21, 136, 35);
INSERT INTO public.europe_data VALUES (7137, 13, 376, 6.32, 47, 35);
INSERT INTO public.europe_data VALUES (7138, 0, 2392, 9.53, 196, 35);
INSERT INTO public.europe_data VALUES (7139, 0, 54, 1.2, 137, 35);
INSERT INTO public.europe_data VALUES (7140, 100, 1137, 5.12, 48, 35);
INSERT INTO public.europe_data VALUES (7141, 2, 86, 31.82, 98, 35);
INSERT INTO public.europe_data VALUES (7142, 234, 7123, 128.48, 197, 35);
INSERT INTO public.europe_data VALUES (7143, 16, 152, 2.98, 198, 35);
INSERT INTO public.europe_data VALUES (7144, 0, 36, 0.32, 138, 35);
INSERT INTO public.europe_data VALUES (7145, 0, 0, 0, 139, 35);
INSERT INTO public.europe_data VALUES (7146, 2, 506, 13.17, 140, 35);
INSERT INTO public.europe_data VALUES (7147, 0, 16, 0.08, 141, 35);
INSERT INTO public.europe_data VALUES (7148, 0, 0, 0, 142, 35);
INSERT INTO public.europe_data VALUES (7149, 0, 36, 1.1, 49, 35);
INSERT INTO public.europe_data VALUES (7150, 0, 6, 0.43, 99, 35);
INSERT INTO public.europe_data VALUES (7151, 0, 9, 0.16, 50, 35);
INSERT INTO public.europe_data VALUES (7152, 115, 8107, 17.43, 199, 35);
INSERT INTO public.europe_data VALUES (7153, 0, 0, 0, 100, 35);
INSERT INTO public.europe_data VALUES (7154, 0, 80, 0.54, 51, 35);
INSERT INTO public.europe_data VALUES (7155, 101, 4155, 17.01, 200, 35);
INSERT INTO public.europe_data VALUES (7156, 13, 3486, 79.19, 143, 35);
INSERT INTO public.europe_data VALUES (7157, 747, 7136, 23.5, 201, 35);
INSERT INTO public.europe_data VALUES (7158, 0, 0, 0, 52, 35);
INSERT INTO public.europe_data VALUES (7159, 5218, 151706, 92.35, 101, 35);
INSERT INTO public.europe_data VALUES (7160, 0, 2, 3.82, 102, 35);
INSERT INTO public.europe_data VALUES (7161, 0, 3, 0.72, 103, 35);
INSERT INTO public.europe_data VALUES (7162, 2, 751, 4.37, 144, 35);
INSERT INTO public.europe_data VALUES (7163, 3, 601, 5.15, 104, 35);
INSERT INTO public.europe_data VALUES (7164, 0, 3, 0.01, 145, 35);
INSERT INTO public.europe_data VALUES (7165, 0, 0, 0, 53, 35);
INSERT INTO public.europe_data VALUES (7166, 52, 242, 1.39, 146, 35);
INSERT INTO public.europe_data VALUES (7167, 4, 204, 1.69, 54, 35);
INSERT INTO public.europe_data VALUES (7168, 0, 101, 1.4, 55, 35);
INSERT INTO public.europe_data VALUES (7169, 100, 5137, 25.66, 105, 36);
INSERT INTO public.europe_data VALUES (7170, 1, 109, 8.66, 147, 36);
INSERT INTO public.europe_data VALUES (7171, 54, 760, 4.29, 1, 36);
INSERT INTO public.europe_data VALUES (7172, 0, 88, 116.83, 148, 36);
INSERT INTO public.europe_data VALUES (7173, 0, 5, 0.07, 2, 36);
INSERT INTO public.europe_data VALUES (7174, 0, 0, 0, 56, 36);
INSERT INTO public.europe_data VALUES (7175, 0, 1, 1.03, 57, 36);
INSERT INTO public.europe_data VALUES (7176, 125, 5943, 23.93, 58, 36);
INSERT INTO public.europe_data VALUES (7177, 72, 3833, 210.03, 149, 36);
INSERT INTO public.europe_data VALUES (7178, 0, 0, 0, 59, 36);
INSERT INTO public.europe_data VALUES (7179, 0, 65, 0.6, 202, 36);
INSERT INTO public.europe_data VALUES (7180, 4, 226, 4.84, 150, 36);
INSERT INTO public.europe_data VALUES (7181, 25, 2059, 34.15, 151, 36);
INSERT INTO public.europe_data VALUES (7182, 0, 1, 0.77, 60, 36);
INSERT INTO public.europe_data VALUES (7183, 7, 3365, 342.74, 106, 36);
INSERT INTO public.europe_data VALUES (7184, 238, 18616, 19.72, 107, 36);
INSERT INTO public.europe_data VALUES (7185, 0, 0, 0, 61, 36);
INSERT INTO public.europe_data VALUES (7186, 34, 6074, 131.52, 152, 36);
INSERT INTO public.europe_data VALUES (7187, 113, 847, 17.38, 153, 36);
INSERT INTO public.europe_data VALUES (7188, 0, 0, 0, 62, 36);
INSERT INTO public.europe_data VALUES (7189, 1, 36, 0.65, 3, 36);
INSERT INTO public.europe_data VALUES (7190, 0, 1, 12.8, 63, 36);
INSERT INTO public.europe_data VALUES (7191, 0, 16, 4.19, 108, 36);
INSERT INTO public.europe_data VALUES (7192, 152, 3661, 64.1, 64, 36);
INSERT INTO public.europe_data VALUES (7193, 0, 0, 0, 65, 36);
INSERT INTO public.europe_data VALUES (7194, 7, 164, 8.27, 154, 36);
INSERT INTO public.europe_data VALUES (7195, 0, 2, 0.22, 4, 36);
INSERT INTO public.europe_data VALUES (7196, 7141, 176909, 155.67, 66, 36);
INSERT INTO public.europe_data VALUES (7197, 0, 0, 0, 67, 36);
INSERT INTO public.europe_data VALUES (7198, 0, 0, 0, 109, 36);
INSERT INTO public.europe_data VALUES (7199, 20, 214, 4.2, 155, 36);
INSERT INTO public.europe_data VALUES (7200, 0, 8, 0.28, 5, 36);
INSERT INTO public.europe_data VALUES (7201, 0, 20, 0.36, 6, 36);
INSERT INTO public.europe_data VALUES (7202, 0, 1, 0.01, 110, 36);
INSERT INTO public.europe_data VALUES (7203, 12, 2004, 11.66, 7, 36);
INSERT INTO public.europe_data VALUES (7204, 505, 4752, 29.4, 68, 36);
INSERT INTO public.europe_data VALUES (7205, 1, 119, 31.64, 8, 36);
INSERT INTO public.europe_data VALUES (7206, 0, 23, 53.89, 69, 36);
INSERT INTO public.europe_data VALUES (7207, 3, 623, 21.71, 9, 36);
INSERT INTO public.europe_data VALUES (7208, 4, 59, 1.02, 10, 36);
INSERT INTO public.europe_data VALUES (7209, 1136, 34462, 343.22, 70, 36);
INSERT INTO public.europe_data VALUES (7210, 0, 44, 0.01, 111, 36);
INSERT INTO public.europe_data VALUES (7211, 320, 9853, 35.88, 71, 36);
INSERT INTO public.europe_data VALUES (7212, 0, 35, 6.35, 11, 36);
INSERT INTO public.europe_data VALUES (7213, 2, 72, 3.64, 12, 36);
INSERT INTO public.europe_data VALUES (7214, 0, 262, 7.69, 72, 36);
INSERT INTO public.europe_data VALUES (7215, 3, 906, 5.3, 13, 36);
INSERT INTO public.europe_data VALUES (7216, 1, 1, 0.07, 156, 36);
INSERT INTO public.europe_data VALUES (7217, 0, 146, 2.21, 73, 36);
INSERT INTO public.europe_data VALUES (7218, 0, 2, 2.45, 74, 36);
INSERT INTO public.europe_data VALUES (7219, 1, 20, 3.31, 157, 36);
INSERT INTO public.europe_data VALUES (7220, 7, 355, 6.3, 158, 36);
INSERT INTO public.europe_data VALUES (7221, 14, 967, 1.98, 14, 36);
INSERT INTO public.europe_data VALUES (7222, 15, 279, 10.13, 159, 36);
INSERT INTO public.europe_data VALUES (7223, 4, 853, 198.96, 15, 36);
INSERT INTO public.europe_data VALUES (7224, 0, 2, 2.79, 75, 36);
INSERT INTO public.europe_data VALUES (7225, 36, 2315, 48.22, 76, 36);
INSERT INTO public.europe_data VALUES (7226, 263, 4022, 36.63, 77, 36);
INSERT INTO public.europe_data VALUES (7227, 278, 9094, 16.75, 16, 36);
INSERT INTO public.europe_data VALUES (7228, 9, 498, 17.04, 78, 36);
INSERT INTO public.europe_data VALUES (7229, 0, 0, 19.4, 17, 36);
INSERT INTO public.europe_data VALUES (7230, 0, 2, 0.06, 18, 36);
INSERT INTO public.europe_data VALUES (7231, 0, 70, 8.76, 160, 36);
INSERT INTO public.europe_data VALUES (7232, 1, 48, 7.23, 19, 36);
INSERT INTO public.europe_data VALUES (7233, 16, 848, 1.28, 20, 36);
INSERT INTO public.europe_data VALUES (7234, 0, 0, 0, 79, 36);
INSERT INTO public.europe_data VALUES (7235, 0, 0, 0, 161, 36);
INSERT INTO public.europe_data VALUES (7236, 0, 0, 0, 203, 36);
INSERT INTO public.europe_data VALUES (7237, 3, 122, 7.29, 162, 36);
INSERT INTO public.europe_data VALUES (7238, 353, 2224, 13.51, 163, 36);
INSERT INTO public.europe_data VALUES (7239, 0, 0, 0, 204, 36);
INSERT INTO public.europe_data VALUES (7240, 4, 446, 53.71, 21, 36);
INSERT INTO public.europe_data VALUES (7241, 0, 1, 0.04, 22, 36);
INSERT INTO public.europe_data VALUES (7242, 1, 25, 1.95, 164, 36);
INSERT INTO public.europe_data VALUES (7243, 163, 2378, 6.77, 165, 36);
INSERT INTO public.europe_data VALUES (7244, 8, 1568, 9.71, 23, 36);
INSERT INTO public.europe_data VALUES (7245, 0, 6, 71.2, 166, 36);
INSERT INTO public.europe_data VALUES (7246, 5, 80, 1.11, 167, 36);
INSERT INTO public.europe_data VALUES (7247, 0, 0, 3.53, 80, 36);
INSERT INTO public.europe_data VALUES (7248, 0, 0, 0.89, 81, 36);
INSERT INTO public.europe_data VALUES (7249, 0, 4, 7.77, 205, 36);
INSERT INTO public.europe_data VALUES (7250, 144, 1968, 20.65, 82, 36);
INSERT INTO public.europe_data VALUES (7251, 0, 0, 0, 168, 36);
INSERT INTO public.europe_data VALUES (7252, 0, 394, 6.97, 24, 36);
INSERT INTO public.europe_data VALUES (7253, 4, 46, 10.15, 25, 36);
INSERT INTO public.europe_data VALUES (7254, 0, 1, 2.43, 83, 36);
INSERT INTO public.europe_data VALUES (7255, 7, 1210, 21.1, 84, 36);
INSERT INTO public.europe_data VALUES (7256, 0, 0, 0, 169, 36);
INSERT INTO public.europe_data VALUES (7257, 46, 1125, 24.39, 85, 36);
INSERT INTO public.europe_data VALUES (7258, 16, 94, 2.19, 170, 36);
INSERT INTO public.europe_data VALUES (7259, 0, 1, 0.84, 171, 36);
INSERT INTO public.europe_data VALUES (7260, 1741, 66076, 8.62, 112, 36);
INSERT INTO public.europe_data VALUES (7261, 238, 4713, 3.29, 113, 36);
INSERT INTO public.europe_data VALUES (7262, 484, 20323, 43.52, 114, 36);
INSERT INTO public.europe_data VALUES (7263, 141, 5927, 20.09, 115, 36);
INSERT INTO public.europe_data VALUES (7264, 29, 211, 11.46, 172, 36);
INSERT INTO public.europe_data VALUES (7265, 0, 0, 0, 173, 36);
INSERT INTO public.europe_data VALUES (7266, 13, 844, 14.03, 116, 36);
INSERT INTO public.europe_data VALUES (7267, 484, 1979, 8.52, 174, 36);
INSERT INTO public.europe_data VALUES (7268, 1, 12, 1.56, 86, 36);
INSERT INTO public.europe_data VALUES (7269, 24, 290, 0.47, 117, 36);
INSERT INTO public.europe_data VALUES (7270, 1, 3, 4.64, 175, 36);
INSERT INTO public.europe_data VALUES (7271, 0, 69, 0.99, 118, 36);
INSERT INTO public.europe_data VALUES (7272, 15, 1551, 23.33, 119, 36);
INSERT INTO public.europe_data VALUES (7273, 20, 805, 2.95, 26, 36);
INSERT INTO public.europe_data VALUES (7274, 1, 151, 11.23, 176, 36);
INSERT INTO public.europe_data VALUES (7275, 52, 4805, 250.67, 120, 36);
INSERT INTO public.europe_data VALUES (7276, 7, 215, 9.34, 121, 36);
INSERT INTO public.europe_data VALUES (7277, 0, 0, 0, 122, 36);
INSERT INTO public.europe_data VALUES (7278, 1, 22, 2.14, 177, 36);
INSERT INTO public.europe_data VALUES (7279, 3, 111, 3.17, 123, 36);
INSERT INTO public.europe_data VALUES (7280, 0, 2, 0.09, 27, 36);
INSERT INTO public.europe_data VALUES (7281, 3, 71, 1.9, 28, 36);
INSERT INTO public.europe_data VALUES (7282, 0, 100, 2.67, 29, 36);
INSERT INTO public.europe_data VALUES (7283, 0, 0, 0, 178, 36);
INSERT INTO public.europe_data VALUES (7284, 1, 39, 3.26, 179, 36);
INSERT INTO public.europe_data VALUES (7285, 0, 21, 7.66, 180, 36);
INSERT INTO public.europe_data VALUES (7286, 3, 281, 1.95, 30, 36);
INSERT INTO public.europe_data VALUES (7287, 0, 154, 1.91, 31, 36);
INSERT INTO public.europe_data VALUES (7288, 2, 503, 3.37, 124, 36);
INSERT INTO public.europe_data VALUES (7289, 3, 130, 100.2, 125, 36);
INSERT INTO public.europe_data VALUES (7290, 15, 268, 2.56, 32, 36);
INSERT INTO public.europe_data VALUES (7291, 0, 11, 3.85, 181, 36);
INSERT INTO public.europe_data VALUES (7292, 20, 417, 15.69, 33, 36);
INSERT INTO public.europe_data VALUES (7293, 0, 2, 0.24, 34, 36);
INSERT INTO public.europe_data VALUES (7294, 3769, 30070, 44.49, 87, 36);
INSERT INTO public.europe_data VALUES (7295, 46, 1449, 64.48, 182, 36);
INSERT INTO public.europe_data VALUES (7296, 0, 0, 0, 183, 36);
INSERT INTO public.europe_data VALUES (7297, 0, 9, 1.64, 126, 36);
INSERT INTO public.europe_data VALUES (7298, 0, 0, 0, 184, 36);
INSERT INTO public.europe_data VALUES (7299, 0, 0, 0, 88, 36);
INSERT INTO public.europe_data VALUES (7300, 3, 417, 2.17, 35, 36);
INSERT INTO public.europe_data VALUES (7301, 0, 172, 0.76, 36, 36);
INSERT INTO public.europe_data VALUES (7302, 0, 15, 0.08, 127, 36);
INSERT INTO public.europe_data VALUES (7303, 0, 5, 0.32, 37, 36);
INSERT INTO public.europe_data VALUES (7304, 5, 1876, 9.94, 128, 36);
INSERT INTO public.europe_data VALUES (7305, 57, 1132, 13.53, 185, 36);
INSERT INTO public.europe_data VALUES (7306, 0, 1, 0.71, 208, 36);
INSERT INTO public.europe_data VALUES (7307, 0, 0, 0, 209, 36);
INSERT INTO public.europe_data VALUES (7308, 11, 550, 15.74, 89, 36);
INSERT INTO public.europe_data VALUES (7309, 1, 15, 0.12, 38, 36);
INSERT INTO public.europe_data VALUES (7310, 67, 2324, 2.31, 39, 36);
INSERT INTO public.europe_data VALUES (7311, 20, 802, 50.55, 186, 36);
INSERT INTO public.europe_data VALUES (7312, 0, 5, 8.74, 210, 36);
INSERT INTO public.europe_data VALUES (7313, 2, 93, 3.66, 187, 36);
INSERT INTO public.europe_data VALUES (7314, 28, 5445, 183.16, 129, 36);
INSERT INTO public.europe_data VALUES (7315, 524, 31211, 21.85, 130, 36);
INSERT INTO public.europe_data VALUES (7316, 0, 24, 0.98, 131, 36);
INSERT INTO public.europe_data VALUES (7317, 57, 2962, 129.5, 90, 36);
INSERT INTO public.europe_data VALUES (7318, 0, 0, 0, 211, 36);
INSERT INTO public.europe_data VALUES (7319, 0, 149, 3.88, 91, 36);
INSERT INTO public.europe_data VALUES (7320, 959, 32039, 235.48, 92, 36);
INSERT INTO public.europe_data VALUES (7321, 46, 3809, 7.27, 132, 36);
INSERT INTO public.europe_data VALUES (7322, 93, 2775, 13.79, 188, 36);
INSERT INTO public.europe_data VALUES (7323, 69, 1993, 37.66, 189, 36);
INSERT INTO public.europe_data VALUES (7324, 6, 1209, 61.23, 93, 36);
INSERT INTO public.europe_data VALUES (7325, 16, 11880, 885.43, 133, 36);
INSERT INTO public.europe_data VALUES (7326, 64, 1222, 12.41, 190, 36);
INSERT INTO public.europe_data VALUES (7327, 1166, 61830, 84.45, 191, 36);
INSERT INTO public.europe_data VALUES (7328, 1, 69, 0.89, 40, 36);
INSERT INTO public.europe_data VALUES (7329, 0, 0, 0, 94, 36);
INSERT INTO public.europe_data VALUES (7330, 0, 1, 0.55, 95, 36);
INSERT INTO public.europe_data VALUES (7331, 0, 0, 7.23, 96, 36);
INSERT INTO public.europe_data VALUES (7332, 0, 16, 63.86, 192, 36);
INSERT INTO public.europe_data VALUES (7333, 0, 31, 99.98, 41, 36);
INSERT INTO public.europe_data VALUES (7334, 209, 16653, 85.66, 134, 36);
INSERT INTO public.europe_data VALUES (7335, 7, 683, 7.86, 42, 36);
INSERT INTO public.europe_data VALUES (7336, 6, 411, 9.54, 193, 36);
INSERT INTO public.europe_data VALUES (7337, 0, 0, 0, 43, 36);
INSERT INTO public.europe_data VALUES (7338, 2, 108, 3.35, 44, 36);
INSERT INTO public.europe_data VALUES (7339, 2, 3026, 108.44, 135, 36);
INSERT INTO public.europe_data VALUES (7340, 0, 0, 0, 97, 36);
INSERT INTO public.europe_data VALUES (7341, 0, 6, 0.35, 194, 36);
INSERT INTO public.europe_data VALUES (7342, 0, 12, 0.77, 195, 36);
INSERT INTO public.europe_data VALUES (7343, 5, 358, 4.79, 45, 36);
INSERT INTO public.europe_data VALUES (7344, 315, 15602, 43.89, 46, 36);
INSERT INTO public.europe_data VALUES (7345, 2, 311, 1.19, 136, 36);
INSERT INTO public.europe_data VALUES (7346, 4, 323, 6.82, 47, 36);
INSERT INTO public.europe_data VALUES (7347, 9, 2079, 13.46, 196, 36);
INSERT INTO public.europe_data VALUES (7348, 1, 202, 3.25, 137, 36);
INSERT INTO public.europe_data VALUES (7349, 73, 1057, 5.72, 48, 36);
INSERT INTO public.europe_data VALUES (7350, 0, 99, 19.09, 98, 36);
INSERT INTO public.europe_data VALUES (7351, 245, 6021, 100.7, 197, 36);
INSERT INTO public.europe_data VALUES (7352, 4, 103, 2.68, 198, 36);
INSERT INTO public.europe_data VALUES (7353, 2, 19, 0.32, 138, 36);
INSERT INTO public.europe_data VALUES (7354, 0, 1, 0.01, 139, 36);
INSERT INTO public.europe_data VALUES (7355, 1, 722, 19.21, 140, 36);
INSERT INTO public.europe_data VALUES (7356, 1, 38, 0.11, 141, 36);
INSERT INTO public.europe_data VALUES (7357, 0, 0, 0, 142, 36);
INSERT INTO public.europe_data VALUES (7358, 0, 53, 1.41, 49, 36);
INSERT INTO public.europe_data VALUES (7359, 0, 0, 0.07, 99, 36);
INSERT INTO public.europe_data VALUES (7360, 1, 10, 0.31, 50, 36);
INSERT INTO public.europe_data VALUES (7361, 152, 6190, 16.22, 199, 36);
INSERT INTO public.europe_data VALUES (7362, 0, 0, 0, 100, 36);
INSERT INTO public.europe_data VALUES (7363, 0, 158, 0.91, 51, 36);
INSERT INTO public.europe_data VALUES (7364, 80, 3327, 13.67, 200, 36);
INSERT INTO public.europe_data VALUES (7365, 12, 4251, 95.42, 143, 36);
INSERT INTO public.europe_data VALUES (7366, 1174, 8524, 29.16, 201, 36);
INSERT INTO public.europe_data VALUES (7367, 0, 0, 0, 52, 36);
INSERT INTO public.europe_data VALUES (7368, 6131, 152172, 90.9, 101, 36);
INSERT INTO public.europe_data VALUES (7369, 0, 2, 1.91, 102, 36);
INSERT INTO public.europe_data VALUES (7370, 1, 22, 2.2, 103, 36);
INSERT INTO public.europe_data VALUES (7371, 2, 690, 3.6, 144, 36);
INSERT INTO public.europe_data VALUES (7372, 8, 867, 4.4, 104, 36);
INSERT INTO public.europe_data VALUES (7373, 0, 3, 0.01, 145, 36);
INSERT INTO public.europe_data VALUES (7374, 0, 0, 2.92, 53, 36);
INSERT INTO public.europe_data VALUES (7375, 32, 163, 0.91, 146, 36);
INSERT INTO public.europe_data VALUES (7376, 0, 97, 1.31, 54, 36);
INSERT INTO public.europe_data VALUES (7377, 0, 104, 1.54, 55, 36);
INSERT INTO public.europe_data VALUES (7378, 39, 4623, 22.45, 105, 37);
INSERT INTO public.europe_data VALUES (7379, 1, 139, 6.67, 147, 37);
INSERT INTO public.europe_data VALUES (7380, 53, 1088, 5.52, 1, 37);
INSERT INTO public.europe_data VALUES (7381, 0, 1, 3.94, 148, 37);
INSERT INTO public.europe_data VALUES (7382, 0, 17, 0.12, 2, 37);
INSERT INTO public.europe_data VALUES (7383, 0, 0, 0, 56, 37);
INSERT INTO public.europe_data VALUES (7384, 0, 0, 0, 57, 37);
INSERT INTO public.europe_data VALUES (7385, 87, 4775, 20.2, 58, 37);
INSERT INTO public.europe_data VALUES (7386, 52, 2379, 157.86, 149, 37);
INSERT INTO public.europe_data VALUES (7387, 0, 0, 0, 59, 37);
INSERT INTO public.europe_data VALUES (7388, 0, 86, 0.6, 202, 37);
INSERT INTO public.europe_data VALUES (7389, 28, 203, 5.51, 150, 37);
INSERT INTO public.europe_data VALUES (7390, 14, 1372, 22.09, 151, 37);
INSERT INTO public.europe_data VALUES (7391, 0, 2, 1.54, 60, 37);
INSERT INTO public.europe_data VALUES (7392, 5, 2260, 270.66, 106, 37);
INSERT INTO public.europe_data VALUES (7393, 170, 13543, 15.26, 107, 37);
INSERT INTO public.europe_data VALUES (7394, 0, 0, 1.39, 61, 37);
INSERT INTO public.europe_data VALUES (7395, 36, 6358, 136.54, 152, 37);
INSERT INTO public.europe_data VALUES (7396, 160, 1144, 23.17, 153, 37);
INSERT INTO public.europe_data VALUES (7397, 0, 0, 0, 62, 37);
INSERT INTO public.europe_data VALUES (7398, 0, 41, -0.91, 3, 37);
INSERT INTO public.europe_data VALUES (7399, 0, 7, 27.2, 63, 37);
INSERT INTO public.europe_data VALUES (7400, 0, 16, 2.88, 108, 37);
INSERT INTO public.europe_data VALUES (7401, 63, 3719, 51.19, 64, 37);
INSERT INTO public.europe_data VALUES (7402, 0, 0, 3.85, 65, 37);
INSERT INTO public.europe_data VALUES (7403, 9, 109, 6.66, 154, 37);
INSERT INTO public.europe_data VALUES (7404, 0, 3, 0.56, 4, 37);
INSERT INTO public.europe_data VALUES (7405, 6648, 151638, 129.72, 66, 37);
INSERT INTO public.europe_data VALUES (7406, 0, 0, 0, 67, 37);
INSERT INTO public.europe_data VALUES (7407, 1, 0, 0, 109, 37);
INSERT INTO public.europe_data VALUES (7408, 10, 80, 3.97, 155, 37);
INSERT INTO public.europe_data VALUES (7409, 1, 49, 0.42, 5, 37);
INSERT INTO public.europe_data VALUES (7410, 0, 21, 0.18, 6, 37);
INSERT INTO public.europe_data VALUES (7411, 0, 1, 0.02, 110, 37);
INSERT INTO public.europe_data VALUES (7412, 26, 1014, 10.09, 7, 37);
INSERT INTO public.europe_data VALUES (7413, 871, 6248, 37.28, 68, 37);
INSERT INTO public.europe_data VALUES (7414, 1, 55, 19.46, 8, 37);
INSERT INTO public.europe_data VALUES (7415, 0, 12, 72.37, 69, 37);
INSERT INTO public.europe_data VALUES (7416, 1, 407, 14.41, 9, 37);
INSERT INTO public.europe_data VALUES (7417, 5, 103, 1.72, 10, 37);
INSERT INTO public.europe_data VALUES (7418, 336, 30586, 294.99, 70, 37);
INSERT INTO public.europe_data VALUES (7419, 0, 52, 0.01, 111, 37);
INSERT INTO public.europe_data VALUES (7420, 212, 8208, 27.43, 71, 37);
INSERT INTO public.europe_data VALUES (7421, 1, 19, 11.16, 11, 37);
INSERT INTO public.europe_data VALUES (7422, 4, 124, 3.7, 12, 37);
INSERT INTO public.europe_data VALUES (7423, 0, 126, 3.82, 72, 37);
INSERT INTO public.europe_data VALUES (7424, 3, 457, 2.82, 13, 37);
INSERT INTO public.europe_data VALUES (7425, 4, 2, 0.49, 156, 37);
INSERT INTO public.europe_data VALUES (7426, 1, 104, 1.53, 73, 37);
INSERT INTO public.europe_data VALUES (7427, 0, 2, 1.84, 74, 37);
INSERT INTO public.europe_data VALUES (7428, 0, 9, 3.2, 157, 37);
INSERT INTO public.europe_data VALUES (7429, 5, 316, 7.49, 158, 37);
INSERT INTO public.europe_data VALUES (7430, 4, 752, 1.84, 14, 37);
INSERT INTO public.europe_data VALUES (7431, 12, 309, 12.78, 159, 37);
INSERT INTO public.europe_data VALUES (7432, 14, 1084, 200.6, 15, 37);
INSERT INTO public.europe_data VALUES (7433, 0, 0, 0, 75, 37);
INSERT INTO public.europe_data VALUES (7434, 44, 2863, 46.29, 76, 37);
INSERT INTO public.europe_data VALUES (7435, 250, 2342, 34.05, 77, 37);
INSERT INTO public.europe_data VALUES (7436, 195, 7720, 12.71, 16, 37);
INSERT INTO public.europe_data VALUES (7437, 11, 602, 18.27, 78, 37);
INSERT INTO public.europe_data VALUES (7438, 0, 263, 52.51, 17, 37);
INSERT INTO public.europe_data VALUES (7439, 0, 0, 0, 18, 37);
INSERT INTO public.europe_data VALUES (7440, 0, 46, 7.17, 160, 37);
INSERT INTO public.europe_data VALUES (7441, 0, 35, 7.14, 19, 37);
INSERT INTO public.europe_data VALUES (7442, 6, 590, 0.76, 20, 37);
INSERT INTO public.europe_data VALUES (7443, 0, 0, 0, 79, 37);
INSERT INTO public.europe_data VALUES (7444, 0, 0, 0, 161, 37);
INSERT INTO public.europe_data VALUES (7445, 0, 0, 0, 203, 37);
INSERT INTO public.europe_data VALUES (7446, 13, 280, 9.28, 162, 37);
INSERT INTO public.europe_data VALUES (7447, 435, 6832, 13.94, 163, 37);
INSERT INTO public.europe_data VALUES (7448, 0, 0, 0, 204, 37);
INSERT INTO public.europe_data VALUES (7449, 5, 721, 61.45, 21, 37);
INSERT INTO public.europe_data VALUES (7450, 0, 0, 0.09, 22, 37);
INSERT INTO public.europe_data VALUES (7451, 0, 53, 2.05, 164, 37);
INSERT INTO public.europe_data VALUES (7452, 254, 3245, 8.57, 165, 37);
INSERT INTO public.europe_data VALUES (7453, 4, 1387, 7.68, 23, 37);
INSERT INTO public.europe_data VALUES (7454, 0, 18, 65.27, 166, 37);
INSERT INTO public.europe_data VALUES (7455, 4, 39, 0.77, 167, 37);
INSERT INTO public.europe_data VALUES (7456, 0, 2, 3.53, 80, 37);
INSERT INTO public.europe_data VALUES (7457, 0, 1, 0.89, 81, 37);
INSERT INTO public.europe_data VALUES (7458, 0, 9, 12.55, 205, 37);
INSERT INTO public.europe_data VALUES (7459, 50, 1663, 18.06, 82, 37);
INSERT INTO public.europe_data VALUES (7460, 0, 0, 0, 168, 37);
INSERT INTO public.europe_data VALUES (7461, 3, 496, 8.71, 24, 37);
INSERT INTO public.europe_data VALUES (7462, 2, 149, 17.28, 25, 37);
INSERT INTO public.europe_data VALUES (7463, 2, 18, 4.6, 83, 37);
INSERT INTO public.europe_data VALUES (7464, 17, 1166, 14.81, 84, 37);
INSERT INTO public.europe_data VALUES (7465, 0, 0, 0, 169, 37);
INSERT INTO public.europe_data VALUES (7466, 32, 1252, 26.23, 85, 37);
INSERT INTO public.europe_data VALUES (7467, 35, 120, 3.49, 170, 37);
INSERT INTO public.europe_data VALUES (7468, 0, 2, 1.12, 171, 37);
INSERT INTO public.europe_data VALUES (7469, 1373, 51690, 6.91, 112, 37);
INSERT INTO public.europe_data VALUES (7470, 241, 4202, 3.31, 113, 37);
INSERT INTO public.europe_data VALUES (7471, 380, 15765, 37.71, 114, 37);
INSERT INTO public.europe_data VALUES (7472, 45, 1970, 7.72, 115, 37);
INSERT INTO public.europe_data VALUES (7473, 44, 351, 17.9, 172, 37);
INSERT INTO public.europe_data VALUES (7474, 0, 0, 1.18, 173, 37);
INSERT INTO public.europe_data VALUES (7475, 5, 351, 5.33, 116, 37);
INSERT INTO public.europe_data VALUES (7476, 630, 3161, 12.56, 174, 37);
INSERT INTO public.europe_data VALUES (7477, 0, 34, 2.24, 86, 37);
INSERT INTO public.europe_data VALUES (7478, 62, 303, 0.46, 117, 37);
INSERT INTO public.europe_data VALUES (7479, 0, 2, 5.57, 175, 37);
INSERT INTO public.europe_data VALUES (7480, 0, 31, 1.25, 118, 37);
INSERT INTO public.europe_data VALUES (7481, 6, 2777, 26.24, 119, 37);
INSERT INTO public.europe_data VALUES (7482, 13, 748, 2.04, 26, 37);
INSERT INTO public.europe_data VALUES (7483, 1, 51, 5.45, 176, 37);
INSERT INTO public.europe_data VALUES (7484, 56, 5741, 289.82, 120, 37);
INSERT INTO public.europe_data VALUES (7485, 0, 384, 9.37, 121, 37);
INSERT INTO public.europe_data VALUES (7486, 0, 0, 0, 122, 37);
INSERT INTO public.europe_data VALUES (7487, 2, 19, 3.02, 177, 37);
INSERT INTO public.europe_data VALUES (7488, 1, 106, 4.51, 123, 37);
INSERT INTO public.europe_data VALUES (7489, 0, 0, 0.05, 27, 37);
INSERT INTO public.europe_data VALUES (7490, 1, 23, 1.26, 28, 37);
INSERT INTO public.europe_data VALUES (7491, 2, 81, 1.34, 29, 37);
INSERT INTO public.europe_data VALUES (7492, 0, 0, 0, 178, 37);
INSERT INTO public.europe_data VALUES (7493, 7, 52, 4.8, 179, 37);
INSERT INTO public.europe_data VALUES (7494, 0, 26, 11.89, 180, 37);
INSERT INTO public.europe_data VALUES (7495, 4, 244, 1.73, 30, 37);
INSERT INTO public.europe_data VALUES (7496, 0, 201, 1.15, 31, 37);
INSERT INTO public.europe_data VALUES (7497, 0, 574, 2.9, 124, 37);
INSERT INTO public.europe_data VALUES (7498, 1, 402, 127.88, 125, 37);
INSERT INTO public.europe_data VALUES (7499, 12, 235, 2.06, 32, 37);
INSERT INTO public.europe_data VALUES (7500, 3, 8, 12.36, 181, 37);
INSERT INTO public.europe_data VALUES (7501, 17, 293, 10.34, 33, 37);
INSERT INTO public.europe_data VALUES (7502, 0, 1, 0.24, 34, 37);
INSERT INTO public.europe_data VALUES (7503, 2536, 26685, 39.34, 87, 37);
INSERT INTO public.europe_data VALUES (7504, 45, 1158, 54.19, 182, 37);
INSERT INTO public.europe_data VALUES (7505, 0, 0, 3.02, 183, 37);
INSERT INTO public.europe_data VALUES (7506, 0, 44, 1.4, 126, 37);
INSERT INTO public.europe_data VALUES (7507, 0, 0, 0, 184, 37);
INSERT INTO public.europe_data VALUES (7508, 0, 0, 0, 88, 37);
INSERT INTO public.europe_data VALUES (7509, 6, 374, 2.57, 35, 37);
INSERT INTO public.europe_data VALUES (7510, 2, 60, 0.39, 36, 37);
INSERT INTO public.europe_data VALUES (7511, 0, 27, 0.08, 127, 37);
INSERT INTO public.europe_data VALUES (7512, 0, 3, 0.32, 37, 37);
INSERT INTO public.europe_data VALUES (7513, 5, 969, 4.43, 128, 37);
INSERT INTO public.europe_data VALUES (7514, 134, 1206, 14.16, 185, 37);
INSERT INTO public.europe_data VALUES (7515, 0, 1, 0.35, 208, 37);
INSERT INTO public.europe_data VALUES (7516, 1, 0, 0.1, 209, 37);
INSERT INTO public.europe_data VALUES (7517, 18, 480, 11.21, 89, 37);
INSERT INTO public.europe_data VALUES (7518, 3, 13, 0.23, 38, 37);
INSERT INTO public.europe_data VALUES (7519, 61, 2323, 2.09, 39, 37);
INSERT INTO public.europe_data VALUES (7520, 20, 248, 20.89, 186, 37);
INSERT INTO public.europe_data VALUES (7521, 0, 0, 1.75, 210, 37);
INSERT INTO public.europe_data VALUES (7522, 1, 102, 4.02, 187, 37);
INSERT INTO public.europe_data VALUES (7523, 10, 3667, 125.65, 129, 37);
INSERT INTO public.europe_data VALUES (7524, 376, 16111, 14.01, 130, 37);
INSERT INTO public.europe_data VALUES (7525, 0, 25, 1.34, 131, 37);
INSERT INTO public.europe_data VALUES (7526, 30, 2537, 90.83, 90, 37);
INSERT INTO public.europe_data VALUES (7527, 0, 0, 0, 211, 37);
INSERT INTO public.europe_data VALUES (7528, 0, 124, 2.84, 91, 37);
INSERT INTO public.europe_data VALUES (7529, 1050, 44517, 222.09, 92, 37);
INSERT INTO public.europe_data VALUES (7530, 89, 4051, 5.15, 132, 37);
INSERT INTO public.europe_data VALUES (7531, 68, 2460, 13.84, 188, 37);
INSERT INTO public.europe_data VALUES (7532, 94, 1877, 33.71, 189, 37);
INSERT INTO public.europe_data VALUES (7533, 9, 587, 38.52, 93, 37);
INSERT INTO public.europe_data VALUES (7534, 15, 13196, 858.24, 133, 37);
INSERT INTO public.europe_data VALUES (7535, 83, 1187, 12.29, 190, 37);
INSERT INTO public.europe_data VALUES (7536, 1152, 61362, 85.07, 191, 37);
INSERT INTO public.europe_data VALUES (7537, 1, 43, 0.62, 40, 37);
INSERT INTO public.europe_data VALUES (7538, 0, 0, 0, 94, 37);
INSERT INTO public.europe_data VALUES (7539, 0, 0, 0, 95, 37);
INSERT INTO public.europe_data VALUES (7540, 0, 8, 8.14, 96, 37);
INSERT INTO public.europe_data VALUES (7541, 0, 6, 49.34, 192, 37);
INSERT INTO public.europe_data VALUES (7542, 3, 184, 115.32, 41, 37);
INSERT INTO public.europe_data VALUES (7543, 113, 12701, 89.03, 134, 37);
INSERT INTO public.europe_data VALUES (7544, 7, 598, 7.15, 42, 37);
INSERT INTO public.europe_data VALUES (7545, 5, 253, 11.52, 193, 37);
INSERT INTO public.europe_data VALUES (7546, 0, 0, 0, 43, 37);
INSERT INTO public.europe_data VALUES (7547, 6, 154, 4.56, 44, 37);
INSERT INTO public.europe_data VALUES (7548, 0, 3268, 117.95, 135, 37);
INSERT INTO public.europe_data VALUES (7549, 0, 0, 0, 97, 37);
INSERT INTO public.europe_data VALUES (7550, 0, 13, 0.51, 194, 37);
INSERT INTO public.europe_data VALUES (7551, 2, 4, 0.34, 195, 37);
INSERT INTO public.europe_data VALUES (7552, 17, 382, 3.59, 45, 37);
INSERT INTO public.europe_data VALUES (7553, 254, 10100, 29.32, 46, 37);
INSERT INTO public.europe_data VALUES (7554, 4, 297, 0.86, 136, 37);
INSERT INTO public.europe_data VALUES (7555, 4, 431, 6.44, 47, 37);
INSERT INTO public.europe_data VALUES (7556, 293, 4238, 17.11, 196, 37);
INSERT INTO public.europe_data VALUES (7557, 1, 492, 3.06, 137, 37);
INSERT INTO public.europe_data VALUES (7558, 140, 1392, 6.39, 48, 37);
INSERT INTO public.europe_data VALUES (7559, 0, 12, 2.24, 98, 37);
INSERT INTO public.europe_data VALUES (7560, 274, 4281, 77.61, 197, 37);
INSERT INTO public.europe_data VALUES (7561, 15, 126, 3.22, 198, 37);
INSERT INTO public.europe_data VALUES (7562, 0, 36, 0.37, 138, 37);
INSERT INTO public.europe_data VALUES (7563, 0, 1, 0.01, 139, 37);
INSERT INTO public.europe_data VALUES (7564, 3, 1069, 24.49, 140, 37);
INSERT INTO public.europe_data VALUES (7565, 0, 39, 0.08, 141, 37);
INSERT INTO public.europe_data VALUES (7566, 0, 0, 0, 142, 37);
INSERT INTO public.europe_data VALUES (7567, 1, 61, 1.74, 49, 37);
INSERT INTO public.europe_data VALUES (7568, 0, 1, 0.07, 99, 37);
INSERT INTO public.europe_data VALUES (7569, 0, 26, 0.34, 50, 37);
INSERT INTO public.europe_data VALUES (7570, 200, 7115, 17.69, 199, 37);
INSERT INTO public.europe_data VALUES (7571, 0, 0, 0, 100, 37);
INSERT INTO public.europe_data VALUES (7572, 0, 246, 0.52, 51, 37);
INSERT INTO public.europe_data VALUES (7573, 91, 2686, 12.23, 200, 37);
INSERT INTO public.europe_data VALUES (7574, 19, 5072, 114.62, 143, 37);
INSERT INTO public.europe_data VALUES (7575, 1488, 10907, 40.91, 201, 37);
INSERT INTO public.europe_data VALUES (7576, 0, 0, 0, 52, 37);
INSERT INTO public.europe_data VALUES (7577, 6663, 146953, 92.21, 101, 37);
INSERT INTO public.europe_data VALUES (7578, 0, 0, 0, 102, 37);
INSERT INTO public.europe_data VALUES (7579, 0, 54, 2.57, 103, 37);
INSERT INTO public.europe_data VALUES (7580, 2, 498, 2.76, 144, 37);
INSERT INTO public.europe_data VALUES (7581, 4, 389, 3.4, 104, 37);
INSERT INTO public.europe_data VALUES (7582, 0, 3, 0.01, 145, 37);
INSERT INTO public.europe_data VALUES (7583, 1, 17, 2.92, 53, 37);
INSERT INTO public.europe_data VALUES (7584, 38, 101, 0.67, 146, 37);
INSERT INTO public.europe_data VALUES (7585, 0, 137, 1.7, 54, 37);
INSERT INTO public.europe_data VALUES (7586, 0, 122, 0.9, 55, 37);
INSERT INTO public.europe_data VALUES (7587, 49, 3918, 16.25, 105, 38);
INSERT INTO public.europe_data VALUES (7588, 1, 52, 4.54, 147, 38);
INSERT INTO public.europe_data VALUES (7589, 52, 1287, 6, 1, 38);
INSERT INTO public.europe_data VALUES (7590, 0, 2, 10.5, 148, 38);
INSERT INTO public.europe_data VALUES (7591, 2, 21, 0.08, 2, 38);
INSERT INTO public.europe_data VALUES (7592, 0, 0, 0, 56, 38);
INSERT INTO public.europe_data VALUES (7593, 0, 0, 0, 57, 38);
INSERT INTO public.europe_data VALUES (7594, 86, 4271, 14.04, 58, 38);
INSERT INTO public.europe_data VALUES (7595, 26, 2290, 125.81, 149, 38);
INSERT INTO public.europe_data VALUES (7596, 0, 0, 0, 59, 38);
INSERT INTO public.europe_data VALUES (7597, 4, 64, 0.67, 202, 38);
INSERT INTO public.europe_data VALUES (7598, 11, 285, 7.36, 150, 38);
INSERT INTO public.europe_data VALUES (7599, 10, 848, 15.95, 151, 38);
INSERT INTO public.europe_data VALUES (7600, 0, 4, 2.05, 60, 38);
INSERT INTO public.europe_data VALUES (7601, 2, 2182, 255.73, 106, 38);
INSERT INTO public.europe_data VALUES (7602, 152, 11342, 11.62, 107, 38);
INSERT INTO public.europe_data VALUES (7603, 0, 4, 2.79, 61, 38);
INSERT INTO public.europe_data VALUES (7604, 34, 6548, 139.91, 152, 38);
INSERT INTO public.europe_data VALUES (7605, 230, 1510, 31.26, 153, 38);
INSERT INTO public.europe_data VALUES (7606, 0, 0, 0, 62, 38);
INSERT INTO public.europe_data VALUES (7607, 1, -148, -1.08, 3, 38);
INSERT INTO public.europe_data VALUES (7608, 0, 10, 24, 63, 38);
INSERT INTO public.europe_data VALUES (7609, 0, 6, 2.36, 108, 38);
INSERT INTO public.europe_data VALUES (7610, 81, 2175, 32.2, 64, 38);
INSERT INTO public.europe_data VALUES (7611, 0, 1, 3.85, 65, 38);
INSERT INTO public.europe_data VALUES (7612, 11, 111, 8.57, 154, 38);
INSERT INTO public.europe_data VALUES (7613, 0, 10, 0.52, 4, 38);
INSERT INTO public.europe_data VALUES (7614, 6548, 122131, 95.01, 66, 38);
INSERT INTO public.europe_data VALUES (7615, 0, 0, 3.33, 67, 38);
INSERT INTO public.europe_data VALUES (7616, 0, 0, 0, 109, 38);
INSERT INTO public.europe_data VALUES (7617, 20, 198, 6.69, 155, 38);
INSERT INTO public.europe_data VALUES (7618, 1, 36, 0.4, 5, 38);
INSERT INTO public.europe_data VALUES (7619, 0, 0, 0.2, 6, 38);
INSERT INTO public.europe_data VALUES (7620, 0, 2, 0.01, 110, 38);
INSERT INTO public.europe_data VALUES (7621, 25, 1598, 8.93, 7, 38);
INSERT INTO public.europe_data VALUES (7622, 642, 7697, 42.34, 68, 38);
INSERT INTO public.europe_data VALUES (7623, 0, 52, 24.37, 8, 38);
INSERT INTO public.europe_data VALUES (7624, 0, 35, 73.91, 69, 38);
INSERT INTO public.europe_data VALUES (7625, 1, 277, 8.96, 9, 38);
INSERT INTO public.europe_data VALUES (7626, 7, 172, 2.21, 10, 38);
INSERT INTO public.europe_data VALUES (7627, 268, 25321, 212.3, 70, 38);
INSERT INTO public.europe_data VALUES (7628, 0, 41, 0.01, 111, 38);
INSERT INTO public.europe_data VALUES (7629, 153, 5601, 20.09, 71, 38);
INSERT INTO public.europe_data VALUES (7630, 0, 76, 8.93, 11, 38);
INSERT INTO public.europe_data VALUES (7631, 1, 75, 3.72, 12, 38);
INSERT INTO public.europe_data VALUES (7632, 0, 67, 2.73, 72, 38);
INSERT INTO public.europe_data VALUES (7633, 3, 267, 2.63, 13, 38);
INSERT INTO public.europe_data VALUES (7634, 4, 18, 1.4, 156, 38);
INSERT INTO public.europe_data VALUES (7635, 3, 69, 1.54, 73, 38);
INSERT INTO public.europe_data VALUES (7636, 0, 1, 0.61, 74, 38);
INSERT INTO public.europe_data VALUES (7637, 0, 19, 4.22, 157, 38);
INSERT INTO public.europe_data VALUES (7638, 18, 482, 7.83, 158, 38);
INSERT INTO public.europe_data VALUES (7639, 7, 843, 1.47, 14, 38);
INSERT INTO public.europe_data VALUES (7640, 15, 433, 16.03, 159, 38);
INSERT INTO public.europe_data VALUES (7641, 6, 869, 108.88, 15, 38);
INSERT INTO public.europe_data VALUES (7642, 0, 0, 0, 75, 38);
INSERT INTO public.europe_data VALUES (7643, 30, 2108, 37.95, 76, 38);
INSERT INTO public.europe_data VALUES (7644, 372, 3574, 41.42, 77, 38);
INSERT INTO public.europe_data VALUES (7645, 134, 5036, 7.83, 16, 38);
INSERT INTO public.europe_data VALUES (7646, 5, 577, 14.83, 78, 38);
INSERT INTO public.europe_data VALUES (7647, 5, 449, 44.54, 17, 38);
INSERT INTO public.europe_data VALUES (7648, 0, 0, 0, 18, 38);
INSERT INTO public.europe_data VALUES (7649, 0, 49, 6.34, 160, 38);
INSERT INTO public.europe_data VALUES (7650, 0, 47, 6.79, 19, 38);
INSERT INTO public.europe_data VALUES (7651, 0, 265, 0.31, 20, 38);
INSERT INTO public.europe_data VALUES (7652, 0, 0, 0, 79, 38);
INSERT INTO public.europe_data VALUES (7653, 0, 0, 0, 161, 38);
INSERT INTO public.europe_data VALUES (7654, 0, 0, 0, 203, 38);
INSERT INTO public.europe_data VALUES (7655, 9, 232, 11.18, 162, 38);
INSERT INTO public.europe_data VALUES (7656, 656, 2510, 8.74, 163, 38);
INSERT INTO public.europe_data VALUES (7657, 0, 0, 0, 204, 38);
INSERT INTO public.europe_data VALUES (7658, 1, 614, 58.59, 21, 38);
INSERT INTO public.europe_data VALUES (7659, 0, 2, 0.21, 22, 38);
INSERT INTO public.europe_data VALUES (7660, 0, 29, 2.38, 164, 38);
INSERT INTO public.europe_data VALUES (7661, 322, 3873, 10.83, 165, 38);
INSERT INTO public.europe_data VALUES (7662, 3, 948, 7.96, 23, 38);
INSERT INTO public.europe_data VALUES (7663, 0, 4, 14.83, 166, 38);
INSERT INTO public.europe_data VALUES (7664, 8, 44, 1.51, 167, 38);
INSERT INTO public.europe_data VALUES (7665, 0, 0, 0, 80, 38);
INSERT INTO public.europe_data VALUES (7666, 0, 0, 0.89, 81, 38);
INSERT INTO public.europe_data VALUES (7667, 0, 12, 8.97, 205, 38);
INSERT INTO public.europe_data VALUES (7668, 23, 1512, 13.49, 82, 38);
INSERT INTO public.europe_data VALUES (7669, 0, 0, 0, 168, 38);
INSERT INTO public.europe_data VALUES (7670, 4, 617, 8.84, 24, 38);
INSERT INTO public.europe_data VALUES (7671, 2, 183, 23.27, 25, 38);
INSERT INTO public.europe_data VALUES (7672, 0, 18, 3.96, 83, 38);
INSERT INTO public.europe_data VALUES (7673, 7, 502, 6.89, 84, 38);
INSERT INTO public.europe_data VALUES (7674, 0, 0, 0, 169, 38);
INSERT INTO public.europe_data VALUES (7675, 38, 1304, 20.3, 85, 38);
INSERT INTO public.europe_data VALUES (7676, 29, 221, 4.83, 170, 38);
INSERT INTO public.europe_data VALUES (7677, 0, 2, 0.84, 171, 38);
INSERT INTO public.europe_data VALUES (7678, 992, 42676, 5.25, 112, 38);
INSERT INTO public.europe_data VALUES (7679, 224, 4757, 3.04, 113, 38);
INSERT INTO public.europe_data VALUES (7680, 429, 15503, 33.89, 114, 38);
INSERT INTO public.europe_data VALUES (7681, 37, 1065, 4.33, 115, 38);
INSERT INTO public.europe_data VALUES (7682, 63, 527, 33.5, 172, 38);
INSERT INTO public.europe_data VALUES (7683, 0, 1, 7.09, 173, 38);
INSERT INTO public.europe_data VALUES (7684, 8, 103, 2.85, 116, 38);
INSERT INTO public.europe_data VALUES (7685, 877, 4423, 17.87, 174, 38);
INSERT INTO public.europe_data VALUES (7686, 0, 32, 1.7, 86, 38);
INSERT INTO public.europe_data VALUES (7687, 81, 276, 0.62, 117, 38);
INSERT INTO public.europe_data VALUES (7688, 2, 4, 11.13, 175, 38);
INSERT INTO public.europe_data VALUES (7689, 0, 95, 1.66, 118, 38);
INSERT INTO public.europe_data VALUES (7690, 1, 2091, 18.35, 119, 38);
INSERT INTO public.europe_data VALUES (7691, 1, 327, 1.03, 26, 38);
INSERT INTO public.europe_data VALUES (7692, 0, 47, 8.23, 176, 38);
INSERT INTO public.europe_data VALUES (7693, 44, 6452, 299.83, 120, 38);
INSERT INTO public.europe_data VALUES (7694, 2, 217, 6.5, 121, 38);
INSERT INTO public.europe_data VALUES (7695, 0, 0, 0, 122, 38);
INSERT INTO public.europe_data VALUES (7696, 3, 39, 5.63, 177, 38);
INSERT INTO public.europe_data VALUES (7697, 0, 203, 3.92, 123, 38);
INSERT INTO public.europe_data VALUES (7698, 0, 1, 0.09, 27, 38);
INSERT INTO public.europe_data VALUES (7699, 5, 39, 1.34, 28, 38);
INSERT INTO public.europe_data VALUES (7700, 0, 10, 0.16, 29, 38);
INSERT INTO public.europe_data VALUES (7701, 0, 0, 0, 178, 38);
INSERT INTO public.europe_data VALUES (7702, 7, 82, 5.15, 179, 38);
INSERT INTO public.europe_data VALUES (7703, 3, 47, 17.27, 180, 38);
INSERT INTO public.europe_data VALUES (7704, 1, 223, 1.32, 30, 38);
INSERT INTO public.europe_data VALUES (7705, 1, 13, 0.14, 31, 38);
INSERT INTO public.europe_data VALUES (7706, 2, 351, 1.84, 124, 38);
INSERT INTO public.europe_data VALUES (7707, 0, 277, 100.95, 125, 38);
INSERT INTO public.europe_data VALUES (7708, 13, 170, 1.66, 32, 38);
INSERT INTO public.europe_data VALUES (7709, 0, 53, 21.88, 181, 38);
INSERT INTO public.europe_data VALUES (7710, 2, 175, 5.06, 33, 38);
INSERT INTO public.europe_data VALUES (7711, 0, 2, 0.16, 34, 38);
INSERT INTO public.europe_data VALUES (7712, 2217, 23497, 33.48, 87, 38);
INSERT INTO public.europe_data VALUES (7713, 39, 1033, 53.57, 182, 38);
INSERT INTO public.europe_data VALUES (7714, 0, 1, 3.02, 183, 38);
INSERT INTO public.europe_data VALUES (7715, 0, 1, 3.07, 126, 38);
INSERT INTO public.europe_data VALUES (7716, 0, 0, 0, 184, 38);
INSERT INTO public.europe_data VALUES (7717, 0, 0, 0, 88, 38);
INSERT INTO public.europe_data VALUES (7718, 7, 563, 3.76, 35, 38);
INSERT INTO public.europe_data VALUES (7719, 0, 57, 0.34, 36, 38);
INSERT INTO public.europe_data VALUES (7720, 0, 14, 0.04, 127, 38);
INSERT INTO public.europe_data VALUES (7721, 0, 5, 0.2, 37, 38);
INSERT INTO public.europe_data VALUES (7722, 1, 299, 1.69, 128, 38);
INSERT INTO public.europe_data VALUES (7723, 142, 1241, 15.1, 185, 38);
INSERT INTO public.europe_data VALUES (7724, 0, 0, 0, 208, 38);
INSERT INTO public.europe_data VALUES (7725, 0, 5, 0.15, 209, 38);
INSERT INTO public.europe_data VALUES (7726, 9, 254, 4.02, 89, 38);
INSERT INTO public.europe_data VALUES (7727, 7, 41, 0.53, 38, 38);
INSERT INTO public.europe_data VALUES (7728, 44, 1880, 1.71, 39, 38);
INSERT INTO public.europe_data VALUES (7729, 12, 186, 16.18, 186, 38);
INSERT INTO public.europe_data VALUES (7730, 0, 1, 10.49, 210, 38);
INSERT INTO public.europe_data VALUES (7731, 3, 112, 3.94, 187, 38);
INSERT INTO public.europe_data VALUES (7732, 15, 2584, 87.86, 129, 38);
INSERT INTO public.europe_data VALUES (7733, 264, 14224, 11.73, 130, 38);
INSERT INTO public.europe_data VALUES (7734, 1, 42, 1.1, 131, 38);
INSERT INTO public.europe_data VALUES (7735, 31, 1320, 58.35, 90, 38);
INSERT INTO public.europe_data VALUES (7736, 0, 0, 0, 211, 38);
INSERT INTO public.europe_data VALUES (7737, 0, 76, 2.12, 91, 38);
INSERT INTO public.europe_data VALUES (7738, 808, 27686, 161.95, 92, 38);
INSERT INTO public.europe_data VALUES (7739, 44, 1522, 3, 132, 38);
INSERT INTO public.europe_data VALUES (7740, 71, 2797, 14.04, 188, 38);
INSERT INTO public.europe_data VALUES (7741, 98, 1587, 29.6, 189, 38);
INSERT INTO public.europe_data VALUES (7742, 4, 543, 33.78, 93, 38);
INSERT INTO public.europe_data VALUES (7743, 8, 11110, 748.36, 133, 38);
INSERT INTO public.europe_data VALUES (7744, 82, 1199, 13.95, 190, 38);
INSERT INTO public.europe_data VALUES (7745, 910, 62729, 92.4, 191, 38);
INSERT INTO public.europe_data VALUES (7746, 0, 35, 0.34, 40, 38);
INSERT INTO public.europe_data VALUES (7747, 0, 0, 0, 94, 38);
INSERT INTO public.europe_data VALUES (7748, 0, 0, 0, 95, 38);
INSERT INTO public.europe_data VALUES (7749, 0, 1, 0.9, 96, 38);
INSERT INTO public.europe_data VALUES (7750, 1, 11, 107.39, 192, 38);
INSERT INTO public.europe_data VALUES (7751, 2, 64, 42.32, 41, 38);
INSERT INTO public.europe_data VALUES (7752, 78, 17808, 97.79, 134, 38);
INSERT INTO public.europe_data VALUES (7753, 9, 567, 8.21, 42, 38);
INSERT INTO public.europe_data VALUES (7754, 8, 549, 15.01, 193, 38);
INSERT INTO public.europe_data VALUES (7755, 0, 0, 0, 43, 38);
INSERT INTO public.europe_data VALUES (7756, 8, 202, 5.12, 44, 38);
INSERT INTO public.europe_data VALUES (7757, 1, 3578, 142.65, 135, 38);
INSERT INTO public.europe_data VALUES (7758, 0, 0, 2.36, 97, 38);
INSERT INTO public.europe_data VALUES (7759, 0, 15, 0.95, 194, 38);
INSERT INTO public.europe_data VALUES (7760, 2, 3, 0.43, 195, 38);
INSERT INTO public.europe_data VALUES (7761, 5, 173, 3.5, 45, 38);
INSERT INTO public.europe_data VALUES (7762, 165, 7068, 21.46, 46, 38);
INSERT INTO public.europe_data VALUES (7763, 4, 141, 0.58, 136, 38);
INSERT INTO public.europe_data VALUES (7764, 2, 281, 3.68, 47, 38);
INSERT INTO public.europe_data VALUES (7765, -875, 3794, 16.26, 196, 38);
INSERT INTO public.europe_data VALUES (7766, 0, 160, 1.3, 137, 38);
INSERT INTO public.europe_data VALUES (7767, 49, 1345, 5.3, 48, 38);
INSERT INTO public.europe_data VALUES (7768, 0, 1, 0.17, 98, 38);
INSERT INTO public.europe_data VALUES (7769, 360, 3659, 73.59, 197, 38);
INSERT INTO public.europe_data VALUES (7770, 39, 149, 5.04, 198, 38);
INSERT INTO public.europe_data VALUES (7771, 1, 28, 0.23, 138, 38);
INSERT INTO public.europe_data VALUES (7772, 0, 1, 0, 139, 38);
INSERT INTO public.europe_data VALUES (7773, 5, 1214, 22.81, 140, 38);
INSERT INTO public.europe_data VALUES (7774, 1, 14, 0.04, 141, 38);
INSERT INTO public.europe_data VALUES (7775, 0, 0, 0, 142, 38);
INSERT INTO public.europe_data VALUES (7776, 1, 80, 2.56, 49, 38);
INSERT INTO public.europe_data VALUES (7777, 0, 0, 0, 99, 38);
INSERT INTO public.europe_data VALUES (7778, 3, 14, 0.16, 50, 38);
INSERT INTO public.europe_data VALUES (7779, 200, 7392, 22.16, 199, 38);
INSERT INTO public.europe_data VALUES (7780, 0, 0, 0, 100, 38);
INSERT INTO public.europe_data VALUES (7781, 0, -15, 0.21, 51, 38);
INSERT INTO public.europe_data VALUES (7782, 103, 2695, 13.08, 200, 38);
INSERT INTO public.europe_data VALUES (7783, 25, 6127, 115.52, 143, 38);
INSERT INTO public.europe_data VALUES (7784, 2137, 16360, 54.34, 201, 38);
INSERT INTO public.europe_data VALUES (7785, 0, 0, 0, 52, 38);
INSERT INTO public.europe_data VALUES (7786, 8158, 156481, 95.25, 101, 38);
INSERT INTO public.europe_data VALUES (7787, 0, 0, 0, 102, 38);
INSERT INTO public.europe_data VALUES (7788, 2, 35, 1.79, 103, 38);
INSERT INTO public.europe_data VALUES (7789, 1, 411, 2.26, 144, 38);
INSERT INTO public.europe_data VALUES (7790, 0, 580, 2.48, 104, 38);
INSERT INTO public.europe_data VALUES (7791, 0, 5, 0.04, 145, 38);
INSERT INTO public.europe_data VALUES (7792, 0, 0, 0, 53, 38);
INSERT INTO public.europe_data VALUES (7793, 22, 94, 0.59, 146, 38);
INSERT INTO public.europe_data VALUES (7794, 0, 167, 3.66, 54, 38);
INSERT INTO public.europe_data VALUES (7795, 0, 10, 0.14, 55, 38);
INSERT INTO public.europe_data VALUES (7796, 49, 2262, 10.41, 105, 39);
INSERT INTO public.europe_data VALUES (7797, 0, 78, 5.28, 147, 39);
INSERT INTO public.europe_data VALUES (7798, 46, 1296, 5.91, 1, 39);
INSERT INTO public.europe_data VALUES (7799, 3, 6, 17.07, 148, 39);
INSERT INTO public.europe_data VALUES (7800, 0, 3, 0.04, 2, 39);
INSERT INTO public.europe_data VALUES (7801, 0, 0, 0, 56, 39);
INSERT INTO public.europe_data VALUES (7802, 0, 0, 0, 57, 39);
INSERT INTO public.europe_data VALUES (7803, 66, 2016, 6.75, 58, 39);
INSERT INTO public.europe_data VALUES (7804, 15, 1431, 78.3, 149, 39);
INSERT INTO public.europe_data VALUES (7805, 0, 0, 0.94, 59, 39);
INSERT INTO public.europe_data VALUES (7806, 1, 104, 0.97, 202, 39);
INSERT INTO public.europe_data VALUES (7807, 11, 367, 6.95, 150, 39);
INSERT INTO public.europe_data VALUES (7808, 7, 755, 13.36, 151, 39);
INSERT INTO public.europe_data VALUES (7809, 0, 4, 3.34, 60, 39);
INSERT INTO public.europe_data VALUES (7810, 4, 2015, 217.71, 106, 39);
INSERT INTO public.europe_data VALUES (7811, 100, 7611, 7.86, 107, 39);
INSERT INTO public.europe_data VALUES (7812, 0, 4, 2.09, 61, 39);
INSERT INTO public.europe_data VALUES (7813, 34, 6677, 136.95, 152, 39);
INSERT INTO public.europe_data VALUES (7814, 314, 2071, 44.71, 153, 39);
INSERT INTO public.europe_data VALUES (7815, 0, 0, 0, 62, 39);
INSERT INTO public.europe_data VALUES (7816, 0, 20, 2.11, 3, 39);
INSERT INTO public.europe_data VALUES (7817, 2, 5, 12.8, 63, 39);
INSERT INTO public.europe_data VALUES (7818, 0, 12, 1.83, 108, 39);
INSERT INTO public.europe_data VALUES (7819, 51, 1532, 21.66, 64, 39);
INSERT INTO public.europe_data VALUES (7820, 0, 0, 0, 65, 39);
INSERT INTO public.europe_data VALUES (7821, 25, 172, 13.09, 154, 39);
INSERT INTO public.europe_data VALUES (7822, 0, 2, 0.09, 4, 39);
INSERT INTO public.europe_data VALUES (7823, 4995, 78381, 66.3, 66, 39);
INSERT INTO public.europe_data VALUES (7824, 0, 1, 6.66, 67, 39);
INSERT INTO public.europe_data VALUES (7825, 0, 0, 0.69, 109, 39);
INSERT INTO public.europe_data VALUES (7826, 19, 270, 8.81, 155, 39);
INSERT INTO public.europe_data VALUES (7827, 2, 45, 0.66, 5, 39);
INSERT INTO public.europe_data VALUES (7828, 0, 23, 0.2, 6, 39);
INSERT INTO public.europe_data VALUES (7829, 0, 0, 0, 110, 39);
INSERT INTO public.europe_data VALUES (7830, 26, 713, 4.7, 7, 39);
INSERT INTO public.europe_data VALUES (7831, 911, 8143, 46.82, 68, 39);
INSERT INTO public.europe_data VALUES (7832, 1, 82, 29.64, 8, 39);
INSERT INTO public.europe_data VALUES (7833, 0, 13, 30.79, 69, 39);
INSERT INTO public.europe_data VALUES (7834, 0, 148, 5.37, 9, 39);
INSERT INTO public.europe_data VALUES (7835, 22, 181, 2.42, 10, 39);
INSERT INTO public.europe_data VALUES (7836, 138, 14915, 127.26, 70, 39);
INSERT INTO public.europe_data VALUES (7837, 1, 44, 0.01, 111, 39);
INSERT INTO public.europe_data VALUES (7838, 111, 4511, 15.71, 71, 39);
INSERT INTO public.europe_data VALUES (7839, 0, 0, 0.94, 11, 39);
INSERT INTO public.europe_data VALUES (7840, 5, 125, 3.4, 12, 39);
INSERT INTO public.europe_data VALUES (7841, 4, 71, 2.46, 72, 39);
INSERT INTO public.europe_data VALUES (7842, 6, 409, 2.76, 13, 39);
INSERT INTO public.europe_data VALUES (7843, 5, 39, 3.19, 156, 39);
INSERT INTO public.europe_data VALUES (7844, 2, 106, 1.97, 73, 39);
INSERT INTO public.europe_data VALUES (7845, 0, 0, 0, 74, 39);
INSERT INTO public.europe_data VALUES (7846, 1, 18, 5.02, 157, 39);
INSERT INTO public.europe_data VALUES (7847, 17, 352, 6.52, 158, 39);
INSERT INTO public.europe_data VALUES (7848, 19, 430, 0.89, 14, 39);
INSERT INTO public.europe_data VALUES (7849, 28, 498, 24.18, 159, 39);
INSERT INTO public.europe_data VALUES (7850, 1, 191, 29.68, 15, 39);
INSERT INTO public.europe_data VALUES (7851, 0, 0, 0, 75, 39);
INSERT INTO public.europe_data VALUES (7852, 40, 1967, 40.6, 76, 39);
INSERT INTO public.europe_data VALUES (7853, 609, 3623, 20.97, 77, 39);
INSERT INTO public.europe_data VALUES (7854, 105, 2829, 5.74, 16, 39);
INSERT INTO public.europe_data VALUES (7855, 13, 380, 12.13, 78, 39);
INSERT INTO public.europe_data VALUES (7856, 3, 155, 20.58, 17, 39);
INSERT INTO public.europe_data VALUES (7857, 0, 0, 0, 18, 39);
INSERT INTO public.europe_data VALUES (7858, 3, 35, 5.59, 160, 39);
INSERT INTO public.europe_data VALUES (7859, 0, 31, 7.93, 19, 39);
INSERT INTO public.europe_data VALUES (7860, 0, 78, 0.16, 20, 39);
INSERT INTO public.europe_data VALUES (7861, 0, 0, 0, 79, 39);
INSERT INTO public.europe_data VALUES (7862, 0, 0, 0, 161, 39);
INSERT INTO public.europe_data VALUES (7863, 0, 0, 0, 203, 39);
INSERT INTO public.europe_data VALUES (7864, 31, 385, 19.81, 162, 39);
INSERT INTO public.europe_data VALUES (7865, 1331, 3348, 16.6, 163, 39);
INSERT INTO public.europe_data VALUES (7866, 0, 0, 0.72, 204, 39);
INSERT INTO public.europe_data VALUES (7867, 3, 659, 45.34, 21, 39);
INSERT INTO public.europe_data VALUES (7868, 0, 3, 0.26, 22, 39);
INSERT INTO public.europe_data VALUES (7869, 2, 66, 2.8, 164, 39);
INSERT INTO public.europe_data VALUES (7870, 518, 5122, 13.88, 165, 39);
INSERT INTO public.europe_data VALUES (7871, 7, 1472, 11.72, 23, 39);
INSERT INTO public.europe_data VALUES (7872, 0, 1, 8.9, 166, 39);
INSERT INTO public.europe_data VALUES (7873, 12, 118, 1.94, 167, 39);
INSERT INTO public.europe_data VALUES (7874, 0, 0, 0, 80, 39);
INSERT INTO public.europe_data VALUES (7875, 0, 1, 0.89, 81, 39);
INSERT INTO public.europe_data VALUES (7876, 0, 3, 2.99, 205, 39);
INSERT INTO public.europe_data VALUES (7877, 9, 860, 6.88, 82, 39);
INSERT INTO public.europe_data VALUES (7878, 0, 0, 0, 168, 39);
INSERT INTO public.europe_data VALUES (7879, 5, 512, 8.39, 24, 39);
INSERT INTO public.europe_data VALUES (7880, 1, 264, 36.34, 25, 39);
INSERT INTO public.europe_data VALUES (7881, 0, 13, 4.47, 83, 39);
INSERT INTO public.europe_data VALUES (7882, 5, 274, 3.29, 84, 39);
INSERT INTO public.europe_data VALUES (7883, 0, 0, 122.7, 169, 39);
INSERT INTO public.europe_data VALUES (7884, 34, 674, 16.32, 85, 39);
INSERT INTO public.europe_data VALUES (7885, 41, 251, 5.12, 170, 39);
INSERT INTO public.europe_data VALUES (7886, 0, 1, 0.84, 171, 39);
INSERT INTO public.europe_data VALUES (7887, 823, 29017, 3.93, 112, 39);
INSERT INTO public.europe_data VALUES (7888, 175, 3482, 2.34, 113, 39);
INSERT INTO public.europe_data VALUES (7889, 348, 12595, 27.47, 114, 39);
INSERT INTO public.europe_data VALUES (7890, 14, 637, 2.82, 115, 39);
INSERT INTO public.europe_data VALUES (7891, 85, 1116, 53.14, 172, 39);
INSERT INTO public.europe_data VALUES (7892, 1, 5, 16.55, 173, 39);
INSERT INTO public.europe_data VALUES (7893, 20, 140, 4.8, 116, 39);
INSERT INTO public.europe_data VALUES (7894, 1348, 6365, 24.38, 174, 39);
INSERT INTO public.europe_data VALUES (7895, 0, 18, 1.73, 86, 39);
INSERT INTO public.europe_data VALUES (7896, 128, 507, 0.98, 117, 39);
INSERT INTO public.europe_data VALUES (7897, 2, 8, 9.28, 175, 39);
INSERT INTO public.europe_data VALUES (7898, 0, 73, 1.5, 118, 39);
INSERT INTO public.europe_data VALUES (7899, 3, 1314, 13.35, 119, 39);
INSERT INTO public.europe_data VALUES (7900, 18, 215, 0.8, 26, 39);
INSERT INTO public.europe_data VALUES (7901, 1, 101, 7.45, 176, 39);
INSERT INTO public.europe_data VALUES (7902, 54, 6162, 234.53, 120, 39);
INSERT INTO public.europe_data VALUES (7903, 2, 200, 6.02, 121, 39);
INSERT INTO public.europe_data VALUES (7904, 0, 0, 0, 122, 39);
INSERT INTO public.europe_data VALUES (7905, 1, 69, 6.72, 177, 39);
INSERT INTO public.europe_data VALUES (7906, 0, 66, 2.54, 123, 39);
INSERT INTO public.europe_data VALUES (7907, 0, 1, 0, 27, 39);
INSERT INTO public.europe_data VALUES (7908, 1, 27, 1.38, 28, 39);
INSERT INTO public.europe_data VALUES (7909, 0, 1, 0.03, 29, 39);
INSERT INTO public.europe_data VALUES (7910, 0, 0, 0, 178, 39);
INSERT INTO public.europe_data VALUES (7911, 6, 62, 4.69, 179, 39);
INSERT INTO public.europe_data VALUES (7912, 6, 59, 19.71, 180, 39);
INSERT INTO public.europe_data VALUES (7913, 1, 133, 0.57, 30, 39);
INSERT INTO public.europe_data VALUES (7914, 0, 14, 0.17, 31, 39);
INSERT INTO public.europe_data VALUES (7915, 5, 238, 1.87, 124, 39);
INSERT INTO public.europe_data VALUES (7916, 1, 259, 106.79, 125, 39);
INSERT INTO public.europe_data VALUES (7917, 14, 156, 1.51, 32, 39);
INSERT INTO public.europe_data VALUES (7918, 1, 55, 15.8, 181, 39);
INSERT INTO public.europe_data VALUES (7919, 3, 54, 1.19, 33, 39);
INSERT INTO public.europe_data VALUES (7920, 0, 0, 0, 34, 39);
INSERT INTO public.europe_data VALUES (7921, 1712, 19213, 26.45, 87, 39);
INSERT INTO public.europe_data VALUES (7922, 42, 1133, 47.96, 182, 39);
INSERT INTO public.europe_data VALUES (7923, 0, 0, 0, 183, 39);
INSERT INTO public.europe_data VALUES (7924, 0, 98, 3.1, 126, 39);
INSERT INTO public.europe_data VALUES (7925, 0, 0, 0.32, 184, 39);
INSERT INTO public.europe_data VALUES (7926, 0, 0, 0, 88, 39);
INSERT INTO public.europe_data VALUES (7927, 4, 807, 5.39, 35, 39);
INSERT INTO public.europe_data VALUES (7928, 0, 46, 0.19, 36, 39);
INSERT INTO public.europe_data VALUES (7929, 0, 7, 0.06, 127, 39);
INSERT INTO public.europe_data VALUES (7930, 0, 0, 0, 37, 39);
INSERT INTO public.europe_data VALUES (7931, 2, 184, 0.8, 128, 39);
INSERT INTO public.europe_data VALUES (7932, 240, 1368, 19.81, 185, 39);
INSERT INTO public.europe_data VALUES (7933, 0, 0, 0, 208, 39);
INSERT INTO public.europe_data VALUES (7934, 0, 2, 0.25, 209, 39);
INSERT INTO public.europe_data VALUES (7935, 3, 9, 0.17, 89, 39);
INSERT INTO public.europe_data VALUES (7936, 8, 83, 0.66, 38, 39);
INSERT INTO public.europe_data VALUES (7937, 39, 1560, 1.69, 39, 39);
INSERT INTO public.europe_data VALUES (7938, 10, 150, 13.53, 186, 39);
INSERT INTO public.europe_data VALUES (7939, 0, 5, 12.23, 210, 39);
INSERT INTO public.europe_data VALUES (7940, 15, 98, 7.28, 187, 39);
INSERT INTO public.europe_data VALUES (7941, 5, 1787, 52.62, 129, 39);
INSERT INTO public.europe_data VALUES (7942, 236, 11184, 10.13, 130, 39);
INSERT INTO public.europe_data VALUES (7943, 0, 13, 0.76, 131, 39);
INSERT INTO public.europe_data VALUES (7944, 31, 1158, 56.73, 90, 39);
INSERT INTO public.europe_data VALUES (7945, 0, 0, 0, 211, 39);
INSERT INTO public.europe_data VALUES (7946, 1, 73, 5.54, 91, 39);
INSERT INTO public.europe_data VALUES (7947, 759, 24966, 142.55, 92, 39);
INSERT INTO public.europe_data VALUES (7948, 105, 1719, 3.04, 132, 39);
INSERT INTO public.europe_data VALUES (7949, 125, 2533, 12.74, 188, 39);
INSERT INTO public.europe_data VALUES (7950, 83, 1455, 34.17, 189, 39);
INSERT INTO public.europe_data VALUES (7951, 12, 448, 28.57, 93, 39);
INSERT INTO public.europe_data VALUES (7952, 1, 10084, 602.14, 133, 39);
INSERT INTO public.europe_data VALUES (7953, 145, 1509, 19.1, 190, 39);
INSERT INTO public.europe_data VALUES (7954, 716, 72064, 100.82, 191, 39);
INSERT INTO public.europe_data VALUES (7955, 0, 8, 0.26, 40, 39);
INSERT INTO public.europe_data VALUES (7956, 0, 0, 0, 94, 39);
INSERT INTO public.europe_data VALUES (7957, 0, 0, 0, 95, 39);
INSERT INTO public.europe_data VALUES (7958, 0, 0, 0, 96, 39);
INSERT INTO public.europe_data VALUES (7959, 0, 26, 208.98, 192, 39);
INSERT INTO public.europe_data VALUES (7960, 2, 27, 100.91, 41, 39);
INSERT INTO public.europe_data VALUES (7961, 66, 15704, 80.95, 134, 39);
INSERT INTO public.europe_data VALUES (7962, 7, 771, 7.96, 42, 39);
INSERT INTO public.europe_data VALUES (7963, 15, 496, 16.46, 193, 39);
INSERT INTO public.europe_data VALUES (7964, 0, 0, 0, 43, 39);
INSERT INTO public.europe_data VALUES (7965, 14, 198, 4.45, 44, 39);
INSERT INTO public.europe_data VALUES (7966, 2, 4702, 169.41, 135, 39);
INSERT INTO public.europe_data VALUES (7967, 0, 1, 2.36, 97, 39);
INSERT INTO public.europe_data VALUES (7968, 2, 37, 1.58, 194, 39);
INSERT INTO public.europe_data VALUES (7969, 2, 6, 1.3, 195, 39);
INSERT INTO public.europe_data VALUES (7970, 5, 367, 4.53, 45, 39);
INSERT INTO public.europe_data VALUES (7971, 70, 5500, 14.91, 46, 39);
INSERT INTO public.europe_data VALUES (7972, 7, 156, 0.52, 136, 39);
INSERT INTO public.europe_data VALUES (7973, 4, 126, 2.13, 47, 39);
INSERT INTO public.europe_data VALUES (7974, 965, 3836, 26.42, 196, 39);
INSERT INTO public.europe_data VALUES (7975, 0, 118, 1.23, 137, 39);
INSERT INTO public.europe_data VALUES (7976, 27, 926, 3.76, 48, 39);
INSERT INTO public.europe_data VALUES (7977, 0, 0, 0, 98, 39);
INSERT INTO public.europe_data VALUES (7978, 380, 3869, 78.42, 197, 39);
INSERT INTO public.europe_data VALUES (7979, 65, 282, 7.98, 198, 39);
INSERT INTO public.europe_data VALUES (7980, 0, 11, 0.08, 138, 39);
INSERT INTO public.europe_data VALUES (7981, 1, 0, 0.02, 139, 39);
INSERT INTO public.europe_data VALUES (7982, 19, 912, 15.53, 140, 39);
INSERT INTO public.europe_data VALUES (7983, 0, 13, 0.08, 141, 39);
INSERT INTO public.europe_data VALUES (7984, 0, 0, 0, 142, 39);
INSERT INTO public.europe_data VALUES (7985, 0, 127, 2.19, 49, 39);
INSERT INTO public.europe_data VALUES (7986, 0, 0, 0, 99, 39);
INSERT INTO public.europe_data VALUES (7987, 0, 5, 0.21, 50, 39);
INSERT INTO public.europe_data VALUES (7988, 354, 10778, 28.52, 199, 39);
INSERT INTO public.europe_data VALUES (7989, 0, 0, 0, 100, 39);
INSERT INTO public.europe_data VALUES (7990, 0, 106, 0.31, 51, 39);
INSERT INTO public.europe_data VALUES (7991, 123, 3059, 14.5, 200, 39);
INSERT INTO public.europe_data VALUES (7992, 22, 5160, 94.11, 143, 39);
INSERT INTO public.europe_data VALUES (7993, 2428, 19857, 64.1, 201, 39);
INSERT INTO public.europe_data VALUES (7994, 0, 0, 0.05, 52, 39);
INSERT INTO public.europe_data VALUES (7995, 10034, 156958, 99.89, 101, 39);
INSERT INTO public.europe_data VALUES (7996, 2, 0, 2.87, 102, 39);
INSERT INTO public.europe_data VALUES (7997, 1, 27, 2.28, 103, 39);
INSERT INTO public.europe_data VALUES (7998, 2, 335, 1.83, 144, 39);
INSERT INTO public.europe_data VALUES (7999, 0, 127, 0.65, 104, 39);
INSERT INTO public.europe_data VALUES (8000, 0, 32, 0.05, 145, 39);
INSERT INTO public.europe_data VALUES (8001, 0, 0, 0, 53, 39);
INSERT INTO public.europe_data VALUES (8002, 12, 77, 0.4, 146, 39);
INSERT INTO public.europe_data VALUES (8003, 0, 486, 3.52, 54, 39);
INSERT INTO public.europe_data VALUES (8004, 0, 10, 0.08, 55, 39);
INSERT INTO public.europe_data VALUES (8005, 35, 1698, 7.55, 105, 40);
INSERT INTO public.europe_data VALUES (8006, 0, 73, 4.96, 147, 40);
INSERT INTO public.europe_data VALUES (8007, 39, 1249, 5.44, 1, 40);
INSERT INTO public.europe_data VALUES (8008, 3, 7, 19.69, 148, 40);
INSERT INTO public.europe_data VALUES (8009, 0, 10, 0.06, 2, 40);
INSERT INTO public.europe_data VALUES (8010, 0, 0, 0, 56, 40);
INSERT INTO public.europe_data VALUES (8011, 0, 0, 1.03, 57, 40);
INSERT INTO public.europe_data VALUES (8012, 54, 1006, 4.49, 58, 40);
INSERT INTO public.europe_data VALUES (8013, 7, 885, 53.55, 149, 40);
INSERT INTO public.europe_data VALUES (8014, 1, 1, 0.94, 59, 40);
INSERT INTO public.europe_data VALUES (8015, 2, 140, 0.9, 202, 40);
INSERT INTO public.europe_data VALUES (8016, 20, 249, 6.75, 150, 40);
INSERT INTO public.europe_data VALUES (8017, 7, 587, 8.7, 151, 40);
INSERT INTO public.europe_data VALUES (8018, 0, 9, 3.08, 60, 40);
INSERT INTO public.europe_data VALUES (8019, 0, 1558, 139.78, 106, 40);
INSERT INTO public.europe_data VALUES (8020, 51, 5202, 5.67, 107, 40);
INSERT INTO public.europe_data VALUES (8021, 0, 2, 1.74, 61, 40);
INSERT INTO public.europe_data VALUES (8022, 32, 6268, 132.35, 152, 40);
INSERT INTO public.europe_data VALUES (8023, 535, 3051, 53.65, 153, 40);
INSERT INTO public.europe_data VALUES (8024, 0, 0, 0, 62, 40);
INSERT INTO public.europe_data VALUES (8025, 0, 229, 2.16, 3, 40);
INSERT INTO public.europe_data VALUES (8026, 0, 3, 14.4, 63, 40);
INSERT INTO public.europe_data VALUES (8027, 0, 2, 0.26, 108, 40);
INSERT INTO public.europe_data VALUES (8028, 42, 962, 13.95, 64, 40);
INSERT INTO public.europe_data VALUES (8029, 0, 0, 0, 65, 40);
INSERT INTO public.europe_data VALUES (8030, 31, 260, 18.21, 154, 40);
INSERT INTO public.europe_data VALUES (8031, 0, 0, 0.04, 4, 40);
INSERT INTO public.europe_data VALUES (8032, 4098, 61552, 47.77, 66, 40);
INSERT INTO public.europe_data VALUES (8033, 0, 1, 3.33, 67, 40);
INSERT INTO public.europe_data VALUES (8034, 0, 3, 0.69, 109, 40);
INSERT INTO public.europe_data VALUES (8035, 18, 347, 9.5, 155, 40);
INSERT INTO public.europe_data VALUES (8036, 4, 89, 0.59, 5, 40);
INSERT INTO public.europe_data VALUES (8037, 0, 0, 0.03, 6, 40);
INSERT INTO public.europe_data VALUES (8038, 0, 0, 0, 110, 40);
INSERT INTO public.europe_data VALUES (8039, 50, 502, 3.7, 7, 40);
INSERT INTO public.europe_data VALUES (8040, 1189, 9374, 58.71, 68, 40);
INSERT INTO public.europe_data VALUES (8041, 0, 81, 25.46, 8, 40);
INSERT INTO public.europe_data VALUES (8042, 0, 7, 16.94, 69, 40);
INSERT INTO public.europe_data VALUES (8043, 0, 107, 3.37, 9, 40);
INSERT INTO public.europe_data VALUES (8044, 21, 205, 1.73, 10, 40);
INSERT INTO public.europe_data VALUES (8045, 52, 9203, 81.97, 70, 40);
INSERT INTO public.europe_data VALUES (8046, 0, 46, 0.01, 111, 40);
INSERT INTO public.europe_data VALUES (8047, 123, 3395, 11.29, 71, 40);
INSERT INTO public.europe_data VALUES (8048, 1, 8, 1.29, 11, 40);
INSERT INTO public.europe_data VALUES (8049, 0, 58, 1.62, 12, 40);
INSERT INTO public.europe_data VALUES (8050, 0, 53, 1.92, 72, 40);
INSERT INTO public.europe_data VALUES (8051, 4, 302, 2.14, 13, 40);
INSERT INTO public.europe_data VALUES (8052, 11, 91, 3.85, 156, 40);
INSERT INTO public.europe_data VALUES (8053, 10, 117, 3.5, 73, 40);
INSERT INTO public.europe_data VALUES (8054, 0, 0, 0, 74, 40);
INSERT INTO public.europe_data VALUES (8055, 1, 26, 9.25, 157, 40);
INSERT INTO public.europe_data VALUES (8056, 32, 342, 6.75, 158, 40);
INSERT INTO public.europe_data VALUES (8057, 7, 340, 0.65, 14, 40);
INSERT INTO public.europe_data VALUES (8058, 38, 906, 31.93, 159, 40);
INSERT INTO public.europe_data VALUES (8059, 1, 98, 19.21, 15, 40);
INSERT INTO public.europe_data VALUES (8060, 0, 0, 0, 75, 40);
INSERT INTO public.europe_data VALUES (8061, 55, 2393, 39.22, 76, 40);
INSERT INTO public.europe_data VALUES (8062, 563, 21, 39.37, 77, 40);
INSERT INTO public.europe_data VALUES (8063, 96, 2935, 5.06, 16, 40);
INSERT INTO public.europe_data VALUES (8064, 5, 403, 10.23, 78, 40);
INSERT INTO public.europe_data VALUES (8065, 3, 124, 13.35, 17, 40);
INSERT INTO public.europe_data VALUES (8066, 0, 0, 0, 18, 40);
INSERT INTO public.europe_data VALUES (8067, 5, 39, 7.25, 160, 40);
INSERT INTO public.europe_data VALUES (8068, 1, 60, 9.84, 19, 40);
INSERT INTO public.europe_data VALUES (8069, 2, 104, 0.1, 20, 40);
INSERT INTO public.europe_data VALUES (8070, 0, 0, 0, 79, 40);
INSERT INTO public.europe_data VALUES (8071, 0, 0, 0, 161, 40);
INSERT INTO public.europe_data VALUES (8072, 0, 0, 0, 203, 40);
INSERT INTO public.europe_data VALUES (8073, 37, 708, 25.12, 162, 40);
INSERT INTO public.europe_data VALUES (8074, 1485, 7776, 21.62, 163, 40);
INSERT INTO public.europe_data VALUES (8075, 0, 2, 1.07, 204, 40);
INSERT INTO public.europe_data VALUES (8076, 3, 326, 22.32, 21, 40);
INSERT INTO public.europe_data VALUES (8077, 0, 3, 0.43, 22, 40);
INSERT INTO public.europe_data VALUES (8078, 1, 46, 3.73, 164, 40);
INSERT INTO public.europe_data VALUES (8079, 725, 6400, 17.32, 165, 40);
INSERT INTO public.europe_data VALUES (8080, 4, 2094, 8.92, 23, 40);
INSERT INTO public.europe_data VALUES (8081, 0, 2, 14.83, 166, 40);
INSERT INTO public.europe_data VALUES (8082, 7, 90, 1.96, 167, 40);
INSERT INTO public.europe_data VALUES (8083, 0, 0, 0, 80, 40);
INSERT INTO public.europe_data VALUES (8084, 0, 0, 2.68, 81, 40);
INSERT INTO public.europe_data VALUES (8085, 0, 2, 5.38, 205, 40);
INSERT INTO public.europe_data VALUES (8086, 9, 349, 3.14, 82, 40);
INSERT INTO public.europe_data VALUES (8087, 0, 0, 7.76, 168, 40);
INSERT INTO public.europe_data VALUES (8088, 4, 560, 8.24, 24, 40);
INSERT INTO public.europe_data VALUES (8089, 1, 434, 35.04, 25, 40);
INSERT INTO public.europe_data VALUES (8090, 1, 22, 3.83, 83, 40);
INSERT INTO public.europe_data VALUES (8091, 7, 97, 0.98, 84, 40);
INSERT INTO public.europe_data VALUES (8092, 0, 1, 368.1, 169, 40);
INSERT INTO public.europe_data VALUES (8093, 26, 917, 13.45, 85, 40);
INSERT INTO public.europe_data VALUES (8094, 70, 249, 7.17, 170, 40);
INSERT INTO public.europe_data VALUES (8095, 0, 2, 2.52, 171, 40);
INSERT INTO public.europe_data VALUES (8096, 833, 24619, 2.87, 112, 40);
INSERT INTO public.europe_data VALUES (8097, 128, 2840, 1.9, 113, 40);
INSERT INTO public.europe_data VALUES (8098, 437, 10179, 20.65, 114, 40);
INSERT INTO public.europe_data VALUES (8099, 12, 471, 2.41, 115, 40);
INSERT INTO public.europe_data VALUES (8100, 155, 1490, 76.14, 172, 40);
INSERT INTO public.europe_data VALUES (8101, 1, 9, 26.01, 173, 40);
INSERT INTO public.europe_data VALUES (8102, 20, 269, 12.67, 116, 40);
INSERT INTO public.europe_data VALUES (8103, 1676, 8353, 35.45, 174, 40);
INSERT INTO public.europe_data VALUES (8104, 0, 33, 5.16, 86, 40);
INSERT INTO public.europe_data VALUES (8105, 111, 741, 1.9, 117, 40);
INSERT INTO public.europe_data VALUES (8106, 1, 2, 12.06, 175, 40);
INSERT INTO public.europe_data VALUES (8107, 0, 79, 0.92, 118, 40);
INSERT INTO public.europe_data VALUES (8108, 4, 1162, 12.99, 119, 40);
INSERT INTO public.europe_data VALUES (8109, 8, 207, 0.6, 26, 40);
INSERT INTO public.europe_data VALUES (8110, 3, 33, 6.67, 176, 40);
INSERT INTO public.europe_data VALUES (8111, 20, 3705, 133.42, 120, 40);
INSERT INTO public.europe_data VALUES (8112, 2, 186, 5, 121, 40);
INSERT INTO public.europe_data VALUES (8113, 0, 0, 0, 122, 40);
INSERT INTO public.europe_data VALUES (8114, 2, 60, 6.61, 177, 40);
INSERT INTO public.europe_data VALUES (8115, 1, 108, 2.01, 123, 40);
INSERT INTO public.europe_data VALUES (8116, 2, 41, 1.52, 28, 40);
INSERT INTO public.europe_data VALUES (8117, 0, 1, 0.04, 29, 40);
INSERT INTO public.europe_data VALUES (8118, 0, 0, 0, 178, 40);
INSERT INTO public.europe_data VALUES (8119, 4, 69, 1.47, 179, 40);
INSERT INTO public.europe_data VALUES (8120, 5, 62, 26.55, 180, 40);
INSERT INTO public.europe_data VALUES (8121, 0, 22, 0.17, 30, 40);
INSERT INTO public.europe_data VALUES (8122, 0, 17, 0.12, 31, 40);
INSERT INTO public.europe_data VALUES (8123, 3, 358, 2.74, 124, 40);
INSERT INTO public.europe_data VALUES (8124, 2, 308, 116.96, 125, 40);
INSERT INTO public.europe_data VALUES (8125, 11, 141, 1.6, 32, 40);
INSERT INTO public.europe_data VALUES (8126, 1, 23, 10.74, 181, 40);
INSERT INTO public.europe_data VALUES (8127, 0, 0, 0.02, 33, 40);
INSERT INTO public.europe_data VALUES (8128, 0, 0, 0, 34, 40);
INSERT INTO public.europe_data VALUES (8129, 1311, 14536, 20.09, 87, 40);
INSERT INTO public.europe_data VALUES (8130, 44, 806, 37.57, 182, 40);
INSERT INTO public.europe_data VALUES (8131, 0, 0, 3.02, 183, 40);
INSERT INTO public.europe_data VALUES (8132, 0, 2, 0.12, 126, 40);
INSERT INTO public.europe_data VALUES (8133, 1, 2, 0.48, 184, 40);
INSERT INTO public.europe_data VALUES (8134, 0, 0, 0, 88, 40);
INSERT INTO public.europe_data VALUES (8135, 14, 1160, 5.48, 35, 40);
INSERT INTO public.europe_data VALUES (8136, 0, 11, 0.05, 36, 40);
INSERT INTO public.europe_data VALUES (8137, 0, 25, 0.06, 127, 40);
INSERT INTO public.europe_data VALUES (8138, 0, 0, 0, 37, 40);
INSERT INTO public.europe_data VALUES (8139, 0, 45, 0.24, 128, 40);
INSERT INTO public.europe_data VALUES (8140, 384, 2056, 27.67, 185, 40);
INSERT INTO public.europe_data VALUES (8141, 0, 0, 0, 208, 40);
INSERT INTO public.europe_data VALUES (8142, 1, 10, 0.52, 209, 40);
INSERT INTO public.europe_data VALUES (8143, 0, 2, 0.05, 89, 40);
INSERT INTO public.europe_data VALUES (8144, 10, 71, 0.54, 38, 40);
INSERT INTO public.europe_data VALUES (8145, 56, 1841, 1.56, 39, 40);
INSERT INTO public.europe_data VALUES (8146, 7, 131, 12.32, 186, 40);
INSERT INTO public.europe_data VALUES (8147, 0, 2, 3.5, 210, 40);
INSERT INTO public.europe_data VALUES (8148, 9, 290, 11.15, 187, 40);
INSERT INTO public.europe_data VALUES (8149, 5, 831, 28.16, 129, 40);
INSERT INTO public.europe_data VALUES (8150, 205, 10755, 8.13, 130, 40);
INSERT INTO public.europe_data VALUES (8151, 0, 25, 1.04, 131, 40);
INSERT INTO public.europe_data VALUES (8152, 44, 1251, 62.85, 90, 40);
INSERT INTO public.europe_data VALUES (8153, 0, 0, 0, 211, 40);
INSERT INTO public.europe_data VALUES (8154, 0, 317, 6.88, 91, 40);
INSERT INTO public.europe_data VALUES (8155, 603, 21379, 122.39, 92, 40);
INSERT INTO public.europe_data VALUES (8156, 112, 1571, 2.97, 132, 40);
INSERT INTO public.europe_data VALUES (8157, 122, 2303, 11.53, 188, 40);
INSERT INTO public.europe_data VALUES (8158, 72, 2057, 36.34, 189, 40);
INSERT INTO public.europe_data VALUES (8159, 14, 390, 28.19, 93, 40);
INSERT INTO public.europe_data VALUES (8160, 2, 6969, 431.95, 133, 40);
INSERT INTO public.europe_data VALUES (8161, 172, 2199, 22.28, 190, 40);
INSERT INTO public.europe_data VALUES (8162, 635, 75001, 88.25, 191, 40);
INSERT INTO public.europe_data VALUES (8163, 0, 25, 0.74, 40, 40);
INSERT INTO public.europe_data VALUES (8164, 0, 0, 0, 94, 40);
INSERT INTO public.europe_data VALUES (8165, 0, 0, 1.64, 95, 40);
INSERT INTO public.europe_data VALUES (8166, 0, 0, 2.71, 96, 40);
INSERT INTO public.europe_data VALUES (8167, 0, 46, 261.23, 192, 40);
INSERT INTO public.europe_data VALUES (8168, 4, 190, 93, 41, 40);
INSERT INTO public.europe_data VALUES (8169, 62, 12037, 62.82, 134, 40);
INSERT INTO public.europe_data VALUES (8170, 10, 527, 6.37, 42, 40);
INSERT INTO public.europe_data VALUES (8171, 22, 650, 29.75, 193, 40);
INSERT INTO public.europe_data VALUES (8172, 0, 0, 0, 43, 40);
INSERT INTO public.europe_data VALUES (8173, 10, 150, 2.74, 44, 40);
INSERT INTO public.europe_data VALUES (8174, 2, 5131, 167.32, 135, 40);
INSERT INTO public.europe_data VALUES (8175, 2, 0, 4.72, 97, 40);
INSERT INTO public.europe_data VALUES (8176, 2, 49, 1.43, 194, 40);
INSERT INTO public.europe_data VALUES (8177, 6, 21, 2.55, 195, 40);
INSERT INTO public.europe_data VALUES (8178, 19, 332, 4, 45, 40);
INSERT INTO public.europe_data VALUES (8179, 63, 3232, 9.34, 46, 40);
INSERT INTO public.europe_data VALUES (8180, 4, 108, 0.33, 136, 40);
INSERT INTO public.europe_data VALUES (8181, 0, 110, 1.36, 47, 40);
INSERT INTO public.europe_data VALUES (8182, 1316, 8565, 34.51, 196, 40);
INSERT INTO public.europe_data VALUES (8183, 2, 145, 1.59, 137, 40);
INSERT INTO public.europe_data VALUES (8184, 29, 685, 2.63, 48, 40);
INSERT INTO public.europe_data VALUES (8185, 0, 0, 0, 98, 40);
INSERT INTO public.europe_data VALUES (8186, 510, 4153, 78.05, 197, 40);
INSERT INTO public.europe_data VALUES (8187, 65, 400, 14.56, 198, 40);
INSERT INTO public.europe_data VALUES (8188, 0, 3, 0.02, 138, 40);
INSERT INTO public.europe_data VALUES (8189, 0, 4, 0.05, 139, 40);
INSERT INTO public.europe_data VALUES (8190, 18, 536, 6.57, 140, 40);
INSERT INTO public.europe_data VALUES (8191, 2, 46, 0.13, 141, 40);
INSERT INTO public.europe_data VALUES (8192, 0, 0, 0, 142, 40);
INSERT INTO public.europe_data VALUES (8193, 2, 50, 0.94, 49, 40);
INSERT INTO public.europe_data VALUES (8194, 0, 0, 0, 99, 40);
INSERT INTO public.europe_data VALUES (8195, 3, 19, 0.71, 50, 40);
INSERT INTO public.europe_data VALUES (8196, 389, 12612, 34.79, 199, 40);
INSERT INTO public.europe_data VALUES (8197, 0, 0, 2.62, 100, 40);
INSERT INTO public.europe_data VALUES (8198, 0, 32, 0.09, 51, 40);
INSERT INTO public.europe_data VALUES (8199, 103, 3319, 15.04, 200, 40);
INSERT INTO public.europe_data VALUES (8200, 72, 4035, 80.33, 143, 40);
INSERT INTO public.europe_data VALUES (8201, 3174, 22867, 81.25, 201, 40);
INSERT INTO public.europe_data VALUES (8202, 5, 29, 0.36, 52, 40);
INSERT INTO public.europe_data VALUES (8203, 11846, 171758, 110.58, 101, 40);
INSERT INTO public.europe_data VALUES (8204, 0, 3, 13.39, 102, 40);
INSERT INTO public.europe_data VALUES (8205, 2, 52, 2.92, 103, 40);
INSERT INTO public.europe_data VALUES (8206, 0, 269, 1.61, 144, 40);
INSERT INTO public.europe_data VALUES (8207, 0, 57, 0.31, 104, 40);
INSERT INTO public.europe_data VALUES (8208, 0, 17, 0.02, 145, 40);
INSERT INTO public.europe_data VALUES (8209, 0, 0, 0, 53, 40);
INSERT INTO public.europe_data VALUES (8210, 6, 41, 0.17, 146, 40);
INSERT INTO public.europe_data VALUES (8211, 4, 143, 1, 54, 40);
INSERT INTO public.europe_data VALUES (8212, 0, 2, 0.03, 55, 40);
INSERT INTO public.europe_data VALUES (8213, 28, 1173, 4.49, 105, 41);
INSERT INTO public.europe_data VALUES (8214, 3, 69, 8.14, 147, 41);
INSERT INTO public.europe_data VALUES (8215, 38, 1092, 4.29, 1, 41);
INSERT INTO public.europe_data VALUES (8216, 5, 8, 45.95, 148, 41);
INSERT INTO public.europe_data VALUES (8217, 0, 9, 0.03, 2, 41);
INSERT INTO public.europe_data VALUES (8218, 0, 0, 0, 56, 41);
INSERT INTO public.europe_data VALUES (8219, 0, 1, 2.06, 57, 41);
INSERT INTO public.europe_data VALUES (8220, 60, 1003, 4.11, 58, 41);
INSERT INTO public.europe_data VALUES (8221, 10, 699, 39.49, 149, 41);
INSERT INTO public.europe_data VALUES (8222, 0, 0, 2.82, 59, 41);
INSERT INTO public.europe_data VALUES (8223, 12, 88, 0.75, 202, 41);
INSERT INTO public.europe_data VALUES (8224, 56, 349, 9.35, 150, 41);
INSERT INTO public.europe_data VALUES (8225, 4, 287, 5.31, 151, 41);
INSERT INTO public.europe_data VALUES (8226, 0, 3, 5.91, 60, 41);
INSERT INTO public.europe_data VALUES (8227, 0, 736, 92.01, 106, 41);
INSERT INTO public.europe_data VALUES (8228, 32, 4039, 4.29, 107, 41);
INSERT INTO public.europe_data VALUES (8229, 1, 3, 2.44, 61, 41);
INSERT INTO public.europe_data VALUES (8230, 27, 6242, 115.29, 152, 41);
INSERT INTO public.europe_data VALUES (8231, 698, 3095, 76.8, 153, 41);
INSERT INTO public.europe_data VALUES (8232, 0, 0, 0, 62, 41);
INSERT INTO public.europe_data VALUES (8233, 1, 26, 0.45, 3, 41);
INSERT INTO public.europe_data VALUES (8234, 2, 6, 46.39, 63, 41);
INSERT INTO public.europe_data VALUES (8235, 0, 0, 0.26, 108, 41);
INSERT INTO public.europe_data VALUES (8236, 26, 644, 8.95, 64, 41);
INSERT INTO public.europe_data VALUES (8237, 0, 0, 3.85, 65, 41);
INSERT INTO public.europe_data VALUES (8238, 18, 341, 17.81, 154, 41);
INSERT INTO public.europe_data VALUES (8239, 0, 1, 0.13, 4, 41);
INSERT INTO public.europe_data VALUES (8240, 2820, 39259, 29.61, 66, 41);
INSERT INTO public.europe_data VALUES (8241, 0, 0, 6.66, 67, 41);
INSERT INTO public.europe_data VALUES (8242, 0, 0, 0, 109, 41);
INSERT INTO public.europe_data VALUES (8243, 17, 318, 10.04, 155, 41);
INSERT INTO public.europe_data VALUES (8244, 3, 30, 0.42, 5, 41);
INSERT INTO public.europe_data VALUES (8245, 0, 4, 0.11, 6, 41);
INSERT INTO public.europe_data VALUES (8246, 0, 0, 0, 110, 41);
INSERT INTO public.europe_data VALUES (8247, 8, 456, 4.1, 7, 41);
INSERT INTO public.europe_data VALUES (8248, 1122, 12590, 66.02, 68, 41);
INSERT INTO public.europe_data VALUES (8249, 1, 59, 18.91, 8, 41);
INSERT INTO public.europe_data VALUES (8250, 0, 4, 20.02, 69, 41);
INSERT INTO public.europe_data VALUES (8251, 0, 53, 1.26, 9, 41);
INSERT INTO public.europe_data VALUES (8252, 10, 71, 0.53, 10, 41);
INSERT INTO public.europe_data VALUES (8253, 71, 6332, 50.52, 70, 41);
INSERT INTO public.europe_data VALUES (8254, 0, 52, 0.01, 111, 41);
INSERT INTO public.europe_data VALUES (8255, 97, 2289, 7.7, 71, 41);
INSERT INTO public.europe_data VALUES (8256, 0, 3, 0, 11, 41);
INSERT INTO public.europe_data VALUES (8257, 2, 29, 1.28, 12, 41);
INSERT INTO public.europe_data VALUES (8258, 0, 44, 1.57, 72, 41);
INSERT INTO public.europe_data VALUES (8259, 3, 248, 2.14, 13, 41);
INSERT INTO public.europe_data VALUES (8260, 24, 66, 5.52, 156, 41);
INSERT INTO public.europe_data VALUES (8261, 13, 280, 5.42, 73, 41);
INSERT INTO public.europe_data VALUES (8262, 0, 0, 1.22, 74, 41);
INSERT INTO public.europe_data VALUES (8263, 1, 55, 11.99, 157, 41);
INSERT INTO public.europe_data VALUES (8264, 27, 377, 9.33, 158, 41);
INSERT INTO public.europe_data VALUES (8265, 6, 225, 0.41, 14, 41);
INSERT INTO public.europe_data VALUES (8266, 59, 948, 36.84, 159, 41);
INSERT INTO public.europe_data VALUES (8267, 0, 89, 27.32, 15, 41);
INSERT INTO public.europe_data VALUES (8268, 0, 0, 0, 75, 41);
INSERT INTO public.europe_data VALUES (8269, 55, 1819, 30.49, 76, 41);
INSERT INTO public.europe_data VALUES (8270, 988, 6819, 115.52, 77, 41);
INSERT INTO public.europe_data VALUES (8271, 122, 2146, 3.31, 16, 41);
INSERT INTO public.europe_data VALUES (8272, 4, 257, 5.49, 78, 41);
INSERT INTO public.europe_data VALUES (8273, 0, 57, 17.4, 17, 41);
INSERT INTO public.europe_data VALUES (8274, 0, 0, 0, 18, 41);
INSERT INTO public.europe_data VALUES (8275, 6, 57, 12.98, 160, 41);
INSERT INTO public.europe_data VALUES (8276, 0, 53, 7.84, 19, 41);
INSERT INTO public.europe_data VALUES (8277, 0, 12, 0.02, 20, 41);
INSERT INTO public.europe_data VALUES (8278, 0, 0, 59.31, 79, 41);
INSERT INTO public.europe_data VALUES (8279, 0, 0, 4.11, 161, 41);
INSERT INTO public.europe_data VALUES (8280, 0, 0, 0.11, 203, 41);
INSERT INTO public.europe_data VALUES (8281, 40, 678, 26.66, 162, 41);
INSERT INTO public.europe_data VALUES (8282, 2039, 6712, 27.88, 163, 41);
INSERT INTO public.europe_data VALUES (8283, 0, 1, 1.07, 204, 41);
INSERT INTO public.europe_data VALUES (8284, 2, 159, 10.4, 21, 41);
INSERT INTO public.europe_data VALUES (8285, 0, 7, 0.3, 22, 41);
INSERT INTO public.europe_data VALUES (8286, 3, 103, 4.88, 164, 41);
INSERT INTO public.europe_data VALUES (8287, 942, 7982, 25.9, 165, 41);
INSERT INTO public.europe_data VALUES (8288, 7, 619, 3.71, 23, 41);
INSERT INTO public.europe_data VALUES (8289, 0, 3, 32.64, 166, 41);
INSERT INTO public.europe_data VALUES (8290, 14, 120, 3.65, 167, 41);
INSERT INTO public.europe_data VALUES (8291, 0, 0, 0, 80, 41);
INSERT INTO public.europe_data VALUES (8292, 0, 3, 6.25, 81, 41);
INSERT INTO public.europe_data VALUES (8293, 0, 7, 7.77, 205, 41);
INSERT INTO public.europe_data VALUES (8294, 2, 203, 2.35, 82, 41);
INSERT INTO public.europe_data VALUES (8295, 0, 5, 20.17, 168, 41);
INSERT INTO public.europe_data VALUES (8296, 0, 492, 7.88, 24, 41);
INSERT INTO public.europe_data VALUES (8297, 1, 239, 12.6, 25, 41);
INSERT INTO public.europe_data VALUES (8298, 1, 8, 2.17, 83, 41);
INSERT INTO public.europe_data VALUES (8299, 2, 13, 0.34, 84, 41);
INSERT INTO public.europe_data VALUES (8300, 0, 2, 368.1, 169, 41);
INSERT INTO public.europe_data VALUES (8301, 21, 394, 5.93, 85, 41);
INSERT INTO public.europe_data VALUES (8302, 71, 452, 10.75, 170, 41);
INSERT INTO public.europe_data VALUES (8303, 0, 7, 7.84, 171, 41);
INSERT INTO public.europe_data VALUES (8304, 501, 14641, 1.85, 112, 41);
INSERT INTO public.europe_data VALUES (8305, 102, 2310, 1.71, 113, 41);
INSERT INTO public.europe_data VALUES (8306, 493, 6943, 18.35, 114, 41);
INSERT INTO public.europe_data VALUES (8307, 10, 476, 1.93, 115, 41);
INSERT INTO public.europe_data VALUES (8308, 216, 2244, 127.54, 172, 41);
INSERT INTO public.europe_data VALUES (8309, 4, 13, 27.19, 173, 41);
INSERT INTO public.europe_data VALUES (8310, 33, 810, 31.89, 116, 41);
INSERT INTO public.europe_data VALUES (8311, 2240, 13042, 52.59, 174, 41);
INSERT INTO public.europe_data VALUES (8312, 2, 119, 9.26, 86, 41);
INSERT INTO public.europe_data VALUES (8313, 159, 1672, 3.39, 117, 41);
INSERT INTO public.europe_data VALUES (8314, 5, 11, 39.89, 175, 41);
INSERT INTO public.europe_data VALUES (8315, 2, 14, 0.44, 118, 41);
INSERT INTO public.europe_data VALUES (8316, 2, 1247, 12.02, 119, 41);
INSERT INTO public.europe_data VALUES (8317, 10, 110, 0.37, 26, 41);
INSERT INTO public.europe_data VALUES (8318, 5, 87, 16.12, 176, 41);
INSERT INTO public.europe_data VALUES (8319, 18, 1908, 72.92, 120, 41);
INSERT INTO public.europe_data VALUES (8320, 2, 135, 4.08, 121, 41);
INSERT INTO public.europe_data VALUES (8321, 0, 0, 0, 122, 41);
INSERT INTO public.europe_data VALUES (8322, 4, 67, 7.92, 177, 41);
INSERT INTO public.europe_data VALUES (8323, 1, 30, 0.93, 123, 41);
INSERT INTO public.europe_data VALUES (8324, 6, 34, 1.36, 28, 41);
INSERT INTO public.europe_data VALUES (8325, 1, 2, 0.21, 29, 41);
INSERT INTO public.europe_data VALUES (8326, 0, 0, 2.61, 178, 41);
INSERT INTO public.europe_data VALUES (8327, 5, -28, 3.01, 179, 41);
INSERT INTO public.europe_data VALUES (8328, 8, 101, 44.63, 180, 41);
INSERT INTO public.europe_data VALUES (8329, 0, 25, 0.1, 30, 41);
INSERT INTO public.europe_data VALUES (8330, 0, 5, 0.12, 31, 41);
INSERT INTO public.europe_data VALUES (8331, 7, 518, 2.85, 124, 41);
INSERT INTO public.europe_data VALUES (8332, 1, 313, 89.46, 125, 41);
INSERT INTO public.europe_data VALUES (8333, 4, 174, 1.72, 32, 41);
INSERT INTO public.europe_data VALUES (8334, 0, 30, 9.73, 181, 41);
INSERT INTO public.europe_data VALUES (8335, 0, 1, 0.02, 33, 41);
INSERT INTO public.europe_data VALUES (8336, 1, 0, 0.32, 34, 41);
INSERT INTO public.europe_data VALUES (8337, 803, 11094, 15.86, 87, 41);
INSERT INTO public.europe_data VALUES (8338, 29, 713, 40.78, 182, 41);
INSERT INTO public.europe_data VALUES (8339, 0, 1, 3.02, 183, 41);
INSERT INTO public.europe_data VALUES (8340, 0, 2, 0.25, 126, 41);
INSERT INTO public.europe_data VALUES (8341, 1, 1, 2.25, 184, 41);
INSERT INTO public.europe_data VALUES (8342, 0, 0, 0, 88, 41);
INSERT INTO public.europe_data VALUES (8343, 13, 838, 5.62, 35, 41);
INSERT INTO public.europe_data VALUES (8344, 0, 4, 0.14, 36, 41);
INSERT INTO public.europe_data VALUES (8345, 1, 9, 0.08, 127, 41);
INSERT INTO public.europe_data VALUES (8346, 0, 0, 0, 37, 41);
INSERT INTO public.europe_data VALUES (8347, 0, 23, 0.15, 128, 41);
INSERT INTO public.europe_data VALUES (8348, 581, 2726, 45.8, 185, 41);
INSERT INTO public.europe_data VALUES (8349, 0, 0, 0, 208, 41);
INSERT INTO public.europe_data VALUES (8350, 1, 15, 0.67, 209, 41);
INSERT INTO public.europe_data VALUES (8351, 2, 1, 0.08, 89, 41);
INSERT INTO public.europe_data VALUES (8352, 7, 54, 0.44, 38, 41);
INSERT INTO public.europe_data VALUES (8353, 47, 1285, 0.96, 39, 41);
INSERT INTO public.europe_data VALUES (8354, 23, 125, 14.64, 186, 41);
INSERT INTO public.europe_data VALUES (8355, 0, 0, 0, 210, 41);
INSERT INTO public.europe_data VALUES (8356, 15, 304, 13.91, 187, 41);
INSERT INTO public.europe_data VALUES (8357, 2, 570, 26.17, 129, 41);
INSERT INTO public.europe_data VALUES (8358, 181, 6858, 5.43, 130, 41);
INSERT INTO public.europe_data VALUES (8359, 2, 27, 4.01, 131, 41);
INSERT INTO public.europe_data VALUES (8360, 35, 1418, 64.29, 90, 41);
INSERT INTO public.europe_data VALUES (8361, 0, 0, 0.01, 211, 41);
INSERT INTO public.europe_data VALUES (8362, 1, 168, 2.7, 91, 41);
INSERT INTO public.europe_data VALUES (8363, 558, 18411, 93.2, 92, 41);
INSERT INTO public.europe_data VALUES (8364, 106, 1644, 2.74, 132, 41);
INSERT INTO public.europe_data VALUES (8365, 143, 2076, 11.6, 188, 41);
INSERT INTO public.europe_data VALUES (8366, 135, 1678, 51.75, 189, 41);
INSERT INTO public.europe_data VALUES (8367, 13, 437, 20.28, 93, 41);
INSERT INTO public.europe_data VALUES (8368, 2, 5264, 356.74, 133, 41);
INSERT INTO public.europe_data VALUES (8369, 172, 2127, 22.75, 190, 41);
INSERT INTO public.europe_data VALUES (8370, 533, 53738, 62.96, 191, 41);
INSERT INTO public.europe_data VALUES (8371, 0, 68, 0.89, 40, 41);
INSERT INTO public.europe_data VALUES (8372, 0, 0, 0, 94, 41);
INSERT INTO public.europe_data VALUES (8373, 0, 3, 1.64, 95, 41);
INSERT INTO public.europe_data VALUES (8374, 0, 3, 4.52, 96, 41);
INSERT INTO public.europe_data VALUES (8375, 0, 44, 351.2, 192, 41);
INSERT INTO public.europe_data VALUES (8376, 1, 10, 6.51, 41, 41);
INSERT INTO public.europe_data VALUES (8377, 45, 9489, 51.5, 134, 41);
INSERT INTO public.europe_data VALUES (8378, 0, 511, 5, 42, 41);
INSERT INTO public.europe_data VALUES (8379, 37, 1422, 45.18, 193, 41);
INSERT INTO public.europe_data VALUES (8380, 0, 0, 0, 43, 41);
INSERT INTO public.europe_data VALUES (8381, 4, 64, 1.56, 44, 41);
INSERT INTO public.europe_data VALUES (8382, 6, 4581, 200.14, 135, 41);
INSERT INTO public.europe_data VALUES (8383, 0, 2, 21.23, 97, 41);
INSERT INTO public.europe_data VALUES (8384, 6, 29, 4.53, 194, 41);
INSERT INTO public.europe_data VALUES (8385, 14, 32, 5.24, 195, 41);
INSERT INTO public.europe_data VALUES (8386, 9, 286, 3.61, 45, 41);
INSERT INTO public.europe_data VALUES (8387, 44, 2237, 6.19, 46, 41);
INSERT INTO public.europe_data VALUES (8388, 9, 63, 0.25, 136, 41);
INSERT INTO public.europe_data VALUES (8389, 0, 40, 0.38, 47, 41);
INSERT INTO public.europe_data VALUES (8390, 2238, 7635, 50.57, 196, 41);
INSERT INTO public.europe_data VALUES (8391, 0, 195, 1.98, 137, 41);
INSERT INTO public.europe_data VALUES (8392, 20, 441, 1.43, 48, 41);
INSERT INTO public.europe_data VALUES (8393, 0, 0, 0, 98, 41);
INSERT INTO public.europe_data VALUES (8394, 544, 3832, 78.52, 197, 41);
INSERT INTO public.europe_data VALUES (8395, 136, 844, 25.33, 198, 41);
INSERT INTO public.europe_data VALUES (8396, 0, 1, 0.03, 138, 41);
INSERT INTO public.europe_data VALUES (8397, 0, 7, 0.07, 139, 41);
INSERT INTO public.europe_data VALUES (8398, 2, 76, 0, 140, 41);
INSERT INTO public.europe_data VALUES (8399, 3, 47, 0.29, 141, 41);
INSERT INTO public.europe_data VALUES (8400, 0, 0, 0.39, 142, 41);
INSERT INTO public.europe_data VALUES (8401, 3, 26, 0.49, 49, 41);
INSERT INTO public.europe_data VALUES (8402, 0, 0, 0.14, 99, 41);
INSERT INTO public.europe_data VALUES (8403, 4, 64, 1.15, 50, 41);
INSERT INTO public.europe_data VALUES (8404, 592, 15915, 48.46, 199, 41);
INSERT INTO public.europe_data VALUES (8405, 0, 1, 2.62, 100, 41);
INSERT INTO public.europe_data VALUES (8406, 0, 10, 0.08, 51, 41);
INSERT INTO public.europe_data VALUES (8407, 79, 3296, 14.69, 200, 41);
INSERT INTO public.europe_data VALUES (8408, 50, 3814, 73.9, 143, 41);
INSERT INTO public.europe_data VALUES (8409, 4227, 31282, 96.2, 201, 41);
INSERT INTO public.europe_data VALUES (8410, 6, 180, 0.53, 52, 41);
INSERT INTO public.europe_data VALUES (8411, 12806, 192131, 121.06, 101, 41);
INSERT INTO public.europe_data VALUES (8412, 1, 11, 12.43, 102, 41);
INSERT INTO public.europe_data VALUES (8413, 2, 49, 3.67, 103, 41);
INSERT INTO public.europe_data VALUES (8414, 2, 262, 1.77, 144, 41);
INSERT INTO public.europe_data VALUES (8415, 0, 32, 0.35, 104, 41);
INSERT INTO public.europe_data VALUES (8416, 0, 1, 0, 145, 41);
INSERT INTO public.europe_data VALUES (8417, 0, 0, 1.03, 53, 41);
INSERT INTO public.europe_data VALUES (8418, 2, 9, 0.03, 146, 41);
INSERT INTO public.europe_data VALUES (8419, 0, 36, 0.35, 54, 41);
INSERT INTO public.europe_data VALUES (8420, 0, 3, 0.06, 55, 41);
INSERT INTO public.europe_data VALUES (8421, 24, 535, 2.43, 105, 42);
INSERT INTO public.europe_data VALUES (8422, 2, 164, 9.78, 147, 42);
INSERT INTO public.europe_data VALUES (8423, 50, 753, 3.41, 1, 42);
INSERT INTO public.europe_data VALUES (8424, 4, 27, 133.9, 148, 42);
INSERT INTO public.europe_data VALUES (8425, 0, 2, 0.02, 2, 42);
INSERT INTO public.europe_data VALUES (8426, 0, 0, 0, 56, 42);
INSERT INTO public.europe_data VALUES (8427, 1, 1, 3.09, 57, 42);
INSERT INTO public.europe_data VALUES (8428, 52, 837, 3.49, 58, 42);
INSERT INTO public.europe_data VALUES (8429, 7, 469, 26, 149, 42);
INSERT INTO public.europe_data VALUES (8430, 0, 3, 7.53, 59, 42);
INSERT INTO public.europe_data VALUES (8431, 13, 101, 1.55, 202, 42);
INSERT INTO public.europe_data VALUES (8432, 90, 479, 14.13, 150, 42);
INSERT INTO public.europe_data VALUES (8433, 2, 247, 5.44, 151, 42);
INSERT INTO public.europe_data VALUES (8434, 2, 20, 8.47, 60, 42);
INSERT INTO public.europe_data VALUES (8435, 1, 774, 92.07, 106, 42);
INSERT INTO public.europe_data VALUES (8436, 54, 2960, 2.94, 107, 42);
INSERT INTO public.europe_data VALUES (8437, 1, 4, 2.79, 61, 42);
INSERT INTO public.europe_data VALUES (8438, 25, 4656, 83.42, 152, 42);
INSERT INTO public.europe_data VALUES (8439, 1195, 5703, 119.3, 153, 42);
INSERT INTO public.europe_data VALUES (8440, 0, 0, 1.02, 62, 42);
INSERT INTO public.europe_data VALUES (8441, 0, 27, 0.25, 3, 42);
INSERT INTO public.europe_data VALUES (8442, 0, 23, 83.19, 63, 42);
INSERT INTO public.europe_data VALUES (8443, 0, 2, 0.26, 108, 42);
INSERT INTO public.europe_data VALUES (8444, 17, 386, 5.39, 64, 42);
INSERT INTO public.europe_data VALUES (8445, 0, 1, 11.55, 65, 42);
INSERT INTO public.europe_data VALUES (8446, 12, 247, 15.42, 154, 42);
INSERT INTO public.europe_data VALUES (8447, 0, 2, 0.39, 4, 42);
INSERT INTO public.europe_data VALUES (8448, 1743, 23234, 18.82, 66, 42);
INSERT INTO public.europe_data VALUES (8449, 0, 2, 9.99, 67, 42);
INSERT INTO public.europe_data VALUES (8450, 0, 0, 0.46, 109, 42);
INSERT INTO public.europe_data VALUES (8451, 13, 385, 8.93, 155, 42);
INSERT INTO public.europe_data VALUES (8452, 6, 56, 0.66, 5, 42);
INSERT INTO public.europe_data VALUES (8453, 0, 9, 0.09, 6, 42);
INSERT INTO public.europe_data VALUES (8454, 0, 0, 0, 110, 42);
INSERT INTO public.europe_data VALUES (8455, 14, 605, 3.1, 7, 42);
INSERT INTO public.europe_data VALUES (8456, 980, 12107, 60.19, 68, 42);
INSERT INTO public.europe_data VALUES (8457, 0, 45, 17.46, 8, 42);
INSERT INTO public.europe_data VALUES (8458, 0, 9, 26.17, 69, 42);
INSERT INTO public.europe_data VALUES (8459, 0, 7, 0.17, 9, 42);
INSERT INTO public.europe_data VALUES (8460, 0, 13, 0.19, 10, 42);
INSERT INTO public.europe_data VALUES (8461, 56, 3243, 32.28, 70, 42);
INSERT INTO public.europe_data VALUES (8462, 1, 95, 0.05, 111, 42);
INSERT INTO public.europe_data VALUES (8463, 64, 1587, 5.17, 71, 42);
INSERT INTO public.europe_data VALUES (8464, 2, 40, 2.42, 12, 42);
INSERT INTO public.europe_data VALUES (8465, 2, 35, 1.98, 72, 42);
INSERT INTO public.europe_data VALUES (8466, 5, 303, 2.24, 13, 42);
INSERT INTO public.europe_data VALUES (8467, 8, 159, 10.55, 156, 42);
INSERT INTO public.europe_data VALUES (8468, 20, 334, 6.18, 73, 42);
INSERT INTO public.europe_data VALUES (8469, 0, 2, 1.22, 74, 42);
INSERT INTO public.europe_data VALUES (8470, 2, 50, 21.01, 157, 42);
INSERT INTO public.europe_data VALUES (8471, 33, 617, 13.27, 158, 42);
INSERT INTO public.europe_data VALUES (8472, 3, 127, 0.26, 14, 42);
INSERT INTO public.europe_data VALUES (8473, 67, 1191, 41.35, 159, 42);
INSERT INTO public.europe_data VALUES (8474, 0, 177, 83.1, 15, 42);
INSERT INTO public.europe_data VALUES (8475, 0, 0, 0, 75, 42);
INSERT INTO public.europe_data VALUES (8476, 52, 1455, 29.5, 76, 42);
INSERT INTO public.europe_data VALUES (8477, 102, 13251, 87.79, 77, 42);
INSERT INTO public.europe_data VALUES (8478, 68, 1175, 2.25, 16, 42);
INSERT INTO public.europe_data VALUES (8479, 1, 97, 2.68, 78, 42);
INSERT INTO public.europe_data VALUES (8480, 1, 179, 17.48, 17, 42);
INSERT INTO public.europe_data VALUES (8481, 0, 0, 0.14, 18, 42);
INSERT INTO public.europe_data VALUES (8482, 9, 115, 25.21, 160, 42);
INSERT INTO public.europe_data VALUES (8483, 0, 37, 3.92, 19, 42);
INSERT INTO public.europe_data VALUES (8484, 0, 15, 0.05, 20, 42);
INSERT INTO public.europe_data VALUES (8485, 0, 2, 237.25, 79, 42);
INSERT INTO public.europe_data VALUES (8486, 0, 2, 6.16, 161, 42);
INSERT INTO public.europe_data VALUES (8487, 0, 1, 0.22, 203, 42);
INSERT INTO public.europe_data VALUES (8488, 96, 793, 29.03, 162, 42);
INSERT INTO public.europe_data VALUES (8489, 3138, 11969, 43.53, 163, 42);
INSERT INTO public.europe_data VALUES (8490, 0, 2, 1.43, 204, 42);
INSERT INTO public.europe_data VALUES (8491, 2, 67, 5.48, 21, 42);
INSERT INTO public.europe_data VALUES (8492, 0, 0, 0.04, 22, 42);
INSERT INTO public.europe_data VALUES (8493, 2, 92, 5.73, 164, 42);
INSERT INTO public.europe_data VALUES (8494, 1346, 13521, 38.76, 165, 42);
INSERT INTO public.europe_data VALUES (8495, 2, 508, 3.23, 23, 42);
INSERT INTO public.europe_data VALUES (8496, 0, 8, 35.6, 166, 42);
INSERT INTO public.europe_data VALUES (8497, 20, 271, 3.66, 167, 42);
INSERT INTO public.europe_data VALUES (8498, 0, 0, 0, 80, 42);
INSERT INTO public.europe_data VALUES (8499, 0, 4, 3.57, 81, 42);
INSERT INTO public.europe_data VALUES (8500, 0, 6, 5.38, 205, 42);
INSERT INTO public.europe_data VALUES (8501, 8, 211, 1.96, 82, 42);
INSERT INTO public.europe_data VALUES (8502, 4, 8, 44.98, 168, 42);
INSERT INTO public.europe_data VALUES (8503, 2, 515, 6.61, 24, 42);
INSERT INTO public.europe_data VALUES (8504, 1, 3, 0.73, 25, 42);
INSERT INTO public.europe_data VALUES (8505, 1, 9, 3.7, 83, 42);
INSERT INTO public.europe_data VALUES (8506, 3, 25, 0.35, 84, 42);
INSERT INTO public.europe_data VALUES (8507, 0, 1, 122.7, 169, 42);
INSERT INTO public.europe_data VALUES (8508, 15, 184, 2.71, 85, 42);
INSERT INTO public.europe_data VALUES (8509, 81, 599, 11.51, 170, 42);
INSERT INTO public.europe_data VALUES (8510, 1, 21, 25.49, 171, 42);
INSERT INTO public.europe_data VALUES (8511, 329, 10627, 1.37, 112, 42);
INSERT INTO public.europe_data VALUES (8512, 161, 2307, 1.71, 113, 42);
INSERT INTO public.europe_data VALUES (8513, 592, 8270, 22.67, 114, 42);
INSERT INTO public.europe_data VALUES (8514, 5, 281, 1.19, 115, 42);
INSERT INTO public.europe_data VALUES (8515, 477, 4011, 195.89, 172, 42);
INSERT INTO public.europe_data VALUES (8516, 12, 10, 94.57, 173, 42);
INSERT INTO public.europe_data VALUES (8517, 27, 1907, 49.92, 116, 42);
INSERT INTO public.europe_data VALUES (8518, 2984, 18703, 68.44, 174, 42);
INSERT INTO public.europe_data VALUES (8519, 2, 154, 9.43, 86, 42);
INSERT INTO public.europe_data VALUES (8520, 180, 2634, 4.83, 117, 42);
INSERT INTO public.europe_data VALUES (8521, 7, 32, 63.08, 175, 42);
INSERT INTO public.europe_data VALUES (8522, 0, 30, 0.57, 118, 42);
INSERT INTO public.europe_data VALUES (8523, 6, 982, 9.47, 119, 42);
INSERT INTO public.europe_data VALUES (8524, 0, 85, 0.3, 26, 42);
INSERT INTO public.europe_data VALUES (8525, 6, 203, 22.35, 176, 42);
INSERT INTO public.europe_data VALUES (8526, 13, 1160, 43.76, 120, 42);
INSERT INTO public.europe_data VALUES (8527, 1, 127, 4.3, 121, 42);
INSERT INTO public.europe_data VALUES (8528, 0, 0, 0, 122, 42);
INSERT INTO public.europe_data VALUES (8529, 7, 85, 8.39, 177, 42);
INSERT INTO public.europe_data VALUES (8530, 3, 34, 1.12, 123, 42);
INSERT INTO public.europe_data VALUES (8531, 4, 33, 1.5, 28, 42);
INSERT INTO public.europe_data VALUES (8532, 1, 12, 0.53, 29, 42);
INSERT INTO public.europe_data VALUES (8533, 0, 1, 7.82, 178, 42);
INSERT INTO public.europe_data VALUES (8534, 5, 112, 13.46, 179, 42);
INSERT INTO public.europe_data VALUES (8535, 15, 173, 72, 180, 42);
INSERT INTO public.europe_data VALUES (8536, 0, 3, 0.07, 30, 42);
INSERT INTO public.europe_data VALUES (8537, 1, 17, 0.11, 31, 42);
INSERT INTO public.europe_data VALUES (8538, 9, 391, 3.43, 124, 42);
INSERT INTO public.europe_data VALUES (8539, 0, 162, 36.54, 125, 42);
INSERT INTO public.europe_data VALUES (8540, 9, 165, 1.39, 32, 42);
INSERT INTO public.europe_data VALUES (8541, 1, 18, 13.17, 181, 42);
INSERT INTO public.europe_data VALUES (8542, 0, 0, 0, 33, 42);
INSERT INTO public.europe_data VALUES (8543, 0, 4, 0.63, 34, 42);
INSERT INTO public.europe_data VALUES (8544, 665, 9135, 11.97, 87, 42);
INSERT INTO public.europe_data VALUES (8545, 29, 936, 43.18, 182, 42);
INSERT INTO public.europe_data VALUES (8546, 0, 0, 3.02, 183, 42);
INSERT INTO public.europe_data VALUES (8547, 0, 6, 0.68, 126, 42);
INSERT INTO public.europe_data VALUES (8548, 2, 13, 7.88, 184, 42);
INSERT INTO public.europe_data VALUES (8549, 1, 0, 0, 88, 42);
INSERT INTO public.europe_data VALUES (8550, 20, 1210, 6.59, 35, 42);
INSERT INTO public.europe_data VALUES (8551, 0, 37, 0.18, 36, 42);
INSERT INTO public.europe_data VALUES (8552, 0, 35, 0.19, 127, 42);
INSERT INTO public.europe_data VALUES (8553, 0, 0, 0, 37, 42);
INSERT INTO public.europe_data VALUES (8554, 0, 21, 0.14, 128, 42);
INSERT INTO public.europe_data VALUES (8555, 791, 5190, 70.93, 185, 42);
INSERT INTO public.europe_data VALUES (8556, 0, 0, 0, 208, 42);
INSERT INTO public.europe_data VALUES (8557, 7, 17, 1.21, 209, 42);
INSERT INTO public.europe_data VALUES (8558, 2, 4, 0.06, 89, 42);
INSERT INTO public.europe_data VALUES (8559, 9, 48, 0.72, 38, 42);
INSERT INTO public.europe_data VALUES (8560, 19, 646, 0.47, 39, 42);
INSERT INTO public.europe_data VALUES (8561, 10, 179, 26.86, 186, 42);
INSERT INTO public.europe_data VALUES (8562, 0, 0, 5.24, 210, 42);
INSERT INTO public.europe_data VALUES (8563, 39, 437, 20.46, 187, 42);
INSERT INTO public.europe_data VALUES (8564, 3, 732, 28.12, 129, 42);
INSERT INTO public.europe_data VALUES (8565, 105, 4910, 3.67, 130, 42);
INSERT INTO public.europe_data VALUES (8566, 0, 173, 4.56, 131, 42);
INSERT INTO public.europe_data VALUES (8567, 39, 1312, 56.02, 90, 42);
INSERT INTO public.europe_data VALUES (8568, 0, 1, 0.07, 211, 42);
INSERT INTO public.europe_data VALUES (8569, 1, 22, 1.15, 91, 42);
INSERT INTO public.europe_data VALUES (8570, 328, 11889, 61.51, 92, 42);
INSERT INTO public.europe_data VALUES (8571, 92, 1320, 2.71, 132, 42);
INSERT INTO public.europe_data VALUES (8572, 175, 2330, 13.02, 188, 42);
INSERT INTO public.europe_data VALUES (8573, 214, 3640, 70.66, 189, 42);
INSERT INTO public.europe_data VALUES (8574, 22, 158, 16.16, 93, 42);
INSERT INTO public.europe_data VALUES (8575, 2, 4839, 258.04, 133, 42);
INSERT INTO public.europe_data VALUES (8576, 174, 2290, 24.39, 190, 42);
INSERT INTO public.europe_data VALUES (8577, 386, 38096, 44.68, 191, 42);
INSERT INTO public.europe_data VALUES (8578, 0, 44, 0.51, 40, 42);
INSERT INTO public.europe_data VALUES (8579, 0, 0, 5.68, 94, 42);
INSERT INTO public.europe_data VALUES (8580, 0, 0, 0, 95, 42);
INSERT INTO public.europe_data VALUES (8581, 0, 2, 1.81, 96, 42);
INSERT INTO public.europe_data VALUES (8582, 2, 77, 528.26, 192, 42);
INSERT INTO public.europe_data VALUES (8583, 0, 4, 1.86, 41, 42);
INSERT INTO public.europe_data VALUES (8584, 42, 8160, 38.11, 134, 42);
INSERT INTO public.europe_data VALUES (8585, 5, 304, 2.4, 42, 42);
INSERT INTO public.europe_data VALUES (8586, 34, 1724, 63.36, 193, 42);
INSERT INTO public.europe_data VALUES (8587, 0, 0, 1.02, 43, 42);
INSERT INTO public.europe_data VALUES (8588, 4, 58, 1.06, 44, 42);
INSERT INTO public.europe_data VALUES (8589, 1, 7036, 191.1, 135, 42);
INSERT INTO public.europe_data VALUES (8590, 3, 7, 56.62, 97, 42);
INSERT INTO public.europe_data VALUES (8591, 6, 218, 11.69, 194, 42);
INSERT INTO public.europe_data VALUES (8592, 8, 77, 9.71, 195, 42);
INSERT INTO public.europe_data VALUES (8593, 16, 272, 2.66, 45, 42);
INSERT INTO public.europe_data VALUES (8594, 33, 1388, 4.05, 46, 42);
INSERT INTO public.europe_data VALUES (8595, 7, 64, 0.39, 136, 42);
INSERT INTO public.europe_data VALUES (8596, 0, 2, 0.02, 47, 42);
INSERT INTO public.europe_data VALUES (8597, 2338, 16100, 78.02, 196, 42);
INSERT INTO public.europe_data VALUES (8598, 0, 228, 1.47, 137, 42);
INSERT INTO public.europe_data VALUES (8599, 11, 171, 0.51, 48, 42);
INSERT INTO public.europe_data VALUES (8600, 0, 0, 0, 98, 42);
INSERT INTO public.europe_data VALUES (8601, 546, 4201, 77.73, 197, 42);
INSERT INTO public.europe_data VALUES (8602, 202, 1320, 43.98, 198, 42);
INSERT INTO public.europe_data VALUES (8603, 0, 4, 0.11, 138, 42);
INSERT INTO public.europe_data VALUES (8604, 0, 9, 0.17, 139, 42);
INSERT INTO public.europe_data VALUES (8605, 4, 157, 0.49, 141, 42);
INSERT INTO public.europe_data VALUES (8606, 0, 5, 1.7, 142, 42);
INSERT INTO public.europe_data VALUES (8607, 1, 14, 0.27, 49, 42);
INSERT INTO public.europe_data VALUES (8608, 0, 2, 0.22, 99, 42);
INSERT INTO public.europe_data VALUES (8609, 0, 70, 2.07, 50, 42);
INSERT INTO public.europe_data VALUES (8610, 788, 23824, 64.84, 199, 42);
INSERT INTO public.europe_data VALUES (8611, 0, 0, 5.24, 100, 42);
INSERT INTO public.europe_data VALUES (8612, 0, 24, 0.06, 51, 42);
INSERT INTO public.europe_data VALUES (8613, 68, 3168, 13.27, 200, 42);
INSERT INTO public.europe_data VALUES (8614, 35, 3406, 65.17, 143, 42);
INSERT INTO public.europe_data VALUES (8615, 5512, 32830, 97.31, 201, 42);
INSERT INTO public.europe_data VALUES (8616, 5, 130, 0.46, 52, 42);
INSERT INTO public.europe_data VALUES (8617, 14194, 206223, 124.09, 101, 42);
INSERT INTO public.europe_data VALUES (8618, 0, 2, 3.82, 102, 42);
INSERT INTO public.europe_data VALUES (8619, 5, 78, 4.07, 103, 42);
INSERT INTO public.europe_data VALUES (8620, 3, 322, 3.1, 144, 42);
INSERT INTO public.europe_data VALUES (8621, 1, 69, 0.5, 104, 42);
INSERT INTO public.europe_data VALUES (8622, 0, 2, 0.01, 145, 42);
INSERT INTO public.europe_data VALUES (8623, 0, 6, 0, 53, 42);
INSERT INTO public.europe_data VALUES (8624, 0, 0, 0, 146, 42);
INSERT INTO public.europe_data VALUES (8625, 0, 27, 0.25, 54, 42);
INSERT INTO public.europe_data VALUES (8626, 1, 6, 0.12, 55, 42);
INSERT INTO public.europe_data VALUES (8627, 15, 389, 1.83, 105, 43);
INSERT INTO public.europe_data VALUES (8628, 3, 116, 7.02, 147, 43);
INSERT INTO public.europe_data VALUES (8629, 82, 715, 3.04, 1, 43);
INSERT INTO public.europe_data VALUES (8630, 7, 75, 278.3, 148, 43);
INSERT INTO public.europe_data VALUES (8631, 0, 5, 0.03, 2, 43);
INSERT INTO public.europe_data VALUES (8632, 0, 0, 0, 56, 43);
INSERT INTO public.europe_data VALUES (8633, 0, 2, 8.24, 57, 43);
INSERT INTO public.europe_data VALUES (8634, 39, 727, 3.07, 58, 43);
INSERT INTO public.europe_data VALUES (8635, 8, 300, 17.11, 149, 43);
INSERT INTO public.europe_data VALUES (8636, 2, 5, 31.04, 59, 43);
INSERT INTO public.europe_data VALUES (8637, 9, 290, 3.44, 202, 43);
INSERT INTO public.europe_data VALUES (8638, 102, 773, 30.78, 150, 43);
INSERT INTO public.europe_data VALUES (8639, 8, 300, 8.1, 151, 43);
INSERT INTO public.europe_data VALUES (8640, 1, 13, 7.96, 60, 43);
INSERT INTO public.europe_data VALUES (8641, 1, 737, 71.47, 106, 43);
INSERT INTO public.europe_data VALUES (8642, 57, 1835, 1.45, 107, 43);
INSERT INTO public.europe_data VALUES (8643, 1, 4, 6.62, 61, 43);
INSERT INTO public.europe_data VALUES (8644, 21, 3229, 55.47, 152, 43);
INSERT INTO public.europe_data VALUES (8645, 1667, 7963, 167.06, 153, 43);
INSERT INTO public.europe_data VALUES (8646, 0, 4, 3.33, 62, 43);
INSERT INTO public.europe_data VALUES (8647, 0, 2, 0.13, 3, 43);
INSERT INTO public.europe_data VALUES (8648, 1, 29, 78.39, 63, 43);
INSERT INTO public.europe_data VALUES (8649, 0, 0, 0, 108, 43);
INSERT INTO public.europe_data VALUES (8650, 6, 234, 3.31, 64, 43);
INSERT INTO public.europe_data VALUES (8651, 0, 2, 11.55, 65, 43);
INSERT INTO public.europe_data VALUES (8652, 8, 262, 18.36, 154, 43);
INSERT INTO public.europe_data VALUES (8653, 0, 7, 0.61, 4, 43);
INSERT INTO public.europe_data VALUES (8654, 1239, 16485, 13.04, 66, 43);
INSERT INTO public.europe_data VALUES (8655, 1, 1, 3.33, 67, 43);
INSERT INTO public.europe_data VALUES (8656, 0, 2, 0.69, 109, 43);
INSERT INTO public.europe_data VALUES (8657, 14, 240, 5.49, 155, 43);
INSERT INTO public.europe_data VALUES (8658, 9, 79, 1.14, 5, 43);
INSERT INTO public.europe_data VALUES (8659, 1, 1, 0.03, 6, 43);
INSERT INTO public.europe_data VALUES (8660, 0, 0, 0.05, 110, 43);
INSERT INTO public.europe_data VALUES (8661, 30, 196, 1.41, 7, 43);
INSERT INTO public.europe_data VALUES (8662, 863, 10412, 51.54, 68, 43);
INSERT INTO public.europe_data VALUES (8663, 0, 51, 9.82, 8, 43);
INSERT INTO public.europe_data VALUES (8664, 0, 8, 33.87, 69, 43);
INSERT INTO public.europe_data VALUES (8665, 0, 1, 0.06, 9, 43);
INSERT INTO public.europe_data VALUES (8666, 0, 18, 0.15, 10, 43);
INSERT INTO public.europe_data VALUES (8667, 53, 2875, 29.64, 70, 43);
INSERT INTO public.europe_data VALUES (8668, 1291, 608, 0.08, 111, 43);
INSERT INTO public.europe_data VALUES (8669, 70, 1016, 4.58, 71, 43);
INSERT INTO public.europe_data VALUES (8670, 1, 90, 2.14, 12, 43);
INSERT INTO public.europe_data VALUES (8671, 1, 65, 4.08, 72, 43);
INSERT INTO public.europe_data VALUES (8672, 4, 273, 2.28, 13, 43);
INSERT INTO public.europe_data VALUES (8673, 24, 271, 16.9, 156, 43);
INSERT INTO public.europe_data VALUES (8674, 16, 366, 6.31, 73, 43);
INSERT INTO public.europe_data VALUES (8675, 0, 0, 1.84, 74, 43);
INSERT INTO public.europe_data VALUES (8676, 1, 134, 36.65, 157, 43);
INSERT INTO public.europe_data VALUES (8677, 50, 796, 20.66, 158, 43);
INSERT INTO public.europe_data VALUES (8678, 5, 98, 0.21, 14, 43);
INSERT INTO public.europe_data VALUES (8679, 82, 1210, 51.93, 159, 43);
INSERT INTO public.europe_data VALUES (8680, 0, 632, 80.84, 15, 43);
INSERT INTO public.europe_data VALUES (8681, 0, 0, 2.79, 75, 43);
INSERT INTO public.europe_data VALUES (8682, 53, 1713, 27.33, 76, 43);
INSERT INTO public.europe_data VALUES (8683, 141, 2002, 33.51, 77, 43);
INSERT INTO public.europe_data VALUES (8684, 80, 1079, 2.07, 16, 43);
INSERT INTO public.europe_data VALUES (8685, 1, 76, 2.05, 78, 43);
INSERT INTO public.europe_data VALUES (8686, 0, 58, 4.65, 17, 43);
INSERT INTO public.europe_data VALUES (8687, 0, 5, 0.29, 18, 43);
INSERT INTO public.europe_data VALUES (8688, 15, 219, 32.53, 160, 43);
INSERT INTO public.europe_data VALUES (8689, 1, 8, 1.13, 19, 43);
INSERT INTO public.europe_data VALUES (8690, 0, 37, 0.06, 20, 43);
INSERT INTO public.europe_data VALUES (8691, 0, 6, 266.9, 79, 43);
INSERT INTO public.europe_data VALUES (8692, 0, 1, 8.22, 161, 43);
INSERT INTO public.europe_data VALUES (8693, 0, 1, 0.34, 203, 43);
INSERT INTO public.europe_data VALUES (8694, 38, 809, 33.64, 162, 43);
INSERT INTO public.europe_data VALUES (8695, 5325, 17203, 62.87, 163, 43);
INSERT INTO public.europe_data VALUES (8696, 0, 2, 5.01, 204, 43);
INSERT INTO public.europe_data VALUES (8697, 0, 52, 4.05, 21, 43);
INSERT INTO public.europe_data VALUES (8698, 0, 1, 0.26, 22, 43);
INSERT INTO public.europe_data VALUES (8699, 1, 137, 5.5, 164, 43);
INSERT INTO public.europe_data VALUES (8700, 1605, 18656, 55.75, 165, 43);
INSERT INTO public.europe_data VALUES (8701, 1, 476, 2.72, 23, 43);
INSERT INTO public.europe_data VALUES (8702, 0, 4, 89, 166, 43);
INSERT INTO public.europe_data VALUES (8703, 12, 121, 4.66, 167, 43);
INSERT INTO public.europe_data VALUES (8704, 0, 0, 0, 80, 43);
INSERT INTO public.europe_data VALUES (8705, 0, 0, 1.79, 81, 43);
INSERT INTO public.europe_data VALUES (8706, 0, 3, 15.54, 205, 43);
INSERT INTO public.europe_data VALUES (8707, 2, 133, 1.25, 82, 43);
INSERT INTO public.europe_data VALUES (8708, 3, 21, 131.85, 168, 43);
INSERT INTO public.europe_data VALUES (8709, 5, 329, 3.59, 24, 43);
INSERT INTO public.europe_data VALUES (8710, 0, 11, 1.67, 25, 43);
INSERT INTO public.europe_data VALUES (8711, 1, 20, 4.6, 83, 43);
INSERT INTO public.europe_data VALUES (8712, 0, 14, 0.23, 84, 43);
INSERT INTO public.europe_data VALUES (8713, 0, 0, 122.7, 169, 43);
INSERT INTO public.europe_data VALUES (8714, 21, 80, 1.84, 85, 43);
INSERT INTO public.europe_data VALUES (8715, 90, 526, 12.69, 170, 43);
INSERT INTO public.europe_data VALUES (8716, 1, 70, 79.83, 171, 43);
INSERT INTO public.europe_data VALUES (8717, 235, 8113, 0.97, 112, 43);
INSERT INTO public.europe_data VALUES (8718, 209, 2334, 1.59, 113, 43);
INSERT INTO public.europe_data VALUES (8719, 644, 10525, 28.93, 114, 43);
INSERT INTO public.europe_data VALUES (8720, 6, 187, 1.47, 115, 43);
INSERT INTO public.europe_data VALUES (8721, 276, 5596, 206.76, 172, 43);
INSERT INTO public.europe_data VALUES (8722, 4, 70, 202.15, 173, 43);
INSERT INTO public.europe_data VALUES (8723, 69, 2346, 59.41, 116, 43);
INSERT INTO public.europe_data VALUES (8724, 3759, 22609, 82.88, 174, 43);
INSERT INTO public.europe_data VALUES (8725, 1, 124, 4.68, 86, 43);
INSERT INTO public.europe_data VALUES (8726, 69, 3496, 5.59, 117, 43);
INSERT INTO public.europe_data VALUES (8727, 8, 36, 87.2, 175, 43);
INSERT INTO public.europe_data VALUES (8728, 0, 28, 0.71, 118, 43);
INSERT INTO public.europe_data VALUES (8729, 9, 774, 6.49, 119, 43);
INSERT INTO public.europe_data VALUES (8730, 6, 73, 0.24, 26, 43);
INSERT INTO public.europe_data VALUES (8731, 7, 199, 22.02, 176, 43);
INSERT INTO public.europe_data VALUES (8732, 6, 681, 32.3, 120, 43);
INSERT INTO public.europe_data VALUES (8733, 2, 149, 5.49, 121, 43);
INSERT INTO public.europe_data VALUES (8734, 0, 0, 0.11, 122, 43);
INSERT INTO public.europe_data VALUES (8735, 0, 76, 10.1, 177, 43);
INSERT INTO public.europe_data VALUES (8736, 1, 43, 2.13, 123, 43);
INSERT INTO public.europe_data VALUES (8737, 3, 41, 1.58, 28, 43);
INSERT INTO public.europe_data VALUES (8738, 0, 24, 0.46, 29, 43);
INSERT INTO public.europe_data VALUES (8739, 0, 2, 10.42, 178, 43);
INSERT INTO public.europe_data VALUES (8740, 12, 264, 18.43, 179, 43);
INSERT INTO public.europe_data VALUES (8741, 7, 269, 121.52, 180, 43);
INSERT INTO public.europe_data VALUES (8742, 0, 15, 0.18, 30, 43);
INSERT INTO public.europe_data VALUES (8743, 0, 4, 0.07, 31, 43);
INSERT INTO public.europe_data VALUES (8744, 13, 706, 5.41, 124, 43);
INSERT INTO public.europe_data VALUES (8745, 0, 32, 6.22, 125, 43);
INSERT INTO public.europe_data VALUES (8746, 5, 108, 0.91, 32, 43);
INSERT INTO public.europe_data VALUES (8747, 0, 47, 38.5, 181, 43);
INSERT INTO public.europe_data VALUES (8748, 0, 0, 0.02, 33, 43);
INSERT INTO public.europe_data VALUES (8749, 0, 4, 7.95, 34, 43);
INSERT INTO public.europe_data VALUES (8750, 390, 6141, 7.47, 87, 43);
INSERT INTO public.europe_data VALUES (8751, 35, 810, 39.77, 182, 43);
INSERT INTO public.europe_data VALUES (8752, 0, 1, 42.32, 183, 43);
INSERT INTO public.europe_data VALUES (8753, 0, 16, 0.56, 126, 43);
INSERT INTO public.europe_data VALUES (8754, 2, 36, 15.11, 184, 43);
INSERT INTO public.europe_data VALUES (8755, 0, 0, 100.18, 88, 43);
INSERT INTO public.europe_data VALUES (8756, 23, 1194, 5.03, 35, 43);
INSERT INTO public.europe_data VALUES (8757, 0, 18, 0.1, 36, 43);
INSERT INTO public.europe_data VALUES (8758, 1, 70, 0.17, 127, 43);
INSERT INTO public.europe_data VALUES (8759, 0, 0, 0, 37, 43);
INSERT INTO public.europe_data VALUES (8760, 0, 19, 0.08, 128, 43);
INSERT INTO public.europe_data VALUES (8761, 947, 7068, 85.66, 185, 43);
INSERT INTO public.europe_data VALUES (8762, 0, 0, 0, 208, 43);
INSERT INTO public.europe_data VALUES (8763, 7, 41, 4.06, 209, 43);
INSERT INTO public.europe_data VALUES (8764, 0, 0, 0.06, 89, 43);
INSERT INTO public.europe_data VALUES (8765, 8, 119, 1.99, 38, 43);
INSERT INTO public.europe_data VALUES (8766, 11, 304, 0.2, 39, 43);
INSERT INTO public.europe_data VALUES (8767, 17, 379, 34.86, 186, 43);
INSERT INTO public.europe_data VALUES (8768, 0, 3, 10.49, 210, 43);
INSERT INTO public.europe_data VALUES (8769, 51, 653, 26.8, 187, 43);
INSERT INTO public.europe_data VALUES (8770, 3, 667, 19.46, 129, 43);
INSERT INTO public.europe_data VALUES (8771, 83, 3044, 2.37, 130, 43);
INSERT INTO public.europe_data VALUES (8772, 0, 54, 2.11, 131, 43);
INSERT INTO public.europe_data VALUES (8773, 39, 1067, 58.38, 90, 43);
INSERT INTO public.europe_data VALUES (8774, 0, 5, 0.07, 211, 43);
INSERT INTO public.europe_data VALUES (8775, 2, 59, 1.32, 91, 43);
INSERT INTO public.europe_data VALUES (8776, 207, 8109, 41.05, 92, 43);
INSERT INTO public.europe_data VALUES (8777, 112, 1611, 2.79, 132, 43);
INSERT INTO public.europe_data VALUES (8778, 128, 2613, 13.65, 188, 43);
INSERT INTO public.europe_data VALUES (8779, 210, 3621, 86.88, 189, 43);
INSERT INTO public.europe_data VALUES (8780, 18, 316, 25.16, 93, 43);
INSERT INTO public.europe_data VALUES (8781, 1, 2469, 135.73, 133, 43);
INSERT INTO public.europe_data VALUES (8782, 128, 2446, 25.15, 190, 43);
INSERT INTO public.europe_data VALUES (8783, 231, 27083, 25.68, 191, 43);
INSERT INTO public.europe_data VALUES (8784, 0, 21, 0.34, 40, 43);
INSERT INTO public.europe_data VALUES (8785, 0, 3, 9.46, 94, 43);
INSERT INTO public.europe_data VALUES (8786, 0, 0, 0.55, 95, 43);
INSERT INTO public.europe_data VALUES (8787, 0, 0, 4.52, 96, 43);
INSERT INTO public.europe_data VALUES (8788, 4, 105, 565.99, 192, 43);
INSERT INTO public.europe_data VALUES (8789, 0, 0, 1.86, 41, 43);
INSERT INTO public.europe_data VALUES (8790, 38, 4900, 20.36, 134, 43);
INSERT INTO public.europe_data VALUES (8791, 2, 87, 0.89, 42, 43);
INSERT INTO public.europe_data VALUES (8792, 42, 2688, 63.33, 193, 43);
INSERT INTO public.europe_data VALUES (8793, 0, 1, 1.02, 43, 43);
INSERT INTO public.europe_data VALUES (8794, 0, 25, 0.37, 44, 43);
INSERT INTO public.europe_data VALUES (8795, 3, 4056, 90.95, 135, 43);
INSERT INTO public.europe_data VALUES (8796, 1, 17, 99.08, 97, 43);
INSERT INTO public.europe_data VALUES (8797, 10, 419, 12.4, 194, 43);
INSERT INTO public.europe_data VALUES (8798, 21, 125, 16, 195, 43);
INSERT INTO public.europe_data VALUES (8799, 5, 139, 1.02, 45, 43);
INSERT INTO public.europe_data VALUES (8800, 29, 985, 2.57, 46, 43);
INSERT INTO public.europe_data VALUES (8801, 19, 137, 0.76, 136, 43);
INSERT INTO public.europe_data VALUES (8802, 0, 0, 0.03, 47, 43);
INSERT INTO public.europe_data VALUES (8803, 3880, 20519, 113.07, 196, 43);
INSERT INTO public.europe_data VALUES (8804, 0, 85, 0.6, 137, 43);
INSERT INTO public.europe_data VALUES (8805, 8, 47, 0.13, 48, 43);
INSERT INTO public.europe_data VALUES (8806, 0, 0, 0, 98, 43);
INSERT INTO public.europe_data VALUES (8807, 658, 3751, 73.21, 197, 43);
INSERT INTO public.europe_data VALUES (8808, 276, 2438, 77.66, 198, 43);
INSERT INTO public.europe_data VALUES (8809, 1, 14, 0.12, 138, 43);
INSERT INTO public.europe_data VALUES (8810, 0, 32, 0.24, 139, 43);
INSERT INTO public.europe_data VALUES (8811, 7, 186, 0.78, 141, 43);
INSERT INTO public.europe_data VALUES (8812, 0, 17, 1.39, 142, 43);
INSERT INTO public.europe_data VALUES (8813, 2, 8, 0.49, 49, 43);
INSERT INTO public.europe_data VALUES (8814, 0, 1, 0.72, 99, 43);
INSERT INTO public.europe_data VALUES (8815, 7, 172, 2.79, 50, 43);
INSERT INTO public.europe_data VALUES (8816, 819, 29350, 72.24, 199, 43);
INSERT INTO public.europe_data VALUES (8817, 0, 2, 15.71, 100, 43);
INSERT INTO public.europe_data VALUES (8818, 0, 1, 0.01, 51, 43);
INSERT INTO public.europe_data VALUES (8819, 58, 2672, 9.41, 200, 43);
INSERT INTO public.europe_data VALUES (8820, 19, 2961, 52.81, 143, 43);
INSERT INTO public.europe_data VALUES (8821, 6166, 32027, 96.38, 201, 43);
INSERT INTO public.europe_data VALUES (8822, 2, 138, 0.26, 52, 43);
INSERT INTO public.europe_data VALUES (8823, 18574, 202116, 128.26, 101, 43);
INSERT INTO public.europe_data VALUES (8824, 2, 2, 10.52, 102, 43);
INSERT INTO public.europe_data VALUES (8825, 2, 63, 3.5, 103, 43);
INSERT INTO public.europe_data VALUES (8826, 1, 700, 3.71, 144, 43);
INSERT INTO public.europe_data VALUES (8827, 0, 75, 0.38, 104, 43);
INSERT INTO public.europe_data VALUES (8828, 0, 4, 0.02, 145, 43);
INSERT INTO public.europe_data VALUES (8829, 0, 0, 0, 146, 43);
INSERT INTO public.europe_data VALUES (8830, 1, 18, 0.12, 54, 43);
INSERT INTO public.europe_data VALUES (8831, 0, 11, 0.11, 55, 43);
INSERT INTO public.europe_data VALUES (8832, 11, 308, 1.3, 105, 44);
INSERT INTO public.europe_data VALUES (8833, 2, 85, 8.17, 147, 44);
INSERT INTO public.europe_data VALUES (8834, 141, 594, 3.26, 1, 44);
INSERT INTO public.europe_data VALUES (8835, 11, 137, 399.07, 148, 44);
INSERT INTO public.europe_data VALUES (8836, 0, 5, 0.04, 2, 44);
INSERT INTO public.europe_data VALUES (8837, 0, 0, 6.72, 56, 44);
INSERT INTO public.europe_data VALUES (8838, 2, 6, 14.42, 57, 44);
INSERT INTO public.europe_data VALUES (8839, 49, 649, 3.09, 58, 44);
INSERT INTO public.europe_data VALUES (8840, 6, 206, 18.83, 149, 44);
INSERT INTO public.europe_data VALUES (8841, 0, 28, 39.51, 59, 44);
INSERT INTO public.europe_data VALUES (8842, 25, 578, 8.84, 202, 44);
INSERT INTO public.europe_data VALUES (8843, 146, 1954, 57.84, 150, 44);
INSERT INTO public.europe_data VALUES (8844, 4, 514, 8.85, 151, 44);
INSERT INTO public.europe_data VALUES (8845, 3, 18, 8.47, 60, 44);
INSERT INTO public.europe_data VALUES (8846, 2, 436, 38.75, 106, 44);
INSERT INTO public.europe_data VALUES (8847, 25, 533, 0.35, 107, 44);
INSERT INTO public.europe_data VALUES (8848, 3, 15, 13.24, 61, 44);
INSERT INTO public.europe_data VALUES (8849, 18, 2014, 26.28, 152, 44);
INSERT INTO public.europe_data VALUES (8850, 1979, 11175, 182.17, 153, 44);
INSERT INTO public.europe_data VALUES (8851, 1, 9, 3.07, 62, 44);
INSERT INTO public.europe_data VALUES (8852, 1, 13, 0.25, 3, 44);
INSERT INTO public.europe_data VALUES (8853, 4, 20, 55.99, 63, 44);
INSERT INTO public.europe_data VALUES (8854, 0, 0, 0.13, 108, 44);
INSERT INTO public.europe_data VALUES (8855, 16, 147, 2.03, 64, 44);
INSERT INTO public.europe_data VALUES (8856, 0, 1, 11.55, 65, 44);
INSERT INTO public.europe_data VALUES (8857, 14, 344, 20.72, 154, 44);
INSERT INTO public.europe_data VALUES (8858, 0, 7, 0.56, 4, 44);
INSERT INTO public.europe_data VALUES (8859, 737, 11039, 8.49, 66, 44);
INSERT INTO public.europe_data VALUES (8860, 0, 0, 3.33, 67, 44);
INSERT INTO public.europe_data VALUES (8861, 0, 1, 2.31, 109, 44);
INSERT INTO public.europe_data VALUES (8862, 9, 144, 4.7, 155, 44);
INSERT INTO public.europe_data VALUES (8863, 10, 152, 1.56, 5, 44);
INSERT INTO public.europe_data VALUES (8864, 0, 2, 0.04, 6, 44);
INSERT INTO public.europe_data VALUES (8865, 0, 8, 0.09, 110, 44);
INSERT INTO public.europe_data VALUES (8866, 3, 170, 2.79, 7, 44);
INSERT INTO public.europe_data VALUES (8867, 437, 8869, 48.41, 68, 44);
INSERT INTO public.europe_data VALUES (8868, 0, 3, 0.91, 8, 44);
INSERT INTO public.europe_data VALUES (8869, 0, 14, 69.29, 69, 44);
INSERT INTO public.europe_data VALUES (8870, 0, 2, 0.11, 9, 44);
INSERT INTO public.europe_data VALUES (8871, 0, 6, 0.06, 10, 44);
INSERT INTO public.europe_data VALUES (8872, 46, 2742, 26.77, 70, 44);
INSERT INTO public.europe_data VALUES (8873, 10, 567, 0.07, 111, 44);
INSERT INTO public.europe_data VALUES (8874, 74, 1291, 4.12, 71, 44);
INSERT INTO public.europe_data VALUES (8875, 0, 25, 0.95, 12, 44);
INSERT INTO public.europe_data VALUES (8876, 1, 141, 5.57, 72, 44);
INSERT INTO public.europe_data VALUES (8877, 2, 313, 1.59, 13, 44);
INSERT INTO public.europe_data VALUES (8878, 8, 418, 21.76, 156, 44);
INSERT INTO public.europe_data VALUES (8879, 10, 349, 4.68, 73, 44);
INSERT INTO public.europe_data VALUES (8880, 0, 3, 3.06, 74, 44);
INSERT INTO public.europe_data VALUES (8881, 2, 187, 47.84, 157, 44);
INSERT INTO public.europe_data VALUES (8882, 71, 1404, 29.69, 158, 44);
INSERT INTO public.europe_data VALUES (8883, 2, 80, 0.18, 14, 44);
INSERT INTO public.europe_data VALUES (8884, 94, 1805, 65.09, 159, 44);
INSERT INTO public.europe_data VALUES (8885, 2, 155, 20.03, 15, 44);
INSERT INTO public.europe_data VALUES (8886, 0, 2, 6.96, 75, 44);
INSERT INTO public.europe_data VALUES (8887, 91, 1222, 19.63, 76, 44);
INSERT INTO public.europe_data VALUES (8888, 153, 3820, 32.09, 77, 44);
INSERT INTO public.europe_data VALUES (8889, 88, 995, 1.48, 16, 44);
INSERT INTO public.europe_data VALUES (8890, 3, 56, 1.47, 78, 44);
INSERT INTO public.europe_data VALUES (8891, 0, 5, 0.52, 17, 44);
INSERT INTO public.europe_data VALUES (8892, 0, 5, 0.63, 18, 44);
INSERT INTO public.europe_data VALUES (8893, 10, 212, 47.55, 160, 44);
INSERT INTO public.europe_data VALUES (8894, 0, 5, 0.44, 19, 44);
INSERT INTO public.europe_data VALUES (8895, 1, 28, 0.05, 20, 44);
INSERT INTO public.europe_data VALUES (8896, 0, 3, 148.28, 79, 44);
INSERT INTO public.europe_data VALUES (8897, 0, 3, 51.36, 161, 44);
INSERT INTO public.europe_data VALUES (8898, 0, 2, 1.24, 203, 44);
INSERT INTO public.europe_data VALUES (8899, 29, 1047, 31.82, 162, 44);
INSERT INTO public.europe_data VALUES (8900, 6315, 24925, 82.42, 163, 44);
INSERT INTO public.europe_data VALUES (8901, 0, 12, 6.45, 204, 44);
INSERT INTO public.europe_data VALUES (8902, 0, 36, 2.3, 21, 44);
INSERT INTO public.europe_data VALUES (8903, 0, 5, 0.26, 22, 44);
INSERT INTO public.europe_data VALUES (8904, 1, 83, 4.18, 164, 44);
INSERT INTO public.europe_data VALUES (8905, 1365, 27625, 79.16, 165, 44);
INSERT INTO public.europe_data VALUES (8906, 3, 352, 1.36, 23, 44);
INSERT INTO public.europe_data VALUES (8907, 0, 26, 189.88, 166, 44);
INSERT INTO public.europe_data VALUES (8908, 25, 379, 8.93, 167, 44);
INSERT INTO public.europe_data VALUES (8909, 0, 0, 1.76, 80, 44);
INSERT INTO public.europe_data VALUES (8910, 0, 2, 4.46, 81, 44);
INSERT INTO public.europe_data VALUES (8911, 1, 23, 46.03, 205, 44);
INSERT INTO public.europe_data VALUES (8912, 2, 86, 0.68, 82, 44);
INSERT INTO public.europe_data VALUES (8913, 3, 64, 268.35, 168, 44);
INSERT INTO public.europe_data VALUES (8914, 0, 129, 1.89, 24, 44);
INSERT INTO public.europe_data VALUES (8915, 0, 21, 1.93, 25, 44);
INSERT INTO public.europe_data VALUES (8916, 2, 16, 4.73, 83, 44);
INSERT INTO public.europe_data VALUES (8917, 3, 12, 0.16, 84, 44);
INSERT INTO public.europe_data VALUES (8918, 0, 1, 245.4, 169, 44);
INSERT INTO public.europe_data VALUES (8919, 3, 99, 2.65, 85, 44);
INSERT INTO public.europe_data VALUES (8920, 71, 714, 10.35, 170, 44);
INSERT INTO public.europe_data VALUES (8921, 4, 215, 190.76, 171, 44);
INSERT INTO public.europe_data VALUES (8922, 199, 5085, 0.59, 112, 44);
INSERT INTO public.europe_data VALUES (8923, 175, 1968, 1.09, 113, 44);
INSERT INTO public.europe_data VALUES (8924, 871, 13460, 40.26, 114, 44);
INSERT INTO public.europe_data VALUES (8925, 15, 391, 2.05, 115, 44);
INSERT INTO public.europe_data VALUES (8926, 176, 4544, 143.55, 172, 44);
INSERT INTO public.europe_data VALUES (8927, 1, 101, 219.89, 173, 44);
INSERT INTO public.europe_data VALUES (8928, 54, 2715, 80.97, 116, 44);
INSERT INTO public.europe_data VALUES (8929, 4012, 27415, 97.21, 174, 44);
INSERT INTO public.europe_data VALUES (8930, 1, 14, 1.29, 86, 44);
INSERT INTO public.europe_data VALUES (8931, 29, 3601, 4.25, 117, 44);
INSERT INTO public.europe_data VALUES (8932, 1, 58, 139.15, 175, 44);
INSERT INTO public.europe_data VALUES (8933, 2, 44, 1.29, 118, 44);
INSERT INTO public.europe_data VALUES (8934, 5, 430, 3.65, 119, 44);
INSERT INTO public.europe_data VALUES (8935, 4, 55, 0.29, 26, 44);
INSERT INTO public.europe_data VALUES (8936, 6, 197, 14.68, 176, 44);
INSERT INTO public.europe_data VALUES (8937, 0, 678, 23.27, 120, 44);
INSERT INTO public.europe_data VALUES (8938, 1, 203, 5.22, 121, 44);
INSERT INTO public.europe_data VALUES (8939, 0, 8, 0.18, 122, 44);
INSERT INTO public.europe_data VALUES (8940, 4, 118, 14.32, 177, 44);
INSERT INTO public.europe_data VALUES (8941, 2, 103, 2.8, 123, 44);
INSERT INTO public.europe_data VALUES (8942, 2, 37, 0.95, 28, 44);
INSERT INTO public.europe_data VALUES (8943, 0, 7, 0.25, 29, 44);
INSERT INTO public.europe_data VALUES (8944, 0, 2, 46.9, 178, 44);
INSERT INTO public.europe_data VALUES (8945, 11, 251, 20.69, 179, 44);
INSERT INTO public.europe_data VALUES (8946, 30, 477, 216.81, 180, 44);
INSERT INTO public.europe_data VALUES (8947, 0, 34, 0.26, 30, 44);
INSERT INTO public.europe_data VALUES (8948, 2, 9, 0.07, 31, 44);
INSERT INTO public.europe_data VALUES (8949, 15, 1021, 6.93, 124, 44);
INSERT INTO public.europe_data VALUES (8950, 0, 1, 0.57, 125, 44);
INSERT INTO public.europe_data VALUES (8951, 4, 71, 0.5, 32, 44);
INSERT INTO public.europe_data VALUES (8952, 3, 143, 46.2, 181, 44);
INSERT INTO public.europe_data VALUES (8953, 0, 1, 0.04, 33, 44);
INSERT INTO public.europe_data VALUES (8954, 2, 97, 16.85, 34, 44);
INSERT INTO public.europe_data VALUES (8955, 202, 3386, 4.29, 87, 44);
INSERT INTO public.europe_data VALUES (8956, 17, 798, 34.6, 182, 44);
INSERT INTO public.europe_data VALUES (8957, 1, 13, 87.65, 183, 44);
INSERT INTO public.europe_data VALUES (8958, 0, 2, 0.12, 126, 44);
INSERT INTO public.europe_data VALUES (8959, 1, 58, 30.06, 184, 44);
INSERT INTO public.europe_data VALUES (8960, 0, 5, 120.22, 88, 44);
INSERT INTO public.europe_data VALUES (8961, 48, 640, 3.24, 35, 44);
INSERT INTO public.europe_data VALUES (8962, 0, 11, 0.04, 36, 44);
INSERT INTO public.europe_data VALUES (8963, 3, 20, 0.06, 127, 44);
INSERT INTO public.europe_data VALUES (8964, 0, 0, 0.2, 37, 44);
INSERT INTO public.europe_data VALUES (8965, 0, 3, 0.02, 128, 44);
INSERT INTO public.europe_data VALUES (8966, 971, 7736, 85.18, 185, 44);
INSERT INTO public.europe_data VALUES (8967, 0, 0, 1.06, 208, 44);
INSERT INTO public.europe_data VALUES (8968, 4, 153, 10.7, 209, 44);
INSERT INTO public.europe_data VALUES (8969, 0, 4, 0.08, 89, 44);
INSERT INTO public.europe_data VALUES (8970, 2, 345, 2.23, 38, 44);
INSERT INTO public.europe_data VALUES (8971, 5, 91, 0.11, 39, 44);
INSERT INTO public.europe_data VALUES (8972, 17, 345, 27.39, 186, 44);
INSERT INTO public.europe_data VALUES (8973, 1, 3, 19.23, 210, 44);
INSERT INTO public.europe_data VALUES (8974, 45, 775, 43.41, 187, 44);
INSERT INTO public.europe_data VALUES (8975, 2, 301, 8.68, 129, 44);
INSERT INTO public.europe_data VALUES (8976, 43, 2097, 1.78, 130, 44);
INSERT INTO public.europe_data VALUES (8977, 1, 51, 3.25, 131, 44);
INSERT INTO public.europe_data VALUES (8978, 33, 1412, 56.78, 90, 44);
INSERT INTO public.europe_data VALUES (8979, 0, 1, 0.01, 211, 44);
INSERT INTO public.europe_data VALUES (8980, 1, 34, 1.18, 91, 44);
INSERT INTO public.europe_data VALUES (8981, 110, 5238, 20.51, 92, 44);
INSERT INTO public.europe_data VALUES (8982, 145, 1402, 2.99, 132, 44);
INSERT INTO public.europe_data VALUES (8983, 138, 2572, 12.67, 188, 44);
INSERT INTO public.europe_data VALUES (8984, 209, 5307, 103.37, 189, 44);
INSERT INTO public.europe_data VALUES (8985, 24, 422, 26.25, 93, 44);
INSERT INTO public.europe_data VALUES (8986, 3, 1375, 82.8, 133, 44);
INSERT INTO public.europe_data VALUES (8987, 158, 2436, 23.38, 190, 44);
INSERT INTO public.europe_data VALUES (8988, 85, 10381, 9.76, 191, 44);
INSERT INTO public.europe_data VALUES (8989, 0, 22, 0.44, 40, 44);
INSERT INTO public.europe_data VALUES (8990, 0, 2, 9.46, 94, 44);
INSERT INTO public.europe_data VALUES (8991, 0, 1, 3.28, 95, 44);
INSERT INTO public.europe_data VALUES (8992, 0, 5, 9.95, 96, 44);
INSERT INTO public.europe_data VALUES (8993, 3, 90, 368.62, 192, 44);
INSERT INTO public.europe_data VALUES (8994, 0, 4, 0, 41, 44);
INSERT INTO public.europe_data VALUES (8995, 25, 2077, 9.43, 134, 44);
INSERT INTO public.europe_data VALUES (8996, 0, 58, 0.85, 42, 44);
INSERT INTO public.europe_data VALUES (8997, 29, 1722, 41.49, 193, 44);
INSERT INTO public.europe_data VALUES (8998, 0, 0, 2.05, 43, 44);
INSERT INTO public.europe_data VALUES (8999, 0, 4, 0.13, 44, 44);
INSERT INTO public.europe_data VALUES (9000, 2, 1223, 29.08, 135, 44);
INSERT INTO public.europe_data VALUES (9001, 5, 25, 110.88, 97, 44);
INSERT INTO public.europe_data VALUES (9002, 2, 257, 7.45, 194, 44);
INSERT INTO public.europe_data VALUES (9003, 25, 208, 22.83, 195, 44);
INSERT INTO public.europe_data VALUES (9004, 2, 18, 0.14, 45, 44);
INSERT INTO public.europe_data VALUES (9005, 14, 518, 1.52, 46, 44);
INSERT INTO public.europe_data VALUES (9006, 31, 253, 1.71, 136, 44);
INSERT INTO public.europe_data VALUES (9007, 0, 3, 0.04, 47, 44);
INSERT INTO public.europe_data VALUES (9008, 4554, 32553, 167.95, 196, 44);
INSERT INTO public.europe_data VALUES (9009, 2, 44, 0.42, 137, 44);
INSERT INTO public.europe_data VALUES (9010, 0, 7, 0.03, 48, 44);
INSERT INTO public.europe_data VALUES (9011, 0, 0, 0.34, 98, 44);
INSERT INTO public.europe_data VALUES (9012, 664, 3739, 68.1, 197, 44);
INSERT INTO public.europe_data VALUES (9013, 299, 4198, 128.11, 198, 44);
INSERT INTO public.europe_data VALUES (9014, 0, 6, 0.09, 138, 44);
INSERT INTO public.europe_data VALUES (9015, 1, 25, 0.34, 139, 44);
INSERT INTO public.europe_data VALUES (9016, 14, 359, 1.71, 141, 44);
INSERT INTO public.europe_data VALUES (9017, 0, 1, 0.08, 142, 44);
INSERT INTO public.europe_data VALUES (9018, 0, 32, 0.57, 49, 44);
INSERT INTO public.europe_data VALUES (9019, 1, 9, 2.51, 99, 44);
INSERT INTO public.europe_data VALUES (9020, 12, 154, 3.67, 50, 44);
INSERT INTO public.europe_data VALUES (9021, 624, 29887, 58.15, 199, 44);
INSERT INTO public.europe_data VALUES (9022, 0, 4, 10.47, 100, 44);
INSERT INTO public.europe_data VALUES (9023, 0, 2, 0.05, 51, 44);
INSERT INTO public.europe_data VALUES (9024, 46, 1469, 5.36, 200, 44);
INSERT INTO public.europe_data VALUES (9025, 12, 2199, 34.92, 143, 44);
INSERT INTO public.europe_data VALUES (9026, 6440, 32205, 93.87, 201, 44);
INSERT INTO public.europe_data VALUES (9027, 2, 10, 0.03, 52, 44);
INSERT INTO public.europe_data VALUES (9028, 12461, 219936, 125.98, 101, 44);
INSERT INTO public.europe_data VALUES (9029, 0, 9, 20.08, 102, 44);
INSERT INTO public.europe_data VALUES (9030, 2, 58, 4.91, 103, 44);
INSERT INTO public.europe_data VALUES (9031, 2, 523, 2.18, 144, 44);
INSERT INTO public.europe_data VALUES (9032, 4, 33, 0.22, 104, 44);
INSERT INTO public.europe_data VALUES (9033, 0, 19, 0.06, 145, 44);
INSERT INTO public.europe_data VALUES (9034, 0, 1, 0, 146, 44);
INSERT INTO public.europe_data VALUES (9035, 1, 4, 0.08, 54, 44);
INSERT INTO public.europe_data VALUES (9036, 2, 5, 0.05, 55, 44);
INSERT INTO public.europe_data VALUES (9037, 3, 185, 0.7, 105, 45);
INSERT INTO public.europe_data VALUES (9038, 11, 149, 9.5, 147, 45);
INSERT INTO public.europe_data VALUES (9039, 121, 809, 2.6, 1, 45);
INSERT INTO public.europe_data VALUES (9040, 12, 167, 509.34, 148, 45);
INSERT INTO public.europe_data VALUES (9041, 0, 7, 0.04, 2, 45);
INSERT INTO public.europe_data VALUES (9042, 0, 1, 20.17, 56, 45);
INSERT INTO public.europe_data VALUES (9043, 0, 8, 14.42, 57, 45);
INSERT INTO public.europe_data VALUES (9044, 26, 734, 2.88, 58, 45);
INSERT INTO public.europe_data VALUES (9045, 5, 351, 21.6, 149, 45);
INSERT INTO public.europe_data VALUES (9046, 0, 14, 60.2, 59, 45);
INSERT INTO public.europe_data VALUES (9047, 20, 1651, 16.01, 202, 45);
INSERT INTO public.europe_data VALUES (9048, 118, 3170, 94.28, 150, 45);
INSERT INTO public.europe_data VALUES (9049, 3, 375, 5.17, 151, 45);
INSERT INTO public.europe_data VALUES (9050, 5, 15, 6.42, 60, 45);
INSERT INTO public.europe_data VALUES (9051, 0, 200, 22.3, 106, 45);
INSERT INTO public.europe_data VALUES (9052, 4, 39, 0.04, 107, 45);
INSERT INTO public.europe_data VALUES (9053, 1, 23, 13.59, 61, 45);
INSERT INTO public.europe_data VALUES (9054, 8, 470, 5.16, 152, 45);
INSERT INTO public.europe_data VALUES (9055, 1584, 9694, 155.59, 153, 45);
INSERT INTO public.europe_data VALUES (9056, 1, 3, 1.28, 62, 45);
INSERT INTO public.europe_data VALUES (9057, 0, 16, 0.17, 3, 45);
INSERT INTO public.europe_data VALUES (9058, 0, 15, 49.59, 63, 45);
INSERT INTO public.europe_data VALUES (9059, 0, 1, 0.39, 108, 45);
INSERT INTO public.europe_data VALUES (9060, 8, 87, 1.35, 64, 45);
INSERT INTO public.europe_data VALUES (9061, 0, 2, 0, 65, 45);
INSERT INTO public.europe_data VALUES (9062, 18, 340, 16.3, 154, 45);
INSERT INTO public.europe_data VALUES (9063, 1, 6, 0, 4, 45);
INSERT INTO public.europe_data VALUES (9064, 350, 6874, 4.54, 66, 45);
INSERT INTO public.europe_data VALUES (9065, 0, 1, 9.99, 67, 45);
INSERT INTO public.europe_data VALUES (9066, 0, 9, 10.85, 109, 45);
INSERT INTO public.europe_data VALUES (9067, 12, 185, 4.94, 155, 45);
INSERT INTO public.europe_data VALUES (9068, 8, 165, 1.38, 5, 45);
INSERT INTO public.europe_data VALUES (9069, 0, 3, 0, 6, 45);
INSERT INTO public.europe_data VALUES (9070, 0, 7, 0.17, 110, 45);
INSERT INTO public.europe_data VALUES (9071, 7, 551, 2.41, 7, 45);
INSERT INTO public.europe_data VALUES (9072, 219, 9241, 37.6, 68, 45);
INSERT INTO public.europe_data VALUES (9073, 0, 2, 0.73, 8, 45);
INSERT INTO public.europe_data VALUES (9074, 0, 31, 55.43, 69, 45);
INSERT INTO public.europe_data VALUES (9075, 0, 3, 0.11, 9, 45);
INSERT INTO public.europe_data VALUES (9076, 0, 4, 0.04, 10, 45);
INSERT INTO public.europe_data VALUES (9077, 27, 2332, 20.26, 70, 45);
INSERT INTO public.europe_data VALUES (9078, 29, 485, 0.08, 111, 45);
INSERT INTO public.europe_data VALUES (9079, 25, 783, 2.48, 71, 45);
INSERT INTO public.europe_data VALUES (9080, 5, 26, 0.76, 12, 45);
INSERT INTO public.europe_data VALUES (9081, 0, 140, 6.34, 72, 45);
INSERT INTO public.europe_data VALUES (9082, 2, 96, 0.92, 13, 45);
INSERT INTO public.europe_data VALUES (9083, 9, 469, 23.23, 156, 45);
INSERT INTO public.europe_data VALUES (9084, 5, 181, 2.51, 73, 45);
INSERT INTO public.europe_data VALUES (9085, 0, 2, 6.73, 74, 45);
INSERT INTO public.europe_data VALUES (9086, 3, 232, 40.07, 157, 45);
INSERT INTO public.europe_data VALUES (9087, 51, 1758, 32.13, 158, 45);
INSERT INTO public.europe_data VALUES (9088, 10, 73, 0.15, 14, 45);
INSERT INTO public.europe_data VALUES (9089, 107, 1974, 51.22, 159, 45);
INSERT INTO public.europe_data VALUES (9090, 0, 40, 5.96, 15, 45);
INSERT INTO public.europe_data VALUES (9091, 0, 3, 18.1, 75, 45);
INSERT INTO public.europe_data VALUES (9092, 43, 886, 14.37, 76, 45);
INSERT INTO public.europe_data VALUES (9093, 122, 1756, 16.44, 77, 45);
INSERT INTO public.europe_data VALUES (9094, 35, 494, 0.77, 16, 45);
INSERT INTO public.europe_data VALUES (9095, 3, 39, 1.02, 78, 45);
INSERT INTO public.europe_data VALUES (9096, 0, 2, 0.74, 17, 45);
INSERT INTO public.europe_data VALUES (9097, 0, 17, 0.8, 18, 45);
INSERT INTO public.europe_data VALUES (9098, 12, 418, 58.2, 160, 45);
INSERT INTO public.europe_data VALUES (9099, 0, 0, 0.44, 19, 45);
INSERT INTO public.europe_data VALUES (9100, 2, 27, 0.03, 20, 45);
INSERT INTO public.europe_data VALUES (9101, 0, 2, 0, 79, 45);
INSERT INTO public.europe_data VALUES (9102, 0, 22, 135.59, 161, 45);
INSERT INTO public.europe_data VALUES (9103, 0, 9, 1.24, 203, 45);
INSERT INTO public.europe_data VALUES (9104, 16, 709, 23.58, 162, 45);
INSERT INTO public.europe_data VALUES (9105, 5472, 30304, 81.27, 163, 45);
INSERT INTO public.europe_data VALUES (9106, 0, 6, 8.24, 204, 45);
INSERT INTO public.europe_data VALUES (9107, 0, 14, 0.69, 21, 45);
INSERT INTO public.europe_data VALUES (9108, 0, 1, 0.13, 22, 45);
INSERT INTO public.europe_data VALUES (9109, 2, 84, 3, 164, 45);
INSERT INTO public.europe_data VALUES (9110, 979, 38093, 85.06, 165, 45);
INSERT INTO public.europe_data VALUES (9111, 0, 62, 0.62, 23, 45);
INSERT INTO public.europe_data VALUES (9112, 0, 38, 261.08, 166, 45);
INSERT INTO public.europe_data VALUES (9113, 35, 579, 10.36, 167, 45);
INSERT INTO public.europe_data VALUES (9114, 0, 1, 15.88, 80, 45);
INSERT INTO public.europe_data VALUES (9115, 0, 3, 9.82, 81, 45);
INSERT INTO public.europe_data VALUES (9116, 3, 54, 49.61, 205, 45);
INSERT INTO public.europe_data VALUES (9117, 2, 34, 0.29, 82, 45);
INSERT INTO public.europe_data VALUES (9118, 3, 109, 212.51, 168, 45);
INSERT INTO public.europe_data VALUES (9119, 0, 113, 0.93, 24, 45);
INSERT INTO public.europe_data VALUES (9120, 0, 16, 0.94, 25, 45);
INSERT INTO public.europe_data VALUES (9121, 3, 21, 3.07, 83, 45);
INSERT INTO public.europe_data VALUES (9122, 0, 6, 0.17, 84, 45);
INSERT INTO public.europe_data VALUES (9123, 0, 1, 736.2, 169, 45);
INSERT INTO public.europe_data VALUES (9124, 19, 159, 2.78, 85, 45);
INSERT INTO public.europe_data VALUES (9125, 23, 297, 5.9, 170, 45);
INSERT INTO public.europe_data VALUES (9126, 2, 466, 257.15, 171, 45);
INSERT INTO public.europe_data VALUES (9127, 80, 2996, 0.27, 112, 45);
INSERT INTO public.europe_data VALUES (9128, 84, 988, 0.65, 113, 45);
INSERT INTO public.europe_data VALUES (9129, 963, 19917, 44.13, 114, 45);
INSERT INTO public.europe_data VALUES (9130, 19, 414, 1.85, 115, 45);
INSERT INTO public.europe_data VALUES (9131, 112, 2496, 85.74, 172, 45);
INSERT INTO public.europe_data VALUES (9132, 1, 85, 147.77, 173, 45);
INSERT INTO public.europe_data VALUES (9133, 34, 4183, 86.38, 116, 45);
INSERT INTO public.europe_data VALUES (9134, 5108, 31259, 115.66, 174, 45);
INSERT INTO public.europe_data VALUES (9135, 2, 24, 1.32, 86, 45);
INSERT INTO public.europe_data VALUES (9136, 19, 1788, 2.02, 117, 45);
INSERT INTO public.europe_data VALUES (9137, 1, 92, 129.87, 175, 45);
INSERT INTO public.europe_data VALUES (9138, 4, 86, 2.44, 118, 45);
INSERT INTO public.europe_data VALUES (9139, 4, 247, 2.54, 119, 45);
INSERT INTO public.europe_data VALUES (9140, 3, 100, 0.24, 26, 45);
INSERT INTO public.europe_data VALUES (9141, 0, 67, 7.34, 176, 45);
INSERT INTO public.europe_data VALUES (9142, 1, 301, 8.75, 120, 45);
INSERT INTO public.europe_data VALUES (9143, 4, 132, 3.15, 121, 45);
INSERT INTO public.europe_data VALUES (9144, 0, 5, 0.15, 122, 45);
INSERT INTO public.europe_data VALUES (9145, 1, 157, 20.52, 177, 45);
INSERT INTO public.europe_data VALUES (9146, 8, 89, 4.07, 123, 45);
INSERT INTO public.europe_data VALUES (9147, 3, 10, 0.2, 28, 45);
INSERT INTO public.europe_data VALUES (9148, 1, 10, 0.27, 29, 45);
INSERT INTO public.europe_data VALUES (9149, 1, 16, 83.38, 178, 45);
INSERT INTO public.europe_data VALUES (9150, 6, 327, 23.91, 179, 45);
INSERT INTO public.europe_data VALUES (9151, 15, 854, 326.77, 180, 45);
INSERT INTO public.europe_data VALUES (9152, 0, 35, 0.26, 30, 45);
INSERT INTO public.europe_data VALUES (9153, 0, 4, 0, 31, 45);
INSERT INTO public.europe_data VALUES (9154, 27, 1192, 7.37, 124, 45);
INSERT INTO public.europe_data VALUES (9155, 0, 2, 1.13, 125, 45);
INSERT INTO public.europe_data VALUES (9156, 5, 27, 0.23, 32, 45);
INSERT INTO public.europe_data VALUES (9157, 0, 85, 27.15, 181, 45);
INSERT INTO public.europe_data VALUES (9158, 1, 1, 0.09, 33, 45);
INSERT INTO public.europe_data VALUES (9159, 4, 117, 15.67, 34, 45);
INSERT INTO public.europe_data VALUES (9160, 74, 2083, 2.59, 87, 45);
INSERT INTO public.europe_data VALUES (9161, 13, 601, 19.04, 182, 45);
INSERT INTO public.europe_data VALUES (9162, 0, 16, 93.7, 183, 45);
INSERT INTO public.europe_data VALUES (9163, 0, 2, 0.12, 126, 45);
INSERT INTO public.europe_data VALUES (9164, 1, 129, 31.02, 184, 45);
INSERT INTO public.europe_data VALUES (9165, 0, 1, 100.18, 88, 45);
INSERT INTO public.europe_data VALUES (9166, 44, 542, 2.48, 35, 45);
INSERT INTO public.europe_data VALUES (9167, 0, 2, 0.03, 36, 45);
INSERT INTO public.europe_data VALUES (9168, 1, 13, 0.04, 127, 45);
INSERT INTO public.europe_data VALUES (9169, 0, 5, 0.52, 37, 45);
INSERT INTO public.europe_data VALUES (9170, 0, 4, 0.03, 128, 45);
INSERT INTO public.europe_data VALUES (9171, 995, 6985, 78.97, 185, 45);
INSERT INTO public.europe_data VALUES (9172, 0, 3, 4.6, 208, 45);
INSERT INTO public.europe_data VALUES (9173, 0, 359, 16.91, 209, 45);
INSERT INTO public.europe_data VALUES (9174, 0, 1, 0.05, 89, 45);
INSERT INTO public.europe_data VALUES (9175, 9, 174, 0.79, 38, 45);
INSERT INTO public.europe_data VALUES (9176, 4, 135, 0.1, 39, 45);
INSERT INTO public.europe_data VALUES (9177, 11, 224, 17.76, 186, 45);
INSERT INTO public.europe_data VALUES (9178, 1, 8, 0, 210, 45);
INSERT INTO public.europe_data VALUES (9179, 36, 1538, 65.84, 187, 45);
INSERT INTO public.europe_data VALUES (9180, 2, 131, 4.88, 129, 45);
INSERT INTO public.europe_data VALUES (9181, 37, 1751, 1.15, 130, 45);
INSERT INTO public.europe_data VALUES (9182, 0, 111, 3.17, 131, 45);
INSERT INTO public.europe_data VALUES (9183, 30, 999, 39.44, 90, 45);
INSERT INTO public.europe_data VALUES (9184, 0, 0, 0, 211, 45);
INSERT INTO public.europe_data VALUES (9185, 2, 49, 1.29, 91, 45);
INSERT INTO public.europe_data VALUES (9186, 65, 1429, 5.9, 92, 45);
INSERT INTO public.europe_data VALUES (9187, 81, 1828, 2.65, 132, 45);
INSERT INTO public.europe_data VALUES (9188, 72, 2240, 9.13, 188, 45);
INSERT INTO public.europe_data VALUES (9189, 176, 5316, 94.17, 189, 45);
INSERT INTO public.europe_data VALUES (9190, 15, 348, 16.19, 93, 45);
INSERT INTO public.europe_data VALUES (9191, 3, 970, 39.19, 133, 45);
INSERT INTO public.europe_data VALUES (9192, 108, 2104, 17.67, 190, 45);
INSERT INTO public.europe_data VALUES (9193, 37, 3855, 3.44, 191, 45);
INSERT INTO public.europe_data VALUES (9194, 0, 34, 0.67, 40, 45);
INSERT INTO public.europe_data VALUES (9195, 0, 3, 18.93, 94, 45);
INSERT INTO public.europe_data VALUES (9196, 0, 5, 6.56, 95, 45);
INSERT INTO public.europe_data VALUES (9197, 0, 6, 6.33, 96, 45);
INSERT INTO public.europe_data VALUES (9198, 8, 37, 333.79, 192, 45);
INSERT INTO public.europe_data VALUES (9199, 26, 1156, 5.47, 134, 45);
INSERT INTO public.europe_data VALUES (9200, 2, 80, 0.95, 42, 45);
INSERT INTO public.europe_data VALUES (9201, 38, 1167, 24.7, 193, 45);
INSERT INTO public.europe_data VALUES (9202, 0, 2, 3.07, 43, 45);
INSERT INTO public.europe_data VALUES (9203, 0, 6, 0, 44, 45);
INSERT INTO public.europe_data VALUES (9204, 3, 465, 14.71, 135, 45);
INSERT INTO public.europe_data VALUES (9205, 4, 22, 58.98, 97, 45);
INSERT INTO public.europe_data VALUES (9206, 0, 149, 5.5, 194, 45);
INSERT INTO public.europe_data VALUES (9207, 17, 267, 28.02, 195, 45);
INSERT INTO public.europe_data VALUES (9208, 0, 4, 0.04, 45, 45);
INSERT INTO public.europe_data VALUES (9209, 9, 375, 2.36, 46, 45);
INSERT INTO public.europe_data VALUES (9210, 28, 623, 2.58, 136, 45);
INSERT INTO public.europe_data VALUES (9211, 0, 1, 0, 47, 45);
INSERT INTO public.europe_data VALUES (9212, 5890, 46276, 215.47, 196, 45);
INSERT INTO public.europe_data VALUES (9213, 4, 46, 0.37, 137, 45);
INSERT INTO public.europe_data VALUES (9214, 1, 7, 0.02, 48, 45);
INSERT INTO public.europe_data VALUES (9215, 1, 2, 0.86, 98, 45);
INSERT INTO public.europe_data VALUES (9216, 451, 3228, 50.68, 197, 45);
INSERT INTO public.europe_data VALUES (9217, 302, 6748, 164.44, 198, 45);
INSERT INTO public.europe_data VALUES (9218, 1, 10, 0.11, 138, 45);
INSERT INTO public.europe_data VALUES (9219, 0, 57, 0.83, 139, 45);
INSERT INTO public.europe_data VALUES (9220, 19, 832, 2.15, 141, 45);
INSERT INTO public.europe_data VALUES (9221, 0, 0, 0, 142, 45);
INSERT INTO public.europe_data VALUES (9222, 2, 14, 0.36, 49, 45);
INSERT INTO public.europe_data VALUES (9223, 4, 26, 3.87, 99, 45);
INSERT INTO public.europe_data VALUES (9224, 11, 275, 4.09, 50, 45);
INSERT INTO public.europe_data VALUES (9225, 443, 17798, 31.5, 199, 45);
INSERT INTO public.europe_data VALUES (9226, 1, 0, 13.09, 100, 45);
INSERT INTO public.europe_data VALUES (9227, 0, 19, 0.12, 51, 45);
INSERT INTO public.europe_data VALUES (9228, 28, 890, 2.87, 200, 45);
INSERT INTO public.europe_data VALUES (9229, 7, 1213, 16.68, 143, 45);
INSERT INTO public.europe_data VALUES (9230, 4197, 30357, 72.39, 201, 45);
INSERT INTO public.europe_data VALUES (9231, 0, 8, 0.02, 52, 45);
INSERT INTO public.europe_data VALUES (9232, 7138, 194610, 91.91, 101, 45);
INSERT INTO public.europe_data VALUES (9233, 1, 12, 40.16, 102, 45);
INSERT INTO public.europe_data VALUES (9234, 5, 112, 7.19, 103, 45);
INSERT INTO public.europe_data VALUES (9235, 1, 197, 0.9, 144, 45);
INSERT INTO public.europe_data VALUES (9236, 4, 29, 0.39, 104, 45);
INSERT INTO public.europe_data VALUES (9237, 0, 42, 0.13, 145, 45);
INSERT INTO public.europe_data VALUES (9238, 1, 10, 0.2, 54, 45);
INSERT INTO public.europe_data VALUES (9239, 0, 2, 0.05, 55, 45);
INSERT INTO public.europe_data VALUES (9240, 4, 80, 0.26, 105, 46);
INSERT INTO public.europe_data VALUES (9241, 8, 123, 5.94, 147, 46);
INSERT INTO public.europe_data VALUES (9242, 14, 310, 1.08, 1, 46);
INSERT INTO public.europe_data VALUES (9243, 6, 221, 431.89, 148, 46);
INSERT INTO public.europe_data VALUES (9244, 2, 5, 0.02, 2, 46);
INSERT INTO public.europe_data VALUES (9245, 0, 2, 0, 56, 46);
INSERT INTO public.europe_data VALUES (9246, 0, 6, 7.21, 57, 46);
INSERT INTO public.europe_data VALUES (9247, 16, 554, 1.71, 58, 46);
INSERT INTO public.europe_data VALUES (9248, 3, 288, 15.35, 149, 46);
INSERT INTO public.europe_data VALUES (9249, 0, 50, 0, 59, 46);
INSERT INTO public.europe_data VALUES (9250, 9, 2384, 15.06, 202, 46);
INSERT INTO public.europe_data VALUES (9251, 70, 5182, 89.78, 150, 46);
INSERT INTO public.europe_data VALUES (9252, 3, 144, 1.89, 151, 46);
INSERT INTO public.europe_data VALUES (9253, 0, 10, 3.34, 60, 46);
INSERT INTO public.europe_data VALUES (9254, 2, 166, 17.43, 106, 46);
INSERT INTO public.europe_data VALUES (9255, 2, 22, 0.03, 107, 46);
INSERT INTO public.europe_data VALUES (9256, 0, 16, 11.5, 61, 46);
INSERT INTO public.europe_data VALUES (9257, 0, 18, 0.71, 152, 46);
INSERT INTO public.europe_data VALUES (9258, 782, 8130, 103.03, 153, 46);
INSERT INTO public.europe_data VALUES (9259, 0, 2, 0, 62, 46);
INSERT INTO public.europe_data VALUES (9260, 0, 4, 0.05, 3, 46);
INSERT INTO public.europe_data VALUES (9261, 0, 16, 35.2, 63, 46);
INSERT INTO public.europe_data VALUES (9262, 0, 2, 0.52, 108, 46);
INSERT INTO public.europe_data VALUES (9263, 3, 69, 0.83, 64, 46);
INSERT INTO public.europe_data VALUES (9264, 5, 198, 9.24, 154, 46);
INSERT INTO public.europe_data VALUES (9265, 111, 2710, 1.92, 66, 46);
INSERT INTO public.europe_data VALUES (9266, 0, 2, 0, 67, 46);
INSERT INTO public.europe_data VALUES (9267, 1, 38, 17.54, 109, 46);
INSERT INTO public.europe_data VALUES (9268, 5, 161, 4.21, 155, 46);
INSERT INTO public.europe_data VALUES (9269, 6, 116, 0.87, 5, 46);
INSERT INTO public.europe_data VALUES (9270, 0, 21, 0.58, 110, 46);
INSERT INTO public.europe_data VALUES (9271, 2, 72, 0.37, 7, 46);
INSERT INTO public.europe_data VALUES (9272, 41, 4825, 15.91, 68, 46);
INSERT INTO public.europe_data VALUES (9273, 1, 2, 0.91, 8, 46);
INSERT INTO public.europe_data VALUES (9274, 0, 5, 12.32, 69, 46);
INSERT INTO public.europe_data VALUES (9275, 0, 2, 0.11, 9, 46);
INSERT INTO public.europe_data VALUES (9276, 0, 3, 0.03, 10, 46);
INSERT INTO public.europe_data VALUES (9277, 6, 1507, 10.89, 70, 46);
INSERT INTO public.europe_data VALUES (9278, 32, 673, 0.08, 111, 46);
INSERT INTO public.europe_data VALUES (9279, 8, 467, 1.31, 71, 46);
INSERT INTO public.europe_data VALUES (9280, 0, 15, 0.33, 12, 46);
INSERT INTO public.europe_data VALUES (9281, 0, 180, 5.53, 72, 46);
INSERT INTO public.europe_data VALUES (9282, 1, 140, 0.63, 13, 46);
INSERT INTO public.europe_data VALUES (9283, 6, 478, 16.31, 156, 46);
INSERT INTO public.europe_data VALUES (9284, 2, 104, 1.23, 73, 46);
INSERT INTO public.europe_data VALUES (9285, 1, 9, 0, 74, 46);
INSERT INTO public.europe_data VALUES (9286, 6, 119, 21.01, 157, 46);
INSERT INTO public.europe_data VALUES (9287, 15, 1664, 23.77, 158, 46);
INSERT INTO public.europe_data VALUES (9288, 6, 55, 0.09, 14, 46);
INSERT INTO public.europe_data VALUES (9289, 59, 1000, 26.18, 159, 46);
INSERT INTO public.europe_data VALUES (9290, 0, 18, 1.95, 15, 46);
INSERT INTO public.europe_data VALUES (9291, 0, 10, 15.32, 75, 46);
INSERT INTO public.europe_data VALUES (9292, 36, 657, 7.9, 76, 46);
INSERT INTO public.europe_data VALUES (9293, 44, 1101, 10.67, 77, 46);
INSERT INTO public.europe_data VALUES (9294, 26, 282, 0.46, 16, 46);
INSERT INTO public.europe_data VALUES (9295, 0, 27, 0.46, 78, 46);
INSERT INTO public.europe_data VALUES (9296, 0, 8, 0.96, 17, 46);
INSERT INTO public.europe_data VALUES (9297, 0, 11, 0.34, 18, 46);
INSERT INTO public.europe_data VALUES (9298, 3, 353, 38.34, 160, 46);
INSERT INTO public.europe_data VALUES (9299, 0, 5, 0.7, 19, 46);
INSERT INTO public.europe_data VALUES (9300, 0, 5, 0.01, 20, 46);
INSERT INTO public.europe_data VALUES (9301, 0, 44, 308.15, 161, 46);
INSERT INTO public.europe_data VALUES (9302, 0, 2, 0.56, 203, 46);
INSERT INTO public.europe_data VALUES (9303, 10, 592, 17.23, 162, 46);
INSERT INTO public.europe_data VALUES (9304, 1932, 24156, 51.86, 163, 46);
INSERT INTO public.europe_data VALUES (9305, 0, 17, 12.53, 204, 46);
INSERT INTO public.europe_data VALUES (9306, 0, 1, 0.28, 21, 46);
INSERT INTO public.europe_data VALUES (9307, 1, 2, 0.13, 22, 46);
INSERT INTO public.europe_data VALUES (9308, 0, 36, 1.5, 164, 46);
INSERT INTO public.europe_data VALUES (9309, 361, 32524, 63.19, 165, 46);
INSERT INTO public.europe_data VALUES (9310, 4, 128, 0.49, 23, 46);
INSERT INTO public.europe_data VALUES (9311, 0, 50, 192.84, 166, 46);
INSERT INTO public.europe_data VALUES (9312, 23, 532, 7.69, 167, 46);
INSERT INTO public.europe_data VALUES (9313, 0, 8, 17.65, 80, 46);
INSERT INTO public.europe_data VALUES (9314, 0, 8, 8.04, 81, 46);
INSERT INTO public.europe_data VALUES (9315, 0, 29, 33.47, 205, 46);
INSERT INTO public.europe_data VALUES (9316, 0, 17, 0.2, 82, 46);
INSERT INTO public.europe_data VALUES (9317, 0, 28, 69.8, 168, 46);
INSERT INTO public.europe_data VALUES (9318, 0, 6, 0.06, 24, 46);
INSERT INTO public.europe_data VALUES (9319, 0, 2, 0, 25, 46);
INSERT INTO public.europe_data VALUES (9320, 0, 3, 0.51, 83, 46);
INSERT INTO public.europe_data VALUES (9321, 0, 13, 0.13, 84, 46);
INSERT INTO public.europe_data VALUES (9322, 0, 5, 613.5, 169, 46);
INSERT INTO public.europe_data VALUES (9323, 3, 112, 1.36, 85, 46);
INSERT INTO public.europe_data VALUES (9324, 8, 280, 4.17, 170, 46);
INSERT INTO public.europe_data VALUES (9325, 1, 452, 235.86, 171, 46);
INSERT INTO public.europe_data VALUES (9326, 22, 632, 0.07, 112, 46);
INSERT INTO public.europe_data VALUES (9327, 66, 771, 0.43, 113, 46);
INSERT INTO public.europe_data VALUES (9328, 955, 16671, 29.39, 114, 46);
INSERT INTO public.europe_data VALUES (9329, 22, 314, 1.08, 115, 46);
INSERT INTO public.europe_data VALUES (9330, 42, 1709, 49.88, 172, 46);
INSERT INTO public.europe_data VALUES (9331, 0, 40, 49.65, 173, 46);
INSERT INTO public.europe_data VALUES (9332, 14, 3176, 46.92, 116, 46);
INSERT INTO public.europe_data VALUES (9333, 5305, 38551, 122.12, 174, 46);
INSERT INTO public.europe_data VALUES (9334, 1, 15, 0.81, 86, 46);
INSERT INTO public.europe_data VALUES (9335, 13, 777, 0.83, 117, 46);
INSERT INTO public.europe_data VALUES (9336, 2, 48, 58.44, 175, 46);
INSERT INTO public.europe_data VALUES (9337, 1, 160, 2.42, 118, 46);
INSERT INTO public.europe_data VALUES (9338, 1, 224, 1.48, 119, 46);
INSERT INTO public.europe_data VALUES (9339, 1, 27, 0.07, 26, 46);
INSERT INTO public.europe_data VALUES (9340, 0, 65, 4.73, 176, 46);
INSERT INTO public.europe_data VALUES (9341, 0, 67, 3.4, 120, 46);
INSERT INTO public.europe_data VALUES (9342, 0, 70, 1.31, 121, 46);
INSERT INTO public.europe_data VALUES (9343, 0, 6, 0, 122, 46);
INSERT INTO public.europe_data VALUES (9344, 0, 237, 17.97, 177, 46);
INSERT INTO public.europe_data VALUES (9345, 6, 190, 4.94, 123, 46);
INSERT INTO public.europe_data VALUES (9346, 0, 0, 0.06, 28, 46);
INSERT INTO public.europe_data VALUES (9347, 0, 8, 0, 29, 46);
INSERT INTO public.europe_data VALUES (9348, 0, 16, 143.31, 178, 46);
INSERT INTO public.europe_data VALUES (9349, 6, 341, 16.82, 179, 46);
INSERT INTO public.europe_data VALUES (9350, 13, 1152, 305.1, 180, 46);
INSERT INTO public.europe_data VALUES (9351, 0, 34, 0.14, 30, 46);
INSERT INTO public.europe_data VALUES (9352, 24, 1164, 6.39, 124, 46);
INSERT INTO public.europe_data VALUES (9353, 0, 4, 0.75, 125, 46);
INSERT INTO public.europe_data VALUES (9354, 0, 18, 0, 32, 46);
INSERT INTO public.europe_data VALUES (9355, 0, 49, 25.53, 181, 46);
INSERT INTO public.europe_data VALUES (9356, 0, 3, 0.09, 33, 46);
INSERT INTO public.europe_data VALUES (9357, 1, 82, 8.66, 34, 46);
INSERT INTO public.europe_data VALUES (9358, 18, 1221, 1.47, 87, 46);
INSERT INTO public.europe_data VALUES (9359, 1, 169, 5.94, 182, 46);
INSERT INTO public.europe_data VALUES (9360, 0, 15, 78.59, 183, 46);
INSERT INTO public.europe_data VALUES (9361, 0, 2, 0.37, 126, 46);
INSERT INTO public.europe_data VALUES (9362, 1, 64, 13.66, 184, 46);
INSERT INTO public.europe_data VALUES (9363, 0, 4, 100.18, 88, 46);
INSERT INTO public.europe_data VALUES (9364, 22, 364, 1.24, 35, 46);
INSERT INTO public.europe_data VALUES (9365, 0, 7, 0.03, 36, 46);
INSERT INTO public.europe_data VALUES (9366, 0, 8, 0, 127, 46);
INSERT INTO public.europe_data VALUES (9367, 0, 8, 0.36, 37, 46);
INSERT INTO public.europe_data VALUES (9368, 0, 4, 0.01, 128, 46);
INSERT INTO public.europe_data VALUES (9369, 592, 6662, 56.31, 185, 46);
INSERT INTO public.europe_data VALUES (9370, 0, 10, 5.3, 208, 46);
INSERT INTO public.europe_data VALUES (9371, 1, 450, 11.37, 209, 46);
INSERT INTO public.europe_data VALUES (9372, 1, 2, 0.06, 89, 46);
INSERT INTO public.europe_data VALUES (9373, 1, 9, 0.04, 38, 46);
INSERT INTO public.europe_data VALUES (9374, 1, 67, 0.05, 39, 46);
INSERT INTO public.europe_data VALUES (9375, 5, 145, 11.84, 186, 46);
INSERT INTO public.europe_data VALUES (9376, 15, 1970, 56.77, 187, 46);
INSERT INTO public.europe_data VALUES (9377, 0, 112, 2.91, 129, 46);
INSERT INTO public.europe_data VALUES (9378, 8, 742, 0.69, 130, 46);
INSERT INTO public.europe_data VALUES (9379, 1, 47, 1.37, 131, 46);
INSERT INTO public.europe_data VALUES (9380, 21, 676, 22.28, 90, 46);
INSERT INTO public.europe_data VALUES (9381, 0, 0, 0.01, 211, 46);
INSERT INTO public.europe_data VALUES (9382, 2, 42, 0.79, 91, 46);
INSERT INTO public.europe_data VALUES (9383, 13, 489, 2.4, 92, 46);
INSERT INTO public.europe_data VALUES (9384, 46, 1038, 1.18, 132, 46);
INSERT INTO public.europe_data VALUES (9385, 15, 1228, 4.57, 188, 46);
INSERT INTO public.europe_data VALUES (9386, 105, 4362, 55.63, 189, 46);
INSERT INTO public.europe_data VALUES (9387, 5, 127, 0, 93, 46);
INSERT INTO public.europe_data VALUES (9388, 1, 140, 8.23, 133, 46);
INSERT INTO public.europe_data VALUES (9389, 38, 1327, 8.35, 190, 46);
INSERT INTO public.europe_data VALUES (9390, 8, 1167, 1.01, 191, 46);
INSERT INTO public.europe_data VALUES (9391, 0, 51, 0.51, 40, 46);
INSERT INTO public.europe_data VALUES (9392, 0, 7, 0, 94, 46);
INSERT INTO public.europe_data VALUES (9393, 0, 7, 3.83, 95, 46);
INSERT INTO public.europe_data VALUES (9394, 0, 1, 0, 96, 46);
INSERT INTO public.europe_data VALUES (9395, 4, 78, 380.23, 192, 46);
INSERT INTO public.europe_data VALUES (9396, 8, 718, 3.24, 134, 46);
INSERT INTO public.europe_data VALUES (9397, 0, 75, 0.71, 42, 46);
INSERT INTO public.europe_data VALUES (9398, 12, 553, 9.85, 193, 46);
INSERT INTO public.europe_data VALUES (9399, 0, 1, 5.12, 43, 46);
INSERT INTO public.europe_data VALUES (9400, 1, 389, 10.65, 135, 46);
INSERT INTO public.europe_data VALUES (9401, 0, 3, 0, 97, 46);
INSERT INTO public.europe_data VALUES (9402, 0, 151, 5.05, 194, 46);
INSERT INTO public.europe_data VALUES (9403, 10, 316, 24.56, 195, 46);
INSERT INTO public.europe_data VALUES (9404, 0, 2, 0.02, 45, 46);
INSERT INTO public.europe_data VALUES (9405, 2, 1006, 2.1, 46, 46);
INSERT INTO public.europe_data VALUES (9406, 45, 700, 2.78, 136, 46);
INSERT INTO public.europe_data VALUES (9407, 4808, 54860, 180.31, 196, 46);
INSERT INTO public.europe_data VALUES (9408, 1, 33, 0.47, 137, 46);
INSERT INTO public.europe_data VALUES (9409, 0, 3, 0.01, 48, 46);
INSERT INTO public.europe_data VALUES (9410, 0, 3, 1.38, 98, 46);
INSERT INTO public.europe_data VALUES (9411, 190, 1957, 28.16, 197, 46);
INSERT INTO public.europe_data VALUES (9412, 197, 7303, 141.31, 198, 46);
INSERT INTO public.europe_data VALUES (9413, 1, 8, 0.05, 138, 46);
INSERT INTO public.europe_data VALUES (9414, 3, 141, 1.04, 139, 46);
INSERT INTO public.europe_data VALUES (9415, 6, 667, 1.83, 141, 46);
INSERT INTO public.europe_data VALUES (9416, 0, 0, 0.08, 142, 46);
INSERT INTO public.europe_data VALUES (9417, 1, 15, 0.36, 49, 46);
INSERT INTO public.europe_data VALUES (9418, 3, 28, 5.3, 99, 46);
INSERT INTO public.europe_data VALUES (9419, 5, 203, 2.22, 50, 46);
INSERT INTO public.europe_data VALUES (9420, 101, 8035, 11.28, 199, 46);
INSERT INTO public.europe_data VALUES (9421, 0, 5, 0, 100, 46);
INSERT INTO public.europe_data VALUES (9422, 0, 32, 0.07, 51, 46);
INSERT INTO public.europe_data VALUES (9423, 6, 371, 0.94, 200, 46);
INSERT INTO public.europe_data VALUES (9424, 1, 417, 4.83, 143, 46);
INSERT INTO public.europe_data VALUES (9425, 1388, 17889, 36.34, 201, 46);
INSERT INTO public.europe_data VALUES (9426, 1, 2, 0.02, 52, 46);
INSERT INTO public.europe_data VALUES (9427, 2038, 107819, 42.32, 101, 46);
INSERT INTO public.europe_data VALUES (9428, 0, 30, 0, 102, 46);
INSERT INTO public.europe_data VALUES (9429, 1, 137, 8.29, 103, 46);
INSERT INTO public.europe_data VALUES (9430, 1, 99, 0.42, 144, 46);
INSERT INTO public.europe_data VALUES (9431, 1, 83, 0.36, 104, 46);
INSERT INTO public.europe_data VALUES (9432, 0, 82, 0.15, 145, 46);
INSERT INTO public.europe_data VALUES (9433, 0, 26, 0.16, 54, 46);
INSERT INTO public.europe_data VALUES (9434, 1, 5, 0.05, 55, 46);
INSERT INTO public.europe_data VALUES (9435, 0, 18, 0.08, 105, 47);
INSERT INTO public.europe_data VALUES (9436, 1, 47, 3.04, 147, 47);
INSERT INTO public.europe_data VALUES (9437, 13, 153, 0.42, 1, 47);
INSERT INTO public.europe_data VALUES (9438, 0, 108, 148.34, 148, 47);
INSERT INTO public.europe_data VALUES (9439, 0, 2, 0, 2, 47);
INSERT INTO public.europe_data VALUES (9440, 0, 1, 0, 57, 47);
INSERT INTO public.europe_data VALUES (9441, 2, 210, 0.57, 58, 47);
INSERT INTO public.europe_data VALUES (9442, 0, 166, 6.53, 149, 47);
INSERT INTO public.europe_data VALUES (9443, 2, 1411, 6.46, 202, 47);
INSERT INTO public.europe_data VALUES (9444, 15, 2771, 39.84, 150, 47);
INSERT INTO public.europe_data VALUES (9445, 1, 46, 0.56, 151, 47);
INSERT INTO public.europe_data VALUES (9446, 0, 3, 1.03, 60, 47);
INSERT INTO public.europe_data VALUES (9447, 2, 120, 15.54, 106, 47);
INSERT INTO public.europe_data VALUES (9448, 3, 24, 0.01, 107, 47);
INSERT INTO public.europe_data VALUES (9449, 0, 17, 0, 61, 47);
INSERT INTO public.europe_data VALUES (9450, 0, 49, 0.74, 152, 47);
INSERT INTO public.europe_data VALUES (9451, 198, 3673, 43.83, 153, 47);
INSERT INTO public.europe_data VALUES (9452, 0, 2, 0, 3, 47);
INSERT INTO public.europe_data VALUES (9453, 0, 6, 0, 63, 47);
INSERT INTO public.europe_data VALUES (9454, 0, 2, 0, 108, 47);
INSERT INTO public.europe_data VALUES (9455, 0, 27, 0, 64, 47);
INSERT INTO public.europe_data VALUES (9456, 1, 107, 3.79, 154, 47);
INSERT INTO public.europe_data VALUES (9457, 25, 1346, 0.72, 66, 47);
INSERT INTO public.europe_data VALUES (9458, 0, 38, 20.31, 109, 47);
INSERT INTO public.europe_data VALUES (9459, 1, 134, 2.59, 155, 47);
INSERT INTO public.europe_data VALUES (9460, 3, 61, 0.31, 5, 47);
INSERT INTO public.europe_data VALUES (9461, 0, 74, 0.51, 110, 47);
INSERT INTO public.europe_data VALUES (9462, 0, 23, 0.1, 7, 47);
INSERT INTO public.europe_data VALUES (9463, 19, 1126, 3.66, 68, 47);
INSERT INTO public.europe_data VALUES (9464, 0, 3, 0, 8, 47);
INSERT INTO public.europe_data VALUES (9465, 1, 3, 0, 69, 47);
INSERT INTO public.europe_data VALUES (9466, 0, 3, 0.08, 9, 47);
INSERT INTO public.europe_data VALUES (9467, 0, 2, 0, 10, 47);
INSERT INTO public.europe_data VALUES (9468, 1, 557, 3.28, 70, 47);
INSERT INTO public.europe_data VALUES (9469, 58, 464, 0.04, 111, 47);
INSERT INTO public.europe_data VALUES (9470, 2, 190, 0.47, 71, 47);
INSERT INTO public.europe_data VALUES (9471, 0, 3, 0.07, 12, 47);
INSERT INTO public.europe_data VALUES (9472, 2, 99, 2.56, 72, 47);
INSERT INTO public.europe_data VALUES (9473, 0, 21, 0.1, 13, 47);
INSERT INTO public.europe_data VALUES (9474, 0, 187, 5.47, 156, 47);
INSERT INTO public.europe_data VALUES (9475, 1, 35, 0, 73, 47);
INSERT INTO public.europe_data VALUES (9476, 0, 65, 10.85, 157, 47);
INSERT INTO public.europe_data VALUES (9477, 1, 867, 10.64, 158, 47);
INSERT INTO public.europe_data VALUES (9478, 2, 24, 0.03, 14, 47);
INSERT INTO public.europe_data VALUES (9479, 12, 520, 23.37, 159, 47);
INSERT INTO public.europe_data VALUES (9480, 0, 1, 0, 15, 47);
INSERT INTO public.europe_data VALUES (9481, 0, 1, 0, 75, 47);
INSERT INTO public.europe_data VALUES (9482, 3, 191, 1.86, 76, 47);
INSERT INTO public.europe_data VALUES (9483, 12, 752, 4.46, 77, 47);
INSERT INTO public.europe_data VALUES (9484, 8, 184, 0.24, 16, 47);
INSERT INTO public.europe_data VALUES (9485, 0, 3, 0, 78, 47);
INSERT INTO public.europe_data VALUES (9486, 0, 5, 0.44, 17, 47);
INSERT INTO public.europe_data VALUES (9487, 0, 1, 0, 18, 47);
INSERT INTO public.europe_data VALUES (9488, 0, 155, 23.85, 160, 47);
INSERT INTO public.europe_data VALUES (9489, 0, 3, 0.35, 19, 47);
INSERT INTO public.europe_data VALUES (9490, 0, 7, 0.01, 20, 47);
INSERT INTO public.europe_data VALUES (9491, 0, 106, 230.09, 161, 47);
INSERT INTO public.europe_data VALUES (9492, 0, 3, 0, 203, 47);
INSERT INTO public.europe_data VALUES (9493, 1, 359, 10.8, 162, 47);
INSERT INTO public.europe_data VALUES (9494, 547, 10595, 22.22, 163, 47);
INSERT INTO public.europe_data VALUES (9495, 0, 18, 0, 204, 47);
INSERT INTO public.europe_data VALUES (9496, 1, 5, 0.28, 21, 47);
INSERT INTO public.europe_data VALUES (9497, 0, 1, 0, 22, 47);
INSERT INTO public.europe_data VALUES (9498, 0, 24, 1.03, 164, 47);
INSERT INTO public.europe_data VALUES (9499, 82, 19936, 28.75, 165, 47);
INSERT INTO public.europe_data VALUES (9500, 1, 22, 0.08, 23, 47);
INSERT INTO public.europe_data VALUES (9501, 0, 15, 0, 166, 47);
INSERT INTO public.europe_data VALUES (9502, 11, 293, 5.14, 167, 47);
INSERT INTO public.europe_data VALUES (9503, 0, 2, 0, 80, 47);
INSERT INTO public.europe_data VALUES (9504, 0, 1, 0, 81, 47);
INSERT INTO public.europe_data VALUES (9505, 1, 27, 0, 205, 47);
INSERT INTO public.europe_data VALUES (9506, 0, 18, 0.11, 82, 47);
INSERT INTO public.europe_data VALUES (9507, 0, 17, 0, 168, 47);
INSERT INTO public.europe_data VALUES (9508, 0, 2, 0, 24, 47);
INSERT INTO public.europe_data VALUES (9509, 0, 1, 0.64, 83, 47);
INSERT INTO public.europe_data VALUES (9510, 0, 2, 0, 84, 47);
INSERT INTO public.europe_data VALUES (9511, 0, 0, 122.7, 169, 47);
INSERT INTO public.europe_data VALUES (9512, 0, 21, 0.28, 85, 47);
INSERT INTO public.europe_data VALUES (9513, 6, 128, 1.63, 170, 47);
INSERT INTO public.europe_data VALUES (9514, 1, 390, 143.7, 171, 47);
INSERT INTO public.europe_data VALUES (9515, 5, 346, 0.03, 112, 47);
INSERT INTO public.europe_data VALUES (9516, 43, 397, 0.19, 113, 47);
INSERT INTO public.europe_data VALUES (9517, 961, 7700, 18.18, 114, 47);
INSERT INTO public.europe_data VALUES (9518, 11, 109, 0.44, 115, 47);
INSERT INTO public.europe_data VALUES (9519, 2, 737, 18.05, 172, 47);
INSERT INTO public.europe_data VALUES (9520, 0, 2, 0, 173, 47);
INSERT INTO public.europe_data VALUES (9521, 1, 821, 12.11, 116, 47);
INSERT INTO public.europe_data VALUES (9522, 3665, 35158, 85.76, 174, 47);
INSERT INTO public.europe_data VALUES (9523, 0, 9, 0.64, 86, 47);
INSERT INTO public.europe_data VALUES (9524, 17, 275, 0.47, 117, 47);
INSERT INTO public.europe_data VALUES (9525, 0, 15, 0, 175, 47);
INSERT INTO public.europe_data VALUES (9526, 0, 84, 0.98, 118, 47);
INSERT INTO public.europe_data VALUES (9527, 0, 51, 0.32, 119, 47);
INSERT INTO public.europe_data VALUES (9528, 0, 12, 0.03, 26, 47);
INSERT INTO public.europe_data VALUES (9529, 1, 20, 1.83, 176, 47);
INSERT INTO public.europe_data VALUES (9530, 0, 76, 2.95, 120, 47);
INSERT INTO public.europe_data VALUES (9531, 0, 14, 0, 121, 47);
INSERT INTO public.europe_data VALUES (9532, 0, 108, 7.08, 177, 47);
INSERT INTO public.europe_data VALUES (9533, 1, 149, 3.15, 123, 47);
INSERT INTO public.europe_data VALUES (9534, 0, 3, 0, 28, 47);
INSERT INTO public.europe_data VALUES (9535, 0, 39, 119.86, 178, 47);
INSERT INTO public.europe_data VALUES (9536, 1, 129, 5.08, 179, 47);
INSERT INTO public.europe_data VALUES (9537, 7, 721, 129.18, 180, 47);
INSERT INTO public.europe_data VALUES (9538, 0, 3, 0, 30, 47);
INSERT INTO public.europe_data VALUES (9539, 10, 878, 3.78, 124, 47);
INSERT INTO public.europe_data VALUES (9540, 0, 0, 1.7, 125, 47);
INSERT INTO public.europe_data VALUES (9541, 0, 77, 21.07, 181, 47);
INSERT INTO public.europe_data VALUES (9542, 0, 1, 0.04, 33, 47);
INSERT INTO public.europe_data VALUES (9543, 2, 28, 0, 34, 47);
INSERT INTO public.europe_data VALUES (9544, 2, 654, 0.68, 87, 47);
INSERT INTO public.europe_data VALUES (9545, 1, 71, 2.32, 182, 47);
INSERT INTO public.europe_data VALUES (9546, 0, 11, 57.43, 183, 47);
INSERT INTO public.europe_data VALUES (9547, 0, 10, 0, 126, 47);
INSERT INTO public.europe_data VALUES (9548, 0, 21, 0, 184, 47);
INSERT INTO public.europe_data VALUES (9549, 0, 1, 0, 88, 47);
INSERT INTO public.europe_data VALUES (9550, 3, 87, 0.32, 35, 47);
INSERT INTO public.europe_data VALUES (9551, 0, 1, 0, 36, 47);
INSERT INTO public.europe_data VALUES (9552, 0, 1, 0.12, 37, 47);
INSERT INTO public.europe_data VALUES (9553, 0, 0, 0, 128, 47);
INSERT INTO public.europe_data VALUES (9554, 159, 3069, 22.79, 185, 47);
INSERT INTO public.europe_data VALUES (9555, 0, 5, 0, 208, 47);
INSERT INTO public.europe_data VALUES (9556, 0, 94, 2.03, 209, 47);
INSERT INTO public.europe_data VALUES (9557, 0, 2, 0, 89, 47);
INSERT INTO public.europe_data VALUES (9558, 0, 1, 0, 38, 47);
INSERT INTO public.europe_data VALUES (9559, 0, 28, 0.01, 39, 47);
INSERT INTO public.europe_data VALUES (9560, 1, 101, 5.34, 186, 47);
INSERT INTO public.europe_data VALUES (9561, 6, 1055, 36.84, 187, 47);
INSERT INTO public.europe_data VALUES (9562, 0, 33, 0.78, 129, 47);
INSERT INTO public.europe_data VALUES (9563, 5, 753, 0.36, 130, 47);
INSERT INTO public.europe_data VALUES (9564, 0, 21, 1.18, 131, 47);
INSERT INTO public.europe_data VALUES (9565, 2, 270, 7.37, 90, 47);
INSERT INTO public.europe_data VALUES (9566, 0, 1, 0, 211, 47);
INSERT INTO public.europe_data VALUES (9567, 1, 14, 0.31, 91, 47);
INSERT INTO public.europe_data VALUES (9568, 5, 292, 1.1, 92, 47);
INSERT INTO public.europe_data VALUES (9569, 13, 240, 0.34, 132, 47);
INSERT INTO public.europe_data VALUES (9570, 4, 509, 1.64, 188, 47);
INSERT INTO public.europe_data VALUES (9571, 14, 1355, 15.28, 189, 47);
INSERT INTO public.europe_data VALUES (9572, 0, 93, 16.91, 133, 47);
INSERT INTO public.europe_data VALUES (9573, 2, 294, 2.15, 190, 47);
INSERT INTO public.europe_data VALUES (9574, 0, 304, 0.24, 191, 47);
INSERT INTO public.europe_data VALUES (9575, 0, 14, 0.15, 40, 47);
INSERT INTO public.europe_data VALUES (9576, 0, 0, 1.09, 95, 47);
INSERT INTO public.europe_data VALUES (9577, 13, 53, 330.89, 192, 47);
INSERT INTO public.europe_data VALUES (9578, 0, 393, 1.46, 134, 47);
INSERT INTO public.europe_data VALUES (9579, 0, 41, 0.41, 42, 47);
INSERT INTO public.europe_data VALUES (9580, 1, 133, 2.7, 193, 47);
INSERT INTO public.europe_data VALUES (9581, 0, 4, 7.16, 43, 47);
INSERT INTO public.europe_data VALUES (9582, 2, 229, 5.25, 135, 47);
INSERT INTO public.europe_data VALUES (9583, 0, 124, 3.3, 194, 47);
INSERT INTO public.europe_data VALUES (9584, 1, 195, 19.13, 195, 47);
INSERT INTO public.europe_data VALUES (9585, 0, 1, 0, 45, 47);
INSERT INTO public.europe_data VALUES (9586, 0, 223, 0.46, 46, 47);
INSERT INTO public.europe_data VALUES (9587, 38, 725, 3.08, 136, 47);
INSERT INTO public.europe_data VALUES (9588, 1432, 29771, 84.66, 196, 47);
INSERT INTO public.europe_data VALUES (9589, 0, 68, 0.4, 137, 47);
INSERT INTO public.europe_data VALUES (9590, 0, 1, 0, 48, 47);
INSERT INTO public.europe_data VALUES (9591, 0, 5, 0, 98, 47);
INSERT INTO public.europe_data VALUES (9592, 44, 924, 17.22, 197, 47);
INSERT INTO public.europe_data VALUES (9593, 47, 4771, 77.7, 198, 47);
INSERT INTO public.europe_data VALUES (9594, 0, 1, 0, 138, 47);
INSERT INTO public.europe_data VALUES (9595, 1, 106, 0.5, 139, 47);
INSERT INTO public.europe_data VALUES (9596, 0, 607, 0.96, 141, 47);
INSERT INTO public.europe_data VALUES (9597, 0, 1, 0, 142, 47);
INSERT INTO public.europe_data VALUES (9598, 0, 14, 0.19, 49, 47);
INSERT INTO public.europe_data VALUES (9599, 0, 46, 3.58, 99, 47);
INSERT INTO public.europe_data VALUES (9600, 3, 57, 0.64, 50, 47);
INSERT INTO public.europe_data VALUES (9601, 30, 1218, 1.51, 199, 47);
INSERT INTO public.europe_data VALUES (9602, 0, 1, 0, 51, 47);
INSERT INTO public.europe_data VALUES (9603, 3, 44, 0.11, 200, 47);
INSERT INTO public.europe_data VALUES (9604, 2, 55, 1.11, 143, 47);
INSERT INTO public.europe_data VALUES (9605, 245, 6329, 12.79, 201, 47);
INSERT INTO public.europe_data VALUES (9606, 0, 12, 0, 52, 47);
INSERT INTO public.europe_data VALUES (9607, 402, 31432, 10.53, 101, 47);
INSERT INTO public.europe_data VALUES (9608, 0, 150, 4.56, 103, 47);
INSERT INTO public.europe_data VALUES (9609, 0, 40, 0.14, 144, 47);
INSERT INTO public.europe_data VALUES (9610, 0, 21, 0.13, 104, 47);
INSERT INTO public.europe_data VALUES (9611, 0, 64, 0.09, 145, 47);
INSERT INTO public.europe_data VALUES (9612, 0, 3, 0, 54, 47);
INSERT INTO public.europe_data VALUES (9613, 0, 2, 0, 55, 47);
INSERT INTO public.europe_data VALUES (9614, 0, 12, 0.04, 105, 48);
INSERT INTO public.europe_data VALUES (9615, 1, 40, 1.47, 147, 48);
INSERT INTO public.europe_data VALUES (9616, 4, 28, 0.1, 1, 48);
INSERT INTO public.europe_data VALUES (9617, 0, 5, 0, 148, 48);
INSERT INTO public.europe_data VALUES (9618, 1, 44, 0.13, 58, 48);
INSERT INTO public.europe_data VALUES (9619, 0, 27, 0.91, 149, 48);
INSERT INTO public.europe_data VALUES (9620, 2, 218, 1.07, 202, 48);
INSERT INTO public.europe_data VALUES (9621, 1, 758, 9.55, 150, 48);
INSERT INTO public.europe_data VALUES (9622, 0, 10, 0.16, 151, 48);
INSERT INTO public.europe_data VALUES (9623, 0, 1, 0, 60, 48);
INSERT INTO public.europe_data VALUES (9624, 0, 135, 10.18, 106, 48);
INSERT INTO public.europe_data VALUES (9625, 0, 0, 0, 107, 48);
INSERT INTO public.europe_data VALUES (9626, 0, 21, 0.28, 152, 48);
INSERT INTO public.europe_data VALUES (9627, 18, 1348, 15.15, 153, 48);
INSERT INTO public.europe_data VALUES (9628, 0, 18, 0, 154, 48);
INSERT INTO public.europe_data VALUES (9629, 0, 175, 0.09, 66, 48);
INSERT INTO public.europe_data VALUES (9630, 0, 50, 0, 109, 48);
INSERT INTO public.europe_data VALUES (9631, 2, 47, 0.73, 155, 48);
INSERT INTO public.europe_data VALUES (9632, 0, 3, 0, 5, 48);
INSERT INTO public.europe_data VALUES (9633, 0, 10, 0.07, 110, 48);
INSERT INTO public.europe_data VALUES (9634, 0, 2, 0.02, 7, 48);
INSERT INTO public.europe_data VALUES (9635, 1, 242, 0.75, 68, 48);
INSERT INTO public.europe_data VALUES (9636, 0, 1, 0, 9, 48);
INSERT INTO public.europe_data VALUES (9637, 0, 65, 0.4, 70, 48);
INSERT INTO public.europe_data VALUES (9638, 94, 161, 0.06, 111, 48);
INSERT INTO public.europe_data VALUES (9639, 0, 45, 0, 71, 48);
INSERT INTO public.europe_data VALUES (9640, 0, 1, 0, 12, 48);
INSERT INTO public.europe_data VALUES (9641, 0, 30, 0.69, 72, 48);
INSERT INTO public.europe_data VALUES (9642, 0, 4, 0, 13, 48);
INSERT INTO public.europe_data VALUES (9643, 0, 36, 1.01, 156, 48);
INSERT INTO public.europe_data VALUES (9644, 0, 30, 0, 157, 48);
INSERT INTO public.europe_data VALUES (9645, 0, 266, 2.77, 158, 48);
INSERT INTO public.europe_data VALUES (9646, 0, 2, 0, 14, 48);
INSERT INTO public.europe_data VALUES (9647, 1, 837, 15, 159, 48);
INSERT INTO public.europe_data VALUES (9648, 0, 9, 0.09, 76, 48);
INSERT INTO public.europe_data VALUES (9649, 2, 23, 0.18, 77, 48);
INSERT INTO public.europe_data VALUES (9650, 1, 61, 0.11, 16, 48);
INSERT INTO public.europe_data VALUES (9651, 0, 1, 0, 17, 48);
INSERT INTO public.europe_data VALUES (9652, 0, 161, 12.83, 160, 48);
INSERT INTO public.europe_data VALUES (9653, 0, 1, 0, 19, 48);
INSERT INTO public.europe_data VALUES (9654, 0, 4, 0, 20, 48);
INSERT INTO public.europe_data VALUES (9655, 0, 6, 18.49, 161, 48);
INSERT INTO public.europe_data VALUES (9656, 0, 237, 4.73, 162, 48);
INSERT INTO public.europe_data VALUES (9657, 108, 4297, 7.9, 163, 48);
INSERT INTO public.europe_data VALUES (9658, 0, 1, 0, 21, 48);
INSERT INTO public.europe_data VALUES (9659, 0, 17, 0.68, 164, 48);
INSERT INTO public.europe_data VALUES (9660, 12, 3936, 5.67, 165, 48);
INSERT INTO public.europe_data VALUES (9661, 0, 2, 0, 23, 48);
INSERT INTO public.europe_data VALUES (9662, 4, 258, 3.02, 167, 48);
INSERT INTO public.europe_data VALUES (9663, 1, 1, 0, 82, 48);
INSERT INTO public.europe_data VALUES (9664, 1, 4, 0, 83, 48);
INSERT INTO public.europe_data VALUES (9665, 0, 1, 0, 169, 48);
INSERT INTO public.europe_data VALUES (9666, 0, 6, 0, 85, 48);
INSERT INTO public.europe_data VALUES (9667, 1, 31, 0.4, 170, 48);
INSERT INTO public.europe_data VALUES (9668, 0, 123, 49.02, 171, 48);
INSERT INTO public.europe_data VALUES (9669, 2, 59, 0.01, 112, 48);
INSERT INTO public.europe_data VALUES (9670, 5, 111, 0.04, 113, 48);
INSERT INTO public.europe_data VALUES (9671, 530, 7372, 15.63, 114, 48);
INSERT INTO public.europe_data VALUES (9672, 3, 63, 0.27, 115, 48);
INSERT INTO public.europe_data VALUES (9673, 2, 148, 3.43, 172, 48);
INSERT INTO public.europe_data VALUES (9674, 0, 211, 2.82, 116, 48);
INSERT INTO public.europe_data VALUES (9675, 1445, 16605, 36.93, 174, 48);
INSERT INTO public.europe_data VALUES (9676, 0, 10, 0, 86, 48);
INSERT INTO public.europe_data VALUES (9677, 17, 326, 0.44, 117, 48);
INSERT INTO public.europe_data VALUES (9678, 0, 15, 0, 118, 48);
INSERT INTO public.europe_data VALUES (9679, 0, 9, 0, 119, 48);
INSERT INTO public.europe_data VALUES (9680, 0, 3, 0, 26, 48);
INSERT INTO public.europe_data VALUES (9681, 0, 13, 0, 176, 48);
INSERT INTO public.europe_data VALUES (9682, 0, 48, 1.57, 120, 48);
INSERT INTO public.europe_data VALUES (9683, 0, 28, 1.61, 177, 48);
INSERT INTO public.europe_data VALUES (9684, 3, 67, 1.3, 123, 48);
INSERT INTO public.europe_data VALUES (9685, 0, 7, 0, 178, 48);
INSERT INTO public.europe_data VALUES (9686, 0, 13, 0.47, 179, 48);
INSERT INTO public.europe_data VALUES (9687, 1, 72, 12.38, 180, 48);
INSERT INTO public.europe_data VALUES (9688, 0, 329, 1.25, 124, 48);
INSERT INTO public.europe_data VALUES (9689, 0, 9, 2.45, 125, 48);
INSERT INTO public.europe_data VALUES (9690, 0, 27, 6.08, 181, 48);
INSERT INTO public.europe_data VALUES (9691, 0, 1, 0, 33, 48);
INSERT INTO public.europe_data VALUES (9692, 0, 216, 0.18, 87, 48);
INSERT INTO public.europe_data VALUES (9693, 0, 23, 0, 182, 48);
INSERT INTO public.europe_data VALUES (9694, 0, 8, 24.18, 183, 48);
INSERT INTO public.europe_data VALUES (9695, 1, 28, 0, 35, 48);
INSERT INTO public.europe_data VALUES (9696, 0, 2, 0, 37, 48);
INSERT INTO public.europe_data VALUES (9697, 0, 0, 0, 128, 48);
INSERT INTO public.europe_data VALUES (9698, 17, 870, 6.49, 185, 48);
INSERT INTO public.europe_data VALUES (9699, 0, 3, 0.15, 209, 48);
INSERT INTO public.europe_data VALUES (9700, 0, 1, 0, 39, 48);
INSERT INTO public.europe_data VALUES (9701, 0, 10, 0.58, 186, 48);
INSERT INTO public.europe_data VALUES (9702, 1, 908, 19.86, 187, 48);
INSERT INTO public.europe_data VALUES (9703, 0, 6, 0.32, 129, 48);
INSERT INTO public.europe_data VALUES (9704, 0, 25, 0.01, 130, 48);
INSERT INTO public.europe_data VALUES (9705, 0, 38, 0, 131, 48);
INSERT INTO public.europe_data VALUES (9706, 1, 43, 0, 90, 48);
INSERT INTO public.europe_data VALUES (9707, 0, 8, 0, 91, 48);
INSERT INTO public.europe_data VALUES (9708, 0, 64, 0.22, 92, 48);
INSERT INTO public.europe_data VALUES (9709, 11, 130, 0.13, 132, 48);
INSERT INTO public.europe_data VALUES (9710, 3, 114, 0.33, 188, 48);
INSERT INTO public.europe_data VALUES (9711, 0, 215, 2.38, 189, 48);
INSERT INTO public.europe_data VALUES (9712, 0, 386, 14.05, 133, 48);
INSERT INTO public.europe_data VALUES (9713, 0, 124, 0.7, 190, 48);
INSERT INTO public.europe_data VALUES (9714, 0, 53, 0.04, 191, 48);
INSERT INTO public.europe_data VALUES (9715, 0, 5, 0, 40, 48);
INSERT INTO public.europe_data VALUES (9716, 0, 2, 0, 95, 48);
INSERT INTO public.europe_data VALUES (9717, 6, 61, 261.23, 192, 48);
INSERT INTO public.europe_data VALUES (9718, 0, 107, 0.34, 134, 48);
INSERT INTO public.europe_data VALUES (9719, 0, 26, 0, 42, 48);
INSERT INTO public.europe_data VALUES (9720, 0, 55, 0, 193, 48);
INSERT INTO public.europe_data VALUES (9721, 0, 3, 0, 43, 48);
INSERT INTO public.europe_data VALUES (9722, 0, 76, 2.07, 135, 48);
INSERT INTO public.europe_data VALUES (9723, 0, 56, 1.12, 194, 48);
INSERT INTO public.europe_data VALUES (9724, 0, 203, 10.52, 195, 48);
INSERT INTO public.europe_data VALUES (9725, 0, 48, 0.09, 46, 48);
INSERT INTO public.europe_data VALUES (9726, 24, 854, 7.86, 136, 48);
INSERT INTO public.europe_data VALUES (9727, 283, 9964, 24.19, 196, 48);
INSERT INTO public.europe_data VALUES (9728, 0, 18, 0.08, 137, 48);
INSERT INTO public.europe_data VALUES (9729, 1, 1, 0, 48, 48);
INSERT INTO public.europe_data VALUES (9730, 5, 838, 10.25, 197, 48);
INSERT INTO public.europe_data VALUES (9731, 11, 1868, 25.47, 198, 48);
INSERT INTO public.europe_data VALUES (9732, 0, 14, 0.08, 139, 48);
INSERT INTO public.europe_data VALUES (9733, 0, 64, 0.1, 141, 48);
INSERT INTO public.europe_data VALUES (9734, 0, 1, 0, 49, 48);
INSERT INTO public.europe_data VALUES (9735, 0, 4, 0, 99, 48);
INSERT INTO public.europe_data VALUES (9736, 0, 18, 0, 50, 48);
INSERT INTO public.europe_data VALUES (9737, 0, 18, 0, 199, 48);
INSERT INTO public.europe_data VALUES (9738, 0, 3, 0, 200, 48);
INSERT INTO public.europe_data VALUES (9739, 0, 53, 0.79, 143, 48);
INSERT INTO public.europe_data VALUES (9740, 41, 2193, 3.84, 201, 48);
INSERT INTO public.europe_data VALUES (9741, 48, 3220, 1.12, 101, 48);
INSERT INTO public.europe_data VALUES (9742, 0, 8, 0, 103, 48);
INSERT INTO public.europe_data VALUES (9743, 0, 6, 0, 144, 48);
INSERT INTO public.europe_data VALUES (9744, 0, 15, 0, 104, 48);
INSERT INTO public.europe_data VALUES (9745, 0, 27, 0.04, 145, 48);
INSERT INTO public.europe_data VALUES (9746, 0, 3, 0.01, 105, 49);
INSERT INTO public.europe_data VALUES (9747, 0, 2, 0, 147, 49);
INSERT INTO public.europe_data VALUES (9748, 0, 17, 0.05, 1, 49);
INSERT INTO public.europe_data VALUES (9749, 1, 12, 0, 58, 49);
INSERT INTO public.europe_data VALUES (9750, 0, 0, 0.03, 149, 49);
INSERT INTO public.europe_data VALUES (9751, 2, 51, 0.23, 202, 49);
INSERT INTO public.europe_data VALUES (9752, 0, 88, 1.15, 150, 49);
INSERT INTO public.europe_data VALUES (9753, 0, 6, 0.09, 151, 49);
INSERT INTO public.europe_data VALUES (9754, 0, 32, 4.75, 106, 49);
INSERT INTO public.europe_data VALUES (9755, 0, 3, 0, 107, 49);
INSERT INTO public.europe_data VALUES (9756, 0, 5, 0.06, 152, 49);
INSERT INTO public.europe_data VALUES (9757, 0, 388, 0.56, 153, 49);
INSERT INTO public.europe_data VALUES (9758, 0, 23, 0.01, 66, 49);
INSERT INTO public.europe_data VALUES (9759, 0, 4, 0, 155, 49);
INSERT INTO public.europe_data VALUES (9760, 0, 1, 0.01, 110, 49);
INSERT INTO public.europe_data VALUES (9761, 0, 2, 0, 7, 49);
INSERT INTO public.europe_data VALUES (9762, 0, 38, 0.14, 68, 49);
INSERT INTO public.europe_data VALUES (9763, 0, 10, 0, 70, 49);
INSERT INTO public.europe_data VALUES (9764, 208, 725, 0.25, 111, 49);
INSERT INTO public.europe_data VALUES (9765, 0, 5, 0, 72, 49);
INSERT INTO public.europe_data VALUES (9766, 0, 5, 0.29, 156, 49);
INSERT INTO public.europe_data VALUES (9767, 0, 29, 0.3, 158, 49);
INSERT INTO public.europe_data VALUES (9768, 0, 34, 0.65, 159, 49);
INSERT INTO public.europe_data VALUES (9769, 0, 1, 0.02, 76, 49);
INSERT INTO public.europe_data VALUES (9770, 0, 8, 0.08, 77, 49);
INSERT INTO public.europe_data VALUES (9771, 1, 47, 0.05, 16, 49);
INSERT INTO public.europe_data VALUES (9772, 0, 9, 0.75, 160, 49);
INSERT INTO public.europe_data VALUES (9773, 0, 3, 0, 161, 49);
INSERT INTO public.europe_data VALUES (9774, 0, 24, 0.53, 162, 49);
INSERT INTO public.europe_data VALUES (9775, 17, 996, 1.66, 163, 49);
INSERT INTO public.europe_data VALUES (9776, 0, 10, 0.33, 164, 49);
INSERT INTO public.europe_data VALUES (9777, 0, 773, 1.07, 165, 49);
INSERT INTO public.europe_data VALUES (9778, 0, 66, 0.68, 167, 49);
INSERT INTO public.europe_data VALUES (9779, 0, 8, 0, 170, 49);
INSERT INTO public.europe_data VALUES (9780, 0, 52, 15.41, 171, 49);
INSERT INTO public.europe_data VALUES (9781, 0, 31, 0, 112, 49);
INSERT INTO public.europe_data VALUES (9782, 0, 4, 0, 113, 49);
INSERT INTO public.europe_data VALUES (9783, 140, 5588, 7.87, 114, 49);
INSERT INTO public.europe_data VALUES (9784, 6, 42, 0.16, 115, 49);
INSERT INTO public.europe_data VALUES (9785, 0, 20, 0.43, 172, 49);
INSERT INTO public.europe_data VALUES (9786, 0, 29, 0.43, 116, 49);
INSERT INTO public.europe_data VALUES (9787, 331, 5686, 12, 174, 49);
INSERT INTO public.europe_data VALUES (9788, 1, 234, 0.27, 117, 49);
INSERT INTO public.europe_data VALUES (9789, 0, 18, 1.45, 120, 49);
INSERT INTO public.europe_data VALUES (9790, 0, 3, 0, 177, 49);
INSERT INTO public.europe_data VALUES (9791, 0, 22, 0.45, 123, 49);
INSERT INTO public.europe_data VALUES (9792, 0, 0, 0.04, 179, 49);
INSERT INTO public.europe_data VALUES (9793, 0, 4, 0.81, 180, 49);
INSERT INTO public.europe_data VALUES (9794, 0, 70, 0.24, 124, 49);
INSERT INTO public.europe_data VALUES (9795, 0, 4, 0, 125, 49);
INSERT INTO public.europe_data VALUES (9796, 0, 3, 0, 181, 49);
INSERT INTO public.europe_data VALUES (9797, 0, 14, 0.02, 87, 49);
INSERT INTO public.europe_data VALUES (9798, 0, 0, 3.02, 183, 49);
INSERT INTO public.europe_data VALUES (9799, 0, 0, 0, 128, 49);
INSERT INTO public.europe_data VALUES (9800, 3, 252, 1.53, 185, 49);
INSERT INTO public.europe_data VALUES (9801, 0, 4, 0.1, 209, 49);
INSERT INTO public.europe_data VALUES (9802, 0, 0, 0, 39, 49);
INSERT INTO public.europe_data VALUES (9803, 0, 2, 0.14, 186, 49);
INSERT INTO public.europe_data VALUES (9804, 0, 150, 3.17, 187, 49);
INSERT INTO public.europe_data VALUES (9805, 0, 10, 0.32, 129, 49);
INSERT INTO public.europe_data VALUES (9806, 0, 2, 0, 130, 49);
INSERT INTO public.europe_data VALUES (9807, 0, 7, 0, 92, 49);
INSERT INTO public.europe_data VALUES (9808, 0, 7, 0.01, 132, 49);
INSERT INTO public.europe_data VALUES (9809, 0, 11, 0, 188, 49);
INSERT INTO public.europe_data VALUES (9810, 0, 30, 0, 189, 49);
INSERT INTO public.europe_data VALUES (9811, 0, 12, 0.53, 133, 49);
INSERT INTO public.europe_data VALUES (9812, 0, 12, 0.08, 190, 49);
INSERT INTO public.europe_data VALUES (9813, 0, 8, 0.01, 191, 49);
INSERT INTO public.europe_data VALUES (9814, 0, 29, 107.39, 192, 49);
INSERT INTO public.europe_data VALUES (9815, 0, 11, 0, 134, 49);
INSERT INTO public.europe_data VALUES (9816, 0, 44, 1.05, 135, 49);
INSERT INTO public.europe_data VALUES (9817, 0, 5, 0, 194, 49);
INSERT INTO public.europe_data VALUES (9818, 0, 16, 0, 195, 49);
INSERT INTO public.europe_data VALUES (9819, 0, 3, 0, 46, 49);
INSERT INTO public.europe_data VALUES (9820, 29, 3170, 12.92, 136, 49);
INSERT INTO public.europe_data VALUES (9821, 5, 1391, 3.25, 196, 49);
INSERT INTO public.europe_data VALUES (9822, 0, 0, 0, 137, 49);
INSERT INTO public.europe_data VALUES (9823, 0, 211, 2.19, 197, 49);
INSERT INTO public.europe_data VALUES (9824, 2, 308, 3.89, 198, 49);
INSERT INTO public.europe_data VALUES (9825, 0, 5, 0.07, 139, 49);
INSERT INTO public.europe_data VALUES (9826, 0, 7, 0.02, 141, 49);
INSERT INTO public.europe_data VALUES (9827, 0, 24, 0.33, 143, 49);
INSERT INTO public.europe_data VALUES (9828, 2, 365, 0.6, 201, 49);
INSERT INTO public.europe_data VALUES (9829, 19, 465, 0.16, 101, 49);
INSERT INTO public.europe_data VALUES (9830, 0, 14, 0.01, 145, 49);
INSERT INTO public.europe_data VALUES (9831, 0, 1, 0, 105, 50);
INSERT INTO public.europe_data VALUES (9832, 0, 3, 0.01, 1, 50);
INSERT INTO public.europe_data VALUES (9833, 0, 1, 0.03, 149, 50);
INSERT INTO public.europe_data VALUES (9834, 1, 7, 0.06, 202, 50);
INSERT INTO public.europe_data VALUES (9835, 0, 14, 0.16, 150, 50);
INSERT INTO public.europe_data VALUES (9836, 0, 3, 0.03, 151, 50);
INSERT INTO public.europe_data VALUES (9837, 0, 46, 2.86, 106, 50);
INSERT INTO public.europe_data VALUES (9838, 0, 1, 0.01, 152, 50);
INSERT INTO public.europe_data VALUES (9839, 0, -324, 0.17, 153, 50);
INSERT INTO public.europe_data VALUES (9840, 0, 2, 0, 66, 50);
INSERT INTO public.europe_data VALUES (9841, 0, 0, 0, 110, 50);
INSERT INTO public.europe_data VALUES (9842, 0, 15, 0.04, 68, 50);
INSERT INTO public.europe_data VALUES (9843, 3, 14, 0, 215, 50);
INSERT INTO public.europe_data VALUES (9844, 319, 2900, 0.66, 111, 50);
INSERT INTO public.europe_data VALUES (9845, 0, 7, 0.17, 156, 50);
INSERT INTO public.europe_data VALUES (9846, 0, 3, 0.03, 158, 50);
INSERT INTO public.europe_data VALUES (9847, 0, 4, 0.07, 159, 50);
INSERT INTO public.europe_data VALUES (9848, 0, 1, 0.01, 76, 50);
INSERT INTO public.europe_data VALUES (9849, 0, 6, 0.03, 77, 50);
INSERT INTO public.europe_data VALUES (9850, 0, 1, 0, 16, 50);
INSERT INTO public.europe_data VALUES (9851, 0, 1, 0.08, 160, 50);
INSERT INTO public.europe_data VALUES (9852, 0, 5, 0.09, 162, 50);
INSERT INTO public.europe_data VALUES (9853, 1, 118, 0.18, 163, 50);
INSERT INTO public.europe_data VALUES (9854, 0, 3, 0.08, 164, 50);
INSERT INTO public.europe_data VALUES (9855, 0, 114, 0.14, 165, 50);
INSERT INTO public.europe_data VALUES (9856, 0, 7, 0.07, 167, 50);
INSERT INTO public.europe_data VALUES (9857, 0, 3, 0.84, 171, 50);
INSERT INTO public.europe_data VALUES (9858, 0, 0, 0, 112, 50);
INSERT INTO public.europe_data VALUES (9859, 0, 2, 0, 113, 50);
INSERT INTO public.europe_data VALUES (9860, 46, 935, 1.18, 114, 50);
INSERT INTO public.europe_data VALUES (9861, 0, 19, 0.05, 115, 50);
INSERT INTO public.europe_data VALUES (9862, 0, 1, 0.02, 172, 50);
INSERT INTO public.europe_data VALUES (9863, 0, 8, 0.12, 116, 50);
INSERT INTO public.europe_data VALUES (9864, 33, 1557, 2.79, 174, 50);
INSERT INTO public.europe_data VALUES (9865, 5, 110, 0.15, 117, 50);
INSERT INTO public.europe_data VALUES (9866, 0, 43, 1.09, 120, 50);
INSERT INTO public.europe_data VALUES (9867, 0, 9, 0.15, 123, 50);
INSERT INTO public.europe_data VALUES (9868, 0, 1, 0.04, 179, 50);
INSERT INTO public.europe_data VALUES (9869, 0, 1, 0.16, 180, 50);
INSERT INTO public.europe_data VALUES (9870, 0, 7, 0.02, 124, 50);
INSERT INTO public.europe_data VALUES (9871, 0, 11, 0.01, 87, 50);
INSERT INTO public.europe_data VALUES (9872, 0, 1, 3.02, 183, 50);
INSERT INTO public.europe_data VALUES (9873, 0, 0, 0, 128, 50);
INSERT INTO public.europe_data VALUES (9874, 0, 13, 0.08, 185, 50);
INSERT INTO public.europe_data VALUES (9875, 0, 1, 0.02, 209, 50);
INSERT INTO public.europe_data VALUES (9876, 0, 1, 0, 39, 50);
INSERT INTO public.europe_data VALUES (9877, 0, 1, 0.05, 186, 50);
INSERT INTO public.europe_data VALUES (9878, 0, 19, 0.36, 187, 50);
INSERT INTO public.europe_data VALUES (9879, 0, 6, 0.12, 129, 50);
INSERT INTO public.europe_data VALUES (9880, 0, 4, 0, 130, 50);
INSERT INTO public.europe_data VALUES (9881, 0, 0, 0, 132, 50);
INSERT INTO public.europe_data VALUES (9882, 0, 3, 0.11, 133, 50);
INSERT INTO public.europe_data VALUES (9883, 0, 3, 0.02, 190, 50);
INSERT INTO public.europe_data VALUES (9884, 0, 0, 0, 191, 50);
INSERT INTO public.europe_data VALUES (9885, 1, 8, 23.22, 192, 50);
INSERT INTO public.europe_data VALUES (9886, 0, 17, 0.53, 135, 50);
INSERT INTO public.europe_data VALUES (9887, 15, 3450, 8.16, 136, 50);
INSERT INTO public.europe_data VALUES (9888, 0, 134, 0.29, 196, 50);
INSERT INTO public.europe_data VALUES (9889, 0, 0, 0, 137, 50);
INSERT INTO public.europe_data VALUES (9890, 0, 13, 0.13, 197, 50);
INSERT INTO public.europe_data VALUES (9891, 0, 24, 0.28, 198, 50);
INSERT INTO public.europe_data VALUES (9892, 0, 12, 0.08, 139, 50);
INSERT INTO public.europe_data VALUES (9893, 1, 8, 0.01, 141, 50);
INSERT INTO public.europe_data VALUES (9894, 0, 8, 0.12, 143, 50);
INSERT INTO public.europe_data VALUES (9895, 0, 36, 0.06, 201, 50);
INSERT INTO public.europe_data VALUES (9896, 2, 54, 0.02, 101, 50);
INSERT INTO public.europe_data VALUES (9897, 0, 0, 0, 145, 50);
INSERT INTO public.europe_data VALUES (9898, 0, 0, 0, 105, 51);
INSERT INTO public.europe_data VALUES (9899, 0, 0, 0, 1, 51);
INSERT INTO public.europe_data VALUES (9900, 0, 0, 0, 149, 51);
INSERT INTO public.europe_data VALUES (9901, 0, 7, 0.03, 202, 51);
INSERT INTO public.europe_data VALUES (9902, 0, 0, 0, 150, 51);
INSERT INTO public.europe_data VALUES (9903, 0, 0, 0, 151, 51);
INSERT INTO public.europe_data VALUES (9904, 0, 1, 0.06, 106, 51);
INSERT INTO public.europe_data VALUES (9905, 0, 0, 0, 152, 51);
INSERT INTO public.europe_data VALUES (9906, 0, 343, 2.99, 153, 51);
INSERT INTO public.europe_data VALUES (9907, 0, 0, 0, 66, 51);
INSERT INTO public.europe_data VALUES (9908, 0, 0, 0, 110, 51);
INSERT INTO public.europe_data VALUES (9909, 0, 1, 0.01, 68, 51);
INSERT INTO public.europe_data VALUES (9910, 3, 336, 0, 215, 51);
INSERT INTO public.europe_data VALUES (9911, 824, 6616, 2.58, 111, 51);
INSERT INTO public.europe_data VALUES (9912, 0, 0, 0, 156, 51);
INSERT INTO public.europe_data VALUES (9913, 0, 0, 0, 158, 51);
INSERT INTO public.europe_data VALUES (9914, 0, 0, 0, 159, 51);
INSERT INTO public.europe_data VALUES (9915, 0, 0, 0, 76, 51);
INSERT INTO public.europe_data VALUES (9916, 0, 0, 0, 77, 51);
INSERT INTO public.europe_data VALUES (9917, 0, 0, 0, 16, 51);
INSERT INTO public.europe_data VALUES (9918, 0, 0, 0, 160, 51);
INSERT INTO public.europe_data VALUES (9919, 0, 0, 0, 162, 51);
INSERT INTO public.europe_data VALUES (9920, 0, 0, 0, 163, 51);
INSERT INTO public.europe_data VALUES (9921, 0, 0, 0, 164, 51);
INSERT INTO public.europe_data VALUES (9922, 0, 0, 0, 165, 51);
INSERT INTO public.europe_data VALUES (9923, 0, 0, 0, 167, 51);
INSERT INTO public.europe_data VALUES (9924, 0, 0, 0, 171, 51);
INSERT INTO public.europe_data VALUES (9925, 0, 0, 0, 112, 51);
INSERT INTO public.europe_data VALUES (9926, 0, 0, 0, 113, 51);
INSERT INTO public.europe_data VALUES (9927, 8, 43, 0.05, 114, 51);
INSERT INTO public.europe_data VALUES (9928, 0, 0, 0, 115, 51);
INSERT INTO public.europe_data VALUES (9929, 0, 0, 0, 172, 51);
INSERT INTO public.europe_data VALUES (9930, 0, 2, 0.02, 116, 51);
INSERT INTO public.europe_data VALUES (9931, 2, 129, 0.21, 174, 51);
INSERT INTO public.europe_data VALUES (9932, 0, 85, 0.09, 117, 51);
INSERT INTO public.europe_data VALUES (9933, 0, 3, 0.07, 120, 51);
INSERT INTO public.europe_data VALUES (9934, 0, 1, 0.01, 123, 51);
INSERT INTO public.europe_data VALUES (9935, 0, 0, 0, 179, 51);
INSERT INTO public.europe_data VALUES (9936, 0, 0, 0, 180, 51);
INSERT INTO public.europe_data VALUES (9937, 0, 0, 0.01, 124, 51);
INSERT INTO public.europe_data VALUES (9938, 0, 1, 0, 87, 51);
INSERT INTO public.europe_data VALUES (9939, 0, 0, 0, 183, 51);
INSERT INTO public.europe_data VALUES (9940, 0, 0, 0, 128, 51);
INSERT INTO public.europe_data VALUES (9941, 0, 0, 0, 185, 51);
INSERT INTO public.europe_data VALUES (9942, 0, 0, 0, 209, 51);
INSERT INTO public.europe_data VALUES (9943, 0, 0, 0, 39, 51);
INSERT INTO public.europe_data VALUES (9944, 0, 0, 0, 186, 51);
INSERT INTO public.europe_data VALUES (9945, 0, 0, 0, 187, 51);
INSERT INTO public.europe_data VALUES (9946, 0, 0, 0, 129, 51);
INSERT INTO public.europe_data VALUES (9947, 0, 0, 0, 130, 51);
INSERT INTO public.europe_data VALUES (9948, 0, 0, 0, 132, 51);
INSERT INTO public.europe_data VALUES (9949, 0, 0, 0, 133, 51);
INSERT INTO public.europe_data VALUES (9950, 0, 0, 0, 190, 51);
INSERT INTO public.europe_data VALUES (9951, 0, 0, 0, 191, 51);
INSERT INTO public.europe_data VALUES (9952, 0, 0, 0, 192, 51);
INSERT INTO public.europe_data VALUES (9953, 0, 14, 0.79, 135, 51);
INSERT INTO public.europe_data VALUES (9954, 7, 732, 1.43, 136, 51);
INSERT INTO public.europe_data VALUES (9955, 0, 0, 0, 196, 51);
INSERT INTO public.europe_data VALUES (9956, 0, 0, 0, 137, 51);
INSERT INTO public.europe_data VALUES (9957, 0, 0, 0, 197, 51);
INSERT INTO public.europe_data VALUES (9958, 0, 0, 0, 198, 51);
INSERT INTO public.europe_data VALUES (9959, 0, 8, 0.04, 139, 51);
INSERT INTO public.europe_data VALUES (9960, 0, 1, 0, 141, 51);
INSERT INTO public.europe_data VALUES (9961, 0, 4, 0.06, 143, 51);
INSERT INTO public.europe_data VALUES (9962, 0, 1, 0, 201, 51);
INSERT INTO public.europe_data VALUES (9963, 0, 20, 0.01, 101, 51);
INSERT INTO public.europe_data VALUES (9964, 0, 0, 0, 145, 51);
INSERT INTO public.europe_data VALUES (9965, 0, 0, 0, 105, 52);
INSERT INTO public.europe_data VALUES (9966, 0, 0, 0, 1, 52);
INSERT INTO public.europe_data VALUES (9967, 0, 0, 0, 149, 52);
INSERT INTO public.europe_data VALUES (9968, 0, 1, 0.02, 202, 52);
INSERT INTO public.europe_data VALUES (9969, 0, 0, 0, 150, 52);
INSERT INTO public.europe_data VALUES (9970, 0, 0, 0, 151, 52);
INSERT INTO public.europe_data VALUES (9971, 0, 0, 0, 106, 52);
INSERT INTO public.europe_data VALUES (9972, 0, 0, 0, 152, 52);
INSERT INTO public.europe_data VALUES (9973, 0, 0, 0, 153, 52);
INSERT INTO public.europe_data VALUES (9974, 0, 0, 0, 66, 52);
INSERT INTO public.europe_data VALUES (9975, 0, 0, 0, 110, 52);
INSERT INTO public.europe_data VALUES (9976, 0, 1, 0.01, 68, 52);
INSERT INTO public.europe_data VALUES (9977, 0, 285, 0, 215, 52);
INSERT INTO public.europe_data VALUES (9978, 862, 30412, 3.72, 111, 52);
INSERT INTO public.europe_data VALUES (9979, 0, 0, 0, 156, 52);
INSERT INTO public.europe_data VALUES (9980, 0, 0, 0, 158, 52);
INSERT INTO public.europe_data VALUES (9981, 0, 0, 0, 159, 52);
INSERT INTO public.europe_data VALUES (9982, 0, 0, 0, 76, 52);
INSERT INTO public.europe_data VALUES (9983, 0, 0, 0, 77, 52);
INSERT INTO public.europe_data VALUES (9984, 0, 1, 0, 16, 52);
INSERT INTO public.europe_data VALUES (9985, 0, 0, 0, 160, 52);
INSERT INTO public.europe_data VALUES (9986, 0, 0, 0, 162, 52);
INSERT INTO public.europe_data VALUES (9987, 1, 1, 0.01, 163, 52);
INSERT INTO public.europe_data VALUES (9988, 0, 0, 0, 164, 52);
INSERT INTO public.europe_data VALUES (9989, 0, 2, 0.01, 165, 52);
INSERT INTO public.europe_data VALUES (9990, 0, 0, 0, 167, 52);
INSERT INTO public.europe_data VALUES (9991, 0, 0, 0, 171, 52);
INSERT INTO public.europe_data VALUES (9992, 0, 0, 0, 112, 52);
INSERT INTO public.europe_data VALUES (9993, 0, 0, 0, 113, 52);
INSERT INTO public.europe_data VALUES (9994, 0, 0, 0, 114, 52);
INSERT INTO public.europe_data VALUES (9995, 0, 0, 0, 115, 52);
INSERT INTO public.europe_data VALUES (9996, 0, 0, 0, 172, 52);
INSERT INTO public.europe_data VALUES (9997, 0, 0, 0, 116, 52);
INSERT INTO public.europe_data VALUES (9998, 0, 0, 0, 174, 52);
INSERT INTO public.europe_data VALUES (9999, 1, 34, 0.03, 117, 52);
INSERT INTO public.europe_data VALUES (10000, 0, 0, 0, 120, 52);
INSERT INTO public.europe_data VALUES (10001, 0, 0, 0, 123, 52);
INSERT INTO public.europe_data VALUES (10002, 0, 0, 0, 179, 52);
INSERT INTO public.europe_data VALUES (10003, 0, 0, 0, 180, 52);
INSERT INTO public.europe_data VALUES (10004, 0, 4, 0.04, 124, 52);
INSERT INTO public.europe_data VALUES (10005, 0, 1, 0, 87, 52);
INSERT INTO public.europe_data VALUES (10006, 0, 0, 0, 183, 52);
INSERT INTO public.europe_data VALUES (10007, 0, 0, 0, 128, 52);
INSERT INTO public.europe_data VALUES (10008, 0, 0, 0, 185, 52);
INSERT INTO public.europe_data VALUES (10009, 0, 0, 0, 209, 52);
INSERT INTO public.europe_data VALUES (10010, 0, 0, 0, 39, 52);
INSERT INTO public.europe_data VALUES (10011, 0, 0, 0, 186, 52);
INSERT INTO public.europe_data VALUES (10012, 0, 0, 0, 187, 52);
INSERT INTO public.europe_data VALUES (10013, 0, 0, 0, 129, 52);
INSERT INTO public.europe_data VALUES (10014, 0, 0, 0, 130, 52);
INSERT INTO public.europe_data VALUES (10015, 0, 0, 0, 132, 52);
INSERT INTO public.europe_data VALUES (10016, 0, 0, 0, 133, 52);
INSERT INTO public.europe_data VALUES (10017, 0, 0, 0, 190, 52);
INSERT INTO public.europe_data VALUES (10018, 0, 0, 0, 191, 52);
INSERT INTO public.europe_data VALUES (10019, 0, 0, 0, 192, 52);
INSERT INTO public.europe_data VALUES (10020, 0, 32, 0.98, 135, 52);
INSERT INTO public.europe_data VALUES (10021, 0, 3, 0.03, 136, 52);
INSERT INTO public.europe_data VALUES (10022, 0, 0, 0, 196, 52);
INSERT INTO public.europe_data VALUES (10023, 0, 0, 0, 137, 52);
INSERT INTO public.europe_data VALUES (10024, 0, 0, 0.01, 197, 52);
INSERT INTO public.europe_data VALUES (10025, 0, 0, 0, 198, 52);
INSERT INTO public.europe_data VALUES (10026, 1, 2, 0.04, 139, 52);
INSERT INTO public.europe_data VALUES (10027, 0, 2, 0.02, 141, 52);
INSERT INTO public.europe_data VALUES (10028, 0, 2, 0.04, 143, 52);
INSERT INTO public.europe_data VALUES (10029, 0, 2, 0.01, 201, 52);
INSERT INTO public.europe_data VALUES (10030, 0, 3, 0, 101, 52);
INSERT INTO public.europe_data VALUES (10031, 0, 2, 0.01, 145, 52);
INSERT INTO public.europe_data VALUES (10032, 0, 0, 0, 105, 53);
INSERT INTO public.europe_data VALUES (10033, 0, 0, 0, 1, 53);
INSERT INTO public.europe_data VALUES (10034, 0, 0, 0, 149, 53);
INSERT INTO public.europe_data VALUES (10035, 0, 3, 0.04, 202, 53);
INSERT INTO public.europe_data VALUES (10036, 0, 0, 0, 150, 53);
INSERT INTO public.europe_data VALUES (10037, 0, 0, 0, 151, 53);
INSERT INTO public.europe_data VALUES (10038, 0, 0, 0, 106, 53);
INSERT INTO public.europe_data VALUES (10039, 0, 0, 0, 152, 53);
INSERT INTO public.europe_data VALUES (10040, 0, 0, 0, 153, 53);
INSERT INTO public.europe_data VALUES (10041, 0, 0, 0, 66, 53);
INSERT INTO public.europe_data VALUES (10042, 0, 0, 0.01, 110, 53);
INSERT INTO public.europe_data VALUES (10043, 0, 3, 0.02, 68, 53);
INSERT INTO public.europe_data VALUES (10044, 0, 70, 0, 215, 53);
INSERT INTO public.europe_data VALUES (10045, 548, 22995, 2.61, 111, 53);
INSERT INTO public.europe_data VALUES (10046, 0, 0, 0, 156, 53);
INSERT INTO public.europe_data VALUES (10047, 0, 0, 0, 158, 53);
INSERT INTO public.europe_data VALUES (10048, 0, 0, 0, 159, 53);
INSERT INTO public.europe_data VALUES (10049, 0, 0, 0, 76, 53);
INSERT INTO public.europe_data VALUES (10050, 0, 0, 0, 77, 53);
INSERT INTO public.europe_data VALUES (10051, 0, 0, 0, 16, 53);
INSERT INTO public.europe_data VALUES (10052, 0, 0, 0, 160, 53);
INSERT INTO public.europe_data VALUES (10053, 0, 0, 0.02, 162, 53);
INSERT INTO public.europe_data VALUES (10054, 0, 5, 0.01, 163, 53);
INSERT INTO public.europe_data VALUES (10055, 0, 0, 0, 164, 53);
INSERT INTO public.europe_data VALUES (10056, 0, 4, 0.02, 165, 53);
INSERT INTO public.europe_data VALUES (10057, 0, 0, 0, 167, 53);
INSERT INTO public.europe_data VALUES (10058, 0, 0, 0, 171, 53);
INSERT INTO public.europe_data VALUES (10059, 0, 1, 0, 112, 53);
INSERT INTO public.europe_data VALUES (10060, 0, 0, 0, 113, 53);
INSERT INTO public.europe_data VALUES (10061, 0, 0, 0, 114, 53);
INSERT INTO public.europe_data VALUES (10062, 0, 0, 0, 115, 53);
INSERT INTO public.europe_data VALUES (10063, 0, 0, 0, 172, 53);
INSERT INTO public.europe_data VALUES (10064, 0, 0, 0, 116, 53);
INSERT INTO public.europe_data VALUES (10065, 0, 0, 0, 174, 53);
INSERT INTO public.europe_data VALUES (10066, 0, 5, 0.02, 117, 53);
INSERT INTO public.europe_data VALUES (10067, 0, 0, 0, 120, 53);
INSERT INTO public.europe_data VALUES (10068, 0, 0, 0, 123, 53);
INSERT INTO public.europe_data VALUES (10069, 0, 0, 0, 179, 53);
INSERT INTO public.europe_data VALUES (10070, 0, 0, 0, 180, 53);
INSERT INTO public.europe_data VALUES (10071, 0, 10, 0.04, 124, 53);
INSERT INTO public.europe_data VALUES (10072, 0, 0, 0, 87, 53);
INSERT INTO public.europe_data VALUES (10073, 0, 0, 0, 183, 53);
INSERT INTO public.europe_data VALUES (10074, 0, 0, 0, 128, 53);
INSERT INTO public.europe_data VALUES (10075, 0, 0, 0, 185, 53);
INSERT INTO public.europe_data VALUES (10076, 0, 0, 0, 209, 53);
INSERT INTO public.europe_data VALUES (10077, 0, 0, 0, 39, 53);
INSERT INTO public.europe_data VALUES (10078, 0, 0, 0, 186, 53);
INSERT INTO public.europe_data VALUES (10079, 0, 0, 0, 187, 53);
INSERT INTO public.europe_data VALUES (10080, 0, 0, 0, 129, 53);
INSERT INTO public.europe_data VALUES (10081, 0, 0, 0, 130, 53);
INSERT INTO public.europe_data VALUES (10082, 0, 1, 0, 132, 53);
INSERT INTO public.europe_data VALUES (10083, 0, 0, 0, 133, 53);
INSERT INTO public.europe_data VALUES (10084, 0, 0, 0, 190, 53);
INSERT INTO public.europe_data VALUES (10085, 0, 0, 0, 191, 53);
INSERT INTO public.europe_data VALUES (10086, 0, 0, 0, 192, 53);
INSERT INTO public.europe_data VALUES (10087, 0, 25, 0.67, 135, 53);
INSERT INTO public.europe_data VALUES (10088, 0, 12, 0.04, 136, 53);
INSERT INTO public.europe_data VALUES (10089, 0, 1, 0, 196, 53);
INSERT INTO public.europe_data VALUES (10090, 0, 0, 0, 137, 53);
INSERT INTO public.europe_data VALUES (10091, 0, 1, 0.01, 197, 53);
INSERT INTO public.europe_data VALUES (10092, 0, 0, 0, 198, 53);
INSERT INTO public.europe_data VALUES (10093, 0, 8, 0.05, 139, 53);
INSERT INTO public.europe_data VALUES (10094, 0, 13, 0.03, 141, 53);
INSERT INTO public.europe_data VALUES (10095, 0, 2, 0.06, 143, 53);
INSERT INTO public.europe_data VALUES (10096, 0, 6, 0.01, 201, 53);
INSERT INTO public.europe_data VALUES (10097, 0, 1, 0, 101, 53);
INSERT INTO public.europe_data VALUES (10098, 0, 6, 0.01, 145, 53);
INSERT INTO public.europe_data VALUES (10099, 0, 0, 0, 105, 54);
INSERT INTO public.europe_data VALUES (10100, 0, 0, 0, 1, 54);
INSERT INTO public.europe_data VALUES (10101, 0, 0, 0, 149, 54);
INSERT INTO public.europe_data VALUES (10102, 0, 7, 0.04, 202, 54);
INSERT INTO public.europe_data VALUES (10103, 0, 0, 0, 150, 54);
INSERT INTO public.europe_data VALUES (10104, 0, 0, 0, 151, 54);
INSERT INTO public.europe_data VALUES (10105, 0, 0, 0, 106, 54);
INSERT INTO public.europe_data VALUES (10106, 0, 0, 0, 152, 54);
INSERT INTO public.europe_data VALUES (10107, 0, 0, 0, 153, 54);
INSERT INTO public.europe_data VALUES (10108, 0, 0, 0, 66, 54);
INSERT INTO public.europe_data VALUES (10109, 0, 1, 0.01, 110, 54);
INSERT INTO public.europe_data VALUES (10110, 0, 3, 0.01, 68, 54);
INSERT INTO public.europe_data VALUES (10111, 0, 0, 0, 215, 54);
INSERT INTO public.europe_data VALUES (10112, 280, 14436, 1.18, 111, 54);
INSERT INTO public.europe_data VALUES (10113, 0, 0, 0, 156, 54);
INSERT INTO public.europe_data VALUES (10114, 0, 0, 0, 158, 54);
INSERT INTO public.europe_data VALUES (10115, 0, 0, 0, 159, 54);
INSERT INTO public.europe_data VALUES (10116, 0, 0, 0, 76, 54);
INSERT INTO public.europe_data VALUES (10117, 0, 0, 0, 77, 54);
INSERT INTO public.europe_data VALUES (10118, 0, 0, 0, 16, 54);
INSERT INTO public.europe_data VALUES (10119, 0, 0, 0, 160, 54);
INSERT INTO public.europe_data VALUES (10120, 0, 1, 0.02, 162, 54);
INSERT INTO public.europe_data VALUES (10121, 0, 3, 0.01, 163, 54);
INSERT INTO public.europe_data VALUES (10122, 0, 0, 0, 164, 54);
INSERT INTO public.europe_data VALUES (10123, 0, 9, 0.01, 165, 54);
INSERT INTO public.europe_data VALUES (10124, 0, 0, 0, 167, 54);
INSERT INTO public.europe_data VALUES (10125, 0, 0, 0, 171, 54);
INSERT INTO public.europe_data VALUES (10126, 0, 2, 0, 112, 54);
INSERT INTO public.europe_data VALUES (10127, 0, 0, 0, 113, 54);
INSERT INTO public.europe_data VALUES (10128, 0, 0, 0, 114, 54);
INSERT INTO public.europe_data VALUES (10129, 0, 0, 0, 115, 54);
INSERT INTO public.europe_data VALUES (10130, 0, 0, 0, 172, 54);
INSERT INTO public.europe_data VALUES (10131, 0, 0, 0, 116, 54);
INSERT INTO public.europe_data VALUES (10132, 0, 3, 0, 174, 54);
INSERT INTO public.europe_data VALUES (10133, 0, 17, 0.01, 117, 54);
INSERT INTO public.europe_data VALUES (10134, 0, 0, 0, 120, 54);
INSERT INTO public.europe_data VALUES (10135, 0, 0, 0, 123, 54);
INSERT INTO public.europe_data VALUES (10136, 0, 0, 0, 179, 54);
INSERT INTO public.europe_data VALUES (10137, 0, 0, 0, 180, 54);
INSERT INTO public.europe_data VALUES (10138, 0, 4, 0.03, 124, 54);
INSERT INTO public.europe_data VALUES (10139, 0, 1, 0, 87, 54);
INSERT INTO public.europe_data VALUES (10140, 0, 0, 0, 183, 54);
INSERT INTO public.europe_data VALUES (10141, 0, 0, 0, 128, 54);
INSERT INTO public.europe_data VALUES (10142, 0, 0, 0, 185, 54);
INSERT INTO public.europe_data VALUES (10143, 0, 0, 0, 209, 54);
INSERT INTO public.europe_data VALUES (10144, 0, 0, 0, 39, 54);
INSERT INTO public.europe_data VALUES (10145, 0, 0, 0, 186, 54);
INSERT INTO public.europe_data VALUES (10146, 0, 0, 0, 187, 54);
INSERT INTO public.europe_data VALUES (10147, 0, 0, 0, 129, 54);
INSERT INTO public.europe_data VALUES (10148, 0, 0, 0, 130, 54);
INSERT INTO public.europe_data VALUES (10149, 1, 2, 0, 132, 54);
INSERT INTO public.europe_data VALUES (10150, 0, 0, 0, 133, 54);
INSERT INTO public.europe_data VALUES (10151, 0, 0, 0, 190, 54);
INSERT INTO public.europe_data VALUES (10152, 0, 2, 0, 191, 54);
INSERT INTO public.europe_data VALUES (10153, 0, 0, 0, 192, 54);
INSERT INTO public.europe_data VALUES (10154, 0, 14, 0.31, 135, 54);
INSERT INTO public.europe_data VALUES (10155, 0, 11, 0.03, 136, 54);
INSERT INTO public.europe_data VALUES (10156, 0, 1, 0, 196, 54);
INSERT INTO public.europe_data VALUES (10157, 0, 1, 0, 137, 54);
INSERT INTO public.europe_data VALUES (10158, 0, 0, 0, 197, 54);
INSERT INTO public.europe_data VALUES (10159, 0, 0, 0, 198, 54);
INSERT INTO public.europe_data VALUES (10160, 0, 5, 0.04, 139, 54);
INSERT INTO public.europe_data VALUES (10161, 0, 11, 0.02, 141, 54);
INSERT INTO public.europe_data VALUES (10162, 0, 4, 0.05, 143, 54);
INSERT INTO public.europe_data VALUES (10163, 0, 2, 0, 201, 54);
INSERT INTO public.europe_data VALUES (10164, 0, 6, 0, 101, 54);
INSERT INTO public.europe_data VALUES (10165, 0, 6, 0.01, 145, 54);
INSERT INTO public.europe_data VALUES (10166, 0, 0, 0, 105, 55);
INSERT INTO public.europe_data VALUES (10167, 0, 0, 0, 1, 55);
INSERT INTO public.europe_data VALUES (10168, 0, 0, 0, 149, 55);
INSERT INTO public.europe_data VALUES (10169, 0, 4, 0.02, 202, 55);
INSERT INTO public.europe_data VALUES (10170, 0, 0, 0, 150, 55);
INSERT INTO public.europe_data VALUES (10171, 0, 0, 0, 151, 55);
INSERT INTO public.europe_data VALUES (10172, 0, 0, 0, 106, 55);
INSERT INTO public.europe_data VALUES (10173, 0, 0, 0, 152, 55);
INSERT INTO public.europe_data VALUES (10174, 0, 0, 0, 153, 55);
INSERT INTO public.europe_data VALUES (10175, 0, 0, 0, 66, 55);
INSERT INTO public.europe_data VALUES (10176, 0, 0, 0, 110, 55);
INSERT INTO public.europe_data VALUES (10177, 0, 1, 0, 68, 55);
INSERT INTO public.europe_data VALUES (10178, 0, 0, 0, 215, 55);
INSERT INTO public.europe_data VALUES (10179, 78, 2540, 0.19, 111, 55);
INSERT INTO public.europe_data VALUES (10180, 0, 0, 0, 156, 55);
INSERT INTO public.europe_data VALUES (10181, 0, 0, 0, 158, 55);
INSERT INTO public.europe_data VALUES (10182, 0, 0, 0, 159, 55);
INSERT INTO public.europe_data VALUES (10183, 0, 0, 0, 76, 55);
INSERT INTO public.europe_data VALUES (10184, 0, 0, 0, 77, 55);
INSERT INTO public.europe_data VALUES (10185, 0, 0, 0, 16, 55);
INSERT INTO public.europe_data VALUES (10186, 0, 0, 0, 160, 55);
INSERT INTO public.europe_data VALUES (10187, 0, 0, 0, 162, 55);
INSERT INTO public.europe_data VALUES (10188, 0, 3, 0, 163, 55);
INSERT INTO public.europe_data VALUES (10189, 0, 0, 0, 164, 55);
INSERT INTO public.europe_data VALUES (10190, 0, 0, 0, 165, 55);
INSERT INTO public.europe_data VALUES (10191, 0, 0, 0, 167, 55);
INSERT INTO public.europe_data VALUES (10192, 0, 0, 0, 171, 55);
INSERT INTO public.europe_data VALUES (10193, 0, 0, 0, 112, 55);
INSERT INTO public.europe_data VALUES (10194, 0, 0, 0, 113, 55);
INSERT INTO public.europe_data VALUES (10195, 0, 0, 0, 114, 55);
INSERT INTO public.europe_data VALUES (10196, 0, 0, 0, 115, 55);
INSERT INTO public.europe_data VALUES (10197, 0, 0, 0, 172, 55);
INSERT INTO public.europe_data VALUES (10198, 0, 0, 0, 116, 55);
INSERT INTO public.europe_data VALUES (10199, 0, 0, 0, 174, 55);
INSERT INTO public.europe_data VALUES (10200, 0, 2, 0, 117, 55);
INSERT INTO public.europe_data VALUES (10201, 0, 0, 0, 120, 55);
INSERT INTO public.europe_data VALUES (10202, 0, 0, 0, 123, 55);
INSERT INTO public.europe_data VALUES (10203, 0, 0, 0, 179, 55);
INSERT INTO public.europe_data VALUES (10204, 0, 0, 0, 180, 55);
INSERT INTO public.europe_data VALUES (10205, 0, 4, 0.01, 124, 55);
INSERT INTO public.europe_data VALUES (10206, 0, 0, 0, 87, 55);
INSERT INTO public.europe_data VALUES (10207, 0, 0, 0, 183, 55);
INSERT INTO public.europe_data VALUES (10208, 0, 1, 0, 128, 55);
INSERT INTO public.europe_data VALUES (10209, 0, 0, 0, 185, 55);
INSERT INTO public.europe_data VALUES (10210, 0, 0, 0, 209, 55);
INSERT INTO public.europe_data VALUES (10211, 0, 0, 0, 39, 55);
INSERT INTO public.europe_data VALUES (10212, 0, 0, 0, 186, 55);
INSERT INTO public.europe_data VALUES (10213, 0, 0, 0, 187, 55);
INSERT INTO public.europe_data VALUES (10214, 0, 0, 0, 129, 55);
INSERT INTO public.europe_data VALUES (10215, 0, 0, 0, 130, 55);
INSERT INTO public.europe_data VALUES (10216, 0, 0, 0, 132, 55);
INSERT INTO public.europe_data VALUES (10217, 0, 0, 0, 133, 55);
INSERT INTO public.europe_data VALUES (10218, 0, 0, 0, 190, 55);
INSERT INTO public.europe_data VALUES (10219, 0, 0, 0, 191, 55);
INSERT INTO public.europe_data VALUES (10220, 0, 0, 0, 192, 55);
INSERT INTO public.europe_data VALUES (10221, 0, 4, 0.07, 135, 55);
INSERT INTO public.europe_data VALUES (10222, 0, 3, 0.01, 136, 55);
INSERT INTO public.europe_data VALUES (10223, 0, 0, 0, 196, 55);
INSERT INTO public.europe_data VALUES (10224, 0, 0, 0, 137, 55);
INSERT INTO public.europe_data VALUES (10225, 0, 0, 0, 197, 55);
INSERT INTO public.europe_data VALUES (10226, 0, 0, 0, 198, 55);
INSERT INTO public.europe_data VALUES (10227, 0, 5, 0.02, 139, 55);
INSERT INTO public.europe_data VALUES (10228, 0, 6, 0.01, 141, 55);
INSERT INTO public.europe_data VALUES (10229, 0, 1, 0.01, 143, 55);
INSERT INTO public.europe_data VALUES (10230, 0, 0, 0, 201, 55);
INSERT INTO public.europe_data VALUES (10231, 0, 5, 0, 101, 55);
INSERT INTO public.europe_data VALUES (10232, 0, 2, 0, 145, 55);
INSERT INTO public.europe_data VALUES (10233, 0, 0, 0, 105, 56);
INSERT INTO public.europe_data VALUES (10234, 0, 0, 0, 1, 56);
INSERT INTO public.europe_data VALUES (10235, 0, 0, 0, 149, 56);
INSERT INTO public.europe_data VALUES (10236, 0, 0, 0, 202, 56);
INSERT INTO public.europe_data VALUES (10237, 0, 0, 0, 150, 56);
INSERT INTO public.europe_data VALUES (10238, 0, 0, 0, 151, 56);
INSERT INTO public.europe_data VALUES (10239, 0, 0, 0, 106, 56);
INSERT INTO public.europe_data VALUES (10240, 0, 0, 0, 152, 56);
INSERT INTO public.europe_data VALUES (10241, 0, 0, 0, 153, 56);
INSERT INTO public.europe_data VALUES (10242, 0, 0, 0, 66, 56);
INSERT INTO public.europe_data VALUES (10243, 0, 0, 0, 110, 56);
INSERT INTO public.europe_data VALUES (10244, 0, 0, 0, 68, 56);
INSERT INTO public.europe_data VALUES (10245, 0, 0, 0, 215, 56);
INSERT INTO public.europe_data VALUES (10246, 2, 176, 0.01, 111, 56);
INSERT INTO public.europe_data VALUES (10247, 0, 0, 0, 156, 56);
INSERT INTO public.europe_data VALUES (10248, 0, 0, 0, 158, 56);
INSERT INTO public.europe_data VALUES (10249, 0, 0, 0, 159, 56);
INSERT INTO public.europe_data VALUES (10250, 0, 0, 0, 76, 56);
INSERT INTO public.europe_data VALUES (10251, 0, 0, 0, 77, 56);
INSERT INTO public.europe_data VALUES (10252, 0, 0, 0, 16, 56);
INSERT INTO public.europe_data VALUES (10253, 0, 0, 0, 160, 56);
INSERT INTO public.europe_data VALUES (10254, 0, 0, 0, 162, 56);
INSERT INTO public.europe_data VALUES (10255, 0, 0, 0, 163, 56);
INSERT INTO public.europe_data VALUES (10256, 0, 0, 0, 164, 56);
INSERT INTO public.europe_data VALUES (10257, 0, 0, 0, 165, 56);
INSERT INTO public.europe_data VALUES (10258, 0, 0, 0, 167, 56);
INSERT INTO public.europe_data VALUES (10259, 0, 0, 0, 171, 56);
INSERT INTO public.europe_data VALUES (10260, 0, 0, 0, 112, 56);
INSERT INTO public.europe_data VALUES (10261, 0, 0, 0, 113, 56);
INSERT INTO public.europe_data VALUES (10262, 0, 0, 0, 114, 56);
INSERT INTO public.europe_data VALUES (10263, 0, 0, 0, 115, 56);
INSERT INTO public.europe_data VALUES (10264, 0, 0, 0, 172, 56);
INSERT INTO public.europe_data VALUES (10265, 0, 0, 0, 116, 56);
INSERT INTO public.europe_data VALUES (10266, 0, 0, 0, 174, 56);
INSERT INTO public.europe_data VALUES (10267, 0, 1, 0, 117, 56);
INSERT INTO public.europe_data VALUES (10268, 0, 0, 0, 120, 56);
INSERT INTO public.europe_data VALUES (10269, 0, 0, 0, 123, 56);
INSERT INTO public.europe_data VALUES (10270, 0, 0, 0, 179, 56);
INSERT INTO public.europe_data VALUES (10271, 0, 0, 0, 180, 56);
INSERT INTO public.europe_data VALUES (10272, 0, 0, 0, 124, 56);
INSERT INTO public.europe_data VALUES (10273, 0, 1, 0, 87, 56);
INSERT INTO public.europe_data VALUES (10274, 0, 0, 0, 183, 56);
INSERT INTO public.europe_data VALUES (10275, 0, 0, 0, 128, 56);
INSERT INTO public.europe_data VALUES (10276, 0, 0, 0, 185, 56);
INSERT INTO public.europe_data VALUES (10277, 0, 0, 0, 209, 56);
INSERT INTO public.europe_data VALUES (10278, 0, 0, 0, 39, 56);
INSERT INTO public.europe_data VALUES (10279, 0, 0, 0, 186, 56);
INSERT INTO public.europe_data VALUES (10280, 0, 0, 0, 187, 56);
INSERT INTO public.europe_data VALUES (10281, 0, 0, 0, 129, 56);
INSERT INTO public.europe_data VALUES (10282, 0, 0, 0, 130, 56);
INSERT INTO public.europe_data VALUES (10283, 0, 0, 0, 132, 56);
INSERT INTO public.europe_data VALUES (10284, 0, 0, 0, 133, 56);
INSERT INTO public.europe_data VALUES (10285, 0, 0, 0, 190, 56);
INSERT INTO public.europe_data VALUES (10286, 0, 0, 0, 191, 56);
INSERT INTO public.europe_data VALUES (10287, 0, 0, 0, 192, 56);
INSERT INTO public.europe_data VALUES (10288, 0, 0, 0, 135, 56);
INSERT INTO public.europe_data VALUES (10289, 0, 1, 0, 136, 56);
INSERT INTO public.europe_data VALUES (10290, 0, 0, 0, 196, 56);
INSERT INTO public.europe_data VALUES (10291, 0, 0, 0, 137, 56);
INSERT INTO public.europe_data VALUES (10292, 0, 0, 0, 197, 56);
INSERT INTO public.europe_data VALUES (10293, 0, 0, 0, 198, 56);
INSERT INTO public.europe_data VALUES (10294, 0, 0, 0, 139, 56);
INSERT INTO public.europe_data VALUES (10295, 0, 1, 0, 141, 56);
INSERT INTO public.europe_data VALUES (10296, 0, 0, 0, 143, 56);
INSERT INTO public.europe_data VALUES (10297, 0, 0, 0, 201, 56);
INSERT INTO public.europe_data VALUES (10298, 0, 0, 0, 101, 56);
INSERT INTO public.europe_data VALUES (10299, 0, 0, 0, 145, 56);
INSERT INTO public.europe_data VALUES (10300, 0, 0, 0, 105, 57);
INSERT INTO public.europe_data VALUES (10301, 0, 0, 0, 1, 57);
INSERT INTO public.europe_data VALUES (10302, 0, 0, 0, 149, 57);
INSERT INTO public.europe_data VALUES (10303, 0, 0, 0, 202, 57);
INSERT INTO public.europe_data VALUES (10304, 0, 0, 0, 150, 57);
INSERT INTO public.europe_data VALUES (10305, 0, 0, 0, 151, 57);
INSERT INTO public.europe_data VALUES (10306, 0, 0, 0, 106, 57);
INSERT INTO public.europe_data VALUES (10307, 0, 0, 0, 152, 57);
INSERT INTO public.europe_data VALUES (10308, 0, 0, 0, 153, 57);
INSERT INTO public.europe_data VALUES (10309, 0, 0, 0, 66, 57);
INSERT INTO public.europe_data VALUES (10310, 0, 0, 0, 110, 57);
INSERT INTO public.europe_data VALUES (10311, 0, 0, 0, 68, 57);
INSERT INTO public.europe_data VALUES (10312, 0, 0, 0, 215, 57);
INSERT INTO public.europe_data VALUES (10313, 1, 0, 0, 111, 57);
INSERT INTO public.europe_data VALUES (10314, 0, 0, 0, 156, 57);
INSERT INTO public.europe_data VALUES (10315, 0, 0, 0, 158, 57);
INSERT INTO public.europe_data VALUES (10316, 0, 0, 0, 159, 57);
INSERT INTO public.europe_data VALUES (10317, 0, 0, 0, 76, 57);
INSERT INTO public.europe_data VALUES (10318, 0, 0, 0, 77, 57);
INSERT INTO public.europe_data VALUES (10319, 0, 0, 0, 16, 57);
INSERT INTO public.europe_data VALUES (10320, 0, 0, 0, 160, 57);
INSERT INTO public.europe_data VALUES (10321, 0, 0, 0, 162, 57);
INSERT INTO public.europe_data VALUES (10322, 0, 0, 0, 163, 57);
INSERT INTO public.europe_data VALUES (10323, 0, 0, 0, 164, 57);
INSERT INTO public.europe_data VALUES (10324, 0, 0, 0, 165, 57);
INSERT INTO public.europe_data VALUES (10325, 0, 0, 0, 167, 57);
INSERT INTO public.europe_data VALUES (10326, 0, 0, 0, 171, 57);
INSERT INTO public.europe_data VALUES (10327, 0, 0, 0, 112, 57);
INSERT INTO public.europe_data VALUES (10328, 0, 0, 0, 113, 57);
INSERT INTO public.europe_data VALUES (10329, 0, 0, 0, 114, 57);
INSERT INTO public.europe_data VALUES (10330, 0, 0, 0, 115, 57);
INSERT INTO public.europe_data VALUES (10331, 0, 0, 0, 172, 57);
INSERT INTO public.europe_data VALUES (10332, 0, 0, 0, 116, 57);
INSERT INTO public.europe_data VALUES (10333, 0, 0, 0, 174, 57);
INSERT INTO public.europe_data VALUES (10334, 0, 0, 0, 117, 57);
INSERT INTO public.europe_data VALUES (10335, 0, 0, 0, 120, 57);
INSERT INTO public.europe_data VALUES (10336, 0, 0, 0, 123, 57);
INSERT INTO public.europe_data VALUES (10337, 0, 0, 0, 179, 57);
INSERT INTO public.europe_data VALUES (10338, 0, 0, 0, 180, 57);
INSERT INTO public.europe_data VALUES (10339, 0, 0, 0, 124, 57);
INSERT INTO public.europe_data VALUES (10340, 0, 0, 0, 87, 57);
INSERT INTO public.europe_data VALUES (10341, 0, 0, 0, 183, 57);
INSERT INTO public.europe_data VALUES (10342, 0, 0, 0, 128, 57);
INSERT INTO public.europe_data VALUES (10343, 0, 0, 0, 185, 57);
INSERT INTO public.europe_data VALUES (10344, 0, 0, 0, 209, 57);
INSERT INTO public.europe_data VALUES (10345, 0, 0, 0, 39, 57);
INSERT INTO public.europe_data VALUES (10346, 0, 0, 0, 186, 57);
INSERT INTO public.europe_data VALUES (10347, 0, 0, 0, 187, 57);
INSERT INTO public.europe_data VALUES (10348, 0, 0, 0, 129, 57);
INSERT INTO public.europe_data VALUES (10349, 0, 0, 0, 130, 57);
INSERT INTO public.europe_data VALUES (10350, 0, 0, 0, 132, 57);
INSERT INTO public.europe_data VALUES (10351, 0, 0, 0, 133, 57);
INSERT INTO public.europe_data VALUES (10352, 0, 0, 0, 190, 57);
INSERT INTO public.europe_data VALUES (10353, 0, 0, 0, 191, 57);
INSERT INTO public.europe_data VALUES (10354, 0, 0, 0, 192, 57);
INSERT INTO public.europe_data VALUES (10355, 0, 0, 0, 135, 57);
INSERT INTO public.europe_data VALUES (10356, 0, 0, 0, 136, 57);
INSERT INTO public.europe_data VALUES (10357, 0, 0, 0, 196, 57);
INSERT INTO public.europe_data VALUES (10358, 0, 0, 0, 137, 57);
INSERT INTO public.europe_data VALUES (10359, 0, 0, 0, 197, 57);
INSERT INTO public.europe_data VALUES (10360, 0, 0, 0, 198, 57);
INSERT INTO public.europe_data VALUES (10361, 0, 0, 0, 139, 57);
INSERT INTO public.europe_data VALUES (10362, 0, 1, 0, 141, 57);
INSERT INTO public.europe_data VALUES (10363, 0, 0, 0, 143, 57);
INSERT INTO public.europe_data VALUES (10364, 0, 0, 0, 201, 57);
INSERT INTO public.europe_data VALUES (10365, 0, 0, 0, 101, 57);
INSERT INTO public.europe_data VALUES (10366, 0, 0, 0, 145, 57);


--
-- Data for Name: europe_data_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.europe_data_import VALUES (1, '01/02/2021', '2021-04', '267', '16', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.58');
INSERT INTO public.europe_data_import VALUES (2, '25/01/2021', '2021-03', '713', '43', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.34');
INSERT INTO public.europe_data_import VALUES (3, '18/01/2021', '2021-02', '557', '45', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.24');
INSERT INTO public.europe_data_import VALUES (4, '11/01/2021', '2021-01', '675', '71', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.15');
INSERT INTO public.europe_data_import VALUES (5, '04/01/2021', '2020-53', '902', '60', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.61');
INSERT INTO public.europe_data_import VALUES (6, '28/12/2020', '2020-52', '1994', '88', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.19');
INSERT INTO public.europe_data_import VALUES (7, '21/12/2020', '2020-51', '740', '111', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.56');
INSERT INTO public.europe_data_import VALUES (8, '14/12/2020', '2020-50', '1757', '71', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '9.01');
INSERT INTO public.europe_data_import VALUES (9, '07/12/2020', '2020-49', '1672', '137', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.22');
INSERT INTO public.europe_data_import VALUES (10, '30/11/2020', '2020-48', '1073', '68', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.42');
INSERT INTO public.europe_data_import VALUES (11, '23/11/2020', '2020-47', '1368', '69', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.66');
INSERT INTO public.europe_data_import VALUES (12, '16/11/2020', '2020-46', '1164', '61', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.65');
INSERT INTO public.europe_data_import VALUES (13, '09/11/2020', '2020-45', '606', '24', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.7');
INSERT INTO public.europe_data_import VALUES (14, '02/11/2020', '2020-44', '800', '27', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.77');
INSERT INTO public.europe_data_import VALUES (15, '26/10/2020', '2020-43', '633', '22', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.72');
INSERT INTO public.europe_data_import VALUES (16, '19/10/2020', '2020-42', '401', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.26');
INSERT INTO public.europe_data_import VALUES (17, '12/10/2020', '2020-41', '458', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.5');
INSERT INTO public.europe_data_import VALUES (18, '05/10/2020', '2020-40', '114', '9', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (19, '28/09/2020', '2020-39', '183', '12', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.34');
INSERT INTO public.europe_data_import VALUES (20, '21/09/2020', '2020-38', '328', '21', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.7');
INSERT INTO public.europe_data_import VALUES (21, '14/09/2020', '2020-37', '318', '8', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.46');
INSERT INTO public.europe_data_import VALUES (22, '07/09/2020', '2020-36', '236', '10', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.05');
INSERT INTO public.europe_data_import VALUES (23, '31/08/2020', '2020-35', '163', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.49');
INSERT INTO public.europe_data_import VALUES (24, '24/08/2020', '2020-34', '403', '12', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.48');
INSERT INTO public.europe_data_import VALUES (25, '17/08/2020', '2020-33', '542', '63', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.33');
INSERT INTO public.europe_data_import VALUES (26, '10/08/2020', '2020-32', '344', '28', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.08');
INSERT INTO public.europe_data_import VALUES (27, '03/08/2020', '2020-31', '447', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.25');
INSERT INTO public.europe_data_import VALUES (28, '27/07/2020', '2020-30', '788', '88', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.76');
INSERT INTO public.europe_data_import VALUES (29, '20/07/2020', '2020-29', '1024', '171', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.63');
INSERT INTO public.europe_data_import VALUES (30, '13/07/2020', '2020-28', '1500', '146', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '9.16');
INSERT INTO public.europe_data_import VALUES (31, '06/07/2020', '2020-27', '1984', '143', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '10.82');
INSERT INTO public.europe_data_import VALUES (32, '29/06/2020', '2020-26', '2134', '140', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '16.3');
INSERT INTO public.europe_data_import VALUES (33, '22/06/2020', '2020-25', '4067', '110', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '22.32');
INSERT INTO public.europe_data_import VALUES (34, '15/06/2020', '2020-24', '4424', '114', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '25.13');
INSERT INTO public.europe_data_import VALUES (35, '08/06/2020', '2020-23', '5137', '100', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '25.66');
INSERT INTO public.europe_data_import VALUES (36, '01/06/2020', '2020-22', '4623', '39', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '22.45');
INSERT INTO public.europe_data_import VALUES (37, '25/05/2020', '2020-21', '3918', '49', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '16.25');
INSERT INTO public.europe_data_import VALUES (38, '18/05/2020', '2020-20', '2262', '49', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '10.41');
INSERT INTO public.europe_data_import VALUES (39, '11/05/2020', '2020-19', '1698', '35', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.55');
INSERT INTO public.europe_data_import VALUES (40, '04/05/2020', '2020-18', '1173', '28', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.49');
INSERT INTO public.europe_data_import VALUES (41, '27/04/2020', '2020-17', '535', '24', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.43');
INSERT INTO public.europe_data_import VALUES (42, '20/04/2020', '2020-16', '389', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (43, '13/04/2020', '2020-15', '308', '11', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (44, '06/04/2020', '2020-14', '185', '3', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.7');
INSERT INTO public.europe_data_import VALUES (45, '30/03/2020', '2020-13', '80', '4', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (46, '23/03/2020', '2020-12', '18', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (47, '16/03/2020', '2020-11', '12', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (48, '09/03/2020', '2020-10', '3', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (49, '02/03/2020', '2020-09', '1', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (50, '24/02/2020', '2020-08', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (51, '17/02/2020', '2020-07', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (52, '10/02/2020', '2020-06', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (53, '03/02/2020', '2020-05', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (54, '27/01/2020', '2020-04', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (55, '20/01/2020', '2020-03', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (56, '13/01/2020', '2020-02', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (57, '06/01/2020', '2020-01', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (58, '01/02/2021', '2021-04', '5853', '65', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '364.62');
INSERT INTO public.europe_data_import VALUES (59, '25/01/2021', '2021-03', '4584', '38', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '303.2');
INSERT INTO public.europe_data_import VALUES (60, '18/01/2021', '2021-02', '4095', '36', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '288.29');
INSERT INTO public.europe_data_import VALUES (61, '11/01/2021', '2021-01', '4157', '48', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '245.35');
INSERT INTO public.europe_data_import VALUES (62, '04/01/2021', '2020-53', '2866', '29', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '224.81');
INSERT INTO public.europe_data_import VALUES (63, '28/12/2020', '2020-52', '3569', '76', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '280.95');
INSERT INTO public.europe_data_import VALUES (64, '21/12/2020', '2020-51', '4473', '85', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '349.88');
INSERT INTO public.europe_data_import VALUES (65, '14/12/2020', '2020-50', '5542', '98', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '380.97');
INSERT INTO public.europe_data_import VALUES (66, '07/12/2020', '2020-49', '5363', '107', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '357.28');
INSERT INTO public.europe_data_import VALUES (67, '30/11/2020', '2020-48', '4864', '99', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '342.19');
INSERT INTO public.europe_data_import VALUES (68, '23/11/2020', '2020-47', '4931', '76', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '298.87');
INSERT INTO public.europe_data_import VALUES (69, '16/11/2020', '2020-46', '3624', '64', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '231.55');
INSERT INTO public.europe_data_import VALUES (70, '09/11/2020', '2020-45', '3004', '41', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '176.39');
INSERT INTO public.europe_data_import VALUES (71, '02/11/2020', '2020-44', '2045', '41', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '144.88');
INSERT INTO public.europe_data_import VALUES (72, '26/10/2020', '2020-43', '2102', '26', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '131.29');
INSERT INTO public.europe_data_import VALUES (73, '19/10/2020', '2020-42', '1656', '31', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '97.43');
INSERT INTO public.europe_data_import VALUES (74, '12/10/2020', '2020-41', '1133', '24', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '74.76');
INSERT INTO public.europe_data_import VALUES (75, '05/10/2020', '2020-40', '1007', '19', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '65.71');
INSERT INTO public.europe_data_import VALUES (76, '28/09/2020', '2020-39', '874', '15', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '66.59');
INSERT INTO public.europe_data_import VALUES (77, '21/09/2020', '2020-38', '1032', '28', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '74.41');
INSERT INTO public.europe_data_import VALUES (78, '14/09/2020', '2020-37', '1098', '18', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '68.93');
INSERT INTO public.europe_data_import VALUES (79, '07/09/2020', '2020-36', '875', '36', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '63.86');
INSERT INTO public.europe_data_import VALUES (80, '31/08/2020', '2020-35', '953', '30', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '69.87');
INSERT INTO public.europe_data_import VALUES (81, '24/08/2020', '2020-34', '1047', '22', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '70.43');
INSERT INTO public.europe_data_import VALUES (82, '17/08/2020', '2020-33', '969', '29', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '65.01');
INSERT INTO public.europe_data_import VALUES (83, '10/08/2020', '2020-32', '892', '33', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '57.57');
INSERT INTO public.europe_data_import VALUES (84, '03/08/2020', '2020-31', '756', '28', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '49.92');
INSERT INTO public.europe_data_import VALUES (85, '27/07/2020', '2020-30', '673', '26', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '45.73');
INSERT INTO public.europe_data_import VALUES (86, '20/07/2020', '2020-29', '636', '19', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '41.82');
INSERT INTO public.europe_data_import VALUES (87, '13/07/2020', '2020-28', '561', '17', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '36.75');
INSERT INTO public.europe_data_import VALUES (88, '06/07/2020', '2020-27', '491', '21', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '33.75');
INSERT INTO public.europe_data_import VALUES (89, '29/06/2020', '2020-26', '475', '11', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '30.78');
INSERT INTO public.europe_data_import VALUES (90, '22/06/2020', '2020-25', '406', '8', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '23.79');
INSERT INTO public.europe_data_import VALUES (91, '15/06/2020', '2020-24', '275', '2', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '13.42');
INSERT INTO public.europe_data_import VALUES (92, '08/06/2020', '2020-23', '109', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '8.66');
INSERT INTO public.europe_data_import VALUES (93, '01/06/2020', '2020-22', '139', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '6.67');
INSERT INTO public.europe_data_import VALUES (94, '25/05/2020', '2020-21', '52', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '4.54');
INSERT INTO public.europe_data_import VALUES (95, '18/05/2020', '2020-20', '78', '0', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '5.28');
INSERT INTO public.europe_data_import VALUES (96, '11/05/2020', '2020-19', '73', '0', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '4.96');
INSERT INTO public.europe_data_import VALUES (97, '04/05/2020', '2020-18', '69', '3', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '8.14');
INSERT INTO public.europe_data_import VALUES (98, '27/04/2020', '2020-17', '164', '2', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '9.78');
INSERT INTO public.europe_data_import VALUES (99, '20/04/2020', '2020-16', '116', '3', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '7.02');
INSERT INTO public.europe_data_import VALUES (100, '13/04/2020', '2020-15', '85', '2', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '8.17');
INSERT INTO public.europe_data_import VALUES (101, '06/04/2020', '2020-14', '149', '11', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '9.5');
INSERT INTO public.europe_data_import VALUES (102, '30/03/2020', '2020-13', '123', '8', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '5.94');
INSERT INTO public.europe_data_import VALUES (103, '23/03/2020', '2020-12', '47', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '3.04');
INSERT INTO public.europe_data_import VALUES (104, '16/03/2020', '2020-11', '40', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '1.47');
INSERT INTO public.europe_data_import VALUES (105, '09/03/2020', '2020-10', '2', '0', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (106, '01/02/2021', '2021-04', '1743', '28', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.14');
INSERT INTO public.europe_data_import VALUES (107, '25/01/2021', '2021-03', '1763', '27', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.02');
INSERT INTO public.europe_data_import VALUES (108, '18/01/2021', '2021-02', '1689', '29', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '7.96');
INSERT INTO public.europe_data_import VALUES (109, '11/01/2021', '2021-01', '1736', '35', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.16');
INSERT INTO public.europe_data_import VALUES (110, '04/01/2021', '2020-53', '1777', '35', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '12.09');
INSERT INTO public.europe_data_import VALUES (111, '28/12/2020', '2020-52', '3428', '71', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '15.17');
INSERT INTO public.europe_data_import VALUES (112, '21/12/2020', '2020-51', '3101', '70', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '16.15');
INSERT INTO public.europe_data_import VALUES (113, '14/12/2020', '2020-50', '3850', '80', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '22.95');
INSERT INTO public.europe_data_import VALUES (114, '07/12/2020', '2020-49', '6031', '106', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '31.1');
INSERT INTO public.europe_data_import VALUES (115, '30/11/2020', '2020-48', '7359', '135', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '33.78');
INSERT INTO public.europe_data_import VALUES (116, '23/11/2020', '2020-47', '7183', '121', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '29.76');
INSERT INTO public.europe_data_import VALUES (117, '16/11/2020', '2020-46', '5628', '106', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '21.85');
INSERT INTO public.europe_data_import VALUES (118, '09/11/2020', '2020-45', '3779', '75', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '13.72');
INSERT INTO public.europe_data_import VALUES (119, '02/11/2020', '2020-44', '2129', '59', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.99');
INSERT INTO public.europe_data_import VALUES (120, '26/10/2020', '2020-43', '1741', '58', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '7.13');
INSERT INTO public.europe_data_import VALUES (121, '19/10/2020', '2020-42', '1330', '55', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.26');
INSERT INTO public.europe_data_import VALUES (122, '12/10/2020', '2020-41', '936', '41', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '4.66');
INSERT INTO public.europe_data_import VALUES (123, '05/10/2020', '2020-40', '1069', '46', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.37');
INSERT INTO public.europe_data_import VALUES (124, '28/09/2020', '2020-39', '1241', '42', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '6.53');
INSERT INTO public.europe_data_import VALUES (125, '21/09/2020', '2020-38', '1572', '60', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.04');
INSERT INTO public.europe_data_import VALUES (126, '14/09/2020', '2020-37', '1890', '56', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '9.54');
INSERT INTO public.europe_data_import VALUES (127, '07/09/2020', '2020-36', '2218', '55', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '11.39');
INSERT INTO public.europe_data_import VALUES (128, '31/08/2020', '2020-35', '2686', '66', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '12.92');
INSERT INTO public.europe_data_import VALUES (129, '24/08/2020', '2020-34', '2877', '65', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '14.51');
INSERT INTO public.europe_data_import VALUES (130, '17/08/2020', '2020-33', '3369', '68', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '16.53');
INSERT INTO public.europe_data_import VALUES (131, '10/08/2020', '2020-32', '3749', '71', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '18.25');
INSERT INTO public.europe_data_import VALUES (132, '03/08/2020', '2020-31', '4108', '76', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '19.47');
INSERT INTO public.europe_data_import VALUES (133, '27/07/2020', '2020-30', '4273', '77', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '18.96');
INSERT INTO public.europe_data_import VALUES (134, '20/07/2020', '2020-29', '3889', '67', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '16.59');
INSERT INTO public.europe_data_import VALUES (135, '13/07/2020', '2020-28', '3254', '59', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '13.76');
INSERT INTO public.europe_data_import VALUES (136, '06/07/2020', '2020-27', '2668', '55', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '9.69');
INSERT INTO public.europe_data_import VALUES (137, '29/06/2020', '2020-26', '1502', '52', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.47');
INSERT INTO public.europe_data_import VALUES (138, '22/06/2020', '2020-25', '852', '78', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (139, '15/06/2020', '2020-24', '765', '60', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (140, '08/06/2020', '2020-23', '760', '54', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '4.29');
INSERT INTO public.europe_data_import VALUES (141, '01/06/2020', '2020-22', '1088', '53', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.52');
INSERT INTO public.europe_data_import VALUES (142, '25/05/2020', '2020-21', '1287', '52', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '6.0');
INSERT INTO public.europe_data_import VALUES (143, '18/05/2020', '2020-20', '1296', '46', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.91');
INSERT INTO public.europe_data_import VALUES (144, '11/05/2020', '2020-19', '1249', '39', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.44');
INSERT INTO public.europe_data_import VALUES (145, '04/05/2020', '2020-18', '1092', '38', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '4.29');
INSERT INTO public.europe_data_import VALUES (146, '27/04/2020', '2020-17', '753', '50', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.41');
INSERT INTO public.europe_data_import VALUES (147, '20/04/2020', '2020-16', '715', '82', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.04');
INSERT INTO public.europe_data_import VALUES (148, '13/04/2020', '2020-15', '594', '141', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (149, '06/04/2020', '2020-14', '809', '121', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '2.6');
INSERT INTO public.europe_data_import VALUES (150, '30/03/2020', '2020-13', '310', '14', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (151, '23/03/2020', '2020-12', '153', '13', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (152, '16/03/2020', '2020-11', '28', '4', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (153, '09/03/2020', '2020-10', '17', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (154, '02/03/2020', '2020-09', '3', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (155, '24/02/2020', '2020-08', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (156, '17/02/2020', '2020-07', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (157, '10/02/2020', '2020-06', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (158, '03/02/2020', '2020-05', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (159, '27/01/2020', '2020-04', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (160, '20/01/2020', '2020-03', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (161, '13/01/2020', '2020-02', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (162, '06/01/2020', '2020-01', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (163, '01/02/2021', '2021-04', '388', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1121.07');
INSERT INTO public.europe_data_import VALUES (164, '25/01/2021', '2021-03', '466', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1138.14');
INSERT INTO public.europe_data_import VALUES (165, '18/01/2021', '2021-02', '401', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1169.64');
INSERT INTO public.europe_data_import VALUES (166, '11/01/2021', '2021-01', '490', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1437.44');
INSERT INTO public.europe_data_import VALUES (167, '04/01/2021', '2020-53', '605', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '807.33');
INSERT INTO public.europe_data_import VALUES (168, '28/12/2020', '2020-52', '10', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '326.87');
INSERT INTO public.europe_data_import VALUES (169, '21/12/2020', '2020-51', '239', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '691.81');
INSERT INTO public.europe_data_import VALUES (170, '14/12/2020', '2020-50', '288', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '821.77');
INSERT INTO public.europe_data_import VALUES (171, '07/12/2020', '2020-49', '338', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1042.31');
INSERT INTO public.europe_data_import VALUES (172, '30/11/2020', '2020-48', '456', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1102.7');
INSERT INTO public.europe_data_import VALUES (173, '23/11/2020', '2020-47', '384', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1146.02');
INSERT INTO public.europe_data_import VALUES (174, '16/11/2020', '2020-46', '489', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1374.43');
INSERT INTO public.europe_data_import VALUES (175, '09/11/2020', '2020-45', '558', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1765.62');
INSERT INTO public.europe_data_import VALUES (176, '02/11/2020', '2020-44', '787', '6', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1900.84');
INSERT INTO public.europe_data_import VALUES (177, '26/10/2020', '2020-43', '661', '10', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1761.69');
INSERT INTO public.europe_data_import VALUES (178, '19/10/2020', '2020-42', '681', '4', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1663.23');
INSERT INTO public.europe_data_import VALUES (179, '12/10/2020', '2020-41', '586', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1128.95');
INSERT INTO public.europe_data_import VALUES (180, '05/10/2020', '2020-40', '274', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '716.75');
INSERT INTO public.europe_data_import VALUES (181, '28/09/2020', '2020-39', '272', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '645.86');
INSERT INTO public.europe_data_import VALUES (182, '21/09/2020', '2020-38', '220', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '458.14');
INSERT INTO public.europe_data_import VALUES (183, '14/09/2020', '2020-37', '129', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '288.8');
INSERT INTO public.europe_data_import VALUES (184, '07/09/2020', '2020-36', '91', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '223.16');
INSERT INTO public.europe_data_import VALUES (185, '31/08/2020', '2020-35', '79', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '177.22');
INSERT INTO public.europe_data_import VALUES (186, '24/08/2020', '2020-34', '56', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '116.83');
INSERT INTO public.europe_data_import VALUES (187, '17/08/2020', '2020-33', '33', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '84.01');
INSERT INTO public.europe_data_import VALUES (188, '10/08/2020', '2020-32', '31', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '77.45');
INSERT INTO public.europe_data_import VALUES (189, '03/08/2020', '2020-31', '28', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '59.07');
INSERT INTO public.europe_data_import VALUES (190, '27/07/2020', '2020-30', '17', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '55.13');
INSERT INTO public.europe_data_import VALUES (191, '20/07/2020', '2020-29', '25', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '32.82');
INSERT INTO public.europe_data_import VALUES (192, '13/07/2020', '2020-28', '0', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (193, '06/07/2020', '2020-27', '0', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (194, '29/06/2020', '2020-26', '0', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '2.63');
INSERT INTO public.europe_data_import VALUES (195, '22/06/2020', '2020-25', '2', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (196, '15/06/2020', '2020-24', '1', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '116.83');
INSERT INTO public.europe_data_import VALUES (197, '08/06/2020', '2020-23', '88', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '116.83');
INSERT INTO public.europe_data_import VALUES (198, '01/06/2020', '2020-22', '1', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (199, '25/05/2020', '2020-21', '2', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '10.5');
INSERT INTO public.europe_data_import VALUES (200, '18/05/2020', '2020-20', '6', '3', '76177', 'Andorra', 'AD', 'AND', 'Europe', '17.07');
INSERT INTO public.europe_data_import VALUES (201, '11/05/2020', '2020-19', '7', '3', '76177', 'Andorra', 'AD', 'AND', 'Europe', '19.69');
INSERT INTO public.europe_data_import VALUES (202, '04/05/2020', '2020-18', '8', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '45.95');
INSERT INTO public.europe_data_import VALUES (203, '27/04/2020', '2020-17', '27', '4', '76177', 'Andorra', 'AD', 'AND', 'Europe', '133.9');
INSERT INTO public.europe_data_import VALUES (204, '20/04/2020', '2020-16', '75', '7', '76177', 'Andorra', 'AD', 'AND', 'Europe', '278.3');
INSERT INTO public.europe_data_import VALUES (205, '13/04/2020', '2020-15', '137', '11', '76177', 'Andorra', 'AD', 'AND', 'Europe', '399.07');
INSERT INTO public.europe_data_import VALUES (206, '06/04/2020', '2020-14', '167', '12', '76177', 'Andorra', 'AD', 'AND', 'Europe', '509.34');
INSERT INTO public.europe_data_import VALUES (207, '30/03/2020', '2020-13', '221', '6', '76177', 'Andorra', 'AD', 'AND', 'Europe', '431.89');
INSERT INTO public.europe_data_import VALUES (208, '23/03/2020', '2020-12', '108', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '148.34');
INSERT INTO public.europe_data_import VALUES (209, '16/03/2020', '2020-11', '5', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (210, '01/02/2021', '2021-04', '397', '7', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.89');
INSERT INTO public.europe_data_import VALUES (211, '25/01/2021', '2021-03', '524', '23', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.79');
INSERT INTO public.europe_data_import VALUES (212, '18/01/2021', '2021-02', '682', '20', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (213, '11/01/2021', '2021-01', '551', '8', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.82');
INSERT INTO public.europe_data_import VALUES (214, '04/01/2021', '2020-53', '346', '5', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.14');
INSERT INTO public.europe_data_import VALUES (215, '28/12/2020', '2020-52', '652', '16', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.48');
INSERT INTO public.europe_data_import VALUES (216, '21/12/2020', '2020-51', '456', '16', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.48');
INSERT INTO public.europe_data_import VALUES (217, '14/12/2020', '2020-50', '652', '17', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.41');
INSERT INTO public.europe_data_import VALUES (218, '07/12/2020', '2020-49', '433', '8', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.28');
INSERT INTO public.europe_data_import VALUES (219, '30/11/2020', '2020-48', '610', '9', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '5.43');
INSERT INTO public.europe_data_import VALUES (220, '23/11/2020', '2020-47', '1119', '15', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '6.78');
INSERT INTO public.europe_data_import VALUES (221, '16/11/2020', '2020-46', '1039', '19', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '8.07');
INSERT INTO public.europe_data_import VALUES (222, '09/11/2020', '2020-45', '1530', '19', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '10.4');
INSERT INTO public.europe_data_import VALUES (223, '02/11/2020', '2020-44', '1779', '17', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '10.5');
INSERT INTO public.europe_data_import VALUES (224, '26/10/2020', '2020-43', '1564', '26', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '8.74');
INSERT INTO public.europe_data_import VALUES (225, '19/10/2020', '2020-42', '1216', '23', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '6.57');
INSERT INTO public.europe_data_import VALUES (226, '12/10/2020', '2020-41', '876', '25', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '4.95');
INSERT INTO public.europe_data_import VALUES (227, '05/10/2020', '2020-40', '698', '22', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '4.33');
INSERT INTO public.europe_data_import VALUES (228, '28/09/2020', '2020-39', '681', '19', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '4.2');
INSERT INTO public.europe_data_import VALUES (229, '21/09/2020', '2020-38', '656', '20', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.32');
INSERT INTO public.europe_data_import VALUES (230, '14/09/2020', '2020-37', '400', '15', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.23');
INSERT INTO public.europe_data_import VALUES (231, '07/09/2020', '2020-36', '311', '10', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (232, '31/08/2020', '2020-35', '453', '11', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.34');
INSERT INTO public.europe_data_import VALUES (233, '24/08/2020', '2020-34', '292', '10', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (234, '17/08/2020', '2020-33', '307', '16', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (235, '10/08/2020', '2020-32', '424', '18', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.02');
INSERT INTO public.europe_data_import VALUES (236, '03/08/2020', '2020-31', '218', '12', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (237, '27/07/2020', '2020-30', '225', '11', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.33');
INSERT INTO public.europe_data_import VALUES (238, '20/07/2020', '2020-29', '199', '3', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (239, '13/07/2020', '2020-28', '160', '7', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.75');
INSERT INTO public.europe_data_import VALUES (240, '06/07/2020', '2020-27', '79', '8', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (241, '29/06/2020', '2020-26', '91', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (242, '22/06/2020', '2020-25', '36', '3', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (243, '15/06/2020', '2020-24', '49', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (244, '08/06/2020', '2020-23', '5', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (245, '01/06/2020', '2020-22', '17', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (246, '25/05/2020', '2020-21', '21', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (247, '18/05/2020', '2020-20', '3', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (248, '11/05/2020', '2020-19', '10', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (249, '04/05/2020', '2020-18', '9', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (250, '27/04/2020', '2020-17', '2', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (251, '20/04/2020', '2020-16', '5', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (252, '13/04/2020', '2020-15', '5', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (253, '06/04/2020', '2020-14', '7', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (254, '30/03/2020', '2020-13', '5', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (255, '23/03/2020', '2020-12', '2', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (256, '01/02/2021', '2021-04', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '13.45');
INSERT INTO public.europe_data_import VALUES (257, '25/01/2021', '2021-03', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (258, '18/01/2021', '2021-02', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (259, '11/01/2021', '2021-01', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '13.45');
INSERT INTO public.europe_data_import VALUES (260, '04/01/2021', '2020-53', '2', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '33.62');
INSERT INTO public.europe_data_import VALUES (261, '28/12/2020', '2020-52', '3', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '20.17');
INSERT INTO public.europe_data_import VALUES (262, '21/12/2020', '2020-51', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (263, '14/12/2020', '2020-50', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '40.34');
INSERT INTO public.europe_data_import VALUES (264, '07/12/2020', '2020-49', '5', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '33.62');
INSERT INTO public.europe_data_import VALUES (265, '30/11/2020', '2020-48', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (266, '23/11/2020', '2020-47', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (267, '16/11/2020', '2020-46', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (268, '09/11/2020', '2020-45', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (269, '02/11/2020', '2020-44', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (270, '26/10/2020', '2020-43', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (271, '19/10/2020', '2020-42', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (272, '12/10/2020', '2020-41', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (273, '05/10/2020', '2020-40', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (274, '28/09/2020', '2020-39', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (275, '21/09/2020', '2020-38', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (276, '14/09/2020', '2020-37', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (277, '07/09/2020', '2020-36', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (278, '31/08/2020', '2020-35', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (279, '24/08/2020', '2020-34', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (280, '17/08/2020', '2020-33', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (281, '10/08/2020', '2020-32', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (282, '03/08/2020', '2020-31', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (283, '27/07/2020', '2020-30', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (284, '20/07/2020', '2020-29', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (285, '13/07/2020', '2020-28', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (286, '06/07/2020', '2020-27', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (287, '29/06/2020', '2020-26', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (288, '22/06/2020', '2020-25', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (289, '15/06/2020', '2020-24', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (290, '08/06/2020', '2020-23', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (291, '01/06/2020', '2020-22', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (292, '25/05/2020', '2020-21', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (293, '18/05/2020', '2020-20', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (294, '11/05/2020', '2020-19', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (295, '04/05/2020', '2020-18', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (296, '27/04/2020', '2020-17', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (297, '20/04/2020', '2020-16', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (298, '13/04/2020', '2020-15', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (299, '06/04/2020', '2020-14', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '20.17');
INSERT INTO public.europe_data_import VALUES (300, '30/03/2020', '2020-13', '2', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '');
INSERT INTO public.europe_data_import VALUES (301, '01/02/2021', '2021-04', '33', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '46.34');
INSERT INTO public.europe_data_import VALUES (302, '25/01/2021', '2021-03', '12', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '25.74');
INSERT INTO public.europe_data_import VALUES (303, '18/01/2021', '2021-02', '13', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '29.86');
INSERT INTO public.europe_data_import VALUES (304, '11/01/2021', '2021-01', '16', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '18.53');
INSERT INTO public.europe_data_import VALUES (305, '04/01/2021', '2020-53', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (306, '28/12/2020', '2020-52', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '10.3');
INSERT INTO public.europe_data_import VALUES (307, '21/12/2020', '2020-51', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (308, '14/12/2020', '2020-50', '2', '1', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (309, '07/12/2020', '2020-49', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (310, '30/11/2020', '2020-48', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (311, '23/11/2020', '2020-47', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (312, '16/11/2020', '2020-46', '3', '1', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '6.18');
INSERT INTO public.europe_data_import VALUES (313, '09/11/2020', '2020-45', '3', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (314, '02/11/2020', '2020-44', '4', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '9.27');
INSERT INTO public.europe_data_import VALUES (315, '26/10/2020', '2020-43', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '13.39');
INSERT INTO public.europe_data_import VALUES (316, '19/10/2020', '2020-42', '8', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '12.36');
INSERT INTO public.europe_data_import VALUES (317, '12/10/2020', '2020-41', '4', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '10.3');
INSERT INTO public.europe_data_import VALUES (318, '05/10/2020', '2020-40', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '11.33');
INSERT INTO public.europe_data_import VALUES (319, '28/09/2020', '2020-39', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '6.18');
INSERT INTO public.europe_data_import VALUES (320, '21/09/2020', '2020-38', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (321, '14/09/2020', '2020-37', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (322, '07/09/2020', '2020-36', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (323, '31/08/2020', '2020-35', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (324, '24/08/2020', '2020-34', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '2.06');
INSERT INTO public.europe_data_import VALUES (325, '17/08/2020', '2020-33', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '2.06');
INSERT INTO public.europe_data_import VALUES (326, '10/08/2020', '2020-32', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '10.3');
INSERT INTO public.europe_data_import VALUES (327, '03/08/2020', '2020-31', '9', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '15.45');
INSERT INTO public.europe_data_import VALUES (328, '27/07/2020', '2020-30', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (329, '20/07/2020', '2020-29', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (330, '13/07/2020', '2020-28', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '9.27');
INSERT INTO public.europe_data_import VALUES (331, '06/07/2020', '2020-27', '3', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '43.25');
INSERT INTO public.europe_data_import VALUES (332, '29/06/2020', '2020-26', '39', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '40.16');
INSERT INTO public.europe_data_import VALUES (333, '22/06/2020', '2020-25', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (412, '05/10/2020', '2020-40', '3096', '26', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '171.25');
INSERT INTO public.europe_data_import VALUES (334, '15/06/2020', '2020-24', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (335, '08/06/2020', '2020-23', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (336, '01/06/2020', '2020-22', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (337, '25/05/2020', '2020-21', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (338, '18/05/2020', '2020-20', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (339, '11/05/2020', '2020-19', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (340, '04/05/2020', '2020-18', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '2.06');
INSERT INTO public.europe_data_import VALUES (341, '27/04/2020', '2020-17', '1', '1', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '3.09');
INSERT INTO public.europe_data_import VALUES (342, '20/04/2020', '2020-16', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (343, '13/04/2020', '2020-15', '6', '2', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '14.42');
INSERT INTO public.europe_data_import VALUES (344, '06/04/2020', '2020-14', '8', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '14.42');
INSERT INTO public.europe_data_import VALUES (345, '30/03/2020', '2020-13', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (346, '23/03/2020', '2020-12', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '');
INSERT INTO public.europe_data_import VALUES (347, '01/02/2021', '2021-04', '59056', '1215', '44780675', 'Argentina', 'AR', 'ARG', 'America', '282.36');
INSERT INTO public.europe_data_import VALUES (348, '25/01/2021', '2021-03', '67388', '1202', '44780675', 'Argentina', 'AR', 'ARG', 'America', '321.29');
INSERT INTO public.europe_data_import VALUES (349, '18/01/2021', '2021-02', '76488', '1178', '44780675', 'Argentina', 'AR', 'ARG', 'America', '372.24');
INSERT INTO public.europe_data_import VALUES (350, '11/01/2021', '2021-01', '90203', '1172', '44780675', 'Argentina', 'AR', 'ARG', 'America', '313.58');
INSERT INTO public.europe_data_import VALUES (351, '04/01/2021', '2020-53', '50220', '614', '44780675', 'Argentina', 'AR', 'ARG', 'America', '209.0');
INSERT INTO public.europe_data_import VALUES (352, '28/12/2020', '2020-52', '43370', '871', '44780675', 'Argentina', 'AR', 'ARG', 'America', '206.17');
INSERT INTO public.europe_data_import VALUES (353, '21/12/2020', '2020-51', '48955', '1231', '44780675', 'Argentina', 'AR', 'ARG', 'America', '187.63');
INSERT INTO public.europe_data_import VALUES (354, '14/12/2020', '2020-50', '35067', '996', '44780675', 'Argentina', 'AR', 'ARG', 'America', '177.23');
INSERT INTO public.europe_data_import VALUES (355, '07/12/2020', '2020-49', '44299', '1297', '44780675', 'Argentina', 'AR', 'ARG', 'America', '207.1');
INSERT INTO public.europe_data_import VALUES (356, '30/11/2020', '2020-48', '48444', '1471', '44780675', 'Argentina', 'AR', 'ARG', 'America', '241.89');
INSERT INTO public.europe_data_import VALUES (357, '23/11/2020', '2020-47', '59874', '1566', '44780675', 'Argentina', 'AR', 'ARG', 'America', '286.24');
INSERT INTO public.europe_data_import VALUES (358, '16/11/2020', '2020-46', '68307', '1876', '44780675', 'Argentina', 'AR', 'ARG', 'America', '305.84');
INSERT INTO public.europe_data_import VALUES (359, '09/11/2020', '2020-45', '68649', '2420', '44780675', 'Argentina', 'AR', 'ARG', 'America', '338.52');
INSERT INTO public.europe_data_import VALUES (360, '02/11/2020', '2020-44', '82944', '2244', '44780675', 'Argentina', 'AR', 'ARG', 'America', '410.56');
INSERT INTO public.europe_data_import VALUES (361, '26/10/2020', '2020-43', '100909', '2629', '44780675', 'Argentina', 'AR', 'ARG', 'America', '438.54');
INSERT INTO public.europe_data_import VALUES (362, '19/10/2020', '2020-42', '95474', '2399', '44780675', 'Argentina', 'AR', 'ARG', 'America', '426.96');
INSERT INTO public.europe_data_import VALUES (363, '12/10/2020', '2020-41', '95720', '2850', '44780675', 'Argentina', 'AR', 'ARG', 'America', '408.39');
INSERT INTO public.europe_data_import VALUES (364, '05/10/2020', '2020-40', '87161', '5269', '44780675', 'Argentina', 'AR', 'ARG', 'America', '392.03');
INSERT INTO public.europe_data_import VALUES (365, '28/09/2020', '2020-39', '88391', '2840', '44780675', 'Argentina', 'AR', 'ARG', 'America', '368.11');
INSERT INTO public.europe_data_import VALUES (366, '21/09/2020', '2020-38', '76453', '1602', '44780675', 'Argentina', 'AR', 'ARG', 'America', '337.48');
INSERT INTO public.europe_data_import VALUES (367, '14/09/2020', '2020-37', '74675', '1500', '44780675', 'Argentina', 'AR', 'ARG', 'America', '324.34');
INSERT INTO public.europe_data_import VALUES (368, '07/09/2020', '2020-36', '70567', '1406', '44780675', 'Argentina', 'AR', 'ARG', 'America', '301.48');
INSERT INTO public.europe_data_import VALUES (369, '31/08/2020', '2020-35', '64437', '1553', '44780675', 'Argentina', 'AR', 'ARG', 'America', '250.42');
INSERT INTO public.europe_data_import VALUES (370, '24/08/2020', '2020-34', '47702', '1191', '44780675', 'Argentina', 'AR', 'ARG', 'America', '212.12');
INSERT INTO public.europe_data_import VALUES (371, '17/08/2020', '2020-33', '47289', '1101', '44780675', 'Argentina', 'AR', 'ARG', 'America', '206.69');
INSERT INTO public.europe_data_import VALUES (372, '10/08/2020', '2020-32', '45268', '944', '44780675', 'Argentina', 'AR', 'ARG', 'America', '177.05');
INSERT INTO public.europe_data_import VALUES (373, '03/08/2020', '2020-31', '34017', '673', '44780675', 'Argentina', 'AR', 'ARG', 'America', '165.29');
INSERT INTO public.europe_data_import VALUES (374, '27/07/2020', '2020-30', '40002', '693', '44780675', 'Argentina', 'AR', 'ARG', 'America', '145.19');
INSERT INTO public.europe_data_import VALUES (375, '20/07/2020', '2020-29', '25015', '428', '44780675', 'Argentina', 'AR', 'ARG', 'America', '105.29');
INSERT INTO public.europe_data_import VALUES (376, '13/07/2020', '2020-28', '22133', '328', '44780675', 'Argentina', 'AR', 'ARG', 'America', '88.8');
INSERT INTO public.europe_data_import VALUES (377, '06/07/2020', '2020-27', '17632', '273', '44780675', 'Argentina', 'AR', 'ARG', 'America', '72.78');
INSERT INTO public.europe_data_import VALUES (378, '29/06/2020', '2020-26', '14959', '206', '44780675', 'Argentina', 'AR', 'ARG', 'America', '58.43');
INSERT INTO public.europe_data_import VALUES (379, '22/06/2020', '2020-25', '11208', '178', '44780675', 'Argentina', 'AR', 'ARG', 'America', '44.64');
INSERT INTO public.europe_data_import VALUES (380, '15/06/2020', '2020-24', '8783', '169', '44780675', 'Argentina', 'AR', 'ARG', 'America', '32.88');
INSERT INTO public.europe_data_import VALUES (381, '08/06/2020', '2020-23', '5943', '125', '44780675', 'Argentina', 'AR', 'ARG', 'America', '23.93');
INSERT INTO public.europe_data_import VALUES (382, '01/06/2020', '2020-22', '4775', '87', '44780675', 'Argentina', 'AR', 'ARG', 'America', '20.2');
INSERT INTO public.europe_data_import VALUES (383, '25/05/2020', '2020-21', '4271', '86', '44780675', 'Argentina', 'AR', 'ARG', 'America', '14.04');
INSERT INTO public.europe_data_import VALUES (384, '18/05/2020', '2020-20', '2016', '66', '44780675', 'Argentina', 'AR', 'ARG', 'America', '6.75');
INSERT INTO public.europe_data_import VALUES (385, '11/05/2020', '2020-19', '1006', '54', '44780675', 'Argentina', 'AR', 'ARG', 'America', '4.49');
INSERT INTO public.europe_data_import VALUES (386, '04/05/2020', '2020-18', '1003', '60', '44780675', 'Argentina', 'AR', 'ARG', 'America', '4.11');
INSERT INTO public.europe_data_import VALUES (387, '27/04/2020', '2020-17', '837', '52', '44780675', 'Argentina', 'AR', 'ARG', 'America', '3.49');
INSERT INTO public.europe_data_import VALUES (388, '20/04/2020', '2020-16', '727', '39', '44780675', 'Argentina', 'AR', 'ARG', 'America', '3.07');
INSERT INTO public.europe_data_import VALUES (389, '13/04/2020', '2020-15', '649', '49', '44780675', 'Argentina', 'AR', 'ARG', 'America', '3.09');
INSERT INTO public.europe_data_import VALUES (390, '06/04/2020', '2020-14', '734', '26', '44780675', 'Argentina', 'AR', 'ARG', 'America', '2.88');
INSERT INTO public.europe_data_import VALUES (391, '30/03/2020', '2020-13', '554', '16', '44780675', 'Argentina', 'AR', 'ARG', 'America', '1.71');
INSERT INTO public.europe_data_import VALUES (392, '23/03/2020', '2020-12', '210', '2', '44780675', 'Argentina', 'AR', 'ARG', 'America', '0.57');
INSERT INTO public.europe_data_import VALUES (393, '16/03/2020', '2020-11', '44', '1', '44780675', 'Argentina', 'AR', 'ARG', 'America', '0.13');
INSERT INTO public.europe_data_import VALUES (394, '09/03/2020', '2020-10', '12', '1', '44780675', 'Argentina', 'AR', 'ARG', 'America', '');
INSERT INTO public.europe_data_import VALUES (395, '01/02/2021', '2021-04', '994', '37', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '81.55');
INSERT INTO public.europe_data_import VALUES (396, '25/01/2021', '2021-03', '1418', '49', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '128.68');
INSERT INTO public.europe_data_import VALUES (397, '18/01/2021', '2021-02', '2388', '67', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '150.66');
INSERT INTO public.europe_data_import VALUES (398, '11/01/2021', '2021-01', '2068', '67', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '146.73');
INSERT INTO public.europe_data_import VALUES (399, '04/01/2021', '2020-53', '2272', '89', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '208.1');
INSERT INTO public.europe_data_import VALUES (400, '28/12/2020', '2020-52', '3883', '119', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '313.28');
INSERT INTO public.europe_data_import VALUES (401, '21/12/2020', '2020-51', '5383', '153', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '396.28');
INSERT INTO public.europe_data_import VALUES (402, '14/12/2020', '2020-50', '6338', '159', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '458.39');
INSERT INTO public.europe_data_import VALUES (403, '07/12/2020', '2020-49', '7220', '180', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '528.62');
INSERT INTO public.europe_data_import VALUES (404, '30/11/2020', '2020-48', '8415', '188', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '582.81');
INSERT INTO public.europe_data_import VALUES (405, '23/11/2020', '2020-47', '8823', '188', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '650.6');
INSERT INTO public.europe_data_import VALUES (406, '16/11/2020', '2020-46', '10420', '208', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '826.24');
INSERT INTO public.europe_data_import VALUES (407, '09/11/2020', '2020-45', '14018', '189', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '968.85');
INSERT INTO public.europe_data_import VALUES (408, '02/11/2020', '2020-44', '14638', '195', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '972.17');
INSERT INTO public.europe_data_import VALUES (409, '26/10/2020', '2020-43', '14116', '115', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '755.95');
INSERT INTO public.europe_data_import VALUES (410, '19/10/2020', '2020-42', '8243', '61', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '412.41');
INSERT INTO public.europe_data_import VALUES (411, '12/10/2020', '2020-41', '3955', '43', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '238.39');
INSERT INTO public.europe_data_import VALUES (413, '28/09/2020', '2020-39', '1969', '21', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '119.62');
INSERT INTO public.europe_data_import VALUES (414, '21/09/2020', '2020-38', '1569', '14', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '89.53');
INSERT INTO public.europe_data_import VALUES (415, '14/09/2020', '2020-37', '1079', '19', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '71.41');
INSERT INTO public.europe_data_import VALUES (416, '07/09/2020', '2020-36', '1033', '20', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '67.32');
INSERT INTO public.europe_data_import VALUES (417, '31/08/2020', '2020-35', '958', '25', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '70.56');
INSERT INTO public.europe_data_import VALUES (418, '24/08/2020', '2020-34', '1129', '34', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '80.53');
INSERT INTO public.europe_data_import VALUES (419, '17/08/2020', '2020-33', '1253', '27', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '86.59');
INSERT INTO public.europe_data_import VALUES (420, '10/08/2020', '2020-32', '1308', '29', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '102.11');
INSERT INTO public.europe_data_import VALUES (421, '03/08/2020', '2020-31', '1712', '51', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '139.33');
INSERT INTO public.europe_data_import VALUES (422, '27/07/2020', '2020-30', '2409', '61', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '177.13');
INSERT INTO public.europe_data_import VALUES (423, '20/07/2020', '2020-29', '2830', '77', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '204.38');
INSERT INTO public.europe_data_import VALUES (424, '13/07/2020', '2020-28', '3215', '82', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '237.48');
INSERT INTO public.europe_data_import VALUES (425, '06/07/2020', '2020-27', '3809', '58', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '282.24');
INSERT INTO public.europe_data_import VALUES (426, '29/06/2020', '2020-26', '4539', '73', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '272.61');
INSERT INTO public.europe_data_import VALUES (427, '22/06/2020', '2020-25', '3524', '75', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '245.56');
INSERT INTO public.europe_data_import VALUES (428, '15/06/2020', '2020-24', '3739', '74', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '256.01');
INSERT INTO public.europe_data_import VALUES (429, '08/06/2020', '2020-23', '3833', '72', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '210.03');
INSERT INTO public.europe_data_import VALUES (430, '01/06/2020', '2020-22', '2379', '52', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '157.86');
INSERT INTO public.europe_data_import VALUES (431, '25/05/2020', '2020-21', '2290', '26', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '125.81');
INSERT INTO public.europe_data_import VALUES (432, '18/05/2020', '2020-20', '1431', '15', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '78.3');
INSERT INTO public.europe_data_import VALUES (433, '11/05/2020', '2020-19', '885', '7', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '53.55');
INSERT INTO public.europe_data_import VALUES (434, '04/05/2020', '2020-18', '699', '10', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '39.49');
INSERT INTO public.europe_data_import VALUES (435, '27/04/2020', '2020-17', '469', '7', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '26.0');
INSERT INTO public.europe_data_import VALUES (436, '20/04/2020', '2020-16', '300', '8', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '17.11');
INSERT INTO public.europe_data_import VALUES (437, '13/04/2020', '2020-15', '206', '6', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '18.83');
INSERT INTO public.europe_data_import VALUES (438, '06/04/2020', '2020-14', '351', '5', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '21.6');
INSERT INTO public.europe_data_import VALUES (439, '30/03/2020', '2020-13', '288', '3', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '15.35');
INSERT INTO public.europe_data_import VALUES (440, '23/03/2020', '2020-12', '166', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '6.53');
INSERT INTO public.europe_data_import VALUES (441, '16/03/2020', '2020-11', '27', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0.91');
INSERT INTO public.europe_data_import VALUES (442, '09/03/2020', '2020-10', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (443, '02/03/2020', '2020-09', '1', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (444, '24/02/2020', '2020-08', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (445, '17/02/2020', '2020-07', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (446, '10/02/2020', '2020-06', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (447, '03/02/2020', '2020-05', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (448, '27/01/2020', '2020-04', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (449, '20/01/2020', '2020-03', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (450, '13/01/2020', '2020-02', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (451, '06/01/2020', '2020-01', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (452, '01/02/2021', '2021-04', '244', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '518.3');
INSERT INTO public.europe_data_import VALUES (453, '25/01/2021', '2021-03', '307', '5', '106310', 'Aruba', 'AW', 'ABW', 'America', '633.99');
INSERT INTO public.europe_data_import VALUES (454, '18/01/2021', '2021-02', '367', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '819.3');
INSERT INTO public.europe_data_import VALUES (455, '11/01/2021', '2021-01', '504', '3', '106310', 'Aruba', 'AW', 'ABW', 'America', '700.78');
INSERT INTO public.europe_data_import VALUES (456, '04/01/2021', '2020-53', '241', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '364.97');
INSERT INTO public.europe_data_import VALUES (457, '28/12/2020', '2020-52', '147', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '257.74');
INSERT INTO public.europe_data_import VALUES (458, '21/12/2020', '2020-51', '127', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '198.48');
INSERT INTO public.europe_data_import VALUES (459, '14/12/2020', '2020-50', '84', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '198.48');
INSERT INTO public.europe_data_import VALUES (460, '07/12/2020', '2020-49', '127', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '220.11');
INSERT INTO public.europe_data_import VALUES (461, '30/11/2020', '2020-48', '107', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '165.55');
INSERT INTO public.europe_data_import VALUES (462, '23/11/2020', '2020-47', '69', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '123.22');
INSERT INTO public.europe_data_import VALUES (463, '16/11/2020', '2020-46', '62', '4', '106310', 'Aruba', 'AW', 'ABW', 'America', '134.51');
INSERT INTO public.europe_data_import VALUES (464, '09/11/2020', '2020-45', '81', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '169.32');
INSERT INTO public.europe_data_import VALUES (465, '02/11/2020', '2020-44', '99', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '185.31');
INSERT INTO public.europe_data_import VALUES (466, '26/10/2020', '2020-43', '98', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '212.59');
INSERT INTO public.europe_data_import VALUES (467, '19/10/2020', '2020-42', '128', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '228.58');
INSERT INTO public.europe_data_import VALUES (468, '12/10/2020', '2020-41', '115', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '329.23');
INSERT INTO public.europe_data_import VALUES (469, '05/10/2020', '2020-40', '235', '5', '106310', 'Aruba', 'AW', 'ABW', 'America', '496.66');
INSERT INTO public.europe_data_import VALUES (470, '28/09/2020', '2020-39', '293', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '750.63');
INSERT INTO public.europe_data_import VALUES (471, '21/09/2020', '2020-38', '505', '5', '106310', 'Aruba', 'AW', 'ABW', 'America', '1036.59');
INSERT INTO public.europe_data_import VALUES (472, '14/09/2020', '2020-37', '597', '4', '106310', 'Aruba', 'AW', 'ABW', 'America', '986.74');
INSERT INTO public.europe_data_import VALUES (473, '07/09/2020', '2020-36', '452', '4', '106310', 'Aruba', 'AW', 'ABW', 'America', '828.71');
INSERT INTO public.europe_data_import VALUES (474, '31/08/2020', '2020-35', '429', '3', '106310', 'Aruba', 'AW', 'ABW', 'America', '841.88');
INSERT INTO public.europe_data_import VALUES (475, '24/08/2020', '2020-34', '466', '3', '106310', 'Aruba', 'AW', 'ABW', 'America', '945.35');
INSERT INTO public.europe_data_import VALUES (476, '17/08/2020', '2020-33', '539', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '921.83');
INSERT INTO public.europe_data_import VALUES (477, '10/08/2020', '2020-32', '441', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '417.65');
INSERT INTO public.europe_data_import VALUES (478, '03/08/2020', '2020-31', '3', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '8.47');
INSERT INTO public.europe_data_import VALUES (479, '27/07/2020', '2020-30', '6', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '13.17');
INSERT INTO public.europe_data_import VALUES (480, '20/07/2020', '2020-29', '8', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '7.53');
INSERT INTO public.europe_data_import VALUES (481, '13/07/2020', '2020-28', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '3.76');
INSERT INTO public.europe_data_import VALUES (482, '06/07/2020', '2020-27', '4', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '3.76');
INSERT INTO public.europe_data_import VALUES (483, '29/06/2020', '2020-26', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (484, '22/06/2020', '2020-25', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (485, '15/06/2020', '2020-24', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (486, '08/06/2020', '2020-23', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (487, '01/06/2020', '2020-22', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (488, '25/05/2020', '2020-21', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (489, '18/05/2020', '2020-20', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0.94');
INSERT INTO public.europe_data_import VALUES (490, '11/05/2020', '2020-19', '1', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '0.94');
INSERT INTO public.europe_data_import VALUES (491, '04/05/2020', '2020-18', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '2.82');
INSERT INTO public.europe_data_import VALUES (492, '27/04/2020', '2020-17', '3', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '7.53');
INSERT INTO public.europe_data_import VALUES (493, '20/04/2020', '2020-16', '5', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '31.04');
INSERT INTO public.europe_data_import VALUES (494, '13/04/2020', '2020-15', '28', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '39.51');
INSERT INTO public.europe_data_import VALUES (495, '06/04/2020', '2020-14', '14', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '60.2');
INSERT INTO public.europe_data_import VALUES (496, '30/03/2020', '2020-13', '50', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '');
INSERT INTO public.europe_data_import VALUES (497, '01/02/2021', '2021-04', '52', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.44');
INSERT INTO public.europe_data_import VALUES (498, '25/01/2021', '2021-03', '58', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (499, '18/01/2021', '2021-02', '94', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.81');
INSERT INTO public.europe_data_import VALUES (500, '11/01/2021', '2021-01', '110', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.2');
INSERT INTO public.europe_data_import VALUES (501, '04/01/2021', '2020-53', '192', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.21');
INSERT INTO public.europe_data_import VALUES (502, '28/12/2020', '2020-52', '114', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.11');
INSERT INTO public.europe_data_import VALUES (503, '21/12/2020', '2020-51', '167', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.92');
INSERT INTO public.europe_data_import VALUES (504, '14/12/2020', '2020-50', '66', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.55');
INSERT INTO public.europe_data_import VALUES (505, '07/12/2020', '2020-49', '72', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.57');
INSERT INTO public.europe_data_import VALUES (506, '30/11/2020', '2020-48', '72', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (507, '23/11/2020', '2020-47', '96', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.65');
INSERT INTO public.europe_data_import VALUES (508, '16/11/2020', '2020-46', '67', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.52');
INSERT INTO public.europe_data_import VALUES (509, '09/11/2020', '2020-45', '63', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.55');
INSERT INTO public.europe_data_import VALUES (510, '02/11/2020', '2020-44', '75', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.81');
INSERT INTO public.europe_data_import VALUES (511, '26/10/2020', '2020-43', '130', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.02');
INSERT INTO public.europe_data_import VALUES (512, '19/10/2020', '2020-42', '126', '6', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.01');
INSERT INTO public.europe_data_import VALUES (513, '12/10/2020', '2020-41', '128', '4', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.89');
INSERT INTO public.europe_data_import VALUES (514, '05/10/2020', '2020-40', '96', '22', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.94');
INSERT INTO public.europe_data_import VALUES (515, '28/09/2020', '2020-39', '142', '23', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.54');
INSERT INTO public.europe_data_import VALUES (516, '21/09/2020', '2020-38', '247', '39', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '2.46');
INSERT INTO public.europe_data_import VALUES (517, '14/09/2020', '2020-37', '372', '57', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '3.89');
INSERT INTO public.europe_data_import VALUES (518, '07/09/2020', '2020-36', '609', '142', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '5.82');
INSERT INTO public.europe_data_import VALUES (519, '31/08/2020', '2020-35', '858', '109', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '9.45');
INSERT INTO public.europe_data_import VALUES (520, '24/08/2020', '2020-34', '1524', '106', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '14.79');
INSERT INTO public.europe_data_import VALUES (521, '17/08/2020', '2020-33', '2204', '101', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '21.29');
INSERT INTO public.europe_data_import VALUES (522, '10/08/2020', '2020-32', '3161', '87', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '26.51');
INSERT INTO public.europe_data_import VALUES (523, '03/08/2020', '2020-31', '3520', '53', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '24.29');
INSERT INTO public.europe_data_import VALUES (524, '27/07/2020', '2020-30', '2601', '33', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '18.28');
INSERT INTO public.europe_data_import VALUES (525, '20/07/2020', '2020-29', '2005', '14', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '13.3');
INSERT INTO public.europe_data_import VALUES (526, '13/07/2020', '2020-28', '1348', '4', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '8.38');
INSERT INTO public.europe_data_import VALUES (527, '06/07/2020', '2020-27', '763', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '3.92');
INSERT INTO public.europe_data_import VALUES (528, '29/06/2020', '2020-26', '225', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.45');
INSERT INTO public.europe_data_import VALUES (529, '22/06/2020', '2020-25', '141', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.8');
INSERT INTO public.europe_data_import VALUES (530, '15/06/2020', '2020-24', '60', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.5');
INSERT INTO public.europe_data_import VALUES (531, '08/06/2020', '2020-23', '65', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (532, '01/06/2020', '2020-22', '86', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (533, '25/05/2020', '2020-21', '64', '4', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (534, '18/05/2020', '2020-20', '104', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.97');
INSERT INTO public.europe_data_import VALUES (535, '11/05/2020', '2020-19', '140', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.9');
INSERT INTO public.europe_data_import VALUES (536, '04/05/2020', '2020-18', '88', '12', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.75');
INSERT INTO public.europe_data_import VALUES (537, '27/04/2020', '2020-17', '101', '13', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.55');
INSERT INTO public.europe_data_import VALUES (538, '20/04/2020', '2020-16', '290', '9', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '3.44');
INSERT INTO public.europe_data_import VALUES (539, '13/04/2020', '2020-15', '578', '25', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '8.84');
INSERT INTO public.europe_data_import VALUES (540, '06/04/2020', '2020-14', '1651', '20', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '16.01');
INSERT INTO public.europe_data_import VALUES (541, '30/03/2020', '2020-13', '2384', '9', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '15.06');
INSERT INTO public.europe_data_import VALUES (542, '23/03/2020', '2020-12', '1411', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '6.46');
INSERT INTO public.europe_data_import VALUES (543, '16/03/2020', '2020-11', '218', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.07');
INSERT INTO public.europe_data_import VALUES (544, '09/03/2020', '2020-10', '51', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.23');
INSERT INTO public.europe_data_import VALUES (545, '02/03/2020', '2020-09', '7', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.06');
INSERT INTO public.europe_data_import VALUES (546, '24/02/2020', '2020-08', '7', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.03');
INSERT INTO public.europe_data_import VALUES (547, '17/02/2020', '2020-07', '1', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (548, '10/02/2020', '2020-06', '3', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.04');
INSERT INTO public.europe_data_import VALUES (549, '03/02/2020', '2020-05', '7', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.04');
INSERT INTO public.europe_data_import VALUES (550, '27/01/2020', '2020-04', '4', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (551, '20/01/2020', '2020-03', '0', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (552, '13/01/2020', '2020-02', '0', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (553, '06/01/2020', '2020-01', '0', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (554, '01/02/2021', '2021-04', '9451', '291', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '224.32');
INSERT INTO public.europe_data_import VALUES (555, '25/01/2021', '2021-03', '10421', '348', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '246.39');
INSERT INTO public.europe_data_import VALUES (556, '18/01/2021', '2021-02', '11406', '383', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '299.58');
INSERT INTO public.europe_data_import VALUES (557, '11/01/2021', '2021-01', '15133', '378', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '319.69');
INSERT INTO public.europe_data_import VALUES (558, '04/01/2021', '2020-53', '13188', '381', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '320.04');
INSERT INTO public.europe_data_import VALUES (559, '28/12/2020', '2020-52', '15164', '656', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '353.89');
INSERT INTO public.europe_data_import VALUES (560, '21/12/2020', '2020-51', '16186', '816', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '397.87');
INSERT INTO public.europe_data_import VALUES (561, '14/12/2020', '2020-50', '19060', '668', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '472.46');
INSERT INTO public.europe_data_import VALUES (562, '07/12/2020', '2020-49', '22794', '828', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '619.18');
INSERT INTO public.europe_data_import VALUES (563, '30/11/2020', '2020-48', '32058', '705', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '843.1');
INSERT INTO public.europe_data_import VALUES (564, '23/11/2020', '2020-47', '42630', '520', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '1056.76');
INSERT INTO public.europe_data_import VALUES (565, '16/11/2020', '2020-46', '50986', '344', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '1042.85');
INSERT INTO public.europe_data_import VALUES (566, '09/11/2020', '2020-45', '41398', '221', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '789.86');
INSERT INTO public.europe_data_import VALUES (567, '02/11/2020', '2020-44', '28574', '130', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '514.21');
INSERT INTO public.europe_data_import VALUES (568, '26/10/2020', '2020-43', '16979', '74', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '299.74');
INSERT INTO public.europe_data_import VALUES (569, '19/10/2020', '2020-42', '9574', '46', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '191.21');
INSERT INTO public.europe_data_import VALUES (570, '12/10/2020', '2020-41', '7365', '51', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '141.29');
INSERT INTO public.europe_data_import VALUES (571, '05/10/2020', '2020-40', '5152', '26', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '113.57');
INSERT INTO public.europe_data_import VALUES (572, '28/09/2020', '2020-39', '4909', '21', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '114.36');
INSERT INTO public.europe_data_import VALUES (573, '21/09/2020', '2020-38', '5222', '10', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '105.69');
INSERT INTO public.europe_data_import VALUES (574, '14/09/2020', '2020-37', '4141', '20', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '69.05');
INSERT INTO public.europe_data_import VALUES (575, '07/09/2020', '2020-36', '1976', '3', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '44.64');
INSERT INTO public.europe_data_import VALUES (576, '31/08/2020', '2020-35', '1979', '1', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '43.4');
INSERT INTO public.europe_data_import VALUES (577, '24/08/2020', '2020-34', '1866', '4', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '36.44');
INSERT INTO public.europe_data_import VALUES (578, '17/08/2020', '2020-33', '1362', '7', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '23.3');
INSERT INTO public.europe_data_import VALUES (579, '10/08/2020', '2020-32', '702', '3', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '17.21');
INSERT INTO public.europe_data_import VALUES (580, '03/08/2020', '2020-31', '823', '6', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '19.62');
INSERT INTO public.europe_data_import VALUES (581, '27/07/2020', '2020-30', '915', '2', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '18.5');
INSERT INTO public.europe_data_import VALUES (582, '20/07/2020', '2020-29', '724', '2', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '14.7');
INSERT INTO public.europe_data_import VALUES (583, '13/07/2020', '2020-28', '578', '2', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '13.79');
INSERT INTO public.europe_data_import VALUES (584, '06/07/2020', '2020-27', '644', '4', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '11.11');
INSERT INTO public.europe_data_import VALUES (585, '29/06/2020', '2020-26', '340', '12', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '6.63');
INSERT INTO public.europe_data_import VALUES (586, '22/06/2020', '2020-25', '247', '13', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '4.71');
INSERT INTO public.europe_data_import VALUES (587, '15/06/2020', '2020-24', '170', '5', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '4.47');
INSERT INTO public.europe_data_import VALUES (588, '08/06/2020', '2020-23', '226', '4', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '4.84');
INSERT INTO public.europe_data_import VALUES (589, '01/06/2020', '2020-22', '203', '28', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '5.51');
INSERT INTO public.europe_data_import VALUES (590, '25/05/2020', '2020-21', '285', '11', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '7.36');
INSERT INTO public.europe_data_import VALUES (591, '18/05/2020', '2020-20', '367', '11', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '6.95');
INSERT INTO public.europe_data_import VALUES (592, '11/05/2020', '2020-19', '249', '20', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '6.75');
INSERT INTO public.europe_data_import VALUES (593, '04/05/2020', '2020-18', '349', '56', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '9.35');
INSERT INTO public.europe_data_import VALUES (594, '27/04/2020', '2020-17', '479', '90', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '14.13');
INSERT INTO public.europe_data_import VALUES (595, '20/04/2020', '2020-16', '773', '102', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '30.78');
INSERT INTO public.europe_data_import VALUES (596, '13/04/2020', '2020-15', '1954', '146', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '57.84');
INSERT INTO public.europe_data_import VALUES (597, '06/04/2020', '2020-14', '3170', '118', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '94.28');
INSERT INTO public.europe_data_import VALUES (598, '30/03/2020', '2020-13', '5182', '70', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '89.78');
INSERT INTO public.europe_data_import VALUES (599, '23/03/2020', '2020-12', '2771', '15', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '39.84');
INSERT INTO public.europe_data_import VALUES (600, '16/03/2020', '2020-11', '758', '1', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '9.55');
INSERT INTO public.europe_data_import VALUES (601, '09/03/2020', '2020-10', '88', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '1.15');
INSERT INTO public.europe_data_import VALUES (602, '02/03/2020', '2020-09', '14', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (603, '24/02/2020', '2020-08', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (604, '17/02/2020', '2020-07', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (605, '10/02/2020', '2020-06', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (606, '03/02/2020', '2020-05', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (607, '27/01/2020', '2020-04', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (608, '20/01/2020', '2020-03', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (609, '13/01/2020', '2020-02', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (610, '06/01/2020', '2020-01', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (611, '01/02/2021', '2021-04', '1187', '39', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '28.15');
INSERT INTO public.europe_data_import VALUES (612, '25/01/2021', '2021-03', '1641', '71', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '41.85');
INSERT INTO public.europe_data_import VALUES (613, '18/01/2021', '2021-02', '2564', '96', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '70.92');
INSERT INTO public.europe_data_import VALUES (614, '11/01/2021', '2021-01', '4562', '193', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '93.0');
INSERT INTO public.europe_data_import VALUES (615, '04/01/2021', '2020-53', '4782', '195', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '180.91');
INSERT INTO public.europe_data_import VALUES (616, '28/12/2020', '2020-52', '13395', '328', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '394.21');
INSERT INTO public.europe_data_import VALUES (617, '21/12/2020', '2020-51', '26214', '288', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '551.46');
INSERT INTO public.europe_data_import VALUES (618, '14/12/2020', '2020-50', '29195', '290', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '574.05');
INSERT INTO public.europe_data_import VALUES (619, '07/12/2020', '2020-49', '28484', '271', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '533.31');
INSERT INTO public.europe_data_import VALUES (620, '30/11/2020', '2020-48', '25101', '230', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '423.05');
INSERT INTO public.europe_data_import VALUES (621, '23/11/2020', '2020-47', '17406', '164', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '275.52');
INSERT INTO public.europe_data_import VALUES (622, '16/11/2020', '2020-46', '10277', '127', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '191.53');
INSERT INTO public.europe_data_import VALUES (623, '09/11/2020', '2020-45', '8967', '100', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '153.79');
INSERT INTO public.europe_data_import VALUES (624, '02/11/2020', '2020-44', '6485', '69', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '114.25');
INSERT INTO public.europe_data_import VALUES (625, '26/10/2020', '2020-43', '4995', '45', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '79.39');
INSERT INTO public.europe_data_import VALUES (626, '19/10/2020', '2020-42', '2982', '17', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '42.53');
INSERT INTO public.europe_data_import VALUES (627, '12/10/2020', '2020-41', '1291', '13', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '19.5');
INSERT INTO public.europe_data_import VALUES (628, '05/10/2020', '2020-40', '668', '10', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '14.96');
INSERT INTO public.europe_data_import VALUES (629, '28/09/2020', '2020-39', '835', '11', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '16.88');
INSERT INTO public.europe_data_import VALUES (630, '21/09/2020', '2020-38', '861', '13', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '18.5');
INSERT INTO public.europe_data_import VALUES (631, '14/09/2020', '2020-37', '998', '14', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '20.08');
INSERT INTO public.europe_data_import VALUES (632, '07/09/2020', '2020-36', '1020', '17', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '20.45');
INSERT INTO public.europe_data_import VALUES (633, '31/08/2020', '2020-35', '1035', '13', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '20.8');
INSERT INTO public.europe_data_import VALUES (634, '24/08/2020', '2020-34', '1055', '12', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '16.98');
INSERT INTO public.europe_data_import VALUES (635, '17/08/2020', '2020-33', '651', '16', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '17.68');
INSERT INTO public.europe_data_import VALUES (636, '10/08/2020', '2020-32', '1125', '28', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '35.01');
INSERT INTO public.europe_data_import VALUES (637, '03/08/2020', '2020-31', '2393', '45', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '48.99');
INSERT INTO public.europe_data_import VALUES (638, '27/07/2020', '2020-30', '2529', '63', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '59.8');
INSERT INTO public.europe_data_import VALUES (639, '20/07/2020', '2020-29', '3480', '48', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '71.63');
INSERT INTO public.europe_data_import VALUES (640, '13/07/2020', '2020-28', '3717', '56', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '75.81');
INSERT INTO public.europe_data_import VALUES (641, '06/07/2020', '2020-27', '3900', '52', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '75.59');
INSERT INTO public.europe_data_import VALUES (642, '29/06/2020', '2020-26', '3695', '44', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '64.36');
INSERT INTO public.europe_data_import VALUES (643, '22/06/2020', '2020-25', '2772', '35', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '51.51');
INSERT INTO public.europe_data_import VALUES (644, '15/06/2020', '2020-24', '2404', '31', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '44.42');
INSERT INTO public.europe_data_import VALUES (645, '08/06/2020', '2020-23', '2059', '25', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '34.15');
INSERT INTO public.europe_data_import VALUES (646, '01/06/2020', '2020-22', '1372', '14', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '22.09');
INSERT INTO public.europe_data_import VALUES (647, '25/05/2020', '2020-21', '848', '10', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '15.95');
INSERT INTO public.europe_data_import VALUES (648, '18/05/2020', '2020-20', '755', '7', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '13.36');
INSERT INTO public.europe_data_import VALUES (649, '11/05/2020', '2020-19', '587', '7', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '8.7');
INSERT INTO public.europe_data_import VALUES (650, '04/05/2020', '2020-18', '287', '4', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '5.31');
INSERT INTO public.europe_data_import VALUES (651, '27/04/2020', '2020-17', '247', '2', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '5.44');
INSERT INTO public.europe_data_import VALUES (652, '20/04/2020', '2020-16', '300', '8', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '8.1');
INSERT INTO public.europe_data_import VALUES (653, '13/04/2020', '2020-15', '514', '4', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '8.85');
INSERT INTO public.europe_data_import VALUES (654, '06/04/2020', '2020-14', '375', '3', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '5.17');
INSERT INTO public.europe_data_import VALUES (655, '30/03/2020', '2020-13', '144', '3', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '1.89');
INSERT INTO public.europe_data_import VALUES (656, '23/03/2020', '2020-12', '46', '1', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.56');
INSERT INTO public.europe_data_import VALUES (657, '16/03/2020', '2020-11', '10', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (658, '09/03/2020', '2020-10', '6', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.09');
INSERT INTO public.europe_data_import VALUES (659, '02/03/2020', '2020-09', '3', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (660, '24/02/2020', '2020-08', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (661, '17/02/2020', '2020-07', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (662, '10/02/2020', '2020-06', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (663, '03/02/2020', '2020-05', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (664, '27/01/2020', '2020-04', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (665, '20/01/2020', '2020-03', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (666, '13/01/2020', '2020-02', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (667, '06/01/2020', '2020-01', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (668, '01/02/2021', '2021-04', '41', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '27.47');
INSERT INTO public.europe_data_import VALUES (669, '25/01/2021', '2021-03', '66', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '33.12');
INSERT INTO public.europe_data_import VALUES (670, '18/01/2021', '2021-02', '63', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '36.72');
INSERT INTO public.europe_data_import VALUES (671, '11/01/2021', '2021-01', '80', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '43.65');
INSERT INTO public.europe_data_import VALUES (672, '04/01/2021', '2020-53', '90', '5', '389486', 'Bahamas', 'BS', 'BHS', 'America', '40.82');
INSERT INTO public.europe_data_import VALUES (673, '28/12/2020', '2020-52', '69', '6', '389486', 'Bahamas', 'BS', 'BHS', 'America', '41.08');
INSERT INTO public.europe_data_import VALUES (674, '21/12/2020', '2020-51', '91', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '47.76');
INSERT INTO public.europe_data_import VALUES (675, '14/12/2020', '2020-50', '95', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '45.7');
INSERT INTO public.europe_data_import VALUES (676, '07/12/2020', '2020-49', '83', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '42.62');
INSERT INTO public.europe_data_import VALUES (677, '30/11/2020', '2020-48', '83', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '79.59');
INSERT INTO public.europe_data_import VALUES (678, '23/11/2020', '2020-47', '227', '7', '389486', 'Bahamas', 'BS', 'BHS', 'America', '119.64');
INSERT INTO public.europe_data_import VALUES (679, '16/11/2020', '2020-46', '239', '4', '389486', 'Bahamas', 'BS', 'BHS', 'America', '121.19');
INSERT INTO public.europe_data_import VALUES (680, '09/11/2020', '2020-45', '233', '8', '389486', 'Bahamas', 'BS', 'BHS', 'America', '137.87');
INSERT INTO public.europe_data_import VALUES (681, '02/11/2020', '2020-44', '304', '12', '389486', 'Bahamas', 'BS', 'BHS', 'America', '259.57');
INSERT INTO public.europe_data_import VALUES (682, '26/10/2020', '2020-43', '707', '10', '389486', 'Bahamas', 'BS', 'BHS', 'America', '341.99');
INSERT INTO public.europe_data_import VALUES (683, '19/10/2020', '2020-42', '625', '15', '389486', 'Bahamas', 'BS', 'BHS', 'America', '332.23');
INSERT INTO public.europe_data_import VALUES (684, '12/10/2020', '2020-41', '669', '11', '389486', 'Bahamas', 'BS', 'BHS', 'America', '330.69');
INSERT INTO public.europe_data_import VALUES (685, '05/10/2020', '2020-40', '619', '9', '389486', 'Bahamas', 'BS', 'BHS', 'America', '266.76');
INSERT INTO public.europe_data_import VALUES (686, '28/09/2020', '2020-39', '420', '13', '389486', 'Bahamas', 'BS', 'BHS', 'America', '221.32');
INSERT INTO public.europe_data_import VALUES (687, '21/09/2020', '2020-38', '442', '7', '389486', 'Bahamas', 'BS', 'BHS', 'America', '211.56');
INSERT INTO public.europe_data_import VALUES (688, '14/09/2020', '2020-37', '382', '9', '389486', 'Bahamas', 'BS', 'BHS', 'America', '195.39');
INSERT INTO public.europe_data_import VALUES (689, '07/09/2020', '2020-36', '379', '15', '389486', 'Bahamas', 'BS', 'BHS', 'America', '200.52');
INSERT INTO public.europe_data_import VALUES (690, '31/08/2020', '2020-35', '402', '14', '389486', 'Bahamas', 'BS', 'BHS', 'America', '218.75');
INSERT INTO public.europe_data_import VALUES (691, '24/08/2020', '2020-34', '450', '11', '389486', 'Bahamas', 'BS', 'BHS', 'America', '222.6');
INSERT INTO public.europe_data_import VALUES (692, '17/08/2020', '2020-33', '417', '3', '389486', 'Bahamas', 'BS', 'BHS', 'America', '171.25');
INSERT INTO public.europe_data_import VALUES (693, '10/08/2020', '2020-32', '250', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '142.75');
INSERT INTO public.europe_data_import VALUES (694, '03/08/2020', '2020-31', '306', '3', '389486', 'Bahamas', 'BS', 'BHS', 'America', '127.09');
INSERT INTO public.europe_data_import VALUES (695, '27/07/2020', '2020-30', '189', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (696, '20/07/2020', '2020-29', '42', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '12.58');
INSERT INTO public.europe_data_import VALUES (697, '13/07/2020', '2020-28', '7', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '1.8');
INSERT INTO public.europe_data_import VALUES (698, '06/07/2020', '2020-27', '0', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0');
INSERT INTO public.europe_data_import VALUES (699, '29/06/2020', '2020-26', '0', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.26');
INSERT INTO public.europe_data_import VALUES (700, '22/06/2020', '2020-25', '1', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.26');
INSERT INTO public.europe_data_import VALUES (701, '15/06/2020', '2020-24', '0', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.26');
INSERT INTO public.europe_data_import VALUES (702, '08/06/2020', '2020-23', '1', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (703, '01/06/2020', '2020-22', '2', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '1.54');
INSERT INTO public.europe_data_import VALUES (704, '25/05/2020', '2020-21', '4', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (705, '18/05/2020', '2020-20', '4', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '3.34');
INSERT INTO public.europe_data_import VALUES (706, '11/05/2020', '2020-19', '9', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (707, '04/05/2020', '2020-18', '3', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '5.91');
INSERT INTO public.europe_data_import VALUES (708, '27/04/2020', '2020-17', '20', '2', '389486', 'Bahamas', 'BS', 'BHS', 'America', '8.47');
INSERT INTO public.europe_data_import VALUES (709, '20/04/2020', '2020-16', '13', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '7.96');
INSERT INTO public.europe_data_import VALUES (710, '13/04/2020', '2020-15', '18', '3', '389486', 'Bahamas', 'BS', 'BHS', 'America', '8.47');
INSERT INTO public.europe_data_import VALUES (711, '06/04/2020', '2020-14', '15', '5', '389486', 'Bahamas', 'BS', 'BHS', 'America', '6.42');
INSERT INTO public.europe_data_import VALUES (712, '30/03/2020', '2020-13', '10', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '3.34');
INSERT INTO public.europe_data_import VALUES (713, '23/03/2020', '2020-12', '3', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (714, '16/03/2020', '2020-11', '1', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '');
INSERT INTO public.europe_data_import VALUES (715, '01/02/2021', '2021-04', '3601', '8', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '332.08');
INSERT INTO public.europe_data_import VALUES (716, '25/01/2021', '2021-03', '1849', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '237.51');
INSERT INTO public.europe_data_import VALUES (717, '18/01/2021', '2021-02', '2049', '4', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '251.59');
INSERT INTO public.europe_data_import VALUES (718, '11/01/2021', '2021-01', '2080', '4', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '233.07');
INSERT INTO public.europe_data_import VALUES (719, '04/01/2021', '2020-53', '1745', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '194.74');
INSERT INTO public.europe_data_import VALUES (720, '28/12/2020', '2020-52', '1451', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '157.81');
INSERT INTO public.europe_data_import VALUES (721, '21/12/2020', '2020-51', '1139', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '143.31');
INSERT INTO public.europe_data_import VALUES (722, '14/12/2020', '2020-50', '1213', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '143.56');
INSERT INTO public.europe_data_import VALUES (723, '07/12/2020', '2020-49', '1143', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '135.57');
INSERT INTO public.europe_data_import VALUES (724, '30/11/2020', '2020-48', '1082', '3', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '126.98');
INSERT INTO public.europe_data_import VALUES (725, '23/11/2020', '2020-47', '1002', '3', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '137.04');
INSERT INTO public.europe_data_import VALUES (726, '16/11/2020', '2020-46', '1247', '6', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '169.39');
INSERT INTO public.europe_data_import VALUES (727, '09/11/2020', '2020-45', '1533', '8', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '195.04');
INSERT INTO public.europe_data_import VALUES (728, '02/11/2020', '2020-44', '1668', '9', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '245.01');
INSERT INTO public.europe_data_import VALUES (729, '26/10/2020', '2020-43', '2353', '12', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '302.71');
INSERT INTO public.europe_data_import VALUES (730, '19/10/2020', '2020-42', '2615', '27', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '319.29');
INSERT INTO public.europe_data_import VALUES (731, '12/10/2020', '2020-41', '2625', '13', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '396.79');
INSERT INTO public.europe_data_import VALUES (732, '05/10/2020', '2020-40', '3887', '18', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '497.39');
INSERT INTO public.europe_data_import VALUES (733, '28/09/2020', '2020-39', '4276', '21', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '559.91');
INSERT INTO public.europe_data_import VALUES (734, '21/09/2020', '2020-38', '4913', '9', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '592.75');
INSERT INTO public.europe_data_import VALUES (735, '14/09/2020', '2020-37', '4815', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '488.19');
INSERT INTO public.europe_data_import VALUES (736, '07/09/2020', '2020-36', '3197', '9', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '349.33');
INSERT INTO public.europe_data_import VALUES (737, '31/08/2020', '2020-35', '2536', '5', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '313.44');
INSERT INTO public.europe_data_import VALUES (738, '24/08/2020', '2020-34', '2608', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '306.31');
INSERT INTO public.europe_data_import VALUES (739, '17/08/2020', '2020-33', '2419', '8', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '298.2');
INSERT INTO public.europe_data_import VALUES (740, '10/08/2020', '2020-32', '2475', '15', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '297.35');
INSERT INTO public.europe_data_import VALUES (741, '03/08/2020', '2020-31', '2405', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '311.61');
INSERT INTO public.europe_data_import VALUES (742, '27/07/2020', '2020-30', '2709', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '377.17');
INSERT INTO public.europe_data_import VALUES (743, '20/07/2020', '2020-29', '3481', '17', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '429.88');
INSERT INTO public.europe_data_import VALUES (744, '13/07/2020', '2020-28', '3574', '12', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '440.91');
INSERT INTO public.europe_data_import VALUES (745, '06/07/2020', '2020-27', '3662', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '463.27');
INSERT INTO public.europe_data_import VALUES (746, '29/06/2020', '2020-26', '3941', '20', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '436.34');
INSERT INTO public.europe_data_import VALUES (747, '22/06/2020', '2020-25', '3220', '20', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '426.59');
INSERT INTO public.europe_data_import VALUES (748, '15/06/2020', '2020-24', '3781', '17', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '435.42');
INSERT INTO public.europe_data_import VALUES (749, '08/06/2020', '2020-23', '3365', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '342.74');
INSERT INTO public.europe_data_import VALUES (750, '01/06/2020', '2020-22', '2260', '5', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '270.66');
INSERT INTO public.europe_data_import VALUES (751, '25/05/2020', '2020-21', '2182', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '255.73');
INSERT INTO public.europe_data_import VALUES (752, '18/05/2020', '2020-20', '2015', '4', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '217.71');
INSERT INTO public.europe_data_import VALUES (753, '11/05/2020', '2020-19', '1558', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '139.78');
INSERT INTO public.europe_data_import VALUES (754, '04/05/2020', '2020-18', '736', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '92.01');
INSERT INTO public.europe_data_import VALUES (755, '27/04/2020', '2020-17', '774', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '92.07');
INSERT INTO public.europe_data_import VALUES (756, '20/04/2020', '2020-16', '737', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '71.47');
INSERT INTO public.europe_data_import VALUES (757, '13/04/2020', '2020-15', '436', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '38.75');
INSERT INTO public.europe_data_import VALUES (758, '06/04/2020', '2020-14', '200', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '22.3');
INSERT INTO public.europe_data_import VALUES (759, '30/03/2020', '2020-13', '166', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '17.43');
INSERT INTO public.europe_data_import VALUES (760, '23/03/2020', '2020-12', '120', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '15.54');
INSERT INTO public.europe_data_import VALUES (761, '16/03/2020', '2020-11', '135', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '10.18');
INSERT INTO public.europe_data_import VALUES (762, '09/03/2020', '2020-10', '32', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '4.75');
INSERT INTO public.europe_data_import VALUES (763, '02/03/2020', '2020-09', '46', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '2.86');
INSERT INTO public.europe_data_import VALUES (764, '24/02/2020', '2020-08', '1', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (765, '17/02/2020', '2020-07', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (766, '10/02/2020', '2020-06', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (767, '03/02/2020', '2020-05', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (768, '27/01/2020', '2020-04', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (769, '20/01/2020', '2020-03', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (770, '13/01/2020', '2020-02', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (771, '06/01/2020', '2020-01', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (772, '01/02/2021', '2021-04', '3340', '104', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '4.6');
INSERT INTO public.europe_data_import VALUES (773, '25/01/2021', '2021-03', '4167', '117', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '5.73');
INSERT INTO public.europe_data_import VALUES (774, '18/01/2021', '2021-02', '5179', '125', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '7.12');
INSERT INTO public.europe_data_import VALUES (775, '11/01/2021', '2021-01', '6434', '155', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '8.16');
INSERT INTO public.europe_data_import VALUES (776, '04/01/2021', '2020-53', '6871', '174', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '9.39');
INSERT INTO public.europe_data_import VALUES (777, '28/12/2020', '2020-52', '8435', '172', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '11.42');
INSERT INTO public.europe_data_import VALUES (778, '21/12/2020', '2020-51', '10180', '228', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '14.21');
INSERT INTO public.europe_data_import VALUES (779, '14/12/2020', '2020-50', '12988', '214', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '17.25');
INSERT INTO public.europe_data_import VALUES (780, '07/12/2020', '2020-49', '15138', '229', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '18.52');
INSERT INTO public.europe_data_import VALUES (781, '30/11/2020', '2020-48', '15066', '221', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '18.45');
INSERT INTO public.europe_data_import VALUES (782, '23/11/2020', '2020-47', '15008', '194', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '16.62');
INSERT INTO public.europe_data_import VALUES (783, '16/11/2020', '2020-46', '12095', '127', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '14.16');
INSERT INTO public.europe_data_import VALUES (784, '09/11/2020', '2020-45', '10986', '126', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '13.14');
INSERT INTO public.europe_data_import VALUES (785, '02/11/2020', '2020-44', '10437', '138', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.69');
INSERT INTO public.europe_data_import VALUES (786, '26/10/2020', '2020-43', '10246', '143', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.6');
INSERT INTO public.europe_data_import VALUES (787, '19/10/2020', '2020-42', '10303', '136', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.19');
INSERT INTO public.europe_data_import VALUES (788, '12/10/2020', '2020-41', '9576', '176', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '11.73');
INSERT INTO public.europe_data_import VALUES (789, '05/10/2020', '2020-40', '9542', '187', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.13');
INSERT INTO public.europe_data_import VALUES (790, '28/09/2020', '2020-39', '10232', '222', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '13.26');
INSERT INTO public.europe_data_import VALUES (791, '21/09/2020', '2020-38', '11396', '206', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '14.57');
INSERT INTO public.europe_data_import VALUES (792, '14/09/2020', '2020-37', '12363', '284', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '16.37');
INSERT INTO public.europe_data_import VALUES (793, '07/09/2020', '2020-36', '14335', '201', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '18.74');
INSERT INTO public.europe_data_import VALUES (794, '31/08/2020', '2020-35', '16224', '307', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '21.02');
INSERT INTO public.europe_data_import VALUES (795, '24/08/2020', '2020-34', '18049', '284', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '22.69');
INSERT INTO public.europe_data_import VALUES (796, '17/08/2020', '2020-33', '18949', '258', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '21.96');
INSERT INTO public.europe_data_import VALUES (797, '10/08/2020', '2020-32', '16854', '245', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '20.94');
INSERT INTO public.europe_data_import VALUES (798, '03/08/2020', '2020-31', '17293', '226', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '22.22');
INSERT INTO public.europe_data_import VALUES (799, '27/07/2020', '2020-30', '18928', '310', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '24.32');
INSERT INTO public.europe_data_import VALUES (800, '20/07/2020', '2020-29', '20730', '266', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '25.83');
INSERT INTO public.europe_data_import VALUES (801, '13/07/2020', '2020-28', '21378', '300', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '28.22');
INSERT INTO public.europe_data_import VALUES (802, '06/07/2020', '2020-27', '24630', '314', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '30.73');
INSERT INTO public.europe_data_import VALUES (803, '29/06/2020', '2020-26', '25481', '274', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '30.83');
INSERT INTO public.europe_data_import VALUES (804, '22/06/2020', '2020-25', '24786', '293', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '28.54');
INSERT INTO public.europe_data_import VALUES (805, '15/06/2020', '2020-24', '21751', '283', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '24.76');
INSERT INTO public.europe_data_import VALUES (806, '08/06/2020', '2020-23', '18616', '238', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '19.72');
INSERT INTO public.europe_data_import VALUES (807, '01/06/2020', '2020-22', '13543', '170', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '15.26');
INSERT INTO public.europe_data_import VALUES (808, '25/05/2020', '2020-21', '11342', '152', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '11.62');
INSERT INTO public.europe_data_import VALUES (809, '18/05/2020', '2020-20', '7611', '100', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '7.86');
INSERT INTO public.europe_data_import VALUES (810, '11/05/2020', '2020-19', '5202', '51', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '5.67');
INSERT INTO public.europe_data_import VALUES (811, '04/05/2020', '2020-18', '4039', '32', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '4.29');
INSERT INTO public.europe_data_import VALUES (812, '27/04/2020', '2020-17', '2960', '54', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '2.94');
INSERT INTO public.europe_data_import VALUES (813, '20/04/2020', '2020-16', '1835', '57', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '1.45');
INSERT INTO public.europe_data_import VALUES (814, '13/04/2020', '2020-15', '533', '25', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.35');
INSERT INTO public.europe_data_import VALUES (815, '06/04/2020', '2020-14', '39', '4', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (816, '30/03/2020', '2020-13', '22', '2', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (817, '23/03/2020', '2020-12', '24', '3', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (818, '16/03/2020', '2020-11', '0', '0', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (819, '09/03/2020', '2020-10', '3', '0', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (820, '01/02/2021', '2021-04', '157', '4', '287021', 'Barbados', 'BB', 'BRB', 'America', '161.31');
INSERT INTO public.europe_data_import VALUES (821, '25/01/2021', '2021-03', '306', '3', '287021', 'Barbados', 'BB', 'BRB', 'America', '180.13');
INSERT INTO public.europe_data_import VALUES (822, '18/01/2021', '2021-02', '211', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '170.37');
INSERT INTO public.europe_data_import VALUES (823, '11/01/2021', '2021-01', '278', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '181.87');
INSERT INTO public.europe_data_import VALUES (824, '04/01/2021', '2020-53', '244', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '98.95');
INSERT INTO public.europe_data_import VALUES (825, '28/12/2020', '2020-52', '40', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '22.99');
INSERT INTO public.europe_data_import VALUES (826, '21/12/2020', '2020-51', '26', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '12.19');
INSERT INTO public.europe_data_import VALUES (827, '14/12/2020', '2020-50', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '7.32');
INSERT INTO public.europe_data_import VALUES (828, '07/12/2020', '2020-49', '12', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '9.76');
INSERT INTO public.europe_data_import VALUES (829, '30/11/2020', '2020-48', '16', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '8.71');
INSERT INTO public.europe_data_import VALUES (830, '23/11/2020', '2020-47', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '5.92');
INSERT INTO public.europe_data_import VALUES (831, '16/11/2020', '2020-46', '8', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '4.53');
INSERT INTO public.europe_data_import VALUES (832, '09/11/2020', '2020-45', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '5.23');
INSERT INTO public.europe_data_import VALUES (833, '02/11/2020', '2020-44', '10', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '5.23');
INSERT INTO public.europe_data_import VALUES (834, '26/10/2020', '2020-43', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (835, '19/10/2020', '2020-42', '14', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '8.01');
INSERT INTO public.europe_data_import VALUES (836, '12/10/2020', '2020-41', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.27');
INSERT INTO public.europe_data_import VALUES (837, '05/10/2020', '2020-40', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '3.48');
INSERT INTO public.europe_data_import VALUES (838, '28/09/2020', '2020-39', '1', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '3.14');
INSERT INTO public.europe_data_import VALUES (839, '21/09/2020', '2020-38', '8', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '3.48');
INSERT INTO public.europe_data_import VALUES (840, '14/09/2020', '2020-37', '2', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (841, '07/09/2020', '2020-36', '6', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.27');
INSERT INTO public.europe_data_import VALUES (842, '31/08/2020', '2020-35', '12', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '7.66');
INSERT INTO public.europe_data_import VALUES (843, '24/08/2020', '2020-34', '10', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (844, '17/08/2020', '2020-33', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (845, '10/08/2020', '2020-32', '10', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '11.15');
INSERT INTO public.europe_data_import VALUES (846, '03/08/2020', '2020-31', '22', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '9.41');
INSERT INTO public.europe_data_import VALUES (847, '27/07/2020', '2020-30', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.44');
INSERT INTO public.europe_data_import VALUES (848, '20/07/2020', '2020-29', '2', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.44');
INSERT INTO public.europe_data_import VALUES (849, '13/07/2020', '2020-28', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.09');
INSERT INTO public.europe_data_import VALUES (850, '06/07/2020', '2020-27', '1', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (851, '29/06/2020', '2020-26', '0', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (852, '22/06/2020', '2020-25', '1', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.74');
INSERT INTO public.europe_data_import VALUES (853, '15/06/2020', '2020-24', '4', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (854, '08/06/2020', '2020-23', '0', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (855, '01/06/2020', '2020-22', '0', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (856, '25/05/2020', '2020-21', '4', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (857, '18/05/2020', '2020-20', '4', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.09');
INSERT INTO public.europe_data_import VALUES (858, '11/05/2020', '2020-19', '2', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.74');
INSERT INTO public.europe_data_import VALUES (859, '04/05/2020', '2020-18', '3', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.44');
INSERT INTO public.europe_data_import VALUES (860, '27/04/2020', '2020-17', '4', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (861, '20/04/2020', '2020-16', '4', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (862, '13/04/2020', '2020-15', '15', '3', '287021', 'Barbados', 'BB', 'BRB', 'America', '13.24');
INSERT INTO public.europe_data_import VALUES (863, '06/04/2020', '2020-14', '23', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '13.59');
INSERT INTO public.europe_data_import VALUES (864, '30/03/2020', '2020-13', '16', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '11.5');
INSERT INTO public.europe_data_import VALUES (865, '23/03/2020', '2020-12', '17', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '');
INSERT INTO public.europe_data_import VALUES (866, '01/02/2021', '2021-04', '10725', '69', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '221.91');
INSERT INTO public.europe_data_import VALUES (867, '25/01/2021', '2021-03', '10251', '58', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '249.86');
INSERT INTO public.europe_data_import VALUES (868, '18/01/2021', '2021-02', '13367', '65', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '289.85');
INSERT INTO public.europe_data_import VALUES (869, '11/01/2021', '2021-01', '14031', '75', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '268.77');
INSERT INTO public.europe_data_import VALUES (870, '04/01/2021', '2020-53', '11374', '57', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '279.71');
INSERT INTO public.europe_data_import VALUES (871, '28/12/2020', '2020-52', '15065', '70', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '299.32');
INSERT INTO public.europe_data_import VALUES (872, '21/12/2020', '2020-51', '13228', '61', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '278.93');
INSERT INTO public.europe_data_import VALUES (873, '14/12/2020', '2020-50', '13138', '56', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '267.52');
INSERT INTO public.europe_data_import VALUES (874, '07/12/2020', '2020-49', '12149', '56', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '245.0');
INSERT INTO public.europe_data_import VALUES (875, '30/11/2020', '2020-48', '11009', '55', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '220.29');
INSERT INTO public.europe_data_import VALUES (876, '23/11/2020', '2020-47', '9814', '50', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '187.47');
INSERT INTO public.europe_data_import VALUES (877, '16/11/2020', '2020-46', '7906', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '155.79');
INSERT INTO public.europe_data_import VALUES (878, '09/11/2020', '2020-45', '6820', '22', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '142.36');
INSERT INTO public.europe_data_import VALUES (879, '02/11/2020', '2020-44', '6636', '28', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '124.42');
INSERT INTO public.europe_data_import VALUES (880, '26/10/2020', '2020-43', '5125', '28', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '98.27');
INSERT INTO public.europe_data_import VALUES (881, '19/10/2020', '2020-42', '4164', '33', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '78.32');
INSERT INTO public.europe_data_import VALUES (882, '12/10/2020', '2020-41', '3239', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '62.68');
INSERT INTO public.europe_data_import VALUES (883, '05/10/2020', '2020-40', '2686', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '48.89');
INSERT INTO public.europe_data_import VALUES (884, '28/09/2020', '2020-39', '1935', '38', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '36.35');
INSERT INTO public.europe_data_import VALUES (885, '21/09/2020', '2020-38', '1501', '30', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '29.78');
INSERT INTO public.europe_data_import VALUES (886, '14/09/2020', '2020-37', '1314', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '26.3');
INSERT INTO public.europe_data_import VALUES (887, '07/09/2020', '2020-36', '1172', '35', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '25.3');
INSERT INTO public.europe_data_import VALUES (888, '31/08/2020', '2020-35', '1219', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '22.97');
INSERT INTO public.europe_data_import VALUES (889, '24/08/2020', '2020-34', '952', '32', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '17.12');
INSERT INTO public.europe_data_import VALUES (890, '17/08/2020', '2020-33', '666', '23', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '15.33');
INSERT INTO public.europe_data_import VALUES (891, '10/08/2020', '2020-32', '783', '20', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '18.18');
INSERT INTO public.europe_data_import VALUES (892, '03/08/2020', '2020-31', '935', '33', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '20.86');
INSERT INTO public.europe_data_import VALUES (893, '27/07/2020', '2020-30', '1037', '35', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '23.27');
INSERT INTO public.europe_data_import VALUES (894, '20/07/2020', '2020-29', '1163', '35', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '26.88');
INSERT INTO public.europe_data_import VALUES (895, '13/07/2020', '2020-28', '1378', '41', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '36.57');
INSERT INTO public.europe_data_import VALUES (896, '06/07/2020', '2020-27', '2079', '40', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '53.41');
INSERT INTO public.europe_data_import VALUES (897, '29/06/2020', '2020-26', '2970', '37', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '79.37');
INSERT INTO public.europe_data_import VALUES (898, '22/06/2020', '2020-25', '4532', '38', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '104.47');
INSERT INTO public.europe_data_import VALUES (899, '15/06/2020', '2020-24', '5343', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '120.78');
INSERT INTO public.europe_data_import VALUES (900, '08/06/2020', '2020-23', '6074', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '131.52');
INSERT INTO public.europe_data_import VALUES (901, '01/06/2020', '2020-22', '6358', '36', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '136.54');
INSERT INTO public.europe_data_import VALUES (902, '25/05/2020', '2020-21', '6548', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '139.91');
INSERT INTO public.europe_data_import VALUES (903, '18/05/2020', '2020-20', '6677', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '136.95');
INSERT INTO public.europe_data_import VALUES (904, '11/05/2020', '2020-19', '6268', '32', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '132.35');
INSERT INTO public.europe_data_import VALUES (905, '04/05/2020', '2020-18', '6242', '27', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '115.29');
INSERT INTO public.europe_data_import VALUES (906, '27/04/2020', '2020-17', '4656', '25', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '83.42');
INSERT INTO public.europe_data_import VALUES (907, '20/04/2020', '2020-16', '3229', '21', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '55.47');
INSERT INTO public.europe_data_import VALUES (908, '13/04/2020', '2020-15', '2014', '18', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '26.28');
INSERT INTO public.europe_data_import VALUES (909, '06/04/2020', '2020-14', '470', '8', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '5.16');
INSERT INTO public.europe_data_import VALUES (910, '30/03/2020', '2020-13', '18', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.71');
INSERT INTO public.europe_data_import VALUES (911, '23/03/2020', '2020-12', '49', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.74');
INSERT INTO public.europe_data_import VALUES (912, '16/03/2020', '2020-11', '21', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.28');
INSERT INTO public.europe_data_import VALUES (913, '09/03/2020', '2020-10', '5', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.06');
INSERT INTO public.europe_data_import VALUES (914, '02/03/2020', '2020-09', '1', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (915, '24/02/2020', '2020-08', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (916, '17/02/2020', '2020-07', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (917, '10/02/2020', '2020-06', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (918, '03/02/2020', '2020-05', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (919, '27/01/2020', '2020-04', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (920, '20/01/2020', '2020-03', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (921, '13/01/2020', '2020-02', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (922, '06/01/2020', '2020-01', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (923, '01/02/2021', '2021-04', '16454', '291', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '276.37');
INSERT INTO public.europe_data_import VALUES (924, '25/01/2021', '2021-03', '15206', '373', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '253.6');
INSERT INTO public.europe_data_import VALUES (925, '18/01/2021', '2021-02', '13845', '344', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '249.23');
INSERT INTO public.europe_data_import VALUES (926, '11/01/2021', '2021-01', '14706', '384', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '227.74');
INSERT INTO public.europe_data_import VALUES (927, '04/01/2021', '2020-53', '11383', '455', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '209.22');
INSERT INTO public.europe_data_import VALUES (928, '28/12/2020', '2020-52', '12584', '534', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '264.21');
INSERT INTO public.europe_data_import VALUES (929, '21/12/2020', '2020-51', '17683', '654', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '300.96');
INSERT INTO public.europe_data_import VALUES (930, '14/12/2020', '2020-50', '16793', '666', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '279.93');
INSERT INTO public.europe_data_import VALUES (931, '07/12/2020', '2020-49', '15275', '699', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '275.22');
INSERT INTO public.europe_data_import VALUES (932, '30/11/2020', '2020-48', '16253', '874', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '336.6');
INSERT INTO public.europe_data_import VALUES (933, '23/11/2020', '2020-47', '22306', '1123', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '491.19');
INSERT INTO public.europe_data_import VALUES (934, '16/11/2020', '2020-46', '33962', '1328', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '767.8');
INSERT INTO public.europe_data_import VALUES (935, '09/11/2020', '2020-45', '53994', '1411', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '1340.3');
INSERT INTO public.europe_data_import VALUES (936, '02/11/2020', '2020-44', '99544', '1056', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '1788.42');
INSERT INTO public.europe_data_import VALUES (937, '26/10/2020', '2020-43', '105329', '502', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '1549.69');
INSERT INTO public.europe_data_import VALUES (938, '19/10/2020', '2020-42', '72196', '236', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '969.19');
INSERT INTO public.europe_data_import VALUES (939, '12/10/2020', '2020-41', '38830', '139', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '503.81');
INSERT INTO public.europe_data_import VALUES (940, '05/10/2020', '2020-40', '18884', '84', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '263.26');
INSERT INTO public.europe_data_import VALUES (941, '28/09/2020', '2020-39', '11274', '39', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '186.65');
INSERT INTO public.europe_data_import VALUES (942, '21/09/2020', '2020-38', '10108', '27', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '141.99');
INSERT INTO public.europe_data_import VALUES (943, '14/09/2020', '2020-37', '6158', '19', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '85.66');
INSERT INTO public.europe_data_import VALUES (944, '07/09/2020', '2020-36', '3655', '17', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '59.15');
INSERT INTO public.europe_data_import VALUES (945, '31/08/2020', '2020-35', '3121', '28', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '57.39');
INSERT INTO public.europe_data_import VALUES (946, '24/08/2020', '2020-34', '3453', '42', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '62.89');
INSERT INTO public.europe_data_import VALUES (947, '17/08/2020', '2020-33', '3751', '75', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '70.63');
INSERT INTO public.europe_data_import VALUES (948, '10/08/2020', '2020-32', '4340', '30', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '70.7');
INSERT INTO public.europe_data_import VALUES (949, '03/08/2020', '2020-31', '3759', '20', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '54.54');
INSERT INTO public.europe_data_import VALUES (950, '27/07/2020', '2020-30', '2489', '15', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '33.82');
INSERT INTO public.europe_data_import VALUES (951, '20/07/2020', '2020-29', '1385', '19', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '18.24');
INSERT INTO public.europe_data_import VALUES (952, '13/07/2020', '2020-28', '704', '13', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '11.71');
INSERT INTO public.europe_data_import VALUES (953, '06/07/2020', '2020-27', '637', '25', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '10.86');
INSERT INTO public.europe_data_import VALUES (954, '29/06/2020', '2020-26', '607', '39', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '11.13');
INSERT INTO public.europe_data_import VALUES (955, '22/06/2020', '2020-25', '668', '43', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '11.69');
INSERT INTO public.europe_data_import VALUES (956, '15/06/2020', '2020-24', '671', '58', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '13.25');
INSERT INTO public.europe_data_import VALUES (957, '08/06/2020', '2020-23', '847', '113', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '17.38');
INSERT INTO public.europe_data_import VALUES (958, '01/06/2020', '2020-22', '1144', '160', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '23.17');
INSERT INTO public.europe_data_import VALUES (959, '25/05/2020', '2020-21', '1510', '230', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '31.26');
INSERT INTO public.europe_data_import VALUES (960, '18/05/2020', '2020-20', '2071', '314', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '44.71');
INSERT INTO public.europe_data_import VALUES (961, '11/05/2020', '2020-19', '3051', '535', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '53.65');
INSERT INTO public.europe_data_import VALUES (962, '04/05/2020', '2020-18', '3095', '698', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '76.8');
INSERT INTO public.europe_data_import VALUES (963, '27/04/2020', '2020-17', '5703', '1195', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '119.3');
INSERT INTO public.europe_data_import VALUES (964, '20/04/2020', '2020-16', '7963', '1667', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '167.06');
INSERT INTO public.europe_data_import VALUES (965, '13/04/2020', '2020-15', '11175', '1979', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '182.17');
INSERT INTO public.europe_data_import VALUES (966, '06/04/2020', '2020-14', '9694', '1584', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '155.59');
INSERT INTO public.europe_data_import VALUES (967, '30/03/2020', '2020-13', '8130', '782', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '103.03');
INSERT INTO public.europe_data_import VALUES (968, '23/03/2020', '2020-12', '3673', '198', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '43.83');
INSERT INTO public.europe_data_import VALUES (969, '16/03/2020', '2020-11', '1348', '18', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '15.15');
INSERT INTO public.europe_data_import VALUES (970, '09/03/2020', '2020-10', '388', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0.56');
INSERT INTO public.europe_data_import VALUES (971, '02/03/2020', '2020-09', '-324', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0.17');
INSERT INTO public.europe_data_import VALUES (972, '24/02/2020', '2020-08', '343', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '2.99');
INSERT INTO public.europe_data_import VALUES (973, '17/02/2020', '2020-07', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (974, '10/02/2020', '2020-06', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (975, '03/02/2020', '2020-05', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (976, '27/01/2020', '2020-04', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (977, '20/01/2020', '2020-03', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (978, '13/01/2020', '2020-02', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (979, '06/01/2020', '2020-01', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (980, '01/02/2021', '2021-04', '175', '9', '390351', 'Belize', 'BZ', 'BLZ', 'America', '111.95');
INSERT INTO public.europe_data_import VALUES (981, '25/01/2021', '2021-03', '262', '12', '390351', 'Belize', 'BZ', 'BLZ', 'America', '119.64');
INSERT INTO public.europe_data_import VALUES (982, '18/01/2021', '2021-02', '205', '7', '390351', 'Belize', 'BZ', 'BLZ', 'America', '155.5');
INSERT INTO public.europe_data_import VALUES (983, '11/01/2021', '2021-01', '402', '24', '390351', 'Belize', 'BZ', 'BLZ', 'America', '190.09');
INSERT INTO public.europe_data_import VALUES (984, '04/01/2021', '2020-53', '340', '17', '390351', 'Belize', 'BZ', 'BLZ', 'America', '193.67');
INSERT INTO public.europe_data_import VALUES (985, '28/12/2020', '2020-52', '416', '9', '390351', 'Belize', 'BZ', 'BLZ', 'America', '324.32');
INSERT INTO public.europe_data_import VALUES (986, '21/12/2020', '2020-51', '850', '29', '390351', 'Belize', 'BZ', 'BLZ', 'America', '608.68');
INSERT INTO public.europe_data_import VALUES (987, '14/12/2020', '2020-50', '1526', '22', '390351', 'Belize', 'BZ', 'BLZ', 'America', '909.95');
INSERT INTO public.europe_data_import VALUES (988, '07/12/2020', '2020-49', '2026', '26', '390351', 'Belize', 'BZ', 'BLZ', 'America', '662.48');
INSERT INTO public.europe_data_import VALUES (989, '30/11/2020', '2020-48', '560', '31', '390351', 'Belize', 'BZ', 'BLZ', 'America', '225.95');
INSERT INTO public.europe_data_import VALUES (990, '23/11/2020', '2020-47', '322', '26', '390351', 'Belize', 'BZ', 'BLZ', 'America', '257.97');
INSERT INTO public.europe_data_import VALUES (991, '16/11/2020', '2020-46', '685', '20', '390351', 'Belize', 'BZ', 'BLZ', 'America', '358.4');
INSERT INTO public.europe_data_import VALUES (992, '09/11/2020', '2020-45', '714', '12', '390351', 'Belize', 'BZ', 'BLZ', 'America', '264.12');
INSERT INTO public.europe_data_import VALUES (993, '02/11/2020', '2020-44', '317', '8', '390351', 'Belize', 'BZ', 'BLZ', 'America', '166.26');
INSERT INTO public.europe_data_import VALUES (994, '26/10/2020', '2020-43', '332', '6', '390351', 'Belize', 'BZ', 'BLZ', 'America', '183.94');
INSERT INTO public.europe_data_import VALUES (995, '19/10/2020', '2020-42', '386', '9', '390351', 'Belize', 'BZ', 'BLZ', 'America', '158.06');
INSERT INTO public.europe_data_import VALUES (996, '12/10/2020', '2020-41', '231', '5', '390351', 'Belize', 'BZ', 'BLZ', 'America', '146.79');
INSERT INTO public.europe_data_import VALUES (997, '05/10/2020', '2020-40', '342', '6', '390351', 'Belize', 'BZ', 'BLZ', 'America', '145.77');
INSERT INTO public.europe_data_import VALUES (998, '28/09/2020', '2020-39', '227', '3', '390351', 'Belize', 'BZ', 'BLZ', 'America', '95.81');
INSERT INTO public.europe_data_import VALUES (999, '21/09/2020', '2020-38', '147', '2', '390351', 'Belize', 'BZ', 'BLZ', 'America', '93.76');
INSERT INTO public.europe_data_import VALUES (1000, '14/09/2020', '2020-37', '219', '4', '390351', 'Belize', 'BZ', 'BLZ', 'America', '124.5');
INSERT INTO public.europe_data_import VALUES (1001, '07/09/2020', '2020-36', '267', '2', '390351', 'Belize', 'BZ', 'BLZ', 'America', '147.3');
INSERT INTO public.europe_data_import VALUES (1002, '31/08/2020', '2020-35', '308', '7', '390351', 'Belize', 'BZ', 'BLZ', 'America', '138.85');
INSERT INTO public.europe_data_import VALUES (1003, '24/08/2020', '2020-34', '234', '3', '390351', 'Belize', 'BZ', 'BLZ', 'America', '136.29');
INSERT INTO public.europe_data_import VALUES (1004, '17/08/2020', '2020-33', '298', '1', '390351', 'Belize', 'BZ', 'BLZ', 'America', '101.19');
INSERT INTO public.europe_data_import VALUES (1005, '10/08/2020', '2020-32', '97', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '27.16');
INSERT INTO public.europe_data_import VALUES (1006, '03/08/2020', '2020-31', '9', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '4.36');
INSERT INTO public.europe_data_import VALUES (1007, '27/07/2020', '2020-30', '8', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '2.82');
INSERT INTO public.europe_data_import VALUES (1008, '20/07/2020', '2020-29', '3', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '2.56');
INSERT INTO public.europe_data_import VALUES (1009, '13/07/2020', '2020-28', '7', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1010, '06/07/2020', '2020-27', '6', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (1011, '29/06/2020', '2020-26', '2', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (1012, '22/06/2020', '2020-25', '1', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '1.02');
INSERT INTO public.europe_data_import VALUES (1013, '15/06/2020', '2020-24', '3', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (1014, '08/06/2020', '2020-23', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1015, '01/06/2020', '2020-22', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1016, '25/05/2020', '2020-21', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1017, '18/05/2020', '2020-20', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1018, '11/05/2020', '2020-19', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1019, '04/05/2020', '2020-18', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1020, '27/04/2020', '2020-17', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '1.02');
INSERT INTO public.europe_data_import VALUES (1021, '20/04/2020', '2020-16', '4', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1022, '13/04/2020', '2020-15', '9', '1', '390351', 'Belize', 'BZ', 'BLZ', 'America', '3.07');
INSERT INTO public.europe_data_import VALUES (1023, '06/04/2020', '2020-14', '3', '1', '390351', 'Belize', 'BZ', 'BLZ', 'America', '1.28');
INSERT INTO public.europe_data_import VALUES (1024, '30/03/2020', '2020-13', '2', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '');
INSERT INTO public.europe_data_import VALUES (1025, '01/02/2021', '2021-04', '250', '4', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '4.07');
INSERT INTO public.europe_data_import VALUES (1026, '25/01/2021', '2021-03', '230', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.87');
INSERT INTO public.europe_data_import VALUES (1027, '18/01/2021', '2021-02', '109', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.37');
INSERT INTO public.europe_data_import VALUES (1028, '11/01/2021', '2021-01', '53', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (1029, '04/01/2021', '2020-53', '46', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.71');
INSERT INTO public.europe_data_import VALUES (1030, '28/12/2020', '2020-52', '38', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (1031, '21/12/2020', '2020-51', '77', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (1032, '14/12/2020', '2020-50', '35', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (1033, '07/12/2020', '2020-49', '81', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (1034, '30/11/2020', '2020-48', '58', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (1035, '23/11/2020', '2020-47', '72', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.45');
INSERT INTO public.europe_data_import VALUES (1036, '16/11/2020', '2020-46', '99', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.7');
INSERT INTO public.europe_data_import VALUES (1037, '09/11/2020', '2020-45', '102', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.59');
INSERT INTO public.europe_data_import VALUES (1038, '02/11/2020', '2020-44', '86', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.25');
INSERT INTO public.europe_data_import VALUES (1039, '26/10/2020', '2020-43', '61', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.24');
INSERT INTO public.europe_data_import VALUES (1040, '19/10/2020', '2020-42', '85', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (1041, '12/10/2020', '2020-41', '54', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (1042, '05/10/2020', '2020-40', '17', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (1043, '28/09/2020', '2020-39', '60', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (1044, '21/09/2020', '2020-38', '13', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (1045, '14/09/2020', '2020-37', '54', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1046, '07/09/2020', '2020-36', '68', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (1047, '31/08/2020', '2020-35', '30', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1048, '24/08/2020', '2020-34', '52', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (1049, '17/08/2020', '2020-33', '127', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.19');
INSERT INTO public.europe_data_import VALUES (1050, '10/08/2020', '2020-32', '131', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (1051, '03/08/2020', '2020-31', '35', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (1052, '27/07/2020', '2020-30', '168', '4', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '3.32');
INSERT INTO public.europe_data_import VALUES (1053, '20/07/2020', '2020-29', '224', '5', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '3.41');
INSERT INTO public.europe_data_import VALUES (1054, '13/07/2020', '2020-28', '179', '5', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (1055, '06/07/2020', '2020-27', '50', '5', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '3.68');
INSERT INTO public.europe_data_import VALUES (1056, '29/06/2020', '2020-26', '384', '3', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '5.75');
INSERT INTO public.europe_data_import VALUES (1057, '22/06/2020', '2020-25', '295', '6', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '4.21');
INSERT INTO public.europe_data_import VALUES (1058, '15/06/2020', '2020-24', '202', '3', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.02');
INSERT INTO public.europe_data_import VALUES (1059, '08/06/2020', '2020-23', '36', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (1060, '01/06/2020', '2020-22', '41', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '-0.91');
INSERT INTO public.europe_data_import VALUES (1061, '25/05/2020', '2020-21', '-148', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '-1.08');
INSERT INTO public.europe_data_import VALUES (1062, '18/05/2020', '2020-20', '20', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.11');
INSERT INTO public.europe_data_import VALUES (1063, '11/05/2020', '2020-19', '229', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.16');
INSERT INTO public.europe_data_import VALUES (1064, '04/05/2020', '2020-18', '26', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (1065, '27/04/2020', '2020-17', '27', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1066, '20/04/2020', '2020-16', '2', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1067, '13/04/2020', '2020-15', '13', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1068, '06/04/2020', '2020-14', '16', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (1069, '30/03/2020', '2020-13', '4', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (1070, '23/03/2020', '2020-12', '2', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1071, '01/02/2021', '2021-04', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '14.4');
INSERT INTO public.europe_data_import VALUES (1072, '25/01/2021', '2021-03', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '47.99');
INSERT INTO public.europe_data_import VALUES (1073, '18/01/2021', '2021-02', '27', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '97.59');
INSERT INTO public.europe_data_import VALUES (1074, '11/01/2021', '2021-01', '34', '2', '62508', 'Bermuda', 'BM', 'BMU', 'America', '119.98');
INSERT INTO public.europe_data_import VALUES (1075, '04/01/2021', '2020-53', '41', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '151.98');
INSERT INTO public.europe_data_import VALUES (1076, '28/12/2020', '2020-52', '54', '1', '62508', 'Bermuda', 'BM', 'BMU', 'America', '239.97');
INSERT INTO public.europe_data_import VALUES (1077, '21/12/2020', '2020-51', '96', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '382.35');
INSERT INTO public.europe_data_import VALUES (1078, '14/12/2020', '2020-50', '143', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '287.96');
INSERT INTO public.europe_data_import VALUES (1079, '07/12/2020', '2020-49', '37', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '97.59');
INSERT INTO public.europe_data_import VALUES (1080, '30/11/2020', '2020-48', '24', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '46.39');
INSERT INTO public.europe_data_import VALUES (1081, '23/11/2020', '2020-47', '5', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '28.8');
INSERT INTO public.europe_data_import VALUES (1082, '16/11/2020', '2020-46', '13', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '36.8');
INSERT INTO public.europe_data_import VALUES (1083, '09/11/2020', '2020-45', '10', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '28.8');
INSERT INTO public.europe_data_import VALUES (1084, '02/11/2020', '2020-44', '8', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '22.4');
INSERT INTO public.europe_data_import VALUES (1085, '26/10/2020', '2020-43', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '11.2');
INSERT INTO public.europe_data_import VALUES (1086, '19/10/2020', '2020-42', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1087, '12/10/2020', '2020-41', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '4.8');
INSERT INTO public.europe_data_import VALUES (1088, '05/10/2020', '2020-40', '0', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '1.6');
INSERT INTO public.europe_data_import VALUES (1089, '28/09/2020', '2020-39', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1090, '21/09/2020', '2020-38', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '8.0');
INSERT INTO public.europe_data_import VALUES (1091, '14/09/2020', '2020-37', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1092, '07/09/2020', '2020-36', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1093, '31/08/2020', '2020-35', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '11.2');
INSERT INTO public.europe_data_import VALUES (1094, '24/08/2020', '2020-34', '5', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '14.4');
INSERT INTO public.europe_data_import VALUES (1095, '17/08/2020', '2020-33', '4', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '9.6');
INSERT INTO public.europe_data_import VALUES (1096, '10/08/2020', '2020-32', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1097, '03/08/2020', '2020-31', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '4.8');
INSERT INTO public.europe_data_import VALUES (1098, '27/07/2020', '2020-30', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1099, '20/07/2020', '2020-29', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '11.2');
INSERT INTO public.europe_data_import VALUES (1100, '13/07/2020', '2020-28', '4', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1101, '06/07/2020', '2020-27', '0', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1102, '29/06/2020', '2020-26', '0', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '3.2');
INSERT INTO public.europe_data_import VALUES (1103, '22/06/2020', '2020-25', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '8.0');
INSERT INTO public.europe_data_import VALUES (1104, '15/06/2020', '2020-24', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1105, '08/06/2020', '2020-23', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1106, '01/06/2020', '2020-22', '7', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '27.2');
INSERT INTO public.europe_data_import VALUES (1107, '25/05/2020', '2020-21', '10', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '24.0');
INSERT INTO public.europe_data_import VALUES (1108, '18/05/2020', '2020-20', '5', '2', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1109, '11/05/2020', '2020-19', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '14.4');
INSERT INTO public.europe_data_import VALUES (1110, '04/05/2020', '2020-18', '6', '2', '62508', 'Bermuda', 'BM', 'BMU', 'America', '46.39');
INSERT INTO public.europe_data_import VALUES (1111, '27/04/2020', '2020-17', '23', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '83.19');
INSERT INTO public.europe_data_import VALUES (1112, '20/04/2020', '2020-16', '29', '1', '62508', 'Bermuda', 'BM', 'BMU', 'America', '78.39');
INSERT INTO public.europe_data_import VALUES (1113, '13/04/2020', '2020-15', '20', '4', '62508', 'Bermuda', 'BM', 'BMU', 'America', '55.99');
INSERT INTO public.europe_data_import VALUES (1114, '06/04/2020', '2020-14', '15', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '49.59');
INSERT INTO public.europe_data_import VALUES (1115, '30/03/2020', '2020-13', '16', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '35.2');
INSERT INTO public.europe_data_import VALUES (1116, '23/03/2020', '2020-12', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '');
INSERT INTO public.europe_data_import VALUES (1117, '01/02/2021', '2021-04', '4', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.23');
INSERT INTO public.europe_data_import VALUES (1118, '25/01/2021', '2021-03', '13', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '5.5');
INSERT INTO public.europe_data_import VALUES (1119, '18/01/2021', '2021-02', '29', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '16.51');
INSERT INTO public.europe_data_import VALUES (1120, '11/01/2021', '2021-01', '97', '1', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '24.9');
INSERT INTO public.europe_data_import VALUES (1121, '04/01/2021', '2020-53', '93', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '32.63');
INSERT INTO public.europe_data_import VALUES (1122, '28/12/2020', '2020-52', '156', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '24.24');
INSERT INTO public.europe_data_import VALUES (1123, '21/12/2020', '2020-51', '29', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.85');
INSERT INTO public.europe_data_import VALUES (1124, '14/12/2020', '2020-50', '8', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '5.5');
INSERT INTO public.europe_data_import VALUES (1125, '07/12/2020', '2020-49', '34', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '6.29');
INSERT INTO public.europe_data_import VALUES (1126, '30/11/2020', '2020-48', '14', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.75');
INSERT INTO public.europe_data_import VALUES (1127, '23/11/2020', '2020-47', '7', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.01');
INSERT INTO public.europe_data_import VALUES (1128, '16/11/2020', '2020-46', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.75');
INSERT INTO public.europe_data_import VALUES (1129, '09/11/2020', '2020-45', '5', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.23');
INSERT INTO public.europe_data_import VALUES (1130, '02/11/2020', '2020-44', '12', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.54');
INSERT INTO public.europe_data_import VALUES (1131, '26/10/2020', '2020-43', '15', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.32');
INSERT INTO public.europe_data_import VALUES (1132, '19/10/2020', '2020-42', '18', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.8');
INSERT INTO public.europe_data_import VALUES (1133, '12/10/2020', '2020-41', '11', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.72');
INSERT INTO public.europe_data_import VALUES (1134, '05/10/2020', '2020-40', '25', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.85');
INSERT INTO public.europe_data_import VALUES (1135, '28/09/2020', '2020-39', '12', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.67');
INSERT INTO public.europe_data_import VALUES (1136, '21/09/2020', '2020-38', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.06');
INSERT INTO public.europe_data_import VALUES (1137, '14/09/2020', '2020-37', '15', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.75');
INSERT INTO public.europe_data_import VALUES (1138, '07/09/2020', '2020-36', '6', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '9.83');
INSERT INTO public.europe_data_import VALUES (1139, '31/08/2020', '2020-35', '69', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '10.88');
INSERT INTO public.europe_data_import VALUES (1140, '24/08/2020', '2020-34', '14', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '5.9');
INSERT INTO public.europe_data_import VALUES (1141, '17/08/2020', '2020-33', '31', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.98');
INSERT INTO public.europe_data_import VALUES (1142, '10/08/2020', '2020-32', '7', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.97');
INSERT INTO public.europe_data_import VALUES (1143, '03/08/2020', '2020-31', '8', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (1144, '27/07/2020', '2020-30', '6', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.44');
INSERT INTO public.europe_data_import VALUES (1145, '20/07/2020', '2020-29', '5', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (1146, '13/07/2020', '2020-28', '4', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.05');
INSERT INTO public.europe_data_import VALUES (1147, '06/07/2020', '2020-27', '4', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.57');
INSERT INTO public.europe_data_import VALUES (1148, '29/06/2020', '2020-26', '8', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.31');
INSERT INTO public.europe_data_import VALUES (1149, '22/06/2020', '2020-25', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (1150, '15/06/2020', '2020-24', '7', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.01');
INSERT INTO public.europe_data_import VALUES (1151, '08/06/2020', '2020-23', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.19');
INSERT INTO public.europe_data_import VALUES (1152, '01/06/2020', '2020-22', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.88');
INSERT INTO public.europe_data_import VALUES (1153, '25/05/2020', '2020-21', '6', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.36');
INSERT INTO public.europe_data_import VALUES (1154, '18/05/2020', '2020-20', '12', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (1155, '11/05/2020', '2020-19', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (1156, '04/05/2020', '2020-18', '0', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (1157, '27/04/2020', '2020-17', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (1158, '20/04/2020', '2020-16', '0', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1159, '13/04/2020', '2020-15', '0', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (1160, '06/04/2020', '2020-14', '1', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.39');
INSERT INTO public.europe_data_import VALUES (1161, '30/03/2020', '2020-13', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.52');
INSERT INTO public.europe_data_import VALUES (1162, '23/03/2020', '2020-12', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (1163, '01/02/2021', '2021-04', '14017', '328', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '257.55');
INSERT INTO public.europe_data_import VALUES (1164, '25/01/2021', '2021-03', '15635', '415', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '251.21');
INSERT INTO public.europe_data_import VALUES (1165, '18/01/2021', '2021-02', '13287', '260', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '212.99');
INSERT INTO public.europe_data_import VALUES (1166, '11/01/2021', '2021-01', '11235', '175', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '165.49');
INSERT INTO public.europe_data_import VALUES (1167, '04/01/2021', '2020-53', '7818', '103', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '106.63');
INSERT INTO public.europe_data_import VALUES (1168, '28/12/2020', '2020-52', '4458', '55', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '66.82');
INSERT INTO public.europe_data_import VALUES (1169, '21/12/2020', '2020-51', '3235', '25', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '41.91');
INSERT INTO public.europe_data_import VALUES (1170, '14/12/2020', '2020-50', '1590', '23', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '21.96');
INSERT INTO public.europe_data_import VALUES (1171, '07/12/2020', '2020-49', '938', '43', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '14.23');
INSERT INTO public.europe_data_import VALUES (1172, '30/11/2020', '2020-48', '700', '48', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '11.95');
INSERT INTO public.europe_data_import VALUES (1173, '23/11/2020', '2020-47', '676', '55', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '12.57');
INSERT INTO public.europe_data_import VALUES (1174, '16/11/2020', '2020-46', '771', '54', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '12.27');
INSERT INTO public.europe_data_import VALUES (1175, '09/11/2020', '2020-45', '642', '64', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '14.09');
INSERT INTO public.europe_data_import VALUES (1176, '02/11/2020', '2020-44', '980', '86', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '17.91');
INSERT INTO public.europe_data_import VALUES (1177, '26/10/2020', '2020-43', '1082', '164', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '19.79');
INSERT INTO public.europe_data_import VALUES (1178, '19/10/2020', '2020-42', '1197', '173', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '25.21');
INSERT INTO public.europe_data_import VALUES (1179, '12/10/2020', '2020-41', '1706', '207', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '40.59');
INSERT INTO public.europe_data_import VALUES (1180, '05/10/2020', '2020-40', '2967', '243', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '53.78');
INSERT INTO public.europe_data_import VALUES (1181, '28/09/2020', '2020-39', '3225', '241', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '61.76');
INSERT INTO public.europe_data_import VALUES (1182, '21/09/2020', '2020-38', '3885', '273', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '86.05');
INSERT INTO public.europe_data_import VALUES (1183, '14/09/2020', '2020-37', '6022', '336', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '94.01');
INSERT INTO public.europe_data_import VALUES (1184, '07/09/2020', '2020-36', '4801', '2042', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '100.93');
INSERT INTO public.europe_data_import VALUES (1185, '31/08/2020', '2020-35', '6819', '457', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '135.71');
INSERT INTO public.europe_data_import VALUES (1186, '24/08/2020', '2020-34', '8805', '461', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '166.33');
INSERT INTO public.europe_data_import VALUES (1187, '17/08/2020', '2020-33', '10345', '408', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '175.37');
INSERT INTO public.europe_data_import VALUES (1188, '10/08/2020', '2020-32', '9846', '487', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '178.67');
INSERT INTO public.europe_data_import VALUES (1189, '03/08/2020', '2020-31', '10724', '570', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '178.67');
INSERT INTO public.europe_data_import VALUES (1190, '27/07/2020', '2020-30', '9847', '432', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '184.5');
INSERT INTO public.europe_data_import VALUES (1191, '20/07/2020', '2020-29', '11395', '344', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '176.19');
INSERT INTO public.europe_data_import VALUES (1192, '13/07/2020', '2020-28', '8890', '373', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '144.73');
INSERT INTO public.europe_data_import VALUES (1193, '06/07/2020', '2020-27', '7773', '420', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '129.5');
INSERT INTO public.europe_data_import VALUES (1194, '29/06/2020', '2020-26', '7136', '241', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '113.48');
INSERT INTO public.europe_data_import VALUES (1195, '22/06/2020', '2020-25', '5929', '162', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '93.33');
INSERT INTO public.europe_data_import VALUES (1196, '15/06/2020', '2020-24', '4816', '146', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '73.63');
INSERT INTO public.europe_data_import VALUES (1197, '08/06/2020', '2020-23', '3661', '152', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '64.1');
INSERT INTO public.europe_data_import VALUES (1198, '01/06/2020', '2020-22', '3719', '63', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '51.19');
INSERT INTO public.europe_data_import VALUES (1199, '25/05/2020', '2020-21', '2175', '81', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '32.2');
INSERT INTO public.europe_data_import VALUES (1200, '18/05/2020', '2020-20', '1532', '51', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '21.66');
INSERT INTO public.europe_data_import VALUES (1201, '11/05/2020', '2020-19', '962', '42', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '13.95');
INSERT INTO public.europe_data_import VALUES (1202, '04/05/2020', '2020-18', '644', '26', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '8.95');
INSERT INTO public.europe_data_import VALUES (1203, '27/04/2020', '2020-17', '386', '17', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '5.39');
INSERT INTO public.europe_data_import VALUES (1204, '20/04/2020', '2020-16', '234', '6', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '3.31');
INSERT INTO public.europe_data_import VALUES (1205, '13/04/2020', '2020-15', '147', '16', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '2.03');
INSERT INTO public.europe_data_import VALUES (1206, '06/04/2020', '2020-14', '87', '8', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '1.35');
INSERT INTO public.europe_data_import VALUES (1207, '30/03/2020', '2020-13', '69', '3', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '0.83');
INSERT INTO public.europe_data_import VALUES (1208, '23/03/2020', '2020-12', '27', '0', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '');
INSERT INTO public.europe_data_import VALUES (1209, '01/02/2021', '2021-04', '10', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '103.91');
INSERT INTO public.europe_data_import VALUES (1210, '25/01/2021', '2021-03', '17', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '184.74');
INSERT INTO public.europe_data_import VALUES (1211, '18/01/2021', '2021-02', '31', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '477.24');
INSERT INTO public.europe_data_import VALUES (1212, '11/01/2021', '2021-01', '93', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '581.15');
INSERT INTO public.europe_data_import VALUES (1213, '04/01/2021', '2020-53', '58', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '238.62');
INSERT INTO public.europe_data_import VALUES (1214, '28/12/2020', '2020-52', '4', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '38.49');
INSERT INTO public.europe_data_import VALUES (1215, '21/12/2020', '2020-51', '6', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '57.73');
INSERT INTO public.europe_data_import VALUES (1216, '14/12/2020', '2020-50', '9', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '46.18');
INSERT INTO public.europe_data_import VALUES (1217, '07/12/2020', '2020-49', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1218, '30/11/2020', '2020-48', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '23.09');
INSERT INTO public.europe_data_import VALUES (1219, '23/11/2020', '2020-47', '6', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '26.94');
INSERT INTO public.europe_data_import VALUES (1220, '16/11/2020', '2020-46', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1221, '09/11/2020', '2020-45', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '15.39');
INSERT INTO public.europe_data_import VALUES (1222, '02/11/2020', '2020-44', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1223, '26/10/2020', '2020-43', '0', '1', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1224, '19/10/2020', '2020-42', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '100.07');
INSERT INTO public.europe_data_import VALUES (1225, '12/10/2020', '2020-41', '24', '1', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '242.47');
INSERT INTO public.europe_data_import VALUES (1226, '05/10/2020', '2020-40', '39', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '338.68');
INSERT INTO public.europe_data_import VALUES (1227, '28/09/2020', '2020-39', '49', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '227.07');
INSERT INTO public.europe_data_import VALUES (1228, '21/09/2020', '2020-38', '10', '1', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '69.28');
INSERT INTO public.europe_data_import VALUES (1229, '14/09/2020', '2020-37', '8', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '42.34');
INSERT INTO public.europe_data_import VALUES (1230, '07/09/2020', '2020-36', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '19.24');
INSERT INTO public.europe_data_import VALUES (1231, '31/08/2020', '2020-35', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1232, '24/08/2020', '2020-34', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1233, '17/08/2020', '2020-33', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1234, '10/08/2020', '2020-32', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1235, '03/08/2020', '2020-31', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1236, '27/07/2020', '2020-30', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '15.39');
INSERT INTO public.europe_data_import VALUES (1237, '20/07/2020', '2020-29', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1238, '13/07/2020', '2020-28', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1239, '06/07/2020', '2020-27', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1240, '29/06/2020', '2020-26', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1241, '22/06/2020', '2020-25', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1242, '15/06/2020', '2020-24', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1243, '08/06/2020', '2020-23', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1244, '01/06/2020', '2020-22', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1245, '25/05/2020', '2020-21', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1246, '18/05/2020', '2020-20', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1247, '11/05/2020', '2020-19', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1248, '04/05/2020', '2020-18', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1249, '27/04/2020', '2020-17', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1250, '20/04/2020', '2020-16', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1251, '13/04/2020', '2020-15', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1252, '06/04/2020', '2020-14', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '');
INSERT INTO public.europe_data_import VALUES (1253, '01/02/2021', '2021-04', '2056', '131', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '124.69');
INSERT INTO public.europe_data_import VALUES (1254, '25/01/2021', '2021-03', '2060', '107', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '132.84');
INSERT INTO public.europe_data_import VALUES (1255, '18/01/2021', '2021-02', '2325', '128', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '164.74');
INSERT INTO public.europe_data_import VALUES (1256, '11/01/2021', '2021-01', '3113', '227', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '183.79');
INSERT INTO public.europe_data_import VALUES (1257, '04/01/2021', '2020-53', '2954', '178', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '215.72');
INSERT INTO public.europe_data_import VALUES (1258, '28/12/2020', '2020-52', '4167', '328', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '259.74');
INSERT INTO public.europe_data_import VALUES (1259, '21/12/2020', '2020-51', '4407', '289', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '333.75');
INSERT INTO public.europe_data_import VALUES (1260, '14/12/2020', '2020-50', '6610', '384', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '416.33');
INSERT INTO public.europe_data_import VALUES (1261, '07/12/2020', '2020-49', '7133', '332', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '439.26');
INSERT INTO public.europe_data_import VALUES (1262, '30/11/2020', '2020-48', '7367', '344', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '499.06');
INSERT INTO public.europe_data_import VALUES (1263, '23/11/2020', '2020-47', '9107', '419', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '532.69');
INSERT INTO public.europe_data_import VALUES (1264, '16/11/2020', '2020-46', '8477', '347', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '587.55');
INSERT INTO public.europe_data_import VALUES (1265, '09/11/2020', '2020-45', '10918', '262', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '652.2');
INSERT INTO public.europe_data_import VALUES (1266, '02/11/2020', '2020-44', '10611', '162', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '526.66');
INSERT INTO public.europe_data_import VALUES (1267, '26/10/2020', '2020-43', '6774', '102', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '310.48');
INSERT INTO public.europe_data_import VALUES (1268, '19/10/2020', '2020-42', '3475', '63', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '186.16');
INSERT INTO public.europe_data_import VALUES (1269, '12/10/2020', '2020-41', '2670', '50', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '112.94');
INSERT INTO public.europe_data_import VALUES (1270, '05/10/2020', '2020-40', '1058', '61', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '77.28');
INSERT INTO public.europe_data_import VALUES (1271, '28/09/2020', '2020-39', '1493', '53', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '104.67');
INSERT INTO public.europe_data_import VALUES (1272, '21/09/2020', '2020-38', '1962', '68', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '129.72');
INSERT INTO public.europe_data_import VALUES (1273, '14/09/2020', '2020-37', '2320', '50', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '111.27');
INSERT INTO public.europe_data_import VALUES (1274, '07/09/2020', '2020-36', '1353', '47', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '98.21');
INSERT INTO public.europe_data_import VALUES (1275, '31/08/2020', '2020-35', '1889', '63', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '128.87');
INSERT INTO public.europe_data_import VALUES (1276, '24/08/2020', '2020-34', '2365', '60', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '108.3');
INSERT INTO public.europe_data_import VALUES (1277, '17/08/2020', '2020-33', '1210', '67', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '103.82');
INSERT INTO public.europe_data_import VALUES (1278, '10/08/2020', '2020-32', '2217', '59', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '128.93');
INSERT INTO public.europe_data_import VALUES (1279, '03/08/2020', '2020-31', '2039', '60', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '110.75');
INSERT INTO public.europe_data_import VALUES (1280, '27/07/2020', '2020-30', '1617', '33', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '96.49');
INSERT INTO public.europe_data_import VALUES (1281, '20/07/2020', '2020-29', '1568', '30', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '92.67');
INSERT INTO public.europe_data_import VALUES (1282, '13/07/2020', '2020-28', '1491', '27', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '80.85');
INSERT INTO public.europe_data_import VALUES (1283, '06/07/2020', '2020-27', '1178', '11', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '59.44');
INSERT INTO public.europe_data_import VALUES (1284, '29/06/2020', '2020-26', '784', '13', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '36.78');
INSERT INTO public.europe_data_import VALUES (1285, '22/06/2020', '2020-25', '430', '6', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '22.96');
INSERT INTO public.europe_data_import VALUES (1286, '15/06/2020', '2020-24', '328', '4', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '14.9');
INSERT INTO public.europe_data_import VALUES (1287, '08/06/2020', '2020-23', '164', '7', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '8.27');
INSERT INTO public.europe_data_import VALUES (1288, '01/06/2020', '2020-22', '109', '9', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '6.66');
INSERT INTO public.europe_data_import VALUES (1289, '25/05/2020', '2020-21', '111', '11', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '8.57');
INSERT INTO public.europe_data_import VALUES (1290, '18/05/2020', '2020-20', '172', '25', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '13.09');
INSERT INTO public.europe_data_import VALUES (1291, '11/05/2020', '2020-19', '260', '31', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '18.21');
INSERT INTO public.europe_data_import VALUES (1292, '04/05/2020', '2020-18', '341', '18', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '17.81');
INSERT INTO public.europe_data_import VALUES (1293, '27/04/2020', '2020-17', '247', '12', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '15.42');
INSERT INTO public.europe_data_import VALUES (1294, '20/04/2020', '2020-16', '262', '8', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '18.36');
INSERT INTO public.europe_data_import VALUES (1295, '13/04/2020', '2020-15', '344', '14', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '20.72');
INSERT INTO public.europe_data_import VALUES (1296, '06/04/2020', '2020-14', '340', '18', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '16.3');
INSERT INTO public.europe_data_import VALUES (1297, '30/03/2020', '2020-13', '198', '5', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '9.24');
INSERT INTO public.europe_data_import VALUES (1298, '23/03/2020', '2020-12', '107', '1', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '3.79');
INSERT INTO public.europe_data_import VALUES (1299, '16/03/2020', '2020-11', '18', '0', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (1300, '01/02/2021', '2021-04', '1639', '29', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '170.51');
INSERT INTO public.europe_data_import VALUES (1301, '25/01/2021', '2021-03', '2289', '34', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '156.44');
INSERT INTO public.europe_data_import VALUES (1302, '18/01/2021', '2021-02', '1315', '23', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '112.86');
INSERT INTO public.europe_data_import VALUES (1303, '11/01/2021', '2021-01', '1285', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '87.9');
INSERT INTO public.europe_data_import VALUES (1304, '04/01/2021', '2020-53', '740', '5', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '76.01');
INSERT INTO public.europe_data_import VALUES (1305, '28/12/2020', '2020-52', '1011', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '50.01');
INSERT INTO public.europe_data_import VALUES (1306, '21/12/2020', '2020-51', '141', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '64.37');
INSERT INTO public.europe_data_import VALUES (1307, '14/12/2020', '2020-50', '1342', '4', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '125.06');
INSERT INTO public.europe_data_import VALUES (1308, '07/12/2020', '2020-49', '1539', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '84.08');
INSERT INTO public.europe_data_import VALUES (1309, '30/11/2020', '2020-48', '398', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '76.7');
INSERT INTO public.europe_data_import VALUES (1310, '23/11/2020', '2020-47', '1369', '4', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '76.36');
INSERT INTO public.europe_data_import VALUES (1311, '16/11/2020', '2020-46', '390', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '68.72');
INSERT INTO public.europe_data_import VALUES (1312, '09/11/2020', '2020-45', '1193', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '83.0');
INSERT INTO public.europe_data_import VALUES (1313, '02/11/2020', '2020-44', '719', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '60.77');
INSERT INTO public.europe_data_import VALUES (1314, '26/10/2020', '2020-43', '681', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '60.9');
INSERT INTO public.europe_data_import VALUES (1315, '19/10/2020', '2020-42', '722', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '89.86');
INSERT INTO public.europe_data_import VALUES (1316, '12/10/2020', '2020-41', '1348', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '69.41');
INSERT INTO public.europe_data_import VALUES (1317, '05/10/2020', '2020-40', '251', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '26.26');
INSERT INTO public.europe_data_import VALUES (1318, '28/09/2020', '2020-39', '354', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '29.04');
INSERT INTO public.europe_data_import VALUES (1319, '21/09/2020', '2020-38', '315', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '24.53');
INSERT INTO public.europe_data_import VALUES (1320, '14/09/2020', '2020-37', '250', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '26.87');
INSERT INTO public.europe_data_import VALUES (1321, '07/09/2020', '2020-36', '369', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '30.13');
INSERT INTO public.europe_data_import VALUES (1322, '31/08/2020', '2020-35', '325', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '18.19');
INSERT INTO public.europe_data_import VALUES (1323, '24/08/2020', '2020-34', '94', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '17.32');
INSERT INTO public.europe_data_import VALUES (1324, '17/08/2020', '2020-33', '305', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '17.8');
INSERT INTO public.europe_data_import VALUES (1325, '10/08/2020', '2020-32', '105', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '9.68');
INSERT INTO public.europe_data_import VALUES (1326, '03/08/2020', '2020-31', '118', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '12.24');
INSERT INTO public.europe_data_import VALUES (1327, '27/07/2020', '2020-30', '164', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '12.46');
INSERT INTO public.europe_data_import VALUES (1328, '20/07/2020', '2020-29', '123', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '10.72');
INSERT INTO public.europe_data_import VALUES (1329, '13/07/2020', '2020-28', '124', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '11.89');
INSERT INTO public.europe_data_import VALUES (1330, '06/07/2020', '2020-27', '150', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '8.07');
INSERT INTO public.europe_data_import VALUES (1331, '29/06/2020', '2020-26', '36', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '2.82');
INSERT INTO public.europe_data_import VALUES (1332, '22/06/2020', '2020-25', '29', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '2.13');
INSERT INTO public.europe_data_import VALUES (1333, '15/06/2020', '2020-24', '20', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (1334, '08/06/2020', '2020-23', '2', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.22');
INSERT INTO public.europe_data_import VALUES (1335, '01/06/2020', '2020-22', '3', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.56');
INSERT INTO public.europe_data_import VALUES (1336, '25/05/2020', '2020-21', '10', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (1337, '18/05/2020', '2020-20', '2', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1338, '11/05/2020', '2020-19', '0', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (1339, '04/05/2020', '2020-18', '1', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1340, '27/04/2020', '2020-17', '2', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.39');
INSERT INTO public.europe_data_import VALUES (1341, '20/04/2020', '2020-16', '7', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (1342, '13/04/2020', '2020-15', '7', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.56');
INSERT INTO public.europe_data_import VALUES (1343, '06/04/2020', '2020-14', '6', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1344, '01/02/2021', '2021-04', '357929', '7435', '211049519', 'Brazil', 'BR', 'BRA', 'America', '339.99');
INSERT INTO public.europe_data_import VALUES (1345, '25/01/2021', '2021-03', '359623', '7365', '211049519', 'Brazil', 'BR', 'BRA', 'America', '350.52');
INSERT INTO public.europe_data_import VALUES (1346, '18/01/2021', '2021-02', '380158', '6719', '211049519', 'Brazil', 'BR', 'BRA', 'America', '368.65');
INSERT INTO public.europe_data_import VALUES (1347, '11/01/2021', '2021-01', '397866', '7562', '211049519', 'Brazil', 'BR', 'BRA', 'America', '306.72');
INSERT INTO public.europe_data_import VALUES (1348, '04/01/2021', '2020-53', '249461', '4879', '211049519', 'Brazil', 'BR', 'BRA', 'America', '222.76');
INSERT INTO public.europe_data_import VALUES (1349, '28/12/2020', '2020-52', '220666', '3848', '211049519', 'Brazil', 'BR', 'BRA', 'America', '275.92');
INSERT INTO public.europe_data_import VALUES (1350, '21/12/2020', '2020-51', '361667', '5889', '211049519', 'Brazil', 'BR', 'BRA', 'America', '312.76');
INSERT INTO public.europe_data_import VALUES (1351, '14/12/2020', '2020-50', '298412', '4461', '211049519', 'Brazil', 'BR', 'BRA', 'America', '278.23');
INSERT INTO public.europe_data_import VALUES (1352, '07/12/2020', '2020-49', '288800', '4108', '211049519', 'Brazil', 'BR', 'BRA', 'America', '252.14');
INSERT INTO public.europe_data_import VALUES (1353, '30/11/2020', '2020-48', '243339', '3650', '211049519', 'Brazil', 'BR', 'BRA', 'America', '214.0');
INSERT INTO public.europe_data_import VALUES (1354, '23/11/2020', '2020-47', '208308', '3385', '211049519', 'Brazil', 'BR', 'BRA', 'America', '192.98');
INSERT INTO public.europe_data_import VALUES (1355, '16/11/2020', '2020-46', '198978', '3401', '211049519', 'Brazil', 'BR', 'BRA', 'America', '150.39');
INSERT INTO public.europe_data_import VALUES (1356, '09/11/2020', '2020-45', '118410', '2323', '211049519', 'Brazil', 'BR', 'BRA', 'America', '127.93');
INSERT INTO public.europe_data_import VALUES (1357, '02/11/2020', '2020-44', '151577', '2940', '211049519', 'Brazil', 'BR', 'BRA', 'America', '147.06');
INSERT INTO public.europe_data_import VALUES (1358, '26/10/2020', '2020-43', '158784', '3229', '211049519', 'Brazil', 'BR', 'BRA', 'America', '141.74');
INSERT INTO public.europe_data_import VALUES (1359, '19/10/2020', '2020-42', '140362', '3417', '211049519', 'Brazil', 'BR', 'BRA', 'America', '151.65');
INSERT INTO public.europe_data_import VALUES (1360, '12/10/2020', '2020-41', '179693', '4136', '211049519', 'Brazil', 'BR', 'BRA', 'America', '171.84');
INSERT INTO public.europe_data_import VALUES (1361, '05/10/2020', '2020-40', '182980', '4611', '211049519', 'Brazil', 'BR', 'BRA', 'America', '175.63');
INSERT INTO public.europe_data_import VALUES (1362, '28/09/2020', '2020-39', '187680', '4846', '211049519', 'Brazil', 'BR', 'BRA', 'America', '190.41');
INSERT INTO public.europe_data_import VALUES (1363, '21/09/2020', '2020-38', '214174', '5270', '211049519', 'Brazil', 'BR', 'BRA', 'America', '192.9');
INSERT INTO public.europe_data_import VALUES (1364, '14/09/2020', '2020-37', '192934', '4975', '211049519', 'Brazil', 'BR', 'BRA', 'America', '221.82');
INSERT INTO public.europe_data_import VALUES (1365, '07/09/2020', '2020-36', '275210', '5822', '211049519', 'Brazil', 'BR', 'BRA', 'America', '251.95');
INSERT INTO public.europe_data_import VALUES (1366, '31/08/2020', '2020-35', '256528', '6084', '211049519', 'Brazil', 'BR', 'BRA', 'America', '247.39');
INSERT INTO public.europe_data_import VALUES (1367, '24/08/2020', '2020-34', '265586', '6892', '211049519', 'Brazil', 'BR', 'BRA', 'America', '270.25');
INSERT INTO public.europe_data_import VALUES (1368, '17/08/2020', '2020-33', '304775', '6803', '211049519', 'Brazil', 'BR', 'BRA', 'America', '287.38');
INSERT INTO public.europe_data_import VALUES (1369, '10/08/2020', '2020-32', '301745', '6945', '211049519', 'Brazil', 'BR', 'BRA', 'America', '292.03');
INSERT INTO public.europe_data_import VALUES (1370, '03/08/2020', '2020-31', '314586', '7100', '211049519', 'Brazil', 'BR', 'BRA', 'America', '301.01');
INSERT INTO public.europe_data_import VALUES (1371, '27/07/2020', '2020-30', '320702', '7516', '211049519', 'Brazil', 'BR', 'BRA', 'America', '262.69');
INSERT INTO public.europe_data_import VALUES (1372, '20/07/2020', '2020-29', '233708', '7388', '211049519', 'Brazil', 'BR', 'BRA', 'America', '234.7');
INSERT INTO public.europe_data_import VALUES (1373, '13/07/2020', '2020-28', '261626', '7233', '211049519', 'Brazil', 'BR', 'BRA', 'America', '246.64');
INSERT INTO public.europe_data_import VALUES (1374, '06/07/2020', '2020-27', '258912', '7245', '211049519', 'Brazil', 'BR', 'BRA', 'America', '245.45');
INSERT INTO public.europe_data_import VALUES (1375, '29/06/2020', '2020-26', '259105', '7005', '211049519', 'Brazil', 'BR', 'BRA', 'America', '225.79');
INSERT INTO public.europe_data_import VALUES (1376, '22/06/2020', '2020-25', '217414', '7285', '211049519', 'Brazil', 'BR', 'BRA', 'America', '186.34');
INSERT INTO public.europe_data_import VALUES (1377, '15/06/2020', '2020-24', '175866', '6877', '211049519', 'Brazil', 'BR', 'BRA', 'America', '167.15');
INSERT INTO public.europe_data_import VALUES (1378, '08/06/2020', '2020-23', '176909', '7141', '211049519', 'Brazil', 'BR', 'BRA', 'America', '155.67');
INSERT INTO public.europe_data_import VALUES (1379, '01/06/2020', '2020-22', '151638', '6648', '211049519', 'Brazil', 'BR', 'BRA', 'America', '129.72');
INSERT INTO public.europe_data_import VALUES (1380, '25/05/2020', '2020-21', '122131', '6548', '211049519', 'Brazil', 'BR', 'BRA', 'America', '95.01');
INSERT INTO public.europe_data_import VALUES (1381, '18/05/2020', '2020-20', '78381', '4995', '211049519', 'Brazil', 'BR', 'BRA', 'America', '66.3');
INSERT INTO public.europe_data_import VALUES (1382, '11/05/2020', '2020-19', '61552', '4098', '211049519', 'Brazil', 'BR', 'BRA', 'America', '47.77');
INSERT INTO public.europe_data_import VALUES (1383, '04/05/2020', '2020-18', '39259', '2820', '211049519', 'Brazil', 'BR', 'BRA', 'America', '29.61');
INSERT INTO public.europe_data_import VALUES (1384, '27/04/2020', '2020-17', '23234', '1743', '211049519', 'Brazil', 'BR', 'BRA', 'America', '18.82');
INSERT INTO public.europe_data_import VALUES (1385, '20/04/2020', '2020-16', '16485', '1239', '211049519', 'Brazil', 'BR', 'BRA', 'America', '13.04');
INSERT INTO public.europe_data_import VALUES (1386, '13/04/2020', '2020-15', '11039', '737', '211049519', 'Brazil', 'BR', 'BRA', 'America', '8.49');
INSERT INTO public.europe_data_import VALUES (1387, '06/04/2020', '2020-14', '6874', '350', '211049519', 'Brazil', 'BR', 'BRA', 'America', '4.54');
INSERT INTO public.europe_data_import VALUES (1388, '30/03/2020', '2020-13', '2710', '111', '211049519', 'Brazil', 'BR', 'BRA', 'America', '1.92');
INSERT INTO public.europe_data_import VALUES (1389, '23/03/2020', '2020-12', '1346', '25', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (1390, '16/03/2020', '2020-11', '175', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.09');
INSERT INTO public.europe_data_import VALUES (1391, '09/03/2020', '2020-10', '23', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1392, '02/03/2020', '2020-09', '2', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (1393, '24/02/2020', '2020-08', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1394, '17/02/2020', '2020-07', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1395, '10/02/2020', '2020-06', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1396, '03/02/2020', '2020-05', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1397, '27/01/2020', '2020-04', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1398, '20/01/2020', '2020-03', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1399, '13/01/2020', '2020-02', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1400, '06/01/2020', '2020-01', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '');
INSERT INTO public.europe_data_import VALUES (1401, '01/02/2021', '2021-04', '4', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '66.59');
INSERT INTO public.europe_data_import VALUES (1402, '25/01/2021', '2021-03', '16', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '133.19');
INSERT INTO public.europe_data_import VALUES (1403, '18/01/2021', '2021-02', '24', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '79.91');
INSERT INTO public.europe_data_import VALUES (1404, '11/01/2021', '2021-01', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '13.32');
INSERT INTO public.europe_data_import VALUES (1405, '04/01/2021', '2020-53', '4', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '36.63');
INSERT INTO public.europe_data_import VALUES (1406, '28/12/2020', '2020-52', '7', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '43.29');
INSERT INTO public.europe_data_import VALUES (1407, '21/12/2020', '2020-51', '6', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '43.29');
INSERT INTO public.europe_data_import VALUES (1408, '14/12/2020', '2020-50', '7', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '23.31');
INSERT INTO public.europe_data_import VALUES (1409, '07/12/2020', '2020-49', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1410, '30/11/2020', '2020-48', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1411, '23/11/2020', '2020-47', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1412, '16/11/2020', '2020-46', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1413, '09/11/2020', '2020-45', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1414, '02/11/2020', '2020-44', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1415, '26/10/2020', '2020-43', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1416, '19/10/2020', '2020-42', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1417, '12/10/2020', '2020-41', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1418, '05/10/2020', '2020-40', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1419, '28/09/2020', '2020-39', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '16.65');
INSERT INTO public.europe_data_import VALUES (1420, '21/09/2020', '2020-38', '5', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '26.64');
INSERT INTO public.europe_data_import VALUES (1421, '14/09/2020', '2020-37', '3', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '96.56');
INSERT INTO public.europe_data_import VALUES (1422, '07/09/2020', '2020-36', '26', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '139.85');
INSERT INTO public.europe_data_import VALUES (1423, '31/08/2020', '2020-35', '16', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '93.23');
INSERT INTO public.europe_data_import VALUES (1424, '24/08/2020', '2020-34', '12', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '39.96');
INSERT INTO public.europe_data_import VALUES (1425, '17/08/2020', '2020-33', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1426, '10/08/2020', '2020-32', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1427, '03/08/2020', '2020-31', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1428, '27/07/2020', '2020-30', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1429, '20/07/2020', '2020-29', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1430, '13/07/2020', '2020-28', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1431, '06/07/2020', '2020-27', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1432, '29/06/2020', '2020-26', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1433, '22/06/2020', '2020-25', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1434, '15/06/2020', '2020-24', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1435, '08/06/2020', '2020-23', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1436, '01/06/2020', '2020-22', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1437, '25/05/2020', '2020-21', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1438, '18/05/2020', '2020-20', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '6.66');
INSERT INTO public.europe_data_import VALUES (1439, '11/05/2020', '2020-19', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1440, '04/05/2020', '2020-18', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '6.66');
INSERT INTO public.europe_data_import VALUES (1441, '27/04/2020', '2020-17', '2', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '9.99');
INSERT INTO public.europe_data_import VALUES (1442, '20/04/2020', '2020-16', '1', '1', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1443, '13/04/2020', '2020-15', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1444, '06/04/2020', '2020-14', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '9.99');
INSERT INTO public.europe_data_import VALUES (1445, '30/03/2020', '2020-13', '2', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '');
INSERT INTO public.europe_data_import VALUES (1446, '01/02/2021', '2021-04', '5', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '1.38');
INSERT INTO public.europe_data_import VALUES (1447, '25/01/2021', '2021-03', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1448, '18/01/2021', '2021-02', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1449, '11/01/2021', '2021-01', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '4.85');
INSERT INTO public.europe_data_import VALUES (1450, '04/01/2021', '2020-53', '20', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '4.62');
INSERT INTO public.europe_data_import VALUES (1451, '28/12/2020', '2020-52', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1452, '21/12/2020', '2020-51', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1453, '14/12/2020', '2020-50', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1454, '07/12/2020', '2020-49', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1455, '30/11/2020', '2020-48', '2', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1456, '23/11/2020', '2020-47', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1457, '16/11/2020', '2020-46', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1458, '09/11/2020', '2020-45', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1459, '02/11/2020', '2020-44', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1460, '26/10/2020', '2020-43', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1461, '19/10/2020', '2020-42', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1462, '12/10/2020', '2020-41', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1463, '05/10/2020', '2020-40', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1464, '28/09/2020', '2020-39', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1465, '21/09/2020', '2020-38', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1466, '14/09/2020', '2020-37', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1467, '07/09/2020', '2020-36', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1468, '31/08/2020', '2020-35', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1469, '24/08/2020', '2020-34', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1470, '17/08/2020', '2020-33', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1471, '10/08/2020', '2020-32', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1472, '03/08/2020', '2020-31', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1473, '27/07/2020', '2020-30', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1474, '20/07/2020', '2020-29', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1475, '13/07/2020', '2020-28', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1476, '06/07/2020', '2020-27', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1477, '29/06/2020', '2020-26', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1478, '22/06/2020', '2020-25', '0', '1', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1479, '15/06/2020', '2020-24', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1480, '08/06/2020', '2020-23', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1481, '01/06/2020', '2020-22', '0', '1', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1482, '25/05/2020', '2020-21', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1483, '18/05/2020', '2020-20', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1484, '11/05/2020', '2020-19', '3', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1485, '04/05/2020', '2020-18', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1486, '27/04/2020', '2020-17', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1487, '20/04/2020', '2020-16', '2', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1488, '13/04/2020', '2020-15', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '2.31');
INSERT INTO public.europe_data_import VALUES (1489, '06/04/2020', '2020-14', '9', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '10.85');
INSERT INTO public.europe_data_import VALUES (1490, '30/03/2020', '2020-13', '38', '1', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '17.54');
INSERT INTO public.europe_data_import VALUES (1491, '23/03/2020', '2020-12', '38', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '20.31');
INSERT INTO public.europe_data_import VALUES (1492, '16/03/2020', '2020-11', '50', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (1493, '01/02/2021', '2021-04', '3931', '225', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '99.07');
INSERT INTO public.europe_data_import VALUES (1494, '25/01/2021', '2021-03', '3004', '337', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '90.09');
INSERT INTO public.europe_data_import VALUES (1495, '18/01/2021', '2021-02', '3302', '357', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '125.17');
INSERT INTO public.europe_data_import VALUES (1496, '11/01/2021', '2021-01', '5460', '448', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '154.21');
INSERT INTO public.europe_data_import VALUES (1497, '04/01/2021', '2020-53', '5335', '514', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '169.37');
INSERT INTO public.europe_data_import VALUES (1498, '28/12/2020', '2020-52', '6521', '555', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '260.96');
INSERT INTO public.europe_data_import VALUES (1499, '21/12/2020', '2020-51', '11746', '921', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '425.34');
INSERT INTO public.europe_data_import VALUES (1500, '14/12/2020', '2020-50', '18028', '891', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '528.04');
INSERT INTO public.europe_data_import VALUES (1501, '07/12/2020', '2020-49', '18935', '983', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '565.73');
INSERT INTO public.europe_data_import VALUES (1502, '30/11/2020', '2020-48', '20666', '934', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '631.93');
INSERT INTO public.europe_data_import VALUES (1503, '23/11/2020', '2020-47', '23569', '750', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '666.57');
INSERT INTO public.europe_data_import VALUES (1504, '16/11/2020', '2020-46', '23091', '465', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '631.17');
INSERT INTO public.europe_data_import VALUES (1505, '09/11/2020', '2020-45', '21091', '367', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '532.44');
INSERT INTO public.europe_data_import VALUES (1506, '02/11/2020', '2020-44', '16180', '204', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '350.94');
INSERT INTO public.europe_data_import VALUES (1507, '26/10/2020', '2020-43', '8386', '108', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '192.67');
INSERT INTO public.europe_data_import VALUES (1508, '19/10/2020', '2020-42', '5101', '94', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '113.09');
INSERT INTO public.europe_data_import VALUES (1509, '12/10/2020', '2020-41', '2815', '48', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '62.1');
INSERT INTO public.europe_data_import VALUES (1510, '05/10/2020', '2020-40', '1532', '48', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '38.91');
INSERT INTO public.europe_data_import VALUES (1511, '28/09/2020', '2020-39', '1192', '35', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '30.53');
INSERT INTO public.europe_data_import VALUES (1512, '21/09/2020', '2020-38', '945', '41', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '25.9');
INSERT INTO public.europe_data_import VALUES (1513, '14/09/2020', '2020-37', '868', '49', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '24.69');
INSERT INTO public.europe_data_import VALUES (1514, '07/09/2020', '2020-36', '860', '58', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '25.19');
INSERT INTO public.europe_data_import VALUES (1515, '31/08/2020', '2020-35', '903', '68', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '26.07');
INSERT INTO public.europe_data_import VALUES (1516, '24/08/2020', '2020-34', '922', '47', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '27.01');
INSERT INTO public.europe_data_import VALUES (1517, '17/08/2020', '2020-33', '969', '51', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '34.43');
INSERT INTO public.europe_data_import VALUES (1518, '10/08/2020', '2020-32', '1441', '59', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '42.41');
INSERT INTO public.europe_data_import VALUES (1519, '03/08/2020', '2020-31', '1528', '48', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '46.03');
INSERT INTO public.europe_data_import VALUES (1520, '27/07/2020', '2020-30', '1694', '40', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '45.36');
INSERT INTO public.europe_data_import VALUES (1521, '20/07/2020', '2020-29', '1481', '32', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '42.76');
INSERT INTO public.europe_data_import VALUES (1522, '13/07/2020', '2020-28', '1512', '22', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '36.59');
INSERT INTO public.europe_data_import VALUES (1523, '06/07/2020', '2020-27', '1049', '27', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '26.21');
INSERT INTO public.europe_data_import VALUES (1524, '29/06/2020', '2020-26', '786', '20', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '20.01');
INSERT INTO public.europe_data_import VALUES (1525, '22/06/2020', '2020-25', '615', '25', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '16.83');
INSERT INTO public.europe_data_import VALUES (1526, '15/06/2020', '2020-24', '563', '14', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '11.1');
INSERT INTO public.europe_data_import VALUES (1527, '08/06/2020', '2020-23', '214', '20', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.2');
INSERT INTO public.europe_data_import VALUES (1528, '01/06/2020', '2020-22', '80', '10', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '3.97');
INSERT INTO public.europe_data_import VALUES (1529, '25/05/2020', '2020-21', '198', '20', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '6.69');
INSERT INTO public.europe_data_import VALUES (1530, '18/05/2020', '2020-20', '270', '19', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '8.81');
INSERT INTO public.europe_data_import VALUES (1531, '11/05/2020', '2020-19', '347', '18', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '9.5');
INSERT INTO public.europe_data_import VALUES (1532, '04/05/2020', '2020-18', '318', '17', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '10.04');
INSERT INTO public.europe_data_import VALUES (1533, '27/04/2020', '2020-17', '385', '13', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '8.93');
INSERT INTO public.europe_data_import VALUES (1534, '20/04/2020', '2020-16', '240', '14', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '5.49');
INSERT INTO public.europe_data_import VALUES (1535, '13/04/2020', '2020-15', '144', '9', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.7');
INSERT INTO public.europe_data_import VALUES (1536, '06/04/2020', '2020-14', '185', '12', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.94');
INSERT INTO public.europe_data_import VALUES (1537, '30/03/2020', '2020-13', '161', '5', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.21');
INSERT INTO public.europe_data_import VALUES (1538, '23/03/2020', '2020-12', '134', '1', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '2.59');
INSERT INTO public.europe_data_import VALUES (1539, '16/03/2020', '2020-11', '47', '2', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '0.73');
INSERT INTO public.europe_data_import VALUES (1540, '09/03/2020', '2020-10', '4', '0', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (1541, '01/02/2021', '2021-04', '665', '4', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '7.78');
INSERT INTO public.europe_data_import VALUES (1542, '25/01/2021', '2021-03', '915', '15', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.0');
INSERT INTO public.europe_data_import VALUES (1543, '18/01/2021', '2021-02', '913', '13', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '10.52');
INSERT INTO public.europe_data_import VALUES (1544, '11/01/2021', '2021-01', '1224', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.5');
INSERT INTO public.europe_data_import VALUES (1545, '04/01/2021', '2020-53', '707', '8', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.31');
INSERT INTO public.europe_data_import VALUES (1546, '28/12/2020', '2020-52', '1184', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '11.39');
INSERT INTO public.europe_data_import VALUES (1547, '21/12/2020', '2020-51', '1130', '5', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.59');
INSERT INTO public.europe_data_import VALUES (1548, '14/12/2020', '2020-50', '818', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '5.78');
INSERT INTO public.europe_data_import VALUES (1549, '07/12/2020', '2020-49', '356', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '2.35');
INSERT INTO public.europe_data_import VALUES (1550, '30/11/2020', '2020-48', '121', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (1551, '23/11/2020', '2020-47', '94', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (1552, '16/11/2020', '2020-46', '72', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1553, '09/11/2020', '2020-45', '69', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.58');
INSERT INTO public.europe_data_import VALUES (1554, '02/11/2020', '2020-44', '49', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (1555, '26/10/2020', '2020-43', '70', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (1556, '19/10/2020', '2020-42', '101', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (1557, '12/10/2020', '2020-41', '113', '4', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (1558, '05/10/2020', '2020-40', '159', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.58');
INSERT INTO public.europe_data_import VALUES (1559, '28/09/2020', '2020-39', '162', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.48');
INSERT INTO public.europe_data_import VALUES (1560, '21/09/2020', '2020-38', '139', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (1561, '14/09/2020', '2020-37', '255', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (1562, '07/09/2020', '2020-36', '84', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (1563, '31/08/2020', '2020-35', '40', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (1564, '24/08/2020', '2020-34', '61', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (1565, '17/08/2020', '2020-33', '63', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.58');
INSERT INTO public.europe_data_import VALUES (1566, '10/08/2020', '2020-32', '54', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (1567, '03/08/2020', '2020-31', '50', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1568, '27/07/2020', '2020-30', '35', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (1569, '20/07/2020', '2020-29', '29', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (1570, '13/07/2020', '2020-28', '49', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (1571, '06/07/2020', '2020-27', '28', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1572, '29/06/2020', '2020-26', '56', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (1573, '22/06/2020', '2020-25', '9', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (1574, '15/06/2020', '2020-24', '5', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (1575, '08/06/2020', '2020-23', '8', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1576, '01/06/2020', '2020-22', '49', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1577, '25/05/2020', '2020-21', '36', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (1578, '18/05/2020', '2020-20', '45', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (1579, '11/05/2020', '2020-19', '89', '4', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (1580, '04/05/2020', '2020-18', '30', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1581, '27/04/2020', '2020-17', '56', '6', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (1582, '20/04/2020', '2020-16', '79', '9', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (1583, '13/04/2020', '2020-15', '152', '10', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (1584, '06/04/2020', '2020-14', '165', '8', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (1585, '30/03/2020', '2020-13', '116', '6', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (1586, '23/03/2020', '2020-12', '61', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (1587, '16/03/2020', '2020-11', '3', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1588, '01/02/2021', '2021-04', '156', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (1589, '25/01/2021', '2021-03', '243', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '3.99');
INSERT INTO public.europe_data_import VALUES (1590, '18/01/2021', '2021-02', '217', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '3.5');
INSERT INTO public.europe_data_import VALUES (1591, '11/01/2021', '2021-01', '186', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '1.82');
INSERT INTO public.europe_data_import VALUES (1592, '04/01/2021', '2020-53', '24', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (1593, '28/12/2020', '2020-52', '48', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1594, '21/12/2020', '2020-51', '32', '1', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.58');
INSERT INTO public.europe_data_import VALUES (1595, '14/12/2020', '2020-50', '35', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1596, '07/12/2020', '2020-49', '13', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1597, '30/11/2020', '2020-48', '19', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (1598, '23/11/2020', '2020-47', '34', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1599, '16/11/2020', '2020-46', '14', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (1600, '09/11/2020', '2020-45', '25', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (1601, '02/11/2020', '2020-44', '33', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1602, '26/10/2020', '2020-43', '14', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1603, '19/10/2020', '2020-42', '18', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1604, '12/10/2020', '2020-41', '11', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (1605, '05/10/2020', '2020-40', '28', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (1606, '28/09/2020', '2020-39', '12', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1607, '21/09/2020', '2020-38', '1', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (1608, '14/09/2020', '2020-37', '10', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1609, '07/09/2020', '2020-36', '17', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (1610, '31/08/2020', '2020-35', '16', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1611, '24/08/2020', '2020-34', '16', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (1612, '17/08/2020', '2020-33', '5', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (1613, '10/08/2020', '2020-32', '13', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1614, '03/08/2020', '2020-31', '34', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (1615, '27/07/2020', '2020-30', '51', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (1616, '20/07/2020', '2020-29', '60', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1617, '13/07/2020', '2020-28', '59', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1618, '06/07/2020', '2020-27', '21', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1619, '29/06/2020', '2020-26', '26', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (1620, '22/06/2020', '2020-25', '50', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1621, '15/06/2020', '2020-24', '11', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (1622, '08/06/2020', '2020-23', '20', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (1623, '01/06/2020', '2020-22', '21', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (1624, '25/05/2020', '2020-21', '0', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (1625, '18/05/2020', '2020-20', '23', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (1626, '11/05/2020', '2020-19', '0', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (1627, '04/05/2020', '2020-18', '4', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1628, '27/04/2020', '2020-17', '9', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1629, '20/04/2020', '2020-16', '1', '1', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (1630, '13/04/2020', '2020-15', '2', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (1631, '06/04/2020', '2020-14', '3', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1632, '01/02/2021', '2021-04', '8', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (1633, '25/01/2021', '2021-03', '17', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.41');
INSERT INTO public.europe_data_import VALUES (1634, '18/01/2021', '2021-02', '50', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.36');
INSERT INTO public.europe_data_import VALUES (1635, '11/01/2021', '2021-01', '9', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (1636, '04/01/2021', '2020-53', '18', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (1637, '28/12/2020', '2020-52', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (1638, '21/12/2020', '2020-51', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (1639, '14/12/2020', '2020-50', '11', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (1640, '07/12/2020', '2020-49', '25', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (1641, '30/11/2020', '2020-48', '17', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (1642, '23/11/2020', '2020-47', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (1643, '16/11/2020', '2020-46', '5', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (1644, '09/11/2020', '2020-45', '6', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (1645, '02/11/2020', '2020-44', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (1646, '26/10/2020', '2020-43', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1647, '19/10/2020', '2020-42', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1648, '12/10/2020', '2020-41', '3', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (1649, '05/10/2020', '2020-40', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (1650, '28/09/2020', '2020-39', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1651, '21/09/2020', '2020-38', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1652, '14/09/2020', '2020-37', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1653, '07/09/2020', '2020-36', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1654, '31/08/2020', '2020-35', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1655, '24/08/2020', '2020-34', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (1656, '17/08/2020', '2020-33', '22', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.2');
INSERT INTO public.europe_data_import VALUES (1657, '10/08/2020', '2020-32', '11', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (1658, '03/08/2020', '2020-31', '15', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (1659, '27/07/2020', '2020-30', '54', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (1660, '20/07/2020', '2020-29', '15', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.18');
INSERT INTO public.europe_data_import VALUES (1661, '13/07/2020', '2020-28', '15', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (1662, '06/07/2020', '2020-27', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (1663, '29/06/2020', '2020-26', '12', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (1664, '22/06/2020', '2020-25', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1665, '15/06/2020', '2020-24', '2', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1666, '08/06/2020', '2020-23', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1667, '01/06/2020', '2020-22', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1668, '25/05/2020', '2020-21', '2', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1669, '18/05/2020', '2020-20', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1670, '11/05/2020', '2020-19', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1671, '04/05/2020', '2020-18', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1672, '27/04/2020', '2020-17', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1673, '20/04/2020', '2020-16', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (1674, '13/04/2020', '2020-15', '8', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (1675, '06/04/2020', '2020-14', '7', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (1676, '30/03/2020', '2020-13', '21', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (1677, '23/03/2020', '2020-12', '74', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.51');
INSERT INTO public.europe_data_import VALUES (1678, '16/03/2020', '2020-11', '10', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (1679, '09/03/2020', '2020-10', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1680, '02/03/2020', '2020-09', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1681, '24/02/2020', '2020-08', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1682, '17/02/2020', '2020-07', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1683, '10/02/2020', '2020-06', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1684, '03/02/2020', '2020-05', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1685, '27/01/2020', '2020-04', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1686, '20/01/2020', '2020-03', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1687, '13/01/2020', '2020-02', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1688, '06/01/2020', '2020-01', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (1689, '01/02/2021', '2021-04', '696', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '8.9');
INSERT INTO public.europe_data_import VALUES (1690, '25/01/2021', '2021-03', '1607', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '10.7');
INSERT INTO public.europe_data_import VALUES (1691, '18/01/2021', '2021-02', '1162', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.49');
INSERT INTO public.europe_data_import VALUES (1692, '11/01/2021', '2021-01', '0', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (1693, '04/01/2021', '2020-53', '571', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.86');
INSERT INTO public.europe_data_import VALUES (1694, '28/12/2020', '2020-52', '428', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.55');
INSERT INTO public.europe_data_import VALUES (1695, '21/12/2020', '2020-51', '490', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.24');
INSERT INTO public.europe_data_import VALUES (1696, '14/12/2020', '2020-50', '607', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.8');
INSERT INTO public.europe_data_import VALUES (1697, '07/12/2020', '2020-49', '635', '6', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.73');
INSERT INTO public.europe_data_import VALUES (1698, '30/11/2020', '2020-48', '589', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '5.51');
INSERT INTO public.europe_data_import VALUES (1699, '23/11/2020', '2020-47', '836', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.28');
INSERT INTO public.europe_data_import VALUES (1700, '16/11/2020', '2020-46', '271', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.47');
INSERT INTO public.europe_data_import VALUES (1701, '09/11/2020', '2020-45', '628', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.29');
INSERT INTO public.europe_data_import VALUES (1702, '02/11/2020', '2020-44', '223', '1', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (1703, '26/10/2020', '2020-43', '129', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.42');
INSERT INTO public.europe_data_import VALUES (1704, '19/10/2020', '2020-42', '238', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (1705, '12/10/2020', '2020-41', '279', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (1706, '05/10/2020', '2020-40', '189', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.91');
INSERT INTO public.europe_data_import VALUES (1707, '28/09/2020', '2020-39', '304', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (1708, '21/09/2020', '2020-38', '264', '1', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.2');
INSERT INTO public.europe_data_import VALUES (1709, '14/09/2020', '2020-37', '563', '1', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.96');
INSERT INTO public.europe_data_import VALUES (1710, '07/09/2020', '2020-36', '462', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.25');
INSERT INTO public.europe_data_import VALUES (1711, '31/08/2020', '2020-35', '380', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.6');
INSERT INTO public.europe_data_import VALUES (1712, '24/08/2020', '2020-34', '293', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.78');
INSERT INTO public.europe_data_import VALUES (1713, '17/08/2020', '2020-33', '427', '6', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.69');
INSERT INTO public.europe_data_import VALUES (1714, '10/08/2020', '2020-32', '787', '8', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '5.16');
INSERT INTO public.europe_data_import VALUES (1715, '03/08/2020', '2020-31', '547', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.24');
INSERT INTO public.europe_data_import VALUES (1716, '27/07/2020', '2020-30', '551', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '5.93');
INSERT INTO public.europe_data_import VALUES (1717, '20/07/2020', '2020-29', '984', '14', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '9.45');
INSERT INTO public.europe_data_import VALUES (1718, '13/07/2020', '2020-28', '1462', '31', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '9.97');
INSERT INTO public.europe_data_import VALUES (1719, '06/07/2020', '2020-27', '1119', '15', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '8.12');
INSERT INTO public.europe_data_import VALUES (1720, '29/06/2020', '2020-26', '982', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '10.54');
INSERT INTO public.europe_data_import VALUES (1721, '22/06/2020', '2020-25', '1746', '25', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '14.31');
INSERT INTO public.europe_data_import VALUES (1722, '15/06/2020', '2020-24', '1956', '73', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '15.3');
INSERT INTO public.europe_data_import VALUES (1723, '08/06/2020', '2020-23', '2004', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '11.66');
INSERT INTO public.europe_data_import VALUES (1724, '01/06/2020', '2020-22', '1014', '26', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '10.09');
INSERT INTO public.europe_data_import VALUES (1725, '25/05/2020', '2020-21', '1598', '25', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '8.93');
INSERT INTO public.europe_data_import VALUES (1726, '18/05/2020', '2020-20', '713', '26', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.7');
INSERT INTO public.europe_data_import VALUES (1727, '11/05/2020', '2020-19', '502', '50', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.7');
INSERT INTO public.europe_data_import VALUES (1728, '04/05/2020', '2020-18', '456', '8', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.1');
INSERT INTO public.europe_data_import VALUES (1729, '27/04/2020', '2020-17', '605', '14', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (1730, '20/04/2020', '2020-16', '196', '30', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (1731, '13/04/2020', '2020-15', '170', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.79');
INSERT INTO public.europe_data_import VALUES (1732, '06/04/2020', '2020-14', '551', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.41');
INSERT INTO public.europe_data_import VALUES (1733, '30/03/2020', '2020-13', '72', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (1734, '23/03/2020', '2020-12', '23', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (1735, '16/03/2020', '2020-11', '2', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (1736, '09/03/2020', '2020-10', '2', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1737, '01/02/2021', '2021-04', '30578', '898', '37411038', 'Canada', 'CA', 'CAN', 'America', '183.15');
INSERT INTO public.europe_data_import VALUES (1738, '25/01/2021', '2021-03', '37939', '1118', '37411038', 'Canada', 'CA', 'CAN', 'America', '226.75');
INSERT INTO public.europe_data_import VALUES (1739, '18/01/2021', '2021-02', '46891', '1034', '37411038', 'Canada', 'CA', 'CAN', 'America', '303.14');
INSERT INTO public.europe_data_import VALUES (1740, '11/01/2021', '2021-01', '66518', '1221', '37411038', 'Canada', 'CA', 'CAN', 'America', '310.5');
INSERT INTO public.europe_data_import VALUES (1741, '04/01/2021', '2020-53', '49643', '901', '37411038', 'Canada', 'CA', 'CAN', 'America', '230.81');
INSERT INTO public.europe_data_import VALUES (1742, '28/12/2020', '2020-52', '36706', '632', '37411038', 'Canada', 'CA', 'CAN', 'America', '243.98');
INSERT INTO public.europe_data_import VALUES (1743, '21/12/2020', '2020-51', '54571', '901', '37411038', 'Canada', 'CA', 'CAN', 'America', '267.65');
INSERT INTO public.europe_data_import VALUES (1744, '14/12/2020', '2020-50', '45561', '766', '37411038', 'Canada', 'CA', 'CAN', 'America', '241.81');
INSERT INTO public.europe_data_import VALUES (1745, '07/12/2020', '2020-49', '44904', '633', '37411038', 'Canada', 'CA', 'CAN', 'America', '226.35');
INSERT INTO public.europe_data_import VALUES (1746, '30/11/2020', '2020-48', '39775', '577', '37411038', 'Canada', 'CA', 'CAN', 'America', '198.34');
INSERT INTO public.europe_data_import VALUES (1747, '23/11/2020', '2020-47', '34426', '502', '37411038', 'Canada', 'CA', 'CAN', 'America', '177.46');
INSERT INTO public.europe_data_import VALUES (1748, '16/11/2020', '2020-46', '31964', '431', '37411038', 'Canada', 'CA', 'CAN', 'America', '158.34');
INSERT INTO public.europe_data_import VALUES (1749, '09/11/2020', '2020-45', '27272', '343', '37411038', 'Canada', 'CA', 'CAN', 'America', '128.33');
INSERT INTO public.europe_data_import VALUES (1750, '02/11/2020', '2020-44', '20737', '233', '37411038', 'Canada', 'CA', 'CAN', 'America', '103.43');
INSERT INTO public.europe_data_import VALUES (1751, '26/10/2020', '2020-43', '17956', '186', '37411038', 'Canada', 'CA', 'CAN', 'America', '101.54');
INSERT INTO public.europe_data_import VALUES (1752, '19/10/2020', '2020-42', '20031', '175', '37411038', 'Canada', 'CA', 'CAN', 'America', '85.51');
INSERT INTO public.europe_data_import VALUES (1753, '12/10/2020', '2020-41', '11961', '104', '37411038', 'Canada', 'CA', 'CAN', 'America', '66.8');
INSERT INTO public.europe_data_import VALUES (1754, '05/10/2020', '2020-40', '13031', '213', '37411038', 'Canada', 'CA', 'CAN', 'America', '60.16');
INSERT INTO public.europe_data_import VALUES (1755, '28/09/2020', '2020-39', '9476', '51', '37411038', 'Canada', 'CA', 'CAN', 'America', '44.01');
INSERT INTO public.europe_data_import VALUES (1756, '21/09/2020', '2020-38', '6990', '46', '37411038', 'Canada', 'CA', 'CAN', 'America', '31.42');
INSERT INTO public.europe_data_import VALUES (1757, '14/09/2020', '2020-37', '4764', '26', '37411038', 'Canada', 'CA', 'CAN', 'America', '23.31');
INSERT INTO public.europe_data_import VALUES (1758, '07/09/2020', '2020-36', '3955', '28', '37411038', 'Canada', 'CA', 'CAN', 'America', '18.71');
INSERT INTO public.europe_data_import VALUES (1759, '31/08/2020', '2020-35', '3044', '44', '37411038', 'Canada', 'CA', 'CAN', 'America', '15.65');
INSERT INTO public.europe_data_import VALUES (1760, '24/08/2020', '2020-34', '2809', '47', '37411038', 'Canada', 'CA', 'CAN', 'America', '14.55');
INSERT INTO public.europe_data_import VALUES (1761, '17/08/2020', '2020-33', '2636', '45', '37411038', 'Canada', 'CA', 'CAN', 'America', '13.95');
INSERT INTO public.europe_data_import VALUES (1762, '10/08/2020', '2020-32', '2581', '36', '37411038', 'Canada', 'CA', 'CAN', 'America', '14.84');
INSERT INTO public.europe_data_import VALUES (1763, '03/08/2020', '2020-31', '2972', '55', '37411038', 'Canada', 'CA', 'CAN', 'America', '17.46');
INSERT INTO public.europe_data_import VALUES (1764, '27/07/2020', '2020-30', '3560', '38', '37411038', 'Canada', 'CA', 'CAN', 'America', '16.89');
INSERT INTO public.europe_data_import VALUES (1765, '20/07/2020', '2020-29', '2759', '69', '37411038', 'Canada', 'CA', 'CAN', 'America', '12.87');
INSERT INTO public.europe_data_import VALUES (1766, '13/07/2020', '2020-28', '2055', '99', '37411038', 'Canada', 'CA', 'CAN', 'America', '11.6');
INSERT INTO public.europe_data_import VALUES (1767, '06/07/2020', '2020-27', '2285', '162', '37411038', 'Canada', 'CA', 'CAN', 'America', '11.22');
INSERT INTO public.europe_data_import VALUES (1768, '29/06/2020', '2020-26', '1913', '92', '37411038', 'Canada', 'CA', 'CAN', 'America', '11.93');
INSERT INTO public.europe_data_import VALUES (1769, '22/06/2020', '2020-25', '2550', '284', '37411038', 'Canada', 'CA', 'CAN', 'America', '15.07');
INSERT INTO public.europe_data_import VALUES (1770, '15/06/2020', '2020-24', '3088', '346', '37411038', 'Canada', 'CA', 'CAN', 'America', '20.96');
INSERT INTO public.europe_data_import VALUES (1771, '08/06/2020', '2020-23', '4752', '505', '37411038', 'Canada', 'CA', 'CAN', 'America', '29.4');
INSERT INTO public.europe_data_import VALUES (1772, '01/06/2020', '2020-22', '6248', '871', '37411038', 'Canada', 'CA', 'CAN', 'America', '37.28');
INSERT INTO public.europe_data_import VALUES (1773, '25/05/2020', '2020-21', '7697', '642', '37411038', 'Canada', 'CA', 'CAN', 'America', '42.34');
INSERT INTO public.europe_data_import VALUES (1774, '18/05/2020', '2020-20', '8143', '911', '37411038', 'Canada', 'CA', 'CAN', 'America', '46.82');
INSERT INTO public.europe_data_import VALUES (1775, '11/05/2020', '2020-19', '9374', '1189', '37411038', 'Canada', 'CA', 'CAN', 'America', '58.71');
INSERT INTO public.europe_data_import VALUES (1776, '04/05/2020', '2020-18', '12590', '1122', '37411038', 'Canada', 'CA', 'CAN', 'America', '66.02');
INSERT INTO public.europe_data_import VALUES (1777, '27/04/2020', '2020-17', '12107', '980', '37411038', 'Canada', 'CA', 'CAN', 'America', '60.19');
INSERT INTO public.europe_data_import VALUES (1778, '20/04/2020', '2020-16', '10412', '863', '37411038', 'Canada', 'CA', 'CAN', 'America', '51.54');
INSERT INTO public.europe_data_import VALUES (1779, '13/04/2020', '2020-15', '8869', '437', '37411038', 'Canada', 'CA', 'CAN', 'America', '48.41');
INSERT INTO public.europe_data_import VALUES (1780, '06/04/2020', '2020-14', '9241', '219', '37411038', 'Canada', 'CA', 'CAN', 'America', '37.6');
INSERT INTO public.europe_data_import VALUES (1781, '30/03/2020', '2020-13', '4825', '41', '37411038', 'Canada', 'CA', 'CAN', 'America', '15.91');
INSERT INTO public.europe_data_import VALUES (1782, '23/03/2020', '2020-12', '1126', '19', '37411038', 'Canada', 'CA', 'CAN', 'America', '3.66');
INSERT INTO public.europe_data_import VALUES (1783, '16/03/2020', '2020-11', '242', '1', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.75');
INSERT INTO public.europe_data_import VALUES (1784, '09/03/2020', '2020-10', '38', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.14');
INSERT INTO public.europe_data_import VALUES (1785, '02/03/2020', '2020-09', '15', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.04');
INSERT INTO public.europe_data_import VALUES (1786, '24/02/2020', '2020-08', '1', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1787, '17/02/2020', '2020-07', '1', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1788, '10/02/2020', '2020-06', '3', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (1789, '03/02/2020', '2020-05', '3', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1790, '27/01/2020', '2020-04', '1', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (1791, '20/01/2020', '2020-03', '0', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1792, '13/01/2020', '2020-02', '0', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1793, '06/01/2020', '2020-01', '0', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '');
INSERT INTO public.europe_data_import VALUES (1794, '01/02/2021', '2021-04', '609', '4', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '200.93');
INSERT INTO public.europe_data_import VALUES (1795, '25/01/2021', '2021-03', '496', '11', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '192.02');
INSERT INTO public.europe_data_import VALUES (1796, '18/01/2021', '2021-02', '560', '4', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '195.11');
INSERT INTO public.europe_data_import VALUES (1797, '11/01/2021', '2021-01', '513', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '129.11');
INSERT INTO public.europe_data_import VALUES (1798, '04/01/2021', '2020-53', '197', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '62.01');
INSERT INTO public.europe_data_import VALUES (1799, '28/12/2020', '2020-52', '144', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '66.55');
INSERT INTO public.europe_data_import VALUES (1800, '21/12/2020', '2020-51', '222', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '93.83');
INSERT INTO public.europe_data_import VALUES (1801, '14/12/2020', '2020-50', '294', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '151.11');
INSERT INTO public.europe_data_import VALUES (1802, '07/12/2020', '2020-49', '537', '5', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '143.11');
INSERT INTO public.europe_data_import VALUES (1803, '30/11/2020', '2020-48', '250', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '128.01');
INSERT INTO public.europe_data_import VALUES (1804, '23/11/2020', '2020-47', '454', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '164.93');
INSERT INTO public.europe_data_import VALUES (1805, '16/11/2020', '2020-46', '453', '3', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '177.11');
INSERT INTO public.europe_data_import VALUES (1806, '09/11/2020', '2020-45', '521', '5', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '176.93');
INSERT INTO public.europe_data_import VALUES (1807, '02/11/2020', '2020-44', '452', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '199.3');
INSERT INTO public.europe_data_import VALUES (1808, '26/10/2020', '2020-43', '644', '8', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '240.76');
INSERT INTO public.europe_data_import VALUES (1809, '19/10/2020', '2020-42', '680', '11', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '253.12');
INSERT INTO public.europe_data_import VALUES (1810, '12/10/2020', '2020-41', '712', '10', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '236.57');
INSERT INTO public.europe_data_import VALUES (1811, '05/10/2020', '2020-40', '589', '8', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '200.57');
INSERT INTO public.europe_data_import VALUES (1812, '28/09/2020', '2020-39', '514', '6', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '174.2');
INSERT INTO public.europe_data_import VALUES (1813, '21/09/2020', '2020-38', '444', '7', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '168.57');
INSERT INTO public.europe_data_import VALUES (1814, '14/09/2020', '2020-37', '483', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '174.75');
INSERT INTO public.europe_data_import VALUES (1815, '07/09/2020', '2020-36', '478', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '149.29');
INSERT INTO public.europe_data_import VALUES (1816, '31/08/2020', '2020-35', '343', '3', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '122.38');
INSERT INTO public.europe_data_import VALUES (1817, '24/08/2020', '2020-34', '330', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '118.38');
INSERT INTO public.europe_data_import VALUES (1818, '17/08/2020', '2020-33', '321', '3', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '114.92');
INSERT INTO public.europe_data_import VALUES (1819, '10/08/2020', '2020-32', '311', '8', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '100.19');
INSERT INTO public.europe_data_import VALUES (1820, '03/08/2020', '2020-31', '240', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '91.65');
INSERT INTO public.europe_data_import VALUES (1821, '27/07/2020', '2020-30', '264', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '110.74');
INSERT INTO public.europe_data_import VALUES (1822, '20/07/2020', '2020-29', '345', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '107.65');
INSERT INTO public.europe_data_import VALUES (1823, '13/07/2020', '2020-28', '247', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '98.74');
INSERT INTO public.europe_data_import VALUES (1824, '06/07/2020', '2020-27', '296', '5', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '102.01');
INSERT INTO public.europe_data_import VALUES (1825, '29/06/2020', '2020-26', '265', '4', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '73.64');
INSERT INTO public.europe_data_import VALUES (1826, '22/06/2020', '2020-25', '140', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '61.1');
INSERT INTO public.europe_data_import VALUES (1827, '15/06/2020', '2020-24', '196', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '57.28');
INSERT INTO public.europe_data_import VALUES (1828, '08/06/2020', '2020-23', '119', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '31.64');
INSERT INTO public.europe_data_import VALUES (1829, '01/06/2020', '2020-22', '55', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '19.46');
INSERT INTO public.europe_data_import VALUES (1830, '25/05/2020', '2020-21', '52', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '24.37');
INSERT INTO public.europe_data_import VALUES (1831, '18/05/2020', '2020-20', '82', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '29.64');
INSERT INTO public.europe_data_import VALUES (1832, '11/05/2020', '2020-19', '81', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '25.46');
INSERT INTO public.europe_data_import VALUES (1833, '04/05/2020', '2020-18', '59', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '18.91');
INSERT INTO public.europe_data_import VALUES (1834, '27/04/2020', '2020-17', '45', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '17.46');
INSERT INTO public.europe_data_import VALUES (1835, '20/04/2020', '2020-16', '51', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '9.82');
INSERT INTO public.europe_data_import VALUES (1836, '13/04/2020', '2020-15', '3', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (1837, '06/04/2020', '2020-14', '2', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (1838, '30/03/2020', '2020-13', '2', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (1839, '23/03/2020', '2020-12', '3', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1840, '02/03/2020', '2020-09', '14', '3', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1841, '24/02/2020', '2020-08', '336', '3', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1842, '17/02/2020', '2020-07', '285', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1843, '10/02/2020', '2020-06', '70', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1844, '03/02/2020', '2020-05', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1845, '27/01/2020', '2020-04', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1846, '20/01/2020', '2020-03', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1847, '13/01/2020', '2020-02', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1848, '06/01/2020', '2020-01', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1849, '01/02/2021', '2021-04', '15', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '27.71');
INSERT INTO public.europe_data_import VALUES (1850, '25/01/2021', '2021-03', '3', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '32.33');
INSERT INTO public.europe_data_import VALUES (1851, '18/01/2021', '2021-02', '18', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '50.81');
INSERT INTO public.europe_data_import VALUES (1852, '11/01/2021', '2021-01', '15', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '67.75');
INSERT INTO public.europe_data_import VALUES (1853, '04/01/2021', '2020-53', '29', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '47.73');
INSERT INTO public.europe_data_import VALUES (1854, '28/12/2020', '2020-52', '2', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1855, '21/12/2020', '2020-51', '18', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '43.11');
INSERT INTO public.europe_data_import VALUES (1856, '14/12/2020', '2020-50', '10', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '36.95');
INSERT INTO public.europe_data_import VALUES (1857, '07/12/2020', '2020-49', '14', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '41.57');
INSERT INTO public.europe_data_import VALUES (1858, '30/11/2020', '2020-48', '13', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1859, '23/11/2020', '2020-47', '7', '1', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1860, '16/11/2020', '2020-46', '4', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '21.56');
INSERT INTO public.europe_data_import VALUES (1861, '09/11/2020', '2020-45', '10', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1862, '02/11/2020', '2020-44', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '10.78');
INSERT INTO public.europe_data_import VALUES (1863, '26/10/2020', '2020-43', '6', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '27.71');
INSERT INTO public.europe_data_import VALUES (1864, '19/10/2020', '2020-42', '12', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1865, '12/10/2020', '2020-41', '8', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1866, '05/10/2020', '2020-40', '3', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '6.16');
INSERT INTO public.europe_data_import VALUES (1867, '28/09/2020', '2020-39', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1868, '21/09/2020', '2020-38', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '6.16');
INSERT INTO public.europe_data_import VALUES (1869, '14/09/2020', '2020-37', '3', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '4.62');
INSERT INTO public.europe_data_import VALUES (1870, '07/09/2020', '2020-36', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1871, '31/08/2020', '2020-35', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1872, '24/08/2020', '2020-34', '2', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1873, '17/08/2020', '2020-33', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1874, '10/08/2020', '2020-32', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1875, '03/08/2020', '2020-31', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1876, '27/07/2020', '2020-30', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1877, '20/07/2020', '2020-29', '2', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1878, '13/07/2020', '2020-28', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1879, '06/07/2020', '2020-27', '5', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '9.24');
INSERT INTO public.europe_data_import VALUES (1880, '29/06/2020', '2020-26', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '13.86');
INSERT INTO public.europe_data_import VALUES (1881, '22/06/2020', '2020-25', '8', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '47.73');
INSERT INTO public.europe_data_import VALUES (1882, '15/06/2020', '2020-24', '23', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '70.83');
INSERT INTO public.europe_data_import VALUES (1883, '08/06/2020', '2020-23', '23', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '53.89');
INSERT INTO public.europe_data_import VALUES (1884, '01/06/2020', '2020-22', '12', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '72.37');
INSERT INTO public.europe_data_import VALUES (1885, '25/05/2020', '2020-21', '35', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '73.91');
INSERT INTO public.europe_data_import VALUES (1886, '18/05/2020', '2020-20', '13', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1887, '11/05/2020', '2020-19', '7', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1888, '04/05/2020', '2020-18', '4', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '20.02');
INSERT INTO public.europe_data_import VALUES (1889, '27/04/2020', '2020-17', '9', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '26.17');
INSERT INTO public.europe_data_import VALUES (1890, '20/04/2020', '2020-16', '8', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '33.87');
INSERT INTO public.europe_data_import VALUES (1891, '13/04/2020', '2020-15', '14', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '69.29');
INSERT INTO public.europe_data_import VALUES (1892, '06/04/2020', '2020-14', '31', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '55.43');
INSERT INTO public.europe_data_import VALUES (1893, '30/03/2020', '2020-13', '5', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '12.32');
INSERT INTO public.europe_data_import VALUES (1894, '23/03/2020', '2020-12', '3', '1', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '');
INSERT INTO public.europe_data_import VALUES (1895, '01/02/2021', '2021-04', '9', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (1896, '25/01/2021', '2021-03', '6', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (1897, '18/01/2021', '2021-02', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1898, '11/01/2021', '2021-01', '10', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1899, '04/01/2021', '2020-53', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1900, '28/12/2020', '2020-52', '23', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1901, '21/12/2020', '2020-51', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (1902, '14/12/2020', '2020-50', '14', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.48');
INSERT INTO public.europe_data_import VALUES (1903, '07/12/2020', '2020-49', '9', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1904, '30/11/2020', '2020-48', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (1905, '23/11/2020', '2020-47', '11', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.67');
INSERT INTO public.europe_data_import VALUES (1906, '16/11/2020', '2020-46', '21', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (1907, '09/11/2020', '2020-45', '13', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (1908, '02/11/2020', '2020-44', '4', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1909, '26/10/2020', '2020-43', '7', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (1910, '19/10/2020', '2020-42', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (1911, '12/10/2020', '2020-41', '9', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (1912, '05/10/2020', '2020-40', '39', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (1913, '28/09/2020', '2020-39', '13', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.2');
INSERT INTO public.europe_data_import VALUES (1914, '21/09/2020', '2020-38', '44', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.35');
INSERT INTO public.europe_data_import VALUES (1915, '14/09/2020', '2020-37', '20', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1916, '07/09/2020', '2020-36', '29', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (1917, '31/08/2020', '2020-35', '21', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (1918, '24/08/2020', '2020-34', '27', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (1919, '17/08/2020', '2020-33', '11', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (1920, '10/08/2020', '2020-32', '27', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (1921, '03/08/2020', '2020-31', '15', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (1922, '27/07/2020', '2020-30', '114', '4', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '6.55');
INSERT INTO public.europe_data_import VALUES (1923, '20/07/2020', '2020-29', '197', '2', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '10.87');
INSERT INTO public.europe_data_import VALUES (1924, '13/07/2020', '2020-28', '319', '5', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '18.1');
INSERT INTO public.europe_data_import VALUES (1925, '06/07/2020', '2020-27', '540', '3', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '24.47');
INSERT INTO public.europe_data_import VALUES (1926, '29/06/2020', '2020-26', '621', '22', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '25.44');
INSERT INTO public.europe_data_import VALUES (1927, '22/06/2020', '2020-25', '586', '16', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '24.74');
INSERT INTO public.europe_data_import VALUES (1928, '15/06/2020', '2020-24', '588', '2', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '25.52');
INSERT INTO public.europe_data_import VALUES (1929, '08/06/2020', '2020-23', '623', '3', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '21.71');
INSERT INTO public.europe_data_import VALUES (1930, '01/06/2020', '2020-22', '407', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '14.41');
INSERT INTO public.europe_data_import VALUES (1931, '25/05/2020', '2020-21', '277', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '8.96');
INSERT INTO public.europe_data_import VALUES (1932, '18/05/2020', '2020-20', '148', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '5.37');
INSERT INTO public.europe_data_import VALUES (1933, '11/05/2020', '2020-19', '107', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '3.37');
INSERT INTO public.europe_data_import VALUES (1934, '04/05/2020', '2020-18', '53', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (1935, '27/04/2020', '2020-17', '7', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (1936, '20/04/2020', '2020-16', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (1937, '13/04/2020', '2020-15', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1938, '06/04/2020', '2020-14', '3', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1939, '30/03/2020', '2020-13', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1940, '23/03/2020', '2020-12', '3', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (1941, '16/03/2020', '2020-11', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1942, '01/02/2021', '2021-04', '224', '5', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (1943, '25/01/2021', '2021-03', '266', '5', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (1944, '18/01/2021', '2021-02', '358', '4', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '4.28');
INSERT INTO public.europe_data_import VALUES (1945, '11/01/2021', '2021-01', '324', '3', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '3.27');
INSERT INTO public.europe_data_import VALUES (1946, '04/01/2021', '2020-53', '198', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '2.03');
INSERT INTO public.europe_data_import VALUES (1947, '28/12/2020', '2020-52', '125', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (1948, '21/12/2020', '2020-51', '120', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1949, '14/12/2020', '2020-50', '45', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.55');
INSERT INTO public.europe_data_import VALUES (1950, '07/12/2020', '2020-49', '43', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (1951, '30/11/2020', '2020-48', '40', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1952, '23/11/2020', '2020-47', '45', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (1953, '16/11/2020', '2020-46', '50', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (1954, '09/11/2020', '2020-45', '49', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1955, '02/11/2020', '2020-44', '61', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.75');
INSERT INTO public.europe_data_import VALUES (1956, '26/10/2020', '2020-43', '58', '3', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (1957, '19/10/2020', '2020-42', '75', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (1958, '12/10/2020', '2020-41', '87', '6', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (1959, '05/10/2020', '2020-40', '39', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1960, '28/09/2020', '2020-39', '27', '3', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (1961, '21/09/2020', '2020-38', '67', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (1962, '14/09/2020', '2020-37', '45', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (1963, '07/09/2020', '2020-36', '27', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.33');
INSERT INTO public.europe_data_import VALUES (1964, '31/08/2020', '2020-35', '26', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (1965, '24/08/2020', '2020-34', '30', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (1966, '17/08/2020', '2020-33', '12', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1967, '10/08/2020', '2020-32', '8', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (1968, '03/08/2020', '2020-31', '21', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (1969, '27/07/2020', '2020-30', '26', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.22');
INSERT INTO public.europe_data_import VALUES (1970, '20/07/2020', '2020-29', '9', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1971, '13/07/2020', '2020-28', '8', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1972, '06/07/2020', '2020-27', '6', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1973, '29/06/2020', '2020-26', '8', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (1974, '22/06/2020', '2020-25', '8', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1975, '15/06/2020', '2020-24', '13', '4', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (1976, '08/06/2020', '2020-23', '59', '4', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (1977, '01/06/2020', '2020-22', '103', '5', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (1978, '25/05/2020', '2020-21', '172', '7', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (1979, '18/05/2020', '2020-20', '181', '22', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '2.42');
INSERT INTO public.europe_data_import VALUES (1980, '11/05/2020', '2020-19', '205', '21', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (1981, '04/05/2020', '2020-18', '71', '10', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1982, '27/04/2020', '2020-17', '13', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (1983, '20/04/2020', '2020-16', '18', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (1984, '13/04/2020', '2020-15', '6', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (1985, '06/04/2020', '2020-14', '4', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (1986, '30/03/2020', '2020-13', '3', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (1987, '23/03/2020', '2020-12', '2', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1988, '01/02/2021', '2021-04', '27710', '538', '18952035', 'Chile', 'CL', 'CHL', 'America', '301.49');
INSERT INTO public.europe_data_import VALUES (1989, '25/01/2021', '2021-03', '29428', '452', '18952035', 'Chile', 'CL', 'CHL', 'America', '302.27');
INSERT INTO public.europe_data_import VALUES (1990, '18/01/2021', '2021-02', '27858', '385', '18952035', 'Chile', 'CL', 'CHL', 'America', '293.16');
INSERT INTO public.europe_data_import VALUES (1991, '11/01/2021', '2021-01', '27701', '395', '18952035', 'Chile', 'CL', 'CHL', 'America', '231.45');
INSERT INTO public.europe_data_import VALUES (1992, '04/01/2021', '2020-53', '16163', '324', '18952035', 'Chile', 'CL', 'CHL', 'America', '162.0');
INSERT INTO public.europe_data_import VALUES (1993, '28/12/2020', '2020-52', '14540', '246', '18952035', 'Chile', 'CL', 'CHL', 'America', '158.87');
INSERT INTO public.europe_data_import VALUES (1994, '21/12/2020', '2020-51', '15569', '311', '18952035', 'Chile', 'CL', 'CHL', 'America', '143.02');
INSERT INTO public.europe_data_import VALUES (1995, '14/12/2020', '2020-50', '11537', '258', '18952035', 'Chile', 'CL', 'CHL', 'America', '113.39');
INSERT INTO public.europe_data_import VALUES (1996, '07/12/2020', '2020-49', '9952', '272', '18952035', 'Chile', 'CL', 'CHL', 'America', '104.17');
INSERT INTO public.europe_data_import VALUES (1997, '30/11/2020', '2020-48', '9790', '287', '18952035', 'Chile', 'CL', 'CHL', 'America', '101.08');
INSERT INTO public.europe_data_import VALUES (1998, '23/11/2020', '2020-47', '9367', '250', '18952035', 'Chile', 'CL', 'CHL', 'America', '100.69');
INSERT INTO public.europe_data_import VALUES (1999, '16/11/2020', '2020-46', '9715', '276', '18952035', 'Chile', 'CL', 'CHL', 'America', '102.41');
INSERT INTO public.europe_data_import VALUES (2000, '09/11/2020', '2020-45', '9694', '296', '18952035', 'Chile', 'CL', 'CHL', 'America', '102.86');
INSERT INTO public.europe_data_import VALUES (2001, '02/11/2020', '2020-44', '9801', '303', '18952035', 'Chile', 'CL', 'CHL', 'America', '106.08');
INSERT INTO public.europe_data_import VALUES (2002, '26/10/2020', '2020-43', '10303', '309', '18952035', 'Chile', 'CL', 'CHL', 'America', '109.18');
INSERT INTO public.europe_data_import VALUES (2003, '19/10/2020', '2020-42', '10389', '317', '18952035', 'Chile', 'CL', 'CHL', 'America', '113.87');
INSERT INTO public.europe_data_import VALUES (2004, '12/10/2020', '2020-41', '11192', '339', '18952035', 'Chile', 'CL', 'CHL', 'America', '123.84');
INSERT INTO public.europe_data_import VALUES (2005, '05/10/2020', '2020-40', '12278', '338', '18952035', 'Chile', 'CL', 'CHL', 'America', '126.13');
INSERT INTO public.europe_data_import VALUES (2006, '28/09/2020', '2020-39', '11627', '355', '18952035', 'Chile', 'CL', 'CHL', 'America', '122.17');
INSERT INTO public.europe_data_import VALUES (2007, '21/09/2020', '2020-38', '11526', '337', '18952035', 'Chile', 'CL', 'CHL', 'America', '125.39');
INSERT INTO public.europe_data_import VALUES (2008, '14/09/2020', '2020-37', '12238', '357', '18952035', 'Chile', 'CL', 'CHL', 'America', '130.72');
INSERT INTO public.europe_data_import VALUES (2009, '07/09/2020', '2020-36', '12536', '348', '18952035', 'Chile', 'CL', 'CHL', 'America', '131.09');
INSERT INTO public.europe_data_import VALUES (2010, '31/08/2020', '2020-35', '12309', '392', '18952035', 'Chile', 'CL', 'CHL', 'America', '126.78');
INSERT INTO public.europe_data_import VALUES (2011, '24/08/2020', '2020-34', '11719', '400', '18952035', 'Chile', 'CL', 'CHL', 'America', '129.85');
INSERT INTO public.europe_data_import VALUES (2012, '17/08/2020', '2020-33', '12890', '375', '18952035', 'Chile', 'CL', 'CHL', 'America', '138.32');
INSERT INTO public.europe_data_import VALUES (2013, '10/08/2020', '2020-32', '13325', '469', '18952035', 'Chile', 'CL', 'CHL', 'America', '143.87');
INSERT INTO public.europe_data_import VALUES (2014, '03/08/2020', '2020-31', '13941', '496', '18952035', 'Chile', 'CL', 'CHL', 'America', '151.97');
INSERT INTO public.europe_data_import VALUES (2015, '27/07/2020', '2020-30', '14860', '609', '18952035', 'Chile', 'CL', 'CHL', 'America', '162.25');
INSERT INTO public.europe_data_import VALUES (2016, '20/07/2020', '2020-29', '15889', '1524', '18952035', 'Chile', 'CL', 'CHL', 'America', '186.78');
INSERT INTO public.europe_data_import VALUES (2017, '13/07/2020', '2020-28', '19509', '671', '18952035', 'Chile', 'CL', 'CHL', 'America', '227.2');
INSERT INTO public.europe_data_import VALUES (2018, '06/07/2020', '2020-27', '23550', '799', '18952035', 'Chile', 'CL', 'CHL', 'America', '280.59');
INSERT INTO public.europe_data_import VALUES (2019, '29/06/2020', '2020-26', '29627', '1030', '18952035', 'Chile', 'CL', 'CHL', 'America', '515.45');
INSERT INTO public.europe_data_import VALUES (2020, '22/06/2020', '2020-25', '68062', '1156', '18952035', 'Chile', 'CL', 'CHL', 'America', '570.94');
INSERT INTO public.europe_data_import VALUES (2021, '15/06/2020', '2020-24', '40143', '1133', '18952035', 'Chile', 'CL', 'CHL', 'America', '393.65');
INSERT INTO public.europe_data_import VALUES (2022, '08/06/2020', '2020-23', '34462', '1136', '18952035', 'Chile', 'CL', 'CHL', 'America', '343.22');
INSERT INTO public.europe_data_import VALUES (2023, '01/06/2020', '2020-22', '30586', '336', '18952035', 'Chile', 'CL', 'CHL', 'America', '294.99');
INSERT INTO public.europe_data_import VALUES (2024, '25/05/2020', '2020-21', '25321', '268', '18952035', 'Chile', 'CL', 'CHL', 'America', '212.3');
INSERT INTO public.europe_data_import VALUES (2025, '18/05/2020', '2020-20', '14915', '138', '18952035', 'Chile', 'CL', 'CHL', 'America', '127.26');
INSERT INTO public.europe_data_import VALUES (2026, '11/05/2020', '2020-19', '9203', '52', '18952035', 'Chile', 'CL', 'CHL', 'America', '81.97');
INSERT INTO public.europe_data_import VALUES (2027, '04/05/2020', '2020-18', '6332', '71', '18952035', 'Chile', 'CL', 'CHL', 'America', '50.52');
INSERT INTO public.europe_data_import VALUES (2028, '27/04/2020', '2020-17', '3243', '56', '18952035', 'Chile', 'CL', 'CHL', 'America', '32.28');
INSERT INTO public.europe_data_import VALUES (2029, '20/04/2020', '2020-16', '2875', '53', '18952035', 'Chile', 'CL', 'CHL', 'America', '29.64');
INSERT INTO public.europe_data_import VALUES (2030, '13/04/2020', '2020-15', '2742', '46', '18952035', 'Chile', 'CL', 'CHL', 'America', '26.77');
INSERT INTO public.europe_data_import VALUES (2031, '06/04/2020', '2020-14', '2332', '27', '18952035', 'Chile', 'CL', 'CHL', 'America', '20.26');
INSERT INTO public.europe_data_import VALUES (2032, '30/03/2020', '2020-13', '1507', '6', '18952035', 'Chile', 'CL', 'CHL', 'America', '10.89');
INSERT INTO public.europe_data_import VALUES (2033, '23/03/2020', '2020-12', '557', '1', '18952035', 'Chile', 'CL', 'CHL', 'America', '3.28');
INSERT INTO public.europe_data_import VALUES (2034, '16/03/2020', '2020-11', '65', '0', '18952035', 'Chile', 'CL', 'CHL', 'America', '0.4');
INSERT INTO public.europe_data_import VALUES (2035, '09/03/2020', '2020-10', '10', '0', '18952035', 'Chile', 'CL', 'CHL', 'America', '');
INSERT INTO public.europe_data_import VALUES (2036, '01/02/2021', '2021-04', '816', '13', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (2037, '25/01/2021', '2021-03', '1308', '7', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (2038, '18/01/2021', '2021-02', '1115', '10', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (2039, '11/01/2021', '2021-01', '611', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (2040, '04/01/2021', '2020-53', '918', '14', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2041, '28/12/2020', '2020-52', '245', '7', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (2042, '21/12/2020', '2020-51', '3029', '25', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (2043, '14/12/2020', '2020-50', '103', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2044, '07/12/2020', '2020-49', '104', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2045, '30/11/2020', '2020-48', '83', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2046, '23/11/2020', '2020-47', '95', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2047, '16/11/2020', '2020-46', '76', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2048, '09/11/2020', '2020-45', '213', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2049, '02/11/2020', '2020-44', '196', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2050, '26/10/2020', '2020-43', '179', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2051, '19/10/2020', '2020-42', '160', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2052, '12/10/2020', '2020-41', '183', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2053, '05/10/2020', '2020-40', '146', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2054, '28/09/2020', '2020-39', '114', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2055, '21/09/2020', '2020-38', '172', '3', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2056, '14/09/2020', '2020-37', '139', '4', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2057, '07/09/2020', '2020-36', '163', '8', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2058, '31/08/2020', '2020-35', '200', '11', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (2059, '24/08/2020', '2020-34', '320', '8', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (2060, '17/08/2020', '2020-33', '582', '17', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (2061, '10/08/2020', '2020-32', '808', '17', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (2062, '03/08/2020', '2020-31', '1415', '17', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (2063, '27/07/2020', '2020-30', '957', '6', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (2064, '20/07/2020', '2020-29', '496', '5', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (2065, '13/07/2020', '2020-28', '246', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2066, '06/07/2020', '2020-27', '114', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2067, '29/06/2020', '2020-26', '185', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2068, '22/06/2020', '2020-25', '237', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2069, '15/06/2020', '2020-24', '144', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2070, '08/06/2020', '2020-23', '44', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2071, '01/06/2020', '2020-22', '52', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2072, '25/05/2020', '2020-21', '41', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2073, '18/05/2020', '2020-20', '44', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2074, '11/05/2020', '2020-19', '46', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2075, '04/05/2020', '2020-18', '52', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2076, '27/04/2020', '2020-17', '95', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (2077, '20/04/2020', '2020-16', '608', '1291', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2078, '13/04/2020', '2020-15', '567', '10', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (2079, '06/04/2020', '2020-14', '485', '29', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2080, '30/03/2020', '2020-13', '673', '32', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2081, '23/03/2020', '2020-12', '464', '58', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (2082, '16/03/2020', '2020-11', '161', '94', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (2083, '09/03/2020', '2020-10', '725', '208', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (2084, '02/03/2020', '2020-09', '2900', '319', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.66');
INSERT INTO public.europe_data_import VALUES (2085, '24/02/2020', '2020-08', '6616', '824', '1433783692', 'China', 'CN', 'CHN', 'Asia', '2.58');
INSERT INTO public.europe_data_import VALUES (2086, '17/02/2020', '2020-07', '30412', '862', '1433783692', 'China', 'CN', 'CHN', 'Asia', '3.72');
INSERT INTO public.europe_data_import VALUES (2087, '10/02/2020', '2020-06', '22995', '548', '1433783692', 'China', 'CN', 'CHN', 'Asia', '2.61');
INSERT INTO public.europe_data_import VALUES (2088, '03/02/2020', '2020-05', '14436', '280', '1433783692', 'China', 'CN', 'CHN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (2089, '27/01/2020', '2020-04', '2540', '78', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (2090, '20/01/2020', '2020-03', '176', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2091, '13/01/2020', '2020-02', '0', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (2092, '06/01/2020', '2020-01', '59', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (2093, '01/02/2021', '2021-04', '76760', '2525', '50339443', 'Colombia', 'CO', 'COL', 'America', '360.3');
INSERT INTO public.europe_data_import VALUES (2094, '25/01/2021', '2021-03', '104614', '2743', '50339443', 'Colombia', 'CO', 'COL', 'America', '448.64');
INSERT INTO public.europe_data_import VALUES (2095, '18/01/2021', '2021-02', '121229', '2553', '50339443', 'Colombia', 'CO', 'COL', 'America', '491.29');
INSERT INTO public.europe_data_import VALUES (2096, '11/01/2021', '2021-01', '126083', '2486', '50339443', 'Colombia', 'CO', 'COL', 'America', '393.52');
INSERT INTO public.europe_data_import VALUES (2097, '04/01/2021', '2020-53', '72013', '1591', '50339443', 'Colombia', 'CO', 'COL', 'America', '313.38');
INSERT INTO public.europe_data_import VALUES (2098, '28/12/2020', '2020-52', '85740', '1694', '50339443', 'Colombia', 'CO', 'COL', 'America', '353.67');
INSERT INTO public.europe_data_import VALUES (2099, '21/12/2020', '2020-51', '92293', '1627', '50339443', 'Colombia', 'CO', 'COL', 'America', '291.95');
INSERT INTO public.europe_data_import VALUES (2100, '14/12/2020', '2020-50', '54671', '1245', '50339443', 'Colombia', 'CO', 'COL', 'America', '233.21');
INSERT INTO public.europe_data_import VALUES (2101, '07/12/2020', '2020-49', '62727', '1224', '50339443', 'Colombia', 'CO', 'COL', 'America', '243.72');
INSERT INTO public.europe_data_import VALUES (2102, '30/11/2020', '2020-48', '59959', '1297', '50339443', 'Colombia', 'CO', 'COL', 'America', '217.78');
INSERT INTO public.europe_data_import VALUES (2103, '23/11/2020', '2020-47', '49671', '1256', '50339443', 'Colombia', 'CO', 'COL', 'America', '207.65');
INSERT INTO public.europe_data_import VALUES (2104, '16/11/2020', '2020-46', '54859', '1240', '50339443', 'Colombia', 'CO', 'COL', 'America', '229.29');
INSERT INTO public.europe_data_import VALUES (2105, '09/11/2020', '2020-45', '60566', '1276', '50339443', 'Colombia', 'CO', 'COL', 'America', '254.28');
INSERT INTO public.europe_data_import VALUES (2106, '02/11/2020', '2020-44', '67436', '1361', '50339443', 'Colombia', 'CO', 'COL', 'America', '245.83');
INSERT INTO public.europe_data_import VALUES (2107, '26/10/2020', '2020-43', '56313', '1184', '50339443', 'Colombia', 'CO', 'COL', 'America', '207.73');
INSERT INTO public.europe_data_import VALUES (2108, '19/10/2020', '2020-42', '48256', '1136', '50339443', 'Colombia', 'CO', 'COL', 'America', '207.63');
INSERT INTO public.europe_data_import VALUES (2109, '12/10/2020', '2020-41', '56264', '1122', '50339443', 'Colombia', 'CO', 'COL', 'America', '195.19');
INSERT INTO public.europe_data_import VALUES (2110, '05/10/2020', '2020-40', '41996', '1224', '50339443', 'Colombia', 'CO', 'COL', 'America', '178.74');
INSERT INTO public.europe_data_import VALUES (2111, '28/09/2020', '2020-39', '47980', '1280', '50339443', 'Colombia', 'CO', 'COL', 'America', '192.17');
INSERT INTO public.europe_data_import VALUES (2112, '21/09/2020', '2020-38', '48757', '1284', '50339443', 'Colombia', 'CO', 'COL', 'America', '195.78');
INSERT INTO public.europe_data_import VALUES (2113, '14/09/2020', '2020-37', '49798', '1512', '50339443', 'Colombia', 'CO', 'COL', 'America', '215.3');
INSERT INTO public.europe_data_import VALUES (2114, '07/09/2020', '2020-36', '58583', '2048', '50339443', 'Colombia', 'CO', 'COL', 'America', '249.06');
INSERT INTO public.europe_data_import VALUES (2115, '31/08/2020', '2020-35', '66791', '2048', '50339443', 'Colombia', 'CO', 'COL', 'America', '277.33');
INSERT INTO public.europe_data_import VALUES (2116, '24/08/2020', '2020-34', '72815', '2219', '50339443', 'Colombia', 'CO', 'COL', 'America', '305.26');
INSERT INTO public.europe_data_import VALUES (2117, '17/08/2020', '2020-33', '80851', '2255', '50339443', 'Colombia', 'CO', 'COL', 'America', '299.33');
INSERT INTO public.europe_data_import VALUES (2118, '10/08/2020', '2020-32', '69830', '2192', '50339443', 'Colombia', 'CO', 'COL', 'America', '275.14');
INSERT INTO public.europe_data_import VALUES (2119, '03/08/2020', '2020-31', '68675', '2125', '50339443', 'Colombia', 'CO', 'COL', 'America', '239.12');
INSERT INTO public.europe_data_import VALUES (2120, '27/07/2020', '2020-30', '51698', '1789', '50339443', 'Colombia', 'CO', 'COL', 'America', '195.73');
INSERT INTO public.europe_data_import VALUES (2121, '20/07/2020', '2020-29', '46833', '1429', '50339443', 'Colombia', 'CO', 'COL', 'America', '159.25');
INSERT INTO public.europe_data_import VALUES (2122, '13/07/2020', '2020-28', '33335', '1243', '50339443', 'Colombia', 'CO', 'COL', 'America', '116.56');
INSERT INTO public.europe_data_import VALUES (2123, '06/07/2020', '2020-27', '25341', '958', '50339443', 'Colombia', 'CO', 'COL', 'America', '96.26');
INSERT INTO public.europe_data_import VALUES (2124, '29/06/2020', '2020-26', '23117', '869', '50339443', 'Colombia', 'CO', 'COL', 'America', '81.11');
INSERT INTO public.europe_data_import VALUES (2125, '22/06/2020', '2020-25', '17713', '570', '50339443', 'Colombia', 'CO', 'COL', 'America', '58.44');
INSERT INTO public.europe_data_import VALUES (2126, '15/06/2020', '2020-24', '11703', '408', '50339443', 'Colombia', 'CO', 'COL', 'America', '42.82');
INSERT INTO public.europe_data_import VALUES (2127, '08/06/2020', '2020-23', '9853', '320', '50339443', 'Colombia', 'CO', 'COL', 'America', '35.88');
INSERT INTO public.europe_data_import VALUES (2128, '01/06/2020', '2020-22', '8208', '212', '50339443', 'Colombia', 'CO', 'COL', 'America', '27.43');
INSERT INTO public.europe_data_import VALUES (2129, '25/05/2020', '2020-21', '5601', '153', '50339443', 'Colombia', 'CO', 'COL', 'America', '20.09');
INSERT INTO public.europe_data_import VALUES (2130, '18/05/2020', '2020-20', '4511', '111', '50339443', 'Colombia', 'CO', 'COL', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (2131, '11/05/2020', '2020-19', '3395', '123', '50339443', 'Colombia', 'CO', 'COL', 'America', '11.29');
INSERT INTO public.europe_data_import VALUES (2132, '04/05/2020', '2020-18', '2289', '97', '50339443', 'Colombia', 'CO', 'COL', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (2133, '27/04/2020', '2020-17', '1587', '64', '50339443', 'Colombia', 'CO', 'COL', 'America', '5.17');
INSERT INTO public.europe_data_import VALUES (2134, '20/04/2020', '2020-16', '1016', '70', '50339443', 'Colombia', 'CO', 'COL', 'America', '4.58');
INSERT INTO public.europe_data_import VALUES (2135, '13/04/2020', '2020-15', '1291', '74', '50339443', 'Colombia', 'CO', 'COL', 'America', '4.12');
INSERT INTO public.europe_data_import VALUES (2136, '06/04/2020', '2020-14', '783', '25', '50339443', 'Colombia', 'CO', 'COL', 'America', '2.48');
INSERT INTO public.europe_data_import VALUES (2137, '30/03/2020', '2020-13', '467', '8', '50339443', 'Colombia', 'CO', 'COL', 'America', '1.31');
INSERT INTO public.europe_data_import VALUES (2138, '23/03/2020', '2020-12', '190', '2', '50339443', 'Colombia', 'CO', 'COL', 'America', '0.47');
INSERT INTO public.europe_data_import VALUES (2139, '16/03/2020', '2020-11', '45', '0', '50339443', 'Colombia', 'CO', 'COL', 'America', '');
INSERT INTO public.europe_data_import VALUES (2140, '01/02/2021', '2021-04', '543', '27', '850891', 'Comoros', 'KM', 'COM', 'Africa', '143.26');
INSERT INTO public.europe_data_import VALUES (2141, '25/01/2021', '2021-03', '676', '26', '850891', 'Comoros', 'KM', 'COM', 'Africa', '130.22');
INSERT INTO public.europe_data_import VALUES (2142, '18/01/2021', '2021-02', '432', '27', '850891', 'Comoros', 'KM', 'COM', 'Africa', '85.56');
INSERT INTO public.europe_data_import VALUES (2143, '11/01/2021', '2021-01', '296', '5', '850891', 'Comoros', 'KM', 'COM', 'Africa', '50.42');
INSERT INTO public.europe_data_import VALUES (2144, '04/01/2021', '2020-53', '133', '6', '850891', 'Comoros', 'KM', 'COM', 'Africa', '23.27');
INSERT INTO public.europe_data_import VALUES (2145, '28/12/2020', '2020-52', '65', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '12.1');
INSERT INTO public.europe_data_import VALUES (2146, '21/12/2020', '2020-51', '38', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.88');
INSERT INTO public.europe_data_import VALUES (2147, '14/12/2020', '2020-50', '12', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (2148, '07/12/2020', '2020-49', '5', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.35');
INSERT INTO public.europe_data_import VALUES (2149, '30/11/2020', '2020-48', '15', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (2150, '23/11/2020', '2020-47', '17', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '3.88');
INSERT INTO public.europe_data_import VALUES (2151, '16/11/2020', '2020-46', '16', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '4.0');
INSERT INTO public.europe_data_import VALUES (2152, '09/11/2020', '2020-45', '18', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.41');
INSERT INTO public.europe_data_import VALUES (2153, '02/11/2020', '2020-44', '28', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.05');
INSERT INTO public.europe_data_import VALUES (2154, '26/10/2020', '2020-43', '15', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.59');
INSERT INTO public.europe_data_import VALUES (2155, '19/10/2020', '2020-42', '7', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '1.76');
INSERT INTO public.europe_data_import VALUES (2156, '12/10/2020', '2020-41', '8', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (2157, '05/10/2020', '2020-40', '9', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (2158, '28/09/2020', '2020-39', '8', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.59');
INSERT INTO public.europe_data_import VALUES (2159, '21/09/2020', '2020-38', '14', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (2160, '14/09/2020', '2020-37', '4', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '3.88');
INSERT INTO public.europe_data_import VALUES (2161, '07/09/2020', '2020-36', '29', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '4.11');
INSERT INTO public.europe_data_import VALUES (2162, '31/08/2020', '2020-35', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (2163, '24/08/2020', '2020-34', '12', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (2164, '17/08/2020', '2020-33', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.23');
INSERT INTO public.europe_data_import VALUES (2165, '10/08/2020', '2020-32', '13', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '6.93');
INSERT INTO public.europe_data_import VALUES (2166, '03/08/2020', '2020-31', '46', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '6.11');
INSERT INTO public.europe_data_import VALUES (2167, '27/07/2020', '2020-30', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (2168, '20/07/2020', '2020-29', '17', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (2169, '13/07/2020', '2020-28', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.29');
INSERT INTO public.europe_data_import VALUES (2170, '06/07/2020', '2020-27', '39', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '7.52');
INSERT INTO public.europe_data_import VALUES (2171, '29/06/2020', '2020-26', '25', '2', '850891', 'Comoros', 'KM', 'COM', 'Africa', '11.28');
INSERT INTO public.europe_data_import VALUES (2172, '22/06/2020', '2020-25', '71', '3', '850891', 'Comoros', 'KM', 'COM', 'Africa', '12.46');
INSERT INTO public.europe_data_import VALUES (2173, '15/06/2020', '2020-24', '35', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '8.23');
INSERT INTO public.europe_data_import VALUES (2174, '08/06/2020', '2020-23', '35', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '6.35');
INSERT INTO public.europe_data_import VALUES (2175, '01/06/2020', '2020-22', '19', '1', '850891', 'Comoros', 'KM', 'COM', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (2176, '25/05/2020', '2020-21', '76', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '8.93');
INSERT INTO public.europe_data_import VALUES (2177, '18/05/2020', '2020-20', '0', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (2178, '11/05/2020', '2020-19', '8', '1', '850891', 'Comoros', 'KM', 'COM', 'Africa', '1.29');
INSERT INTO public.europe_data_import VALUES (2179, '04/05/2020', '2020-18', '3', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2180, '01/02/2021', '2021-04', '93', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.31');
INSERT INTO public.europe_data_import VALUES (2181, '25/01/2021', '2021-03', '85', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '10.72');
INSERT INTO public.europe_data_import VALUES (2182, '18/01/2021', '2021-02', '492', '6', '5380504', 'Congo', 'CG', 'COG', 'Africa', '11.19');
INSERT INTO public.europe_data_import VALUES (2183, '11/01/2021', '2021-01', '110', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '12.01');
INSERT INTO public.europe_data_import VALUES (2184, '04/01/2021', '2020-53', '536', '8', '5380504', 'Congo', 'CG', 'COG', 'Africa', '16.86');
INSERT INTO public.europe_data_import VALUES (2185, '28/12/2020', '2020-52', '371', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '6.9');
INSERT INTO public.europe_data_import VALUES (2186, '21/12/2020', '2020-51', '0', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '7.92');
INSERT INTO public.europe_data_import VALUES (2187, '14/12/2020', '2020-50', '426', '6', '5380504', 'Congo', 'CG', 'COG', 'Africa', '7.92');
INSERT INTO public.europe_data_import VALUES (2188, '07/12/2020', '2020-49', '0', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.64');
INSERT INTO public.europe_data_import VALUES (2189, '30/11/2020', '2020-48', '142', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '7.34');
INSERT INTO public.europe_data_import VALUES (2190, '23/11/2020', '2020-47', '253', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '4.7');
INSERT INTO public.europe_data_import VALUES (2191, '16/11/2020', '2020-46', '0', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.65');
INSERT INTO public.europe_data_import VALUES (2192, '09/11/2020', '2020-45', '89', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.34');
INSERT INTO public.europe_data_import VALUES (2193, '02/11/2020', '2020-44', '37', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.49');
INSERT INTO public.europe_data_import VALUES (2194, '26/10/2020', '2020-43', '97', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.51');
INSERT INTO public.europe_data_import VALUES (2195, '19/10/2020', '2020-42', '38', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.25');
INSERT INTO public.europe_data_import VALUES (2196, '12/10/2020', '2020-41', '29', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (2197, '05/10/2020', '2020-40', '81', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.91');
INSERT INTO public.europe_data_import VALUES (2198, '28/09/2020', '2020-39', '22', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (2199, '21/09/2020', '2020-38', '52', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '6.65');
INSERT INTO public.europe_data_import VALUES (2200, '14/09/2020', '2020-37', '306', '6', '5380504', 'Congo', 'CG', 'COG', 'Africa', '17.75');
INSERT INTO public.europe_data_import VALUES (2201, '07/09/2020', '2020-36', '649', '4', '5380504', 'Congo', 'CG', 'COG', 'Africa', '14.46');
INSERT INTO public.europe_data_import VALUES (2202, '31/08/2020', '2020-35', '129', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (2203, '24/08/2020', '2020-34', '15', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (2204, '17/08/2020', '2020-33', '171', '18', '5380504', 'Congo', 'CG', 'COG', 'Africa', '8.33');
INSERT INTO public.europe_data_import VALUES (2205, '10/08/2020', '2020-32', '277', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '11.63');
INSERT INTO public.europe_data_import VALUES (2206, '03/08/2020', '2020-31', '349', '5', '5380504', 'Congo', 'CG', 'COG', 'Africa', '14.01');
INSERT INTO public.europe_data_import VALUES (2207, '27/07/2020', '2020-30', '405', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '17.38');
INSERT INTO public.europe_data_import VALUES (2208, '20/07/2020', '2020-29', '530', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '20.0');
INSERT INTO public.europe_data_import VALUES (2209, '13/07/2020', '2020-28', '546', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '15.95');
INSERT INTO public.europe_data_import VALUES (2210, '06/07/2020', '2020-27', '312', '4', '5380504', 'Congo', 'CG', 'COG', 'Africa', '10.11');
INSERT INTO public.europe_data_import VALUES (2211, '29/06/2020', '2020-26', '232', '12', '5380504', 'Congo', 'CG', 'COG', 'Africa', '8.66');
INSERT INTO public.europe_data_import VALUES (2212, '22/06/2020', '2020-25', '234', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '6.13');
INSERT INTO public.europe_data_import VALUES (2213, '15/06/2020', '2020-24', '96', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.12');
INSERT INTO public.europe_data_import VALUES (2214, '08/06/2020', '2020-23', '72', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.64');
INSERT INTO public.europe_data_import VALUES (2215, '01/06/2020', '2020-22', '124', '4', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.7');
INSERT INTO public.europe_data_import VALUES (2216, '25/05/2020', '2020-21', '75', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.72');
INSERT INTO public.europe_data_import VALUES (2217, '18/05/2020', '2020-20', '125', '5', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.4');
INSERT INTO public.europe_data_import VALUES (2218, '11/05/2020', '2020-19', '58', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.62');
INSERT INTO public.europe_data_import VALUES (2219, '04/05/2020', '2020-18', '29', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.28');
INSERT INTO public.europe_data_import VALUES (2220, '27/04/2020', '2020-17', '40', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.42');
INSERT INTO public.europe_data_import VALUES (2221, '20/04/2020', '2020-16', '90', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2222, '13/04/2020', '2020-15', '25', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (2223, '06/04/2020', '2020-14', '26', '5', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (2224, '30/03/2020', '2020-13', '15', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.33');
INSERT INTO public.europe_data_import VALUES (2225, '23/03/2020', '2020-12', '3', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (2226, '16/03/2020', '2020-11', '1', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2227, '01/02/2021', '2021-04', '3824', '76', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '169.45');
INSERT INTO public.europe_data_import VALUES (2228, '25/01/2021', '2021-03', '4729', '100', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '211.67');
INSERT INTO public.europe_data_import VALUES (2229, '18/01/2021', '2021-02', '5955', '105', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '269.04');
INSERT INTO public.europe_data_import VALUES (2230, '11/01/2021', '2021-01', '7625', '124', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '283.29');
INSERT INTO public.europe_data_import VALUES (2231, '04/01/2021', '2020-53', '6674', '85', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '248.5');
INSERT INTO public.europe_data_import VALUES (2232, '28/12/2020', '2020-52', '5869', '107', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '249.49');
INSERT INTO public.europe_data_import VALUES (2233, '21/12/2020', '2020-51', '6724', '101', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '321.11');
INSERT INTO public.europe_data_import VALUES (2234, '14/12/2020', '2020-50', '9484', '163', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '318.49');
INSERT INTO public.europe_data_import VALUES (2235, '07/12/2020', '2020-49', '6592', '83', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '282.65');
INSERT INTO public.europe_data_import VALUES (2236, '30/11/2020', '2020-48', '7675', '82', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '274.79');
INSERT INTO public.europe_data_import VALUES (2237, '23/11/2020', '2020-47', '6195', '62', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '258.64');
INSERT INTO public.europe_data_import VALUES (2238, '16/11/2020', '2020-46', '6860', '82', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '262.54');
INSERT INTO public.europe_data_import VALUES (2239, '09/11/2020', '2020-45', '6392', '79', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '263.0');
INSERT INTO public.europe_data_import VALUES (2240, '02/11/2020', '2020-44', '6883', '103', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '286.42');
INSERT INTO public.europe_data_import VALUES (2241, '26/10/2020', '2020-43', '7574', '99', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '310.03');
INSERT INTO public.europe_data_import VALUES (2242, '19/10/2020', '2020-42', '8075', '107', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '323.56');
INSERT INTO public.europe_data_import VALUES (2243, '12/10/2020', '2020-41', '8257', '126', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '304.9');
INSERT INTO public.europe_data_import VALUES (2244, '05/10/2020', '2020-40', '7133', '122', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '306.48');
INSERT INTO public.europe_data_import VALUES (2245, '28/09/2020', '2020-39', '8337', '122', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '328.77');
INSERT INTO public.europe_data_import VALUES (2246, '21/09/2020', '2020-38', '8258', '116', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '332.68');
INSERT INTO public.europe_data_import VALUES (2247, '14/09/2020', '2020-37', '8534', '112', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '312.13');
INSERT INTO public.europe_data_import VALUES (2248, '07/09/2020', '2020-36', '7221', '60', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '259.53');
INSERT INTO public.europe_data_import VALUES (2249, '31/08/2020', '2020-35', '5879', '63', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '222.56');
INSERT INTO public.europe_data_import VALUES (2250, '24/08/2020', '2020-34', '5355', '61', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '208.69');
INSERT INTO public.europe_data_import VALUES (2251, '17/08/2020', '2020-33', '5179', '59', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '188.01');
INSERT INTO public.europe_data_import VALUES (2252, '10/08/2020', '2020-32', '4311', '73', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '159.62');
INSERT INTO public.europe_data_import VALUES (2253, '03/08/2020', '2020-31', '3746', '58', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '155.74');
INSERT INTO public.europe_data_import VALUES (2254, '27/07/2020', '2020-30', '4115', '42', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '151.22');
INSERT INTO public.europe_data_import VALUES (2255, '20/07/2020', '2020-29', '3518', '32', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '121.21');
INSERT INTO public.europe_data_import VALUES (2256, '13/07/2020', '2020-28', '2600', '11', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '88.48');
INSERT INTO public.europe_data_import VALUES (2257, '06/07/2020', '2020-27', '1866', '4', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '55.14');
INSERT INTO public.europe_data_import VALUES (2258, '29/06/2020', '2020-26', '917', '3', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '28.03');
INSERT INTO public.europe_data_import VALUES (2259, '22/06/2020', '2020-25', '498', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '17.73');
INSERT INTO public.europe_data_import VALUES (2260, '15/06/2020', '2020-24', '397', '2', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '13.06');
INSERT INTO public.europe_data_import VALUES (2261, '08/06/2020', '2020-23', '262', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '7.69');
INSERT INTO public.europe_data_import VALUES (2262, '01/06/2020', '2020-22', '126', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '3.82');
INSERT INTO public.europe_data_import VALUES (2263, '25/05/2020', '2020-21', '67', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '2.73');
INSERT INTO public.europe_data_import VALUES (2264, '18/05/2020', '2020-20', '71', '4', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '2.46');
INSERT INTO public.europe_data_import VALUES (2265, '11/05/2020', '2020-19', '53', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '1.92');
INSERT INTO public.europe_data_import VALUES (2266, '04/05/2020', '2020-18', '44', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '1.57');
INSERT INTO public.europe_data_import VALUES (2267, '27/04/2020', '2020-17', '35', '2', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '1.98');
INSERT INTO public.europe_data_import VALUES (2268, '20/04/2020', '2020-16', '65', '1', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '4.08');
INSERT INTO public.europe_data_import VALUES (2269, '13/04/2020', '2020-15', '141', '1', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2270, '06/04/2020', '2020-14', '140', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '6.34');
INSERT INTO public.europe_data_import VALUES (2271, '30/03/2020', '2020-13', '180', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '5.53');
INSERT INTO public.europe_data_import VALUES (2272, '23/03/2020', '2020-12', '99', '2', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '2.56');
INSERT INTO public.europe_data_import VALUES (2273, '16/03/2020', '2020-11', '30', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '0.69');
INSERT INTO public.europe_data_import VALUES (2274, '09/03/2020', '2020-10', '5', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '');
INSERT INTO public.europe_data_import VALUES (2275, '01/02/2021', '2021-04', '844', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '9.54');
INSERT INTO public.europe_data_import VALUES (2276, '25/01/2021', '2021-03', '1609', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '12.05');
INSERT INTO public.europe_data_import VALUES (2277, '18/01/2021', '2021-02', '1491', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '10.08');
INSERT INTO public.europe_data_import VALUES (2278, '11/01/2021', '2021-01', '1102', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '6.12');
INSERT INTO public.europe_data_import VALUES (2279, '04/01/2021', '2020-53', '472', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.84');
INSERT INTO public.europe_data_import VALUES (2280, '28/12/2020', '2020-52', '258', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.93');
INSERT INTO public.europe_data_import VALUES (2281, '21/12/2020', '2020-51', '238', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.68');
INSERT INTO public.europe_data_import VALUES (2282, '14/12/2020', '2020-50', '195', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.44');
INSERT INTO public.europe_data_import VALUES (2283, '07/12/2020', '2020-49', '175', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.35');
INSERT INTO public.europe_data_import VALUES (2284, '30/11/2020', '2020-48', '172', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.3');
INSERT INTO public.europe_data_import VALUES (2285, '23/11/2020', '2020-47', '162', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (2286, '16/11/2020', '2020-46', '144', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (2287, '09/11/2020', '2020-45', '116', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (2288, '02/11/2020', '2020-44', '246', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.53');
INSERT INTO public.europe_data_import VALUES (2289, '26/10/2020', '2020-43', '147', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.23');
INSERT INTO public.europe_data_import VALUES (2290, '19/10/2020', '2020-42', '169', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.71');
INSERT INTO public.europe_data_import VALUES (2291, '12/10/2020', '2020-41', '272', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (2292, '05/10/2020', '2020-40', '253', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.19');
INSERT INTO public.europe_data_import VALUES (2293, '28/09/2020', '2020-39', '309', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (2294, '21/09/2020', '2020-38', '307', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.85');
INSERT INTO public.europe_data_import VALUES (2295, '14/09/2020', '2020-37', '425', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '4.14');
INSERT INTO public.europe_data_import VALUES (2296, '07/09/2020', '2020-36', '640', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '4.34');
INSERT INTO public.europe_data_import VALUES (2297, '31/08/2020', '2020-35', '477', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '3.59');
INSERT INTO public.europe_data_import VALUES (2298, '24/08/2020', '2020-34', '445', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.94');
INSERT INTO public.europe_data_import VALUES (2299, '17/08/2020', '2020-33', '311', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '3.28');
INSERT INTO public.europe_data_import VALUES (2300, '10/08/2020', '2020-32', '533', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '4.35');
INSERT INTO public.europe_data_import VALUES (2301, '03/08/2020', '2020-31', '586', '6', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '8.02');
INSERT INTO public.europe_data_import VALUES (2302, '27/07/2020', '2020-30', '1477', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '11.0');
INSERT INTO public.europe_data_import VALUES (2303, '20/07/2020', '2020-29', '1353', '8', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '13.01');
INSERT INTO public.europe_data_import VALUES (2304, '13/07/2020', '2020-28', '1994', '10', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '14.86');
INSERT INTO public.europe_data_import VALUES (2305, '06/07/2020', '2020-27', '1828', '8', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '12.75');
INSERT INTO public.europe_data_import VALUES (2306, '29/06/2020', '2020-26', '1452', '15', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '15.01');
INSERT INTO public.europe_data_import VALUES (2307, '22/06/2020', '2020-25', '2408', '6', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '14.59');
INSERT INTO public.europe_data_import VALUES (2308, '15/06/2020', '2020-24', '1345', '9', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '8.75');
INSERT INTO public.europe_data_import VALUES (2309, '08/06/2020', '2020-23', '906', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '5.3');
INSERT INTO public.europe_data_import VALUES (2310, '01/06/2020', '2020-22', '457', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.82');
INSERT INTO public.europe_data_import VALUES (2311, '25/05/2020', '2020-21', '267', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.63');
INSERT INTO public.europe_data_import VALUES (2312, '18/05/2020', '2020-20', '409', '6', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.76');
INSERT INTO public.europe_data_import VALUES (2313, '11/05/2020', '2020-19', '302', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2314, '04/05/2020', '2020-18', '248', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2315, '27/04/2020', '2020-17', '303', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.24');
INSERT INTO public.europe_data_import VALUES (2316, '20/04/2020', '2020-16', '273', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.28');
INSERT INTO public.europe_data_import VALUES (2317, '13/04/2020', '2020-15', '313', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.59');
INSERT INTO public.europe_data_import VALUES (2318, '06/04/2020', '2020-14', '96', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '0.92');
INSERT INTO public.europe_data_import VALUES (2319, '30/03/2020', '2020-13', '140', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (2320, '23/03/2020', '2020-12', '21', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (2321, '16/03/2020', '2020-11', '4', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2322, '01/02/2021', '2021-04', '3466', '195', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '181.34');
INSERT INTO public.europe_data_import VALUES (2323, '25/01/2021', '2021-03', '3926', '204', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '216.65');
INSERT INTO public.europe_data_import VALUES (2324, '18/01/2021', '2021-02', '4905', '252', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '298.56');
INSERT INTO public.europe_data_import VALUES (2325, '11/01/2021', '2021-01', '7265', '331', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '367.42');
INSERT INTO public.europe_data_import VALUES (2326, '04/01/2021', '2020-53', '7712', '333', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '422.69');
INSERT INTO public.europe_data_import VALUES (2327, '28/12/2020', '2020-52', '9518', '482', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '720.27');
INSERT INTO public.europe_data_import VALUES (2328, '21/12/2020', '2020-51', '19842', '617', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1113.16');
INSERT INTO public.europe_data_import VALUES (2329, '14/12/2020', '2020-50', '25533', '466', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1208.81');
INSERT INTO public.europe_data_import VALUES (2330, '07/12/2020', '2020-49', '23741', '462', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1144.07');
INSERT INTO public.europe_data_import VALUES (2331, '30/11/2020', '2020-48', '22894', '359', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1040.32');
INSERT INTO public.europe_data_import VALUES (2332, '23/11/2020', '2020-47', '19512', '304', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '894.72');
INSERT INTO public.europe_data_import VALUES (2333, '16/11/2020', '2020-46', '16959', '255', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '802.48');
INSERT INTO public.europe_data_import VALUES (2334, '09/11/2020', '2020-45', '15752', '232', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '757.24');
INSERT INTO public.europe_data_import VALUES (2335, '02/11/2020', '2020-44', '15115', '125', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '635.76');
INSERT INTO public.europe_data_import VALUES (2336, '26/10/2020', '2020-43', '10800', '74', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '391.05');
INSERT INTO public.europe_data_import VALUES (2337, '19/10/2020', '2020-42', '5140', '39', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '194.32');
INSERT INTO public.europe_data_import VALUES (2338, '12/10/2020', '2020-41', '2781', '26', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '104.09');
INSERT INTO public.europe_data_import VALUES (2339, '05/10/2020', '2020-40', '1462', '26', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '67.15');
INSERT INTO public.europe_data_import VALUES (2340, '28/09/2020', '2020-39', '1275', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '65.35');
INSERT INTO public.europe_data_import VALUES (2341, '21/09/2020', '2020-38', '1389', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '72.57');
INSERT INTO public.europe_data_import VALUES (2342, '14/09/2020', '2020-37', '1569', '26', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '83.66');
INSERT INTO public.europe_data_import VALUES (2343, '07/09/2020', '2020-36', '1841', '14', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '92.95');
INSERT INTO public.europe_data_import VALUES (2344, '31/08/2020', '2020-35', '1948', '13', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '87.14');
INSERT INTO public.europe_data_import VALUES (2345, '24/08/2020', '2020-34', '1604', '5', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '63.07');
INSERT INTO public.europe_data_import VALUES (2346, '17/08/2020', '2020-33', '967', '9', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '32.16');
INSERT INTO public.europe_data_import VALUES (2347, '10/08/2020', '2020-32', '344', '8', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '18.33');
INSERT INTO public.europe_data_import VALUES (2348, '03/08/2020', '2020-31', '403', '13', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '22.23');
INSERT INTO public.europe_data_import VALUES (2349, '27/07/2020', '2020-30', '503', '16', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '27.84');
INSERT INTO public.europe_data_import VALUES (2350, '20/07/2020', '2020-29', '632', '1', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '29.51');
INSERT INTO public.europe_data_import VALUES (2351, '13/07/2020', '2020-28', '571', '6', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '25.29');
INSERT INTO public.europe_data_import VALUES (2352, '06/07/2020', '2020-27', '460', '6', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '20.46');
INSERT INTO public.europe_data_import VALUES (2353, '29/06/2020', '2020-26', '374', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '10.77');
INSERT INTO public.europe_data_import VALUES (2354, '22/06/2020', '2020-25', '65', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1.72');
INSERT INTO public.europe_data_import VALUES (2355, '15/06/2020', '2020-24', '5', '3', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.15');
INSERT INTO public.europe_data_import VALUES (2356, '08/06/2020', '2020-23', '1', '1', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.07');
INSERT INTO public.europe_data_import VALUES (2357, '01/06/2020', '2020-22', '2', '4', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.49');
INSERT INTO public.europe_data_import VALUES (2358, '25/05/2020', '2020-21', '18', '4', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1.4');
INSERT INTO public.europe_data_import VALUES (2359, '18/05/2020', '2020-20', '39', '5', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '3.19');
INSERT INTO public.europe_data_import VALUES (2360, '11/05/2020', '2020-19', '91', '11', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '3.85');
INSERT INTO public.europe_data_import VALUES (2361, '04/05/2020', '2020-18', '66', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '5.52');
INSERT INTO public.europe_data_import VALUES (2362, '27/04/2020', '2020-17', '159', '8', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '10.55');
INSERT INTO public.europe_data_import VALUES (2363, '20/04/2020', '2020-16', '271', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '16.9');
INSERT INTO public.europe_data_import VALUES (2364, '13/04/2020', '2020-15', '418', '8', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '21.76');
INSERT INTO public.europe_data_import VALUES (2365, '06/04/2020', '2020-14', '469', '9', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '23.23');
INSERT INTO public.europe_data_import VALUES (2366, '30/03/2020', '2020-13', '478', '6', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '16.31');
INSERT INTO public.europe_data_import VALUES (2367, '23/03/2020', '2020-12', '187', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '5.47');
INSERT INTO public.europe_data_import VALUES (2368, '16/03/2020', '2020-11', '36', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1.01');
INSERT INTO public.europe_data_import VALUES (2369, '09/03/2020', '2020-10', '5', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.29');
INSERT INTO public.europe_data_import VALUES (2370, '02/03/2020', '2020-09', '7', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.17');
INSERT INTO public.europe_data_import VALUES (2371, '24/02/2020', '2020-08', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2372, '17/02/2020', '2020-07', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2373, '10/02/2020', '2020-06', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2374, '03/02/2020', '2020-05', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2375, '27/01/2020', '2020-04', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2376, '20/01/2020', '2020-03', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2377, '13/01/2020', '2020-02', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2378, '06/01/2020', '2020-01', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2379, '01/02/2021', '2021-04', '5764', '19', '11333484', 'Cuba', 'CU', 'CUB', 'America', '80.73');
INSERT INTO public.europe_data_import VALUES (2380, '25/01/2021', '2021-03', '3385', '24', '11333484', 'Cuba', 'CU', 'CUB', 'America', '60.18');
INSERT INTO public.europe_data_import VALUES (2381, '18/01/2021', '2021-02', '3436', '20', '11333484', 'Cuba', 'CU', 'CUB', 'America', '50.32');
INSERT INTO public.europe_data_import VALUES (2382, '11/01/2021', '2021-01', '2267', '6', '11333484', 'Cuba', 'CU', 'CUB', 'America', '31.53');
INSERT INTO public.europe_data_import VALUES (2383, '04/01/2021', '2020-53', '1306', '4', '11333484', 'Cuba', 'CU', 'CUB', 'America', '22.04');
INSERT INTO public.europe_data_import VALUES (2384, '28/12/2020', '2020-52', '1192', '6', '11333484', 'Cuba', 'CU', 'CUB', 'America', '17.74');
INSERT INTO public.europe_data_import VALUES (2385, '21/12/2020', '2020-51', '819', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '12.88');
INSERT INTO public.europe_data_import VALUES (2386, '14/12/2020', '2020-50', '641', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '10.5');
INSERT INTO public.europe_data_import VALUES (2387, '07/12/2020', '2020-49', '549', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '8.26');
INSERT INTO public.europe_data_import VALUES (2388, '30/11/2020', '2020-48', '387', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.67');
INSERT INTO public.europe_data_import VALUES (2389, '23/11/2020', '2020-47', '256', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.84');
INSERT INTO public.europe_data_import VALUES (2390, '16/11/2020', '2020-46', '293', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.78');
INSERT INTO public.europe_data_import VALUES (2391, '09/11/2020', '2020-45', '362', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.45');
INSERT INTO public.europe_data_import VALUES (2392, '02/11/2020', '2020-44', '369', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.31');
INSERT INTO public.europe_data_import VALUES (2393, '26/10/2020', '2020-43', '346', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.19');
INSERT INTO public.europe_data_import VALUES (2394, '19/10/2020', '2020-42', '242', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '3.63');
INSERT INTO public.europe_data_import VALUES (2395, '12/10/2020', '2020-41', '169', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.6');
INSERT INTO public.europe_data_import VALUES (2396, '05/10/2020', '2020-40', '352', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.34');
INSERT INTO public.europe_data_import VALUES (2397, '28/09/2020', '2020-39', '366', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.82');
INSERT INTO public.europe_data_import VALUES (2398, '21/09/2020', '2020-38', '407', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.9');
INSERT INTO public.europe_data_import VALUES (2399, '14/09/2020', '2020-37', '375', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.27');
INSERT INTO public.europe_data_import VALUES (2400, '07/09/2020', '2020-36', '336', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.53');
INSERT INTO public.europe_data_import VALUES (2401, '31/08/2020', '2020-35', '291', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.8');
INSERT INTO public.europe_data_import VALUES (2402, '24/08/2020', '2020-34', '366', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.43');
INSERT INTO public.europe_data_import VALUES (2403, '17/08/2020', '2020-33', '363', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.91');
INSERT INTO public.europe_data_import VALUES (2404, '10/08/2020', '2020-32', '307', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.04');
INSERT INTO public.europe_data_import VALUES (2405, '03/08/2020', '2020-31', '151', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (2406, '27/07/2020', '2020-30', '49', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2407, '20/07/2020', '2020-29', '20', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.65');
INSERT INTO public.europe_data_import VALUES (2408, '13/07/2020', '2020-28', '54', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.83');
INSERT INTO public.europe_data_import VALUES (2409, '06/07/2020', '2020-27', '40', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.53');
INSERT INTO public.europe_data_import VALUES (2410, '29/06/2020', '2020-26', '20', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.74');
INSERT INTO public.europe_data_import VALUES (2411, '22/06/2020', '2020-25', '64', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.07');
INSERT INTO public.europe_data_import VALUES (2412, '15/06/2020', '2020-24', '57', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.79');
INSERT INTO public.europe_data_import VALUES (2413, '08/06/2020', '2020-23', '146', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '2.21');
INSERT INTO public.europe_data_import VALUES (2414, '01/06/2020', '2020-22', '104', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.53');
INSERT INTO public.europe_data_import VALUES (2415, '25/05/2020', '2020-21', '69', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.54');
INSERT INTO public.europe_data_import VALUES (2416, '18/05/2020', '2020-20', '106', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.97');
INSERT INTO public.europe_data_import VALUES (2417, '11/05/2020', '2020-19', '117', '10', '11333484', 'Cuba', 'CU', 'CUB', 'America', '3.5');
INSERT INTO public.europe_data_import VALUES (2418, '04/05/2020', '2020-18', '280', '13', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.42');
INSERT INTO public.europe_data_import VALUES (2419, '27/04/2020', '2020-17', '334', '20', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.18');
INSERT INTO public.europe_data_import VALUES (2420, '20/04/2020', '2020-16', '366', '16', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.31');
INSERT INTO public.europe_data_import VALUES (2421, '13/04/2020', '2020-15', '349', '10', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.68');
INSERT INTO public.europe_data_import VALUES (2422, '06/04/2020', '2020-14', '181', '5', '11333484', 'Cuba', 'CU', 'CUB', 'America', '2.51');
INSERT INTO public.europe_data_import VALUES (2423, '30/03/2020', '2020-13', '104', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.23');
INSERT INTO public.europe_data_import VALUES (2424, '23/03/2020', '2020-12', '35', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '');
INSERT INTO public.europe_data_import VALUES (2425, '01/02/2021', '2021-04', '37', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '39.77');
INSERT INTO public.europe_data_import VALUES (2426, '25/01/2021', '2021-03', '28', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '51.4');
INSERT INTO public.europe_data_import VALUES (2427, '18/01/2021', '2021-02', '56', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '124.22');
INSERT INTO public.europe_data_import VALUES (2428, '11/01/2021', '2021-01', '147', '3', '163423', 'Curaçao', 'CW', 'CUW', 'America', '191.53');
INSERT INTO public.europe_data_import VALUES (2429, '04/01/2021', '2020-53', '166', '2', '163423', 'Curaçao', 'CW', 'CUW', 'America', '209.88');
INSERT INTO public.europe_data_import VALUES (2430, '28/12/2020', '2020-52', '177', '3', '163423', 'Curaçao', 'CW', 'CUW', 'America', '322.48');
INSERT INTO public.europe_data_import VALUES (2431, '21/12/2020', '2020-51', '350', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '512.78');
INSERT INTO public.europe_data_import VALUES (2432, '14/12/2020', '2020-50', '488', '4', '163423', 'Curaçao', 'CW', 'CUW', 'America', '771.01');
INSERT INTO public.europe_data_import VALUES (2433, '07/12/2020', '2020-49', '772', '3', '163423', 'Curaçao', 'CW', 'CUW', 'America', '848.72');
INSERT INTO public.europe_data_import VALUES (2434, '30/11/2020', '2020-48', '615', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '626.59');
INSERT INTO public.europe_data_import VALUES (2435, '23/11/2020', '2020-47', '409', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '398.96');
INSERT INTO public.europe_data_import VALUES (2436, '16/11/2020', '2020-46', '243', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '216.0');
INSERT INTO public.europe_data_import VALUES (2437, '09/11/2020', '2020-45', '110', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '146.25');
INSERT INTO public.europe_data_import VALUES (2438, '02/11/2020', '2020-44', '129', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '148.69');
INSERT INTO public.europe_data_import VALUES (2439, '26/10/2020', '2020-43', '114', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '168.27');
INSERT INTO public.europe_data_import VALUES (2440, '19/10/2020', '2020-42', '161', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '178.68');
INSERT INTO public.europe_data_import VALUES (2441, '12/10/2020', '2020-41', '131', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '136.46');
INSERT INTO public.europe_data_import VALUES (2442, '05/10/2020', '2020-40', '92', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '112.59');
INSERT INTO public.europe_data_import VALUES (2443, '28/09/2020', '2020-39', '92', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '124.22');
INSERT INTO public.europe_data_import VALUES (2444, '21/09/2020', '2020-38', '111', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '107.7');
INSERT INTO public.europe_data_import VALUES (2445, '14/09/2020', '2020-37', '65', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '61.19');
INSERT INTO public.europe_data_import VALUES (2446, '07/09/2020', '2020-36', '35', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '29.98');
INSERT INTO public.europe_data_import VALUES (2447, '31/08/2020', '2020-35', '14', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '14.07');
INSERT INTO public.europe_data_import VALUES (2448, '24/08/2020', '2020-34', '9', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '7.34');
INSERT INTO public.europe_data_import VALUES (2449, '17/08/2020', '2020-33', '3', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '3.06');
INSERT INTO public.europe_data_import VALUES (2450, '10/08/2020', '2020-32', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2451, '03/08/2020', '2020-31', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2452, '27/07/2020', '2020-30', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '2.45');
INSERT INTO public.europe_data_import VALUES (2453, '20/07/2020', '2020-29', '3', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2454, '13/07/2020', '2020-28', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2455, '06/07/2020', '2020-27', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2456, '29/06/2020', '2020-26', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2457, '22/06/2020', '2020-25', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2458, '15/06/2020', '2020-24', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2459, '08/06/2020', '2020-23', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '2.45');
INSERT INTO public.europe_data_import VALUES (2460, '01/06/2020', '2020-22', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2461, '25/05/2020', '2020-21', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2462, '18/05/2020', '2020-20', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2463, '11/05/2020', '2020-19', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2464, '04/05/2020', '2020-18', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2465, '27/04/2020', '2020-17', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2466, '20/04/2020', '2020-16', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2467, '13/04/2020', '2020-15', '3', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '3.06');
INSERT INTO public.europe_data_import VALUES (2468, '06/04/2020', '2020-14', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '6.73');
INSERT INTO public.europe_data_import VALUES (2469, '30/03/2020', '2020-13', '9', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '');
INSERT INTO public.europe_data_import VALUES (2470, '01/02/2021', '2021-04', '859', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '217.83');
INSERT INTO public.europe_data_import VALUES (2471, '25/01/2021', '2021-03', '1049', '16', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '304.49');
INSERT INTO public.europe_data_import VALUES (2472, '18/01/2021', '2021-02', '1618', '22', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '570.16');
INSERT INTO public.europe_data_import VALUES (2473, '11/01/2021', '2021-01', '3376', '17', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '878.3');
INSERT INTO public.europe_data_import VALUES (2474, '04/01/2021', '2020-53', '4317', '19', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '717.66');
INSERT INTO public.europe_data_import VALUES (2475, '28/12/2020', '2020-52', '1969', '21', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '520.15');
INSERT INTO public.europe_data_import VALUES (2476, '21/12/2020', '2020-51', '2587', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '597.9');
INSERT INTO public.europe_data_import VALUES (2477, '14/12/2020', '2020-50', '2650', '17', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '538.65');
INSERT INTO public.europe_data_import VALUES (2478, '07/12/2020', '2020-49', '2068', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '434.75');
INSERT INTO public.europe_data_import VALUES (2479, '30/11/2020', '2020-48', '1740', '4', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '365.91');
INSERT INTO public.europe_data_import VALUES (2480, '23/11/2020', '2020-47', '1465', '4', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '303.23');
INSERT INTO public.europe_data_import VALUES (2481, '16/11/2020', '2020-46', '1191', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '298.55');
INSERT INTO public.europe_data_import VALUES (2482, '09/11/2020', '2020-45', '1424', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '278.8');
INSERT INTO public.europe_data_import VALUES (2483, '02/11/2020', '2020-44', '1018', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '219.09');
INSERT INTO public.europe_data_import VALUES (2484, '26/10/2020', '2020-43', '901', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '177.99');
INSERT INTO public.europe_data_import VALUES (2485, '19/10/2020', '2020-42', '658', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '93.62');
INSERT INTO public.europe_data_import VALUES (2486, '12/10/2020', '2020-41', '162', '3', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '33.11');
INSERT INTO public.europe_data_import VALUES (2487, '05/10/2020', '2020-40', '128', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '25.57');
INSERT INTO public.europe_data_import VALUES (2488, '28/09/2020', '2020-39', '96', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '19.41');
INSERT INTO public.europe_data_import VALUES (2489, '21/09/2020', '2020-38', '74', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '10.39');
INSERT INTO public.europe_data_import VALUES (2490, '14/09/2020', '2020-37', '17', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.45');
INSERT INTO public.europe_data_import VALUES (2491, '07/09/2020', '2020-36', '22', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '10.05');
INSERT INTO public.europe_data_import VALUES (2492, '31/08/2020', '2020-35', '66', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '17.7');
INSERT INTO public.europe_data_import VALUES (2493, '24/08/2020', '2020-34', '89', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '20.44');
INSERT INTO public.europe_data_import VALUES (2494, '17/08/2020', '2020-33', '90', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '20.78');
INSERT INTO public.europe_data_import VALUES (2495, '10/08/2020', '2020-32', '92', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '21.12');
INSERT INTO public.europe_data_import VALUES (2496, '03/08/2020', '2020-31', '93', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '12.79');
INSERT INTO public.europe_data_import VALUES (2497, '27/07/2020', '2020-30', '19', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.11');
INSERT INTO public.europe_data_import VALUES (2498, '20/07/2020', '2020-29', '17', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.0');
INSERT INTO public.europe_data_import VALUES (2499, '13/07/2020', '2020-28', '18', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '3.08');
INSERT INTO public.europe_data_import VALUES (2500, '06/07/2020', '2020-27', '9', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '1.94');
INSERT INTO public.europe_data_import VALUES (2501, '29/06/2020', '2020-26', '8', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '1.26');
INSERT INTO public.europe_data_import VALUES (2502, '22/06/2020', '2020-25', '3', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '2.51');
INSERT INTO public.europe_data_import VALUES (2503, '15/06/2020', '2020-24', '19', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.45');
INSERT INTO public.europe_data_import VALUES (2504, '08/06/2020', '2020-23', '20', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '3.31');
INSERT INTO public.europe_data_import VALUES (2505, '01/06/2020', '2020-22', '9', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '3.2');
INSERT INTO public.europe_data_import VALUES (2506, '25/05/2020', '2020-21', '19', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.22');
INSERT INTO public.europe_data_import VALUES (2507, '18/05/2020', '2020-20', '18', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '5.02');
INSERT INTO public.europe_data_import VALUES (2508, '11/05/2020', '2020-19', '26', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '9.25');
INSERT INTO public.europe_data_import VALUES (2509, '04/05/2020', '2020-18', '55', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '11.99');
INSERT INTO public.europe_data_import VALUES (2510, '27/04/2020', '2020-17', '50', '2', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '21.01');
INSERT INTO public.europe_data_import VALUES (2511, '20/04/2020', '2020-16', '134', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '36.65');
INSERT INTO public.europe_data_import VALUES (2512, '13/04/2020', '2020-15', '187', '2', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '47.84');
INSERT INTO public.europe_data_import VALUES (2513, '06/04/2020', '2020-14', '232', '3', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '40.07');
INSERT INTO public.europe_data_import VALUES (2514, '30/03/2020', '2020-13', '119', '6', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '21.01');
INSERT INTO public.europe_data_import VALUES (2515, '23/03/2020', '2020-12', '65', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '10.85');
INSERT INTO public.europe_data_import VALUES (2516, '16/03/2020', '2020-11', '30', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2517, '01/02/2021', '2021-04', '47325', '939', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '896.51');
INSERT INTO public.europe_data_import VALUES (2518, '25/01/2021', '2021-03', '48152', '1004', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '981.71');
INSERT INTO public.europe_data_import VALUES (2519, '18/01/2021', '2021-02', '56398', '1177', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1362.82');
INSERT INTO public.europe_data_import VALUES (2520, '11/01/2021', '2021-01', '88740', '1202', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1512.84');
INSERT INTO public.europe_data_import VALUES (2521, '04/01/2021', '2020-53', '72374', '918', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1119.19');
INSERT INTO public.europe_data_import VALUES (2522, '28/12/2020', '2020-52', '46817', '741', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '875.71');
INSERT INTO public.europe_data_import VALUES (2523, '21/12/2020', '2020-51', '46444', '802', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '757.67');
INSERT INTO public.europe_data_import VALUES (2524, '14/12/2020', '2020-50', '34246', '707', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '576.12');
INSERT INTO public.europe_data_import VALUES (2525, '07/12/2020', '2020-49', '27110', '764', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '512.4');
INSERT INTO public.europe_data_import VALUES (2526, '30/11/2020', '2020-48', '27460', '942', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '559.7');
INSERT INTO public.europe_data_import VALUES (2527, '23/11/2020', '2020-47', '32147', '988', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '727.1');
INSERT INTO public.europe_data_import VALUES (2528, '16/11/2020', '2020-46', '45288', '1350', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1112.43');
INSERT INTO public.europe_data_import VALUES (2529, '09/11/2020', '2020-45', '73184', '1429', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1471.68');
INSERT INTO public.europe_data_import VALUES (2530, '02/11/2020', '2020-44', '83547', '1228', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1575.23');
INSERT INTO public.europe_data_import VALUES (2531, '26/10/2020', '2020-43', '84212', '779', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1323.85');
INSERT INTO public.europe_data_import VALUES (2532, '19/10/2020', '2020-42', '56775', '388', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '858.6');
INSERT INTO public.europe_data_import VALUES (2533, '12/10/2020', '2020-41', '34664', '307', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '493.09');
INSERT INTO public.europe_data_import VALUES (2534, '05/10/2020', '2020-40', '17849', '121', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '311.8');
INSERT INTO public.europe_data_import VALUES (2535, '28/09/2020', '2020-39', '15357', '103', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '266.76');
INSERT INTO public.europe_data_import VALUES (2536, '21/09/2020', '2020-38', '13052', '47', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '197.98');
INSERT INTO public.europe_data_import VALUES (2537, '14/09/2020', '2020-37', '8032', '20', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '111.0');
INSERT INTO public.europe_data_import VALUES (2538, '07/09/2020', '2020-36', '3789', '13', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '58.53');
INSERT INTO public.europe_data_import VALUES (2539, '31/08/2020', '2020-35', '2444', '11', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '40.89');
INSERT INTO public.europe_data_import VALUES (2540, '24/08/2020', '2020-34', '1911', '15', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '33.5');
INSERT INTO public.europe_data_import VALUES (2541, '17/08/2020', '2020-33', '1657', '8', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '30.16');
INSERT INTO public.europe_data_import VALUES (2542, '10/08/2020', '2020-32', '1555', '6', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '28.46');
INSERT INTO public.europe_data_import VALUES (2543, '03/08/2020', '2020-31', '1476', '12', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '26.81');
INSERT INTO public.europe_data_import VALUES (2544, '27/07/2020', '2020-30', '1379', '12', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '20.19');
INSERT INTO public.europe_data_import VALUES (2545, '20/07/2020', '2020-29', '771', '7', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '13.43');
INSERT INTO public.europe_data_import VALUES (2546, '13/07/2020', '2020-28', '659', '4', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '14.75');
INSERT INTO public.europe_data_import VALUES (2547, '06/07/2020', '2020-27', '912', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '18.94');
INSERT INTO public.europe_data_import VALUES (2548, '29/06/2020', '2020-26', '1105', '12', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (2549, '22/06/2020', '2020-25', '474', '7', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '8.17');
INSERT INTO public.europe_data_import VALUES (2550, '15/06/2020', '2020-24', '396', '2', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '7.05');
INSERT INTO public.europe_data_import VALUES (2551, '08/06/2020', '2020-23', '355', '7', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '6.3');
INSERT INTO public.europe_data_import VALUES (2552, '01/06/2020', '2020-22', '316', '5', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '7.49');
INSERT INTO public.europe_data_import VALUES (2553, '25/05/2020', '2020-21', '482', '18', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '7.83');
INSERT INTO public.europe_data_import VALUES (2554, '18/05/2020', '2020-20', '352', '17', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '6.52');
INSERT INTO public.europe_data_import VALUES (2555, '11/05/2020', '2020-19', '342', '32', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '6.75');
INSERT INTO public.europe_data_import VALUES (2556, '04/05/2020', '2020-18', '377', '27', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '9.33');
INSERT INTO public.europe_data_import VALUES (2557, '27/04/2020', '2020-17', '617', '33', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '13.27');
INSERT INTO public.europe_data_import VALUES (2558, '20/04/2020', '2020-16', '796', '50', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '20.66');
INSERT INTO public.europe_data_import VALUES (2559, '13/04/2020', '2020-15', '1404', '71', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '29.69');
INSERT INTO public.europe_data_import VALUES (2560, '06/04/2020', '2020-14', '1758', '51', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '32.13');
INSERT INTO public.europe_data_import VALUES (2561, '30/03/2020', '2020-13', '1664', '15', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '23.77');
INSERT INTO public.europe_data_import VALUES (2562, '23/03/2020', '2020-12', '867', '1', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '10.64');
INSERT INTO public.europe_data_import VALUES (2563, '16/03/2020', '2020-11', '266', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '2.77');
INSERT INTO public.europe_data_import VALUES (2564, '09/03/2020', '2020-10', '29', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0.3');
INSERT INTO public.europe_data_import VALUES (2565, '02/03/2020', '2020-09', '3', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (2566, '24/02/2020', '2020-08', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2567, '17/02/2020', '2020-07', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2568, '10/02/2020', '2020-06', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2569, '03/02/2020', '2020-05', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2570, '27/01/2020', '2020-04', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2571, '20/01/2020', '2020-03', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2572, '13/01/2020', '2020-02', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2573, '06/01/2020', '2020-01', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2574, '01/02/2021', '2021-04', '888', '12', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.05');
INSERT INTO public.europe_data_import VALUES (2575, '25/01/2021', '2021-03', '895', '28', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.83');
INSERT INTO public.europe_data_import VALUES (2576, '18/01/2021', '2021-02', '1564', '15', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '3.35');
INSERT INTO public.europe_data_import VALUES (2577, '11/01/2021', '2021-01', '1343', '20', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.97');
INSERT INTO public.europe_data_import VALUES (2578, '04/01/2021', '2020-53', '1236', '20', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (2579, '28/12/2020', '2020-52', '1107', '13', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (2580, '21/12/2020', '2020-51', '1297', '210', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.55');
INSERT INTO public.europe_data_import VALUES (2581, '14/12/2020', '2020-50', '918', '12', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (2582, '07/12/2020', '2020-49', '893', '11', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (2583, '30/11/2020', '2020-48', '462', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (2584, '23/11/2020', '2020-47', '450', '8', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (2585, '16/11/2020', '2020-46', '182', '4', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.48');
INSERT INTO public.europe_data_import VALUES (2586, '09/11/2020', '2020-45', '236', '8', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (2587, '02/11/2020', '2020-44', '229', '3', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (2588, '26/10/2020', '2020-43', '91', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (2589, '19/10/2020', '2020-42', '201', '27', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (2590, '12/10/2020', '2020-41', '91', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (2591, '05/10/2020', '2020-40', '148', '3', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (2592, '28/09/2020', '2020-39', '97', '0', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (2593, '21/09/2020', '2020-38', '125', '6', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (2594, '14/09/2020', '2020-37', '180', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (2595, '07/09/2020', '2020-36', '165', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (2596, '31/08/2020', '2020-35', '215', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (2597, '24/08/2020', '2020-34', '154', '11', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (2598, '17/08/2020', '2020-33', '222', '16', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (2599, '10/08/2020', '2020-32', '339', '9', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (2600, '03/08/2020', '2020-31', '283', '10', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (2601, '27/07/2020', '2020-30', '429', '11', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.92');
INSERT INTO public.europe_data_import VALUES (2602, '20/07/2020', '2020-29', '370', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (2603, '13/07/2020', '2020-28', '622', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (2604, '06/07/2020', '2020-27', '584', '24', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.83');
INSERT INTO public.europe_data_import VALUES (2605, '29/06/2020', '2020-26', '1000', '27', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (2606, '22/06/2020', '2020-25', '1049', '24', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (2607, '15/06/2020', '2020-24', '761', '21', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.99');
INSERT INTO public.europe_data_import VALUES (2608, '08/06/2020', '2020-23', '967', '14', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (2609, '01/06/2020', '2020-22', '752', '4', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.84');
INSERT INTO public.europe_data_import VALUES (2610, '25/05/2020', '2020-21', '843', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.47');
INSERT INTO public.europe_data_import VALUES (2611, '18/05/2020', '2020-20', '430', '19', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (2612, '11/05/2020', '2020-19', '340', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (2613, '04/05/2020', '2020-18', '225', '6', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (2614, '27/04/2020', '2020-17', '127', '3', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (2615, '20/04/2020', '2020-16', '98', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (2616, '13/04/2020', '2020-15', '80', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (2617, '06/04/2020', '2020-14', '73', '10', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (2618, '30/03/2020', '2020-13', '55', '6', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (2619, '23/03/2020', '2020-12', '24', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (2620, '16/03/2020', '2020-11', '2', '0', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2621, '01/02/2021', '2021-04', '3664', '135', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '156.13');
INSERT INTO public.europe_data_import VALUES (2622, '25/01/2021', '2021-03', '5401', '205', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '216.51');
INSERT INTO public.europe_data_import VALUES (2623, '18/01/2021', '2021-02', '7170', '208', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '364.86');
INSERT INTO public.europe_data_import VALUES (2624, '11/01/2021', '2021-01', '14014', '223', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '505.95');
INSERT INTO public.europe_data_import VALUES (2625, '04/01/2021', '2020-53', '15362', '170', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '590.36');
INSERT INTO public.europe_data_import VALUES (2626, '28/12/2020', '2020-52', '18915', '169', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '750.78');
INSERT INTO public.europe_data_import VALUES (2627, '21/12/2020', '2020-51', '24676', '94', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '754.92');
INSERT INTO public.europe_data_import VALUES (2628, '14/12/2020', '2020-50', '19155', '56', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '523.69');
INSERT INTO public.europe_data_import VALUES (2629, '07/12/2020', '2020-49', '11251', '56', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '346.5');
INSERT INTO public.europe_data_import VALUES (2630, '30/11/2020', '2020-48', '8867', '45', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '296.52');
INSERT INTO public.europe_data_import VALUES (2631, '23/11/2020', '2020-47', '8349', '24', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '264.62');
INSERT INTO public.europe_data_import VALUES (2632, '16/11/2020', '2020-46', '7015', '17', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '255.54');
INSERT INTO public.europe_data_import VALUES (2633, '09/11/2020', '2020-45', '7822', '20', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '254.3');
INSERT INTO public.europe_data_import VALUES (2634, '02/11/2020', '2020-44', '6943', '21', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '205.08');
INSERT INTO public.europe_data_import VALUES (2635, '26/10/2020', '2020-43', '4964', '22', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '136.65');
INSERT INTO public.europe_data_import VALUES (2636, '19/10/2020', '2020-42', '2970', '11', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '98.38');
INSERT INTO public.europe_data_import VALUES (2637, '12/10/2020', '2020-41', '2742', '11', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '99.64');
INSERT INTO public.europe_data_import VALUES (2638, '05/10/2020', '2020-40', '3043', '9', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '134.91');
INSERT INTO public.europe_data_import VALUES (2639, '28/09/2020', '2020-39', '4790', '14', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '127.81');
INSERT INTO public.europe_data_import VALUES (2640, '21/09/2020', '2020-38', '2631', '6', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '74.06');
INSERT INTO public.europe_data_import VALUES (2641, '14/09/2020', '2020-37', '1669', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '43.33');
INSERT INTO public.europe_data_import VALUES (2642, '07/09/2020', '2020-36', '847', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '24.46');
INSERT INTO public.europe_data_import VALUES (2643, '31/08/2020', '2020-35', '573', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '18.65');
INSERT INTO public.europe_data_import VALUES (2644, '24/08/2020', '2020-34', '510', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '29.02');
INSERT INTO public.europe_data_import VALUES (2645, '17/08/2020', '2020-33', '1175', '4', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '31.48');
INSERT INTO public.europe_data_import VALUES (2646, '10/08/2020', '2020-32', '653', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '17.29');
INSERT INTO public.europe_data_import VALUES (2647, '03/08/2020', '2020-31', '351', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '10.61');
INSERT INTO public.europe_data_import VALUES (2648, '27/07/2020', '2020-30', '265', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '8.47');
INSERT INTO public.europe_data_import VALUES (2649, '20/07/2020', '2020-29', '227', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '5.87');
INSERT INTO public.europe_data_import VALUES (2650, '13/07/2020', '2020-28', '114', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '4.67');
INSERT INTO public.europe_data_import VALUES (2651, '06/07/2020', '2020-27', '157', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '7.6');
INSERT INTO public.europe_data_import VALUES (2652, '29/06/2020', '2020-26', '284', '4', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '8.3');
INSERT INTO public.europe_data_import VALUES (2653, '22/06/2020', '2020-25', '198', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '7.63');
INSERT INTO public.europe_data_import VALUES (2654, '15/06/2020', '2020-24', '245', '8', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '9.03');
INSERT INTO public.europe_data_import VALUES (2655, '08/06/2020', '2020-23', '279', '15', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '10.13');
INSERT INTO public.europe_data_import VALUES (2656, '01/06/2020', '2020-22', '309', '12', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '12.78');
INSERT INTO public.europe_data_import VALUES (2657, '25/05/2020', '2020-21', '433', '15', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '16.03');
INSERT INTO public.europe_data_import VALUES (2658, '18/05/2020', '2020-20', '498', '28', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '24.18');
INSERT INTO public.europe_data_import VALUES (2659, '11/05/2020', '2020-19', '906', '38', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '31.93');
INSERT INTO public.europe_data_import VALUES (2660, '04/05/2020', '2020-18', '948', '59', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '36.84');
INSERT INTO public.europe_data_import VALUES (2661, '27/04/2020', '2020-17', '1191', '67', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '41.35');
INSERT INTO public.europe_data_import VALUES (2662, '20/04/2020', '2020-16', '1210', '82', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '51.93');
INSERT INTO public.europe_data_import VALUES (2663, '13/04/2020', '2020-15', '1805', '94', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '65.09');
INSERT INTO public.europe_data_import VALUES (2664, '06/04/2020', '2020-14', '1974', '107', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '51.22');
INSERT INTO public.europe_data_import VALUES (2665, '30/03/2020', '2020-13', '1000', '59', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '26.18');
INSERT INTO public.europe_data_import VALUES (2666, '23/03/2020', '2020-12', '520', '12', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '23.37');
INSERT INTO public.europe_data_import VALUES (2667, '16/03/2020', '2020-11', '837', '1', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '15.0');
INSERT INTO public.europe_data_import VALUES (2668, '09/03/2020', '2020-10', '34', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0.65');
INSERT INTO public.europe_data_import VALUES (2669, '02/03/2020', '2020-09', '4', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0.07');
INSERT INTO public.europe_data_import VALUES (2670, '24/02/2020', '2020-08', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2671, '17/02/2020', '2020-07', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2672, '10/02/2020', '2020-06', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2673, '03/02/2020', '2020-05', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2674, '27/01/2020', '2020-04', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2675, '20/01/2020', '2020-03', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2676, '13/01/2020', '2020-02', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2677, '06/01/2020', '2020-01', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2678, '01/02/2021', '2021-04', '13', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (2679, '25/01/2021', '2021-03', '14', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '4.93');
INSERT INTO public.europe_data_import VALUES (2680, '18/01/2021', '2021-02', '34', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '6.47');
INSERT INTO public.europe_data_import VALUES (2681, '11/01/2021', '2021-01', '29', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '5.96');
INSERT INTO public.europe_data_import VALUES (2682, '04/01/2021', '2020-53', '29', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '6.27');
INSERT INTO public.europe_data_import VALUES (2683, '28/12/2020', '2020-52', '32', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.73');
INSERT INTO public.europe_data_import VALUES (2684, '21/12/2020', '2020-51', '53', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.22');
INSERT INTO public.europe_data_import VALUES (2685, '14/12/2020', '2020-50', '27', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '5.24');
INSERT INTO public.europe_data_import VALUES (2686, '07/12/2020', '2020-49', '24', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (2687, '30/11/2020', '2020-48', '9', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '2.88');
INSERT INTO public.europe_data_import VALUES (2688, '23/11/2020', '2020-47', '19', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '6.16');
INSERT INTO public.europe_data_import VALUES (2689, '16/11/2020', '2020-46', '41', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.83');
INSERT INTO public.europe_data_import VALUES (2690, '09/11/2020', '2020-45', '45', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '7.4');
INSERT INTO public.europe_data_import VALUES (2691, '02/11/2020', '2020-44', '27', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '10.68');
INSERT INTO public.europe_data_import VALUES (2692, '26/10/2020', '2020-43', '77', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '11.61');
INSERT INTO public.europe_data_import VALUES (2693, '19/10/2020', '2020-42', '36', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '4.11');
INSERT INTO public.europe_data_import VALUES (2694, '12/10/2020', '2020-41', '4', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.44');
INSERT INTO public.europe_data_import VALUES (2695, '05/10/2020', '2020-40', '10', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (2696, '28/09/2020', '2020-39', '6', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.44');
INSERT INTO public.europe_data_import VALUES (2697, '21/09/2020', '2020-38', '8', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (2698, '14/09/2020', '2020-37', '7', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (2699, '07/09/2020', '2020-36', '3', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (2700, '31/08/2020', '2020-35', '3', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (2701, '24/08/2020', '2020-34', '13', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '3.9');
INSERT INTO public.europe_data_import VALUES (2702, '17/08/2020', '2020-33', '25', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '21.36');
INSERT INTO public.europe_data_import VALUES (2703, '10/08/2020', '2020-32', '183', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '30.2');
INSERT INTO public.europe_data_import VALUES (2704, '03/08/2020', '2020-31', '111', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '15.41');
INSERT INTO public.europe_data_import VALUES (2705, '27/07/2020', '2020-30', '39', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.01');
INSERT INTO public.europe_data_import VALUES (2706, '20/07/2020', '2020-29', '39', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '22.49');
INSERT INTO public.europe_data_import VALUES (2707, '13/07/2020', '2020-28', '180', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '33.79');
INSERT INTO public.europe_data_import VALUES (2708, '06/07/2020', '2020-27', '149', '3', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '21.57');
INSERT INTO public.europe_data_import VALUES (2709, '29/06/2020', '2020-26', '61', '7', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '18.28');
INSERT INTO public.europe_data_import VALUES (2710, '22/06/2020', '2020-25', '117', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '38.52');
INSERT INTO public.europe_data_import VALUES (2711, '15/06/2020', '2020-24', '258', '15', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '114.12');
INSERT INTO public.europe_data_import VALUES (2712, '08/06/2020', '2020-23', '853', '4', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '198.96');
INSERT INTO public.europe_data_import VALUES (2713, '01/06/2020', '2020-22', '1084', '14', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '200.6');
INSERT INTO public.europe_data_import VALUES (2714, '25/05/2020', '2020-21', '869', '6', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '108.88');
INSERT INTO public.europe_data_import VALUES (2715, '18/05/2020', '2020-20', '191', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '29.68');
INSERT INTO public.europe_data_import VALUES (2716, '11/05/2020', '2020-19', '98', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '19.21');
INSERT INTO public.europe_data_import VALUES (2717, '04/05/2020', '2020-18', '89', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '27.32');
INSERT INTO public.europe_data_import VALUES (2718, '27/04/2020', '2020-17', '177', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '83.1');
INSERT INTO public.europe_data_import VALUES (2719, '20/04/2020', '2020-16', '632', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '80.84');
INSERT INTO public.europe_data_import VALUES (2720, '13/04/2020', '2020-15', '155', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '20.03');
INSERT INTO public.europe_data_import VALUES (2721, '06/04/2020', '2020-14', '40', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '5.96');
INSERT INTO public.europe_data_import VALUES (2722, '30/03/2020', '2020-13', '18', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (2723, '23/03/2020', '2020-12', '1', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2724, '01/02/2021', '2021-04', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2725, '25/01/2021', '2021-03', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2726, '18/01/2021', '2021-02', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '23.67');
INSERT INTO public.europe_data_import VALUES (2727, '11/01/2021', '2021-01', '13', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '23.67');
INSERT INTO public.europe_data_import VALUES (2728, '04/01/2021', '2020-53', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2729, '28/12/2020', '2020-52', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2730, '21/12/2020', '2020-51', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '9.75');
INSERT INTO public.europe_data_import VALUES (2731, '14/12/2020', '2020-50', '3', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '4.18');
INSERT INTO public.europe_data_import VALUES (2732, '07/12/2020', '2020-49', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '11.14');
INSERT INTO public.europe_data_import VALUES (2733, '30/11/2020', '2020-48', '8', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '23.67');
INSERT INTO public.europe_data_import VALUES (2734, '23/11/2020', '2020-47', '9', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '48.74');
INSERT INTO public.europe_data_import VALUES (2735, '16/11/2020', '2020-46', '26', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '36.21');
INSERT INTO public.europe_data_import VALUES (2736, '09/11/2020', '2020-45', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2737, '02/11/2020', '2020-44', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '12.53');
INSERT INTO public.europe_data_import VALUES (2738, '26/10/2020', '2020-43', '5', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '8.36');
INSERT INTO public.europe_data_import VALUES (2739, '19/10/2020', '2020-42', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2740, '12/10/2020', '2020-41', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '11.14');
INSERT INTO public.europe_data_import VALUES (2741, '05/10/2020', '2020-40', '7', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '9.75');
INSERT INTO public.europe_data_import VALUES (2742, '28/09/2020', '2020-39', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2743, '21/09/2020', '2020-38', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2744, '14/09/2020', '2020-37', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2745, '07/09/2020', '2020-36', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (2746, '31/08/2020', '2020-35', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2747, '24/08/2020', '2020-34', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (2748, '17/08/2020', '2020-33', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2749, '10/08/2020', '2020-32', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2750, '03/08/2020', '2020-31', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2751, '27/07/2020', '2020-30', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2752, '20/07/2020', '2020-29', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2753, '13/07/2020', '2020-28', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2754, '06/07/2020', '2020-27', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2755, '29/06/2020', '2020-26', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2756, '22/06/2020', '2020-25', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2757, '15/06/2020', '2020-24', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2758, '08/06/2020', '2020-23', '2', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2759, '01/06/2020', '2020-22', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2760, '25/05/2020', '2020-21', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2761, '18/05/2020', '2020-20', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2762, '11/05/2020', '2020-19', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2763, '04/05/2020', '2020-18', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2764, '27/04/2020', '2020-17', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2765, '20/04/2020', '2020-16', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2766, '13/04/2020', '2020-15', '2', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '6.96');
INSERT INTO public.europe_data_import VALUES (2767, '06/04/2020', '2020-14', '3', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '18.1');
INSERT INTO public.europe_data_import VALUES (2768, '30/03/2020', '2020-13', '10', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '15.32');
INSERT INTO public.europe_data_import VALUES (2769, '23/03/2020', '2020-12', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '');
INSERT INTO public.europe_data_import VALUES (2770, '01/02/2021', '2021-04', '9924', '143', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '187.36');
INSERT INTO public.europe_data_import VALUES (2771, '25/01/2021', '2021-03', '10196', '97', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '203.74');
INSERT INTO public.europe_data_import VALUES (2772, '18/01/2021', '2021-02', '11684', '21', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '201.46');
INSERT INTO public.europe_data_import VALUES (2773, '11/01/2021', '2021-01', '9951', '9', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '147.84');
INSERT INTO public.europe_data_import VALUES (2774, '04/01/2021', '2020-53', '5926', '14', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '114.34');
INSERT INTO public.europe_data_import VALUES (2775, '28/12/2020', '2020-52', '6353', '19', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '118.38');
INSERT INTO public.europe_data_import VALUES (2776, '21/12/2020', '2020-51', '6360', '24', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '117.32');
INSERT INTO public.europe_data_import VALUES (2777, '14/12/2020', '2020-50', '6239', '16', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '104.47');
INSERT INTO public.europe_data_import VALUES (2778, '07/12/2020', '2020-49', '4980', '15', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '93.52');
INSERT INTO public.europe_data_import VALUES (2779, '30/11/2020', '2020-48', '5063', '20', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '90.78');
INSERT INTO public.europe_data_import VALUES (2780, '23/11/2020', '2020-47', '4686', '25', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '76.62');
INSERT INTO public.europe_data_import VALUES (2781, '16/11/2020', '2020-46', '3542', '20', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '59.52');
INSERT INTO public.europe_data_import VALUES (2782, '09/11/2020', '2020-45', '2850', '16', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '52.66');
INSERT INTO public.europe_data_import VALUES (2783, '02/11/2020', '2020-44', '2805', '26', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '55.73');
INSERT INTO public.europe_data_import VALUES (2784, '26/10/2020', '2020-43', '3180', '24', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '56.34');
INSERT INTO public.europe_data_import VALUES (2785, '19/10/2020', '2020-42', '2870', '26', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '63.94');
INSERT INTO public.europe_data_import VALUES (2786, '12/10/2020', '2020-41', '3997', '39', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '66.03');
INSERT INTO public.europe_data_import VALUES (2787, '05/10/2020', '2020-40', '3094', '39', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '57.65');
INSERT INTO public.europe_data_import VALUES (2788, '28/09/2020', '2020-39', '3097', '48', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '71.94');
INSERT INTO public.europe_data_import VALUES (2789, '21/09/2020', '2020-38', '4629', '79', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '83.4');
INSERT INTO public.europe_data_import VALUES (2790, '14/09/2020', '2020-37', '4327', '123', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '87.71');
INSERT INTO public.europe_data_import VALUES (2791, '07/09/2020', '2020-36', '5092', '164', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '76.1');
INSERT INTO public.europe_data_import VALUES (2792, '31/08/2020', '2020-35', '3080', '114', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '73.86');
INSERT INTO public.europe_data_import VALUES (2793, '24/08/2020', '2020-34', '4852', '114', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '106.43');
INSERT INTO public.europe_data_import VALUES (2794, '17/08/2020', '2020-33', '6577', '144', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '130.98');
INSERT INTO public.europe_data_import VALUES (2795, '10/08/2020', '2020-32', '7489', '131', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '156.66');
INSERT INTO public.europe_data_import VALUES (2796, '03/08/2020', '2020-31', '9335', '115', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '180.54');
INSERT INTO public.europe_data_import VALUES (2797, '27/07/2020', '2020-30', '10053', '82', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '171.12');
INSERT INTO public.europe_data_import VALUES (2798, '20/07/2020', '2020-29', '8323', '84', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '143.68');
INSERT INTO public.europe_data_import VALUES (2799, '13/07/2020', '2020-28', '7107', '103', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '122.54');
INSERT INTO public.europe_data_import VALUES (2800, '06/07/2020', '2020-27', '6052', '68', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '100.08');
INSERT INTO public.europe_data_import VALUES (2801, '29/06/2020', '2020-26', '4696', '64', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '78.32');
INSERT INTO public.europe_data_import VALUES (2802, '22/06/2020', '2020-25', '3715', '70', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '65.9');
INSERT INTO public.europe_data_import VALUES (2803, '15/06/2020', '2020-24', '3362', '54', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '52.86');
INSERT INTO public.europe_data_import VALUES (2804, '08/06/2020', '2020-23', '2315', '36', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '48.22');
INSERT INTO public.europe_data_import VALUES (2805, '01/06/2020', '2020-22', '2863', '44', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '46.29');
INSERT INTO public.europe_data_import VALUES (2806, '25/05/2020', '2020-21', '2108', '30', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '37.95');
INSERT INTO public.europe_data_import VALUES (2807, '18/05/2020', '2020-20', '1967', '40', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '40.6');
INSERT INTO public.europe_data_import VALUES (2808, '11/05/2020', '2020-19', '2393', '55', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '39.22');
INSERT INTO public.europe_data_import VALUES (2809, '04/05/2020', '2020-18', '1819', '55', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '30.49');
INSERT INTO public.europe_data_import VALUES (2810, '27/04/2020', '2020-17', '1455', '52', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '29.5');
INSERT INTO public.europe_data_import VALUES (2811, '20/04/2020', '2020-16', '1713', '53', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '27.33');
INSERT INTO public.europe_data_import VALUES (2812, '13/04/2020', '2020-15', '1222', '91', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '19.63');
INSERT INTO public.europe_data_import VALUES (2813, '06/04/2020', '2020-14', '886', '43', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '14.37');
INSERT INTO public.europe_data_import VALUES (2814, '30/03/2020', '2020-13', '657', '36', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '7.9');
INSERT INTO public.europe_data_import VALUES (2815, '23/03/2020', '2020-12', '191', '3', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '1.86');
INSERT INTO public.europe_data_import VALUES (2816, '16/03/2020', '2020-11', '9', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0.09');
INSERT INTO public.europe_data_import VALUES (2817, '09/03/2020', '2020-10', '1', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (2818, '02/03/2020', '2020-09', '1', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (2819, '24/02/2020', '2020-08', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2820, '17/02/2020', '2020-07', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2821, '10/02/2020', '2020-06', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2822, '03/02/2020', '2020-05', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2823, '27/01/2020', '2020-04', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2824, '20/01/2020', '2020-03', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2825, '13/01/2020', '2020-02', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2826, '06/01/2020', '2020-01', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '');
INSERT INTO public.europe_data_import VALUES (2827, '01/02/2021', '2021-04', '9419', '251', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '111.33');
INSERT INTO public.europe_data_import VALUES (2828, '25/01/2021', '2021-03', '9923', '317', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '115.47');
INSERT INTO public.europe_data_import VALUES (2829, '18/01/2021', '2021-02', '10138', '138', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '98.02');
INSERT INTO public.europe_data_import VALUES (2830, '11/01/2021', '2021-01', '6892', '125', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '67.62');
INSERT INTO public.europe_data_import VALUES (2831, '04/01/2021', '2020-53', '4856', '65', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '47.69');
INSERT INTO public.europe_data_import VALUES (2832, '28/12/2020', '2020-52', '3429', '45', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '44.02');
INSERT INTO public.europe_data_import VALUES (2833, '21/12/2020', '2020-51', '4219', '74', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '47.95');
INSERT INTO public.europe_data_import VALUES (2834, '14/12/2020', '2020-50', '4112', '97', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '57.52');
INSERT INTO public.europe_data_import VALUES (2835, '07/12/2020', '2020-49', '5881', '355', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '71.11');
INSERT INTO public.europe_data_import VALUES (2836, '30/11/2020', '2020-48', '6474', '222', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '68.05');
INSERT INTO public.europe_data_import VALUES (2837, '23/11/2020', '2020-47', '5348', '193', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '61.79');
INSERT INTO public.europe_data_import VALUES (2838, '16/11/2020', '2020-46', '5388', '178', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '63.9');
INSERT INTO public.europe_data_import VALUES (2839, '09/11/2020', '2020-45', '5713', '146', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '76.39');
INSERT INTO public.europe_data_import VALUES (2840, '02/11/2020', '2020-44', '7559', '131', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '91.55');
INSERT INTO public.europe_data_import VALUES (2841, '26/10/2020', '2020-43', '8346', '166', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '84.05');
INSERT INTO public.europe_data_import VALUES (2842, '19/10/2020', '2020-42', '6256', '196', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '70.54');
INSERT INTO public.europe_data_import VALUES (2843, '12/10/2020', '2020-41', '5999', '544', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '70.72');
INSERT INTO public.europe_data_import VALUES (2844, '05/10/2020', '2020-40', '6287', '368', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '84.12');
INSERT INTO public.europe_data_import VALUES (2845, '28/09/2020', '2020-39', '8328', '189', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '92.97');
INSERT INTO public.europe_data_import VALUES (2846, '21/09/2020', '2020-38', '7825', '187', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '95.75');
INSERT INTO public.europe_data_import VALUES (2847, '14/09/2020', '2020-37', '8810', '379', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '28.47');
INSERT INTO public.europe_data_import VALUES (2848, '07/09/2020', '2020-36', '-3864', '3969', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '11.6');
INSERT INTO public.europe_data_import VALUES (2849, '31/08/2020', '2020-35', '5879', '245', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '69.68');
INSERT INTO public.europe_data_import VALUES (2850, '24/08/2020', '2020-34', '6227', '240', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '76.61');
INSERT INTO public.europe_data_import VALUES (2851, '17/08/2020', '2020-33', '7083', '148', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '86.44');
INSERT INTO public.europe_data_import VALUES (2852, '10/08/2020', '2020-32', '7935', '172', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '79.23');
INSERT INTO public.europe_data_import VALUES (2853, '03/08/2020', '2020-31', '5830', '235', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '72.01');
INSERT INTO public.europe_data_import VALUES (2854, '27/07/2020', '2020-30', '6681', '202', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '73.81');
INSERT INTO public.europe_data_import VALUES (2855, '20/07/2020', '2020-29', '6143', '266', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '69.39');
INSERT INTO public.europe_data_import VALUES (2856, '13/07/2020', '2020-28', '5912', '266', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '72.61');
INSERT INTO public.europe_data_import VALUES (2857, '06/07/2020', '2020-27', '6703', '352', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '65.14');
INSERT INTO public.europe_data_import VALUES (2858, '29/06/2020', '2020-26', '4615', '206', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '48.95');
INSERT INTO public.europe_data_import VALUES (2859, '22/06/2020', '2020-25', '3889', '327', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '43.28');
INSERT INTO public.europe_data_import VALUES (2860, '15/06/2020', '2020-24', '3631', '275', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '44.05');
INSERT INTO public.europe_data_import VALUES (2861, '08/06/2020', '2020-23', '4022', '263', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '36.63');
INSERT INTO public.europe_data_import VALUES (2862, '01/06/2020', '2020-22', '2342', '250', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '34.05');
INSERT INTO public.europe_data_import VALUES (2863, '25/05/2020', '2020-21', '3574', '372', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '41.42');
INSERT INTO public.europe_data_import VALUES (2864, '18/05/2020', '2020-20', '3623', '609', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '20.97');
INSERT INTO public.europe_data_import VALUES (2865, '11/05/2020', '2020-19', '21', '563', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '39.37');
INSERT INTO public.europe_data_import VALUES (2866, '04/05/2020', '2020-18', '6819', '988', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '115.52');
INSERT INTO public.europe_data_import VALUES (2867, '27/04/2020', '2020-17', '13251', '102', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '87.79');
INSERT INTO public.europe_data_import VALUES (2868, '20/04/2020', '2020-16', '2002', '141', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '33.51');
INSERT INTO public.europe_data_import VALUES (2869, '13/04/2020', '2020-15', '3820', '153', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '32.09');
INSERT INTO public.europe_data_import VALUES (2870, '06/04/2020', '2020-14', '1756', '122', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '16.44');
INSERT INTO public.europe_data_import VALUES (2871, '30/03/2020', '2020-13', '1101', '44', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '10.67');
INSERT INTO public.europe_data_import VALUES (2872, '23/03/2020', '2020-12', '752', '12', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '4.46');
INSERT INTO public.europe_data_import VALUES (2873, '16/03/2020', '2020-11', '23', '2', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0.18');
INSERT INTO public.europe_data_import VALUES (2874, '09/03/2020', '2020-10', '8', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0.08');
INSERT INTO public.europe_data_import VALUES (2875, '02/03/2020', '2020-09', '6', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0.03');
INSERT INTO public.europe_data_import VALUES (2876, '24/02/2020', '2020-08', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2877, '17/02/2020', '2020-07', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2878, '10/02/2020', '2020-06', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2879, '03/02/2020', '2020-05', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2880, '27/01/2020', '2020-04', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2881, '20/01/2020', '2020-03', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2882, '13/01/2020', '2020-02', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2883, '06/01/2020', '2020-01', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '');
INSERT INTO public.europe_data_import VALUES (2884, '01/02/2021', '2021-04', '4134', '357', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '9.52');
INSERT INTO public.europe_data_import VALUES (2885, '25/01/2021', '2021-03', '5420', '376', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '11.98');
INSERT INTO public.europe_data_import VALUES (2886, '18/01/2021', '2021-02', '6605', '386', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '14.16');
INSERT INTO public.europe_data_import VALUES (2887, '11/01/2021', '2021-01', '7605', '392', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '17.18');
INSERT INTO public.europe_data_import VALUES (2888, '04/01/2021', '2020-53', '9646', '400', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '16.57');
INSERT INTO public.europe_data_import VALUES (2889, '28/12/2020', '2020-52', '6986', '307', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '10.92');
INSERT INTO public.europe_data_import VALUES (2890, '21/12/2020', '2020-51', '3980', '178', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '7.1');
INSERT INTO public.europe_data_import VALUES (2891, '14/12/2020', '2020-50', '3143', '149', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '6.01');
INSERT INTO public.europe_data_import VALUES (2892, '07/12/2020', '2020-49', '2891', '135', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '5.38');
INSERT INTO public.europe_data_import VALUES (2893, '30/11/2020', '2020-48', '2514', '88', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '4.76');
INSERT INTO public.europe_data_import VALUES (2894, '23/11/2020', '2020-47', '2260', '95', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.81');
INSERT INTO public.europe_data_import VALUES (2895, '16/11/2020', '2020-46', '1566', '85', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.02');
INSERT INTO public.europe_data_import VALUES (2896, '09/11/2020', '2020-45', '1465', '90', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.65');
INSERT INTO public.europe_data_import VALUES (2897, '02/11/2020', '2020-44', '1196', '79', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (2898, '26/10/2020', '2020-43', '1116', '79', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2899, '19/10/2020', '2020-42', '1037', '80', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (2900, '12/10/2020', '2020-41', '704', '59', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (2901, '05/10/2020', '2020-40', '843', '98', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.66');
INSERT INTO public.europe_data_import VALUES (2902, '28/09/2020', '2020-39', '825', '113', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.82');
INSERT INTO public.europe_data_import VALUES (2903, '21/09/2020', '2020-38', '1006', '122', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2904, '14/09/2020', '2020-37', '1146', '118', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.27');
INSERT INTO public.europe_data_import VALUES (2905, '07/09/2020', '2020-36', '1136', '131', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.62');
INSERT INTO public.europe_data_import VALUES (2906, '31/08/2020', '2020-35', '1490', '156', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.24');
INSERT INTO public.europe_data_import VALUES (2907, '24/08/2020', '2020-34', '762', '83', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (2908, '17/08/2020', '2020-33', '983', '151', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (2909, '10/08/2020', '2020-32', '1009', '144', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.42');
INSERT INTO public.europe_data_import VALUES (2910, '03/08/2020', '2020-31', '2421', '259', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '6.68');
INSERT INTO public.europe_data_import VALUES (2911, '27/07/2020', '2020-30', '4287', '304', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '9.95');
INSERT INTO public.europe_data_import VALUES (2912, '20/07/2020', '2020-29', '5705', '444', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '12.47');
INSERT INTO public.europe_data_import VALUES (2913, '13/07/2020', '2020-28', '6817', '515', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '16.82');
INSERT INTO public.europe_data_import VALUES (2914, '06/07/2020', '2020-27', '10065', '554', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '19.94');
INSERT INTO public.europe_data_import VALUES (2915, '29/06/2020', '2020-26', '9955', '596', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '20.51');
INSERT INTO public.europe_data_import VALUES (2916, '22/06/2020', '2020-25', '10635', '618', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '21.07');
INSERT INTO public.europe_data_import VALUES (2917, '15/06/2020', '2020-24', '10519', '338', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '19.54');
INSERT INTO public.europe_data_import VALUES (2918, '08/06/2020', '2020-23', '9094', '278', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '16.75');
INSERT INTO public.europe_data_import VALUES (2919, '01/06/2020', '2020-22', '7720', '195', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '12.71');
INSERT INTO public.europe_data_import VALUES (2920, '25/05/2020', '2020-21', '5036', '134', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '7.83');
INSERT INTO public.europe_data_import VALUES (2921, '18/05/2020', '2020-20', '2829', '105', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '5.74');
INSERT INTO public.europe_data_import VALUES (2922, '11/05/2020', '2020-19', '2935', '96', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '5.06');
INSERT INTO public.europe_data_import VALUES (2923, '04/05/2020', '2020-18', '2146', '122', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.31');
INSERT INTO public.europe_data_import VALUES (2924, '27/04/2020', '2020-17', '1175', '68', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.25');
INSERT INTO public.europe_data_import VALUES (2925, '20/04/2020', '2020-16', '1079', '80', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.07');
INSERT INTO public.europe_data_import VALUES (2926, '13/04/2020', '2020-15', '995', '88', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.48');
INSERT INTO public.europe_data_import VALUES (2927, '06/04/2020', '2020-14', '494', '35', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (2928, '30/03/2020', '2020-13', '282', '26', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (2929, '23/03/2020', '2020-12', '184', '8', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (2930, '16/03/2020', '2020-11', '61', '1', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (2931, '09/03/2020', '2020-10', '47', '1', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (2932, '02/03/2020', '2020-09', '1', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (2933, '24/02/2020', '2020-08', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (2934, '17/02/2020', '2020-07', '1', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (2935, '10/02/2020', '2020-06', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2936, '03/02/2020', '2020-05', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2937, '27/01/2020', '2020-04', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2938, '20/01/2020', '2020-03', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2939, '13/01/2020', '2020-02', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2940, '06/01/2020', '2020-01', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2941, '01/02/2021', '2021-04', '1716', '49', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '58.23');
INSERT INTO public.europe_data_import VALUES (2942, '25/01/2021', '2021-03', '2042', '85', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '70.88');
INSERT INTO public.europe_data_import VALUES (2943, '18/01/2021', '2021-02', '2532', '70', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '67.4');
INSERT INTO public.europe_data_import VALUES (2944, '11/01/2021', '2021-01', '1818', '64', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '66.41');
INSERT INTO public.europe_data_import VALUES (2945, '04/01/2021', '2020-53', '2468', '51', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '51.37');
INSERT INTO public.europe_data_import VALUES (2946, '28/12/2020', '2020-52', '847', '56', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '42.44');
INSERT INTO public.europe_data_import VALUES (2947, '21/12/2020', '2020-51', '1892', '52', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '53.1');
INSERT INTO public.europe_data_import VALUES (2948, '14/12/2020', '2020-50', '1535', '41', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '53.85');
INSERT INTO public.europe_data_import VALUES (2949, '07/12/2020', '2020-49', '1940', '50', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '43.12');
INSERT INTO public.europe_data_import VALUES (2950, '30/11/2020', '2020-48', '843', '33', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '31.72');
INSERT INTO public.europe_data_import VALUES (2951, '23/11/2020', '2020-47', '1204', '34', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '37.45');
INSERT INTO public.europe_data_import VALUES (2952, '16/11/2020', '2020-46', '1213', '33', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '36.31');
INSERT INTO public.europe_data_import VALUES (2953, '09/11/2020', '2020-45', '1130', '31', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '39.67');
INSERT INTO public.europe_data_import VALUES (2954, '02/11/2020', '2020-44', '1430', '30', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '36.4');
INSERT INTO public.europe_data_import VALUES (2955, '26/10/2020', '2020-43', '919', '31', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '37.02');
INSERT INTO public.europe_data_import VALUES (2956, '19/10/2020', '2020-42', '1470', '28', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '34.34');
INSERT INTO public.europe_data_import VALUES (2957, '12/10/2020', '2020-41', '746', '31', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '24.27');
INSERT INTO public.europe_data_import VALUES (2958, '05/10/2020', '2020-40', '820', '37', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '29.39');
INSERT INTO public.europe_data_import VALUES (2959, '28/09/2020', '2020-39', '1077', '14', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '25.12');
INSERT INTO public.europe_data_import VALUES (2960, '21/09/2020', '2020-38', '544', '24', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '19.29');
INSERT INTO public.europe_data_import VALUES (2961, '14/09/2020', '2020-37', '701', '24', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '19.83');
INSERT INTO public.europe_data_import VALUES (2962, '07/09/2020', '2020-36', '579', '47', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '26.13');
INSERT INTO public.europe_data_import VALUES (2963, '31/08/2020', '2020-35', '1107', '48', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '43.65');
INSERT INTO public.europe_data_import VALUES (2964, '24/08/2020', '2020-34', '1710', '51', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '65.06');
INSERT INTO public.europe_data_import VALUES (2965, '17/08/2020', '2020-33', '2489', '55', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '84.67');
INSERT INTO public.europe_data_import VALUES (2966, '10/08/2020', '2020-32', '2975', '96', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '89.76');
INSERT INTO public.europe_data_import VALUES (2967, '03/08/2020', '2020-31', '2818', '59', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '86.8');
INSERT INTO public.europe_data_import VALUES (2968, '27/07/2020', '2020-30', '2784', '64', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '76.79');
INSERT INTO public.europe_data_import VALUES (2969, '20/07/2020', '2020-29', '2172', '77', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '63.05');
INSERT INTO public.europe_data_import VALUES (2970, '13/07/2020', '2020-28', '1897', '50', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '57.95');
INSERT INTO public.europe_data_import VALUES (2971, '06/07/2020', '2020-27', '1843', '53', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '48.83');
INSERT INTO public.europe_data_import VALUES (2972, '29/06/2020', '2020-26', '1308', '57', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '34.31');
INSERT INTO public.europe_data_import VALUES (2973, '22/06/2020', '2020-25', '906', '33', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '24.96');
INSERT INTO public.europe_data_import VALUES (2974, '15/06/2020', '2020-24', '705', '19', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '18.64');
INSERT INTO public.europe_data_import VALUES (2975, '08/06/2020', '2020-23', '498', '9', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '17.04');
INSERT INTO public.europe_data_import VALUES (2976, '01/06/2020', '2020-22', '602', '11', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '18.27');
INSERT INTO public.europe_data_import VALUES (2977, '25/05/2020', '2020-21', '577', '5', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '14.83');
INSERT INTO public.europe_data_import VALUES (2978, '18/05/2020', '2020-20', '380', '13', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '12.13');
INSERT INTO public.europe_data_import VALUES (2979, '11/05/2020', '2020-19', '403', '5', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '10.23');
INSERT INTO public.europe_data_import VALUES (2980, '04/05/2020', '2020-18', '257', '4', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '5.49');
INSERT INTO public.europe_data_import VALUES (2981, '27/04/2020', '2020-17', '97', '1', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (2982, '20/04/2020', '2020-16', '76', '1', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (2983, '13/04/2020', '2020-15', '56', '3', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '1.47');
INSERT INTO public.europe_data_import VALUES (2984, '06/04/2020', '2020-14', '39', '3', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '1.02');
INSERT INTO public.europe_data_import VALUES (2985, '30/03/2020', '2020-13', '27', '0', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '0.46');
INSERT INTO public.europe_data_import VALUES (2986, '23/03/2020', '2020-12', '3', '0', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '');
INSERT INTO public.europe_data_import VALUES (2987, '01/02/2021', '2021-04', '80', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '12.46');
INSERT INTO public.europe_data_import VALUES (2988, '25/01/2021', '2021-03', '89', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '11.65');
INSERT INTO public.europe_data_import VALUES (2989, '18/01/2021', '2021-02', '69', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '6.34');
INSERT INTO public.europe_data_import VALUES (2990, '11/01/2021', '2021-01', '17', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (2991, '04/01/2021', '2020-53', '31', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (2992, '28/12/2020', '2020-52', '17', '1', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (2993, '21/12/2020', '2020-51', '36', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '4.79');
INSERT INTO public.europe_data_import VALUES (2994, '14/12/2020', '2020-50', '29', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (2995, '07/12/2020', '2020-49', '13', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.65');
INSERT INTO public.europe_data_import VALUES (2996, '30/11/2020', '2020-48', '23', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.61');
INSERT INTO public.europe_data_import VALUES (2997, '23/11/2020', '2020-47', '26', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.8');
INSERT INTO public.europe_data_import VALUES (2998, '16/11/2020', '2020-46', '12', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (2999, '09/11/2020', '2020-45', '3', '2', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (3000, '02/11/2020', '2020-44', '10', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.4');
INSERT INTO public.europe_data_import VALUES (3001, '26/10/2020', '2020-43', '9', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (3002, '19/10/2020', '2020-42', '7', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.84');
INSERT INTO public.europe_data_import VALUES (3003, '12/10/2020', '2020-41', '18', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.58');
INSERT INTO public.europe_data_import VALUES (3004, '05/10/2020', '2020-40', '17', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.17');
INSERT INTO public.europe_data_import VALUES (3005, '28/09/2020', '2020-39', '26', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (3006, '21/09/2020', '2020-38', '6', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (3007, '14/09/2020', '2020-37', '24', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '4.06');
INSERT INTO public.europe_data_import VALUES (3008, '07/09/2020', '2020-36', '31', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (3009, '31/08/2020', '2020-35', '15', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '8.85');
INSERT INTO public.europe_data_import VALUES (3010, '24/08/2020', '2020-34', '105', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '7.74');
INSERT INTO public.europe_data_import VALUES (3011, '17/08/2020', '2020-33', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3012, '10/08/2020', '2020-32', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '129.06');
INSERT INTO public.europe_data_import VALUES (3013, '03/08/2020', '2020-31', '1750', '32', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '129.06');
INSERT INTO public.europe_data_import VALUES (3014, '27/07/2020', '2020-30', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3015, '20/07/2020', '2020-29', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3016, '13/07/2020', '2020-28', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '78.91');
INSERT INTO public.europe_data_import VALUES (3017, '06/07/2020', '2020-27', '1070', '19', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '103.76');
INSERT INTO public.europe_data_import VALUES (3018, '29/06/2020', '2020-26', '337', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '51.25');
INSERT INTO public.europe_data_import VALUES (3019, '22/06/2020', '2020-25', '358', '20', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '26.4');
INSERT INTO public.europe_data_import VALUES (3020, '15/06/2020', '2020-24', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3021, '08/06/2020', '2020-23', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '19.4');
INSERT INTO public.europe_data_import VALUES (3022, '01/06/2020', '2020-22', '263', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '52.51');
INSERT INTO public.europe_data_import VALUES (3023, '25/05/2020', '2020-21', '449', '5', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '44.54');
INSERT INTO public.europe_data_import VALUES (3024, '18/05/2020', '2020-20', '155', '3', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '20.58');
INSERT INTO public.europe_data_import VALUES (3025, '11/05/2020', '2020-19', '124', '3', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '13.35');
INSERT INTO public.europe_data_import VALUES (3026, '04/05/2020', '2020-18', '57', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '17.4');
INSERT INTO public.europe_data_import VALUES (3027, '27/04/2020', '2020-17', '179', '1', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '17.48');
INSERT INTO public.europe_data_import VALUES (3028, '20/04/2020', '2020-16', '58', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (3029, '13/04/2020', '2020-15', '5', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (3030, '06/04/2020', '2020-14', '2', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (3031, '30/03/2020', '2020-13', '8', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (3032, '23/03/2020', '2020-12', '5', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (3033, '16/03/2020', '2020-11', '1', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3034, '01/02/2021', '2021-04', '185', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '7.38');
INSERT INTO public.europe_data_import VALUES (3035, '25/01/2021', '2021-03', '73', '1', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '11.27');
INSERT INTO public.europe_data_import VALUES (3036, '18/01/2021', '2021-02', '321', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '14.7');
INSERT INTO public.europe_data_import VALUES (3037, '11/01/2021', '2021-01', '193', '3', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '14.78');
INSERT INTO public.europe_data_import VALUES (3038, '04/01/2021', '2020-53', '324', '2', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '15.9');
INSERT INTO public.europe_data_import VALUES (3039, '28/12/2020', '2020-52', '232', '1', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '9.38');
INSERT INTO public.europe_data_import VALUES (3040, '21/12/2020', '2020-51', '96', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '5.0');
INSERT INTO public.europe_data_import VALUES (3041, '14/12/2020', '2020-50', '79', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '3.83');
INSERT INTO public.europe_data_import VALUES (3042, '07/12/2020', '2020-49', '55', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.32');
INSERT INTO public.europe_data_import VALUES (3043, '30/11/2020', '2020-48', '26', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (3044, '23/11/2020', '2020-47', '58', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (3045, '16/11/2020', '2020-46', '2', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (3046, '09/11/2020', '2020-45', '28', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (3047, '02/11/2020', '2020-44', '2', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.09');
INSERT INTO public.europe_data_import VALUES (3048, '26/10/2020', '2020-43', '36', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (3049, '19/10/2020', '2020-42', '11', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (3050, '12/10/2020', '2020-41', '16', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.12');
INSERT INTO public.europe_data_import VALUES (3051, '05/10/2020', '2020-40', '23', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (3052, '28/09/2020', '2020-39', '11', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (3053, '21/09/2020', '2020-38', '3', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (3054, '14/09/2020', '2020-37', '31', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.23');
INSERT INTO public.europe_data_import VALUES (3055, '07/09/2020', '2020-36', '12', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (3056, '31/08/2020', '2020-35', '12', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (3057, '24/08/2020', '2020-34', '21', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (3058, '17/08/2020', '2020-33', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (3059, '10/08/2020', '2020-32', '6', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (3060, '03/08/2020', '2020-31', '16', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (3061, '27/07/2020', '2020-30', '12', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (3062, '20/07/2020', '2020-29', '19', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (3063, '13/07/2020', '2020-28', '17', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.17');
INSERT INTO public.europe_data_import VALUES (3064, '06/07/2020', '2020-27', '24', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.06');
INSERT INTO public.europe_data_import VALUES (3065, '29/06/2020', '2020-26', '48', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (3066, '22/06/2020', '2020-25', '47', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (3067, '15/06/2020', '2020-24', '55', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.63');
INSERT INTO public.europe_data_import VALUES (3068, '08/06/2020', '2020-23', '2', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (3069, '01/06/2020', '2020-22', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3070, '25/05/2020', '2020-21', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3071, '18/05/2020', '2020-20', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3072, '11/05/2020', '2020-19', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3073, '04/05/2020', '2020-18', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3074, '27/04/2020', '2020-17', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (3075, '20/04/2020', '2020-16', '5', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (3076, '13/04/2020', '2020-15', '5', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (3077, '06/04/2020', '2020-14', '17', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (3078, '30/03/2020', '2020-13', '11', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (3079, '23/03/2020', '2020-12', '1', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3080, '01/02/2021', '2021-04', '3492', '43', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '518.11');
INSERT INTO public.europe_data_import VALUES (3081, '25/01/2021', '2021-03', '3372', '43', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '521.66');
INSERT INTO public.europe_data_import VALUES (3082, '18/01/2021', '2021-02', '3539', '46', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '590.5');
INSERT INTO public.europe_data_import VALUES (3083, '11/01/2021', '2021-01', '4284', '36', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '603.63');
INSERT INTO public.europe_data_import VALUES (3084, '04/01/2021', '2020-53', '3713', '38', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '583.25');
INSERT INTO public.europe_data_import VALUES (3085, '28/12/2020', '2020-52', '4014', '39', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '585.21');
INSERT INTO public.europe_data_import VALUES (3086, '21/12/2020', '2020-51', '3739', '25', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '514.48');
INSERT INTO public.europe_data_import VALUES (3087, '14/12/2020', '2020-50', '3077', '18', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '453.12');
INSERT INTO public.europe_data_import VALUES (3088, '07/12/2020', '2020-49', '2926', '19', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '396.58');
INSERT INTO public.europe_data_import VALUES (3089, '30/11/2020', '2020-48', '2328', '24', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '333.25');
INSERT INTO public.europe_data_import VALUES (3090, '23/11/2020', '2020-47', '2087', '7', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '271.66');
INSERT INTO public.europe_data_import VALUES (3091, '16/11/2020', '2020-46', '1512', '6', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '200.18');
INSERT INTO public.europe_data_import VALUES (3092, '09/11/2020', '2020-45', '1140', '2', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '129.38');
INSERT INTO public.europe_data_import VALUES (3093, '02/11/2020', '2020-44', '574', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '68.46');
INSERT INTO public.europe_data_import VALUES (3094, '26/10/2020', '2020-43', '333', '5', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '41.21');
INSERT INTO public.europe_data_import VALUES (3095, '19/10/2020', '2020-42', '213', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '35.55');
INSERT INTO public.europe_data_import VALUES (3096, '12/10/2020', '2020-41', '258', '1', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '50.2');
INSERT INTO public.europe_data_import VALUES (3097, '05/10/2020', '2020-40', '407', '3', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '51.55');
INSERT INTO public.europe_data_import VALUES (3098, '28/09/2020', '2020-39', '276', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '39.55');
INSERT INTO public.europe_data_import VALUES (3099, '21/09/2020', '2020-38', '248', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '30.87');
INSERT INTO public.europe_data_import VALUES (3100, '14/09/2020', '2020-37', '161', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '22.87');
INSERT INTO public.europe_data_import VALUES (3101, '07/09/2020', '2020-36', '142', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '18.34');
INSERT INTO public.europe_data_import VALUES (3102, '31/08/2020', '2020-35', '101', '1', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '13.81');
INSERT INTO public.europe_data_import VALUES (3103, '24/08/2020', '2020-34', '82', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '9.06');
INSERT INTO public.europe_data_import VALUES (3104, '17/08/2020', '2020-33', '38', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '8.38');
INSERT INTO public.europe_data_import VALUES (3105, '10/08/2020', '2020-32', '73', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '8.91');
INSERT INTO public.europe_data_import VALUES (3106, '03/08/2020', '2020-31', '45', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '4.38');
INSERT INTO public.europe_data_import VALUES (3107, '27/07/2020', '2020-30', '13', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '1.51');
INSERT INTO public.europe_data_import VALUES (3108, '20/07/2020', '2020-29', '7', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '2.11');
INSERT INTO public.europe_data_import VALUES (3109, '13/07/2020', '2020-28', '21', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '2.04');
INSERT INTO public.europe_data_import VALUES (3110, '06/07/2020', '2020-27', '6', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0.91');
INSERT INTO public.europe_data_import VALUES (3111, '29/06/2020', '2020-26', '6', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '1.06');
INSERT INTO public.europe_data_import VALUES (3112, '22/06/2020', '2020-25', '8', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '3.17');
INSERT INTO public.europe_data_import VALUES (3113, '15/06/2020', '2020-24', '34', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '7.85');
INSERT INTO public.europe_data_import VALUES (3114, '08/06/2020', '2020-23', '70', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '8.76');
INSERT INTO public.europe_data_import VALUES (3115, '01/06/2020', '2020-22', '46', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '7.17');
INSERT INTO public.europe_data_import VALUES (3116, '25/05/2020', '2020-21', '49', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '6.34');
INSERT INTO public.europe_data_import VALUES (3117, '18/05/2020', '2020-20', '35', '3', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '5.59');
INSERT INTO public.europe_data_import VALUES (3118, '11/05/2020', '2020-19', '39', '5', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '7.25');
INSERT INTO public.europe_data_import VALUES (3119, '04/05/2020', '2020-18', '57', '6', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '12.98');
INSERT INTO public.europe_data_import VALUES (3120, '27/04/2020', '2020-17', '115', '9', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '25.21');
INSERT INTO public.europe_data_import VALUES (3121, '20/04/2020', '2020-16', '219', '15', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '32.53');
INSERT INTO public.europe_data_import VALUES (3122, '13/04/2020', '2020-15', '212', '10', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '47.55');
INSERT INTO public.europe_data_import VALUES (3123, '06/04/2020', '2020-14', '418', '12', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '58.2');
INSERT INTO public.europe_data_import VALUES (3124, '30/03/2020', '2020-13', '353', '3', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '38.34');
INSERT INTO public.europe_data_import VALUES (3125, '23/03/2020', '2020-12', '155', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '23.85');
INSERT INTO public.europe_data_import VALUES (3126, '16/03/2020', '2020-11', '161', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '12.83');
INSERT INTO public.europe_data_import VALUES (3127, '09/03/2020', '2020-10', '9', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0.75');
INSERT INTO public.europe_data_import VALUES (3128, '02/03/2020', '2020-09', '1', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (3129, '24/02/2020', '2020-08', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3130, '17/02/2020', '2020-07', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3131, '10/02/2020', '2020-06', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3132, '03/02/2020', '2020-05', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3133, '27/01/2020', '2020-04', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3134, '20/01/2020', '2020-03', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3135, '13/01/2020', '2020-02', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3136, '06/01/2020', '2020-01', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3137, '01/02/2021', '2021-04', '2860', '198', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '249.1');
INSERT INTO public.europe_data_import VALUES (3138, '25/01/2021', '2021-03', '0', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '107.39');
INSERT INTO public.europe_data_import VALUES (3139, '18/01/2021', '2021-02', '1233', '78', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '261.38');
INSERT INTO public.europe_data_import VALUES (3140, '11/01/2021', '2021-01', '1768', '67', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '263.38');
INSERT INTO public.europe_data_import VALUES (3141, '04/01/2021', '2020-53', '1256', '64', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '219.14');
INSERT INTO public.europe_data_import VALUES (3142, '28/12/2020', '2020-52', '1260', '27', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '167.14');
INSERT INTO public.europe_data_import VALUES (3143, '21/12/2020', '2020-51', '659', '13', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '80.65');
INSERT INTO public.europe_data_import VALUES (3144, '14/12/2020', '2020-50', '267', '5', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '31.18');
INSERT INTO public.europe_data_import VALUES (3145, '07/12/2020', '2020-49', '91', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '24.56');
INSERT INTO public.europe_data_import VALUES (3146, '30/11/2020', '2020-48', '191', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '27.44');
INSERT INTO public.europe_data_import VALUES (3147, '23/11/2020', '2020-47', '124', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '18.81');
INSERT INTO public.europe_data_import VALUES (3148, '16/11/2020', '2020-46', '92', '2', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '14.81');
INSERT INTO public.europe_data_import VALUES (3149, '09/11/2020', '2020-45', '78', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '12.98');
INSERT INTO public.europe_data_import VALUES (3150, '02/11/2020', '2020-44', '71', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '12.63');
INSERT INTO public.europe_data_import VALUES (3151, '26/10/2020', '2020-43', '74', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '16.11');
INSERT INTO public.europe_data_import VALUES (3152, '19/10/2020', '2020-42', '111', '3', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '18.38');
INSERT INTO public.europe_data_import VALUES (3153, '12/10/2020', '2020-41', '100', '2', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '20.73');
INSERT INTO public.europe_data_import VALUES (3154, '05/10/2020', '2020-40', '138', '3', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '26.13');
INSERT INTO public.europe_data_import VALUES (3155, '28/09/2020', '2020-39', '162', '4', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '31.01');
INSERT INTO public.europe_data_import VALUES (3156, '21/09/2020', '2020-38', '194', '6', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '36.23');
INSERT INTO public.europe_data_import VALUES (3157, '14/09/2020', '2020-37', '222', '4', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '44.77');
INSERT INTO public.europe_data_import VALUES (3158, '07/09/2020', '2020-36', '292', '3', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '54.7');
INSERT INTO public.europe_data_import VALUES (3159, '31/08/2020', '2020-35', '336', '6', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '62.88');
INSERT INTO public.europe_data_import VALUES (3160, '24/08/2020', '2020-34', '386', '15', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '86.14');
INSERT INTO public.europe_data_import VALUES (3161, '17/08/2020', '2020-33', '603', '12', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '92.67');
INSERT INTO public.europe_data_import VALUES (3162, '10/08/2020', '2020-32', '461', '15', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '89.62');
INSERT INTO public.europe_data_import VALUES (3163, '03/08/2020', '2020-31', '568', '11', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '85.53');
INSERT INTO public.europe_data_import VALUES (3164, '27/07/2020', '2020-30', '414', '11', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '74.56');
INSERT INTO public.europe_data_import VALUES (3165, '20/07/2020', '2020-29', '442', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '70.11');
INSERT INTO public.europe_data_import VALUES (3166, '13/07/2020', '2020-28', '363', '7', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '49.65');
INSERT INTO public.europe_data_import VALUES (3167, '06/07/2020', '2020-27', '207', '2', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '30.75');
INSERT INTO public.europe_data_import VALUES (3168, '29/06/2020', '2020-26', '146', '6', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '25.35');
INSERT INTO public.europe_data_import VALUES (3169, '22/06/2020', '2020-25', '145', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '26.3');
INSERT INTO public.europe_data_import VALUES (3170, '15/06/2020', '2020-24', '157', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '17.86');
INSERT INTO public.europe_data_import VALUES (3171, '08/06/2020', '2020-23', '48', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.23');
INSERT INTO public.europe_data_import VALUES (3172, '01/06/2020', '2020-22', '35', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.14');
INSERT INTO public.europe_data_import VALUES (3173, '25/05/2020', '2020-21', '47', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '6.79');
INSERT INTO public.europe_data_import VALUES (3174, '18/05/2020', '2020-20', '31', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.93');
INSERT INTO public.europe_data_import VALUES (3175, '11/05/2020', '2020-19', '60', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '9.84');
INSERT INTO public.europe_data_import VALUES (3176, '04/05/2020', '2020-18', '53', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.84');
INSERT INTO public.europe_data_import VALUES (3177, '27/04/2020', '2020-17', '37', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '3.92');
INSERT INTO public.europe_data_import VALUES (3178, '20/04/2020', '2020-16', '8', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (3179, '13/04/2020', '2020-15', '5', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (3180, '06/04/2020', '2020-14', '0', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (3181, '30/03/2020', '2020-13', '5', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (3182, '23/03/2020', '2020-12', '3', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (3183, '16/03/2020', '2020-11', '1', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3184, '01/02/2021', '2021-04', '4617', '37', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.41');
INSERT INTO public.europe_data_import VALUES (3185, '25/01/2021', '2021-03', '2572', '36', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (3186, '18/01/2021', '2021-02', '2579', '27', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '4.97');
INSERT INTO public.europe_data_import VALUES (3187, '11/01/2021', '2021-01', '2994', '55', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '4.88');
INSERT INTO public.europe_data_import VALUES (3188, '04/01/2021', '2020-53', '2477', '36', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.06');
INSERT INTO public.europe_data_import VALUES (3189, '28/12/2020', '2020-52', '3194', '59', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.69');
INSERT INTO public.europe_data_import VALUES (3190, '21/12/2020', '2020-51', '3182', '47', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.94');
INSERT INTO public.europe_data_import VALUES (3191, '14/12/2020', '2020-50', '3474', '59', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.46');
INSERT INTO public.europe_data_import VALUES (3192, '07/12/2020', '2020-49', '3761', '47', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.7');
INSERT INTO public.europe_data_import VALUES (3193, '30/11/2020', '2020-48', '3749', '53', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.08');
INSERT INTO public.europe_data_import VALUES (3194, '23/11/2020', '2020-47', '3065', '78', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.45');
INSERT INTO public.europe_data_import VALUES (3195, '16/11/2020', '2020-46', '3045', '46', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.48');
INSERT INTO public.europe_data_import VALUES (3196, '09/11/2020', '2020-45', '3092', '45', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.65');
INSERT INTO public.europe_data_import VALUES (3197, '02/11/2020', '2020-44', '3240', '52', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.64');
INSERT INTO public.europe_data_import VALUES (3198, '26/10/2020', '2020-43', '4206', '74', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '8.07');
INSERT INTO public.europe_data_import VALUES (3199, '19/10/2020', '2020-42', '4842', '65', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '9.21');
INSERT INTO public.europe_data_import VALUES (3200, '12/10/2020', '2020-41', '5476', '65', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '9.78');
INSERT INTO public.europe_data_import VALUES (3201, '05/10/2020', '2020-40', '5487', '52', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '8.92');
INSERT INTO public.europe_data_import VALUES (3202, '28/09/2020', '2020-39', '4512', '74', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '8.06');
INSERT INTO public.europe_data_import VALUES (3203, '21/09/2020', '2020-38', '4519', '83', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '9.05');
INSERT INTO public.europe_data_import VALUES (3204, '14/09/2020', '2020-37', '5629', '95', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '11.76');
INSERT INTO public.europe_data_import VALUES (3205, '07/09/2020', '2020-36', '7550', '125', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '16.06');
INSERT INTO public.europe_data_import VALUES (3206, '31/08/2020', '2020-35', '10451', '115', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '18.96');
INSERT INTO public.europe_data_import VALUES (3207, '24/08/2020', '2020-34', '10795', '150', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '15.93');
INSERT INTO public.europe_data_import VALUES (3208, '17/08/2020', '2020-33', '7058', '121', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '10.6');
INSERT INTO public.europe_data_import VALUES (3209, '10/08/2020', '2020-32', '4819', '123', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '7.9');
INSERT INTO public.europe_data_import VALUES (3210, '03/08/2020', '2020-31', '4031', '61', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '7.58');
INSERT INTO public.europe_data_import VALUES (3211, '27/07/2020', '2020-30', '4465', '56', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.72');
INSERT INTO public.europe_data_import VALUES (3212, '20/07/2020', '2020-29', '1943', '40', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (3213, '13/07/2020', '2020-28', '1714', '24', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (3214, '06/07/2020', '2020-27', '157', '5', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.17');
INSERT INTO public.europe_data_import VALUES (3215, '29/06/2020', '2020-26', '1157', '24', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (3216, '22/06/2020', '2020-25', '1187', '17', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '2.24');
INSERT INTO public.europe_data_import VALUES (3217, '15/06/2020', '2020-24', '1325', '30', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (3218, '08/06/2020', '2020-23', '848', '16', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.28');
INSERT INTO public.europe_data_import VALUES (3219, '01/06/2020', '2020-22', '590', '6', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (3220, '25/05/2020', '2020-21', '265', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (3221, '18/05/2020', '2020-20', '78', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (3222, '11/05/2020', '2020-19', '104', '2', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (3223, '04/05/2020', '2020-18', '12', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (3224, '27/04/2020', '2020-17', '15', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (3225, '20/04/2020', '2020-16', '37', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (3226, '13/04/2020', '2020-15', '28', '1', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (3227, '06/04/2020', '2020-14', '27', '2', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (3228, '30/03/2020', '2020-13', '5', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (3229, '23/03/2020', '2020-12', '7', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (3230, '16/03/2020', '2020-11', '4', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3231, '01/02/2021', '2021-04', '3', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '237.25');
INSERT INTO public.europe_data_import VALUES (3232, '25/01/2021', '2021-03', '5', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '237.25');
INSERT INTO public.europe_data_import VALUES (3233, '18/01/2021', '2021-02', '3', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '88.97');
INSERT INTO public.europe_data_import VALUES (3234, '11/01/2021', '2021-01', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '29.66');
INSERT INTO public.europe_data_import VALUES (3235, '04/01/2021', '2020-53', '1', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '177.94');
INSERT INTO public.europe_data_import VALUES (3236, '28/12/2020', '2020-52', '5', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '266.9');
INSERT INTO public.europe_data_import VALUES (3237, '21/12/2020', '2020-51', '4', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '177.94');
INSERT INTO public.europe_data_import VALUES (3238, '14/12/2020', '2020-50', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3239, '07/12/2020', '2020-49', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '29.66');
INSERT INTO public.europe_data_import VALUES (3240, '30/11/2020', '2020-48', '1', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3241, '23/11/2020', '2020-47', '1', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '88.97');
INSERT INTO public.europe_data_import VALUES (3242, '16/11/2020', '2020-46', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3243, '09/11/2020', '2020-45', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3244, '02/11/2020', '2020-44', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3245, '26/10/2020', '2020-43', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3246, '19/10/2020', '2020-42', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3247, '12/10/2020', '2020-41', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3248, '05/10/2020', '2020-40', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3249, '28/09/2020', '2020-39', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3250, '21/09/2020', '2020-38', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3251, '14/09/2020', '2020-37', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3252, '07/09/2020', '2020-36', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3253, '31/08/2020', '2020-35', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3254, '24/08/2020', '2020-34', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3255, '17/08/2020', '2020-33', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3256, '10/08/2020', '2020-32', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3257, '03/08/2020', '2020-31', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3258, '27/07/2020', '2020-30', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3259, '20/07/2020', '2020-29', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3260, '13/07/2020', '2020-28', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3261, '06/07/2020', '2020-27', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3262, '29/06/2020', '2020-26', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3263, '22/06/2020', '2020-25', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3264, '15/06/2020', '2020-24', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3265, '08/06/2020', '2020-23', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3266, '01/06/2020', '2020-22', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3267, '25/05/2020', '2020-21', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3268, '18/05/2020', '2020-20', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3269, '11/05/2020', '2020-19', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3270, '04/05/2020', '2020-18', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3271, '27/04/2020', '2020-17', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '237.25');
INSERT INTO public.europe_data_import VALUES (3272, '20/04/2020', '2020-16', '6', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '266.9');
INSERT INTO public.europe_data_import VALUES (3273, '13/04/2020', '2020-15', '3', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '148.28');
INSERT INTO public.europe_data_import VALUES (3274, '06/04/2020', '2020-14', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '');
INSERT INTO public.europe_data_import VALUES (3275, '01/02/2021', '2021-04', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '10.27');
INSERT INTO public.europe_data_import VALUES (3276, '25/01/2021', '2021-03', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '12.33');
INSERT INTO public.europe_data_import VALUES (3277, '18/01/2021', '2021-02', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '59.58');
INSERT INTO public.europe_data_import VALUES (3278, '11/01/2021', '2021-01', '26', '1', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '131.48');
INSERT INTO public.europe_data_import VALUES (3279, '04/01/2021', '2020-53', '38', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '152.02');
INSERT INTO public.europe_data_import VALUES (3280, '28/12/2020', '2020-52', '36', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '110.94');
INSERT INTO public.europe_data_import VALUES (3281, '21/12/2020', '2020-51', '18', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '73.96');
INSERT INTO public.europe_data_import VALUES (3282, '14/12/2020', '2020-50', '18', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '53.41');
INSERT INTO public.europe_data_import VALUES (3283, '07/12/2020', '2020-49', '8', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '20.54');
INSERT INTO public.europe_data_import VALUES (3284, '30/11/2020', '2020-48', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '8.22');
INSERT INTO public.europe_data_import VALUES (3285, '23/11/2020', '2020-47', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3286, '16/11/2020', '2020-46', '1', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3287, '09/11/2020', '2020-45', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '14.38');
INSERT INTO public.europe_data_import VALUES (3288, '02/11/2020', '2020-44', '5', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '20.54');
INSERT INTO public.europe_data_import VALUES (3289, '26/10/2020', '2020-43', '5', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '26.71');
INSERT INTO public.europe_data_import VALUES (3290, '19/10/2020', '2020-42', '8', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '22.6');
INSERT INTO public.europe_data_import VALUES (3291, '12/10/2020', '2020-41', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '34.92');
INSERT INTO public.europe_data_import VALUES (3292, '05/10/2020', '2020-40', '14', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '82.17');
INSERT INTO public.europe_data_import VALUES (3293, '28/09/2020', '2020-39', '26', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '76.01');
INSERT INTO public.europe_data_import VALUES (3294, '21/09/2020', '2020-38', '11', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '43.14');
INSERT INTO public.europe_data_import VALUES (3295, '14/09/2020', '2020-37', '10', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '24.65');
INSERT INTO public.europe_data_import VALUES (3296, '07/09/2020', '2020-36', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '59.58');
INSERT INTO public.europe_data_import VALUES (3297, '31/08/2020', '2020-35', '27', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '80.12');
INSERT INTO public.europe_data_import VALUES (3298, '24/08/2020', '2020-34', '12', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '191.06');
INSERT INTO public.europe_data_import VALUES (3299, '17/08/2020', '2020-33', '81', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '301.99');
INSERT INTO public.europe_data_import VALUES (3300, '10/08/2020', '2020-32', '66', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '205.44');
INSERT INTO public.europe_data_import VALUES (3301, '03/08/2020', '2020-31', '34', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '69.85');
INSERT INTO public.europe_data_import VALUES (3302, '27/07/2020', '2020-30', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3303, '20/07/2020', '2020-29', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '8.22');
INSERT INTO public.europe_data_import VALUES (3304, '13/07/2020', '2020-28', '1', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '2.05');
INSERT INTO public.europe_data_import VALUES (3305, '06/07/2020', '2020-27', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3306, '29/06/2020', '2020-26', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3307, '22/06/2020', '2020-25', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3308, '15/06/2020', '2020-24', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3309, '08/06/2020', '2020-23', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3310, '01/06/2020', '2020-22', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3311, '25/05/2020', '2020-21', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3312, '18/05/2020', '2020-20', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3313, '11/05/2020', '2020-19', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3314, '04/05/2020', '2020-18', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '4.11');
INSERT INTO public.europe_data_import VALUES (3315, '27/04/2020', '2020-17', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3316, '20/04/2020', '2020-16', '1', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '8.22');
INSERT INTO public.europe_data_import VALUES (3317, '13/04/2020', '2020-15', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '51.36');
INSERT INTO public.europe_data_import VALUES (3318, '06/04/2020', '2020-14', '22', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '135.59');
INSERT INTO public.europe_data_import VALUES (3319, '30/03/2020', '2020-13', '44', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '308.15');
INSERT INTO public.europe_data_import VALUES (3320, '23/03/2020', '2020-12', '106', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '230.09');
INSERT INTO public.europe_data_import VALUES (3321, '16/03/2020', '2020-11', '6', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '18.49');
INSERT INTO public.europe_data_import VALUES (3322, '09/03/2020', '2020-10', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3323, '01/02/2021', '2021-04', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3324, '25/01/2021', '2021-03', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3325, '18/01/2021', '2021-02', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (3326, '11/01/2021', '2021-01', '4', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (3327, '04/01/2021', '2020-53', '3', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.34');
INSERT INTO public.europe_data_import VALUES (3328, '28/12/2020', '2020-52', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3329, '21/12/2020', '2020-51', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3330, '14/12/2020', '2020-50', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.45');
INSERT INTO public.europe_data_import VALUES (3331, '07/12/2020', '2020-49', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '1.01');
INSERT INTO public.europe_data_import VALUES (3332, '30/11/2020', '2020-48', '7', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (3333, '23/11/2020', '2020-47', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3334, '16/11/2020', '2020-46', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3335, '09/11/2020', '2020-45', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3336, '02/11/2020', '2020-44', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3337, '26/10/2020', '2020-43', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3338, '19/10/2020', '2020-42', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3339, '12/10/2020', '2020-41', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3340, '05/10/2020', '2020-40', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3341, '28/09/2020', '2020-39', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3342, '21/09/2020', '2020-38', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3343, '14/09/2020', '2020-37', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.45');
INSERT INTO public.europe_data_import VALUES (3344, '07/09/2020', '2020-36', '3', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.34');
INSERT INTO public.europe_data_import VALUES (3345, '31/08/2020', '2020-35', '0', '1', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3346, '24/08/2020', '2020-34', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3347, '17/08/2020', '2020-33', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3348, '10/08/2020', '2020-32', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3349, '03/08/2020', '2020-31', '0', '1', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3350, '27/07/2020', '2020-30', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3351, '20/07/2020', '2020-29', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.9');
INSERT INTO public.europe_data_import VALUES (3352, '13/07/2020', '2020-28', '8', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.9');
INSERT INTO public.europe_data_import VALUES (3353, '06/07/2020', '2020-27', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3354, '29/06/2020', '2020-26', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3355, '22/06/2020', '2020-25', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3356, '15/06/2020', '2020-24', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3357, '08/06/2020', '2020-23', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3358, '01/06/2020', '2020-22', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3359, '25/05/2020', '2020-21', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3360, '18/05/2020', '2020-20', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3361, '11/05/2020', '2020-19', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3362, '04/05/2020', '2020-18', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3363, '27/04/2020', '2020-17', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3364, '20/04/2020', '2020-16', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.34');
INSERT INTO public.europe_data_import VALUES (3365, '13/04/2020', '2020-15', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '1.24');
INSERT INTO public.europe_data_import VALUES (3366, '06/04/2020', '2020-14', '9', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '1.24');
INSERT INTO public.europe_data_import VALUES (3367, '30/03/2020', '2020-13', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.56');
INSERT INTO public.europe_data_import VALUES (3368, '23/03/2020', '2020-12', '3', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (3369, '01/02/2021', '2021-04', '2902', '22', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '93.24');
INSERT INTO public.europe_data_import VALUES (3370, '25/01/2021', '2021-03', '2243', '34', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '72.31');
INSERT INTO public.europe_data_import VALUES (3371, '18/01/2021', '2021-02', '1747', '24', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '61.94');
INSERT INTO public.europe_data_import VALUES (3372, '11/01/2021', '2021-01', '1671', '32', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '62.58');
INSERT INTO public.europe_data_import VALUES (3373, '04/01/2021', '2020-53', '1782', '19', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '68.09');
INSERT INTO public.europe_data_import VALUES (3374, '28/12/2020', '2020-52', '1975', '57', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '78.42');
INSERT INTO public.europe_data_import VALUES (3375, '21/12/2020', '2020-51', '2352', '28', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '100.24');
INSERT INTO public.europe_data_import VALUES (3376, '14/12/2020', '2020-50', '3179', '46', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '112.02');
INSERT INTO public.europe_data_import VALUES (3377, '07/12/2020', '2020-49', '3002', '22', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '108.59');
INSERT INTO public.europe_data_import VALUES (3378, '30/11/2020', '2020-48', '2990', '18', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '96.3');
INSERT INTO public.europe_data_import VALUES (3379, '23/11/2020', '2020-47', '2324', '6', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '69.63');
INSERT INTO public.europe_data_import VALUES (3380, '16/11/2020', '2020-46', '1518', '7', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '54.8');
INSERT INTO public.europe_data_import VALUES (3381, '09/11/2020', '2020-45', '1506', '4', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '53.44');
INSERT INTO public.europe_data_import VALUES (3382, '02/11/2020', '2020-44', '1443', '5', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '51.96');
INSERT INTO public.europe_data_import VALUES (3383, '26/10/2020', '2020-43', '1424', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '51.65');
INSERT INTO public.europe_data_import VALUES (3384, '19/10/2020', '2020-42', '1426', '5', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '52.3');
INSERT INTO public.europe_data_import VALUES (3385, '12/10/2020', '2020-41', '1460', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '41.97');
INSERT INTO public.europe_data_import VALUES (3386, '05/10/2020', '2020-40', '856', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '28.24');
INSERT INTO public.europe_data_import VALUES (3387, '28/09/2020', '2020-39', '702', '4', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '19.97');
INSERT INTO public.europe_data_import VALUES (3388, '21/09/2020', '2020-38', '400', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '12.49');
INSERT INTO public.europe_data_import VALUES (3389, '14/09/2020', '2020-37', '289', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '9.12');
INSERT INTO public.europe_data_import VALUES (3390, '07/09/2020', '2020-36', '214', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '6.72');
INSERT INTO public.europe_data_import VALUES (3391, '31/08/2020', '2020-35', '157', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '6.27');
INSERT INTO public.europe_data_import VALUES (3392, '24/08/2020', '2020-34', '189', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '6.09');
INSERT INTO public.europe_data_import VALUES (3393, '17/08/2020', '2020-33', '147', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '5.04');
INSERT INTO public.europe_data_import VALUES (3394, '10/08/2020', '2020-32', '131', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '3.46');
INSERT INTO public.europe_data_import VALUES (3395, '03/08/2020', '2020-31', '60', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '2.08');
INSERT INTO public.europe_data_import VALUES (3396, '27/07/2020', '2020-30', '55', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.83');
INSERT INTO public.europe_data_import VALUES (3397, '20/07/2020', '2020-29', '46', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.2');
INSERT INTO public.europe_data_import VALUES (3398, '13/07/2020', '2020-28', '20', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.83');
INSERT INTO public.europe_data_import VALUES (3399, '06/07/2020', '2020-27', '81', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '2.34');
INSERT INTO public.europe_data_import VALUES (3400, '29/06/2020', '2020-26', '48', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.58');
INSERT INTO public.europe_data_import VALUES (3401, '22/06/2020', '2020-25', '39', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '2.94');
INSERT INTO public.europe_data_import VALUES (3402, '15/06/2020', '2020-24', '123', '3', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '4.44');
INSERT INTO public.europe_data_import VALUES (3403, '08/06/2020', '2020-23', '122', '3', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '7.29');
INSERT INTO public.europe_data_import VALUES (3404, '01/06/2020', '2020-22', '280', '13', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '9.28');
INSERT INTO public.europe_data_import VALUES (3405, '25/05/2020', '2020-21', '232', '9', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '11.18');
INSERT INTO public.europe_data_import VALUES (3406, '18/05/2020', '2020-20', '385', '31', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '19.81');
INSERT INTO public.europe_data_import VALUES (3407, '11/05/2020', '2020-19', '708', '37', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '25.12');
INSERT INTO public.europe_data_import VALUES (3408, '04/05/2020', '2020-18', '678', '40', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '26.66');
INSERT INTO public.europe_data_import VALUES (3409, '27/04/2020', '2020-17', '793', '96', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '29.03');
INSERT INTO public.europe_data_import VALUES (3410, '20/04/2020', '2020-16', '809', '38', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '33.64');
INSERT INTO public.europe_data_import VALUES (3411, '13/04/2020', '2020-15', '1047', '29', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '31.82');
INSERT INTO public.europe_data_import VALUES (3412, '06/04/2020', '2020-14', '709', '16', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '23.58');
INSERT INTO public.europe_data_import VALUES (3413, '30/03/2020', '2020-13', '592', '10', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '17.23');
INSERT INTO public.europe_data_import VALUES (3414, '23/03/2020', '2020-12', '359', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '10.8');
INSERT INTO public.europe_data_import VALUES (3415, '16/03/2020', '2020-11', '237', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '4.73');
INSERT INTO public.europe_data_import VALUES (3416, '09/03/2020', '2020-10', '24', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.53');
INSERT INTO public.europe_data_import VALUES (3417, '02/03/2020', '2020-09', '5', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.09');
INSERT INTO public.europe_data_import VALUES (3418, '24/02/2020', '2020-08', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3419, '17/02/2020', '2020-07', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3420, '10/02/2020', '2020-06', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (3421, '03/02/2020', '2020-05', '1', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (3422, '27/01/2020', '2020-04', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3423, '20/01/2020', '2020-03', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3424, '13/01/2020', '2020-02', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3425, '06/01/2020', '2020-01', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3426, '01/02/2021', '2021-04', '143497', '3008', '67012883', 'France', 'FR', 'FRA', 'Europe', '426.97');
INSERT INTO public.europe_data_import VALUES (3427, '25/01/2021', '2021-03', '142628', '2766', '67012883', 'France', 'FR', 'FRA', 'Europe', '403.45');
INSERT INTO public.europe_data_import VALUES (3428, '18/01/2021', '2021-02', '127733', '2533', '67012883', 'France', 'FR', 'FRA', 'Europe', '380.91');
INSERT INTO public.europe_data_import VALUES (3429, '11/01/2021', '2021-01', '127528', '2713', '67012883', 'France', 'FR', 'FRA', 'Europe', '329.21');
INSERT INTO public.europe_data_import VALUES (3430, '04/01/2021', '2020-53', '93082', '1928', '67012883', 'France', 'FR', 'FRA', 'Europe', '272.15');
INSERT INTO public.europe_data_import VALUES (3431, '28/12/2020', '2020-52', '89292', '2560', '67012883', 'France', 'FR', 'FRA', 'Europe', '277.25');
INSERT INTO public.europe_data_import VALUES (3432, '21/12/2020', '2020-51', '96502', '2638', '67012883', 'France', 'FR', 'FRA', 'Europe', '269.88');
INSERT INTO public.europe_data_import VALUES (3433, '14/12/2020', '2020-50', '84355', '2756', '67012883', 'France', 'FR', 'FRA', 'Europe', '236.33');
INSERT INTO public.europe_data_import VALUES (3434, '07/12/2020', '2020-49', '74014', '2830', '67012883', 'France', 'FR', 'FRA', 'Europe', '227.25');
INSERT INTO public.europe_data_import VALUES (3435, '30/11/2020', '2020-48', '78275', '3593', '67012883', 'France', 'FR', 'FRA', 'Europe', '353.15');
INSERT INTO public.europe_data_import VALUES (3436, '23/11/2020', '2020-47', '158381', '4184', '67012883', 'France', 'FR', 'FRA', 'Europe', '526.59');
INSERT INTO public.europe_data_import VALUES (3437, '16/11/2020', '2020-46', '194503', '4109', '67012883', 'France', 'FR', 'FRA', 'Europe', '847.47');
INSERT INTO public.europe_data_import VALUES (3438, '09/11/2020', '2020-45', '373409', '3420', '67012883', 'France', 'FR', 'FRA', 'Europe', '968.2');
INSERT INTO public.europe_data_import VALUES (3439, '02/11/2020', '2020-44', '275408', '2258', '67012883', 'France', 'FR', 'FRA', 'Europe', '771.32');
INSERT INTO public.europe_data_import VALUES (3440, '26/10/2020', '2020-43', '241473', '1284', '67012883', 'France', 'FR', 'FRA', 'Europe', '602.17');
INSERT INTO public.europe_data_import VALUES (3441, '19/10/2020', '2020-42', '162060', '747', '67012883', 'France', 'FR', 'FRA', 'Europe', '414.64');
INSERT INTO public.europe_data_import VALUES (3442, '12/10/2020', '2020-41', '115804', '500', '67012883', 'France', 'FR', 'FRA', 'Europe', '293.09');
INSERT INTO public.europe_data_import VALUES (3443, '05/10/2020', '2020-40', '80601', '503', '67012883', 'France', 'FR', 'FRA', 'Europe', '246.83');
INSERT INTO public.europe_data_import VALUES (3444, '28/09/2020', '2020-39', '84806', '442', '67012883', 'France', 'FR', 'FRA', 'Europe', '234.99');
INSERT INTO public.europe_data_import VALUES (3445, '21/09/2020', '2020-38', '72669', '369', '67012883', 'France', 'FR', 'FRA', 'Europe', '192.48');
INSERT INTO public.europe_data_import VALUES (3446, '14/09/2020', '2020-37', '56317', '215', '67012883', 'France', 'FR', 'FRA', 'Europe', '153.93');
INSERT INTO public.europe_data_import VALUES (3447, '07/09/2020', '2020-36', '46834', '95', '67012883', 'France', 'FR', 'FRA', 'Europe', '122.18');
INSERT INTO public.europe_data_import VALUES (3448, '31/08/2020', '2020-35', '35044', '93', '67012883', 'France', 'FR', 'FRA', 'Europe', '88.65');
INSERT INTO public.europe_data_import VALUES (3449, '24/08/2020', '2020-34', '24363', '103', '67012883', 'France', 'FR', 'FRA', 'Europe', '67.12');
INSERT INTO public.europe_data_import VALUES (3450, '17/08/2020', '2020-33', '20615', '86', '67012883', 'France', 'FR', 'FRA', 'Europe', '45.69');
INSERT INTO public.europe_data_import VALUES (3451, '10/08/2020', '2020-32', '10002', '59', '67012883', 'France', 'FR', 'FRA', 'Europe', '25.95');
INSERT INTO public.europe_data_import VALUES (3452, '03/08/2020', '2020-31', '7391', '73', '67012883', 'France', 'FR', 'FRA', 'Europe', '19.76');
INSERT INTO public.europe_data_import VALUES (3453, '27/07/2020', '2020-30', '5854', '40', '67012883', 'France', 'FR', 'FRA', 'Europe', '14.59');
INSERT INTO public.europe_data_import VALUES (3454, '20/07/2020', '2020-29', '3922', '148', '67012883', 'France', 'FR', 'FRA', 'Europe', '11.51');
INSERT INTO public.europe_data_import VALUES (3455, '13/07/2020', '2020-28', '3792', '111', '67012883', 'France', 'FR', 'FRA', 'Europe', '11.66');
INSERT INTO public.europe_data_import VALUES (3456, '06/07/2020', '2020-27', '4024', '115', '67012883', 'France', 'FR', 'FRA', 'Europe', '9.82');
INSERT INTO public.europe_data_import VALUES (3457, '29/06/2020', '2020-26', '2559', '138', '67012883', 'France', 'FR', 'FRA', 'Europe', '8.53');
INSERT INTO public.europe_data_import VALUES (3458, '22/06/2020', '2020-25', '3157', '233', '67012883', 'France', 'FR', 'FRA', 'Europe', '9.55');
INSERT INTO public.europe_data_import VALUES (3459, '15/06/2020', '2020-24', '3243', '252', '67012883', 'France', 'FR', 'FRA', 'Europe', '8.16');
INSERT INTO public.europe_data_import VALUES (3460, '08/06/2020', '2020-23', '2224', '353', '67012883', 'France', 'FR', 'FRA', 'Europe', '13.51');
INSERT INTO public.europe_data_import VALUES (3461, '01/06/2020', '2020-22', '6832', '435', '67012883', 'France', 'FR', 'FRA', 'Europe', '13.94');
INSERT INTO public.europe_data_import VALUES (3462, '25/05/2020', '2020-21', '2510', '656', '67012883', 'France', 'FR', 'FRA', 'Europe', '8.74');
INSERT INTO public.europe_data_import VALUES (3463, '18/05/2020', '2020-20', '3348', '1331', '67012883', 'France', 'FR', 'FRA', 'Europe', '16.6');
INSERT INTO public.europe_data_import VALUES (3464, '11/05/2020', '2020-19', '7776', '1485', '67012883', 'France', 'FR', 'FRA', 'Europe', '21.62');
INSERT INTO public.europe_data_import VALUES (3465, '04/05/2020', '2020-18', '6712', '2039', '67012883', 'France', 'FR', 'FRA', 'Europe', '27.88');
INSERT INTO public.europe_data_import VALUES (3466, '27/04/2020', '2020-17', '11969', '3138', '67012883', 'France', 'FR', 'FRA', 'Europe', '43.53');
INSERT INTO public.europe_data_import VALUES (3467, '20/04/2020', '2020-16', '17203', '5325', '67012883', 'France', 'FR', 'FRA', 'Europe', '62.87');
INSERT INTO public.europe_data_import VALUES (3468, '13/04/2020', '2020-15', '24925', '6315', '67012883', 'France', 'FR', 'FRA', 'Europe', '82.42');
INSERT INTO public.europe_data_import VALUES (3469, '06/04/2020', '2020-14', '30304', '5472', '67012883', 'France', 'FR', 'FRA', 'Europe', '81.27');
INSERT INTO public.europe_data_import VALUES (3470, '30/03/2020', '2020-13', '24156', '1932', '67012883', 'France', 'FR', 'FRA', 'Europe', '51.86');
INSERT INTO public.europe_data_import VALUES (3471, '23/03/2020', '2020-12', '10595', '547', '67012883', 'France', 'FR', 'FRA', 'Europe', '22.22');
INSERT INTO public.europe_data_import VALUES (3472, '16/03/2020', '2020-11', '4297', '108', '67012883', 'France', 'FR', 'FRA', 'Europe', '7.9');
INSERT INTO public.europe_data_import VALUES (3473, '09/03/2020', '2020-10', '996', '17', '67012883', 'France', 'FR', 'FRA', 'Europe', '1.66');
INSERT INTO public.europe_data_import VALUES (3474, '02/03/2020', '2020-09', '118', '1', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.18');
INSERT INTO public.europe_data_import VALUES (3475, '24/02/2020', '2020-08', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (3476, '17/02/2020', '2020-07', '1', '1', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3477, '10/02/2020', '2020-06', '5', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3478, '03/02/2020', '2020-05', '3', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3479, '27/01/2020', '2020-04', '3', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (3480, '20/01/2020', '2020-03', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3481, '13/01/2020', '2020-02', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3482, '06/01/2020', '2020-01', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3483, '01/02/2021', '2021-04', '425', '5', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '152.17');
INSERT INTO public.europe_data_import VALUES (3484, '25/01/2021', '2021-03', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '141.07');
INSERT INTO public.europe_data_import VALUES (3485, '18/01/2021', '2021-02', '394', '4', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '253.86');
INSERT INTO public.europe_data_import VALUES (3486, '11/01/2021', '2021-01', '315', '8', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '247.42');
INSERT INTO public.europe_data_import VALUES (3487, '04/01/2021', '2020-53', '376', '6', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '266.39');
INSERT INTO public.europe_data_import VALUES (3488, '28/12/2020', '2020-52', '368', '5', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '287.52');
INSERT INTO public.europe_data_import VALUES (3489, '21/12/2020', '2020-51', '435', '7', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '384.91');
INSERT INTO public.europe_data_import VALUES (3490, '14/12/2020', '2020-50', '640', '17', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '591.15');
INSERT INTO public.europe_data_import VALUES (3491, '07/12/2020', '2020-49', '1011', '6', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '762.3');
INSERT INTO public.europe_data_import VALUES (3492, '30/11/2020', '2020-48', '1118', '10', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '855.76');
INSERT INTO public.europe_data_import VALUES (3493, '23/11/2020', '2020-47', '1272', '10', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1068.08');
INSERT INTO public.europe_data_import VALUES (3494, '16/11/2020', '2020-46', '1711', '14', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1591.21');
INSERT INTO public.europe_data_import VALUES (3495, '09/11/2020', '2020-45', '2733', '10', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1503.12');
INSERT INTO public.europe_data_import VALUES (3496, '02/11/2020', '2020-44', '1465', '9', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1240.67');
INSERT INTO public.europe_data_import VALUES (3497, '26/10/2020', '2020-43', '2000', '6', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1111.77');
INSERT INTO public.europe_data_import VALUES (3498, '19/10/2020', '2020-42', '1105', '4', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '656.32');
INSERT INTO public.europe_data_import VALUES (3499, '12/10/2020', '2020-41', '728', '2', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '486.96');
INSERT INTO public.europe_data_import VALUES (3500, '05/10/2020', '2020-40', '632', '3', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '231.3');
INSERT INTO public.europe_data_import VALUES (3501, '28/09/2020', '2020-39', '14', '3', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '157.9');
INSERT INTO public.europe_data_import VALUES (3502, '21/09/2020', '2020-38', '427', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '223.43');
INSERT INTO public.europe_data_import VALUES (3503, '14/09/2020', '2020-37', '197', '2', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '168.64');
INSERT INTO public.europe_data_import VALUES (3504, '07/09/2020', '2020-36', '274', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '163.99');
INSERT INTO public.europe_data_import VALUES (3505, '31/08/2020', '2020-35', '184', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '81.64');
INSERT INTO public.europe_data_import VALUES (3506, '24/08/2020', '2020-34', '44', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '62.3');
INSERT INTO public.europe_data_import VALUES (3507, '17/08/2020', '2020-33', '130', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '46.55');
INSERT INTO public.europe_data_import VALUES (3508, '10/08/2020', '2020-32', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3509, '03/08/2020', '2020-31', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3510, '27/07/2020', '2020-30', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3511, '20/07/2020', '2020-29', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3512, '13/07/2020', '2020-28', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3513, '06/07/2020', '2020-27', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0.72');
INSERT INTO public.europe_data_import VALUES (3514, '29/06/2020', '2020-26', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0.72');
INSERT INTO public.europe_data_import VALUES (3515, '22/06/2020', '2020-25', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3516, '15/06/2020', '2020-24', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3517, '08/06/2020', '2020-23', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3518, '01/06/2020', '2020-22', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3519, '25/05/2020', '2020-21', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3520, '18/05/2020', '2020-20', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0.72');
INSERT INTO public.europe_data_import VALUES (3521, '11/05/2020', '2020-19', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1.07');
INSERT INTO public.europe_data_import VALUES (3522, '04/05/2020', '2020-18', '1', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1.07');
INSERT INTO public.europe_data_import VALUES (3523, '27/04/2020', '2020-17', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1.43');
INSERT INTO public.europe_data_import VALUES (3524, '20/04/2020', '2020-16', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '5.01');
INSERT INTO public.europe_data_import VALUES (3525, '13/04/2020', '2020-15', '12', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '6.45');
INSERT INTO public.europe_data_import VALUES (3526, '06/04/2020', '2020-14', '6', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '8.24');
INSERT INTO public.europe_data_import VALUES (3527, '30/03/2020', '2020-13', '17', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '12.53');
INSERT INTO public.europe_data_import VALUES (3528, '23/03/2020', '2020-12', '18', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (3529, '01/02/2021', '2021-04', '542', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '48.51');
INSERT INTO public.europe_data_import VALUES (3530, '25/01/2021', '2021-03', '512', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '30.88');
INSERT INTO public.europe_data_import VALUES (3531, '18/01/2021', '2021-02', '159', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '13.53');
INSERT INTO public.europe_data_import VALUES (3532, '11/01/2021', '2021-01', '135', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '10.59');
INSERT INTO public.europe_data_import VALUES (3533, '04/01/2021', '2020-53', '95', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '8.52');
INSERT INTO public.europe_data_import VALUES (3534, '28/12/2020', '2020-52', '90', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '7.32');
INSERT INTO public.europe_data_import VALUES (3535, '21/12/2020', '2020-51', '69', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '7.64');
INSERT INTO public.europe_data_import VALUES (3536, '14/12/2020', '2020-50', '97', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '7.36');
INSERT INTO public.europe_data_import VALUES (3537, '07/12/2020', '2020-49', '63', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.66');
INSERT INTO public.europe_data_import VALUES (3538, '30/11/2020', '2020-48', '60', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.94');
INSERT INTO public.europe_data_import VALUES (3539, '23/11/2020', '2020-47', '69', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.02');
INSERT INTO public.europe_data_import VALUES (3540, '16/11/2020', '2020-46', '40', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.33');
INSERT INTO public.europe_data_import VALUES (3541, '09/11/2020', '2020-45', '54', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.74');
INSERT INTO public.europe_data_import VALUES (3542, '02/11/2020', '2020-44', '49', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.0');
INSERT INTO public.europe_data_import VALUES (3543, '26/10/2020', '2020-43', '38', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (3544, '19/10/2020', '2020-42', '46', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (3545, '12/10/2020', '2020-41', '38', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.93');
INSERT INTO public.europe_data_import VALUES (3546, '05/10/2020', '2020-40', '69', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (3547, '28/09/2020', '2020-39', '32', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (3548, '21/09/2020', '2020-38', '53', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.37');
INSERT INTO public.europe_data_import VALUES (3549, '14/09/2020', '2020-37', '42', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '6.35');
INSERT INTO public.europe_data_import VALUES (3550, '07/09/2020', '2020-36', '96', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '9.8');
INSERT INTO public.europe_data_import VALUES (3551, '31/08/2020', '2020-35', '117', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '12.89');
INSERT INTO public.europe_data_import VALUES (3552, '24/08/2020', '2020-34', '163', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '21.4');
INSERT INTO public.europe_data_import VALUES (3553, '17/08/2020', '2020-33', '302', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '31.94');
INSERT INTO public.europe_data_import VALUES (3554, '10/08/2020', '2020-32', '392', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '43.22');
INSERT INTO public.europe_data_import VALUES (3555, '03/08/2020', '2020-31', '547', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '55.97');
INSERT INTO public.europe_data_import VALUES (3556, '27/07/2020', '2020-30', '669', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '47.96');
INSERT INTO public.europe_data_import VALUES (3557, '20/07/2020', '2020-29', '373', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '31.99');
INSERT INTO public.europe_data_import VALUES (3558, '13/07/2020', '2020-28', '322', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '33.74');
INSERT INTO public.europe_data_import VALUES (3559, '06/07/2020', '2020-27', '411', '4', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '54.87');
INSERT INTO public.europe_data_import VALUES (3560, '29/06/2020', '2020-26', '781', '6', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '80.37');
INSERT INTO public.europe_data_import VALUES (3561, '22/06/2020', '2020-25', '965', '11', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '61.08');
INSERT INTO public.europe_data_import VALUES (3562, '15/06/2020', '2020-24', '362', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '37.19');
INSERT INTO public.europe_data_import VALUES (3563, '08/06/2020', '2020-23', '446', '4', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '53.71');
INSERT INTO public.europe_data_import VALUES (3564, '01/06/2020', '2020-22', '721', '5', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '61.45');
INSERT INTO public.europe_data_import VALUES (3565, '25/05/2020', '2020-21', '614', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '58.59');
INSERT INTO public.europe_data_import VALUES (3566, '18/05/2020', '2020-20', '659', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '45.34');
INSERT INTO public.europe_data_import VALUES (3567, '11/05/2020', '2020-19', '326', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '22.32');
INSERT INTO public.europe_data_import VALUES (3568, '04/05/2020', '2020-18', '159', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '10.4');
INSERT INTO public.europe_data_import VALUES (3569, '27/04/2020', '2020-17', '67', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.48');
INSERT INTO public.europe_data_import VALUES (3570, '20/04/2020', '2020-16', '52', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.05');
INSERT INTO public.europe_data_import VALUES (3571, '13/04/2020', '2020-15', '36', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (3572, '06/04/2020', '2020-14', '14', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (3573, '30/03/2020', '2020-13', '1', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (3574, '23/03/2020', '2020-12', '5', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (3575, '16/03/2020', '2020-11', '1', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3576, '01/02/2021', '2021-04', '131', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '9.75');
INSERT INTO public.europe_data_import VALUES (3577, '25/01/2021', '2021-03', '98', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '5.62');
INSERT INTO public.europe_data_import VALUES (3578, '18/01/2021', '2021-02', '34', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '4.43');
INSERT INTO public.europe_data_import VALUES (3579, '11/01/2021', '2021-01', '70', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '3.37');
INSERT INTO public.europe_data_import VALUES (3580, '04/01/2021', '2020-53', '9', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (3581, '28/12/2020', '2020-52', '8', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.64');
INSERT INTO public.europe_data_import VALUES (3582, '21/12/2020', '2020-51', '7', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (3583, '14/12/2020', '2020-50', '12', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (3584, '07/12/2020', '2020-49', '36', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.87');
INSERT INTO public.europe_data_import VALUES (3585, '30/11/2020', '2020-48', '8', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (3586, '23/11/2020', '2020-47', '24', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.79');
INSERT INTO public.europe_data_import VALUES (3587, '16/11/2020', '2020-46', '18', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.28');
INSERT INTO public.europe_data_import VALUES (3588, '09/11/2020', '2020-45', '12', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (3589, '02/11/2020', '2020-44', '12', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (3590, '26/10/2020', '2020-43', '11', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (3591, '19/10/2020', '2020-42', '17', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.34');
INSERT INTO public.europe_data_import VALUES (3592, '12/10/2020', '2020-41', '38', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (3593, '05/10/2020', '2020-40', '25', '4', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.9');
INSERT INTO public.europe_data_import VALUES (3594, '28/09/2020', '2020-39', '43', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '6.99');
INSERT INTO public.europe_data_import VALUES (3595, '21/09/2020', '2020-38', '121', '5', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '14.01');
INSERT INTO public.europe_data_import VALUES (3596, '14/09/2020', '2020-37', '208', '4', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '18.83');
INSERT INTO public.europe_data_import VALUES (3597, '07/09/2020', '2020-36', '234', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '32.37');
INSERT INTO public.europe_data_import VALUES (3598, '31/08/2020', '2020-35', '526', '12', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '46.47');
INSERT INTO public.europe_data_import VALUES (3599, '24/08/2020', '2020-34', '565', '21', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '51.2');
INSERT INTO public.europe_data_import VALUES (3600, '17/08/2020', '2020-33', '637', '40', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '58.53');
INSERT INTO public.europe_data_import VALUES (3601, '10/08/2020', '2020-32', '737', '14', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '40.81');
INSERT INTO public.europe_data_import VALUES (3602, '03/08/2020', '2020-31', '221', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '17.25');
INSERT INTO public.europe_data_import VALUES (3603, '27/07/2020', '2020-30', '184', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '9.07');
INSERT INTO public.europe_data_import VALUES (3604, '20/07/2020', '2020-29', '29', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.53');
INSERT INTO public.europe_data_import VALUES (3605, '13/07/2020', '2020-28', '7', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (3606, '06/07/2020', '2020-27', '12', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.85');
INSERT INTO public.europe_data_import VALUES (3607, '29/06/2020', '2020-26', '8', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (3608, '22/06/2020', '2020-25', '9', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.47');
INSERT INTO public.europe_data_import VALUES (3609, '15/06/2020', '2020-24', '2', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (3610, '08/06/2020', '2020-23', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (3611, '01/06/2020', '2020-22', '0', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (3612, '25/05/2020', '2020-21', '2', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (3613, '18/05/2020', '2020-20', '3', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (3614, '11/05/2020', '2020-19', '3', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (3615, '04/05/2020', '2020-18', '7', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (3616, '27/04/2020', '2020-17', '0', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (3617, '20/04/2020', '2020-16', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (3618, '13/04/2020', '2020-15', '5', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (3619, '06/04/2020', '2020-14', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (3620, '30/03/2020', '2020-13', '2', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (3621, '23/03/2020', '2020-12', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3622, '01/02/2021', '2021-04', '4535', '123', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '261.11');
INSERT INTO public.europe_data_import VALUES (3623, '25/01/2021', '2021-03', '5901', '113', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '351.18');
INSERT INTO public.europe_data_import VALUES (3624, '18/01/2021', '2021-02', '8135', '162', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '454.17');
INSERT INTO public.europe_data_import VALUES (3625, '11/01/2021', '2021-01', '10017', '168', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '441.28');
INSERT INTO public.europe_data_import VALUES (3626, '04/01/2021', '2020-53', '7620', '210', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '507.94');
INSERT INTO public.europe_data_import VALUES (3627, '28/12/2020', '2020-52', '12681', '278', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '777.63');
INSERT INTO public.europe_data_import VALUES (3628, '21/12/2020', '2020-51', '18399', '301', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1113.05');
INSERT INTO public.europe_data_import VALUES (3629, '14/12/2020', '2020-50', '26087', '299', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1388.1');
INSERT INTO public.europe_data_import VALUES (3630, '07/12/2020', '2020-49', '29392', '273', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1408.29');
INSERT INTO public.europe_data_import VALUES (3631, '30/11/2020', '2020-48', '26894', '255', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1319.79');
INSERT INTO public.europe_data_import VALUES (3632, '23/11/2020', '2020-47', '25855', '279', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1201.22');
INSERT INTO public.europe_data_import VALUES (3633, '16/11/2020', '2020-46', '22155', '234', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1007.22');
INSERT INTO public.europe_data_import VALUES (3634, '09/11/2020', '2020-45', '18101', '157', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '760.04');
INSERT INTO public.europe_data_import VALUES (3635, '02/11/2020', '2020-44', '12276', '127', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '628.06');
INSERT INTO public.europe_data_import VALUES (3636, '26/10/2020', '2020-43', '12826', '79', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '463.1');
INSERT INTO public.europe_data_import VALUES (3637, '19/10/2020', '2020-42', '5683', '51', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '234.16');
INSERT INTO public.europe_data_import VALUES (3638, '12/10/2020', '2020-41', '3676', '35', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '156.18');
INSERT INTO public.europe_data_import VALUES (3639, '05/10/2020', '2020-40', '2566', '22', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '110.66');
INSERT INTO public.europe_data_import VALUES (3640, '28/09/2020', '2020-39', '1857', '8', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '79.06');
INSERT INTO public.europe_data_import VALUES (3641, '21/09/2020', '2020-38', '1303', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '51.42');
INSERT INTO public.europe_data_import VALUES (3642, '14/09/2020', '2020-37', '752', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '22.64');
INSERT INTO public.europe_data_import VALUES (3643, '07/09/2020', '2020-36', '153', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '5.73');
INSERT INTO public.europe_data_import VALUES (3644, '31/08/2020', '2020-35', '76', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.65');
INSERT INTO public.europe_data_import VALUES (3645, '24/08/2020', '2020-34', '70', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.03');
INSERT INTO public.europe_data_import VALUES (3646, '17/08/2020', '2020-33', '91', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.1');
INSERT INTO public.europe_data_import VALUES (3647, '10/08/2020', '2020-32', '73', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.83');
INSERT INTO public.europe_data_import VALUES (3648, '03/08/2020', '2020-31', '40', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.73');
INSERT INTO public.europe_data_import VALUES (3649, '27/07/2020', '2020-30', '109', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (3650, '20/07/2020', '2020-29', '33', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.88');
INSERT INTO public.europe_data_import VALUES (3651, '13/07/2020', '2020-28', '42', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.73');
INSERT INTO public.europe_data_import VALUES (3652, '06/07/2020', '2020-27', '27', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.13');
INSERT INTO public.europe_data_import VALUES (3653, '29/06/2020', '2020-26', '18', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (3654, '22/06/2020', '2020-25', '29', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.5');
INSERT INTO public.europe_data_import VALUES (3655, '15/06/2020', '2020-24', '71', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.4');
INSERT INTO public.europe_data_import VALUES (3656, '08/06/2020', '2020-23', '25', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.95');
INSERT INTO public.europe_data_import VALUES (3657, '01/06/2020', '2020-22', '53', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.05');
INSERT INTO public.europe_data_import VALUES (3658, '25/05/2020', '2020-21', '29', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.38');
INSERT INTO public.europe_data_import VALUES (3659, '18/05/2020', '2020-20', '66', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.8');
INSERT INTO public.europe_data_import VALUES (3660, '11/05/2020', '2020-19', '46', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.73');
INSERT INTO public.europe_data_import VALUES (3661, '04/05/2020', '2020-18', '103', '3', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.88');
INSERT INTO public.europe_data_import VALUES (3662, '27/04/2020', '2020-17', '92', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '5.73');
INSERT INTO public.europe_data_import VALUES (3663, '20/04/2020', '2020-16', '137', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '5.5');
INSERT INTO public.europe_data_import VALUES (3664, '13/04/2020', '2020-15', '83', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.18');
INSERT INTO public.europe_data_import VALUES (3665, '06/04/2020', '2020-14', '84', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.0');
INSERT INTO public.europe_data_import VALUES (3666, '30/03/2020', '2020-13', '36', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.5');
INSERT INTO public.europe_data_import VALUES (3667, '23/03/2020', '2020-12', '24', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.03');
INSERT INTO public.europe_data_import VALUES (3668, '16/03/2020', '2020-11', '17', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (3669, '09/03/2020', '2020-10', '10', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0.33');
INSERT INTO public.europe_data_import VALUES (3670, '02/03/2020', '2020-09', '3', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (3671, '24/02/2020', '2020-08', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3672, '17/02/2020', '2020-07', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3673, '10/02/2020', '2020-06', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3674, '03/02/2020', '2020-05', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3675, '27/01/2020', '2020-04', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3676, '20/01/2020', '2020-03', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3677, '13/01/2020', '2020-02', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3678, '06/01/2020', '2020-01', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3679, '01/02/2021', '2021-04', '80306', '5033', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '218.4');
INSERT INTO public.europe_data_import VALUES (3680, '25/01/2021', '2021-03', '101006', '5454', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '265.77');
INSERT INTO public.europe_data_import VALUES (3681, '18/01/2021', '2021-02', '119635', '5947', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '319.38');
INSERT INTO public.europe_data_import VALUES (3682, '11/01/2021', '2021-01', '145511', '6112', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '324.25');
INSERT INTO public.europe_data_import VALUES (3683, '04/01/2021', '2020-53', '123679', '4448', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '319.04');
INSERT INTO public.europe_data_import VALUES (3684, '28/12/2020', '2020-52', '141182', '3851', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '379.14');
INSERT INTO public.europe_data_import VALUES (3685, '21/12/2020', '2020-51', '173574', '4300', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '393.88');
INSERT INTO public.europe_data_import VALUES (3686, '14/12/2020', '2020-50', '153424', '3056', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '341.14');
INSERT INTO public.europe_data_import VALUES (3687, '07/12/2020', '2020-49', '129785', '2671', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '306.58');
INSERT INTO public.europe_data_import VALUES (3688, '30/11/2020', '2020-48', '124736', '2136', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '304.2');
INSERT INTO public.europe_data_import VALUES (3689, '23/11/2020', '2020-47', '127806', '1565', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '309.89');
INSERT INTO public.europe_data_import VALUES (3690, '16/11/2020', '2020-46', '129459', '1195', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '308.72');
INSERT INTO public.europe_data_import VALUES (3691, '09/11/2020', '2020-45', '126841', '822', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '281.86');
INSERT INTO public.europe_data_import VALUES (3692, '02/11/2020', '2020-44', '107161', '474', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '215.29');
INSERT INTO public.europe_data_import VALUES (3693, '26/10/2020', '2020-43', '71567', '267', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '135.55');
INSERT INTO public.europe_data_import VALUES (3694, '19/10/2020', '2020-42', '40968', '168', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '79.11');
INSERT INTO public.europe_data_import VALUES (3695, '12/10/2020', '2020-41', '24712', '87', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '48.18');
INSERT INTO public.europe_data_import VALUES (3696, '05/10/2020', '2020-40', '15287', '74', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '34.07');
INSERT INTO public.europe_data_import VALUES (3697, '28/09/2020', '2020-39', '12995', '74', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '30.09');
INSERT INTO public.europe_data_import VALUES (3698, '21/09/2020', '2020-38', '11982', '36', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '25.94');
INSERT INTO public.europe_data_import VALUES (3699, '14/09/2020', '2020-37', '9556', '25', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '21.65');
INSERT INTO public.europe_data_import VALUES (3700, '07/09/2020', '2020-36', '8418', '27', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '20.75');
INSERT INTO public.europe_data_import VALUES (3701, '31/08/2020', '2020-35', '8806', '26', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '22.12');
INSERT INTO public.europe_data_import VALUES (3702, '24/08/2020', '2020-34', '9561', '40', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '20.78');
INSERT INTO public.europe_data_import VALUES (3703, '17/08/2020', '2020-33', '7687', '35', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '16.4');
INSERT INTO public.europe_data_import VALUES (3704, '10/08/2020', '2020-32', '5925', '49', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '12.91');
INSERT INTO public.europe_data_import VALUES (3705, '03/08/2020', '2020-31', '4793', '30', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '10.33');
INSERT INTO public.europe_data_import VALUES (3706, '27/07/2020', '2020-30', '3786', '32', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '8.01');
INSERT INTO public.europe_data_import VALUES (3707, '20/07/2020', '2020-29', '2860', '22', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '6.35');
INSERT INTO public.europe_data_import VALUES (3708, '13/07/2020', '2020-28', '2409', '48', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '6.27');
INSERT INTO public.europe_data_import VALUES (3709, '06/07/2020', '2020-27', '2793', '55', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '7.46');
INSERT INTO public.europe_data_import VALUES (3710, '29/06/2020', '2020-26', '3402', '76', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '8.79');
INSERT INTO public.europe_data_import VALUES (3711, '22/06/2020', '2020-25', '3898', '94', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '7.43');
INSERT INTO public.europe_data_import VALUES (3712, '15/06/2020', '2020-24', '2268', '117', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '5.6');
INSERT INTO public.europe_data_import VALUES (3713, '08/06/2020', '2020-23', '2378', '163', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '6.77');
INSERT INTO public.europe_data_import VALUES (3714, '01/06/2020', '2020-22', '3245', '254', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '8.57');
INSERT INTO public.europe_data_import VALUES (3715, '25/05/2020', '2020-21', '3873', '322', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '10.83');
INSERT INTO public.europe_data_import VALUES (3716, '18/05/2020', '2020-20', '5122', '518', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '13.88');
INSERT INTO public.europe_data_import VALUES (3717, '11/05/2020', '2020-19', '6400', '725', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '17.32');
INSERT INTO public.europe_data_import VALUES (3718, '04/05/2020', '2020-18', '7982', '942', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '25.9');
INSERT INTO public.europe_data_import VALUES (3719, '27/04/2020', '2020-17', '13521', '1346', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '38.76');
INSERT INTO public.europe_data_import VALUES (3720, '20/04/2020', '2020-16', '18656', '1605', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '55.75');
INSERT INTO public.europe_data_import VALUES (3721, '13/04/2020', '2020-15', '27625', '1365', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '79.16');
INSERT INTO public.europe_data_import VALUES (3722, '06/04/2020', '2020-14', '38093', '979', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '85.06');
INSERT INTO public.europe_data_import VALUES (3723, '30/03/2020', '2020-13', '32524', '361', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '63.19');
INSERT INTO public.europe_data_import VALUES (3724, '23/03/2020', '2020-12', '19936', '82', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '28.75');
INSERT INTO public.europe_data_import VALUES (3725, '16/03/2020', '2020-11', '3936', '12', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '5.67');
INSERT INTO public.europe_data_import VALUES (3726, '09/03/2020', '2020-10', '773', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '1.07');
INSERT INTO public.europe_data_import VALUES (3727, '02/03/2020', '2020-09', '114', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.14');
INSERT INTO public.europe_data_import VALUES (3728, '24/02/2020', '2020-08', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (3729, '17/02/2020', '2020-07', '2', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3730, '10/02/2020', '2020-06', '4', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (3731, '03/02/2020', '2020-05', '9', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3732, '27/01/2020', '2020-04', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3733, '20/01/2020', '2020-03', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3734, '13/01/2020', '2020-02', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3735, '06/01/2020', '2020-01', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3736, '01/02/2021', '2021-04', '4875', '44', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '30.56');
INSERT INTO public.europe_data_import VALUES (3737, '25/01/2021', '2021-03', '4421', '26', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '19.41');
INSERT INTO public.europe_data_import VALUES (3738, '18/01/2021', '2021-02', '1484', '8', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '8.37');
INSERT INTO public.europe_data_import VALUES (3739, '11/01/2021', '2021-01', '1062', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '5.68');
INSERT INTO public.europe_data_import VALUES (3740, '04/01/2021', '2020-53', '665', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.98');
INSERT INTO public.europe_data_import VALUES (3741, '28/12/2020', '2020-52', '850', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.9');
INSERT INTO public.europe_data_import VALUES (3742, '21/12/2020', '2020-51', '639', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.53');
INSERT INTO public.europe_data_import VALUES (3743, '14/12/2020', '2020-50', '740', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.75');
INSERT INTO public.europe_data_import VALUES (3744, '07/12/2020', '2020-49', '705', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (3745, '30/11/2020', '2020-48', '695', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.75');
INSERT INTO public.europe_data_import VALUES (3746, '23/11/2020', '2020-47', '751', '1', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (3747, '16/11/2020', '2020-46', '921', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '6.57');
INSERT INTO public.europe_data_import VALUES (3748, '09/11/2020', '2020-45', '1078', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.97');
INSERT INTO public.europe_data_import VALUES (3749, '02/11/2020', '2020-44', '434', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (3750, '26/10/2020', '2020-43', '380', '6', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.25');
INSERT INTO public.europe_data_import VALUES (3751, '19/10/2020', '2020-42', '305', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '1.58');
INSERT INTO public.europe_data_import VALUES (3752, '12/10/2020', '2020-41', '176', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.03');
INSERT INTO public.europe_data_import VALUES (3753, '05/10/2020', '2020-40', '442', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.71');
INSERT INTO public.europe_data_import VALUES (3754, '28/09/2020', '2020-39', '383', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '3.13');
INSERT INTO public.europe_data_import VALUES (3755, '21/09/2020', '2020-38', '570', '11', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.03');
INSERT INTO public.europe_data_import VALUES (3756, '14/09/2020', '2020-37', '657', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.04');
INSERT INTO public.europe_data_import VALUES (3757, '07/09/2020', '2020-36', '572', '7', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.18');
INSERT INTO public.europe_data_import VALUES (3758, '31/08/2020', '2020-35', '700', '15', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (3759, '24/08/2020', '2020-34', '973', '30', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '8.23');
INSERT INTO public.europe_data_import VALUES (3760, '17/08/2020', '2020-33', '1529', '16', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '18.14');
INSERT INTO public.europe_data_import VALUES (3761, '10/08/2020', '2020-32', '3989', '33', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '26.41');
INSERT INTO public.europe_data_import VALUES (3762, '03/08/2020', '2020-31', '4045', '14', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '30.73');
INSERT INTO public.europe_data_import VALUES (3763, '27/07/2020', '2020-30', '5302', '20', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '27.78');
INSERT INTO public.europe_data_import VALUES (3764, '20/07/2020', '2020-29', '3149', '9', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '24.93');
INSERT INTO public.europe_data_import VALUES (3765, '13/07/2020', '2020-28', '4433', '17', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '23.56');
INSERT INTO public.europe_data_import VALUES (3766, '06/07/2020', '2020-27', '2734', '10', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '19.5');
INSERT INTO public.europe_data_import VALUES (3767, '29/06/2020', '2020-26', '3197', '27', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '17.71');
INSERT INTO public.europe_data_import VALUES (3768, '22/06/2020', '2020-25', '2190', '31', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '14.85');
INSERT INTO public.europe_data_import VALUES (3769, '15/06/2020', '2020-24', '2326', '10', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '12.8');
INSERT INTO public.europe_data_import VALUES (3770, '08/06/2020', '2020-23', '1568', '8', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '9.71');
INSERT INTO public.europe_data_import VALUES (3771, '01/06/2020', '2020-22', '1387', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '7.68');
INSERT INTO public.europe_data_import VALUES (3772, '25/05/2020', '2020-21', '948', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '7.96');
INSERT INTO public.europe_data_import VALUES (3773, '18/05/2020', '2020-20', '1472', '7', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '11.72');
INSERT INTO public.europe_data_import VALUES (3774, '11/05/2020', '2020-19', '2094', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '8.92');
INSERT INTO public.europe_data_import VALUES (3775, '04/05/2020', '2020-18', '619', '7', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (3776, '27/04/2020', '2020-17', '508', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '3.23');
INSERT INTO public.europe_data_import VALUES (3777, '20/04/2020', '2020-16', '476', '1', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (3778, '13/04/2020', '2020-15', '352', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (3779, '06/04/2020', '2020-14', '62', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (3780, '30/03/2020', '2020-13', '128', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (3781, '23/03/2020', '2020-12', '22', '1', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (3782, '16/03/2020', '2020-11', '2', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3783, '01/02/2021', '2021-04', '148', '14', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '1317.27');
INSERT INTO public.europe_data_import VALUES (3784, '25/01/2021', '2021-03', '296', '20', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '2361.6');
INSERT INTO public.europe_data_import VALUES (3785, '18/01/2021', '2021-02', '500', '27', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '3750.07');
INSERT INTO public.europe_data_import VALUES (3786, '11/01/2021', '2021-01', '764', '8', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '4343.44');
INSERT INTO public.europe_data_import VALUES (3787, '04/01/2021', '2020-53', '700', '2', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '3447.46');
INSERT INTO public.europe_data_import VALUES (3788, '28/12/2020', '2020-52', '462', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '1872.07');
INSERT INTO public.europe_data_import VALUES (3789, '21/12/2020', '2020-51', '169', '1', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '566.66');
INSERT INTO public.europe_data_import VALUES (3790, '14/12/2020', '2020-50', '22', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '180.98');
INSERT INTO public.europe_data_import VALUES (3791, '07/12/2020', '2020-49', '39', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '281.85');
INSERT INTO public.europe_data_import VALUES (3792, '30/11/2020', '2020-48', '56', '1', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '332.29');
INSERT INTO public.europe_data_import VALUES (3793, '23/11/2020', '2020-47', '56', '3', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '489.53');
INSERT INTO public.europe_data_import VALUES (3794, '16/11/2020', '2020-46', '109', '1', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '590.4');
INSERT INTO public.europe_data_import VALUES (3795, '09/11/2020', '2020-45', '90', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '373.82');
INSERT INTO public.europe_data_import VALUES (3796, '02/11/2020', '2020-44', '36', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '391.62');
INSERT INTO public.europe_data_import VALUES (3797, '26/10/2020', '2020-43', '96', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '539.96');
INSERT INTO public.europe_data_import VALUES (3798, '19/10/2020', '2020-42', '86', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '412.39');
INSERT INTO public.europe_data_import VALUES (3799, '12/10/2020', '2020-41', '53', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '314.48');
INSERT INTO public.europe_data_import VALUES (3800, '05/10/2020', '2020-40', '53', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '243.28');
INSERT INTO public.europe_data_import VALUES (3801, '28/09/2020', '2020-39', '29', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '145.37');
INSERT INTO public.europe_data_import VALUES (3802, '21/09/2020', '2020-38', '20', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '103.84');
INSERT INTO public.europe_data_import VALUES (3803, '14/09/2020', '2020-37', '15', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '133.51');
INSERT INTO public.europe_data_import VALUES (3804, '07/09/2020', '2020-36', '30', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '255.15');
INSERT INTO public.europe_data_import VALUES (3805, '31/08/2020', '2020-35', '56', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '207.68');
INSERT INTO public.europe_data_import VALUES (3806, '24/08/2020', '2020-34', '14', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '94.94');
INSERT INTO public.europe_data_import VALUES (3807, '17/08/2020', '2020-33', '18', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '80.1');
INSERT INTO public.europe_data_import VALUES (3808, '10/08/2020', '2020-32', '9', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '35.6');
INSERT INTO public.europe_data_import VALUES (3809, '03/08/2020', '2020-31', '3', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '23.73');
INSERT INTO public.europe_data_import VALUES (3810, '27/07/2020', '2020-30', '5', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (3811, '20/07/2020', '2020-29', '0', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '5.93');
INSERT INTO public.europe_data_import VALUES (3812, '13/07/2020', '2020-28', '2', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '8.9');
INSERT INTO public.europe_data_import VALUES (3813, '06/07/2020', '2020-27', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '5.93');
INSERT INTO public.europe_data_import VALUES (3814, '29/06/2020', '2020-26', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '2.97');
INSERT INTO public.europe_data_import VALUES (3815, '22/06/2020', '2020-25', '0', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '2.97');
INSERT INTO public.europe_data_import VALUES (3816, '15/06/2020', '2020-24', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '20.77');
INSERT INTO public.europe_data_import VALUES (3817, '08/06/2020', '2020-23', '6', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '71.2');
INSERT INTO public.europe_data_import VALUES (3818, '01/06/2020', '2020-22', '18', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '65.27');
INSERT INTO public.europe_data_import VALUES (3819, '25/05/2020', '2020-21', '4', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (3820, '18/05/2020', '2020-20', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '8.9');
INSERT INTO public.europe_data_import VALUES (3821, '11/05/2020', '2020-19', '2', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (3822, '04/05/2020', '2020-18', '3', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '32.64');
INSERT INTO public.europe_data_import VALUES (3823, '27/04/2020', '2020-17', '8', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '35.6');
INSERT INTO public.europe_data_import VALUES (3824, '20/04/2020', '2020-16', '4', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '89.0');
INSERT INTO public.europe_data_import VALUES (3825, '13/04/2020', '2020-15', '26', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '189.88');
INSERT INTO public.europe_data_import VALUES (3826, '06/04/2020', '2020-14', '38', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '261.08');
INSERT INTO public.europe_data_import VALUES (3827, '30/03/2020', '2020-13', '50', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '192.84');
INSERT INTO public.europe_data_import VALUES (3828, '23/03/2020', '2020-12', '15', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3829, '01/02/2021', '2021-04', '4977', '150', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '77.86');
INSERT INTO public.europe_data_import VALUES (3830, '25/01/2021', '2021-03', '3373', '177', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '67.53');
INSERT INTO public.europe_data_import VALUES (3831, '18/01/2021', '2021-02', '3869', '206', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '79.33');
INSERT INTO public.europe_data_import VALUES (3832, '11/01/2021', '2021-01', '4639', '306', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '82.12');
INSERT INTO public.europe_data_import VALUES (3833, '04/01/2021', '2020-53', '4168', '285', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '84.17');
INSERT INTO public.europe_data_import VALUES (3834, '28/12/2020', '2020-52', '4859', '500', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '106.27');
INSERT INTO public.europe_data_import VALUES (3835, '21/12/2020', '2020-51', '6538', '547', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '145.47');
INSERT INTO public.europe_data_import VALUES (3836, '14/12/2020', '2020-50', '9063', '622', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '189.35');
INSERT INTO public.europe_data_import VALUES (3837, '07/12/2020', '2020-49', '11244', '682', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '222.4');
INSERT INTO public.europe_data_import VALUES (3838, '30/11/2020', '2020-48', '12608', '691', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '279.94');
INSERT INTO public.europe_data_import VALUES (3839, '23/11/2020', '2020-47', '17414', '524', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '325.62');
INSERT INTO public.europe_data_import VALUES (3840, '16/11/2020', '2020-46', '17507', '322', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '310.28');
INSERT INTO public.europe_data_import VALUES (3841, '09/11/2020', '2020-45', '15769', '149', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '241.65');
INSERT INTO public.europe_data_import VALUES (3842, '02/11/2020', '2020-44', '10147', '61', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '145.08');
INSERT INTO public.europe_data_import VALUES (3843, '26/10/2020', '2020-43', '5412', '65', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '78.55');
INSERT INTO public.europe_data_import VALUES (3844, '19/10/2020', '2020-42', '3012', '60', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '51.55');
INSERT INTO public.europe_data_import VALUES (3845, '12/10/2020', '2020-41', '2516', '40', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '45.82');
INSERT INTO public.europe_data_import VALUES (3846, '05/10/2020', '2020-40', '2398', '30', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '43.82');
INSERT INTO public.europe_data_import VALUES (3847, '28/09/2020', '2020-39', '2302', '41', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '39.2');
INSERT INTO public.europe_data_import VALUES (3848, '21/09/2020', '2020-38', '1902', '33', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '33.74');
INSERT INTO public.europe_data_import VALUES (3849, '14/09/2020', '2020-37', '1716', '21', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '28.96');
INSERT INTO public.europe_data_import VALUES (3850, '07/09/2020', '2020-36', '1390', '22', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '26.67');
INSERT INTO public.europe_data_import VALUES (3851, '31/08/2020', '2020-35', '1470', '20', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '28.52');
INSERT INTO public.europe_data_import VALUES (3852, '24/08/2020', '2020-34', '1589', '14', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '28.36');
INSERT INTO public.europe_data_import VALUES (3853, '17/08/2020', '2020-33', '1452', '16', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '22.5');
INSERT INTO public.europe_data_import VALUES (3854, '10/08/2020', '2020-32', '961', '4', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '13.33');
INSERT INTO public.europe_data_import VALUES (3855, '03/08/2020', '2020-31', '469', '6', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '6.11');
INSERT INTO public.europe_data_import VALUES (3856, '27/07/2020', '2020-30', '186', '8', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.64');
INSERT INTO public.europe_data_import VALUES (3857, '20/07/2020', '2020-29', '204', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '4.55');
INSERT INTO public.europe_data_import VALUES (3858, '13/07/2020', '2020-28', '284', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.98');
INSERT INTO public.europe_data_import VALUES (3859, '06/07/2020', '2020-27', '143', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (3860, '29/06/2020', '2020-26', '110', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '2.38');
INSERT INTO public.europe_data_import VALUES (3861, '22/06/2020', '2020-25', '145', '7', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '2.51');
INSERT INTO public.europe_data_import VALUES (3862, '15/06/2020', '2020-24', '124', '3', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.9');
INSERT INTO public.europe_data_import VALUES (3863, '08/06/2020', '2020-23', '80', '5', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.11');
INSERT INTO public.europe_data_import VALUES (3864, '01/06/2020', '2020-22', '39', '4', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0.77');
INSERT INTO public.europe_data_import VALUES (3865, '25/05/2020', '2020-21', '44', '8', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.51');
INSERT INTO public.europe_data_import VALUES (3866, '18/05/2020', '2020-20', '118', '12', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.94');
INSERT INTO public.europe_data_import VALUES (3867, '11/05/2020', '2020-19', '90', '7', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.96');
INSERT INTO public.europe_data_import VALUES (3868, '04/05/2020', '2020-18', '120', '14', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.65');
INSERT INTO public.europe_data_import VALUES (3869, '27/04/2020', '2020-17', '271', '20', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.66');
INSERT INTO public.europe_data_import VALUES (3870, '20/04/2020', '2020-16', '121', '12', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '4.66');
INSERT INTO public.europe_data_import VALUES (3871, '13/04/2020', '2020-15', '379', '25', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '8.93');
INSERT INTO public.europe_data_import VALUES (3872, '06/04/2020', '2020-14', '579', '35', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '10.36');
INSERT INTO public.europe_data_import VALUES (3873, '30/03/2020', '2020-13', '532', '23', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '7.69');
INSERT INTO public.europe_data_import VALUES (3874, '23/03/2020', '2020-12', '293', '11', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '5.14');
INSERT INTO public.europe_data_import VALUES (3875, '16/03/2020', '2020-11', '258', '4', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (3876, '09/03/2020', '2020-10', '66', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (3877, '02/03/2020', '2020-09', '7', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0.07');
INSERT INTO public.europe_data_import VALUES (3878, '24/02/2020', '2020-08', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3879, '17/02/2020', '2020-07', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3880, '10/02/2020', '2020-06', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3881, '03/02/2020', '2020-05', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3882, '27/01/2020', '2020-04', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3883, '20/01/2020', '2020-03', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3884, '13/01/2020', '2020-02', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3885, '06/01/2020', '2020-01', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3886, '01/02/2021', '2021-04', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3887, '25/01/2021', '2021-03', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '5.29');
INSERT INTO public.europe_data_import VALUES (3888, '18/01/2021', '2021-02', '3', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '5.29');
INSERT INTO public.europe_data_import VALUES (3889, '11/01/2021', '2021-01', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3890, '04/01/2021', '2020-53', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '14.12');
INSERT INTO public.europe_data_import VALUES (3891, '28/12/2020', '2020-52', '7', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '12.35');
INSERT INTO public.europe_data_import VALUES (3892, '21/12/2020', '2020-51', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3893, '14/12/2020', '2020-50', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3894, '07/12/2020', '2020-49', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3895, '30/11/2020', '2020-48', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3896, '23/11/2020', '2020-47', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3897, '16/11/2020', '2020-46', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3898, '09/11/2020', '2020-45', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3899, '02/11/2020', '2020-44', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3900, '26/10/2020', '2020-43', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3901, '19/10/2020', '2020-42', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3902, '12/10/2020', '2020-41', '2', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3903, '05/10/2020', '2020-40', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3904, '28/09/2020', '2020-39', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3905, '21/09/2020', '2020-38', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3906, '14/09/2020', '2020-37', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3907, '07/09/2020', '2020-36', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3908, '31/08/2020', '2020-35', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3909, '24/08/2020', '2020-34', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3910, '17/08/2020', '2020-33', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3911, '10/08/2020', '2020-32', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3912, '03/08/2020', '2020-31', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3913, '27/07/2020', '2020-30', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3914, '20/07/2020', '2020-29', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3915, '13/07/2020', '2020-28', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3916, '06/07/2020', '2020-27', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3917, '29/06/2020', '2020-26', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3918, '22/06/2020', '2020-25', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3919, '15/06/2020', '2020-24', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3920, '08/06/2020', '2020-23', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3921, '01/06/2020', '2020-22', '2', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3922, '25/05/2020', '2020-21', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3923, '18/05/2020', '2020-20', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3924, '11/05/2020', '2020-19', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3925, '04/05/2020', '2020-18', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3926, '27/04/2020', '2020-17', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3927, '20/04/2020', '2020-16', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3928, '13/04/2020', '2020-15', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3929, '06/04/2020', '2020-14', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '15.88');
INSERT INTO public.europe_data_import VALUES (3930, '30/03/2020', '2020-13', '8', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '17.65');
INSERT INTO public.europe_data_import VALUES (3931, '23/03/2020', '2020-12', '2', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '');
INSERT INTO public.europe_data_import VALUES (3932, '01/02/2021', '2021-04', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3933, '25/01/2021', '2021-03', '9', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '11.61');
INSERT INTO public.europe_data_import VALUES (3934, '18/01/2021', '2021-02', '4', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '4.46');
INSERT INTO public.europe_data_import VALUES (3935, '11/01/2021', '2021-01', '1', '1', '112002', 'Grenada', 'GD', 'GRD', 'America', '16.96');
INSERT INTO public.europe_data_import VALUES (3936, '04/01/2021', '2020-53', '18', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '24.11');
INSERT INTO public.europe_data_import VALUES (3937, '28/12/2020', '2020-52', '9', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '41.96');
INSERT INTO public.europe_data_import VALUES (3938, '21/12/2020', '2020-51', '38', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '58.93');
INSERT INTO public.europe_data_import VALUES (3939, '14/12/2020', '2020-50', '28', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '25.0');
INSERT INTO public.europe_data_import VALUES (3940, '07/12/2020', '2020-49', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3941, '30/11/2020', '2020-48', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3942, '23/11/2020', '2020-47', '9', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3943, '16/11/2020', '2020-46', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3944, '09/11/2020', '2020-45', '4', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3945, '02/11/2020', '2020-44', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3946, '26/10/2020', '2020-43', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3947, '19/10/2020', '2020-42', '3', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (3948, '12/10/2020', '2020-41', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3949, '05/10/2020', '2020-40', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3950, '28/09/2020', '2020-39', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3951, '21/09/2020', '2020-38', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3952, '14/09/2020', '2020-37', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3953, '07/09/2020', '2020-36', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3954, '31/08/2020', '2020-35', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3955, '24/08/2020', '2020-34', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3956, '17/08/2020', '2020-33', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3957, '10/08/2020', '2020-32', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3958, '03/08/2020', '2020-31', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3959, '27/07/2020', '2020-30', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3960, '20/07/2020', '2020-29', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3961, '13/07/2020', '2020-28', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3962, '06/07/2020', '2020-27', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3963, '29/06/2020', '2020-26', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3964, '22/06/2020', '2020-25', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3965, '15/06/2020', '2020-24', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3966, '08/06/2020', '2020-23', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3967, '01/06/2020', '2020-22', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3968, '25/05/2020', '2020-21', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3969, '18/05/2020', '2020-20', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3970, '11/05/2020', '2020-19', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (3971, '04/05/2020', '2020-18', '3', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '6.25');
INSERT INTO public.europe_data_import VALUES (3972, '27/04/2020', '2020-17', '4', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3973, '20/04/2020', '2020-16', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '1.79');
INSERT INTO public.europe_data_import VALUES (3974, '13/04/2020', '2020-15', '2', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '4.46');
INSERT INTO public.europe_data_import VALUES (3975, '06/04/2020', '2020-14', '3', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '9.82');
INSERT INTO public.europe_data_import VALUES (3976, '30/03/2020', '2020-13', '8', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3977, '23/03/2020', '2020-12', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '');
INSERT INTO public.europe_data_import VALUES (3978, '01/02/2021', '2021-04', '54', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '73.52');
INSERT INTO public.europe_data_import VALUES (3979, '25/01/2021', '2021-03', '69', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '78.3');
INSERT INTO public.europe_data_import VALUES (3980, '18/01/2021', '2021-02', '62', '4', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '94.44');
INSERT INTO public.europe_data_import VALUES (3981, '11/01/2021', '2021-01', '96', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '91.46');
INSERT INTO public.europe_data_import VALUES (3982, '04/01/2021', '2020-53', '57', '2', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '69.34');
INSERT INTO public.europe_data_import VALUES (3983, '28/12/2020', '2020-52', '59', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '98.03');
INSERT INTO public.europe_data_import VALUES (3984, '21/12/2020', '2020-51', '105', '2', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '123.73');
INSERT INTO public.europe_data_import VALUES (3985, '14/12/2020', '2020-50', '102', '5', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '172.15');
INSERT INTO public.europe_data_import VALUES (3986, '07/12/2020', '2020-49', '186', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '271.97');
INSERT INTO public.europe_data_import VALUES (3987, '30/11/2020', '2020-48', '269', '6', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '416.63');
INSERT INTO public.europe_data_import VALUES (3988, '23/11/2020', '2020-47', '428', '8', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '786.63');
INSERT INTO public.europe_data_import VALUES (3989, '16/11/2020', '2020-46', '888', '9', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '853.58');
INSERT INTO public.europe_data_import VALUES (3990, '09/11/2020', '2020-45', '540', '10', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '607.91');
INSERT INTO public.europe_data_import VALUES (3991, '02/11/2020', '2020-44', '477', '7', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '608.51');
INSERT INTO public.europe_data_import VALUES (3992, '26/10/2020', '2020-43', '541', '6', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '680.24');
INSERT INTO public.europe_data_import VALUES (3993, '19/10/2020', '2020-42', '597', '6', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '583.4');
INSERT INTO public.europe_data_import VALUES (3994, '12/10/2020', '2020-41', '379', '8', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '432.77');
INSERT INTO public.europe_data_import VALUES (3995, '05/10/2020', '2020-40', '345', '10', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '347.89');
INSERT INTO public.europe_data_import VALUES (3996, '28/09/2020', '2020-39', '237', '8', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '276.76');
INSERT INTO public.europe_data_import VALUES (3997, '21/09/2020', '2020-38', '226', '9', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '297.68');
INSERT INTO public.europe_data_import VALUES (3998, '14/09/2020', '2020-37', '272', '11', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '325.17');
INSERT INTO public.europe_data_import VALUES (3999, '07/09/2020', '2020-36', '272', '4', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '477.6');
INSERT INTO public.europe_data_import VALUES (4000, '31/08/2020', '2020-35', '527', '3', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '471.62');
INSERT INTO public.europe_data_import VALUES (4001, '24/08/2020', '2020-34', '262', '2', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '240.29');
INSERT INTO public.europe_data_import VALUES (4002, '17/08/2020', '2020-33', '140', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '113.57');
INSERT INTO public.europe_data_import VALUES (4003, '10/08/2020', '2020-32', '50', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '43.04');
INSERT INTO public.europe_data_import VALUES (4004, '03/08/2020', '2020-31', '22', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '29.29');
INSERT INTO public.europe_data_import VALUES (4005, '27/07/2020', '2020-30', '27', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '20.32');
INSERT INTO public.europe_data_import VALUES (4006, '20/07/2020', '2020-29', '7', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '10.76');
INSERT INTO public.europe_data_import VALUES (4007, '13/07/2020', '2020-28', '11', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '35.27');
INSERT INTO public.europe_data_import VALUES (4008, '06/07/2020', '2020-27', '48', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '47.22');
INSERT INTO public.europe_data_import VALUES (4009, '29/06/2020', '2020-26', '31', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '40.65');
INSERT INTO public.europe_data_import VALUES (4010, '22/06/2020', '2020-25', '37', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '25.7');
INSERT INTO public.europe_data_import VALUES (4011, '15/06/2020', '2020-24', '6', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '5.98');
INSERT INTO public.europe_data_import VALUES (4012, '08/06/2020', '2020-23', '4', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '7.77');
INSERT INTO public.europe_data_import VALUES (4013, '01/06/2020', '2020-22', '9', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '12.55');
INSERT INTO public.europe_data_import VALUES (4014, '25/05/2020', '2020-21', '12', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '8.97');
INSERT INTO public.europe_data_import VALUES (4015, '18/05/2020', '2020-20', '3', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '2.99');
INSERT INTO public.europe_data_import VALUES (4016, '11/05/2020', '2020-19', '2', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '5.38');
INSERT INTO public.europe_data_import VALUES (4017, '04/05/2020', '2020-18', '7', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '7.77');
INSERT INTO public.europe_data_import VALUES (4018, '27/04/2020', '2020-17', '6', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '5.38');
INSERT INTO public.europe_data_import VALUES (4019, '20/04/2020', '2020-16', '3', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '15.54');
INSERT INTO public.europe_data_import VALUES (4020, '13/04/2020', '2020-15', '23', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '46.03');
INSERT INTO public.europe_data_import VALUES (4021, '06/04/2020', '2020-14', '54', '3', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '49.61');
INSERT INTO public.europe_data_import VALUES (4022, '30/03/2020', '2020-13', '29', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '33.47');
INSERT INTO public.europe_data_import VALUES (4023, '23/03/2020', '2020-12', '27', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (4024, '01/02/2021', '2021-04', '5202', '204', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '59.64');
INSERT INTO public.europe_data_import VALUES (4025, '25/01/2021', '2021-03', '5284', '191', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '64.03');
INSERT INTO public.europe_data_import VALUES (4026, '18/01/2021', '2021-02', '5973', '228', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '59.67');
INSERT INTO public.europe_data_import VALUES (4027, '11/01/2021', '2021-01', '4517', '215', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '43.98');
INSERT INTO public.europe_data_import VALUES (4028, '04/01/2021', '2020-53', '3215', '62', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '28.75');
INSERT INTO public.europe_data_import VALUES (4029, '28/12/2020', '2020-52', '1840', '55', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '35.03');
INSERT INTO public.europe_data_import VALUES (4030, '21/12/2020', '2020-51', '4319', '295', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '45.79');
INSERT INTO public.europe_data_import VALUES (4031, '14/12/2020', '2020-50', '3732', '173', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '41.58');
INSERT INTO public.europe_data_import VALUES (4032, '07/12/2020', '2020-49', '3579', '84', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '39.37');
INSERT INTO public.europe_data_import VALUES (4033, '30/11/2020', '2020-48', '3342', '90', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '40.3');
INSERT INTO public.europe_data_import VALUES (4034, '23/11/2020', '2020-47', '3744', '144', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '41.9');
INSERT INTO public.europe_data_import VALUES (4035, '16/11/2020', '2020-46', '3623', '111', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '38.57');
INSERT INTO public.europe_data_import VALUES (4036, '09/11/2020', '2020-45', '3158', '83', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '36.83');
INSERT INTO public.europe_data_import VALUES (4037, '02/11/2020', '2020-44', '3317', '94', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '38.36');
INSERT INTO public.europe_data_import VALUES (4038, '26/10/2020', '2020-43', '3427', '114', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '40.22');
INSERT INTO public.europe_data_import VALUES (4039, '19/10/2020', '2020-42', '3645', '146', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '42.07');
INSERT INTO public.europe_data_import VALUES (4040, '12/10/2020', '2020-41', '3752', '91', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '43.36');
INSERT INTO public.europe_data_import VALUES (4041, '05/10/2020', '2020-40', '3871', '64', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '48.45');
INSERT INTO public.europe_data_import VALUES (4042, '28/09/2020', '2020-39', '4648', '110', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '46.54');
INSERT INTO public.europe_data_import VALUES (4043, '21/09/2020', '2020-38', '3535', '162', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '44.14');
INSERT INTO public.europe_data_import VALUES (4044, '14/09/2020', '2020-37', '4226', '105', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '45.49');
INSERT INTO public.europe_data_import VALUES (4045, '07/09/2020', '2020-36', '3771', '112', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '54.01');
INSERT INTO public.europe_data_import VALUES (4046, '31/08/2020', '2020-35', '5724', '146', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '64.56');
INSERT INTO public.europe_data_import VALUES (4047, '24/08/2020', '2020-34', '5626', '215', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '65.88');
INSERT INTO public.europe_data_import VALUES (4048, '17/08/2020', '2020-33', '5957', '168', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '64.02');
INSERT INTO public.europe_data_import VALUES (4049, '10/08/2020', '2020-32', '5299', '216', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '65.71');
INSERT INTO public.europe_data_import VALUES (4050, '03/08/2020', '2020-31', '6253', '261', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '71.83');
INSERT INTO public.europe_data_import VALUES (4051, '27/07/2020', '2020-30', '6376', '249', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '89.29');
INSERT INTO public.europe_data_import VALUES (4052, '20/07/2020', '2020-29', '9322', '266', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '87.76');
INSERT INTO public.europe_data_import VALUES (4053, '13/07/2020', '2020-28', '6107', '272', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '70.67');
INSERT INTO public.europe_data_import VALUES (4054, '06/07/2020', '2020-27', '6318', '220', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '57.46');
INSERT INTO public.europe_data_import VALUES (4055, '29/06/2020', '2020-26', '3785', '196', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '40.3');
INSERT INTO public.europe_data_import VALUES (4056, '22/06/2020', '2020-25', '3300', '147', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '34.64');
INSERT INTO public.europe_data_import VALUES (4057, '15/06/2020', '2020-24', '2790', '132', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '27.06');
INSERT INTO public.europe_data_import VALUES (4058, '08/06/2020', '2020-23', '1968', '144', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '20.65');
INSERT INTO public.europe_data_import VALUES (4059, '01/06/2020', '2020-22', '1663', '50', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '18.06');
INSERT INTO public.europe_data_import VALUES (4060, '25/05/2020', '2020-21', '1512', '23', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '13.49');
INSERT INTO public.europe_data_import VALUES (4061, '18/05/2020', '2020-20', '860', '9', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '6.88');
INSERT INTO public.europe_data_import VALUES (4062, '11/05/2020', '2020-19', '349', '9', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '3.14');
INSERT INTO public.europe_data_import VALUES (4063, '04/05/2020', '2020-18', '203', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '2.35');
INSERT INTO public.europe_data_import VALUES (4064, '27/04/2020', '2020-17', '211', '8', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '1.96');
INSERT INTO public.europe_data_import VALUES (4065, '20/04/2020', '2020-16', '133', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '1.25');
INSERT INTO public.europe_data_import VALUES (4066, '13/04/2020', '2020-15', '86', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.68');
INSERT INTO public.europe_data_import VALUES (4067, '06/04/2020', '2020-14', '34', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.29');
INSERT INTO public.europe_data_import VALUES (4068, '30/03/2020', '2020-13', '17', '0', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.2');
INSERT INTO public.europe_data_import VALUES (4069, '23/03/2020', '2020-12', '18', '0', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.11');
INSERT INTO public.europe_data_import VALUES (4070, '16/03/2020', '2020-11', '1', '1', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '');
INSERT INTO public.europe_data_import VALUES (4071, '01/02/2021', '2021-04', '218', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '356.77');
INSERT INTO public.europe_data_import VALUES (4072, '25/01/2021', '2021-03', '12', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '24.82');
INSERT INTO public.europe_data_import VALUES (4073, '18/01/2021', '2021-02', '4', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '13.96');
INSERT INTO public.europe_data_import VALUES (4074, '11/01/2021', '2021-01', '5', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '12.41');
INSERT INTO public.europe_data_import VALUES (4075, '04/01/2021', '2020-53', '3', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '10.86');
INSERT INTO public.europe_data_import VALUES (4076, '28/12/2020', '2020-52', '4', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '12.41');
INSERT INTO public.europe_data_import VALUES (4077, '21/12/2020', '2020-51', '4', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '7.76');
INSERT INTO public.europe_data_import VALUES (4078, '14/12/2020', '2020-50', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '4.65');
INSERT INTO public.europe_data_import VALUES (4079, '07/12/2020', '2020-49', '2', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '7.76');
INSERT INTO public.europe_data_import VALUES (4080, '30/11/2020', '2020-48', '3', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '6.2');
INSERT INTO public.europe_data_import VALUES (4081, '23/11/2020', '2020-47', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '6.2');
INSERT INTO public.europe_data_import VALUES (4082, '16/11/2020', '2020-46', '3', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '18.61');
INSERT INTO public.europe_data_import VALUES (4083, '09/11/2020', '2020-45', '9', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '21.72');
INSERT INTO public.europe_data_import VALUES (4084, '02/11/2020', '2020-44', '5', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '18.61');
INSERT INTO public.europe_data_import VALUES (4085, '26/10/2020', '2020-43', '7', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '10.86');
INSERT INTO public.europe_data_import VALUES (4086, '19/10/2020', '2020-42', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '1.55');
INSERT INTO public.europe_data_import VALUES (4087, '12/10/2020', '2020-41', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '3.1');
INSERT INTO public.europe_data_import VALUES (4088, '05/10/2020', '2020-40', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '3.1');
INSERT INTO public.europe_data_import VALUES (4089, '28/09/2020', '2020-39', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '4.65');
INSERT INTO public.europe_data_import VALUES (4090, '21/09/2020', '2020-38', '2', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '4.65');
INSERT INTO public.europe_data_import VALUES (4091, '14/09/2020', '2020-37', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '1.55');
INSERT INTO public.europe_data_import VALUES (4092, '07/09/2020', '2020-36', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4093, '31/08/2020', '2020-35', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4094, '24/08/2020', '2020-34', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4095, '17/08/2020', '2020-33', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4096, '10/08/2020', '2020-32', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4097, '03/08/2020', '2020-31', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4098, '27/07/2020', '2020-30', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4099, '20/07/2020', '2020-29', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4100, '13/07/2020', '2020-28', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4101, '06/07/2020', '2020-27', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4102, '29/06/2020', '2020-26', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4103, '22/06/2020', '2020-25', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4104, '15/06/2020', '2020-24', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4105, '08/06/2020', '2020-23', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4106, '01/06/2020', '2020-22', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4107, '25/05/2020', '2020-21', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4108, '18/05/2020', '2020-20', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4109, '11/05/2020', '2020-19', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '7.76');
INSERT INTO public.europe_data_import VALUES (4110, '04/05/2020', '2020-18', '5', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '20.17');
INSERT INTO public.europe_data_import VALUES (4111, '27/04/2020', '2020-17', '8', '4', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '44.98');
INSERT INTO public.europe_data_import VALUES (4112, '20/04/2020', '2020-16', '21', '3', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '131.85');
INSERT INTO public.europe_data_import VALUES (4113, '13/04/2020', '2020-15', '64', '3', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '268.35');
INSERT INTO public.europe_data_import VALUES (4114, '06/04/2020', '2020-14', '109', '3', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '212.51');
INSERT INTO public.europe_data_import VALUES (4115, '30/03/2020', '2020-13', '28', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '69.8');
INSERT INTO public.europe_data_import VALUES (4116, '23/03/2020', '2020-12', '17', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4117, '01/02/2021', '2021-04', '176', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.0');
INSERT INTO public.europe_data_import VALUES (4118, '25/01/2021', '2021-03', '207', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.05');
INSERT INTO public.europe_data_import VALUES (4119, '18/01/2021', '2021-02', '183', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (4120, '11/01/2021', '2021-01', '190', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (4121, '04/01/2021', '2020-53', '111', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (4122, '28/12/2020', '2020-52', '138', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (4123, '21/12/2020', '2020-51', '93', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '2.48');
INSERT INTO public.europe_data_import VALUES (4124, '14/12/2020', '2020-50', '224', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.27');
INSERT INTO public.europe_data_import VALUES (4125, '07/12/2020', '2020-49', '194', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.19');
INSERT INTO public.europe_data_import VALUES (4126, '30/11/2020', '2020-48', '213', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.35');
INSERT INTO public.europe_data_import VALUES (4127, '23/11/2020', '2020-47', '215', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.13');
INSERT INTO public.europe_data_import VALUES (4128, '16/11/2020', '2020-46', '185', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (4129, '09/11/2020', '2020-45', '231', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.93');
INSERT INTO public.europe_data_import VALUES (4130, '02/11/2020', '2020-44', '526', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.3');
INSERT INTO public.europe_data_import VALUES (4131, '26/10/2020', '2020-43', '151', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.07');
INSERT INTO public.europe_data_import VALUES (4132, '19/10/2020', '2020-42', '496', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.98');
INSERT INTO public.europe_data_import VALUES (4133, '12/10/2020', '2020-41', '268', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (4134, '05/10/2020', '2020-40', '174', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.36');
INSERT INTO public.europe_data_import VALUES (4135, '28/09/2020', '2020-39', '255', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '4.38');
INSERT INTO public.europe_data_import VALUES (4136, '21/09/2020', '2020-38', '305', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '4.72');
INSERT INTO public.europe_data_import VALUES (4137, '14/09/2020', '2020-37', '298', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.08');
INSERT INTO public.europe_data_import VALUES (4138, '07/09/2020', '2020-36', '351', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.91');
INSERT INTO public.europe_data_import VALUES (4139, '31/08/2020', '2020-35', '404', '6', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.96');
INSERT INTO public.europe_data_import VALUES (4140, '24/08/2020', '2020-34', '485', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.12');
INSERT INTO public.europe_data_import VALUES (4141, '17/08/2020', '2020-33', '552', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.75');
INSERT INTO public.europe_data_import VALUES (4142, '10/08/2020', '2020-32', '566', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '7.22');
INSERT INTO public.europe_data_import VALUES (4143, '03/08/2020', '2020-31', '356', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.42');
INSERT INTO public.europe_data_import VALUES (4144, '27/07/2020', '2020-30', '464', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.79');
INSERT INTO public.europe_data_import VALUES (4145, '20/07/2020', '2020-29', '403', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '7.31');
INSERT INTO public.europe_data_import VALUES (4146, '13/07/2020', '2020-28', '531', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.26');
INSERT INTO public.europe_data_import VALUES (4147, '06/07/2020', '2020-27', '268', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '4.87');
INSERT INTO public.europe_data_import VALUES (4148, '29/06/2020', '2020-26', '354', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.34');
INSERT INTO public.europe_data_import VALUES (4149, '22/06/2020', '2020-25', '456', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.44');
INSERT INTO public.europe_data_import VALUES (4150, '15/06/2020', '2020-24', '367', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.96');
INSERT INTO public.europe_data_import VALUES (4151, '08/06/2020', '2020-23', '394', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.97');
INSERT INTO public.europe_data_import VALUES (4152, '01/06/2020', '2020-22', '496', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.71');
INSERT INTO public.europe_data_import VALUES (4153, '25/05/2020', '2020-21', '617', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.84');
INSERT INTO public.europe_data_import VALUES (4154, '18/05/2020', '2020-20', '512', '5', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.39');
INSERT INTO public.europe_data_import VALUES (4155, '11/05/2020', '2020-19', '560', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.24');
INSERT INTO public.europe_data_import VALUES (4156, '04/05/2020', '2020-18', '492', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '7.88');
INSERT INTO public.europe_data_import VALUES (4157, '27/04/2020', '2020-17', '515', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.61');
INSERT INTO public.europe_data_import VALUES (4158, '20/04/2020', '2020-16', '329', '5', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.59');
INSERT INTO public.europe_data_import VALUES (4159, '13/04/2020', '2020-15', '129', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '1.89');
INSERT INTO public.europe_data_import VALUES (4160, '06/04/2020', '2020-14', '113', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (4161, '30/03/2020', '2020-13', '6', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (4162, '23/03/2020', '2020-12', '2', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (4163, '01/02/2021', '2021-04', '103', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '6.56');
INSERT INTO public.europe_data_import VALUES (4164, '25/01/2021', '2021-03', '23', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (4165, '18/01/2021', '2021-02', '31', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.23');
INSERT INTO public.europe_data_import VALUES (4166, '11/01/2021', '2021-01', '31', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.61');
INSERT INTO public.europe_data_import VALUES (4167, '04/01/2021', '2020-53', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (4168, '28/12/2020', '2020-52', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (4169, '21/12/2020', '2020-51', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (4170, '14/12/2020', '2020-50', '5', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.3');
INSERT INTO public.europe_data_import VALUES (4171, '07/12/2020', '2020-49', '20', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.09');
INSERT INTO public.europe_data_import VALUES (4172, '30/11/2020', '2020-48', '1', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (4173, '23/11/2020', '2020-47', '2', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (4174, '16/11/2020', '2020-46', '6', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (4175, '09/11/2020', '2020-45', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (4176, '02/11/2020', '2020-44', '10', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.25');
INSERT INTO public.europe_data_import VALUES (4177, '26/10/2020', '2020-43', '14', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (4178, '19/10/2020', '2020-42', '4', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (4179, '12/10/2020', '2020-41', '23', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (4180, '05/10/2020', '2020-40', '38', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (4181, '28/09/2020', '2020-39', '21', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '2.55');
INSERT INTO public.europe_data_import VALUES (4182, '21/09/2020', '2020-38', '28', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.02');
INSERT INTO public.europe_data_import VALUES (4183, '14/09/2020', '2020-37', '30', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.64');
INSERT INTO public.europe_data_import VALUES (4184, '07/09/2020', '2020-36', '40', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.0');
INSERT INTO public.europe_data_import VALUES (4185, '31/08/2020', '2020-35', '56', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '4.58');
INSERT INTO public.europe_data_import VALUES (4186, '24/08/2020', '2020-34', '32', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.05');
INSERT INTO public.europe_data_import VALUES (4187, '17/08/2020', '2020-33', '65', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '7.08');
INSERT INTO public.europe_data_import VALUES (4188, '10/08/2020', '2020-32', '71', '3', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.1');
INSERT INTO public.europe_data_import VALUES (4189, '03/08/2020', '2020-31', '27', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (4190, '27/07/2020', '2020-30', '27', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.83');
INSERT INTO public.europe_data_import VALUES (4191, '20/07/2020', '2020-29', '85', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '8.43');
INSERT INTO public.europe_data_import VALUES (4192, '13/07/2020', '2020-28', '77', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '11.87');
INSERT INTO public.europe_data_import VALUES (4193, '06/07/2020', '2020-27', '151', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '11.66');
INSERT INTO public.europe_data_import VALUES (4194, '29/06/2020', '2020-26', '73', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '8.02');
INSERT INTO public.europe_data_import VALUES (4195, '22/06/2020', '2020-25', '81', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '9.01');
INSERT INTO public.europe_data_import VALUES (4196, '15/06/2020', '2020-24', '92', '3', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '7.18');
INSERT INTO public.europe_data_import VALUES (4197, '08/06/2020', '2020-23', '46', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '10.15');
INSERT INTO public.europe_data_import VALUES (4198, '01/06/2020', '2020-22', '149', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '17.28');
INSERT INTO public.europe_data_import VALUES (4199, '25/05/2020', '2020-21', '183', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '23.27');
INSERT INTO public.europe_data_import VALUES (4200, '18/05/2020', '2020-20', '264', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '36.34');
INSERT INTO public.europe_data_import VALUES (4201, '11/05/2020', '2020-19', '434', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '35.04');
INSERT INTO public.europe_data_import VALUES (4202, '04/05/2020', '2020-18', '239', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '12.6');
INSERT INTO public.europe_data_import VALUES (4203, '27/04/2020', '2020-17', '3', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (4204, '20/04/2020', '2020-16', '11', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (4205, '13/04/2020', '2020-15', '21', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.93');
INSERT INTO public.europe_data_import VALUES (4206, '06/04/2020', '2020-14', '16', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (4207, '30/03/2020', '2020-13', '2', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (4208, '01/02/2021', '2021-04', '324', '4', '782775', 'Guyana', 'GY', 'GUY', 'America', '93.64');
INSERT INTO public.europe_data_import VALUES (4209, '25/01/2021', '2021-03', '409', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '71.92');
INSERT INTO public.europe_data_import VALUES (4210, '18/01/2021', '2021-02', '154', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '70.26');
INSERT INTO public.europe_data_import VALUES (4211, '11/01/2021', '2021-01', '396', '5', '782775', 'Guyana', 'GY', 'GUY', 'America', '58.89');
INSERT INTO public.europe_data_import VALUES (4212, '04/01/2021', '2020-53', '65', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '23.89');
INSERT INTO public.europe_data_import VALUES (4213, '28/12/2020', '2020-52', '122', '5', '782775', 'Guyana', 'GY', 'GUY', 'America', '47.65');
INSERT INTO public.europe_data_import VALUES (4214, '21/12/2020', '2020-51', '251', '4', '782775', 'Guyana', 'GY', 'GUY', 'America', '64.64');
INSERT INTO public.europe_data_import VALUES (4215, '14/12/2020', '2020-50', '255', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '69.5');
INSERT INTO public.europe_data_import VALUES (4216, '07/12/2020', '2020-49', '289', '3', '782775', 'Guyana', 'GY', 'GUY', 'America', '67.96');
INSERT INTO public.europe_data_import VALUES (4217, '30/11/2020', '2020-48', '243', '7', '782775', 'Guyana', 'GY', 'GUY', 'America', '70.65');
INSERT INTO public.europe_data_import VALUES (4218, '23/11/2020', '2020-47', '310', '4', '782775', 'Guyana', 'GY', 'GUY', 'America', '79.08');
INSERT INTO public.europe_data_import VALUES (4219, '16/11/2020', '2020-46', '309', '5', '782775', 'Guyana', 'GY', 'GUY', 'America', '78.57');
INSERT INTO public.europe_data_import VALUES (4220, '09/11/2020', '2020-45', '306', '8', '782775', 'Guyana', 'GY', 'GUY', 'America', '62.73');
INSERT INTO public.europe_data_import VALUES (4221, '02/11/2020', '2020-44', '185', '7', '782775', 'Guyana', 'GY', 'GUY', 'America', '60.55');
INSERT INTO public.europe_data_import VALUES (4222, '26/10/2020', '2020-43', '289', '10', '782775', 'Guyana', 'GY', 'GUY', 'America', '70.77');
INSERT INTO public.europe_data_import VALUES (4223, '19/10/2020', '2020-42', '265', '6', '782775', 'Guyana', 'GY', 'GUY', 'America', '81.89');
INSERT INTO public.europe_data_import VALUES (4224, '12/10/2020', '2020-41', '376', '16', '782775', 'Guyana', 'GY', 'GUY', 'America', '89.04');
INSERT INTO public.europe_data_import VALUES (4225, '05/10/2020', '2020-40', '321', '11', '782775', 'Guyana', 'GY', 'GUY', 'America', '105.27');
INSERT INTO public.europe_data_import VALUES (4226, '28/09/2020', '2020-39', '503', '12', '782775', 'Guyana', 'GY', 'GUY', 'America', '117.4');
INSERT INTO public.europe_data_import VALUES (4227, '21/09/2020', '2020-38', '416', '8', '782775', 'Guyana', 'GY', 'GUY', 'America', '102.33');
INSERT INTO public.europe_data_import VALUES (4228, '14/09/2020', '2020-37', '385', '10', '782775', 'Guyana', 'GY', 'GUY', 'America', '79.08');
INSERT INTO public.europe_data_import VALUES (4229, '07/09/2020', '2020-36', '234', '9', '782775', 'Guyana', 'GY', 'GUY', 'America', '65.54');
INSERT INTO public.europe_data_import VALUES (4230, '31/08/2020', '2020-35', '279', '6', '782775', 'Guyana', 'GY', 'GUY', 'America', '67.07');
INSERT INTO public.europe_data_import VALUES (4231, '24/08/2020', '2020-34', '246', '8', '782775', 'Guyana', 'GY', 'GUY', 'America', '49.44');
INSERT INTO public.europe_data_import VALUES (4232, '17/08/2020', '2020-33', '141', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '30.02');
INSERT INTO public.europe_data_import VALUES (4233, '10/08/2020', '2020-32', '94', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '25.29');
INSERT INTO public.europe_data_import VALUES (4234, '03/08/2020', '2020-31', '104', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '17.63');
INSERT INTO public.europe_data_import VALUES (4235, '27/07/2020', '2020-30', '34', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '9.33');
INSERT INTO public.europe_data_import VALUES (4236, '20/07/2020', '2020-29', '39', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '8.05');
INSERT INTO public.europe_data_import VALUES (4237, '13/07/2020', '2020-28', '24', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '8.56');
INSERT INTO public.europe_data_import VALUES (4238, '06/07/2020', '2020-27', '43', '3', '782775', 'Guyana', 'GY', 'GUY', 'America', '11.37');
INSERT INTO public.europe_data_import VALUES (4239, '29/06/2020', '2020-26', '46', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '9.07');
INSERT INTO public.europe_data_import VALUES (4240, '22/06/2020', '2020-25', '25', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.83');
INSERT INTO public.europe_data_import VALUES (4241, '15/06/2020', '2020-24', '5', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (4242, '08/06/2020', '2020-23', '1', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '2.43');
INSERT INTO public.europe_data_import VALUES (4243, '01/06/2020', '2020-22', '18', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.6');
INSERT INTO public.europe_data_import VALUES (4244, '25/05/2020', '2020-21', '18', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.96');
INSERT INTO public.europe_data_import VALUES (4245, '18/05/2020', '2020-20', '13', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.47');
INSERT INTO public.europe_data_import VALUES (4246, '11/05/2020', '2020-19', '22', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.83');
INSERT INTO public.europe_data_import VALUES (4247, '04/05/2020', '2020-18', '8', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '2.17');
INSERT INTO public.europe_data_import VALUES (4248, '27/04/2020', '2020-17', '9', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.7');
INSERT INTO public.europe_data_import VALUES (4249, '20/04/2020', '2020-16', '20', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.6');
INSERT INTO public.europe_data_import VALUES (4250, '13/04/2020', '2020-15', '16', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.73');
INSERT INTO public.europe_data_import VALUES (4251, '06/04/2020', '2020-14', '21', '3', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.07');
INSERT INTO public.europe_data_import VALUES (4252, '30/03/2020', '2020-13', '3', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '0.51');
INSERT INTO public.europe_data_import VALUES (4253, '23/03/2020', '2020-12', '1', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '0.64');
INSERT INTO public.europe_data_import VALUES (4254, '16/03/2020', '2020-11', '4', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '');
INSERT INTO public.europe_data_import VALUES (4255, '01/02/2021', '2021-04', '304', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.06');
INSERT INTO public.europe_data_import VALUES (4256, '25/01/2021', '2021-03', '379', '3', '11263079', 'Haiti', 'HT', 'HTI', 'America', '9.0');
INSERT INTO public.europe_data_import VALUES (4257, '18/01/2021', '2021-02', '635', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.93');
INSERT INTO public.europe_data_import VALUES (4258, '11/01/2021', '2021-01', '145', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.42');
INSERT INTO public.europe_data_import VALUES (4259, '04/01/2021', '2020-53', '128', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.16');
INSERT INTO public.europe_data_import VALUES (4260, '28/12/2020', '2020-52', '228', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (4261, '21/12/2020', '2020-51', '206', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.56');
INSERT INTO public.europe_data_import VALUES (4262, '14/12/2020', '2020-50', '195', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.67');
INSERT INTO public.europe_data_import VALUES (4263, '07/12/2020', '2020-49', '106', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (4264, '30/11/2020', '2020-48', '50', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.75');
INSERT INTO public.europe_data_import VALUES (4265, '23/11/2020', '2020-47', '35', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (4266, '16/11/2020', '2020-46', '52', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.11');
INSERT INTO public.europe_data_import VALUES (4267, '09/11/2020', '2020-45', '73', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (4268, '02/11/2020', '2020-44', '28', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.15');
INSERT INTO public.europe_data_import VALUES (4269, '26/10/2020', '2020-43', '101', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.28');
INSERT INTO public.europe_data_import VALUES (4270, '19/10/2020', '2020-42', '43', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.94');
INSERT INTO public.europe_data_import VALUES (4271, '12/10/2020', '2020-41', '63', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.41');
INSERT INTO public.europe_data_import VALUES (4272, '05/10/2020', '2020-40', '96', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.78');
INSERT INTO public.europe_data_import VALUES (4273, '28/09/2020', '2020-39', '104', '6', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.04');
INSERT INTO public.europe_data_import VALUES (4274, '21/09/2020', '2020-38', '126', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.3');
INSERT INTO public.europe_data_import VALUES (4275, '14/09/2020', '2020-37', '133', '5', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.52');
INSERT INTO public.europe_data_import VALUES (4276, '07/09/2020', '2020-36', '151', '13', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.47');
INSERT INTO public.europe_data_import VALUES (4277, '31/08/2020', '2020-35', '127', '5', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.93');
INSERT INTO public.europe_data_import VALUES (4278, '24/08/2020', '2020-34', '203', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.98');
INSERT INTO public.europe_data_import VALUES (4279, '17/08/2020', '2020-33', '245', '13', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.58');
INSERT INTO public.europe_data_import VALUES (4280, '10/08/2020', '2020-32', '158', '18', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.83');
INSERT INTO public.europe_data_import VALUES (4281, '03/08/2020', '2020-31', '161', '8', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.76');
INSERT INTO public.europe_data_import VALUES (4282, '27/07/2020', '2020-30', '262', '11', '11263079', 'Haiti', 'HT', 'HTI', 'America', '5.22');
INSERT INTO public.europe_data_import VALUES (4283, '20/07/2020', '2020-29', '326', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.39');
INSERT INTO public.europe_data_import VALUES (4284, '13/07/2020', '2020-28', '394', '26', '11263079', 'Haiti', 'HT', 'HTI', 'America', '7.81');
INSERT INTO public.europe_data_import VALUES (4285, '06/07/2020', '2020-27', '486', '9', '11263079', 'Haiti', 'HT', 'HTI', 'America', '9.96');
INSERT INTO public.europe_data_import VALUES (4286, '29/06/2020', '2020-26', '636', '16', '11263079', 'Haiti', 'HT', 'HTI', 'America', '13.66');
INSERT INTO public.europe_data_import VALUES (4287, '22/06/2020', '2020-25', '902', '15', '11263079', 'Haiti', 'HT', 'HTI', 'America', '16.67');
INSERT INTO public.europe_data_import VALUES (4288, '15/06/2020', '2020-24', '975', '22', '11263079', 'Haiti', 'HT', 'HTI', 'America', '19.4');
INSERT INTO public.europe_data_import VALUES (4289, '08/06/2020', '2020-23', '1210', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '21.1');
INSERT INTO public.europe_data_import VALUES (4290, '01/06/2020', '2020-22', '1166', '17', '11263079', 'Haiti', 'HT', 'HTI', 'America', '14.81');
INSERT INTO public.europe_data_import VALUES (4291, '25/05/2020', '2020-21', '502', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.89');
INSERT INTO public.europe_data_import VALUES (4292, '18/05/2020', '2020-20', '274', '5', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.29');
INSERT INTO public.europe_data_import VALUES (4293, '11/05/2020', '2020-19', '97', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.98');
INSERT INTO public.europe_data_import VALUES (4294, '04/05/2020', '2020-18', '13', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.34');
INSERT INTO public.europe_data_import VALUES (4295, '27/04/2020', '2020-17', '25', '3', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (4296, '20/04/2020', '2020-16', '14', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.23');
INSERT INTO public.europe_data_import VALUES (4297, '13/04/2020', '2020-15', '12', '3', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.16');
INSERT INTO public.europe_data_import VALUES (4298, '06/04/2020', '2020-14', '6', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.17');
INSERT INTO public.europe_data_import VALUES (4299, '30/03/2020', '2020-13', '13', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.13');
INSERT INTO public.europe_data_import VALUES (4300, '23/03/2020', '2020-12', '2', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '');
INSERT INTO public.europe_data_import VALUES (4301, '01/02/2021', '2021-04', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4302, '25/01/2021', '2021-03', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4303, '18/01/2021', '2021-02', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4304, '11/01/2021', '2021-01', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4305, '04/01/2021', '2020-53', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4306, '28/12/2020', '2020-52', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4307, '21/12/2020', '2020-51', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4308, '14/12/2020', '2020-50', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4309, '07/12/2020', '2020-49', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4310, '30/11/2020', '2020-48', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4311, '23/11/2020', '2020-47', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4312, '16/11/2020', '2020-46', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4313, '09/11/2020', '2020-45', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4314, '02/11/2020', '2020-44', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4315, '26/10/2020', '2020-43', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '1717.79');
INSERT INTO public.europe_data_import VALUES (4316, '19/10/2020', '2020-42', '14', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '1717.79');
INSERT INTO public.europe_data_import VALUES (4317, '12/10/2020', '2020-41', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4318, '05/10/2020', '2020-40', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4319, '28/09/2020', '2020-39', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4320, '21/09/2020', '2020-38', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4321, '14/09/2020', '2020-37', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4322, '07/09/2020', '2020-36', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4323, '31/08/2020', '2020-35', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4324, '24/08/2020', '2020-34', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4325, '17/08/2020', '2020-33', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4326, '10/08/2020', '2020-32', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4327, '03/08/2020', '2020-31', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4328, '27/07/2020', '2020-30', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4329, '20/07/2020', '2020-29', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4330, '13/07/2020', '2020-28', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4331, '06/07/2020', '2020-27', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4332, '29/06/2020', '2020-26', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4333, '22/06/2020', '2020-25', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4334, '15/06/2020', '2020-24', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4335, '08/06/2020', '2020-23', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4336, '01/06/2020', '2020-22', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4337, '25/05/2020', '2020-21', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4338, '18/05/2020', '2020-20', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4339, '11/05/2020', '2020-19', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '368.1');
INSERT INTO public.europe_data_import VALUES (4340, '04/05/2020', '2020-18', '2', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '368.1');
INSERT INTO public.europe_data_import VALUES (4341, '27/04/2020', '2020-17', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4342, '20/04/2020', '2020-16', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4343, '13/04/2020', '2020-15', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '245.4');
INSERT INTO public.europe_data_import VALUES (4344, '06/04/2020', '2020-14', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '736.2');
INSERT INTO public.europe_data_import VALUES (4345, '30/03/2020', '2020-13', '5', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '613.5');
INSERT INTO public.europe_data_import VALUES (4346, '23/03/2020', '2020-12', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4347, '16/03/2020', '2020-11', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4348, '01/02/2021', '2021-04', '5859', '148', '9746115', 'Honduras', 'HN', 'HND', 'America', '140.9');
INSERT INTO public.europe_data_import VALUES (4349, '25/01/2021', '2021-03', '7873', '108', '9746115', 'Honduras', 'HN', 'HND', 'America', '144.05');
INSERT INTO public.europe_data_import VALUES (4350, '18/01/2021', '2021-02', '6166', '81', '9746115', 'Honduras', 'HN', 'HND', 'America', '110.22');
INSERT INTO public.europe_data_import VALUES (4351, '11/01/2021', '2021-01', '4576', '93', '9746115', 'Honduras', 'HN', 'HND', 'America', '80.46');
INSERT INTO public.europe_data_import VALUES (4352, '04/01/2021', '2020-53', '3266', '92', '9746115', 'Honduras', 'HN', 'HND', 'America', '65.12');
INSERT INTO public.europe_data_import VALUES (4353, '28/12/2020', '2020-52', '3081', '61', '9746115', 'Honduras', 'HN', 'HND', 'America', '58.94');
INSERT INTO public.europe_data_import VALUES (4354, '21/12/2020', '2020-51', '2663', '52', '9746115', 'Honduras', 'HN', 'HND', 'America', '61.55');
INSERT INTO public.europe_data_import VALUES (4355, '14/12/2020', '2020-50', '3336', '29', '9746115', 'Honduras', 'HN', 'HND', 'America', '66.4');
INSERT INTO public.europe_data_import VALUES (4356, '07/12/2020', '2020-49', '3135', '37', '9746115', 'Honduras', 'HN', 'HND', 'America', '67.6');
INSERT INTO public.europe_data_import VALUES (4357, '30/11/2020', '2020-48', '3453', '52', '9746115', 'Honduras', 'HN', 'HND', 'America', '49.11');
INSERT INTO public.europe_data_import VALUES (4358, '23/11/2020', '2020-47', '1333', '34', '9746115', 'Honduras', 'HN', 'HND', 'America', '40.29');
INSERT INTO public.europe_data_import VALUES (4359, '16/11/2020', '2020-46', '2594', '72', '9746115', 'Honduras', 'HN', 'HND', 'America', '50.17');
INSERT INTO public.europe_data_import VALUES (4360, '09/11/2020', '2020-45', '2296', '76', '9746115', 'Honduras', 'HN', 'HND', 'America', '74.84');
INSERT INTO public.europe_data_import VALUES (4361, '02/11/2020', '2020-44', '4998', '52', '9746115', 'Honduras', 'HN', 'HND', 'America', '100.42');
INSERT INTO public.europe_data_import VALUES (4362, '26/10/2020', '2020-43', '4789', '55', '9746115', 'Honduras', 'HN', 'HND', 'America', '93.71');
INSERT INTO public.europe_data_import VALUES (4363, '19/10/2020', '2020-42', '4344', '56', '9746115', 'Honduras', 'HN', 'HND', 'America', '90.25');
INSERT INTO public.europe_data_import VALUES (4364, '12/10/2020', '2020-41', '4452', '90', '9746115', 'Honduras', 'HN', 'HND', 'America', '92.06');
INSERT INTO public.europe_data_import VALUES (4365, '05/10/2020', '2020-40', '4520', '133', '9746115', 'Honduras', 'HN', 'HND', 'America', '82.22');
INSERT INTO public.europe_data_import VALUES (4366, '28/09/2020', '2020-39', '3493', '105', '9746115', 'Honduras', 'HN', 'HND', 'America', '75.11');
INSERT INTO public.europe_data_import VALUES (4367, '21/09/2020', '2020-38', '3827', '105', '9746115', 'Honduras', 'HN', 'HND', 'America', '70.3');
INSERT INTO public.europe_data_import VALUES (4368, '14/09/2020', '2020-37', '3025', '72', '9746115', 'Honduras', 'HN', 'HND', 'America', '78.13');
INSERT INTO public.europe_data_import VALUES (4369, '07/09/2020', '2020-36', '4590', '149', '9746115', 'Honduras', 'HN', 'HND', 'America', '105.2');
INSERT INTO public.europe_data_import VALUES (4370, '31/08/2020', '2020-35', '5663', '204', '9746115', 'Honduras', 'HN', 'HND', 'America', '99.24');
INSERT INTO public.europe_data_import VALUES (4371, '24/08/2020', '2020-34', '4009', '79', '9746115', 'Honduras', 'HN', 'HND', 'America', '72.41');
INSERT INTO public.europe_data_import VALUES (4372, '17/08/2020', '2020-33', '3048', '80', '9746115', 'Honduras', 'HN', 'HND', 'America', '74.95');
INSERT INTO public.europe_data_import VALUES (4373, '10/08/2020', '2020-32', '4257', '118', '9746115', 'Honduras', 'HN', 'HND', 'America', '83.91');
INSERT INTO public.europe_data_import VALUES (4374, '03/08/2020', '2020-31', '3921', '261', '9746115', 'Honduras', 'HN', 'HND', 'America', '96.06');
INSERT INTO public.europe_data_import VALUES (4375, '27/07/2020', '2020-30', '5441', '216', '9746115', 'Honduras', 'HN', 'HND', 'America', '114.77');
INSERT INTO public.europe_data_import VALUES (4376, '20/07/2020', '2020-29', '5745', '126', '9746115', 'Honduras', 'HN', 'HND', 'America', '101.5');
INSERT INTO public.europe_data_import VALUES (4377, '13/07/2020', '2020-28', '4147', '135', '9746115', 'Honduras', 'HN', 'HND', 'America', '102.69');
INSERT INTO public.europe_data_import VALUES (4378, '06/07/2020', '2020-27', '5861', '160', '9746115', 'Honduras', 'HN', 'HND', 'America', '114.65');
INSERT INTO public.europe_data_import VALUES (4379, '29/06/2020', '2020-26', '5313', '116', '9746115', 'Honduras', 'HN', 'HND', 'America', '94.64');
INSERT INTO public.europe_data_import VALUES (4380, '22/06/2020', '2020-25', '3911', '51', '9746115', 'Honduras', 'HN', 'HND', 'America', '66.1');
INSERT INTO public.europe_data_import VALUES (4381, '15/06/2020', '2020-24', '2531', '54', '9746115', 'Honduras', 'HN', 'HND', 'America', '37.51');
INSERT INTO public.europe_data_import VALUES (4382, '08/06/2020', '2020-23', '1125', '46', '9746115', 'Honduras', 'HN', 'HND', 'America', '24.39');
INSERT INTO public.europe_data_import VALUES (4383, '01/06/2020', '2020-22', '1252', '32', '9746115', 'Honduras', 'HN', 'HND', 'America', '26.23');
INSERT INTO public.europe_data_import VALUES (4384, '25/05/2020', '2020-21', '1304', '38', '9746115', 'Honduras', 'HN', 'HND', 'America', '20.3');
INSERT INTO public.europe_data_import VALUES (4385, '18/05/2020', '2020-20', '674', '34', '9746115', 'Honduras', 'HN', 'HND', 'America', '16.32');
INSERT INTO public.europe_data_import VALUES (4386, '11/05/2020', '2020-19', '917', '26', '9746115', 'Honduras', 'HN', 'HND', 'America', '13.45');
INSERT INTO public.europe_data_import VALUES (4387, '04/05/2020', '2020-18', '394', '21', '9746115', 'Honduras', 'HN', 'HND', 'America', '5.93');
INSERT INTO public.europe_data_import VALUES (4388, '27/04/2020', '2020-17', '184', '15', '9746115', 'Honduras', 'HN', 'HND', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (4389, '20/04/2020', '2020-16', '80', '21', '9746115', 'Honduras', 'HN', 'HND', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (4390, '13/04/2020', '2020-15', '99', '3', '9746115', 'Honduras', 'HN', 'HND', 'America', '2.65');
INSERT INTO public.europe_data_import VALUES (4391, '06/04/2020', '2020-14', '159', '19', '9746115', 'Honduras', 'HN', 'HND', 'America', '2.78');
INSERT INTO public.europe_data_import VALUES (4392, '30/03/2020', '2020-13', '112', '3', '9746115', 'Honduras', 'HN', 'HND', 'America', '1.36');
INSERT INTO public.europe_data_import VALUES (4393, '23/03/2020', '2020-12', '21', '0', '9746115', 'Honduras', 'HN', 'HND', 'America', '0.28');
INSERT INTO public.europe_data_import VALUES (4394, '16/03/2020', '2020-11', '6', '0', '9746115', 'Honduras', 'HN', 'HND', 'America', '');
INSERT INTO public.europe_data_import VALUES (4395, '01/02/2021', '2021-04', '8292', '554', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '163.79');
INSERT INTO public.europe_data_import VALUES (4396, '25/01/2021', '2021-03', '7715', '615', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '171.52');
INSERT INTO public.europe_data_import VALUES (4397, '18/01/2021', '2021-02', '9047', '684', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '244.07');
INSERT INTO public.europe_data_import VALUES (4398, '11/01/2021', '2021-01', '14805', '748', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '276.15');
INSERT INTO public.europe_data_import VALUES (4399, '04/01/2021', '2020-53', '12182', '816', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '242.73');
INSERT INTO public.europe_data_import VALUES (4400, '28/12/2020', '2020-52', '11539', '879', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '335.62');
INSERT INTO public.europe_data_import VALUES (4401, '21/12/2020', '2020-51', '21260', '1152', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '521.67');
INSERT INTO public.europe_data_import VALUES (4402, '14/12/2020', '2020-50', '29722', '1146', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '683.0');
INSERT INTO public.europe_data_import VALUES (4403, '07/12/2020', '2020-49', '37026', '1161', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '779.68');
INSERT INTO public.europe_data_import VALUES (4404, '30/11/2020', '2020-48', '39170', '932', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '712.86');
INSERT INTO public.europe_data_import VALUES (4405, '23/11/2020', '2020-47', '30496', '701', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '646.43');
INSERT INTO public.europe_data_import VALUES (4406, '16/11/2020', '2020-46', '32678', '697', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '661.8');
INSERT INTO public.europe_data_import VALUES (4407, '09/11/2020', '2020-45', '31998', '604', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '544.52');
INSERT INTO public.europe_data_import VALUES (4408, '02/11/2020', '2020-44', '21217', '417', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '358.26');
INSERT INTO public.europe_data_import VALUES (4409, '26/10/2020', '2020-43', '13795', '299', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '235.2');
INSERT INTO public.europe_data_import VALUES (4410, '19/10/2020', '2020-42', '9191', '205', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '166.67');
INSERT INTO public.europe_data_import VALUES (4411, '12/10/2020', '2020-41', '7097', '135', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '141.83');
INSERT INTO public.europe_data_import VALUES (4412, '05/10/2020', '2020-40', '6764', '84', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '129.07');
INSERT INTO public.europe_data_import VALUES (4413, '28/09/2020', '2020-39', '5850', '63', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '126.95');
INSERT INTO public.europe_data_import VALUES (4414, '21/09/2020', '2020-38', '6557', '49', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '107.23');
INSERT INTO public.europe_data_import VALUES (4415, '14/09/2020', '2020-37', '3922', '13', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '64.96');
INSERT INTO public.europe_data_import VALUES (4416, '07/09/2020', '2020-36', '2426', '10', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '33.07');
INSERT INTO public.europe_data_import VALUES (4417, '31/08/2020', '2020-35', '806', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '10.69');
INSERT INTO public.europe_data_import VALUES (4418, '24/08/2020', '2020-34', '239', '5', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '4.7');
INSERT INTO public.europe_data_import VALUES (4419, '17/08/2020', '2020-33', '220', '6', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '3.9');
INSERT INTO public.europe_data_import VALUES (4420, '10/08/2020', '2020-32', '161', '5', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.54');
INSERT INTO public.europe_data_import VALUES (4421, '03/08/2020', '2020-31', '87', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.07');
INSERT INTO public.europe_data_import VALUES (4422, '27/07/2020', '2020-30', '115', '0', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.19');
INSERT INTO public.europe_data_import VALUES (4423, '20/07/2020', '2020-29', '99', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '1.53');
INSERT INTO public.europe_data_import VALUES (4424, '13/07/2020', '2020-28', '51', '6', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.94');
INSERT INTO public.europe_data_import VALUES (4425, '06/07/2020', '2020-27', '41', '8', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.83');
INSERT INTO public.europe_data_import VALUES (4426, '29/06/2020', '2020-26', '40', '9', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (4427, '22/06/2020', '2020-25', '26', '9', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '1.35');
INSERT INTO public.europe_data_import VALUES (4428, '15/06/2020', '2020-24', '106', '21', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.05');
INSERT INTO public.europe_data_import VALUES (4429, '08/06/2020', '2020-23', '94', '16', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.19');
INSERT INTO public.europe_data_import VALUES (4430, '01/06/2020', '2020-22', '120', '35', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '3.49');
INSERT INTO public.europe_data_import VALUES (4431, '25/05/2020', '2020-21', '221', '29', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '4.83');
INSERT INTO public.europe_data_import VALUES (4432, '18/05/2020', '2020-20', '251', '41', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '5.12');
INSERT INTO public.europe_data_import VALUES (4433, '11/05/2020', '2020-19', '249', '70', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '7.17');
INSERT INTO public.europe_data_import VALUES (4434, '04/05/2020', '2020-18', '452', '71', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '10.75');
INSERT INTO public.europe_data_import VALUES (4435, '27/04/2020', '2020-17', '599', '81', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '11.51');
INSERT INTO public.europe_data_import VALUES (4436, '20/04/2020', '2020-16', '526', '90', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '12.69');
INSERT INTO public.europe_data_import VALUES (4437, '13/04/2020', '2020-15', '714', '71', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '10.35');
INSERT INTO public.europe_data_import VALUES (4438, '06/04/2020', '2020-14', '297', '23', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '5.9');
INSERT INTO public.europe_data_import VALUES (4439, '30/03/2020', '2020-13', '280', '8', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '4.17');
INSERT INTO public.europe_data_import VALUES (4440, '23/03/2020', '2020-12', '128', '6', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '1.63');
INSERT INTO public.europe_data_import VALUES (4441, '16/03/2020', '2020-11', '31', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.4');
INSERT INTO public.europe_data_import VALUES (4442, '09/03/2020', '2020-10', '8', '0', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4443, '01/02/2021', '2021-04', '19', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '10.92');
INSERT INTO public.europe_data_import VALUES (4444, '25/01/2021', '2021-03', '20', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '25.77');
INSERT INTO public.europe_data_import VALUES (4445, '18/01/2021', '2021-02', '72', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '60.51');
INSERT INTO public.europe_data_import VALUES (4446, '11/01/2021', '2021-01', '144', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '48.18');
INSERT INTO public.europe_data_import VALUES (4447, '04/01/2021', '2020-53', '28', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '31.37');
INSERT INTO public.europe_data_import VALUES (4448, '28/12/2020', '2020-52', '84', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '47.34');
INSERT INTO public.europe_data_import VALUES (4449, '21/12/2020', '2020-51', '85', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '44.82');
INSERT INTO public.europe_data_import VALUES (4450, '14/12/2020', '2020-50', '75', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '49.3');
INSERT INTO public.europe_data_import VALUES (4451, '07/12/2020', '2020-49', '101', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '57.42');
INSERT INTO public.europe_data_import VALUES (4452, '30/11/2020', '2020-48', '104', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '53.78');
INSERT INTO public.europe_data_import VALUES (4453, '23/11/2020', '2020-47', '88', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '55.74');
INSERT INTO public.europe_data_import VALUES (4454, '16/11/2020', '2020-46', '111', '5', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '83.76');
INSERT INTO public.europe_data_import VALUES (4455, '09/11/2020', '2020-45', '188', '8', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '176.48');
INSERT INTO public.europe_data_import VALUES (4456, '02/11/2020', '2020-44', '442', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '233.9');
INSERT INTO public.europe_data_import VALUES (4457, '26/10/2020', '2020-43', '393', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '258.27');
INSERT INTO public.europe_data_import VALUES (4458, '19/10/2020', '2020-42', '529', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '317.66');
INSERT INTO public.europe_data_import VALUES (4459, '12/10/2020', '2020-41', '605', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '252.95');
INSERT INTO public.europe_data_import VALUES (4460, '05/10/2020', '2020-40', '298', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '161.07');
INSERT INTO public.europe_data_import VALUES (4461, '28/09/2020', '2020-39', '277', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '128.29');
INSERT INTO public.europe_data_import VALUES (4462, '21/09/2020', '2020-38', '181', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '57.42');
INSERT INTO public.europe_data_import VALUES (4463, '14/09/2020', '2020-37', '24', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '16.81');
INSERT INTO public.europe_data_import VALUES (4464, '07/09/2020', '2020-36', '36', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '21.57');
INSERT INTO public.europe_data_import VALUES (4465, '31/08/2020', '2020-35', '41', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '26.33');
INSERT INTO public.europe_data_import VALUES (4466, '24/08/2020', '2020-34', '53', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '29.69');
INSERT INTO public.europe_data_import VALUES (4467, '17/08/2020', '2020-33', '53', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '29.13');
INSERT INTO public.europe_data_import VALUES (4468, '10/08/2020', '2020-32', '51', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '31.09');
INSERT INTO public.europe_data_import VALUES (4469, '03/08/2020', '2020-31', '60', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '19.05');
INSERT INTO public.europe_data_import VALUES (4470, '27/07/2020', '2020-30', '8', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '3.92');
INSERT INTO public.europe_data_import VALUES (4471, '20/07/2020', '2020-29', '6', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '2.52');
INSERT INTO public.europe_data_import VALUES (4472, '13/07/2020', '2020-28', '3', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '3.36');
INSERT INTO public.europe_data_import VALUES (4473, '06/07/2020', '2020-27', '9', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '4.2');
INSERT INTO public.europe_data_import VALUES (4474, '29/06/2020', '2020-26', '6', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '3.08');
INSERT INTO public.europe_data_import VALUES (4475, '22/06/2020', '2020-25', '5', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '2.24');
INSERT INTO public.europe_data_import VALUES (4476, '15/06/2020', '2020-24', '3', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '1.12');
INSERT INTO public.europe_data_import VALUES (4477, '08/06/2020', '2020-23', '1', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4478, '01/06/2020', '2020-22', '2', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '1.12');
INSERT INTO public.europe_data_import VALUES (4479, '25/05/2020', '2020-21', '2', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4480, '18/05/2020', '2020-20', '1', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4481, '11/05/2020', '2020-19', '2', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '2.52');
INSERT INTO public.europe_data_import VALUES (4482, '04/05/2020', '2020-18', '7', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '7.84');
INSERT INTO public.europe_data_import VALUES (4483, '27/04/2020', '2020-17', '21', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '25.49');
INSERT INTO public.europe_data_import VALUES (4484, '20/04/2020', '2020-16', '70', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '79.83');
INSERT INTO public.europe_data_import VALUES (4485, '13/04/2020', '2020-15', '215', '4', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '190.76');
INSERT INTO public.europe_data_import VALUES (4486, '06/04/2020', '2020-14', '466', '2', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '257.15');
INSERT INTO public.europe_data_import VALUES (4487, '30/03/2020', '2020-13', '452', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '235.86');
INSERT INTO public.europe_data_import VALUES (4488, '23/03/2020', '2020-12', '390', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '143.7');
INSERT INTO public.europe_data_import VALUES (4489, '16/03/2020', '2020-11', '123', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '49.02');
INSERT INTO public.europe_data_import VALUES (4490, '09/03/2020', '2020-10', '52', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '15.41');
INSERT INTO public.europe_data_import VALUES (4491, '02/03/2020', '2020-09', '3', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4492, '24/02/2020', '2020-08', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4493, '17/02/2020', '2020-07', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4494, '10/02/2020', '2020-06', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4495, '03/02/2020', '2020-05', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4496, '27/01/2020', '2020-04', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4497, '20/01/2020', '2020-03', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4498, '13/01/2020', '2020-02', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4499, '06/01/2020', '2020-01', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4500, '01/02/2021', '2021-04', '89874', '922', '1366417756', 'India', 'IN', 'IND', 'Asia', '13.6');
INSERT INTO public.europe_data_import VALUES (4501, '25/01/2021', '2021-03', '95963', '1051', '1366417756', 'India', 'IN', 'IND', 'Asia', '14.72');
INSERT INTO public.europe_data_import VALUES (4502, '18/01/2021', '2021-02', '105178', '1259', '1366417756', 'India', 'IN', 'IND', 'Asia', '16.93');
INSERT INTO public.europe_data_import VALUES (4503, '11/01/2021', '2021-01', '126126', '1511', '1366417756', 'India', 'IN', 'IND', 'Asia', '18.93');
INSERT INTO public.europe_data_import VALUES (4504, '04/01/2021', '2020-53', '132598', '1748', '1366417756', 'India', 'IN', 'IND', 'Asia', '20.85');
INSERT INTO public.europe_data_import VALUES (4505, '28/12/2020', '2020-52', '152311', '2091', '1366417756', 'India', 'IN', 'IND', 'Asia', '23.69');
INSERT INTO public.europe_data_import VALUES (4506, '21/12/2020', '2020-51', '171460', '2455', '1366417756', 'India', 'IN', 'IND', 'Asia', '27.69');
INSERT INTO public.europe_data_import VALUES (4507, '14/12/2020', '2020-50', '206897', '2782', '1366417756', 'India', 'IN', 'IND', 'Asia', '33.11');
INSERT INTO public.europe_data_import VALUES (4508, '07/12/2020', '2020-49', '245512', '3434', '1366417756', 'India', 'IN', 'IND', 'Asia', '39.32');
INSERT INTO public.europe_data_import VALUES (4509, '30/11/2020', '2020-48', '291826', '3401', '1366417756', 'India', 'IN', 'IND', 'Asia', '42.93');
INSERT INTO public.europe_data_import VALUES (4510, '23/11/2020', '2020-47', '294738', '3668', '1366417756', 'India', 'IN', 'IND', 'Asia', '42.9');
INSERT INTO public.europe_data_import VALUES (4511, '16/11/2020', '2020-46', '291470', '3459', '1366417756', 'India', 'IN', 'IND', 'Asia', '45.07');
INSERT INTO public.europe_data_import VALUES (4512, '09/11/2020', '2020-45', '324344', '4004', '1366417756', 'India', 'IN', 'IND', 'Asia', '47.11');
INSERT INTO public.europe_data_import VALUES (4513, '02/11/2020', '2020-44', '319354', '3593', '1366417756', 'India', 'IN', 'IND', 'Asia', '49.69');
INSERT INTO public.europe_data_import VALUES (4514, '26/10/2020', '2020-43', '359686', '4404', '1366417756', 'India', 'IN', 'IND', 'Asia', '57.77');
INSERT INTO public.europe_data_import VALUES (4515, '19/10/2020', '2020-42', '429735', '5460', '1366417756', 'India', 'IN', 'IND', 'Asia', '67.8');
INSERT INTO public.europe_data_import VALUES (4516, '12/10/2020', '2020-41', '496723', '6465', '1366417756', 'India', 'IN', 'IND', 'Asia', '76.54');
INSERT INTO public.europe_data_import VALUES (4517, '05/10/2020', '2020-40', '549113', '7143', '1366417756', 'India', 'IN', 'IND', 'Asia', '83.15');
INSERT INTO public.europe_data_import VALUES (4518, '28/09/2020', '2020-39', '587122', '7660', '1366417756', 'India', 'IN', 'IND', 'Asia', '89.89');
INSERT INTO public.europe_data_import VALUES (4519, '21/09/2020', '2020-38', '641153', '8160', '1366417756', 'India', 'IN', 'IND', 'Asia', '93.89');
INSERT INTO public.europe_data_import VALUES (4520, '14/09/2020', '2020-37', '641814', '8080', '1366417756', 'India', 'IN', 'IND', 'Asia', '89.66');
INSERT INTO public.europe_data_import VALUES (4521, '07/09/2020', '2020-36', '583368', '7173', '1366417756', 'India', 'IN', 'IND', 'Asia', '80.38');
INSERT INTO public.europe_data_import VALUES (4522, '31/08/2020', '2020-35', '514897', '6927', '1366417756', 'India', 'IN', 'IND', 'Asia', '71.25');
INSERT INTO public.europe_data_import VALUES (4523, '24/08/2020', '2020-34', '458685', '6621', '1366417756', 'India', 'IN', 'IND', 'Asia', '65.23');
INSERT INTO public.europe_data_import VALUES (4524, '17/08/2020', '2020-33', '432589', '6535', '1366417756', 'India', 'IN', 'IND', 'Asia', '61.77');
INSERT INTO public.europe_data_import VALUES (4525, '10/08/2020', '2020-32', '411379', '6251', '1366417756', 'India', 'IN', 'IND', 'Asia', '57.06');
INSERT INTO public.europe_data_import VALUES (4526, '03/08/2020', '2020-31', '368242', '5364', '1366417756', 'India', 'IN', 'IND', 'Asia', '50.18');
INSERT INTO public.europe_data_import VALUES (4527, '27/07/2020', '2020-30', '317410', '5274', '1366417756', 'India', 'IN', 'IND', 'Asia', '40.78');
INSERT INTO public.europe_data_import VALUES (4528, '20/07/2020', '2020-29', '239789', '4323', '1366417756', 'India', 'IN', 'IND', 'Asia', '30.78');
INSERT INTO public.europe_data_import VALUES (4529, '13/07/2020', '2020-28', '180841', '3481', '1366417756', 'India', 'IN', 'IND', 'Asia', '24.15');
INSERT INTO public.europe_data_import VALUES (4530, '06/07/2020', '2020-27', '149095', '3218', '1366417756', 'India', 'IN', 'IND', 'Asia', '19.92');
INSERT INTO public.europe_data_import VALUES (4531, '29/06/2020', '2020-26', '123036', '2776', '1366417756', 'India', 'IN', 'IND', 'Asia', '15.8');
INSERT INTO public.europe_data_import VALUES (4532, '22/06/2020', '2020-25', '92858', '4179', '1366417756', 'India', 'IN', 'IND', 'Asia', '12.34');
INSERT INTO public.europe_data_import VALUES (4533, '15/06/2020', '2020-24', '75813', '2385', '1366417756', 'India', 'IN', 'IND', 'Asia', '10.38');
INSERT INTO public.europe_data_import VALUES (4534, '08/06/2020', '2020-23', '66076', '1741', '1366417756', 'India', 'IN', 'IND', 'Asia', '8.62');
INSERT INTO public.europe_data_import VALUES (4535, '01/06/2020', '2020-22', '51690', '1373', '1366417756', 'India', 'IN', 'IND', 'Asia', '6.91');
INSERT INTO public.europe_data_import VALUES (4536, '25/05/2020', '2020-21', '42676', '992', '1366417756', 'India', 'IN', 'IND', 'Asia', '5.25');
INSERT INTO public.europe_data_import VALUES (4537, '18/05/2020', '2020-20', '29017', '823', '1366417756', 'India', 'IN', 'IND', 'Asia', '3.93');
INSERT INTO public.europe_data_import VALUES (4538, '11/05/2020', '2020-19', '24619', '833', '1366417756', 'India', 'IN', 'IND', 'Asia', '2.87');
INSERT INTO public.europe_data_import VALUES (4539, '04/05/2020', '2020-18', '14641', '501', '1366417756', 'India', 'IN', 'IND', 'Asia', '1.85');
INSERT INTO public.europe_data_import VALUES (4540, '27/04/2020', '2020-17', '10627', '329', '1366417756', 'India', 'IN', 'IND', 'Asia', '1.37');
INSERT INTO public.europe_data_import VALUES (4541, '20/04/2020', '2020-16', '8113', '235', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.97');
INSERT INTO public.europe_data_import VALUES (4542, '13/04/2020', '2020-15', '5085', '199', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (4543, '06/04/2020', '2020-14', '2996', '80', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (4544, '30/03/2020', '2020-13', '632', '22', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (4545, '23/03/2020', '2020-12', '346', '5', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (4546, '16/03/2020', '2020-11', '59', '2', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (4547, '09/03/2020', '2020-10', '31', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4548, '02/03/2020', '2020-09', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4549, '24/02/2020', '2020-08', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4550, '17/02/2020', '2020-07', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4551, '10/02/2020', '2020-06', '1', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4552, '03/02/2020', '2020-05', '2', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4553, '27/01/2020', '2020-04', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4554, '20/01/2020', '2020-03', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4555, '13/01/2020', '2020-02', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4556, '06/01/2020', '2020-01', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4557, '01/02/2021', '2021-04', '89052', '2163', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '62.96');
INSERT INTO public.europe_data_import VALUES (4558, '25/01/2021', '2021-03', '81333', '1848', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '59.58');
INSERT INTO public.europe_data_import VALUES (4559, '18/01/2021', '2021-02', '79903', '1858', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '55.23');
INSERT INTO public.europe_data_import VALUES (4560, '11/01/2021', '2021-01', '69553', '1574', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '42.37');
INSERT INTO public.europe_data_import VALUES (4561, '04/01/2021', '2020-53', '45108', '1318', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '34.57');
INSERT INTO public.europe_data_import VALUES (4562, '28/12/2020', '2020-52', '48435', '1357', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '35.31');
INSERT INTO public.europe_data_import VALUES (4563, '21/12/2020', '2020-51', '47110', '1061', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '32.94');
INSERT INTO public.europe_data_import VALUES (4564, '14/12/2020', '2020-50', '42024', '1079', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '30.87');
INSERT INTO public.europe_data_import VALUES (4565, '07/12/2020', '2020-49', '41530', '925', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '28.87');
INSERT INTO public.europe_data_import VALUES (4566, '30/11/2020', '2020-48', '36598', '931', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '24.81');
INSERT INTO public.europe_data_import VALUES (4567, '23/11/2020', '2020-47', '30555', '673', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '22.15');
INSERT INTO public.europe_data_import VALUES (4568, '16/11/2020', '2020-46', '29397', '597', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '20.08');
INSERT INTO public.europe_data_import VALUES (4569, '09/11/2020', '2020-45', '24932', '671', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '17.74');
INSERT INTO public.europe_data_import VALUES (4570, '02/11/2020', '2020-44', '23072', '644', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '18.81');
INSERT INTO public.europe_data_import VALUES (4571, '26/10/2020', '2020-43', '27845', '788', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '20.79');
INSERT INTO public.europe_data_import VALUES (4572, '19/10/2020', '2020-42', '28418', '667', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.57');
INSERT INTO public.europe_data_import VALUES (4573, '12/10/2020', '2020-41', '29951', '693', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.52');
INSERT INTO public.europe_data_import VALUES (4574, '05/10/2020', '2020-40', '28285', '765', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.74');
INSERT INTO public.europe_data_import VALUES (4575, '28/09/2020', '2020-39', '30537', '833', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.0');
INSERT INTO public.europe_data_import VALUES (4576, '21/09/2020', '2020-38', '26294', '830', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '18.69');
INSERT INTO public.europe_data_import VALUES (4577, '14/09/2020', '2020-37', '24273', '698', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '17.12');
INSERT INTO public.europe_data_import VALUES (4578, '07/09/2020', '2020-36', '22056', '682', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '14.99');
INSERT INTO public.europe_data_import VALUES (4579, '31/08/2020', '2020-35', '18518', '663', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '12.01');
INSERT INTO public.europe_data_import VALUES (4580, '24/08/2020', '2020-34', '13986', '530', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '10.4');
INSERT INTO public.europe_data_import VALUES (4581, '17/08/2020', '2020-33', '14153', '427', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '10.38');
INSERT INTO public.europe_data_import VALUES (4582, '10/08/2020', '2020-32', '13941', '487', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '9.84');
INSERT INTO public.europe_data_import VALUES (4583, '03/08/2020', '2020-31', '12677', '455', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '9.21');
INSERT INTO public.europe_data_import VALUES (4584, '27/07/2020', '2020-30', '12257', '638', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '8.53');
INSERT INTO public.europe_data_import VALUES (4585, '20/07/2020', '2020-29', '10822', '537', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '8.41');
INSERT INTO public.europe_data_import VALUES (4586, '13/07/2020', '2020-28', '11950', '435', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '8.01');
INSERT INTO public.europe_data_import VALUES (4587, '06/07/2020', '2020-27', '9739', '417', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '6.6');
INSERT INTO public.europe_data_import VALUES (4588, '29/06/2020', '2020-26', '8119', '289', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '5.81');
INSERT INTO public.europe_data_import VALUES (4589, '22/06/2020', '2020-25', '7614', '331', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '5.43');
INSERT INTO public.europe_data_import VALUES (4590, '15/06/2020', '2020-24', '7091', '283', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '4.36');
INSERT INTO public.europe_data_import VALUES (4591, '08/06/2020', '2020-23', '4713', '238', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '3.29');
INSERT INTO public.europe_data_import VALUES (4592, '01/06/2020', '2020-22', '4202', '241', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '3.31');
INSERT INTO public.europe_data_import VALUES (4593, '25/05/2020', '2020-21', '4757', '224', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '3.04');
INSERT INTO public.europe_data_import VALUES (4594, '18/05/2020', '2020-20', '3482', '175', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '2.34');
INSERT INTO public.europe_data_import VALUES (4595, '11/05/2020', '2020-19', '2840', '128', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.9');
INSERT INTO public.europe_data_import VALUES (4596, '04/05/2020', '2020-18', '2310', '102', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (4597, '27/04/2020', '2020-17', '2307', '161', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (4598, '20/04/2020', '2020-16', '2334', '209', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.59');
INSERT INTO public.europe_data_import VALUES (4599, '13/04/2020', '2020-15', '1968', '175', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.09');
INSERT INTO public.europe_data_import VALUES (4600, '06/04/2020', '2020-14', '988', '84', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.65');
INSERT INTO public.europe_data_import VALUES (4601, '30/03/2020', '2020-13', '771', '66', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.43');
INSERT INTO public.europe_data_import VALUES (4602, '23/03/2020', '2020-12', '397', '43', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (4603, '16/03/2020', '2020-11', '111', '5', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (4604, '09/03/2020', '2020-10', '4', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4605, '02/03/2020', '2020-09', '2', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4606, '24/02/2020', '2020-08', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4607, '17/02/2020', '2020-07', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4608, '10/02/2020', '2020-06', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4609, '03/02/2020', '2020-05', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4610, '27/01/2020', '2020-04', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4611, '20/01/2020', '2020-03', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4612, '13/01/2020', '2020-02', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4613, '06/01/2020', '2020-01', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4614, '01/02/2021', '2021-04', '45022', '576', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '105.64');
INSERT INTO public.europe_data_import VALUES (4615, '25/01/2021', '2021-03', '42566', '580', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '104.41');
INSERT INTO public.europe_data_import VALUES (4616, '18/01/2021', '2021-02', '44005', '632', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '104.9');
INSERT INTO public.europe_data_import VALUES (4617, '11/01/2021', '2021-01', '42972', '631', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '103.65');
INSERT INTO public.europe_data_import VALUES (4618, '04/01/2021', '2020-53', '42969', '847', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '110.19');
INSERT INTO public.europe_data_import VALUES (4619, '28/12/2020', '2020-52', '48393', '1245', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '111.19');
INSERT INTO public.europe_data_import VALUES (4620, '21/12/2020', '2020-51', '43803', '1252', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '134.51');
INSERT INTO public.europe_data_import VALUES (4621, '14/12/2020', '2020-50', '67722', '1886', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '192.39');
INSERT INTO public.europe_data_import VALUES (4622, '07/12/2020', '2020-49', '91798', '2435', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '224.55');
INSERT INTO public.europe_data_import VALUES (4623, '30/11/2020', '2020-48', '94388', '3073', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '225.15');
INSERT INTO public.europe_data_import VALUES (4624, '23/11/2020', '2020-47', '92293', '3309', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '207.29');
INSERT INTO public.europe_data_import VALUES (4625, '16/11/2020', '2020-46', '79582', '3202', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '170.75');
INSERT INTO public.europe_data_import VALUES (4626, '09/11/2020', '2020-45', '61995', '2993', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '137.0');
INSERT INTO public.europe_data_import VALUES (4627, '02/11/2020', '2020-44', '51595', '2682', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '108.68');
INSERT INTO public.europe_data_import VALUES (4628, '26/10/2020', '2020-43', '38516', '2241', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '83.0');
INSERT INTO public.europe_data_import VALUES (4629, '19/10/2020', '2020-42', '30305', '1831', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '70.69');
INSERT INTO public.europe_data_import VALUES (4630, '12/10/2020', '2020-41', '28303', '1587', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '64.68');
INSERT INTO public.europe_data_import VALUES (4631, '05/10/2020', '2020-40', '25324', '1368', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '59.86');
INSERT INTO public.europe_data_import VALUES (4632, '28/09/2020', '2020-39', '24308', '1288', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '53.57');
INSERT INTO public.europe_data_import VALUES (4633, '21/09/2020', '2020-38', '20111', '1144', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.79');
INSERT INTO public.europe_data_import VALUES (4634, '14/09/2020', '2020-37', '15371', '864', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '34.32');
INSERT INTO public.europe_data_import VALUES (4635, '07/09/2020', '2020-36', '13088', '831', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '33.47');
INSERT INTO public.europe_data_import VALUES (4636, '31/08/2020', '2020-35', '14665', '819', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '36.62');
INSERT INTO public.europe_data_import VALUES (4637, '24/08/2020', '2020-34', '15702', '1004', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '38.83');
INSERT INTO public.europe_data_import VALUES (4638, '17/08/2020', '2020-33', '16491', '1212', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.72');
INSERT INTO public.europe_data_import VALUES (4639, '10/08/2020', '2020-32', '17275', '1237', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.86');
INSERT INTO public.europe_data_import VALUES (4640, '03/08/2020', '2020-31', '18265', '1490', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '43.0');
INSERT INTO public.europe_data_import VALUES (4641, '27/07/2020', '2020-30', '17384', '1512', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.85');
INSERT INTO public.europe_data_import VALUES (4642, '20/07/2020', '2020-29', '16485', '1359', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.22');
INSERT INTO public.europe_data_import VALUES (4643, '13/07/2020', '2020-28', '16865', '1258', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '41.77');
INSERT INTO public.europe_data_import VALUES (4644, '06/07/2020', '2020-27', '17769', '1063', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.8');
INSERT INTO public.europe_data_import VALUES (4645, '29/06/2020', '2020-26', '17717', '885', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.5');
INSERT INTO public.europe_data_import VALUES (4646, '22/06/2020', '2020-25', '17525', '786', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.0');
INSERT INTO public.europe_data_import VALUES (4647, '15/06/2020', '2020-24', '15638', '556', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '43.37');
INSERT INTO public.europe_data_import VALUES (4648, '08/06/2020', '2020-23', '20323', '484', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '43.52');
INSERT INTO public.europe_data_import VALUES (4649, '01/06/2020', '2020-22', '15765', '380', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '37.71');
INSERT INTO public.europe_data_import VALUES (4650, '25/05/2020', '2020-21', '15503', '429', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '33.89');
INSERT INTO public.europe_data_import VALUES (4651, '18/05/2020', '2020-20', '12595', '348', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '27.47');
INSERT INTO public.europe_data_import VALUES (4652, '11/05/2020', '2020-19', '10179', '437', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '20.65');
INSERT INTO public.europe_data_import VALUES (4653, '04/05/2020', '2020-18', '6943', '493', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '18.35');
INSERT INTO public.europe_data_import VALUES (4654, '27/04/2020', '2020-17', '8270', '592', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '22.67');
INSERT INTO public.europe_data_import VALUES (4655, '20/04/2020', '2020-16', '10525', '644', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '28.93');
INSERT INTO public.europe_data_import VALUES (4656, '13/04/2020', '2020-15', '13460', '871', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.26');
INSERT INTO public.europe_data_import VALUES (4657, '06/04/2020', '2020-14', '19917', '963', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '44.13');
INSERT INTO public.europe_data_import VALUES (4658, '30/03/2020', '2020-13', '16671', '955', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '29.39');
INSERT INTO public.europe_data_import VALUES (4659, '23/03/2020', '2020-12', '7700', '961', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '18.18');
INSERT INTO public.europe_data_import VALUES (4660, '16/03/2020', '2020-11', '7372', '530', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '15.63');
INSERT INTO public.europe_data_import VALUES (4661, '09/03/2020', '2020-10', '5588', '140', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '7.87');
INSERT INTO public.europe_data_import VALUES (4662, '02/03/2020', '2020-09', '935', '46', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (4663, '24/02/2020', '2020-08', '43', '8', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (4664, '17/02/2020', '2020-07', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4665, '10/02/2020', '2020-06', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4666, '03/02/2020', '2020-05', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4667, '27/01/2020', '2020-04', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4668, '20/01/2020', '2020-03', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4669, '13/01/2020', '2020-02', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4670, '06/01/2020', '2020-01', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4671, '01/02/2021', '2021-04', '5873', '54', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '29.01');
INSERT INTO public.europe_data_import VALUES (4672, '25/01/2021', '2021-03', '5531', '49', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '39.16');
INSERT INTO public.europe_data_import VALUES (4673, '18/01/2021', '2021-02', '9863', '100', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '25.09');
INSERT INTO public.europe_data_import VALUES (4674, '11/01/2021', '2021-01', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '17.23');
INSERT INTO public.europe_data_import VALUES (4675, '04/01/2021', '2020-53', '6772', '64', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '36.18');
INSERT INTO public.europe_data_import VALUES (4676, '28/12/2020', '2020-52', '7452', '83', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '43.15');
INSERT INTO public.europe_data_import VALUES (4677, '21/12/2020', '2020-51', '9511', '118', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '50.74');
INSERT INTO public.europe_data_import VALUES (4678, '14/12/2020', '2020-50', '10434', '147', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '61.56');
INSERT INTO public.europe_data_import VALUES (4679, '07/12/2020', '2020-49', '13765', '208', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '73.47');
INSERT INTO public.europe_data_import VALUES (4680, '30/11/2020', '2020-48', '15114', '266', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '79.58');
INSERT INTO public.europe_data_import VALUES (4681, '23/11/2020', '2020-47', '16169', '288', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '93.54');
INSERT INTO public.europe_data_import VALUES (4682, '16/11/2020', '2020-46', '20603', '343', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '111.59');
INSERT INTO public.europe_data_import VALUES (4683, '09/11/2020', '2020-45', '23261', '361', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '119.16');
INSERT INTO public.europe_data_import VALUES (4684, '02/11/2020', '2020-44', '23581', '343', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '123.77');
INSERT INTO public.europe_data_import VALUES (4685, '26/10/2020', '2020-43', '25073', '369', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '125.61');
INSERT INTO public.europe_data_import VALUES (4686, '19/10/2020', '2020-42', '24304', '402', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '120.82');
INSERT INTO public.europe_data_import VALUES (4687, '12/10/2020', '2020-41', '23189', '453', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '134.52');
INSERT INTO public.europe_data_import VALUES (4688, '05/10/2020', '2020-40', '29691', '409', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '152.9');
INSERT INTO public.europe_data_import VALUES (4689, '28/09/2020', '2020-39', '30415', '435', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '150.45');
INSERT INTO public.europe_data_import VALUES (4690, '21/09/2020', '2020-38', '28726', '541', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '149.24');
INSERT INTO public.europe_data_import VALUES (4691, '14/09/2020', '2020-37', '29939', '502', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '150.43');
INSERT INTO public.europe_data_import VALUES (4692, '07/09/2020', '2020-36', '29193', '553', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '142.53');
INSERT INTO public.europe_data_import VALUES (4693, '31/08/2020', '2020-35', '26836', '531', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '138.0');
INSERT INTO public.europe_data_import VALUES (4694, '24/08/2020', '2020-34', '27410', '568', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '137.95');
INSERT INTO public.europe_data_import VALUES (4695, '17/08/2020', '2020-33', '26816', '468', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '121.55');
INSERT INTO public.europe_data_import VALUES (4696, '10/08/2020', '2020-32', '20964', '524', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '101.97');
INSERT INTO public.europe_data_import VALUES (4697, '03/08/2020', '2020-31', '19119', '506', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '93.16');
INSERT INTO public.europe_data_import VALUES (4698, '27/07/2020', '2020-30', '17502', '581', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '82.74');
INSERT INTO public.europe_data_import VALUES (4699, '20/07/2020', '2020-29', '15024', '631', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '81.53');
INSERT INTO public.europe_data_import VALUES (4700, '13/07/2020', '2020-28', '17027', '677', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '81.67');
INSERT INTO public.europe_data_import VALUES (4701, '06/07/2020', '2020-27', '15077', '717', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '75.33');
INSERT INTO public.europe_data_import VALUES (4702, '29/06/2020', '2020-26', '14534', '656', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '64.09');
INSERT INTO public.europe_data_import VALUES (4703, '22/06/2020', '2020-25', '10659', '493', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '47.07');
INSERT INTO public.europe_data_import VALUES (4704, '15/06/2020', '2020-24', '7843', '261', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '35.03');
INSERT INTO public.europe_data_import VALUES (4705, '08/06/2020', '2020-23', '5927', '141', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '20.09');
INSERT INTO public.europe_data_import VALUES (4706, '01/06/2020', '2020-22', '1970', '45', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '7.72');
INSERT INTO public.europe_data_import VALUES (4707, '25/05/2020', '2020-21', '1065', '37', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '4.33');
INSERT INTO public.europe_data_import VALUES (4708, '18/05/2020', '2020-20', '637', '14', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '2.82');
INSERT INTO public.europe_data_import VALUES (4709, '11/05/2020', '2020-19', '471', '12', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '2.41');
INSERT INTO public.europe_data_import VALUES (4710, '04/05/2020', '2020-18', '476', '10', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.93');
INSERT INTO public.europe_data_import VALUES (4711, '27/04/2020', '2020-17', '281', '5', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.19');
INSERT INTO public.europe_data_import VALUES (4712, '20/04/2020', '2020-16', '187', '6', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.47');
INSERT INTO public.europe_data_import VALUES (4713, '13/04/2020', '2020-15', '391', '15', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '2.05');
INSERT INTO public.europe_data_import VALUES (4714, '06/04/2020', '2020-14', '414', '19', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.85');
INSERT INTO public.europe_data_import VALUES (4715, '30/03/2020', '2020-13', '314', '22', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.08');
INSERT INTO public.europe_data_import VALUES (4716, '23/03/2020', '2020-12', '109', '11', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (4717, '16/03/2020', '2020-11', '63', '3', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (4718, '09/03/2020', '2020-10', '42', '6', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (4719, '02/03/2020', '2020-09', '19', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (4720, '24/02/2020', '2020-08', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4721, '17/02/2020', '2020-07', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4722, '10/02/2020', '2020-06', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4723, '03/02/2020', '2020-05', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4724, '27/01/2020', '2020-04', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4725, '20/01/2020', '2020-03', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4726, '13/01/2020', '2020-02', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4727, '06/01/2020', '2020-01', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4728, '01/02/2021', '2021-04', '8993', '337', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '485.72');
INSERT INTO public.europe_data_import VALUES (4729, '25/01/2021', '2021-03', '14828', '362', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '814.42');
INSERT INTO public.europe_data_import VALUES (4730, '18/01/2021', '2021-02', '25113', '264', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '1444.44');
INSERT INTO public.europe_data_import VALUES (4731, '11/01/2021', '2021-01', '45726', '85', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '1253.69');
INSERT INTO public.europe_data_import VALUES (4732, '04/01/2021', '2020-53', '15758', '55', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '455.63');
INSERT INTO public.europe_data_import VALUES (4733, '28/12/2020', '2020-52', '6587', '46', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '202.76');
INSERT INTO public.europe_data_import VALUES (4734, '21/12/2020', '2020-51', '3357', '34', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '107.99');
INSERT INTO public.europe_data_import VALUES (4735, '14/12/2020', '2020-50', '1939', '27', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '80.42');
INSERT INTO public.europe_data_import VALUES (4736, '07/12/2020', '2020-49', '2005', '45', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '77.18');
INSERT INTO public.europe_data_import VALUES (4737, '30/11/2020', '2020-48', '1780', '30', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '88.45');
INSERT INTO public.europe_data_import VALUES (4738, '23/11/2020', '2020-47', '2558', '43', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '103.32');
INSERT INTO public.europe_data_import VALUES (4739, '16/11/2020', '2020-46', '2509', '32', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '120.32');
INSERT INTO public.europe_data_import VALUES (4740, '09/11/2020', '2020-45', '3392', '32', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '168.55');
INSERT INTO public.europe_data_import VALUES (4741, '02/11/2020', '2020-44', '4874', '33', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '245.5');
INSERT INTO public.europe_data_import VALUES (4742, '26/10/2020', '2020-43', '7166', '30', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '297.7');
INSERT INTO public.europe_data_import VALUES (4743, '19/10/2020', '2020-42', '7434', '26', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '243.26');
INSERT INTO public.europe_data_import VALUES (4744, '12/10/2020', '2020-41', '4496', '16', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '153.7');
INSERT INTO public.europe_data_import VALUES (4745, '05/10/2020', '2020-40', '3042', '8', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '103.97');
INSERT INTO public.europe_data_import VALUES (4746, '28/09/2020', '2020-39', '2057', '10', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '81.66');
INSERT INTO public.europe_data_import VALUES (4747, '21/09/2020', '2020-38', '1948', '8', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '66.49');
INSERT INTO public.europe_data_import VALUES (4748, '14/09/2020', '2020-37', '1313', '7', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '45.37');
INSERT INTO public.europe_data_import VALUES (4749, '07/09/2020', '2020-36', '912', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '34.73');
INSERT INTO public.europe_data_import VALUES (4750, '31/08/2020', '2020-35', '791', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '30.65');
INSERT INTO public.europe_data_import VALUES (4751, '24/08/2020', '2020-34', '712', '3', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '25.63');
INSERT INTO public.europe_data_import VALUES (4752, '17/08/2020', '2020-33', '545', '2', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '22.33');
INSERT INTO public.europe_data_import VALUES (4753, '10/08/2020', '2020-32', '550', '9', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '16.94');
INSERT INTO public.europe_data_import VALUES (4754, '03/08/2020', '2020-31', '281', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '8.2');
INSERT INTO public.europe_data_import VALUES (4755, '27/07/2020', '2020-30', '121', '10', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '5.16');
INSERT INTO public.europe_data_import VALUES (4756, '20/07/2020', '2020-29', '132', '7', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '4.75');
INSERT INTO public.europe_data_import VALUES (4757, '13/07/2020', '2020-28', '101', '5', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.85');
INSERT INTO public.europe_data_import VALUES (4758, '06/07/2020', '2020-27', '88', '6', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (4759, '29/06/2020', '2020-26', '60', '20', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '2.77');
INSERT INTO public.europe_data_import VALUES (4760, '22/06/2020', '2020-25', '76', '9', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.63');
INSERT INTO public.europe_data_import VALUES (4761, '15/06/2020', '2020-24', '102', '27', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '6.38');
INSERT INTO public.europe_data_import VALUES (4762, '08/06/2020', '2020-23', '211', '29', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '11.46');
INSERT INTO public.europe_data_import VALUES (4763, '01/06/2020', '2020-22', '351', '44', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '17.9');
INSERT INTO public.europe_data_import VALUES (4764, '25/05/2020', '2020-21', '527', '63', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '33.5');
INSERT INTO public.europe_data_import VALUES (4765, '18/05/2020', '2020-20', '1116', '85', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '53.14');
INSERT INTO public.europe_data_import VALUES (4766, '11/05/2020', '2020-19', '1490', '155', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '76.14');
INSERT INTO public.europe_data_import VALUES (4767, '04/05/2020', '2020-18', '2244', '216', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '127.54');
INSERT INTO public.europe_data_import VALUES (4768, '27/04/2020', '2020-17', '4011', '477', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '195.89');
INSERT INTO public.europe_data_import VALUES (4769, '20/04/2020', '2020-16', '5596', '276', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '206.76');
INSERT INTO public.europe_data_import VALUES (4770, '13/04/2020', '2020-15', '4544', '176', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '143.55');
INSERT INTO public.europe_data_import VALUES (4771, '06/04/2020', '2020-14', '2496', '112', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '85.74');
INSERT INTO public.europe_data_import VALUES (4772, '30/03/2020', '2020-13', '1709', '42', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '49.88');
INSERT INTO public.europe_data_import VALUES (4773, '23/03/2020', '2020-12', '737', '2', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '18.05');
INSERT INTO public.europe_data_import VALUES (4774, '16/03/2020', '2020-11', '148', '2', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.43');
INSERT INTO public.europe_data_import VALUES (4775, '09/03/2020', '2020-10', '20', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0.43');
INSERT INTO public.europe_data_import VALUES (4776, '02/03/2020', '2020-09', '1', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (4777, '24/02/2020', '2020-08', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4778, '17/02/2020', '2020-07', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4779, '10/02/2020', '2020-06', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4780, '03/02/2020', '2020-05', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4781, '27/01/2020', '2020-04', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4782, '20/01/2020', '2020-03', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4783, '13/01/2020', '2020-02', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4784, '06/01/2020', '2020-01', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4785, '01/02/2021', '2021-04', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4786, '25/01/2021', '2021-03', '4', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '42.56');
INSERT INTO public.europe_data_import VALUES (4787, '18/01/2021', '2021-02', '32', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '56.74');
INSERT INTO public.europe_data_import VALUES (4788, '11/01/2021', '2021-01', '16', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '26.01');
INSERT INTO public.europe_data_import VALUES (4789, '04/01/2021', '2020-53', '6', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '8.28');
INSERT INTO public.europe_data_import VALUES (4790, '28/12/2020', '2020-52', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4791, '21/12/2020', '2020-51', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (4792, '14/12/2020', '2020-50', '3', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '4.73');
INSERT INTO public.europe_data_import VALUES (4793, '07/12/2020', '2020-49', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (4794, '30/11/2020', '2020-48', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4795, '23/11/2020', '2020-47', '5', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '13.0');
INSERT INTO public.europe_data_import VALUES (4796, '16/11/2020', '2020-46', '6', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '11.82');
INSERT INTO public.europe_data_import VALUES (4797, '09/11/2020', '2020-45', '4', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '10.64');
INSERT INTO public.europe_data_import VALUES (4798, '02/11/2020', '2020-44', '5', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '5.91');
INSERT INTO public.europe_data_import VALUES (4799, '26/10/2020', '2020-43', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (4800, '19/10/2020', '2020-42', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4801, '12/10/2020', '2020-41', '4', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4802, '05/10/2020', '2020-40', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (4803, '28/09/2020', '2020-39', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (4804, '21/09/2020', '2020-38', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (4805, '14/09/2020', '2020-37', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4806, '07/09/2020', '2020-36', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4807, '31/08/2020', '2020-35', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4808, '24/08/2020', '2020-34', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4809, '17/08/2020', '2020-33', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4810, '10/08/2020', '2020-32', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4811, '03/08/2020', '2020-31', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4812, '27/07/2020', '2020-30', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4813, '20/07/2020', '2020-29', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4814, '13/07/2020', '2020-28', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4815, '06/07/2020', '2020-27', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4816, '29/06/2020', '2020-26', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4817, '22/06/2020', '2020-25', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4818, '15/06/2020', '2020-24', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4819, '08/06/2020', '2020-23', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4820, '01/06/2020', '2020-22', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4821, '25/05/2020', '2020-21', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4822, '18/05/2020', '2020-20', '5', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '16.55');
INSERT INTO public.europe_data_import VALUES (4823, '11/05/2020', '2020-19', '9', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '26.01');
INSERT INTO public.europe_data_import VALUES (4824, '04/05/2020', '2020-18', '13', '4', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '27.19');
INSERT INTO public.europe_data_import VALUES (4825, '27/04/2020', '2020-17', '10', '12', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '94.57');
INSERT INTO public.europe_data_import VALUES (4826, '20/04/2020', '2020-16', '70', '4', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '202.15');
INSERT INTO public.europe_data_import VALUES (4827, '13/04/2020', '2020-15', '101', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '219.89');
INSERT INTO public.europe_data_import VALUES (4828, '06/04/2020', '2020-14', '85', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '147.77');
INSERT INTO public.europe_data_import VALUES (4829, '30/03/2020', '2020-13', '40', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '49.65');
INSERT INTO public.europe_data_import VALUES (4830, '23/03/2020', '2020-12', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4831, '01/02/2021', '2021-04', '45208', '359', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1110.27');
INSERT INTO public.europe_data_import VALUES (4832, '25/01/2021', '2021-03', '49380', '432', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1244.29');
INSERT INTO public.europe_data_import VALUES (4833, '18/01/2021', '2021-02', '56626', '316', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1285.33');
INSERT INTO public.europe_data_import VALUES (4834, '11/01/2021', '2021-01', '52876', '256', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1069.06');
INSERT INTO public.europe_data_import VALUES (4835, '04/01/2021', '2020-53', '38201', '193', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '772.69');
INSERT INTO public.europe_data_import VALUES (4836, '28/12/2020', '2020-52', '27627', '139', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '541.44');
INSERT INTO public.europe_data_import VALUES (4837, '21/12/2020', '2020-51', '18500', '102', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '365.73');
INSERT INTO public.europe_data_import VALUES (4838, '14/12/2020', '2020-50', '12658', '82', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '256.81');
INSERT INTO public.europe_data_import VALUES (4839, '07/12/2020', '2020-49', '9221', '53', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '185.44');
INSERT INTO public.europe_data_import VALUES (4840, '30/11/2020', '2020-48', '6577', '58', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '139.04');
INSERT INTO public.europe_data_import VALUES (4841, '23/11/2020', '2020-47', '5268', '74', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '115.51');
INSERT INTO public.europe_data_import VALUES (4842, '16/11/2020', '2020-46', '4573', '58', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '105.69');
INSERT INTO public.europe_data_import VALUES (4843, '09/11/2020', '2020-45', '4431', '120', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '110.5');
INSERT INTO public.europe_data_import VALUES (4844, '02/11/2020', '2020-44', '4983', '157', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '132.46');
INSERT INTO public.europe_data_import VALUES (4845, '26/10/2020', '2020-43', '6302', '188', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '215.04');
INSERT INTO public.europe_data_import VALUES (4846, '19/10/2020', '2020-42', '12018', '226', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '418.7');
INSERT INTO public.europe_data_import VALUES (4847, '12/10/2020', '2020-41', '23653', '264', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '713.69');
INSERT INTO public.europe_data_import VALUES (4848, '05/10/2020', '2020-40', '37149', '253', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '936.08');
INSERT INTO public.europe_data_import VALUES (4849, '28/09/2020', '2020-39', '42599', '210', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '873.66');
INSERT INTO public.europe_data_import VALUES (4850, '21/09/2020', '2020-38', '31831', '137', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '678.25');
INSERT INTO public.europe_data_import VALUES (4851, '14/09/2020', '2020-37', '25952', '100', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '499.76');
INSERT INTO public.europe_data_import VALUES (4852, '07/09/2020', '2020-36', '16624', '100', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '322.71');
INSERT INTO public.europe_data_import VALUES (4853, '31/08/2020', '2020-35', '10869', '85', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '250.49');
INSERT INTO public.europe_data_import VALUES (4854, '24/08/2020', '2020-34', '10471', '149', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '236.51');
INSERT INTO public.europe_data_import VALUES (4855, '17/08/2020', '2020-33', '9678', '85', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '230.71');
INSERT INTO public.europe_data_import VALUES (4856, '10/08/2020', '2020-32', '9977', '64', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '247.04');
INSERT INTO public.europe_data_import VALUES (4857, '03/08/2020', '2020-31', '11069', '66', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '266.87');
INSERT INTO public.europe_data_import VALUES (4858, '27/07/2020', '2020-30', '11667', '61', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '273.33');
INSERT INTO public.europe_data_import VALUES (4859, '20/07/2020', '2020-29', '11619', '47', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '238.64');
INSERT INTO public.europe_data_import VALUES (4860, '13/07/2020', '2020-28', '8712', '31', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '175.07');
INSERT INTO public.europe_data_import VALUES (4861, '06/07/2020', '2020-27', '6203', '13', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '107.75');
INSERT INTO public.europe_data_import VALUES (4862, '29/06/2020', '2020-26', '2977', '12', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '54.39');
INSERT INTO public.europe_data_import VALUES (4863, '22/06/2020', '2020-25', '1657', '4', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '33.61');
INSERT INTO public.europe_data_import VALUES (4864, '15/06/2020', '2020-24', '1206', '4', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '24.06');
INSERT INTO public.europe_data_import VALUES (4865, '08/06/2020', '2020-23', '844', '13', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '14.03');
INSERT INTO public.europe_data_import VALUES (4866, '01/06/2020', '2020-22', '351', '5', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '5.33');
INSERT INTO public.europe_data_import VALUES (4867, '25/05/2020', '2020-21', '103', '8', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '2.85');
INSERT INTO public.europe_data_import VALUES (4868, '18/05/2020', '2020-20', '140', '20', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '4.8');
INSERT INTO public.europe_data_import VALUES (4869, '11/05/2020', '2020-19', '269', '20', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '12.67');
INSERT INTO public.europe_data_import VALUES (4870, '04/05/2020', '2020-18', '810', '33', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '31.89');
INSERT INTO public.europe_data_import VALUES (4871, '27/04/2020', '2020-17', '1907', '27', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '49.92');
INSERT INTO public.europe_data_import VALUES (4872, '20/04/2020', '2020-16', '2346', '69', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '59.41');
INSERT INTO public.europe_data_import VALUES (4873, '13/04/2020', '2020-15', '2715', '54', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '80.97');
INSERT INTO public.europe_data_import VALUES (4874, '06/04/2020', '2020-14', '4183', '34', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '86.38');
INSERT INTO public.europe_data_import VALUES (4875, '30/03/2020', '2020-13', '3176', '14', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '46.92');
INSERT INTO public.europe_data_import VALUES (4876, '23/03/2020', '2020-12', '821', '1', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '12.11');
INSERT INTO public.europe_data_import VALUES (4877, '16/03/2020', '2020-11', '211', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '2.82');
INSERT INTO public.europe_data_import VALUES (4878, '09/03/2020', '2020-10', '29', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0.43');
INSERT INTO public.europe_data_import VALUES (4879, '02/03/2020', '2020-09', '8', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (4880, '24/02/2020', '2020-08', '2', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (4881, '17/02/2020', '2020-07', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4882, '10/02/2020', '2020-06', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4883, '03/02/2020', '2020-05', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4884, '27/01/2020', '2020-04', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4885, '20/01/2020', '2020-03', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4886, '13/01/2020', '2020-02', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4887, '06/01/2020', '2020-01', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4888, '01/02/2021', '2021-04', '86219', '3055', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '284.55');
INSERT INTO public.europe_data_import VALUES (4889, '25/01/2021', '2021-03', '85536', '3284', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '315.31');
INSERT INTO public.europe_data_import VALUES (4890, '18/01/2021', '2021-02', '104786', '3422', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '374.14');
INSERT INTO public.europe_data_import VALUES (4891, '11/01/2021', '2021-01', '121045', '3423', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '379.05');
INSERT INTO public.europe_data_import VALUES (4892, '04/01/2021', '2020-53', '107750', '3407', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '335.09');
INSERT INTO public.europe_data_import VALUES (4893, '28/12/2020', '2020-52', '94511', '3126', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '337.95');
INSERT INTO public.europe_data_import VALUES (4894, '21/12/2020', '2020-51', '109473', '4279', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '371.62');
INSERT INTO public.europe_data_import VALUES (4895, '14/12/2020', '2020-50', '114834', '4442', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '428.32');
INSERT INTO public.europe_data_import VALUES (4896, '07/12/2020', '2020-49', '143700', '5174', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '530.17');
INSERT INTO public.europe_data_import VALUES (4897, '30/11/2020', '2020-48', '176310', '5081', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '673.71');
INSERT INTO public.europe_data_import VALUES (4898, '23/11/2020', '2020-47', '230339', '4594', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '784.9');
INSERT INTO public.europe_data_import VALUES (4899, '16/11/2020', '2020-46', '243425', '3835', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '777.33');
INSERT INTO public.europe_data_import VALUES (4900, '09/11/2020', '2020-45', '225769', '2568', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '678.14');
INSERT INTO public.europe_data_import VALUES (4901, '02/11/2020', '2020-44', '183553', '1488', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '488.89');
INSERT INTO public.europe_data_import VALUES (4902, '26/10/2020', '2020-43', '111541', '795', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '283.02');
INSERT INTO public.europe_data_import VALUES (4903, '19/10/2020', '2020-42', '59291', '377', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '147.3');
INSERT INTO public.europe_data_import VALUES (4904, '12/10/2020', '2020-41', '29621', '180', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '74.69');
INSERT INTO public.europe_data_import VALUES (4905, '05/10/2020', '2020-40', '15459', '151', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '45.02');
INSERT INTO public.europe_data_import VALUES (4906, '28/09/2020', '2020-39', '11714', '128', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '36.64');
INSERT INTO public.europe_data_import VALUES (4907, '21/09/2020', '2020-38', '10403', '97', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '34.0');
INSERT INTO public.europe_data_import VALUES (4908, '14/09/2020', '2020-37', '10119', '69', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '32.36');
INSERT INTO public.europe_data_import VALUES (4909, '07/09/2020', '2020-36', '9416', '64', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '30.3');
INSERT INTO public.europe_data_import VALUES (4910, '31/08/2020', '2020-35', '8873', '40', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '23.7');
INSERT INTO public.europe_data_import VALUES (4911, '24/08/2020', '2020-34', '5430', '41', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '14.54');
INSERT INTO public.europe_data_import VALUES (4912, '17/08/2020', '2020-33', '3349', '191', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '9.68');
INSERT INTO public.europe_data_import VALUES (4913, '10/08/2020', '2020-32', '2496', '51', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '7.37');
INSERT INTO public.europe_data_import VALUES (4914, '03/08/2020', '2020-31', '1952', '47', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '6.02');
INSERT INTO public.europe_data_import VALUES (4915, '27/07/2020', '2020-30', '1684', '62', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.06');
INSERT INTO public.europe_data_import VALUES (4916, '20/07/2020', '2020-29', '1373', '91', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '4.68');
INSERT INTO public.europe_data_import VALUES (4917, '13/07/2020', '2020-28', '1450', '93', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '4.56');
INSERT INTO public.europe_data_import VALUES (4918, '06/07/2020', '2020-27', '1301', '123', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.16');
INSERT INTO public.europe_data_import VALUES (4919, '29/06/2020', '2020-26', '1811', '104', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.5');
INSERT INTO public.europe_data_import VALUES (4920, '22/06/2020', '2020-25', '1510', '289', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.8');
INSERT INTO public.europe_data_import VALUES (4921, '15/06/2020', '2020-24', '1991', '446', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '6.58');
INSERT INTO public.europe_data_import VALUES (4922, '08/06/2020', '2020-23', '1979', '484', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '8.52');
INSERT INTO public.europe_data_import VALUES (4923, '01/06/2020', '2020-22', '3161', '630', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '12.56');
INSERT INTO public.europe_data_import VALUES (4924, '25/05/2020', '2020-21', '4423', '877', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '17.87');
INSERT INTO public.europe_data_import VALUES (4925, '18/05/2020', '2020-20', '6365', '1348', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '24.38');
INSERT INTO public.europe_data_import VALUES (4926, '11/05/2020', '2020-19', '8353', '1676', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '35.45');
INSERT INTO public.europe_data_import VALUES (4927, '04/05/2020', '2020-18', '13042', '2240', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '52.59');
INSERT INTO public.europe_data_import VALUES (4928, '27/04/2020', '2020-17', '18703', '2984', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '68.44');
INSERT INTO public.europe_data_import VALUES (4929, '20/04/2020', '2020-16', '22609', '3759', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '82.88');
INSERT INTO public.europe_data_import VALUES (4930, '13/04/2020', '2020-15', '27415', '4012', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '97.21');
INSERT INTO public.europe_data_import VALUES (4931, '06/04/2020', '2020-14', '31259', '5108', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '115.66');
INSERT INTO public.europe_data_import VALUES (4932, '30/03/2020', '2020-13', '38551', '5305', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '122.12');
INSERT INTO public.europe_data_import VALUES (4933, '23/03/2020', '2020-12', '35158', '3665', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '85.76');
INSERT INTO public.europe_data_import VALUES (4934, '16/03/2020', '2020-11', '16605', '1445', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '36.93');
INSERT INTO public.europe_data_import VALUES (4935, '09/03/2020', '2020-10', '5686', '331', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '12.0');
INSERT INTO public.europe_data_import VALUES (4936, '02/03/2020', '2020-09', '1557', '33', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '2.79');
INSERT INTO public.europe_data_import VALUES (4937, '24/02/2020', '2020-08', '129', '2', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0.21');
INSERT INTO public.europe_data_import VALUES (4938, '17/02/2020', '2020-07', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4939, '10/02/2020', '2020-06', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (4940, '03/02/2020', '2020-05', '3', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (4941, '27/01/2020', '2020-04', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4942, '20/01/2020', '2020-03', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4943, '13/01/2020', '2020-02', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4944, '06/01/2020', '2020-01', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4945, '01/02/2021', '2021-04', '766', '14', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '51.01');
INSERT INTO public.europe_data_import VALUES (4946, '25/01/2021', '2021-03', '738', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '46.64');
INSERT INTO public.europe_data_import VALUES (4947, '18/01/2021', '2021-02', '637', '13', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '41.55');
INSERT INTO public.europe_data_import VALUES (4948, '11/01/2021', '2021-01', '588', '9', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '30.7');
INSERT INTO public.europe_data_import VALUES (4949, '04/01/2021', '2020-53', '317', '6', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '25.78');
INSERT INTO public.europe_data_import VALUES (4950, '28/12/2020', '2020-52', '443', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '34.66');
INSERT INTO public.europe_data_import VALUES (4951, '21/12/2020', '2020-51', '579', '13', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '39.65');
INSERT INTO public.europe_data_import VALUES (4952, '14/12/2020', '2020-50', '590', '8', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '33.95');
INSERT INTO public.europe_data_import VALUES (4953, '07/12/2020', '2020-49', '411', '9', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '28.36');
INSERT INTO public.europe_data_import VALUES (4954, '30/11/2020', '2020-48', '425', '18', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '27.98');
INSERT INTO public.europe_data_import VALUES (4955, '23/11/2020', '2020-47', '400', '7', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '26.39');
INSERT INTO public.europe_data_import VALUES (4956, '16/11/2020', '2020-46', '378', '10', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '25.54');
INSERT INTO public.europe_data_import VALUES (4957, '09/11/2020', '2020-45', '375', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '26.86');
INSERT INTO public.europe_data_import VALUES (4958, '02/11/2020', '2020-44', '417', '21', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '29.07');
INSERT INTO public.europe_data_import VALUES (4959, '26/10/2020', '2020-43', '440', '17', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '33.78');
INSERT INTO public.europe_data_import VALUES (4960, '19/10/2020', '2020-42', '556', '32', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '46.77');
INSERT INTO public.europe_data_import VALUES (4961, '12/10/2020', '2020-41', '823', '19', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '58.51');
INSERT INTO public.europe_data_import VALUES (4962, '05/10/2020', '2020-40', '902', '31', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '64.68');
INSERT INTO public.europe_data_import VALUES (4963, '28/09/2020', '2020-39', '1005', '22', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '75.37');
INSERT INTO public.europe_data_import VALUES (4964, '21/09/2020', '2020-38', '1217', '25', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '63.94');
INSERT INTO public.europe_data_import VALUES (4965, '14/09/2020', '2020-37', '668', '9', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '47.96');
INSERT INTO public.europe_data_import VALUES (4966, '07/09/2020', '2020-36', '746', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '53.39');
INSERT INTO public.europe_data_import VALUES (4967, '31/08/2020', '2020-35', '828', '5', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '42.19');
INSERT INTO public.europe_data_import VALUES (4968, '24/08/2020', '2020-34', '416', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '17.16');
INSERT INTO public.europe_data_import VALUES (4969, '17/08/2020', '2020-33', '90', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '7.43');
INSERT INTO public.europe_data_import VALUES (4970, '10/08/2020', '2020-32', '129', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '6.14');
INSERT INTO public.europe_data_import VALUES (4971, '03/08/2020', '2020-31', '52', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (4972, '27/07/2020', '2020-30', '52', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.85');
INSERT INTO public.europe_data_import VALUES (4973, '20/07/2020', '2020-29', '32', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.97');
INSERT INTO public.europe_data_import VALUES (4974, '13/07/2020', '2020-28', '26', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.1');
INSERT INTO public.europe_data_import VALUES (4975, '06/07/2020', '2020-27', '36', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.48');
INSERT INTO public.europe_data_import VALUES (4976, '29/06/2020', '2020-26', '37', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (4977, '22/06/2020', '2020-25', '42', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.07');
INSERT INTO public.europe_data_import VALUES (4978, '15/06/2020', '2020-24', '19', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.05');
INSERT INTO public.europe_data_import VALUES (4979, '08/06/2020', '2020-23', '12', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.56');
INSERT INTO public.europe_data_import VALUES (4980, '01/06/2020', '2020-22', '34', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.24');
INSERT INTO public.europe_data_import VALUES (4981, '25/05/2020', '2020-21', '32', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.7');
INSERT INTO public.europe_data_import VALUES (4982, '18/05/2020', '2020-20', '18', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.73');
INSERT INTO public.europe_data_import VALUES (4983, '11/05/2020', '2020-19', '33', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '5.16');
INSERT INTO public.europe_data_import VALUES (4984, '04/05/2020', '2020-18', '119', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '9.26');
INSERT INTO public.europe_data_import VALUES (4985, '27/04/2020', '2020-17', '154', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '9.43');
INSERT INTO public.europe_data_import VALUES (4986, '20/04/2020', '2020-16', '124', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '4.68');
INSERT INTO public.europe_data_import VALUES (4987, '13/04/2020', '2020-15', '14', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.29');
INSERT INTO public.europe_data_import VALUES (4988, '06/04/2020', '2020-14', '24', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.32');
INSERT INTO public.europe_data_import VALUES (4989, '30/03/2020', '2020-13', '15', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '0.81');
INSERT INTO public.europe_data_import VALUES (4990, '23/03/2020', '2020-12', '9', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '0.64');
INSERT INTO public.europe_data_import VALUES (4991, '16/03/2020', '2020-11', '10', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '');
INSERT INTO public.europe_data_import VALUES (4992, '01/02/2021', '2021-04', '28857', '703', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '48.26');
INSERT INTO public.europe_data_import VALUES (4993, '25/01/2021', '2021-03', '32367', '518', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '58.26');
INSERT INTO public.europe_data_import VALUES (4994, '18/01/2021', '2021-02', '41542', '457', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '66.57');
INSERT INTO public.europe_data_import VALUES (4995, '11/01/2021', '2021-01', '42905', '445', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '52.43');
INSERT INTO public.europe_data_import VALUES (4996, '04/01/2021', '2020-53', '23611', '347', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '35.73');
INSERT INTO public.europe_data_import VALUES (4997, '28/12/2020', '2020-52', '21713', '352', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '31.99');
INSERT INTO public.europe_data_import VALUES (4998, '21/12/2020', '2020-51', '18870', '315', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '28.74');
INSERT INTO public.europe_data_import VALUES (4999, '14/12/2020', '2020-50', '17586', '250', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '25.93');
INSERT INTO public.europe_data_import VALUES (5000, '07/12/2020', '2020-49', '15307', '216', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '24.55');
INSERT INTO public.europe_data_import VALUES (5001, '30/11/2020', '2020-48', '15843', '139', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '23.71');
INSERT INTO public.europe_data_import VALUES (5002, '23/11/2020', '2020-47', '14240', '97', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '18.0');
INSERT INTO public.europe_data_import VALUES (5003, '16/11/2020', '2020-46', '8593', '65', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '11.72');
INSERT INTO public.europe_data_import VALUES (5004, '09/11/2020', '2020-45', '6271', '44', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '8.68');
INSERT INTO public.europe_data_import VALUES (5005, '02/11/2020', '2020-44', '4739', '56', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.85');
INSERT INTO public.europe_data_import VALUES (5006, '26/10/2020', '2020-43', '3947', '44', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.09');
INSERT INTO public.europe_data_import VALUES (5007, '19/10/2020', '2020-42', '3780', '45', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.82');
INSERT INTO public.europe_data_import VALUES (5008, '12/10/2020', '2020-41', '3608', '30', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.69');
INSERT INTO public.europe_data_import VALUES (5009, '05/10/2020', '2020-40', '3608', '51', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.58');
INSERT INTO public.europe_data_import VALUES (5010, '28/09/2020', '2020-39', '3474', '48', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.1');
INSERT INTO public.europe_data_import VALUES (5011, '21/09/2020', '2020-38', '3000', '58', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.36');
INSERT INTO public.europe_data_import VALUES (5012, '14/09/2020', '2020-37', '3801', '79', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.14');
INSERT INTO public.europe_data_import VALUES (5013, '07/09/2020', '2020-36', '3991', '84', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '7.96');
INSERT INTO public.europe_data_import VALUES (5014, '31/08/2020', '2020-35', '6111', '99', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '10.18');
INSERT INTO public.europe_data_import VALUES (5015, '24/08/2020', '2020-34', '6802', '82', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '10.85');
INSERT INTO public.europe_data_import VALUES (5016, '17/08/2020', '2020-33', '6962', '51', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '13.31');
INSERT INTO public.europe_data_import VALUES (5017, '10/08/2020', '2020-32', '9918', '36', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '14.19');
INSERT INTO public.europe_data_import VALUES (5018, '03/08/2020', '2020-31', '8083', '15', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '10.23');
INSERT INTO public.europe_data_import VALUES (5019, '27/07/2020', '2020-30', '4893', '11', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.4');
INSERT INTO public.europe_data_import VALUES (5020, '20/07/2020', '2020-29', '3228', '3', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '4.19');
INSERT INTO public.europe_data_import VALUES (5021, '13/07/2020', '2020-28', '2093', '5', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '2.67');
INSERT INTO public.europe_data_import VALUES (5022, '06/07/2020', '2020-27', '1299', '5', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '1.47');
INSERT INTO public.europe_data_import VALUES (5023, '29/06/2020', '2020-26', '560', '19', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (5024, '22/06/2020', '2020-25', '414', '28', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (5025, '15/06/2020', '2020-24', '328', '9', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.49');
INSERT INTO public.europe_data_import VALUES (5026, '08/06/2020', '2020-23', '290', '24', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.47');
INSERT INTO public.europe_data_import VALUES (5027, '01/06/2020', '2020-22', '303', '62', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (5028, '25/05/2020', '2020-21', '276', '81', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.62');
INSERT INTO public.europe_data_import VALUES (5029, '18/05/2020', '2020-20', '507', '128', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (5030, '11/05/2020', '2020-19', '741', '111', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '1.9');
INSERT INTO public.europe_data_import VALUES (5031, '04/05/2020', '2020-18', '1672', '159', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '3.39');
INSERT INTO public.europe_data_import VALUES (5032, '27/04/2020', '2020-17', '2634', '180', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '4.83');
INSERT INTO public.europe_data_import VALUES (5033, '20/04/2020', '2020-16', '3496', '69', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.59');
INSERT INTO public.europe_data_import VALUES (5034, '13/04/2020', '2020-15', '3601', '29', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '4.25');
INSERT INTO public.europe_data_import VALUES (5035, '06/04/2020', '2020-14', '1788', '19', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '2.02');
INSERT INTO public.europe_data_import VALUES (5036, '30/03/2020', '2020-13', '777', '13', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.83');
INSERT INTO public.europe_data_import VALUES (5037, '23/03/2020', '2020-12', '275', '17', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.47');
INSERT INTO public.europe_data_import VALUES (5038, '16/03/2020', '2020-11', '326', '17', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (5039, '09/03/2020', '2020-10', '234', '1', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (5040, '02/03/2020', '2020-09', '110', '5', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (5041, '24/02/2020', '2020-08', '85', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (5042, '17/02/2020', '2020-07', '34', '1', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5043, '10/02/2020', '2020-06', '5', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (5044, '03/02/2020', '2020-05', '17', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5045, '27/01/2020', '2020-04', '2', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (5046, '20/01/2020', '2020-03', '1', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (5047, '13/01/2020', '2020-02', '0', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5048, '06/01/2020', '2020-01', '0', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5049, '01/02/2021', '2021-04', '30', '3', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '90.91');
INSERT INTO public.europe_data_import VALUES (5050, '25/01/2021', '2021-03', '68', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '139.15');
INSERT INTO public.europe_data_import VALUES (5051, '18/01/2021', '2021-02', '82', '5', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '216.15');
INSERT INTO public.europe_data_import VALUES (5052, '11/01/2021', '2021-01', '151', '13', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '286.65');
INSERT INTO public.europe_data_import VALUES (5053, '04/01/2021', '2020-53', '158', '3', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '449.92');
INSERT INTO public.europe_data_import VALUES (5054, '28/12/2020', '2020-52', '327', '5', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '820.07');
INSERT INTO public.europe_data_import VALUES (5055, '21/12/2020', '2020-51', '557', '4', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '908.2');
INSERT INTO public.europe_data_import VALUES (5056, '14/12/2020', '2020-50', '422', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '789.45');
INSERT INTO public.europe_data_import VALUES (5057, '07/12/2020', '2020-49', '429', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '506.51');
INSERT INTO public.europe_data_import VALUES (5058, '30/11/2020', '2020-48', '117', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '181.82');
INSERT INTO public.europe_data_import VALUES (5059, '23/11/2020', '2020-47', '79', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '155.85');
INSERT INTO public.europe_data_import VALUES (5060, '16/11/2020', '2020-46', '89', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '146.57');
INSERT INTO public.europe_data_import VALUES (5061, '09/11/2020', '2020-45', '69', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '104.83');
INSERT INTO public.europe_data_import VALUES (5062, '02/11/2020', '2020-44', '44', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '77.92');
INSERT INTO public.europe_data_import VALUES (5063, '26/10/2020', '2020-43', '40', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '75.14');
INSERT INTO public.europe_data_import VALUES (5064, '19/10/2020', '2020-42', '41', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '64.01');
INSERT INTO public.europe_data_import VALUES (5065, '12/10/2020', '2020-41', '28', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '45.46');
INSERT INTO public.europe_data_import VALUES (5066, '05/10/2020', '2020-40', '21', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '25.97');
INSERT INTO public.europe_data_import VALUES (5067, '28/09/2020', '2020-39', '7', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '18.55');
INSERT INTO public.europe_data_import VALUES (5068, '21/09/2020', '2020-38', '13', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '8.35');
INSERT INTO public.europe_data_import VALUES (5069, '14/09/2020', '2020-37', '-4', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5070, '07/09/2020', '2020-36', '10', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '19.48');
INSERT INTO public.europe_data_import VALUES (5071, '31/08/2020', '2020-35', '11', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '17.63');
INSERT INTO public.europe_data_import VALUES (5072, '24/08/2020', '2020-34', '8', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '16.7');
INSERT INTO public.europe_data_import VALUES (5073, '17/08/2020', '2020-33', '10', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '18.55');
INSERT INTO public.europe_data_import VALUES (5074, '10/08/2020', '2020-32', '10', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '12.06');
INSERT INTO public.europe_data_import VALUES (5075, '03/08/2020', '2020-31', '3', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '3.71');
INSERT INTO public.europe_data_import VALUES (5076, '27/07/2020', '2020-30', '1', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '6.49');
INSERT INTO public.europe_data_import VALUES (5077, '20/07/2020', '2020-29', '6', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '10.2');
INSERT INTO public.europe_data_import VALUES (5078, '13/07/2020', '2020-28', '5', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5079, '06/07/2020', '2020-27', '1', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '1.86');
INSERT INTO public.europe_data_import VALUES (5080, '29/06/2020', '2020-26', '1', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5081, '22/06/2020', '2020-25', '5', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '6.49');
INSERT INTO public.europe_data_import VALUES (5082, '15/06/2020', '2020-24', '2', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '4.64');
INSERT INTO public.europe_data_import VALUES (5083, '08/06/2020', '2020-23', '3', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '4.64');
INSERT INTO public.europe_data_import VALUES (5084, '01/06/2020', '2020-22', '2', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5085, '25/05/2020', '2020-21', '4', '2', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '11.13');
INSERT INTO public.europe_data_import VALUES (5086, '18/05/2020', '2020-20', '8', '2', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '9.28');
INSERT INTO public.europe_data_import VALUES (5087, '11/05/2020', '2020-19', '2', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '12.06');
INSERT INTO public.europe_data_import VALUES (5088, '04/05/2020', '2020-18', '11', '5', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '39.89');
INSERT INTO public.europe_data_import VALUES (5089, '27/04/2020', '2020-17', '32', '7', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '63.08');
INSERT INTO public.europe_data_import VALUES (5090, '20/04/2020', '2020-16', '36', '8', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '87.2');
INSERT INTO public.europe_data_import VALUES (5091, '13/04/2020', '2020-15', '58', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '139.15');
INSERT INTO public.europe_data_import VALUES (5092, '06/04/2020', '2020-14', '92', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '129.87');
INSERT INTO public.europe_data_import VALUES (5093, '30/03/2020', '2020-13', '48', '2', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '58.44');
INSERT INTO public.europe_data_import VALUES (5094, '23/03/2020', '2020-12', '15', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5095, '01/02/2021', '2021-04', '7609', '102', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '123.92');
INSERT INTO public.europe_data_import VALUES (5096, '25/01/2021', '2021-03', '4909', '71', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '116.64');
INSERT INTO public.europe_data_import VALUES (5097, '18/01/2021', '2021-02', '6874', '110', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '171.61');
INSERT INTO public.europe_data_import VALUES (5098, '11/01/2021', '2021-01', '10462', '140', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '205.15');
INSERT INTO public.europe_data_import VALUES (5099, '04/01/2021', '2020-53', '10262', '145', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '205.51');
INSERT INTO public.europe_data_import VALUES (5100, '28/12/2020', '2020-52', '10498', '154', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '280.47');
INSERT INTO public.europe_data_import VALUES (5101, '21/12/2020', '2020-51', '17834', '239', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '369.83');
INSERT INTO public.europe_data_import VALUES (5102, '14/12/2020', '2020-50', '19525', '309', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '448.51');
INSERT INTO public.europe_data_import VALUES (5103, '07/12/2020', '2020-49', '25782', '362', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '560.9');
INSERT INTO public.europe_data_import VALUES (5104, '30/11/2020', '2020-48', '30878', '458', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '699.18');
INSERT INTO public.europe_data_import VALUES (5105, '23/11/2020', '2020-47', '39751', '464', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '733.62');
INSERT INTO public.europe_data_import VALUES (5106, '16/11/2020', '2020-46', '34357', '539', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '671.29');
INSERT INTO public.europe_data_import VALUES (5107, '09/11/2020', '2020-45', '33455', '367', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '556.68');
INSERT INTO public.europe_data_import VALUES (5108, '02/11/2020', '2020-44', '22779', '287', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '379.07');
INSERT INTO public.europe_data_import VALUES (5109, '26/10/2020', '2020-43', '15514', '234', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '278.77');
INSERT INTO public.europe_data_import VALUES (5110, '19/10/2020', '2020-42', '12647', '154', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '217.12');
INSERT INTO public.europe_data_import VALUES (5111, '12/10/2020', '2020-41', '9286', '90', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '162.69');
INSERT INTO public.europe_data_import VALUES (5112, '05/10/2020', '2020-40', '7148', '56', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '107.52');
INSERT INTO public.europe_data_import VALUES (5113, '28/09/2020', '2020-39', '3713', '15', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '51.26');
INSERT INTO public.europe_data_import VALUES (5114, '21/09/2020', '2020-38', '1465', '6', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '23.44');
INSERT INTO public.europe_data_import VALUES (5115, '14/09/2020', '2020-37', '903', '8', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '13.34');
INSERT INTO public.europe_data_import VALUES (5116, '07/09/2020', '2020-36', '445', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '7.94');
INSERT INTO public.europe_data_import VALUES (5117, '31/08/2020', '2020-35', '357', '3', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '5.82');
INSERT INTO public.europe_data_import VALUES (5118, '24/08/2020', '2020-34', '231', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '3.53');
INSERT INTO public.europe_data_import VALUES (5119, '17/08/2020', '2020-33', '126', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.63');
INSERT INTO public.europe_data_import VALUES (5120, '10/08/2020', '2020-32', '39', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.83');
INSERT INTO public.europe_data_import VALUES (5121, '03/08/2020', '2020-31', '45', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '-0.05');
INSERT INTO public.europe_data_import VALUES (5122, '27/07/2020', '2020-30', '-50', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '-0.11');
INSERT INTO public.europe_data_import VALUES (5123, '20/07/2020', '2020-29', '39', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.53');
INSERT INTO public.europe_data_import VALUES (5124, '13/07/2020', '2020-28', '15', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (5125, '06/07/2020', '2020-27', '43', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (5126, '29/06/2020', '2020-26', '88', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.58');
INSERT INTO public.europe_data_import VALUES (5127, '22/06/2020', '2020-25', '72', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.23');
INSERT INTO public.europe_data_import VALUES (5128, '15/06/2020', '2020-24', '153', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.2');
INSERT INTO public.europe_data_import VALUES (5129, '08/06/2020', '2020-23', '69', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.99');
INSERT INTO public.europe_data_import VALUES (5130, '01/06/2020', '2020-22', '31', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.25');
INSERT INTO public.europe_data_import VALUES (5131, '25/05/2020', '2020-21', '95', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.66');
INSERT INTO public.europe_data_import VALUES (5132, '18/05/2020', '2020-20', '73', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.5');
INSERT INTO public.europe_data_import VALUES (5133, '11/05/2020', '2020-19', '79', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.92');
INSERT INTO public.europe_data_import VALUES (5134, '04/05/2020', '2020-18', '14', '2', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (5135, '27/04/2020', '2020-17', '30', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (5136, '20/04/2020', '2020-16', '28', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.71');
INSERT INTO public.europe_data_import VALUES (5137, '13/04/2020', '2020-15', '44', '2', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.29');
INSERT INTO public.europe_data_import VALUES (5138, '06/04/2020', '2020-14', '86', '4', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.44');
INSERT INTO public.europe_data_import VALUES (5139, '30/03/2020', '2020-13', '160', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.42');
INSERT INTO public.europe_data_import VALUES (5140, '23/03/2020', '2020-12', '84', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (5141, '16/03/2020', '2020-11', '15', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5142, '01/02/2021', '2021-04', '9953', '88', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '101.77');
INSERT INTO public.europe_data_import VALUES (5143, '25/01/2021', '2021-03', '8927', '67', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '85.2');
INSERT INTO public.europe_data_import VALUES (5144, '18/01/2021', '2021-02', '6878', '16', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '53.34');
INSERT INTO public.europe_data_import VALUES (5145, '11/01/2021', '2021-01', '3018', '100', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '61.6');
INSERT INTO public.europe_data_import VALUES (5146, '04/01/2021', '2020-53', '8409', '86', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '83.11');
INSERT INTO public.europe_data_import VALUES (5147, '28/12/2020', '2020-52', '7009', '67', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '66.74');
INSERT INTO public.europe_data_import VALUES (5148, '21/12/2020', '2020-51', '5373', '70', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '62.32');
INSERT INTO public.europe_data_import VALUES (5149, '14/12/2020', '2020-50', '6188', '64', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '67.22');
INSERT INTO public.europe_data_import VALUES (5150, '07/12/2020', '2020-49', '6283', '55', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '68.48');
INSERT INTO public.europe_data_import VALUES (5151, '30/11/2020', '2020-48', '6421', '61', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '67.69');
INSERT INTO public.europe_data_import VALUES (5152, '23/11/2020', '2020-47', '6137', '53', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '62.04');
INSERT INTO public.europe_data_import VALUES (5153, '16/11/2020', '2020-46', '5372', '53', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '55.98');
INSERT INTO public.europe_data_import VALUES (5154, '09/11/2020', '2020-45', '5013', '39', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '45.35');
INSERT INTO public.europe_data_import VALUES (5155, '02/11/2020', '2020-44', '3400', '37', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '29.05');
INSERT INTO public.europe_data_import VALUES (5156, '26/10/2020', '2020-43', '1990', '40', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '20.07');
INSERT INTO public.europe_data_import VALUES (5157, '19/10/2020', '2020-42', '1733', '36', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '19.56');
INSERT INTO public.europe_data_import VALUES (5158, '12/10/2020', '2020-41', '1896', '29', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.73');
INSERT INTO public.europe_data_import VALUES (5159, '05/10/2020', '2020-40', '1579', '36', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.27');
INSERT INTO public.europe_data_import VALUES (5160, '28/09/2020', '2020-39', '1810', '34', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '20.22');
INSERT INTO public.europe_data_import VALUES (5161, '21/09/2020', '2020-38', '1942', '53', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '23.35');
INSERT INTO public.europe_data_import VALUES (5162, '14/09/2020', '2020-37', '2390', '60', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '31.48');
INSERT INTO public.europe_data_import VALUES (5163, '07/09/2020', '2020-36', '3450', '121', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '35.91');
INSERT INTO public.europe_data_import VALUES (5164, '31/08/2020', '2020-35', '3211', '108', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '48.7');
INSERT INTO public.europe_data_import VALUES (5165, '24/08/2020', '2020-34', '5823', '186', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '79.45');
INSERT INTO public.europe_data_import VALUES (5166, '17/08/2020', '2020-33', '8917', '54', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '123.97');
INSERT INTO public.europe_data_import VALUES (5167, '10/08/2020', '2020-32', '14081', '324', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '159.56');
INSERT INTO public.europe_data_import VALUES (5168, '03/08/2020', '2020-31', '15519', '524', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '144.48');
INSERT INTO public.europe_data_import VALUES (5169, '27/07/2020', '2020-30', '11284', '210', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '125.24');
INSERT INTO public.europe_data_import VALUES (5170, '20/07/2020', '2020-29', '11949', '0', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '125.4');
INSERT INTO public.europe_data_import VALUES (5171, '13/07/2020', '2020-28', '11315', '187', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '207.87');
INSERT INTO public.europe_data_import VALUES (5172, '06/07/2020', '2020-27', '27247', '5', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '166.25');
INSERT INTO public.europe_data_import VALUES (5173, '29/06/2020', '2020-26', '3595', '63', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '35.13');
INSERT INTO public.europe_data_import VALUES (5174, '22/06/2020', '2020-25', '2923', '43', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '26.27');
INSERT INTO public.europe_data_import VALUES (5175, '15/06/2020', '2020-24', '1950', '21', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.87');
INSERT INTO public.europe_data_import VALUES (5176, '08/06/2020', '2020-23', '1551', '15', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '23.33');
INSERT INTO public.europe_data_import VALUES (5177, '01/06/2020', '2020-22', '2777', '6', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '26.24');
INSERT INTO public.europe_data_import VALUES (5178, '25/05/2020', '2020-21', '2091', '1', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.35');
INSERT INTO public.europe_data_import VALUES (5179, '18/05/2020', '2020-20', '1314', '3', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '13.35');
INSERT INTO public.europe_data_import VALUES (5180, '11/05/2020', '2020-19', '1162', '4', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '12.99');
INSERT INTO public.europe_data_import VALUES (5181, '04/05/2020', '2020-18', '1247', '2', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '12.02');
INSERT INTO public.europe_data_import VALUES (5182, '27/04/2020', '2020-17', '982', '6', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '9.47');
INSERT INTO public.europe_data_import VALUES (5183, '20/04/2020', '2020-16', '774', '9', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '6.49');
INSERT INTO public.europe_data_import VALUES (5184, '13/04/2020', '2020-15', '430', '5', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '3.65');
INSERT INTO public.europe_data_import VALUES (5185, '06/04/2020', '2020-14', '247', '4', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '2.54');
INSERT INTO public.europe_data_import VALUES (5186, '30/03/2020', '2020-13', '224', '1', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '1.48');
INSERT INTO public.europe_data_import VALUES (5187, '23/03/2020', '2020-12', '51', '0', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (5188, '16/03/2020', '2020-11', '9', '0', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5189, '01/02/2021', '2021-04', '804', '22', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.22');
INSERT INTO public.europe_data_import VALUES (5190, '25/01/2021', '2021-03', '890', '13', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (5191, '18/01/2021', '2021-02', '891', '18', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.49');
INSERT INTO public.europe_data_import VALUES (5192, '11/01/2021', '2021-01', '1469', '28', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.33');
INSERT INTO public.europe_data_import VALUES (5193, '04/01/2021', '2020-53', '810', '21', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.38');
INSERT INTO public.europe_data_import VALUES (5194, '28/12/2020', '2020-52', '1492', '25', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '7.8');
INSERT INTO public.europe_data_import VALUES (5195, '21/12/2020', '2020-51', '2608', '52', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '11.64');
INSERT INTO public.europe_data_import VALUES (5196, '14/12/2020', '2020-50', '3512', '61', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '16.31');
INSERT INTO public.europe_data_import VALUES (5197, '07/12/2020', '2020-49', '5064', '74', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '20.94');
INSERT INTO public.europe_data_import VALUES (5198, '30/11/2020', '2020-48', '5944', '72', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '24.86');
INSERT INTO public.europe_data_import VALUES (5199, '23/11/2020', '2020-47', '7127', '111', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '28.31');
INSERT INTO public.europe_data_import VALUES (5200, '16/11/2020', '2020-46', '7757', '158', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '27.33');
INSERT INTO public.europe_data_import VALUES (5201, '09/11/2020', '2020-45', '6611', '98', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '24.28');
INSERT INTO public.europe_data_import VALUES (5202, '02/11/2020', '2020-44', '6156', '111', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '20.92');
INSERT INTO public.europe_data_import VALUES (5203, '26/10/2020', '2020-43', '4840', '70', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '15.55');
INSERT INTO public.europe_data_import VALUES (5204, '19/10/2020', '2020-42', '3335', '66', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '10.37');
INSERT INTO public.europe_data_import VALUES (5205, '12/10/2020', '2020-41', '2119', '35', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '6.53');
INSERT INTO public.europe_data_import VALUES (5206, '05/10/2020', '2020-40', '1312', '40', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (5207, '28/09/2020', '2020-39', '1134', '43', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.72');
INSERT INTO public.europe_data_import VALUES (5208, '21/09/2020', '2020-38', '824', '26', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.57');
INSERT INTO public.europe_data_import VALUES (5209, '14/09/2020', '2020-37', '1054', '25', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.99');
INSERT INTO public.europe_data_import VALUES (5210, '07/09/2020', '2020-36', '1046', '23', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '5.21');
INSERT INTO public.europe_data_import VALUES (5211, '31/08/2020', '2020-35', '1693', '26', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '7.49');
INSERT INTO public.europe_data_import VALUES (5212, '24/08/2020', '2020-34', '2244', '74', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '11.28');
INSERT INTO public.europe_data_import VALUES (5213, '17/08/2020', '2020-33', '3684', '54', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '15.34');
INSERT INTO public.europe_data_import VALUES (5214, '10/08/2020', '2020-32', '4383', '51', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '16.8');
INSERT INTO public.europe_data_import VALUES (5215, '03/08/2020', '2020-31', '4450', '89', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '16.55');
INSERT INTO public.europe_data_import VALUES (5216, '27/07/2020', '2020-30', '4250', '46', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '14.26');
INSERT INTO public.europe_data_import VALUES (5217, '20/07/2020', '2020-29', '3248', '49', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '10.4');
INSERT INTO public.europe_data_import VALUES (5218, '13/07/2020', '2020-28', '2219', '25', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '7.67');
INSERT INTO public.europe_data_import VALUES (5219, '06/07/2020', '2020-27', '1816', '17', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '5.99');
INSERT INTO public.europe_data_import VALUES (5220, '29/06/2020', '2020-26', '1332', '20', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.71');
INSERT INTO public.europe_data_import VALUES (5221, '22/06/2020', '2020-25', '1144', '20', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.75');
INSERT INTO public.europe_data_import VALUES (5222, '15/06/2020', '2020-24', '827', '19', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (5223, '08/06/2020', '2020-23', '805', '20', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '2.95');
INSERT INTO public.europe_data_import VALUES (5224, '01/06/2020', '2020-22', '748', '13', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (5225, '25/05/2020', '2020-21', '327', '1', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (5226, '18/05/2020', '2020-20', '215', '18', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (5227, '11/05/2020', '2020-19', '207', '8', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (5228, '04/05/2020', '2020-18', '110', '10', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (5229, '27/04/2020', '2020-17', '85', '0', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5230, '20/04/2020', '2020-16', '73', '6', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (5231, '13/04/2020', '2020-15', '55', '4', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (5232, '06/04/2020', '2020-14', '100', '3', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (5233, '30/03/2020', '2020-13', '27', '1', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5234, '23/03/2020', '2020-12', '12', '0', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (5235, '16/03/2020', '2020-11', '3', '0', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5236, '01/02/2021', '2021-04', '2130', '42', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '242.81');
INSERT INTO public.europe_data_import VALUES (5237, '25/01/2021', '2021-03', '2237', '46', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '239.75');
INSERT INTO public.europe_data_import VALUES (5238, '18/01/2021', '2021-02', '2075', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '216.07');
INSERT INTO public.europe_data_import VALUES (5239, '11/01/2021', '2021-01', '1811', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '165.42');
INSERT INTO public.europe_data_import VALUES (5240, '04/01/2021', '2020-53', '1164', '27', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '155.46');
INSERT INTO public.europe_data_import VALUES (5241, '28/12/2020', '2020-52', '1632', '55', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '234.69');
INSERT INTO public.europe_data_import VALUES (5242, '21/12/2020', '2020-51', '2589', '64', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '353.85');
INSERT INTO public.europe_data_import VALUES (5243, '14/12/2020', '2020-50', '3775', '92', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '418.29');
INSERT INTO public.europe_data_import VALUES (5244, '07/12/2020', '2020-49', '3748', '101', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '473.17');
INSERT INTO public.europe_data_import VALUES (5245, '30/11/2020', '2020-48', '4762', '91', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '552.68');
INSERT INTO public.europe_data_import VALUES (5246, '23/11/2020', '2020-47', '5178', '92', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '563.8');
INSERT INTO public.europe_data_import VALUES (5247, '16/11/2020', '2020-46', '4962', '67', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '496.97');
INSERT INTO public.europe_data_import VALUES (5248, '09/11/2020', '2020-45', '3976', '67', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '345.4');
INSERT INTO public.europe_data_import VALUES (5249, '02/11/2020', '2020-44', '2236', '25', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '182.82');
INSERT INTO public.europe_data_import VALUES (5250, '26/10/2020', '2020-43', '1052', '10', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '98.08');
INSERT INTO public.europe_data_import VALUES (5251, '19/10/2020', '2020-42', '712', '6', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '59.88');
INSERT INTO public.europe_data_import VALUES (5252, '12/10/2020', '2020-41', '365', '17', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '39.31');
INSERT INTO public.europe_data_import VALUES (5253, '05/10/2020', '2020-40', '342', '8', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '41.76');
INSERT INTO public.europe_data_import VALUES (5254, '28/09/2020', '2020-39', '409', '9', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '46.43');
INSERT INTO public.europe_data_import VALUES (5255, '21/09/2020', '2020-38', '426', '17', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '52.49');
INSERT INTO public.europe_data_import VALUES (5256, '14/09/2020', '2020-37', '518', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '72.45');
INSERT INTO public.europe_data_import VALUES (5257, '07/09/2020', '2020-36', '785', '47', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '92.91');
INSERT INTO public.europe_data_import VALUES (5258, '31/08/2020', '2020-35', '886', '49', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '106.64');
INSERT INTO public.europe_data_import VALUES (5259, '24/08/2020', '2020-34', '1032', '66', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '122.38');
INSERT INTO public.europe_data_import VALUES (5260, '17/08/2020', '2020-33', '1169', '74', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '145.51');
INSERT INTO public.europe_data_import VALUES (5261, '10/08/2020', '2020-32', '1448', '78', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '185.15');
INSERT INTO public.europe_data_import VALUES (5262, '03/08/2020', '2020-31', '1882', '80', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '170.36');
INSERT INTO public.europe_data_import VALUES (5263, '27/07/2020', '2020-30', '1182', '34', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '110.42');
INSERT INTO public.europe_data_import VALUES (5264, '20/07/2020', '2020-29', '804', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '132.28');
INSERT INTO public.europe_data_import VALUES (5265, '13/07/2020', '2020-28', '1575', '36', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '125.33');
INSERT INTO public.europe_data_import VALUES (5266, '06/07/2020', '2020-27', '679', '17', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '66.0');
INSERT INTO public.europe_data_import VALUES (5267, '29/06/2020', '2020-26', '508', '13', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '66.22');
INSERT INTO public.europe_data_import VALUES (5268, '22/06/2020', '2020-25', '683', '3', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '51.99');
INSERT INTO public.europe_data_import VALUES (5269, '15/06/2020', '2020-24', '252', '2', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '22.41');
INSERT INTO public.europe_data_import VALUES (5270, '08/06/2020', '2020-23', '151', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '11.23');
INSERT INTO public.europe_data_import VALUES (5271, '01/06/2020', '2020-22', '51', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '5.45');
INSERT INTO public.europe_data_import VALUES (5272, '25/05/2020', '2020-21', '47', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '8.23');
INSERT INTO public.europe_data_import VALUES (5273, '18/05/2020', '2020-20', '101', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '7.45');
INSERT INTO public.europe_data_import VALUES (5274, '11/05/2020', '2020-19', '33', '3', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '6.67');
INSERT INTO public.europe_data_import VALUES (5275, '04/05/2020', '2020-18', '87', '5', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '16.12');
INSERT INTO public.europe_data_import VALUES (5276, '27/04/2020', '2020-17', '203', '6', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '22.35');
INSERT INTO public.europe_data_import VALUES (5277, '20/04/2020', '2020-16', '199', '7', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '22.02');
INSERT INTO public.europe_data_import VALUES (5278, '13/04/2020', '2020-15', '197', '6', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '14.68');
INSERT INTO public.europe_data_import VALUES (5279, '06/04/2020', '2020-14', '67', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '7.34');
INSERT INTO public.europe_data_import VALUES (5280, '30/03/2020', '2020-13', '65', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '4.73');
INSERT INTO public.europe_data_import VALUES (5281, '23/03/2020', '2020-12', '20', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '1.83');
INSERT INTO public.europe_data_import VALUES (5282, '16/03/2020', '2020-11', '13', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5283, '01/02/2021', '2021-04', '3972', '7', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '177.8');
INSERT INTO public.europe_data_import VALUES (5284, '25/01/2021', '2021-03', '3508', '5', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '165.7');
INSERT INTO public.europe_data_import VALUES (5285, '18/01/2021', '2021-02', '3463', '4', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '152.93');
INSERT INTO public.europe_data_import VALUES (5286, '11/01/2021', '2021-01', '2971', '6', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '110.79');
INSERT INTO public.europe_data_import VALUES (5287, '04/01/2021', '2020-53', '1690', '6', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '79.96');
INSERT INTO public.europe_data_import VALUES (5288, '28/12/2020', '2020-52', '1674', '10', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '81.65');
INSERT INTO public.europe_data_import VALUES (5289, '21/12/2020', '2020-51', '1761', '10', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '85.81');
INSERT INTO public.europe_data_import VALUES (5290, '14/12/2020', '2020-50', '1849', '20', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '90.13');
INSERT INTO public.europe_data_import VALUES (5291, '07/12/2020', '2020-49', '1943', '13', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '102.52');
INSERT INTO public.europe_data_import VALUES (5292, '30/11/2020', '2020-48', '2370', '12', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '132.78');
INSERT INTO public.europe_data_import VALUES (5293, '23/11/2020', '2020-47', '3216', '28', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '197.6');
INSERT INTO public.europe_data_import VALUES (5294, '16/11/2020', '2020-46', '5097', '27', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '244.97');
INSERT INTO public.europe_data_import VALUES (5295, '09/11/2020', '2020-45', '5209', '29', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '240.26');
INSERT INTO public.europe_data_import VALUES (5296, '02/11/2020', '2020-44', '4899', '36', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '246.92');
INSERT INTO public.europe_data_import VALUES (5297, '26/10/2020', '2020-43', '5489', '45', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '250.03');
INSERT INTO public.europe_data_import VALUES (5298, '19/10/2020', '2020-42', '5030', '43', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '216.8');
INSERT INTO public.europe_data_import VALUES (5299, '12/10/2020', '2020-41', '4091', '34', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '179.98');
INSERT INTO public.europe_data_import VALUES (5300, '05/10/2020', '2020-40', '3481', '23', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '180.43');
INSERT INTO public.europe_data_import VALUES (5301, '28/09/2020', '2020-39', '4110', '17', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '208.7');
INSERT INTO public.europe_data_import VALUES (5302, '21/09/2020', '2020-38', '4670', '24', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '234.18');
INSERT INTO public.europe_data_import VALUES (5303, '14/09/2020', '2020-37', '5182', '16', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '240.74');
INSERT INTO public.europe_data_import VALUES (5304, '07/09/2020', '2020-36', '4946', '14', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '215.21');
INSERT INTO public.europe_data_import VALUES (5305, '31/08/2020', '2020-35', '4108', '15', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '200.4');
INSERT INTO public.europe_data_import VALUES (5306, '24/08/2020', '2020-34', '4323', '14', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '209.53');
INSERT INTO public.europe_data_import VALUES (5307, '17/08/2020', '2020-33', '4492', '23', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '197.14');
INSERT INTO public.europe_data_import VALUES (5308, '10/08/2020', '2020-32', '3802', '21', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '188.73');
INSERT INTO public.europe_data_import VALUES (5309, '03/08/2020', '2020-31', '4138', '24', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '206.96');
INSERT INTO public.europe_data_import VALUES (5310, '27/07/2020', '2020-30', '4569', '25', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '211.05');
INSERT INTO public.europe_data_import VALUES (5311, '20/07/2020', '2020-29', '4310', '18', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '220.18');
INSERT INTO public.europe_data_import VALUES (5312, '13/07/2020', '2020-28', '4953', '22', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '236.55');
INSERT INTO public.europe_data_import VALUES (5313, '06/07/2020', '2020-27', '4999', '20', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '244.61');
INSERT INTO public.europe_data_import VALUES (5314, '29/06/2020', '2020-26', '5292', '22', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '214.45');
INSERT INTO public.europe_data_import VALUES (5315, '22/06/2020', '2020-25', '3730', '30', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '185.45');
INSERT INTO public.europe_data_import VALUES (5316, '15/06/2020', '2020-24', '4072', '32', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '211.0');
INSERT INTO public.europe_data_import VALUES (5317, '08/06/2020', '2020-23', '4805', '52', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '250.67');
INSERT INTO public.europe_data_import VALUES (5318, '01/06/2020', '2020-22', '5741', '56', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '289.82');
INSERT INTO public.europe_data_import VALUES (5319, '25/05/2020', '2020-21', '6452', '44', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '299.83');
INSERT INTO public.europe_data_import VALUES (5320, '18/05/2020', '2020-20', '6162', '54', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '234.53');
INSERT INTO public.europe_data_import VALUES (5321, '11/05/2020', '2020-19', '3705', '20', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '133.42');
INSERT INTO public.europe_data_import VALUES (5322, '04/05/2020', '2020-18', '1908', '18', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '72.92');
INSERT INTO public.europe_data_import VALUES (5323, '27/04/2020', '2020-17', '1160', '13', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '43.76');
INSERT INTO public.europe_data_import VALUES (5324, '20/04/2020', '2020-16', '681', '6', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '32.3');
INSERT INTO public.europe_data_import VALUES (5325, '13/04/2020', '2020-15', '678', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '23.27');
INSERT INTO public.europe_data_import VALUES (5326, '06/04/2020', '2020-14', '301', '1', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '8.75');
INSERT INTO public.europe_data_import VALUES (5327, '30/03/2020', '2020-13', '67', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '3.4');
INSERT INTO public.europe_data_import VALUES (5328, '23/03/2020', '2020-12', '76', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '2.95');
INSERT INTO public.europe_data_import VALUES (5329, '16/03/2020', '2020-11', '48', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '1.57');
INSERT INTO public.europe_data_import VALUES (5330, '09/03/2020', '2020-10', '18', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '1.45');
INSERT INTO public.europe_data_import VALUES (5331, '02/03/2020', '2020-09', '43', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '1.09');
INSERT INTO public.europe_data_import VALUES (5332, '24/02/2020', '2020-08', '3', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (5333, '17/02/2020', '2020-07', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5334, '10/02/2020', '2020-06', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5335, '03/02/2020', '2020-05', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5336, '27/01/2020', '2020-04', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5337, '20/01/2020', '2020-03', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5338, '13/01/2020', '2020-02', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5339, '06/01/2020', '2020-01', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5340, '01/02/2021', '2021-04', '617', '11', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '21.98');
INSERT INTO public.europe_data_import VALUES (5341, '25/01/2021', '2021-03', '793', '14', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '24.8');
INSERT INTO public.europe_data_import VALUES (5342, '18/01/2021', '2021-02', '798', '16', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '27.9');
INSERT INTO public.europe_data_import VALUES (5343, '11/01/2021', '2021-01', '992', '11', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '28.76');
INSERT INTO public.europe_data_import VALUES (5344, '04/01/2021', '2020-53', '853', '11', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '33.26');
INSERT INTO public.europe_data_import VALUES (5345, '28/12/2020', '2020-52', '1281', '18', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '44.59');
INSERT INTO public.europe_data_import VALUES (5346, '21/12/2020', '2020-51', '1580', '19', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '60.15');
INSERT INTO public.europe_data_import VALUES (5347, '14/12/2020', '2020-50', '2279', '15', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '75.86');
INSERT INTO public.europe_data_import VALUES (5348, '07/12/2020', '2020-49', '2588', '26', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '85.88');
INSERT INTO public.europe_data_import VALUES (5349, '30/11/2020', '2020-48', '2922', '34', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '90.78');
INSERT INTO public.europe_data_import VALUES (5350, '23/11/2020', '2020-47', '2902', '34', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '101.23');
INSERT INTO public.europe_data_import VALUES (5351, '16/11/2020', '2020-46', '3593', '21', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '110.73');
INSERT INTO public.europe_data_import VALUES (5352, '09/11/2020', '2020-45', '3511', '27', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '112.53');
INSERT INTO public.europe_data_import VALUES (5353, '02/11/2020', '2020-44', '3709', '21', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '114.61');
INSERT INTO public.europe_data_import VALUES (5354, '26/10/2020', '2020-43', '3644', '23', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '108.17');
INSERT INTO public.europe_data_import VALUES (5355, '19/10/2020', '2020-42', '3296', '26', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '76.23');
INSERT INTO public.europe_data_import VALUES (5356, '12/10/2020', '2020-41', '1595', '19', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '44.81');
INSERT INTO public.europe_data_import VALUES (5357, '05/10/2020', '2020-40', '1280', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '33.73');
INSERT INTO public.europe_data_import VALUES (5358, '28/09/2020', '2020-39', '884', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '22.24');
INSERT INTO public.europe_data_import VALUES (5359, '21/09/2020', '2020-38', '543', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '15.9');
INSERT INTO public.europe_data_import VALUES (5360, '14/09/2020', '2020-37', '477', '3', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '16.05');
INSERT INTO public.europe_data_import VALUES (5361, '07/09/2020', '2020-36', '553', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '20.65');
INSERT INTO public.europe_data_import VALUES (5362, '31/08/2020', '2020-35', '772', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '29.72');
INSERT INTO public.europe_data_import VALUES (5363, '24/08/2020', '2020-34', '1135', '-439', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '45.96');
INSERT INTO public.europe_data_import VALUES (5364, '17/08/2020', '2020-33', '1814', '22', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '75.78');
INSERT INTO public.europe_data_import VALUES (5365, '10/08/2020', '2020-32', '3048', '54', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '107.25');
INSERT INTO public.europe_data_import VALUES (5366, '03/08/2020', '2020-31', '3833', '119', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '155.65');
INSERT INTO public.europe_data_import VALUES (5367, '27/07/2020', '2020-30', '6153', '264', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '345.69');
INSERT INTO public.europe_data_import VALUES (5368, '20/07/2020', '2020-29', '16026', '890', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '303.19');
INSERT INTO public.europe_data_import VALUES (5369, '13/07/2020', '2020-28', '3426', '55', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '95.08');
INSERT INTO public.europe_data_import VALUES (5370, '06/07/2020', '2020-27', '2674', '42', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '67.57');
INSERT INTO public.europe_data_import VALUES (5371, '29/06/2020', '2020-26', '1661', '10', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '41.23');
INSERT INTO public.europe_data_import VALUES (5372, '22/06/2020', '2020-25', '984', '13', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '20.64');
INSERT INTO public.europe_data_import VALUES (5373, '15/06/2020', '2020-24', '340', '4', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '8.65');
INSERT INTO public.europe_data_import VALUES (5374, '08/06/2020', '2020-23', '215', '7', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '9.34');
INSERT INTO public.europe_data_import VALUES (5375, '01/06/2020', '2020-22', '384', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '9.37');
INSERT INTO public.europe_data_import VALUES (5376, '25/05/2020', '2020-21', '217', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '6.5');
INSERT INTO public.europe_data_import VALUES (5377, '18/05/2020', '2020-20', '200', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '6.02');
INSERT INTO public.europe_data_import VALUES (5378, '11/05/2020', '2020-19', '186', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '5.0');
INSERT INTO public.europe_data_import VALUES (5379, '04/05/2020', '2020-18', '135', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '4.08');
INSERT INTO public.europe_data_import VALUES (5380, '27/04/2020', '2020-17', '127', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '4.3');
INSERT INTO public.europe_data_import VALUES (5381, '20/04/2020', '2020-16', '149', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '5.49');
INSERT INTO public.europe_data_import VALUES (5382, '13/04/2020', '2020-15', '203', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '5.22');
INSERT INTO public.europe_data_import VALUES (5383, '06/04/2020', '2020-14', '132', '4', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '3.15');
INSERT INTO public.europe_data_import VALUES (5384, '30/03/2020', '2020-13', '70', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '1.31');
INSERT INTO public.europe_data_import VALUES (5385, '23/03/2020', '2020-12', '14', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5386, '01/02/2021', '2021-04', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5387, '25/01/2021', '2021-03', '3', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5388, '18/01/2021', '2021-02', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5389, '11/01/2021', '2021-01', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5390, '04/01/2021', '2020-53', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5391, '28/12/2020', '2020-52', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5392, '21/12/2020', '2020-51', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5393, '14/12/2020', '2020-50', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5394, '07/12/2020', '2020-49', '2', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (5395, '30/11/2020', '2020-48', '15', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (5396, '23/11/2020', '2020-47', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5397, '16/11/2020', '2020-46', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5398, '09/11/2020', '2020-45', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5399, '02/11/2020', '2020-44', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5400, '26/10/2020', '2020-43', '1', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5401, '19/10/2020', '2020-42', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5402, '12/10/2020', '2020-41', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5403, '05/10/2020', '2020-40', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5404, '28/09/2020', '2020-39', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5405, '21/09/2020', '2020-38', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5406, '14/09/2020', '2020-37', '1', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5407, '07/09/2020', '2020-36', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5408, '31/08/2020', '2020-35', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5409, '24/08/2020', '2020-34', '2', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5410, '17/08/2020', '2020-33', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5411, '10/08/2020', '2020-32', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5412, '03/08/2020', '2020-31', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5413, '27/07/2020', '2020-30', '1', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5414, '20/07/2020', '2020-29', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5415, '13/07/2020', '2020-28', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5416, '06/07/2020', '2020-27', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5417, '29/06/2020', '2020-26', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5418, '22/06/2020', '2020-25', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5419, '15/06/2020', '2020-24', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5420, '08/06/2020', '2020-23', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5421, '01/06/2020', '2020-22', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5422, '25/05/2020', '2020-21', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5423, '18/05/2020', '2020-20', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5424, '11/05/2020', '2020-19', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5425, '04/05/2020', '2020-18', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5426, '27/04/2020', '2020-17', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5427, '20/04/2020', '2020-16', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (5428, '13/04/2020', '2020-15', '8', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.18');
INSERT INTO public.europe_data_import VALUES (5429, '06/04/2020', '2020-14', '5', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (5430, '30/03/2020', '2020-13', '6', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5431, '01/02/2021', '2021-04', '5233', '84', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '550.89');
INSERT INTO public.europe_data_import VALUES (5432, '25/01/2021', '2021-03', '5344', '133', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '595.84');
INSERT INTO public.europe_data_import VALUES (5433, '18/01/2021', '2021-02', '6096', '129', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '685.79');
INSERT INTO public.europe_data_import VALUES (5434, '11/01/2021', '2021-01', '7071', '169', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '689.49');
INSERT INTO public.europe_data_import VALUES (5435, '04/01/2021', '2020-53', '6167', '121', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '601.94');
INSERT INTO public.europe_data_import VALUES (5436, '28/12/2020', '2020-52', '5390', '120', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '554.96');
INSERT INTO public.europe_data_import VALUES (5437, '21/12/2020', '2020-51', '5265', '90', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '501.41');
INSERT INTO public.europe_data_import VALUES (5438, '14/12/2020', '2020-50', '4362', '87', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '453.13');
INSERT INTO public.europe_data_import VALUES (5439, '07/12/2020', '2020-49', '4338', '65', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '426.73');
INSERT INTO public.europe_data_import VALUES (5440, '30/11/2020', '2020-48', '3855', '44', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '334.8');
INSERT INTO public.europe_data_import VALUES (5441, '23/11/2020', '2020-47', '2573', '30', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '261.72');
INSERT INTO public.europe_data_import VALUES (5442, '16/11/2020', '2020-46', '2452', '24', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '229.74');
INSERT INTO public.europe_data_import VALUES (5443, '09/11/2020', '2020-45', '1959', '25', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '177.97');
INSERT INTO public.europe_data_import VALUES (5444, '02/11/2020', '2020-44', '1458', '18', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '139.9');
INSERT INTO public.europe_data_import VALUES (5445, '26/10/2020', '2020-43', '1228', '14', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '104.59');
INSERT INTO public.europe_data_import VALUES (5446, '19/10/2020', '2020-42', '780', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '71.04');
INSERT INTO public.europe_data_import VALUES (5447, '12/10/2020', '2020-41', '584', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '51.77');
INSERT INTO public.europe_data_import VALUES (5448, '05/10/2020', '2020-40', '410', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '29.22');
INSERT INTO public.europe_data_import VALUES (5449, '28/09/2020', '2020-39', '151', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '10.52');
INSERT INTO public.europe_data_import VALUES (5450, '21/09/2020', '2020-38', '51', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '5.05');
INSERT INTO public.europe_data_import VALUES (5451, '14/09/2020', '2020-37', '46', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '4.22');
INSERT INTO public.europe_data_import VALUES (5452, '07/09/2020', '2020-36', '35', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '4.74');
INSERT INTO public.europe_data_import VALUES (5453, '31/08/2020', '2020-35', '56', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.7');
INSERT INTO public.europe_data_import VALUES (5454, '24/08/2020', '2020-34', '15', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.45');
INSERT INTO public.europe_data_import VALUES (5455, '17/08/2020', '2020-33', '32', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '4.11');
INSERT INTO public.europe_data_import VALUES (5456, '10/08/2020', '2020-32', '47', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.7');
INSERT INTO public.europe_data_import VALUES (5457, '03/08/2020', '2020-31', '24', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.66');
INSERT INTO public.europe_data_import VALUES (5458, '27/07/2020', '2020-30', '27', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.4');
INSERT INTO public.europe_data_import VALUES (5459, '20/07/2020', '2020-29', '19', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.54');
INSERT INTO public.europe_data_import VALUES (5460, '13/07/2020', '2020-28', '49', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.97');
INSERT INTO public.europe_data_import VALUES (5461, '06/07/2020', '2020-27', '8', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (5462, '29/06/2020', '2020-26', '5', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '0.99');
INSERT INTO public.europe_data_import VALUES (5463, '22/06/2020', '2020-25', '14', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '1.2');
INSERT INTO public.europe_data_import VALUES (5464, '15/06/2020', '2020-24', '9', '3', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '1.61');
INSERT INTO public.europe_data_import VALUES (5465, '08/06/2020', '2020-23', '22', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.14');
INSERT INTO public.europe_data_import VALUES (5466, '01/06/2020', '2020-22', '19', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (5467, '25/05/2020', '2020-21', '39', '3', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '5.63');
INSERT INTO public.europe_data_import VALUES (5468, '18/05/2020', '2020-20', '69', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '6.72');
INSERT INTO public.europe_data_import VALUES (5469, '11/05/2020', '2020-19', '60', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '6.61');
INSERT INTO public.europe_data_import VALUES (5470, '04/05/2020', '2020-18', '67', '4', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '7.92');
INSERT INTO public.europe_data_import VALUES (5471, '27/04/2020', '2020-17', '85', '7', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '8.39');
INSERT INTO public.europe_data_import VALUES (5472, '20/04/2020', '2020-16', '76', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '10.1');
INSERT INTO public.europe_data_import VALUES (5473, '13/04/2020', '2020-15', '118', '4', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '14.32');
INSERT INTO public.europe_data_import VALUES (5474, '06/04/2020', '2020-14', '157', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '20.52');
INSERT INTO public.europe_data_import VALUES (5475, '30/03/2020', '2020-13', '237', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '17.97');
INSERT INTO public.europe_data_import VALUES (5476, '23/03/2020', '2020-12', '108', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '7.08');
INSERT INTO public.europe_data_import VALUES (5477, '16/03/2020', '2020-11', '28', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '1.61');
INSERT INTO public.europe_data_import VALUES (5478, '09/03/2020', '2020-10', '3', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5479, '01/02/2021', '2021-04', '21455', '762', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '703.65');
INSERT INTO public.europe_data_import VALUES (5480, '25/01/2021', '2021-03', '26785', '455', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '879.57');
INSERT INTO public.europe_data_import VALUES (5481, '18/01/2021', '2021-02', '33516', '259', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '926.73');
INSERT INTO public.europe_data_import VALUES (5482, '11/01/2021', '2021-01', '30018', '107', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '701.17');
INSERT INTO public.europe_data_import VALUES (5483, '04/01/2021', '2020-53', '18052', '105', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '454.72');
INSERT INTO public.europe_data_import VALUES (5484, '28/12/2020', '2020-52', '13122', '113', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '360.37');
INSERT INTO public.europe_data_import VALUES (5485, '21/12/2020', '2020-51', '11584', '81', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '305.6');
INSERT INTO public.europe_data_import VALUES (5486, '14/12/2020', '2020-50', '9367', '101', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '285.54');
INSERT INTO public.europe_data_import VALUES (5487, '07/12/2020', '2020-49', '10209', '95', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '301.6');
INSERT INTO public.europe_data_import VALUES (5488, '30/11/2020', '2020-48', '10468', '104', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '313.81');
INSERT INTO public.europe_data_import VALUES (5489, '23/11/2020', '2020-47', '11046', '83', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '324.4');
INSERT INTO public.europe_data_import VALUES (5490, '16/11/2020', '2020-46', '11194', '94', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '332.76');
INSERT INTO public.europe_data_import VALUES (5491, '09/11/2020', '2020-45', '11619', '80', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '333.24');
INSERT INTO public.europe_data_import VALUES (5492, '02/11/2020', '2020-44', '11227', '78', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '296.56');
INSERT INTO public.europe_data_import VALUES (5493, '26/10/2020', '2020-43', '9104', '45', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '274.69');
INSERT INTO public.europe_data_import VALUES (5494, '19/10/2020', '2020-42', '9728', '65', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '259.7');
INSERT INTO public.europe_data_import VALUES (5495, '12/10/2020', '2020-41', '8076', '49', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '237.82');
INSERT INTO public.europe_data_import VALUES (5496, '05/10/2020', '2020-40', '8228', '59', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '221.41');
INSERT INTO public.europe_data_import VALUES (5497, '28/09/2020', '2020-39', '6951', '50', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '174.22');
INSERT INTO public.europe_data_import VALUES (5498, '21/09/2020', '2020-38', '4993', '56', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '129.48');
INSERT INTO public.europe_data_import VALUES (5499, '14/09/2020', '2020-37', '3884', '50', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '108.52');
INSERT INTO public.europe_data_import VALUES (5500, '07/09/2020', '2020-36', '3556', '31', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '120.12');
INSERT INTO public.europe_data_import VALUES (5501, '31/08/2020', '2020-35', '4679', '39', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '116.53');
INSERT INTO public.europe_data_import VALUES (5502, '24/08/2020', '2020-34', '3310', '18', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '82.76');
INSERT INTO public.europe_data_import VALUES (5503, '17/08/2020', '2020-33', '2364', '27', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '58.29');
INSERT INTO public.europe_data_import VALUES (5504, '10/08/2020', '2020-32', '1632', '14', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '40.36');
INSERT INTO public.europe_data_import VALUES (5505, '03/08/2020', '2020-31', '1135', '11', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '29.55');
INSERT INTO public.europe_data_import VALUES (5506, '27/07/2020', '2020-30', '891', '11', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '20.65');
INSERT INTO public.europe_data_import VALUES (5507, '20/07/2020', '2020-29', '525', '4', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '14.38');
INSERT INTO public.europe_data_import VALUES (5508, '13/07/2020', '2020-28', '461', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '8.66');
INSERT INTO public.europe_data_import VALUES (5509, '06/07/2020', '2020-27', '133', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.17');
INSERT INTO public.europe_data_import VALUES (5510, '29/06/2020', '2020-26', '153', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.29');
INSERT INTO public.europe_data_import VALUES (5511, '22/06/2020', '2020-25', '141', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.73');
INSERT INTO public.europe_data_import VALUES (5512, '15/06/2020', '2020-24', '115', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.3');
INSERT INTO public.europe_data_import VALUES (5513, '08/06/2020', '2020-23', '111', '3', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.17');
INSERT INTO public.europe_data_import VALUES (5514, '01/06/2020', '2020-22', '106', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.51');
INSERT INTO public.europe_data_import VALUES (5515, '25/05/2020', '2020-21', '203', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.92');
INSERT INTO public.europe_data_import VALUES (5516, '18/05/2020', '2020-20', '66', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.54');
INSERT INTO public.europe_data_import VALUES (5517, '11/05/2020', '2020-19', '108', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.01');
INSERT INTO public.europe_data_import VALUES (5518, '04/05/2020', '2020-18', '30', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.93');
INSERT INTO public.europe_data_import VALUES (5519, '27/04/2020', '2020-17', '34', '3', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '1.12');
INSERT INTO public.europe_data_import VALUES (5520, '20/04/2020', '2020-16', '43', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.13');
INSERT INTO public.europe_data_import VALUES (5521, '13/04/2020', '2020-15', '103', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.8');
INSERT INTO public.europe_data_import VALUES (5522, '06/04/2020', '2020-14', '89', '8', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.07');
INSERT INTO public.europe_data_import VALUES (5523, '30/03/2020', '2020-13', '190', '6', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.94');
INSERT INTO public.europe_data_import VALUES (5524, '23/03/2020', '2020-12', '149', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.15');
INSERT INTO public.europe_data_import VALUES (5525, '16/03/2020', '2020-11', '67', '3', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (5526, '09/03/2020', '2020-10', '22', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.45');
INSERT INTO public.europe_data_import VALUES (5527, '02/03/2020', '2020-09', '9', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (5528, '24/02/2020', '2020-08', '1', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5529, '17/02/2020', '2020-07', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5530, '10/02/2020', '2020-06', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5531, '03/02/2020', '2020-05', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5532, '27/01/2020', '2020-04', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5533, '20/01/2020', '2020-03', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5534, '13/01/2020', '2020-02', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5535, '06/01/2020', '2020-01', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5536, '01/02/2021', '2021-04', '622', '37', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '89.73');
INSERT INTO public.europe_data_import VALUES (5537, '25/01/2021', '2021-03', '1285', '30', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '80.88');
INSERT INTO public.europe_data_import VALUES (5538, '18/01/2021', '2021-02', '434', '8', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '148.92');
INSERT INTO public.europe_data_import VALUES (5539, '11/01/2021', '2021-01', '2731', '20', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '140.26');
INSERT INTO public.europe_data_import VALUES (5540, '04/01/2021', '2020-53', '250', '14', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '31.05');
INSERT INTO public.europe_data_import VALUES (5541, '28/12/2020', '2020-52', '410', '3', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '31.57');
INSERT INTO public.europe_data_import VALUES (5542, '21/12/2020', '2020-51', '261', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '18.63');
INSERT INTO public.europe_data_import VALUES (5543, '14/12/2020', '2020-50', '135', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '8.28');
INSERT INTO public.europe_data_import VALUES (5544, '07/12/2020', '2020-49', '41', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '3.06');
INSERT INTO public.europe_data_import VALUES (5545, '30/11/2020', '2020-48', '24', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '3.2');
INSERT INTO public.europe_data_import VALUES (5546, '23/11/2020', '2020-47', '44', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '5.55');
INSERT INTO public.europe_data_import VALUES (5547, '16/11/2020', '2020-46', '74', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '4.42');
INSERT INTO public.europe_data_import VALUES (5548, '09/11/2020', '2020-45', '20', '1', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '1.27');
INSERT INTO public.europe_data_import VALUES (5549, '02/11/2020', '2020-44', '7', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '5.36');
INSERT INTO public.europe_data_import VALUES (5550, '26/10/2020', '2020-43', '107', '1', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '6.35');
INSERT INTO public.europe_data_import VALUES (5551, '19/10/2020', '2020-42', '28', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '7.2');
INSERT INTO public.europe_data_import VALUES (5552, '12/10/2020', '2020-41', '125', '3', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '11.62');
INSERT INTO public.europe_data_import VALUES (5553, '05/10/2020', '2020-40', '122', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '12.05');
INSERT INTO public.europe_data_import VALUES (5554, '28/09/2020', '2020-39', '134', '2', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '14.73');
INSERT INTO public.europe_data_import VALUES (5555, '21/09/2020', '2020-38', '179', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '12.99');
INSERT INTO public.europe_data_import VALUES (5556, '14/09/2020', '2020-37', '97', '2', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '8.42');
INSERT INTO public.europe_data_import VALUES (5557, '07/09/2020', '2020-36', '82', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '6.26');
INSERT INTO public.europe_data_import VALUES (5558, '31/08/2020', '2020-35', '51', '1', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '5.65');
INSERT INTO public.europe_data_import VALUES (5559, '24/08/2020', '2020-34', '69', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '12.85');
INSERT INTO public.europe_data_import VALUES (5560, '17/08/2020', '2020-33', '204', '7', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '10.73');
INSERT INTO public.europe_data_import VALUES (5561, '10/08/2020', '2020-32', '24', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '13.93');
INSERT INTO public.europe_data_import VALUES (5562, '03/08/2020', '2020-31', '272', '8', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '16.89');
INSERT INTO public.europe_data_import VALUES (5563, '27/07/2020', '2020-30', '87', '5', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '10.02');
INSERT INTO public.europe_data_import VALUES (5564, '20/07/2020', '2020-29', '126', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '13.17');
INSERT INTO public.europe_data_import VALUES (5565, '13/07/2020', '2020-28', '154', '2', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '9.69');
INSERT INTO public.europe_data_import VALUES (5566, '06/07/2020', '2020-27', '52', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '3.53');
INSERT INTO public.europe_data_import VALUES (5567, '29/06/2020', '2020-26', '23', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (5568, '22/06/2020', '2020-25', '0', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (5569, '15/06/2020', '2020-24', '0', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (5570, '08/06/2020', '2020-23', '2', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (5571, '01/06/2020', '2020-22', '0', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (5572, '25/05/2020', '2020-21', '1', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (5573, '18/05/2020', '2020-20', '1', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5574, '01/02/2021', '2021-04', '25', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (5575, '25/01/2021', '2021-03', '27', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.31');
INSERT INTO public.europe_data_import VALUES (5576, '18/01/2021', '2021-02', '87', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.76');
INSERT INTO public.europe_data_import VALUES (5577, '11/01/2021', '2021-01', '0', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (5578, '04/01/2021', '2020-53', '0', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (5579, '28/12/2020', '2020-52', '12', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (5580, '21/12/2020', '2020-51', '17', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.27');
INSERT INTO public.europe_data_import VALUES (5581, '14/12/2020', '2020-50', '95', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '3.56');
INSERT INTO public.europe_data_import VALUES (5582, '07/12/2020', '2020-49', '81', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.53');
INSERT INTO public.europe_data_import VALUES (5583, '30/11/2020', '2020-48', '44', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.78');
INSERT INTO public.europe_data_import VALUES (5584, '23/11/2020', '2020-47', '44', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (5585, '16/11/2020', '2020-46', '65', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (5586, '09/11/2020', '2020-45', '16', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (5587, '02/11/2020', '2020-44', '33', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (5588, '26/10/2020', '2020-43', '16', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (5589, '19/10/2020', '2020-42', '14', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (5590, '12/10/2020', '2020-41', '15', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (5591, '05/10/2020', '2020-40', '9', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5592, '28/09/2020', '2020-39', '4', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (5593, '21/09/2020', '2020-38', '16', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (5594, '14/09/2020', '2020-37', '12', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5595, '07/09/2020', '2020-36', '3', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (5596, '31/08/2020', '2020-35', '18', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (5597, '24/08/2020', '2020-34', '29', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (5598, '17/08/2020', '2020-33', '20', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (5599, '10/08/2020', '2020-32', '30', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (5600, '03/08/2020', '2020-31', '45', '5', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.35');
INSERT INTO public.europe_data_import VALUES (5601, '27/07/2020', '2020-30', '71', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '3.08');
INSERT INTO public.europe_data_import VALUES (5602, '20/07/2020', '2020-29', '81', '19', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '4.4');
INSERT INTO public.europe_data_import VALUES (5603, '13/07/2020', '2020-28', '136', '14', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '4.9');
INSERT INTO public.europe_data_import VALUES (5604, '06/07/2020', '2020-27', '106', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '5.02');
INSERT INTO public.europe_data_import VALUES (5605, '29/06/2020', '2020-26', '142', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '6.28');
INSERT INTO public.europe_data_import VALUES (5606, '22/06/2020', '2020-25', '168', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '5.41');
INSERT INTO public.europe_data_import VALUES (5607, '15/06/2020', '2020-24', '99', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '3.44');
INSERT INTO public.europe_data_import VALUES (5608, '08/06/2020', '2020-23', '71', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.9');
INSERT INTO public.europe_data_import VALUES (5609, '01/06/2020', '2020-22', '23', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (5610, '25/05/2020', '2020-21', '39', '5', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (5611, '18/05/2020', '2020-20', '27', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (5612, '11/05/2020', '2020-19', '41', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (5613, '04/05/2020', '2020-18', '34', '6', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (5614, '27/04/2020', '2020-17', '33', '4', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.5');
INSERT INTO public.europe_data_import VALUES (5615, '20/04/2020', '2020-16', '41', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.58');
INSERT INTO public.europe_data_import VALUES (5616, '13/04/2020', '2020-15', '37', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (5617, '06/04/2020', '2020-14', '10', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (5618, '30/03/2020', '2020-13', '0', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (5619, '23/03/2020', '2020-12', '3', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5620, '01/02/2021', '2021-04', '4103', '94', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '140.66');
INSERT INTO public.europe_data_import VALUES (5621, '25/01/2021', '2021-03', '5430', '91', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '146.38');
INSERT INTO public.europe_data_import VALUES (5622, '18/01/2021', '2021-02', '4491', '109', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '116.47');
INSERT INTO public.europe_data_import VALUES (5623, '11/01/2021', '2021-01', '3403', '63', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '103.24');
INSERT INTO public.europe_data_import VALUES (5624, '04/01/2021', '2020-53', '3594', '90', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '99.96');
INSERT INTO public.europe_data_import VALUES (5625, '28/12/2020', '2020-52', '3181', '67', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '112.17');
INSERT INTO public.europe_data_import VALUES (5626, '21/12/2020', '2020-51', '4421', '70', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '127.19');
INSERT INTO public.europe_data_import VALUES (5627, '14/12/2020', '2020-50', '4199', '68', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '123.19');
INSERT INTO public.europe_data_import VALUES (5628, '07/12/2020', '2020-49', '4150', '65', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '129.21');
INSERT INTO public.europe_data_import VALUES (5629, '30/11/2020', '2020-48', '4607', '77', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '130.26');
INSERT INTO public.europe_data_import VALUES (5630, '23/11/2020', '2020-47', '4221', '72', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '143.21');
INSERT INTO public.europe_data_import VALUES (5631, '16/11/2020', '2020-46', '5485', '88', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '170.52');
INSERT INTO public.europe_data_import VALUES (5632, '09/11/2020', '2020-45', '6072', '58', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '178.59');
INSERT INTO public.europe_data_import VALUES (5633, '02/11/2020', '2020-44', '6032', '76', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '195.57');
INSERT INTO public.europe_data_import VALUES (5634, '26/10/2020', '2020-43', '7223', '70', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '196.25');
INSERT INTO public.europe_data_import VALUES (5635, '19/10/2020', '2020-42', '6078', '94', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '176.78');
INSERT INTO public.europe_data_import VALUES (5636, '12/10/2020', '2020-41', '5903', '39', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '152.68');
INSERT INTO public.europe_data_import VALUES (5637, '05/10/2020', '2020-40', '4445', '72', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '130.73');
INSERT INTO public.europe_data_import VALUES (5638, '28/09/2020', '2020-39', '4415', '82', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '141.4');
INSERT INTO public.europe_data_import VALUES (5639, '21/09/2020', '2020-38', '5168', '76', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '150.5');
INSERT INTO public.europe_data_import VALUES (5640, '14/09/2020', '2020-37', '5032', '77', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '138.08');
INSERT INTO public.europe_data_import VALUES (5641, '07/09/2020', '2020-36', '4326', '53', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '107.89');
INSERT INTO public.europe_data_import VALUES (5642, '31/08/2020', '2020-35', '2986', '44', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '83.88');
INSERT INTO public.europe_data_import VALUES (5643, '24/08/2020', '2020-34', '2699', '43', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '76.8');
INSERT INTO public.europe_data_import VALUES (5644, '17/08/2020', '2020-33', '2506', '32', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '59.71');
INSERT INTO public.europe_data_import VALUES (5645, '10/08/2020', '2020-32', '1541', '33', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '39.62');
INSERT INTO public.europe_data_import VALUES (5646, '03/08/2020', '2020-31', '1144', '22', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '26.93');
INSERT INTO public.europe_data_import VALUES (5647, '27/07/2020', '2020-30', '681', '10', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '16.44');
INSERT INTO public.europe_data_import VALUES (5648, '20/07/2020', '2020-29', '433', '9', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '12.94');
INSERT INTO public.europe_data_import VALUES (5649, '13/07/2020', '2020-28', '444', '12', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '9.9');
INSERT INTO public.europe_data_import VALUES (5650, '06/07/2020', '2020-27', '227', '6', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '6.57');
INSERT INTO public.europe_data_import VALUES (5651, '29/06/2020', '2020-26', '218', '11', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '5.08');
INSERT INTO public.europe_data_import VALUES (5652, '22/06/2020', '2020-25', '126', '2', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '4.25');
INSERT INTO public.europe_data_import VALUES (5653, '15/06/2020', '2020-24', '162', '3', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (5654, '08/06/2020', '2020-23', '100', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '2.67');
INSERT INTO public.europe_data_import VALUES (5655, '01/06/2020', '2020-22', '81', '2', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (5656, '25/05/2020', '2020-21', '10', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (5657, '18/05/2020', '2020-20', '1', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (5658, '11/05/2020', '2020-19', '1', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (5659, '04/05/2020', '2020-18', '2', '1', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (5660, '27/04/2020', '2020-17', '12', '1', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (5661, '20/04/2020', '2020-16', '24', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (5662, '13/04/2020', '2020-15', '7', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (5663, '06/04/2020', '2020-14', '10', '1', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (5664, '30/03/2020', '2020-13', '8', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5665, '01/02/2021', '2021-04', '43', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '265.78');
INSERT INTO public.europe_data_import VALUES (5666, '25/01/2021', '2021-03', '59', '2', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '281.41');
INSERT INTO public.europe_data_import VALUES (5667, '18/01/2021', '2021-02', '49', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '450.78');
INSERT INTO public.europe_data_import VALUES (5668, '11/01/2021', '2021-01', '124', '14', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '661.84');
INSERT INTO public.europe_data_import VALUES (5669, '04/01/2021', '2020-53', '130', '8', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1024.02');
INSERT INTO public.europe_data_import VALUES (5670, '28/12/2020', '2020-52', '263', '3', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1506.07');
INSERT INTO public.europe_data_import VALUES (5671, '21/12/2020', '2020-51', '315', '6', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1128.25');
INSERT INTO public.europe_data_import VALUES (5672, '14/12/2020', '2020-50', '118', '2', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '627.96');
INSERT INTO public.europe_data_import VALUES (5673, '07/12/2020', '2020-49', '123', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '740.01');
INSERT INTO public.europe_data_import VALUES (5674, '30/11/2020', '2020-48', '161', '7', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '750.43');
INSERT INTO public.europe_data_import VALUES (5675, '23/11/2020', '2020-47', '127', '4', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '844.23');
INSERT INTO public.europe_data_import VALUES (5676, '16/11/2020', '2020-46', '197', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1130.86');
INSERT INTO public.europe_data_import VALUES (5677, '09/11/2020', '2020-45', '237', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1102.19');
INSERT INTO public.europe_data_import VALUES (5678, '02/11/2020', '2020-44', '186', '2', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '852.05');
INSERT INTO public.europe_data_import VALUES (5679, '26/10/2020', '2020-43', '141', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '591.48');
INSERT INTO public.europe_data_import VALUES (5680, '19/10/2020', '2020-42', '86', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '255.35');
INSERT INTO public.europe_data_import VALUES (5681, '12/10/2020', '2020-41', '12', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '54.72');
INSERT INTO public.europe_data_import VALUES (5682, '05/10/2020', '2020-40', '9', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '36.48');
INSERT INTO public.europe_data_import VALUES (5683, '28/09/2020', '2020-39', '5', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '15.63');
INSERT INTO public.europe_data_import VALUES (5684, '21/09/2020', '2020-38', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '10.42');
INSERT INTO public.europe_data_import VALUES (5685, '14/09/2020', '2020-37', '3', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '7.82');
INSERT INTO public.europe_data_import VALUES (5686, '07/09/2020', '2020-36', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '18.24');
INSERT INTO public.europe_data_import VALUES (5687, '31/08/2020', '2020-35', '7', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '39.08');
INSERT INTO public.europe_data_import VALUES (5688, '24/08/2020', '2020-34', '8', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '31.27');
INSERT INTO public.europe_data_import VALUES (5689, '17/08/2020', '2020-33', '4', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '10.42');
INSERT INTO public.europe_data_import VALUES (5690, '10/08/2020', '2020-32', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5691, '03/08/2020', '2020-31', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5692, '27/07/2020', '2020-30', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5693, '20/07/2020', '2020-29', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '7.82');
INSERT INTO public.europe_data_import VALUES (5694, '13/07/2020', '2020-28', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5695, '06/07/2020', '2020-27', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '2.61');
INSERT INTO public.europe_data_import VALUES (5696, '29/06/2020', '2020-26', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5697, '22/06/2020', '2020-25', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5698, '15/06/2020', '2020-24', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5699, '08/06/2020', '2020-23', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5700, '01/06/2020', '2020-22', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5701, '25/05/2020', '2020-21', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5702, '18/05/2020', '2020-20', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5703, '11/05/2020', '2020-19', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5704, '04/05/2020', '2020-18', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '2.61');
INSERT INTO public.europe_data_import VALUES (5705, '27/04/2020', '2020-17', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '7.82');
INSERT INTO public.europe_data_import VALUES (5706, '20/04/2020', '2020-16', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '10.42');
INSERT INTO public.europe_data_import VALUES (5707, '13/04/2020', '2020-15', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '46.9');
INSERT INTO public.europe_data_import VALUES (5708, '06/04/2020', '2020-14', '16', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '83.38');
INSERT INTO public.europe_data_import VALUES (5709, '30/03/2020', '2020-13', '16', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '143.31');
INSERT INTO public.europe_data_import VALUES (5710, '23/03/2020', '2020-12', '39', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '119.86');
INSERT INTO public.europe_data_import VALUES (5711, '16/03/2020', '2020-11', '7', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5712, '01/02/2021', '2021-04', '5727', '161', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '533.29');
INSERT INTO public.europe_data_import VALUES (5713, '25/01/2021', '2021-03', '9174', '195', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '598.39');
INSERT INTO public.europe_data_import VALUES (5714, '18/01/2021', '2021-02', '7546', '237', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '715.95');
INSERT INTO public.europe_data_import VALUES (5715, '11/01/2021', '2021-01', '12459', '282', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1004.84');
INSERT INTO public.europe_data_import VALUES (5716, '04/01/2021', '2020-53', '15618', '681', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1198.92');
INSERT INTO public.europe_data_import VALUES (5717, '28/12/2020', '2020-52', '17882', '230', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1336.63');
INSERT INTO public.europe_data_import VALUES (5718, '21/12/2020', '2020-51', '19466', '214', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1376.11');
INSERT INTO public.europe_data_import VALUES (5719, '14/12/2020', '2020-50', '18985', '188', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1205.93');
INSERT INTO public.europe_data_import VALUES (5720, '07/12/2020', '2020-49', '14711', '131', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1037.48');
INSERT INTO public.europe_data_import VALUES (5721, '30/11/2020', '2020-48', '14278', '120', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '950.8');
INSERT INTO public.europe_data_import VALUES (5722, '23/11/2020', '2020-47', '12289', '109', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '799.8');
INSERT INTO public.europe_data_import VALUES (5723, '16/11/2020', '2020-46', '10059', '70', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '681.38');
INSERT INTO public.europe_data_import VALUES (5724, '09/11/2020', '2020-45', '8980', '41', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '519.47');
INSERT INTO public.europe_data_import VALUES (5725, '02/11/2020', '2020-44', '5535', '32', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '293.4');
INSERT INTO public.europe_data_import VALUES (5726, '26/10/2020', '2020-43', '2663', '21', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '145.37');
INSERT INTO public.europe_data_import VALUES (5727, '19/10/2020', '2020-42', '1399', '10', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '83.6');
INSERT INTO public.europe_data_import VALUES (5728, '12/10/2020', '2020-41', '937', '9', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '62.16');
INSERT INTO public.europe_data_import VALUES (5729, '05/10/2020', '2020-40', '800', '3', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '51.57');
INSERT INTO public.europe_data_import VALUES (5730, '28/09/2020', '2020-39', '641', '4', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '37.58');
INSERT INTO public.europe_data_import VALUES (5731, '21/09/2020', '2020-38', '409', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '23.66');
INSERT INTO public.europe_data_import VALUES (5732, '14/09/2020', '2020-37', '252', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.5');
INSERT INTO public.europe_data_import VALUES (5733, '07/09/2020', '2020-36', '209', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.03');
INSERT INTO public.europe_data_import VALUES (5734, '31/08/2020', '2020-35', '239', '2', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.39');
INSERT INTO public.europe_data_import VALUES (5735, '24/08/2020', '2020-34', '219', '3', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '13.71');
INSERT INTO public.europe_data_import VALUES (5736, '17/08/2020', '2020-33', '164', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '10.95');
INSERT INTO public.europe_data_import VALUES (5737, '10/08/2020', '2020-32', '142', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '8.73');
INSERT INTO public.europe_data_import VALUES (5738, '03/08/2020', '2020-31', '102', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '6.37');
INSERT INTO public.europe_data_import VALUES (5739, '27/07/2020', '2020-30', '76', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '4.97');
INSERT INTO public.europe_data_import VALUES (5740, '20/07/2020', '2020-29', '63', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.44');
INSERT INTO public.europe_data_import VALUES (5741, '13/07/2020', '2020-28', '33', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.9');
INSERT INTO public.europe_data_import VALUES (5742, '06/07/2020', '2020-27', '20', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.36');
INSERT INTO public.europe_data_import VALUES (5743, '29/06/2020', '2020-26', '18', '2', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.72');
INSERT INTO public.europe_data_import VALUES (5744, '22/06/2020', '2020-25', '30', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.01');
INSERT INTO public.europe_data_import VALUES (5745, '15/06/2020', '2020-24', '54', '4', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.33');
INSERT INTO public.europe_data_import VALUES (5746, '08/06/2020', '2020-23', '39', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.26');
INSERT INTO public.europe_data_import VALUES (5747, '01/06/2020', '2020-22', '52', '7', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '4.8');
INSERT INTO public.europe_data_import VALUES (5748, '25/05/2020', '2020-21', '82', '7', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '5.15');
INSERT INTO public.europe_data_import VALUES (5749, '18/05/2020', '2020-20', '62', '6', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '4.69');
INSERT INTO public.europe_data_import VALUES (5750, '11/05/2020', '2020-19', '69', '4', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.47');
INSERT INTO public.europe_data_import VALUES (5751, '04/05/2020', '2020-18', '-28', '5', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.01');
INSERT INTO public.europe_data_import VALUES (5752, '27/04/2020', '2020-17', '112', '5', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '13.46');
INSERT INTO public.europe_data_import VALUES (5753, '20/04/2020', '2020-16', '264', '12', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '18.43');
INSERT INTO public.europe_data_import VALUES (5754, '13/04/2020', '2020-15', '251', '11', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '20.69');
INSERT INTO public.europe_data_import VALUES (5755, '06/04/2020', '2020-14', '327', '6', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '23.91');
INSERT INTO public.europe_data_import VALUES (5756, '30/03/2020', '2020-13', '341', '6', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.82');
INSERT INTO public.europe_data_import VALUES (5757, '23/03/2020', '2020-12', '129', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '5.08');
INSERT INTO public.europe_data_import VALUES (5758, '16/03/2020', '2020-11', '13', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0.47');
INSERT INTO public.europe_data_import VALUES (5759, '09/03/2020', '2020-10', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0.04');
INSERT INTO public.europe_data_import VALUES (5760, '02/03/2020', '2020-09', '1', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0.04');
INSERT INTO public.europe_data_import VALUES (5761, '24/02/2020', '2020-08', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5762, '17/02/2020', '2020-07', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5763, '10/02/2020', '2020-06', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5764, '03/02/2020', '2020-05', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5765, '27/01/2020', '2020-04', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5766, '20/01/2020', '2020-03', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5767, '13/01/2020', '2020-02', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5768, '06/01/2020', '2020-01', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5769, '01/02/2021', '2021-04', '965', '16', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '295.98');
INSERT INTO public.europe_data_import VALUES (5770, '25/01/2021', '2021-03', '852', '12', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '280.18');
INSERT INTO public.europe_data_import VALUES (5771, '18/01/2021', '2021-02', '868', '19', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '314.88');
INSERT INTO public.europe_data_import VALUES (5772, '11/01/2021', '2021-01', '1065', '27', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '347.78');
INSERT INTO public.europe_data_import VALUES (5773, '04/01/2021', '2020-53', '1070', '19', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '464.58');
INSERT INTO public.europe_data_import VALUES (5774, '28/12/2020', '2020-52', '1782', '47', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '745.57');
INSERT INTO public.europe_data_import VALUES (5775, '21/12/2020', '2020-51', '2795', '44', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1039.76');
INSERT INTO public.europe_data_import VALUES (5776, '14/12/2020', '2020-50', '3588', '46', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1188.97');
INSERT INTO public.europe_data_import VALUES (5777, '07/12/2020', '2020-49', '3711', '44', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1197.44');
INSERT INTO public.europe_data_import VALUES (5778, '30/11/2020', '2020-48', '3640', '44', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1210.14');
INSERT INTO public.europe_data_import VALUES (5779, '23/11/2020', '2020-47', '3789', '40', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1279.05');
INSERT INTO public.europe_data_import VALUES (5780, '16/11/2020', '2020-46', '4063', '37', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1264.39');
INSERT INTO public.europe_data_import VALUES (5781, '09/11/2020', '2020-45', '3699', '25', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1348.28');
INSERT INTO public.europe_data_import VALUES (5782, '02/11/2020', '2020-44', '4578', '15', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1325.31');
INSERT INTO public.europe_data_import VALUES (5783, '26/10/2020', '2020-43', '3558', '12', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '789.06');
INSERT INTO public.europe_data_import VALUES (5784, '19/10/2020', '2020-42', '1286', '3', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '315.53');
INSERT INTO public.europe_data_import VALUES (5785, '12/10/2020', '2020-41', '651', '5', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '163.38');
INSERT INTO public.europe_data_import VALUES (5786, '05/10/2020', '2020-40', '352', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '147.42');
INSERT INTO public.europe_data_import VALUES (5787, '28/09/2020', '2020-39', '553', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '189.45');
INSERT INTO public.europe_data_import VALUES (5788, '21/09/2020', '2020-38', '610', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '147.91');
INSERT INTO public.europe_data_import VALUES (5789, '14/09/2020', '2020-37', '298', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '92.69');
INSERT INTO public.europe_data_import VALUES (5790, '07/09/2020', '2020-36', '271', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '-131.62');
INSERT INTO public.europe_data_import VALUES (5791, '31/08/2020', '2020-35', '-1079', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '-132.6');
INSERT INTO public.europe_data_import VALUES (5792, '24/08/2020', '2020-34', '265', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '96.27');
INSERT INTO public.europe_data_import VALUES (5793, '17/08/2020', '2020-33', '326', '4', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '121.19');
INSERT INTO public.europe_data_import VALUES (5794, '10/08/2020', '2020-32', '418', '2', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '136.99');
INSERT INTO public.europe_data_import VALUES (5795, '03/08/2020', '2020-31', '423', '5', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '197.43');
INSERT INTO public.europe_data_import VALUES (5796, '27/07/2020', '2020-30', '789', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '219.42');
INSERT INTO public.europe_data_import VALUES (5797, '20/07/2020', '2020-29', '558', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '156.54');
INSERT INTO public.europe_data_import VALUES (5798, '13/07/2020', '2020-28', '403', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '111.26');
INSERT INTO public.europe_data_import VALUES (5799, '06/07/2020', '2020-27', '280', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '65.48');
INSERT INTO public.europe_data_import VALUES (5800, '29/06/2020', '2020-26', '122', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '28.02');
INSERT INTO public.europe_data_import VALUES (5801, '22/06/2020', '2020-25', '50', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '13.19');
INSERT INTO public.europe_data_import VALUES (5802, '15/06/2020', '2020-24', '31', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '8.47');
INSERT INTO public.europe_data_import VALUES (5803, '08/06/2020', '2020-23', '21', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '7.66');
INSERT INTO public.europe_data_import VALUES (5804, '01/06/2020', '2020-22', '26', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '11.89');
INSERT INTO public.europe_data_import VALUES (5805, '25/05/2020', '2020-21', '47', '3', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '17.27');
INSERT INTO public.europe_data_import VALUES (5806, '18/05/2020', '2020-20', '59', '6', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '19.71');
INSERT INTO public.europe_data_import VALUES (5807, '11/05/2020', '2020-19', '62', '5', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '26.55');
INSERT INTO public.europe_data_import VALUES (5808, '04/05/2020', '2020-18', '101', '8', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '44.63');
INSERT INTO public.europe_data_import VALUES (5809, '27/04/2020', '2020-17', '173', '15', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '72.0');
INSERT INTO public.europe_data_import VALUES (5810, '20/04/2020', '2020-16', '269', '7', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '121.52');
INSERT INTO public.europe_data_import VALUES (5811, '13/04/2020', '2020-15', '477', '30', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '216.81');
INSERT INTO public.europe_data_import VALUES (5812, '06/04/2020', '2020-14', '854', '15', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '326.77');
INSERT INTO public.europe_data_import VALUES (5813, '30/03/2020', '2020-13', '1152', '13', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '305.1');
INSERT INTO public.europe_data_import VALUES (5814, '23/03/2020', '2020-12', '721', '7', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '129.18');
INSERT INTO public.europe_data_import VALUES (5815, '16/03/2020', '2020-11', '72', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '12.38');
INSERT INTO public.europe_data_import VALUES (5816, '09/03/2020', '2020-10', '4', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0.81');
INSERT INTO public.europe_data_import VALUES (5817, '02/03/2020', '2020-09', '1', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (5818, '24/02/2020', '2020-08', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5819, '17/02/2020', '2020-07', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5820, '10/02/2020', '2020-06', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5821, '03/02/2020', '2020-05', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5822, '27/01/2020', '2020-04', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5823, '20/01/2020', '2020-03', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5824, '13/01/2020', '2020-02', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5825, '06/01/2020', '2020-01', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5826, '01/02/2021', '2021-04', '322', '2', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.83');
INSERT INTO public.europe_data_import VALUES (5827, '25/01/2021', '2021-03', '442', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.75');
INSERT INTO public.europe_data_import VALUES (5828, '18/01/2021', '2021-02', '300', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (5829, '11/01/2021', '2021-01', '234', '5', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (5830, '04/01/2021', '2020-53', '53', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (5831, '28/12/2020', '2020-52', '81', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5832, '21/12/2020', '2020-51', '0', '2', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (5833, '14/12/2020', '2020-50', '120', '3', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (5834, '07/12/2020', '2020-49', '172', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.64');
INSERT INTO public.europe_data_import VALUES (5835, '30/11/2020', '2020-48', '0', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (5836, '23/11/2020', '2020-47', '108', '2', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (5837, '16/11/2020', '2020-46', '10', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (5838, '09/11/2020', '2020-45', '112', '5', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (5839, '02/11/2020', '2020-44', '143', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.12');
INSERT INTO public.europe_data_import VALUES (5840, '26/10/2020', '2020-43', '158', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (5841, '19/10/2020', '2020-42', '92', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (5842, '12/10/2020', '2020-41', '160', '5', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.61');
INSERT INTO public.europe_data_import VALUES (5843, '05/10/2020', '2020-40', '273', '3', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.87');
INSERT INTO public.europe_data_import VALUES (5844, '28/09/2020', '2020-39', '232', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.96');
INSERT INTO public.europe_data_import VALUES (5845, '21/09/2020', '2020-38', '296', '12', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (5846, '14/09/2020', '2020-37', '438', '11', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (5847, '07/09/2020', '2020-36', '476', '9', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '3.68');
INSERT INTO public.europe_data_import VALUES (5848, '31/08/2020', '2020-35', '516', '13', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '3.77');
INSERT INTO public.europe_data_import VALUES (5849, '24/08/2020', '2020-34', '500', '8', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (5850, '17/08/2020', '2020-33', '741', '22', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '8.52');
INSERT INTO public.europe_data_import VALUES (5851, '10/08/2020', '2020-32', '1558', '34', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '14.06');
INSERT INTO public.europe_data_import VALUES (5852, '03/08/2020', '2020-31', '2233', '29', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '16.61');
INSERT INTO public.europe_data_import VALUES (5853, '27/07/2020', '2020-30', '2246', '26', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '16.42');
INSERT INTO public.europe_data_import VALUES (5854, '20/07/2020', '2020-29', '2182', '24', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '16.02');
INSERT INTO public.europe_data_import VALUES (5855, '13/07/2020', '2020-28', '2139', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '10.34');
INSERT INTO public.europe_data_import VALUES (5856, '06/07/2020', '2020-27', '650', '11', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '4.2');
INSERT INTO public.europe_data_import VALUES (5857, '29/06/2020', '2020-26', '482', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.99');
INSERT INTO public.europe_data_import VALUES (5858, '22/06/2020', '2020-25', '324', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.02');
INSERT INTO public.europe_data_import VALUES (5859, '15/06/2020', '2020-24', '220', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (5860, '08/06/2020', '2020-23', '281', '3', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (5861, '01/06/2020', '2020-22', '244', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (5862, '25/05/2020', '2020-21', '223', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.32');
INSERT INTO public.europe_data_import VALUES (5863, '18/05/2020', '2020-20', '133', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (5864, '11/05/2020', '2020-19', '22', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (5865, '04/05/2020', '2020-18', '25', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (5866, '27/04/2020', '2020-17', '3', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5867, '20/04/2020', '2020-16', '15', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (5868, '13/04/2020', '2020-15', '34', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5869, '06/04/2020', '2020-14', '35', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5870, '30/03/2020', '2020-13', '34', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (5871, '23/03/2020', '2020-12', '3', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5872, '01/02/2021', '2021-04', '4378', '194', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '63.85');
INSERT INTO public.europe_data_import VALUES (5873, '25/01/2021', '2021-03', '7517', '204', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '61.26');
INSERT INTO public.europe_data_import VALUES (5874, '18/01/2021', '2021-02', '3895', '89', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '30.2');
INSERT INTO public.europe_data_import VALUES (5875, '11/01/2021', '2021-01', '1731', '30', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '11.8');
INSERT INTO public.europe_data_import VALUES (5876, '04/01/2021', '2020-53', '467', '7', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (5877, '28/12/2020', '2020-52', '216', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (5878, '21/12/2020', '2020-51', '95', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (5879, '14/12/2020', '2020-50', '15', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.22');
INSERT INTO public.europe_data_import VALUES (5880, '07/12/2020', '2020-49', '26', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5881, '30/11/2020', '2020-48', '22', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (5882, '23/11/2020', '2020-47', '38', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (5883, '16/11/2020', '2020-46', '14', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (5884, '09/11/2020', '2020-45', '19', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.33');
INSERT INTO public.europe_data_import VALUES (5885, '02/11/2020', '2020-44', '42', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (5886, '26/10/2020', '2020-43', '33', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (5887, '19/10/2020', '2020-42', '36', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (5888, '12/10/2020', '2020-41', '35', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (5889, '05/10/2020', '2020-40', '18', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5890, '28/09/2020', '2020-39', '37', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (5891, '21/09/2020', '2020-38', '41', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (5892, '14/09/2020', '2020-37', '76', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (5893, '07/09/2020', '2020-36', '78', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.57');
INSERT INTO public.europe_data_import VALUES (5894, '31/08/2020', '2020-35', '214', '8', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '2.49');
INSERT INTO public.europe_data_import VALUES (5895, '24/08/2020', '2020-34', '250', '5', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '3.56');
INSERT INTO public.europe_data_import VALUES (5896, '17/08/2020', '2020-33', '414', '15', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '4.51');
INSERT INTO public.europe_data_import VALUES (5897, '10/08/2020', '2020-32', '427', '23', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '5.46');
INSERT INTO public.europe_data_import VALUES (5898, '03/08/2020', '2020-31', '591', '24', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.65');
INSERT INTO public.europe_data_import VALUES (5899, '27/07/2020', '2020-30', '648', '37', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.85');
INSERT INTO public.europe_data_import VALUES (5900, '20/07/2020', '2020-29', '628', '24', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.71');
INSERT INTO public.europe_data_import VALUES (5901, '13/07/2020', '2020-28', '622', '19', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.54');
INSERT INTO public.europe_data_import VALUES (5902, '06/07/2020', '2020-27', '596', '6', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '5.43');
INSERT INTO public.europe_data_import VALUES (5903, '29/06/2020', '2020-26', '416', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '3.22');
INSERT INTO public.europe_data_import VALUES (5904, '22/06/2020', '2020-25', '183', '5', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.57');
INSERT INTO public.europe_data_import VALUES (5905, '15/06/2020', '2020-24', '109', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (5906, '08/06/2020', '2020-23', '154', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.91');
INSERT INTO public.europe_data_import VALUES (5907, '01/06/2020', '2020-22', '201', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.15');
INSERT INTO public.europe_data_import VALUES (5908, '25/05/2020', '2020-21', '13', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (5909, '18/05/2020', '2020-20', '14', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (5910, '11/05/2020', '2020-19', '17', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (5911, '04/05/2020', '2020-18', '5', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (5912, '27/04/2020', '2020-17', '17', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (5913, '20/04/2020', '2020-16', '4', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5914, '13/04/2020', '2020-15', '9', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5915, '06/04/2020', '2020-14', '4', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5916, '01/02/2021', '2021-04', '31158', '82', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '176.92');
INSERT INTO public.europe_data_import VALUES (5917, '25/01/2021', '2021-03', '25367', '77', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '149.64');
INSERT INTO public.europe_data_import VALUES (5918, '18/01/2021', '2021-02', '22442', '50', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '117.73');
INSERT INTO public.europe_data_import VALUES (5919, '11/01/2021', '2021-01', '15174', '50', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '96.7');
INSERT INTO public.europe_data_import VALUES (5920, '04/01/2021', '2020-53', '15722', '49', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '86.1');
INSERT INTO public.europe_data_import VALUES (5921, '28/12/2020', '2020-52', '11787', '15', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '67.67');
INSERT INTO public.europe_data_import VALUES (5922, '21/12/2020', '2020-51', '9834', '22', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '64.52');
INSERT INTO public.europe_data_import VALUES (5923, '14/12/2020', '2020-50', '10781', '33', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '59.44');
INSERT INTO public.europe_data_import VALUES (5924, '07/12/2020', '2020-49', '8209', '25', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '56.08');
INSERT INTO public.europe_data_import VALUES (5925, '30/11/2020', '2020-48', '9710', '22', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '53.42');
INSERT INTO public.europe_data_import VALUES (5926, '23/11/2020', '2020-47', '7358', '26', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '45.59');
INSERT INTO public.europe_data_import VALUES (5927, '16/11/2020', '2020-46', '7208', '23', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '46.67');
INSERT INTO public.europe_data_import VALUES (5928, '09/11/2020', '2020-45', '7704', '37', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '42.7');
INSERT INTO public.europe_data_import VALUES (5929, '02/11/2020', '2020-44', '5940', '20', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '37.58');
INSERT INTO public.europe_data_import VALUES (5930, '26/10/2020', '2020-43', '6067', '42', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '34.14');
INSERT INTO public.europe_data_import VALUES (5931, '19/10/2020', '2020-42', '4841', '30', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '25.41');
INSERT INTO public.europe_data_import VALUES (5932, '12/10/2020', '2020-41', '3276', '20', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '14.83');
INSERT INTO public.europe_data_import VALUES (5933, '05/10/2020', '2020-40', '1462', '3', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '6.77');
INSERT INTO public.europe_data_import VALUES (5934, '28/09/2020', '2020-39', '700', '4', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.14');
INSERT INTO public.europe_data_import VALUES (5935, '21/09/2020', '2020-38', '304', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.57');
INSERT INTO public.europe_data_import VALUES (5936, '14/09/2020', '2020-37', '518', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.82');
INSERT INTO public.europe_data_import VALUES (5937, '07/09/2020', '2020-36', '63', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.41');
INSERT INTO public.europe_data_import VALUES (5938, '31/08/2020', '2020-35', '67', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (5939, '24/08/2020', '2020-34', '67', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (5940, '17/08/2020', '2020-33', '117', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.63');
INSERT INTO public.europe_data_import VALUES (5941, '10/08/2020', '2020-32', '84', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (5942, '03/08/2020', '2020-31', '102', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (5943, '27/07/2020', '2020-30', '118', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.56');
INSERT INTO public.europe_data_import VALUES (5944, '20/07/2020', '2020-29', '61', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.38');
INSERT INTO public.europe_data_import VALUES (5945, '13/07/2020', '2020-28', '60', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (5946, '06/07/2020', '2020-27', '24', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (5947, '29/06/2020', '2020-26', '62', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (5948, '22/06/2020', '2020-25', '119', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (5949, '15/06/2020', '2020-24', '131', '4', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.98');
INSERT INTO public.europe_data_import VALUES (5950, '08/06/2020', '2020-23', '503', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.37');
INSERT INTO public.europe_data_import VALUES (5951, '01/06/2020', '2020-22', '574', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.9');
INSERT INTO public.europe_data_import VALUES (5952, '25/05/2020', '2020-21', '351', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.84');
INSERT INTO public.europe_data_import VALUES (5953, '18/05/2020', '2020-20', '238', '5', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.87');
INSERT INTO public.europe_data_import VALUES (5954, '11/05/2020', '2020-19', '358', '3', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.74');
INSERT INTO public.europe_data_import VALUES (5955, '04/05/2020', '2020-18', '518', '7', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.85');
INSERT INTO public.europe_data_import VALUES (5956, '27/04/2020', '2020-17', '391', '9', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.43');
INSERT INTO public.europe_data_import VALUES (5957, '20/04/2020', '2020-16', '706', '13', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '5.41');
INSERT INTO public.europe_data_import VALUES (5958, '13/04/2020', '2020-15', '1021', '15', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '6.93');
INSERT INTO public.europe_data_import VALUES (5959, '06/04/2020', '2020-14', '1192', '27', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '7.37');
INSERT INTO public.europe_data_import VALUES (5960, '30/03/2020', '2020-13', '1164', '24', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '6.39');
INSERT INTO public.europe_data_import VALUES (5961, '23/03/2020', '2020-12', '878', '10', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.78');
INSERT INTO public.europe_data_import VALUES (5962, '16/03/2020', '2020-11', '329', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.25');
INSERT INTO public.europe_data_import VALUES (5963, '09/03/2020', '2020-10', '70', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (5964, '02/03/2020', '2020-09', '7', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (5965, '24/02/2020', '2020-08', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5966, '17/02/2020', '2020-07', '4', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5967, '10/02/2020', '2020-06', '10', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5968, '03/02/2020', '2020-05', '4', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5969, '27/01/2020', '2020-04', '4', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5970, '20/01/2020', '2020-03', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5971, '13/01/2020', '2020-02', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5972, '06/01/2020', '2020-01', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5973, '01/02/2021', '2021-04', '848', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '250.11');
INSERT INTO public.europe_data_import VALUES (5974, '25/01/2021', '2021-03', '480', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '166.49');
INSERT INTO public.europe_data_import VALUES (5975, '18/01/2021', '2021-02', '404', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '121.67');
INSERT INTO public.europe_data_import VALUES (5976, '11/01/2021', '2021-01', '242', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '87.58');
INSERT INTO public.europe_data_import VALUES (5977, '04/01/2021', '2020-53', '223', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '70.44');
INSERT INTO public.europe_data_import VALUES (5978, '28/12/2020', '2020-52', '151', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '51.98');
INSERT INTO public.europe_data_import VALUES (5979, '21/12/2020', '2020-51', '125', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '55.56');
INSERT INTO public.europe_data_import VALUES (5980, '14/12/2020', '2020-50', '170', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '70.44');
INSERT INTO public.europe_data_import VALUES (5981, '07/12/2020', '2020-49', '204', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '111.12');
INSERT INTO public.europe_data_import VALUES (5982, '30/11/2020', '2020-48', '386', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '148.79');
INSERT INTO public.europe_data_import VALUES (5983, '23/11/2020', '2020-47', '404', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '117.15');
INSERT INTO public.europe_data_import VALUES (5984, '16/11/2020', '2020-46', '218', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '94.73');
INSERT INTO public.europe_data_import VALUES (5985, '09/11/2020', '2020-45', '285', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '90.59');
INSERT INTO public.europe_data_import VALUES (5986, '02/11/2020', '2020-44', '196', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '92.47');
INSERT INTO public.europe_data_import VALUES (5987, '26/10/2020', '2020-43', '295', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '115.08');
INSERT INTO public.europe_data_import VALUES (5988, '19/10/2020', '2020-42', '316', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '128.07');
INSERT INTO public.europe_data_import VALUES (5989, '12/10/2020', '2020-41', '364', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '149.92');
INSERT INTO public.europe_data_import VALUES (5990, '05/10/2020', '2020-40', '432', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '151.8');
INSERT INTO public.europe_data_import VALUES (5991, '28/09/2020', '2020-39', '374', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '174.21');
INSERT INTO public.europe_data_import VALUES (5992, '21/09/2020', '2020-38', '551', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '214.71');
INSERT INTO public.europe_data_import VALUES (5993, '14/09/2020', '2020-37', '589', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '283.64');
INSERT INTO public.europe_data_import VALUES (5994, '07/09/2020', '2020-36', '917', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '339.95');
INSERT INTO public.europe_data_import VALUES (5995, '31/08/2020', '2020-35', '888', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '354.45');
INSERT INTO public.europe_data_import VALUES (5996, '24/08/2020', '2020-34', '994', '4', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '327.33');
INSERT INTO public.europe_data_import VALUES (5997, '17/08/2020', '2020-33', '744', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '305.3');
INSERT INTO public.europe_data_import VALUES (5998, '10/08/2020', '2020-32', '877', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '327.52');
INSERT INTO public.europe_data_import VALUES (5999, '03/08/2020', '2020-31', '862', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '225.63');
INSERT INTO public.europe_data_import VALUES (6000, '27/07/2020', '2020-30', '336', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '107.54');
INSERT INTO public.europe_data_import VALUES (6001, '20/07/2020', '2020-29', '235', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '93.79');
INSERT INTO public.europe_data_import VALUES (6002, '13/07/2020', '2020-28', '263', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '76.84');
INSERT INTO public.europe_data_import VALUES (6003, '06/07/2020', '2020-27', '145', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '49.91');
INSERT INTO public.europe_data_import VALUES (6004, '29/06/2020', '2020-26', '120', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '54.24');
INSERT INTO public.europe_data_import VALUES (6005, '22/06/2020', '2020-25', '168', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '56.5');
INSERT INTO public.europe_data_import VALUES (6006, '15/06/2020', '2020-24', '132', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '49.34');
INSERT INTO public.europe_data_import VALUES (6007, '08/06/2020', '2020-23', '130', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '100.2');
INSERT INTO public.europe_data_import VALUES (6008, '01/06/2020', '2020-22', '402', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '127.88');
INSERT INTO public.europe_data_import VALUES (6009, '25/05/2020', '2020-21', '277', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '100.95');
INSERT INTO public.europe_data_import VALUES (6010, '18/05/2020', '2020-20', '259', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '106.79');
INSERT INTO public.europe_data_import VALUES (6011, '11/05/2020', '2020-19', '308', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '116.96');
INSERT INTO public.europe_data_import VALUES (6012, '04/05/2020', '2020-18', '313', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '89.46');
INSERT INTO public.europe_data_import VALUES (6013, '27/04/2020', '2020-17', '162', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '36.54');
INSERT INTO public.europe_data_import VALUES (6014, '20/04/2020', '2020-16', '32', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '6.22');
INSERT INTO public.europe_data_import VALUES (6015, '13/04/2020', '2020-15', '1', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (6016, '06/04/2020', '2020-14', '2', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '1.13');
INSERT INTO public.europe_data_import VALUES (6017, '30/03/2020', '2020-13', '4', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '0.75');
INSERT INTO public.europe_data_import VALUES (6018, '23/03/2020', '2020-12', '0', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '1.7');
INSERT INTO public.europe_data_import VALUES (6019, '16/03/2020', '2020-11', '9', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '2.45');
INSERT INTO public.europe_data_import VALUES (6020, '09/03/2020', '2020-10', '4', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6021, '01/02/2021', '2021-04', '117', '8', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.33');
INSERT INTO public.europe_data_import VALUES (6022, '25/01/2021', '2021-03', '144', '11', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (6023, '18/01/2021', '2021-02', '239', '13', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.98');
INSERT INTO public.europe_data_import VALUES (6024, '11/01/2021', '2021-01', '347', '20', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.56');
INSERT INTO public.europe_data_import VALUES (6025, '04/01/2021', '2020-53', '550', '22', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '5.4');
INSERT INTO public.europe_data_import VALUES (6026, '28/12/2020', '2020-52', '512', '34', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.52');
INSERT INTO public.europe_data_import VALUES (6027, '21/12/2020', '2020-51', '377', '28', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '5.37');
INSERT INTO public.europe_data_import VALUES (6028, '14/12/2020', '2020-50', '679', '30', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '5.88');
INSERT INTO public.europe_data_import VALUES (6029, '07/12/2020', '2020-49', '476', '15', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.73');
INSERT INTO public.europe_data_import VALUES (6030, '30/11/2020', '2020-48', '453', '6', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.02');
INSERT INTO public.europe_data_import VALUES (6031, '23/11/2020', '2020-47', '338', '4', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (6032, '16/11/2020', '2020-46', '192', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (6033, '09/11/2020', '2020-45', '131', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (6034, '02/11/2020', '2020-44', '55', '3', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (6035, '26/10/2020', '2020-43', '111', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (6036, '19/10/2020', '2020-42', '93', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (6037, '12/10/2020', '2020-41', '102', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (6038, '05/10/2020', '2020-40', '98', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6039, '28/09/2020', '2020-39', '73', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (6040, '21/09/2020', '2020-38', '89', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6041, '14/09/2020', '2020-37', '82', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (6042, '07/09/2020', '2020-36', '69', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (6043, '31/08/2020', '2020-35', '68', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (6044, '24/08/2020', '2020-34', '91', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (6045, '17/08/2020', '2020-33', '47', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (6046, '10/08/2020', '2020-32', '26', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (6047, '03/08/2020', '2020-31', '31', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (6048, '27/07/2020', '2020-30', '35', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (6049, '20/07/2020', '2020-29', '64', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (6050, '13/07/2020', '2020-28', '81', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (6051, '06/07/2020', '2020-27', '183', '5', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (6052, '29/06/2020', '2020-26', '186', '3', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (6053, '22/06/2020', '2020-25', '152', '7', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.18');
INSERT INTO public.europe_data_import VALUES (6054, '15/06/2020', '2020-24', '276', '12', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (6055, '08/06/2020', '2020-23', '268', '15', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.56');
INSERT INTO public.europe_data_import VALUES (6056, '01/06/2020', '2020-22', '235', '12', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.06');
INSERT INTO public.europe_data_import VALUES (6057, '25/05/2020', '2020-21', '170', '13', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.66');
INSERT INTO public.europe_data_import VALUES (6058, '18/05/2020', '2020-20', '156', '14', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.51');
INSERT INTO public.europe_data_import VALUES (6059, '11/05/2020', '2020-19', '141', '11', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.6');
INSERT INTO public.europe_data_import VALUES (6060, '04/05/2020', '2020-18', '174', '4', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (6061, '27/04/2020', '2020-17', '165', '9', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (6062, '20/04/2020', '2020-16', '108', '5', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (6063, '13/04/2020', '2020-15', '71', '4', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (6064, '06/04/2020', '2020-14', '27', '5', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (6065, '30/03/2020', '2020-13', '18', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6066, '01/02/2021', '2021-04', '1177', '22', '493559', 'Malta', 'MT', 'MLT', 'Europe', '465.19');
INSERT INTO public.europe_data_import VALUES (6067, '25/01/2021', '2021-03', '1119', '12', '493559', 'Malta', 'MT', 'MLT', 'Europe', '472.49');
INSERT INTO public.europe_data_import VALUES (6068, '18/01/2021', '2021-02', '1213', '7', '493559', 'Malta', 'MT', 'MLT', 'Europe', '508.96');
INSERT INTO public.europe_data_import VALUES (6069, '11/01/2021', '2021-01', '1299', '11', '493559', 'Malta', 'MT', 'MLT', 'Europe', '426.09');
INSERT INTO public.europe_data_import VALUES (6070, '04/01/2021', '2020-53', '804', '6', '493559', 'Malta', 'MT', 'MLT', 'Europe', '289.33');
INSERT INTO public.europe_data_import VALUES (6071, '28/12/2020', '2020-52', '624', '20', '493559', 'Malta', 'MT', 'MLT', 'Europe', '237.46');
INSERT INTO public.europe_data_import VALUES (6072, '21/12/2020', '2020-51', '548', '20', '493559', 'Malta', 'MT', 'MLT', 'Europe', '231.58');
INSERT INTO public.europe_data_import VALUES (6073, '14/12/2020', '2020-50', '595', '21', '493559', 'Malta', 'MT', 'MLT', 'Europe', '279.8');
INSERT INTO public.europe_data_import VALUES (6074, '07/12/2020', '2020-49', '786', '15', '493559', 'Malta', 'MT', 'MLT', 'Europe', '335.32');
INSERT INTO public.europe_data_import VALUES (6075, '30/11/2020', '2020-48', '869', '25', '493559', 'Malta', 'MT', 'MLT', 'Europe', '351.73');
INSERT INTO public.europe_data_import VALUES (6076, '23/11/2020', '2020-47', '867', '15', '493559', 'Malta', 'MT', 'MLT', 'Europe', '356.8');
INSERT INTO public.europe_data_import VALUES (6077, '16/11/2020', '2020-46', '894', '20', '493559', 'Malta', 'MT', 'MLT', 'Europe', '351.73');
INSERT INTO public.europe_data_import VALUES (6078, '09/11/2020', '2020-45', '842', '14', '493559', 'Malta', 'MT', 'MLT', 'Europe', '337.35');
INSERT INTO public.europe_data_import VALUES (6079, '02/11/2020', '2020-44', '823', '8', '493559', 'Malta', 'MT', 'MLT', 'Europe', '336.54');
INSERT INTO public.europe_data_import VALUES (6080, '26/10/2020', '2020-43', '838', '8', '493559', 'Malta', 'MT', 'MLT', 'Europe', '350.92');
INSERT INTO public.europe_data_import VALUES (6081, '19/10/2020', '2020-42', '894', '2', '493559', 'Malta', 'MT', 'MLT', 'Europe', '285.88');
INSERT INTO public.europe_data_import VALUES (6082, '12/10/2020', '2020-41', '517', '4', '493559', 'Malta', 'MT', 'MLT', 'Europe', '167.76');
INSERT INTO public.europe_data_import VALUES (6083, '05/10/2020', '2020-40', '311', '7', '493559', 'Malta', 'MT', 'MLT', 'Europe', '109.61');
INSERT INTO public.europe_data_import VALUES (6084, '28/09/2020', '2020-39', '230', '11', '493559', 'Malta', 'MT', 'MLT', 'Europe', '121.77');
INSERT INTO public.europe_data_import VALUES (6085, '21/09/2020', '2020-38', '371', '6', '493559', 'Malta', 'MT', 'MLT', 'Europe', '141.83');
INSERT INTO public.europe_data_import VALUES (6086, '14/09/2020', '2020-37', '329', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '105.56');
INSERT INTO public.europe_data_import VALUES (6087, '07/09/2020', '2020-36', '192', '2', '493559', 'Malta', 'MT', 'MLT', 'Europe', '82.87');
INSERT INTO public.europe_data_import VALUES (6088, '31/08/2020', '2020-35', '217', '2', '493559', 'Malta', 'MT', 'MLT', 'Europe', '103.74');
INSERT INTO public.europe_data_import VALUES (6089, '24/08/2020', '2020-34', '295', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '134.13');
INSERT INTO public.europe_data_import VALUES (6090, '17/08/2020', '2020-33', '367', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '119.54');
INSERT INTO public.europe_data_import VALUES (6091, '10/08/2020', '2020-32', '223', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '62.2');
INSERT INTO public.europe_data_import VALUES (6092, '03/08/2020', '2020-31', '84', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '21.88');
INSERT INTO public.europe_data_import VALUES (6093, '27/07/2020', '2020-30', '24', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '5.27');
INSERT INTO public.europe_data_import VALUES (6094, '20/07/2020', '2020-29', '2', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '0.81');
INSERT INTO public.europe_data_import VALUES (6095, '13/07/2020', '2020-28', '2', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '0.81');
INSERT INTO public.europe_data_import VALUES (6096, '06/07/2020', '2020-27', '2', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '1.42');
INSERT INTO public.europe_data_import VALUES (6097, '29/06/2020', '2020-26', '5', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '4.05');
INSERT INTO public.europe_data_import VALUES (6098, '22/06/2020', '2020-25', '15', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (6099, '15/06/2020', '2020-24', '20', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '6.28');
INSERT INTO public.europe_data_import VALUES (6100, '08/06/2020', '2020-23', '11', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '3.85');
INSERT INTO public.europe_data_import VALUES (6101, '01/06/2020', '2020-22', '8', '3', '493559', 'Malta', 'MT', 'MLT', 'Europe', '12.36');
INSERT INTO public.europe_data_import VALUES (6102, '25/05/2020', '2020-21', '53', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '21.88');
INSERT INTO public.europe_data_import VALUES (6103, '18/05/2020', '2020-20', '55', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '15.8');
INSERT INTO public.europe_data_import VALUES (6104, '11/05/2020', '2020-19', '23', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '10.74');
INSERT INTO public.europe_data_import VALUES (6105, '04/05/2020', '2020-18', '30', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '9.73');
INSERT INTO public.europe_data_import VALUES (6106, '27/04/2020', '2020-17', '18', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '13.17');
INSERT INTO public.europe_data_import VALUES (6107, '20/04/2020', '2020-16', '47', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '38.5');
INSERT INTO public.europe_data_import VALUES (6108, '13/04/2020', '2020-15', '143', '3', '493559', 'Malta', 'MT', 'MLT', 'Europe', '46.2');
INSERT INTO public.europe_data_import VALUES (6109, '06/04/2020', '2020-14', '85', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '27.15');
INSERT INTO public.europe_data_import VALUES (6110, '30/03/2020', '2020-13', '49', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '25.53');
INSERT INTO public.europe_data_import VALUES (6111, '23/03/2020', '2020-12', '77', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '21.07');
INSERT INTO public.europe_data_import VALUES (6112, '16/03/2020', '2020-11', '27', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '6.08');
INSERT INTO public.europe_data_import VALUES (6113, '09/03/2020', '2020-10', '3', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6114, '01/02/2021', '2021-04', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6115, '25/01/2021', '2021-03', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6116, '18/01/2021', '2021-02', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6117, '11/01/2021', '2021-01', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6118, '04/01/2021', '2020-53', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6119, '28/12/2020', '2020-52', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6120, '21/12/2020', '2020-51', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6121, '14/12/2020', '2020-50', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6122, '07/12/2020', '2020-49', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6123, '30/11/2020', '2020-48', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '5.1');
INSERT INTO public.europe_data_import VALUES (6124, '23/11/2020', '2020-47', '3', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '5.1');
INSERT INTO public.europe_data_import VALUES (6125, '16/11/2020', '2020-46', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6126, '09/11/2020', '2020-45', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '1.7');
INSERT INTO public.europe_data_import VALUES (6127, '02/11/2020', '2020-44', '1', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6128, '01/02/2021', '2021-04', '146', '5', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '11.14');
INSERT INTO public.europe_data_import VALUES (6129, '25/01/2021', '2021-03', '358', '11', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '19.55');
INSERT INTO public.europe_data_import VALUES (6130, '18/01/2021', '2021-02', '527', '21', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '27.51');
INSERT INTO public.europe_data_import VALUES (6131, '11/01/2021', '2021-01', '718', '26', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '38.31');
INSERT INTO public.europe_data_import VALUES (6132, '04/01/2021', '2020-53', '1016', '28', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '52.5');
INSERT INTO public.europe_data_import VALUES (6133, '28/12/2020', '2020-52', '1360', '49', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '62.02');
INSERT INTO public.europe_data_import VALUES (6134, '21/12/2020', '2020-51', '1447', '56', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '81.93');
INSERT INTO public.europe_data_import VALUES (6135, '14/12/2020', '2020-50', '2261', '48', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '53.52');
INSERT INTO public.europe_data_import VALUES (6136, '07/12/2020', '2020-49', '161', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '13.57');
INSERT INTO public.europe_data_import VALUES (6137, '30/11/2020', '2020-48', '453', '6', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '14.67');
INSERT INTO public.europe_data_import VALUES (6138, '23/11/2020', '2020-47', '211', '4', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '6.41');
INSERT INTO public.europe_data_import VALUES (6139, '16/11/2020', '2020-46', '79', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (6140, '09/11/2020', '2020-45', '89', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (6141, '02/11/2020', '2020-44', '55', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '2.52');
INSERT INTO public.europe_data_import VALUES (6142, '26/10/2020', '2020-43', '59', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '2.47');
INSERT INTO public.europe_data_import VALUES (6143, '19/10/2020', '2020-42', '53', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '1.83');
INSERT INTO public.europe_data_import VALUES (6144, '12/10/2020', '2020-41', '30', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (6145, '05/10/2020', '2020-40', '58', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '3.36');
INSERT INTO public.europe_data_import VALUES (6146, '28/09/2020', '2020-39', '94', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '4.11');
INSERT INTO public.europe_data_import VALUES (6147, '21/09/2020', '2020-38', '92', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.17');
INSERT INTO public.europe_data_import VALUES (6148, '14/09/2020', '2020-37', '142', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.61');
INSERT INTO public.europe_data_import VALUES (6149, '07/09/2020', '2020-36', '112', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (6150, '31/08/2020', '2020-35', '137', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '7.09');
INSERT INTO public.europe_data_import VALUES (6151, '24/08/2020', '2020-34', '184', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '8.55');
INSERT INTO public.europe_data_import VALUES (6152, '17/08/2020', '2020-33', '203', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '8.64');
INSERT INTO public.europe_data_import VALUES (6153, '10/08/2020', '2020-32', '188', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '7.23');
INSERT INTO public.europe_data_import VALUES (6154, '03/08/2020', '2020-31', '139', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '9.66');
INSERT INTO public.europe_data_import VALUES (6155, '27/07/2020', '2020-30', '298', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '23.09');
INSERT INTO public.europe_data_import VALUES (6156, '20/07/2020', '2020-29', '747', '11', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '21.96');
INSERT INTO public.europe_data_import VALUES (6157, '13/07/2020', '2020-28', '247', '14', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '26.94');
INSERT INTO public.europe_data_import VALUES (6158, '06/07/2020', '2020-27', '972', '10', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '45.65');
INSERT INTO public.europe_data_import VALUES (6159, '29/06/2020', '2020-26', '1094', '12', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '46.93');
INSERT INTO public.europe_data_import VALUES (6160, '22/06/2020', '2020-25', '1030', '21', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '41.23');
INSERT INTO public.europe_data_import VALUES (6161, '15/06/2020', '2020-24', '836', '44', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '27.69');
INSERT INTO public.europe_data_import VALUES (6162, '08/06/2020', '2020-23', '417', '20', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '15.69');
INSERT INTO public.europe_data_import VALUES (6163, '01/06/2020', '2020-22', '293', '17', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '10.34');
INSERT INTO public.europe_data_import VALUES (6164, '25/05/2020', '2020-21', '175', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.06');
INSERT INTO public.europe_data_import VALUES (6165, '18/05/2020', '2020-20', '54', '3', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (6166, '11/05/2020', '2020-19', '0', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6167, '04/05/2020', '2020-18', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6168, '27/04/2020', '2020-17', '0', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6169, '20/04/2020', '2020-16', '0', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6170, '13/04/2020', '2020-15', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6171, '06/04/2020', '2020-14', '1', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (6172, '30/03/2020', '2020-13', '3', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (6173, '23/03/2020', '2020-12', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6174, '16/03/2020', '2020-11', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6175, '01/02/2021', '2021-04', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (6176, '25/01/2021', '2021-03', '21', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (6177, '18/01/2021', '2021-02', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (6178, '11/01/2021', '2021-01', '14', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.42');
INSERT INTO public.europe_data_import VALUES (6179, '04/01/2021', '2020-53', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.39');
INSERT INTO public.europe_data_import VALUES (6180, '28/12/2020', '2020-52', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6181, '21/12/2020', '2020-51', '3', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.65');
INSERT INTO public.europe_data_import VALUES (6182, '14/12/2020', '2020-50', '18', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (6183, '07/12/2020', '2020-49', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6184, '30/11/2020', '2020-48', '7', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (6185, '23/11/2020', '2020-47', '16', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '3.31');
INSERT INTO public.europe_data_import VALUES (6186, '16/11/2020', '2020-46', '26', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '2.52');
INSERT INTO public.europe_data_import VALUES (6187, '09/11/2020', '2020-45', '6', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (6188, '02/11/2020', '2020-44', '11', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (6189, '26/10/2020', '2020-43', '28', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '3.15');
INSERT INTO public.europe_data_import VALUES (6190, '19/10/2020', '2020-42', '12', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '2.05');
INSERT INTO public.europe_data_import VALUES (6191, '12/10/2020', '2020-41', '14', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (6192, '05/10/2020', '2020-40', '14', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (6193, '28/09/2020', '2020-39', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.47');
INSERT INTO public.europe_data_import VALUES (6194, '21/09/2020', '2020-38', '6', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6195, '14/09/2020', '2020-37', '5', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (6196, '07/09/2020', '2020-36', '10', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (6197, '31/08/2020', '2020-35', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6198, '24/08/2020', '2020-34', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6199, '17/08/2020', '2020-33', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6200, '10/08/2020', '2020-32', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6201, '03/08/2020', '2020-31', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (6202, '27/07/2020', '2020-30', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6203, '20/07/2020', '2020-29', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6204, '13/07/2020', '2020-28', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (6205, '06/07/2020', '2020-27', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6206, '29/06/2020', '2020-26', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6207, '22/06/2020', '2020-25', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6208, '15/06/2020', '2020-24', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6209, '08/06/2020', '2020-23', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (6210, '01/06/2020', '2020-22', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (6211, '25/05/2020', '2020-21', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6212, '18/05/2020', '2020-20', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6213, '11/05/2020', '2020-19', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6214, '04/05/2020', '2020-18', '0', '1', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6215, '27/04/2020', '2020-17', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (6216, '20/04/2020', '2020-16', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '7.95');
INSERT INTO public.europe_data_import VALUES (6217, '13/04/2020', '2020-15', '97', '2', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '16.85');
INSERT INTO public.europe_data_import VALUES (6218, '06/04/2020', '2020-14', '117', '4', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '15.67');
INSERT INTO public.europe_data_import VALUES (6219, '30/03/2020', '2020-13', '82', '1', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '8.66');
INSERT INTO public.europe_data_import VALUES (6220, '23/03/2020', '2020-12', '28', '2', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6221, '01/02/2021', '2021-04', '97968', '8827', '127575529', 'Mexico', 'MX', 'MEX', 'America', '172.61');
INSERT INTO public.europe_data_import VALUES (6222, '25/01/2021', '2021-03', '122238', '9025', '127575529', 'Mexico', 'MX', 'MEX', 'America', '180.37');
INSERT INTO public.europe_data_import VALUES (6223, '18/01/2021', '2021-02', '107869', '6880', '127575529', 'Mexico', 'MX', 'MEX', 'America', '157.36');
INSERT INTO public.europe_data_import VALUES (6224, '11/01/2021', '2021-01', '92878', '7155', '127575529', 'Mexico', 'MX', 'MEX', 'America', '119.3');
INSERT INTO public.europe_data_import VALUES (6225, '04/01/2021', '2020-53', '59325', '4358', '127575529', 'Mexico', 'MX', 'MEX', 'America', '96.29');
INSERT INTO public.europe_data_import VALUES (6226, '28/12/2020', '2020-52', '63515', '4257', '127575529', 'Mexico', 'MX', 'MEX', 'America', '109.26');
INSERT INTO public.europe_data_import VALUES (6227, '21/12/2020', '2020-51', '75871', '4645', '127575529', 'Mexico', 'MX', 'MEX', 'America', '117.63');
INSERT INTO public.europe_data_import VALUES (6228, '14/12/2020', '2020-50', '74194', '4236', '127575529', 'Mexico', 'MX', 'MEX', 'America', '112.07');
INSERT INTO public.europe_data_import VALUES (6229, '07/12/2020', '2020-49', '68779', '4062', '127575529', 'Mexico', 'MX', 'MEX', 'America', '105.02');
INSERT INTO public.europe_data_import VALUES (6230, '30/11/2020', '2020-48', '65196', '3979', '127575529', 'Mexico', 'MX', 'MEX', 'America', '78.82');
INSERT INTO public.europe_data_import VALUES (6231, '23/11/2020', '2020-47', '35353', '3134', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.04');
INSERT INTO public.europe_data_import VALUES (6232, '16/11/2020', '2020-46', '38697', '3515', '127575529', 'Mexico', 'MX', 'MEX', 'America', '60.46');
INSERT INTO public.europe_data_import VALUES (6233, '09/11/2020', '2020-45', '38433', '3132', '127575529', 'Mexico', 'MX', 'MEX', 'America', '60.09');
INSERT INTO public.europe_data_import VALUES (6234, '02/11/2020', '2020-44', '38232', '2971', '127575529', 'Mexico', 'MX', 'MEX', 'America', '61.27');
INSERT INTO public.europe_data_import VALUES (6235, '26/10/2020', '2020-43', '39933', '2757', '127575529', 'Mexico', 'MX', 'MEX', 'America', '45.79');
INSERT INTO public.europe_data_import VALUES (6236, '19/10/2020', '2020-42', '18484', '2525', '127575529', 'Mexico', 'MX', 'MEX', 'America', '37.97');
INSERT INTO public.europe_data_import VALUES (6237, '12/10/2020', '2020-41', '29957', '4554', '127575529', 'Mexico', 'MX', 'MEX', 'America', '47.31');
INSERT INTO public.europe_data_import VALUES (6238, '05/10/2020', '2020-40', '30405', '2658', '127575529', 'Mexico', 'MX', 'MEX', 'America', '48.87');
INSERT INTO public.europe_data_import VALUES (6239, '28/09/2020', '2020-39', '31936', '2937', '127575529', 'Mexico', 'MX', 'MEX', 'America', '47.04');
INSERT INTO public.europe_data_import VALUES (6240, '21/09/2020', '2020-38', '28075', '2672', '127575529', 'Mexico', 'MX', 'MEX', 'America', '48.45');
INSERT INTO public.europe_data_import VALUES (6241, '14/09/2020', '2020-37', '33735', '3263', '127575529', 'Mexico', 'MX', 'MEX', 'America', '55.6');
INSERT INTO public.europe_data_import VALUES (6242, '07/09/2020', '2020-36', '37193', '3400', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.71');
INSERT INTO public.europe_data_import VALUES (6243, '31/08/2020', '2020-35', '37703', '3678', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.3');
INSERT INTO public.europe_data_import VALUES (6244, '24/08/2020', '2020-34', '36673', '3723', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.44');
INSERT INTO public.europe_data_import VALUES (6245, '17/08/2020', '2020-33', '37880', '4459', '127575529', 'Mexico', 'MX', 'MEX', 'America', '61.78');
INSERT INTO public.europe_data_import VALUES (6246, '10/08/2020', '2020-32', '40936', '4552', '127575529', 'Mexico', 'MX', 'MEX', 'America', '66.98');
INSERT INTO public.europe_data_import VALUES (6247, '03/08/2020', '2020-31', '44519', '4066', '127575529', 'Mexico', 'MX', 'MEX', 'America', '73.26');
INSERT INTO public.europe_data_import VALUES (6248, '27/07/2020', '2020-30', '48945', '4496', '127575529', 'Mexico', 'MX', 'MEX', 'America', '77.36');
INSERT INTO public.europe_data_import VALUES (6249, '20/07/2020', '2020-29', '49745', '4178', '127575529', 'Mexico', 'MX', 'MEX', 'America', '73.68');
INSERT INTO public.europe_data_import VALUES (6250, '13/07/2020', '2020-28', '44253', '4367', '127575529', 'Mexico', 'MX', 'MEX', 'America', '68.19');
INSERT INTO public.europe_data_import VALUES (6251, '06/07/2020', '2020-27', '42740', '3991', '127575529', 'Mexico', 'MX', 'MEX', 'America', '64.01');
INSERT INTO public.europe_data_import VALUES (6252, '29/06/2020', '2020-26', '38916', '4823', '127575529', 'Mexico', 'MX', 'MEX', 'America', '59.55');
INSERT INTO public.europe_data_import VALUES (6253, '22/06/2020', '2020-25', '37054', '4684', '127575529', 'Mexico', 'MX', 'MEX', 'America', '55.79');
INSERT INTO public.europe_data_import VALUES (6254, '15/06/2020', '2020-24', '34118', '3442', '127575529', 'Mexico', 'MX', 'MEX', 'America', '50.31');
INSERT INTO public.europe_data_import VALUES (6255, '08/06/2020', '2020-23', '30070', '3769', '127575529', 'Mexico', 'MX', 'MEX', 'America', '44.49');
INSERT INTO public.europe_data_import VALUES (6256, '01/06/2020', '2020-22', '26685', '2536', '127575529', 'Mexico', 'MX', 'MEX', 'America', '39.34');
INSERT INTO public.europe_data_import VALUES (6257, '25/05/2020', '2020-21', '23497', '2217', '127575529', 'Mexico', 'MX', 'MEX', 'America', '33.48');
INSERT INTO public.europe_data_import VALUES (6258, '18/05/2020', '2020-20', '19213', '1712', '127575529', 'Mexico', 'MX', 'MEX', 'America', '26.45');
INSERT INTO public.europe_data_import VALUES (6259, '11/05/2020', '2020-19', '14536', '1311', '127575529', 'Mexico', 'MX', 'MEX', 'America', '20.09');
INSERT INTO public.europe_data_import VALUES (6260, '04/05/2020', '2020-18', '11094', '803', '127575529', 'Mexico', 'MX', 'MEX', 'America', '15.86');
INSERT INTO public.europe_data_import VALUES (6261, '27/04/2020', '2020-17', '9135', '665', '127575529', 'Mexico', 'MX', 'MEX', 'America', '11.97');
INSERT INTO public.europe_data_import VALUES (6262, '20/04/2020', '2020-16', '6141', '390', '127575529', 'Mexico', 'MX', 'MEX', 'America', '7.47');
INSERT INTO public.europe_data_import VALUES (6263, '13/04/2020', '2020-15', '3386', '202', '127575529', 'Mexico', 'MX', 'MEX', 'America', '4.29');
INSERT INTO public.europe_data_import VALUES (6264, '06/04/2020', '2020-14', '2083', '74', '127575529', 'Mexico', 'MX', 'MEX', 'America', '2.59');
INSERT INTO public.europe_data_import VALUES (6265, '30/03/2020', '2020-13', '1221', '18', '127575529', 'Mexico', 'MX', 'MEX', 'America', '1.47');
INSERT INTO public.europe_data_import VALUES (6266, '23/03/2020', '2020-12', '654', '2', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.68');
INSERT INTO public.europe_data_import VALUES (6267, '16/03/2020', '2020-11', '216', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.18');
INSERT INTO public.europe_data_import VALUES (6268, '09/03/2020', '2020-10', '14', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (6269, '02/03/2020', '2020-09', '11', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (6270, '24/02/2020', '2020-08', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6271, '17/02/2020', '2020-07', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6272, '10/02/2020', '2020-06', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6273, '03/02/2020', '2020-05', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6274, '27/01/2020', '2020-04', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6275, '20/01/2020', '2020-03', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6276, '13/01/2020', '2020-02', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6277, '06/01/2020', '2020-01', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '');
INSERT INTO public.europe_data_import VALUES (6278, '01/02/2021', '2021-04', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6279, '25/01/2021', '2021-03', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6280, '18/01/2021', '2021-02', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6281, '11/01/2021', '2021-01', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6282, '01/02/2021', '2021-04', '3602', '77', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '171.89');
INSERT INTO public.europe_data_import VALUES (6283, '25/01/2021', '2021-03', '3348', '111', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '168.45');
INSERT INTO public.europe_data_import VALUES (6284, '18/01/2021', '2021-02', '3463', '111', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '172.66');
INSERT INTO public.europe_data_import VALUES (6285, '11/01/2021', '2021-01', '3518', '102', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '198.75');
INSERT INTO public.europe_data_import VALUES (6286, '04/01/2021', '2020-53', '4518', '146', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '263.8');
INSERT INTO public.europe_data_import VALUES (6287, '28/12/2020', '2020-52', '6148', '139', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '366.96');
INSERT INTO public.europe_data_import VALUES (6288, '21/12/2020', '2020-51', '8689', '180', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '459.33');
INSERT INTO public.europe_data_import VALUES (6289, '14/12/2020', '2020-50', '9883', '153', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '482.31');
INSERT INTO public.europe_data_import VALUES (6290, '07/12/2020', '2020-49', '9618', '129', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '462.35');
INSERT INTO public.europe_data_import VALUES (6291, '30/11/2020', '2020-48', '9076', '141', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '438.71');
INSERT INTO public.europe_data_import VALUES (6292, '23/11/2020', '2020-47', '8662', '130', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '385.7');
INSERT INTO public.europe_data_import VALUES (6293, '16/11/2020', '2020-46', '6933', '126', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '314.03');
INSERT INTO public.europe_data_import VALUES (6294, '09/11/2020', '2020-45', '5764', '93', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '268.17');
INSERT INTO public.europe_data_import VALUES (6295, '02/11/2020', '2020-44', '5079', '115', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '235.75');
INSERT INTO public.europe_data_import VALUES (6296, '26/10/2020', '2020-43', '4453', '101', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '231.3');
INSERT INTO public.europe_data_import VALUES (6297, '19/10/2020', '2020-42', '4899', '123', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '258.97');
INSERT INTO public.europe_data_import VALUES (6298, '12/10/2020', '2020-41', '5572', '95', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '278.88');
INSERT INTO public.europe_data_import VALUES (6299, '05/10/2020', '2020-40', '5704', '79', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '246.9');
INSERT INTO public.europe_data_import VALUES (6300, '28/09/2020', '2020-39', '4279', '84', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '195.31');
INSERT INTO public.europe_data_import VALUES (6301, '21/09/2020', '2020-38', '3618', '80', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '168.16');
INSERT INTO public.europe_data_import VALUES (6302, '14/09/2020', '2020-37', '3181', '60', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '155.27');
INSERT INTO public.europe_data_import VALUES (6303, '07/09/2020', '2020-36', '3097', '71', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '156.28');
INSERT INTO public.europe_data_import VALUES (6304, '31/08/2020', '2020-35', '3222', '52', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '161.18');
INSERT INTO public.europe_data_import VALUES (6305, '24/08/2020', '2020-34', '3295', '44', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '143.89');
INSERT INTO public.europe_data_import VALUES (6306, '17/08/2020', '2020-33', '2523', '51', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '119.24');
INSERT INTO public.europe_data_import VALUES (6307, '10/08/2020', '2020-32', '2298', '54', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '114.41');
INSERT INTO public.europe_data_import VALUES (6308, '03/08/2020', '2020-31', '2328', '56', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '108.38');
INSERT INTO public.europe_data_import VALUES (6309, '27/07/2020', '2020-30', '2054', '51', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '90.32');
INSERT INTO public.europe_data_import VALUES (6310, '20/07/2020', '2020-29', '1598', '42', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '78.3');
INSERT INTO public.europe_data_import VALUES (6311, '13/07/2020', '2020-28', '1568', '57', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '77.46');
INSERT INTO public.europe_data_import VALUES (6312, '06/07/2020', '2020-27', '1564', '55', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '89.38');
INSERT INTO public.europe_data_import VALUES (6313, '29/06/2020', '2020-26', '2050', '57', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '111.54');
INSERT INTO public.europe_data_import VALUES (6314, '22/06/2020', '2020-25', '2460', '67', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '111.3');
INSERT INTO public.europe_data_import VALUES (6315, '15/06/2020', '2020-24', '2040', '65', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '86.29');
INSERT INTO public.europe_data_import VALUES (6316, '08/06/2020', '2020-23', '1449', '46', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '64.48');
INSERT INTO public.europe_data_import VALUES (6317, '01/06/2020', '2020-22', '1158', '45', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '54.19');
INSERT INTO public.europe_data_import VALUES (6318, '25/05/2020', '2020-21', '1033', '39', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '53.57');
INSERT INTO public.europe_data_import VALUES (6319, '18/05/2020', '2020-20', '1133', '42', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '47.96');
INSERT INTO public.europe_data_import VALUES (6320, '11/05/2020', '2020-19', '806', '44', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '37.57');
INSERT INTO public.europe_data_import VALUES (6321, '04/05/2020', '2020-18', '713', '29', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '40.78');
INSERT INTO public.europe_data_import VALUES (6322, '27/04/2020', '2020-17', '936', '29', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '43.18');
INSERT INTO public.europe_data_import VALUES (6323, '20/04/2020', '2020-16', '810', '35', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '39.77');
INSERT INTO public.europe_data_import VALUES (6324, '13/04/2020', '2020-15', '798', '17', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '34.6');
INSERT INTO public.europe_data_import VALUES (6325, '06/04/2020', '2020-14', '601', '13', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '19.04');
INSERT INTO public.europe_data_import VALUES (6326, '30/03/2020', '2020-13', '169', '1', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '5.94');
INSERT INTO public.europe_data_import VALUES (6327, '23/03/2020', '2020-12', '71', '1', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '2.32');
INSERT INTO public.europe_data_import VALUES (6328, '16/03/2020', '2020-11', '23', '0', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6329, '01/02/2021', '2021-04', '132', '5', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '858.4');
INSERT INTO public.europe_data_import VALUES (6330, '25/01/2021', '2021-03', '152', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '906.76');
INSERT INTO public.europe_data_import VALUES (6331, '18/01/2021', '2021-02', '148', '5', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '900.71');
INSERT INTO public.europe_data_import VALUES (6332, '11/01/2021', '2021-01', '150', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '767.72');
INSERT INTO public.europe_data_import VALUES (6333, '04/01/2021', '2020-53', '104', '1', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '541.03');
INSERT INTO public.europe_data_import VALUES (6334, '28/12/2020', '2020-52', '75', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '408.04');
INSERT INTO public.europe_data_import VALUES (6335, '21/12/2020', '2020-51', '60', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '272.03');
INSERT INTO public.europe_data_import VALUES (6336, '14/12/2020', '2020-50', '30', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '181.35');
INSERT INTO public.europe_data_import VALUES (6337, '07/12/2020', '2020-49', '30', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '169.26');
INSERT INTO public.europe_data_import VALUES (6338, '30/11/2020', '2020-48', '26', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '181.35');
INSERT INTO public.europe_data_import VALUES (6339, '23/11/2020', '2020-47', '34', '1', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '290.16');
INSERT INTO public.europe_data_import VALUES (6340, '16/11/2020', '2020-46', '62', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '550.1');
INSERT INTO public.europe_data_import VALUES (6341, '09/11/2020', '2020-45', '120', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '544.05');
INSERT INTO public.europe_data_import VALUES (6342, '02/11/2020', '2020-44', '60', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '305.27');
INSERT INTO public.europe_data_import VALUES (6343, '26/10/2020', '2020-43', '41', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '217.62');
INSERT INTO public.europe_data_import VALUES (6344, '19/10/2020', '2020-42', '31', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '129.97');
INSERT INTO public.europe_data_import VALUES (6345, '12/10/2020', '2020-41', '12', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '72.54');
INSERT INTO public.europe_data_import VALUES (6346, '05/10/2020', '2020-40', '12', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '87.65');
INSERT INTO public.europe_data_import VALUES (6347, '28/09/2020', '2020-39', '17', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '117.88');
INSERT INTO public.europe_data_import VALUES (6348, '21/09/2020', '2020-38', '22', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '136.01');
INSERT INTO public.europe_data_import VALUES (6349, '14/09/2020', '2020-37', '23', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '120.9');
INSERT INTO public.europe_data_import VALUES (6350, '07/09/2020', '2020-36', '17', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '111.83');
INSERT INTO public.europe_data_import VALUES (6351, '31/08/2020', '2020-35', '20', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '96.72');
INSERT INTO public.europe_data_import VALUES (6352, '24/08/2020', '2020-34', '12', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '51.38');
INSERT INTO public.europe_data_import VALUES (6353, '17/08/2020', '2020-33', '5', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '45.34');
INSERT INTO public.europe_data_import VALUES (6354, '10/08/2020', '2020-32', '10', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '39.29');
INSERT INTO public.europe_data_import VALUES (6355, '03/08/2020', '2020-31', '3', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '24.18');
INSERT INTO public.europe_data_import VALUES (6356, '27/07/2020', '2020-30', '5', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '15.11');
INSERT INTO public.europe_data_import VALUES (6357, '20/07/2020', '2020-29', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6358, '13/07/2020', '2020-28', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '18.14');
INSERT INTO public.europe_data_import VALUES (6359, '06/07/2020', '2020-27', '5', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '21.16');
INSERT INTO public.europe_data_import VALUES (6360, '29/06/2020', '2020-26', '2', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '9.07');
INSERT INTO public.europe_data_import VALUES (6361, '22/06/2020', '2020-25', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6362, '15/06/2020', '2020-24', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6363, '08/06/2020', '2020-23', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6364, '01/06/2020', '2020-22', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6365, '25/05/2020', '2020-21', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6366, '18/05/2020', '2020-20', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6367, '11/05/2020', '2020-19', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6368, '04/05/2020', '2020-18', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6369, '27/04/2020', '2020-17', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6370, '20/04/2020', '2020-16', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '42.32');
INSERT INTO public.europe_data_import VALUES (6371, '13/04/2020', '2020-15', '13', '1', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '87.65');
INSERT INTO public.europe_data_import VALUES (6372, '06/04/2020', '2020-14', '16', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '93.7');
INSERT INTO public.europe_data_import VALUES (6373, '30/03/2020', '2020-13', '15', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '78.59');
INSERT INTO public.europe_data_import VALUES (6374, '23/03/2020', '2020-12', '11', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '57.43');
INSERT INTO public.europe_data_import VALUES (6375, '16/03/2020', '2020-11', '8', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '24.18');
INSERT INTO public.europe_data_import VALUES (6376, '09/03/2020', '2020-10', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6377, '02/03/2020', '2020-09', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6378, '24/02/2020', '2020-08', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6379, '17/02/2020', '2020-07', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6380, '10/02/2020', '2020-06', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6381, '03/02/2020', '2020-05', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6382, '27/01/2020', '2020-04', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6383, '20/01/2020', '2020-03', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6384, '13/01/2020', '2020-02', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6385, '06/01/2020', '2020-01', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6386, '01/02/2021', '2021-04', '171', '2', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '8.93');
INSERT INTO public.europe_data_import VALUES (6387, '25/01/2021', '2021-03', '117', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '6.23');
INSERT INTO public.europe_data_import VALUES (6388, '18/01/2021', '2021-02', '84', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '7.44');
INSERT INTO public.europe_data_import VALUES (6389, '11/01/2021', '2021-01', '156', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '9.46');
INSERT INTO public.europe_data_import VALUES (6390, '04/01/2021', '2020-53', '149', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '9.08');
INSERT INTO public.europe_data_import VALUES (6391, '28/12/2020', '2020-52', '144', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '6.98');
INSERT INTO public.europe_data_import VALUES (6392, '21/12/2020', '2020-51', '81', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.29');
INSERT INTO public.europe_data_import VALUES (6393, '14/12/2020', '2020-50', '25', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.75');
INSERT INTO public.europe_data_import VALUES (6394, '07/12/2020', '2020-49', '96', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '7.66');
INSERT INTO public.europe_data_import VALUES (6395, '30/11/2020', '2020-48', '151', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '11.16');
INSERT INTO public.europe_data_import VALUES (6396, '23/11/2020', '2020-47', '209', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '8.43');
INSERT INTO public.europe_data_import VALUES (6397, '16/11/2020', '2020-46', '63', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '2.54');
INSERT INTO public.europe_data_import VALUES (6398, '09/11/2020', '2020-45', '19', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.9');
INSERT INTO public.europe_data_import VALUES (6399, '02/11/2020', '2020-44', '10', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (6400, '26/10/2020', '2020-43', '15', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.65');
INSERT INTO public.europe_data_import VALUES (6401, '19/10/2020', '2020-42', '6', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (6402, '12/10/2020', '2020-41', '4', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6403, '05/10/2020', '2020-40', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6404, '28/09/2020', '2020-39', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6405, '21/09/2020', '2020-38', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6406, '14/09/2020', '2020-37', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (6407, '07/09/2020', '2020-36', '9', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (6408, '31/08/2020', '2020-35', '3', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (6409, '24/08/2020', '2020-34', '0', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6410, '17/08/2020', '2020-33', '5', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6411, '10/08/2020', '2020-32', '0', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6412, '03/08/2020', '2020-31', '5', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (6413, '27/07/2020', '2020-30', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '1.8');
INSERT INTO public.europe_data_import VALUES (6414, '20/07/2020', '2020-29', '57', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '2.08');
INSERT INTO public.europe_data_import VALUES (6415, '13/07/2020', '2020-28', '10', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (6416, '06/07/2020', '2020-27', '0', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (6417, '29/06/2020', '2020-26', '7', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.71');
INSERT INTO public.europe_data_import VALUES (6418, '22/06/2020', '2020-25', '16', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (6419, '15/06/2020', '2020-24', '3', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (6420, '08/06/2020', '2020-23', '9', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '1.64');
INSERT INTO public.europe_data_import VALUES (6421, '01/06/2020', '2020-22', '44', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '1.4');
INSERT INTO public.europe_data_import VALUES (6422, '25/05/2020', '2020-21', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.07');
INSERT INTO public.europe_data_import VALUES (6423, '18/05/2020', '2020-20', '98', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.1');
INSERT INTO public.europe_data_import VALUES (6424, '11/05/2020', '2020-19', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (6425, '04/05/2020', '2020-18', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (6426, '27/04/2020', '2020-17', '6', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.68');
INSERT INTO public.europe_data_import VALUES (6427, '20/04/2020', '2020-16', '16', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.56');
INSERT INTO public.europe_data_import VALUES (6428, '13/04/2020', '2020-15', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (6429, '06/04/2020', '2020-14', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (6430, '30/03/2020', '2020-13', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (6431, '23/03/2020', '2020-12', '10', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6432, '01/02/2021', '2021-04', '3343', '37', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '991.03');
INSERT INTO public.europe_data_import VALUES (6433, '25/01/2021', '2021-03', '2823', '23', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '945.86');
INSERT INTO public.europe_data_import VALUES (6434, '18/01/2021', '2021-02', '3062', '20', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1012.24');
INSERT INTO public.europe_data_import VALUES (6435, '11/01/2021', '2021-01', '3236', '36', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '922.08');
INSERT INTO public.europe_data_import VALUES (6436, '04/01/2021', '2020-53', '2501', '23', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '842.2');
INSERT INTO public.europe_data_import VALUES (6437, '28/12/2020', '2020-52', '2739', '40', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '846.7');
INSERT INTO public.europe_data_import VALUES (6438, '21/12/2020', '2020-51', '2529', '44', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '917.58');
INSERT INTO public.europe_data_import VALUES (6439, '14/12/2020', '2020-50', '3180', '49', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1051.94');
INSERT INTO public.europe_data_import VALUES (6440, '07/12/2020', '2020-49', '3365', '46', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1154.65');
INSERT INTO public.europe_data_import VALUES (6441, '30/11/2020', '2020-48', '3819', '48', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1238.22');
INSERT INTO public.europe_data_import VALUES (6442, '23/11/2020', '2020-47', '3885', '48', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1327.1');
INSERT INTO public.europe_data_import VALUES (6443, '16/11/2020', '2020-46', '4372', '54', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1360.21');
INSERT INTO public.europe_data_import VALUES (6444, '09/11/2020', '2020-45', '4091', '24', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '965.63');
INSERT INTO public.europe_data_import VALUES (6445, '02/11/2020', '2020-44', '1917', '47', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '498.09');
INSERT INTO public.europe_data_import VALUES (6446, '26/10/2020', '2020-43', '1182', '30', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '470.6');
INSERT INTO public.europe_data_import VALUES (6447, '19/10/2020', '2020-42', '1746', '34', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '560.61');
INSERT INTO public.europe_data_import VALUES (6448, '12/10/2020', '2020-41', '1742', '23', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '571.54');
INSERT INTO public.europe_data_import VALUES (6449, '05/10/2020', '2020-40', '1814', '21', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '564.95');
INSERT INTO public.europe_data_import VALUES (6450, '28/09/2020', '2020-39', '1701', '22', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '578.77');
INSERT INTO public.europe_data_import VALUES (6451, '21/09/2020', '2020-38', '1900', '16', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '491.66');
INSERT INTO public.europe_data_import VALUES (6452, '14/09/2020', '2020-37', '1159', '12', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '308.91');
INSERT INTO public.europe_data_import VALUES (6453, '07/09/2020', '2020-36', '763', '10', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '194.48');
INSERT INTO public.europe_data_import VALUES (6454, '31/08/2020', '2020-35', '447', '14', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '121.35');
INSERT INTO public.europe_data_import VALUES (6455, '24/08/2020', '2020-34', '308', '7', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '116.53');
INSERT INTO public.europe_data_import VALUES (6456, '17/08/2020', '2020-33', '417', '13', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '124.88');
INSERT INTO public.europe_data_import VALUES (6457, '10/08/2020', '2020-32', '360', '13', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '168.6');
INSERT INTO public.europe_data_import VALUES (6458, '03/08/2020', '2020-31', '689', '11', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '239.0');
INSERT INTO public.europe_data_import VALUES (6459, '27/07/2020', '2020-30', '798', '10', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '216.66');
INSERT INTO public.europe_data_import VALUES (6460, '20/07/2020', '2020-29', '550', '7', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '159.12');
INSERT INTO public.europe_data_import VALUES (6461, '13/07/2020', '2020-28', '440', '9', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '118.94');
INSERT INTO public.europe_data_import VALUES (6462, '06/07/2020', '2020-27', '300', '3', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '67.34');
INSERT INTO public.europe_data_import VALUES (6463, '29/06/2020', '2020-26', '119', '2', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '25.07');
INSERT INTO public.europe_data_import VALUES (6464, '22/06/2020', '2020-25', '37', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '6.11');
INSERT INTO public.europe_data_import VALUES (6465, '15/06/2020', '2020-24', '1', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (6466, '08/06/2020', '2020-23', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6467, '01/06/2020', '2020-22', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6468, '25/05/2020', '2020-21', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6469, '18/05/2020', '2020-20', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0.32');
INSERT INTO public.europe_data_import VALUES (6470, '11/05/2020', '2020-19', '2', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0.48');
INSERT INTO public.europe_data_import VALUES (6471, '04/05/2020', '2020-18', '1', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '2.25');
INSERT INTO public.europe_data_import VALUES (6472, '27/04/2020', '2020-17', '13', '2', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '7.88');
INSERT INTO public.europe_data_import VALUES (6473, '20/04/2020', '2020-16', '36', '2', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '15.11');
INSERT INTO public.europe_data_import VALUES (6474, '13/04/2020', '2020-15', '58', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '30.06');
INSERT INTO public.europe_data_import VALUES (6475, '06/04/2020', '2020-14', '129', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '31.02');
INSERT INTO public.europe_data_import VALUES (6476, '30/03/2020', '2020-13', '64', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '13.66');
INSERT INTO public.europe_data_import VALUES (6477, '23/03/2020', '2020-12', '21', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6478, '01/02/2021', '2021-04', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6479, '25/01/2021', '2021-03', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6480, '18/01/2021', '2021-02', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6481, '11/01/2021', '2021-01', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6482, '04/01/2021', '2020-53', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6483, '28/12/2020', '2020-52', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6484, '21/12/2020', '2020-51', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6485, '14/12/2020', '2020-50', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6486, '07/12/2020', '2020-49', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6487, '30/11/2020', '2020-48', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6488, '23/11/2020', '2020-47', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6489, '16/11/2020', '2020-46', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6490, '09/11/2020', '2020-45', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6491, '02/11/2020', '2020-44', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6492, '26/10/2020', '2020-43', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6493, '19/10/2020', '2020-42', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6494, '12/10/2020', '2020-41', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6495, '05/10/2020', '2020-40', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6496, '28/09/2020', '2020-39', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6497, '21/09/2020', '2020-38', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6498, '14/09/2020', '2020-37', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6499, '07/09/2020', '2020-36', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6500, '31/08/2020', '2020-35', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6501, '24/08/2020', '2020-34', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6502, '17/08/2020', '2020-33', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6503, '10/08/2020', '2020-32', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6504, '03/08/2020', '2020-31', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6505, '27/07/2020', '2020-30', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6506, '20/07/2020', '2020-29', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6507, '13/07/2020', '2020-28', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6508, '06/07/2020', '2020-27', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6509, '29/06/2020', '2020-26', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6510, '22/06/2020', '2020-25', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6511, '15/06/2020', '2020-24', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6512, '08/06/2020', '2020-23', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6513, '01/06/2020', '2020-22', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6514, '25/05/2020', '2020-21', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6515, '18/05/2020', '2020-20', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6516, '11/05/2020', '2020-19', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6517, '04/05/2020', '2020-18', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6518, '27/04/2020', '2020-17', '0', '1', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6519, '20/04/2020', '2020-16', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '100.18');
INSERT INTO public.europe_data_import VALUES (6520, '13/04/2020', '2020-15', '5', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '120.22');
INSERT INTO public.europe_data_import VALUES (6521, '06/04/2020', '2020-14', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '100.18');
INSERT INTO public.europe_data_import VALUES (6522, '30/03/2020', '2020-13', '4', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '100.18');
INSERT INTO public.europe_data_import VALUES (6523, '23/03/2020', '2020-12', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '');
INSERT INTO public.europe_data_import VALUES (6524, '01/02/2021', '2021-04', '4868', '125', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '31.49');
INSERT INTO public.europe_data_import VALUES (6525, '25/01/2021', '2021-03', '6618', '208', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '37.72');
INSERT INTO public.europe_data_import VALUES (6526, '18/01/2021', '2021-02', '7139', '199', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '45.31');
INSERT INTO public.europe_data_import VALUES (6527, '11/01/2021', '2021-01', '9386', '258', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '56.08');
INSERT INTO public.europe_data_import VALUES (6528, '04/01/2021', '2020-53', '11067', '245', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '71.35');
INSERT INTO public.europe_data_import VALUES (6529, '28/12/2020', '2020-52', '14954', '283', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '89.03');
INSERT INTO public.europe_data_import VALUES (6530, '21/12/2020', '2020-51', '17516', '333', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '102.73');
INSERT INTO public.europe_data_import VALUES (6531, '14/12/2020', '2020-50', '19952', '379', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '125.59');
INSERT INTO public.europe_data_import VALUES (6532, '07/12/2020', '2020-49', '25854', '456', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '160.93');
INSERT INTO public.europe_data_import VALUES (6533, '30/11/2020', '2020-48', '32841', '533', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '166.23');
INSERT INTO public.europe_data_import VALUES (6534, '23/11/2020', '2020-47', '27785', '477', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '175.97');
INSERT INTO public.europe_data_import VALUES (6535, '16/11/2020', '2020-46', '36396', '507', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '193.66');
INSERT INTO public.europe_data_import VALUES (6536, '09/11/2020', '2020-45', '34237', '510', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '162.59');
INSERT INTO public.europe_data_import VALUES (6537, '02/11/2020', '2020-44', '25063', '461', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '134.11');
INSERT INTO public.europe_data_import VALUES (6538, '26/10/2020', '2020-43', '23849', '373', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '123.59');
INSERT INTO public.europe_data_import VALUES (6539, '19/10/2020', '2020-42', '21228', '323', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '110.66');
INSERT INTO public.europe_data_import VALUES (6540, '12/10/2020', '2020-41', '19132', '275', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '95.19');
INSERT INTO public.europe_data_import VALUES (6541, '05/10/2020', '2020-40', '15587', '261', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '86.45');
INSERT INTO public.europe_data_import VALUES (6542, '28/09/2020', '2020-39', '15942', '239', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '84.99');
INSERT INTO public.europe_data_import VALUES (6543, '21/09/2020', '2020-38', '15057', '252', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '80.47');
INSERT INTO public.europe_data_import VALUES (6544, '14/09/2020', '2020-37', '14292', '217', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '69.33');
INSERT INTO public.europe_data_import VALUES (6545, '07/09/2020', '2020-36', '10995', '250', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '54.96');
INSERT INTO public.europe_data_import VALUES (6546, '31/08/2020', '2020-35', '9050', '223', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '51.85');
INSERT INTO public.europe_data_import VALUES (6547, '24/08/2020', '2020-34', '9860', '230', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '52.4');
INSERT INTO public.europe_data_import VALUES (6548, '17/08/2020', '2020-33', '9252', '160', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '46.48');
INSERT INTO public.europe_data_import VALUES (6549, '10/08/2020', '2020-32', '7700', '116', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '35.53');
INSERT INTO public.europe_data_import VALUES (6550, '03/08/2020', '2020-31', '5259', '69', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '22.76');
INSERT INTO public.europe_data_import VALUES (6551, '27/07/2020', '2020-30', '3042', '40', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '12.43');
INSERT INTO public.europe_data_import VALUES (6552, '20/07/2020', '2020-29', '1491', '23', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '8.28');
INSERT INTO public.europe_data_import VALUES (6553, '13/07/2020', '2020-28', '1530', '15', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '10.13');
INSERT INTO public.europe_data_import VALUES (6554, '06/07/2020', '2020-27', '2163', '14', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '11.62');
INSERT INTO public.europe_data_import VALUES (6555, '29/06/2020', '2020-26', '2075', '7', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '9.1');
INSERT INTO public.europe_data_import VALUES (6556, '22/06/2020', '2020-25', '1243', '2', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '4.81');
INSERT INTO public.europe_data_import VALUES (6557, '15/06/2020', '2020-24', '510', '4', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.54');
INSERT INTO public.europe_data_import VALUES (6558, '08/06/2020', '2020-23', '417', '3', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.17');
INSERT INTO public.europe_data_import VALUES (6559, '01/06/2020', '2020-22', '374', '6', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.57');
INSERT INTO public.europe_data_import VALUES (6560, '25/05/2020', '2020-21', '563', '7', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (6561, '18/05/2020', '2020-20', '807', '4', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.39');
INSERT INTO public.europe_data_import VALUES (6562, '11/05/2020', '2020-19', '1160', '14', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.48');
INSERT INTO public.europe_data_import VALUES (6563, '04/05/2020', '2020-18', '838', '13', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.62');
INSERT INTO public.europe_data_import VALUES (6564, '27/04/2020', '2020-17', '1210', '20', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '6.59');
INSERT INTO public.europe_data_import VALUES (6565, '20/04/2020', '2020-16', '1194', '23', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.03');
INSERT INTO public.europe_data_import VALUES (6566, '13/04/2020', '2020-15', '640', '48', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '3.24');
INSERT INTO public.europe_data_import VALUES (6567, '06/04/2020', '2020-14', '542', '44', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.48');
INSERT INTO public.europe_data_import VALUES (6568, '30/03/2020', '2020-13', '364', '22', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '1.24');
INSERT INTO public.europe_data_import VALUES (6569, '23/03/2020', '2020-12', '87', '3', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6570, '16/03/2020', '2020-11', '28', '1', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6571, '01/02/2021', '2021-04', '6679', '23', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '42.51');
INSERT INTO public.europe_data_import VALUES (6572, '25/01/2021', '2021-03', '6230', '122', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '34.4');
INSERT INTO public.europe_data_import VALUES (6573, '18/01/2021', '2021-02', '4217', '44', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '23.85');
INSERT INTO public.europe_data_import VALUES (6574, '11/01/2021', '2021-01', '3025', '28', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '13.25');
INSERT INTO public.europe_data_import VALUES (6575, '04/01/2021', '2020-53', '999', '7', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '5.73');
INSERT INTO public.europe_data_import VALUES (6576, '28/12/2020', '2020-52', '742', '14', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.47');
INSERT INTO public.europe_data_import VALUES (6577, '21/12/2020', '2020-51', '614', '6', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.36');
INSERT INTO public.europe_data_import VALUES (6578, '14/12/2020', '2020-50', '710', '9', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.42');
INSERT INTO public.europe_data_import VALUES (6579, '07/12/2020', '2020-49', '631', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.97');
INSERT INTO public.europe_data_import VALUES (6580, '30/11/2020', '2020-48', '576', '6', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.84');
INSERT INTO public.europe_data_import VALUES (6581, '23/11/2020', '2020-47', '589', '11', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.18');
INSERT INTO public.europe_data_import VALUES (6582, '16/11/2020', '2020-46', '680', '14', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.81');
INSERT INTO public.europe_data_import VALUES (6583, '09/11/2020', '2020-45', '780', '6', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '5.87');
INSERT INTO public.europe_data_import VALUES (6584, '02/11/2020', '2020-44', '1002', '7', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '6.99');
INSERT INTO public.europe_data_import VALUES (6585, '26/10/2020', '2020-43', '1120', '11', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '6.54');
INSERT INTO public.europe_data_import VALUES (6586, '19/10/2020', '2020-42', '865', '4', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (6587, '12/10/2020', '2020-41', '805', '5', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '6.65');
INSERT INTO public.europe_data_import VALUES (6588, '05/10/2020', '2020-40', '1213', '8', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '7.99');
INSERT INTO public.europe_data_import VALUES (6589, '28/09/2020', '2020-39', '1212', '15', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '8.94');
INSERT INTO public.europe_data_import VALUES (6590, '21/09/2020', '2020-38', '1502', '8', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '7.66');
INSERT INTO public.europe_data_import VALUES (6591, '14/09/2020', '2020-37', '825', '8', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.77');
INSERT INTO public.europe_data_import VALUES (6592, '07/09/2020', '2020-36', '623', '4', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.45');
INSERT INTO public.europe_data_import VALUES (6593, '31/08/2020', '2020-35', '426', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (6594, '24/08/2020', '2020-34', '540', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (6595, '17/08/2020', '2020-33', '586', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '2.99');
INSERT INTO public.europe_data_import VALUES (6596, '10/08/2020', '2020-32', '323', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (6597, '03/08/2020', '2020-31', '277', '2', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.5');
INSERT INTO public.europe_data_import VALUES (6598, '27/07/2020', '2020-30', '178', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (6599, '20/07/2020', '2020-29', '334', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.66');
INSERT INTO public.europe_data_import VALUES (6600, '13/07/2020', '2020-28', '170', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (6601, '06/07/2020', '2020-27', '128', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (6602, '29/06/2020', '2020-26', '126', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (6603, '22/06/2020', '2020-25', '150', '2', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (6604, '15/06/2020', '2020-24', '157', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (6605, '08/06/2020', '2020-23', '172', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (6606, '01/06/2020', '2020-22', '60', '2', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.39');
INSERT INTO public.europe_data_import VALUES (6607, '25/05/2020', '2020-21', '57', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (6608, '18/05/2020', '2020-20', '46', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (6609, '11/05/2020', '2020-19', '11', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6610, '04/05/2020', '2020-18', '4', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (6611, '27/04/2020', '2020-17', '37', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (6612, '20/04/2020', '2020-16', '18', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (6613, '13/04/2020', '2020-15', '11', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6614, '06/04/2020', '2020-14', '2', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (6615, '30/03/2020', '2020-13', '7', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (6616, '23/03/2020', '2020-12', '1', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6617, '01/02/2021', '2021-04', '2571', '69', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '10.78');
INSERT INTO public.europe_data_import VALUES (6618, '25/01/2021', '2021-03', '3256', '107', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '12.9');
INSERT INTO public.europe_data_import VALUES (6619, '18/01/2021', '2021-02', '3714', '109', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '14.75');
INSERT INTO public.europe_data_import VALUES (6620, '11/01/2021', '2021-01', '4259', '118', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '16.13');
INSERT INTO public.europe_data_import VALUES (6621, '04/01/2021', '2020-53', '4459', '127', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '18.89');
INSERT INTO public.europe_data_import VALUES (6622, '28/12/2020', '2020-52', '5752', '158', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '25.06');
INSERT INTO public.europe_data_import VALUES (6623, '21/12/2020', '2020-51', '7792', '175', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '31.42');
INSERT INTO public.europe_data_import VALUES (6624, '14/12/2020', '2020-50', '9187', '158', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '34.89');
INSERT INTO public.europe_data_import VALUES (6625, '07/12/2020', '2020-49', '9669', '192', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '36.84');
INSERT INTO public.europe_data_import VALUES (6626, '30/11/2020', '2020-48', '10240', '179', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '37.92');
INSERT INTO public.europe_data_import VALUES (6627, '23/11/2020', '2020-47', '10252', '162', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '33.06');
INSERT INTO public.europe_data_import VALUES (6628, '16/11/2020', '2020-46', '7617', '157', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '28.84');
INSERT INTO public.europe_data_import VALUES (6629, '09/11/2020', '2020-45', '7972', '162', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '30.72');
INSERT INTO public.europe_data_import VALUES (6630, '02/11/2020', '2020-44', '8631', '163', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '32.16');
INSERT INTO public.europe_data_import VALUES (6631, '26/10/2020', '2020-43', '8749', '215', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '31.08');
INSERT INTO public.europe_data_import VALUES (6632, '19/10/2020', '2020-42', '8051', '234', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '33.73');
INSERT INTO public.europe_data_import VALUES (6633, '12/10/2020', '2020-41', '10180', '234', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '31.9');
INSERT INTO public.europe_data_import VALUES (6634, '05/10/2020', '2020-40', '7060', '186', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '22.18');
INSERT INTO public.europe_data_import VALUES (6635, '28/09/2020', '2020-39', '4929', '132', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '14.28');
INSERT INTO public.europe_data_import VALUES (6636, '21/09/2020', '2020-38', '2790', '70', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '8.03');
INSERT INTO public.europe_data_import VALUES (6637, '14/09/2020', '2020-37', '1551', '16', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '4.12');
INSERT INTO public.europe_data_import VALUES (6638, '07/09/2020', '2020-36', '677', '2', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '1.85');
INSERT INTO public.europe_data_import VALUES (6639, '31/08/2020', '2020-35', '324', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (6640, '24/08/2020', '2020-34', '88', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (6641, '17/08/2020', '2020-33', '15', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6642, '10/08/2020', '2020-32', '7', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (6643, '03/08/2020', '2020-31', '3', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (6644, '27/07/2020', '2020-30', '9', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6645, '20/07/2020', '2020-29', '10', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (6646, '13/07/2020', '2020-28', '18', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6647, '06/07/2020', '2020-27', '14', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6648, '29/06/2020', '2020-26', '9', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (6649, '22/06/2020', '2020-25', '28', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (6650, '15/06/2020', '2020-24', '19', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6651, '08/06/2020', '2020-23', '15', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6652, '01/06/2020', '2020-22', '27', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6653, '25/05/2020', '2020-21', '14', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6654, '18/05/2020', '2020-20', '7', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6655, '11/05/2020', '2020-19', '25', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6656, '04/05/2020', '2020-18', '9', '1', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6657, '27/04/2020', '2020-17', '35', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (6658, '20/04/2020', '2020-16', '70', '1', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (6659, '13/04/2020', '2020-15', '20', '3', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6660, '06/04/2020', '2020-14', '13', '1', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6661, '30/03/2020', '2020-13', '8', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6662, '01/02/2021', '2021-04', '1743', '34', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '152.53');
INSERT INTO public.europe_data_import VALUES (6663, '25/01/2021', '2021-03', '2062', '34', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '153.26');
INSERT INTO public.europe_data_import VALUES (6664, '18/01/2021', '2021-02', '1761', '24', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '199.52');
INSERT INTO public.europe_data_import VALUES (6665, '11/01/2021', '2021-01', '3216', '43', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '253.15');
INSERT INTO public.europe_data_import VALUES (6666, '04/01/2021', '2020-53', '3099', '25', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '267.47');
INSERT INTO public.europe_data_import VALUES (6667, '28/12/2020', '2020-52', '3573', '16', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '230.54');
INSERT INTO public.europe_data_import VALUES (6668, '21/12/2020', '2020-51', '2178', '17', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '145.76');
INSERT INTO public.europe_data_import VALUES (6669, '14/12/2020', '2020-50', '1458', '8', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '87.83');
INSERT INTO public.europe_data_import VALUES (6670, '07/12/2020', '2020-49', '733', '1', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '48.63');
INSERT INTO public.europe_data_import VALUES (6671, '30/11/2020', '2020-48', '480', '6', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '33.55');
INSERT INTO public.europe_data_import VALUES (6672, '23/11/2020', '2020-47', '357', '7', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '26.22');
INSERT INTO public.europe_data_import VALUES (6673, '16/11/2020', '2020-46', '297', '4', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '20.85');
INSERT INTO public.europe_data_import VALUES (6674, '09/11/2020', '2020-45', '223', '1', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '22.09');
INSERT INTO public.europe_data_import VALUES (6675, '02/11/2020', '2020-44', '328', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '27.86');
INSERT INTO public.europe_data_import VALUES (6676, '26/10/2020', '2020-43', '367', '2', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '29.02');
INSERT INTO public.europe_data_import VALUES (6677, '19/10/2020', '2020-42', '357', '3', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '26.74');
INSERT INTO public.europe_data_import VALUES (6678, '12/10/2020', '2020-41', '310', '5', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '36.2');
INSERT INTO public.europe_data_import VALUES (6679, '05/10/2020', '2020-40', '593', '4', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '50.07');
INSERT INTO public.europe_data_import VALUES (6680, '28/09/2020', '2020-39', '656', '7', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '52.68');
INSERT INTO public.europe_data_import VALUES (6681, '21/09/2020', '2020-38', '658', '11', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '67.83');
INSERT INTO public.europe_data_import VALUES (6682, '14/09/2020', '2020-37', '1034', '12', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '94.37');
INSERT INTO public.europe_data_import VALUES (6683, '07/09/2020', '2020-36', '1320', '17', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '113.49');
INSERT INTO public.europe_data_import VALUES (6684, '31/08/2020', '2020-35', '1511', '20', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '128.72');
INSERT INTO public.europe_data_import VALUES (6685, '24/08/2020', '2020-34', '1700', '17', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '116.46');
INSERT INTO public.europe_data_import VALUES (6686, '17/08/2020', '2020-33', '1205', '16', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '74.56');
INSERT INTO public.europe_data_import VALUES (6687, '10/08/2020', '2020-32', '655', '8', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '47.06');
INSERT INTO public.europe_data_import VALUES (6688, '03/08/2020', '2020-31', '519', '3', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '41.97');
INSERT INTO public.europe_data_import VALUES (6689, '27/07/2020', '2020-30', '528', '5', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '39.69');
INSERT INTO public.europe_data_import VALUES (6690, '20/07/2020', '2020-29', '462', '2', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '33.47');
INSERT INTO public.europe_data_import VALUES (6691, '13/07/2020', '2020-28', '373', '1', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '24.13');
INSERT INTO public.europe_data_import VALUES (6692, '06/07/2020', '2020-27', '229', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '14.31');
INSERT INTO public.europe_data_import VALUES (6693, '29/06/2020', '2020-26', '128', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '6.05');
INSERT INTO public.europe_data_import VALUES (6694, '22/06/2020', '2020-25', '23', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (6695, '15/06/2020', '2020-24', '3', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6696, '08/06/2020', '2020-23', '5', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6697, '01/06/2020', '2020-22', '3', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6698, '25/05/2020', '2020-21', '5', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (6699, '18/05/2020', '2020-20', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6700, '11/05/2020', '2020-19', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6701, '04/05/2020', '2020-18', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6702, '27/04/2020', '2020-17', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6703, '20/04/2020', '2020-16', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6704, '13/04/2020', '2020-15', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (6705, '06/04/2020', '2020-14', '5', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (6706, '30/03/2020', '2020-13', '8', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (6707, '23/03/2020', '2020-12', '1', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (6708, '16/03/2020', '2020-11', '2', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6709, '01/02/2021', '2021-04', '1509', '28', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '12.71');
INSERT INTO public.europe_data_import VALUES (6710, '25/01/2021', '2021-03', '2128', '42', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '16.32');
INSERT INTO public.europe_data_import VALUES (6711, '18/01/2021', '2021-02', '2542', '42', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '19.1');
INSERT INTO public.europe_data_import VALUES (6712, '11/01/2021', '2021-01', '2921', '39', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '23.07');
INSERT INTO public.europe_data_import VALUES (6713, '04/01/2021', '2020-53', '3678', '53', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '28.27');
INSERT INTO public.europe_data_import VALUES (6714, '28/12/2020', '2020-52', '4409', '37', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '34.11');
INSERT INTO public.europe_data_import VALUES (6715, '21/12/2020', '2020-51', '5349', '90', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '44.71');
INSERT INTO public.europe_data_import VALUES (6716, '14/12/2020', '2020-50', '7442', '104', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '57.48');
INSERT INTO public.europe_data_import VALUES (6717, '07/12/2020', '2020-49', '9003', '115', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '72.26');
INSERT INTO public.europe_data_import VALUES (6718, '30/11/2020', '2020-48', '11670', '158', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '77.61');
INSERT INTO public.europe_data_import VALUES (6719, '23/11/2020', '2020-47', '10532', '100', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '90.37');
INSERT INTO public.europe_data_import VALUES (6720, '16/11/2020', '2020-46', '15323', '113', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '126.57');
INSERT INTO public.europe_data_import VALUES (6721, '09/11/2020', '2020-45', '20886', '148', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '127.11');
INSERT INTO public.europe_data_import VALUES (6722, '02/11/2020', '2020-44', '15478', '113', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '144.44');
INSERT INTO public.europe_data_import VALUES (6723, '26/10/2020', '2020-43', '25843', '108', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '175.94');
INSERT INTO public.europe_data_import VALUES (6724, '19/10/2020', '2020-42', '24491', '103', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '158.77');
INSERT INTO public.europe_data_import VALUES (6725, '12/10/2020', '2020-41', '20932', '101', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '120.11');
INSERT INTO public.europe_data_import VALUES (6726, '05/10/2020', '2020-40', '13429', '58', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '79.35');
INSERT INTO public.europe_data_import VALUES (6727, '28/09/2020', '2020-39', '9272', '66', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '67.23');
INSERT INTO public.europe_data_import VALUES (6728, '21/09/2020', '2020-38', '9963', '66', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '62.45');
INSERT INTO public.europe_data_import VALUES (6729, '14/09/2020', '2020-37', '7902', '56', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '54.52');
INSERT INTO public.europe_data_import VALUES (6730, '07/09/2020', '2020-36', '7696', '68', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '50.06');
INSERT INTO public.europe_data_import VALUES (6731, '31/08/2020', '2020-35', '6626', '72', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '41.6');
INSERT INTO public.europe_data_import VALUES (6732, '24/08/2020', '2020-34', '5275', '45', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '31.33');
INSERT INTO public.europe_data_import VALUES (6733, '17/08/2020', '2020-33', '3688', '29', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '22.12');
INSERT INTO public.europe_data_import VALUES (6734, '10/08/2020', '2020-32', '2640', '18', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '15.24');
INSERT INTO public.europe_data_import VALUES (6735, '03/08/2020', '2020-31', '1719', '12', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '9.35');
INSERT INTO public.europe_data_import VALUES (6736, '27/07/2020', '2020-30', '955', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '6.33');
INSERT INTO public.europe_data_import VALUES (6737, '20/07/2020', '2020-29', '857', '2', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '6.55');
INSERT INTO public.europe_data_import VALUES (6738, '13/07/2020', '2020-28', '1017', '4', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '14.08');
INSERT INTO public.europe_data_import VALUES (6739, '06/07/2020', '2020-27', '3012', '6', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '23.62');
INSERT INTO public.europe_data_import VALUES (6740, '29/06/2020', '2020-26', '3746', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '24.51');
INSERT INTO public.europe_data_import VALUES (6741, '22/06/2020', '2020-25', '3266', '4', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '19.5');
INSERT INTO public.europe_data_import VALUES (6742, '15/06/2020', '2020-24', '2312', '6', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '14.64');
INSERT INTO public.europe_data_import VALUES (6743, '08/06/2020', '2020-23', '1876', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '9.94');
INSERT INTO public.europe_data_import VALUES (6744, '01/06/2020', '2020-22', '969', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '4.43');
INSERT INTO public.europe_data_import VALUES (6745, '25/05/2020', '2020-21', '299', '1', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '1.69');
INSERT INTO public.europe_data_import VALUES (6746, '18/05/2020', '2020-20', '184', '2', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.8');
INSERT INTO public.europe_data_import VALUES (6747, '11/05/2020', '2020-19', '45', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (6748, '04/05/2020', '2020-18', '23', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (6749, '27/04/2020', '2020-17', '21', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (6750, '20/04/2020', '2020-16', '19', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6751, '13/04/2020', '2020-15', '3', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (6752, '06/04/2020', '2020-14', '4', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (6753, '30/03/2020', '2020-13', '4', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (6754, '23/03/2020', '2020-12', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6755, '16/03/2020', '2020-11', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6756, '09/03/2020', '2020-10', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6757, '02/03/2020', '2020-09', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6758, '24/02/2020', '2020-08', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6759, '17/02/2020', '2020-07', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6760, '10/02/2020', '2020-06', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6761, '03/02/2020', '2020-05', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (6762, '27/01/2020', '2020-04', '1', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (6763, '20/01/2020', '2020-03', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6764, '13/01/2020', '2020-02', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6765, '06/01/2020', '2020-01', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6766, '01/02/2021', '2021-04', '28671', '445', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '371.83');
INSERT INTO public.europe_data_import VALUES (6767, '25/01/2021', '2021-03', '35590', '522', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '431.41');
INSERT INTO public.europe_data_import VALUES (6768, '18/01/2021', '2021-02', '38967', '645', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '555.45');
INSERT INTO public.europe_data_import VALUES (6769, '11/01/2021', '2021-01', '57026', '799', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '623.33');
INSERT INTO public.europe_data_import VALUES (6770, '04/01/2021', '2020-53', '50699', '570', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '759.7');
INSERT INTO public.europe_data_import VALUES (6771, '28/12/2020', '2020-52', '80594', '551', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '906.99');
INSERT INTO public.europe_data_import VALUES (6772, '21/12/2020', '2020-51', '76154', '443', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '765.8');
INSERT INTO public.europe_data_import VALUES (6773, '14/12/2020', '2020-50', '56193', '360', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '546.65');
INSERT INTO public.europe_data_import VALUES (6774, '07/12/2020', '2020-49', '38280', '338', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '419.47');
INSERT INTO public.europe_data_import VALUES (6775, '30/11/2020', '2020-48', '34213', '457', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '410.47');
INSERT INTO public.europe_data_import VALUES (6776, '23/11/2020', '2020-47', '36725', '404', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '431.01');
INSERT INTO public.europe_data_import VALUES (6777, '16/11/2020', '2020-46', '37762', '481', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '508.61');
INSERT INTO public.europe_data_import VALUES (6778, '09/11/2020', '2020-45', '50136', '570', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '686.53');
INSERT INTO public.europe_data_import VALUES (6779, '02/11/2020', '2020-44', '68512', '388', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '759.18');
INSERT INTO public.europe_data_import VALUES (6780, '26/10/2020', '2020-43', '62691', '285', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '673.96');
INSERT INTO public.europe_data_import VALUES (6781, '19/10/2020', '2020-42', '53784', '176', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '535.15');
INSERT INTO public.europe_data_import VALUES (6782, '12/10/2020', '2020-41', '38701', '130', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '364.19');
INSERT INTO public.europe_data_import VALUES (6783, '05/10/2020', '2020-40', '24239', '80', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '243.4');
INSERT INTO public.europe_data_import VALUES (6784, '28/09/2020', '2020-39', '17826', '95', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '170.62');
INSERT INTO public.europe_data_import VALUES (6785, '21/09/2020', '2020-38', '11661', '25', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '109.76');
INSERT INTO public.europe_data_import VALUES (6786, '14/09/2020', '2020-37', '7308', '11', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '69.16');
INSERT INTO public.europe_data_import VALUES (6787, '07/09/2020', '2020-36', '4644', '19', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '47.59');
INSERT INTO public.europe_data_import VALUES (6788, '31/08/2020', '2020-35', '3581', '24', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '41.24');
INSERT INTO public.europe_data_import VALUES (6789, '24/08/2020', '2020-34', '3547', '28', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '45.86');
INSERT INTO public.europe_data_import VALUES (6790, '17/08/2020', '2020-33', '4379', '15', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '45.71');
INSERT INTO public.europe_data_import VALUES (6791, '10/08/2020', '2020-32', '3521', '8', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '32.51');
INSERT INTO public.europe_data_import VALUES (6792, '03/08/2020', '2020-31', '2097', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '19.2');
INSERT INTO public.europe_data_import VALUES (6793, '27/07/2020', '2020-30', '1221', '4', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '11.13');
INSERT INTO public.europe_data_import VALUES (6794, '20/07/2020', '2020-29', '703', '1', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '6.39');
INSERT INTO public.europe_data_import VALUES (6795, '13/07/2020', '2020-28', '401', '8', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '5.06');
INSERT INTO public.europe_data_import VALUES (6796, '06/07/2020', '2020-27', '474', '22', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '5.95');
INSERT INTO public.europe_data_import VALUES (6797, '29/06/2020', '2020-26', '554', '15', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '7.89');
INSERT INTO public.europe_data_import VALUES (6798, '22/06/2020', '2020-25', '810', '31', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '11.68');
INSERT INTO public.europe_data_import VALUES (6799, '15/06/2020', '2020-24', '1209', '46', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '13.55');
INSERT INTO public.europe_data_import VALUES (6800, '08/06/2020', '2020-23', '1132', '57', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '13.53');
INSERT INTO public.europe_data_import VALUES (6801, '01/06/2020', '2020-22', '1206', '134', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '14.16');
INSERT INTO public.europe_data_import VALUES (6802, '25/05/2020', '2020-21', '1241', '142', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '15.1');
INSERT INTO public.europe_data_import VALUES (6803, '18/05/2020', '2020-20', '1368', '240', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '19.81');
INSERT INTO public.europe_data_import VALUES (6804, '11/05/2020', '2020-19', '2056', '384', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '27.67');
INSERT INTO public.europe_data_import VALUES (6805, '04/05/2020', '2020-18', '2726', '581', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '45.8');
INSERT INTO public.europe_data_import VALUES (6806, '27/04/2020', '2020-17', '5190', '791', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '70.93');
INSERT INTO public.europe_data_import VALUES (6807, '20/04/2020', '2020-16', '7068', '947', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '85.66');
INSERT INTO public.europe_data_import VALUES (6808, '13/04/2020', '2020-15', '7736', '971', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '85.18');
INSERT INTO public.europe_data_import VALUES (6809, '06/04/2020', '2020-14', '6985', '995', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '78.97');
INSERT INTO public.europe_data_import VALUES (6810, '30/03/2020', '2020-13', '6662', '592', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '56.31');
INSERT INTO public.europe_data_import VALUES (6811, '23/03/2020', '2020-12', '3069', '159', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '22.79');
INSERT INTO public.europe_data_import VALUES (6812, '16/03/2020', '2020-11', '870', '17', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '6.49');
INSERT INTO public.europe_data_import VALUES (6813, '09/03/2020', '2020-10', '252', '3', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '1.53');
INSERT INTO public.europe_data_import VALUES (6814, '02/03/2020', '2020-09', '13', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (6815, '24/02/2020', '2020-08', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6816, '17/02/2020', '2020-07', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6817, '10/02/2020', '2020-06', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6818, '03/02/2020', '2020-05', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6819, '27/01/2020', '2020-04', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6820, '20/01/2020', '2020-03', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6821, '13/01/2020', '2020-02', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6822, '06/01/2020', '2020-01', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6823, '01/02/2021', '2021-04', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6824, '25/01/2021', '2021-03', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.41');
INSERT INTO public.europe_data_import VALUES (6825, '18/01/2021', '2021-02', '4', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.41');
INSERT INTO public.europe_data_import VALUES (6826, '11/01/2021', '2021-01', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6827, '04/01/2021', '2020-53', '2', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6828, '28/12/2020', '2020-52', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6829, '21/12/2020', '2020-51', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6830, '14/12/2020', '2020-50', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.41');
INSERT INTO public.europe_data_import VALUES (6831, '07/12/2020', '2020-49', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6832, '30/11/2020', '2020-48', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6833, '23/11/2020', '2020-47', '2', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6834, '16/11/2020', '2020-46', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6835, '09/11/2020', '2020-45', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6836, '02/11/2020', '2020-44', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6837, '26/10/2020', '2020-43', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6838, '19/10/2020', '2020-42', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6839, '12/10/2020', '2020-41', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6840, '05/10/2020', '2020-40', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6841, '28/09/2020', '2020-39', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6842, '21/09/2020', '2020-38', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6843, '14/09/2020', '2020-37', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6844, '07/09/2020', '2020-36', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6845, '31/08/2020', '2020-35', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6846, '24/08/2020', '2020-34', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6847, '17/08/2020', '2020-33', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6848, '10/08/2020', '2020-32', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6849, '03/08/2020', '2020-31', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6850, '27/07/2020', '2020-30', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6851, '20/07/2020', '2020-29', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6852, '13/07/2020', '2020-28', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6853, '06/07/2020', '2020-27', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6854, '29/06/2020', '2020-26', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6855, '22/06/2020', '2020-25', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6856, '15/06/2020', '2020-24', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6857, '08/06/2020', '2020-23', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6858, '01/06/2020', '2020-22', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6859, '25/05/2020', '2020-21', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6860, '18/05/2020', '2020-20', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6861, '11/05/2020', '2020-19', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6862, '04/05/2020', '2020-18', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6863, '27/04/2020', '2020-17', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6864, '20/04/2020', '2020-16', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6865, '13/04/2020', '2020-15', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6866, '06/04/2020', '2020-14', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '4.6');
INSERT INTO public.europe_data_import VALUES (6867, '30/03/2020', '2020-13', '10', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '5.3');
INSERT INTO public.europe_data_import VALUES (6868, '23/03/2020', '2020-12', '5', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6869, '01/02/2021', '2021-04', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.86');
INSERT INTO public.europe_data_import VALUES (6870, '25/01/2021', '2021-03', '26', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.38');
INSERT INTO public.europe_data_import VALUES (6871, '18/01/2021', '2021-02', '40', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.69');
INSERT INTO public.europe_data_import VALUES (6872, '11/01/2021', '2021-01', '41', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.63');
INSERT INTO public.europe_data_import VALUES (6873, '04/01/2021', '2020-53', '37', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.25');
INSERT INTO public.europe_data_import VALUES (6874, '28/12/2020', '2020-52', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.0');
INSERT INTO public.europe_data_import VALUES (6875, '21/12/2020', '2020-51', '25', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.88');
INSERT INTO public.europe_data_import VALUES (6876, '14/12/2020', '2020-50', '17', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.84');
INSERT INTO public.europe_data_import VALUES (6877, '07/12/2020', '2020-49', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.02');
INSERT INTO public.europe_data_import VALUES (6878, '30/11/2020', '2020-48', '26', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.15');
INSERT INTO public.europe_data_import VALUES (6879, '23/11/2020', '2020-47', '29', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.92');
INSERT INTO public.europe_data_import VALUES (6880, '16/11/2020', '2020-46', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (6881, '09/11/2020', '2020-45', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.96');
INSERT INTO public.europe_data_import VALUES (6882, '02/11/2020', '2020-44', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.61');
INSERT INTO public.europe_data_import VALUES (6883, '26/10/2020', '2020-43', '54', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.44');
INSERT INTO public.europe_data_import VALUES (6884, '19/10/2020', '2020-42', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.65');
INSERT INTO public.europe_data_import VALUES (6885, '12/10/2020', '2020-41', '16', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (6886, '05/10/2020', '2020-40', '22', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.73');
INSERT INTO public.europe_data_import VALUES (6887, '28/09/2020', '2020-39', '13', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.63');
INSERT INTO public.europe_data_import VALUES (6888, '21/09/2020', '2020-38', '17', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.82');
INSERT INTO public.europe_data_import VALUES (6889, '14/09/2020', '2020-37', '22', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.25');
INSERT INTO public.europe_data_import VALUES (6890, '07/09/2020', '2020-36', '38', '2', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.94');
INSERT INTO public.europe_data_import VALUES (6891, '31/08/2020', '2020-35', '55', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '2.24');
INSERT INTO public.europe_data_import VALUES (6892, '24/08/2020', '2020-34', '52', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '2.36');
INSERT INTO public.europe_data_import VALUES (6893, '17/08/2020', '2020-33', '61', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.32');
INSERT INTO public.europe_data_import VALUES (6894, '10/08/2020', '2020-32', '2', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.27');
INSERT INTO public.europe_data_import VALUES (6895, '03/08/2020', '2020-31', '11', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.27');
INSERT INTO public.europe_data_import VALUES (6896, '27/07/2020', '2020-30', '2', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.25');
INSERT INTO public.europe_data_import VALUES (6897, '20/07/2020', '2020-29', '10', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.44');
INSERT INTO public.europe_data_import VALUES (6898, '13/07/2020', '2020-28', '11', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.33');
INSERT INTO public.europe_data_import VALUES (6899, '06/07/2020', '2020-27', '5', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.42');
INSERT INTO public.europe_data_import VALUES (6900, '29/06/2020', '2020-26', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.5');
INSERT INTO public.europe_data_import VALUES (6901, '22/06/2020', '2020-25', '9', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.19');
INSERT INTO public.europe_data_import VALUES (6902, '15/06/2020', '2020-24', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6903, '08/06/2020', '2020-23', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6904, '01/06/2020', '2020-22', '0', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (6905, '25/05/2020', '2020-21', '5', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (6906, '18/05/2020', '2020-20', '2', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.25');
INSERT INTO public.europe_data_import VALUES (6907, '11/05/2020', '2020-19', '10', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.52');
INSERT INTO public.europe_data_import VALUES (6908, '04/05/2020', '2020-18', '15', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (6909, '27/04/2020', '2020-17', '17', '7', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.21');
INSERT INTO public.europe_data_import VALUES (6910, '20/04/2020', '2020-16', '41', '7', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '4.06');
INSERT INTO public.europe_data_import VALUES (6911, '13/04/2020', '2020-15', '153', '4', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '10.7');
INSERT INTO public.europe_data_import VALUES (6912, '06/04/2020', '2020-14', '359', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '16.91');
INSERT INTO public.europe_data_import VALUES (6913, '30/03/2020', '2020-13', '450', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '11.37');
INSERT INTO public.europe_data_import VALUES (6914, '23/03/2020', '2020-12', '94', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '2.03');
INSERT INTO public.europe_data_import VALUES (6915, '16/03/2020', '2020-11', '3', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (6916, '09/03/2020', '2020-10', '4', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (6917, '02/03/2020', '2020-09', '1', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (6918, '24/02/2020', '2020-08', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6919, '17/02/2020', '2020-07', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6920, '10/02/2020', '2020-06', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6921, '03/02/2020', '2020-05', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6922, '27/01/2020', '2020-04', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6923, '20/01/2020', '2020-03', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6924, '13/01/2020', '2020-02', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6925, '06/01/2020', '2020-01', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6926, '01/02/2021', '2021-04', '49', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.54');
INSERT INTO public.europe_data_import VALUES (6927, '25/01/2021', '2021-03', '52', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.63');
INSERT INTO public.europe_data_import VALUES (6928, '18/01/2021', '2021-02', '55', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.62');
INSERT INTO public.europe_data_import VALUES (6929, '11/01/2021', '2021-01', '51', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.62');
INSERT INTO public.europe_data_import VALUES (6930, '04/01/2021', '2020-53', '55', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.65');
INSERT INTO public.europe_data_import VALUES (6931, '28/12/2020', '2020-52', '53', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.59');
INSERT INTO public.europe_data_import VALUES (6932, '21/12/2020', '2020-51', '51', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.53');
INSERT INTO public.europe_data_import VALUES (6933, '14/12/2020', '2020-50', '49', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.57');
INSERT INTO public.europe_data_import VALUES (6934, '07/12/2020', '2020-49', '54', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.73');
INSERT INTO public.europe_data_import VALUES (6935, '30/11/2020', '2020-48', '59', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.88');
INSERT INTO public.europe_data_import VALUES (6936, '23/11/2020', '2020-47', '64', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (6937, '16/11/2020', '2020-46', '70', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.25');
INSERT INTO public.europe_data_import VALUES (6938, '09/11/2020', '2020-45', '77', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.4');
INSERT INTO public.europe_data_import VALUES (6939, '02/11/2020', '2020-44', '80', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.46');
INSERT INTO public.europe_data_import VALUES (6940, '26/10/2020', '2020-43', '81', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.6');
INSERT INTO public.europe_data_import VALUES (6941, '19/10/2020', '2020-42', '89', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.8');
INSERT INTO public.europe_data_import VALUES (6942, '12/10/2020', '2020-41', '94', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.92');
INSERT INTO public.europe_data_import VALUES (6943, '05/10/2020', '2020-40', '97', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '3.19');
INSERT INTO public.europe_data_import VALUES (6944, '28/09/2020', '2020-39', '112', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '3.9');
INSERT INTO public.europe_data_import VALUES (6945, '21/09/2020', '2020-38', '143', '3', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '4.48');
INSERT INTO public.europe_data_import VALUES (6946, '14/09/2020', '2020-37', '150', '3', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '4.95');
INSERT INTO public.europe_data_import VALUES (6947, '07/09/2020', '2020-36', '174', '4', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '5.45');
INSERT INTO public.europe_data_import VALUES (6948, '31/08/2020', '2020-35', '183', '4', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '5.79');
INSERT INTO public.europe_data_import VALUES (6949, '24/08/2020', '2020-34', '196', '5', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '6.25');
INSERT INTO public.europe_data_import VALUES (6950, '17/08/2020', '2020-33', '213', '5', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '6.77');
INSERT INTO public.europe_data_import VALUES (6951, '10/08/2020', '2020-32', '230', '7', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '7.07');
INSERT INTO public.europe_data_import VALUES (6952, '03/08/2020', '2020-31', '233', '8', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '8.02');
INSERT INTO public.europe_data_import VALUES (6953, '27/07/2020', '2020-30', '292', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '9.06');
INSERT INTO public.europe_data_import VALUES (6954, '20/07/2020', '2020-29', '301', '8', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '9.59');
INSERT INTO public.europe_data_import VALUES (6955, '13/07/2020', '2020-28', '327', '8', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '10.33');
INSERT INTO public.europe_data_import VALUES (6956, '06/07/2020', '2020-27', '349', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '7.72');
INSERT INTO public.europe_data_import VALUES (6957, '29/06/2020', '2020-26', '156', '10', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '7.87');
INSERT INTO public.europe_data_import VALUES (6958, '22/06/2020', '2020-25', '359', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '10.77');
INSERT INTO public.europe_data_import VALUES (6959, '15/06/2020', '2020-24', '346', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '13.69');
INSERT INTO public.europe_data_import VALUES (6960, '08/06/2020', '2020-23', '550', '11', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '15.74');
INSERT INTO public.europe_data_import VALUES (6961, '01/06/2020', '2020-22', '480', '18', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '11.21');
INSERT INTO public.europe_data_import VALUES (6962, '25/05/2020', '2020-21', '254', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '4.02');
INSERT INTO public.europe_data_import VALUES (6963, '18/05/2020', '2020-20', '9', '3', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.17');
INSERT INTO public.europe_data_import VALUES (6964, '11/05/2020', '2020-19', '2', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.05');
INSERT INTO public.europe_data_import VALUES (6965, '04/05/2020', '2020-18', '1', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.08');
INSERT INTO public.europe_data_import VALUES (6966, '27/04/2020', '2020-17', '4', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.06');
INSERT INTO public.europe_data_import VALUES (6967, '20/04/2020', '2020-16', '0', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.06');
INSERT INTO public.europe_data_import VALUES (6968, '13/04/2020', '2020-15', '4', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.08');
INSERT INTO public.europe_data_import VALUES (6969, '06/04/2020', '2020-14', '1', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.05');
INSERT INTO public.europe_data_import VALUES (6970, '30/03/2020', '2020-13', '2', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.06');
INSERT INTO public.europe_data_import VALUES (6971, '23/03/2020', '2020-12', '2', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '');
INSERT INTO public.europe_data_import VALUES (6972, '01/02/2021', '2021-04', '184', '10', '23310719', 'Niger', 'NE', 'NER', 'Africa', '1.63');
INSERT INTO public.europe_data_import VALUES (6973, '25/01/2021', '2021-03', '197', '11', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (6974, '18/01/2021', '2021-02', '279', '14', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.96');
INSERT INTO public.europe_data_import VALUES (6975, '11/01/2021', '2021-01', '412', '16', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.08');
INSERT INTO public.europe_data_import VALUES (6976, '04/01/2021', '2020-53', '306', '11', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (6977, '28/12/2020', '2020-52', '500', '12', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (6978, '21/12/2020', '2020-51', '401', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.44');
INSERT INTO public.europe_data_import VALUES (6979, '14/12/2020', '2020-50', '402', '3', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (6980, '07/12/2020', '2020-49', '340', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (6981, '30/11/2020', '2020-48', '148', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.9');
INSERT INTO public.europe_data_import VALUES (6982, '23/11/2020', '2020-47', '61', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (6983, '16/11/2020', '2020-46', '64', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (6984, '09/11/2020', '2020-45', '22', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (6985, '02/11/2020', '2020-44', '6', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6986, '26/10/2020', '2020-43', '5', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (6987, '19/10/2020', '2020-42', '9', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6988, '12/10/2020', '2020-41', '1', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6989, '05/10/2020', '2020-40', '4', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6990, '28/09/2020', '2020-39', '8', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (6991, '21/09/2020', '2020-38', '8', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6992, '14/09/2020', '2020-37', '3', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6993, '07/09/2020', '2020-36', '1', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6994, '31/08/2020', '2020-35', '4', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6995, '24/08/2020', '2020-34', '5', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (6996, '17/08/2020', '2020-33', '9', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (6997, '10/08/2020', '2020-32', '11', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (6998, '03/08/2020', '2020-31', '15', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (6999, '27/07/2020', '2020-30', '28', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (7000, '20/07/2020', '2020-29', '5', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (7001, '13/07/2020', '2020-28', '6', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (7002, '06/07/2020', '2020-27', '19', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (7003, '29/06/2020', '2020-26', '38', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (7004, '22/06/2020', '2020-25', '56', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (7005, '15/06/2020', '2020-24', '7', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (7006, '08/06/2020', '2020-23', '15', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (7007, '01/06/2020', '2020-22', '13', '3', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (7008, '25/05/2020', '2020-21', '41', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (7009, '18/05/2020', '2020-20', '83', '8', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (7010, '11/05/2020', '2020-19', '71', '10', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (7011, '04/05/2020', '2020-18', '54', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (7012, '27/04/2020', '2020-17', '48', '9', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (7013, '20/04/2020', '2020-16', '119', '8', '23310719', 'Niger', 'NE', 'NER', 'Africa', '1.99');
INSERT INTO public.europe_data_import VALUES (7014, '13/04/2020', '2020-15', '345', '2', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.23');
INSERT INTO public.europe_data_import VALUES (7015, '06/04/2020', '2020-14', '174', '9', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (7016, '30/03/2020', '2020-13', '9', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (7017, '23/03/2020', '2020-12', '1', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (7018, '01/02/2021', '2021-04', '8922', '100', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '10.71');
INSERT INTO public.europe_data_import VALUES (7019, '25/01/2021', '2021-03', '12609', '72', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '11.4');
INSERT INTO public.europe_data_import VALUES (7020, '18/01/2021', '2021-02', '10300', '77', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '10.1');
INSERT INTO public.europe_data_import VALUES (7021, '11/01/2021', '2021-01', '10007', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '7.6');
INSERT INTO public.europe_data_import VALUES (7022, '04/01/2021', '2020-53', '5269', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '5.8');
INSERT INTO public.europe_data_import VALUES (7023, '28/12/2020', '2020-52', '6377', '43', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '5.79');
INSERT INTO public.europe_data_import VALUES (7024, '21/12/2020', '2020-51', '5259', '24', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '4.57');
INSERT INTO public.europe_data_import VALUES (7025, '14/12/2020', '2020-50', '3920', '17', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.87');
INSERT INTO public.europe_data_import VALUES (7026, '07/12/2020', '2020-49', '1843', '7', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.43');
INSERT INTO public.europe_data_import VALUES (7027, '30/11/2020', '2020-48', '1029', '6', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (7028, '23/11/2020', '2020-47', '1235', '4', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (7029, '16/11/2020', '2020-46', '1058', '9', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.09');
INSERT INTO public.europe_data_import VALUES (7030, '09/11/2020', '2020-45', '1126', '8', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (7031, '02/11/2020', '2020-44', '972', '16', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (7032, '26/10/2020', '2020-43', '552', '5', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (7033, '19/10/2020', '2020-42', '1174', '10', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (7034, '12/10/2020', '2020-41', '921', '2', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (7035, '05/10/2020', '2020-40', '1021', '5', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (7036, '28/09/2020', '2020-39', '1082', '10', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (7037, '21/09/2020', '2020-38', '986', '16', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (7038, '14/09/2020', '2020-37', '1251', '25', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (7039, '07/09/2020', '2020-36', '1140', '44', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (7040, '31/08/2020', '2020-35', '1638', '11', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.39');
INSERT INTO public.europe_data_import VALUES (7041, '24/08/2020', '2020-34', '3159', '27', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (7042, '17/08/2020', '2020-33', '2491', '30', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.6');
INSERT INTO public.europe_data_import VALUES (7043, '10/08/2020', '2020-32', '2736', '57', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.01');
INSERT INTO public.europe_data_import VALUES (7044, '03/08/2020', '2020-31', '3309', '30', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.57');
INSERT INTO public.europe_data_import VALUES (7045, '27/07/2020', '2020-30', '3869', '69', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.97');
INSERT INTO public.europe_data_import VALUES (7046, '20/07/2020', '2020-29', '4105', '49', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.96');
INSERT INTO public.europe_data_import VALUES (7047, '13/07/2020', '2020-28', '3847', '95', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.98');
INSERT INTO public.europe_data_import VALUES (7048, '06/07/2020', '2020-27', '4144', '80', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '4.21');
INSERT INTO public.europe_data_import VALUES (7049, '29/06/2020', '2020-26', '4323', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '4.22');
INSERT INTO public.europe_data_import VALUES (7050, '22/06/2020', '2020-25', '4159', '98', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.86');
INSERT INTO public.europe_data_import VALUES (7051, '15/06/2020', '2020-24', '3599', '66', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.95');
INSERT INTO public.europe_data_import VALUES (7052, '08/06/2020', '2020-23', '2324', '67', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.31');
INSERT INTO public.europe_data_import VALUES (7053, '01/06/2020', '2020-22', '2323', '61', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (7054, '25/05/2020', '2020-21', '1880', '44', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.71');
INSERT INTO public.europe_data_import VALUES (7055, '18/05/2020', '2020-20', '1560', '39', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (7056, '11/05/2020', '2020-19', '1841', '56', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (7057, '04/05/2020', '2020-18', '1285', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (7058, '27/04/2020', '2020-17', '646', '19', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.47');
INSERT INTO public.europe_data_import VALUES (7059, '20/04/2020', '2020-16', '304', '11', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (7060, '13/04/2020', '2020-15', '91', '5', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (7061, '06/04/2020', '2020-14', '135', '4', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (7062, '30/03/2020', '2020-13', '67', '1', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (7063, '23/03/2020', '2020-12', '28', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (7064, '16/03/2020', '2020-11', '1', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (7065, '09/03/2020', '2020-10', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (7066, '02/03/2020', '2020-09', '1', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (7067, '24/02/2020', '2020-08', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7068, '17/02/2020', '2020-07', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7069, '10/02/2020', '2020-06', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7070, '03/02/2020', '2020-05', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7071, '27/01/2020', '2020-04', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7072, '20/01/2020', '2020-03', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7073, '13/01/2020', '2020-02', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7074, '06/01/2020', '2020-01', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (7075, '01/02/2021', '2021-04', '2039', '70', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '180.78');
INSERT INTO public.europe_data_import VALUES (7076, '25/01/2021', '2021-03', '1716', '83', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '200.28');
INSERT INTO public.europe_data_import VALUES (7077, '18/01/2021', '2021-02', '2444', '80', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '236.58');
INSERT INTO public.europe_data_import VALUES (7078, '11/01/2021', '2021-01', '2470', '92', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '225.79');
INSERT INTO public.europe_data_import VALUES (7079, '04/01/2021', '2020-53', '2220', '74', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '275.33');
INSERT INTO public.europe_data_import VALUES (7080, '28/12/2020', '2020-52', '3499', '164', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '393.14');
INSERT INTO public.europe_data_import VALUES (7081, '21/12/2020', '2020-51', '4667', '171', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '497.66');
INSERT INTO public.europe_data_import VALUES (7082, '14/12/2020', '2020-50', '5670', '197', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '582.29');
INSERT INTO public.europe_data_import VALUES (7083, '07/12/2020', '2020-49', '6425', '193', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '636.7');
INSERT INTO public.europe_data_import VALUES (7084, '30/11/2020', '2020-48', '6800', '220', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '697.74');
INSERT INTO public.europe_data_import VALUES (7085, '23/11/2020', '2020-47', '7693', '206', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '721.33');
INSERT INTO public.europe_data_import VALUES (7086, '16/11/2020', '2020-46', '7290', '169', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '703.57');
INSERT INTO public.europe_data_import VALUES (7087, '09/11/2020', '2020-45', '7324', '132', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '616.52');
INSERT INTO public.europe_data_import VALUES (7088, '02/11/2020', '2020-44', '5482', '85', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '424.05');
INSERT INTO public.europe_data_import VALUES (7089, '26/10/2020', '2020-43', '3326', '85', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '289.68');
INSERT INTO public.europe_data_import VALUES (7090, '19/10/2020', '2020-42', '2691', '42', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '241.97');
INSERT INTO public.europe_data_import VALUES (7091, '12/10/2020', '2020-41', '2335', '39', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '159.26');
INSERT INTO public.europe_data_import VALUES (7092, '05/10/2020', '2020-40', '973', '28', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '89.88');
INSERT INTO public.europe_data_import VALUES (7093, '28/09/2020', '2020-39', '894', '32', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '93.16');
INSERT INTO public.europe_data_import VALUES (7094, '21/09/2020', '2020-38', '1041', '47', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '94.99');
INSERT INTO public.europe_data_import VALUES (7095, '14/09/2020', '2020-37', '932', '40', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '85.07');
INSERT INTO public.europe_data_import VALUES (7096, '07/09/2020', '2020-36', '835', '22', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '60.08');
INSERT INTO public.europe_data_import VALUES (7097, '31/08/2020', '2020-35', '413', '21', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '57.19');
INSERT INTO public.europe_data_import VALUES (7098, '24/08/2020', '2020-34', '775', '19', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '79.82');
INSERT INTO public.europe_data_import VALUES (7099, '17/08/2020', '2020-33', '883', '17', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '81.12');
INSERT INTO public.europe_data_import VALUES (7100, '10/08/2020', '2020-32', '802', '30', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '85.21');
INSERT INTO public.europe_data_import VALUES (7101, '03/08/2020', '2020-31', '968', '37', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '92.53');
INSERT INTO public.europe_data_import VALUES (7102, '27/07/2020', '2020-30', '954', '38', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '95.08');
INSERT INTO public.europe_data_import VALUES (7103, '20/07/2020', '2020-29', '1021', '40', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '100.43');
INSERT INTO public.europe_data_import VALUES (7104, '13/07/2020', '2020-28', '1065', '41', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '97.2');
INSERT INTO public.europe_data_import VALUES (7105, '06/07/2020', '2020-27', '954', '55', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '93.4');
INSERT INTO public.europe_data_import VALUES (7106, '29/06/2020', '2020-26', '986', '48', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '97.97');
INSERT INTO public.europe_data_import VALUES (7107, '22/06/2020', '2020-25', '1049', '50', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '100.04');
INSERT INTO public.europe_data_import VALUES (7108, '15/06/2020', '2020-24', '1029', '35', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '88.15');
INSERT INTO public.europe_data_import VALUES (7109, '08/06/2020', '2020-23', '802', '20', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '50.55');
INSERT INTO public.europe_data_import VALUES (7110, '01/06/2020', '2020-22', '248', '20', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '20.89');
INSERT INTO public.europe_data_import VALUES (7111, '25/05/2020', '2020-21', '186', '12', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '16.18');
INSERT INTO public.europe_data_import VALUES (7112, '18/05/2020', '2020-20', '150', '10', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '13.53');
INSERT INTO public.europe_data_import VALUES (7113, '11/05/2020', '2020-19', '131', '7', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '12.32');
INSERT INTO public.europe_data_import VALUES (7114, '04/05/2020', '2020-18', '125', '23', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '14.64');
INSERT INTO public.europe_data_import VALUES (7115, '27/04/2020', '2020-17', '179', '10', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '26.86');
INSERT INTO public.europe_data_import VALUES (7116, '20/04/2020', '2020-16', '379', '17', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '34.86');
INSERT INTO public.europe_data_import VALUES (7117, '13/04/2020', '2020-15', '345', '17', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '27.39');
INSERT INTO public.europe_data_import VALUES (7118, '06/04/2020', '2020-14', '224', '11', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '17.76');
INSERT INTO public.europe_data_import VALUES (7119, '30/03/2020', '2020-13', '145', '5', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '11.84');
INSERT INTO public.europe_data_import VALUES (7120, '23/03/2020', '2020-12', '101', '1', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '5.34');
INSERT INTO public.europe_data_import VALUES (7121, '16/03/2020', '2020-11', '10', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0.58');
INSERT INTO public.europe_data_import VALUES (7122, '09/03/2020', '2020-10', '2', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0.14');
INSERT INTO public.europe_data_import VALUES (7123, '02/03/2020', '2020-09', '1', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0.05');
INSERT INTO public.europe_data_import VALUES (7124, '24/02/2020', '2020-08', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7125, '17/02/2020', '2020-07', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7126, '10/02/2020', '2020-06', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7127, '03/02/2020', '2020-05', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7128, '27/01/2020', '2020-04', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7129, '20/01/2020', '2020-03', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7130, '13/01/2020', '2020-02', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7131, '06/01/2020', '2020-01', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7132, '01/02/2021', '2021-04', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7133, '25/01/2021', '2021-03', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7134, '18/01/2021', '2021-02', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7135, '11/01/2021', '2021-01', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7136, '04/01/2021', '2020-53', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7137, '28/12/2020', '2020-52', '6', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '15.73');
INSERT INTO public.europe_data_import VALUES (7138, '21/12/2020', '2020-51', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7139, '14/12/2020', '2020-50', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7140, '07/12/2020', '2020-49', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '8.74');
INSERT INTO public.europe_data_import VALUES (7141, '30/11/2020', '2020-48', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7142, '23/11/2020', '2020-47', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7143, '16/11/2020', '2020-46', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7144, '09/11/2020', '2020-45', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '13.98');
INSERT INTO public.europe_data_import VALUES (7145, '02/11/2020', '2020-44', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '17.48');
INSERT INTO public.europe_data_import VALUES (7146, '26/10/2020', '2020-43', '6', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '26.22');
INSERT INTO public.europe_data_import VALUES (7147, '19/10/2020', '2020-42', '9', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '22.72');
INSERT INTO public.europe_data_import VALUES (7148, '12/10/2020', '2020-41', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7149, '05/10/2020', '2020-40', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7150, '28/09/2020', '2020-39', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '17.48');
INSERT INTO public.europe_data_import VALUES (7151, '21/09/2020', '2020-38', '9', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '19.23');
INSERT INTO public.europe_data_import VALUES (7152, '14/09/2020', '2020-37', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7153, '07/09/2020', '2020-36', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7154, '31/08/2020', '2020-35', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7155, '24/08/2020', '2020-34', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7156, '17/08/2020', '2020-33', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7157, '10/08/2020', '2020-32', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '13.98');
INSERT INTO public.europe_data_import VALUES (7158, '03/08/2020', '2020-31', '6', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '15.73');
INSERT INTO public.europe_data_import VALUES (7159, '27/07/2020', '2020-30', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7160, '20/07/2020', '2020-29', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7161, '13/07/2020', '2020-28', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7162, '06/07/2020', '2020-27', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '1.75');
INSERT INTO public.europe_data_import VALUES (7163, '29/06/2020', '2020-26', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7164, '22/06/2020', '2020-25', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7165, '15/06/2020', '2020-24', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '13.98');
INSERT INTO public.europe_data_import VALUES (7166, '08/06/2020', '2020-23', '5', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '8.74');
INSERT INTO public.europe_data_import VALUES (7167, '01/06/2020', '2020-22', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '1.75');
INSERT INTO public.europe_data_import VALUES (7168, '25/05/2020', '2020-21', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7169, '18/05/2020', '2020-20', '5', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7170, '11/05/2020', '2020-19', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '3.5');
INSERT INTO public.europe_data_import VALUES (7171, '04/05/2020', '2020-18', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7172, '27/04/2020', '2020-17', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7173, '20/04/2020', '2020-16', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7174, '13/04/2020', '2020-15', '3', '1', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '19.23');
INSERT INTO public.europe_data_import VALUES (7175, '06/04/2020', '2020-14', '8', '1', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (7176, '01/02/2021', '2021-04', '1884', '19', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '80.98');
INSERT INTO public.europe_data_import VALUES (7177, '25/01/2021', '2021-03', '2431', '27', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '105.27');
INSERT INTO public.europe_data_import VALUES (7178, '18/01/2021', '2021-02', '3178', '43', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '148.94');
INSERT INTO public.europe_data_import VALUES (7179, '11/01/2021', '2021-01', '4758', '29', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '157.95');
INSERT INTO public.europe_data_import VALUES (7180, '04/01/2021', '2020-53', '3658', '20', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '149.02');
INSERT INTO public.europe_data_import VALUES (7181, '28/12/2020', '2020-52', '4282', '25', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '113.62');
INSERT INTO public.europe_data_import VALUES (7182, '21/12/2020', '2020-51', '1772', '11', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '101.42');
INSERT INTO public.europe_data_import VALUES (7183, '14/12/2020', '2020-50', '3632', '39', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '117.41');
INSERT INTO public.europe_data_import VALUES (7184, '07/12/2020', '2020-49', '2624', '26', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '111.35');
INSERT INTO public.europe_data_import VALUES (7185, '30/11/2020', '2020-48', '3309', '22', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '141.15');
INSERT INTO public.europe_data_import VALUES (7186, '23/11/2020', '2020-47', '4212', '12', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '154.14');
INSERT INTO public.europe_data_import VALUES (7187, '16/11/2020', '2020-46', '4001', '9', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '143.82');
INSERT INTO public.europe_data_import VALUES (7188, '09/11/2020', '2020-45', '3662', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '112.48');
INSERT INTO public.europe_data_import VALUES (7189, '02/11/2020', '2020-44', '2331', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '64.32');
INSERT INTO public.europe_data_import VALUES (7190, '26/10/2020', '2020-43', '1096', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '37.74');
INSERT INTO public.europe_data_import VALUES (7191, '19/10/2020', '2020-42', '915', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '37.29');
INSERT INTO public.europe_data_import VALUES (7192, '12/10/2020', '2020-41', '1072', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '34.06');
INSERT INTO public.europe_data_import VALUES (7193, '05/10/2020', '2020-40', '743', '5', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '28.23');
INSERT INTO public.europe_data_import VALUES (7194, '28/09/2020', '2020-39', '761', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '28.9');
INSERT INTO public.europe_data_import VALUES (7195, '21/09/2020', '2020-38', '779', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '28.62');
INSERT INTO public.europe_data_import VALUES (7196, '14/09/2020', '2020-37', '746', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '24.83');
INSERT INTO public.europe_data_import VALUES (7197, '07/09/2020', '2020-36', '577', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '17.32');
INSERT INTO public.europe_data_import VALUES (7198, '31/08/2020', '2020-35', '346', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '13.01');
INSERT INTO public.europe_data_import VALUES (7199, '24/08/2020', '2020-34', '347', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '13.68');
INSERT INTO public.europe_data_import VALUES (7200, '17/08/2020', '2020-33', '382', '5', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '12.05');
INSERT INTO public.europe_data_import VALUES (7201, '10/08/2020', '2020-32', '260', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '7.19');
INSERT INTO public.europe_data_import VALUES (7202, '03/08/2020', '2020-31', '123', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.62');
INSERT INTO public.europe_data_import VALUES (7203, '27/07/2020', '2020-30', '70', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '2.25');
INSERT INTO public.europe_data_import VALUES (7204, '20/07/2020', '2020-29', '50', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '2.25');
INSERT INTO public.europe_data_import VALUES (7205, '13/07/2020', '2020-28', '70', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '2.82');
INSERT INTO public.europe_data_import VALUES (7206, '06/07/2020', '2020-27', '80', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.51');
INSERT INTO public.europe_data_import VALUES (7207, '29/06/2020', '2020-26', '107', '5', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.92');
INSERT INTO public.europe_data_import VALUES (7208, '22/06/2020', '2020-25', '102', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.83');
INSERT INTO public.europe_data_import VALUES (7209, '15/06/2020', '2020-24', '102', '4', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.66');
INSERT INTO public.europe_data_import VALUES (7210, '08/06/2020', '2020-23', '93', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.66');
INSERT INTO public.europe_data_import VALUES (7211, '01/06/2020', '2020-22', '102', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '4.02');
INSERT INTO public.europe_data_import VALUES (7212, '25/05/2020', '2020-21', '112', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (7213, '18/05/2020', '2020-20', '98', '15', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '7.28');
INSERT INTO public.europe_data_import VALUES (7214, '11/05/2020', '2020-19', '290', '9', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '11.15');
INSERT INTO public.europe_data_import VALUES (7215, '04/05/2020', '2020-18', '304', '15', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '13.91');
INSERT INTO public.europe_data_import VALUES (7216, '27/04/2020', '2020-17', '437', '39', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '20.46');
INSERT INTO public.europe_data_import VALUES (7217, '20/04/2020', '2020-16', '653', '51', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '26.8');
INSERT INTO public.europe_data_import VALUES (7218, '13/04/2020', '2020-15', '775', '45', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '43.41');
INSERT INTO public.europe_data_import VALUES (7219, '06/04/2020', '2020-14', '1538', '36', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '65.84');
INSERT INTO public.europe_data_import VALUES (7220, '30/03/2020', '2020-13', '1970', '15', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '56.77');
INSERT INTO public.europe_data_import VALUES (7221, '23/03/2020', '2020-12', '1055', '6', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '36.84');
INSERT INTO public.europe_data_import VALUES (7222, '16/03/2020', '2020-11', '908', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '19.86');
INSERT INTO public.europe_data_import VALUES (7223, '09/03/2020', '2020-10', '150', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.17');
INSERT INTO public.europe_data_import VALUES (7224, '02/03/2020', '2020-09', '19', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0.36');
INSERT INTO public.europe_data_import VALUES (7225, '24/02/2020', '2020-08', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7226, '17/02/2020', '2020-07', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7227, '10/02/2020', '2020-06', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7228, '03/02/2020', '2020-05', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7229, '27/01/2020', '2020-04', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7230, '20/01/2020', '2020-03', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7231, '13/01/2020', '2020-02', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7232, '06/01/2020', '2020-01', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7233, '01/02/2021', '2021-04', '1480', '11', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '54.95');
INSERT INTO public.europe_data_import VALUES (7234, '25/01/2021', '2021-03', '1254', '9', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '45.51');
INSERT INTO public.europe_data_import VALUES (7235, '18/01/2021', '2021-02', '1010', '4', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '44.34');
INSERT INTO public.europe_data_import VALUES (7236, '11/01/2021', '2021-01', '1196', '6', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '46.39');
INSERT INTO public.europe_data_import VALUES (7237, '04/01/2021', '2020-53', '1112', '7', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '38.53');
INSERT INTO public.europe_data_import VALUES (7238, '28/12/2020', '2020-52', '805', '7', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '44.86');
INSERT INTO public.europe_data_import VALUES (7239, '21/12/2020', '2020-51', '1427', '17', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '55.9');
INSERT INTO public.europe_data_import VALUES (7240, '14/12/2020', '2020-50', '1354', '27', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '55.4');
INSERT INTO public.europe_data_import VALUES (7241, '07/12/2020', '2020-49', '1402', '26', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '56.38');
INSERT INTO public.europe_data_import VALUES (7242, '30/11/2020', '2020-48', '1403', '38', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '62.21');
INSERT INTO public.europe_data_import VALUES (7243, '23/11/2020', '2020-47', '1692', '42', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '79.22');
INSERT INTO public.europe_data_import VALUES (7244, '16/11/2020', '2020-46', '2249', '37', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '93.57');
INSERT INTO public.europe_data_import VALUES (7245, '09/11/2020', '2020-45', '2406', '55', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '104.68');
INSERT INTO public.europe_data_import VALUES (7246, '02/11/2020', '2020-44', '2802', '72', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '116.2');
INSERT INTO public.europe_data_import VALUES (7247, '26/10/2020', '2020-43', '2979', '73', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '141.55');
INSERT INTO public.europe_data_import VALUES (7248, '19/10/2020', '2020-42', '4063', '63', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '174.53');
INSERT INTO public.europe_data_import VALUES (7249, '12/10/2020', '2020-41', '4620', '61', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '169.65');
INSERT INTO public.europe_data_import VALUES (7250, '05/10/2020', '2020-40', '3820', '68', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '156.68');
INSERT INTO public.europe_data_import VALUES (7251, '28/09/2020', '2020-39', '3975', '63', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '154.85');
INSERT INTO public.europe_data_import VALUES (7252, '21/09/2020', '2020-38', '3729', '66', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '128.7');
INSERT INTO public.europe_data_import VALUES (7253, '14/09/2020', '2020-37', '2674', '52', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '84.46');
INSERT INTO public.europe_data_import VALUES (7254, '07/09/2020', '2020-36', '1528', '51', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '66.39');
INSERT INTO public.europe_data_import VALUES (7255, '31/08/2020', '2020-35', '1775', '68', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '49.41');
INSERT INTO public.europe_data_import VALUES (7256, '24/08/2020', '2020-34', '683', '37', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '44.0');
INSERT INTO public.europe_data_import VALUES (7257, '17/08/2020', '2020-33', '1506', '59', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '78.93');
INSERT INTO public.europe_data_import VALUES (7258, '10/08/2020', '2020-32', '2421', '92', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '112.06');
INSERT INTO public.europe_data_import VALUES (7259, '03/08/2020', '2020-31', '3154', '37', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '251.22');
INSERT INTO public.europe_data_import VALUES (7260, '27/07/2020', '2020-30', '9344', '66', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '401.81');
INSERT INTO public.europe_data_import VALUES (7261, '20/07/2020', '2020-29', '10646', '61', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '411.72');
INSERT INTO public.europe_data_import VALUES (7262, '13/07/2020', '2020-28', '9837', '44', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '359.1');
INSERT INTO public.europe_data_import VALUES (7263, '06/07/2020', '2020-27', '8028', '50', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '335.82');
INSERT INTO public.europe_data_import VALUES (7264, '29/06/2020', '2020-26', '8679', '32', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '294.85');
INSERT INTO public.europe_data_import VALUES (7265, '22/06/2020', '2020-25', '5990', '27', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '253.05');
INSERT INTO public.europe_data_import VALUES (7266, '15/06/2020', '2020-24', '6599', '29', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '242.09');
INSERT INTO public.europe_data_import VALUES (7267, '08/06/2020', '2020-23', '5445', '28', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '183.16');
INSERT INTO public.europe_data_import VALUES (7268, '01/06/2020', '2020-22', '3667', '10', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '125.65');
INSERT INTO public.europe_data_import VALUES (7269, '25/05/2020', '2020-21', '2584', '15', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '87.86');
INSERT INTO public.europe_data_import VALUES (7270, '18/05/2020', '2020-20', '1787', '5', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '52.62');
INSERT INTO public.europe_data_import VALUES (7271, '11/05/2020', '2020-19', '831', '5', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '28.16');
INSERT INTO public.europe_data_import VALUES (7272, '04/05/2020', '2020-18', '570', '2', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '26.17');
INSERT INTO public.europe_data_import VALUES (7273, '27/04/2020', '2020-17', '732', '3', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '28.12');
INSERT INTO public.europe_data_import VALUES (7274, '20/04/2020', '2020-16', '667', '3', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '19.46');
INSERT INTO public.europe_data_import VALUES (7275, '13/04/2020', '2020-15', '301', '2', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '8.68');
INSERT INTO public.europe_data_import VALUES (7276, '06/04/2020', '2020-14', '131', '2', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '4.88');
INSERT INTO public.europe_data_import VALUES (7277, '30/03/2020', '2020-13', '112', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '2.91');
INSERT INTO public.europe_data_import VALUES (7278, '23/03/2020', '2020-12', '33', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (7279, '16/03/2020', '2020-11', '6', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (7280, '09/03/2020', '2020-10', '10', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (7281, '02/03/2020', '2020-09', '6', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (7282, '24/02/2020', '2020-08', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7283, '17/02/2020', '2020-07', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7284, '10/02/2020', '2020-06', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7285, '03/02/2020', '2020-05', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7286, '27/01/2020', '2020-04', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7287, '20/01/2020', '2020-03', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7288, '13/01/2020', '2020-02', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7289, '06/01/2020', '2020-01', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7290, '01/02/2021', '2021-04', '12387', '365', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '11.64');
INSERT INTO public.europe_data_import VALUES (7291, '25/01/2021', '2021-03', '12830', '321', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '13.74');
INSERT INTO public.europe_data_import VALUES (7292, '18/01/2021', '2021-02', '16918', '321', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '15.09');
INSERT INTO public.europe_data_import VALUES (7293, '11/01/2021', '2021-01', '15764', '326', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '14.31');
INSERT INTO public.europe_data_import VALUES (7294, '04/01/2021', '2020-53', '15220', '421', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '13.65');
INSERT INTO public.europe_data_import VALUES (7295, '28/12/2020', '2020-52', '14341', '537', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '15.02');
INSERT INTO public.europe_data_import VALUES (7296, '21/12/2020', '2020-51', '18181', '560', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '17.86');
INSERT INTO public.europe_data_import VALUES (7297, '14/12/2020', '2020-50', '20493', '434', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '19.75');
INSERT INTO public.europe_data_import VALUES (7298, '07/12/2020', '2020-49', '22270', '373', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '20.02');
INSERT INTO public.europe_data_import VALUES (7299, '30/11/2020', '2020-48', '21095', '329', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '18.0');
INSERT INTO public.europe_data_import VALUES (7300, '23/11/2020', '2020-47', '17897', '536', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '14.82');
INSERT INTO public.europe_data_import VALUES (7301, '16/11/2020', '2020-46', '14193', '183', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '11.05');
INSERT INTO public.europe_data_import VALUES (7302, '09/11/2020', '2020-45', '9746', '142', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '7.5');
INSERT INTO public.europe_data_import VALUES (7303, '02/11/2020', '2020-44', '6491', '96', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '5.38');
INSERT INTO public.europe_data_import VALUES (7304, '26/10/2020', '2020-43', '5150', '80', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.47');
INSERT INTO public.europe_data_import VALUES (7305, '19/10/2020', '2020-42', '4520', '89', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.08');
INSERT INTO public.europe_data_import VALUES (7306, '12/10/2020', '2020-41', '4316', '57', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.74');
INSERT INTO public.europe_data_import VALUES (7307, '05/10/2020', '2020-40', '3775', '47', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.84');
INSERT INTO public.europe_data_import VALUES (7308, '28/09/2020', '2020-39', '4537', '46', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.07');
INSERT INTO public.europe_data_import VALUES (7309, '21/09/2020', '2020-38', '4284', '37', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.42');
INSERT INTO public.europe_data_import VALUES (7310, '14/09/2020', '2020-37', '3117', '38', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '2.85');
INSERT INTO public.europe_data_import VALUES (7311, '07/09/2020', '2020-36', '3054', '51', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '2.83');
INSERT INTO public.europe_data_import VALUES (7312, '31/08/2020', '2020-35', '3084', '59', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.06');
INSERT INTO public.europe_data_import VALUES (7313, '24/08/2020', '2020-34', '3550', '60', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.74');
INSERT INTO public.europe_data_import VALUES (7314, '17/08/2020', '2020-33', '4555', '78', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.24');
INSERT INTO public.europe_data_import VALUES (7315, '10/08/2020', '2020-32', '4631', '113', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.79');
INSERT INTO public.europe_data_import VALUES (7316, '03/08/2020', '2020-31', '5740', '142', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '6.9');
INSERT INTO public.europe_data_import VALUES (7317, '27/07/2020', '2020-30', '9206', '243', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '10.47');
INSERT INTO public.europe_data_import VALUES (7318, '20/07/2020', '2020-29', '13458', '333', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '15.36');
INSERT INTO public.europe_data_import VALUES (7319, '13/07/2020', '2020-28', '19807', '504', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '20.83');
INSERT INTO public.europe_data_import VALUES (7320, '06/07/2020', '2020-27', '25306', '595', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '23.42');
INSERT INTO public.europe_data_import VALUES (7321, '29/06/2020', '2020-26', '25424', '577', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '28.64');
INSERT INTO public.europe_data_import VALUES (7322, '22/06/2020', '2020-25', '36610', '861', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '35.75');
INSERT INTO public.europe_data_import VALUES (7323, '15/06/2020', '2020-24', '40807', '662', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '33.25');
INSERT INTO public.europe_data_import VALUES (7324, '08/06/2020', '2020-23', '31211', '524', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '21.85');
INSERT INTO public.europe_data_import VALUES (7325, '01/06/2020', '2020-22', '16111', '376', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '14.01');
INSERT INTO public.europe_data_import VALUES (7326, '25/05/2020', '2020-21', '14224', '264', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '11.73');
INSERT INTO public.europe_data_import VALUES (7327, '18/05/2020', '2020-20', '11184', '236', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '10.13');
INSERT INTO public.europe_data_import VALUES (7328, '11/05/2020', '2020-19', '10755', '205', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '8.13');
INSERT INTO public.europe_data_import VALUES (7329, '04/05/2020', '2020-18', '6858', '181', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '5.43');
INSERT INTO public.europe_data_import VALUES (7330, '27/04/2020', '2020-17', '4910', '105', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.67');
INSERT INTO public.europe_data_import VALUES (7331, '20/04/2020', '2020-16', '3044', '83', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '2.37');
INSERT INTO public.europe_data_import VALUES (7332, '13/04/2020', '2020-15', '2097', '43', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '1.78');
INSERT INTO public.europe_data_import VALUES (7333, '06/04/2020', '2020-14', '1751', '37', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '1.15');
INSERT INTO public.europe_data_import VALUES (7334, '30/03/2020', '2020-13', '742', '8', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (7335, '23/03/2020', '2020-12', '753', '5', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.36');
INSERT INTO public.europe_data_import VALUES (7336, '16/03/2020', '2020-11', '25', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (7337, '09/03/2020', '2020-10', '2', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7338, '02/03/2020', '2020-09', '4', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7339, '24/02/2020', '2020-08', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7340, '17/02/2020', '2020-07', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7341, '10/02/2020', '2020-06', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7342, '03/02/2020', '2020-05', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7343, '27/01/2020', '2020-04', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7344, '20/01/2020', '2020-03', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7345, '13/01/2020', '2020-02', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7346, '06/01/2020', '2020-01', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7347, '01/02/2021', '2021-04', '3973', '50', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '154.65');
INSERT INTO public.europe_data_import VALUES (7348, '25/01/2021', '2021-03', '3731', '90', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '180.61');
INSERT INTO public.europe_data_import VALUES (7349, '18/01/2021', '2021-02', '5266', '125', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '224.27');
INSERT INTO public.europe_data_import VALUES (7350, '11/01/2021', '2021-01', '5906', '124', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '312.88');
INSERT INTO public.europe_data_import VALUES (7351, '04/01/2021', '2020-53', '9680', '189', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '401.41');
INSERT INTO public.europe_data_import VALUES (7352, '28/12/2020', '2020-52', '10316', '147', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '516.04');
INSERT INTO public.europe_data_import VALUES (7353, '21/12/2020', '2020-51', '15390', '208', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '562.33');
INSERT INTO public.europe_data_import VALUES (7354, '14/12/2020', '2020-50', '12622', '157', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '559.46');
INSERT INTO public.europe_data_import VALUES (7355, '07/12/2020', '2020-49', '15247', '115', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '555.97');
INSERT INTO public.europe_data_import VALUES (7356, '30/11/2020', '2020-48', '12448', '93', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '430.84');
INSERT INTO public.europe_data_import VALUES (7357, '23/11/2020', '2020-47', '9014', '74', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '284.64');
INSERT INTO public.europe_data_import VALUES (7358, '16/11/2020', '2020-46', '5165', '53', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '191.19');
INSERT INTO public.europe_data_import VALUES (7359, '09/11/2020', '2020-45', '4359', '26', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '162.91');
INSERT INTO public.europe_data_import VALUES (7360, '02/11/2020', '2020-44', '3756', '43', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '145.8');
INSERT INTO public.europe_data_import VALUES (7361, '26/10/2020', '2020-43', '3507', '39', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '130.28');
INSERT INTO public.europe_data_import VALUES (7362, '19/10/2020', '2020-42', '2983', '34', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '122.58');
INSERT INTO public.europe_data_import VALUES (7363, '12/10/2020', '2020-41', '3123', '54', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '127.73');
INSERT INTO public.europe_data_import VALUES (7364, '05/10/2020', '2020-40', '3240', '48', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '140.26');
INSERT INTO public.europe_data_import VALUES (7365, '28/09/2020', '2020-39', '3747', '43', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '194.38');
INSERT INTO public.europe_data_import VALUES (7366, '21/09/2020', '2020-38', '5936', '50', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '229.53');
INSERT INTO public.europe_data_import VALUES (7367, '14/09/2020', '2020-37', '5498', '47', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '209.72');
INSERT INTO public.europe_data_import VALUES (7368, '07/09/2020', '2020-36', '4949', '37', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '180.43');
INSERT INTO public.europe_data_import VALUES (7369, '31/08/2020', '2020-35', '4039', '23', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '143.09');
INSERT INTO public.europe_data_import VALUES (7370, '24/08/2020', '2020-34', '3089', '22', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '127.94');
INSERT INTO public.europe_data_import VALUES (7371, '17/08/2020', '2020-33', '3284', '18', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '123.56');
INSERT INTO public.europe_data_import VALUES (7372, '10/08/2020', '2020-32', '2871', '16', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '110.85');
INSERT INTO public.europe_data_import VALUES (7373, '03/08/2020', '2020-31', '2651', '9', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '114.99');
INSERT INTO public.europe_data_import VALUES (7374, '27/07/2020', '2020-30', '3077', '16', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '122.27');
INSERT INTO public.europe_data_import VALUES (7375, '20/07/2020', '2020-29', '3014', '25', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '112.3');
INSERT INTO public.europe_data_import VALUES (7376, '13/07/2020', '2020-28', '2580', '17', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '96.16');
INSERT INTO public.europe_data_import VALUES (7377, '06/07/2020', '2020-27', '2210', '13', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '68.98');
INSERT INTO public.europe_data_import VALUES (7378, '29/06/2020', '2020-26', '1226', '2', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '31.62');
INSERT INTO public.europe_data_import VALUES (7379, '22/06/2020', '2020-25', '349', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '7.45');
INSERT INTO public.europe_data_import VALUES (7380, '15/06/2020', '2020-24', '22', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '0.92');
INSERT INTO public.europe_data_import VALUES (7381, '08/06/2020', '2020-23', '24', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (7382, '01/06/2020', '2020-22', '25', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.34');
INSERT INTO public.europe_data_import VALUES (7383, '25/05/2020', '2020-21', '42', '1', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.1');
INSERT INTO public.europe_data_import VALUES (7384, '18/05/2020', '2020-20', '13', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (7385, '11/05/2020', '2020-19', '25', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.04');
INSERT INTO public.europe_data_import VALUES (7386, '04/05/2020', '2020-18', '27', '2', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '4.01');
INSERT INTO public.europe_data_import VALUES (7387, '27/04/2020', '2020-17', '173', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '4.56');
INSERT INTO public.europe_data_import VALUES (7388, '20/04/2020', '2020-16', '54', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '2.11');
INSERT INTO public.europe_data_import VALUES (7389, '13/04/2020', '2020-15', '51', '1', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '3.25');
INSERT INTO public.europe_data_import VALUES (7390, '06/04/2020', '2020-14', '111', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '3.17');
INSERT INTO public.europe_data_import VALUES (7391, '30/03/2020', '2020-13', '47', '1', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.37');
INSERT INTO public.europe_data_import VALUES (7392, '23/03/2020', '2020-12', '21', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (7393, '16/03/2020', '2020-11', '38', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7394, '01/02/2021', '2021-04', '8221', '172', '4246440', 'Panama', 'PA', 'PAN', 'America', '526.56');
INSERT INTO public.europe_data_import VALUES (7395, '25/01/2021', '2021-03', '14139', '311', '4246440', 'Panama', 'PA', 'PAN', 'America', '776.23');
INSERT INTO public.europe_data_import VALUES (7396, '18/01/2021', '2021-02', '18823', '332', '4246440', 'Panama', 'PA', 'PAN', 'America', '1042.83');
INSERT INTO public.europe_data_import VALUES (7397, '11/01/2021', '2021-01', '25460', '315', '4246440', 'Panama', 'PA', 'PAN', 'America', '1071.27');
INSERT INTO public.europe_data_import VALUES (7398, '04/01/2021', '2020-53', '20031', '248', '4246440', 'Panama', 'PA', 'PAN', 'America', '934.85');
INSERT INTO public.europe_data_import VALUES (7399, '28/12/2020', '2020-52', '19667', '295', '4246440', 'Panama', 'PA', 'PAN', 'America', '958.4');
INSERT INTO public.europe_data_import VALUES (7400, '21/12/2020', '2020-51', '21031', '241', '4246440', 'Panama', 'PA', 'PAN', 'America', '855.28');
INSERT INTO public.europe_data_import VALUES (7401, '14/12/2020', '2020-50', '15288', '163', '4246440', 'Panama', 'PA', 'PAN', 'America', '665.92');
INSERT INTO public.europe_data_import VALUES (7402, '07/12/2020', '2020-49', '12990', '133', '4246440', 'Panama', 'PA', 'PAN', 'America', '540.12');
INSERT INTO public.europe_data_import VALUES (7403, '30/11/2020', '2020-48', '9946', '103', '4246440', 'Panama', 'PA', 'PAN', 'America', '425.67');
INSERT INTO public.europe_data_import VALUES (7404, '23/11/2020', '2020-47', '8130', '84', '4246440', 'Panama', 'PA', 'PAN', 'America', '359.27');
INSERT INTO public.europe_data_import VALUES (7405, '16/11/2020', '2020-46', '7126', '75', '4246440', 'Panama', 'PA', 'PAN', 'America', '290.05');
INSERT INTO public.europe_data_import VALUES (7406, '09/11/2020', '2020-45', '5191', '92', '4246440', 'Panama', 'PA', 'PAN', 'America', '243.19');
INSERT INTO public.europe_data_import VALUES (7407, '02/11/2020', '2020-44', '5136', '73', '4246440', 'Panama', 'PA', 'PAN', 'America', '225.86');
INSERT INTO public.europe_data_import VALUES (7408, '26/10/2020', '2020-43', '4455', '69', '4246440', 'Panama', 'PA', 'PAN', 'America', '209.28');
INSERT INTO public.europe_data_import VALUES (7409, '19/10/2020', '2020-42', '4432', '73', '4246440', 'Panama', 'PA', 'PAN', 'America', '222.75');
INSERT INTO public.europe_data_import VALUES (7410, '12/10/2020', '2020-41', '5027', '68', '4246440', 'Panama', 'PA', 'PAN', 'America', '229.79');
INSERT INTO public.europe_data_import VALUES (7411, '05/10/2020', '2020-40', '4731', '83', '4246440', 'Panama', 'PA', 'PAN', 'America', '213.9');
INSERT INTO public.europe_data_import VALUES (7412, '28/09/2020', '2020-39', '4352', '83', '4246440', 'Panama', 'PA', 'PAN', 'America', '207.47');
INSERT INTO public.europe_data_import VALUES (7413, '21/09/2020', '2020-38', '4458', '91', '4246440', 'Panama', 'PA', 'PAN', 'America', '215.71');
INSERT INTO public.europe_data_import VALUES (7414, '14/09/2020', '2020-37', '4702', '80', '4246440', 'Panama', 'PA', 'PAN', 'America', '227.96');
INSERT INTO public.europe_data_import VALUES (7415, '07/09/2020', '2020-36', '4978', '91', '4246440', 'Panama', 'PA', 'PAN', 'America', '238.86');
INSERT INTO public.europe_data_import VALUES (7416, '31/08/2020', '2020-35', '5165', '103', '4246440', 'Panama', 'PA', 'PAN', 'America', '238.44');
INSERT INTO public.europe_data_import VALUES (7417, '24/08/2020', '2020-34', '4960', '125', '4246440', 'Panama', 'PA', 'PAN', 'America', '292.2');
INSERT INTO public.europe_data_import VALUES (7418, '17/08/2020', '2020-33', '7448', '128', '4246440', 'Panama', 'PA', 'PAN', 'America', '341.16');
INSERT INTO public.europe_data_import VALUES (7419, '10/08/2020', '2020-32', '7039', '168', '4246440', 'Panama', 'PA', 'PAN', 'America', '334.3');
INSERT INTO public.europe_data_import VALUES (7420, '03/08/2020', '2020-31', '7157', '177', '4246440', 'Panama', 'PA', 'PAN', 'America', '329.33');
INSERT INTO public.europe_data_import VALUES (7421, '27/07/2020', '2020-30', '6828', '198', '4246440', 'Panama', 'PA', 'PAN', 'America', '345.3');
INSERT INTO public.europe_data_import VALUES (7422, '20/07/2020', '2020-29', '7835', '187', '4246440', 'Panama', 'PA', 'PAN', 'America', '360.75');
INSERT INTO public.europe_data_import VALUES (7423, '13/07/2020', '2020-28', '7484', '162', '4246440', 'Panama', 'PA', 'PAN', 'America', '328.44');
INSERT INTO public.europe_data_import VALUES (7424, '06/07/2020', '2020-27', '6463', '143', '4246440', 'Panama', 'PA', 'PAN', 'America', '285.39');
INSERT INTO public.europe_data_import VALUES (7425, '29/06/2020', '2020-26', '5656', '103', '4246440', 'Panama', 'PA', 'PAN', 'America', '259.04');
INSERT INTO public.europe_data_import VALUES (7426, '22/06/2020', '2020-25', '5344', '64', '4246440', 'Panama', 'PA', 'PAN', 'America', '226.19');
INSERT INTO public.europe_data_import VALUES (7427, '15/06/2020', '2020-24', '4261', '44', '4246440', 'Panama', 'PA', 'PAN', 'America', '170.1');
INSERT INTO public.europe_data_import VALUES (7428, '08/06/2020', '2020-23', '2962', '57', '4246440', 'Panama', 'PA', 'PAN', 'America', '129.5');
INSERT INTO public.europe_data_import VALUES (7429, '01/06/2020', '2020-22', '2537', '30', '4246440', 'Panama', 'PA', 'PAN', 'America', '90.83');
INSERT INTO public.europe_data_import VALUES (7430, '25/05/2020', '2020-21', '1320', '31', '4246440', 'Panama', 'PA', 'PAN', 'America', '58.35');
INSERT INTO public.europe_data_import VALUES (7431, '18/05/2020', '2020-20', '1158', '31', '4246440', 'Panama', 'PA', 'PAN', 'America', '56.73');
INSERT INTO public.europe_data_import VALUES (7432, '11/05/2020', '2020-19', '1251', '44', '4246440', 'Panama', 'PA', 'PAN', 'America', '62.85');
INSERT INTO public.europe_data_import VALUES (7433, '04/05/2020', '2020-18', '1418', '35', '4246440', 'Panama', 'PA', 'PAN', 'America', '64.29');
INSERT INTO public.europe_data_import VALUES (7434, '27/04/2020', '2020-17', '1312', '39', '4246440', 'Panama', 'PA', 'PAN', 'America', '56.02');
INSERT INTO public.europe_data_import VALUES (7435, '20/04/2020', '2020-16', '1067', '39', '4246440', 'Panama', 'PA', 'PAN', 'America', '58.38');
INSERT INTO public.europe_data_import VALUES (7436, '13/04/2020', '2020-15', '1412', '33', '4246440', 'Panama', 'PA', 'PAN', 'America', '56.78');
INSERT INTO public.europe_data_import VALUES (7437, '06/04/2020', '2020-14', '999', '30', '4246440', 'Panama', 'PA', 'PAN', 'America', '39.44');
INSERT INTO public.europe_data_import VALUES (7438, '30/03/2020', '2020-13', '676', '21', '4246440', 'Panama', 'PA', 'PAN', 'America', '22.28');
INSERT INTO public.europe_data_import VALUES (7439, '23/03/2020', '2020-12', '270', '2', '4246440', 'Panama', 'PA', 'PAN', 'America', '7.37');
INSERT INTO public.europe_data_import VALUES (7440, '16/03/2020', '2020-11', '43', '1', '4246440', 'Panama', 'PA', 'PAN', 'America', '');
INSERT INTO public.europe_data_import VALUES (7441, '01/02/2021', '2021-04', '18', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.38');
INSERT INTO public.europe_data_import VALUES (7442, '25/01/2021', '2021-03', '15', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.43');
INSERT INTO public.europe_data_import VALUES (7443, '18/01/2021', '2021-02', '23', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.4');
INSERT INTO public.europe_data_import VALUES (7444, '11/01/2021', '2021-01', '12', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (7445, '04/01/2021', '2020-53', '19', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.43');
INSERT INTO public.europe_data_import VALUES (7446, '28/12/2020', '2020-52', '19', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.63');
INSERT INTO public.europe_data_import VALUES (7447, '21/12/2020', '2020-51', '36', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.03');
INSERT INTO public.europe_data_import VALUES (7448, '14/12/2020', '2020-50', '54', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.8');
INSERT INTO public.europe_data_import VALUES (7449, '07/12/2020', '2020-49', '16', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.76');
INSERT INTO public.europe_data_import VALUES (7450, '30/11/2020', '2020-48', '51', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.63');
INSERT INTO public.europe_data_import VALUES (7451, '23/11/2020', '2020-47', '4', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.08');
INSERT INTO public.europe_data_import VALUES (7452, '16/11/2020', '2020-46', '3', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (7453, '09/11/2020', '2020-45', '7', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (7454, '02/11/2020', '2020-44', '2', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (7455, '26/10/2020', '2020-43', '7', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.39');
INSERT INTO public.europe_data_import VALUES (7456, '19/10/2020', '2020-42', '27', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.47');
INSERT INTO public.europe_data_import VALUES (7457, '12/10/2020', '2020-41', '14', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.25');
INSERT INTO public.europe_data_import VALUES (7458, '05/10/2020', '2020-40', '8', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.26');
INSERT INTO public.europe_data_import VALUES (7459, '28/09/2020', '2020-39', '15', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.24');
INSERT INTO public.europe_data_import VALUES (7460, '21/09/2020', '2020-38', '6', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.23');
INSERT INTO public.europe_data_import VALUES (7461, '14/09/2020', '2020-37', '14', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.59');
INSERT INTO public.europe_data_import VALUES (7462, '07/09/2020', '2020-36', '38', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.09');
INSERT INTO public.europe_data_import VALUES (7463, '31/08/2020', '2020-35', '58', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.55');
INSERT INTO public.europe_data_import VALUES (7464, '24/08/2020', '2020-34', '78', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '2.13');
INSERT INTO public.europe_data_import VALUES (7465, '17/08/2020', '2020-33', '109', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '2.43');
INSERT INTO public.europe_data_import VALUES (7466, '10/08/2020', '2020-32', '104', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.73');
INSERT INTO public.europe_data_import VALUES (7467, '03/08/2020', '2020-31', '48', '2', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (7468, '27/07/2020', '2020-30', '45', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.58');
INSERT INTO public.europe_data_import VALUES (7469, '20/07/2020', '2020-29', '6', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.07');
INSERT INTO public.europe_data_import VALUES (7470, '13/07/2020', '2020-28', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7471, '06/07/2020', '2020-27', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (7472, '29/06/2020', '2020-26', '2', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.03');
INSERT INTO public.europe_data_import VALUES (7473, '22/06/2020', '2020-25', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7474, '15/06/2020', '2020-24', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7475, '08/06/2020', '2020-23', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7476, '01/06/2020', '2020-22', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7477, '25/05/2020', '2020-21', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7478, '18/05/2020', '2020-20', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7479, '11/05/2020', '2020-19', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7480, '04/05/2020', '2020-18', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7481, '27/04/2020', '2020-17', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.07');
INSERT INTO public.europe_data_import VALUES (7482, '20/04/2020', '2020-16', '5', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.07');
INSERT INTO public.europe_data_import VALUES (7483, '13/04/2020', '2020-15', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7484, '06/04/2020', '2020-14', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7485, '30/03/2020', '2020-13', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7486, '23/03/2020', '2020-12', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (7487, '01/02/2021', '2021-04', '4861', '86', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '157.1');
INSERT INTO public.europe_data_import VALUES (7488, '25/01/2021', '2021-03', '6206', '127', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '179.33');
INSERT INTO public.europe_data_import VALUES (7489, '18/01/2021', '2021-02', '6427', '100', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '185.77');
INSERT INTO public.europe_data_import VALUES (7490, '11/01/2021', '2021-01', '6660', '113', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '147.05');
INSERT INTO public.europe_data_import VALUES (7491, '04/01/2021', '2020-53', '3699', '90', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '120.11');
INSERT INTO public.europe_data_import VALUES (7492, '28/12/2020', '2020-52', '4762', '99', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '167.39');
INSERT INTO public.europe_data_import VALUES (7493, '21/12/2020', '2020-51', '7030', '150', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '180.17');
INSERT INTO public.europe_data_import VALUES (7494, '14/12/2020', '2020-50', '5662', '100', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '165.74');
INSERT INTO public.europe_data_import VALUES (7495, '07/12/2020', '2020-49', '6014', '110', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '162.45');
INSERT INTO public.europe_data_import VALUES (7496, '30/11/2020', '2020-48', '5430', '86', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '146.66');
INSERT INTO public.europe_data_import VALUES (7497, '23/11/2020', '2020-47', '4902', '70', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '126.15');
INSERT INTO public.europe_data_import VALUES (7498, '16/11/2020', '2020-46', '3985', '97', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '111.33');
INSERT INTO public.europe_data_import VALUES (7499, '09/11/2020', '2020-45', '3858', '72', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '113.49');
INSERT INTO public.europe_data_import VALUES (7500, '02/11/2020', '2020-44', '4137', '109', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '127.86');
INSERT INTO public.europe_data_import VALUES (7501, '26/10/2020', '2020-43', '4870', '121', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '140.8');
INSERT INTO public.europe_data_import VALUES (7502, '19/10/2020', '2020-42', '5049', '111', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '149.65');
INSERT INTO public.europe_data_import VALUES (7503, '12/10/2020', '2020-41', '5493', '148', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '156.02');
INSERT INTO public.europe_data_import VALUES (7504, '05/10/2020', '2020-40', '5498', '126', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '151.35');
INSERT INTO public.europe_data_import VALUES (7505, '28/09/2020', '2020-39', '5164', '144', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '154.26');
INSERT INTO public.europe_data_import VALUES (7506, '21/09/2020', '2020-38', '5703', '134', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '156.63');
INSERT INTO public.europe_data_import VALUES (7507, '14/09/2020', '2020-37', '5331', '90', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '150.78');
INSERT INTO public.europe_data_import VALUES (7508, '07/09/2020', '2020-36', '5291', '127', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '131.35');
INSERT INTO public.europe_data_import VALUES (7509, '31/08/2020', '2020-35', '3962', '103', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '105.1');
INSERT INTO public.europe_data_import VALUES (7510, '24/08/2020', '2020-34', '3442', '67', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '89.8');
INSERT INTO public.europe_data_import VALUES (7511, '17/08/2020', '2020-33', '2884', '63', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '58.87');
INSERT INTO public.europe_data_import VALUES (7512, '10/08/2020', '2020-32', '1263', '23', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '34.96');
INSERT INTO public.europe_data_import VALUES (7513, '03/08/2020', '2020-31', '1200', '11', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '27.3');
INSERT INTO public.europe_data_import VALUES (7514, '27/07/2020', '2020-30', '723', '10', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '21.24');
INSERT INTO public.europe_data_import VALUES (7515, '20/07/2020', '2020-29', '773', '9', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '18.37');
INSERT INTO public.europe_data_import VALUES (7516, '13/07/2020', '2020-28', '521', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '11.65');
INSERT INTO public.europe_data_import VALUES (7517, '06/07/2020', '2020-27', '300', '5', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '14.88');
INSERT INTO public.europe_data_import VALUES (7518, '29/06/2020', '2020-26', '748', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '11.9');
INSERT INTO public.europe_data_import VALUES (7519, '22/06/2020', '2020-25', '90', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '3.46');
INSERT INTO public.europe_data_import VALUES (7520, '15/06/2020', '2020-24', '154', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '4.3');
INSERT INTO public.europe_data_import VALUES (7521, '08/06/2020', '2020-23', '149', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '3.88');
INSERT INTO public.europe_data_import VALUES (7522, '01/06/2020', '2020-22', '124', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '2.84');
INSERT INTO public.europe_data_import VALUES (7523, '25/05/2020', '2020-21', '76', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '2.12');
INSERT INTO public.europe_data_import VALUES (7524, '18/05/2020', '2020-20', '73', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '5.54');
INSERT INTO public.europe_data_import VALUES (7525, '11/05/2020', '2020-19', '317', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '6.88');
INSERT INTO public.europe_data_import VALUES (7526, '04/05/2020', '2020-18', '168', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '2.7');
INSERT INTO public.europe_data_import VALUES (7527, '27/04/2020', '2020-17', '22', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.15');
INSERT INTO public.europe_data_import VALUES (7528, '20/04/2020', '2020-16', '59', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.32');
INSERT INTO public.europe_data_import VALUES (7529, '13/04/2020', '2020-15', '34', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.18');
INSERT INTO public.europe_data_import VALUES (7530, '06/04/2020', '2020-14', '49', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.29');
INSERT INTO public.europe_data_import VALUES (7531, '30/03/2020', '2020-13', '42', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '0.79');
INSERT INTO public.europe_data_import VALUES (7532, '23/03/2020', '2020-12', '14', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '0.31');
INSERT INTO public.europe_data_import VALUES (7533, '16/03/2020', '2020-11', '8', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '');
INSERT INTO public.europe_data_import VALUES (7534, '01/02/2021', '2021-04', '43703', '1404', '32510462', 'Peru', 'PE', 'PER', 'America', '227.35');
INSERT INTO public.europe_data_import VALUES (7535, '25/01/2021', '2021-03', '30211', '846', '32510462', 'Peru', 'PE', 'PER', 'America', '189.67');
INSERT INTO public.europe_data_import VALUES (7536, '18/01/2021', '2021-02', '31452', '596', '32510462', 'Peru', 'PE', 'PER', 'America', '146.86');
INSERT INTO public.europe_data_import VALUES (7537, '11/01/2021', '2021-01', '16292', '462', '32510462', 'Peru', 'PE', 'PER', 'America', '87.49');
INSERT INTO public.europe_data_import VALUES (7538, '04/01/2021', '2020-53', '12150', '348', '32510462', 'Peru', 'PE', 'PER', 'America', '69.46');
INSERT INTO public.europe_data_import VALUES (7539, '28/12/2020', '2020-52', '10433', '352', '32510462', 'Peru', 'PE', 'PER', 'America', '73.62');
INSERT INTO public.europe_data_import VALUES (7540, '21/12/2020', '2020-51', '13502', '496', '32510462', 'Peru', 'PE', 'PER', 'America', '75.55');
INSERT INTO public.europe_data_import VALUES (7541, '14/12/2020', '2020-50', '11061', '403', '32510462', 'Peru', 'PE', 'PER', 'America', '69.03');
INSERT INTO public.europe_data_import VALUES (7542, '07/12/2020', '2020-49', '11382', '351', '32510462', 'Peru', 'PE', 'PER', 'America', '74.57');
INSERT INTO public.europe_data_import VALUES (7543, '30/11/2020', '2020-48', '12860', '328', '32510462', 'Peru', 'PE', 'PER', 'America', '78.49');
INSERT INTO public.europe_data_import VALUES (7544, '23/11/2020', '2020-47', '12659', '364', '32510462', 'Peru', 'PE', 'PER', 'America', '84.09');
INSERT INTO public.europe_data_import VALUES (7545, '16/11/2020', '2020-46', '14678', '352', '32510462', 'Peru', 'PE', 'PER', 'America', '98.74');
INSERT INTO public.europe_data_import VALUES (7546, '09/11/2020', '2020-45', '17422', '350', '32510462', 'Peru', 'PE', 'PER', 'America', '103.41');
INSERT INTO public.europe_data_import VALUES (7547, '02/11/2020', '2020-44', '16196', '380', '32510462', 'Peru', 'PE', 'PER', 'America', '111.46');
INSERT INTO public.europe_data_import VALUES (7548, '26/10/2020', '2020-43', '20040', '390', '32510462', 'Peru', 'PE', 'PER', 'America', '121.02');
INSERT INTO public.europe_data_import VALUES (7549, '19/10/2020', '2020-42', '19304', '454', '32510462', 'Peru', 'PE', 'PER', 'America', '124.59');
INSERT INTO public.europe_data_import VALUES (7550, '12/10/2020', '2020-41', '21202', '563', '32510462', 'Peru', 'PE', 'PER', 'America', '135.55');
INSERT INTO public.europe_data_import VALUES (7551, '05/10/2020', '2020-40', '22867', '480', '32510462', 'Peru', 'PE', 'PER', 'America', '182.32');
INSERT INTO public.europe_data_import VALUES (7552, '28/09/2020', '2020-39', '36407', '893', '32510462', 'Peru', 'PE', 'PER', 'America', '232.8');
INSERT INTO public.europe_data_import VALUES (7553, '21/09/2020', '2020-38', '39276', '659', '32510462', 'Peru', 'PE', 'PER', 'America', '242.75');
INSERT INTO public.europe_data_import VALUES (7554, '14/09/2020', '2020-37', '39642', '872', '32510462', 'Peru', 'PE', 'PER', 'America', '253.62');
INSERT INTO public.europe_data_import VALUES (7555, '07/09/2020', '2020-36', '42811', '1050', '32510462', 'Peru', 'PE', 'PER', 'America', '294.22');
INSERT INTO public.europe_data_import VALUES (7556, '31/08/2020', '2020-35', '52840', '1125', '32510462', 'Peru', 'PE', 'PER', 'America', '342.11');
INSERT INTO public.europe_data_import VALUES (7557, '24/08/2020', '2020-34', '58380', '1382', '32510462', 'Peru', 'PE', 'PER', 'America', '357.74');
INSERT INTO public.europe_data_import VALUES (7558, '17/08/2020', '2020-33', '57922', '5209', '32510462', 'Peru', 'PE', 'PER', 'America', '329.42');
INSERT INTO public.europe_data_import VALUES (7559, '10/08/2020', '2020-32', '49174', '1458', '32510462', 'Peru', 'PE', 'PER', 'America', '286.76');
INSERT INTO public.europe_data_import VALUES (7560, '03/08/2020', '2020-31', '44053', '1385', '32510462', 'Peru', 'PE', 'PER', 'America', '231.49');
INSERT INTO public.europe_data_import VALUES (7561, '27/07/2020', '2020-30', '31207', '5042', '32510462', 'Peru', 'PE', 'PER', 'America', '179.85');
INSERT INTO public.europe_data_import VALUES (7562, '20/07/2020', '2020-29', '27264', '1317', '32510462', 'Peru', 'PE', 'PER', 'America', '156.48');
INSERT INTO public.europe_data_import VALUES (7563, '13/07/2020', '2020-28', '23608', '1281', '32510462', 'Peru', 'PE', 'PER', 'America', '144.28');
INSERT INTO public.europe_data_import VALUES (7564, '06/07/2020', '2020-27', '23299', '1272', '32510462', 'Peru', 'PE', 'PER', 'America', '146.97');
INSERT INTO public.europe_data_import VALUES (7565, '29/06/2020', '2020-26', '24483', '1272', '32510462', 'Peru', 'PE', 'PER', 'America', '152.82');
INSERT INTO public.europe_data_import VALUES (7566, '22/06/2020', '2020-25', '25200', '1357', '32510462', 'Peru', 'PE', 'PER', 'America', '179.7');
INSERT INTO public.europe_data_import VALUES (7567, '15/06/2020', '2020-24', '33221', '1223', '32510462', 'Peru', 'PE', 'PER', 'America', '200.74');
INSERT INTO public.europe_data_import VALUES (7568, '08/06/2020', '2020-23', '32039', '959', '32510462', 'Peru', 'PE', 'PER', 'America', '235.48');
INSERT INTO public.europe_data_import VALUES (7569, '01/06/2020', '2020-22', '44517', '1050', '32510462', 'Peru', 'PE', 'PER', 'America', '222.09');
INSERT INTO public.europe_data_import VALUES (7570, '25/05/2020', '2020-21', '27686', '808', '32510462', 'Peru', 'PE', 'PER', 'America', '161.95');
INSERT INTO public.europe_data_import VALUES (7571, '18/05/2020', '2020-20', '24966', '759', '32510462', 'Peru', 'PE', 'PER', 'America', '142.55');
INSERT INTO public.europe_data_import VALUES (7572, '11/05/2020', '2020-19', '21379', '603', '32510462', 'Peru', 'PE', 'PER', 'America', '122.39');
INSERT INTO public.europe_data_import VALUES (7573, '04/05/2020', '2020-18', '18411', '558', '32510462', 'Peru', 'PE', 'PER', 'America', '93.2');
INSERT INTO public.europe_data_import VALUES (7574, '27/04/2020', '2020-17', '11889', '328', '32510462', 'Peru', 'PE', 'PER', 'America', '61.51');
INSERT INTO public.europe_data_import VALUES (7575, '20/04/2020', '2020-16', '8109', '207', '32510462', 'Peru', 'PE', 'PER', 'America', '41.05');
INSERT INTO public.europe_data_import VALUES (7576, '13/04/2020', '2020-15', '5238', '110', '32510462', 'Peru', 'PE', 'PER', 'America', '20.51');
INSERT INTO public.europe_data_import VALUES (7577, '06/04/2020', '2020-14', '1429', '65', '32510462', 'Peru', 'PE', 'PER', 'America', '5.9');
INSERT INTO public.europe_data_import VALUES (7578, '30/03/2020', '2020-13', '489', '13', '32510462', 'Peru', 'PE', 'PER', 'America', '2.4');
INSERT INTO public.europe_data_import VALUES (7579, '23/03/2020', '2020-12', '292', '5', '32510462', 'Peru', 'PE', 'PER', 'America', '1.1');
INSERT INTO public.europe_data_import VALUES (7580, '16/03/2020', '2020-11', '64', '0', '32510462', 'Peru', 'PE', 'PER', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (7581, '09/03/2020', '2020-10', '7', '0', '32510462', 'Peru', 'PE', 'PER', 'America', '');
INSERT INTO public.europe_data_import VALUES (7582, '01/02/2021', '2021-04', '11999', '507', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '23.16');
INSERT INTO public.europe_data_import VALUES (7583, '25/01/2021', '2021-03', '13042', '347', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '23.98');
INSERT INTO public.europe_data_import VALUES (7584, '18/01/2021', '2021-02', '12887', '490', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '21.06');
INSERT INTO public.europe_data_import VALUES (7585, '11/01/2021', '2021-01', '9883', '148', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '16.47');
INSERT INTO public.europe_data_import VALUES (7586, '04/01/2021', '2020-53', '7921', '148', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '16.67');
INSERT INTO public.europe_data_import VALUES (7587, '28/12/2020', '2020-52', '10097', '162', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '18.95');
INSERT INTO public.europe_data_import VALUES (7588, '21/12/2020', '2020-51', '10389', '214', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '18.46');
INSERT INTO public.europe_data_import VALUES (7589, '14/12/2020', '2020-50', '9566', '179', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '18.07');
INSERT INTO public.europe_data_import VALUES (7590, '07/12/2020', '2020-49', '9970', '181', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '19.44');
INSERT INTO public.europe_data_import VALUES (7591, '30/11/2020', '2020-48', '11046', '250', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '20.37');
INSERT INTO public.europe_data_import VALUES (7592, '23/11/2020', '2020-47', '10980', '291', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '20.74');
INSERT INTO public.europe_data_import VALUES (7593, '16/11/2020', '2020-46', '11443', '293', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '22.87');
INSERT INTO public.europe_data_import VALUES (7594, '09/11/2020', '2020-45', '13282', '301', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '24.39');
INSERT INTO public.europe_data_import VALUES (7595, '02/11/2020', '2020-44', '13085', '261', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '24.51');
INSERT INTO public.europe_data_import VALUES (7596, '26/10/2020', '2020-43', '13410', '325', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '28.38');
INSERT INTO public.europe_data_import VALUES (7597, '19/10/2020', '2020-42', '17277', '331', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '31.56');
INSERT INTO public.europe_data_import VALUES (7598, '12/10/2020', '2020-41', '16844', '545', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '32.48');
INSERT INTO public.europe_data_import VALUES (7599, '05/10/2020', '2020-40', '18271', '432', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '33.07');
INSERT INTO public.europe_data_import VALUES (7600, '28/09/2020', '2020-39', '17483', '360', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '39.78');
INSERT INTO public.europe_data_import VALUES (7601, '21/09/2020', '2020-38', '25527', '613', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '45.67');
INSERT INTO public.europe_data_import VALUES (7602, '14/09/2020', '2020-37', '23851', '496', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '40.53');
INSERT INTO public.europe_data_import VALUES (7603, '07/09/2020', '2020-36', '19969', '355', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '44.18');
INSERT INTO public.europe_data_import VALUES (7604, '31/08/2020', '2020-35', '27795', '522', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '51.93');
INSERT INTO public.europe_data_import VALUES (7605, '24/08/2020', '2020-34', '28348', '333', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '55.21');
INSERT INTO public.europe_data_import VALUES (7606, '17/08/2020', '2020-33', '31340', '395', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '53.71');
INSERT INTO public.europe_data_import VALUES (7607, '10/08/2020', '2020-32', '26728', '211', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '45.75');
INSERT INTO public.europe_data_import VALUES (7608, '03/08/2020', '2020-31', '22737', '127', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '33.05');
INSERT INTO public.europe_data_import VALUES (7609, '27/07/2020', '2020-30', '12992', '101', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '22.37');
INSERT INTO public.europe_data_import VALUES (7610, '20/07/2020', '2020-29', '11197', '297', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '23.7');
INSERT INTO public.europe_data_import VALUES (7611, '13/07/2020', '2020-28', '14429', '244', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '19.24');
INSERT INTO public.europe_data_import VALUES (7612, '06/07/2020', '2020-27', '6375', '46', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '10.89');
INSERT INTO public.europe_data_import VALUES (7613, '29/06/2020', '2020-26', '5403', '75', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '8.81');
INSERT INTO public.europe_data_import VALUES (7614, '22/06/2020', '2020-25', '4122', '81', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '7.54');
INSERT INTO public.europe_data_import VALUES (7615, '15/06/2020', '2020-24', '4035', '85', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '7.26');
INSERT INTO public.europe_data_import VALUES (7616, '08/06/2020', '2020-23', '3809', '46', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '7.27');
INSERT INTO public.europe_data_import VALUES (7617, '01/06/2020', '2020-22', '4051', '89', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '5.15');
INSERT INTO public.europe_data_import VALUES (7618, '25/05/2020', '2020-21', '1522', '44', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '3.0');
INSERT INTO public.europe_data_import VALUES (7619, '18/05/2020', '2020-20', '1719', '105', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '3.04');
INSERT INTO public.europe_data_import VALUES (7620, '11/05/2020', '2020-19', '1571', '112', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.97');
INSERT INTO public.europe_data_import VALUES (7621, '04/05/2020', '2020-18', '1644', '106', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.74');
INSERT INTO public.europe_data_import VALUES (7622, '27/04/2020', '2020-17', '1320', '92', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.71');
INSERT INTO public.europe_data_import VALUES (7623, '20/04/2020', '2020-16', '1611', '112', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.79');
INSERT INTO public.europe_data_import VALUES (7624, '13/04/2020', '2020-15', '1402', '145', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.99');
INSERT INTO public.europe_data_import VALUES (7625, '06/04/2020', '2020-14', '1828', '81', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.65');
INSERT INTO public.europe_data_import VALUES (7626, '30/03/2020', '2020-13', '1038', '46', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (7627, '23/03/2020', '2020-12', '240', '13', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.34');
INSERT INTO public.europe_data_import VALUES (7628, '16/03/2020', '2020-11', '130', '11', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (7629, '09/03/2020', '2020-10', '7', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (7630, '02/03/2020', '2020-09', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7631, '24/02/2020', '2020-08', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7632, '17/02/2020', '2020-07', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7633, '10/02/2020', '2020-06', '1', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7634, '03/02/2020', '2020-05', '2', '1', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7635, '27/01/2020', '2020-04', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7636, '20/01/2020', '2020-03', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7637, '13/01/2020', '2020-02', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7638, '06/01/2020', '2020-01', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7639, '01/02/2021', '2021-04', '35266', '1779', '37972812', 'Poland', 'PL', 'POL', 'Europe', '196.12');
INSERT INTO public.europe_data_import VALUES (7640, '25/01/2021', '2021-03', '39205', '1994', '37972812', 'Poland', 'PL', 'POL', 'Europe', '231.04');
INSERT INTO public.europe_data_import VALUES (7641, '18/01/2021', '2021-02', '48529', '2143', '37972812', 'Poland', 'PL', 'POL', 'Europe', '305.39');
INSERT INTO public.europe_data_import VALUES (7642, '11/01/2021', '2021-01', '67438', '2103', '37972812', 'Poland', 'PL', 'POL', 'Europe', '340.7');
INSERT INTO public.europe_data_import VALUES (7643, '04/01/2021', '2020-53', '61937', '2014', '37972812', 'Poland', 'PL', 'POL', 'Europe', '316.67');
INSERT INTO public.europe_data_import VALUES (7644, '28/12/2020', '2020-52', '58310', '1750', '37972812', 'Poland', 'PL', 'POL', 'Europe', '330.06');
INSERT INTO public.europe_data_import VALUES (7645, '21/12/2020', '2020-51', '67024', '2533', '37972812', 'Poland', 'PL', 'POL', 'Europe', '366.71');
INSERT INTO public.europe_data_import VALUES (7646, '14/12/2020', '2020-50', '72227', '2775', '37972812', 'Poland', 'PL', 'POL', 'Europe', '396.6');
INSERT INTO public.europe_data_import VALUES (7647, '07/12/2020', '2020-49', '78374', '3060', '37972812', 'Poland', 'PL', 'POL', 'Europe', '532.27');
INSERT INTO public.europe_data_import VALUES (7648, '30/11/2020', '2020-48', '123744', '3411', '37972812', 'Poland', 'PL', 'POL', 'Europe', '716.57');
INSERT INTO public.europe_data_import VALUES (7649, '23/11/2020', '2020-47', '148359', '3270', '37972812', 'Poland', 'PL', 'POL', 'Europe', '829.29');
INSERT INTO public.europe_data_import VALUES (7650, '16/11/2020', '2020-46', '166547', '2476', '37972812', 'Poland', 'PL', 'POL', 'Europe', '877.13');
INSERT INTO public.europe_data_import VALUES (7651, '09/11/2020', '2020-45', '166523', '2089', '37972812', 'Poland', 'PL', 'POL', 'Europe', '770.91');
INSERT INTO public.europe_data_import VALUES (7652, '02/11/2020', '2020-44', '126214', '1345', '37972812', 'Poland', 'PL', 'POL', 'Europe', '537.58');
INSERT INTO public.europe_data_import VALUES (7653, '26/10/2020', '2020-43', '77922', '865', '37972812', 'Poland', 'PL', 'POL', 'Europe', '336.75');
INSERT INTO public.europe_data_import VALUES (7654, '19/10/2020', '2020-42', '49950', '569', '37972812', 'Poland', 'PL', 'POL', 'Europe', '204.43');
INSERT INTO public.europe_data_import VALUES (7655, '12/10/2020', '2020-41', '27676', '400', '37972812', 'Poland', 'PL', 'POL', 'Europe', '101.35');
INSERT INTO public.europe_data_import VALUES (7656, '05/10/2020', '2020-40', '10810', '172', '37972812', 'Poland', 'PL', 'POL', 'Europe', '49.77');
INSERT INTO public.europe_data_import VALUES (7657, '28/09/2020', '2020-39', '8090', '139', '37972812', 'Poland', 'PL', 'POL', 'Europe', '34.7');
INSERT INTO public.europe_data_import VALUES (7658, '21/09/2020', '2020-38', '5088', '105', '37972812', 'Poland', 'PL', 'POL', 'Europe', '22.16');
INSERT INTO public.europe_data_import VALUES (7659, '14/09/2020', '2020-37', '3328', '68', '37972812', 'Poland', 'PL', 'POL', 'Europe', '19.18');
INSERT INTO public.europe_data_import VALUES (7660, '07/09/2020', '2020-36', '3954', '87', '37972812', 'Poland', 'PL', 'POL', 'Europe', '23.86');
INSERT INTO public.europe_data_import VALUES (7661, '31/08/2020', '2020-35', '5108', '78', '37972812', 'Poland', 'PL', 'POL', 'Europe', '26.82');
INSERT INTO public.europe_data_import VALUES (7662, '24/08/2020', '2020-34', '5078', '78', '37972812', 'Poland', 'PL', 'POL', 'Europe', '26.26');
INSERT INTO public.europe_data_import VALUES (7663, '17/08/2020', '2020-33', '4893', '70', '37972812', 'Poland', 'PL', 'POL', 'Europe', '25.78');
INSERT INTO public.europe_data_import VALUES (7664, '10/08/2020', '2020-32', '4897', '76', '37972812', 'Poland', 'PL', 'POL', 'Europe', '22.98');
INSERT INTO public.europe_data_import VALUES (7665, '03/08/2020', '2020-31', '3829', '60', '37972812', 'Poland', 'PL', 'POL', 'Europe', '17.88');
INSERT INTO public.europe_data_import VALUES (7666, '27/07/2020', '2020-30', '2961', '47', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.63');
INSERT INTO public.europe_data_import VALUES (7667, '20/07/2020', '2020-29', '2213', '53', '37972812', 'Poland', 'PL', 'POL', 'Europe', '10.94');
INSERT INTO public.europe_data_import VALUES (7668, '13/07/2020', '2020-28', '1941', '54', '37972812', 'Poland', 'PL', 'POL', 'Europe', '10.49');
INSERT INTO public.europe_data_import VALUES (7669, '06/07/2020', '2020-27', '2043', '79', '37972812', 'Poland', 'PL', 'POL', 'Europe', '10.58');
INSERT INTO public.europe_data_import VALUES (7670, '29/06/2020', '2020-26', '1976', '82', '37972812', 'Poland', 'PL', 'POL', 'Europe', '11.89');
INSERT INTO public.europe_data_import VALUES (7671, '22/06/2020', '2020-25', '2539', '109', '37972812', 'Poland', 'PL', 'POL', 'Europe', '14.14');
INSERT INTO public.europe_data_import VALUES (7672, '15/06/2020', '2020-24', '2831', '90', '37972812', 'Poland', 'PL', 'POL', 'Europe', '14.76');
INSERT INTO public.europe_data_import VALUES (7673, '08/06/2020', '2020-23', '2775', '93', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.79');
INSERT INTO public.europe_data_import VALUES (7674, '01/06/2020', '2020-22', '2460', '68', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.84');
INSERT INTO public.europe_data_import VALUES (7675, '25/05/2020', '2020-21', '2797', '71', '37972812', 'Poland', 'PL', 'POL', 'Europe', '14.04');
INSERT INTO public.europe_data_import VALUES (7676, '18/05/2020', '2020-20', '2533', '125', '37972812', 'Poland', 'PL', 'POL', 'Europe', '12.74');
INSERT INTO public.europe_data_import VALUES (7677, '11/05/2020', '2020-19', '2303', '122', '37972812', 'Poland', 'PL', 'POL', 'Europe', '11.53');
INSERT INTO public.europe_data_import VALUES (7678, '04/05/2020', '2020-18', '2076', '143', '37972812', 'Poland', 'PL', 'POL', 'Europe', '11.6');
INSERT INTO public.europe_data_import VALUES (7679, '27/04/2020', '2020-17', '2330', '175', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.02');
INSERT INTO public.europe_data_import VALUES (7680, '20/04/2020', '2020-16', '2613', '128', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.65');
INSERT INTO public.europe_data_import VALUES (7681, '13/04/2020', '2020-15', '2572', '138', '37972812', 'Poland', 'PL', 'POL', 'Europe', '12.67');
INSERT INTO public.europe_data_import VALUES (7682, '06/04/2020', '2020-14', '2240', '72', '37972812', 'Poland', 'PL', 'POL', 'Europe', '9.13');
INSERT INTO public.europe_data_import VALUES (7683, '30/03/2020', '2020-13', '1228', '15', '37972812', 'Poland', 'PL', 'POL', 'Europe', '4.57');
INSERT INTO public.europe_data_import VALUES (7684, '23/03/2020', '2020-12', '509', '4', '37972812', 'Poland', 'PL', 'POL', 'Europe', '1.64');
INSERT INTO public.europe_data_import VALUES (7685, '16/03/2020', '2020-11', '114', '3', '37972812', 'Poland', 'PL', 'POL', 'Europe', '0.33');
INSERT INTO public.europe_data_import VALUES (7686, '09/03/2020', '2020-10', '11', '0', '37972812', 'Poland', 'PL', 'POL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7687, '01/02/2021', '2021-04', '83208', '2036', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '1652.47');
INSERT INTO public.europe_data_import VALUES (7688, '25/01/2021', '2021-03', '86610', '1693', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '1496.8');
INSERT INTO public.europe_data_import VALUES (7689, '18/01/2021', '2021-02', '67210', '1103', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '1215.19');
INSERT INTO public.europe_data_import VALUES (7690, '11/01/2021', '2021-01', '57670', '729', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '901.34');
INSERT INTO public.europe_data_import VALUES (7691, '04/01/2021', '2020-53', '34957', '519', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '559.54');
INSERT INTO public.europe_data_import VALUES (7692, '28/12/2020', '2020-52', '22545', '543', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '466.32');
INSERT INTO public.europe_data_import VALUES (7693, '21/12/2020', '2020-51', '25377', '575', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '502.57');
INSERT INTO public.europe_data_import VALUES (7694, '14/12/2020', '2020-50', '26270', '596', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '524.93');
INSERT INTO public.europe_data_import VALUES (7695, '07/12/2020', '2020-49', '27675', '536', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '600.55');
INSERT INTO public.europe_data_import VALUES (7696, '30/11/2020', '2020-48', '34041', '530', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '754.12');
INSERT INTO public.europe_data_import VALUES (7697, '23/11/2020', '2020-47', '43457', '516', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '792.42');
INSERT INTO public.europe_data_import VALUES (7698, '16/11/2020', '2020-46', '37977', '485', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '709.96');
INSERT INTO public.europe_data_import VALUES (7699, '09/11/2020', '2020-45', '34983', '352', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '590.06');
INSERT INTO public.europe_data_import VALUES (7700, '02/11/2020', '2020-44', '25655', '228', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '432.34');
INSERT INTO public.europe_data_import VALUES (7701, '26/10/2020', '2020-43', '18775', '135', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '311.6');
INSERT INTO public.europe_data_import VALUES (7702, '19/10/2020', '2020-42', '13247', '101', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '210.81');
INSERT INTO public.europe_data_import VALUES (7703, '12/10/2020', '2020-41', '8417', '85', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '127.08');
INSERT INTO public.europe_data_import VALUES (7704, '05/10/2020', '2020-40', '4643', '42', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '94.1');
INSERT INTO public.europe_data_import VALUES (7705, '28/09/2020', '2020-39', '5027', '41', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '93.62');
INSERT INTO public.europe_data_import VALUES (7706, '21/09/2020', '2020-38', '4594', '45', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '80.95');
INSERT INTO public.europe_data_import VALUES (7707, '14/09/2020', '2020-37', '3725', '27', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '60.48');
INSERT INTO public.europe_data_import VALUES (7708, '07/09/2020', '2020-36', '2490', '21', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '45.36');
INSERT INTO public.europe_data_import VALUES (7709, '31/08/2020', '2020-35', '2171', '23', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '35.67');
INSERT INTO public.europe_data_import VALUES (7710, '24/08/2020', '2020-34', '1495', '18', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '28.5');
INSERT INTO public.europe_data_import VALUES (7711, '17/08/2020', '2020-33', '1434', '22', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '25.68');
INSERT INTO public.europe_data_import VALUES (7712, '10/08/2020', '2020-32', '1205', '18', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '24.37');
INSERT INTO public.europe_data_import VALUES (7713, '03/08/2020', '2020-31', '1299', '21', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '27.51');
INSERT INTO public.europe_data_import VALUES (7714, '27/07/2020', '2020-30', '1528', '28', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '35.54');
INSERT INTO public.europe_data_import VALUES (7715, '20/07/2020', '2020-29', '2124', '29', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '46.11');
INSERT INTO public.europe_data_import VALUES (7716, '13/07/2020', '2020-28', '2615', '46', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '47.35');
INSERT INTO public.europe_data_import VALUES (7717, '06/07/2020', '2020-27', '2251', '50', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '46.36');
INSERT INTO public.europe_data_import VALUES (7718, '29/06/2020', '2020-26', '2513', '34', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '48.23');
INSERT INTO public.europe_data_import VALUES (7719, '22/06/2020', '2020-25', '2443', '13', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '45.15');
INSERT INTO public.europe_data_import VALUES (7720, '15/06/2020', '2020-24', '2197', '38', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '40.77');
INSERT INTO public.europe_data_import VALUES (7721, '08/06/2020', '2020-23', '1993', '69', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '37.66');
INSERT INTO public.europe_data_import VALUES (7722, '01/06/2020', '2020-22', '1877', '94', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '33.71');
INSERT INTO public.europe_data_import VALUES (7723, '25/05/2020', '2020-21', '1587', '98', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '29.6');
INSERT INTO public.europe_data_import VALUES (7724, '18/05/2020', '2020-20', '1455', '83', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '34.17');
INSERT INTO public.europe_data_import VALUES (7725, '11/05/2020', '2020-19', '2057', '72', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '36.34');
INSERT INTO public.europe_data_import VALUES (7726, '04/05/2020', '2020-18', '1678', '135', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '51.75');
INSERT INTO public.europe_data_import VALUES (7727, '27/04/2020', '2020-17', '3640', '214', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '70.66');
INSERT INTO public.europe_data_import VALUES (7728, '20/04/2020', '2020-16', '3621', '210', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '86.88');
INSERT INTO public.europe_data_import VALUES (7729, '13/04/2020', '2020-15', '5307', '209', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '103.37');
INSERT INTO public.europe_data_import VALUES (7730, '06/04/2020', '2020-14', '5316', '176', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '94.17');
INSERT INTO public.europe_data_import VALUES (7731, '30/03/2020', '2020-13', '4362', '105', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '55.63');
INSERT INTO public.europe_data_import VALUES (7732, '23/03/2020', '2020-12', '1355', '14', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '15.28');
INSERT INTO public.europe_data_import VALUES (7733, '16/03/2020', '2020-11', '215', '0', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '2.38');
INSERT INTO public.europe_data_import VALUES (7734, '09/03/2020', '2020-10', '30', '0', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7735, '01/02/2021', '2021-04', '5521', '58', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '448.32');
INSERT INTO public.europe_data_import VALUES (7736, '25/01/2021', '2021-03', '7630', '75', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '532.08');
INSERT INTO public.europe_data_import VALUES (7737, '18/01/2021', '2021-02', '7978', '61', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '469.69');
INSERT INTO public.europe_data_import VALUES (7738, '11/01/2021', '2021-01', '5800', '80', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '464.85');
INSERT INTO public.europe_data_import VALUES (7739, '04/01/2021', '2020-53', '7836', '106', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '721.11');
INSERT INTO public.europe_data_import VALUES (7740, '28/12/2020', '2020-52', '13317', '74', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '734.51');
INSERT INTO public.europe_data_import VALUES (7741, '21/12/2020', '2020-51', '8229', '110', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '589.18');
INSERT INTO public.europe_data_import VALUES (7742, '14/12/2020', '2020-50', '9054', '80', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '564.63');
INSERT INTO public.europe_data_import VALUES (7743, '07/12/2020', '2020-49', '7509', '98', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '449.31');
INSERT INTO public.europe_data_import VALUES (7744, '30/11/2020', '2020-48', '5671', '77', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '428.55');
INSERT INTO public.europe_data_import VALUES (7745, '23/11/2020', '2020-47', '6900', '82', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '438.36');
INSERT INTO public.europe_data_import VALUES (7746, '16/11/2020', '2020-46', '5959', '63', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '387.37');
INSERT INTO public.europe_data_import VALUES (7747, '09/11/2020', '2020-45', '5404', '40', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '325.97');
INSERT INTO public.europe_data_import VALUES (7748, '02/11/2020', '2020-44', '4158', '31', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '319.36');
INSERT INTO public.europe_data_import VALUES (7749, '26/10/2020', '2020-43', '5210', '35', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '301.08');
INSERT INTO public.europe_data_import VALUES (7750, '19/10/2020', '2020-42', '3622', '36', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '225.61');
INSERT INTO public.europe_data_import VALUES (7751, '12/10/2020', '2020-41', '2996', '44', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '251.14');
INSERT INTO public.europe_data_import VALUES (7752, '05/10/2020', '2020-40', '4371', '42', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '301.25');
INSERT INTO public.europe_data_import VALUES (7753, '28/09/2020', '2020-39', '4466', '36', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '304.22');
INSERT INTO public.europe_data_import VALUES (7754, '21/09/2020', '2020-38', '4458', '69', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '249.03');
INSERT INTO public.europe_data_import VALUES (7755, '14/09/2020', '2020-37', '2847', '62', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '154.5');
INSERT INTO public.europe_data_import VALUES (7756, '07/09/2020', '2020-36', '1685', '43', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '158.08');
INSERT INTO public.europe_data_import VALUES (7757, '31/08/2020', '2020-35', '2952', '44', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '233.24');
INSERT INTO public.europe_data_import VALUES (7758, '24/08/2020', '2020-34', '3890', '55', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '265.05');
INSERT INTO public.europe_data_import VALUES (7759, '17/08/2020', '2020-33', '3885', '56', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '258.91');
INSERT INTO public.europe_data_import VALUES (7760, '10/08/2020', '2020-32', '3710', '49', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '237.88');
INSERT INTO public.europe_data_import VALUES (7761, '03/08/2020', '2020-31', '3268', '29', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '216.4');
INSERT INTO public.europe_data_import VALUES (7762, '27/07/2020', '2020-30', '3080', '23', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '181.43');
INSERT INTO public.europe_data_import VALUES (7763, '20/07/2020', '2020-29', '2242', '11', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '141.37');
INSERT INTO public.europe_data_import VALUES (7764, '13/07/2020', '2020-28', '1905', '12', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '89.73');
INSERT INTO public.europe_data_import VALUES (7765, '06/07/2020', '2020-27', '727', '2', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '47.42');
INSERT INTO public.europe_data_import VALUES (7766, '29/06/2020', '2020-26', '664', '4', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '46.98');
INSERT INTO public.europe_data_import VALUES (7767, '22/06/2020', '2020-25', '714', '2', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '52.5');
INSERT INTO public.europe_data_import VALUES (7768, '15/06/2020', '2020-24', '826', '5', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '69.37');
INSERT INTO public.europe_data_import VALUES (7769, '08/06/2020', '2020-23', '1209', '6', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '61.23');
INSERT INTO public.europe_data_import VALUES (7770, '01/06/2020', '2020-22', '587', '9', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '38.52');
INSERT INTO public.europe_data_import VALUES (7771, '25/05/2020', '2020-21', '543', '4', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '33.78');
INSERT INTO public.europe_data_import VALUES (7772, '18/05/2020', '2020-20', '448', '12', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '28.57');
INSERT INTO public.europe_data_import VALUES (7773, '11/05/2020', '2020-19', '390', '14', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '28.19');
INSERT INTO public.europe_data_import VALUES (7774, '04/05/2020', '2020-18', '437', '13', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '20.28');
INSERT INTO public.europe_data_import VALUES (7775, '27/04/2020', '2020-17', '158', '22', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '16.16');
INSERT INTO public.europe_data_import VALUES (7776, '20/04/2020', '2020-16', '316', '18', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '25.16');
INSERT INTO public.europe_data_import VALUES (7777, '13/04/2020', '2020-15', '422', '24', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '26.25');
INSERT INTO public.europe_data_import VALUES (7778, '06/04/2020', '2020-14', '348', '15', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '16.19');
INSERT INTO public.europe_data_import VALUES (7779, '30/03/2020', '2020-13', '127', '5', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '');
INSERT INTO public.europe_data_import VALUES (7780, '01/02/2021', '2021-04', '2316', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '135.27');
INSERT INTO public.europe_data_import VALUES (7781, '25/01/2021', '2021-03', '1515', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '104.2');
INSERT INTO public.europe_data_import VALUES (7782, '18/01/2021', '2021-02', '1436', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '100.99');
INSERT INTO public.europe_data_import VALUES (7783, '11/01/2021', '2021-01', '1424', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '106.14');
INSERT INTO public.europe_data_import VALUES (7784, '04/01/2021', '2020-53', '1582', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '93.32');
INSERT INTO public.europe_data_import VALUES (7785, '28/12/2020', '2020-52', '1061', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '68.54');
INSERT INTO public.europe_data_import VALUES (7786, '21/12/2020', '2020-51', '880', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '73.9');
INSERT INTO public.europe_data_import VALUES (7787, '14/12/2020', '2020-50', '1213', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '87.32');
INSERT INTO public.europe_data_import VALUES (7788, '07/12/2020', '2020-49', '1260', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '94.6');
INSERT INTO public.europe_data_import VALUES (7789, '30/11/2020', '2020-48', '1419', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '101.09');
INSERT INTO public.europe_data_import VALUES (7790, '23/11/2020', '2020-47', '1444', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '106.85');
INSERT INTO public.europe_data_import VALUES (7791, '16/11/2020', '2020-46', '1582', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '108.22');
INSERT INTO public.europe_data_import VALUES (7792, '09/11/2020', '2020-45', '1483', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '107.09');
INSERT INTO public.europe_data_import VALUES (7793, '02/11/2020', '2020-44', '1550', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '116.13');
INSERT INTO public.europe_data_import VALUES (7794, '26/10/2020', '2020-43', '1739', '6', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '112.46');
INSERT INTO public.europe_data_import VALUES (7795, '19/10/2020', '2020-42', '1446', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '103.56');
INSERT INTO public.europe_data_import VALUES (7796, '12/10/2020', '2020-41', '1487', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '102.43');
INSERT INTO public.europe_data_import VALUES (7797, '05/10/2020', '2020-40', '1414', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '110.24');
INSERT INTO public.europe_data_import VALUES (7798, '28/09/2020', '2020-39', '1708', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '118.08');
INSERT INTO public.europe_data_import VALUES (7799, '21/09/2020', '2020-38', '1636', '5', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '115.85');
INSERT INTO public.europe_data_import VALUES (7800, '14/09/2020', '2020-37', '1645', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '111.76');
INSERT INTO public.europe_data_import VALUES (7801, '07/09/2020', '2020-36', '1520', '6', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '109.0');
INSERT INTO public.europe_data_import VALUES (7802, '31/08/2020', '2020-35', '1567', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '123.41');
INSERT INTO public.europe_data_import VALUES (7803, '24/08/2020', '2020-34', '1928', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '143.39');
INSERT INTO public.europe_data_import VALUES (7804, '17/08/2020', '2020-33', '2133', '9', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '140.29');
INSERT INTO public.europe_data_import VALUES (7805, '10/08/2020', '2020-32', '1840', '7', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '128.6');
INSERT INTO public.europe_data_import VALUES (7806, '03/08/2020', '2020-31', '1802', '12', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '157.45');
INSERT INTO public.europe_data_import VALUES (7807, '27/07/2020', '2020-30', '2657', '8', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '201.51');
INSERT INTO public.europe_data_import VALUES (7808, '20/07/2020', '2020-29', '3050', '10', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '241.84');
INSERT INTO public.europe_data_import VALUES (7809, '13/07/2020', '2020-28', '3799', '19', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '324.32');
INSERT INTO public.europe_data_import VALUES (7810, '06/07/2020', '2020-27', '5386', '18', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '438.9');
INSERT INTO public.europe_data_import VALUES (7811, '29/06/2020', '2020-26', '7044', '12', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '522.97');
INSERT INTO public.europe_data_import VALUES (7812, '22/06/2020', '2020-25', '7767', '25', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '656.02');
INSERT INTO public.europe_data_import VALUES (7813, '15/06/2020', '2020-24', '10812', '19', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '801.25');
INSERT INTO public.europe_data_import VALUES (7814, '08/06/2020', '2020-23', '11880', '16', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '885.43');
INSERT INTO public.europe_data_import VALUES (7815, '01/06/2020', '2020-22', '13196', '15', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '858.24');
INSERT INTO public.europe_data_import VALUES (7816, '25/05/2020', '2020-21', '11110', '8', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '748.36');
INSERT INTO public.europe_data_import VALUES (7817, '18/05/2020', '2020-20', '10084', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '602.14');
INSERT INTO public.europe_data_import VALUES (7818, '11/05/2020', '2020-19', '6969', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '431.95');
INSERT INTO public.europe_data_import VALUES (7819, '04/05/2020', '2020-18', '5264', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '356.74');
INSERT INTO public.europe_data_import VALUES (7820, '27/04/2020', '2020-17', '4839', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '258.04');
INSERT INTO public.europe_data_import VALUES (7821, '20/04/2020', '2020-16', '2469', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '135.73');
INSERT INTO public.europe_data_import VALUES (7822, '13/04/2020', '2020-15', '1375', '3', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '82.8');
INSERT INTO public.europe_data_import VALUES (7823, '06/04/2020', '2020-14', '970', '3', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '39.19');
INSERT INTO public.europe_data_import VALUES (7824, '30/03/2020', '2020-13', '140', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '8.23');
INSERT INTO public.europe_data_import VALUES (7825, '23/03/2020', '2020-12', '93', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '16.91');
INSERT INTO public.europe_data_import VALUES (7826, '16/03/2020', '2020-11', '386', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '14.05');
INSERT INTO public.europe_data_import VALUES (7827, '09/03/2020', '2020-10', '12', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0.53');
INSERT INTO public.europe_data_import VALUES (7828, '02/03/2020', '2020-09', '3', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (7829, '24/02/2020', '2020-08', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7830, '17/02/2020', '2020-07', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7831, '10/02/2020', '2020-06', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7832, '03/02/2020', '2020-05', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7833, '27/01/2020', '2020-04', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7834, '20/01/2020', '2020-03', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7835, '13/01/2020', '2020-02', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7836, '06/01/2020', '2020-01', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7837, '01/02/2021', '2021-04', '17495', '561', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '179.78');
INSERT INTO public.europe_data_import VALUES (7838, '25/01/2021', '2021-03', '17408', '570', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '202.37');
INSERT INTO public.europe_data_import VALUES (7839, '18/01/2021', '2021-02', '21882', '546', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '281.87');
INSERT INTO public.europe_data_import VALUES (7840, '11/01/2021', '2021-01', '32842', '746', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '282.48');
INSERT INTO public.europe_data_import VALUES (7841, '04/01/2021', '2020-53', '22000', '645', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '253.08');
INSERT INTO public.europe_data_import VALUES (7842, '28/12/2020', '2020-52', '27135', '940', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '319.83');
INSERT INTO public.europe_data_import VALUES (7843, '21/12/2020', '2020-51', '34959', '1009', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '400.31');
INSERT INTO public.europe_data_import VALUES (7844, '14/12/2020', '2020-50', '42759', '1065', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '436.78');
INSERT INTO public.europe_data_import VALUES (7845, '07/12/2020', '2020-49', '42040', '1127', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '488.97');
INSERT INTO public.europe_data_import VALUES (7846, '30/11/2020', '2020-48', '52891', '1146', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '573.05');
INSERT INTO public.europe_data_import VALUES (7847, '23/11/2020', '2020-47', '58364', '1121', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '591.8');
INSERT INTO public.europe_data_import VALUES (7848, '16/11/2020', '2020-46', '56530', '1047', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '585.22');
INSERT INTO public.europe_data_import VALUES (7849, '09/11/2020', '2020-45', '57088', '812', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '484.71');
INSERT INTO public.europe_data_import VALUES (7850, '02/11/2020', '2020-44', '37015', '676', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '341.37');
INSERT INTO public.europe_data_import VALUES (7851, '26/10/2020', '2020-43', '29260', '519', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '280.02');
INSERT INTO public.europe_data_import VALUES (7852, '19/10/2020', '2020-42', '25105', '461', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '238.6');
INSERT INTO public.europe_data_import VALUES (7853, '12/10/2020', '2020-41', '21218', '464', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '167.97');
INSERT INTO public.europe_data_import VALUES (7854, '05/10/2020', '2020-40', '11392', '229', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '109.63');
INSERT INTO public.europe_data_import VALUES (7855, '28/09/2020', '2020-39', '9892', '283', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '98.78');
INSERT INTO public.europe_data_import VALUES (7856, '21/09/2020', '2020-38', '9286', '272', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '91.51');
INSERT INTO public.europe_data_import VALUES (7857, '14/09/2020', '2020-37', '8481', '270', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '86.07');
INSERT INTO public.europe_data_import VALUES (7858, '07/09/2020', '2020-36', '8229', '315', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '84.93');
INSERT INTO public.europe_data_import VALUES (7859, '31/08/2020', '2020-35', '8260', '306', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '84.08');
INSERT INTO public.europe_data_import VALUES (7860, '24/08/2020', '2020-34', '8064', '281', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '86.31');
INSERT INTO public.europe_data_import VALUES (7861, '17/08/2020', '2020-33', '8693', '291', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '88.98');
INSERT INTO public.europe_data_import VALUES (7862, '10/08/2020', '2020-32', '8582', '287', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '87.41');
INSERT INTO public.europe_data_import VALUES (7863, '03/08/2020', '2020-31', '8388', '226', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '81.01');
INSERT INTO public.europe_data_import VALUES (7864, '27/07/2020', '2020-30', '7340', '161', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '63.16');
INSERT INTO public.europe_data_import VALUES (7865, '20/07/2020', '2020-29', '4923', '142', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '43.7');
INSERT INTO public.europe_data_import VALUES (7866, '13/07/2020', '2020-28', '3562', '134', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '32.05');
INSERT INTO public.europe_data_import VALUES (7867, '06/07/2020', '2020-27', '2660', '138', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '25.38');
INSERT INTO public.europe_data_import VALUES (7868, '29/06/2020', '2020-26', '2268', '100', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '22.22');
INSERT INTO public.europe_data_import VALUES (7869, '22/06/2020', '2020-25', '2046', '102', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '18.37');
INSERT INTO public.europe_data_import VALUES (7870, '15/06/2020', '2020-24', '1520', '84', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '14.12');
INSERT INTO public.europe_data_import VALUES (7871, '08/06/2020', '2020-23', '1222', '64', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '12.41');
INSERT INTO public.europe_data_import VALUES (7872, '01/06/2020', '2020-22', '1187', '83', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '12.29');
INSERT INTO public.europe_data_import VALUES (7873, '25/05/2020', '2020-21', '1199', '82', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '13.95');
INSERT INTO public.europe_data_import VALUES (7874, '18/05/2020', '2020-20', '1509', '145', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '19.1');
INSERT INTO public.europe_data_import VALUES (7875, '11/05/2020', '2020-19', '2199', '172', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '22.28');
INSERT INTO public.europe_data_import VALUES (7876, '04/05/2020', '2020-18', '2127', '172', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '22.75');
INSERT INTO public.europe_data_import VALUES (7877, '27/04/2020', '2020-17', '2290', '174', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '24.39');
INSERT INTO public.europe_data_import VALUES (7878, '20/04/2020', '2020-16', '2446', '128', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '25.15');
INSERT INTO public.europe_data_import VALUES (7879, '13/04/2020', '2020-15', '2436', '158', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '23.38');
INSERT INTO public.europe_data_import VALUES (7880, '06/04/2020', '2020-14', '2104', '108', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '17.67');
INSERT INTO public.europe_data_import VALUES (7881, '30/03/2020', '2020-13', '1327', '38', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '8.35');
INSERT INTO public.europe_data_import VALUES (7882, '23/03/2020', '2020-12', '294', '2', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '2.15');
INSERT INTO public.europe_data_import VALUES (7883, '16/03/2020', '2020-11', '124', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0.7');
INSERT INTO public.europe_data_import VALUES (7884, '09/03/2020', '2020-10', '12', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (7885, '02/03/2020', '2020-09', '3', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (7886, '24/02/2020', '2020-08', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7887, '17/02/2020', '2020-07', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7888, '10/02/2020', '2020-06', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7889, '03/02/2020', '2020-05', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7890, '27/01/2020', '2020-04', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7891, '20/01/2020', '2020-03', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7892, '13/01/2020', '2020-02', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7893, '06/01/2020', '2020-01', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7894, '01/02/2021', '2021-04', '129397', '3701', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '189.91');
INSERT INTO public.europe_data_import VALUES (7895, '25/01/2021', '2021-03', '147624', '3881', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '214.86');
INSERT INTO public.europe_data_import VALUES (7896, '18/01/2021', '2021-02', '165797', '3764', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '226.86');
INSERT INTO public.europe_data_import VALUES (7897, '11/01/2021', '2021-01', '165131', '3285', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '238.04');
INSERT INTO public.europe_data_import VALUES (7898, '04/01/2021', '2020-53', '182103', '3723', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '341.03');
INSERT INTO public.europe_data_import VALUES (7899, '28/12/2020', '2020-52', '315367', '6114', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '290.74');
INSERT INTO public.europe_data_import VALUES (7900, '21/12/2020', '2020-51', '108740', '2210', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '206.96');
INSERT INTO public.europe_data_import VALUES (7901, '14/12/2020', '2020-50', '193158', '3800', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '263.66');
INSERT INTO public.europe_data_import VALUES (7902, '07/12/2020', '2020-49', '191454', '3614', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '254.63');
INSERT INTO public.europe_data_import VALUES (7903, '30/11/2020', '2020-48', '179987', '3348', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '235.47');
INSERT INTO public.europe_data_import VALUES (7904, '23/11/2020', '2020-47', '163504', '2993', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '215.94');
INSERT INTO public.europe_data_import VALUES (7905, '16/11/2020', '2020-46', '151491', '2649', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '198.15');
INSERT INTO public.europe_data_import VALUES (7906, '09/11/2020', '2020-45', '137553', '2302', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '178.55');
INSERT INTO public.europe_data_import VALUES (7907, '02/11/2020', '2020-44', '122904', '2185', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '162.78');
INSERT INTO public.europe_data_import VALUES (7908, '26/10/2020', '2020-43', '114543', '1863', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '147.5');
INSERT INTO public.europe_data_import VALUES (7909, '19/10/2020', '2020-42', '100616', '1590', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '126.37');
INSERT INTO public.europe_data_import VALUES (7910, '12/10/2020', '2020-41', '83717', '1239', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '100.97');
INSERT INTO public.europe_data_import VALUES (7911, '05/10/2020', '2020-40', '63563', '1034', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '76.51');
INSERT INTO public.europe_data_import VALUES (7912, '28/09/2020', '2020-39', '48039', '906', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '60.76');
INSERT INTO public.europe_data_import VALUES (7913, '21/09/2020', '2020-38', '40588', '840', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '53.4');
INSERT INTO public.europe_data_import VALUES (7914, '14/09/2020', '2020-37', '37306', '758', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '49.69');
INSERT INTO public.europe_data_import VALUES (7915, '07/09/2020', '2020-36', '35179', '727', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '47.13');
INSERT INTO public.europe_data_import VALUES (7916, '31/08/2020', '2020-35', '33577', '710', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '46.25');
INSERT INTO public.europe_data_import VALUES (7917, '24/08/2020', '2020-34', '33896', '698', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '47.45');
INSERT INTO public.europe_data_import VALUES (7918, '17/08/2020', '2020-33', '35317', '754', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '49.35');
INSERT INTO public.europe_data_import VALUES (7919, '10/08/2020', '2020-32', '36666', '803', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '51.45');
INSERT INTO public.europe_data_import VALUES (7920, '03/08/2020', '2020-31', '38385', '859', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '54.38');
INSERT INTO public.europe_data_import VALUES (7921, '27/07/2020', '2020-30', '40939', '927', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '58.49');
INSERT INTO public.europe_data_import VALUES (7922, '20/07/2020', '2020-29', '44384', '1007', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '61.9');
INSERT INTO public.europe_data_import VALUES (7923, '13/07/2020', '2020-28', '45911', '1174', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '63.57');
INSERT INTO public.europe_data_import VALUES (7924, '06/07/2020', '2020-27', '46814', '1088', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '66.2');
INSERT INTO public.europe_data_import VALUES (7925, '29/06/2020', '2020-26', '49757', '962', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '72.31');
INSERT INTO public.europe_data_import VALUES (7926, '22/06/2020', '2020-25', '55716', '1163', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '80.21');
INSERT INTO public.europe_data_import VALUES (7927, '15/06/2020', '2020-24', '61291', '1089', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '84.4');
INSERT INTO public.europe_data_import VALUES (7928, '08/06/2020', '2020-23', '61830', '1166', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '84.45');
INSERT INTO public.europe_data_import VALUES (7929, '01/06/2020', '2020-22', '61362', '1152', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '85.07');
INSERT INTO public.europe_data_import VALUES (7930, '25/05/2020', '2020-21', '62729', '910', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '92.4');
INSERT INTO public.europe_data_import VALUES (7931, '18/05/2020', '2020-20', '72064', '716', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '100.82');
INSERT INTO public.europe_data_import VALUES (7932, '11/05/2020', '2020-19', '75001', '635', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '88.25');
INSERT INTO public.europe_data_import VALUES (7933, '04/05/2020', '2020-18', '53738', '533', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '62.96');
INSERT INTO public.europe_data_import VALUES (7934, '27/04/2020', '2020-17', '38096', '386', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '44.68');
INSERT INTO public.europe_data_import VALUES (7935, '20/04/2020', '2020-16', '27083', '231', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '25.68');
INSERT INTO public.europe_data_import VALUES (7936, '13/04/2020', '2020-15', '10381', '85', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '9.76');
INSERT INTO public.europe_data_import VALUES (7937, '06/04/2020', '2020-14', '3855', '37', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '3.44');
INSERT INTO public.europe_data_import VALUES (7938, '30/03/2020', '2020-13', '1167', '8', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '1.01');
INSERT INTO public.europe_data_import VALUES (7939, '23/03/2020', '2020-12', '304', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.24');
INSERT INTO public.europe_data_import VALUES (7940, '16/03/2020', '2020-11', '53', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.04');
INSERT INTO public.europe_data_import VALUES (7941, '09/03/2020', '2020-10', '8', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (7942, '02/03/2020', '2020-09', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7943, '24/02/2020', '2020-08', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7944, '17/02/2020', '2020-07', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7945, '10/02/2020', '2020-06', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (7946, '03/02/2020', '2020-05', '2', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (7947, '27/01/2020', '2020-04', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7948, '20/01/2020', '2020-03', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7949, '13/01/2020', '2020-02', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7950, '06/01/2020', '2020-01', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7951, '01/02/2021', '2021-04', '2484', '24', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '35.06');
INSERT INTO public.europe_data_import VALUES (7952, '25/01/2021', '2021-03', '1943', '32', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '26.49');
INSERT INTO public.europe_data_import VALUES (7953, '18/01/2021', '2021-02', '1402', '22', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '18.66');
INSERT INTO public.europe_data_import VALUES (7954, '11/01/2021', '2021-01', '954', '19', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '12.74');
INSERT INTO public.europe_data_import VALUES (7955, '04/01/2021', '2020-53', '655', '26', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '10.95');
INSERT INTO public.europe_data_import VALUES (7956, '28/12/2020', '2020-52', '728', '12', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '10.79');
INSERT INTO public.europe_data_import VALUES (7957, '21/12/2020', '2020-51', '634', '7', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '9.22');
INSERT INTO public.europe_data_import VALUES (7958, '14/12/2020', '2020-50', '530', '5', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '5.86');
INSERT INTO public.europe_data_import VALUES (7959, '07/12/2020', '2020-49', '210', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (7960, '30/11/2020', '2020-48', '254', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (7961, '23/11/2020', '2020-47', '210', '2', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.51');
INSERT INTO public.europe_data_import VALUES (7962, '16/11/2020', '2020-46', '233', '9', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.45');
INSERT INTO public.europe_data_import VALUES (7963, '09/11/2020', '2020-45', '76', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.24');
INSERT INTO public.europe_data_import VALUES (7964, '02/11/2020', '2020-44', '80', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (7965, '26/10/2020', '2020-43', '92', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.35');
INSERT INTO public.europe_data_import VALUES (7966, '19/10/2020', '2020-42', '78', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (7967, '12/10/2020', '2020-41', '30', '2', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (7968, '05/10/2020', '2020-40', '46', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.23');
INSERT INTO public.europe_data_import VALUES (7969, '28/09/2020', '2020-39', '109', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (7970, '21/09/2020', '2020-38', '120', '4', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.67');
INSERT INTO public.europe_data_import VALUES (7971, '14/09/2020', '2020-37', '217', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '4.52');
INSERT INTO public.europe_data_import VALUES (7972, '07/09/2020', '2020-36', '354', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '10.18');
INSERT INTO public.europe_data_import VALUES (7973, '31/08/2020', '2020-35', '931', '4', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '12.41');
INSERT INTO public.europe_data_import VALUES (7974, '24/08/2020', '2020-34', '636', '4', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '7.52');
INSERT INTO public.europe_data_import VALUES (7975, '17/08/2020', '2020-33', '313', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (7976, '10/08/2020', '2020-32', '78', '2', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.53');
INSERT INTO public.europe_data_import VALUES (7977, '03/08/2020', '2020-31', '241', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.8');
INSERT INTO public.europe_data_import VALUES (7978, '27/07/2020', '2020-30', '239', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.83');
INSERT INTO public.europe_data_import VALUES (7979, '20/07/2020', '2020-29', '245', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.78');
INSERT INTO public.europe_data_import VALUES (7980, '13/07/2020', '2020-28', '232', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (7981, '06/07/2020', '2020-27', '205', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.99');
INSERT INTO public.europe_data_import VALUES (7982, '29/06/2020', '2020-26', '172', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.52');
INSERT INTO public.europe_data_import VALUES (7983, '22/06/2020', '2020-25', '146', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.29');
INSERT INTO public.europe_data_import VALUES (7984, '15/06/2020', '2020-24', '143', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.68');
INSERT INTO public.europe_data_import VALUES (7985, '08/06/2020', '2020-23', '69', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (7986, '01/06/2020', '2020-22', '43', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (7987, '25/05/2020', '2020-21', '35', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (7988, '18/05/2020', '2020-20', '8', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (7989, '11/05/2020', '2020-19', '25', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (7990, '04/05/2020', '2020-18', '68', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (7991, '27/04/2020', '2020-17', '44', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (7992, '20/04/2020', '2020-16', '21', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (7993, '13/04/2020', '2020-15', '22', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (7994, '06/04/2020', '2020-14', '34', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.67');
INSERT INTO public.europe_data_import VALUES (7995, '30/03/2020', '2020-13', '51', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (7996, '23/03/2020', '2020-12', '14', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (7997, '16/03/2020', '2020-11', '5', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (7998, '01/02/2021', '2021-04', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (7999, '25/01/2021', '2021-03', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8000, '18/01/2021', '2021-02', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8001, '11/01/2021', '2021-01', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8002, '04/01/2021', '2020-53', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (8003, '28/12/2020', '2020-52', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '7.57');
INSERT INTO public.europe_data_import VALUES (8004, '21/12/2020', '2020-51', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8005, '14/12/2020', '2020-50', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '11.36');
INSERT INTO public.europe_data_import VALUES (8006, '07/12/2020', '2020-49', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8007, '30/11/2020', '2020-48', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (8008, '23/11/2020', '2020-47', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8009, '16/11/2020', '2020-46', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8010, '09/11/2020', '2020-45', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8011, '02/11/2020', '2020-44', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8012, '26/10/2020', '2020-43', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8013, '19/10/2020', '2020-42', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8014, '12/10/2020', '2020-41', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8015, '05/10/2020', '2020-40', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8016, '28/09/2020', '2020-39', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8017, '21/09/2020', '2020-38', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8018, '14/09/2020', '2020-37', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8019, '07/09/2020', '2020-36', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8020, '31/08/2020', '2020-35', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8021, '24/08/2020', '2020-34', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8022, '17/08/2020', '2020-33', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8023, '10/08/2020', '2020-32', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8024, '03/08/2020', '2020-31', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8025, '27/07/2020', '2020-30', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8026, '20/07/2020', '2020-29', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8027, '13/07/2020', '2020-28', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8028, '06/07/2020', '2020-27', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8029, '29/06/2020', '2020-26', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8030, '22/06/2020', '2020-25', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8031, '15/06/2020', '2020-24', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8032, '08/06/2020', '2020-23', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8033, '01/06/2020', '2020-22', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8034, '25/05/2020', '2020-21', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8035, '18/05/2020', '2020-20', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8036, '11/05/2020', '2020-19', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8037, '04/05/2020', '2020-18', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8038, '27/04/2020', '2020-17', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (8039, '20/04/2020', '2020-16', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8040, '13/04/2020', '2020-15', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8041, '06/04/2020', '2020-14', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '18.93');
INSERT INTO public.europe_data_import VALUES (8042, '30/03/2020', '2020-13', '7', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '');
INSERT INTO public.europe_data_import VALUES (8043, '01/02/2021', '2021-04', '490', '2', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '437.65');
INSERT INTO public.europe_data_import VALUES (8044, '25/01/2021', '2021-03', '310', '5', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '264.23');
INSERT INTO public.europe_data_import VALUES (8045, '18/01/2021', '2021-02', '173', '3', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '141.14');
INSERT INTO public.europe_data_import VALUES (8046, '11/01/2021', '2021-01', '85', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '72.76');
INSERT INTO public.europe_data_import VALUES (8047, '04/01/2021', '2020-53', '48', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '36.11');
INSERT INTO public.europe_data_import VALUES (8048, '28/12/2020', '2020-52', '18', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '16.41');
INSERT INTO public.europe_data_import VALUES (8049, '21/12/2020', '2020-51', '12', '1', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '12.04');
INSERT INTO public.europe_data_import VALUES (8050, '14/12/2020', '2020-50', '10', '2', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '9.85');
INSERT INTO public.europe_data_import VALUES (8051, '07/12/2020', '2020-49', '8', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '24.62');
INSERT INTO public.europe_data_import VALUES (8052, '30/11/2020', '2020-48', '37', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '47.05');
INSERT INTO public.europe_data_import VALUES (8053, '23/11/2020', '2020-47', '49', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '48.69');
INSERT INTO public.europe_data_import VALUES (8054, '16/11/2020', '2020-46', '40', '2', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '47.59');
INSERT INTO public.europe_data_import VALUES (8055, '09/11/2020', '2020-45', '47', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '42.12');
INSERT INTO public.europe_data_import VALUES (8056, '02/11/2020', '2020-44', '30', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '27.9');
INSERT INTO public.europe_data_import VALUES (8057, '26/10/2020', '2020-43', '21', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '13.68');
INSERT INTO public.europe_data_import VALUES (8058, '19/10/2020', '2020-42', '4', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '3.28');
INSERT INTO public.europe_data_import VALUES (8059, '12/10/2020', '2020-41', '2', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8060, '05/10/2020', '2020-40', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8061, '28/09/2020', '2020-39', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8062, '21/09/2020', '2020-38', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8063, '14/09/2020', '2020-37', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8064, '07/09/2020', '2020-36', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8065, '31/08/2020', '2020-35', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8066, '24/08/2020', '2020-34', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8067, '17/08/2020', '2020-33', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8068, '10/08/2020', '2020-32', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8069, '03/08/2020', '2020-31', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8070, '27/07/2020', '2020-30', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8071, '20/07/2020', '2020-29', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8072, '13/07/2020', '2020-28', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8073, '06/07/2020', '2020-27', '3', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8074, '29/06/2020', '2020-26', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8075, '22/06/2020', '2020-25', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8076, '15/06/2020', '2020-24', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8077, '08/06/2020', '2020-23', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8078, '01/06/2020', '2020-22', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8079, '25/05/2020', '2020-21', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8080, '18/05/2020', '2020-20', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8081, '11/05/2020', '2020-19', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8082, '04/05/2020', '2020-18', '3', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8083, '27/04/2020', '2020-17', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8084, '20/04/2020', '2020-16', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8085, '13/04/2020', '2020-15', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '3.28');
INSERT INTO public.europe_data_import VALUES (8086, '06/04/2020', '2020-14', '5', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '6.56');
INSERT INTO public.europe_data_import VALUES (8087, '30/03/2020', '2020-13', '7', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '3.83');
INSERT INTO public.europe_data_import VALUES (8088, '23/03/2020', '2020-12', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8089, '16/03/2020', '2020-11', '2', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '');
INSERT INTO public.europe_data_import VALUES (8090, '01/02/2021', '2021-04', '205', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '413.23');
INSERT INTO public.europe_data_import VALUES (8091, '25/01/2021', '2021-03', '252', '1', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '449.4');
INSERT INTO public.europe_data_import VALUES (8092, '18/01/2021', '2021-02', '245', '1', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '334.56');
INSERT INTO public.europe_data_import VALUES (8093, '11/01/2021', '2021-01', '125', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '126.59');
INSERT INTO public.europe_data_import VALUES (8094, '04/01/2021', '2020-53', '15', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '18.08');
INSERT INTO public.europe_data_import VALUES (8095, '28/12/2020', '2020-52', '5', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '9.95');
INSERT INTO public.europe_data_import VALUES (8096, '21/12/2020', '2020-51', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '15.37');
INSERT INTO public.europe_data_import VALUES (8097, '14/12/2020', '2020-50', '11', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '11.75');
INSERT INTO public.europe_data_import VALUES (8098, '07/12/2020', '2020-49', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8099, '30/11/2020', '2020-48', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '6.33');
INSERT INTO public.europe_data_import VALUES (8100, '23/11/2020', '2020-47', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '7.23');
INSERT INTO public.europe_data_import VALUES (8101, '16/11/2020', '2020-46', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8102, '09/11/2020', '2020-45', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8103, '02/11/2020', '2020-44', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '7.23');
INSERT INTO public.europe_data_import VALUES (8104, '26/10/2020', '2020-43', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '8.14');
INSERT INTO public.europe_data_import VALUES (8105, '19/10/2020', '2020-42', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8106, '12/10/2020', '2020-41', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8107, '05/10/2020', '2020-40', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8108, '28/09/2020', '2020-39', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8109, '21/09/2020', '2020-38', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8110, '14/09/2020', '2020-37', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '3.62');
INSERT INTO public.europe_data_import VALUES (8111, '07/09/2020', '2020-36', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8112, '31/08/2020', '2020-35', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8113, '24/08/2020', '2020-34', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (8114, '17/08/2020', '2020-33', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '1.81');
INSERT INTO public.europe_data_import VALUES (8115, '10/08/2020', '2020-32', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8116, '03/08/2020', '2020-31', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8117, '27/07/2020', '2020-30', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '15.37');
INSERT INTO public.europe_data_import VALUES (8118, '20/07/2020', '2020-29', '15', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '18.99');
INSERT INTO public.europe_data_import VALUES (8119, '13/07/2020', '2020-28', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '5.43');
INSERT INTO public.europe_data_import VALUES (8120, '06/07/2020', '2020-27', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8121, '29/06/2020', '2020-26', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '1.81');
INSERT INTO public.europe_data_import VALUES (8122, '22/06/2020', '2020-25', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8123, '15/06/2020', '2020-24', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (8124, '08/06/2020', '2020-23', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '7.23');
INSERT INTO public.europe_data_import VALUES (8125, '01/06/2020', '2020-22', '8', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '8.14');
INSERT INTO public.europe_data_import VALUES (8126, '25/05/2020', '2020-21', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (8127, '18/05/2020', '2020-20', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8128, '11/05/2020', '2020-19', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8129, '04/05/2020', '2020-18', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8130, '27/04/2020', '2020-17', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '1.81');
INSERT INTO public.europe_data_import VALUES (8131, '20/04/2020', '2020-16', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8132, '13/04/2020', '2020-15', '5', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '9.95');
INSERT INTO public.europe_data_import VALUES (8133, '06/04/2020', '2020-14', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '6.33');
INSERT INTO public.europe_data_import VALUES (8134, '30/03/2020', '2020-13', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '');
INSERT INTO public.europe_data_import VALUES (8135, '01/02/2021', '2021-04', '151', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '690.8');
INSERT INTO public.europe_data_import VALUES (8136, '25/01/2021', '2021-03', '87', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '600.82');
INSERT INTO public.europe_data_import VALUES (8137, '18/01/2021', '2021-02', '120', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '853.34');
INSERT INTO public.europe_data_import VALUES (8138, '11/01/2021', '2021-01', '174', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1137.78');
INSERT INTO public.europe_data_import VALUES (8139, '04/01/2021', '2020-53', '218', '5', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1120.37');
INSERT INTO public.europe_data_import VALUES (8140, '28/12/2020', '2020-52', '168', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '952.02');
INSERT INTO public.europe_data_import VALUES (8141, '21/12/2020', '2020-51', '160', '4', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '923.0');
INSERT INTO public.europe_data_import VALUES (8142, '14/12/2020', '2020-50', '158', '3', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1047.8');
INSERT INTO public.europe_data_import VALUES (8143, '07/12/2020', '2020-49', '203', '3', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1143.59');
INSERT INTO public.europe_data_import VALUES (8144, '30/11/2020', '2020-48', '191', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '966.53');
INSERT INTO public.europe_data_import VALUES (8145, '23/11/2020', '2020-47', '142', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1021.68');
INSERT INTO public.europe_data_import VALUES (8146, '16/11/2020', '2020-46', '210', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '943.31');
INSERT INTO public.europe_data_import VALUES (8147, '09/11/2020', '2020-45', '115', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '650.16');
INSERT INTO public.europe_data_import VALUES (8148, '02/11/2020', '2020-44', '109', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '490.52');
INSERT INTO public.europe_data_import VALUES (8149, '26/10/2020', '2020-43', '60', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '194.47');
INSERT INTO public.europe_data_import VALUES (8150, '19/10/2020', '2020-42', '7', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '78.37');
INSERT INTO public.europe_data_import VALUES (8151, '12/10/2020', '2020-41', '20', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '72.56');
INSERT INTO public.europe_data_import VALUES (8152, '05/10/2020', '2020-40', '5', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '26.12');
INSERT INTO public.europe_data_import VALUES (8153, '28/09/2020', '2020-39', '4', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '14.51');
INSERT INTO public.europe_data_import VALUES (8154, '21/09/2020', '2020-38', '1', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '20.32');
INSERT INTO public.europe_data_import VALUES (8155, '14/09/2020', '2020-37', '6', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '34.83');
INSERT INTO public.europe_data_import VALUES (8156, '07/09/2020', '2020-36', '6', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '17.42');
INSERT INTO public.europe_data_import VALUES (8157, '31/08/2020', '2020-35', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8158, '24/08/2020', '2020-34', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8159, '17/08/2020', '2020-33', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '31.93');
INSERT INTO public.europe_data_import VALUES (8160, '10/08/2020', '2020-32', '11', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '31.93');
INSERT INTO public.europe_data_import VALUES (8161, '03/08/2020', '2020-31', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8162, '27/07/2020', '2020-30', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8163, '20/07/2020', '2020-29', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '2.9');
INSERT INTO public.europe_data_import VALUES (8164, '13/07/2020', '2020-28', '1', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '2.9');
INSERT INTO public.europe_data_import VALUES (8165, '06/07/2020', '2020-27', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '5.81');
INSERT INTO public.europe_data_import VALUES (8166, '29/06/2020', '2020-26', '2', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '11.61');
INSERT INTO public.europe_data_import VALUES (8167, '22/06/2020', '2020-25', '2', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '26.12');
INSERT INTO public.europe_data_import VALUES (8168, '15/06/2020', '2020-24', '7', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '66.76');
INSERT INTO public.europe_data_import VALUES (8169, '08/06/2020', '2020-23', '16', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '63.86');
INSERT INTO public.europe_data_import VALUES (8170, '01/06/2020', '2020-22', '6', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '49.34');
INSERT INTO public.europe_data_import VALUES (8171, '25/05/2020', '2020-21', '11', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '107.39');
INSERT INTO public.europe_data_import VALUES (8172, '18/05/2020', '2020-20', '26', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '208.98');
INSERT INTO public.europe_data_import VALUES (8173, '11/05/2020', '2020-19', '46', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '261.23');
INSERT INTO public.europe_data_import VALUES (8174, '04/05/2020', '2020-18', '44', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '351.2');
INSERT INTO public.europe_data_import VALUES (8175, '27/04/2020', '2020-17', '77', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '528.26');
INSERT INTO public.europe_data_import VALUES (8176, '20/04/2020', '2020-16', '105', '4', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '565.99');
INSERT INTO public.europe_data_import VALUES (8177, '13/04/2020', '2020-15', '90', '3', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '368.62');
INSERT INTO public.europe_data_import VALUES (8178, '06/04/2020', '2020-14', '37', '8', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '333.79');
INSERT INTO public.europe_data_import VALUES (8179, '30/03/2020', '2020-13', '78', '4', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '380.23');
INSERT INTO public.europe_data_import VALUES (8180, '23/03/2020', '2020-12', '53', '13', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '330.89');
INSERT INTO public.europe_data_import VALUES (8181, '16/03/2020', '2020-11', '61', '6', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '261.23');
INSERT INTO public.europe_data_import VALUES (8182, '09/03/2020', '2020-10', '29', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '107.39');
INSERT INTO public.europe_data_import VALUES (8183, '02/03/2020', '2020-09', '8', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '23.22');
INSERT INTO public.europe_data_import VALUES (8184, '24/02/2020', '2020-08', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8185, '17/02/2020', '2020-07', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8186, '10/02/2020', '2020-06', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8187, '03/02/2020', '2020-05', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8188, '27/01/2020', '2020-04', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8189, '20/01/2020', '2020-03', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8190, '13/01/2020', '2020-02', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8191, '06/01/2020', '2020-01', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8192, '01/02/2021', '2021-04', '58', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '48.83');
INSERT INTO public.europe_data_import VALUES (8193, '25/01/2021', '2021-03', '47', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '57.2');
INSERT INTO public.europe_data_import VALUES (8194, '18/01/2021', '2021-02', '76', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '54.87');
INSERT INTO public.europe_data_import VALUES (8195, '11/01/2021', '2021-01', '42', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '24.18');
INSERT INTO public.europe_data_import VALUES (8196, '04/01/2021', '2020-53', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.58');
INSERT INTO public.europe_data_import VALUES (8197, '28/12/2020', '2020-52', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8198, '21/12/2020', '2020-51', '3', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.05');
INSERT INTO public.europe_data_import VALUES (8199, '14/12/2020', '2020-50', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '9.3');
INSERT INTO public.europe_data_import VALUES (8200, '07/12/2020', '2020-49', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '9.3');
INSERT INTO public.europe_data_import VALUES (8201, '30/11/2020', '2020-48', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (8202, '23/11/2020', '2020-47', '14', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.91');
INSERT INTO public.europe_data_import VALUES (8203, '16/11/2020', '2020-46', '3', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.44');
INSERT INTO public.europe_data_import VALUES (8204, '09/11/2020', '2020-45', '13', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '10.23');
INSERT INTO public.europe_data_import VALUES (8205, '02/11/2020', '2020-44', '9', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.44');
INSERT INTO public.europe_data_import VALUES (8206, '26/10/2020', '2020-43', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8207, '19/10/2020', '2020-42', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '9.3');
INSERT INTO public.europe_data_import VALUES (8208, '12/10/2020', '2020-41', '16', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '8.37');
INSERT INTO public.europe_data_import VALUES (8209, '05/10/2020', '2020-40', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8210, '28/09/2020', '2020-39', '3', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8211, '21/09/2020', '2020-38', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (8212, '14/09/2020', '2020-37', '8', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (8213, '07/09/2020', '2020-36', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.79');
INSERT INTO public.europe_data_import VALUES (8214, '31/08/2020', '2020-35', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8215, '24/08/2020', '2020-34', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.51');
INSERT INTO public.europe_data_import VALUES (8216, '17/08/2020', '2020-33', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8217, '10/08/2020', '2020-32', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.98');
INSERT INTO public.europe_data_import VALUES (8218, '03/08/2020', '2020-31', '11', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '59.52');
INSERT INTO public.europe_data_import VALUES (8219, '27/07/2020', '2020-30', '117', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '62.31');
INSERT INTO public.europe_data_import VALUES (8220, '20/07/2020', '2020-29', '17', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '12.09');
INSERT INTO public.europe_data_import VALUES (8221, '13/07/2020', '2020-28', '9', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.44');
INSERT INTO public.europe_data_import VALUES (8222, '06/07/2020', '2020-27', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '10.23');
INSERT INTO public.europe_data_import VALUES (8223, '29/06/2020', '2020-26', '15', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '24.18');
INSERT INTO public.europe_data_import VALUES (8224, '22/06/2020', '2020-25', '37', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '85.56');
INSERT INTO public.europe_data_import VALUES (8225, '15/06/2020', '2020-24', '147', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '82.77');
INSERT INTO public.europe_data_import VALUES (8226, '08/06/2020', '2020-23', '31', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '99.98');
INSERT INTO public.europe_data_import VALUES (8227, '01/06/2020', '2020-22', '184', '3', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '115.32');
INSERT INTO public.europe_data_import VALUES (8228, '25/05/2020', '2020-21', '64', '2', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '42.32');
INSERT INTO public.europe_data_import VALUES (8229, '18/05/2020', '2020-20', '27', '2', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '100.91');
INSERT INTO public.europe_data_import VALUES (8230, '11/05/2020', '2020-19', '190', '4', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '93.0');
INSERT INTO public.europe_data_import VALUES (8231, '04/05/2020', '2020-18', '10', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.51');
INSERT INTO public.europe_data_import VALUES (8232, '27/04/2020', '2020-17', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (8233, '20/04/2020', '2020-16', '0', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (8234, '13/04/2020', '2020-15', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8235, '01/02/2021', '2021-04', '1703', '23', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '9.18');
INSERT INTO public.europe_data_import VALUES (8236, '25/01/2021', '2021-03', '1442', '29', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '7.48');
INSERT INTO public.europe_data_import VALUES (8237, '18/01/2021', '2021-02', '1120', '32', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '5.18');
INSERT INTO public.europe_data_import VALUES (8238, '11/01/2021', '2021-01', '654', '35', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '4.64');
INSERT INTO public.europe_data_import VALUES (8239, '04/01/2021', '2020-53', '935', '71', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '6.26');
INSERT INTO public.europe_data_import VALUES (8240, '28/12/2020', '2020-52', '1210', '63', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '6.81');
INSERT INTO public.europe_data_import VALUES (8241, '21/12/2020', '2020-51', '1122', '74', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '6.7');
INSERT INTO public.europe_data_import VALUES (8242, '14/12/2020', '2020-50', '1175', '83', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '8.05');
INSERT INTO public.europe_data_import VALUES (8243, '07/12/2020', '2020-49', '1585', '81', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '10.08');
INSERT INTO public.europe_data_import VALUES (8244, '30/11/2020', '2020-48', '1870', '104', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '11.3');
INSERT INTO public.europe_data_import VALUES (8245, '23/11/2020', '2020-47', '2003', '123', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '13.62');
INSERT INTO public.europe_data_import VALUES (8246, '16/11/2020', '2020-46', '2663', '117', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.34');
INSERT INTO public.europe_data_import VALUES (8247, '09/11/2020', '2020-45', '2936', '138', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.68');
INSERT INTO public.europe_data_import VALUES (8248, '02/11/2020', '2020-44', '2781', '106', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '15.92');
INSERT INTO public.europe_data_import VALUES (8249, '26/10/2020', '2020-43', '2673', '111', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.36');
INSERT INTO public.europe_data_import VALUES (8250, '19/10/2020', '2020-42', '2935', '142', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.97');
INSERT INTO public.europe_data_import VALUES (8251, '12/10/2020', '2020-41', '2880', '168', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '17.72');
INSERT INTO public.europe_data_import VALUES (8252, '05/10/2020', '2020-40', '3194', '192', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '19.36');
INSERT INTO public.europe_data_import VALUES (8253, '28/09/2020', '2020-39', '3439', '198', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '22.01');
INSERT INTO public.europe_data_import VALUES (8254, '21/09/2020', '2020-38', '4103', '217', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '26.05');
INSERT INTO public.europe_data_import VALUES (8255, '14/09/2020', '2020-37', '4824', '187', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '31.6');
INSERT INTO public.europe_data_import VALUES (8256, '07/09/2020', '2020-36', '6006', '211', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '38.95');
INSERT INTO public.europe_data_import VALUES (8257, '31/08/2020', '2020-35', '7342', '221', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '47.5');
INSERT INTO public.europe_data_import VALUES (8258, '24/08/2020', '2020-34', '8937', '241', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '54.83');
INSERT INTO public.europe_data_import VALUES (8259, '17/08/2020', '2020-33', '9852', '241', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '57.51');
INSERT INTO public.europe_data_import VALUES (8260, '10/08/2020', '2020-32', '9855', '250', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '63.47');
INSERT INTO public.europe_data_import VALUES (8261, '03/08/2020', '2020-31', '11894', '184', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '81.46');
INSERT INTO public.europe_data_import VALUES (8262, '27/07/2020', '2020-30', '16021', '247', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '101.21');
INSERT INTO public.europe_data_import VALUES (8263, '20/07/2020', '2020-29', '18661', '263', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '120.84');
INSERT INTO public.europe_data_import VALUES (8264, '13/07/2020', '2020-28', '22750', '307', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '145.22');
INSERT INTO public.europe_data_import VALUES (8265, '06/07/2020', '2020-27', '27016', '365', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '151.44');
INSERT INTO public.europe_data_import VALUES (8266, '29/06/2020', '2020-26', '24881', '284', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '160.36');
INSERT INTO public.europe_data_import VALUES (8267, '22/06/2020', '2020-25', '30071', '295', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '162.53');
INSERT INTO public.europe_data_import VALUES (8268, '15/06/2020', '2020-24', '25627', '260', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '123.38');
INSERT INTO public.europe_data_import VALUES (8269, '08/06/2020', '2020-23', '16653', '209', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '85.66');
INSERT INTO public.europe_data_import VALUES (8270, '01/06/2020', '2020-22', '12701', '113', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '89.03');
INSERT INTO public.europe_data_import VALUES (8271, '25/05/2020', '2020-21', '17808', '78', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '97.79');
INSERT INTO public.europe_data_import VALUES (8272, '18/05/2020', '2020-20', '15704', '66', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '80.95');
INSERT INTO public.europe_data_import VALUES (8273, '11/05/2020', '2020-19', '12037', '62', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '62.82');
INSERT INTO public.europe_data_import VALUES (8274, '04/05/2020', '2020-18', '9489', '45', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '51.5');
INSERT INTO public.europe_data_import VALUES (8275, '27/04/2020', '2020-17', '8160', '42', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '38.11');
INSERT INTO public.europe_data_import VALUES (8276, '20/04/2020', '2020-16', '4900', '38', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '20.36');
INSERT INTO public.europe_data_import VALUES (8277, '13/04/2020', '2020-15', '2077', '25', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '9.43');
INSERT INTO public.europe_data_import VALUES (8278, '06/04/2020', '2020-14', '1156', '26', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '5.47');
INSERT INTO public.europe_data_import VALUES (8279, '30/03/2020', '2020-13', '718', '8', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '3.24');
INSERT INTO public.europe_data_import VALUES (8280, '23/03/2020', '2020-12', '393', '0', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '1.46');
INSERT INTO public.europe_data_import VALUES (8281, '16/03/2020', '2020-11', '107', '0', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '0.34');
INSERT INTO public.europe_data_import VALUES (8282, '09/03/2020', '2020-10', '11', '0', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8283, '01/02/2021', '2021-04', '1934', '56', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '22.72');
INSERT INTO public.europe_data_import VALUES (8284, '25/01/2021', '2021-03', '1769', '56', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '21.23');
INSERT INTO public.europe_data_import VALUES (8285, '18/01/2021', '2021-02', '1691', '57', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '20.99');
INSERT INTO public.europe_data_import VALUES (8286, '11/01/2021', '2021-01', '1730', '45', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '17.21');
INSERT INTO public.europe_data_import VALUES (8287, '04/01/2021', '2020-53', '1075', '34', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '12.55');
INSERT INTO public.europe_data_import VALUES (8288, '28/12/2020', '2020-52', '970', '25', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '10.14');
INSERT INTO public.europe_data_import VALUES (8289, '21/12/2020', '2020-51', '683', '16', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.86');
INSERT INTO public.europe_data_import VALUES (8290, '14/12/2020', '2020-50', '598', '11', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '6.14');
INSERT INTO public.europe_data_import VALUES (8291, '07/12/2020', '2020-49', '402', '5', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '3.65');
INSERT INTO public.europe_data_import VALUES (8292, '30/11/2020', '2020-48', '193', '3', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (8293, '23/11/2020', '2020-47', '89', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.07');
INSERT INTO public.europe_data_import VALUES (8294, '16/11/2020', '2020-46', '85', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.0');
INSERT INTO public.europe_data_import VALUES (8295, '09/11/2020', '2020-45', '78', '1', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (8296, '02/11/2020', '2020-44', '79', '4', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.3');
INSERT INTO public.europe_data_import VALUES (8297, '26/10/2020', '2020-43', '133', '4', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (8298, '19/10/2020', '2020-42', '150', '3', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.99');
INSERT INTO public.europe_data_import VALUES (8299, '12/10/2020', '2020-41', '174', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (8300, '05/10/2020', '2020-40', '185', '4', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8301, '28/09/2020', '2020-39', '195', '6', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '3.86');
INSERT INTO public.europe_data_import VALUES (8302, '21/09/2020', '2020-38', '434', '5', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '4.46');
INSERT INTO public.europe_data_import VALUES (8303, '14/09/2020', '2020-37', '293', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '4.44');
INSERT INTO public.europe_data_import VALUES (8304, '07/09/2020', '2020-36', '431', '6', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '6.37');
INSERT INTO public.europe_data_import VALUES (8305, '31/08/2020', '2020-35', '607', '15', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.55');
INSERT INTO public.europe_data_import VALUES (8306, '24/08/2020', '2020-34', '787', '16', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '10.89');
INSERT INTO public.europe_data_import VALUES (8307, '17/08/2020', '2020-33', '987', '21', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (8308, '10/08/2020', '2020-32', '831', '23', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.17');
INSERT INTO public.europe_data_import VALUES (8309, '03/08/2020', '2020-31', '663', '18', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.41');
INSERT INTO public.europe_data_import VALUES (8310, '27/07/2020', '2020-30', '871', '24', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.49');
INSERT INTO public.europe_data_import VALUES (8311, '20/07/2020', '2020-29', '675', '19', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.65');
INSERT INTO public.europe_data_import VALUES (8312, '13/07/2020', '2020-28', '735', '15', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.51');
INSERT INTO public.europe_data_import VALUES (8313, '06/07/2020', '2020-27', '814', '28', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.28');
INSERT INTO public.europe_data_import VALUES (8314, '29/06/2020', '2020-26', '698', '21', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.18');
INSERT INTO public.europe_data_import VALUES (8315, '22/06/2020', '2020-25', '798', '24', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.57');
INSERT INTO public.europe_data_import VALUES (8316, '15/06/2020', '2020-24', '762', '11', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.87');
INSERT INTO public.europe_data_import VALUES (8317, '08/06/2020', '2020-23', '683', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.86');
INSERT INTO public.europe_data_import VALUES (8318, '01/06/2020', '2020-22', '598', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.15');
INSERT INTO public.europe_data_import VALUES (8319, '25/05/2020', '2020-21', '567', '9', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.21');
INSERT INTO public.europe_data_import VALUES (8320, '18/05/2020', '2020-20', '771', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.96');
INSERT INTO public.europe_data_import VALUES (8321, '11/05/2020', '2020-19', '527', '10', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '6.37');
INSERT INTO public.europe_data_import VALUES (8322, '04/05/2020', '2020-18', '511', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '5.0');
INSERT INTO public.europe_data_import VALUES (8323, '27/04/2020', '2020-17', '304', '5', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (8324, '20/04/2020', '2020-16', '87', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (8325, '13/04/2020', '2020-15', '58', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.85');
INSERT INTO public.europe_data_import VALUES (8326, '06/04/2020', '2020-14', '80', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (8327, '30/03/2020', '2020-13', '75', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.71');
INSERT INTO public.europe_data_import VALUES (8328, '23/03/2020', '2020-12', '41', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (8329, '16/03/2020', '2020-11', '26', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8330, '01/02/2021', '2021-04', '11660', '134', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '326.4');
INSERT INTO public.europe_data_import VALUES (8331, '25/01/2021', '2021-03', '11070', '136', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '343.41');
INSERT INTO public.europe_data_import VALUES (8332, '18/01/2021', '2021-02', '12844', '168', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '411.6');
INSERT INTO public.europe_data_import VALUES (8333, '11/01/2021', '2021-01', '15819', '257', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '446.17');
INSERT INTO public.europe_data_import VALUES (8334, '04/01/2021', '2020-53', '15251', '252', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '576.17');
INSERT INTO public.europe_data_import VALUES (8335, '28/12/2020', '2020-52', '24872', '340', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '893.01');
INSERT INTO public.europe_data_import VALUES (8336, '21/12/2020', '2020-51', '37315', '402', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1207.61');
INSERT INTO public.europe_data_import VALUES (8337, '14/12/2020', '2020-50', '46780', '382', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1396.06');
INSERT INTO public.europe_data_import VALUES (8338, '07/12/2020', '2020-49', '50438', '400', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1414.92');
INSERT INTO public.europe_data_import VALUES (8339, '30/11/2020', '2020-48', '48094', '350', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1215.52');
INSERT INTO public.europe_data_import VALUES (8340, '23/11/2020', '2020-47', '36552', '190', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '838.24');
INSERT INTO public.europe_data_import VALUES (8341, '16/11/2020', '2020-46', '21821', '119', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '519.33');
INSERT INTO public.europe_data_import VALUES (8342, '09/11/2020', '2020-45', '14344', '64', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '334.03');
INSERT INTO public.europe_data_import VALUES (8343, '02/11/2020', '2020-44', '8917', '34', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '175.81');
INSERT INTO public.europe_data_import VALUES (8344, '26/10/2020', '2020-43', '3326', '16', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '67.48');
INSERT INTO public.europe_data_import VALUES (8345, '19/10/2020', '2020-42', '1373', '13', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '32.44');
INSERT INTO public.europe_data_import VALUES (8346, '12/10/2020', '2020-41', '886', '9', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '20.15');
INSERT INTO public.europe_data_import VALUES (8347, '05/10/2020', '2020-40', '517', '7', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.26');
INSERT INTO public.europe_data_import VALUES (8348, '28/09/2020', '2020-39', '476', '6', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.02');
INSERT INTO public.europe_data_import VALUES (8349, '21/09/2020', '2020-38', '500', '8', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.4');
INSERT INTO public.europe_data_import VALUES (8350, '14/09/2020', '2020-37', '503', '9', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.98');
INSERT INTO public.europe_data_import VALUES (8351, '07/09/2020', '2020-36', '540', '13', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '17.92');
INSERT INTO public.europe_data_import VALUES (8352, '31/08/2020', '2020-35', '708', '13', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '24.17');
INSERT INTO public.europe_data_import VALUES (8353, '24/08/2020', '2020-34', '975', '24', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '36.73');
INSERT INTO public.europe_data_import VALUES (8354, '17/08/2020', '2020-33', '1583', '33', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '50.1');
INSERT INTO public.europe_data_import VALUES (8355, '10/08/2020', '2020-32', '1906', '51', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '62.74');
INSERT INTO public.europe_data_import VALUES (8356, '03/08/2020', '2020-31', '2463', '56', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '76.09');
INSERT INTO public.europe_data_import VALUES (8357, '27/07/2020', '2020-30', '2836', '62', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '77.11');
INSERT INTO public.europe_data_import VALUES (8358, '20/07/2020', '2020-29', '2534', '79', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '68.4');
INSERT INTO public.europe_data_import VALUES (8359, '13/07/2020', '2020-28', '2229', '82', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '61.95');
INSERT INTO public.europe_data_import VALUES (8360, '06/07/2020', '2020-27', '2085', '41', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '46.48');
INSERT INTO public.europe_data_import VALUES (8361, '29/06/2020', '2020-26', '1152', '9', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '24.93');
INSERT INTO public.europe_data_import VALUES (8362, '22/06/2020', '2020-25', '584', '7', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '15.38');
INSERT INTO public.europe_data_import VALUES (8363, '15/06/2020', '2020-24', '487', '5', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '12.9');
INSERT INTO public.europe_data_import VALUES (8364, '08/06/2020', '2020-23', '411', '6', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '9.54');
INSERT INTO public.europe_data_import VALUES (8365, '01/06/2020', '2020-22', '253', '5', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '11.52');
INSERT INTO public.europe_data_import VALUES (8366, '25/05/2020', '2020-21', '549', '8', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '15.01');
INSERT INTO public.europe_data_import VALUES (8367, '18/05/2020', '2020-20', '496', '15', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '16.46');
INSERT INTO public.europe_data_import VALUES (8368, '11/05/2020', '2020-19', '650', '22', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '29.75');
INSERT INTO public.europe_data_import VALUES (8369, '04/05/2020', '2020-18', '1422', '37', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '45.18');
INSERT INTO public.europe_data_import VALUES (8370, '27/04/2020', '2020-17', '1724', '34', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '63.36');
INSERT INTO public.europe_data_import VALUES (8371, '20/04/2020', '2020-16', '2688', '42', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '63.33');
INSERT INTO public.europe_data_import VALUES (8372, '13/04/2020', '2020-15', '1722', '29', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '41.49');
INSERT INTO public.europe_data_import VALUES (8373, '06/04/2020', '2020-14', '1167', '38', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '24.7');
INSERT INTO public.europe_data_import VALUES (8374, '30/03/2020', '2020-13', '553', '12', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '9.85');
INSERT INTO public.europe_data_import VALUES (8375, '23/03/2020', '2020-12', '133', '1', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '2.7');
INSERT INTO public.europe_data_import VALUES (8376, '16/03/2020', '2020-11', '55', '0', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8377, '01/02/2021', '2021-04', '154', '2', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '529.97');
INSERT INTO public.europe_data_import VALUES (8378, '25/01/2021', '2021-03', '364', '1', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '550.43');
INSERT INTO public.europe_data_import VALUES (8379, '18/01/2021', '2021-02', '174', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '417.43');
INSERT INTO public.europe_data_import VALUES (8380, '11/01/2021', '2021-01', '234', '2', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '321.26');
INSERT INTO public.europe_data_import VALUES (8381, '04/01/2021', '2020-53', '80', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '94.13');
INSERT INTO public.europe_data_import VALUES (8382, '28/12/2020', '2020-52', '12', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '15.35');
INSERT INTO public.europe_data_import VALUES (8383, '21/12/2020', '2020-51', '3', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '21.49');
INSERT INTO public.europe_data_import VALUES (8384, '14/12/2020', '2020-50', '18', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '29.67');
INSERT INTO public.europe_data_import VALUES (8385, '07/12/2020', '2020-49', '11', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '18.42');
INSERT INTO public.europe_data_import VALUES (8386, '30/11/2020', '2020-48', '7', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '15.35');
INSERT INTO public.europe_data_import VALUES (8387, '23/11/2020', '2020-47', '8', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '8.18');
INSERT INTO public.europe_data_import VALUES (8388, '16/11/2020', '2020-46', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8389, '09/11/2020', '2020-45', '5', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8390, '02/11/2020', '2020-44', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8391, '26/10/2020', '2020-43', '4', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8392, '19/10/2020', '2020-42', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8393, '12/10/2020', '2020-41', '3', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8394, '05/10/2020', '2020-40', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8395, '28/09/2020', '2020-39', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8396, '21/09/2020', '2020-38', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8397, '14/09/2020', '2020-37', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (8398, '07/09/2020', '2020-36', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8399, '31/08/2020', '2020-35', '4', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '9.21');
INSERT INTO public.europe_data_import VALUES (8400, '24/08/2020', '2020-34', '5', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '6.14');
INSERT INTO public.europe_data_import VALUES (8401, '17/08/2020', '2020-33', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '13.3');
INSERT INTO public.europe_data_import VALUES (8402, '10/08/2020', '2020-32', '12', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '12.28');
INSERT INTO public.europe_data_import VALUES (8403, '03/08/2020', '2020-31', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '14.32');
INSERT INTO public.europe_data_import VALUES (8404, '27/07/2020', '2020-30', '14', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '14.32');
INSERT INTO public.europe_data_import VALUES (8405, '20/07/2020', '2020-29', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '91.06');
INSERT INTO public.europe_data_import VALUES (8406, '13/07/2020', '2020-28', '89', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '91.06');
INSERT INTO public.europe_data_import VALUES (8407, '06/07/2020', '2020-27', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8408, '29/06/2020', '2020-26', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8409, '22/06/2020', '2020-25', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8410, '15/06/2020', '2020-24', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8411, '08/06/2020', '2020-23', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8412, '01/06/2020', '2020-22', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8413, '25/05/2020', '2020-21', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8414, '18/05/2020', '2020-20', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8415, '11/05/2020', '2020-19', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8416, '04/05/2020', '2020-18', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8417, '27/04/2020', '2020-17', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (8418, '20/04/2020', '2020-16', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (8419, '13/04/2020', '2020-15', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '2.05');
INSERT INTO public.europe_data_import VALUES (8420, '06/04/2020', '2020-14', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (8421, '30/03/2020', '2020-13', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8422, '23/03/2020', '2020-12', '4', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '7.16');
INSERT INTO public.europe_data_import VALUES (8423, '16/03/2020', '2020-11', '3', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8424, '01/02/2021', '2021-04', '461', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '8.04');
INSERT INTO public.europe_data_import VALUES (8425, '25/01/2021', '2021-03', '167', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.19');
INSERT INTO public.europe_data_import VALUES (8426, '18/01/2021', '2021-02', '160', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.26');
INSERT INTO public.europe_data_import VALUES (8427, '11/01/2021', '2021-01', '173', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.66');
INSERT INTO public.europe_data_import VALUES (8428, '04/01/2021', '2020-53', '113', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.1');
INSERT INTO public.europe_data_import VALUES (8429, '28/12/2020', '2020-52', '51', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.47');
INSERT INTO public.europe_data_import VALUES (8430, '21/12/2020', '2020-51', '64', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (8431, '14/12/2020', '2020-50', '19', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (8432, '07/12/2020', '2020-49', '15', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (8433, '30/11/2020', '2020-48', '6', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (8434, '23/11/2020', '2020-47', '14', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (8435, '16/11/2020', '2020-46', '10', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (8436, '09/11/2020', '2020-45', '15', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (8437, '02/11/2020', '2020-44', '20', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (8438, '26/10/2020', '2020-43', '16', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (8439, '19/10/2020', '2020-42', '24', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.78');
INSERT INTO public.europe_data_import VALUES (8440, '12/10/2020', '2020-41', '37', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.16');
INSERT INTO public.europe_data_import VALUES (8441, '05/10/2020', '2020-40', '54', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.29');
INSERT INTO public.europe_data_import VALUES (8442, '28/09/2020', '2020-39', '47', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (8443, '21/09/2020', '2020-38', '59', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.46');
INSERT INTO public.europe_data_import VALUES (8444, '14/09/2020', '2020-37', '55', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (8445, '07/09/2020', '2020-36', '32', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (8446, '31/08/2020', '2020-35', '30', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (8447, '24/08/2020', '2020-34', '36', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (8448, '17/08/2020', '2020-33', '40', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.45');
INSERT INTO public.europe_data_import VALUES (8449, '10/08/2020', '2020-32', '73', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.7');
INSERT INTO public.europe_data_import VALUES (8450, '03/08/2020', '2020-31', '60', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (8451, '27/07/2020', '2020-30', '72', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.89');
INSERT INTO public.europe_data_import VALUES (8452, '20/07/2020', '2020-29', '76', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.16');
INSERT INTO public.europe_data_import VALUES (8453, '13/07/2020', '2020-28', '93', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.66');
INSERT INTO public.europe_data_import VALUES (8454, '06/07/2020', '2020-27', '115', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.75');
INSERT INTO public.europe_data_import VALUES (8455, '29/06/2020', '2020-26', '100', '5', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.3');
INSERT INTO public.europe_data_import VALUES (8456, '22/06/2020', '2020-25', '158', '4', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.58');
INSERT INTO public.europe_data_import VALUES (8457, '15/06/2020', '2020-24', '200', '3', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.94');
INSERT INTO public.europe_data_import VALUES (8458, '08/06/2020', '2020-23', '108', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.35');
INSERT INTO public.europe_data_import VALUES (8459, '01/06/2020', '2020-22', '154', '6', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.56');
INSERT INTO public.europe_data_import VALUES (8460, '25/05/2020', '2020-21', '202', '8', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8461, '18/05/2020', '2020-20', '198', '14', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.45');
INSERT INTO public.europe_data_import VALUES (8462, '11/05/2020', '2020-19', '150', '10', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.74');
INSERT INTO public.europe_data_import VALUES (8463, '04/05/2020', '2020-18', '64', '4', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (8464, '27/04/2020', '2020-17', '58', '4', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (8465, '20/04/2020', '2020-16', '25', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (8466, '13/04/2020', '2020-15', '4', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (8467, '06/04/2020', '2020-14', '6', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8468, '01/02/2021', '2021-04', '228', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '7.29');
INSERT INTO public.europe_data_import VALUES (8469, '25/01/2021', '2021-03', '195', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '6.91');
INSERT INTO public.europe_data_import VALUES (8470, '18/01/2021', '2021-02', '206', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '7.17');
INSERT INTO public.europe_data_import VALUES (8471, '11/01/2021', '2021-01', '210', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '6.6');
INSERT INTO public.europe_data_import VALUES (8472, '04/01/2021', '2020-53', '173', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '4.74');
INSERT INTO public.europe_data_import VALUES (8473, '28/12/2020', '2020-52', '102', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '3.51');
INSERT INTO public.europe_data_import VALUES (8474, '21/12/2020', '2020-51', '102', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '2.79');
INSERT INTO public.europe_data_import VALUES (8475, '14/12/2020', '2020-50', '60', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.84');
INSERT INTO public.europe_data_import VALUES (8476, '07/12/2020', '2020-49', '47', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.72');
INSERT INTO public.europe_data_import VALUES (8477, '30/11/2020', '2020-48', '53', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.62');
INSERT INTO public.europe_data_import VALUES (8478, '23/11/2020', '2020-47', '41', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.79');
INSERT INTO public.europe_data_import VALUES (8479, '16/11/2020', '2020-46', '63', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.72');
INSERT INTO public.europe_data_import VALUES (8480, '09/11/2020', '2020-45', '37', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.48');
INSERT INTO public.europe_data_import VALUES (8481, '02/11/2020', '2020-44', '49', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.86');
INSERT INTO public.europe_data_import VALUES (8482, '26/10/2020', '2020-43', '59', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.62');
INSERT INTO public.europe_data_import VALUES (8483, '19/10/2020', '2020-42', '35', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (8484, '12/10/2020', '2020-41', '64', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '3.03');
INSERT INTO public.europe_data_import VALUES (8485, '05/10/2020', '2020-40', '112', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '4.07');
INSERT INTO public.europe_data_import VALUES (8486, '28/09/2020', '2020-39', '124', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '5.07');
INSERT INTO public.europe_data_import VALUES (8487, '21/09/2020', '2020-38', '170', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '9.54');
INSERT INTO public.europe_data_import VALUES (8488, '14/09/2020', '2020-37', '384', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '10.94');
INSERT INTO public.europe_data_import VALUES (8489, '07/09/2020', '2020-36', '251', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '11.53');
INSERT INTO public.europe_data_import VALUES (8490, '31/08/2020', '2020-35', '418', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '17.64');
INSERT INTO public.europe_data_import VALUES (8491, '24/08/2020', '2020-34', '606', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '21.52');
INSERT INTO public.europe_data_import VALUES (8492, '17/08/2020', '2020-33', '643', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '50.34');
INSERT INTO public.europe_data_import VALUES (8493, '10/08/2020', '2020-32', '2279', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '81.58');
INSERT INTO public.europe_data_import VALUES (8494, '03/08/2020', '2020-31', '2456', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '84.64');
INSERT INTO public.europe_data_import VALUES (8495, '27/07/2020', '2020-30', '2457', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '75.94');
INSERT INTO public.europe_data_import VALUES (8496, '20/07/2020', '2020-29', '1951', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '55.96');
INSERT INTO public.europe_data_import VALUES (8497, '13/07/2020', '2020-28', '1297', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '43.11');
INSERT INTO public.europe_data_import VALUES (8498, '06/07/2020', '2020-27', '1205', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '44.26');
INSERT INTO public.europe_data_import VALUES (8499, '29/06/2020', '2020-26', '1364', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '49.19');
INSERT INTO public.europe_data_import VALUES (8500, '22/06/2020', '2020-25', '1491', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '72.1');
INSERT INTO public.europe_data_import VALUES (8501, '15/06/2020', '2020-24', '2694', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '98.55');
INSERT INTO public.europe_data_import VALUES (8502, '08/06/2020', '2020-23', '3026', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '108.44');
INSERT INTO public.europe_data_import VALUES (8503, '01/06/2020', '2020-22', '3268', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '117.95');
INSERT INTO public.europe_data_import VALUES (8504, '25/05/2020', '2020-21', '3578', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '142.65');
INSERT INTO public.europe_data_import VALUES (8505, '18/05/2020', '2020-20', '4702', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '169.41');
INSERT INTO public.europe_data_import VALUES (8506, '11/05/2020', '2020-19', '5131', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '167.32');
INSERT INTO public.europe_data_import VALUES (8507, '04/05/2020', '2020-18', '4581', '6', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '200.14');
INSERT INTO public.europe_data_import VALUES (8508, '27/04/2020', '2020-17', '7036', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '191.1');
INSERT INTO public.europe_data_import VALUES (8509, '20/04/2020', '2020-16', '4056', '3', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '90.95');
INSERT INTO public.europe_data_import VALUES (8510, '13/04/2020', '2020-15', '1223', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '29.08');
INSERT INTO public.europe_data_import VALUES (8511, '06/04/2020', '2020-14', '465', '3', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '14.71');
INSERT INTO public.europe_data_import VALUES (8512, '30/03/2020', '2020-13', '389', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '10.65');
INSERT INTO public.europe_data_import VALUES (8513, '23/03/2020', '2020-12', '229', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '5.25');
INSERT INTO public.europe_data_import VALUES (8514, '16/03/2020', '2020-11', '76', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '2.07');
INSERT INTO public.europe_data_import VALUES (8515, '09/03/2020', '2020-10', '44', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.05');
INSERT INTO public.europe_data_import VALUES (8516, '02/03/2020', '2020-09', '17', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.53');
INSERT INTO public.europe_data_import VALUES (8517, '24/02/2020', '2020-08', '14', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.79');
INSERT INTO public.europe_data_import VALUES (8518, '17/02/2020', '2020-07', '32', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (8519, '10/02/2020', '2020-06', '25', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.67');
INSERT INTO public.europe_data_import VALUES (8520, '03/02/2020', '2020-05', '14', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (8521, '27/01/2020', '2020-04', '4', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (8522, '20/01/2020', '2020-03', '0', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8523, '13/01/2020', '2020-02', '0', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8524, '06/01/2020', '2020-01', '0', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8525, '01/02/2021', '2021-04', '112', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '504.85');
INSERT INTO public.europe_data_import VALUES (8526, '25/01/2021', '2021-03', '102', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '431.72');
INSERT INTO public.europe_data_import VALUES (8527, '18/01/2021', '2021-02', '81', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '457.67');
INSERT INTO public.europe_data_import VALUES (8528, '11/01/2021', '2021-01', '113', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '386.89');
INSERT INTO public.europe_data_import VALUES (8529, '04/01/2021', '2020-53', '51', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '292.53');
INSERT INTO public.europe_data_import VALUES (8530, '28/12/2020', '2020-52', '73', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '382.17');
INSERT INTO public.europe_data_import VALUES (8531, '21/12/2020', '2020-51', '89', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '464.74');
INSERT INTO public.europe_data_import VALUES (8532, '14/12/2020', '2020-50', '108', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '431.72');
INSERT INTO public.europe_data_import VALUES (8533, '07/12/2020', '2020-49', '75', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '316.12');
INSERT INTO public.europe_data_import VALUES (8534, '30/11/2020', '2020-48', '59', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '313.76');
INSERT INTO public.europe_data_import VALUES (8535, '23/11/2020', '2020-47', '74', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '261.86');
INSERT INTO public.europe_data_import VALUES (8536, '16/11/2020', '2020-46', '37', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '240.63');
INSERT INTO public.europe_data_import VALUES (8537, '09/11/2020', '2020-45', '65', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '264.22');
INSERT INTO public.europe_data_import VALUES (8538, '02/11/2020', '2020-44', '47', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '184.01');
INSERT INTO public.europe_data_import VALUES (8539, '26/10/2020', '2020-43', '31', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '174.57');
INSERT INTO public.europe_data_import VALUES (8540, '19/10/2020', '2020-42', '43', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '174.57');
INSERT INTO public.europe_data_import VALUES (8541, '12/10/2020', '2020-41', '31', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '155.7');
INSERT INTO public.europe_data_import VALUES (8542, '05/10/2020', '2020-40', '35', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '224.11');
INSERT INTO public.europe_data_import VALUES (8543, '28/09/2020', '2020-39', '60', '2', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '224.11');
INSERT INTO public.europe_data_import VALUES (8544, '21/09/2020', '2020-38', '35', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '172.21');
INSERT INTO public.europe_data_import VALUES (8545, '14/09/2020', '2020-37', '38', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '202.88');
INSERT INTO public.europe_data_import VALUES (8546, '07/09/2020', '2020-36', '48', '2', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '271.3');
INSERT INTO public.europe_data_import VALUES (8547, '31/08/2020', '2020-35', '67', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '344.43');
INSERT INTO public.europe_data_import VALUES (8548, '24/08/2020', '2020-34', '79', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '488.33');
INSERT INTO public.europe_data_import VALUES (8549, '17/08/2020', '2020-33', '128', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '403.41');
INSERT INTO public.europe_data_import VALUES (8550, '10/08/2020', '2020-32', '43', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '224.11');
INSERT INTO public.europe_data_import VALUES (8551, '03/08/2020', '2020-31', '52', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '158.06');
INSERT INTO public.europe_data_import VALUES (8552, '27/07/2020', '2020-30', '15', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '37.75');
INSERT INTO public.europe_data_import VALUES (8553, '20/07/2020', '2020-29', '1', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8554, '13/07/2020', '2020-28', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8555, '06/07/2020', '2020-27', '1', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8556, '29/06/2020', '2020-26', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8557, '22/06/2020', '2020-25', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8558, '15/06/2020', '2020-24', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8559, '08/06/2020', '2020-23', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8560, '01/06/2020', '2020-22', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8561, '25/05/2020', '2020-21', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8562, '18/05/2020', '2020-20', '1', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8563, '11/05/2020', '2020-19', '0', '2', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '4.72');
INSERT INTO public.europe_data_import VALUES (8564, '04/05/2020', '2020-18', '2', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '21.23');
INSERT INTO public.europe_data_import VALUES (8565, '27/04/2020', '2020-17', '7', '3', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '56.62');
INSERT INTO public.europe_data_import VALUES (8566, '20/04/2020', '2020-16', '17', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '99.08');
INSERT INTO public.europe_data_import VALUES (8567, '13/04/2020', '2020-15', '25', '5', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '110.88');
INSERT INTO public.europe_data_import VALUES (8568, '06/04/2020', '2020-14', '22', '4', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '58.98');
INSERT INTO public.europe_data_import VALUES (8569, '30/03/2020', '2020-13', '3', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '');
INSERT INTO public.europe_data_import VALUES (8570, '01/02/2021', '2021-04', '12886', '574', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '468.37');
INSERT INTO public.europe_data_import VALUES (8571, '25/01/2021', '2021-03', '12642', '542', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '512.95');
INSERT INTO public.europe_data_import VALUES (8572, '18/01/2021', '2021-02', '15316', '519', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '665.75');
INSERT INTO public.europe_data_import VALUES (8573, '11/01/2021', '2021-01', '20970', '486', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '751.81');
INSERT INTO public.europe_data_import VALUES (8574, '04/01/2021', '2020-53', '20007', '642', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '674.5');
INSERT INTO public.europe_data_import VALUES (8575, '28/12/2020', '2020-52', '16756', '324', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '644.13');
INSERT INTO public.europe_data_import VALUES (8576, '21/12/2020', '2020-51', '18352', '380', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '634.91');
INSERT INTO public.europe_data_import VALUES (8577, '14/12/2020', '2020-50', '16253', '179', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '499.98');
INSERT INTO public.europe_data_import VALUES (8578, '07/12/2020', '2020-49', '10998', '180', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '375.93');
INSERT INTO public.europe_data_import VALUES (8579, '30/11/2020', '2020-48', '9492', '145', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '347.97');
INSERT INTO public.europe_data_import VALUES (8580, '23/11/2020', '2020-47', '9474', '161', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '380.63');
INSERT INTO public.europe_data_import VALUES (8581, '16/11/2020', '2020-46', '11272', '159', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '492.09');
INSERT INTO public.europe_data_import VALUES (8582, '09/11/2020', '2020-45', '15549', '132', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '580.73');
INSERT INTO public.europe_data_import VALUES (8583, '02/11/2020', '2020-44', '16103', '60', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '552.45');
INSERT INTO public.europe_data_import VALUES (8584, '26/10/2020', '2020-43', '14008', '71', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '440.19');
INSERT INTO public.europe_data_import VALUES (8585, '19/10/2020', '2020-42', '9984', '27', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '306.32');
INSERT INTO public.europe_data_import VALUES (8586, '12/10/2020', '2020-41', '6712', '6', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '197.65');
INSERT INTO public.europe_data_import VALUES (8587, '05/10/2020', '2020-40', '4061', '11', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '118.56');
INSERT INTO public.europe_data_import VALUES (8588, '28/09/2020', '2020-39', '2401', '5', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '65.06');
INSERT INTO public.europe_data_import VALUES (8589, '21/09/2020', '2020-38', '1145', '1', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '37.85');
INSERT INTO public.europe_data_import VALUES (8590, '14/09/2020', '2020-37', '918', '1', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '30.38');
INSERT INTO public.europe_data_import VALUES (8591, '07/09/2020', '2020-36', '738', '4', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '23.08');
INSERT INTO public.europe_data_import VALUES (8592, '31/08/2020', '2020-35', '520', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '17.87');
INSERT INTO public.europe_data_import VALUES (8593, '24/08/2020', '2020-34', '454', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '13.94');
INSERT INTO public.europe_data_import VALUES (8594, '17/08/2020', '2020-33', '306', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '10.24');
INSERT INTO public.europe_data_import VALUES (8595, '10/08/2020', '2020-32', '252', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '7.65');
INSERT INTO public.europe_data_import VALUES (8596, '03/08/2020', '2020-31', '165', '1', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '6.7');
INSERT INTO public.europe_data_import VALUES (8597, '27/07/2020', '2020-30', '200', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '5.1');
INSERT INTO public.europe_data_import VALUES (8598, '20/07/2020', '2020-29', '78', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (8599, '13/07/2020', '2020-28', '137', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '4.35');
INSERT INTO public.europe_data_import VALUES (8600, '06/07/2020', '2020-27', '100', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '3.25');
INSERT INTO public.europe_data_import VALUES (8601, '29/06/2020', '2020-26', '77', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '2.13');
INSERT INTO public.europe_data_import VALUES (8602, '22/06/2020', '2020-25', '39', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.08');
INSERT INTO public.europe_data_import VALUES (8603, '15/06/2020', '2020-24', '20', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.48');
INSERT INTO public.europe_data_import VALUES (8604, '08/06/2020', '2020-23', '6', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.35');
INSERT INTO public.europe_data_import VALUES (8605, '01/06/2020', '2020-22', '13', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.51');
INSERT INTO public.europe_data_import VALUES (8606, '25/05/2020', '2020-21', '15', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.95');
INSERT INTO public.europe_data_import VALUES (8607, '18/05/2020', '2020-20', '37', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.58');
INSERT INTO public.europe_data_import VALUES (8608, '11/05/2020', '2020-19', '49', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.43');
INSERT INTO public.europe_data_import VALUES (8609, '04/05/2020', '2020-18', '29', '6', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '4.53');
INSERT INTO public.europe_data_import VALUES (8610, '27/04/2020', '2020-17', '218', '6', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '11.69');
INSERT INTO public.europe_data_import VALUES (8611, '20/04/2020', '2020-16', '419', '10', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '12.4');
INSERT INTO public.europe_data_import VALUES (8612, '13/04/2020', '2020-15', '257', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '7.45');
INSERT INTO public.europe_data_import VALUES (8613, '06/04/2020', '2020-14', '149', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '5.5');
INSERT INTO public.europe_data_import VALUES (8614, '30/03/2020', '2020-13', '151', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '5.05');
INSERT INTO public.europe_data_import VALUES (8615, '23/03/2020', '2020-12', '124', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '3.3');
INSERT INTO public.europe_data_import VALUES (8616, '16/03/2020', '2020-11', '56', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.12');
INSERT INTO public.europe_data_import VALUES (8617, '09/03/2020', '2020-10', '5', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8618, '01/02/2021', '2021-04', '8334', '171', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '818.83');
INSERT INTO public.europe_data_import VALUES (8619, '25/01/2021', '2021-03', '8705', '210', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '885.48');
INSERT INTO public.europe_data_import VALUES (8620, '18/01/2021', '2021-02', '9721', '224', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1132.97');
INSERT INTO public.europe_data_import VALUES (8621, '11/01/2021', '2021-01', '13855', '256', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1171.89');
INSERT INTO public.europe_data_import VALUES (8622, '04/01/2021', '2020-53', '10531', '307', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '959.15');
INSERT INTO public.europe_data_import VALUES (8623, '28/12/2020', '2020-52', '9428', '216', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '913.69');
INSERT INTO public.europe_data_import VALUES (8624, '21/12/2020', '2020-51', '9585', '156', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '965.64');
INSERT INTO public.europe_data_import VALUES (8625, '14/12/2020', '2020-50', '10509', '954', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1005.96');
INSERT INTO public.europe_data_import VALUES (8626, '07/12/2020', '2020-49', '10424', '331', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '985.0');
INSERT INTO public.europe_data_import VALUES (8627, '30/11/2020', '2020-48', '10073', '264', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '977.41');
INSERT INTO public.europe_data_import VALUES (8628, '23/11/2020', '2020-47', '10266', '152', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '968.18');
INSERT INTO public.europe_data_import VALUES (8629, '16/11/2020', '2020-46', '9881', '129', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '931.95');
INSERT INTO public.europe_data_import VALUES (8630, '09/11/2020', '2020-45', '9512', '146', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1067.37');
INSERT INTO public.europe_data_import VALUES (8631, '02/11/2020', '2020-44', '12699', '53', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1081.5');
INSERT INTO public.europe_data_import VALUES (8632, '26/10/2020', '2020-43', '9806', '22', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '686.48');
INSERT INTO public.europe_data_import VALUES (8633, '19/10/2020', '2020-42', '4479', '19', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '319.38');
INSERT INTO public.europe_data_import VALUES (8634, '12/10/2020', '2020-41', '2167', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '159.31');
INSERT INTO public.europe_data_import VALUES (8635, '05/10/2020', '2020-40', '1148', '4', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '99.86');
INSERT INTO public.europe_data_import VALUES (8636, '28/09/2020', '2020-39', '930', '3', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '79.2');
INSERT INTO public.europe_data_import VALUES (8637, '21/09/2020', '2020-38', '718', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '59.88');
INSERT INTO public.europe_data_import VALUES (8638, '14/09/2020', '2020-37', '528', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '40.22');
INSERT INTO public.europe_data_import VALUES (8639, '07/09/2020', '2020-36', '309', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '25.13');
INSERT INTO public.europe_data_import VALUES (8640, '31/08/2020', '2020-35', '214', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '21.58');
INSERT INTO public.europe_data_import VALUES (8641, '24/08/2020', '2020-34', '235', '3', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '19.32');
INSERT INTO public.europe_data_import VALUES (8642, '17/08/2020', '2020-33', '167', '4', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.34');
INSERT INTO public.europe_data_import VALUES (8643, '10/08/2020', '2020-32', '69', '3', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '8.03');
INSERT INTO public.europe_data_import VALUES (8644, '03/08/2020', '2020-31', '98', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.25');
INSERT INTO public.europe_data_import VALUES (8645, '27/07/2020', '2020-30', '136', '4', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.58');
INSERT INTO public.europe_data_import VALUES (8646, '20/07/2020', '2020-29', '105', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.82');
INSERT INTO public.europe_data_import VALUES (8647, '13/07/2020', '2020-28', '141', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '12.49');
INSERT INTO public.europe_data_import VALUES (8648, '06/07/2020', '2020-27', '119', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '8.65');
INSERT INTO public.europe_data_import VALUES (8649, '29/06/2020', '2020-26', '61', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '4.13');
INSERT INTO public.europe_data_import VALUES (8650, '22/06/2020', '2020-25', '25', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1.68');
INSERT INTO public.europe_data_import VALUES (8651, '15/06/2020', '2020-24', '10', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1.06');
INSERT INTO public.europe_data_import VALUES (8652, '08/06/2020', '2020-23', '12', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '0.77');
INSERT INTO public.europe_data_import VALUES (8653, '01/06/2020', '2020-22', '4', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '0.34');
INSERT INTO public.europe_data_import VALUES (8654, '25/05/2020', '2020-21', '3', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '0.43');
INSERT INTO public.europe_data_import VALUES (8655, '18/05/2020', '2020-20', '6', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1.3');
INSERT INTO public.europe_data_import VALUES (8656, '11/05/2020', '2020-19', '21', '6', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '2.55');
INSERT INTO public.europe_data_import VALUES (8657, '04/05/2020', '2020-18', '32', '14', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '5.24');
INSERT INTO public.europe_data_import VALUES (8658, '27/04/2020', '2020-17', '77', '8', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '9.71');
INSERT INTO public.europe_data_import VALUES (8659, '20/04/2020', '2020-16', '125', '21', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '16.0');
INSERT INTO public.europe_data_import VALUES (8660, '13/04/2020', '2020-15', '208', '25', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '22.83');
INSERT INTO public.europe_data_import VALUES (8661, '06/04/2020', '2020-14', '267', '17', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '28.02');
INSERT INTO public.europe_data_import VALUES (8662, '30/03/2020', '2020-13', '316', '10', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '24.56');
INSERT INTO public.europe_data_import VALUES (8663, '23/03/2020', '2020-12', '195', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '19.13');
INSERT INTO public.europe_data_import VALUES (8664, '16/03/2020', '2020-11', '203', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '10.52');
INSERT INTO public.europe_data_import VALUES (8665, '09/03/2020', '2020-10', '16', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8666, '01/02/2021', '2021-04', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8667, '25/01/2021', '2021-03', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8668, '18/01/2021', '2021-02', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8669, '11/01/2021', '2021-01', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8670, '04/01/2021', '2020-53', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8671, '28/12/2020', '2020-52', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8672, '21/12/2020', '2020-51', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8673, '14/12/2020', '2020-50', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8674, '07/12/2020', '2020-49', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (8675, '30/11/2020', '2020-48', '1', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (8676, '23/11/2020', '2020-47', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.45');
INSERT INTO public.europe_data_import VALUES (8677, '16/11/2020', '2020-46', '3', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '1.19');
INSERT INTO public.europe_data_import VALUES (8678, '09/11/2020', '2020-45', '5', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '1.34');
INSERT INTO public.europe_data_import VALUES (8679, '02/11/2020', '2020-44', '4', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.75');
INSERT INTO public.europe_data_import VALUES (8680, '26/10/2020', '2020-43', '1', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (8681, '19/10/2020', '2020-42', '3', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (8682, '01/02/2021', '2021-04', '30', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (8683, '25/01/2021', '2021-03', '10', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (8684, '18/01/2021', '2021-02', '18', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (8685, '11/01/2021', '2021-01', '12', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (8686, '04/01/2021', '2020-53', '24', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (8687, '28/12/2020', '2020-52', '28', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (8688, '21/12/2020', '2020-51', '83', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (8689, '14/12/2020', '2020-50', '54', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (8690, '07/12/2020', '2020-49', '80', '8', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (8691, '30/11/2020', '2020-48', '0', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (8692, '23/11/2020', '2020-47', '144', '6', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.4');
INSERT INTO public.europe_data_import VALUES (8693, '16/11/2020', '2020-46', '72', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8694, '09/11/2020', '2020-45', '288', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (8695, '02/11/2020', '2020-44', '0', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (8696, '26/10/2020', '2020-43', '77', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (8697, '19/10/2020', '2020-42', '0', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (8698, '12/10/2020', '2020-41', '119', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.79');
INSERT INTO public.europe_data_import VALUES (8699, '05/10/2020', '2020-40', '157', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.96');
INSERT INTO public.europe_data_import VALUES (8700, '28/09/2020', '2020-39', '146', '1', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.29');
INSERT INTO public.europe_data_import VALUES (8701, '21/09/2020', '2020-38', '53', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (8702, '14/09/2020', '2020-37', '27', '1', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (8703, '07/09/2020', '2020-36', '52', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (8704, '31/08/2020', '2020-35', '41', '4', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (8705, '24/08/2020', '2020-34', '13', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (8706, '17/08/2020', '2020-33', '29', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (8707, '10/08/2020', '2020-32', '15', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (8708, '03/08/2020', '2020-31', '34', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (8709, '27/07/2020', '2020-30', '59', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (8710, '20/07/2020', '2020-29', '60', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (8711, '13/07/2020', '2020-28', '62', '1', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.07');
INSERT INTO public.europe_data_import VALUES (8712, '06/07/2020', '2020-27', '103', '2', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (8713, '29/06/2020', '2020-26', '115', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (8714, '22/06/2020', '2020-25', '176', '2', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '2.88');
INSERT INTO public.europe_data_import VALUES (8715, '15/06/2020', '2020-24', '269', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.06');
INSERT INTO public.europe_data_import VALUES (8716, '08/06/2020', '2020-23', '358', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.79');
INSERT INTO public.europe_data_import VALUES (8717, '01/06/2020', '2020-22', '382', '17', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '3.59');
INSERT INTO public.europe_data_import VALUES (8718, '25/05/2020', '2020-21', '173', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '3.5');
INSERT INTO public.europe_data_import VALUES (8719, '18/05/2020', '2020-20', '367', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.53');
INSERT INTO public.europe_data_import VALUES (8720, '11/05/2020', '2020-19', '332', '19', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.0');
INSERT INTO public.europe_data_import VALUES (8721, '04/05/2020', '2020-18', '286', '9', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '3.61');
INSERT INTO public.europe_data_import VALUES (8722, '27/04/2020', '2020-17', '272', '16', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '2.66');
INSERT INTO public.europe_data_import VALUES (8723, '20/04/2020', '2020-16', '139', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (8724, '13/04/2020', '2020-15', '18', '2', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (8725, '06/04/2020', '2020-14', '4', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (8726, '30/03/2020', '2020-13', '2', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (8727, '23/03/2020', '2020-12', '1', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8728, '01/02/2021', '2021-04', '43323', '3525', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '202.16');
INSERT INTO public.europe_data_import VALUES (8729, '25/01/2021', '2021-03', '75060', '3769', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '309.76');
INSERT INTO public.europe_data_import VALUES (8730, '18/01/2021', '2021-02', '106329', '3942', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '405.03');
INSERT INTO public.europe_data_import VALUES (8731, '11/01/2021', '2021-01', '130849', '3586', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '375.23');
INSERT INTO public.europe_data_import VALUES (8732, '04/01/2021', '2020-53', '88877', '2506', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '305.38');
INSERT INTO public.europe_data_import VALUES (8733, '28/12/2020', '2020-52', '89949', '2380', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '257.7');
INSERT INTO public.europe_data_import VALUES (8734, '21/12/2020', '2020-51', '60958', '1415', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '183.33');
INSERT INTO public.europe_data_import VALUES (8735, '14/12/2020', '2020-50', '46399', '1070', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '125.11');
INSERT INTO public.europe_data_import VALUES (8736, '07/12/2020', '2020-49', '26863', '729', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '80.07');
INSERT INTO public.europe_data_import VALUES (8737, '30/11/2020', '2020-48', '20023', '574', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '62.64');
INSERT INTO public.europe_data_import VALUES (8738, '23/11/2020', '2020-47', '16655', '662', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '51.92');
INSERT INTO public.europe_data_import VALUES (8739, '16/11/2020', '2020-46', '13746', '432', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '41.33');
INSERT INTO public.europe_data_import VALUES (8740, '09/11/2020', '2020-45', '10455', '398', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '36.56');
INSERT INTO public.europe_data_import VALUES (8741, '02/11/2020', '2020-44', '10955', '443', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '39.33');
INSERT INTO public.europe_data_import VALUES (8742, '26/10/2020', '2020-43', '12075', '497', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '39.96');
INSERT INTO public.europe_data_import VALUES (8743, '19/10/2020', '2020-42', '11322', '691', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '38.43');
INSERT INTO public.europe_data_import VALUES (8744, '12/10/2020', '2020-41', '11182', '804', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '37.07');
INSERT INTO public.europe_data_import VALUES (8745, '05/10/2020', '2020-40', '10523', '578', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '34.29');
INSERT INTO public.europe_data_import VALUES (8746, '28/09/2020', '2020-39', '9555', '445', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '35.82');
INSERT INTO public.europe_data_import VALUES (8747, '21/09/2020', '2020-38', '11418', '506', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '38.75');
INSERT INTO public.europe_data_import VALUES (8748, '14/09/2020', '2020-37', '11276', '558', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '42.24');
INSERT INTO public.europe_data_import VALUES (8749, '07/09/2020', '2020-36', '13461', '861', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '49.09');
INSERT INTO public.europe_data_import VALUES (8750, '31/08/2020', '2020-35', '15283', '969', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '64.4');
INSERT INTO public.europe_data_import VALUES (8751, '24/08/2020', '2020-34', '22428', '1220', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '85.24');
INSERT INTO public.europe_data_import VALUES (8752, '17/08/2020', '2020-33', '27487', '1431', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '129.55');
INSERT INTO public.europe_data_import VALUES (8753, '10/08/2020', '2020-32', '48373', '2042', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '195.4');
INSERT INTO public.europe_data_import VALUES (8754, '03/08/2020', '2020-31', '66052', '1597', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '251.3');
INSERT INTO public.europe_data_import VALUES (8755, '27/07/2020', '2020-30', '81105', '1736', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '288.93');
INSERT INTO public.europe_data_import VALUES (8756, '20/07/2020', '2020-29', '88086', '954', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '286.17');
INSERT INTO public.europe_data_import VALUES (8757, '13/07/2020', '2020-28', '79492', '880', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '235.85');
INSERT INTO public.europe_data_import VALUES (8758, '06/07/2020', '2020-27', '58616', '743', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '169.83');
INSERT INTO public.europe_data_import VALUES (8759, '29/06/2020', '2020-26', '40832', '526', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '116.29');
INSERT INTO public.europe_data_import VALUES (8760, '22/06/2020', '2020-25', '27264', '450', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '83.71');
INSERT INTO public.europe_data_import VALUES (8761, '15/06/2020', '2020-24', '21753', '482', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '63.79');
INSERT INTO public.europe_data_import VALUES (8762, '08/06/2020', '2020-23', '15602', '315', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '43.89');
INSERT INTO public.europe_data_import VALUES (8763, '01/06/2020', '2020-22', '10100', '254', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '29.32');
INSERT INTO public.europe_data_import VALUES (8764, '25/05/2020', '2020-21', '7068', '165', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '21.46');
INSERT INTO public.europe_data_import VALUES (8765, '18/05/2020', '2020-20', '5500', '70', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '14.91');
INSERT INTO public.europe_data_import VALUES (8766, '11/05/2020', '2020-19', '3232', '63', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '9.34');
INSERT INTO public.europe_data_import VALUES (8767, '04/05/2020', '2020-18', '2237', '44', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '6.19');
INSERT INTO public.europe_data_import VALUES (8768, '27/04/2020', '2020-17', '1388', '33', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '4.05');
INSERT INTO public.europe_data_import VALUES (8769, '20/04/2020', '2020-16', '985', '29', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '2.57');
INSERT INTO public.europe_data_import VALUES (8770, '13/04/2020', '2020-15', '518', '14', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (8771, '06/04/2020', '2020-14', '375', '9', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (8772, '30/03/2020', '2020-13', '1006', '2', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '2.1');
INSERT INTO public.europe_data_import VALUES (8773, '23/03/2020', '2020-12', '223', '0', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (8774, '16/03/2020', '2020-11', '48', '0', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (8775, '09/03/2020', '2020-10', '3', '0', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8776, '01/02/2021', '2021-04', '2987', '65', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '11.28');
INSERT INTO public.europe_data_import VALUES (8777, '25/01/2021', '2021-03', '2792', '96', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '12.51');
INSERT INTO public.europe_data_import VALUES (8778, '18/01/2021', '2021-02', '3615', '124', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '16.53');
INSERT INTO public.europe_data_import VALUES (8779, '11/01/2021', '2021-01', '4850', '159', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '22.32');
INSERT INTO public.europe_data_import VALUES (8780, '04/01/2021', '2020-53', '6584', '162', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '26.69');
INSERT INTO public.europe_data_import VALUES (8781, '28/12/2020', '2020-52', '7089', '121', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '27.71');
INSERT INTO public.europe_data_import VALUES (8782, '21/12/2020', '2020-51', '7107', '111', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '24.27');
INSERT INTO public.europe_data_import VALUES (8783, '14/12/2020', '2020-50', '5323', '38', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '18.12');
INSERT INTO public.europe_data_import VALUES (8784, '07/12/2020', '2020-49', '3960', '23', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '13.97');
INSERT INTO public.europe_data_import VALUES (8785, '30/11/2020', '2020-48', '3197', '17', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '10.6');
INSERT INTO public.europe_data_import VALUES (8786, '23/11/2020', '2020-47', '2235', '15', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '6.74');
INSERT INTO public.europe_data_import VALUES (8787, '16/11/2020', '2020-46', '1216', '14', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.98');
INSERT INTO public.europe_data_import VALUES (8788, '09/11/2020', '2020-45', '821', '12', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.12');
INSERT INTO public.europe_data_import VALUES (8789, '02/11/2020', '2020-44', '777', '11', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.84');
INSERT INTO public.europe_data_import VALUES (8790, '26/10/2020', '2020-43', '680', '13', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.44');
INSERT INTO public.europe_data_import VALUES (8791, '19/10/2020', '2020-42', '572', '11', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.17');
INSERT INTO public.europe_data_import VALUES (8792, '12/10/2020', '2020-41', '539', '11', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.03');
INSERT INTO public.europe_data_import VALUES (8793, '05/10/2020', '2020-40', '503', '16', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.18');
INSERT INTO public.europe_data_import VALUES (8794, '28/09/2020', '2020-39', '616', '21', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.69');
INSERT INTO public.europe_data_import VALUES (8795, '21/09/2020', '2020-38', '760', '22', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.41');
INSERT INTO public.europe_data_import VALUES (8796, '14/09/2020', '2020-37', '989', '27', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '4.56');
INSERT INTO public.europe_data_import VALUES (8797, '07/09/2020', '2020-36', '1349', '12', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '7.09');
INSERT INTO public.europe_data_import VALUES (8798, '31/08/2020', '2020-35', '2282', '15', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '8.65');
INSERT INTO public.europe_data_import VALUES (8799, '24/08/2020', '2020-34', '2150', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '5.93');
INSERT INTO public.europe_data_import VALUES (8800, '17/08/2020', '2020-33', '889', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.2');
INSERT INTO public.europe_data_import VALUES (8801, '10/08/2020', '2020-32', '237', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.88');
INSERT INTO public.europe_data_import VALUES (8802, '03/08/2020', '2020-31', '214', '2', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.21');
INSERT INTO public.europe_data_import VALUES (8803, '27/07/2020', '2020-30', '404', '3', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.36');
INSERT INTO public.europe_data_import VALUES (8804, '20/07/2020', '2020-29', '292', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.33');
INSERT INTO public.europe_data_import VALUES (8805, '13/07/2020', '2020-28', '388', '6', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.41');
INSERT INTO public.europe_data_import VALUES (8806, '06/07/2020', '2020-27', '334', '1', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.27');
INSERT INTO public.europe_data_import VALUES (8807, '29/06/2020', '2020-26', '319', '2', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.24');
INSERT INTO public.europe_data_import VALUES (8808, '22/06/2020', '2020-25', '317', '3', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.22');
INSERT INTO public.europe_data_import VALUES (8809, '15/06/2020', '2020-24', '307', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.21');
INSERT INTO public.europe_data_import VALUES (8810, '08/06/2020', '2020-23', '311', '2', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.19');
INSERT INTO public.europe_data_import VALUES (8811, '01/06/2020', '2020-22', '297', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.86');
INSERT INTO public.europe_data_import VALUES (8812, '25/05/2020', '2020-21', '141', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (8813, '18/05/2020', '2020-20', '156', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.52');
INSERT INTO public.europe_data_import VALUES (8814, '11/05/2020', '2020-19', '108', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.33');
INSERT INTO public.europe_data_import VALUES (8815, '04/05/2020', '2020-18', '63', '9', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (8816, '27/04/2020', '2020-17', '64', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.39');
INSERT INTO public.europe_data_import VALUES (8817, '20/04/2020', '2020-16', '137', '19', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (8818, '13/04/2020', '2020-15', '253', '31', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (8819, '06/04/2020', '2020-14', '623', '28', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.58');
INSERT INTO public.europe_data_import VALUES (8820, '30/03/2020', '2020-13', '700', '45', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.78');
INSERT INTO public.europe_data_import VALUES (8821, '23/03/2020', '2020-12', '725', '38', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.08');
INSERT INTO public.europe_data_import VALUES (8822, '16/03/2020', '2020-11', '854', '24', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '7.86');
INSERT INTO public.europe_data_import VALUES (8823, '09/03/2020', '2020-10', '3170', '29', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '12.92');
INSERT INTO public.europe_data_import VALUES (8824, '02/03/2020', '2020-09', '3450', '15', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '8.16');
INSERT INTO public.europe_data_import VALUES (8825, '24/02/2020', '2020-08', '732', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.43');
INSERT INTO public.europe_data_import VALUES (8826, '17/02/2020', '2020-07', '3', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (8827, '10/02/2020', '2020-06', '12', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (8828, '03/02/2020', '2020-05', '11', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (8829, '27/01/2020', '2020-04', '3', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (8830, '20/01/2020', '2020-03', '1', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (8831, '13/01/2020', '2020-02', '0', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8832, '06/01/2020', '2020-01', '0', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8833, '01/02/2021', '2021-04', '249', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '3.32');
INSERT INTO public.europe_data_import VALUES (8834, '25/01/2021', '2021-03', '118', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (8835, '18/01/2021', '2021-02', '8', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (8836, '11/01/2021', '2021-01', '73', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (8837, '04/01/2021', '2020-53', '98', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (8838, '28/12/2020', '2020-52', '263', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.42');
INSERT INTO public.europe_data_import VALUES (8839, '21/12/2020', '2020-51', '5', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (8840, '14/12/2020', '2020-50', '42', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (8841, '07/12/2020', '2020-49', '72', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.21');
INSERT INTO public.europe_data_import VALUES (8842, '30/11/2020', '2020-48', '62', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (8843, '23/11/2020', '2020-47', '44', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (8844, '16/11/2020', '2020-46', '48', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (8845, '09/11/2020', '2020-45', '29', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (8846, '02/11/2020', '2020-44', '43', '3', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (8847, '26/10/2020', '2020-43', '41', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (8848, '19/10/2020', '2020-42', '65', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (8849, '12/10/2020', '2020-41', '51', '5', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (8850, '05/10/2020', '2020-40', '40', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (8851, '28/09/2020', '2020-39', '44', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (8852, '21/09/2020', '2020-38', '64', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (8853, '14/09/2020', '2020-37', '34', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (8854, '07/09/2020', '2020-36', '25', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (8855, '31/08/2020', '2020-35', '20', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (8856, '24/08/2020', '2020-34', '10', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (8857, '17/08/2020', '2020-33', '19', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (8858, '10/08/2020', '2020-32', '41', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (8859, '03/08/2020', '2020-31', '167', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.07');
INSERT INTO public.europe_data_import VALUES (8860, '27/07/2020', '2020-30', '62', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (8861, '20/07/2020', '2020-29', '61', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.48');
INSERT INTO public.europe_data_import VALUES (8862, '13/07/2020', '2020-28', '103', '3', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (8863, '06/07/2020', '2020-27', '47', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (8864, '29/06/2020', '2020-26', '107', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (8865, '22/06/2020', '2020-25', '189', '7', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '5.11');
INSERT INTO public.europe_data_import VALUES (8866, '15/06/2020', '2020-24', '376', '13', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '6.32');
INSERT INTO public.europe_data_import VALUES (8867, '08/06/2020', '2020-23', '323', '4', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '6.82');
INSERT INTO public.europe_data_import VALUES (8868, '01/06/2020', '2020-22', '431', '4', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '6.44');
INSERT INTO public.europe_data_import VALUES (8869, '25/05/2020', '2020-21', '281', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '3.68');
INSERT INTO public.europe_data_import VALUES (8870, '18/05/2020', '2020-20', '126', '4', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.13');
INSERT INTO public.europe_data_import VALUES (8871, '11/05/2020', '2020-19', '110', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (8872, '04/05/2020', '2020-18', '40', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (8873, '27/04/2020', '2020-17', '2', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (8874, '20/04/2020', '2020-16', '0', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (8875, '13/04/2020', '2020-15', '3', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (8876, '06/04/2020', '2020-14', '1', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8877, '01/02/2021', '2021-04', '229423', '2873', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '1036.18');
INSERT INTO public.europe_data_import VALUES (8878, '25/01/2021', '2021-03', '256931', '2439', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '1026.05');
INSERT INTO public.europe_data_import VALUES (8879, '18/01/2021', '2021-02', '224669', '1494', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '804.5');
INSERT INTO public.europe_data_import VALUES (8880, '11/01/2021', '2021-01', '152938', '1197', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '495.07');
INSERT INTO public.europe_data_import VALUES (8881, '04/01/2021', '2020-53', '79431', '956', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '297.41');
INSERT INTO public.europe_data_import VALUES (8882, '28/12/2020', '2020-52', '60164', '862', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '271.7');
INSERT INTO public.europe_data_import VALUES (8883, '21/12/2020', '2020-51', '67365', '1247', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '249.1');
INSERT INTO public.europe_data_import VALUES (8884, '14/12/2020', '2020-50', '49556', '1367', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '220.93');
INSERT INTO public.europe_data_import VALUES (8885, '07/12/2020', '2020-49', '54141', '1577', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '255.05');
INSERT INTO public.europe_data_import VALUES (8886, '30/11/2020', '2020-48', '65571', '1938', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '322.4');
INSERT INTO public.europe_data_import VALUES (8887, '23/11/2020', '2020-47', '85752', '1878', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '429.08');
INSERT INTO public.europe_data_import VALUES (8888, '16/11/2020', '2020-46', '115646', '1908', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '545.77');
INSERT INTO public.europe_data_import VALUES (8889, '09/11/2020', '2020-45', '140521', '3088', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '602.72');
INSERT INTO public.europe_data_import VALUES (8890, '02/11/2020', '2020-44', '142377', '1226', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '567.24');
INSERT INTO public.europe_data_import VALUES (8891, '26/10/2020', '2020-43', '123871', '1039', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '446.03');
INSERT INTO public.europe_data_import VALUES (8892, '19/10/2020', '2020-42', '85481', '868', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '343.09');
INSERT INTO public.europe_data_import VALUES (8893, '12/10/2020', '2020-41', '75556', '899', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '299.77');
INSERT INTO public.europe_data_import VALUES (8894, '05/10/2020', '2020-40', '65146', '814', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '302.41');
INSERT INTO public.europe_data_import VALUES (8895, '28/09/2020', '2020-39', '76798', '748', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '329.24');
INSERT INTO public.europe_data_import VALUES (8896, '21/09/2020', '2020-38', '77738', '815', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '310.88');
INSERT INTO public.europe_data_import VALUES (8897, '14/09/2020', '2020-37', '68181', '332', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '278.82');
INSERT INTO public.europe_data_import VALUES (8898, '07/09/2020', '2020-36', '62691', '422', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '255.9');
INSERT INTO public.europe_data_import VALUES (8899, '31/08/2020', '2020-35', '57422', '222', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '221.1');
INSERT INTO public.europe_data_import VALUES (8900, '24/08/2020', '2020-34', '46354', '226', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '175.67');
INSERT INTO public.europe_data_import VALUES (8901, '17/08/2020', '2020-33', '36102', '70', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '132.15');
INSERT INTO public.europe_data_import VALUES (8902, '10/08/2020', '2020-32', '25926', '104', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '94.16');
INSERT INTO public.europe_data_import VALUES (8903, '03/08/2020', '2020-31', '18272', '38', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '68.64');
INSERT INTO public.europe_data_import VALUES (8904, '27/07/2020', '2020-30', '13946', '12', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '48.64');
INSERT INTO public.europe_data_import VALUES (8905, '20/07/2020', '2020-29', '8883', '16', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '27.8');
INSERT INTO public.europe_data_import VALUES (8906, '13/07/2020', '2020-28', '4164', '18', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '14.88');
INSERT INTO public.europe_data_import VALUES (8907, '06/07/2020', '2020-27', '2819', '42', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '11.26');
INSERT INTO public.europe_data_import VALUES (8908, '29/06/2020', '2020-26', '2466', '22', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '10.36');
INSERT INTO public.europe_data_import VALUES (8909, '22/06/2020', '2020-25', '2395', '1188', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '10.2');
INSERT INTO public.europe_data_import VALUES (8910, '15/06/2020', '2020-24', '2392', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '9.53');
INSERT INTO public.europe_data_import VALUES (8911, '08/06/2020', '2020-23', '2079', '9', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '13.46');
INSERT INTO public.europe_data_import VALUES (8912, '01/06/2020', '2020-22', '4238', '293', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '17.11');
INSERT INTO public.europe_data_import VALUES (8913, '25/05/2020', '2020-21', '3794', '-875', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '16.26');
INSERT INTO public.europe_data_import VALUES (8914, '18/05/2020', '2020-20', '3836', '965', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '26.42');
INSERT INTO public.europe_data_import VALUES (8915, '11/05/2020', '2020-19', '8565', '1316', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '34.51');
INSERT INTO public.europe_data_import VALUES (8916, '04/05/2020', '2020-18', '7635', '2238', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '50.57');
INSERT INTO public.europe_data_import VALUES (8917, '27/04/2020', '2020-17', '16100', '2338', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '78.02');
INSERT INTO public.europe_data_import VALUES (8918, '20/04/2020', '2020-16', '20519', '3880', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '113.07');
INSERT INTO public.europe_data_import VALUES (8919, '13/04/2020', '2020-15', '32553', '4554', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '167.95');
INSERT INTO public.europe_data_import VALUES (8920, '06/04/2020', '2020-14', '46276', '5890', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '215.47');
INSERT INTO public.europe_data_import VALUES (8921, '30/03/2020', '2020-13', '54860', '4808', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '180.31');
INSERT INTO public.europe_data_import VALUES (8922, '23/03/2020', '2020-12', '29771', '1432', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '84.66');
INSERT INTO public.europe_data_import VALUES (8923, '16/03/2020', '2020-11', '9964', '283', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '24.19');
INSERT INTO public.europe_data_import VALUES (8924, '09/03/2020', '2020-10', '1391', '5', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '3.25');
INSERT INTO public.europe_data_import VALUES (8925, '02/03/2020', '2020-09', '134', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.29');
INSERT INTO public.europe_data_import VALUES (8926, '24/02/2020', '2020-08', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8927, '17/02/2020', '2020-07', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (8928, '10/02/2020', '2020-06', '1', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (8929, '03/02/2020', '2020-05', '1', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (8930, '27/01/2020', '2020-04', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8931, '20/01/2020', '2020-03', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8932, '13/01/2020', '2020-02', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8933, '06/01/2020', '2020-01', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8934, '01/02/2021', '2021-04', '5727', '33', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '52.03');
INSERT INTO public.europe_data_import VALUES (8935, '25/01/2021', '2021-03', '5368', '19', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '47.13');
INSERT INTO public.europe_data_import VALUES (8936, '18/01/2021', '2021-02', '4682', '32', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '38.87');
INSERT INTO public.europe_data_import VALUES (8937, '11/01/2021', '2021-01', '3606', '19', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '34.36');
INSERT INTO public.europe_data_import VALUES (8938, '04/01/2021', '2020-53', '3720', '22', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '35.23');
INSERT INTO public.europe_data_import VALUES (8939, '28/12/2020', '2020-52', '3793', '15', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '38.75');
INSERT INTO public.europe_data_import VALUES (8940, '21/12/2020', '2020-51', '4471', '24', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '44.01');
INSERT INTO public.europe_data_import VALUES (8941, '14/12/2020', '2020-50', '4913', '12', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '43.64');
INSERT INTO public.europe_data_import VALUES (8942, '07/12/2020', '2020-49', '4393', '24', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '36.14');
INSERT INTO public.europe_data_import VALUES (8943, '30/11/2020', '2020-48', '3313', '29', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '29.06');
INSERT INTO public.europe_data_import VALUES (8944, '23/11/2020', '2020-47', '2884', '29', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '29.27');
INSERT INTO public.europe_data_import VALUES (8945, '16/11/2020', '2020-46', '3358', '23', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '29.2');
INSERT INTO public.europe_data_import VALUES (8946, '09/11/2020', '2020-45', '2869', '14', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '28.4');
INSERT INTO public.europe_data_import VALUES (8947, '02/11/2020', '2020-44', '3188', '6', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '25.9');
INSERT INTO public.europe_data_import VALUES (8948, '26/10/2020', '2020-43', '2334', '2', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '14.63');
INSERT INTO public.europe_data_import VALUES (8949, '19/10/2020', '2020-42', '786', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '10.02');
INSERT INTO public.europe_data_import VALUES (8950, '12/10/2020', '2020-41', '1350', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '6.53');
INSERT INTO public.europe_data_import VALUES (8951, '05/10/2020', '2020-40', '42', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.54');
INSERT INTO public.europe_data_import VALUES (8952, '28/09/2020', '2020-39', '73', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (8953, '21/09/2020', '2020-38', '53', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (8954, '14/09/2020', '2020-37', '111', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.04');
INSERT INTO public.europe_data_import VALUES (8955, '07/09/2020', '2020-36', '111', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.8');
INSERT INTO public.europe_data_import VALUES (8956, '31/08/2020', '2020-35', '59', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.56');
INSERT INTO public.europe_data_import VALUES (8957, '24/08/2020', '2020-34', '60', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.51');
INSERT INTO public.europe_data_import VALUES (8958, '17/08/2020', '2020-33', '49', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.33');
INSERT INTO public.europe_data_import VALUES (8959, '10/08/2020', '2020-32', '21', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (8960, '03/08/2020', '2020-31', '41', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (8961, '27/07/2020', '2020-30', '58', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (8962, '20/07/2020', '2020-29', '107', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '3.04');
INSERT INTO public.europe_data_import VALUES (8963, '13/07/2020', '2020-28', '541', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '2.72');
INSERT INTO public.europe_data_import VALUES (8964, '06/07/2020', '2020-27', '39', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (8965, '29/06/2020', '2020-26', '87', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (8966, '22/06/2020', '2020-25', '61', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.54');
INSERT INTO public.europe_data_import VALUES (8967, '15/06/2020', '2020-24', '54', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.2');
INSERT INTO public.europe_data_import VALUES (8968, '08/06/2020', '2020-23', '202', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '3.25');
INSERT INTO public.europe_data_import VALUES (8969, '01/06/2020', '2020-22', '492', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '3.06');
INSERT INTO public.europe_data_import VALUES (8970, '25/05/2020', '2020-21', '160', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (8971, '18/05/2020', '2020-20', '118', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.23');
INSERT INTO public.europe_data_import VALUES (8972, '11/05/2020', '2020-19', '145', '2', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.59');
INSERT INTO public.europe_data_import VALUES (8973, '04/05/2020', '2020-18', '195', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.98');
INSERT INTO public.europe_data_import VALUES (8974, '27/04/2020', '2020-17', '228', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.47');
INSERT INTO public.europe_data_import VALUES (8975, '20/04/2020', '2020-16', '85', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.6');
INSERT INTO public.europe_data_import VALUES (8976, '13/04/2020', '2020-15', '44', '2', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (8977, '06/04/2020', '2020-14', '46', '4', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (8978, '30/03/2020', '2020-13', '33', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.47');
INSERT INTO public.europe_data_import VALUES (8979, '23/03/2020', '2020-12', '68', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.4');
INSERT INTO public.europe_data_import VALUES (8980, '16/03/2020', '2020-11', '18', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (8981, '09/03/2020', '2020-10', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8982, '02/03/2020', '2020-09', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8983, '24/02/2020', '2020-08', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8984, '17/02/2020', '2020-07', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8985, '10/02/2020', '2020-06', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (8986, '03/02/2020', '2020-05', '1', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (8987, '27/01/2020', '2020-04', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8988, '20/01/2020', '2020-03', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8989, '13/01/2020', '2020-02', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8990, '06/01/2020', '2020-01', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8991, '01/02/2021', '2021-04', '927', '85', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '14.33');
INSERT INTO public.europe_data_import VALUES (8992, '25/01/2021', '2021-03', '5206', '254', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '12.16');
INSERT INTO public.europe_data_import VALUES (8993, '18/01/2021', '2021-02', '0', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8994, '11/01/2021', '2021-01', '0', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8995, '04/01/2021', '2020-53', '0', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.15');
INSERT INTO public.europe_data_import VALUES (8996, '28/12/2020', '2020-52', '493', '34', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '4.51');
INSERT INTO public.europe_data_import VALUES (8997, '21/12/2020', '2020-51', '1437', '87', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '7.84');
INSERT INTO public.europe_data_import VALUES (8998, '14/12/2020', '2020-50', '1918', '52', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '8.78');
INSERT INTO public.europe_data_import VALUES (8999, '07/12/2020', '2020-49', '1841', '54', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '8.48');
INSERT INTO public.europe_data_import VALUES (9000, '30/11/2020', '2020-48', '1788', '48', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '7.01');
INSERT INTO public.europe_data_import VALUES (9001, '23/11/2020', '2020-47', '1213', '77', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (9002, '16/11/2020', '2020-46', '536', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (9003, '09/11/2020', '2020-45', '271', '278', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (9004, '02/11/2020', '2020-44', '77', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (9005, '26/10/2020', '2020-43', '51', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (9006, '19/10/2020', '2020-42', '21', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (9007, '12/10/2020', '2020-41', '17', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (9008, '05/10/2020', '2020-40', '47', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (9009, '28/09/2020', '2020-39', '51', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (9010, '21/09/2020', '2020-38', '85', '2', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (9011, '14/09/2020', '2020-37', '63', '2', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (9012, '07/09/2020', '2020-36', '218', '9', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.33');
INSERT INTO public.europe_data_import VALUES (9013, '31/08/2020', '2020-35', '353', '8', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.82');
INSERT INTO public.europe_data_import VALUES (9014, '24/08/2020', '2020-34', '426', '12', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (9015, '17/08/2020', '2020-33', '516', '30', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.57');
INSERT INTO public.europe_data_import VALUES (9016, '10/08/2020', '2020-32', '156', '21', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (9017, '03/08/2020', '2020-31', '353', '35', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.28');
INSERT INTO public.europe_data_import VALUES (9018, '27/07/2020', '2020-30', '623', '37', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.65');
INSERT INTO public.europe_data_import VALUES (9019, '20/07/2020', '2020-29', '512', '30', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.32');
INSERT INTO public.europe_data_import VALUES (9020, '13/07/2020', '2020-28', '483', '42', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.32');
INSERT INTO public.europe_data_import VALUES (9021, '06/07/2020', '2020-27', '509', '36', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (9022, '29/06/2020', '2020-26', '678', '51', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '4.76');
INSERT INTO public.europe_data_import VALUES (9023, '22/06/2020', '2020-25', '1360', '62', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.83');
INSERT INTO public.europe_data_import VALUES (9024, '15/06/2020', '2020-24', '1137', '100', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (9025, '08/06/2020', '2020-23', '1057', '73', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.72');
INSERT INTO public.europe_data_import VALUES (9026, '01/06/2020', '2020-22', '1392', '140', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '6.39');
INSERT INTO public.europe_data_import VALUES (9027, '25/05/2020', '2020-21', '1345', '49', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.3');
INSERT INTO public.europe_data_import VALUES (9028, '18/05/2020', '2020-20', '926', '27', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (9029, '11/05/2020', '2020-19', '685', '29', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.63');
INSERT INTO public.europe_data_import VALUES (9030, '04/05/2020', '2020-18', '441', '20', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.43');
INSERT INTO public.europe_data_import VALUES (9031, '27/04/2020', '2020-17', '171', '11', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (9032, '20/04/2020', '2020-16', '47', '8', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (9033, '13/04/2020', '2020-15', '7', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (9034, '06/04/2020', '2020-14', '7', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (9035, '30/03/2020', '2020-13', '3', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (9036, '23/03/2020', '2020-12', '1', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (9037, '16/03/2020', '2020-11', '1', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9038, '01/02/2021', '2021-04', '337', '7', '581363', 'Suriname', 'SR', 'SUR', 'America', '141.91');
INSERT INTO public.europe_data_import VALUES (9039, '25/01/2021', '2021-03', '488', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '180.27');
INSERT INTO public.europe_data_import VALUES (9040, '18/01/2021', '2021-02', '560', '7', '581363', 'Suriname', 'SR', 'SUR', 'America', '211.74');
INSERT INTO public.europe_data_import VALUES (9041, '11/01/2021', '2021-01', '671', '15', '581363', 'Suriname', 'SR', 'SUR', 'America', '180.78');
INSERT INTO public.europe_data_import VALUES (9042, '04/01/2021', '2020-53', '380', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '139.33');
INSERT INTO public.europe_data_import VALUES (9043, '28/12/2020', '2020-52', '430', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '113.53');
INSERT INTO public.europe_data_import VALUES (9044, '21/12/2020', '2020-51', '230', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '44.55');
INSERT INTO public.europe_data_import VALUES (9045, '14/12/2020', '2020-50', '29', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '7.05');
INSERT INTO public.europe_data_import VALUES (9046, '07/12/2020', '2020-49', '12', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '4.82');
INSERT INTO public.europe_data_import VALUES (9047, '30/11/2020', '2020-48', '16', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '6.54');
INSERT INTO public.europe_data_import VALUES (9048, '23/11/2020', '2020-47', '22', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '9.8');
INSERT INTO public.europe_data_import VALUES (9049, '16/11/2020', '2020-46', '35', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '11.01');
INSERT INTO public.europe_data_import VALUES (9050, '09/11/2020', '2020-45', '29', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '11.87');
INSERT INTO public.europe_data_import VALUES (9051, '02/11/2020', '2020-44', '40', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '13.76');
INSERT INTO public.europe_data_import VALUES (9052, '26/10/2020', '2020-43', '40', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '20.47');
INSERT INTO public.europe_data_import VALUES (9053, '19/10/2020', '2020-42', '79', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '32.51');
INSERT INTO public.europe_data_import VALUES (9054, '12/10/2020', '2020-41', '110', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '37.15');
INSERT INTO public.europe_data_import VALUES (9055, '05/10/2020', '2020-40', '106', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '37.5');
INSERT INTO public.europe_data_import VALUES (9056, '28/09/2020', '2020-39', '112', '5', '581363', 'Suriname', 'SR', 'SUR', 'America', '43.52');
INSERT INTO public.europe_data_import VALUES (9057, '21/09/2020', '2020-38', '141', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '64.85');
INSERT INTO public.europe_data_import VALUES (9058, '14/09/2020', '2020-37', '236', '8', '581363', 'Suriname', 'SR', 'SUR', 'America', '98.56');
INSERT INTO public.europe_data_import VALUES (9059, '07/09/2020', '2020-36', '337', '18', '581363', 'Suriname', 'SR', 'SUR', 'America', '127.12');
INSERT INTO public.europe_data_import VALUES (9060, '31/08/2020', '2020-35', '402', '9', '581363', 'Suriname', 'SR', 'SUR', 'America', '170.81');
INSERT INTO public.europe_data_import VALUES (9061, '24/08/2020', '2020-34', '591', '11', '581363', 'Suriname', 'SR', 'SUR', 'America', '209.16');
INSERT INTO public.europe_data_import VALUES (9062, '17/08/2020', '2020-33', '625', '18', '581363', 'Suriname', 'SR', 'SUR', 'America', '200.74');
INSERT INTO public.europe_data_import VALUES (9063, '10/08/2020', '2020-32', '542', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '163.75');
INSERT INTO public.europe_data_import VALUES (9064, '03/08/2020', '2020-31', '410', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '141.05');
INSERT INTO public.europe_data_import VALUES (9065, '27/07/2020', '2020-30', '410', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '120.06');
INSERT INTO public.europe_data_import VALUES (9066, '20/07/2020', '2020-29', '288', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '74.82');
INSERT INTO public.europe_data_import VALUES (9067, '13/07/2020', '2020-28', '147', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '43.17');
INSERT INTO public.europe_data_import VALUES (9068, '06/07/2020', '2020-27', '104', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '48.16');
INSERT INTO public.europe_data_import VALUES (9069, '29/06/2020', '2020-26', '176', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '48.51');
INSERT INTO public.europe_data_import VALUES (9070, '22/06/2020', '2020-25', '106', '5', '581363', 'Suriname', 'SR', 'SUR', 'America', '33.03');
INSERT INTO public.europe_data_import VALUES (9071, '15/06/2020', '2020-24', '86', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '31.82');
INSERT INTO public.europe_data_import VALUES (9072, '08/06/2020', '2020-23', '99', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '19.09');
INSERT INTO public.europe_data_import VALUES (9073, '01/06/2020', '2020-22', '12', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '2.24');
INSERT INTO public.europe_data_import VALUES (9074, '25/05/2020', '2020-21', '1', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0.17');
INSERT INTO public.europe_data_import VALUES (9075, '18/05/2020', '2020-20', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9076, '11/05/2020', '2020-19', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9077, '04/05/2020', '2020-18', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9078, '27/04/2020', '2020-17', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9079, '20/04/2020', '2020-16', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9080, '13/04/2020', '2020-15', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0.34');
INSERT INTO public.europe_data_import VALUES (9081, '06/04/2020', '2020-14', '2', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '0.86');
INSERT INTO public.europe_data_import VALUES (9082, '30/03/2020', '2020-13', '3', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '1.38');
INSERT INTO public.europe_data_import VALUES (9083, '23/03/2020', '2020-12', '5', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '');
INSERT INTO public.europe_data_import VALUES (9084, '01/02/2021', '2021-04', '20683', '89', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '429.49');
INSERT INTO public.europe_data_import VALUES (9085, '25/01/2021', '2021-03', '23255', '400', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '510.37');
INSERT INTO public.europe_data_import VALUES (9086, '18/01/2021', '2021-02', '28957', '569', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '668.84');
INSERT INTO public.europe_data_import VALUES (9087, '11/01/2021', '2021-01', '39467', '637', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '789.85');
INSERT INTO public.europe_data_import VALUES (9088, '04/01/2021', '2020-53', '41336', '657', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '767.08');
INSERT INTO public.europe_data_import VALUES (9089, '28/12/2020', '2020-52', '37138', '638', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '814.44');
INSERT INTO public.europe_data_import VALUES (9090, '21/12/2020', '2020-51', '46181', '645', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '877.91');
INSERT INTO public.europe_data_import VALUES (9091, '14/12/2020', '2020-50', '43631', '499', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '786.61');
INSERT INTO public.europe_data_import VALUES (9092, '07/12/2020', '2020-49', '36841', '476', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '707.71');
INSERT INTO public.europe_data_import VALUES (9093, '30/11/2020', '2020-48', '35559', '418', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '659.85');
INSERT INTO public.europe_data_import VALUES (9094, '23/11/2020', '2020-47', '31945', '332', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '618.42');
INSERT INTO public.europe_data_import VALUES (9095, '16/11/2020', '2020-46', '31320', '235', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '554.49');
INSERT INTO public.europe_data_import VALUES (9096, '09/11/2020', '2020-45', '25405', '157', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '428.93');
INSERT INTO public.europe_data_import VALUES (9097, '02/11/2020', '2020-44', '18475', '82', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '270.09');
INSERT INTO public.europe_data_import VALUES (9098, '26/10/2020', '2020-43', '9156', '43', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '144.44');
INSERT INTO public.europe_data_import VALUES (9099, '19/10/2020', '2020-42', '5620', '16', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '96.75');
INSERT INTO public.europe_data_import VALUES (9100, '12/10/2020', '2020-41', '4278', '22', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '77.42');
INSERT INTO public.europe_data_import VALUES (9101, '05/10/2020', '2020-40', '3642', '17', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '64.13');
INSERT INTO public.europe_data_import VALUES (9102, '28/09/2020', '2020-39', '2919', '11', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '48.87');
INSERT INTO public.europe_data_import VALUES (9103, '21/09/2020', '2020-38', '2080', '12', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '35.89');
INSERT INTO public.europe_data_import VALUES (9104, '14/09/2020', '2020-37', '1592', '13', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.58');
INSERT INTO public.europe_data_import VALUES (9105, '07/09/2020', '2020-36', '1332', '12', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '24.75');
INSERT INTO public.europe_data_import VALUES (9106, '31/08/2020', '2020-35', '1200', '10', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.22');
INSERT INTO public.europe_data_import VALUES (9107, '24/08/2020', '2020-34', '1687', '19', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '36.55');
INSERT INTO public.europe_data_import VALUES (9108, '17/08/2020', '2020-33', '2052', '16', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '39.75');
INSERT INTO public.europe_data_import VALUES (9109, '10/08/2020', '2020-32', '2014', '18', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '34.9');
INSERT INTO public.europe_data_import VALUES (9110, '03/08/2020', '2020-31', '1556', '18', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.07');
INSERT INTO public.europe_data_import VALUES (9111, '27/07/2020', '2020-30', '1316', '30', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.72');
INSERT INTO public.europe_data_import VALUES (9112, '20/07/2020', '2020-29', '1622', '57', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '37.15');
INSERT INTO public.europe_data_import VALUES (9113, '13/07/2020', '2020-28', '2179', '84', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '63.1');
INSERT INTO public.europe_data_import VALUES (9114, '06/07/2020', '2020-27', '4276', '98', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '114.71');
INSERT INTO public.europe_data_import VALUES (9115, '29/06/2020', '2020-26', '7459', '138', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '142.05');
INSERT INTO public.europe_data_import VALUES (9116, '22/06/2020', '2020-25', '7073', '200', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '138.77');
INSERT INTO public.europe_data_import VALUES (9117, '15/06/2020', '2020-24', '7123', '234', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '128.48');
INSERT INTO public.europe_data_import VALUES (9118, '08/06/2020', '2020-23', '6021', '245', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '100.7');
INSERT INTO public.europe_data_import VALUES (9119, '01/06/2020', '2020-22', '4281', '274', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '77.61');
INSERT INTO public.europe_data_import VALUES (9120, '25/05/2020', '2020-21', '3659', '360', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '73.59');
INSERT INTO public.europe_data_import VALUES (9121, '18/05/2020', '2020-20', '3869', '380', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '78.42');
INSERT INTO public.europe_data_import VALUES (9122, '11/05/2020', '2020-19', '4153', '510', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '78.05');
INSERT INTO public.europe_data_import VALUES (9123, '04/05/2020', '2020-18', '3832', '544', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '78.52');
INSERT INTO public.europe_data_import VALUES (9124, '27/04/2020', '2020-17', '4201', '546', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '77.73');
INSERT INTO public.europe_data_import VALUES (9125, '20/04/2020', '2020-16', '3751', '658', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '73.21');
INSERT INTO public.europe_data_import VALUES (9126, '13/04/2020', '2020-15', '3739', '664', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '68.1');
INSERT INTO public.europe_data_import VALUES (9127, '06/04/2020', '2020-14', '3228', '451', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '50.68');
INSERT INTO public.europe_data_import VALUES (9128, '30/03/2020', '2020-13', '1957', '190', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.16');
INSERT INTO public.europe_data_import VALUES (9129, '23/03/2020', '2020-12', '924', '44', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '17.22');
INSERT INTO public.europe_data_import VALUES (9130, '16/03/2020', '2020-11', '838', '5', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '10.25');
INSERT INTO public.europe_data_import VALUES (9131, '09/03/2020', '2020-10', '211', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '2.19');
INSERT INTO public.europe_data_import VALUES (9132, '02/03/2020', '2020-09', '13', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0.13');
INSERT INTO public.europe_data_import VALUES (9133, '24/02/2020', '2020-08', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9134, '17/02/2020', '2020-07', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9135, '10/02/2020', '2020-06', '1', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9136, '03/02/2020', '2020-05', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9137, '27/01/2020', '2020-04', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9138, '20/01/2020', '2020-03', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9139, '13/01/2020', '2020-02', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9140, '06/01/2020', '2020-01', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9141, '01/02/2021', '2021-04', '11451', '295', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '293.24');
INSERT INTO public.europe_data_import VALUES (9142, '25/01/2021', '2021-03', '13605', '337', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '339.2');
INSERT INTO public.europe_data_import VALUES (9143, '18/01/2021', '2021-02', '15378', '392', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '442.53');
INSERT INTO public.europe_data_import VALUES (9144, '11/01/2021', '2021-01', '22434', '417', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '536.58');
INSERT INTO public.europe_data_import VALUES (9145, '04/01/2021', '2020-53', '23414', '495', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '555.89');
INSERT INTO public.europe_data_import VALUES (9146, '28/12/2020', '2020-52', '24084', '563', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '748.05');
INSERT INTO public.europe_data_import VALUES (9147, '21/12/2020', '2020-51', '39833', '802', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '808.25');
INSERT INTO public.europe_data_import VALUES (9148, '14/12/2020', '2020-50', '29228', '546', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '647.34');
INSERT INTO public.europe_data_import VALUES (9149, '07/12/2020', '2020-49', '26084', '596', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '627.51');
INSERT INTO public.europe_data_import VALUES (9150, '30/11/2020', '2020-48', '27534', '669', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '711.93');
INSERT INTO public.europe_data_import VALUES (9151, '23/11/2020', '2020-47', '33297', '611', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '916.65');
INSERT INTO public.europe_data_import VALUES (9152, '16/11/2020', '2020-46', '45026', '552', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '1199.11');
INSERT INTO public.europe_data_import VALUES (9153, '09/11/2020', '2020-45', '57432', '369', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '1262.06');
INSERT INTO public.europe_data_import VALUES (9154, '02/11/2020', '2020-44', '50405', '159', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '928.15');
INSERT INTO public.europe_data_import VALUES (9155, '26/10/2020', '2020-43', '28901', '53', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '504.33');
INSERT INTO public.europe_data_import VALUES (9156, '19/10/2020', '2020-42', '14192', '30', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '235.93');
INSERT INTO public.europe_data_import VALUES (9157, '12/10/2020', '2020-41', '5967', '10', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '97.91');
INSERT INTO public.europe_data_import VALUES (9158, '05/10/2020', '2020-40', '2399', '5', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '59.59');
INSERT INTO public.europe_data_import VALUES (9159, '28/09/2020', '2020-39', '2693', '14', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '56.13');
INSERT INTO public.europe_data_import VALUES (9160, '21/09/2020', '2020-38', '2103', '18', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '57.09');
INSERT INTO public.europe_data_import VALUES (9161, '14/09/2020', '2020-37', '2775', '14', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '60.41');
INSERT INTO public.europe_data_import VALUES (9162, '07/09/2020', '2020-36', '2387', '8', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '52.56');
INSERT INTO public.europe_data_import VALUES (9163, '31/08/2020', '2020-35', '2104', '5', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '45.35');
INSERT INTO public.europe_data_import VALUES (9164, '24/08/2020', '2020-34', '1771', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '38.48');
INSERT INTO public.europe_data_import VALUES (9165, '17/08/2020', '2020-33', '1517', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '30.08');
INSERT INTO public.europe_data_import VALUES (9166, '10/08/2020', '2020-32', '1053', '6', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '25.62');
INSERT INTO public.europe_data_import VALUES (9167, '03/08/2020', '2020-31', '1136', '5', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '22.9');
INSERT INTO public.europe_data_import VALUES (9168, '27/07/2020', '2020-30', '821', '13', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '17.87');
INSERT INTO public.europe_data_import VALUES (9169, '20/07/2020', '2020-29', '706', '2', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '15.45');
INSERT INTO public.europe_data_import VALUES (9170, '13/07/2020', '2020-28', '614', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '14.79');
INSERT INTO public.europe_data_import VALUES (9171, '06/07/2020', '2020-27', '650', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '11.41');
INSERT INTO public.europe_data_import VALUES (9172, '29/06/2020', '2020-26', '325', '2', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '5.85');
INSERT INTO public.europe_data_import VALUES (9173, '22/06/2020', '2020-25', '175', '3', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '3.83');
INSERT INTO public.europe_data_import VALUES (9174, '15/06/2020', '2020-24', '152', '16', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '2.98');
INSERT INTO public.europe_data_import VALUES (9175, '08/06/2020', '2020-23', '103', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '2.68');
INSERT INTO public.europe_data_import VALUES (9176, '01/06/2020', '2020-22', '126', '15', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '3.22');
INSERT INTO public.europe_data_import VALUES (9177, '25/05/2020', '2020-21', '149', '39', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '5.04');
INSERT INTO public.europe_data_import VALUES (9178, '18/05/2020', '2020-20', '282', '65', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '7.98');
INSERT INTO public.europe_data_import VALUES (9179, '11/05/2020', '2020-19', '400', '65', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '14.56');
INSERT INTO public.europe_data_import VALUES (9180, '04/05/2020', '2020-18', '844', '136', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '25.33');
INSERT INTO public.europe_data_import VALUES (9181, '27/04/2020', '2020-17', '1320', '202', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '43.98');
INSERT INTO public.europe_data_import VALUES (9182, '20/04/2020', '2020-16', '2438', '276', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '77.66');
INSERT INTO public.europe_data_import VALUES (9183, '13/04/2020', '2020-15', '4198', '299', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '128.11');
INSERT INTO public.europe_data_import VALUES (9184, '06/04/2020', '2020-14', '6748', '302', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '164.44');
INSERT INTO public.europe_data_import VALUES (9185, '30/03/2020', '2020-13', '7303', '197', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '141.31');
INSERT INTO public.europe_data_import VALUES (9186, '23/03/2020', '2020-12', '4771', '47', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '77.7');
INSERT INTO public.europe_data_import VALUES (9187, '16/03/2020', '2020-11', '1868', '11', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '25.47');
INSERT INTO public.europe_data_import VALUES (9188, '09/03/2020', '2020-10', '308', '2', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '3.89');
INSERT INTO public.europe_data_import VALUES (9189, '02/03/2020', '2020-09', '24', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0.28');
INSERT INTO public.europe_data_import VALUES (9190, '24/02/2020', '2020-08', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9191, '17/02/2020', '2020-07', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9192, '10/02/2020', '2020-06', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9193, '03/02/2020', '2020-05', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9194, '27/01/2020', '2020-04', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9195, '20/01/2020', '2020-03', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9196, '13/01/2020', '2020-02', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9197, '06/01/2020', '2020-01', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9198, '01/02/2021', '2021-04', '420', '36', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.93');
INSERT INTO public.europe_data_import VALUES (9199, '25/01/2021', '2021-03', '592', '53', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '7.4');
INSERT INTO public.europe_data_import VALUES (9200, '18/01/2021', '2021-02', '672', '58', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '7.77');
INSERT INTO public.europe_data_import VALUES (9201, '11/01/2021', '2021-01', '654', '45', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '7.8');
INSERT INTO public.europe_data_import VALUES (9202, '04/01/2021', '2020-53', '677', '51', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '8.88');
INSERT INTO public.europe_data_import VALUES (9203, '28/12/2020', '2020-52', '838', '68', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '10.94');
INSERT INTO public.europe_data_import VALUES (9204, '21/12/2020', '2020-51', '1029', '92', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '10.5');
INSERT INTO public.europe_data_import VALUES (9205, '14/12/2020', '2020-50', '763', '71', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '8.02');
INSERT INTO public.europe_data_import VALUES (9206, '07/12/2020', '2020-49', '606', '34', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.9');
INSERT INTO public.europe_data_import VALUES (9207, '30/11/2020', '2020-48', '572', '37', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.52');
INSERT INTO public.europe_data_import VALUES (9208, '23/11/2020', '2020-47', '541', '31', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.92');
INSERT INTO public.europe_data_import VALUES (9209, '16/11/2020', '2020-46', '469', '28', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.24');
INSERT INTO public.europe_data_import VALUES (9210, '09/11/2020', '2020-45', '426', '25', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.73');
INSERT INTO public.europe_data_import VALUES (9211, '02/11/2020', '2020-44', '381', '23', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.17');
INSERT INTO public.europe_data_import VALUES (9212, '26/10/2020', '2020-43', '331', '21', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.31');
INSERT INTO public.europe_data_import VALUES (9213, '19/10/2020', '2020-42', '404', '27', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.17');
INSERT INTO public.europe_data_import VALUES (9214, '12/10/2020', '2020-41', '307', '16', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.52');
INSERT INTO public.europe_data_import VALUES (9215, '05/10/2020', '2020-40', '294', '13', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.32');
INSERT INTO public.europe_data_import VALUES (9216, '28/09/2020', '2020-39', '272', '20', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.12');
INSERT INTO public.europe_data_import VALUES (9217, '21/09/2020', '2020-38', '260', '17', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.68');
INSERT INTO public.europe_data_import VALUES (9218, '14/09/2020', '2020-37', '369', '21', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.9');
INSERT INTO public.europe_data_import VALUES (9219, '07/09/2020', '2020-36', '468', '25', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.02');
INSERT INTO public.europe_data_import VALUES (9220, '31/08/2020', '2020-35', '560', '24', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.01');
INSERT INTO public.europe_data_import VALUES (9221, '24/08/2020', '2020-34', '466', '21', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.59');
INSERT INTO public.europe_data_import VALUES (9222, '17/08/2020', '2020-33', '489', '12', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.08');
INSERT INTO public.europe_data_import VALUES (9223, '10/08/2020', '2020-32', '379', '8', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.15');
INSERT INTO public.europe_data_import VALUES (9224, '03/08/2020', '2020-31', '159', '6', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (9225, '27/07/2020', '2020-30', '154', '13', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '1.5');
INSERT INTO public.europe_data_import VALUES (9226, '20/07/2020', '2020-29', '102', '9', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.81');
INSERT INTO public.europe_data_import VALUES (9227, '13/07/2020', '2020-28', '36', '3', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.81');
INSERT INTO public.europe_data_import VALUES (9228, '06/07/2020', '2020-27', '102', '4', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.9');
INSERT INTO public.europe_data_import VALUES (9229, '29/06/2020', '2020-26', '52', '2', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (9230, '22/06/2020', '2020-25', '27', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (9231, '15/06/2020', '2020-24', '36', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (9232, '08/06/2020', '2020-23', '19', '2', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (9233, '01/06/2020', '2020-22', '36', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (9234, '25/05/2020', '2020-21', '28', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (9235, '18/05/2020', '2020-20', '11', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9236, '11/05/2020', '2020-19', '3', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9237, '04/05/2020', '2020-18', '1', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9238, '27/04/2020', '2020-17', '4', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9239, '20/04/2020', '2020-16', '14', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9240, '13/04/2020', '2020-15', '6', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9241, '06/04/2020', '2020-14', '10', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9242, '30/03/2020', '2020-13', '8', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9243, '23/03/2020', '2020-12', '1', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9244, '01/02/2021', '2021-04', '23', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (9245, '25/01/2021', '2021-03', '27', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (9246, '18/01/2021', '2021-02', '28', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.2');
INSERT INTO public.europe_data_import VALUES (9247, '11/01/2021', '2021-01', '19', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9248, '04/01/2021', '2020-53', '22', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (9249, '28/12/2020', '2020-52', '27', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (9250, '21/12/2020', '2020-51', '26', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (9251, '14/12/2020', '2020-50', '24', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (9252, '07/12/2020', '2020-49', '41', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.41');
INSERT INTO public.europe_data_import VALUES (9253, '30/11/2020', '2020-48', '57', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.3');
INSERT INTO public.europe_data_import VALUES (9254, '23/11/2020', '2020-47', '15', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9255, '16/11/2020', '2020-46', '25', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9256, '09/11/2020', '2020-45', '15', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9257, '02/11/2020', '2020-44', '13', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9258, '26/10/2020', '2020-43', '10', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9259, '19/10/2020', '2020-42', '13', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9260, '12/10/2020', '2020-41', '10', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9261, '05/10/2020', '2020-40', '7', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9262, '28/09/2020', '2020-39', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9263, '21/09/2020', '2020-38', '11', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9264, '14/09/2020', '2020-37', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9265, '07/09/2020', '2020-36', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9266, '31/08/2020', '2020-35', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9267, '24/08/2020', '2020-34', '2', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9268, '17/08/2020', '2020-33', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9269, '10/08/2020', '2020-32', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9270, '03/08/2020', '2020-31', '13', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9271, '27/07/2020', '2020-30', '7', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9272, '20/07/2020', '2020-29', '4', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9273, '13/07/2020', '2020-28', '2', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9274, '06/07/2020', '2020-27', '2', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9275, '29/06/2020', '2020-26', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9276, '22/06/2020', '2020-25', '3', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9277, '15/06/2020', '2020-24', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9278, '08/06/2020', '2020-23', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9279, '01/06/2020', '2020-22', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9280, '25/05/2020', '2020-21', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9281, '18/05/2020', '2020-20', '0', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9282, '11/05/2020', '2020-19', '4', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9283, '04/05/2020', '2020-18', '7', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9284, '27/04/2020', '2020-17', '9', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9285, '20/04/2020', '2020-16', '32', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (9286, '13/04/2020', '2020-15', '25', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.34');
INSERT INTO public.europe_data_import VALUES (9287, '06/04/2020', '2020-14', '57', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.83');
INSERT INTO public.europe_data_import VALUES (9288, '30/03/2020', '2020-13', '141', '3', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '1.04');
INSERT INTO public.europe_data_import VALUES (9289, '23/03/2020', '2020-12', '106', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.5');
INSERT INTO public.europe_data_import VALUES (9290, '16/03/2020', '2020-11', '14', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9291, '09/03/2020', '2020-10', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9292, '02/03/2020', '2020-09', '12', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9293, '24/02/2020', '2020-08', '8', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9294, '17/02/2020', '2020-07', '2', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9295, '10/02/2020', '2020-06', '8', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9296, '03/02/2020', '2020-05', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9297, '27/01/2020', '2020-04', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9298, '20/01/2020', '2020-03', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9299, '13/01/2020', '2020-02', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9300, '06/01/2020', '2020-01', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9301, '01/02/2021', '2021-04', '0', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9302, '25/01/2021', '2021-03', '0', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9303, '18/01/2021', '2021-02', '0', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9304, '11/01/2021', '2021-01', '8', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (9305, '04/01/2021', '2020-53', '63', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '3.65');
INSERT INTO public.europe_data_import VALUES (9306, '28/12/2020', '2020-52', '277', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.72');
INSERT INTO public.europe_data_import VALUES (9307, '21/12/2020', '2020-51', '256', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.71');
INSERT INTO public.europe_data_import VALUES (9308, '14/12/2020', '2020-50', '276', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.89');
INSERT INTO public.europe_data_import VALUES (9309, '07/12/2020', '2020-49', '273', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.73');
INSERT INTO public.europe_data_import VALUES (9310, '30/11/2020', '2020-48', '261', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.85');
INSERT INTO public.europe_data_import VALUES (9311, '23/11/2020', '2020-47', '284', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.99');
INSERT INTO public.europe_data_import VALUES (9312, '16/11/2020', '2020-46', '274', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.97');
INSERT INTO public.europe_data_import VALUES (9313, '09/11/2020', '2020-45', '282', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.01');
INSERT INTO public.europe_data_import VALUES (9314, '02/11/2020', '2020-44', '278', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.02');
INSERT INTO public.europe_data_import VALUES (9315, '26/10/2020', '2020-43', '283', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.94');
INSERT INTO public.europe_data_import VALUES (9316, '19/10/2020', '2020-42', '271', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.99');
INSERT INTO public.europe_data_import VALUES (9317, '12/10/2020', '2020-41', '287', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.18');
INSERT INTO public.europe_data_import VALUES (9318, '05/10/2020', '2020-40', '289', '3', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.32');
INSERT INTO public.europe_data_import VALUES (9319, '28/09/2020', '2020-39', '300', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.4');
INSERT INTO public.europe_data_import VALUES (9320, '21/09/2020', '2020-38', '297', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.94');
INSERT INTO public.europe_data_import VALUES (9321, '14/09/2020', '2020-37', '257', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.35');
INSERT INTO public.europe_data_import VALUES (9322, '07/09/2020', '2020-36', '242', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.16');
INSERT INTO public.europe_data_import VALUES (9323, '31/08/2020', '2020-35', '239', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.2');
INSERT INTO public.europe_data_import VALUES (9324, '24/08/2020', '2020-34', '246', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.07');
INSERT INTO public.europe_data_import VALUES (9325, '17/08/2020', '2020-33', '320', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.12');
INSERT INTO public.europe_data_import VALUES (9326, '10/08/2020', '2020-32', '250', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.93');
INSERT INTO public.europe_data_import VALUES (9327, '03/08/2020', '2020-31', '303', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.62');
INSERT INTO public.europe_data_import VALUES (9328, '27/07/2020', '2020-30', '314', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.87');
INSERT INTO public.europe_data_import VALUES (9329, '20/07/2020', '2020-29', '326', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '7.13');
INSERT INTO public.europe_data_import VALUES (9330, '13/07/2020', '2020-28', '339', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '7.54');
INSERT INTO public.europe_data_import VALUES (9331, '06/07/2020', '2020-27', '364', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '8.11');
INSERT INTO public.europe_data_import VALUES (9332, '29/06/2020', '2020-26', '392', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '8.73');
INSERT INTO public.europe_data_import VALUES (9333, '22/06/2020', '2020-25', '422', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '9.96');
INSERT INTO public.europe_data_import VALUES (9334, '15/06/2020', '2020-24', '506', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '13.17');
INSERT INTO public.europe_data_import VALUES (9335, '08/06/2020', '2020-23', '722', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '19.21');
INSERT INTO public.europe_data_import VALUES (9336, '01/06/2020', '2020-22', '1069', '3', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '24.49');
INSERT INTO public.europe_data_import VALUES (9337, '25/05/2020', '2020-21', '1214', '5', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '22.81');
INSERT INTO public.europe_data_import VALUES (9338, '18/05/2020', '2020-20', '912', '19', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '15.53');
INSERT INTO public.europe_data_import VALUES (9339, '11/05/2020', '2020-19', '536', '18', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.57');
INSERT INTO public.europe_data_import VALUES (9340, '04/05/2020', '2020-18', '76', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9341, '01/02/2021', '2021-04', '5931', '2', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '10.33');
INSERT INTO public.europe_data_import VALUES (9342, '25/01/2021', '2021-03', '1264', '5', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '4.51');
INSERT INTO public.europe_data_import VALUES (9343, '18/01/2021', '2021-02', '1876', '3', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '5.72');
INSERT INTO public.europe_data_import VALUES (9344, '11/01/2021', '2021-01', '2108', '2', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '6.12');
INSERT INTO public.europe_data_import VALUES (9345, '04/01/2021', '2020-53', '2154', '5', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '5.07');
INSERT INTO public.europe_data_import VALUES (9346, '28/12/2020', '2020-52', '1378', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '2.94');
INSERT INTO public.europe_data_import VALUES (9347, '21/12/2020', '2020-51', '670', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '1.15');
INSERT INTO public.europe_data_import VALUES (9348, '14/12/2020', '2020-50', '130', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (9349, '07/12/2020', '2020-49', '130', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.28');
INSERT INTO public.europe_data_import VALUES (9350, '30/11/2020', '2020-48', '64', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9351, '23/11/2020', '2020-47', '38', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9352, '16/11/2020', '2020-46', '35', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (9353, '09/11/2020', '2020-45', '53', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (9354, '02/11/2020', '2020-44', '44', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (9355, '26/10/2020', '2020-43', '52', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9356, '19/10/2020', '2020-42', '50', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9357, '12/10/2020', '2020-41', '51', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (9358, '05/10/2020', '2020-40', '45', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9359, '28/09/2020', '2020-39', '39', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9360, '21/09/2020', '2020-38', '31', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9361, '14/09/2020', '2020-37', '30', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9362, '07/09/2020', '2020-36', '33', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9363, '31/08/2020', '2020-35', '15', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9364, '24/08/2020', '2020-34', '19', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9365, '17/08/2020', '2020-33', '27', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9366, '10/08/2020', '2020-32', '31', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9367, '03/08/2020', '2020-31', '25', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9368, '27/07/2020', '2020-30', '45', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9369, '20/07/2020', '2020-29', '30', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9370, '13/07/2020', '2020-28', '25', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9371, '06/07/2020', '2020-27', '33', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9372, '29/06/2020', '2020-26', '14', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9373, '22/06/2020', '2020-25', '13', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9374, '15/06/2020', '2020-24', '16', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9375, '08/06/2020', '2020-23', '38', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9376, '01/06/2020', '2020-22', '39', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9377, '25/05/2020', '2020-21', '14', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9378, '18/05/2020', '2020-20', '13', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9379, '11/05/2020', '2020-19', '46', '2', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (9380, '04/05/2020', '2020-18', '47', '3', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (9381, '27/04/2020', '2020-17', '157', '4', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.49');
INSERT INTO public.europe_data_import VALUES (9382, '20/04/2020', '2020-16', '186', '7', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (9383, '13/04/2020', '2020-15', '359', '14', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (9384, '06/04/2020', '2020-14', '832', '19', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '2.15');
INSERT INTO public.europe_data_import VALUES (9385, '30/03/2020', '2020-13', '667', '6', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (9386, '23/03/2020', '2020-12', '607', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.96');
INSERT INTO public.europe_data_import VALUES (9387, '16/03/2020', '2020-11', '64', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9388, '09/03/2020', '2020-10', '7', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9389, '02/03/2020', '2020-09', '8', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9390, '24/02/2020', '2020-08', '1', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9391, '17/02/2020', '2020-07', '2', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9392, '10/02/2020', '2020-06', '13', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9393, '03/02/2020', '2020-05', '11', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9394, '27/01/2020', '2020-04', '6', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9395, '20/01/2020', '2020-03', '1', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9396, '13/01/2020', '2020-02', '1', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9397, '06/01/2020', '2020-01', '0', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9398, '01/02/2021', '2021-04', '3', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (9399, '25/01/2021', '2021-03', '15', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (9400, '18/01/2021', '2021-02', '3', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.62');
INSERT INTO public.europe_data_import VALUES (9401, '11/01/2021', '2021-01', '5', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.62');
INSERT INTO public.europe_data_import VALUES (9402, '04/01/2021', '2020-53', '3', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.01');
INSERT INTO public.europe_data_import VALUES (9403, '28/12/2020', '2020-52', '10', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (9404, '21/12/2020', '2020-51', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9405, '14/12/2020', '2020-50', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9406, '07/12/2020', '2020-49', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9407, '30/11/2020', '2020-48', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9408, '23/11/2020', '2020-47', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9409, '16/11/2020', '2020-46', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9410, '09/11/2020', '2020-45', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9411, '02/11/2020', '2020-44', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9412, '26/10/2020', '2020-43', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9413, '19/10/2020', '2020-42', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9414, '12/10/2020', '2020-41', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9415, '05/10/2020', '2020-40', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9416, '28/09/2020', '2020-39', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9417, '21/09/2020', '2020-38', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9418, '14/09/2020', '2020-37', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9419, '07/09/2020', '2020-36', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9420, '31/08/2020', '2020-35', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9421, '24/08/2020', '2020-34', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9422, '17/08/2020', '2020-33', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9423, '10/08/2020', '2020-32', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9424, '03/08/2020', '2020-31', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9425, '27/07/2020', '2020-30', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9426, '20/07/2020', '2020-29', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9427, '13/07/2020', '2020-28', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9428, '06/07/2020', '2020-27', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9429, '29/06/2020', '2020-26', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9430, '22/06/2020', '2020-25', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9431, '15/06/2020', '2020-24', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9432, '08/06/2020', '2020-23', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9433, '01/06/2020', '2020-22', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9434, '25/05/2020', '2020-21', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9435, '18/05/2020', '2020-20', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9436, '11/05/2020', '2020-19', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9437, '04/05/2020', '2020-18', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.39');
INSERT INTO public.europe_data_import VALUES (9438, '27/04/2020', '2020-17', '5', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.7');
INSERT INTO public.europe_data_import VALUES (9439, '20/04/2020', '2020-16', '17', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (9440, '13/04/2020', '2020-15', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9441, '06/04/2020', '2020-14', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9442, '30/03/2020', '2020-13', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9443, '23/03/2020', '2020-12', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9444, '01/02/2021', '2021-04', '430', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '9.77');
INSERT INTO public.europe_data_import VALUES (9445, '25/01/2021', '2021-03', '360', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '8.72');
INSERT INTO public.europe_data_import VALUES (9446, '18/01/2021', '2021-02', '345', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '7.42');
INSERT INTO public.europe_data_import VALUES (9447, '11/01/2021', '2021-01', '255', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '4.71');
INSERT INTO public.europe_data_import VALUES (9448, '04/01/2021', '2020-53', '126', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (9449, '28/12/2020', '2020-52', '160', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '4.02');
INSERT INTO public.europe_data_import VALUES (9450, '21/12/2020', '2020-51', '165', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.97');
INSERT INTO public.europe_data_import VALUES (9451, '14/12/2020', '2020-50', '156', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.58');
INSERT INTO public.europe_data_import VALUES (9452, '07/12/2020', '2020-49', '133', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.12');
INSERT INTO public.europe_data_import VALUES (9453, '30/11/2020', '2020-48', '119', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.55');
INSERT INTO public.europe_data_import VALUES (9454, '23/11/2020', '2020-47', '168', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '4.05');
INSERT INTO public.europe_data_import VALUES (9455, '16/11/2020', '2020-46', '159', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.93');
INSERT INTO public.europe_data_import VALUES (9456, '09/11/2020', '2020-45', '159', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (9457, '02/11/2020', '2020-44', '157', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (9458, '26/10/2020', '2020-43', '143', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.22');
INSERT INTO public.europe_data_import VALUES (9459, '19/10/2020', '2020-42', '117', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.51');
INSERT INTO public.europe_data_import VALUES (9460, '12/10/2020', '2020-41', '86', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.44');
INSERT INTO public.europe_data_import VALUES (9461, '05/10/2020', '2020-40', '111', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (9462, '28/09/2020', '2020-39', '77', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (9463, '21/09/2020', '2020-38', '94', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (9464, '14/09/2020', '2020-37', '84', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.18');
INSERT INTO public.europe_data_import VALUES (9465, '07/09/2020', '2020-36', '92', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.61');
INSERT INTO public.europe_data_import VALUES (9466, '31/08/2020', '2020-35', '119', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.08');
INSERT INTO public.europe_data_import VALUES (9467, '24/08/2020', '2020-34', '130', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (9468, '17/08/2020', '2020-33', '87', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (9469, '10/08/2020', '2020-32', '99', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.38');
INSERT INTO public.europe_data_import VALUES (9470, '03/08/2020', '2020-31', '93', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.31');
INSERT INTO public.europe_data_import VALUES (9471, '27/07/2020', '2020-30', '94', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.83');
INSERT INTO public.europe_data_import VALUES (9472, '20/07/2020', '2020-29', '54', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.16');
INSERT INTO public.europe_data_import VALUES (9473, '13/07/2020', '2020-28', '40', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (9474, '06/07/2020', '2020-27', '38', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.37');
INSERT INTO public.europe_data_import VALUES (9475, '29/06/2020', '2020-26', '73', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.37');
INSERT INTO public.europe_data_import VALUES (9476, '22/06/2020', '2020-25', '38', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.92');
INSERT INTO public.europe_data_import VALUES (9477, '15/06/2020', '2020-24', '36', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (9478, '08/06/2020', '2020-23', '53', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (9479, '01/06/2020', '2020-22', '61', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (9480, '25/05/2020', '2020-21', '80', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.56');
INSERT INTO public.europe_data_import VALUES (9481, '18/05/2020', '2020-20', '127', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.19');
INSERT INTO public.europe_data_import VALUES (9482, '11/05/2020', '2020-19', '50', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (9483, '04/05/2020', '2020-18', '26', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (9484, '27/04/2020', '2020-17', '14', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (9485, '20/04/2020', '2020-16', '8', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (9486, '13/04/2020', '2020-15', '32', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (9487, '06/04/2020', '2020-14', '14', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (9488, '30/03/2020', '2020-13', '15', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (9489, '23/03/2020', '2020-12', '14', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (9490, '16/03/2020', '2020-11', '1', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9491, '01/02/2021', '2021-04', '74', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '12.26');
INSERT INTO public.europe_data_import VALUES (9492, '25/01/2021', '2021-03', '97', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '16.13');
INSERT INTO public.europe_data_import VALUES (9493, '18/01/2021', '2021-02', '128', '4', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '16.13');
INSERT INTO public.europe_data_import VALUES (9494, '11/01/2021', '2021-01', '97', '1', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '10.75');
INSERT INTO public.europe_data_import VALUES (9495, '04/01/2021', '2020-53', '53', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '11.18');
INSERT INTO public.europe_data_import VALUES (9496, '28/12/2020', '2020-52', '103', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '16.92');
INSERT INTO public.europe_data_import VALUES (9497, '21/12/2020', '2020-51', '133', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '17.56');
INSERT INTO public.europe_data_import VALUES (9498, '14/12/2020', '2020-50', '112', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '15.7');
INSERT INTO public.europe_data_import VALUES (9499, '07/12/2020', '2020-49', '107', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '22.72');
INSERT INTO public.europe_data_import VALUES (9500, '30/11/2020', '2020-48', '210', '5', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '41.58');
INSERT INTO public.europe_data_import VALUES (9501, '23/11/2020', '2020-47', '370', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '43.08');
INSERT INTO public.europe_data_import VALUES (9502, '16/11/2020', '2020-46', '231', '1', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '29.53');
INSERT INTO public.europe_data_import VALUES (9503, '09/11/2020', '2020-45', '181', '4', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '24.23');
INSERT INTO public.europe_data_import VALUES (9504, '02/11/2020', '2020-44', '157', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '26.6');
INSERT INTO public.europe_data_import VALUES (9505, '26/10/2020', '2020-43', '214', '9', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '29.39');
INSERT INTO public.europe_data_import VALUES (9506, '19/10/2020', '2020-42', '196', '6', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '38.28');
INSERT INTO public.europe_data_import VALUES (9507, '12/10/2020', '2020-41', '338', '9', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '52.98');
INSERT INTO public.europe_data_import VALUES (9508, '05/10/2020', '2020-40', '401', '10', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '61.79');
INSERT INTO public.europe_data_import VALUES (9509, '28/09/2020', '2020-39', '461', '6', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '94.63');
INSERT INTO public.europe_data_import VALUES (9510, '21/09/2020', '2020-38', '859', '12', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '118.35');
INSERT INTO public.europe_data_import VALUES (9511, '14/09/2020', '2020-37', '792', '19', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '97.42');
INSERT INTO public.europe_data_import VALUES (9512, '07/09/2020', '2020-36', '567', '13', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '89.11');
INSERT INTO public.europe_data_import VALUES (9513, '31/08/2020', '2020-35', '676', '7', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '81.08');
INSERT INTO public.europe_data_import VALUES (9514, '24/08/2020', '2020-34', '455', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '52.19');
INSERT INTO public.europe_data_import VALUES (9515, '17/08/2020', '2020-33', '273', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '26.52');
INSERT INTO public.europe_data_import VALUES (9516, '10/08/2020', '2020-32', '97', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (9517, '03/08/2020', '2020-31', '35', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '3.23');
INSERT INTO public.europe_data_import VALUES (9518, '27/07/2020', '2020-30', '10', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '1.0');
INSERT INTO public.europe_data_import VALUES (9519, '20/07/2020', '2020-29', '4', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.29');
INSERT INTO public.europe_data_import VALUES (9520, '13/07/2020', '2020-28', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.5');
INSERT INTO public.europe_data_import VALUES (9521, '06/07/2020', '2020-27', '7', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (9522, '29/06/2020', '2020-26', '3', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (9523, '22/06/2020', '2020-25', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.43');
INSERT INTO public.europe_data_import VALUES (9524, '15/06/2020', '2020-24', '6', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.43');
INSERT INTO public.europe_data_import VALUES (9525, '08/06/2020', '2020-23', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.07');
INSERT INTO public.europe_data_import VALUES (9526, '01/06/2020', '2020-22', '1', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.07');
INSERT INTO public.europe_data_import VALUES (9527, '25/05/2020', '2020-21', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9528, '18/05/2020', '2020-20', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9529, '11/05/2020', '2020-19', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9530, '04/05/2020', '2020-18', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.14');
INSERT INTO public.europe_data_import VALUES (9531, '27/04/2020', '2020-17', '2', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (9532, '20/04/2020', '2020-16', '1', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (9533, '13/04/2020', '2020-15', '9', '1', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '2.51');
INSERT INTO public.europe_data_import VALUES (9534, '06/04/2020', '2020-14', '26', '4', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '3.87');
INSERT INTO public.europe_data_import VALUES (9535, '30/03/2020', '2020-13', '28', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '5.3');
INSERT INTO public.europe_data_import VALUES (9536, '23/03/2020', '2020-12', '46', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '3.58');
INSERT INTO public.europe_data_import VALUES (9537, '16/03/2020', '2020-11', '4', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '');
INSERT INTO public.europe_data_import VALUES (9538, '01/02/2021', '2021-04', '11409', '515', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '240.79');
INSERT INTO public.europe_data_import VALUES (9539, '25/01/2021', '2021-03', '16751', '537', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '310.28');
INSERT INTO public.europe_data_import VALUES (9540, '18/01/2021', '2021-02', '19535', '466', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '327.85');
INSERT INTO public.europe_data_import VALUES (9541, '11/01/2021', '2021-01', '18806', '484', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '263.01');
INSERT INTO public.europe_data_import VALUES (9542, '04/01/2021', '2020-53', '11952', '334', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '186.63');
INSERT INTO public.europe_data_import VALUES (9543, '28/12/2020', '2020-52', '9874', '267', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '172.99');
INSERT INTO public.europe_data_import VALUES (9544, '21/12/2020', '2020-51', '10357', '305', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '151.49');
INSERT INTO public.europe_data_import VALUES (9545, '14/12/2020', '2020-50', '7359', '333', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '129.2');
INSERT INTO public.europe_data_import VALUES (9546, '07/12/2020', '2020-49', '7751', '342', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '130.75');
INSERT INTO public.europe_data_import VALUES (9547, '30/11/2020', '2020-48', '7540', '398', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '135.51');
INSERT INTO public.europe_data_import VALUES (9548, '23/11/2020', '2020-47', '8307', '476', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '150.43');
INSERT INTO public.europe_data_import VALUES (9549, '16/11/2020', '2020-46', '9285', '472', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '158.17');
INSERT INTO public.europe_data_import VALUES (9550, '09/11/2020', '2020-45', '9213', '492', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '190.86');
INSERT INTO public.europe_data_import VALUES (9551, '02/11/2020', '2020-44', '13107', '562', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '182.68');
INSERT INTO public.europe_data_import VALUES (9552, '26/10/2020', '2020-43', '8257', '193', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '149.98');
INSERT INTO public.europe_data_import VALUES (9553, '19/10/2020', '2020-42', '9283', '170', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '146.13');
INSERT INTO public.europe_data_import VALUES (9554, '12/10/2020', '2020-41', '7806', '135', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '129.5');
INSERT INTO public.europe_data_import VALUES (9555, '05/10/2020', '2020-40', '7339', '107', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '108.78');
INSERT INTO public.europe_data_import VALUES (9556, '28/09/2020', '2020-39', '5382', '55', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '81.05');
INSERT INTO public.europe_data_import VALUES (9557, '21/09/2020', '2020-38', '4097', '52', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '50.93');
INSERT INTO public.europe_data_import VALUES (9558, '14/09/2020', '2020-37', '1859', '14', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '25.23');
INSERT INTO public.europe_data_import VALUES (9559, '07/09/2020', '2020-36', '1091', '17', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '17.43');
INSERT INTO public.europe_data_import VALUES (9560, '31/08/2020', '2020-35', '947', '8', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '13.49');
INSERT INTO public.europe_data_import VALUES (9561, '24/08/2020', '2020-34', '631', '14', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '8.9');
INSERT INTO public.europe_data_import VALUES (9562, '17/08/2020', '2020-33', '410', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '4.67');
INSERT INTO public.europe_data_import VALUES (9563, '10/08/2020', '2020-32', '136', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (9564, '03/08/2020', '2020-31', '109', '1', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.6');
INSERT INTO public.europe_data_import VALUES (9565, '27/07/2020', '2020-30', '78', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.62');
INSERT INTO public.europe_data_import VALUES (9566, '20/07/2020', '2020-29', '111', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.59');
INSERT INTO public.europe_data_import VALUES (9567, '13/07/2020', '2020-28', '75', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (9568, '06/07/2020', '2020-27', '19', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (9569, '29/06/2020', '2020-26', '12', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (9570, '22/06/2020', '2020-25', '61', '1', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (9571, '15/06/2020', '2020-24', '9', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (9572, '08/06/2020', '2020-23', '10', '1', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (9573, '01/06/2020', '2020-22', '26', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (9574, '25/05/2020', '2020-21', '14', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (9575, '18/05/2020', '2020-20', '5', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (9576, '11/05/2020', '2020-19', '19', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.71');
INSERT INTO public.europe_data_import VALUES (9577, '04/05/2020', '2020-18', '64', '4', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.15');
INSERT INTO public.europe_data_import VALUES (9578, '27/04/2020', '2020-17', '70', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.07');
INSERT INTO public.europe_data_import VALUES (9579, '20/04/2020', '2020-16', '172', '7', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.79');
INSERT INTO public.europe_data_import VALUES (9580, '13/04/2020', '2020-15', '154', '12', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (9581, '06/04/2020', '2020-14', '275', '11', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (9582, '30/03/2020', '2020-13', '203', '5', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.22');
INSERT INTO public.europe_data_import VALUES (9583, '23/03/2020', '2020-12', '57', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.64');
INSERT INTO public.europe_data_import VALUES (9584, '16/03/2020', '2020-11', '18', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9585, '01/02/2021', '2021-04', '47858', '920', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '110.19');
INSERT INTO public.europe_data_import VALUES (9586, '25/01/2021', '2021-03', '42504', '1076', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '126.03');
INSERT INTO public.europe_data_import VALUES (9587, '18/01/2021', '2021-02', '60845', '1190', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '177.05');
INSERT INTO public.europe_data_import VALUES (9588, '11/01/2021', '2021-01', '84344', '1319', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '217.89');
INSERT INTO public.europe_data_import VALUES (9589, '04/01/2021', '2020-53', '94334', '1610', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '265.0');
INSERT INTO public.europe_data_import VALUES (9590, '28/12/2020', '2020-52', '122977', '1781', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '379.07');
INSERT INTO public.europe_data_import VALUES (9591, '21/12/2020', '2020-51', '187873', '1680', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '492.06');
INSERT INTO public.europe_data_import VALUES (9592, '14/12/2020', '2020-50', '215632', '1517', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '532.05');
INSERT INTO public.europe_data_import VALUES (9593, '07/12/2020', '2020-49', '220667', '1342', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '463.55');
INSERT INTO public.europe_data_import VALUES (9594, '30/11/2020', '2020-48', '159462', '1200', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '291.6');
INSERT INTO public.europe_data_import VALUES (9595, '23/11/2020', '2020-47', '79659', '851', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '179.01');
INSERT INTO public.europe_data_import VALUES (9596, '16/11/2020', '2020-46', '67133', '620', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '159.78');
INSERT INTO public.europe_data_import VALUES (9597, '09/11/2020', '2020-45', '63892', '561', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '154.47');
INSERT INTO public.europe_data_import VALUES (9598, '02/11/2020', '2020-44', '62782', '527', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '151.46');
INSERT INTO public.europe_data_import VALUES (9599, '26/10/2020', '2020-43', '61418', '503', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '146.93');
INSERT INTO public.europe_data_import VALUES (9600, '19/10/2020', '2020-42', '59070', '459', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '143.01');
INSERT INTO public.europe_data_import VALUES (9601, '12/10/2020', '2020-41', '58200', '396', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '140.63');
INSERT INTO public.europe_data_import VALUES (9602, '05/10/2020', '2020-40', '57120', '444', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '141.21');
INSERT INTO public.europe_data_import VALUES (9603, '28/09/2020', '2020-39', '58676', '491', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '143.27');
INSERT INTO public.europe_data_import VALUES (9604, '21/09/2020', '2020-38', '58815', '450', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '143.02');
INSERT INTO public.europe_data_import VALUES (9605, '14/09/2020', '2020-37', '58466', '383', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '142.48');
INSERT INTO public.europe_data_import VALUES (9606, '07/09/2020', '2020-36', '58370', '347', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '141.18');
INSERT INTO public.europe_data_import VALUES (9607, '31/08/2020', '2020-35', '57407', '205', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '138.36');
INSERT INTO public.europe_data_import VALUES (9608, '24/08/2020', '2020-34', '56050', '147', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '136.17');
INSERT INTO public.europe_data_import VALUES (9609, '17/08/2020', '2020-33', '55615', '130', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '134.96');
INSERT INTO public.europe_data_import VALUES (9610, '10/08/2020', '2020-32', '55058', '116', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '124.62');
INSERT INTO public.europe_data_import VALUES (9611, '03/08/2020', '2020-31', '47136', '115', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '65.36');
INSERT INTO public.europe_data_import VALUES (9612, '27/07/2020', '2020-30', '6459', '122', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '15.98');
INSERT INTO public.europe_data_import VALUES (9613, '20/07/2020', '2020-29', '6648', '128', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '16.93');
INSERT INTO public.europe_data_import VALUES (9614, '13/07/2020', '2020-28', '7235', '138', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '19.21');
INSERT INTO public.europe_data_import VALUES (9615, '06/07/2020', '2020-27', '8519', '128', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '22.04');
INSERT INTO public.europe_data_import VALUES (9616, '29/06/2020', '2020-26', '9554', '147', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '23.17');
INSERT INTO public.europe_data_import VALUES (9617, '22/06/2020', '2020-25', '9446', '143', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '21.41');
INSERT INTO public.europe_data_import VALUES (9618, '15/06/2020', '2020-24', '8107', '115', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '17.43');
INSERT INTO public.europe_data_import VALUES (9619, '08/06/2020', '2020-23', '6190', '152', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '16.22');
INSERT INTO public.europe_data_import VALUES (9620, '01/06/2020', '2020-22', '7115', '200', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '17.69');
INSERT INTO public.europe_data_import VALUES (9621, '25/05/2020', '2020-21', '7392', '200', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '22.16');
INSERT INTO public.europe_data_import VALUES (9622, '18/05/2020', '2020-20', '10778', '354', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '28.52');
INSERT INTO public.europe_data_import VALUES (9623, '11/05/2020', '2020-19', '12612', '389', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '34.79');
INSERT INTO public.europe_data_import VALUES (9624, '04/05/2020', '2020-18', '15915', '592', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '48.46');
INSERT INTO public.europe_data_import VALUES (9625, '27/04/2020', '2020-17', '23824', '788', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '64.84');
INSERT INTO public.europe_data_import VALUES (9626, '20/04/2020', '2020-16', '29350', '819', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '72.24');
INSERT INTO public.europe_data_import VALUES (9627, '13/04/2020', '2020-15', '29887', '624', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '58.15');
INSERT INTO public.europe_data_import VALUES (9628, '06/04/2020', '2020-14', '17798', '443', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '31.5');
INSERT INTO public.europe_data_import VALUES (9629, '30/03/2020', '2020-13', '8035', '101', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '11.28');
INSERT INTO public.europe_data_import VALUES (9630, '23/03/2020', '2020-12', '1218', '30', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '1.51');
INSERT INTO public.europe_data_import VALUES (9631, '16/03/2020', '2020-11', '18', '0', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9632, '01/02/2021', '2021-04', '217', '2', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '1044.67');
INSERT INTO public.europe_data_import VALUES (9633, '25/01/2021', '2021-03', '182', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '767.14');
INSERT INTO public.europe_data_import VALUES (9634, '18/01/2021', '2021-02', '111', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '510.55');
INSERT INTO public.europe_data_import VALUES (9635, '11/01/2021', '2021-01', '84', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '379.64');
INSERT INTO public.europe_data_import VALUES (9636, '04/01/2021', '2020-53', '61', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '293.24');
INSERT INTO public.europe_data_import VALUES (9637, '28/12/2020', '2020-52', '51', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '209.46');
INSERT INTO public.europe_data_import VALUES (9638, '21/12/2020', '2020-51', '29', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '109.96');
INSERT INTO public.europe_data_import VALUES (9639, '14/12/2020', '2020-50', '13', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '54.98');
INSERT INTO public.europe_data_import VALUES (9640, '07/12/2020', '2020-49', '8', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '26.18');
INSERT INTO public.europe_data_import VALUES (9641, '30/11/2020', '2020-48', '2', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '73.31');
INSERT INTO public.europe_data_import VALUES (9642, '23/11/2020', '2020-47', '26', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '102.11');
INSERT INTO public.europe_data_import VALUES (9643, '16/11/2020', '2020-46', '13', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '41.89');
INSERT INTO public.europe_data_import VALUES (9644, '09/11/2020', '2020-45', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9645, '02/11/2020', '2020-44', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9646, '26/10/2020', '2020-43', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9647, '19/10/2020', '2020-42', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '7.85');
INSERT INTO public.europe_data_import VALUES (9648, '12/10/2020', '2020-41', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '34.04');
INSERT INTO public.europe_data_import VALUES (9649, '05/10/2020', '2020-40', '13', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '70.69');
INSERT INTO public.europe_data_import VALUES (9650, '28/09/2020', '2020-39', '14', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '94.26');
INSERT INTO public.europe_data_import VALUES (9651, '21/09/2020', '2020-38', '22', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '183.27');
INSERT INTO public.europe_data_import VALUES (9652, '14/09/2020', '2020-37', '48', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '363.93');
INSERT INTO public.europe_data_import VALUES (9653, '07/09/2020', '2020-36', '91', '2', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '562.92');
INSERT INTO public.europe_data_import VALUES (9654, '31/08/2020', '2020-35', '124', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '547.21');
INSERT INTO public.europe_data_import VALUES (9655, '24/08/2020', '2020-34', '85', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '437.24');
INSERT INTO public.europe_data_import VALUES (9656, '17/08/2020', '2020-33', '82', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '476.51');
INSERT INTO public.europe_data_import VALUES (9657, '10/08/2020', '2020-32', '100', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '306.33');
INSERT INTO public.europe_data_import VALUES (9658, '03/08/2020', '2020-31', '17', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '91.64');
INSERT INTO public.europe_data_import VALUES (9659, '27/07/2020', '2020-30', '18', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '70.69');
INSERT INTO public.europe_data_import VALUES (9660, '20/07/2020', '2020-29', '9', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '89.02');
INSERT INTO public.europe_data_import VALUES (9661, '13/07/2020', '2020-28', '25', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '115.2');
INSERT INTO public.europe_data_import VALUES (9662, '06/07/2020', '2020-27', '19', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '86.4');
INSERT INTO public.europe_data_import VALUES (9663, '29/06/2020', '2020-26', '14', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '41.89');
INSERT INTO public.europe_data_import VALUES (9664, '22/06/2020', '2020-25', '2', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '5.24');
INSERT INTO public.europe_data_import VALUES (9665, '15/06/2020', '2020-24', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9666, '08/06/2020', '2020-23', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9667, '01/06/2020', '2020-22', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9668, '25/05/2020', '2020-21', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9669, '18/05/2020', '2020-20', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9670, '11/05/2020', '2020-19', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '2.62');
INSERT INTO public.europe_data_import VALUES (9671, '04/05/2020', '2020-18', '1', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '2.62');
INSERT INTO public.europe_data_import VALUES (9672, '27/04/2020', '2020-17', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '5.24');
INSERT INTO public.europe_data_import VALUES (9673, '20/04/2020', '2020-16', '2', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9674, '13/04/2020', '2020-15', '4', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '10.47');
INSERT INTO public.europe_data_import VALUES (9675, '06/04/2020', '2020-14', '0', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '13.09');
INSERT INTO public.europe_data_import VALUES (9676, '30/03/2020', '2020-13', '5', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '');
INSERT INTO public.europe_data_import VALUES (9677, '01/02/2021', '2021-04', '418', '7', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.44');
INSERT INTO public.europe_data_import VALUES (9678, '25/01/2021', '2021-03', '1103', '14', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.12');
INSERT INTO public.europe_data_import VALUES (9679, '18/01/2021', '2021-02', '277', '2', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (9680, '11/01/2021', '2021-01', '1758', '28', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '8.66');
INSERT INTO public.europe_data_import VALUES (9681, '04/01/2021', '2020-53', '2077', '26', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '10.98');
INSERT INTO public.europe_data_import VALUES (9682, '28/12/2020', '2020-52', '2786', '17', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '14.55');
INSERT INTO public.europe_data_import VALUES (9683, '21/12/2020', '2020-51', '3655', '10', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '19.63');
INSERT INTO public.europe_data_import VALUES (9684, '14/12/2020', '2020-50', '5033', '15', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '16.69');
INSERT INTO public.europe_data_import VALUES (9685, '07/12/2020', '2020-49', '2354', '5', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '10.24');
INSERT INTO public.europe_data_import VALUES (9686, '30/11/2020', '2020-48', '2177', '29', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '9.32');
INSERT INTO public.europe_data_import VALUES (9687, '23/11/2020', '2020-47', '1948', '27', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '8.05');
INSERT INTO public.europe_data_import VALUES (9688, '16/11/2020', '2020-46', '1617', '13', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '7.4');
INSERT INTO public.europe_data_import VALUES (9689, '09/11/2020', '2020-45', '1660', '20', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '6.69');
INSERT INTO public.europe_data_import VALUES (9690, '02/11/2020', '2020-44', '1300', '11', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.86');
INSERT INTO public.europe_data_import VALUES (9691, '26/10/2020', '2020-43', '853', '4', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (9692, '19/10/2020', '2020-42', '789', '4', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.03');
INSERT INTO public.europe_data_import VALUES (9693, '12/10/2020', '2020-41', '993', '12', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '5.13');
INSERT INTO public.europe_data_import VALUES (9694, '05/10/2020', '2020-40', '1278', '8', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '5.69');
INSERT INTO public.europe_data_import VALUES (9695, '28/09/2020', '2020-39', '1243', '10', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '6.17');
INSERT INTO public.europe_data_import VALUES (9696, '21/09/2020', '2020-38', '1488', '8', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '5.92');
INSERT INTO public.europe_data_import VALUES (9697, '14/09/2020', '2020-37', '1132', '14', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.23');
INSERT INTO public.europe_data_import VALUES (9698, '07/09/2020', '2020-36', '739', '11', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.17');
INSERT INTO public.europe_data_import VALUES (9699, '31/08/2020', '2020-35', '665', '11', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.23');
INSERT INTO public.europe_data_import VALUES (9700, '24/08/2020', '2020-34', '763', '6', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (9701, '17/08/2020', '2020-33', '217', '6', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (9702, '10/08/2020', '2020-32', '101', '3', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (9703, '03/08/2020', '2020-31', '67', '2', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (9704, '27/07/2020', '2020-30', '50', '2', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (9705, '20/07/2020', '2020-29', '40', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (9706, '13/07/2020', '2020-28', '86', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (9707, '06/07/2020', '2020-27', '80', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (9708, '29/06/2020', '2020-26', '89', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (9709, '22/06/2020', '2020-25', '74', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (9710, '15/06/2020', '2020-24', '80', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (9711, '08/06/2020', '2020-23', '158', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (9712, '01/06/2020', '2020-22', '246', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (9713, '25/05/2020', '2020-21', '-15', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (9714, '18/05/2020', '2020-20', '106', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (9715, '11/05/2020', '2020-19', '32', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (9716, '04/05/2020', '2020-18', '10', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (9717, '27/04/2020', '2020-17', '24', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (9718, '20/04/2020', '2020-16', '1', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (9719, '13/04/2020', '2020-15', '2', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (9720, '06/04/2020', '2020-14', '19', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (9721, '30/03/2020', '2020-13', '32', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (9722, '23/03/2020', '2020-12', '1', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9723, '01/02/2021', '2021-04', '29551', '1010', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '136.75');
INSERT INTO public.europe_data_import VALUES (9724, '25/01/2021', '2021-03', '30612', '1055', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '170.51');
INSERT INTO public.europe_data_import VALUES (9725, '18/01/2021', '2021-02', '44402', '1034', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '203.72');
INSERT INTO public.europe_data_import VALUES (9726, '11/01/2021', '2021-01', '45221', '981', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '202.17');
INSERT INTO public.europe_data_import VALUES (9727, '04/01/2021', '2020-53', '43719', '1005', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '234.35');
INSERT INTO public.europe_data_import VALUES (9728, '28/12/2020', '2020-52', '59381', '1184', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '294.83');
INSERT INTO public.europe_data_import VALUES (9729, '21/12/2020', '2020-51', '70327', '1418', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '358.43');
INSERT INTO public.europe_data_import VALUES (9730, '14/12/2020', '2020-50', '87360', '1659', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '404.57');
INSERT INTO public.europe_data_import VALUES (9731, '07/12/2020', '2020-49', '90627', '1375', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '456.07');
INSERT INTO public.europe_data_import VALUES (9732, '30/11/2020', '2020-48', '110014', '1400', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '424.66');
INSERT INTO public.europe_data_import VALUES (9733, '23/11/2020', '2020-47', '76808', '1210', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '346.26');
INSERT INTO public.europe_data_import VALUES (9734, '16/11/2020', '2020-46', '75526', '1153', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '319.18');
INSERT INTO public.europe_data_import VALUES (9735, '09/11/2020', '2020-45', '64891', '1144', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '265.59');
INSERT INTO public.europe_data_import VALUES (9736, '02/11/2020', '2020-44', '51951', '915', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '208.67');
INSERT INTO public.europe_data_import VALUES (9737, '26/10/2020', '2020-43', '39851', '718', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '187.42');
INSERT INTO public.europe_data_import VALUES (9738, '19/10/2020', '2020-42', '42604', '701', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '175.43');
INSERT INTO public.europe_data_import VALUES (9739, '12/10/2020', '2020-41', '34572', '575', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '141.84');
INSERT INTO public.europe_data_import VALUES (9740, '05/10/2020', '2020-40', '27828', '438', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '115.43');
INSERT INTO public.europe_data_import VALUES (9741, '28/09/2020', '2020-39', '22956', '402', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '100.69');
INSERT INTO public.europe_data_import VALUES (9742, '21/09/2020', '2020-38', '21343', '379', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '90.43');
INSERT INTO public.europe_data_import VALUES (9743, '14/09/2020', '2020-37', '18441', '367', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '80.15');
INSERT INTO public.europe_data_import VALUES (9744, '07/09/2020', '2020-36', '16820', '284', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '70.32');
INSERT INTO public.europe_data_import VALUES (9745, '31/08/2020', '2020-35', '14116', '256', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '59.68');
INSERT INTO public.europe_data_import VALUES (9746, '24/08/2020', '2020-34', '12138', '182', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '52.28');
INSERT INTO public.europe_data_import VALUES (9747, '17/08/2020', '2020-33', '10863', '167', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '46.94');
INSERT INTO public.europe_data_import VALUES (9748, '10/08/2020', '2020-32', '9789', '197', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '38.89');
INSERT INTO public.europe_data_import VALUES (9749, '03/08/2020', '2020-31', '7319', '120', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '30.29');
INSERT INTO public.europe_data_import VALUES (9750, '27/07/2020', '2020-30', '6007', '120', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '25.75');
INSERT INTO public.europe_data_import VALUES (9751, '20/07/2020', '2020-29', '5321', '102', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '23.51');
INSERT INTO public.europe_data_import VALUES (9752, '13/07/2020', '2020-28', '5021', '134', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '23.96');
INSERT INTO public.europe_data_import VALUES (9753, '06/07/2020', '2020-27', '5518', '120', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '27.14');
INSERT INTO public.europe_data_import VALUES (9754, '29/06/2020', '2020-26', '6422', '127', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '26.89');
INSERT INTO public.europe_data_import VALUES (9755, '22/06/2020', '2020-25', '5406', '113', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '21.73');
INSERT INTO public.europe_data_import VALUES (9756, '15/06/2020', '2020-24', '4155', '101', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '17.01');
INSERT INTO public.europe_data_import VALUES (9757, '08/06/2020', '2020-23', '3327', '80', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '13.67');
INSERT INTO public.europe_data_import VALUES (9758, '01/06/2020', '2020-22', '2686', '91', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '12.23');
INSERT INTO public.europe_data_import VALUES (9759, '25/05/2020', '2020-21', '2695', '103', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '13.08');
INSERT INTO public.europe_data_import VALUES (9760, '18/05/2020', '2020-20', '3059', '123', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '14.5');
INSERT INTO public.europe_data_import VALUES (9761, '11/05/2020', '2020-19', '3319', '103', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '15.04');
INSERT INTO public.europe_data_import VALUES (9762, '04/05/2020', '2020-18', '3296', '79', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '14.69');
INSERT INTO public.europe_data_import VALUES (9763, '27/04/2020', '2020-17', '3168', '68', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '13.27');
INSERT INTO public.europe_data_import VALUES (9764, '20/04/2020', '2020-16', '2672', '58', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '9.41');
INSERT INTO public.europe_data_import VALUES (9765, '13/04/2020', '2020-15', '1469', '46', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '5.36');
INSERT INTO public.europe_data_import VALUES (9766, '06/04/2020', '2020-14', '890', '28', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '2.87');
INSERT INTO public.europe_data_import VALUES (9767, '30/03/2020', '2020-13', '371', '6', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '0.94');
INSERT INTO public.europe_data_import VALUES (9768, '23/03/2020', '2020-12', '44', '3', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '0.11');
INSERT INTO public.europe_data_import VALUES (9769, '16/03/2020', '2020-11', '3', '0', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9770, '01/02/2021', '2021-04', '25654', '58', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '515.3');
INSERT INTO public.europe_data_import VALUES (9771, '25/01/2021', '2021-03', '24694', '47', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '460.29');
INSERT INTO public.europe_data_import VALUES (9772, '18/01/2021', '2021-02', '20279', '34', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '394.34');
INSERT INTO public.europe_data_import VALUES (9773, '11/01/2021', '2021-01', '18250', '29', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '318.78');
INSERT INTO public.europe_data_import VALUES (9774, '04/01/2021', '2020-53', '12896', '25', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '216.54');
INSERT INTO public.europe_data_import VALUES (9775, '28/12/2020', '2020-52', '8261', '20', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '172.84');
INSERT INTO public.europe_data_import VALUES (9776, '21/12/2020', '2020-51', '8626', '20', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '175.49');
INSERT INTO public.europe_data_import VALUES (9777, '14/12/2020', '2020-50', '8520', '25', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '176.0');
INSERT INTO public.europe_data_import VALUES (9778, '07/12/2020', '2020-49', '8676', '22', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '178.49');
INSERT INTO public.europe_data_import VALUES (9779, '30/11/2020', '2020-48', '8763', '18', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '178.17');
INSERT INTO public.europe_data_import VALUES (9780, '23/11/2020', '2020-47', '8645', '22', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '172.43');
INSERT INTO public.europe_data_import VALUES (9781, '16/11/2020', '2020-46', '8202', '16', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '168.24');
INSERT INTO public.europe_data_import VALUES (9782, '09/11/2020', '2020-45', '8236', '18', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '174.2');
INSERT INTO public.europe_data_import VALUES (9783, '02/11/2020', '2020-44', '8784', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '187.35');
INSERT INTO public.europe_data_import VALUES (9784, '26/10/2020', '2020-43', '9521', '14', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '193.38');
INSERT INTO public.europe_data_import VALUES (9785, '19/10/2020', '2020-42', '9373', '18', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '171.96');
INSERT INTO public.europe_data_import VALUES (9786, '12/10/2020', '2020-41', '7428', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '151.07');
INSERT INTO public.europe_data_import VALUES (9787, '05/10/2020', '2020-40', '7332', '14', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '142.11');
INSERT INTO public.europe_data_import VALUES (9788, '28/09/2020', '2020-39', '6553', '8', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '122.61');
INSERT INTO public.europe_data_import VALUES (9789, '21/09/2020', '2020-38', '5427', '5', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '111.89');
INSERT INTO public.europe_data_import VALUES (9790, '14/09/2020', '2020-37', '5505', '11', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '100.29');
INSERT INTO public.europe_data_import VALUES (9791, '07/09/2020', '2020-36', '4294', '6', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '71.41');
INSERT INTO public.europe_data_import VALUES (9792, '31/08/2020', '2020-35', '2683', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '55.04');
INSERT INTO public.europe_data_import VALUES (9793, '24/08/2020', '2020-34', '2695', '11', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '45.87');
INSERT INTO public.europe_data_import VALUES (9794, '17/08/2020', '2020-33', '1787', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '33.91');
INSERT INTO public.europe_data_import VALUES (9795, '10/08/2020', '2020-32', '1526', '6', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '36.97');
INSERT INTO public.europe_data_import VALUES (9796, '03/08/2020', '2020-31', '2086', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '41.73');
INSERT INTO public.europe_data_import VALUES (9797, '27/07/2020', '2020-30', '1991', '5', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '41.54');
INSERT INTO public.europe_data_import VALUES (9798, '20/07/2020', '2020-29', '2068', '6', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '55.08');
INSERT INTO public.europe_data_import VALUES (9799, '13/07/2020', '2020-28', '3314', '10', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '72.23');
INSERT INTO public.europe_data_import VALUES (9800, '06/07/2020', '2020-27', '3743', '10', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '67.7');
INSERT INTO public.europe_data_import VALUES (9801, '29/06/2020', '2020-26', '2872', '11', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '56.32');
INSERT INTO public.europe_data_import VALUES (9802, '22/06/2020', '2020-25', '2631', '13', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '62.61');
INSERT INTO public.europe_data_import VALUES (9803, '15/06/2020', '2020-24', '3486', '13', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '79.19');
INSERT INTO public.europe_data_import VALUES (9804, '08/06/2020', '2020-23', '4251', '12', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '95.42');
INSERT INTO public.europe_data_import VALUES (9805, '01/06/2020', '2020-22', '5072', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '114.62');
INSERT INTO public.europe_data_import VALUES (9806, '25/05/2020', '2020-21', '6127', '25', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '115.52');
INSERT INTO public.europe_data_import VALUES (9807, '18/05/2020', '2020-20', '5160', '22', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '94.11');
INSERT INTO public.europe_data_import VALUES (9808, '11/05/2020', '2020-19', '4035', '72', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '80.33');
INSERT INTO public.europe_data_import VALUES (9809, '04/05/2020', '2020-18', '3814', '50', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '73.9');
INSERT INTO public.europe_data_import VALUES (9810, '27/04/2020', '2020-17', '3406', '35', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '65.17');
INSERT INTO public.europe_data_import VALUES (9811, '20/04/2020', '2020-16', '2961', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '52.81');
INSERT INTO public.europe_data_import VALUES (9812, '13/04/2020', '2020-15', '2199', '12', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '34.92');
INSERT INTO public.europe_data_import VALUES (9813, '06/04/2020', '2020-14', '1213', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '16.68');
INSERT INTO public.europe_data_import VALUES (9814, '30/03/2020', '2020-13', '417', '1', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '4.83');
INSERT INTO public.europe_data_import VALUES (9815, '23/03/2020', '2020-12', '55', '2', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '1.11');
INSERT INTO public.europe_data_import VALUES (9816, '16/03/2020', '2020-11', '53', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.79');
INSERT INTO public.europe_data_import VALUES (9817, '09/03/2020', '2020-10', '24', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.33');
INSERT INTO public.europe_data_import VALUES (9818, '02/03/2020', '2020-09', '8', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9819, '24/02/2020', '2020-08', '4', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (9820, '17/02/2020', '2020-07', '2', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9821, '10/02/2020', '2020-06', '2', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (9822, '03/02/2020', '2020-05', '4', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9823, '27/01/2020', '2020-04', '1', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9824, '20/01/2020', '2020-03', '0', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9825, '13/01/2020', '2020-02', '0', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9826, '06/01/2020', '2020-01', '0', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9827, '01/02/2021', '2021-04', '169713', '8219', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '632.01');
INSERT INTO public.europe_data_import VALUES (9828, '25/01/2021', '2021-03', '251504', '8678', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '862.92');
INSERT INTO public.europe_data_import VALUES (9829, '18/01/2021', '2021-02', '323610', '7830', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '1112.1');
INSERT INTO public.europe_data_import VALUES (9830, '11/01/2021', '2021-01', '417570', '6407', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '1114.26');
INSERT INTO public.europe_data_import VALUES (9831, '04/01/2021', '2020-53', '325049', '3915', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '922.22');
INSERT INTO public.europe_data_import VALUES (9832, '28/12/2020', '2020-52', '289583', '3708', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '720.7');
INSERT INTO public.europe_data_import VALUES (9833, '21/12/2020', '2020-51', '190744', '3231', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '475.5');
INSERT INTO public.europe_data_import VALUES (9834, '14/12/2020', '2020-50', '126161', '2925', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '348.22');
INSERT INTO public.europe_data_import VALUES (9835, '07/12/2020', '2020-49', '105915', '3000', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '316.89');
INSERT INTO public.europe_data_import VALUES (9836, '30/11/2020', '2020-48', '105282', '3494', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '372.12');
INSERT INTO public.europe_data_import VALUES (9837, '23/11/2020', '2020-47', '142727', '2817', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '480.19');
INSERT INTO public.europe_data_import VALUES (9838, '16/11/2020', '2020-46', '177305', '2890', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '501.75');
INSERT INTO public.europe_data_import VALUES (9839, '09/11/2020', '2020-45', '157099', '2327', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '477.46');
INSERT INTO public.europe_data_import VALUES (9840, '02/11/2020', '2020-44', '161114', '1821', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '468.9');
INSERT INTO public.europe_data_import VALUES (9841, '26/10/2020', '2020-43', '151391', '1250', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '405.24');
INSERT INTO public.europe_data_import VALUES (9842, '19/10/2020', '2020-42', '118693', '821', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '329.24');
INSERT INTO public.europe_data_import VALUES (9843, '12/10/2020', '2020-41', '100738', '475', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '253.19');
INSERT INTO public.europe_data_import VALUES (9844, '05/10/2020', '2020-40', '68009', '362', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '163.13');
INSERT INTO public.europe_data_import VALUES (9845, '28/09/2020', '2020-39', '40712', '211', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '99.73');
INSERT INTO public.europe_data_import VALUES (9846, '21/09/2020', '2020-38', '25753', '149', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '70.68');
INSERT INTO public.europe_data_import VALUES (9847, '14/09/2020', '2020-37', '21352', '77', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '51.07');
INSERT INTO public.europe_data_import VALUES (9848, '07/09/2020', '2020-36', '12685', '52', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '32.27');
INSERT INTO public.europe_data_import VALUES (9849, '31/08/2020', '2020-35', '8825', '70', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '23.98');
INSERT INTO public.europe_data_import VALUES (9850, '24/08/2020', '2020-34', '7158', '63', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '22.23');
INSERT INTO public.europe_data_import VALUES (9851, '17/08/2020', '2020-33', '7659', '88', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '20.69');
INSERT INTO public.europe_data_import VALUES (9852, '10/08/2020', '2020-32', '6130', '71', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '15.87');
INSERT INTO public.europe_data_import VALUES (9853, '03/08/2020', '2020-31', '4444', '96', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '13.49');
INSERT INTO public.europe_data_import VALUES (9854, '27/07/2020', '2020-30', '4549', '116', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '13.29');
INSERT INTO public.europe_data_import VALUES (9855, '20/07/2020', '2020-29', '4310', '150', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '12.88');
INSERT INTO public.europe_data_import VALUES (9856, '13/07/2020', '2020-28', '4271', '213', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '12.45');
INSERT INTO public.europe_data_import VALUES (9857, '06/07/2020', '2020-27', '4026', '312', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '13.9');
INSERT INTO public.europe_data_import VALUES (9858, '29/06/2020', '2020-26', '5240', '442', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '17.89');
INSERT INTO public.europe_data_import VALUES (9859, '22/06/2020', '2020-25', '6680', '512', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '20.73');
INSERT INTO public.europe_data_import VALUES (9860, '15/06/2020', '2020-24', '7136', '747', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '23.5');
INSERT INTO public.europe_data_import VALUES (9861, '08/06/2020', '2020-23', '8524', '1174', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '29.16');
INSERT INTO public.europe_data_import VALUES (9862, '01/06/2020', '2020-22', '10907', '1488', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '40.91');
INSERT INTO public.europe_data_import VALUES (9863, '25/05/2020', '2020-21', '16360', '2137', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '54.34');
INSERT INTO public.europe_data_import VALUES (9864, '18/05/2020', '2020-20', '19857', '2428', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '64.1');
INSERT INTO public.europe_data_import VALUES (9865, '11/05/2020', '2020-19', '22867', '3174', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '81.25');
INSERT INTO public.europe_data_import VALUES (9866, '04/05/2020', '2020-18', '31282', '4227', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '96.2');
INSERT INTO public.europe_data_import VALUES (9867, '27/04/2020', '2020-17', '32830', '5512', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '97.31');
INSERT INTO public.europe_data_import VALUES (9868, '20/04/2020', '2020-16', '32027', '6166', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '96.38');
INSERT INTO public.europe_data_import VALUES (9869, '13/04/2020', '2020-15', '32205', '6440', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '93.87');
INSERT INTO public.europe_data_import VALUES (9870, '06/04/2020', '2020-14', '30357', '4197', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '72.39');
INSERT INTO public.europe_data_import VALUES (9871, '30/03/2020', '2020-13', '17889', '1388', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '36.34');
INSERT INTO public.europe_data_import VALUES (9872, '23/03/2020', '2020-12', '6329', '245', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '12.79');
INSERT INTO public.europe_data_import VALUES (9873, '16/03/2020', '2020-11', '2193', '41', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '3.84');
INSERT INTO public.europe_data_import VALUES (9874, '09/03/2020', '2020-10', '365', '2', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.6');
INSERT INTO public.europe_data_import VALUES (9875, '02/03/2020', '2020-09', '36', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.06');
INSERT INTO public.europe_data_import VALUES (9876, '24/02/2020', '2020-08', '1', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (9877, '17/02/2020', '2020-07', '2', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9878, '10/02/2020', '2020-06', '6', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9879, '03/02/2020', '2020-05', '2', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (9880, '27/01/2020', '2020-04', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9881, '20/01/2020', '2020-03', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9882, '13/01/2020', '2020-02', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9883, '06/01/2020', '2020-01', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9884, '01/02/2021', '2021-04', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9885, '25/01/2021', '2021-03', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9886, '18/01/2021', '2021-02', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9887, '11/01/2021', '2021-01', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9888, '04/01/2021', '2020-53', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9889, '28/12/2020', '2020-52', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9890, '21/12/2020', '2020-51', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9891, '14/12/2020', '2020-50', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9892, '07/12/2020', '2020-49', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9893, '30/11/2020', '2020-48', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9894, '23/11/2020', '2020-47', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9895, '16/11/2020', '2020-46', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9896, '09/11/2020', '2020-45', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9897, '02/11/2020', '2020-44', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9898, '26/10/2020', '2020-43', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9899, '19/10/2020', '2020-42', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9900, '12/10/2020', '2020-41', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9901, '05/10/2020', '2020-40', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9902, '28/09/2020', '2020-39', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9903, '21/09/2020', '2020-38', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9904, '14/09/2020', '2020-37', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9905, '07/09/2020', '2020-36', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9906, '31/08/2020', '2020-35', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9907, '24/08/2020', '2020-34', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9908, '17/08/2020', '2020-33', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9909, '10/08/2020', '2020-32', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9910, '03/08/2020', '2020-31', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9911, '27/07/2020', '2020-30', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9912, '20/07/2020', '2020-29', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9913, '13/07/2020', '2020-28', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9914, '06/07/2020', '2020-27', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9915, '29/06/2020', '2020-26', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9916, '22/06/2020', '2020-25', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9917, '15/06/2020', '2020-24', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9918, '08/06/2020', '2020-23', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9919, '01/06/2020', '2020-22', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9920, '25/05/2020', '2020-21', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9921, '18/05/2020', '2020-20', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (9922, '11/05/2020', '2020-19', '29', '5', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (9923, '04/05/2020', '2020-18', '180', '6', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (9924, '27/04/2020', '2020-17', '130', '5', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (9925, '20/04/2020', '2020-16', '138', '2', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (9926, '13/04/2020', '2020-15', '10', '2', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (9927, '06/04/2020', '2020-14', '8', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (9928, '30/03/2020', '2020-13', '2', '1', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (9929, '23/03/2020', '2020-12', '12', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9930, '01/02/2021', '2021-04', '1024054', '22226', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '724.12');
INSERT INTO public.europe_data_import VALUES (9931, '25/01/2021', '2021-03', '1358783', '23518', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '873.4');
INSERT INTO public.europe_data_import VALUES (9932, '18/01/2021', '2021-02', '1515282', '23169', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '1002.26');
INSERT INTO public.europe_data_import VALUES (9933, '11/01/2021', '2021-01', '1782792', '22852', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '994.14');
INSERT INTO public.europe_data_import VALUES (9934, '04/01/2021', '2020-53', '1488563', '18264', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '849.49');
INSERT INTO public.europe_data_import VALUES (9935, '28/12/2020', '2020-52', '1306812', '15656', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '879.73');
INSERT INTO public.europe_data_import VALUES (9936, '21/12/2020', '2020-51', '1588085', '18493', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '938.37');
INSERT INTO public.europe_data_import VALUES (9937, '14/12/2020', '2020-50', '1499756', '16867', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '873.21');
INSERT INTO public.europe_data_import VALUES (9938, '07/12/2020', '2020-49', '1373677', '15437', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '762.79');
INSERT INTO public.europe_data_import VALUES (9939, '30/11/2020', '2020-48', '1136412', '10091', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '713.01');
INSERT INTO public.europe_data_import VALUES (9940, '23/11/2020', '2020-47', '1209848', '10568', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '691.43');
INSERT INTO public.europe_data_import VALUES (9941, '16/11/2020', '2020-46', '1065410', '8642', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '556.03');
INSERT INTO public.europe_data_import VALUES (9942, '09/11/2020', '2020-45', '764289', '6576', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '405.84');
INSERT INTO public.europe_data_import VALUES (9943, '02/11/2020', '2020-44', '571197', '5766', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '319.93');
INSERT INTO public.europe_data_import VALUES (9944, '26/10/2020', '2020-43', '481570', '5556', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '265.49');
INSERT INTO public.europe_data_import VALUES (9945, '19/10/2020', '2020-42', '392051', '4903', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '223.89');
INSERT INTO public.europe_data_import VALUES (9946, '12/10/2020', '2020-41', '344699', '4977', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '196.77');
INSERT INTO public.europe_data_import VALUES (9947, '05/10/2020', '2020-40', '302799', '5038', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '186.29');
INSERT INTO public.europe_data_import VALUES (9948, '28/09/2020', '2020-39', '310232', '5247', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '180.84');
INSERT INTO public.europe_data_import VALUES (9949, '21/09/2020', '2020-38', '284835', '5430', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '160.57');
INSERT INTO public.europe_data_import VALUES (9950, '14/09/2020', '2020-37', '243558', '5138', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '158.88');
INSERT INTO public.europe_data_import VALUES (9951, '07/09/2020', '2020-36', '279258', '5872', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '174.38');
INSERT INTO public.europe_data_import VALUES (9952, '31/08/2020', '2020-35', '294552', '6263', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '180.48');
INSERT INTO public.europe_data_import VALUES (9953, '24/08/2020', '2020-34', '299342', '6754', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '199.88');
INSERT INTO public.europe_data_import VALUES (9954, '17/08/2020', '2020-33', '358405', '7114', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '223.46');
INSERT INTO public.europe_data_import VALUES (9955, '10/08/2020', '2020-32', '376909', '8078', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '246.41');
INSERT INTO public.europe_data_import VALUES (9956, '03/08/2020', '2020-31', '433935', '7925', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '271.89');
INSERT INTO public.europe_data_import VALUES (9957, '27/07/2020', '2020-30', '460760', '6401', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '282.34');
INSERT INTO public.europe_data_import VALUES (9958, '20/07/2020', '2020-29', '468318', '5329', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '268.83');
INSERT INTO public.europe_data_import VALUES (9959, '13/07/2020', '2020-28', '416307', '5258', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '229.73');
INSERT INTO public.europe_data_import VALUES (9960, '06/07/2020', '2020-27', '339639', '4143', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '184.68');
INSERT INTO public.europe_data_import VALUES (9961, '29/06/2020', '2020-26', '268084', '5829', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '138.25');
INSERT INTO public.europe_data_import VALUES (9962, '22/06/2020', '2020-25', '186843', '4243', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '102.88');
INSERT INTO public.europe_data_import VALUES (9963, '15/06/2020', '2020-24', '151706', '5218', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '92.35');
INSERT INTO public.europe_data_import VALUES (9964, '08/06/2020', '2020-23', '152172', '6131', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '90.9');
INSERT INTO public.europe_data_import VALUES (9965, '01/06/2020', '2020-22', '146953', '6663', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '92.21');
INSERT INTO public.europe_data_import VALUES (9966, '25/05/2020', '2020-21', '156481', '8158', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '95.25');
INSERT INTO public.europe_data_import VALUES (9967, '18/05/2020', '2020-20', '156958', '10034', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '99.89');
INSERT INTO public.europe_data_import VALUES (9968, '11/05/2020', '2020-19', '171758', '11846', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '110.58');
INSERT INTO public.europe_data_import VALUES (9969, '04/05/2020', '2020-18', '192131', '12806', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '121.06');
INSERT INTO public.europe_data_import VALUES (9970, '27/04/2020', '2020-17', '206223', '14194', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '124.09');
INSERT INTO public.europe_data_import VALUES (9971, '20/04/2020', '2020-16', '202116', '18574', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '128.26');
INSERT INTO public.europe_data_import VALUES (9972, '13/04/2020', '2020-15', '219936', '12461', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '125.98');
INSERT INTO public.europe_data_import VALUES (9973, '06/04/2020', '2020-14', '194610', '7138', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '91.91');
INSERT INTO public.europe_data_import VALUES (9974, '30/03/2020', '2020-13', '107819', '2038', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '42.32');
INSERT INTO public.europe_data_import VALUES (9975, '23/03/2020', '2020-12', '31432', '402', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '10.53');
INSERT INTO public.europe_data_import VALUES (9976, '16/03/2020', '2020-11', '3220', '48', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '1.12');
INSERT INTO public.europe_data_import VALUES (9977, '09/03/2020', '2020-10', '465', '19', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.16');
INSERT INTO public.europe_data_import VALUES (9978, '02/03/2020', '2020-09', '54', '2', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (9979, '24/02/2020', '2020-08', '20', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (9980, '17/02/2020', '2020-07', '3', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9981, '10/02/2020', '2020-06', '1', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9982, '03/02/2020', '2020-05', '6', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9983, '27/01/2020', '2020-04', '5', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9984, '20/01/2020', '2020-03', '0', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9985, '13/01/2020', '2020-02', '0', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9986, '06/01/2020', '2020-01', '0', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '');
INSERT INTO public.europe_data_import VALUES (9987, '01/02/2021', '2021-04', '71', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '153.95');
INSERT INTO public.europe_data_import VALUES (9988, '25/01/2021', '2021-03', '90', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '175.94');
INSERT INTO public.europe_data_import VALUES (9989, '18/01/2021', '2021-02', '94', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '196.02');
INSERT INTO public.europe_data_import VALUES (9990, '11/01/2021', '2021-01', '111', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '154.91');
INSERT INTO public.europe_data_import VALUES (9991, '04/01/2021', '2020-53', '51', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '128.13');
INSERT INTO public.europe_data_import VALUES (9992, '28/12/2020', '2020-52', '83', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '168.29');
INSERT INTO public.europe_data_import VALUES (9993, '21/12/2020', '2020-51', '93', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '260.09');
INSERT INTO public.europe_data_import VALUES (9994, '14/12/2020', '2020-50', '179', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '271.57');
INSERT INTO public.europe_data_import VALUES (9995, '07/12/2020', '2020-49', '105', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '138.65');
INSERT INTO public.europe_data_import VALUES (9996, '30/11/2020', '2020-48', '40', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '105.18');
INSERT INTO public.europe_data_import VALUES (9997, '23/11/2020', '2020-47', '70', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '94.67');
INSERT INTO public.europe_data_import VALUES (9998, '16/11/2020', '2020-46', '29', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '55.46');
INSERT INTO public.europe_data_import VALUES (9999, '09/11/2020', '2020-45', '29', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '54.5');
INSERT INTO public.europe_data_import VALUES (10000, '02/11/2020', '2020-44', '28', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '39.2');
INSERT INTO public.europe_data_import VALUES (10001, '26/10/2020', '2020-43', '13', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '21.99');
INSERT INTO public.europe_data_import VALUES (10002, '19/10/2020', '2020-42', '10', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '13.39');
INSERT INTO public.europe_data_import VALUES (10003, '12/10/2020', '2020-41', '4', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '7.65');
INSERT INTO public.europe_data_import VALUES (10004, '05/10/2020', '2020-40', '4', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '49.72');
INSERT INTO public.europe_data_import VALUES (10005, '28/09/2020', '2020-39', '48', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '92.75');
INSERT INTO public.europe_data_import VALUES (10006, '21/09/2020', '2020-38', '49', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '84.15');
INSERT INTO public.europe_data_import VALUES (10007, '14/09/2020', '2020-37', '39', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '82.23');
INSERT INTO public.europe_data_import VALUES (10008, '07/09/2020', '2020-36', '47', '3', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '188.37');
INSERT INTO public.europe_data_import VALUES (10009, '31/08/2020', '2020-35', '150', '3', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '375.79');
INSERT INTO public.europe_data_import VALUES (10010, '24/08/2020', '2020-34', '243', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '417.87');
INSERT INTO public.europe_data_import VALUES (10011, '17/08/2020', '2020-33', '194', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '305.99');
INSERT INTO public.europe_data_import VALUES (10012, '10/08/2020', '2020-32', '126', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '177.86');
INSERT INTO public.europe_data_import VALUES (10013, '03/08/2020', '2020-31', '60', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '118.57');
INSERT INTO public.europe_data_import VALUES (10014, '27/07/2020', '2020-30', '64', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '172.12');
INSERT INTO public.europe_data_import VALUES (10015, '20/07/2020', '2020-29', '116', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '176.9');
INSERT INTO public.europe_data_import VALUES (10016, '13/07/2020', '2020-28', '69', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '95.62');
INSERT INTO public.europe_data_import VALUES (10017, '06/07/2020', '2020-27', '31', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '34.42');
INSERT INTO public.europe_data_import VALUES (10018, '29/06/2020', '2020-26', '5', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '7.65');
INSERT INTO public.europe_data_import VALUES (10019, '22/06/2020', '2020-25', '3', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '4.78');
INSERT INTO public.europe_data_import VALUES (10020, '15/06/2020', '2020-24', '2', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '3.82');
INSERT INTO public.europe_data_import VALUES (10021, '08/06/2020', '2020-23', '2', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '1.91');
INSERT INTO public.europe_data_import VALUES (10022, '01/06/2020', '2020-22', '0', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (10023, '25/05/2020', '2020-21', '0', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (10024, '18/05/2020', '2020-20', '0', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '2.87');
INSERT INTO public.europe_data_import VALUES (10025, '11/05/2020', '2020-19', '3', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '13.39');
INSERT INTO public.europe_data_import VALUES (10026, '04/05/2020', '2020-18', '11', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '12.43');
INSERT INTO public.europe_data_import VALUES (10027, '27/04/2020', '2020-17', '2', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '3.82');
INSERT INTO public.europe_data_import VALUES (10028, '20/04/2020', '2020-16', '2', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '10.52');
INSERT INTO public.europe_data_import VALUES (10029, '13/04/2020', '2020-15', '9', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '20.08');
INSERT INTO public.europe_data_import VALUES (10030, '06/04/2020', '2020-14', '12', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '40.16');
INSERT INTO public.europe_data_import VALUES (10031, '30/03/2020', '2020-13', '30', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '');
INSERT INTO public.europe_data_import VALUES (10032, '01/02/2021', '2021-04', '4087', '54', '3461731', 'Uruguay', 'UY', 'URY', 'America', '267.64');
INSERT INTO public.europe_data_import VALUES (10033, '25/01/2021', '2021-03', '5178', '71', '3461731', 'Uruguay', 'UY', 'URY', 'America', '321.8');
INSERT INTO public.europe_data_import VALUES (10034, '18/01/2021', '2021-02', '5962', '57', '3461731', 'Uruguay', 'UY', 'URY', 'America', '347.8');
INSERT INTO public.europe_data_import VALUES (10035, '11/01/2021', '2021-01', '6078', '58', '3461731', 'Uruguay', 'UY', 'URY', 'America', '277.17');
INSERT INTO public.europe_data_import VALUES (10036, '04/01/2021', '2020-53', '3517', '44', '3461731', 'Uruguay', 'UY', 'URY', 'America', '212.21');
INSERT INTO public.europe_data_import VALUES (10037, '28/12/2020', '2020-52', '3829', '41', '3461731', 'Uruguay', 'UY', 'URY', 'America', '219.49');
INSERT INTO public.europe_data_import VALUES (10038, '21/12/2020', '2020-51', '3769', '27', '3461731', 'Uruguay', 'UY', 'URY', 'America', '178.35');
INSERT INTO public.europe_data_import VALUES (10039, '14/12/2020', '2020-50', '2405', '10', '3461731', 'Uruguay', 'UY', 'URY', 'America', '115.32');
INSERT INTO public.europe_data_import VALUES (10040, '07/12/2020', '2020-49', '1587', '6', '3461731', 'Uruguay', 'UY', 'URY', 'America', '75.22');
INSERT INTO public.europe_data_import VALUES (10041, '30/11/2020', '2020-48', '1017', '5', '3461731', 'Uruguay', 'UY', 'URY', 'America', '48.7');
INSERT INTO public.europe_data_import VALUES (10042, '23/11/2020', '2020-47', '669', '6', '3461731', 'Uruguay', 'UY', 'URY', 'America', '34.23');
INSERT INTO public.europe_data_import VALUES (10043, '16/11/2020', '2020-46', '516', '3', '3461731', 'Uruguay', 'UY', 'URY', 'America', '25.45');
INSERT INTO public.europe_data_import VALUES (10044, '09/11/2020', '2020-45', '365', '3', '3461731', 'Uruguay', 'UY', 'URY', 'America', '19.15');
INSERT INTO public.europe_data_import VALUES (10045, '02/11/2020', '2020-44', '298', '6', '3461731', 'Uruguay', 'UY', 'URY', 'America', '17.85');
INSERT INTO public.europe_data_import VALUES (10046, '26/10/2020', '2020-43', '320', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '16.09');
INSERT INTO public.europe_data_import VALUES (10047, '19/10/2020', '2020-42', '237', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '11.15');
INSERT INTO public.europe_data_import VALUES (10048, '12/10/2020', '2020-41', '149', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '8.26');
INSERT INTO public.europe_data_import VALUES (10049, '05/10/2020', '2020-40', '137', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.59');
INSERT INTO public.europe_data_import VALUES (10050, '28/09/2020', '2020-39', '91', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '5.78');
INSERT INTO public.europe_data_import VALUES (10051, '21/09/2020', '2020-38', '109', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.88');
INSERT INTO public.europe_data_import VALUES (10052, '14/09/2020', '2020-37', '129', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.44');
INSERT INTO public.europe_data_import VALUES (10053, '07/09/2020', '2020-36', '94', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.39');
INSERT INTO public.europe_data_import VALUES (10054, '31/08/2020', '2020-35', '58', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.19');
INSERT INTO public.europe_data_import VALUES (10055, '24/08/2020', '2020-34', '87', '4', '3461731', 'Uruguay', 'UY', 'URY', 'America', '5.03');
INSERT INTO public.europe_data_import VALUES (10056, '17/08/2020', '2020-33', '87', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.45');
INSERT INTO public.europe_data_import VALUES (10057, '10/08/2020', '2020-32', '67', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.65');
INSERT INTO public.europe_data_import VALUES (10058, '03/08/2020', '2020-31', '94', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.7');
INSERT INTO public.europe_data_import VALUES (10059, '27/07/2020', '2020-30', '138', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '5.92');
INSERT INTO public.europe_data_import VALUES (10060, '20/07/2020', '2020-29', '67', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.83');
INSERT INTO public.europe_data_import VALUES (10061, '13/07/2020', '2020-28', '31', '3', '3461731', 'Uruguay', 'UY', 'URY', 'America', '1.68');
INSERT INTO public.europe_data_import VALUES (10062, '06/07/2020', '2020-27', '27', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.31');
INSERT INTO public.europe_data_import VALUES (10063, '29/06/2020', '2020-26', '53', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.34');
INSERT INTO public.europe_data_import VALUES (10064, '22/06/2020', '2020-25', '28', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (10065, '15/06/2020', '2020-24', '3', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (10066, '08/06/2020', '2020-23', '22', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.2');
INSERT INTO public.europe_data_import VALUES (10067, '01/06/2020', '2020-22', '54', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.57');
INSERT INTO public.europe_data_import VALUES (10068, '25/05/2020', '2020-21', '35', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '1.79');
INSERT INTO public.europe_data_import VALUES (10069, '18/05/2020', '2020-20', '27', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.28');
INSERT INTO public.europe_data_import VALUES (10070, '11/05/2020', '2020-19', '52', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.92');
INSERT INTO public.europe_data_import VALUES (10071, '04/05/2020', '2020-18', '49', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '3.67');
INSERT INTO public.europe_data_import VALUES (10072, '27/04/2020', '2020-17', '78', '5', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.07');
INSERT INTO public.europe_data_import VALUES (10073, '20/04/2020', '2020-16', '63', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '3.5');
INSERT INTO public.europe_data_import VALUES (10074, '13/04/2020', '2020-15', '58', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.91');
INSERT INTO public.europe_data_import VALUES (10075, '06/04/2020', '2020-14', '112', '5', '3461731', 'Uruguay', 'UY', 'URY', 'America', '7.19');
INSERT INTO public.europe_data_import VALUES (10076, '30/03/2020', '2020-13', '137', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '8.29');
INSERT INTO public.europe_data_import VALUES (10077, '23/03/2020', '2020-12', '150', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.56');
INSERT INTO public.europe_data_import VALUES (10078, '16/03/2020', '2020-11', '8', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '');
INSERT INTO public.europe_data_import VALUES (10079, '01/02/2021', '2021-04', '326', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.18');
INSERT INTO public.europe_data_import VALUES (10080, '25/01/2021', '2021-03', '393', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.48');
INSERT INTO public.europe_data_import VALUES (10081, '18/01/2021', '2021-02', '425', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.36');
INSERT INTO public.europe_data_import VALUES (10082, '11/01/2021', '2021-01', '353', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.36');
INSERT INTO public.europe_data_import VALUES (10083, '04/01/2021', '2020-53', '426', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.67');
INSERT INTO public.europe_data_import VALUES (10084, '28/12/2020', '2020-52', '784', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '5.27');
INSERT INTO public.europe_data_import VALUES (10085, '21/12/2020', '2020-51', '954', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '6.05');
INSERT INTO public.europe_data_import VALUES (10086, '14/12/2020', '2020-50', '1041', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '6.74');
INSERT INTO public.europe_data_import VALUES (10087, '07/12/2020', '2020-49', '1183', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '7.39');
INSERT INTO public.europe_data_import VALUES (10088, '30/11/2020', '2020-48', '1253', '5', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '7.97');
INSERT INTO public.europe_data_import VALUES (10089, '23/11/2020', '2020-47', '1374', '5', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '8.58');
INSERT INTO public.europe_data_import VALUES (10090, '16/11/2020', '2020-46', '1455', '13', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '9.36');
INSERT INTO public.europe_data_import VALUES (10091, '09/11/2020', '2020-45', '1632', '15', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '10.03');
INSERT INTO public.europe_data_import VALUES (10092, '02/11/2020', '2020-44', '1676', '20', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '11.3');
INSERT INTO public.europe_data_import VALUES (10093, '26/10/2020', '2020-43', '2050', '21', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '13.29');
INSERT INTO public.europe_data_import VALUES (10094, '19/10/2020', '2020-42', '2332', '24', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '13.86');
INSERT INTO public.europe_data_import VALUES (10095, '12/10/2020', '2020-41', '2239', '22', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '16.69');
INSERT INTO public.europe_data_import VALUES (10096, '05/10/2020', '2020-40', '3266', '23', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '21.44');
INSERT INTO public.europe_data_import VALUES (10097, '28/09/2020', '2020-39', '3804', '25', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '24.17');
INSERT INTO public.europe_data_import VALUES (10098, '21/09/2020', '2020-38', '4169', '41', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '24.3');
INSERT INTO public.europe_data_import VALUES (10099, '14/09/2020', '2020-37', '3845', '44', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '18.1');
INSERT INTO public.europe_data_import VALUES (10100, '07/09/2020', '2020-36', '2124', '33', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '14.64');
INSERT INTO public.europe_data_import VALUES (10101, '31/08/2020', '2020-35', '2705', '44', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '20.34');
INSERT INTO public.europe_data_import VALUES (10102, '24/08/2020', '2020-34', '4002', '45', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '24.64');
INSERT INTO public.europe_data_import VALUES (10103, '17/08/2020', '2020-33', '4124', '32', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '27.64');
INSERT INTO public.europe_data_import VALUES (10104, '10/08/2020', '2020-32', '4992', '41', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '30.32');
INSERT INTO public.europe_data_import VALUES (10105, '03/08/2020', '2020-31', '5008', '38', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '26.87');
INSERT INTO public.europe_data_import VALUES (10106, '27/07/2020', '2020-30', '3854', '29', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '23.12');
INSERT INTO public.europe_data_import VALUES (10107, '20/07/2020', '2020-29', '3773', '27', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '20.69');
INSERT INTO public.europe_data_import VALUES (10108, '13/07/2020', '2020-28', '3050', '26', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '15.65');
INSERT INTO public.europe_data_import VALUES (10109, '06/07/2020', '2020-27', '2112', '13', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '11.48');
INSERT INTO public.europe_data_import VALUES (10110, '29/06/2020', '2020-26', '1673', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '8.88');
INSERT INTO public.europe_data_import VALUES (10111, '22/06/2020', '2020-25', '1255', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '6.08');
INSERT INTO public.europe_data_import VALUES (10112, '15/06/2020', '2020-24', '751', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '4.37');
INSERT INTO public.europe_data_import VALUES (10113, '08/06/2020', '2020-23', '690', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.6');
INSERT INTO public.europe_data_import VALUES (10114, '01/06/2020', '2020-22', '498', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.76');
INSERT INTO public.europe_data_import VALUES (10115, '25/05/2020', '2020-21', '411', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.26');
INSERT INTO public.europe_data_import VALUES (10116, '18/05/2020', '2020-20', '335', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (10117, '11/05/2020', '2020-19', '269', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '1.61');
INSERT INTO public.europe_data_import VALUES (10118, '04/05/2020', '2020-18', '262', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '1.77');
INSERT INTO public.europe_data_import VALUES (10119, '27/04/2020', '2020-17', '322', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.1');
INSERT INTO public.europe_data_import VALUES (10120, '20/04/2020', '2020-16', '700', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.71');
INSERT INTO public.europe_data_import VALUES (10121, '13/04/2020', '2020-15', '523', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.18');
INSERT INTO public.europe_data_import VALUES (10122, '06/04/2020', '2020-14', '197', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '0.9');
INSERT INTO public.europe_data_import VALUES (10123, '30/03/2020', '2020-13', '99', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (10124, '23/03/2020', '2020-12', '40', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (10125, '16/03/2020', '2020-11', '6', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (10126, '01/02/2021', '2021-04', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10127, '25/01/2021', '2021-03', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10128, '18/01/2021', '2021-02', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10129, '11/01/2021', '2021-01', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10130, '04/01/2021', '2020-53', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10131, '28/12/2020', '2020-52', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10132, '21/12/2020', '2020-51', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10133, '14/12/2020', '2020-50', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10134, '07/12/2020', '2020-49', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10135, '30/11/2020', '2020-48', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10136, '23/11/2020', '2020-47', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0.33');
INSERT INTO public.europe_data_import VALUES (10137, '16/11/2020', '2020-46', '1', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10138, '01/02/2021', '2021-04', '3218', '41', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '22.73');
INSERT INTO public.europe_data_import VALUES (10139, '25/01/2021', '2021-03', '3265', '36', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '23.59');
INSERT INTO public.europe_data_import VALUES (10140, '18/01/2021', '2021-02', '3461', '39', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '21.17');
INSERT INTO public.europe_data_import VALUES (10141, '11/01/2021', '2021-01', '2576', '35', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.37');
INSERT INTO public.europe_data_import VALUES (10142, '04/01/2021', '2020-53', '2091', '24', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '15.19');
INSERT INTO public.europe_data_import VALUES (10143, '28/12/2020', '2020-52', '2241', '26', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '18.02');
INSERT INTO public.europe_data_import VALUES (10144, '21/12/2020', '2020-51', '2898', '39', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '19.75');
INSERT INTO public.europe_data_import VALUES (10145, '14/12/2020', '2020-50', '2735', '30', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '18.01');
INSERT INTO public.europe_data_import VALUES (10146, '07/12/2020', '2020-49', '2402', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.16');
INSERT INTO public.europe_data_import VALUES (10147, '30/11/2020', '2020-48', '2205', '23', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.44');
INSERT INTO public.europe_data_import VALUES (10148, '23/11/2020', '2020-47', '2483', '20', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '17.37');
INSERT INTO public.europe_data_import VALUES (10149, '16/11/2020', '2020-46', '2469', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '17.63');
INSERT INTO public.europe_data_import VALUES (10150, '09/11/2020', '2020-45', '2558', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '18.65');
INSERT INTO public.europe_data_import VALUES (10151, '02/11/2020', '2020-44', '2760', '28', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '19.95');
INSERT INTO public.europe_data_import VALUES (10152, '26/10/2020', '2020-43', '2929', '37', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '22.54');
INSERT INTO public.europe_data_import VALUES (10153, '19/10/2020', '2020-42', '3499', '39', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '28.76');
INSERT INTO public.europe_data_import VALUES (10154, '12/10/2020', '2020-41', '4703', '44', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '36.63');
INSERT INTO public.europe_data_import VALUES (10155, '05/10/2020', '2020-40', '5743', '47', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '41.3');
INSERT INTO public.europe_data_import VALUES (10156, '28/09/2020', '2020-39', '6035', '59', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '42.61');
INSERT INTO public.europe_data_import VALUES (10157, '21/09/2020', '2020-38', '6116', '62', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '46.88');
INSERT INTO public.europe_data_import VALUES (10158, '14/09/2020', '2020-37', '7251', '57', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '51.45');
INSERT INTO public.europe_data_import VALUES (10159, '07/09/2020', '2020-36', '7421', '47', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '48.13');
INSERT INTO public.europe_data_import VALUES (10160, '31/08/2020', '2020-35', '6304', '52', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '42.48');
INSERT INTO public.europe_data_import VALUES (10161, '24/08/2020', '2020-34', '5809', '48', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '48.25');
INSERT INTO public.europe_data_import VALUES (10162, '17/08/2020', '2020-33', '7950', '58', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '47.51');
INSERT INTO public.europe_data_import VALUES (10163, '10/08/2020', '2020-32', '5599', '49', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '36.27');
INSERT INTO public.europe_data_import VALUES (10164, '03/08/2020', '2020-31', '4743', '32', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '29.16');
INSERT INTO public.europe_data_import VALUES (10165, '27/07/2020', '2020-30', '3572', '30', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '21.03');
INSERT INTO public.europe_data_import VALUES (10166, '20/07/2020', '2020-29', '2426', '23', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.56');
INSERT INTO public.europe_data_import VALUES (10167, '13/07/2020', '2020-28', '2296', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '14.62');
INSERT INTO public.europe_data_import VALUES (10168, '06/07/2020', '2020-27', '1872', '20', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '11.4');
INSERT INTO public.europe_data_import VALUES (10169, '29/06/2020', '2020-26', '1379', '11', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '8.13');
INSERT INTO public.europe_data_import VALUES (10170, '22/06/2020', '2020-25', '940', '8', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '5.4');
INSERT INTO public.europe_data_import VALUES (10171, '15/06/2020', '2020-24', '601', '3', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '5.15');
INSERT INTO public.europe_data_import VALUES (10172, '08/06/2020', '2020-23', '867', '8', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '4.4');
INSERT INTO public.europe_data_import VALUES (10173, '01/06/2020', '2020-22', '389', '4', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '3.4');
INSERT INTO public.europe_data_import VALUES (10174, '25/05/2020', '2020-21', '580', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '2.48');
INSERT INTO public.europe_data_import VALUES (10175, '18/05/2020', '2020-20', '127', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.65');
INSERT INTO public.europe_data_import VALUES (10176, '11/05/2020', '2020-19', '57', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.31');
INSERT INTO public.europe_data_import VALUES (10177, '04/05/2020', '2020-18', '32', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (10178, '27/04/2020', '2020-17', '69', '1', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.5');
INSERT INTO public.europe_data_import VALUES (10179, '20/04/2020', '2020-16', '75', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.38');
INSERT INTO public.europe_data_import VALUES (10180, '13/04/2020', '2020-15', '33', '4', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (10181, '06/04/2020', '2020-14', '29', '4', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.39');
INSERT INTO public.europe_data_import VALUES (10182, '30/03/2020', '2020-13', '83', '1', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.36');
INSERT INTO public.europe_data_import VALUES (10183, '23/03/2020', '2020-12', '21', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.13');
INSERT INTO public.europe_data_import VALUES (10184, '16/03/2020', '2020-11', '15', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '');
INSERT INTO public.europe_data_import VALUES (10185, '01/02/2021', '2021-04', '271', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (10186, '25/01/2021', '2021-03', '9', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10187, '18/01/2021', '2021-02', '25', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10188, '11/01/2021', '2021-01', '17', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (10189, '04/01/2021', '2020-53', '56', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (10190, '28/12/2020', '2020-52', '28', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10191, '21/12/2020', '2020-51', '16', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10192, '14/12/2020', '2020-50', '31', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10193, '07/12/2020', '2020-49', '23', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10194, '30/11/2020', '2020-48', '37', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10195, '23/11/2020', '2020-47', '25', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (10196, '16/11/2020', '2020-46', '68', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (10197, '09/11/2020', '2020-45', '33', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10198, '02/11/2020', '2020-44', '12', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10199, '26/10/2020', '2020-43', '34', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10200, '19/10/2020', '2020-42', '25', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10201, '12/10/2020', '2020-41', '13', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10202, '05/10/2020', '2020-40', '22', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10203, '28/09/2020', '2020-39', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10204, '21/09/2020', '2020-38', '5', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10205, '14/09/2020', '2020-37', '14', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10206, '07/09/2020', '2020-36', '9', '3', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10207, '31/08/2020', '2020-35', '24', '5', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (10208, '24/08/2020', '2020-34', '52', '3', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.18');
INSERT INTO public.europe_data_import VALUES (10209, '17/08/2020', '2020-33', '123', '11', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.36');
INSERT INTO public.europe_data_import VALUES (10210, '10/08/2020', '2020-32', '220', '7', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (10211, '03/08/2020', '2020-31', '201', '6', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (10212, '27/07/2020', '2020-30', '47', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10213, '20/07/2020', '2020-29', '1', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10214, '13/07/2020', '2020-28', '17', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10215, '06/07/2020', '2020-27', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10216, '29/06/2020', '2020-26', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10217, '22/06/2020', '2020-25', '15', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10218, '15/06/2020', '2020-24', '3', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10219, '08/06/2020', '2020-23', '3', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10220, '01/06/2020', '2020-22', '3', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10221, '25/05/2020', '2020-21', '5', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10222, '18/05/2020', '2020-20', '32', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10223, '11/05/2020', '2020-19', '17', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10224, '04/05/2020', '2020-18', '1', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10225, '27/04/2020', '2020-17', '2', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10226, '20/04/2020', '2020-16', '4', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10227, '13/04/2020', '2020-15', '19', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10228, '06/04/2020', '2020-14', '42', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (10229, '30/03/2020', '2020-13', '82', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (10230, '23/03/2020', '2020-12', '64', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (10231, '16/03/2020', '2020-11', '27', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10232, '09/03/2020', '2020-10', '14', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10233, '02/03/2020', '2020-09', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10234, '24/02/2020', '2020-08', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10235, '17/02/2020', '2020-07', '2', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10236, '10/02/2020', '2020-06', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10237, '03/02/2020', '2020-05', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10238, '27/01/2020', '2020-04', '2', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10239, '20/01/2020', '2020-03', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10240, '13/01/2020', '2020-02', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10241, '06/01/2020', '2020-01', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (10242, '01/02/2021', '2021-04', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10243, '25/01/2021', '2021-03', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10244, '18/01/2021', '2021-02', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10245, '11/01/2021', '2021-01', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10246, '04/01/2021', '2020-53', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10247, '28/12/2020', '2020-52', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10248, '21/12/2020', '2020-51', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10249, '14/12/2020', '2020-50', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10250, '07/12/2020', '2020-49', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10251, '30/11/2020', '2020-48', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10252, '23/11/2020', '2020-47', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10253, '16/11/2020', '2020-46', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10254, '09/11/2020', '2020-45', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10255, '02/11/2020', '2020-44', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10256, '26/10/2020', '2020-43', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10257, '19/10/2020', '2020-42', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10258, '01/02/2021', '2021-04', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10259, '25/01/2021', '2021-03', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10260, '18/01/2021', '2021-02', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10261, '11/01/2021', '2021-01', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10262, '04/01/2021', '2020-53', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10263, '28/12/2020', '2020-52', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10264, '21/12/2020', '2020-51', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10265, '14/12/2020', '2020-50', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10266, '07/12/2020', '2020-49', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10267, '30/11/2020', '2020-48', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10268, '23/11/2020', '2020-47', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10269, '16/11/2020', '2020-46', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10270, '09/11/2020', '2020-45', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10271, '02/11/2020', '2020-44', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10272, '26/10/2020', '2020-43', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10273, '19/10/2020', '2020-42', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10274, '12/10/2020', '2020-41', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10275, '05/10/2020', '2020-40', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10276, '28/09/2020', '2020-39', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10277, '21/09/2020', '2020-38', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10278, '14/09/2020', '2020-37', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10279, '07/09/2020', '2020-36', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10280, '31/08/2020', '2020-35', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10281, '24/08/2020', '2020-34', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10282, '17/08/2020', '2020-33', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10283, '10/08/2020', '2020-32', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10284, '03/08/2020', '2020-31', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10285, '27/07/2020', '2020-30', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '42.41');
INSERT INTO public.europe_data_import VALUES (10286, '20/07/2020', '2020-29', '247', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '42.41');
INSERT INTO public.europe_data_import VALUES (10287, '13/07/2020', '2020-28', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '53.39');
INSERT INTO public.europe_data_import VALUES (10288, '06/07/2020', '2020-27', '311', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '84.81');
INSERT INTO public.europe_data_import VALUES (10289, '29/06/2020', '2020-26', '183', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '31.76');
INSERT INTO public.europe_data_import VALUES (10290, '22/06/2020', '2020-25', '2', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (10291, '15/06/2020', '2020-24', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10292, '08/06/2020', '2020-23', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (10293, '01/06/2020', '2020-22', '17', '1', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (10294, '25/05/2020', '2020-21', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10295, '18/05/2020', '2020-20', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10296, '11/05/2020', '2020-19', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10297, '04/05/2020', '2020-18', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (10298, '27/04/2020', '2020-17', '6', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (10299, '01/02/2021', '2021-04', '3', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10300, '25/01/2021', '2021-03', '6', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10301, '18/01/2021', '2021-02', '8', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10302, '11/01/2021', '2021-01', '3', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10303, '04/01/2021', '2020-53', '7', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10304, '28/12/2020', '2020-52', '9', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10305, '21/12/2020', '2020-51', '6', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10306, '14/12/2020', '2020-50', '6', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10307, '07/12/2020', '2020-49', '0', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10308, '30/11/2020', '2020-48', '8', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10309, '23/11/2020', '2020-47', '1', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10310, '16/11/2020', '2020-46', '5', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10311, '09/11/2020', '2020-45', '0', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10312, '02/11/2020', '2020-44', '0', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10313, '26/10/2020', '2020-43', '4', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10314, '19/10/2020', '2020-42', '4', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10315, '12/10/2020', '2020-41', '10', '5', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (10316, '05/10/2020', '2020-40', '11', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10317, '28/09/2020', '2020-39', '4', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (10318, '21/09/2020', '2020-38', '17', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (10319, '14/09/2020', '2020-37', '26', '11', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (10320, '07/09/2020', '2020-36', '34', '8', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (10321, '31/08/2020', '2020-35', '42', '17', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (10322, '24/08/2020', '2020-34', '42', '17', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (10323, '17/08/2020', '2020-33', '65', '15', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (10324, '10/08/2020', '2020-32', '70', '18', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (10325, '03/08/2020', '2020-31', '53', '18', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (10326, '27/07/2020', '2020-30', '75', '34', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.74');
INSERT INTO public.europe_data_import VALUES (10327, '20/07/2020', '2020-29', '141', '28', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.17');
INSERT INTO public.europe_data_import VALUES (10328, '13/07/2020', '2020-28', '200', '79', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.19');
INSERT INTO public.europe_data_import VALUES (10329, '06/07/2020', '2020-27', '147', '36', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.11');
INSERT INTO public.europe_data_import VALUES (10330, '29/06/2020', '2020-26', '177', '46', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.34');
INSERT INTO public.europe_data_import VALUES (10331, '22/06/2020', '2020-25', '213', '92', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.56');
INSERT INTO public.europe_data_import VALUES (10332, '15/06/2020', '2020-24', '242', '52', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (10333, '08/06/2020', '2020-23', '163', '32', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.91');
INSERT INTO public.europe_data_import VALUES (10334, '01/06/2020', '2020-22', '101', '38', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.67');
INSERT INTO public.europe_data_import VALUES (10335, '25/05/2020', '2020-21', '94', '22', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (10336, '18/05/2020', '2020-20', '77', '12', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.4');
INSERT INTO public.europe_data_import VALUES (10337, '11/05/2020', '2020-19', '41', '6', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (10338, '04/05/2020', '2020-18', '9', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10339, '27/04/2020', '2020-17', '0', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10340, '20/04/2020', '2020-16', '0', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10341, '13/04/2020', '2020-15', '1', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (10342, '01/02/2021', '2021-04', '8896', '120', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '94.26');
INSERT INTO public.europe_data_import VALUES (10343, '25/01/2021', '2021-03', '7939', '101', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '98.26');
INSERT INTO public.europe_data_import VALUES (10344, '18/01/2021', '2021-02', '9611', '88', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '90.78');
INSERT INTO public.europe_data_import VALUES (10345, '11/01/2021', '2021-01', '6603', '73', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '48.45');
INSERT INTO public.europe_data_import VALUES (10346, '04/01/2021', '2020-53', '2050', '14', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '18.35');
INSERT INTO public.europe_data_import VALUES (10347, '28/12/2020', '2020-52', '1227', '11', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '9.34');
INSERT INTO public.europe_data_import VALUES (10348, '21/12/2020', '2020-51', '442', '6', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.48');
INSERT INTO public.europe_data_import VALUES (10349, '14/12/2020', '2020-50', '358', '3', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.73');
INSERT INTO public.europe_data_import VALUES (10350, '07/12/2020', '2020-49', '308', '7', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '2.75');
INSERT INTO public.europe_data_import VALUES (10351, '30/11/2020', '2020-48', '184', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (10352, '23/11/2020', '2020-47', '301', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '2.63');
INSERT INTO public.europe_data_import VALUES (10353, '16/11/2020', '2020-46', '169', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.6');
INSERT INTO public.europe_data_import VALUES (10354, '09/11/2020', '2020-45', '474', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.69');
INSERT INTO public.europe_data_import VALUES (10355, '02/11/2020', '2020-44', '363', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.51');
INSERT INTO public.europe_data_import VALUES (10356, '26/10/2020', '2020-43', '264', '2', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.69');
INSERT INTO public.europe_data_import VALUES (10357, '19/10/2020', '2020-42', '395', '10', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.48');
INSERT INTO public.europe_data_import VALUES (10358, '12/10/2020', '2020-41', '406', '3', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.57');
INSERT INTO public.europe_data_import VALUES (10359, '05/10/2020', '2020-40', '411', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '5.16');
INSERT INTO public.europe_data_import VALUES (10360, '28/09/2020', '2020-39', '510', '2', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '6.17');
INSERT INTO public.europe_data_import VALUES (10361, '21/09/2020', '2020-38', '592', '18', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '7.59');
INSERT INTO public.europe_data_import VALUES (10362, '14/09/2020', '2020-37', '763', '17', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '8.48');
INSERT INTO public.europe_data_import VALUES (10363, '07/09/2020', '2020-36', '751', '8', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '9.48');
INSERT INTO public.europe_data_import VALUES (10364, '31/08/2020', '2020-35', '943', '7', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '15.02');
INSERT INTO public.europe_data_import VALUES (10365, '24/08/2020', '2020-34', '1739', '20', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '16.78');
INSERT INTO public.europe_data_import VALUES (10366, '17/08/2020', '2020-33', '1258', '25', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '16.77');
INSERT INTO public.europe_data_import VALUES (10367, '10/08/2020', '2020-32', '1738', '65', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '20.18');
INSERT INTO public.europe_data_import VALUES (10368, '03/08/2020', '2020-31', '1866', '31', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '18.85');
INSERT INTO public.europe_data_import VALUES (10369, '27/07/2020', '2020-30', '1501', '30', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '14.48');
INSERT INTO public.europe_data_import VALUES (10370, '20/07/2020', '2020-29', '1085', '67', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '7.55');
INSERT INTO public.europe_data_import VALUES (10371, '13/07/2020', '2020-28', '263', '12', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.89');
INSERT INTO public.europe_data_import VALUES (10372, '06/07/2020', '2020-27', '75', '8', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (10373, '29/06/2020', '2020-26', '127', '11', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (10374, '22/06/2020', '2020-25', '72', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (10375, '15/06/2020', '2020-24', '204', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (10376, '08/06/2020', '2020-23', '97', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.31');
INSERT INTO public.europe_data_import VALUES (10377, '01/06/2020', '2020-22', '137', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.7');
INSERT INTO public.europe_data_import VALUES (10378, '25/05/2020', '2020-21', '167', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.66');
INSERT INTO public.europe_data_import VALUES (10379, '18/05/2020', '2020-20', '486', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.52');
INSERT INTO public.europe_data_import VALUES (10380, '11/05/2020', '2020-19', '143', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.0');
INSERT INTO public.europe_data_import VALUES (10381, '04/05/2020', '2020-18', '36', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (10382, '27/04/2020', '2020-17', '27', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (10383, '20/04/2020', '2020-16', '18', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (10384, '13/04/2020', '2020-15', '4', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (10385, '06/04/2020', '2020-14', '10', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (10386, '30/03/2020', '2020-13', '26', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (10387, '23/03/2020', '2020-12', '3', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (10388, '01/02/2021', '2021-04', '2228', '229', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '43.32');
INSERT INTO public.europe_data_import VALUES (10389, '25/01/2021', '2021-03', '4117', '292', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '67.21');
INSERT INTO public.europe_data_import VALUES (10390, '18/01/2021', '2021-02', '5726', '206', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '81.51');
INSERT INTO public.europe_data_import VALUES (10391, '11/01/2021', '2021-01', '6212', '127', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '56.87');
INSERT INTO public.europe_data_import VALUES (10392, '04/01/2021', '2020-53', '2117', '26', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '19.88');
INSERT INTO public.europe_data_import VALUES (10393, '28/12/2020', '2020-52', '795', '34', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '12.99');
INSERT INTO public.europe_data_import VALUES (10394, '21/12/2020', '2020-51', '1107', '13', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (10395, '14/12/2020', '2020-50', '528', '16', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '8.85');
INSERT INTO public.europe_data_import VALUES (10396, '07/12/2020', '2020-49', '768', '15', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '10.23');
INSERT INTO public.europe_data_import VALUES (10397, '30/11/2020', '2020-48', '730', '8', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.95');
INSERT INTO public.europe_data_import VALUES (10398, '23/11/2020', '2020-47', '434', '11', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '4.7');
INSERT INTO public.europe_data_import VALUES (10399, '16/11/2020', '2020-46', '255', '4', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (10400, '09/11/2020', '2020-45', '157', '10', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (10401, '02/11/2020', '2020-44', '98', '6', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (10402, '26/10/2020', '2020-43', '129', '6', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (10403, '19/10/2020', '2020-42', '136', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.79');
INSERT INTO public.europe_data_import VALUES (10404, '12/10/2020', '2020-41', '126', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (10405, '05/10/2020', '2020-40', '73', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (10406, '28/09/2020', '2020-39', '129', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (10407, '21/09/2020', '2020-38', '157', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '4.82');
INSERT INTO public.europe_data_import VALUES (10408, '14/09/2020', '2020-37', '549', '17', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.61');
INSERT INTO public.europe_data_import VALUES (10409, '07/09/2020', '2020-36', '565', '11', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.15');
INSERT INTO public.europe_data_import VALUES (10410, '31/08/2020', '2020-35', '482', '41', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.86');
INSERT INTO public.europe_data_import VALUES (10411, '24/08/2020', '2020-34', '669', '23', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '8.75');
INSERT INTO public.europe_data_import VALUES (10412, '17/08/2020', '2020-33', '612', '28', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '9.15');
INSERT INTO public.europe_data_import VALUES (10413, '10/08/2020', '2020-32', '728', '34', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '14.59');
INSERT INTO public.europe_data_import VALUES (10414, '03/08/2020', '2020-31', '1409', '36', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '15.77');
INSERT INTO public.europe_data_import VALUES (10415, '27/07/2020', '2020-30', '901', '9', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '10.43');
INSERT INTO public.europe_data_import VALUES (10416, '20/07/2020', '2020-29', '626', '7', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '6.11');
INSERT INTO public.europe_data_import VALUES (10417, '13/07/2020', '2020-28', '269', '10', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '2.85');
INSERT INTO public.europe_data_import VALUES (10418, '06/07/2020', '2020-27', '149', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (10419, '29/06/2020', '2020-26', '78', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (10420, '22/06/2020', '2020-25', '106', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (10421, '15/06/2020', '2020-24', '101', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.4');
INSERT INTO public.europe_data_import VALUES (10422, '08/06/2020', '2020-23', '104', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (10423, '01/06/2020', '2020-22', '122', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.9');
INSERT INTO public.europe_data_import VALUES (10424, '25/05/2020', '2020-21', '10', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (10425, '18/05/2020', '2020-20', '10', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (10426, '11/05/2020', '2020-19', '2', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (10427, '04/05/2020', '2020-18', '3', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (10428, '27/04/2020', '2020-17', '6', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (10429, '20/04/2020', '2020-16', '11', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (10430, '13/04/2020', '2020-15', '5', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (10431, '06/04/2020', '2020-14', '2', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (10432, '30/03/2020', '2020-13', '5', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (10433, '23/03/2020', '2020-12', '2', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '');


--
-- Data for Name: rki_bundeslsaender_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: rki_country; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: rki_global_data; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: rki_global_data_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: rki_landkreise_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: vaccination_germany_timeline; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.vaccination_germany_timeline VALUES (1, '2020-12-27', 23900, 23900, 23900, 0, 23900, 0, 0.00029, 0, 8507, 7862, 1280, 13361, 8507, 7862, 1280, 13361, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (2, '2020-12-28', 43734, 19834, 43734, 0, 43734, 0, 0.00053, 0, 16288, 15319, 2010, 23176, 16288, 15319, 2010, 23176, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (3, '2020-12-29', 87148, 43414, 87148, 0, 87148, 0, 0.00105, 0, 28461, 37030, 3089, 40423, 28461, 37030, 3089, 40423, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (4, '2020-12-30', 144903, 57755, 144903, 0, 144903, 0, 0.00174, 0, 45712, 68237, 4688, 61360, 45712, 68237, 4688, 61360, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (5, '2020-12-31', 182960, 38057, 182960, 0, 182960, 0, 0.0022, 0, 58585, 86636, 6500, 76490, 58585, 86636, 6500, 76490, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (6, '2021-01-01', 207452, 24492, 207452, 0, 207452, 0, 0.00249, 0, 66267, 96410, 7591, 89058, 66267, 96410, 7591, 89058, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (7, '2021-01-02', 258223, 50771, 258223, 0, 258223, 0, 0.0031, 0, 85189, 119356, 10036, 109811, 85189, 119356, 10036, 109811, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (8, '2021-01-03', 283420, 25197, 283420, 0, 283420, 0, 0.00341, 0, 94996, 130446, 10966, 120513, 94996, 130446, 10966, 120513, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (9, '2021-01-04', 332306, 48886, 332306, 0, 332306, 0, 0.004, 0, 109242, 155355, 13615, 136512, 109242, 155355, 13615, 136512, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (10, '2021-01-05', 384445, 52139, 384445, 0, 384445, 0, 0.00462, 0, 124529, 182262, 16016, 154812, 124529, 182262, 16016, 154812, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (11, '2021-01-06', 442766, 58321, 442766, 0, 442766, 0, 0.00532, 0, 141003, 212553, 19343, 175492, 141003, 212553, 19343, 175492, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (12, '2021-01-07', 501341, 58575, 501341, 0, 501341, 0, 0.00603, 0, 157704, 242559, 22351, 193485, 157704, 242559, 22351, 193485, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (13, '2021-01-08', 561291, 59950, 561291, 0, 561291, 0, 0.00675, 0, 176158, 273414, 25641, 213253, 176158, 273414, 25641, 213253, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (14, '2021-01-09', 617700, 56409, 617700, 0, 617700, 0, 0.00743, 0, 197374, 297250, 27916, 236125, 197374, 297250, 27916, 236125, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (15, '2021-01-10', 650941, 33241, 650941, 0, 650941, 0, 0.00783, 0, 210590, 311303, 29241, 248154, 210590, 311303, 29241, 248154, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (16, '2021-01-11', 716531, 65590, 716531, 0, 716531, 0, 0.00862, 0, 233169, 342453, 32111, 268277, 233169, 342453, 32111, 268277, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (17, '2021-01-12', 798423, 81892, 798423, 0, 798423, 0, 0.0096, 0, 258584, 384629, 35314, 292624, 258584, 384629, 35314, 292624, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (18, '2021-01-13', 896773, 98350, 895979, 794, 896773, 0, 0.01078, 0, 289461, 435680, 38215, 320089, 289461, 435680, 38215, 320089, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (19, '2021-01-14', 997203, 100430, 992283, 4920, 997072, 131, 0.01199, 0, 314554, 485619, 39895, 350612, 314485, 485616, 39895, 350612, 69, 3, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (20, '2021-01-15', 1089972, 92769, 1080166, 9806, 1089401, 571, 0.0131, 1e-05, 343265, 531555, 43054, 376792, 343063, 531522, 43053, 376756, 202, 33, 1, 36);
INSERT INTO public.vaccination_germany_timeline VALUES (21, '2021-01-16', 1146769, 56797, 1135112, 11657, 1145766, 1003, 0.01378, 1e-05, 362962, 555686, 44752, 395056, 362546, 555550, 44690, 394831, 416, 136, 62, 225);
INSERT INTO public.vaccination_germany_timeline VALUES (22, '2021-01-17', 1191597, 44828, 1178525, 13072, 1176986, 14611, 0.01415, 0.00018, 378882, 574585, 46295, 411583, 372127, 569581, 45638, 403433, 6755, 5004, 657, 8150);
INSERT INTO public.vaccination_germany_timeline VALUES (23, '2021-01-18', 1265746, 74149, 1250661, 15085, 1234700, 31046, 0.01485, 0.00037, 405245, 609368, 47956, 430598, 393085, 597439, 47101, 415524, 12160, 11929, 855, 15074);
INSERT INTO public.vaccination_germany_timeline VALUES (24, '2021-01-19', 1359733, 93987, 1343073, 16660, 1301469, 58264, 0.01565, 0.0007, 436597, 656508, 50783, 455861, 415382, 631628, 49346, 430551, 21215, 24880, 1437, 25310);
INSERT INTO public.vaccination_germany_timeline VALUES (25, '2021-01-20', 1487796, 128063, 1469807, 17989, 1379142, 108654, 0.01658, 0.00131, 477518, 718154, 54523, 496686, 441602, 668079, 52233, 451618, 35916, 50075, 2290, 45068);
INSERT INTO public.vaccination_germany_timeline VALUES (26, '2021-01-21', 1582170, 94374, 1563084, 19086, 1439022, 143148, 0.0173, 0.00172, 513649, 759151, 60006, 525745, 465200, 694030, 55293, 467737, 48449, 65121, 4713, 58008);
INSERT INTO public.vaccination_germany_timeline VALUES (27, '2021-01-22', 1696053, 113883, 1675538, 20515, 1522398, 173655, 0.01831, 0.00209, 553777, 809786, 63249, 566239, 493141, 730684, 57766, 493922, 60636, 79102, 5483, 72317);
INSERT INTO public.vaccination_germany_timeline VALUES (28, '2021-01-23', 1786894, 90841, 1765996, 20898, 1570586, 216308, 0.01888, 0.0026, 587476, 849369, 66399, 596750, 511406, 750167, 58933, 507383, 76070, 99202, 7466, 89367);
INSERT INTO public.vaccination_germany_timeline VALUES (29, '2021-01-24', 1852366, 65472, 1831224, 21142, 1608482, 243884, 0.01934, 0.00293, 609646, 876013, 67188, 620483, 524712, 765008, 59258, 519153, 84934, 111005, 7930, 101330);
INSERT INTO public.vaccination_germany_timeline VALUES (30, '2021-01-25', 1948538, 96172, 1925876, 22662, 1665731, 282807, 0.02003, 0.0034, 648940, 918013, 70445, 645525, 552211, 786754, 60794, 531438, 96729, 131259, 9651, 114087);
INSERT INTO public.vaccination_germany_timeline VALUES (31, '2021-01-26', 2050036, 101498, 2025786, 24250, 1718781, 331255, 0.02067, 0.00398, 686816, 965027, 74067, 672514, 576962, 807064, 62091, 543227, 109854, 157963, 11976, 129287);
INSERT INTO public.vaccination_germany_timeline VALUES (32, '2021-01-27', 2160609, 110573, 2134451, 26158, 1772540, 388069, 0.02131, 0.00467, 726243, 1018135, 79035, 702869, 600110, 829229, 63871, 555103, 126133, 188906, 15164, 147766);
INSERT INTO public.vaccination_germany_timeline VALUES (33, '2021-01-28', 2259749, 99140, 2227111, 32638, 1823978, 435771, 0.02193, 0.00524, 762525, 1066064, 83054, 728419, 621705, 852133, 65396, 566703, 140820, 213931, 17658, 161716);
INSERT INTO public.vaccination_germany_timeline VALUES (34, '2021-01-29', 2368047, 108298, 2334006, 34041, 1880316, 487731, 0.02261, 0.00586, 802637, 1116434, 88285, 755561, 644023, 876115, 67664, 577245, 158614, 240319, 20621, 178316);
INSERT INTO public.vaccination_germany_timeline VALUES (35, '2021-01-30', 2452659, 84612, 2417813, 34846, 1918568, 534091, 0.02307, 0.00642, 834684, 1155612, 91898, 780176, 659419, 893989, 69047, 584938, 175265, 261623, 22851, 195238);
INSERT INTO public.vaccination_germany_timeline VALUES (36, '2021-01-31', 2514878, 62219, 2479689, 35189, 1949712, 565166, 0.02344, 0.0068, 858025, 1183776, 93927, 795708, 672892, 908185, 70205, 590635, 185133, 275591, 23722, 205073);
INSERT INTO public.vaccination_germany_timeline VALUES (37, '2021-02-01', 2627298, 112420, 2590532, 36766, 1997463, 629835, 0.02402, 0.00757, 897741, 1239056, 97364, 823713, 692172, 931160, 71943, 600120, 205569, 307896, 25421, 223593);
INSERT INTO public.vaccination_germany_timeline VALUES (38, '2021-02-02', 2750197, 122899, 2711402, 38795, 2052342, 697855, 0.02468, 0.00839, 937980, 1302216, 102231, 855001, 710304, 961582, 74406, 609503, 227676, 340634, 27825, 245498);
INSERT INTO public.vaccination_germany_timeline VALUES (39, '2021-02-03', 2879446, 129249, 2835355, 44091, 2104895, 774551, 0.02531, 0.00931, 986851, 1362753, 107000, 888168, 731689, 985493, 76401, 619396, 255162, 377260, 30599, 268772);
INSERT INTO public.vaccination_germany_timeline VALUES (40, '2021-02-04', 3005100, 125654, 2956103, 48997, 2162961, 842139, 0.02601, 0.01013, 1030196, 1426024, 111165, 917911, 752272, 1017300, 78525, 628094, 277924, 408724, 32640, 289817);
INSERT INTO public.vaccination_germany_timeline VALUES (41, '2021-02-05', 3116122, 111022, 3063335, 52787, 2212851, 903271, 0.02661, 0.01086, 1075736, 1475216, 115246, 943674, 774875, 1038877, 79857, 636362, 300861, 436339, 35389, 307312);


--
-- Data for Name: who_country; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: who_global_data; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: who_global_data_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Name: common_date_reported_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.common_date_reported_id_seq', 57, true);


--
-- Name: common_region_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.common_region_id_seq', 6, true);


--
-- Name: europe_country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.europe_country_id_seq', 215, true);


--
-- Name: europe_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.europe_data_id_seq', 10366, true);


--
-- Name: europe_data_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.europe_data_import_id_seq', 10433, true);


--
-- Name: rki_bundeslsaender_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_bundeslsaender_import_id_seq', 1, false);


--
-- Name: rki_country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_country_id_seq', 1, false);


--
-- Name: rki_global_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_global_data_id_seq', 1, false);


--
-- Name: rki_global_data_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_global_data_import_id_seq', 1, false);


--
-- Name: rki_landkreise_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_landkreise_import_id_seq', 1, false);


--
-- Name: vaccination_germany_timeline_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.vaccination_germany_timeline_id_seq', 41, true);


--
-- Name: who_country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.who_country_id_seq', 1, false);


--
-- Name: who_global_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.who_global_data_id_seq', 1, false);


--
-- Name: who_global_data_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.who_global_data_import_id_seq', 1, false);


--
-- Name: common_date_reported common_date_reported_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_date_reported
    ADD CONSTRAINT common_date_reported_pkey PRIMARY KEY (id);


--
-- Name: common_region common_region_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_region
    ADD CONSTRAINT common_region_pkey PRIMARY KEY (id);


--
-- Name: europe_country europe_country_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_country
    ADD CONSTRAINT europe_country_pkey PRIMARY KEY (id);


--
-- Name: europe_data_import europe_data_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data_import
    ADD CONSTRAINT europe_data_import_pkey PRIMARY KEY (id);


--
-- Name: europe_data europe_data_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data
    ADD CONSTRAINT europe_data_pkey PRIMARY KEY (id);


--
-- Name: rki_bundeslsaender_import rki_bundeslsaender_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_bundeslsaender_import
    ADD CONSTRAINT rki_bundeslsaender_import_pkey PRIMARY KEY (id);


--
-- Name: rki_country rki_country_country_code_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_country_code_key UNIQUE (country_code);


--
-- Name: rki_country rki_country_country_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_country_key UNIQUE (country);


--
-- Name: rki_country rki_country_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_pkey PRIMARY KEY (id);


--
-- Name: rki_global_data_import rki_global_data_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data_import
    ADD CONSTRAINT rki_global_data_import_pkey PRIMARY KEY (id);


--
-- Name: rki_global_data rki_global_data_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data
    ADD CONSTRAINT rki_global_data_pkey PRIMARY KEY (id);


--
-- Name: rki_landkreise_import rki_landkreise_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_landkreise_import
    ADD CONSTRAINT rki_landkreise_import_pkey PRIMARY KEY (id);


--
-- Name: common_date_reported unique_common_date_reported; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_date_reported
    ADD CONSTRAINT unique_common_date_reported UNIQUE (type, date_reported, datum, year_week);


--
-- Name: common_region unique_common_region_reported; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_region
    ADD CONSTRAINT unique_common_region_reported UNIQUE (type, region);


--
-- Name: vaccination_germany_timeline vaccination_germany_timeline_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.vaccination_germany_timeline
    ADD CONSTRAINT vaccination_germany_timeline_pkey PRIMARY KEY (id);


--
-- Name: who_country who_country_country_code_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_country_code_key UNIQUE (country_code);


--
-- Name: who_country who_country_country_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_country_key UNIQUE (country);


--
-- Name: who_country who_country_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_pkey PRIMARY KEY (id);


--
-- Name: who_global_data_import who_global_data_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data_import
    ADD CONSTRAINT who_global_data_import_pkey PRIMARY KEY (id);


--
-- Name: who_global_data who_global_data_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data
    ADD CONSTRAINT who_global_data_pkey PRIMARY KEY (id);


--
-- Name: europe_country europe_country_continent_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_country
    ADD CONSTRAINT europe_country_continent_id_fkey FOREIGN KEY (continent_id) REFERENCES public.common_region(id);


--
-- Name: europe_data europe_data_europe_country_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data
    ADD CONSTRAINT europe_data_europe_country_id_fkey FOREIGN KEY (europe_country_id) REFERENCES public.europe_country(id);


--
-- Name: europe_data europe_data_europe_date_reported_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data
    ADD CONSTRAINT europe_data_europe_date_reported_id_fkey FOREIGN KEY (europe_date_reported_id) REFERENCES public.common_date_reported(id);


--
-- Name: rki_country rki_country_region_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_region_id_fkey FOREIGN KEY (region_id) REFERENCES public.common_region(id);


--
-- Name: rki_global_data rki_global_data_country_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data
    ADD CONSTRAINT rki_global_data_country_id_fkey FOREIGN KEY (country_id) REFERENCES public.who_country(id);


--
-- Name: rki_global_data rki_global_data_date_reported_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data
    ADD CONSTRAINT rki_global_data_date_reported_id_fkey FOREIGN KEY (date_reported_id) REFERENCES public.common_date_reported(id);


--
-- Name: who_country who_country_region_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_region_id_fkey FOREIGN KEY (region_id) REFERENCES public.common_region(id);


--
-- Name: who_global_data who_global_data_country_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data
    ADD CONSTRAINT who_global_data_country_id_fkey FOREIGN KEY (country_id) REFERENCES public.who_country(id);


--
-- Name: who_global_data who_global_data_date_reported_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data
    ADD CONSTRAINT who_global_data_date_reported_id_fkey FOREIGN KEY (date_reported_id) REFERENCES public.common_date_reported(id);


--
-- PostgreSQL database dump complete
--

